%------------------------------------------------------------------------------
% File     : VBT00017_4 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00391_015684
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00391_015684 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 11354 (4209 unt;1516 typ;   0 def)
%            Number of atoms       : 18181 (8057 equ)
%            Maximal formula atoms :   47 (   1 avg)
%            Number of connectives : 18100 (1725   ~; 291   |;1924   &)
%                                         (2008 <=>;12152  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   35 (   5 avg)
%            Maximal term depth    :   38 (   2 avg)
%            Number of FOOLs       : 1321 (1068 fml; 253 var)
%            Number of X terms     :  523 (   0  []; 460 ite;  63 let)
%            Number of types       :   14 (  13 usr)
%            Number of type conns  : 1277 (1050   >; 227   *;   0   +;   0  <<)
%            Number of predicates  :  249 ( 246 usr;   2 prp; 0-7 aty)
%            Number of functors    : 1270 (1270 usr;  85 con; 0-8 aty)
%            Number of variables   : 29561 (26596   !; 677   ?;29561   :)
%                                         (2288  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TX1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 17:28:46.471
%------------------------------------------------------------------------------
% Could-be-implicit typings (20)
tff(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

tff(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

tff(ty_t_String_Oliteral,type,
    literal: $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Real_Oreal,type,
    real: $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (1496)
tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Odist__norm,type,
    real_V6936659425649961206t_norm: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ouniformity,type,
    topolo4638772830378233104ormity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaa____,type,
    aTP_Lamp_aaa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aab____,type,
    aTP_Lamp_aab: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aac____,type,
    aTP_Lamp_aac: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aad____,type,
    aTP_Lamp_aad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aae____,type,
    aTP_Lamp_aae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaf____,type,
    aTP_Lamp_aaf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aag____,type,
    aTP_Lamp_aag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aah____,type,
    aTP_Lamp_aah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aai____,type,
    aTP_Lamp_aai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaj____,type,
    aTP_Lamp_aaj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aak____,type,
    aTP_Lamp_aak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aal____,type,
    aTP_Lamp_aal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aam____,type,
    aTP_Lamp_aam: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aan____,type,
    aTP_Lamp_aan: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aao____,type,
    aTP_Lamp_aao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aap____,type,
    aTP_Lamp_aap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaq____,type,
    aTP_Lamp_aaq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aar____,type,
    aTP_Lamp_aar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aas____,type,
    aTP_Lamp_aas: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aat____,type,
    aTP_Lamp_aat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aau____,type,
    aTP_Lamp_aau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aav____,type,
    aTP_Lamp_aav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaw____,type,
    aTP_Lamp_aaw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aax____,type,
    aTP_Lamp_aax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aay____,type,
    aTP_Lamp_aay: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aaz____,type,
    aTP_Lamp_aaz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aba____,type,
    aTP_Lamp_aba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abb____,type,
    aTP_Lamp_abb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abc____,type,
    aTP_Lamp_abc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abd____,type,
    aTP_Lamp_abd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abe____,type,
    aTP_Lamp_abe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abf____,type,
    aTP_Lamp_abf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abg____,type,
    aTP_Lamp_abg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abh____,type,
    aTP_Lamp_abh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abi____,type,
    aTP_Lamp_abi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abj____,type,
    aTP_Lamp_abj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abk____,type,
    aTP_Lamp_abk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abl____,type,
    aTP_Lamp_abl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abm____,type,
    aTP_Lamp_abm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abn____,type,
    aTP_Lamp_abn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abo____,type,
    aTP_Lamp_abo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abp____,type,
    aTP_Lamp_abp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abq____,type,
    aTP_Lamp_abq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abr____,type,
    aTP_Lamp_abr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abs____,type,
    aTP_Lamp_abs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abt____,type,
    aTP_Lamp_abt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abu____,type,
    aTP_Lamp_abu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abv____,type,
    aTP_Lamp_abv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abw____,type,
    aTP_Lamp_abw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abx____,type,
    aTP_Lamp_abx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aby____,type,
    aTP_Lamp_aby: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abz____,type,
    aTP_Lamp_abz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aca____,type,
    aTP_Lamp_aca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acb____,type,
    aTP_Lamp_acb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acc____,type,
    aTP_Lamp_acc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acd____,type,
    aTP_Lamp_acd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ace____,type,
    aTP_Lamp_ace: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acf____,type,
    aTP_Lamp_acf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acg____,type,
    aTP_Lamp_acg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ach____,type,
    aTP_Lamp_ach: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aci____,type,
    aTP_Lamp_aci: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acj____,type,
    aTP_Lamp_acj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ack____,type,
    aTP_Lamp_ack: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acl____,type,
    aTP_Lamp_acl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acm____,type,
    aTP_Lamp_acm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acn____,type,
    aTP_Lamp_acn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aco____,type,
    aTP_Lamp_aco: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acp____,type,
    aTP_Lamp_acp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acq____,type,
    aTP_Lamp_acq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acr____,type,
    aTP_Lamp_acr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acs____,type,
    aTP_Lamp_acs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__act____,type,
    aTP_Lamp_act: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acu____,type,
    aTP_Lamp_acu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acv____,type,
    aTP_Lamp_acv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acw____,type,
    aTP_Lamp_acw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acx____,type,
    aTP_Lamp_acx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acy____,type,
    aTP_Lamp_acy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acz____,type,
    aTP_Lamp_acz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ada____,type,
    aTP_Lamp_ada: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adb____,type,
    aTP_Lamp_adb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adc____,type,
    aTP_Lamp_adc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__add____,type,
    aTP_Lamp_add: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ade____,type,
    aTP_Lamp_ade: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adf____,type,
    aTP_Lamp_adf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adg____,type,
    aTP_Lamp_adg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adh____,type,
    aTP_Lamp_adh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adi____,type,
    aTP_Lamp_adi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adj____,type,
    aTP_Lamp_adj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adk____,type,
    aTP_Lamp_adk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adl____,type,
    aTP_Lamp_adl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adm____,type,
    aTP_Lamp_adm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adn____,type,
    aTP_Lamp_adn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ado____,type,
    aTP_Lamp_ado: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adp____,type,
    aTP_Lamp_adp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adq____,type,
    aTP_Lamp_adq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adr____,type,
    aTP_Lamp_adr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ads____,type,
    aTP_Lamp_ads: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adt____,type,
    aTP_Lamp_adt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adu____,type,
    aTP_Lamp_adu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adv____,type,
    aTP_Lamp_adv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adw____,type,
    aTP_Lamp_adw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adx____,type,
    aTP_Lamp_adx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ady____,type,
    aTP_Lamp_ady: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adz____,type,
    aTP_Lamp_adz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aea____,type,
    aTP_Lamp_aea: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aeb____,type,
    aTP_Lamp_aeb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aec____,type,
    aTP_Lamp_aec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aed____,type,
    aTP_Lamp_aed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aee____,type,
    aTP_Lamp_aee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aef____,type,
    aTP_Lamp_aef: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aeg____,type,
    aTP_Lamp_aeg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeh____,type,
    aTP_Lamp_aeh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aei____,type,
    aTP_Lamp_aei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aej____,type,
    aTP_Lamp_aej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aek____,type,
    aTP_Lamp_aek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ael____,type,
    aTP_Lamp_ael: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aem____,type,
    aTP_Lamp_aem: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aen____,type,
    aTP_Lamp_aen: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aeo____,type,
    aTP_Lamp_aeo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aep____,type,
    aTP_Lamp_aep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeq____,type,
    aTP_Lamp_aeq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aer____,type,
    aTP_Lamp_aer: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aes____,type,
    aTP_Lamp_aes: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aet____,type,
    aTP_Lamp_aet: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aeu____,type,
    aTP_Lamp_aeu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aev____,type,
    aTP_Lamp_aev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aew____,type,
    aTP_Lamp_aew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aex____,type,
    aTP_Lamp_aex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aey____,type,
    aTP_Lamp_aey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aez____,type,
    aTP_Lamp_aez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afa____,type,
    aTP_Lamp_afa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afb____,type,
    aTP_Lamp_afb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afc____,type,
    aTP_Lamp_afc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afd____,type,
    aTP_Lamp_afd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afe____,type,
    aTP_Lamp_afe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aff____,type,
    aTP_Lamp_aff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afg____,type,
    aTP_Lamp_afg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afh____,type,
    aTP_Lamp_afh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afi____,type,
    aTP_Lamp_afi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afj____,type,
    aTP_Lamp_afj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afk____,type,
    aTP_Lamp_afk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afl____,type,
    aTP_Lamp_afl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afm____,type,
    aTP_Lamp_afm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afn____,type,
    aTP_Lamp_afn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afo____,type,
    aTP_Lamp_afo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afp____,type,
    aTP_Lamp_afp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afq____,type,
    aTP_Lamp_afq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afr____,type,
    aTP_Lamp_afr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afs____,type,
    aTP_Lamp_afs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aft____,type,
    aTP_Lamp_aft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afu____,type,
    aTP_Lamp_afu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afv____,type,
    aTP_Lamp_afv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afw____,type,
    aTP_Lamp_afw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afx____,type,
    aTP_Lamp_afx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afy____,type,
    aTP_Lamp_afy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afz____,type,
    aTP_Lamp_afz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aga____,type,
    aTP_Lamp_aga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agb____,type,
    aTP_Lamp_agb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agc____,type,
    aTP_Lamp_agc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agd____,type,
    aTP_Lamp_agd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__age____,type,
    aTP_Lamp_age: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agf____,type,
    aTP_Lamp_agf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agg____,type,
    aTP_Lamp_agg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agh____,type,
    aTP_Lamp_agh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agi____,type,
    aTP_Lamp_agi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agj____,type,
    aTP_Lamp_agj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agk____,type,
    aTP_Lamp_agk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agl____,type,
    aTP_Lamp_agl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agm____,type,
    aTP_Lamp_agm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agn____,type,
    aTP_Lamp_agn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ago____,type,
    aTP_Lamp_ago: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agp____,type,
    aTP_Lamp_agp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agq____,type,
    aTP_Lamp_agq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agr____,type,
    aTP_Lamp_agr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ags____,type,
    aTP_Lamp_ags: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agt____,type,
    aTP_Lamp_agt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agu____,type,
    aTP_Lamp_agu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agv____,type,
    aTP_Lamp_agv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agw____,type,
    aTP_Lamp_agw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xi____,type,
    aTP_Lamp_xi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xj____,type,
    aTP_Lamp_xj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xk____,type,
    aTP_Lamp_xk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xl____,type,
    aTP_Lamp_xl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xm____,type,
    aTP_Lamp_xm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xn____,type,
    aTP_Lamp_xn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xo____,type,
    aTP_Lamp_xo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xp____,type,
    aTP_Lamp_xp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xq____,type,
    aTP_Lamp_xq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xr____,type,
    aTP_Lamp_xr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xs____,type,
    aTP_Lamp_xs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xt____,type,
    aTP_Lamp_xt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xu____,type,
    aTP_Lamp_xu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xv____,type,
    aTP_Lamp_xv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xw____,type,
    aTP_Lamp_xw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xx____,type,
    aTP_Lamp_xx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xy____,type,
    aTP_Lamp_xy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xz____,type,
    aTP_Lamp_xz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ya____,type,
    aTP_Lamp_ya: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yb____,type,
    aTP_Lamp_yb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yc____,type,
    aTP_Lamp_yc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yd____,type,
    aTP_Lamp_yd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ye____,type,
    aTP_Lamp_ye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yf____,type,
    aTP_Lamp_yf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yg____,type,
    aTP_Lamp_yg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yh____,type,
    aTP_Lamp_yh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yi____,type,
    aTP_Lamp_yi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yj____,type,
    aTP_Lamp_yj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yk____,type,
    aTP_Lamp_yk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yl____,type,
    aTP_Lamp_yl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ym____,type,
    aTP_Lamp_ym: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yn____,type,
    aTP_Lamp_yn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yo____,type,
    aTP_Lamp_yo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yp____,type,
    aTP_Lamp_yp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yq____,type,
    aTP_Lamp_yq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yr____,type,
    aTP_Lamp_yr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ys____,type,
    aTP_Lamp_ys: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yt____,type,
    aTP_Lamp_yt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yu____,type,
    aTP_Lamp_yu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yv____,type,
    aTP_Lamp_yv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yw____,type,
    aTP_Lamp_yw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yx____,type,
    aTP_Lamp_yx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yy____,type,
    aTP_Lamp_yy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yz____,type,
    aTP_Lamp_yz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__za____,type,
    aTP_Lamp_za: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zb____,type,
    aTP_Lamp_zb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zc____,type,
    aTP_Lamp_zc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zd____,type,
    aTP_Lamp_zd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ze____,type,
    aTP_Lamp_ze: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zf____,type,
    aTP_Lamp_zf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zg____,type,
    aTP_Lamp_zg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zh____,type,
    aTP_Lamp_zh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zi____,type,
    aTP_Lamp_zi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zj____,type,
    aTP_Lamp_zj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zk____,type,
    aTP_Lamp_zk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zl____,type,
    aTP_Lamp_zl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zm____,type,
    aTP_Lamp_zm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zn____,type,
    aTP_Lamp_zn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zo____,type,
    aTP_Lamp_zo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zp____,type,
    aTP_Lamp_zp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zq____,type,
    aTP_Lamp_zq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zr____,type,
    aTP_Lamp_zr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zs____,type,
    aTP_Lamp_zs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zt____,type,
    aTP_Lamp_zt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zu____,type,
    aTP_Lamp_zu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zv____,type,
    aTP_Lamp_zv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zw____,type,
    aTP_Lamp_zw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zx____,type,
    aTP_Lamp_zx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zy____,type,
    aTP_Lamp_zy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zz____,type,
    aTP_Lamp_zz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLess,type,
    bNF_Ca8459412986667044542atLess: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,fun(C,$o)) * fun(B,fun(D,$o)) ) > fun(fun(A,B),fun(fun(C,D),$o)) ) ).

tff(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) * product_prod(A,B) ) > nat ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: nat > fun(nat,nat) ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: ( nat * int ) > fun(int,int) ).

tff(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,$o) ) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself(A) * nat ) > $o ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: fun(num,fun(num,option(num))) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_ONeg,type,
    code_Neg: num > code_integer ).

tff(sy_c_Code__Numeral_OPos,type,
    code_Pos: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,$o) ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odup,type,
    code_dup: code_integer > code_integer ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

tff(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

tff(sy_c_Code__Numeral_Ointeger__of__nat,type,
    code_integer_of_nat: nat > code_integer ).

tff(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: fun(code_integer,nat) ).

tff(sy_c_Code__Numeral_Onegative,type,
    code_negative: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

tff(sy_c_Code__Numeral_Opositive,type,
    code_positive: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Osub,type,
    code_sub: ( num * num ) > code_integer ).

tff(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: fun(num,int) ).

tff(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: fun(num,int) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Complex_OArg,type,
    arg: complex > real ).

tff(sy_c_Complex_Ocis,type,
    cis: real > complex ).

tff(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

tff(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: ( real * real ) > complex ).

tff(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

tff(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

tff(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

tff(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

tff(sy_c_Complex_Orcis,type,
    rcis: ( real * real ) > complex ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( fun(A,A) * A * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__vector__derivative,type,
    has_ve8173657378732805170vative: 
      !>[B: $tType] : ( ( fun(real,B) * B * filter(real) ) > $o ) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: ( int * int ) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: ( int * int * product_prod(int,int) ) > $o ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( product_prod(A,A) > $o ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Extended__Nat_OeSuc,type,
    extended_eSuc: fun(extended_enat,extended_enat) ).

tff(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

tff(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : fun(fun(nat,T),fun(T,fun(extended_enat,T))) ).

tff(sy_c_Extended__Nat_Oenat_Orec__enat,type,
    extended_rec_enat: 
      !>[T: $tType] : fun(fun(nat,T),fun(T,fun(extended_enat,T))) ).

tff(sy_c_Extended__Nat_Oenat_Orec__set__enat,type,
    extend4933016492236175606t_enat: 
      !>[T: $tType] : ( ( fun(nat,T) * T * extended_enat ) > fun(T,$o) ) ).

tff(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

tff(sy_c_Extended__Nat_Othe__enat,type,
    extended_the_enat: extended_enat > nat ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oabstract__filter,type,
    abstract_filter: 
      !>[A: $tType] : ( fun(product_unit,filter(A)) > filter(A) ) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) ) > filter(A) ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : fun(set(B),nat) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : fun(set(A),$o) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) * B ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(set(A),B) ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( fun(B,C) > fun(fun(A,B),fun(A,C)) ) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * set(A) ) > fun(A,B) ) ).

tff(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( fun(A,nat) > $o ) ).

tff(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obezw,type,
    bezw: ( nat * nat ) > product_prod(int,int) ).

tff(sy_c_GCD_Obezw__rel,type,
    bezw_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A ) > fun(set(A),A) ) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( itself(A) > nat ) ).

tff(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(A,fun(list(B),A))) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(list(A),A) ) ).

tff(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( fun(A,$o) > $o ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set(A) * nat ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Ocr__int,type,
    cr_int: fun(product_prod(nat,nat),fun(int,$o)) ).

tff(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Ointrel,type,
    intrel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opcr__int,type,
    pcr_int: fun(product_prod(nat,nat),fun(int,$o)) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,B) * fun(B,A) * fun(A,fun(B,$o)) ) > $o ) ).

tff(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Limits_OZfun,type,
    zfun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( list(A) > set(A) ) ).

tff(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( list(A) > fun(A,nat) ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) * B ) > B ) ).

tff(sy_c_List_Ogen__length,type,
    gen_length: 
      !>[A: $tType] : ( nat > fun(list(A),nat) ) ).

tff(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * nat ) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * set(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( set(A) > list(A) ) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(list(A),fun(list(B),$o)) ) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( fun(A,Aa) * list(A) ) > list(Aa) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( fun(A,nat) * list(A) ) > nat ) ).

tff(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Olist__ex,type,
    list_ex: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > $o ) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(list(A),list(B))) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( list(fun(A,nat)) > set(product_prod(A,A)) ) ).

tff(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(list(A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( list(A) > fun(nat,A) ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : fun(list(A),fun(list(A),$o)) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > fun(list(A),list(A)) ) ).

tff(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > $o ) ).

tff(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( list(A) > list(list(A)) ) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Oupto__aux,type,
    upto_aux: ( int * int * list(int) ) > list(int) ).

tff(sy_c_List_Oupto__rel,type,
    upto_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(A) ) ).

tff(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( list(product_prod(A,B)) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) * list(B) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(B) ) ).

tff(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > fun(A,option(B)) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : fun(nat,fun(fun(A,A),fun(A,A))) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( ( A * fun(nat,A) * nat ) > A ) ).

tff(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

tff(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) ) > fun(nat,T) ) ).

tff(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) * nat ) > fun(T,$o) ) ).

tff(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: fun(nat,int) ).

tff(sy_c_Nat__Bijection_Oint__encode,type,
    nat_int_encode: fun(int,nat) ).

tff(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: fun(nat,list(nat)) ).

tff(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: fun(list(nat),nat) ).

tff(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: fun(list(nat),fun(list(nat),$o)) ).

tff(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: fun(nat,product_prod(nat,nat)) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > fun(nat,product_prod(nat,nat)) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: fun(product_prod(nat,nat),nat) ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: fun(set(nat),nat) ).

tff(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

tff(sy_c_NthRoot_Oroot,type,
    root: nat > fun(real,real) ).

tff(sy_c_NthRoot_Osqrt,type,
    sqrt: fun(real,real) ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: fun(num,num) ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : fun(A,fun(fun(num,A),fun(fun(num,A),fun(num,A)))) ).

tff(sy_c_Num_Onum_Orec__num,type,
    rec_num: 
      !>[A: $tType] : fun(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)))) ).

tff(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opow,type,
    pow: ( num * num ) > num ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > option(A) ) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( fun(A,Aa) * option(A) ) > option(Aa) ) ).

tff(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( fun(A,nat) * option(A) ) > nat ) ).

tff(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( ( A * set(A) ) > A ) ).

tff(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( ( A * fun(A,fun(A,A)) * A * nat ) > A ) ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : fun(A,fun(nat,A)) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > fun(B,product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) * product_prod(A,B) ) > product_prod(C,D) ) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > fun(product_prod(A,B),C) ) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : itself(A) ).

tff(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: fun(product_prod(int,int),rat) ).

tff(sy_c_Rat_OFract,type,
    fract: fun(int,fun(int,rat)) ).

tff(sy_c_Rat_OFrct,type,
    frct: product_prod(int,int) > rat ).

tff(sy_c_Rat_ORep__Rat,type,
    rep_Rat: fun(rat,product_prod(int,int)) ).

tff(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : fun(rat,A) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

tff(sy_c_Rat_Opcr__rat,type,
    pcr_rat: fun(product_prod(int,int),fun(rat,$o)) ).

tff(sy_c_Rat_Opositive,type,
    positive: fun(rat,$o) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Rat_Oratrel,type,
    ratrel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Real_OReal,type,
    real2: fun(fun(nat,rat),real) ).

tff(sy_c_Real_Ocauchy,type,
    cauchy: fun(nat,rat) > $o ).

tff(sy_c_Real_Ocr__real,type,
    cr_real: fun(fun(nat,rat),fun(real,$o)) ).

tff(sy_c_Real_Opcr__real,type,
    pcr_real: fun(fun(nat,rat),fun(real,$o)) ).

tff(sy_c_Real_Opositive,type,
    positive2: fun(real,$o) ).

tff(sy_c_Real_Orealrel,type,
    realrel: fun(fun(nat,rat),fun(fun(nat,rat),$o)) ).

tff(sy_c_Real_Orep__real,type,
    rep_real: fun(real,fun(nat,rat)) ).

tff(sy_c_Real_Ovanishes,type,
    vanishes: fun(nat,rat) > $o ).

tff(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Real__Vector__Spaces_Obounded__bilinear,type,
    real_V2442710119149674383linear: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Oconstruct,type,
    real_V4425403222259421789struct: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * A ) > B ) ).

tff(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Odim,type,
    real_Vector_dim: 
      !>[A: $tType] : ( set(A) > nat ) ).

tff(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( ( A * A ) > real ) ).

tff(sy_c_Real__Vector__Spaces_Oextend__basis,type,
    real_V4986007116245087402_basis: 
      !>[A: $tType] : ( set(A) > set(A) ) ).

tff(sy_c_Real__Vector__Spaces_Olinear,type,
    real_Vector_linear: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

tff(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

tff(sy_c_Real__Vector__Spaces_Orepresentation,type,
    real_V7696804695334737415tation: 
      !>[A: $tType] : ( ( set(A) * A ) > fun(A,real) ) ).

tff(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > fun(A,A) ) ).

tff(sy_c_Real__Vector__Spaces_Ospan,type,
    real_Vector_span: 
      !>[A: $tType] : ( set(A) > set(A) ) ).

tff(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun($o,A) ).

tff(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( fun(nat,A) > A ) ).

tff(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( fun(nat,A) * A ) > $o ) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( fun(A,$o) > set(A) ) ).

tff(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set(A) * set(A) ) > $o ) ).

tff(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > set(B) ) ).

tff(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : fun(A,fun(set(A),set(A))) ).

tff(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(B) ) > set(A) ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_String_OCode_Oabort,type,
    abort: 
      !>[A: $tType] : ( ( literal * fun(product_unit,A) ) > A ) ).

tff(sy_c_String_OLiteral,type,
    literal2: ( $o * $o * $o * $o * $o * $o * $o * literal ) > literal ).

tff(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

tff(sy_c_String_Ochar_OChar,type,
    char2: ( $o * $o * $o * $o * $o * $o * $o * $o ) > char ).

tff(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

tff(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : fun(char,A) ).

tff(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

tff(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : fun(A,char) ).

tff(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter(F) * fun(F,A) ) > A ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( ( A * set(A) ) > filter(A) ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oconvergent,type,
    topolo6863149650580417670ergent: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > filter(A) ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( filter(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : filter(product_prod(A,A)) ).

tff(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Transcendental_Oarccos,type,
    arccos: fun(real,real) ).

tff(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oarcsin,type,
    arcsin: fun(real,real) ).

tff(sy_c_Transcendental_Oarctan,type,
    arctan: fun(real,real) ).

tff(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

tff(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( fun(nat,A) > fun(nat,A) ) ).

tff(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Olog,type,
    log: real > fun(real,real) ).

tff(sy_c_Transcendental_Opi,type,
    pi: real ).

tff(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Transcendental_Opowr__real,type,
    powr_real: ( real * real ) > real ).

tff(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

tff(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( ( nat * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: ( $o * $o ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option(product_prod(nat,nat)) * nat * list(vEBT_VEBT) * vEBT_VEBT ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_Orec__VEBT,type,
    vEBT_rec_VEBT: 
      !>[A: $tType] : ( ( fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))) * fun($o,fun($o,A)) * vEBT_VEBT ) > A ) ).

tff(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: fun(vEBT_VEBT,nat) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > fun(nat,$o) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: ( nat * list(vEBT_VEBT) * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > set(nat) ).

tff(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Oless__than,type,
    less_than: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( fun(A,nat) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( ( A * set(A) ) > $o ) ).

tff(sy_v_va____,type,
    va: nat ).

% Relevant facts (9037)
tff(fact_0_False,axiom,
    ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,va))) ).

% False
tff(fact_1_div2__Suc__Suc,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,M))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% div2_Suc_Suc
tff(fact_2_calculation_I3_J,axiom,
    vEBT_invar_vebt(vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ).

% calculation(3)
tff(fact_3_calculation_I2_J,axiom,
    vEBT_invar_vebt(vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ).

% calculation(2)
tff(fact_4_calculation_I6_J,axiom,
    aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,nat,suc,aa(nat,nat,suc,va)) ).

% calculation(6)
tff(fact_5_semiring__norm_I85_J,axiom,
    ! [M: num] : ( aa(num,num,bit0,M) != one2 ) ).

% semiring_norm(85)
tff(fact_6_semiring__norm_I83_J,axiom,
    ! [Na: num] : ( one2 != aa(num,num,bit0,Na) ) ).

% semiring_norm(83)
tff(fact_7_buildup__nothing__in__leaf,axiom,
    ! [Na: nat,X: nat] : ~ vEBT_V5719532721284313246member(vEBT_vebt_buildup(Na),X) ).

% buildup_nothing_in_leaf
tff(fact_8_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(num,A,numeral_numeral(A),Na) ) ) ).

% numeral_Bit0_div_2
tff(fact_9_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),one2)) = A2 ) ) ).

% divide_numeral_1
tff(fact_10_nat_Oinject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( aa(nat,nat,suc,X2) = aa(nat,nat,suc,Y2) )
    <=> ( X2 = Y2 ) ) ).

% nat.inject
tff(fact_11_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( aa(nat,nat,suc,Nat) = aa(nat,nat,suc,Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% old.nat.inject
tff(fact_12_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N: nat] : ( X != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N) )
     => ~ ! [N: nat] : ( X != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,suc,N)) ) ) ).

% even_odd_cases
tff(fact_13_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: num,Na: num] :
          ( ( aa(num,A,numeral_numeral(A),M) = aa(num,A,numeral_numeral(A),Na) )
        <=> ( M = Na ) ) ) ).

% numeral_eq_iff
tff(fact_14_semiring__norm_I87_J,axiom,
    ! [M: num,Na: num] :
      ( ( aa(num,num,bit0,M) = aa(num,num,bit0,Na) )
    <=> ( M = Na ) ) ).

% semiring_norm(87)
tff(fact_15_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ) ).

% numeral_plus_numeral
tff(fact_16_add__numeral__left,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W))),Z) ) ) ).

% add_numeral_left
tff(fact_17_add__Suc__right,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,suc,Na)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) ) ).

% add_Suc_right
tff(fact_18_add__2__eq__Suc_H,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,suc,Na)) ) ).

% add_2_eq_Suc'
tff(fact_19_add__2__eq__Suc,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) = aa(nat,nat,suc,aa(nat,nat,suc,Na)) ) ).

% add_2_eq_Suc
tff(fact_20_add__self__div__2,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),M)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = M ) ).

% add_self_div_2
tff(fact_21_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% is_num_normalize(1)
tff(fact_22_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% div_plus_div_distrib_dvd_left
tff(fact_23_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% div_plus_div_distrib_dvd_right
tff(fact_24_dvd__antisym,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),M)
       => ( M = Na ) ) ) ).

% dvd_antisym
tff(fact_25_add__Suc__shift,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,M)),Na) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,suc,Na)) ) ).

% add_Suc_shift
tff(fact_26_add__Suc,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,M)),Na) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) ) ).

% add_Suc
tff(fact_27_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),A2) )
     => ( aa(nat,nat,suc,A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,suc,A2)) ) ) ).

% nat_arith.suc1
tff(fact_28_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Na: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Na)),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% numeral_Bit0
tff(fact_29_n__not__Suc__n,axiom,
    ! [Na: nat] : ( Na != aa(nat,nat,suc,Na) ) ).

% n_not_Suc_n
tff(fact_30_Suc__inject,axiom,
    ! [X: nat,Y: nat] :
      ( ( aa(nat,nat,suc,X) = aa(nat,nat,suc,Y) )
     => ( X = Y ) ) ).

% Suc_inject
tff(fact_31_even__Suc__div__two,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% even_Suc_div_two
tff(fact_32_odd__Suc__div__two,axiom,
    ! [Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% odd_Suc_div_two
tff(fact_33_even__Suc__Suc__iff,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Na)))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ).

% even_Suc_Suc_iff
tff(fact_34_even__Suc,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,Na))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ).

% even_Suc
tff(fact_35_even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_add
tff(fact_36_odd__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> ~ ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% odd_add
tff(fact_37_div__add,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ) ).

% div_add
tff(fact_38_div2__even__ext__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Y) )
       => ( X = Y ) ) ) ).

% div2_even_ext_nat
tff(fact_39_div__dvd__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ) ).

% div_dvd_div
tff(fact_40_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_triv_left_iff
tff(fact_41_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_triv_right_iff
tff(fact_42_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: fun(A,$o)] :
      ( member(A,A2,collect(A,P))
    <=> aa(A,$o,P,A2) ) ).

% mem_Collect_eq
tff(fact_43_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( collect(A,aTP_Lamp_a(set(A),fun(A,$o),A3)) = A3 ) ).

% Collect_mem_eq
tff(fact_44_Collect__cong,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ! [X3: A] :
          ( aa(A,$o,P,X3)
        <=> aa(A,$o,Q,X3) )
     => ( collect(A,P) = collect(A,Q) ) ) ).

% Collect_cong
tff(fact_45_ext,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),G: fun(A,B)] :
      ( ! [X3: A] : ( aa(A,B,F2,X3) = aa(A,B,G,X3) )
     => ( F2 = G ) ) ).

% ext
tff(fact_46_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) )
            & ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ) ).

% bit_eq_rec
tff(fact_47_semiring__norm_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit0,M)),aa(num,num,bit0,Na)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% semiring_norm(6)
tff(fact_48_semiring__norm_I2_J,axiom,
    aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),one2) = aa(num,num,bit0,one2) ).

% semiring_norm(2)
tff(fact_49_Suc__numeral,axiom,
    ! [Na: num] : ( aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),Na)) = aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),Na),one2)) ) ).

% Suc_numeral
tff(fact_50_add__One__commute,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Na) = aa(num,num,aa(num,fun(num,num),plus_plus(num),Na),one2) ) ).

% add_One_commute
tff(fact_51_dvd__trans,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_trans
tff(fact_52_dvd__refl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),A2) ) ).

% dvd_refl
tff(fact_53_Suc__nat__number__of__add,axiom,
    ! [V: num,Na: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),one2))),Na) ) ).

% Suc_nat_number_of_add
tff(fact_54_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_add_right_iff
tff(fact_55_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_add_left_iff
tff(fact_56_dvd__add,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ) ).

% dvd_add
tff(fact_57_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
            <=> ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
tff(fact_58_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
tff(fact_59_div__div__div__same,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [D2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),D2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ) ).

% div_div_div_same
tff(fact_60_even__numeral,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Na: num] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na))) ) ).

% even_numeral
tff(fact_61_odd__even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% odd_even_add
tff(fact_62_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = X ) ) ).

% field_sum_of_halves
tff(fact_63_both__member__options__def,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( aa(nat,$o,vEBT_V8194947554948674370ptions(T2),X)
    <=> ( vEBT_V5719532721284313246member(T2,X)
        | vEBT_VEBT_membermima(T2,X) ) ) ).

% both_member_options_def
tff(fact_64_set__decode__Suc,axiom,
    ! [Na: nat,X: nat] :
      ( member(nat,aa(nat,nat,suc,Na),nat_set_decode(X))
    <=> member(nat,Na,nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% set_decode_Suc
tff(fact_65_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_VEBT_valid(T2,D2)
     => vEBT_invar_vebt(T2,D2) ) ).

% valid_eq2
tff(fact_66_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_invar_vebt(T2,D2)
     => vEBT_VEBT_valid(T2,D2) ) ).

% valid_eq1
tff(fact_67_valid__eq,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_VEBT_valid(T2,D2)
    <=> vEBT_invar_vebt(T2,D2) ) ).

% valid_eq
tff(fact_68_verit__eq__simplify_I8_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( aa(num,num,bit0,X2) = aa(num,num,bit0,Y2) )
    <=> ( X2 = Y2 ) ) ).

% verit_eq_simplify(8)
tff(fact_69_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,V))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),W)) ) ).

% zdiv_numeral_Bit0
tff(fact_70_add__right__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
        <=> ( B2 = C2 ) ) ) ).

% add_right_cancel
tff(fact_71_add__left__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add_left_cancel
tff(fact_72_buildup__nothing__in__min__max,axiom,
    ! [Na: nat,X: nat] : ~ vEBT_VEBT_membermima(vEBT_vebt_buildup(Na),X) ).

% buildup_nothing_in_min_max
tff(fact_73__C3_OIH_C_I4_J,axiom,
    ! [X: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,va)))
     => ( ( X = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,suc,X))
         => vEBT_invar_vebt(vEBT_vebt_buildup(aa(nat,nat,suc,X)),aa(nat,nat,suc,X)) ) ) ) ).

% "3.IH"(4)
tff(fact_74__C3_Oprems_C,axiom,
    aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,suc,aa(nat,nat,suc,va))) ).

% "3.prems"
tff(fact_75_not__gr__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Na: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Na)
        <=> ( Na = zero_zero(A) ) ) ) ).

% not_gr_zero
tff(fact_76_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: num,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na) ) ) ).

% numeral_less_iff
tff(fact_77_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% add.right_neutral
tff(fact_78_double__zero__sym,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% double_zero_sym
tff(fact_79_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = A2 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_left
tff(fact_80_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = A2 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_right
tff(fact_81_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_left
tff(fact_82_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_right
tff(fact_83_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) = zero_zero(A) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_84_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X: A,Y: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_85_add__0,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% add_0
tff(fact_86_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_cancel_left
tff(fact_87_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_cancel_right
tff(fact_88_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% bits_div_by_0
tff(fact_89_bits__div__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% bits_div_0
tff(fact_90_div__by__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% div_by_0
tff(fact_91_div__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% div_0
tff(fact_92_dvd__0__right,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),zero_zero(A)) ) ).

% dvd_0_right
tff(fact_93_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),A2)
        <=> ( A2 = zero_zero(A) ) ) ) ).

% dvd_0_left_iff
tff(fact_94_Suc__less__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% Suc_less_eq
tff(fact_95_Suc__mono,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,Na)) ) ).

% Suc_mono
tff(fact_96_lessI,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,Na)) ).

% lessI
tff(fact_97_less__nat__zero__code,axiom,
    ! [Na: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),zero_zero(nat)) ).

% less_nat_zero_code
tff(fact_98_neq0__conv,axiom,
    ! [Na: nat] :
      ( ( Na != zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ).

% neq0_conv
tff(fact_99_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( A2 != zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),A2) ) ).

% bot_nat_0.not_eq_extremum
tff(fact_100_add__is__0,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        & ( Na = zero_zero(nat) ) ) ) ).

% add_is_0
tff(fact_101_Nat_Oadd__0__right,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),zero_zero(nat)) = M ) ).

% Nat.add_0_right
tff(fact_102_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% nat_add_left_cancel_less
tff(fact_103_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% add_less_same_cancel1
tff(fact_104_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% add_less_same_cancel2
tff(fact_105_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ).

% less_add_same_cancel1
tff(fact_106_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ).

% less_add_same_cancel2
tff(fact_107_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_108_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_109_less__Suc0,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,zero_zero(nat)))
    <=> ( Na = zero_zero(nat) ) ) ).

% less_Suc0
tff(fact_110_zero__less__Suc,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,suc,Na)) ).

% zero_less_Suc
tff(fact_111_add__gr__0,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ).

% add_gr_0
tff(fact_112_dvd__1__left,axiom,
    ! [K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,suc,zero_zero(nat))),K) ).

% dvd_1_left
tff(fact_113_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,suc,zero_zero(nat)))
    <=> ( M = aa(nat,nat,suc,zero_zero(nat)) ) ) ).

% dvd_1_iff_1
tff(fact_114_div__by__Suc__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,suc,zero_zero(nat))) = M ) ).

% div_by_Suc_0
tff(fact_115_div__less,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) = zero_zero(nat) ) ) ).

% div_less
tff(fact_116__C3_OIH_C_I1_J,axiom,
    ! [X: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,va)))
     => ( ( X = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X)
         => vEBT_invar_vebt(vEBT_vebt_buildup(X),X) ) ) ) ).

% "3.IH"(1)
tff(fact_117__C3_OIH_C_I3_J,axiom,
    ! [X: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,va)))
     => ( ( X = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X)
         => vEBT_invar_vebt(vEBT_vebt_buildup(X),X) ) ) ) ).

% "3.IH"(3)
tff(fact_118_set__decode__0,axiom,
    ! [X: nat] :
      ( member(nat,zero_zero(nat),nat_set_decode(X))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X) ) ).

% set_decode_0
tff(fact_119_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_neg_neg
tff(fact_120_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_pos_pos
tff(fact_121_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ ! [C3: A] :
                ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C3) )
               => ( C3 = zero_zero(A) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_122_pos__add__strict,axiom,
    ! [A: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% pos_add_strict
tff(fact_123_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ) ).

% linorder_neqE_linordered_idom
tff(fact_124_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),A2) ) ).

% verit_comp_simplify1(1)
tff(fact_125_gr__zeroI,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Na: A] :
          ( ( Na != zero_zero(A) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Na) ) ) ).

% gr_zeroI
tff(fact_126_not__less__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Na: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Na),zero_zero(A)) ) ).

% not_less_zero
tff(fact_127_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [M: A,Na: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),Na)
         => ( Na != zero_zero(A) ) ) ) ).

% gr_implies_not_zero
tff(fact_128_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Na: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Na)
        <=> ( Na != zero_zero(A) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_129_zero__reorient,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X: A] :
          ( ( zero_zero(A) = X )
        <=> ( X = zero_zero(A) ) ) ) ).

% zero_reorient
tff(fact_130_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D1: A,D22: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D1)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D22)
           => ? [E: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),E),D1)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),E),D22) ) ) ) ) ).

% field_lbound_gt_zero
tff(fact_131_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: fun(A,nat),P: fun(A,$o),X: A] :
      ( ! [X3: A] :
          ( ( aa(A,nat,V2,X3) = zero_zero(nat) )
         => aa(A,$o,P,X3) )
     => ( ! [X3: A] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,V2,X3))
           => ( ~ aa(A,$o,P,X3)
             => ? [Y3: A] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,V2,Y3)),aa(A,nat,V2,X3))
                  & ~ aa(A,$o,P,Y3) ) ) )
       => aa(A,$o,P,X) ) ) ).

% infinite_descent0_measure
tff(fact_132_infinite__descent__measure,axiom,
    ! [A: $tType,P: fun(A,$o),V2: fun(A,nat),X: A] :
      ( ! [X3: A] :
          ( ~ aa(A,$o,P,X3)
         => ? [Y3: A] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,V2,Y3)),aa(A,nat,V2,X3))
              & ~ aa(A,$o,P,Y3) ) )
     => aa(A,$o,P,X) ) ).

% infinite_descent_measure
tff(fact_133_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F2: fun(A,B),P: fun(A,$o),A2: A] :
          ( ! [X3: A] :
              ( ! [Y3: A] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,Y3)),aa(A,B,F2,X3))
                 => aa(A,$o,P,Y3) )
             => aa(A,$o,P,X3) )
         => aa(A,$o,P,A2) ) ) ).

% measure_induct_rule
tff(fact_134_linorder__neqE__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y),X) ) ) ).

% linorder_neqE_nat
tff(fact_135_infinite__descent0,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( ~ aa(nat,$o,P,N)
             => ? [M2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                  & ~ aa(nat,$o,P,M2) ) ) )
       => aa(nat,$o,P,Na) ) ) ).

% infinite_descent0
tff(fact_136_infinite__descent,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( ! [N: nat] :
          ( ~ aa(nat,$o,P,N)
         => ? [M2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
              & ~ aa(nat,$o,P,M2) ) )
     => aa(nat,$o,P,Na) ) ).

% infinite_descent
tff(fact_137_nat__less__induct,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( ! [N: nat] :
          ( ! [M2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
             => aa(nat,$o,P,M2) )
         => aa(nat,$o,P,N) )
     => aa(nat,$o,P,Na) ) ).

% nat_less_induct
tff(fact_138_less__irrefl__nat,axiom,
    ! [Na: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),Na) ).

% less_irrefl_nat
tff(fact_139_gr__implies__not0,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( Na != zero_zero(nat) ) ) ).

% gr_implies_not0
tff(fact_140_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F2: fun(A,B),P: fun(A,$o),A2: A] :
          ( ! [X3: A] :
              ( ! [Y3: A] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,Y3)),aa(A,B,F2,X3))
                 => aa(A,$o,P,Y3) )
             => aa(A,$o,P,X3) )
         => aa(A,$o,P,A2) ) ) ).

% measure_induct
tff(fact_141_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),S),T2)
     => ( S != T2 ) ) ).

% less_not_refl3
tff(fact_142_less__not__refl2,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
     => ( M != Na ) ) ).

% less_not_refl2
tff(fact_143_less__not__refl,axiom,
    ! [Na: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),Na) ).

% less_not_refl
tff(fact_144_nat__neq__iff,axiom,
    ! [M: nat,Na: nat] :
      ( ( M != Na )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M) ) ) ).

% nat_neq_iff
tff(fact_145_less__zeroE,axiom,
    ! [Na: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),zero_zero(nat)) ).

% less_zeroE
tff(fact_146_not__less0,axiom,
    ! [Na: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),zero_zero(nat)) ).

% not_less0
tff(fact_147_not__gr0,axiom,
    ! [Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
    <=> ( Na = zero_zero(nat) ) ) ).

% not_gr0
tff(fact_148_gr0I,axiom,
    ! [Na: nat] :
      ( ( Na != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ).

% gr0I
tff(fact_149_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),zero_zero(nat)) ).

% bot_nat_0.extremum_strict
tff(fact_150_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),zero_zero(A)) ) ).

% less_numeral_extra(3)
tff(fact_151_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),Na: nat,N2: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F2,N)),aa(nat,A,F2,aa(nat,nat,suc,N)))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),N2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F2,Na)),aa(nat,A,F2,N2)) ) ) ) ).

% lift_Suc_mono_less
tff(fact_152_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),Na: nat,M: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F2,N)),aa(nat,A,F2,aa(nat,nat,suc,N)))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F2,Na)),aa(nat,A,F2,M))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M) ) ) ) ).

% lift_Suc_mono_less_iff
tff(fact_153_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),Na)) ) ).

% zero_less_numeral
tff(fact_154_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Na)),zero_zero(A)) ) ).

% not_numeral_less_zero
tff(fact_155_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A)) ) ) ) ).

% add_less_zeroD
tff(fact_156_Ex__less__Suc2,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Na))
          & aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,zero_zero(nat))
        | ? [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Na)
            & aa(nat,$o,P,aa(nat,nat,suc,I)) ) ) ) ).

% Ex_less_Suc2
tff(fact_157_gr0__conv__Suc,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
    <=> ? [M3: nat] : ( Na = aa(nat,nat,suc,M3) ) ) ).

% gr0_conv_Suc
tff(fact_158_All__less__Suc2,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Na))
         => aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,zero_zero(nat))
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Na)
           => aa(nat,$o,P,aa(nat,nat,suc,I)) ) ) ) ).

% All_less_Suc2
tff(fact_159_gr0__implies__Suc,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ? [M4: nat] : ( Na = aa(nat,nat,suc,M4) ) ) ).

% gr0_implies_Suc
tff(fact_160_less__Suc__eq__0__disj,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,Na))
    <=> ( ( M = zero_zero(nat) )
        | ? [J: nat] :
            ( ( M = aa(nat,nat,suc,J) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Na) ) ) ) ).

% less_Suc_eq_0_disj
tff(fact_161_less__imp__add__positive,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ? [K2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K2)
          & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K2) = J2 ) ) ) ).

% less_imp_add_positive
tff(fact_162_nat__dvd__not__less,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
       => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),M) ) ) ).

% nat_dvd_not_less
tff(fact_163_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) = zero_zero(nat) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
        | ( Na = zero_zero(nat) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
tff(fact_164_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I2),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_165_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_166_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I2),J2)
            & ( K = L ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_167_add__strict__mono,axiom,
    ! [A: $tType] :
      ( strict9044650504122735259up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_strict_mono
tff(fact_168_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% add_strict_left_mono
tff(fact_169_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add_strict_right_mono
tff(fact_170_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_imp_less_left
tff(fact_171_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_imp_less_right
tff(fact_172_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_173_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% add.comm_neutral
tff(fact_174_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% add.group_left_neutral
tff(fact_175_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% verit_sum_simplify
tff(fact_176_not__less__less__Suc__eq,axiom,
    ! [Na: nat,M: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,M))
      <=> ( Na = M ) ) ) ).

% not_less_less_Suc_eq
tff(fact_177_strict__inc__induct,axiom,
    ! [I2: nat,J2: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( ! [I3: nat] :
            ( ( J2 = aa(nat,nat,suc,I3) )
           => aa(nat,$o,P,I3) )
       => ( ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
             => ( aa(nat,$o,P,aa(nat,nat,suc,I3))
               => aa(nat,$o,P,I3) ) )
         => aa(nat,$o,P,I2) ) ) ) ).

% strict_inc_induct
tff(fact_178_less__Suc__induct,axiom,
    ! [I2: nat,J2: nat,P: fun(nat,fun(nat,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( ! [I3: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,I3),aa(nat,nat,suc,I3))
       => ( ! [I3: nat,J3: nat,K2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J3)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),K2)
               => ( aa(nat,$o,aa(nat,fun(nat,$o),P,I3),J3)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),P,J3),K2)
                   => aa(nat,$o,aa(nat,fun(nat,$o),P,I3),K2) ) ) ) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,I2),J2) ) ) ) ).

% less_Suc_induct
tff(fact_179_less__trans__Suc,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I2)),K) ) ) ).

% less_trans_Suc
tff(fact_180_Suc__less__SucD,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,Na))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% Suc_less_SucD
tff(fact_181_less__antisym,axiom,
    ! [Na: nat,M: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,M))
       => ( M = Na ) ) ) ).

% less_antisym
tff(fact_182_Suc__less__eq2,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Na)),M)
    <=> ? [M5: nat] :
          ( ( M = aa(nat,nat,suc,M5) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M5) ) ) ).

% Suc_less_eq2
tff(fact_183_All__less__Suc,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Na))
         => aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,Na)
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Na)
           => aa(nat,$o,P,I) ) ) ) ).

% All_less_Suc
tff(fact_184_not__less__eq,axiom,
    ! [M: nat,Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,M)) ) ).

% not_less_eq
tff(fact_185_less__Suc__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
        | ( M = Na ) ) ) ).

% less_Suc_eq
tff(fact_186_Ex__less__Suc,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,Na))
          & aa(nat,$o,P,I) )
    <=> ( aa(nat,$o,P,Na)
        | ? [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Na)
            & aa(nat,$o,P,I) ) ) ) ).

% Ex_less_Suc
tff(fact_187_less__SucI,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,Na)) ) ).

% less_SucI
tff(fact_188_less__SucE,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,Na))
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
       => ( M = Na ) ) ) ).

% less_SucE
tff(fact_189_Suc__lessI,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( ( aa(nat,nat,suc,M) != Na )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),Na) ) ) ).

% Suc_lessI
tff(fact_190_Suc__lessE,axiom,
    ! [I2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I2)),K)
     => ~ ! [J3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J3)
           => ( K != aa(nat,nat,suc,J3) ) ) ) ).

% Suc_lessE
tff(fact_191_Suc__lessD,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% Suc_lessD
tff(fact_192_Nat_OlessE,axiom,
    ! [I2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),K)
     => ( ( K != aa(nat,nat,suc,I2) )
       => ~ ! [J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J3)
             => ( K != aa(nat,nat,suc,J3) ) ) ) ) ).

% Nat.lessE
tff(fact_193_add__lessD1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),K) ) ).

% add_lessD1
tff(fact_194_add__less__mono,axiom,
    ! [I2: nat,J2: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),L)) ) ) ).

% add_less_mono
tff(fact_195_not__add__less1,axiom,
    ! [I2: nat,J2: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)),I2) ).

% not_add_less1
tff(fact_196_not__add__less2,axiom,
    ! [J2: nat,I2: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),I2)),I2) ).

% not_add_less2
tff(fact_197_add__less__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) ) ).

% add_less_mono1
tff(fact_198_trans__less__add1,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),M)) ) ).

% trans_less_add1
tff(fact_199_trans__less__add2,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),J2)) ) ).

% trans_less_add2
tff(fact_200_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),L)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),L) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Na) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% less_add_eq_less
tff(fact_201_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: num] : ( zero_zero(A) != aa(num,A,numeral_numeral(A),Na) ) ) ).

% zero_neq_numeral
tff(fact_202_dvd__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),A2)
         => ( A2 = zero_zero(A) ) ) ) ).

% dvd_0_left
tff(fact_203_not0__implies__Suc,axiom,
    ! [Na: nat] :
      ( ( Na != zero_zero(nat) )
     => ? [M4: nat] : ( Na = aa(nat,nat,suc,M4) ) ) ).

% not0_implies_Suc
tff(fact_204_Zero__not__Suc,axiom,
    ! [M: nat] : ( zero_zero(nat) != aa(nat,nat,suc,M) ) ).

% Zero_not_Suc
tff(fact_205_Zero__neq__Suc,axiom,
    ! [M: nat] : ( zero_zero(nat) != aa(nat,nat,suc,M) ) ).

% Zero_neq_Suc
tff(fact_206_Suc__neq__Zero,axiom,
    ! [M: nat] : ( aa(nat,nat,suc,M) != zero_zero(nat) ) ).

% Suc_neq_Zero
tff(fact_207_zero__induct,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [N: nat] :
            ( aa(nat,$o,P,aa(nat,nat,suc,N))
           => aa(nat,$o,P,N) )
       => aa(nat,$o,P,zero_zero(nat)) ) ) ).

% zero_induct
tff(fact_208_diff__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),M: nat,Na: nat] :
      ( ! [X3: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,X3),zero_zero(nat))
     => ( ! [Y4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,zero_zero(nat)),aa(nat,nat,suc,Y4))
       => ( ! [X3: nat,Y4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),P,X3),Y4)
             => aa(nat,$o,aa(nat,fun(nat,$o),P,aa(nat,nat,suc,X3)),aa(nat,nat,suc,Y4)) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,M),Na) ) ) ) ).

% diff_induct
tff(fact_209_nat__induct,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N: nat] :
            ( aa(nat,$o,P,N)
           => aa(nat,$o,P,aa(nat,nat,suc,N)) )
       => aa(nat,$o,P,Na) ) ) ).

% nat_induct
tff(fact_210_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y != zero_zero(nat) )
     => ~ ! [Nat3: nat] : ( Y != aa(nat,nat,suc,Nat3) ) ) ).

% old.nat.exhaust
tff(fact_211_nat_OdiscI,axiom,
    ! [Nat: nat,X2: nat] :
      ( ( Nat = aa(nat,nat,suc,X2) )
     => ( Nat != zero_zero(nat) ) ) ).

% nat.discI
tff(fact_212_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] : ( zero_zero(nat) != aa(nat,nat,suc,Nat2) ) ).

% old.nat.distinct(1)
tff(fact_213_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat2: nat] : ( aa(nat,nat,suc,Nat2) != zero_zero(nat) ) ).

% old.nat.distinct(2)
tff(fact_214_nat_Odistinct_I1_J,axiom,
    ! [X2: nat] : ( zero_zero(nat) != aa(nat,nat,suc,X2) ) ).

% nat.distinct(1)
tff(fact_215_vebt__buildup_Ocases,axiom,
    ! [X: nat] :
      ( ( X != zero_zero(nat) )
     => ( ( X != aa(nat,nat,suc,zero_zero(nat)) )
       => ~ ! [Va: nat] : ( X != aa(nat,nat,suc,aa(nat,nat,suc,Va)) ) ) ) ).

% vebt_buildup.cases
tff(fact_216_list__decode_Ocases,axiom,
    ! [X: nat] :
      ( ( X != zero_zero(nat) )
     => ~ ! [N: nat] : ( X != aa(nat,nat,suc,N) ) ) ).

% list_decode.cases
tff(fact_217_plus__nat_Oadd__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),zero_zero(nat)),Na) = Na ) ).

% plus_nat.add_0
tff(fact_218_add__eq__self__zero,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na) = M )
     => ( Na = zero_zero(nat) ) ) ).

% add_eq_self_zero
tff(fact_219_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% half_gt_zero_iff
tff(fact_220_half__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% half_gt_zero
tff(fact_221_less__2__cases__iff,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))
    <=> ( ( Na = zero_zero(nat) )
        | ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases_iff
tff(fact_222_less__2__cases,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))
     => ( ( Na = zero_zero(nat) )
        | ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases
tff(fact_223_odd__pos,axiom,
    ! [Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ).

% odd_pos
tff(fact_224_less__natE,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ~ ! [Q2: nat] : ( Na != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q2)) ) ) ).

% less_natE
tff(fact_225_less__add__Suc1,axiom,
    ! [I2: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),M))) ).

% less_add_Suc1
tff(fact_226_less__add__Suc2,axiom,
    ! [I2: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I2))) ).

% less_add_Suc2
tff(fact_227_less__iff__Suc__add,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
    <=> ? [K3: nat] : ( Na = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K3)) ) ) ).

% less_iff_Suc_add
tff(fact_228_less__imp__Suc__add,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ? [K2: nat] : ( Na = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K2)) ) ) ).

% less_imp_Suc_add
tff(fact_229_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% dvd_div_eq_0_iff
tff(fact_230_add__is__1,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
          & ( Na = zero_zero(nat) ) )
        | ( ( M = zero_zero(nat) )
          & ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% add_is_1
tff(fact_231_one__is__add,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na) )
    <=> ( ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
          & ( Na = zero_zero(nat) ) )
        | ( ( M = zero_zero(nat) )
          & ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% one_is_add
tff(fact_232_Suc__n__div__2__gt__zero,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% Suc_n_div_2_gt_zero
tff(fact_233_div__2__gt__zero,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% div_2_gt_zero
tff(fact_234_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% ab_semigroup_add_class.add_ac(1)
tff(fact_235_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & ( K = L ) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_236_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% group_cancel.add1
tff(fact_237_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% group_cancel.add2
tff(fact_238_add_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.assoc
tff(fact_239_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add.left_cancel
tff(fact_240_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
        <=> ( B2 = C2 ) ) ) ).

% add.right_cancel
tff(fact_241_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) ) ) ).

% add.commute
tff(fact_242_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.left_commute
tff(fact_243_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_244_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_245_numeral__1__eq__Suc__0,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = aa(nat,nat,suc,zero_zero(nat)) ).

% numeral_1_eq_Suc_0
tff(fact_246_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% field_less_half_sum
tff(fact_247_even__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),zero_zero(A)) ) ).

% even_zero
tff(fact_248_numeral__2__eq__2,axiom,
    aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% numeral_2_eq_2
tff(fact_249_verit__eq__simplify_I10_J,axiom,
    ! [X2: num] : ( one2 != aa(num,num,bit0,X2) ) ).

% verit_eq_simplify(10)
tff(fact_250_pos2,axiom,
    aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ).

% pos2
tff(fact_251_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% division_ring_divide_zero
tff(fact_252_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
tff(fact_253_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
tff(fact_254_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_eq_0_iff
tff(fact_255_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% double_eq_0_iff
tff(fact_256_dvd__pos__nat,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M) ) ) ).

% dvd_pos_nat
tff(fact_257_minf_I10_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S))
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S)) ) ) ) ).

% minf(10)
tff(fact_258_minf_I9_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S)) ) ) ) ).

% minf(9)
tff(fact_259_pinf_I10_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S))
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S)) ) ) ) ).

% pinf(10)
tff(fact_260_pinf_I9_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),S)) ) ) ) ).

% pinf(9)
tff(fact_261_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% divide_strict_right_mono_neg
tff(fact_262_semiring__norm_I78_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit0,M)),aa(num,num,bit0,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na) ) ).

% semiring_norm(78)
tff(fact_263_semiring__norm_I75_J,axiom,
    ! [M: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),one2) ).

% semiring_norm(75)
tff(fact_264_semiring__norm_I76_J,axiom,
    ! [Na: num] : aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),aa(num,num,bit0,Na)) ).

% semiring_norm(76)
tff(fact_265_half__negative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% half_negative_int_iff
tff(fact_266_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int)) ) ) ).

% div_neg_pos_less0
tff(fact_267_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2) ) ) ).

% neg_imp_zdiv_neg_iff
tff(fact_268_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int)) ) ) ).

% pos_imp_zdiv_neg_iff
tff(fact_269_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X4: A] :
        ? [X_1: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),X_1) ) ).

% linordered_field_no_ub
tff(fact_270_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X4: A] :
        ? [Y4: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y4),X4) ) ).

% linordered_field_no_lb
tff(fact_271_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P2: fun(A,$o),Q: fun(A,$o),Q3: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X3)
             => ( aa(A,$o,P,X3)
              <=> aa(A,$o,P2,X3) ) )
         => ( ? [Z3: A] :
              ! [X3: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X3)
               => ( aa(A,$o,Q,X3)
                <=> aa(A,$o,Q3,X3) ) )
           => ? [Z2: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
               => ( ( aa(A,$o,P,X4)
                    & aa(A,$o,Q,X4) )
                <=> ( aa(A,$o,P2,X4)
                    & aa(A,$o,Q3,X4) ) ) ) ) ) ) ).

% pinf(1)
tff(fact_272_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P2: fun(A,$o),Q: fun(A,$o),Q3: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X3)
             => ( aa(A,$o,P,X3)
              <=> aa(A,$o,P2,X3) ) )
         => ( ? [Z3: A] :
              ! [X3: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z3),X3)
               => ( aa(A,$o,Q,X3)
                <=> aa(A,$o,Q3,X3) ) )
           => ? [Z2: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
               => ( ( aa(A,$o,P,X4)
                    | aa(A,$o,Q,X4) )
                <=> ( aa(A,$o,P2,X4)
                    | aa(A,$o,Q3,X4) ) ) ) ) ) ) ).

% pinf(2)
tff(fact_273_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ( X4 != T2 ) ) ) ).

% pinf(3)
tff(fact_274_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ( X4 != T2 ) ) ) ).

% pinf(4)
tff(fact_275_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),T2) ) ) ).

% pinf(5)
tff(fact_276_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),X4) ) ) ).

% pinf(7)
tff(fact_277_pinf_I11_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ord(A)
     => ! [F3: B] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ( F3 = F3 ) ) ) ).

% pinf(11)
tff(fact_278_minf_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P2: fun(A,$o),Q: fun(A,$o),Q3: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z3)
             => ( aa(A,$o,P,X3)
              <=> aa(A,$o,P2,X3) ) )
         => ( ? [Z3: A] :
              ! [X3: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z3)
               => ( aa(A,$o,Q,X3)
                <=> aa(A,$o,Q3,X3) ) )
           => ? [Z2: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
               => ( ( aa(A,$o,P,X4)
                    & aa(A,$o,Q,X4) )
                <=> ( aa(A,$o,P2,X4)
                    & aa(A,$o,Q3,X4) ) ) ) ) ) ) ).

% minf(1)
tff(fact_279_minf_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o),P2: fun(A,$o),Q: fun(A,$o),Q3: fun(A,$o)] :
          ( ? [Z3: A] :
            ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z3)
             => ( aa(A,$o,P,X3)
              <=> aa(A,$o,P2,X3) ) )
         => ( ? [Z3: A] :
              ! [X3: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z3)
               => ( aa(A,$o,Q,X3)
                <=> aa(A,$o,Q3,X3) ) )
           => ? [Z2: A] :
              ! [X4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
               => ( ( aa(A,$o,P,X4)
                    | aa(A,$o,Q,X4) )
                <=> ( aa(A,$o,P2,X4)
                    | aa(A,$o,Q3,X4) ) ) ) ) ) ) ).

% minf(2)
tff(fact_280_minf_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ( X4 != T2 ) ) ) ).

% minf(3)
tff(fact_281_minf_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ( X4 != T2 ) ) ) ).

% minf(4)
tff(fact_282_minf_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),T2) ) ) ).

% minf(5)
tff(fact_283_minf_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),X4) ) ) ).

% minf(7)
tff(fact_284_minf_I11_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ord(A)
     => ! [F3: B] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ( F3 = F3 ) ) ) ).

% minf(11)
tff(fact_285_gcd__nat_Onot__eq__order__implies__strict,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != B2 )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
          & ( A2 != B2 ) ) ) ) ).

% gcd_nat.not_eq_order_implies_strict
tff(fact_286_gcd__nat_Ostrict__implies__not__eq,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( A2 != B2 ) ) ).

% gcd_nat.strict_implies_not_eq
tff(fact_287_gcd__nat_Ostrict__implies__order,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2) ) ).

% gcd_nat.strict_implies_order
tff(fact_288_gcd__nat_Ostrict__iff__order,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) ) ) ).

% gcd_nat.strict_iff_order
tff(fact_289_gcd__nat_Oorder__iff__strict,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
          & ( A2 != B2 ) )
        | ( A2 = B2 ) ) ) ).

% gcd_nat.order_iff_strict
tff(fact_290_gcd__nat_Ostrict__iff__not,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2) ) ) ).

% gcd_nat.strict_iff_not
tff(fact_291_gcd__nat_Ostrict__trans2,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans2
tff(fact_292_gcd__nat_Ostrict__trans1,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
          & ( B2 != C2 ) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans1
tff(fact_293_gcd__nat_Ostrict__trans,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
          & ( B2 != C2 ) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans
tff(fact_294_gcd__nat_Oantisym,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
       => ( A2 = B2 ) ) ) ).

% gcd_nat.antisym
tff(fact_295_gcd__nat_Oirrefl,axiom,
    ! [A2: nat] :
      ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),A2)
        & ( A2 != A2 ) ) ).

% gcd_nat.irrefl
tff(fact_296_gcd__nat_Oeq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = B2 )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2) ) ) ).

% gcd_nat.eq_iff
tff(fact_297_gcd__nat_Otrans,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2) ) ) ).

% gcd_nat.trans
tff(fact_298_gcd__nat_Orefl,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),A2) ).

% gcd_nat.refl
tff(fact_299_gcd__nat_Oasym,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
          & ( B2 != A2 ) ) ) ).

% gcd_nat.asym
tff(fact_300_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
        <=> ( ( A2 = zero_zero(A) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% dvd_field_iff
tff(fact_301_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% add_divide_distrib
tff(fact_302_Euclid__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),A2: nat,B2: nat] :
      ( ! [A4: nat,B4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),P,A4),B4)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),P,B4),A4) )
     => ( ! [A4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,A4),zero_zero(nat))
       => ( ! [A4: nat,B4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),P,A4),B4)
             => aa(nat,$o,aa(nat,fun(nat,$o),P,A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),B4)) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,A2),B2) ) ) ) ).

% Euclid_induct
tff(fact_303_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
     => ( A2 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_uniqueI
tff(fact_304_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( A2 != zero_zero(nat) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),zero_zero(nat))
        & ( A2 != zero_zero(nat) ) ) ) ).

% gcd_nat.not_eq_extremum
tff(fact_305_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
    <=> ( A2 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_unique
tff(fact_306_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
        & ( zero_zero(nat) != A2 ) ) ).

% gcd_nat.extremum_strict
tff(fact_307_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),zero_zero(nat)) ).

% gcd_nat.extremum
tff(fact_308_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% divide_neg_neg
tff(fact_309_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),zero_zero(A)) ) ) ) ).

% divide_neg_pos
tff(fact_310_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),zero_zero(A)) ) ) ) ).

% divide_pos_neg
tff(fact_311_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% divide_pos_pos
tff(fact_312_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ) ).

% divide_less_0_iff
tff(fact_313_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            & ( C2 != zero_zero(A) ) ) ) ) ).

% divide_less_cancel
tff(fact_314_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_less_divide_iff
tff(fact_315_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% divide_strict_right_mono
tff(fact_316_enat__ord__number_I2_J,axiom,
    ! [M: num,Na: num] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),aa(num,extended_enat,numeral_numeral(extended_enat),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),Na)) ) ).

% enat_ord_number(2)
tff(fact_317_num_Osize__gen_I2_J,axiom,
    ! [X2: num] : ( size_num(aa(num,num,bit0,X2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X2)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(2)
tff(fact_318_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),A2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            & ( M != zero_zero(nat) ) ) ) ) ).

% even_set_bit_iff
tff(fact_319_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),M),A2))
        <=> ~ ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            <=> ( M = zero_zero(nat) ) ) ) ) ).

% even_flip_bit_iff
tff(fact_320_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            | ( M = zero_zero(nat) ) ) ) ) ).

% even_unset_bit_iff
tff(fact_321_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W)))
        <=> ( ( aa(num,nat,numeral_numeral(nat),W) = zero_zero(nat) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
              & ( A2 != zero_zero(A) ) )
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_less_power_eq_numeral
tff(fact_322_num_Osize_I5_J,axiom,
    ! [X2: num] : ( aa(num,nat,size_size(num),aa(num,num,bit0,X2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X2)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(5)
tff(fact_323_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_2
tff(fact_324_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ) ).

% odd_succ_div_two
tff(fact_325_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_two
tff(fact_326_even__diff__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) ) ) ).

% even_diff_nat
tff(fact_327_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),one_one(nat))
    <=> ( M = one_one(nat) ) ) ).

% nat_dvd_1_iff_1
tff(fact_328_i0__less,axiom,
    ! [Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Na)
    <=> ( Na != zero_zero(extended_enat) ) ) ).

% i0_less
tff(fact_329_diff__self,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A2) = zero_zero(A) ) ) ).

% diff_self
tff(fact_330_diff__0__right,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),zero_zero(A)) = A2 ) ) ).

% diff_0_right
tff(fact_331_zero__diff,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% zero_diff
tff(fact_332_diff__zero,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),zero_zero(A)) = A2 ) ) ).

% diff_zero
tff(fact_333_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A2) = zero_zero(A) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_334_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = A2 ) ) ).

% add_diff_cancel
tff(fact_335_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),B2) = A2 ) ) ).

% diff_add_cancel
tff(fact_336_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ).

% add_diff_cancel_left
tff(fact_337_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),A2) = B2 ) ) ).

% add_diff_cancel_left'
tff(fact_338_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ).

% add_diff_cancel_right
tff(fact_339_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = A2 ) ) ).

% add_diff_cancel_right'
tff(fact_340_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),one_one(A)) = A2 ) ) ).

% bits_div_by_1
tff(fact_341_div__by__1,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),one_one(A)) = A2 ) ) ).

% div_by_1
tff(fact_342_less__one,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),one_one(nat))
    <=> ( Na = zero_zero(nat) ) ) ).

% less_one
tff(fact_343_diff__Suc__1,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Na)),one_one(nat)) = Na ) ).

% diff_Suc_1
tff(fact_344_Suc__diff__diff,axiom,
    ! [M: nat,Na: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),Na)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),K) ) ).

% Suc_diff_diff
tff(fact_345_diff__Suc__Suc,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) ) ).

% diff_Suc_Suc
tff(fact_346_diff__self__eq__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),M) = zero_zero(nat) ) ).

% diff_self_eq_0
tff(fact_347_diff__0__eq__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),zero_zero(nat)),Na) = zero_zero(nat) ) ).

% diff_0_eq_0
tff(fact_348_diff__diff__left,axiom,
    ! [I2: nat,J2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) ) ).

% diff_diff_left
tff(fact_349_unset__bit__negative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Na),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% unset_bit_negative_int_iff
tff(fact_350_set__bit__negative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Na),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% set_bit_negative_int_iff
tff(fact_351_flip__bit__negative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(nat,fun(int,int),bit_se8732182000553998342ip_bit(int),Na),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% flip_bit_negative_int_iff
tff(fact_352_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% diff_gt_0_iff_gt
tff(fact_353_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),one_one(A)) = zero_zero(A) ) ) ).

% diff_numeral_special(9)
tff(fact_354_diff__add__zero,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = zero_zero(A) ) ) ).

% diff_add_zero
tff(fact_355_div__self,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),A2) = one_one(A) ) ) ) ).

% div_self
tff(fact_356_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_357_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_358_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) )
        <=> ( ( A2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_359_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = one_one(A) )
        <=> ( ( A2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_360_divide__self__if,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),A2)
          = $ite(A2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% divide_self_if
tff(fact_361_divide__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),A2) = one_one(A) ) ) ) ).

% divide_self
tff(fact_362_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( one_one(A) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_363_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = one_one(A) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_364_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Na) )
        <=> ( one2 = Na ) ) ) ).

% one_eq_numeral_iff
tff(fact_365_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: num] :
          ( ( aa(num,A,numeral_numeral(A),Na) = one_one(A) )
        <=> ( Na = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_366_unit__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),one_one(A)) ) ) ) ).

% unit_div
tff(fact_367_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),one_one(A)) ) ) ).

% unit_div_1_unit
tff(fact_368_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)) = A2 ) ) ) ).

% unit_div_1_div_1
tff(fact_369_div__diff,axiom,
    ! [A: $tType] :
      ( idom_modulo(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ) ).

% div_diff
tff(fact_370_zero__less__diff,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% zero_less_diff
tff(fact_371_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% zero_less_divide_1_iff
tff(fact_372_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_373_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_374_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_375_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_376_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% divide_less_0_1_iff
tff(fact_377_Suc__1,axiom,
    aa(nat,nat,suc,one_one(nat)) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) ).

% Suc_1
tff(fact_378_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Na: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% pow_divides_pow_iff
tff(fact_379_Suc__diff__1,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) = Na ) ) ).

% Suc_diff_1
tff(fact_380_Suc__pred,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))) = Na ) ) ).

% Suc_pred
tff(fact_381_one__add__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% one_add_one
tff(fact_382_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Na)) ) ) ).

% one_plus_numeral
tff(fact_383_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Na)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Na),one2)) ) ) ).

% numeral_plus_one
tff(fact_384_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(num,A,numeral_numeral(A),Na))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),Na) ) ) ).

% one_less_numeral_iff
tff(fact_385_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% one_div_two_eq_zero
tff(fact_386_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% bits_1_div_2
tff(fact_387_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_plus_one_iff
tff(fact_388_even__diff,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ).

% even_diff
tff(fact_389_even__power,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ) ).

% even_power
tff(fact_390_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A))
        <=> ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% power_less_zero_eq_numeral
tff(fact_391_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),zero_zero(A))
        <=> ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% power_less_zero_eq
tff(fact_392_odd__Suc__minus__one,axiom,
    ! [Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))) = Na ) ) ).

% odd_Suc_minus_one
tff(fact_393_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),one_one(A)))
        <=> ( Na = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_394_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_395_plus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),zero_zero(int)),L) = L ) ).

% plus_int_code(2)
tff(fact_396_plus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),K),zero_zero(int)) = K ) ).

% plus_int_code(1)
tff(fact_397_odd__nonzero,axiom,
    ! [Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z) != zero_zero(int) ) ).

% odd_nonzero
tff(fact_398_int__gr__induct,axiom,
    ! [K: int,I2: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I2)
     => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int)))
       => ( ! [I3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I3)
             => ( aa(int,$o,P,I3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))) ) )
         => aa(int,$o,P,I2) ) ) ) ).

% int_gr_induct
tff(fact_399_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int)))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
        | ( W = Z ) ) ) ).

% zless_add1_eq
tff(fact_400_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),zero_zero(int)) ) ).

% odd_less_0_iff
tff(fact_401_zdvd__not__zless,axiom,
    ! [M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),M)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),M),Na)
       => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Na),M) ) ) ).

% zdvd_not_zless
tff(fact_402_less__int__code_I1_J,axiom,
    ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),zero_zero(int)) ).

% less_int_code(1)
tff(fact_403_not__iless0,axiom,
    ! [Na: extended_enat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Na),zero_zero(extended_enat)) ).

% not_iless0
tff(fact_404_enat__less__induct,axiom,
    ! [P: fun(extended_enat,$o),Na: extended_enat] :
      ( ! [N: extended_enat] :
          ( ! [M2: extended_enat] :
              ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),M2),N)
             => aa(extended_enat,$o,P,M2) )
         => aa(extended_enat,$o,P,N) )
     => aa(extended_enat,$o,P,Na) ) ).

% enat_less_induct
tff(fact_405_diff__commute,axiom,
    ! [I2: nat,J2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),K)),J2) ) ).

% diff_commute
tff(fact_406_one__reorient,axiom,
    ! [A: $tType] :
      ( one(A)
     => ! [X: A] :
          ( ( one_one(A) = X )
        <=> ( X = one_one(A) ) ) ) ).

% one_reorient
tff(fact_407_diff__right__commute,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) ) ) ).

% diff_right_commute
tff(fact_408_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( ( A2 = B2 )
          <=> ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_409_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),Na) ) ).

% diff_Suc_eq_diff_pred
tff(fact_410_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( size(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,nat,size_size(A),X) != aa(A,nat,size_size(A),Y) )
         => ( X != Y ) ) ) ).

% size_neq_size_imp_neq
tff(fact_411_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = zero_zero(A) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_412_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),D2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ) ).

% diff_strict_mono
tff(fact_413_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2) ) ) ) ).

% diff_eq_diff_less
tff(fact_414_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% diff_strict_left_mono
tff(fact_415_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% diff_strict_right_mono
tff(fact_416_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% group_cancel.sub1
tff(fact_417_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = C2 )
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) ) ) ) ).

% diff_eq_eq
tff(fact_418_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_419_add__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% add_diff_eq
tff(fact_420_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ).

% diff_diff_eq2
tff(fact_421_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ).

% diff_add_eq
tff(fact_422_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),B2) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_423_add__implies__diff,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) = A2 )
         => ( C2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ) ).

% add_implies_diff
tff(fact_424_add__diff__add,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,C2: A,B2: A,D2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2)) ) ) ).

% add_diff_add
tff(fact_425_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% diff_diff_eq
tff(fact_426_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% diff_divide_distrib
tff(fact_427_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( euclid5891614535332579305n_ring(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% dvd_diff_commute
tff(fact_428_dvd__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Z)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z)) ) ) ) ).

% dvd_diff
tff(fact_429_realpow__pos__nth2,axiom,
    ! [A2: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ? [R: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
          & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),R),aa(nat,nat,suc,Na)) = A2 ) ) ) ).

% realpow_pos_nth2
tff(fact_430_zero__induct__lemma,axiom,
    ! [P: fun(nat,$o),K: nat,I2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [N: nat] :
            ( aa(nat,$o,P,aa(nat,nat,suc,N))
           => aa(nat,$o,P,N) )
       => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I2)) ) ) ).

% zero_induct_lemma
tff(fact_431_diffs0__imp__equal,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) = zero_zero(nat) )
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M) = zero_zero(nat) )
       => ( M = Na ) ) ) ).

% diffs0_imp_equal
tff(fact_432_minus__nat_Odiff__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),zero_zero(nat)) = M ) ).

% minus_nat.diff_0
tff(fact_433_less__imp__diff__less,axiom,
    ! [J2: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),Na)),K) ) ).

% less_imp_diff_less
tff(fact_434_diff__less__mono2,axiom,
    ! [M: nat,Na: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),Na)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),M)) ) ) ).

% diff_less_mono2
tff(fact_435_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) ) ).

% Nat.diff_cancel
tff(fact_436_diff__cancel2,axiom,
    ! [M: nat,K: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) ) ).

% diff_cancel2
tff(fact_437_diff__add__inverse,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)),Na) = M ) ).

% diff_add_inverse
tff(fact_438_diff__add__inverse2,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),Na) = M ) ).

% diff_add_inverse2
tff(fact_439_zero__neq__one,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( zero_zero(A) != one_one(A) ) ) ).

% zero_neq_one
tff(fact_440_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),one_one(A)) ) ).

% less_numeral_extra(4)
tff(fact_441_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) ) ) ).

% dvd_diff_nat
tff(fact_442_one__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),one_one(A)),A2) ) ).

% one_dvd
tff(fact_443_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% unit_imp_dvd
tff(fact_444_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_445_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X),K)),X) ) ) ).

% int_div_less_self
tff(fact_446_Suc__diff__eq__diff__pred,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),Na) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) ) ) ).

% Suc_diff_eq_diff_pred
tff(fact_447_Suc__pred_H,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( Na = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) ) ) ).

% Suc_pred'
tff(fact_448_add__eq__if,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)
      = $ite(M = zero_zero(nat),Na,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),Na))) ) ).

% add_eq_if
tff(fact_449_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat,M: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) != zero_zero(A) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
tff(fact_450_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),K),M)),K) = aa(nat,int,aa(int,fun(nat,int),power_power(int),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,zero_zero(nat)))) ) ) ) ).

% int_power_div_base
tff(fact_451_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),zero_zero(A)) ) ) ).

% less_iff_diff_less_0
tff(fact_452_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% diff_less_eq
tff(fact_453_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% less_diff_eq
tff(fact_454_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
tff(fact_455_realpow__pos__nth,axiom,
    ! [Na: nat,A2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ? [R: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
            & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),R),Na) = A2 ) ) ) ) ).

% realpow_pos_nth
tff(fact_456_realpow__pos__nth__unique,axiom,
    ! [Na: nat,A2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ? [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X3)
            & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),X3),Na) = A2 )
            & ! [Y3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3)
                  & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y3),Na) = A2 ) )
               => ( Y3 = X3 ) ) ) ) ) ).

% realpow_pos_nth_unique
tff(fact_457_Suc__diff__Suc,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,Na))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) ) ) ).

% Suc_diff_Suc
tff(fact_458_diff__less__Suc,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),aa(nat,nat,suc,M)) ).

% diff_less_Suc
tff(fact_459_diff__less,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),M) ) ) ).

% diff_less
tff(fact_460_diff__add__0,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)) = zero_zero(nat) ) ).

% diff_add_0
tff(fact_461_less__diff__conv,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),J2) ) ).

% less_diff_conv
tff(fact_462_add__diff__inverse__nat,axiom,
    ! [M: nat,Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) = M ) ) ).

% add_diff_inverse_nat
tff(fact_463_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),zero_zero(A)) ) ).

% not_one_less_zero
tff(fact_464_zero__less__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),one_one(A)) ) ).

% zero_less_one
tff(fact_465_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),one_one(A)) ) ).

% less_numeral_extra(1)
tff(fact_466_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Na)),one_one(A)) ) ).

% not_numeral_less_one
tff(fact_467_add__mono1,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),one_one(A))) ) ) ).

% add_mono1
tff(fact_468_less__add__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))) ) ).

% less_add_one
tff(fact_469_dvd__minus__self,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ) ).

% dvd_minus_self
tff(fact_470_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = one_one(A) )
          <=> ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
tff(fact_471_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),X)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) ) ) ).

% one_plus_numeral_commute
tff(fact_472_numeral__One,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(num,A,numeral_numeral(A),one2) = one_one(A) ) ) ).

% numeral_One
tff(fact_473_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),one_one(A)) ) ).

% not_is_unit_0
tff(fact_474_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_475_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% div_unit_dvd_iff
tff(fact_476_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_div_unit_iff
tff(fact_477_numerals_I1_J,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = one_one(nat) ).

% numerals(1)
tff(fact_478_One__nat__def,axiom,
    one_one(nat) = aa(nat,nat,suc,zero_zero(nat)) ).

% One_nat_def
tff(fact_479_Suc__eq__plus1,axiom,
    ! [Na: nat] : ( aa(nat,nat,suc,Na) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)) ) ).

% Suc_eq_plus1
tff(fact_480_plus__1__eq__Suc,axiom,
    aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)) = suc ).

% plus_1_eq_Suc
tff(fact_481_Suc__eq__plus1__left,axiom,
    ! [Na: nat] : ( aa(nat,nat,suc,Na) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),Na) ) ).

% Suc_eq_plus1_left
tff(fact_482_diff__Suc__less,axiom,
    ! [Na: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,I2))),Na) ) ).

% diff_Suc_less
tff(fact_483_nat__diff__split,axiom,
    ! [P: fun(nat,$o),A2: nat,B2: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
         => aa(nat,$o,P,zero_zero(nat)) )
        & ! [D3: nat] :
            ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D3) )
           => aa(nat,$o,P,D3) ) ) ) ).

% nat_diff_split
tff(fact_484_nat__diff__split__asm,axiom,
    ! [P: fun(nat,$o),A2: nat,B2: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
    <=> ~ ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
            & ~ aa(nat,$o,P,zero_zero(nat)) )
          | ? [D3: nat] :
              ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D3) )
              & ~ aa(nat,$o,P,D3) ) ) ) ).

% nat_diff_split_asm
tff(fact_485_zero__less__two,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A))) ) ).

% zero_less_two
tff(fact_486_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% less_divide_eq_1
tff(fact_487_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( A2 = zero_zero(A) ) ) ) ) ).

% divide_less_eq_1
tff(fact_488_div__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),one_one(A)) ) ) ) ).

% div_add_self1
tff(fact_489_div__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),one_one(A)) ) ) ) ).

% div_add_self2
tff(fact_490_gt__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))),B2) ) ) ).

% gt_half_sum
tff(fact_491_less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))) ) ) ).

% less_half_sum
tff(fact_492_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_493_nat__induct__non__zero,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,P,one_one(nat))
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(nat,$o,P,N)
               => aa(nat,$o,P,aa(nat,nat,suc,N)) ) )
         => aa(nat,$o,P,Na) ) ) ) ).

% nat_induct_non_zero
tff(fact_494_div__eq__dividend__iff,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) = M )
      <=> ( Na = one_one(nat) ) ) ) ).

% div_eq_dividend_iff
tff(fact_495_div__less__dividend,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),M) ) ) ).

% div_less_dividend
tff(fact_496_num_Osize_I4_J,axiom,
    aa(num,nat,size_size(num),one2) = zero_zero(nat) ).

% num.size(4)
tff(fact_497_div__geq,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),Na)) ) ) ) ).

% div_geq
tff(fact_498_div__if,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)
      = $ite(
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
          | ( Na = zero_zero(nat) ) ),
          zero_zero(nat),
          aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),Na)) ) ) ).

% div_if
tff(fact_499_odd__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),one_one(A)) ) ).

% odd_one
tff(fact_500_nat__1__add__1,axiom,
    aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),one_one(nat)) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) ).

% nat_1_add_1
tff(fact_501_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_right
tff(fact_502_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_left
tff(fact_503_div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,M: nat,Na: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))) ) ) ).

% div_exp_eq
tff(fact_504_num_Osize__gen_I1_J,axiom,
    size_num(one2) = zero_zero(nat) ).

% num.size_gen(1)
tff(fact_505_nat__induct2,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( aa(nat,$o,P,one_one(nat))
       => ( ! [N: nat] :
              ( aa(nat,$o,P,N)
             => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) )
         => aa(nat,$o,P,Na) ) ) ) ).

% nat_induct2
tff(fact_506_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
        <=> ( ( Na = zero_zero(nat) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
              & ( A2 != zero_zero(A) ) )
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_less_power_eq
tff(fact_507_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = zero_zero(A) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_power2_eq_zero_iff
tff(fact_508_zero__less__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% zero_less_power2
tff(fact_509_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% zero_eq_power2
tff(fact_510_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_511_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A,Na: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ) ).

% power_eq_0_iff
tff(fact_512_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X: nat,Y: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y) ) ) ) ).

% power_strict_increasing_iff
tff(fact_513_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% power_Suc0_right
tff(fact_514_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),aa(num,nat,numeral_numeral(nat),K)) = zero_zero(A) ) ) ).

% power_zero_numeral
tff(fact_515_power__0__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),aa(nat,nat,suc,Na)) = zero_zero(A) ) ) ).

% power_0_Suc
tff(fact_516_power__inject__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) )
          <=> ( M = Na ) ) ) ) ).

% power_inject_exp
tff(fact_517_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))
        <=> ( ( X != zero_zero(A) )
            | ( Y != zero_zero(A) ) ) ) ) ).

% sum_power2_gt_zero_iff
tff(fact_518_idiff__0,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),zero_zero(extended_enat)),Na) = zero_zero(extended_enat) ) ).

% idiff_0
tff(fact_519_idiff__0__right,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Na),zero_zero(extended_enat)) = Na ) ).

% idiff_0_right
tff(fact_520_power__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),Na) = one_one(A) ) ) ).

% power_one
tff(fact_521_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),X),M) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = zero_zero(nat) )
        | ( X = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% nat_power_eq_Suc_0_iff
tff(fact_522_power__Suc__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,suc,zero_zero(nat))),Na) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% power_Suc_0
tff(fact_523_nat__zero__less__power__iff,axiom,
    ! [X: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),X),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X)
        | ( Na = zero_zero(nat) ) ) ) ).

% nat_zero_less_power_iff
tff(fact_524_power__one__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),one_one(nat)) = A2 ) ) ).

% power_one_right
tff(fact_525_iadd__is__0,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),Na) = zero_zero(extended_enat) )
    <=> ( ( M = zero_zero(extended_enat) )
        & ( Na = zero_zero(extended_enat) ) ) ) ).

% iadd_is_0
tff(fact_526_zero__one__enat__neq_I1_J,axiom,
    zero_zero(extended_enat) != one_one(extended_enat) ).

% zero_one_enat_neq(1)
tff(fact_527_real__arch__pow,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),N)) ) ).

% real_arch_pow
tff(fact_528_real__arch__pow__inv,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),N)),Y) ) ) ).

% real_arch_pow_inv
tff(fact_529_zdvd__zdiffD,axiom,
    ! [K: int,M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),Na))
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),Na)
       => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),M) ) ) ).

% zdvd_zdiffD
tff(fact_530_minus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),K),zero_zero(int)) = K ) ).

% minus_int_code(1)
tff(fact_531_int__less__induct,axiom,
    ! [I2: int,K: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),K)
     => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))
       => ( ! [I3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I3),K)
             => ( aa(int,$o,P,I3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I3),one_one(int))) ) )
         => aa(int,$o,P,I2) ) ) ) ).

% int_less_induct
tff(fact_532_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_diff_iff
tff(fact_533_power__not__zero,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A,Na: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) != zero_zero(A) ) ) ) ).

% power_not_zero
tff(fact_534_power__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),Na) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ).

% power_divide
tff(fact_535_dvd__power__same,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X: A,Y: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),Na)) ) ) ).

% dvd_power_same
tff(fact_536_nat__power__less__imp__less,axiom,
    ! [I2: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),I2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I2),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I2),Na))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% nat_power_less_imp_less
tff(fact_537_zero__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% zero_less_power
tff(fact_538_power__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),Na) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% power_one_over
tff(fact_539_power__0,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),zero_zero(nat)) = one_one(A) ) ) ).

% power_0
tff(fact_540_div__power,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),Na) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ) ).

% div_power
tff(fact_541_power__gt__expt,axiom,
    ! [Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Na),K)) ) ).

% power_gt_expt
tff(fact_542_power__0__left,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Na)
          = $ite(Na = zero_zero(nat),one_one(A),zero_zero(A)) ) ) ).

% power_0_left
tff(fact_543_power__gt1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na))) ) ) ).

% power_gt1
tff(fact_544_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N3)) ) ) ) ).

% power_strict_increasing
tff(fact_545_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ) ).

% power_less_imp_less_exp
tff(fact_546_zero__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Na) = zero_zero(A) ) ) ) ).

% zero_power
tff(fact_547_less__exp,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ).

% less_exp
tff(fact_548_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            | ( Na = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_549_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na))),one_one(A)) ) ) ) ).

% power_Suc_less_one
tff(fact_550_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N3)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ) ).

% power_strict_decreasing
tff(fact_551_zero__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% zero_power2
tff(fact_552_one__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_power2
tff(fact_553_one__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ).

% one_less_power
tff(fact_554_power2__commute,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power2_commute
tff(fact_555_dvd__power,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Na: nat,X: A] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
            | ( X = one_one(A) ) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) ) ) ).

% dvd_power
tff(fact_556_power2__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),zero_zero(A)) ) ).

% power2_less_0
tff(fact_557_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),zero_zero(A)) ) ).

% not_sum_power2_lt_zero
tff(fact_558_calculation_I5_J,axiom,
    aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ).

% calculation(5)
tff(fact_559_high__bound__aux,axiom,
    ! [Ma: nat,Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),vEBT_VEBT_high(Ma,Na)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)) ) ).

% high_bound_aux
tff(fact_560_real__average__minus__second,axiom,
    ! [B2: real,A2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),A2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),A2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ).

% real_average_minus_second
tff(fact_561_real__average__minus__first,axiom,
    ! [A2: real,B2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),A2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ).

% real_average_minus_first
tff(fact_562_Suc__if__eq,axiom,
    ! [A: $tType,F2: fun(nat,A),H: fun(nat,A),G: A,Na: nat] :
      ( ! [N: nat] : ( aa(nat,A,F2,aa(nat,nat,suc,N)) = aa(nat,A,H,N) )
     => ( ( aa(nat,A,F2,zero_zero(nat)) = G )
       => ( aa(nat,A,F2,Na)
          = $ite(Na = zero_zero(nat),G,aa(nat,A,H,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))) ) ) ) ).

% Suc_if_eq
tff(fact_563_high__def,axiom,
    ! [X: nat,Na: nat] : ( vEBT_VEBT_high(X,Na) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% high_def
tff(fact_564_calculation_I4_J,axiom,
    ! [X4: vEBT_VEBT] :
      ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))
     => vEBT_invar_vebt(X4,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% calculation(4)
tff(fact_565_calculation_I7_J,axiom,
    ! [X4: vEBT_VEBT] :
      ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))
     => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) ).

% calculation(7)
tff(fact_566_length__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] : ( aa(list(A),nat,size_size(list(A)),replicate(A,Na,X)) = Na ) ).

% length_replicate
tff(fact_567_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,Na: nat,Y: A] :
      ( ( replicate(A,M,X) = replicate(A,Na,Y) )
    <=> ( ( M = Na )
        & ( ( M != zero_zero(nat) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
tff(fact_568_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% dbl_simps(3)
tff(fact_569_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_570_set__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),zero_zero(nat)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% set_bit_0
tff(fact_571_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),W))
            & ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
              | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
                & ( A2 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
tff(fact_572_power__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,L: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),K)),aa(num,nat,numeral_numeral(nat),L)) = aa(num,A,numeral_numeral(A),pow(K,L)) ) ) ).

% power_numeral
tff(fact_573_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),one_one(A))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)))
        <=> ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) = zero_zero(A) )
            | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ) ).

% even_mask_div_iff
tff(fact_574_semiring__norm_I13_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit0,M)),aa(num,num,bit0,Na)) = aa(num,num,bit0,aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),M),Na))) ) ).

% semiring_norm(13)
tff(fact_575_semiring__norm_I71_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit0,M)),aa(num,num,bit0,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na) ) ).

% semiring_norm(71)
tff(fact_576_semiring__norm_I12_J,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),one2),Na) = Na ) ).

% semiring_norm(12)
tff(fact_577_semiring__norm_I11_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),M),one2) = M ) ).

% semiring_norm(11)
tff(fact_578_semiring__norm_I68_J,axiom,
    ! [Na: num] : aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),one2),Na) ).

% semiring_norm(68)
tff(fact_579_mult__is__0,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        | ( Na = zero_zero(nat) ) ) ) ).

% mult_is_0
tff(fact_580_mult__0__right,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),zero_zero(nat)) = zero_zero(nat) ) ).

% mult_0_right
tff(fact_581_mult__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na) )
    <=> ( ( M = Na )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel1
tff(fact_582_mult__cancel2,axiom,
    ! [M: nat,K: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K) )
    <=> ( ( M = Na )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel2
tff(fact_583_mod__less,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( modulo_modulo(nat,M,Na) = M ) ) ).

% mod_less
tff(fact_584_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,modulo_modulo(A,A2,B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mod_trivial
tff(fact_585_real__divide__square__eq,axiom,
    ! [R2: real,A2: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),R2),A2)),aa(real,real,aa(real,fun(real,real),times_times(real),R2),R2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),R2) ) ).

% real_divide_square_eq
tff(fact_586_nat__mult__eq__1__iff,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) = one_one(nat) )
    <=> ( ( M = one_one(nat) )
        & ( Na = one_one(nat) ) ) ) ).

% nat_mult_eq_1_iff
tff(fact_587_nat__1__eq__mult__iff,axiom,
    ! [M: nat,Na: nat] :
      ( ( one_one(nat) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) )
    <=> ( ( M = one_one(nat) )
        & ( Na = one_one(nat) ) ) ) ).

% nat_1_eq_mult_iff
tff(fact_588_le__zero__eq,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Na: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Na),zero_zero(A))
        <=> ( Na = zero_zero(A) ) ) ) ).

% le_zero_eq
tff(fact_589_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: num,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na) ) ) ).

% numeral_le_iff
tff(fact_590_mult__zero__left,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% mult_zero_left
tff(fact_591_mult__zero__right,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% mult_zero_right
tff(fact_592_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_593_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
tff(fact_594_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
tff(fact_595_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_cancel_right
tff(fact_596_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_cancel_left
tff(fact_597_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Z) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_598_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),Na)) ) ) ).

% numeral_times_numeral
tff(fact_599_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),one_one(A)) = A2 ) ) ).

% mult.right_neutral
tff(fact_600_mult__1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A2) = A2 ) ) ).

% mult_1
tff(fact_601_num__double,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit0,one2)),Na) = aa(num,num,bit0,Na) ) ).

% num_double
tff(fact_602_semiring__norm_I69_J,axiom,
    ! [M: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit0,M)),one2) ).

% semiring_norm(69)
tff(fact_603_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,C2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) ) ) ).

% times_divide_eq_left
tff(fact_604_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_605_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ).

% divide_divide_eq_right
tff(fact_606_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ).

% times_divide_eq_right
tff(fact_607_mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% mod_0
tff(fact_608_mod__by__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,zero_zero(A)) = A2 ) ) ).

% mod_by_0
tff(fact_609_mod__self,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,A2) = zero_zero(A) ) ) ).

% mod_self
tff(fact_610_bits__mod__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( modulo_modulo(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% bits_mod_0
tff(fact_611_mod__by__Suc__0,axiom,
    ! [M: nat] : ( modulo_modulo(nat,M,aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% mod_by_Suc_0
tff(fact_612_one__eq__mult__iff,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% one_eq_mult_iff
tff(fact_613_mult__eq__1__iff,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% mult_eq_1_iff
tff(fact_614_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: num,Na: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),M))),aa(num,nat,numeral_numeral(nat),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),times_times(num),M),Na))) ) ) ).

% power_mult_numeral
tff(fact_615_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% mult_less_cancel2
tff(fact_616_nat__0__less__mult__iff,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ).

% nat_0_less_mult_iff
tff(fact_617_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% nat_mult_less_cancel_disj
tff(fact_618_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),times_times(real),X),X))
    <=> ( X = zero_zero(real) ) ) ).

% not_real_square_gt_zero
tff(fact_619_Suc__le__mono,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),aa(nat,nat,suc,M))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M) ) ).

% Suc_le_mono
tff(fact_620_mod__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_add_self2
tff(fact_621_mod__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_add_self1
tff(fact_622_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),A2) ).

% bot_nat_0.extremum
tff(fact_623_le0,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),Na) ).

% le0
tff(fact_624_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% minus_mod_self2
tff(fact_625_Suc__mod__mult__self4,axiom,
    ! [Na: nat,K: nat,M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K)),M)),Na) = modulo_modulo(nat,aa(nat,nat,suc,M),Na) ) ).

% Suc_mod_mult_self4
tff(fact_626_Suc__mod__mult__self3,axiom,
    ! [K: nat,Na: nat,M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na)),M)),Na) = modulo_modulo(nat,aa(nat,nat,suc,M),Na) ) ).

% Suc_mod_mult_self3
tff(fact_627_Suc__mod__mult__self2,axiom,
    ! [M: nat,Na: nat,K: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K))),Na) = modulo_modulo(nat,aa(nat,nat,suc,M),Na) ) ).

% Suc_mod_mult_self2
tff(fact_628_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,Na: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))),Na) = modulo_modulo(nat,aa(nat,nat,suc,M),Na) ) ).

% Suc_mod_mult_self1
tff(fact_629_mult__Suc__right,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,suc,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) ) ).

% mult_Suc_right
tff(fact_630_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% nat_add_left_cancel_le
tff(fact_631_diff__diff__cancel,axiom,
    ! [I2: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),I2)) = I2 ) ) ).

% diff_diff_cancel
tff(fact_632_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
    <=> ( ( K = zero_zero(nat) )
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ) ).

% nat_mult_dvd_cancel_disj
tff(fact_633_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),K)
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_neg_neg_trivial
tff(fact_634_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),L)
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_pos_pos_trivial
tff(fact_635_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
      = $ite(K = zero_zero(nat),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)) ) ).

% nat_mult_div_cancel_disj
tff(fact_636_unset__bit__nonnegative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% unset_bit_nonnegative_int_iff
tff(fact_637_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,zero_zero(A)) = zero_zero(A) ) ) ).

% dbl_simps(2)
tff(fact_638_set__bit__nonnegative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% set_bit_nonnegative_int_iff
tff(fact_639_flip__bit__nonnegative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(nat,fun(int,int),bit_se8732182000553998342ip_bit(int),Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% flip_bit_nonnegative_int_iff
tff(fact_640_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_641_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_642_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ).

% le_add_same_cancel2
tff(fact_643_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ).

% le_add_same_cancel1
tff(fact_644_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% add_le_same_cancel2
tff(fact_645_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% add_le_same_cancel1
tff(fact_646_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% diff_ge_0_iff_ge
tff(fact_647_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_left1
tff(fact_648_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = one_one(A) ) ) ) ) ).

% mult_cancel_left2
tff(fact_649_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_right1
tff(fact_650_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = one_one(A) ) ) ) ) ).

% mult_cancel_right2
tff(fact_651_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = zero_zero(A) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_652_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = A2 ) ) ) ).

% le_add_diff_inverse
tff(fact_653_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),B2) = A2 ) ) ) ).

% le_add_diff_inverse2
tff(fact_654_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          = $ite(C2 = zero_zero(A),zero_zero(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_655_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_656_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_657_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_658_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_659_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),A2) = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_660_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),B2) = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_661_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          = $ite(C2 = zero_zero(A),zero_zero(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ).

% div_mult_mult1_if
tff(fact_662_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% div_mult_mult2
tff(fact_663_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% div_mult_mult1
tff(fact_664_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [A2: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% distrib_right_numeral
tff(fact_665_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_666_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_667_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [A2: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_668_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( C2 = zero_zero(A) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_669_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( C2 = zero_zero(A) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_670_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_671_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_672_unit__prod,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A)) ) ) ) ).

% unit_prod
tff(fact_673_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_674_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_675_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2),B2) = zero_zero(A) ) ) ).

% mod_mult_self1_is_0
tff(fact_676_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),B2) = zero_zero(A) ) ) ).

% mod_mult_self2_is_0
tff(fact_677_mod__by__1,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,one_one(A)) = zero_zero(A) ) ) ).

% mod_by_1
tff(fact_678_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,one_one(A)) = zero_zero(A) ) ) ).

% bits_mod_by_1
tff(fact_679_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)) = B2 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_680_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),A2) = B2 ) ) ) ).

% dvd_div_mult_self
tff(fact_681_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A2,B2)),B2) = zero_zero(A) ) ) ).

% bits_mod_div_trivial
tff(fact_682_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A2,B2)),B2) = zero_zero(A) ) ) ).

% mod_div_trivial
tff(fact_683_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self4
tff(fact_684_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self3
tff(fact_685_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self2
tff(fact_686_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self1
tff(fact_687_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,V)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W))) ) ).

% zmod_numeral_Bit0
tff(fact_688_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( modulo_modulo(A,B2,A2) = zero_zero(A) ) ) ) ).

% dvd_imp_mod_0
tff(fact_689_one__le__mult__iff,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),M)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),Na) ) ) ).

% one_le_mult_iff
tff(fact_690_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% mult_le_cancel2
tff(fact_691_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% nat_mult_le_cancel_disj
tff(fact_692_diff__is__0__eq,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) = zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% diff_is_0_eq
tff(fact_693_diff__is__0__eq_H,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) = zero_zero(nat) ) ) ).

% diff_is_0_eq'
tff(fact_694_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,Na: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) != one_one(nat) )
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),K)),Na)),aa(num,nat,numeral_numeral(nat),K)) = one_one(nat) ) ) ).

% Suc_times_numeral_mod_eq
tff(fact_695_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),J2) ) ) ).

% Nat.diff_diff_right
tff(fact_696_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I2) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),I2)),K) ) ) ).

% Nat.add_diff_assoc2
tff(fact_697_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)),K) ) ) ).

% Nat.add_diff_assoc
tff(fact_698_div__mult__self__is__m,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),Na) = M ) ) ).

% div_mult_self_is_m
tff(fact_699_div__mult__self1__is__m,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),M)),Na) = M ) ) ).

% div_mult_self1_is_m
tff(fact_700_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int)))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ).

% zle_add1_eq_le
tff(fact_701_Ball__set__replicate,axiom,
    ! [A: $tType,Na: nat,A2: A,P: fun(A,$o)] :
      ( ! [X5: A] :
          ( member(A,X5,aa(list(A),set(A),set2(A),replicate(A,Na,A2)))
         => aa(A,$o,P,X5) )
    <=> ( aa(A,$o,P,A2)
        | ( Na = zero_zero(nat) ) ) ) ).

% Ball_set_replicate
tff(fact_702_Bex__set__replicate,axiom,
    ! [A: $tType,Na: nat,A2: A,P: fun(A,$o)] :
      ( ? [X5: A] :
          ( member(A,X5,aa(list(A),set(A),set2(A),replicate(A,Na,A2)))
          & aa(A,$o,P,X5) )
    <=> ( aa(A,$o,P,A2)
        & ( Na != zero_zero(nat) ) ) ) ).

% Bex_set_replicate
tff(fact_703_in__set__replicate,axiom,
    ! [A: $tType,X: A,Na: nat,Y: A] :
      ( member(A,X,aa(list(A),set(A),set2(A),replicate(A,Na,Y)))
    <=> ( ( X = Y )
        & ( Na != zero_zero(nat) ) ) ) ).

% in_set_replicate
tff(fact_704_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),L)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) ) ) ).

% div_pos_pos_trivial
tff(fact_705_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),K)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = zero_zero(int) ) ) ) ).

% div_neg_neg_trivial
tff(fact_706_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),one_one(int)))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ).

% zle_diff1_eq
tff(fact_707_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)) ) ) ).

% dbl_simps(5)
tff(fact_708_enat__ord__number_I1_J,axiom,
    ! [M: num,Na: num] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),aa(num,extended_enat,numeral_numeral(extended_enat),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),Na)) ) ).

% enat_ord_number(1)
tff(fact_709_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% divide_le_0_1_iff
tff(fact_710_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% zero_le_divide_1_iff
tff(fact_711_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Na)),one_one(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Na),one2) ) ) ).

% numeral_le_one_iff
tff(fact_712_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_713_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))),B2) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_714_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)) = A2 )
        <=> $ite(aa(num,A,numeral_numeral(A),W) != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W)),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_715_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,W: num] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)) )
        <=> $ite(aa(num,A,numeral_numeral(A),W) != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W)) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_716_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_717_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(num,A,numeral_numeral(A),W)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))),B2) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_718_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_719_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_720_div__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self4
tff(fact_721_div__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self3
tff(fact_722_div__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self2
tff(fact_723_div__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_mult_self1
tff(fact_724_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),A2) = B2 ) ) ) ).

% unit_div_mult_self
tff(fact_725_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) ) ) ) ).

% unit_mult_div_div
tff(fact_726_mod2__Suc__Suc,axiom,
    ! [M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% mod2_Suc_Suc
tff(fact_727_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))),I2) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,J2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I2)) ) ) ).

% diff_Suc_diff_eq2
tff(fact_728_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),aa(nat,nat,suc,J2)) ) ) ).

% diff_Suc_diff_eq1
tff(fact_729_power__add__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),Na))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na))) ) ) ).

% power_add_numeral
tff(fact_730_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: num,Na: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),M))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),Na))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)))),B2) ) ) ).

% power_add_numeral2
tff(fact_731_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_732_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_733_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_734_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_735_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X: nat,Y: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Y) ) ) ) ).

% power_increasing_iff
tff(fact_736_even__mult__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_mult_iff
tff(fact_737_power__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na))
              <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ) ).

% power_mono_iff
tff(fact_738_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_739_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_mod_two_eq_one
tff(fact_740_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [Na: nat] :
      ( ( modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) != aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(nat) ) ) ).

% not_mod2_eq_Suc_0_eq_0
tff(fact_741_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_mod_2_iff
tff(fact_742_add__self__mod__2,axiom,
    ! [M: nat] : ( modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = zero_zero(nat) ) ).

% add_self_mod_2
tff(fact_743_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% half_nonnegative_int_iff
tff(fact_744_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M) ) ) ) ) ).

% power_decreasing_iff
tff(fact_745_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),zero_zero(A))
        <=> ( A2 = zero_zero(A) ) ) ) ).

% power2_less_eq_zero_iff
tff(fact_746_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
            <=> ( X = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
tff(fact_747_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) )
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_748_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) )
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_749_mod2__gr__0,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
    <=> ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(nat) ) ) ).

% mod2_gr_0
tff(fact_750_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_le_power_eq_numeral
tff(fact_751_unset__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),zero_zero(nat)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% unset_bit_0
tff(fact_752_odd__two__times__div__two__nat,axiom,
    ! [Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)) ) ) ).

% odd_two_times_div_two_nat
tff(fact_753_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),one_one(A)) = A2 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_754_mod__eq__nat1E,axiom,
    ! [M: nat,Q4: nat,Na: nat] :
      ( ( modulo_modulo(nat,M,Q4) = modulo_modulo(nat,Na,Q4) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
       => ~ ! [S2: nat] : ( M != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q4),S2)) ) ) ) ).

% mod_eq_nat1E
tff(fact_755_mod__eq__nat2E,axiom,
    ! [M: nat,Q4: nat,Na: nat] :
      ( ( modulo_modulo(nat,M,Q4) = modulo_modulo(nat,Na,Q4) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
       => ~ ! [S2: nat] : ( Na != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q4),S2)) ) ) ) ).

% mod_eq_nat2E
tff(fact_756_nat__mod__eq__lemma,axiom,
    ! [X: nat,Na: nat,Y: nat] :
      ( ( modulo_modulo(nat,X,Na) = modulo_modulo(nat,Y,Na) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y),X)
       => ? [Q2: nat] : ( X = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q2)) ) ) ) ).

% nat_mod_eq_lemma
tff(fact_757_mod__eqE,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,B2,C2) )
         => ~ ! [D4: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D4)) ) ) ) ).

% mod_eqE
tff(fact_758_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordere2520102378445227354miring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_759_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_760_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),zero_zero(A)) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_761_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_762_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_763_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_764_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ).

% split_mult_neg_le
tff(fact_765_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ) ) ).

% mult_le_0_iff
tff(fact_766_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_right_mono
tff(fact_767_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_right_mono_neg
tff(fact_768_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_left_mono
tff(fact_769_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_770_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_left_mono_neg
tff(fact_771_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% split_mult_pos_le
tff(fact_772_zero__le__square,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)) ) ).

% zero_le_square
tff(fact_773_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_mono'
tff(fact_774_mult__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_mono
tff(fact_775_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( modulo_modulo(nat,M,D2) = zero_zero(nat) )
     => ? [Q2: nat] : ( M = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),D2),Q2) ) ) ).

% mod_eq_0D
tff(fact_776_mod__Suc__le__divisor,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,M,aa(nat,nat,suc,Na))),Na) ).

% mod_Suc_le_divisor
tff(fact_777_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),A2) ) ).

% verit_comp_simplify1(2)
tff(fact_778_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
tff(fact_779_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.assoc
tff(fact_780_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2) ) ) ).

% mult.commute
tff(fact_781_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.left_commute
tff(fact_782_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
          | ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% verit_la_disequality
tff(fact_783_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_eq
tff(fact_784_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A5),B5),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_785_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,B2)),C2) ) ) ).

% mod_mult_mult2
tff(fact_786_mult__mod__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),modulo_modulo(A,A2,B2)) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% mult_mod_right
tff(fact_787_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_left_eq
tff(fact_788_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_right_eq
tff(fact_789_le__cube,axiom,
    ! [M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),M))) ).

% le_cube
tff(fact_790_le__refl,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),Na) ).

% le_refl
tff(fact_791_le__trans,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),K) ) ) ).

% le_trans
tff(fact_792_eq__imp__le,axiom,
    ! [M: nat,Na: nat] :
      ( ( M = Na )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% eq_imp_le
tff(fact_793_le__square,axiom,
    ! [M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),M)) ).

% le_square
tff(fact_794_le__antisym,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
       => ( M = Na ) ) ) ).

% le_antisym
tff(fact_795_mult__le__mono,axiom,
    ! [I2: nat,J2: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),L)) ) ) ).

% mult_le_mono
tff(fact_796_mult__le__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),K)) ) ).

% mult_le_mono1
tff(fact_797_mult__le__mono2,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J2)) ) ).

% mult_le_mono2
tff(fact_798_nat__le__linear,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
      | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M) ) ).

% nat_le_linear
tff(fact_799_Nat_Oex__has__greatest__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y4: nat] :
            ( aa(nat,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y4),B2) )
       => ? [X3: nat] :
            ( aa(nat,$o,P,X3)
            & ! [Y3: nat] :
                ( aa(nat,$o,P,Y3)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y3),X3) ) ) ) ) ).

% Nat.ex_has_greatest_nat
tff(fact_800_mod__less__eq__dividend,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,M,Na)),M) ).

% mod_less_eq_dividend
tff(fact_801_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),modulo_modulo(A,A2,B2)),A2) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
tff(fact_802_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( modulo_modulo(int,M,D2) = zero_zero(int) )
    <=> ? [Q5: int] : ( M = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q5) ) ) ).

% zmod_eq_0_iff
tff(fact_803_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( modulo_modulo(int,M,D2) = zero_zero(int) )
     => ? [Q2: int] : ( M = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q2) ) ) ).

% zmod_eq_0D
tff(fact_804_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),M)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,M,K)),M) ) ).

% zmod_le_nonneg_dividend
tff(fact_805_nat__mod__eq__iff,axiom,
    ! [X: nat,Na: nat,Y: nat] :
      ( ( modulo_modulo(nat,X,Na) = modulo_modulo(nat,Y,Na) )
    <=> ? [Q1: nat,Q22: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q1)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q22)) ) ) ).

% nat_mod_eq_iff
tff(fact_806_le__mod__geq,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
     => ( modulo_modulo(nat,M,Na) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na),Na) ) ) ).

% le_mod_geq
tff(fact_807_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% Suc_mult_le_cancel1
tff(fact_808_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),Na: nat,N2: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,aa(nat,nat,suc,N))),aa(nat,A,F2,N))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),N2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,N2)),aa(nat,A,F2,Na)) ) ) ) ).

% lift_Suc_antimono_le
tff(fact_809_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A),Na: nat,N2: nat] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,N)),aa(nat,A,F2,aa(nat,nat,suc,N)))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),N2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,Na)),aa(nat,A,F2,N2)) ) ) ) ).

% lift_Suc_mono_le
tff(fact_810_times__div__less__eq__dividend,axiom,
    ! [Na: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na))),M) ).

% times_div_less_eq_dividend
tff(fact_811_div__times__less__eq__dividend,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),Na)),M) ).

% div_times_less_eq_dividend
tff(fact_812_subset__decode__imp__le,axiom,
    ! [M: nat,Na: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),nat_set_decode(M)),nat_set_decode(Na))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% subset_decode_imp_le
tff(fact_813_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2),C2))),modulo_modulo(A,A2,B2)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_814_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),modulo_modulo(A,A2,B2)) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
tff(fact_815_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( modulo_modulo(A,A2,B2) = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
tff(fact_816_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [B2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))),modulo_modulo(A,A2,B2)) = A2 ) ) ).

% mult_div_mod_eq
tff(fact_817_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))) = A2 ) ) ).

% mod_mult_div_eq
tff(fact_818_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)) = A2 ) ) ).

% mod_div_mult_eq
tff(fact_819_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)),modulo_modulo(A,A2,B2)) = A2 ) ) ).

% div_mult_mod_eq
tff(fact_820_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)),modulo_modulo(A,A2,B2)) ) ) ).

% mod_div_decomp
tff(fact_821_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)),modulo_modulo(A,A2,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_822_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))),modulo_modulo(A,A2,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_823_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),modulo_modulo(A,B2,C2))),C2)) ) ) ).

% div_mult1_eq
tff(fact_824_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2)) = modulo_modulo(A,A2,B2) ) ) ).

% minus_div_mult_eq_mod
tff(fact_825_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2) ) ) ).

% minus_mod_eq_div_mult
tff(fact_826_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_827_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))) = modulo_modulo(A,A2,B2) ) ) ).

% minus_mult_div_eq_mod
tff(fact_828_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R2)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R2),B2)
         => ( modulo_modulo(int,A2,B2) = R2 ) ) ) ) ).

% int_mod_pos_eq
tff(fact_829_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R2),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R2)
         => ( modulo_modulo(int,A2,B2) = R2 ) ) ) ) ).

% int_mod_neg_eq
tff(fact_830_split__zmod,axiom,
    ! [P: fun(int,$o),Na: int,K: int] :
      ( aa(int,$o,P,modulo_modulo(int,Na,K))
    <=> ( ( ( K = zero_zero(int) )
         => aa(int,$o,P,Na) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
         => ! [I: int,J: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J)
                & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J),K)
                & ( Na = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J) ) )
             => aa(int,$o,P,J) ) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
         => ! [I: int,J: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J)
                & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J),zero_zero(int))
                & ( Na = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J) ) )
             => aa(int,$o,P,J) ) ) ) ) ).

% split_zmod
tff(fact_831_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_832_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_833_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_left_less_imp_less
tff(fact_834_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_835_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_836_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_right_less_imp_less
tff(fact_837_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_838_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_839_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_840_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_841_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_left_le_imp_le
tff(fact_842_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_right_le_imp_le
tff(fact_843_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_844_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_845_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),X)),X) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_846_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Y)),X) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_847_mult__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A)) ) ) ) ) ).

% mult_le_one
tff(fact_848_mult__left__le,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),A2) ) ) ) ).

% mult_left_le
tff(fact_849_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A))
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_850_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))) ) ).

% sum_squares_ge_zero
tff(fact_851_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),C2)
     => ( modulo_modulo(int,A2,aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2),C2))),modulo_modulo(int,A2,B2)) ) ) ).

% zmod_zmult2_eq
tff(fact_852_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_853_mod__le__divisor,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,M,Na)),Na) ) ).

% mod_le_divisor
tff(fact_854_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E2)),D2)) ) ) ).

% ordered_ring_class.le_add_iff2
tff(fact_855_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E2)),C2)),D2) ) ) ).

% ordered_ring_class.le_add_iff1
tff(fact_856_power__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N3)) ) ) ) ).

% power_increasing
tff(fact_857_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,K,L)),zero_zero(int)) ) ).

% neg_mod_sign
tff(fact_858_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L)) ) ).

% Euclidean_Division.pos_mod_sign
tff(fact_859_zmod__trivial__iff,axiom,
    ! [I2: int,K: int] :
      ( ( modulo_modulo(int,I2,K) = I2 )
    <=> ( ( K = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I2)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),K) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I2) ) ) ) ).

% zmod_trivial_iff
tff(fact_860_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,A2,B2))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),modulo_modulo(int,A2,B2)),B2) ) ) ).

% pos_mod_conj
tff(fact_861_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,A2,B2)),zero_zero(int))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),modulo_modulo(int,A2,B2)) ) ) ).

% neg_mod_conj
tff(fact_862_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% nat_mult_le_cancel1
tff(fact_863_mod__mult2__eq,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q4)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na),Q4))),modulo_modulo(nat,M,Na)) ) ).

% mod_mult2_eq
tff(fact_864_div__mod__decomp,axiom,
    ! [A3: nat,Na: nat] : ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),Na)),Na)),modulo_modulo(nat,A3,Na)) ) ).

% div_mod_decomp
tff(fact_865_modulo__nat__def,axiom,
    ! [M: nat,Na: nat] : ( modulo_modulo(nat,M,Na) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),Na)) ) ).

% modulo_nat_def
tff(fact_866_mod__eq__dvd__iff__nat,axiom,
    ! [Na: nat,M: nat,Q4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
     => ( ( modulo_modulo(nat,M,Q4) = modulo_modulo(nat,Na,Q4) )
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Q4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) ) ) ).

% mod_eq_dvd_iff_nat
tff(fact_867_nat__diff__add__eq2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2)),U)),Na)) ) ) ).

% nat_diff_add_eq2
tff(fact_868_nat__diff__add__eq1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),J2)),U)),M)),Na) ) ) ).

% nat_diff_add_eq1
tff(fact_869_nat__le__add__iff2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2)),U)),Na)) ) ) ).

% nat_le_add_iff2
tff(fact_870_nat__le__add__iff1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),J2)),U)),M)),Na) ) ) ).

% nat_le_add_iff1
tff(fact_871_nat__eq__add__iff2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na) )
      <=> ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2)),U)),Na) ) ) ) ).

% nat_eq_add_iff2
tff(fact_872_nat__eq__add__iff1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I2)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na) )
      <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),J2)),U)),M) = Na ) ) ) ).

% nat_eq_add_iff1
tff(fact_873_div__mod__decomp__int,axiom,
    ! [A3: int,Na: int] : ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Na)),Na)),modulo_modulo(int,A3,Na)) ) ).

% div_mod_decomp_int
tff(fact_874_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),C2)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),C2) ) ) ).

% zdiv_zmult2_eq
tff(fact_875_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_right_eq
tff(fact_876_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_left_eq
tff(fact_877_mod__add__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A5),B5),C2) ) ) ) ) ).

% mod_add_cong
tff(fact_878_mod__add__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_eq
tff(fact_879_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_eq
tff(fact_880_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A5),B5),C2) ) ) ) ) ).

% mod_diff_cong
tff(fact_881_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_left_eq
tff(fact_882_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_right_eq
tff(fact_883_power__mod,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,Na: nat] : ( modulo_modulo(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),modulo_modulo(A,A2,B2)),Na),B2) = modulo_modulo(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na),B2) ) ) ).

% power_mod
tff(fact_884_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),modulo_modulo(A,A2,B2))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2) ) ) ) ).

% dvd_mod_imp_dvd
tff(fact_885_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),modulo_modulo(A,A2,B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2) ) ) ) ).

% dvd_mod_iff
tff(fact_886_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( modulo_modulo(A,modulo_modulo(A,A2,B2),C2) = modulo_modulo(A,A2,C2) ) ) ) ).

% mod_mod_cancel
tff(fact_887_dvd__mod,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [K: A,M: A,Na: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),K),M)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),K),Na)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),K),modulo_modulo(A,M,Na)) ) ) ) ).

% dvd_mod
tff(fact_888_mod__Suc__eq,axiom,
    ! [M: nat,Na: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,modulo_modulo(nat,M,Na)),Na) = modulo_modulo(nat,aa(nat,nat,suc,M),Na) ) ).

% mod_Suc_eq
tff(fact_889_mod__Suc__Suc__eq,axiom,
    ! [M: nat,Na: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,modulo_modulo(nat,M,Na))),Na) = modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),Na) ) ).

% mod_Suc_Suc_eq
tff(fact_890_mult__not__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) != zero_zero(A) )
         => ( ( A2 != zero_zero(A) )
            & ( B2 != zero_zero(A) ) ) ) ) ).

% mult_not_zero
tff(fact_891_divisors__zero,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = zero_zero(A) )
         => ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divisors_zero
tff(fact_892_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) != zero_zero(A) ) ) ) ) ).

% no_zero_divisors
tff(fact_893_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
          <=> ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
tff(fact_894_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
          <=> ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
tff(fact_895_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),zero_zero(A)) ) ).

% le_numeral_extra(3)
tff(fact_896_zero__le,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X) ) ).

% zero_le
tff(fact_897_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),T2) ) ) ).

% pinf(6)
tff(fact_898_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),X4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),X4) ) ) ).

% pinf(8)
tff(fact_899_minf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),T2) ) ) ).

% minf(6)
tff(fact_900_minf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z2: A] :
        ! [X4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Z2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),X4) ) ) ).

% minf(8)
tff(fact_901_verit__comp__simplify1_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B5: A,A5: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B5),A5)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A5),B5) ) ) ).

% verit_comp_simplify1(3)
tff(fact_902_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A2) = A2 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_903_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),one_one(A)) = A2 ) ) ).

% mult.comm_neutral
tff(fact_904_combine__common__factor,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,E2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),E2)),C2) ) ) ).

% combine_common_factor
tff(fact_905_distrib__right,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% distrib_right
tff(fact_906_distrib__left,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% distrib_left
tff(fact_907_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( comm_semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_908_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_909_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_910_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% left_diff_distrib
tff(fact_911_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% right_diff_distrib
tff(fact_912_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [B2: A,C2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ).

% left_diff_distrib'
tff(fact_913_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% right_diff_distrib'
tff(fact_914_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,$o),D5: A,Q: fun(A,$o)] :
          ( ! [X3: A,K2: A] :
              ( aa(A,$o,P,X3)
            <=> aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D5))) )
         => ( ! [X3: A,K2: A] :
                ( aa(A,$o,Q,X3)
              <=> aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D5))) )
           => ! [X4: A,K4: A] :
                ( ( aa(A,$o,P,X4)
                  | aa(A,$o,Q,X4) )
              <=> ( aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D5)))
                  | aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D5))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_915_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,$o),D5: A,Q: fun(A,$o)] :
          ( ! [X3: A,K2: A] :
              ( aa(A,$o,P,X3)
            <=> aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D5))) )
         => ( ! [X3: A,K2: A] :
                ( aa(A,$o,Q,X3)
              <=> aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D5))) )
           => ! [X4: A,K4: A] :
                ( ( aa(A,$o,P,X4)
                  & aa(A,$o,Q,X4) )
              <=> ( aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D5)))
                  & aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D5))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_916_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),W)) ) ) ).

% times_divide_times_eq
tff(fact_917_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Z),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),W)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)) ) ) ).

% divide_divide_times_eq
tff(fact_918_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% divide_divide_eq_left'
tff(fact_919_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),one_one(A)) ) ).

% le_numeral_extra(4)
tff(fact_920_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_imp_le_right
tff(fact_921_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_imp_le_left
tff(fact_922_le__iff__add,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ? [C4: A] : ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C4) ) ) ) ).

% le_iff_add
tff(fact_923_add__right__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add_right_mono
tff(fact_924_less__eqE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ~ ! [C3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C3) ) ) ) ).

% less_eqE
tff(fact_925_add__left__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% add_left_mono
tff(fact_926_add__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_mono
tff(fact_927_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I2),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_928_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( ( I2 = J2 )
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_929_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I2),J2)
            & ( K = L ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_930_le__num__One__iff,axiom,
    ! [X: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),X),one2)
    <=> ( X = one2 ) ) ).

% le_num_One_iff
tff(fact_931_diff__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ) ).

% diff_mono
tff(fact_932_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% diff_left_mono
tff(fact_933_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% diff_right_mono
tff(fact_934_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_935_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A,Y: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),X) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) ) ) ) ).

% power_commuting_commutes
tff(fact_936_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),Na) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ).

% power_mult_distrib
tff(fact_937_power__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% power_commutes
tff(fact_938_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Na) )
    <=> ( M = Na ) ) ).

% Suc_mult_cancel1
tff(fact_939_division__decomp,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ? [B6: A,C5: A] :
              ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B6),C5) )
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B6),B2)
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C5),C2) ) ) ) ).

% division_decomp
tff(fact_940_dvd__productE,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [P3: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),P3),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
         => ~ ! [X3: A,Y4: A] :
                ( ( P3 = aa(A,A,aa(A,fun(A,A),times_times(A),X3),Y4) )
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X3),A2)
                 => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y4),B2) ) ) ) ) ).

% dvd_productE
tff(fact_941_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)) ) ).

% dvd_triv_right
tff(fact_942_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ).

% dvd_mult_right
tff(fact_943_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ).

% mult_dvd_mono
tff(fact_944_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ).

% dvd_triv_left
tff(fact_945_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ).

% dvd_mult_left
tff(fact_946_dvd__mult2,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% dvd_mult2
tff(fact_947_dvd__mult,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% dvd_mult
tff(fact_948_dvd__def,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
        <=> ? [K3: A] : ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K3) ) ) ) ).

% dvd_def
tff(fact_949_dvdI,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [A2: A,B2: A,K: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% dvdI
tff(fact_950_dvdE,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ~ ! [K2: A] : ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),B2),K2) ) ) ) ).

% dvdE
tff(fact_951_power__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: nat,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),Na) ) ) ).

% power_mult
tff(fact_952_mult__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),zero_zero(nat)),Na) = zero_zero(nat) ) ).

% mult_0
tff(fact_953_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na) )
    <=> ( ( K = zero_zero(nat) )
        | ( M = Na ) ) ) ).

% nat_mult_eq_cancel_disj
tff(fact_954_Suc__leD,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% Suc_leD
tff(fact_955_le__SucE,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
       => ( M = aa(nat,nat,suc,Na) ) ) ) ).

% le_SucE
tff(fact_956_le__SucI,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na)) ) ).

% le_SucI
tff(fact_957_Suc__le__D,axiom,
    ! [Na: nat,M6: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),M6)
     => ? [M4: nat] : ( M6 = aa(nat,nat,suc,M4) ) ) ).

% Suc_le_D
tff(fact_958_le__Suc__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
        | ( M = aa(nat,nat,suc,Na) ) ) ) ).

% le_Suc_eq
tff(fact_959_Suc__n__not__le__n,axiom,
    ! [Na: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),Na) ).

% Suc_n_not_le_n
tff(fact_960_not__less__eq__eq,axiom,
    ! [M: nat,Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),M) ) ).

% not_less_eq_eq
tff(fact_961_full__nat__induct,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( ! [N: nat] :
          ( ! [M2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M2)),N)
             => aa(nat,$o,P,M2) )
         => aa(nat,$o,P,N) )
     => aa(nat,$o,P,Na) ) ).

% full_nat_induct
tff(fact_962_nat__induct__at__least,axiom,
    ! [M: nat,Na: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(nat,$o,P,M)
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
             => ( aa(nat,$o,P,N)
               => aa(nat,$o,P,aa(nat,nat,suc,N)) ) )
         => aa(nat,$o,P,Na) ) ) ) ).

% nat_induct_at_least
tff(fact_963_transitive__stepwise__le,axiom,
    ! [M: nat,Na: nat,R3: fun(nat,fun(nat,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( ! [X3: nat] : aa(nat,$o,aa(nat,fun(nat,$o),R3,X3),X3)
       => ( ! [X3: nat,Y4: nat,Z2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),R3,X3),Y4)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),R3,Y4),Z2)
               => aa(nat,$o,aa(nat,fun(nat,$o),R3,X3),Z2) ) )
         => ( ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),R3,N),aa(nat,nat,suc,N))
           => aa(nat,$o,aa(nat,fun(nat,$o),R3,M),Na) ) ) ) ) ).

% transitive_stepwise_le
tff(fact_964_less__eq__nat_Osimps_I1_J,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),Na) ).

% less_eq_nat.simps(1)
tff(fact_965_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),zero_zero(nat))
    <=> ( A2 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_unique
tff(fact_966_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),zero_zero(nat))
     => ( A2 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_uniqueI
tff(fact_967_le__0__eq,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),zero_zero(nat))
    <=> ( Na = zero_zero(nat) ) ) ).

% le_0_eq
tff(fact_968_times__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),K),zero_zero(int)) = zero_zero(int) ) ).

% times_int_code(1)
tff(fact_969_times__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),zero_zero(int)),L) = zero_zero(int) ) ).

% times_int_code(2)
tff(fact_970_nat__less__le,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
        & ( M != Na ) ) ) ).

% nat_less_le
tff(fact_971_less__imp__le__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% less_imp_le_nat
tff(fact_972_le__eq__less__or__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
        | ( M = Na ) ) ) ).

% le_eq_less_or_eq
tff(fact_973_less__or__eq__imp__le,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
        | ( M = Na ) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% less_or_eq_imp_le
tff(fact_974_le__neq__implies__less,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( ( M != Na )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% le_neq_implies_less
tff(fact_975_less__mono__imp__le__mono,axiom,
    ! [F2: fun(nat,nat),I2: nat,J2: nat] :
      ( ! [I3: nat,J3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,F2,I3)),aa(nat,nat,F2,J3)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,F2,I2)),aa(nat,nat,F2,J2)) ) ) ).

% less_mono_imp_le_mono
tff(fact_976_less__eq__real__def,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
        | ( X = Y ) ) ) ).

% less_eq_real_def
tff(fact_977_left__add__mult__distrib,axiom,
    ! [I2: nat,U: nat,J2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)),U)),K) ) ).

% left_add_mult_distrib
tff(fact_978_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na)) ) ).

% add_mult_distrib2
tff(fact_979_add__mult__distrib,axiom,
    ! [M: nat,Na: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K)) ) ).

% add_mult_distrib
tff(fact_980_conj__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P2: $o] :
      ( ( X = X6 )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
         => ( (P)
          <=> (P2) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
            & (P) )
        <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
            & (P2) ) ) ) ) ).

% conj_le_cong
tff(fact_981_imp__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P2: $o] :
      ( ( X = X6 )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
         => ( (P)
          <=> (P2) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
           => (P) )
        <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X6)
           => (P2) ) ) ) ) ).

% imp_le_cong
tff(fact_982_less__eq__int__code_I1_J,axiom,
    aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),zero_zero(int)) ).

% less_eq_int_code(1)
tff(fact_983_diff__mult__distrib,axiom,
    ! [M: nat,Na: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K)) ) ).

% diff_mult_distrib
tff(fact_984_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na)) ) ).

% diff_mult_distrib2
tff(fact_985_nat__le__iff__add,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
    <=> ? [K3: nat] : ( Na = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K3) ) ) ).

% nat_le_iff_add
tff(fact_986_trans__le__add2,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),J2)) ) ).

% trans_le_add2
tff(fact_987_trans__le__add1,axiom,
    ! [I2: nat,J2: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),M)) ) ).

% trans_le_add1
tff(fact_988_add__le__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) ) ).

% add_le_mono1
tff(fact_989_add__le__mono,axiom,
    ! [I2: nat,J2: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),L)) ) ) ).

% add_le_mono
tff(fact_990_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
     => ? [N: nat] : ( L = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N) ) ) ).

% le_Suc_ex
tff(fact_991_add__leD2,axiom,
    ! [M: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na) ) ).

% add_leD2
tff(fact_992_add__leD1,axiom,
    ! [M: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% add_leD1
tff(fact_993_le__add2,axiom,
    ! [Na: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) ).

% le_add2
tff(fact_994_le__add1,axiom,
    ! [Na: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)) ).

% le_add1
tff(fact_995_add__leE,axiom,
    ! [M: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),Na)
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na) ) ) ).

% add_leE
tff(fact_996_eq__diff__iff,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
       => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K) )
        <=> ( M = Na ) ) ) ) ).

% eq_diff_iff
tff(fact_997_le__diff__iff,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ) ).

% le_diff_iff
tff(fact_998_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na) ) ) ) ).

% Nat.diff_diff_eq
tff(fact_999_diff__le__mono,axiom,
    ! [M: nat,Na: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),L)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),L)) ) ).

% diff_le_mono
tff(fact_1000_diff__le__self,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),M) ).

% diff_le_self
tff(fact_1001_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),C2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),C2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),A2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),B2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),A2) ) ) ) ).

% le_diff_iff'
tff(fact_1002_diff__le__mono2,axiom,
    ! [M: nat,Na: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),Na)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),M)) ) ).

% diff_le_mono2
tff(fact_1003_nat__mult__1__right,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),one_one(nat)) = Na ) ).

% nat_mult_1_right
tff(fact_1004_nat__mult__1,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),one_one(nat)),Na) = Na ) ).

% nat_mult_1
tff(fact_1005_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z22)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z22)) ) ).

% int_distrib(2)
tff(fact_1006_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z22)),W) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z22),W)) ) ).

% int_distrib(1)
tff(fact_1007_div__mult2__eq,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q4)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),Q4) ) ).

% div_mult2_eq
tff(fact_1008_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z22)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z22)) ) ).

% int_distrib(4)
tff(fact_1009_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z22)),W) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z22),W)) ) ).

% int_distrib(3)
tff(fact_1010_div__le__mono,axiom,
    ! [M: nat,Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),K)) ) ).

% div_le_mono
tff(fact_1011_div__le__dividend,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),M) ).

% div_le_dividend
tff(fact_1012_split__pos__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,$o)),Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),K)),modulo_modulo(int,Na,K))
      <=> ! [I: int,J: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J)
              & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J),K)
              & ( Na = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J) ) )
           => aa(int,$o,aa(int,fun(int,$o),P,I),J) ) ) ) ).

% split_pos_lemma
tff(fact_1013_split__neg__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,$o)),Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),K)),modulo_modulo(int,Na,K))
      <=> ! [I: int,J: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J),zero_zero(int))
              & ( Na = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J) ) )
           => aa(int,$o,aa(int,fun(int,$o),P,I),J) ) ) ) ).

% split_neg_lemma
tff(fact_1014_imult__is__0,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),Na) = zero_zero(extended_enat) )
    <=> ( ( M = zero_zero(extended_enat) )
        | ( Na = zero_zero(extended_enat) ) ) ) ).

% imult_is_0
tff(fact_1015_i0__lb,axiom,
    ! [Na: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),zero_zero(extended_enat)),Na) ).

% i0_lb
tff(fact_1016_ile0__eq,axiom,
    ! [Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Na),zero_zero(extended_enat))
    <=> ( Na = zero_zero(extended_enat) ) ) ).

% ile0_eq
tff(fact_1017_replicate__length__same,axiom,
    ! [A: $tType,Xs: list(A),X: A] :
      ( ! [X3: A] :
          ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
         => ( X3 = X ) )
     => ( replicate(A,aa(list(A),nat,size_size(list(A)),Xs),X) = Xs ) ) ).

% replicate_length_same
tff(fact_1018_replicate__eqI,axiom,
    ! [A: $tType,Xs: list(A),Na: nat,X: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = Na )
     => ( ! [Y4: A] :
            ( member(A,Y4,aa(list(A),set(A),set2(A),Xs))
           => ( Y4 = X ) )
       => ( Xs = replicate(A,Na,X) ) ) ) ).

% replicate_eqI
tff(fact_1019_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( ! [Z2: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),one_one(A))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),X)),Y) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ).

% field_le_mult_one_interval
tff(fact_1020_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A)) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_1021_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_1022_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A)) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_1023_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_1024_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A)) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_1025_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_1026_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A)) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_1027_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_1028_divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)) ) ) ) ).

% divide_le_eq
tff(fact_1029_le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))) ) ) ) ).

% le_divide_eq
tff(fact_1030_divide__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_left_mono
tff(fact_1031_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% neg_divide_le_eq
tff(fact_1032_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_le_divide_eq
tff(fact_1033_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_divide_le_eq
tff(fact_1034_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% pos_le_divide_eq
tff(fact_1035_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),Z) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_1036_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y)),X)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_1037_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_1038_convex__bound__le,axiom,
    ! [A: $tType] :
      ( linord6961819062388156250ring_1(A)
     => ! [X: A,A2: A,Y: A,U: A,V: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),U)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),V)
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A2) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_1039_frac__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),zero_zero(A)) ) ) ) ) ).

% frac_le_eq
tff(fact_1040_split__mod,axiom,
    ! [P: fun(nat,$o),M: nat,Na: nat] :
      ( aa(nat,$o,P,modulo_modulo(nat,M,Na))
    <=> ( ( ( Na = zero_zero(nat) )
         => aa(nat,$o,P,M) )
        & ( ( Na != zero_zero(nat) )
         => ! [I: nat,J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Na)
             => ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),I)),J) )
               => aa(nat,$o,P,J) ) ) ) ) ) ).

% split_mod
tff(fact_1041_power__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,N3: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N3)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ) ).

% power_decreasing
tff(fact_1042_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ) ).

% power_le_imp_le_exp
tff(fact_1043_mod__nat__eqI,axiom,
    ! [R2: nat,Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),R2),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R2),M)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),R2))
         => ( modulo_modulo(nat,M,Na) = R2 ) ) ) ) ).

% mod_nat_eqI
tff(fact_1044_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int))
       => ( modulo_modulo(int,K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L) ) ) ) ).

% mod_pos_neg_trivial
tff(fact_1045_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
       => ( modulo_modulo(int,K,L) = modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L),L) ) ) ) ).

% mod_pos_geq
tff(fact_1046_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( ( L = zero_zero(int) )
          & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) )
        | aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L) ) ) ).

% mod_int_pos_iff
tff(fact_1047_nat__less__add__iff2,axiom,
    ! [I2: nat,J2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2)),U)),Na)) ) ) ).

% nat_less_add_iff2
tff(fact_1048_nat__less__add__iff1,axiom,
    ! [J2: nat,I2: nat,U: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),U)),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I2),J2)),U)),M)),Na) ) ) ).

% nat_less_add_iff1
tff(fact_1049_div__nat__eqI,axiom,
    ! [Na: nat,Q4: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q4)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,suc,Q4)))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) = Q4 ) ) ) ).

% div_nat_eqI
tff(fact_1050_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q4: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Q4)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),Q4))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q4)),Na) ) ) ).

% less_eq_div_iff_mult_less_eq
tff(fact_1051_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_1052_dvd__minus__add,axiom,
    ! [Q4: nat,Na: nat,R2: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Q4),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Q4),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R2),M))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),Q4))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R2),M)),Q4))) ) ) ) ).

% dvd_minus_add
tff(fact_1053_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q6: int,R4: int,Q4: int,R2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q6)),R4)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R2),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R4)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q4),Q6) ) ) ) ) ).

% unique_quotient_lemma_neg
tff(fact_1054_unique__quotient__lemma,axiom,
    ! [B2: int,Q6: int,R4: int,Q4: int,R2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q6)),R4)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R4)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R4),B2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R2),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q6),Q4) ) ) ) ) ).

% unique_quotient_lemma
tff(fact_1055_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q4: int,R2: int,B5: int,Q6: int,R4: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q6)),R4) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q6)),R4)),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R2),B2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R4)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
               => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q6),Q4) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
tff(fact_1056_incr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,$o),K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X3: int] :
            ( aa(int,$o,P,X3)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D2)) )
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
         => ! [X4: int] :
              ( aa(int,$o,P,X4)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2))) ) ) ) ) ).

% incr_mult_lemma
tff(fact_1057_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q4: int,R2: int,B5: int,Q6: int,R4: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q6)),R4) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q6)),R4))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R4),B5)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
               => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q4),Q6) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
tff(fact_1058_q__pos__lemma,axiom,
    ! [B5: int,Q6: int,R4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q6)),R4))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R4),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Q6) ) ) ) ).

% q_pos_lemma
tff(fact_1059_decr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,$o),K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X3: int] :
            ( aa(int,$o,P,X3)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D2)) )
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
         => ! [X4: int] :
              ( aa(int,$o,P,X4)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2))) ) ) ) ) ).

% decr_mult_lemma
tff(fact_1060_unset__bit__less__eq,axiom,
    ! [Na: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Na),K)),K) ).

% unset_bit_less_eq
tff(fact_1061_set__bit__greater__eq,axiom,
    ! [K: int,Na: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Na),K)) ).

% set_bit_greater_eq
tff(fact_1062_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
           => ( ( modulo_modulo(A,X,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)) = modulo_modulo(A,X,M) )
              | ( modulo_modulo(A,X,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,X,M)),M) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_1063_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))
             => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2) = modulo_modulo(A,A2,B2) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_1064_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,B2,A2))) ) ) ).

% pos_zmod_mult_2
tff(fact_1065_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( linord715952674999750819strict(A)
     => ! [X: A,A2: A,Y: A,U: A,V: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),U)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),V)
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A2) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_1066_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_1067_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(num,A,numeral_numeral(A),W))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_1068_scaling__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,V: A,R2: A,S: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),V)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),R2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),R2),S)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),R2),aa(A,A,aa(A,fun(A,A),minus_minus(A),V),U))),S))),V) ) ) ) ) ).

% scaling_mono
tff(fact_1069_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,B2)),B2) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
tff(fact_1070_Suc__times__mod__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),M) = one_one(nat) ) ) ).

% Suc_times_mod_eq
tff(fact_1071_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = A2 )
        <=> ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) ) ) ) ).

% mod_eq_self_iff_div_eq_0
tff(fact_1072_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q4: num,Na: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,M)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q4)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Na),aa(num,A,numeral_numeral(A),Q4)) ) ) ) ).

% cong_exp_iff_simps(9)
tff(fact_1073_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),one2)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Na),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% cong_exp_iff_simps(4)
tff(fact_1074_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% mod_0_imp_dvd
tff(fact_1075_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
        <=> ( modulo_modulo(A,B2,A2) = zero_zero(A) ) ) ) ).

% dvd_eq_mod_eq_0
tff(fact_1076_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% mod_eq_0_iff_dvd
tff(fact_1077_div__add1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2))),C2)) ) ) ).

% div_add1_eq
tff(fact_1078_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2))) ) ).

% dvd_minus_mod
tff(fact_1079_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,B2,C2) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ).

% mod_eq_dvd_iff
tff(fact_1080_split__div_H,axiom,
    ! [P: fun(nat,$o),M: nat,Na: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na))
    <=> ( ( ( Na = zero_zero(nat) )
          & aa(nat,$o,P,zero_zero(nat)) )
        | ? [Q5: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q5)),M)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,suc,Q5)))
            & aa(nat,$o,P,Q5) ) ) ) ).

% split_div'
tff(fact_1081_mod__Suc,axiom,
    ! [M: nat,Na: nat] :
      ( modulo_modulo(nat,aa(nat,nat,suc,M),Na)
      = $ite(aa(nat,nat,suc,modulo_modulo(nat,M,Na)) = Na,zero_zero(nat),aa(nat,nat,suc,modulo_modulo(nat,M,Na))) ) ).

% mod_Suc
tff(fact_1082_mod__induct,axiom,
    ! [P: fun(nat,$o),Na: nat,P3: nat,M: nat] :
      ( aa(nat,$o,P,Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),P3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),P3)
         => ( ! [N: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),P3)
               => ( aa(nat,$o,P,N)
                 => aa(nat,$o,P,modulo_modulo(nat,aa(nat,nat,suc,N),P3)) ) )
           => aa(nat,$o,P,M) ) ) ) ) ).

% mod_induct
tff(fact_1083_gcd__nat__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),M: nat,Na: nat] :
      ( ! [M4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,M4),zero_zero(nat))
     => ( ! [M4: nat,N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),P,N),modulo_modulo(nat,M4,N))
             => aa(nat,$o,aa(nat,fun(nat,$o),P,M4),N) ) )
       => aa(nat,$o,aa(nat,fun(nat,$o),P,M),Na) ) ) ).

% gcd_nat_induct
tff(fact_1084_mod__less__divisor,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),modulo_modulo(nat,M,Na)),Na) ) ).

% mod_less_divisor
tff(fact_1085_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs: list(A)] :
      ( member(A,X,aa(list(A),set(A),set2(A),Xs))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_pos_if_in_set
tff(fact_1086_mod__if,axiom,
    ! [M: nat,Na: nat] :
      ( modulo_modulo(nat,M,Na)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na),M,modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na),Na)) ) ).

% mod_if
tff(fact_1087_mod__geq,axiom,
    ! [M: nat,Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => ( modulo_modulo(nat,M,Na) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na),Na) ) ) ).

% mod_geq
tff(fact_1088_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_neg_neg
tff(fact_1089_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)),zero_zero(A)) ) ).

% not_square_less_zero
tff(fact_1090_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ) ).

% mult_less_0_iff
tff(fact_1091_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_neg_pos
tff(fact_1092_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_pos_neg
tff(fact_1093_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_pos_pos
tff(fact_1094_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),zero_zero(A)) ) ) ) ).

% mult_pos_neg2
tff(fact_1095_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_1096_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ).

% zero_less_mult_pos
tff(fact_1097_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ).

% zero_less_mult_pos2
tff(fact_1098_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_1099_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_1100_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_1101_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_strict_left_mono
tff(fact_1102_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_1103_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_1104_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_strict_right_mono
tff(fact_1105_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_1106_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord2810124833399127020strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_1107_split__zdiv,axiom,
    ! [P: fun(int,$o),Na: int,K: int] :
      ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),K))
    <=> ( ( ( K = zero_zero(int) )
         => aa(int,$o,P,zero_zero(int)) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
         => ! [I: int,J: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J)
                & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J),K)
                & ( Na = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J) ) )
             => aa(int,$o,P,I) ) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
         => ! [I: int,J: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J)
                & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J),zero_zero(int))
                & ( Na = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),J) ) )
             => aa(int,$o,P,I) ) ) ) ) ).

% split_zdiv
tff(fact_1108_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R2),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R2)
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2) = Q4 ) ) ) ) ).

% int_div_neg_eq
tff(fact_1109_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q4)),R2) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R2)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R2),B2)
         => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2) = Q4 ) ) ) ) ).

% int_div_pos_eq
tff(fact_1110_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),modulo_modulo(int,K,L)) ) ).

% neg_mod_bound
tff(fact_1111_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),modulo_modulo(int,K,L)),L) ) ).

% Euclidean_Division.pos_mod_bound
tff(fact_1112_less__1__mult,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: A,Na: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Na)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),M),Na)) ) ) ) ).

% less_1_mult
tff(fact_1113_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z) )
            <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Z) = aa(A,A,aa(A,fun(A,A),times_times(A),W),Y) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_1114_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A2 )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq
tff(fact_1115_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq
tff(fact_1116_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) )
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A2 ) ) ) ) ).

% divide_eq_imp
tff(fact_1117_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2 )
           => ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_1118_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = A2 )
          <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_1119_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_1120_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Na)),zero_zero(A)) ) ).

% not_numeral_le_zero
tff(fact_1121_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),Na)) ) ).

% zero_le_numeral
tff(fact_1122_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),one2)),A2) = A2 ) ) ).

% mult_numeral_1
tff(fact_1123_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),one2)) = A2 ) ) ).

% mult_numeral_1_right
tff(fact_1124_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),one_one(A)) ) ).

% zero_less_one_class.zero_le_one
tff(fact_1125_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),one_one(A)) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_1126_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),zero_zero(A)) ) ).

% not_one_le_zero
tff(fact_1127_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),zero_zero(A))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) = zero_zero(A) )
            <=> ( ( X = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_1128_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) = zero_zero(A) )
            <=> ( ( X = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_1129_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_nonpos_nonpos
tff(fact_1130_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_nonneg_nonneg
tff(fact_1131_add__increasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_increasing2
tff(fact_1132_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ) ).

% add_decreasing2
tff(fact_1133_add__increasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_increasing
tff(fact_1134_add__decreasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ) ).

% add_decreasing
tff(fact_1135_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E2)),C2) = D2 ) ) ) ).

% eq_add_iff1
tff(fact_1136_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2) )
        <=> ( C2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E2)),D2) ) ) ) ).

% eq_add_iff2
tff(fact_1137_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( comm_ring(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) ) ) ).

% square_diff_square_factored
tff(fact_1138_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [X: A,Y: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2)),B2)) ) ) ).

% mult_diff_mult
tff(fact_1139_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),zero_zero(A)) ) ) ).

% le_iff_diff_le_0
tff(fact_1140_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,K: num,L: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),L)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),K),L))) ) ) ).

% div_mult2_numeral_eq
tff(fact_1141_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_less_le_mono
tff(fact_1142_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_le_less_mono
tff(fact_1143_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I2),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_1144_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I2: A,J2: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I2),J2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L)) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_1145_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ) ) ).

% divide_le_0_iff
tff(fact_1146_divide__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ) ).

% divide_right_mono
tff(fact_1147_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_le_divide_iff
tff(fact_1148_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% divide_nonneg_nonneg
tff(fact_1149_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),zero_zero(A)) ) ) ) ).

% divide_nonneg_nonpos
tff(fact_1150_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),zero_zero(A)) ) ) ) ).

% divide_nonpos_nonneg
tff(fact_1151_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% divide_nonpos_nonpos
tff(fact_1152_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)) ) ) ) ).

% divide_right_mono_neg
tff(fact_1153_one__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(num,A,numeral_numeral(A),Na)) ) ).

% one_le_numeral
tff(fact_1154_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A,Y: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) = one_one(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),Na)) = one_one(A) ) ) ) ).

% left_right_inverse_power
tff(fact_1155_zero__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% zero_le_power
tff(fact_1156_power__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ) ).

% power_mono
tff(fact_1157_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I2: A,K: A,Na: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),Na)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I2),aa(A,A,aa(A,fun(A,A),minus_minus(A),Na),K)) ) ) ).

% add_le_imp_le_diff
tff(fact_1158_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I2: A,K: A,Na: A,J2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),Na)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Na),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K)),Na)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Na),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Na),K)),J2) ) ) ) ) ) ).

% add_le_add_imp_diff_le
tff(fact_1159_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1160_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1161_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1162_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1163_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1164_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1165_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1166_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1167_le__add__diff,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2)) ) ) ).

% le_add_diff
tff(fact_1168_diff__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),A2) = B2 ) ) ) ).

% diff_add
tff(fact_1169_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% le_diff_eq
tff(fact_1170_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% diff_le_eq
tff(fact_1171_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A)) ) ) ) ).

% is_unit_mult_iff
tff(fact_1172_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_1173_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_1174_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_1175_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_1176_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_1177_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_1178_power__Suc2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),A2) ) ) ).

% power_Suc2
tff(fact_1179_power__Suc,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% power_Suc
tff(fact_1180_one__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% one_le_power
tff(fact_1181_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),C2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),D2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_1182_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) ) ) ).

% dvd_mult_imp_div
tff(fact_1183_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_1184_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_1185_div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ) ).

% div_mult_swap
tff(fact_1186_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) ) ) ) ).

% dvd_div_mult
tff(fact_1187_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% Suc_mult_less_cancel1
tff(fact_1188_power__add,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: nat,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% power_add
tff(fact_1189_mult__less__mono1,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J2),K)) ) ) ).

% mult_less_mono1
tff(fact_1190_mult__less__mono2,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J2)) ) ) ).

% mult_less_mono2
tff(fact_1191_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na) )
      <=> ( M = Na ) ) ) ).

% nat_mult_eq_cancel1
tff(fact_1192_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% nat_mult_less_cancel1
tff(fact_1193_mult__Suc,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,M)),Na) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) ) ).

% mult_Suc
tff(fact_1194_le__imp__less__Suc,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,Na)) ) ).

% le_imp_less_Suc
tff(fact_1195_less__eq__Suc__le,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),M) ) ).

% less_eq_Suc_le
tff(fact_1196_less__Suc__eq__le,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% less_Suc_eq_le
tff(fact_1197_le__less__Suc__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,M))
      <=> ( Na = M ) ) ) ).

% le_less_Suc_eq
tff(fact_1198_Suc__le__lessD,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% Suc_le_lessD
tff(fact_1199_inc__induct,axiom,
    ! [I2: nat,J2: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,P,J2)
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),N)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),J2)
               => ( aa(nat,$o,P,aa(nat,nat,suc,N))
                 => aa(nat,$o,P,N) ) ) )
         => aa(nat,$o,P,I2) ) ) ) ).

% inc_induct
tff(fact_1200_dec__induct,axiom,
    ! [I2: nat,J2: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( aa(nat,$o,P,I2)
       => ( ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),N)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),J2)
               => ( aa(nat,$o,P,N)
                 => aa(nat,$o,P,aa(nat,nat,suc,N)) ) ) )
         => aa(nat,$o,P,J2) ) ) ) ).

% dec_induct
tff(fact_1201_Suc__le__eq,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),Na)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% Suc_le_eq
tff(fact_1202_Suc__leI,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),Na) ) ).

% Suc_leI
tff(fact_1203_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M: nat,Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% le_imp_power_dvd
tff(fact_1204_power__le__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat,B2: A,M: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),B2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),B2) ) ) ) ).

% power_le_dvd
tff(fact_1205_dvd__power__le,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X: A,Y: A,Na: nat,M: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),M)) ) ) ) ).

% dvd_power_le
tff(fact_1206_dbl__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X: A] : ( neg_numeral_dbl(A,X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X),X) ) ) ).

% dbl_def
tff(fact_1207_ex__least__nat__le,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,Na)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ? [K2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),Na)
            & ! [I4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),K2)
               => ~ aa(nat,$o,P,I4) )
            & aa(nat,$o,P,K2) ) ) ) ).

% ex_least_nat_le
tff(fact_1208_Suc__diff__le,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),Na) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) ) ) ).

% Suc_diff_le
tff(fact_1209_mult__eq__self__implies__10,axiom,
    ! [M: nat,Na: nat] :
      ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) )
     => ( ( Na = one_one(nat) )
        | ( M = zero_zero(nat) ) ) ) ).

% mult_eq_self_implies_10
tff(fact_1210_mono__nat__linear__lb,axiom,
    ! [F2: fun(nat,nat),M: nat,K: nat] :
      ( ! [M4: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,F2,M4)),aa(nat,nat,F2,N)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,F2,M)),K)),aa(nat,nat,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K))) ) ).

% mono_nat_linear_lb
tff(fact_1211_zmult__zless__mono2,axiom,
    ! [I2: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I2)),aa(int,int,aa(int,fun(int,int),times_times(int),K),J2)) ) ) ).

% zmult_zless_mono2
tff(fact_1212_less__diff__iff,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ) ).

% less_diff_iff
tff(fact_1213_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),C2),A2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),C2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),C2)) ) ) ).

% diff_less_mono
tff(fact_1214_less__mult__imp__div__less,axiom,
    ! [M: nat,I2: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I2),Na))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),I2) ) ).

% less_mult_imp_div_less
tff(fact_1215_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X: nat,Y: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),B2)
       => ( ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y)),D2) )
            | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y)),D2) ) )
         => ? [X3: nat,Y4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))
              & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),Y4)),D2) )
                | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)),D2) ) ) ) ) ) ) ).

% bezout_lemma_nat
tff(fact_1216_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D4),A2)
      & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D4),B2)
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),D4) )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)),D4) ) ) ) ).

% bezout_add_nat
tff(fact_1217_Nat_Ole__imp__diff__is__add,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2) = K )
      <=> ( J2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I2) ) ) ) ).

% Nat.le_imp_diff_is_add
tff(fact_1218_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),I2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I2) ) ) ).

% Nat.diff_add_assoc2
tff(fact_1219_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)) ) ) ).

% Nat.diff_add_assoc
tff(fact_1220_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),J2) ) ) ).

% Nat.le_diff_conv2
tff(fact_1221_le__diff__conv,axiom,
    ! [J2: nat,K: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I2)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)) ) ).

% le_diff_conv
tff(fact_1222_Suc__div__le__mono,axiom,
    ! [M: nat,Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,M)),Na)) ).

% Suc_div_le_mono
tff(fact_1223_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D4),A2)
      & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D4),B2)
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)) = D4 )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)) = D4 ) ) ) ).

% bezout1_nat
tff(fact_1224_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int)),A2))),one_one(int)) ) ) ).

% neg_zmod_mult_2
tff(fact_1225_less__eq__dvd__minus,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) ) ) ).

% less_eq_dvd_minus
tff(fact_1226_dvd__diffD1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Na) ) ) ) ).

% dvd_diffD1
tff(fact_1227_dvd__diffD,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Na)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M) ) ) ) ).

% dvd_diffD
tff(fact_1228_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),T2)
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),T2)) ) ) ).

% zdvd_mono
tff(fact_1229_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),Na))
     => ( ( K != zero_zero(int) )
       => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),Na) ) ) ).

% zdvd_mult_cancel
tff(fact_1230_int__ge__induct,axiom,
    ! [K: int,I2: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I2)
     => ( aa(int,$o,P,K)
       => ( ! [I3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I3)
             => ( aa(int,$o,P,I3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))) ) )
         => aa(int,$o,P,I2) ) ) ) ).

% int_ge_induct
tff(fact_1231_zdvd__antisym__nonneg,axiom,
    ! [M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),M)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na)
       => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),Na)
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Na),M)
           => ( M = Na ) ) ) ) ) ).

% zdvd_antisym_nonneg
tff(fact_1232_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2)
           => ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)) = modulo_modulo(A,A2,B2) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_1233_int__le__induct,axiom,
    ! [I2: int,K: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),K)
     => ( aa(int,$o,P,K)
       => ( ! [I3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),K)
             => ( aa(int,$o,P,I3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I3),one_one(int))) ) )
         => aa(int,$o,P,I2) ) ) ) ).

% int_le_induct
tff(fact_1234_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),D2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),T2))
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),C2),D2))),T2)) ) ) ).

% zdvd_period
tff(fact_1235_zdvd__reduce,axiom,
    ! [K: int,Na: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),plus_plus(int),Na),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),Na) ) ).

% zdvd_reduce
tff(fact_1236_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ) ).

% zero_le_even_power'
tff(fact_1237_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))
             => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))),one_one(A)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_1238_power__odd__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% power_odd_eq
tff(fact_1239_pow_Osimps_I1_J,axiom,
    ! [X: num] : ( pow(X,one2) = X ) ).

% pow.simps(1)
tff(fact_1240_verit__le__mono__div,axiom,
    ! [A3: nat,B3: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),B3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(nat,$o,
            aa(nat,fun(nat,$o),ord_less_eq(nat),
              aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),Na)),$ite(modulo_modulo(nat,B3,Na) = zero_zero(nat),one_one(nat),zero_zero(nat)))),
            aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),B3),Na)) ) ) ).

% verit_le_mono_div
tff(fact_1241_verit__le__mono__div__int,axiom,
    ! [A3: int,B3: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A3),B3)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na)
       => aa(int,$o,
            aa(int,fun(int,$o),ord_less_eq(int),
              aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Na)),$ite(modulo_modulo(int,B3,Na) = zero_zero(int),one_one(int),zero_zero(int)))),
            aa(int,int,aa(int,fun(int,int),divide_divide(int),B3),Na)) ) ) ).

% verit_le_mono_div_int
tff(fact_1242_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),Na))
    <=> ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),M)
        & aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Na) ) ) ).

% enat_0_less_mult_iff
tff(fact_1243_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y: extended_enat,X: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Z),Y)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Y),Z)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X),Y)),Z) ) ) ).

% add_diff_assoc_enat
tff(fact_1244_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_1245_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num,Q4: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) = zero_zero(A) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Na),aa(num,A,numeral_numeral(A),Q4)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(2)
tff(fact_1246_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Na),aa(num,A,numeral_numeral(A),one2)) = zero_zero(A) ) ) ).

% cong_exp_iff_simps(1)
tff(fact_1247_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q4: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,M)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) ) ) ).

% cong_exp_iff_simps(8)
tff(fact_1248_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q4: num,Na: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) ) ) ).

% cong_exp_iff_simps(6)
tff(fact_1249_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( modulo_modulo(A,A2,B2) = zero_zero(A) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_1250_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% sum_squares_bound
tff(fact_1251_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% odd_0_le_power_imp_0_le
tff(fact_1252_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,M,Na))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),M) ) ).

% mod_greater_zero_iff_not_dvd
tff(fact_1253_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),times_times(real),A2),C2))),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),D2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),C2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% L2_set_mult_ineq_lemma
tff(fact_1254_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)))
        <=> ( ( X != zero_zero(A) )
            | ( Y != zero_zero(A) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_1255_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X: A,Y: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A)) ) ).

% not_sum_squares_lt_zero
tff(fact_1256_div__less__mono,axiom,
    ! [A3: nat,B3: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),B3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ( ( modulo_modulo(nat,A3,Na) = zero_zero(nat) )
         => ( ( modulo_modulo(nat,B3,Na) = zero_zero(nat) )
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A3),Na)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),B3),Na)) ) ) ) ) ).

% div_less_mono
tff(fact_1257_divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)) ) ) ) ).

% divide_less_eq
tff(fact_1258_less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))) ) ) ) ).

% less_divide_eq
tff(fact_1259_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% neg_divide_less_eq
tff(fact_1260_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_less_divide_eq
tff(fact_1261_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_divide_less_eq
tff(fact_1262_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% pos_less_divide_eq
tff(fact_1263_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),Z) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_1264_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y)),X)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_1265_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_1266_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2)) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_1267_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = aa(num,A,numeral_numeral(A),W) )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2),aa(num,A,numeral_numeral(A),W) = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_1268_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(num,A,numeral_numeral(A),W) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2) = B2,aa(num,A,numeral_numeral(A),W) = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_1269_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E2)),D2)) ) ) ).

% less_add_iff2
tff(fact_1270_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E2)),C2)),D2) ) ) ).

% less_add_iff1
tff(fact_1271_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z)),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),Z) ) ) ) ).

% divide_add_eq_iff
tff(fact_1272_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),Y)),Z) ) ) ) ).

% add_divide_eq_iff
tff(fact_1273_add__num__frac,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,X: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))),Y) ) ) ) ).

% add_num_frac
tff(fact_1274_add__frac__num,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,X: A,Z: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))),Y) ) ) ) ).

% add_frac_num
tff(fact_1275_add__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)) ) ) ) ) ).

% add_frac_eq
tff(fact_1276_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,Z: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z))
          = $ite(Z = zero_zero(A),A2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),Z)),B2)),Z)) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_1277_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z)),B2)
          = $ite(Z = zero_zero(A),B2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_1278_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( ! [E: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),E)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ).

% field_le_epsilon
tff(fact_1279_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_strict_increasing2
tff(fact_1280_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_strict_increasing
tff(fact_1281_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_pos_nonneg
tff(fact_1282_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_nonpos_neg
tff(fact_1283_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_nonneg_pos
tff(fact_1284_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_neg_nonpos
tff(fact_1285_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,Z: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),Z))
          = $ite(Z = zero_zero(A),A2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),Z)),B2)),Z)) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_1286_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)) ) ) ) ) ).

% diff_frac_eq
tff(fact_1287_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),Y)),Z) ) ) ) ).

% diff_divide_eq_iff
tff(fact_1288_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z)),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),Z) ) ) ) ).

% divide_diff_eq_iff
tff(fact_1289_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))) ) ) ).

% power_less_power_Suc
tff(fact_1290_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))) ) ) ).

% power_gt1_lemma
tff(fact_1291_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) ) ) ).

% square_diff_one_factored
tff(fact_1292_frac__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),W)) ) ) ) ) ) ).

% frac_le
tff(fact_1293_frac__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),W)) ) ) ) ) ) ).

% frac_less
tff(fact_1294_frac__less2,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),W)) ) ) ) ) ) ).

% frac_less2
tff(fact_1295_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% divide_le_cancel
tff(fact_1296_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),zero_zero(A)) ) ) ) ).

% divide_nonneg_neg
tff(fact_1297_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% divide_nonneg_pos
tff(fact_1298_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% divide_nonpos_neg
tff(fact_1299_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),zero_zero(A)) ) ) ) ).

% divide_nonpos_pos
tff(fact_1300_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
tff(fact_1301_div__positive,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% div_positive
tff(fact_1302_unit__dvdE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ~ ( ( A2 != zero_zero(A) )
             => ! [C3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),times_times(A),A2),C3) ) ) ) ) ).

% unit_dvdE
tff(fact_1303_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( dvd(A)
        & semiring_0(A) )
     => ! [P: fun(A,$o),L: A] :
          ( ? [X5: A] : aa(A,$o,P,aa(A,A,aa(A,fun(A,A),times_times(A),L),X5))
        <=> ? [X5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),L),aa(A,A,aa(A,fun(A,A),plus_plus(A),X5),zero_zero(A)))
              & aa(A,$o,P,X5) ) ) ) ).

% unity_coeff_ex
tff(fact_1304_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% power_less_imp_less_base
tff(fact_1305_discrete,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),B2) ) ) ).

% discrete
tff(fact_1306_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( C2 != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D2)
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),D2),C2) )
                <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),D2) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_1307_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_1308_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2)
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_1309_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_1310_power__le__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),one_one(A)) ) ) ) ).

% power_le_one
tff(fact_1311_zdiv__mono__strict,axiom,
    ! [A3: int,B3: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A3),B3)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na)
       => ( ( modulo_modulo(int,A3,Na) = zero_zero(int) )
         => ( ( modulo_modulo(int,B3,Na) = zero_zero(int) )
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Na)),aa(int,int,aa(int,fun(int,int),divide_divide(int),B3),Na)) ) ) ) ) ).

% zdiv_mono_strict
tff(fact_1312_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D5: A,T2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),D5)
         => ! [X4: A,K4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),T2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D5))),T2)) ) ) ) ).

% inf_period(3)
tff(fact_1313_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D5: A,T2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),D5)
         => ! [X4: A,K4: A] :
              ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),T2))
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D5))),T2)) ) ) ) ).

% inf_period(4)
tff(fact_1314_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_1315_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_1316_unit__div__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% unit_div_commute
tff(fact_1317_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_1318_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),B2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_1319_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = C2 )
          <=> ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% unit_eq_div1
tff(fact_1320_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na))),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),aa(nat,nat,suc,Na)))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% power_le_imp_le_base
tff(fact_1321_power__inject__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat,B2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),aa(nat,nat,suc,Na)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
tff(fact_1322_one__less__mult,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) ) ) ).

% one_less_mult
tff(fact_1323_n__less__m__mult__n,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) ) ) ).

% n_less_m_mult_n
tff(fact_1324_n__less__n__mult__m,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),M)) ) ) ).

% n_less_n_mult_m
tff(fact_1325_ex__least__nat__less,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,Na)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ? [K2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),Na)
            & ! [I4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I4),K2)
               => ~ aa(nat,$o,P,I4) )
            & aa(nat,$o,P,aa(nat,nat,suc,K2)) ) ) ) ).

% ex_least_nat_less
tff(fact_1326_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ) ).

% nat_mult_dvd_cancel1
tff(fact_1327_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ) ).

% dvd_mult_cancel
tff(fact_1328_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) ) ) ).

% nat_mult_div_cancel1
tff(fact_1329_div__less__iff__less__mult,axiom,
    ! [Q4: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Q4)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Q4)),Na)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q4)) ) ) ).

% div_less_iff_less_mult
tff(fact_1330_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => ? [D4: nat,X3: nat,Y4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D4),A2)
          & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D4),B2)
          & ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),D4) ) ) ) ).

% bezout_add_strong_nat
tff(fact_1331_dvd__imp__le,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na) ) ) ).

% dvd_imp_le
tff(fact_1332_less__diff__conv2,axiom,
    ! [K: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),K)),I2)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)) ) ) ).

% less_diff_conv2
tff(fact_1333_pos__zmult__eq__1__iff,axiom,
    ! [M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),M)
     => ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),Na) = one_one(int) )
      <=> ( ( M = one_one(int) )
          & ( Na = one_one(int) ) ) ) ) ).

% pos_zmult_eq_1_iff
tff(fact_1334_div__le__mono2,axiom,
    ! [M: nat,Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),K),Na)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),K),M)) ) ) ).

% div_le_mono2
tff(fact_1335_div__greater__zero__iff,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ).

% div_greater_zero_iff
tff(fact_1336_nat__one__le__power,axiom,
    ! [I2: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),I2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I2),Na)) ) ).

% nat_one_le_power
tff(fact_1337_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ).

% int_one_le_iff_zero_less
tff(fact_1338_minusinfinity,axiom,
    ! [D2: int,P1: fun(int,$o),P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X3: int,K2: int] :
            ( aa(int,$o,P1,X3)
          <=> aa(int,$o,P1,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2))) )
       => ( ? [Z3: int] :
            ! [X3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X3),Z3)
             => ( aa(int,$o,P,X3)
              <=> aa(int,$o,P1,X3) ) )
         => ( ? [X_12: int] : aa(int,$o,P1,X_12)
           => ? [X_1: int] : aa(int,$o,P,X_1) ) ) ) ) ).

% minusinfinity
tff(fact_1339_plusinfinity,axiom,
    ! [D2: int,P2: fun(int,$o),P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X3: int,K2: int] :
            ( aa(int,$o,P2,X3)
          <=> aa(int,$o,P2,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2))) )
       => ( ? [Z3: int] :
            ! [X3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z3),X3)
             => ( aa(int,$o,P,X3)
              <=> aa(int,$o,P2,X3) ) )
         => ( ? [X_12: int] : aa(int,$o,P2,X_12)
           => ? [X_1: int] : aa(int,$o,P,X_1) ) ) ) ) ).

% plusinfinity
tff(fact_1340_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z) ) ).

% zless_imp_add1_zle
tff(fact_1341_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ).

% add1_zle_eq
tff(fact_1342_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))
      <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),A2)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
tff(fact_1343_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2) ) ) ).

% pos_imp_zdiv_nonneg_iff
tff(fact_1344_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int)) ) ) ).

% neg_imp_zdiv_nonneg_iff
tff(fact_1345_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),I2),K))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I2) ) ) ).

% pos_imp_zdiv_pos_iff
tff(fact_1346_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int)) ) ) ).

% div_nonpos_pos_le0
tff(fact_1347_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),zero_zero(int)) ) ) ).

% div_nonneg_neg_le0
tff(fact_1348_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)) ) ) ).

% div_positive_int
tff(fact_1349_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L))
    <=> ( ( K = zero_zero(int) )
        | ( L = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
          & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ) ).

% div_int_pos_iff
tff(fact_1350_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B5)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)) ) ) ) ).

% zdiv_mono2_neg
tff(fact_1351_zdiv__mono1__neg,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),A5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A5),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)) ) ) ).

% zdiv_mono1_neg
tff(fact_1352_zdiv__eq__0__iff,axiom,
    ! [I2: int,K: int] :
      ( ( aa(int,int,aa(int,fun(int,int),divide_divide(int),I2),K) = zero_zero(int) )
    <=> ( ( K = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I2)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),K) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I2) ) ) ) ).

% zdiv_eq_0_iff
tff(fact_1353_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B5)) ) ) ) ).

% zdiv_mono2
tff(fact_1354_zdiv__mono1,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),A5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A5),B2)) ) ) ).

% zdiv_mono1
tff(fact_1355_zdvd__imp__le,axiom,
    ! [Z: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Z),Na)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),Na) ) ) ).

% zdvd_imp_le
tff(fact_1356_int__induct,axiom,
    ! [P: fun(int,$o),K: int,I2: int] :
      ( aa(int,$o,P,K)
     => ( ! [I3: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I3)
           => ( aa(int,$o,P,I3)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))) ) )
       => ( ! [I3: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),K)
             => ( aa(int,$o,P,I3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I3),one_one(int))) ) )
         => aa(int,$o,P,I2) ) ) ) ).

% int_induct
tff(fact_1357_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),aa(nat,nat,suc,Na)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_1358_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),aa(nat,nat,suc,Na)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% set_bit_Suc
tff(fact_1359_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),aa(nat,nat,suc,Na)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_1360_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) != aa(list(A),nat,size_size(list(A)),Ys) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
tff(fact_1361_Ex__list__of__length,axiom,
    ! [A: $tType,Na: nat] :
    ? [Xs2: list(A)] : ( aa(list(A),nat,size_size(list(A)),Xs2) = Na ) ).

% Ex_list_of_length
tff(fact_1362_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),B2),A2) ) ) ).

% pos_zdiv_mult_2
tff(fact_1363_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int))),A2) ) ) ).

% neg_zdiv_mult_2
tff(fact_1364_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,X: A,Y: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),U),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ) ) ).

% arith_geo_mean
tff(fact_1365_even__even__mod__4__iff,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2))))) ) ).

% even_even_mod_4_iff
tff(fact_1366_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(num,A,numeral_numeral(A),W))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_1367_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_1368_frac__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)),aa(A,A,aa(A,fun(A,A),divide_divide(A),W),Z))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),zero_zero(A)) ) ) ) ) ).

% frac_less_eq
tff(fact_1369_power__Suc__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ).

% power_Suc_less
tff(fact_1370_mult__2,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2
tff(fact_1371_mult__2__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2_right
tff(fact_1372_left__add__twice,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),B2) ) ) ).

% left_add_twice
tff(fact_1373_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),one_one(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            | ( A2 = zero_zero(A) ) ) ) ) ).

% divide_le_eq_1
tff(fact_1374_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% le_divide_eq_1
tff(fact_1375_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_1376_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_1377_is__unitE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ~ ( ( A2 != zero_zero(A) )
             => ! [B4: A] :
                  ( ( B4 != zero_zero(A) )
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B4),one_one(A))
                   => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) = B4 )
                     => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),B4) = A2 )
                       => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B4) = one_one(A) )
                         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2) != aa(A,A,aa(A,fun(A,A),times_times(A),C2),B4) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_1378_evenE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ~ ! [B4: A] : ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B4) ) ) ) ).

% evenE
tff(fact_1379_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),X)),X) ) ) ).

% power4_eq_xxxx
tff(fact_1380_power2__eq__square,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) ) ) ).

% power2_eq_square
tff(fact_1381_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,Na))),A2) ) ) ) ).

% power_Suc_le_self
tff(fact_1382_Suc__double__not__eq__double,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)) != aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ).

% Suc_double_not_eq_double
tff(fact_1383_double__not__eq__Suc__double,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M) != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% double_not_eq_Suc_double
tff(fact_1384_power__even__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power_even_eq
tff(fact_1385_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat,B2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) = aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
tff(fact_1386_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) = aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na) )
              <=> ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
tff(fact_1387_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X: A,M: nat,Na: nat] :
          ( ( X != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na))
          <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),one_one(A))
              | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ) ) ).

% dvd_power_iff
tff(fact_1388_self__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ).

% self_le_power
tff(fact_1389_power__diff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,Na: nat,M: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ) ).

% power_diff
tff(fact_1390_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),M)) ) ).

% self_le_ge2_pow
tff(fact_1391_power2__nat__le__eq__le,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% power2_nat_le_eq_le
tff(fact_1392_power2__nat__le__imp__le,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% power2_nat_le_imp_le
tff(fact_1393_dividend__less__times__div,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)))) ) ).

% dividend_less_times_div
tff(fact_1394_dividend__less__div__times,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),Na))) ) ).

% dividend_less_div_times
tff(fact_1395_split__div,axiom,
    ! [P: fun(nat,$o),M: nat,Na: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na))
    <=> ( ( ( Na = zero_zero(nat) )
         => aa(nat,$o,P,zero_zero(nat)) )
        & ( ( Na != zero_zero(nat) )
         => ! [I: nat,J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),Na)
             => ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),I)),J) )
               => aa(nat,$o,P,I) ) ) ) ) ) ).

% split_div
tff(fact_1396_mult__eq__if,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)
      = $ite(M = zero_zero(nat),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),Na))) ) ).

% mult_eq_if
tff(fact_1397_dvd__mult__cancel2,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),M)),M)
      <=> ( Na = one_one(nat) ) ) ) ).

% dvd_mult_cancel2
tff(fact_1398_dvd__mult__cancel1,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),M)
      <=> ( Na = one_one(nat) ) ) ) ).

% dvd_mult_cancel1
tff(fact_1399_le__imp__0__less,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ).

% le_imp_0_less
tff(fact_1400_power__dvd__imp__le,axiom,
    ! [I2: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I2),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I2),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),I2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% power_dvd_imp_le
tff(fact_1401_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
            | ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) = zero_zero(A) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_1402_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ) ).

% even_iff_mod_2_eq_zero
tff(fact_1403_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_1404_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = A2 ) ) ) ).

% even_two_times_div_two
tff(fact_1405_zero__le__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% zero_le_power2
tff(fact_1406_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: A,Y: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
             => ( X = Y ) ) ) ) ) ).

% power2_eq_imp_eq
tff(fact_1407_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ) ).

% power2_le_imp_le
tff(fact_1408_power__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ) ) ).

% power_strict_mono
tff(fact_1409_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,M: nat,Na: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
            = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)))) ) ) ) ).

% power_diff_power_eq
tff(fact_1410_power__eq__if,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [P3: A,M: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),P3),M)
          = $ite(M = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(nat,A,aa(A,fun(nat,A),power_power(A),P3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))) ) ) ).

% power_eq_if
tff(fact_1411_power__mono__odd,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,A2: A,B2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ) ).

% power_mono_odd
tff(fact_1412_power__minus__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))),A2) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) ) ) ) ).

% power_minus_mult
tff(fact_1413_four__x__squared,axiom,
    ! [X: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% four_x_squared
tff(fact_1414_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),Na))) ) ).

% diff_le_diff_pow
tff(fact_1415_two__realpow__ge__one,axiom,
    ! [Na: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),Na)) ).

% two_realpow_ge_one
tff(fact_1416_le__div__geq,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),Na)) ) ) ) ).

% le_div_geq
tff(fact_1417_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),Na))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% dvd_power_iff_le
tff(fact_1418_not__exp__less__eq__0__int,axiom,
    ! [Na: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),zero_zero(int)) ).

% not_exp_less_eq_0_int
tff(fact_1419_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = zero_zero(A) ) ) ) ).

% bits_stable_imp_add_self
tff(fact_1420_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),zero_zero(A),one_one(A)) ) ) ).

% mod2_eq_if
tff(fact_1421_parity__cases,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
           => ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) ) )
         => ~ ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
             => ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) ) ) ) ) ).

% parity_cases
tff(fact_1422_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat,M: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ) ).

% div_exp_mod_exp_eq
tff(fact_1423_oddE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ~ ! [B4: A] : ( A2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B4)),one_one(A)) ) ) ) ).

% oddE
tff(fact_1424_power2__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)),Y)) ) ) ).

% power2_sum
tff(fact_1425_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ) ).

% power2_less_imp_less
tff(fact_1426_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% sum_power2_ge_zero
tff(fact_1427_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),zero_zero(A))
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_power2_le_zero_iff
tff(fact_1428_nat__bit__induct,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N: nat] :
            ( aa(nat,$o,P,N)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) ) )
       => ( ! [N: nat] :
              ( aa(nat,$o,P,N)
             => aa(nat,$o,P,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) )
         => aa(nat,$o,P,Na) ) ) ) ).

% nat_bit_induct
tff(fact_1429_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_le_power_eq
tff(fact_1430_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,A2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ).

% zero_le_odd_power
tff(fact_1431_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% zero_le_even_power
tff(fact_1432_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)),L)),one_one(int)) ) ) ) ).

% div_pos_geq
tff(fact_1433_length__induct,axiom,
    ! [A: $tType,P: fun(list(A),$o),Xs: list(A)] :
      ( ! [Xs2: list(A)] :
          ( ! [Ys2: list(A)] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Ys2)),aa(list(A),nat,size_size(list(A)),Xs2))
             => aa(list(A),$o,P,Ys2) )
         => aa(list(A),$o,P,Xs2) )
     => aa(list(A),$o,P,Xs) ) ).

% length_induct
tff(fact_1434_power2__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)),Y)) ) ) ).

% power2_diff
tff(fact_1435_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))),zero_zero(A)) ) ) ).

% odd_power_less_zero
tff(fact_1436_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),K)
       => ? [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) ) ) ).

% ex_power_ivl1
tff(fact_1437_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
       => ? [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) ) ) ).

% ex_power_ivl2
tff(fact_1438_even__mod__4__div__2,axiom,
    ! [Na: nat] :
      ( ( modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(nat,nat,suc,zero_zero(nat)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% even_mod_4_div_2
tff(fact_1439_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),one_one(A))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% even_mask_div_iff'
tff(fact_1440_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),zero_zero(A))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
            & ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
              | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
                & ( A2 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq
tff(fact_1441_low__def,axiom,
    ! [X: nat,Na: nat] : ( vEBT_VEBT_low(X,Na) = modulo_modulo(nat,X,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% low_def
tff(fact_1442_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_1443_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_1444_Bolzano,axiom,
    ! [A2: real,B2: real,P: fun(real,fun(real,$o))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [A4: real,B4: real,C3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),P,A4),B4)
           => ( aa(real,$o,aa(real,fun(real,$o),P,B4),C3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A4),B4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B4),C3)
                 => aa(real,$o,aa(real,fun(real,$o),P,A4),C3) ) ) ) )
       => ( ! [X3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
               => ? [D6: real] :
                    ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                    & ! [A4: real,B4: real] :
                        ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A4),X3)
                          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B4)
                          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B4),A4)),D6) )
                       => aa(real,$o,aa(real,fun(real,$o),P,A4),B4) ) ) ) )
         => aa(real,$o,aa(real,fun(real,$o),P,A2),B2) ) ) ) ).

% Bolzano
tff(fact_1445_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,F2: fun(A,nat),Na: nat] :
      ( aa(A,$o,P,K)
     => ( ! [X3: A] :
            ( aa(A,$o,P,X3)
           => ? [Y3: A] :
                ( aa(A,$o,P,Y3)
                & ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F2,Y3)),aa(A,nat,F2,X3)) ) )
       => ? [Y4: A] :
            ( aa(A,$o,P,Y4)
            & ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,Y4)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F2,K)),Na)) ) ) ) ).

% ex_has_greatest_nat_lemma
tff(fact_1446_flip__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),zero_zero(nat)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% flip_bit_0
tff(fact_1447_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,Na)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_1448_triangle__def,axiom,
    ! [Na: nat] : ( nat_triangle(Na) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,suc,Na))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% triangle_def
tff(fact_1449_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [R2: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R2 != zero_zero(A) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),R2),C2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),R2),D2)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_1450_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ) ).

% mult_less_iff1
tff(fact_1451_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: $o,Q: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q))
        <=> ( (P)
           => (Q) ) ) ) ).

% of_bool_less_eq_iff
tff(fact_1452_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P) = zero_zero(A) )
        <=> ~ (P) ) ) ).

% of_bool_eq_0_iff
tff(fact_1453_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa($o,A,zero_neq_one_of_bool(A),$false) = zero_zero(A) ) ) ).

% of_bool_eq(1)
tff(fact_1454_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: $o,Q: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q))
        <=> ( ~ (P)
            & (Q) ) ) ) ).

% of_bool_less_iff
tff(fact_1455_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P) = one_one(A) )
        <=> (P) ) ) ).

% of_bool_eq_1_iff
tff(fact_1456_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa($o,A,zero_neq_one_of_bool(A),$true) = one_one(A) ) ) ).

% of_bool_eq(2)
tff(fact_1457_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),zero_zero(A)) = zero_zero(A) ) ) ).

% signed_take_bit_of_0
tff(fact_1458_triangle__0,axiom,
    nat_triangle(zero_zero(nat)) = zero_zero(nat) ).

% triangle_0
tff(fact_1459_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa($o,A,zero_neq_one_of_bool(A),P))
        <=> (P) ) ) ).

% zero_less_of_bool_iff
tff(fact_1460_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa($o,A,zero_neq_one_of_bool(A),P)),one_one(A))
        <=> ~ (P) ) ) ).

% of_bool_less_one_iff
tff(fact_1461_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: $o] : ( aa($o,A,zero_neq_one_of_bool(A),~ (P)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa($o,A,zero_neq_one_of_bool(A),P)) ) ) ).

% of_bool_not_iff
tff(fact_1462_Suc__0__mod__eq,axiom,
    ! [Na: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),Na) = aa($o,nat,zero_neq_one_of_bool(nat),( Na != aa(nat,nat,suc,zero_zero(nat)) )) ) ).

% Suc_0_mod_eq
tff(fact_1463_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,Na)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_Suc_1
tff(fact_1464_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_1465_triangle__Suc,axiom,
    ! [Na: nat] : ( nat_triangle(aa(nat,nat,suc,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(Na)),aa(nat,nat,suc,Na)) ) ).

% triangle_Suc
tff(fact_1466_signed__take__bit__Suc__bit0,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Na)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_Suc_bit0
tff(fact_1467_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [P3: $o] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa($o,A,zero_neq_one_of_bool(A),P3))
        <=> (P3) ) ) ).

% odd_of_bool_self
tff(fact_1468_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [B2: $o] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa($o,A,zero_neq_one_of_bool(A),B2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% of_bool_half_eq_0
tff(fact_1469_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa($o,A,zero_neq_one_of_bool(A),( Na = zero_zero(nat) )) ) ) ).

% one_div_2_pow_eq
tff(fact_1470_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa($o,A,zero_neq_one_of_bool(A),( Na = zero_zero(nat) )) ) ) ).

% bits_1_div_exp
tff(fact_1471_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat] : ( modulo_modulo(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)) ) ) ).

% one_mod_2_pow_eq
tff(fact_1472_complete__real,axiom,
    ! [S3: set(real)] :
      ( ? [X4: real] : member(real,X4,S3)
     => ( ? [Z3: real] :
          ! [X3: real] :
            ( member(real,X3,S3)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),Z3) )
       => ? [Y4: real] :
            ( ! [X4: real] :
                ( member(real,X4,S3)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),Y4) )
            & ! [Z3: real] :
                ( ! [X3: real] :
                    ( member(real,X3,S3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),Z3) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),Z3) ) ) ) ) ).

% complete_real
tff(fact_1473_verit__la__generic,axiom,
    ! [A2: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),X)
      | ( A2 = X )
      | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),A2) ) ).

% verit_la_generic
tff(fact_1474_signed__take__bit__mult,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% signed_take_bit_mult
tff(fact_1475_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P3: $o,Q4: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P3) = aa($o,A,zero_neq_one_of_bool(A),Q4) )
        <=> ( (P3)
          <=> (Q4) ) ) ) ).

% of_bool_eq_iff
tff(fact_1476_of__bool__conj,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: $o,Q: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),
              (P)
            & (Q))
          = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_conj
tff(fact_1477_signed__take__bit__add,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% signed_take_bit_add
tff(fact_1478_signed__take__bit__diff,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% signed_take_bit_diff
tff(fact_1479_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa($o,A,zero_neq_one_of_bool(A),P)) ) ).

% zero_less_eq_of_bool
tff(fact_1480_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,zero_neq_one_of_bool(A),P)),one_one(A)) ) ).

% of_bool_less_eq_one
tff(fact_1481_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,$o),P3: $o] :
          ( aa(A,$o,P,aa($o,A,zero_neq_one_of_bool(A),P3))
        <=> ~ ( ( (P3)
                & ~ aa(A,$o,P,one_one(A)) )
              | ( ~ (P3)
                & ~ aa(A,$o,P,zero_zero(A)) ) ) ) ) ).

% split_of_bool_asm
tff(fact_1482_split__of__bool,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,$o),P3: $o] :
          ( aa(A,$o,P,aa($o,A,zero_neq_one_of_bool(A),P3))
        <=> ( ( (P3)
             => aa(A,$o,P,one_one(A)) )
            & ( ~ (P3)
             => aa(A,$o,P,zero_zero(A)) ) ) ) ) ).

% split_of_bool
tff(fact_1483_of__bool__def,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P3: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),P3)
          = $ite((P3),one_one(A),zero_zero(A)) ) ) ).

% of_bool_def
tff(fact_1484_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] : ( aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% of_bool_odd_eq_mod_2
tff(fact_1485_signed__take__bit__int__less__exp,axiom,
    ! [Na: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ).

% signed_take_bit_int_less_exp
tff(fact_1486_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% signed_take_bit_int_greater_eq_self_iff
tff(fact_1487_signed__take__bit__int__less__self__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),K) ) ).

% signed_take_bit_int_less_self_iff
tff(fact_1488_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,M),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_signed_take_bit_iff
tff(fact_1489_bits__induct,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [P: fun(A,$o),A2: A] :
          ( ! [A4: A] :
              ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A4),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A4 )
             => aa(A,$o,P,A4) )
         => ( ! [A4: A,B4: $o] :
                ( aa(A,$o,P,A4)
               => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),B4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A4 )
                 => aa(A,$o,P,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),B4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A4))) ) )
           => aa(A,$o,P,A2) ) ) ) ).

% bits_induct
tff(fact_1490_signed__take__bit__int__less__eq,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),K)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(nat,nat,suc,Na)))) ) ).

% signed_take_bit_int_less_eq
tff(fact_1491_add__0__iff,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [B2: A,A2: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% add_0_iff
tff(fact_1492_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [W: A,Y: A,X: A,Z: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),X),Y)) )
        <=> ( ( W = X )
            | ( Y = Z ) ) ) ) ).

% crossproduct_eq
tff(fact_1493_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),D2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_1494_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,Na: nat] : ( modulo_modulo(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)) ) ) ).

% exp_mod_exp
tff(fact_1495_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,F2: fun(A,nat),B2: nat] :
      ( aa(A,$o,P,K)
     => ( ! [Y4: A] :
            ( aa(A,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,Y4)),B2) )
       => ? [X3: A] :
            ( aa(A,$o,P,X3)
            & ! [Y3: A] :
                ( aa(A,$o,P,Y3)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F2,Y3)),aa(A,nat,F2,X3)) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
tff(fact_1496_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na))
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                aa($o,A,zero_neq_one_of_bool(A),
                  ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M) != zero_zero(A) )
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M))),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na))) ) ) ).

% exp_div_exp_eq
tff(fact_1497_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2)
          = $ite(Na = zero_zero(nat),aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))))) ) ) ).

% signed_take_bit_rec
tff(fact_1498_concat__bit__Suc,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(aa(nat,nat,suc,Na),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,bit_concat_bit(Na,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),L))) ) ).

% concat_bit_Suc
tff(fact_1499_take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)
          = $ite(Na = zero_zero(nat),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% take_bit_rec
tff(fact_1500_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),U) ) ) ) ) ).

% sqrt_sum_squares_half_less
tff(fact_1501_odd__mod__4__div__2,axiom,
    ! [Na: nat] :
      ( ( modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
     => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% odd_mod_4_div_2
tff(fact_1502_Bernoulli__inequality__even,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),X))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X)),Na)) ) ).

% Bernoulli_inequality_even
tff(fact_1503_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),aa(num,num,bit1,V)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W)))),one_one(int)) ) ).

% zmod_numeral_Bit1
tff(fact_1504_psubsetI,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( ( A3 != B3 )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3) ) ) ).

% psubsetI
tff(fact_1505_verit__minus__simplify_I4_J,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),B2)) = B2 ) ) ).

% verit_minus_simplify(4)
tff(fact_1506_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),A2)) = A2 ) ) ).

% add.inverse_inverse
tff(fact_1507_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,uminus_uminus(A),B2) )
        <=> ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
tff(fact_1508_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat,Na: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),M) = aa(nat,A,semiring_1_of_nat(A),Na) )
        <=> ( M = Na ) ) ) ).

% of_nat_eq_iff
tff(fact_1509_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( aa(num,num,bit1,X32) = aa(num,num,bit1,Y32) )
    <=> ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
tff(fact_1510_semiring__norm_I90_J,axiom,
    ! [M: num,Na: num] :
      ( ( aa(num,num,bit1,M) = aa(num,num,bit1,Na) )
    <=> ( M = Na ) ) ).

% semiring_norm(90)
tff(fact_1511_real__sqrt__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( aa(real,real,sqrt,X) = aa(real,real,sqrt,Y) )
    <=> ( X = Y ) ) ).

% real_sqrt_eq_iff
tff(fact_1512_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% neg_le_iff_le
tff(fact_1513_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = A2 )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% neg_equal_zero
tff(fact_1514_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% equal_neg_zero
tff(fact_1515_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_1516_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),A2) )
        <=> ( zero_zero(A) = A2 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_1517_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(A,A,uminus_uminus(A),zero_zero(A)) = zero_zero(A) ) ) ).

% add.inverse_neutral
tff(fact_1518_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% neg_less_iff_less
tff(fact_1519_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,Na: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) )
        <=> ( M = Na ) ) ) ).

% neg_numeral_eq_iff
tff(fact_1520_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% mult_minus_left
tff(fact_1521_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) ) ) ).

% minus_mult_minus
tff(fact_1522_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% mult_minus_right
tff(fact_1523_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_add_distrib
tff(fact_1524_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = B2 ) ) ).

% minus_add_cancel
tff(fact_1525_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),B2)) = B2 ) ) ).

% add_minus_cancel
tff(fact_1526_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) ) ) ).

% minus_diff_eq
tff(fact_1527_div__minus__minus,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ).

% div_minus_minus
tff(fact_1528_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,uminus_uminus(A),X)),Y)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y) ) ) ).

% minus_dvd_iff
tff(fact_1529_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),aa(A,A,uminus_uminus(A),Y))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y) ) ) ).

% dvd_minus_iff
tff(fact_1530_semiring__norm_I89_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,bit1,M) != aa(num,num,bit0,Na) ) ).

% semiring_norm(89)
tff(fact_1531_semiring__norm_I88_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,bit0,M) != aa(num,num,bit1,Na) ) ).

% semiring_norm(88)
tff(fact_1532_semiring__norm_I86_J,axiom,
    ! [M: num] : ( aa(num,num,bit1,M) != one2 ) ).

% semiring_norm(86)
tff(fact_1533_semiring__norm_I84_J,axiom,
    ! [Na: num] : ( one2 != aa(num,num,bit1,Na) ) ).

% semiring_norm(84)
tff(fact_1534_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,B2)) ) ) ).

% mod_minus_minus
tff(fact_1535_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),zero_zero(A)) = zero_zero(A) ) ) ).

% take_bit_of_0
tff(fact_1536_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,uminus_uminus(real),A2)) = zero_zero(real) )
    <=> ( X = A2 ) ) ).

% real_add_minus_iff
tff(fact_1537_real__sqrt__zero,axiom,
    aa(real,real,sqrt,zero_zero(real)) = zero_zero(real) ).

% real_sqrt_zero
tff(fact_1538_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( aa(real,real,sqrt,X) = zero_zero(real) )
    <=> ( X = zero_zero(real) ) ) ).

% real_sqrt_eq_zero_cancel_iff
tff(fact_1539_real__sqrt__less__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ).

% real_sqrt_less_iff
tff(fact_1540_real__sqrt__le__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ).

% real_sqrt_le_iff
tff(fact_1541_real__sqrt__one,axiom,
    aa(real,real,sqrt,one_one(real)) = one_one(real) ).

% real_sqrt_one
tff(fact_1542_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( aa(real,real,sqrt,X) = one_one(real) )
    <=> ( X = one_one(real) ) ) ).

% real_sqrt_eq_1_iff
tff(fact_1543_concat__bit__0,axiom,
    ! [K: int,L: int] : ( aa(int,int,bit_concat_bit(zero_zero(nat),K),L) = L ) ).

% concat_bit_0
tff(fact_1544_concat__bit__of__zero__2,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_concat_bit(Na,K),zero_zero(int)) = aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) ) ).

% concat_bit_of_zero_2
tff(fact_1545_semiring__norm_I80_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit1,M)),aa(num,num,bit1,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na) ) ).

% semiring_norm(80)
tff(fact_1546_semiring__norm_I73_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,M)),aa(num,num,bit1,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na) ) ).

% semiring_norm(73)
tff(fact_1547_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% neg_less_eq_nonneg
tff(fact_1548_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% less_eq_neg_nonpos
tff(fact_1549_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% neg_le_0_iff_le
tff(fact_1550_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% neg_0_le_iff_le
tff(fact_1551_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% neg_less_0_iff_less
tff(fact_1552_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% neg_0_less_iff_less
tff(fact_1553_neg__less__pos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% neg_less_pos
tff(fact_1554_less__neg__neg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% less_neg_neg
tff(fact_1555_ab__left__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),A2) = zero_zero(A) ) ) ).

% ab_left_minus
tff(fact_1556_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),A2)) = zero_zero(A) ) ) ).

% add.right_inverse
tff(fact_1557_diff__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ).

% diff_0
tff(fact_1558_verit__minus__simplify_I3_J,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% verit_minus_simplify(3)
tff(fact_1559_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na))) ) ) ).

% add_neg_numeral_simps(3)
tff(fact_1560_mult__minus1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),one_one(A))),Z) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1
tff(fact_1561_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1_right
tff(fact_1562_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) ) ) ).

% uminus_add_conv_diff
tff(fact_1563_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) ) ) ).

% diff_minus_eq_add
tff(fact_1564_divide__minus1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),X) ) ) ).

% divide_minus1
tff(fact_1565_div__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),A2) ) ) ).

% div_minus1_right
tff(fact_1566_of__nat__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),zero_zero(nat)) = zero_zero(A) ) ) ).

% of_nat_0
tff(fact_1567_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] :
          ( ( zero_zero(A) = aa(nat,A,semiring_1_of_nat(A),Na) )
        <=> ( zero_zero(nat) = Na ) ) ) ).

% of_nat_0_eq_iff
tff(fact_1568_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),M) = zero_zero(A) )
        <=> ( M = zero_zero(nat) ) ) ) ).

% of_nat_eq_0_iff
tff(fact_1569_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% of_nat_less_iff
tff(fact_1570_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ).

% of_nat_le_iff
tff(fact_1571_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: num] : ( aa(nat,A,semiring_1_of_nat(A),aa(num,nat,numeral_numeral(nat),Na)) = aa(num,A,numeral_numeral(A),Na) ) ) ).

% of_nat_numeral
tff(fact_1572_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) ) ) ).

% minus_mod_self1
tff(fact_1573_of__nat__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_add
tff(fact_1574_of__nat__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_mult
tff(fact_1575_take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,zero_zero(nat)),A2) = zero_zero(A) ) ) ).

% take_bit_0
tff(fact_1576_of__nat__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),one_one(nat)) = one_one(A) ) ) ).

% of_nat_1
tff(fact_1577_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] :
          ( ( one_one(A) = aa(nat,A,semiring_1_of_nat(A),Na) )
        <=> ( Na = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_1578_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Na) = one_one(A) )
        <=> ( Na = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_1579_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),one_one(A)) = one_one(A) ) ) ).

% take_bit_Suc_1
tff(fact_1580_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),one_one(A)) = one_one(A) ) ) ).

% take_bit_numeral_1
tff(fact_1581_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [X: nat,B2: nat,W: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),X) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W) )
        <=> ( X = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
tff(fact_1582_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [B2: nat,W: nat,X: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W) = aa(nat,A,semiring_1_of_nat(A),X) )
        <=> ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W) = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
tff(fact_1583_of__nat__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),M),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),M)),Na) ) ) ).

% of_nat_power
tff(fact_1584_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y) ) ).

% real_sqrt_gt_0_iff
tff(fact_1585_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real)) ) ).

% real_sqrt_lt_0_iff
tff(fact_1586_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y) ) ).

% real_sqrt_ge_0_iff
tff(fact_1587_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ).

% real_sqrt_le_0_iff
tff(fact_1588_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_1589_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Y) ) ).

% real_sqrt_gt_1_iff
tff(fact_1590_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real)) ) ).

% real_sqrt_lt_1_iff
tff(fact_1591_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y) ) ).

% real_sqrt_ge_1_iff
tff(fact_1592_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real)) ) ).

% real_sqrt_le_1_iff
tff(fact_1593_semiring__norm_I7_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit0,M)),aa(num,num,bit1,Na)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% semiring_norm(7)
tff(fact_1594_semiring__norm_I9_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,M)),aa(num,num,bit0,Na)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% semiring_norm(9)
tff(fact_1595_semiring__norm_I14_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit0,M)),aa(num,num,bit1,Na)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),M),aa(num,num,bit1,Na))) ) ).

% semiring_norm(14)
tff(fact_1596_semiring__norm_I15_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,M)),aa(num,num,bit0,Na)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,M)),Na)) ) ).

% semiring_norm(15)
tff(fact_1597_semiring__norm_I81_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit1,M)),aa(num,num,bit0,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na) ) ).

% semiring_norm(81)
tff(fact_1598_semiring__norm_I72_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit0,M)),aa(num,num,bit1,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na) ) ).

% semiring_norm(72)
tff(fact_1599_semiring__norm_I77_J,axiom,
    ! [Na: num] : aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),aa(num,num,bit1,Na)) ).

% semiring_norm(77)
tff(fact_1600_semiring__norm_I70_J,axiom,
    ! [M: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,M)),one2) ).

% semiring_norm(70)
tff(fact_1601_concat__bit__nonnegative__iff,axiom,
    ! [Na: nat,K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_concat_bit(Na,K),L))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ).

% concat_bit_nonnegative_iff
tff(fact_1602_concat__bit__negative__iff,axiom,
    ! [Na: nat,K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_concat_bit(Na,K),L)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ).

% concat_bit_negative_iff
tff(fact_1603_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_simps(1)
tff(fact_1604_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: $o] : ( aa(nat,A,semiring_1_of_nat(A),aa($o,nat,zero_neq_one_of_bool(nat),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_nat_of_bool
tff(fact_1605_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% add_neg_numeral_special(7)
tff(fact_1606_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = zero_zero(A) ) ) ).

% add_neg_numeral_special(8)
tff(fact_1607_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% diff_numeral_special(12)
tff(fact_1608_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Na: num] :
          ( ( aa(A,A,uminus_uminus(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) )
        <=> ( Na = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_1609_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Na: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( Na = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_1610_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),M)),zero_zero(A))
        <=> ( M = zero_zero(nat) ) ) ) ).

% of_nat_le_0_iff
tff(fact_1611_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),A2)) = A2 ) ) ).

% left_minus_one_mult_self
tff(fact_1612_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)) = one_one(A) ) ) ).

% minus_one_mult_self
tff(fact_1613_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% mod_minus1_right
tff(fact_1614_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M)) ) ) ).

% of_nat_Suc
tff(fact_1615_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),one_one(A)) = zero_zero(A) )
        <=> ( Na = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_1616_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W)))),Y) ) ) ).

% semiring_norm(168)
tff(fact_1617_real__sqrt__four,axiom,
    aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)) ).

% real_sqrt_four
tff(fact_1618_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),Na)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na))) ) ) ).

% diff_numeral_simps(3)
tff(fact_1619_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ) ).

% diff_numeral_simps(2)
tff(fact_1620_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,V))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),W)) ) ).

% zdiv_numeral_Bit1
tff(fact_1621_semiring__norm_I10_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,M)),aa(num,num,bit1,Na)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)),one2)) ) ).

% semiring_norm(10)
tff(fact_1622_semiring__norm_I8_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,M)),one2) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),one2)) ) ).

% semiring_norm(8)
tff(fact_1623_semiring__norm_I5_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit0,M)),one2) = aa(num,num,bit1,M) ) ).

% semiring_norm(5)
tff(fact_1624_semiring__norm_I4_J,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),aa(num,num,bit1,Na)) = aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),Na),one2)) ) ).

% semiring_norm(4)
tff(fact_1625_semiring__norm_I3_J,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),aa(num,num,bit0,Na)) = aa(num,num,bit1,Na) ) ).

% semiring_norm(3)
tff(fact_1626_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),Na)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_1627_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),Na)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),Na))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_1628_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),Na))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_1629_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y) ) ) ).

% semiring_norm(170)
tff(fact_1630_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y) ) ) ).

% semiring_norm(171)
tff(fact_1631_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Y) ) ) ).

% semiring_norm(172)
tff(fact_1632_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Na),M) ) ) ).

% neg_numeral_le_iff
tff(fact_1633_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Na),M) ) ) ).

% neg_numeral_less_iff
tff(fact_1634_take__bit__of__Suc__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),aa(nat,nat,suc,zero_zero(nat))) = aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)) ) ).

% take_bit_of_Suc_0
tff(fact_1635_semiring__norm_I16_J,axiom,
    ! [M: num,Na: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,M)),aa(num,num,bit1,Na)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)),aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),times_times(num),M),Na)))) ) ).

% semiring_norm(16)
tff(fact_1636_semiring__norm_I74_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,M)),aa(num,num,bit0,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na) ) ).

% semiring_norm(74)
tff(fact_1637_semiring__norm_I79_J,axiom,
    ! [M: num,Na: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit0,M)),aa(num,num,bit1,Na))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na) ) ).

% semiring_norm(79)
tff(fact_1638_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)))
        <=> ( M != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_1639_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_1640_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_1641_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = A2 )
        <=> $ite(aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_1642_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,W: num] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) )
        <=> $ite(aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_1643_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A)))
        <=> ( M != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_1644_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_1645_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_1646_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ).

% of_nat_0_less_iff
tff(fact_1647_power2__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power2_minus
tff(fact_1648_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,X: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),X))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)),X) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
tff(fact_1649_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: nat,B2: nat,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
tff(fact_1650_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: nat,B2: nat,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
tff(fact_1651_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,X: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),X))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)),X) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
tff(fact_1652_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Y: nat,X: num,Na: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Y) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na) )
        <=> ( Y = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
tff(fact_1653_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [X: num,Na: nat,Y: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na) = aa(nat,A,semiring_1_of_nat(A),Y) )
        <=> ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na) = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
tff(fact_1654_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(num,real,numeral_numeral(real),W)),aa(nat,real,semiring_1_of_nat(real),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),W)),Na) ) ).

% numeral_less_real_of_nat_iff
tff(fact_1655_real__of__nat__less__numeral__iff,axiom,
    ! [Na: nat,W: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(num,real,numeral_numeral(real),W))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(num,nat,numeral_numeral(nat),W)) ) ).

% real_of_nat_less_numeral_iff
tff(fact_1656_numeral__le__real__of__nat__iff,axiom,
    ! [Na: num,M: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),Na)),aa(nat,real,semiring_1_of_nat(real),M))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Na)),M) ) ).

% numeral_le_real_of_nat_iff
tff(fact_1657_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),one_one(A)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)) ) ) ).

% take_bit_of_1
tff(fact_1658_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_1659_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_1660_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_1661_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% minus_1_div_2_eq
tff(fact_1662_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% minus_1_mod_2_eq
tff(fact_1663_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_1664_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),X)),Na))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X)
            | ( Na = zero_zero(nat) ) ) ) ) ).

% of_nat_zero_less_power_iff
tff(fact_1665_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ) ).

% Power.ring_1_class.power_minus_even
tff(fact_1666_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat,A2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ) ).

% power_minus_odd
tff(fact_1667_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) ) ) ) ).

% Parity.ring_1_class.power_minus_even
tff(fact_1668_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2))
        <=> ( ( Na = zero_zero(nat) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% even_take_bit_eq
tff(fact_1669_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Na)) ) ) ).

% diff_numeral_special(3)
tff(fact_1670_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_1671_div__Suc__eq__div__add3,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Na)))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Na)) ) ).

% div_Suc_eq_div_add3
tff(fact_1672_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M)))),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M)),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_div_eq_add3_div_numeral
tff(fact_1673_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,Na: nat] : ( modulo_modulo(nat,M,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Na)))) = modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Na)) ) ).

% mod_Suc_eq_mod_add3
tff(fact_1674_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),aa(num,nat,numeral_numeral(nat),V)) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_mod_eq_add3_mod_numeral
tff(fact_1675_signed__take__bit__Suc__minus__bit0,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Na)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_Suc_minus_bit0
tff(fact_1676_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% dbl_simps(4)
tff(fact_1677_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) = one_one(A) ) ) ).

% power_minus1_even
tff(fact_1678_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% neg_one_odd_power
tff(fact_1679_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na) = one_one(A) ) ) ) ).

% neg_one_even_power
tff(fact_1680_even__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,semiring_1_of_nat(A),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ) ).

% even_of_nat
tff(fact_1681_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,zero_zero(nat))),A2) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_0
tff(fact_1682_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I2: num,Na: nat,X: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I2)),Na)),aa(nat,A,semiring_1_of_nat(A),X))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I2)),Na)),X) ) ) ).

% numeral_power_less_of_nat_cancel_iff
tff(fact_1683_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: nat,I2: num,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I2)),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I2)),Na)) ) ) ).

% of_nat_less_numeral_power_cancel_iff
tff(fact_1684_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: nat,I2: num,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I2)),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I2)),Na)) ) ) ).

% of_nat_le_numeral_power_cancel_iff
tff(fact_1685_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I2: num,Na: nat,X: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I2)),Na)),aa(nat,A,semiring_1_of_nat(A),X))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I2)),Na)),X) ) ) ).

% numeral_power_le_of_nat_cancel_iff
tff(fact_1686_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,zero_zero(nat)),A2) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% signed_take_bit_0
tff(fact_1687_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = X ) ) ).

% real_sqrt_pow2
tff(fact_1688_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = X )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% real_sqrt_pow2_iff
tff(fact_1689_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] : ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Ya),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Ya),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% real_sqrt_sum_squares_mult_squared_eq
tff(fact_1690_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ) ).

% take_bit_of_exp
tff(fact_1691_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_of_2
tff(fact_1692_signed__take__bit__Suc__bit1,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Na)),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_bit1
tff(fact_1693_signed__take__bit__Suc__minus__bit1,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,Na)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_minus_bit1
tff(fact_1694_signed__take__bit__minus,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,uminus_uminus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),aa(int,int,uminus_uminus(int),K)) ) ).

% signed_take_bit_minus
tff(fact_1695_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ? [B4: A] : member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) ) ).

% psubset_imp_ex_mem
tff(fact_1696_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,uminus_uminus(A),B2) ) ) ) ).

% verit_negate_coefficient(3)
tff(fact_1697_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% equation_minus_iff
tff(fact_1698_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = B2 )
        <=> ( aa(A,A,uminus_uminus(A),B2) = A2 ) ) ) ).

% minus_equation_iff
tff(fact_1699_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,M: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M)) ) ) ).

% take_bit_of_nat
tff(fact_1700_concat__bit__eq__iff,axiom,
    ! [Na: nat,K: int,L: int,R2: int,S: int] :
      ( ( aa(int,int,bit_concat_bit(Na,K),L) = aa(int,int,bit_concat_bit(Na,R2),S) )
    <=> ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) = aa(int,int,bit_se2584673776208193580ke_bit(int,Na),R2) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
tff(fact_1701_concat__bit__take__bit__eq,axiom,
    ! [Na: nat,B2: int] : ( bit_concat_bit(Na,aa(int,int,bit_se2584673776208193580ke_bit(int,Na),B2)) = bit_concat_bit(Na,B2) ) ).

% concat_bit_take_bit_eq
tff(fact_1702_real__sqrt__minus,axiom,
    ! [X: real] : ( aa(real,real,sqrt,aa(real,real,uminus_uminus(real),X)) = aa(real,real,uminus_uminus(real),aa(real,real,sqrt,X)) ) ).

% real_sqrt_minus
tff(fact_1703_psubset__trans,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B3),C6)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C6) ) ) ).

% psubset_trans
tff(fact_1704_psubsetD,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ( member(A,C2,A3)
       => member(A,C2,B3) ) ) ).

% psubsetD
tff(fact_1705_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A,K: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,K))) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,K)))) ) ) ).

% power_minus_Bit1
tff(fact_1706_take__bit__add,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),B2))) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ).

% take_bit_add
tff(fact_1707_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A,M: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),B2) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,M),B2) ) ) ) ) ).

% take_bit_tightened
tff(fact_1708_take__bit__nat__less__eq__self,axiom,
    ! [Na: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M)),M) ).

% take_bit_nat_less_eq_self
tff(fact_1709_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,Na: nat,Q4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,M),Q4)),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),Q4)) ) ).

% take_bit_tightened_less_eq_nat
tff(fact_1710_real__sqrt__less__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y)) ) ).

% real_sqrt_less_mono
tff(fact_1711_real__sqrt__le__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y)) ) ).

% real_sqrt_le_mono
tff(fact_1712_real__sqrt__divide,axiom,
    ! [X: real,Y: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y)) ) ).

% real_sqrt_divide
tff(fact_1713_real__sqrt__mult,axiom,
    ! [X: real,Y: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y)) ) ).

% real_sqrt_mult
tff(fact_1714_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),X)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,semiring_1_of_nat(A),X)) ) ) ).

% mult_of_nat_commute
tff(fact_1715_real__sqrt__power,axiom,
    ! [X: real,K: nat] : ( aa(real,real,sqrt,aa(nat,real,aa(real,fun(nat,real),power_power(real),X),K)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,X)),K) ) ).

% real_sqrt_power
tff(fact_1716_take__bit__mult,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% take_bit_mult
tff(fact_1717_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% le_minus_iff
tff(fact_1718_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),A2) ) ) ).

% minus_le_iff
tff(fact_1719_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% le_imp_neg_le
tff(fact_1720_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),A2) ) ) ).

% minus_less_iff
tff(fact_1721_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% less_minus_iff
tff(fact_1722_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% verit_negate_coefficient(2)
tff(fact_1723_verit__eq__simplify_I14_J,axiom,
    ! [X2: num,X32: num] : ( aa(num,num,bit0,X2) != aa(num,num,bit1,X32) ) ).

% verit_eq_simplify(14)
tff(fact_1724_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] : ( one2 != aa(num,num,bit1,X32) ) ).

% verit_eq_simplify(12)
tff(fact_1725_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,Na: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) != aa(num,A,numeral_numeral(A),Na) ) ) ).

% neg_numeral_neq_numeral
tff(fact_1726_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,Na: num] : ( aa(num,A,numeral_numeral(A),M) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% numeral_neq_neg_numeral
tff(fact_1727_square__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),B2) )
        <=> ( ( A2 = B2 )
            | ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% square_eq_iff
tff(fact_1728_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_mult_commute
tff(fact_1729_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( one_one(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% one_neq_neg_one
tff(fact_1730_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% is_num_normalize(8)
tff(fact_1731_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% add.inverse_distrib_swap
tff(fact_1732_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,uminus_uminus(A),A2)) ) ) ) ).

% group_cancel.neg1
tff(fact_1733_take__bit__diff,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% take_bit_diff
tff(fact_1734_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),B2)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% minus_diff_commute
tff(fact_1735_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ).

% minus_diff_minus
tff(fact_1736_minus__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_divide_right
tff(fact_1737_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ).

% minus_divide_divide
tff(fact_1738_minus__divide__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% minus_divide_left
tff(fact_1739_div__minus__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% div_minus_right
tff(fact_1740_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,B2)),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) ) ) ).

% mod_minus_eq
tff(fact_1741_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,A5: A] :
          ( ( modulo_modulo(A,A2,B2) = modulo_modulo(A,A5,B2) )
         => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A5),B2) ) ) ) ).

% mod_minus_cong
tff(fact_1742_mod__minus__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,A2,aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2)) ) ) ).

% mod_minus_right
tff(fact_1743_uminus__int__code_I1_J,axiom,
    aa(int,int,uminus_uminus(int),zero_zero(int)) = zero_zero(int) ).

% uminus_int_code(1)
tff(fact_1744_uminus__dvd__conv_I2_J,axiom,
    ! [D2: int,T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),T2)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,uminus_uminus(int),T2)) ) ).

% uminus_dvd_conv(2)
tff(fact_1745_uminus__dvd__conv_I1_J,axiom,
    ! [D2: int,T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),T2)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,uminus_uminus(int),D2)),T2) ) ).

% uminus_dvd_conv(1)
tff(fact_1746_concat__bit__assoc,axiom,
    ! [Na: nat,K: int,M: nat,L: int,R2: int] : ( aa(int,int,bit_concat_bit(Na,K),aa(int,int,bit_concat_bit(M,L),R2)) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na),aa(int,int,bit_concat_bit(Na,K),L)),R2) ) ).

% concat_bit_assoc
tff(fact_1747_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sqrt,X)) ) ).

% real_sqrt_gt_zero
tff(fact_1748_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( ( aa(real,real,sqrt,X) = zero_zero(real) )
       => ( X = zero_zero(real) ) ) ) ).

% real_sqrt_eq_zero_cancel
tff(fact_1749_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,X)) ) ).

% real_sqrt_ge_zero
tff(fact_1750_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ).

% of_nat_0_le_iff
tff(fact_1751_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,sqrt,X)) ) ).

% real_sqrt_ge_one
tff(fact_1752_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),zero_zero(A)) ) ).

% of_nat_less_0_iff
tff(fact_1753_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Na)) != zero_zero(A) ) ) ).

% of_nat_neq_0
tff(fact_1754_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,M: nat,Na: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),M))),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% div_mult2_eq'
tff(fact_1755_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% less_imp_of_nat_less
tff(fact_1756_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ).

% of_nat_less_imp_less
tff(fact_1757_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,Na: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,M),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ).

% take_bit_tightened_less_eq_int
tff(fact_1758_of__nat__mono,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [I2: nat,J2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),I2)),aa(nat,A,semiring_1_of_nat(A),J2)) ) ) ).

% of_nat_mono
tff(fact_1759_take__bit__int__less__eq__self__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% take_bit_int_less_eq_self_iff
tff(fact_1760_take__bit__nonnegative,axiom,
    ! [Na: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ).

% take_bit_nonnegative
tff(fact_1761_not__take__bit__negative,axiom,
    ! [Na: nat,K: int] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),zero_zero(int)) ).

% not_take_bit_negative
tff(fact_1762_take__bit__int__greater__self__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% take_bit_int_greater_self_iff
tff(fact_1763_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A,B2: A] :
          ( ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2) = aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),B2) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),B2) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
tff(fact_1764_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2))
          = aa(A,A,$ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M),bit_se2584673776208193580ke_bit(A,Na),bit_ri4674362597316999326ke_bit(A,M)),A2) ) ) ).

% signed_take_bit_take_bit
tff(fact_1765_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),Na)) ) ).

% neg_numeral_le_numeral
tff(fact_1766_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) ) ).

% not_numeral_le_neg_numeral
tff(fact_1767_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Na: num] : ( zero_zero(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% zero_neq_neg_numeral
tff(fact_1768_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) ) ).

% not_numeral_less_neg_numeral
tff(fact_1769_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),Na)) ) ).

% neg_numeral_less_numeral
tff(fact_1770_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) ) ).

% le_minus_one_simps(2)
tff(fact_1771_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% le_minus_one_simps(4)
tff(fact_1772_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( zero_zero(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% zero_neq_neg_one
tff(fact_1773_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_1774_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_1775_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),A2) = B2 ) ) ) ).

% add.inverse_unique
tff(fact_1776_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),A2) = zero_zero(A) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_1777_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% add_eq_0_iff
tff(fact_1778_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X22: num] : ( Y != aa(num,num,bit0,X22) )
       => ~ ! [X33: num] : ( Y != aa(num,num,bit1,X33) ) ) ) ).

% num.exhaust
tff(fact_1779_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% less_minus_one_simps(4)
tff(fact_1780_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) ) ).

% less_minus_one_simps(2)
tff(fact_1781_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [W: num,X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,uminus_uminus(A),X)) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% numeral_times_minus_swap
tff(fact_1782_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% nonzero_minus_divide_right
tff(fact_1783_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) ) ) ) ).

% nonzero_minus_divide_divide
tff(fact_1784_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Na: num] : ( one_one(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% one_neq_neg_numeral
tff(fact_1785_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Na: num] : ( aa(num,A,numeral_numeral(A),Na) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% numeral_neq_neg_one
tff(fact_1786_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [X: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),X) = one_one(A) )
        <=> ( ( X = one_one(A) )
            | ( X = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_1787_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_1788_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% diff_conv_add_uminus
tff(fact_1789_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% group_cancel.sub2
tff(fact_1790_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
tff(fact_1791_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ) ).

% of_nat_dvd_iff
tff(fact_1792_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,M: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2),aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2))) ) ) ).

% take_bit_unset_bit_eq
tff(fact_1793_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,M: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2),aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2))) ) ) ).

% take_bit_set_bit_eq
tff(fact_1794_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,M: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),M),A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2),aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2))) ) ) ).

% take_bit_flip_bit_eq
tff(fact_1795_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% dvd_neg_div
tff(fact_1796_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) ) ) ) ).

% dvd_div_neg
tff(fact_1797_of__nat__mod,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,M,Na)) = modulo_modulo(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_mod
tff(fact_1798_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),U),U))),aa(real,real,aa(real,fun(real,real),times_times(real),X),X)) ).

% real_minus_mult_self_le
tff(fact_1799_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),Na) = one_one(int) )
     => ( ( M = one_one(int) )
        | ( M = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
tff(fact_1800_zmult__eq__1__iff,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),Na) = one_one(int) )
    <=> ( ( ( M = one_one(int) )
          & ( Na = one_one(int) ) )
        | ( ( M = aa(int,int,uminus_uminus(int),one_one(int)) )
          & ( Na = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ) ).

% zmult_eq_1_iff
tff(fact_1801_minus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),zero_zero(int)),L) = aa(int,int,uminus_uminus(int),L) ) ).

% minus_int_code(2)
tff(fact_1802_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus1_not_zero
tff(fact_1803_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,K,aa(int,int,uminus_uminus(int),L)) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus2_not_zero
tff(fact_1804_minus__real__def,axiom,
    ! [X: real,Y: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y) = aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,uminus_uminus(real),Y)) ) ).

% minus_real_def
tff(fact_1805_take__bit__Suc__minus__bit0,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Na)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% take_bit_Suc_minus_bit0
tff(fact_1806_Bernoulli__inequality,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),X))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X)),Na)) ) ).

% Bernoulli_inequality
tff(fact_1807_real__div__sqrt,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),X),aa(real,real,sqrt,X)) = aa(real,real,sqrt,X) ) ) ).

% real_div_sqrt
tff(fact_1808_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,X)),aa(real,real,sqrt,Y))) ) ) ).

% sqrt_add_le_add_sqrt
tff(fact_1809_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,M),A2) ) ) ) ).

% take_bit_signed_take_bit
tff(fact_1810_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),X),X)),aa(real,real,aa(real,fun(real,real),times_times(real),Y),Y)))) ).

% le_real_sqrt_sumsq
tff(fact_1811_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))),zero_zero(A)) ) ).

% neg_numeral_le_zero
tff(fact_1812_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) ) ).

% not_zero_le_neg_numeral
tff(fact_1813_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))),zero_zero(A)) ) ).

% neg_numeral_less_zero
tff(fact_1814_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) ) ).

% not_zero_less_neg_numeral
tff(fact_1815_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% le_minus_one_simps(3)
tff(fact_1816_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A)) ) ).

% le_minus_one_simps(1)
tff(fact_1817_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Na: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Na)),aa(num,A,numeral_numeral(A),Na))),one_one(A)) ) ) ).

% numeral_Bit1
tff(fact_1818_take__bit__decr__eq,axiom,
    ! [Na: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) != zero_zero(int) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),one_one(int)) ) ) ).

% take_bit_decr_eq
tff(fact_1819_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% less_minus_one_simps(3)
tff(fact_1820_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A)) ) ).

% less_minus_one_simps(1)
tff(fact_1821_of__nat__diff,axiom,
    ! [A: $tType] :
      ( semiring_1_cancel(A)
     => ! [Na: nat,M: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ) ).

% of_nat_diff
tff(fact_1822_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) ) ).

% not_one_le_neg_numeral
tff(fact_1823_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_numeral_le_neg_one
tff(fact_1824_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% neg_numeral_le_neg_one
tff(fact_1825_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M)) ) ).

% neg_one_le_numeral
tff(fact_1826_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) ) ).

% neg_numeral_le_one
tff(fact_1827_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) ) ).

% neg_numeral_less_one
tff(fact_1828_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M)) ) ).

% neg_one_less_numeral
tff(fact_1829_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_numeral_less_neg_one
tff(fact_1830_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) ) ).

% not_one_less_neg_numeral
tff(fact_1831_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_1832_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,uminus_uminus(A),B2),A2 = zero_zero(A)) ) ) ).

% eq_minus_divide_eq
tff(fact_1833_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)) = A2 )
        <=> $ite(C2 != zero_zero(A),aa(A,A,uminus_uminus(A),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),A2 = zero_zero(A)) ) ) ).

% minus_divide_eq_eq
tff(fact_1834_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = C2 )
          <=> ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_1835_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( C2 = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_1836_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_1837_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(2)
tff(fact_1838_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(1)
tff(fact_1839_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% uminus_numeral_One
tff(fact_1840_eval__nat__numeral_I3_J,axiom,
    ! [Na: num] : ( aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Na)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Na))) ) ).

% eval_nat_numeral(3)
tff(fact_1841_power__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% power_minus
tff(fact_1842_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q4: num,Na: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,M)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q4)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),Na),aa(num,A,numeral_numeral(A),Q4)) ) ) ) ).

% cong_exp_iff_simps(13)
tff(fact_1843_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q4: num,Na: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,M)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) ) ) ).

% cong_exp_iff_simps(12)
tff(fact_1844_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q4: num,Na: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,M)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) != modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) ) ) ).

% cong_exp_iff_simps(10)
tff(fact_1845_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A,K: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,K))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,K))) ) ) ).

% power_minus_Bit0
tff(fact_1846_reals__Archimedean3,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ! [Y3: real] :
        ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),X)) ) ).

% reals_Archimedean3
tff(fact_1847_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_Suc_bit1
tff(fact_1848_real__of__nat__div4,axiom,
    ! [Na: nat,X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),X))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,semiring_1_of_nat(real),X))) ).

% real_of_nat_div4
tff(fact_1849_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,suc,Na))),one_one(A)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_1850_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(A)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_1851_real__of__nat__div,axiom,
    ! [D2: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),Na)
     => ( aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),D2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,semiring_1_of_nat(real),D2)) ) ) ).

% real_of_nat_div
tff(fact_1852_real__0__less__add__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),X)),Y) ) ).

% real_0_less_add_iff
tff(fact_1853_real__add__less__0__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,uminus_uminus(real),X)) ) ).

% real_add_less_0_iff
tff(fact_1854_real__0__le__add__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),X)),Y) ) ).

% real_0_le_add_iff
tff(fact_1855_real__add__le__0__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,uminus_uminus(real),X)) ) ).

% real_add_le_0_iff
tff(fact_1856_psubsetE,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ~ ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ) ).

% psubsetE
tff(fact_1857_psubset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
        & ( A3 != B3 ) ) ) ).

% psubset_eq
tff(fact_1858_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% psubset_imp_subset
tff(fact_1859_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C6) ) ) ).

% psubset_subset_trans
tff(fact_1860_subset__not__subset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
        & ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ) ).

% subset_not_subset_eq
tff(fact_1861_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B3),C6)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C6) ) ) ).

% subset_psubset_trans
tff(fact_1862_subset__iff__psubset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
        | ( A3 = B3 ) ) ) ).

% subset_iff_psubset_eq
tff(fact_1863_double__diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3)) = A3 ) ) ) ).

% double_diff
tff(fact_1864_Diff__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),A3) ).

% Diff_subset
tff(fact_1865_Diff__mono,axiom,
    ! [A: $tType,A3: set(A),C6: set(A),D5: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),D5),B3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),D5)) ) ) ).

% Diff_mono
tff(fact_1866_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( modulo_modulo(int,aa(int,int,uminus_uminus(int),A2),B2)
      = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),modulo_modulo(int,A2,B2))) ) ).

% zmod_zminus1_eq_if
tff(fact_1867_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( modulo_modulo(int,A2,aa(int,int,uminus_uminus(int),B2))
      = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,A2,B2)),B2)) ) ).

% zmod_zminus2_eq_if
tff(fact_1868_sqrt2__less__2,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sqrt2_less_2
tff(fact_1869_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,M: nat,Na: nat] : ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),modulo_modulo(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)))),modulo_modulo(A,A2,aa(nat,A,semiring_1_of_nat(A),M))) ) ) ).

% mod_mult2_eq'
tff(fact_1870_take__bit__minus__small__eq,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,uminus_uminus(int),K)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),K) ) ) ) ).

% take_bit_minus_small_eq
tff(fact_1871_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(num,A,numeral_numeral(A),Na) ) ) ).

% numeral_Bit1_div_2
tff(fact_1872_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))) ) ) ) ).

% less_minus_divide_eq
tff(fact_1873_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)) ) ) ) ).

% minus_divide_less_eq
tff(fact_1874_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_1875_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_1876_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_1877_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_1878_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_1879_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2) = B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_1880_odd__numeral,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Na: num] : ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na))) ) ).

% odd_numeral
tff(fact_1881_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z))),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),Z) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_1882_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z))),B2)
          = $ite(Z = zero_zero(A),B2,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_1883_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num,Q4: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) != zero_zero(A) ) ) ).

% cong_exp_iff_simps(3)
tff(fact_1884_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z))),B2)
          = $ite(Z = zero_zero(A),aa(A,A,uminus_uminus(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_1885_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),Z)),B2)
          = $ite(Z = zero_zero(A),aa(A,A,uminus_uminus(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z))),Z)) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_1886_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,X: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Z))),Y) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),Z) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_1887_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)),A2) ) ) ).

% power3_eq_cube
tff(fact_1888_even__minus,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_minus
tff(fact_1889_numeral__3__eq__3,axiom,
    aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) = aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))) ).

% numeral_3_eq_3
tff(fact_1890_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [X: A,Y: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) )
        <=> ( ( X = Y )
            | ( X = aa(A,A,uminus_uminus(A),Y) ) ) ) ) ).

% power2_eq_iff
tff(fact_1891_Suc3__eq__add__3,axiom,
    ! [Na: nat] : ( aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,Na))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),Na) ) ).

% Suc3_eq_add_3
tff(fact_1892_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,M,Na)))),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% field_char_0_class.of_nat_div
tff(fact_1893_nat__less__real__le,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),Na)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),M)) ) ).

% nat_less_real_le
tff(fact_1894_nat__le__real__less,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),M)),one_one(real))) ) ).

% nat_le_real_less
tff(fact_1895_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),X)),aa(nat,real,semiring_1_of_nat(real),D2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),D2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),modulo_modulo(nat,X,D2))),aa(nat,real,semiring_1_of_nat(real),D2))) ) ).

% real_of_nat_div_aux
tff(fact_1896_verit__less__mono__div__int2,axiom,
    ! [A3: int,B3: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A3),B3)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,uminus_uminus(int),Na))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),B3),Na)),aa(int,int,aa(int,fun(int,int),divide_divide(int),A3),Na)) ) ) ).

% verit_less_mono_div_int2
tff(fact_1897_div__eq__minus1,axiom,
    ! [B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),B2) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ).

% div_eq_minus1
tff(fact_1898_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_1899_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ) ).

% take_bit_eq_mod
tff(fact_1900_take__bit__nat__eq__self,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M) = M ) ) ).

% take_bit_nat_eq_self
tff(fact_1901_take__bit__nat__less__exp,axiom,
    ! [Na: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ).

% take_bit_nat_less_exp
tff(fact_1902_take__bit__nat__eq__self__iff,axiom,
    ! [Na: nat,M: nat] :
      ( ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M) = M )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% take_bit_nat_eq_self_iff
tff(fact_1903_real__less__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,sqrt,Y)) ) ).

% real_less_rsqrt
tff(fact_1904_sqrt__le__D,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X)),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% sqrt_le_D
tff(fact_1905_real__le__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,sqrt,Y)) ) ).

% real_le_rsqrt
tff(fact_1906_num_Osize__gen_I3_J,axiom,
    ! [X32: num] : ( size_num(aa(num,num,bit1,X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(3)
tff(fact_1907_num_Osize_I6_J,axiom,
    ! [X32: num] : ( aa(num,nat,size_size(num),aa(num,num,bit1,X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(6)
tff(fact_1908_take__bit__nat__def,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M) = modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% take_bit_nat_def
tff(fact_1909_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ).

% of_nat_less_two_power
tff(fact_1910_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Na: nat,M: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
         => ( ( Na != zero_zero(nat) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Na))) ) ) ) ).

% inverse_of_nat_le
tff(fact_1911_take__bit__int__less__exp,axiom,
    ! [Na: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ).

% take_bit_int_less_exp
tff(fact_1912_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))) ) ) ) ).

% le_minus_divide_eq
tff(fact_1913_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)) ) ) ) ).

% minus_divide_le_eq
tff(fact_1914_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_1915_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_1916_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_1917_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_1918_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_1919_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_1920_take__bit__int__def,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) = modulo_modulo(int,K,aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% take_bit_int_def
tff(fact_1921_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q4: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,M)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q4)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(11)
tff(fact_1922_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q4: num,Na: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Q4))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),Na),aa(num,A,numeral_numeral(A),Q4)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(7)
tff(fact_1923_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( ( A2 = one_one(A) )
            | ( A2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_1924_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),C2)
       => ( ! [M4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M4)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M4)),X)),C2) )
         => ( X = zero_zero(real) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
tff(fact_1925_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na),aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na))) ) ) ).

% uminus_power_if
tff(fact_1926_Suc__div__eq__add3__div,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M)))),Na) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M)),Na) ) ).

% Suc_div_eq_add3_div
tff(fact_1927_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_1928_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,Na: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),Na) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M),Na) ) ).

% Suc_mod_eq_add3_mod
tff(fact_1929_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),U),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ).

% realpow_square_minus_le
tff(fact_1930_real__of__nat__div2,axiom,
    ! [Na: nat,X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,semiring_1_of_nat(real),X))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),X)))) ).

% real_of_nat_div2
tff(fact_1931_real__of__nat__div3,axiom,
    ! [Na: nat,X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,semiring_1_of_nat(real),X))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),X)))),one_one(real)) ).

% real_of_nat_div3
tff(fact_1932_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))),K) ) ).

% signed_take_bit_int_less_eq_self_iff
tff(fact_1933_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [Na: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)) ).

% signed_take_bit_int_greater_eq_minus_exp
tff(fact_1934_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))) ) ).

% signed_take_bit_int_greater_self_iff
tff(fact_1935_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = zero_zero(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),A2) ) ) ).

% take_bit_eq_0_iff
tff(fact_1936_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L)
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),one_one(int))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)),L)) ) ) ).

% minus_mod_int_eq
tff(fact_1937_zmod__minus1,axiom,
    ! [B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),B2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),one_one(int)) ) ) ).

% zmod_minus1
tff(fact_1938_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2 != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A2)),B2)
        = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))),one_one(int))) ) ) ).

% zdiv_zminus1_eq_if
tff(fact_1939_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2 != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),aa(int,int,uminus_uminus(int),B2))
        = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))),one_one(int))) ) ) ).

% zdiv_zminus2_eq_if
tff(fact_1940_take__bit__nat__less__self__iff,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),M)),M)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),M) ) ).

% take_bit_nat_less_self_iff
tff(fact_1941_real__le__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,X)),Y) ) ) ) ).

% real_le_lsqrt
tff(fact_1942_real__sqrt__unique,axiom,
    ! [Y: real,X: real] :
      ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = X )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,real,sqrt,X) = Y ) ) ) ).

% real_sqrt_unique
tff(fact_1943_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),U)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),U) ) ).

% lemma_real_divide_sqrt_less
tff(fact_1944_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) = X )
     => ( Y = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel
tff(fact_1945_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) = Y )
     => ( X = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
tff(fact_1946_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_sum_squares_ge1
tff(fact_1947_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_sum_squares_ge2
tff(fact_1948_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),C2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),D2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),C2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),D2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ).

% real_sqrt_sum_squares_triangle_ineq
tff(fact_1949_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% take_bit_int_greater_eq_self_iff
tff(fact_1950_take__bit__int__less__self__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),K) ) ).

% take_bit_int_less_self_iff
tff(fact_1951_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_1952_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_1953_square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)) ) ) ) ).

% square_le_1
tff(fact_1954_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ) ).

% minus_power_mult_self
tff(fact_1955_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na),one_one(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ).

% minus_one_power_iff
tff(fact_1956_linear__plus__1__le__power,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),X)),one_one(real))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),one_one(real))),Na)) ) ).

% linear_plus_1_le_power
tff(fact_1957_signed__take__bit__int__eq__self__iff,axiom,
    ! [Na: nat,K: int] :
      ( ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K) = K )
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ) ).

% signed_take_bit_int_eq_self_iff
tff(fact_1958_signed__take__bit__int__eq__self,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
       => ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K) = K ) ) ) ).

% signed_take_bit_int_eq_self
tff(fact_1959_minus__1__div__exp__eq__int,axiom,
    ! [Na: nat] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% minus_1_div_exp_eq_int
tff(fact_1960_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int))
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% div_pos_neg_trivial
tff(fact_1961_real__less__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,X)),Y) ) ) ) ).

% real_less_lsqrt
tff(fact_1962_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)) ) ) ).

% sqrt_sum_squares_le_sum
tff(fact_1963_sqrt__even__pow2,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(real,real,sqrt,aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),Na)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% sqrt_even_pow2
tff(fact_1964_take__bit__int__eq__self__iff,axiom,
    ! [Na: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) = K )
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ) ).

% take_bit_int_eq_self_iff
tff(fact_1965_take__bit__int__eq__self,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) = K ) ) ) ).

% take_bit_int_eq_self
tff(fact_1966_signed__take__bit__eq__take__bit__shift,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Na)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% signed_take_bit_eq_take_bit_shift
tff(fact_1967_take__bit__incr__eq,axiom,
    ! [Na: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),one_one(int)) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ) ).

% take_bit_incr_eq
tff(fact_1968_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% power_minus1_odd
tff(fact_1969_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% take_bit_Suc
tff(fact_1970_int__bit__induct,axiom,
    ! [P: fun(int,$o),K: int] :
      ( aa(int,$o,P,zero_zero(int))
     => ( aa(int,$o,P,aa(int,int,uminus_uminus(int),one_one(int)))
       => ( ! [K2: int] :
              ( aa(int,$o,P,K2)
             => ( ( K2 != zero_zero(int) )
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),times_times(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) ) )
         => ( ! [K2: int] :
                ( aa(int,$o,P,K2)
               => ( ( K2 != aa(int,int,uminus_uminus(int),one_one(int)) )
                 => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))) ) )
           => aa(int,$o,P,K) ) ) ) ) ).

% int_bit_induct
tff(fact_1971_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Ya),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ).

% real_sqrt_sum_squares_mult_ge_zero
tff(fact_1972_real__sqrt__power__even,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
       => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,X)),Na) = aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ) ).

% real_sqrt_power_even
tff(fact_1973_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X),Y))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% arith_geo_mean_sqrt
tff(fact_1974_take__bit__int__less__eq,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))) ) ) ).

% take_bit_int_less_eq
tff(fact_1975_take__bit__int__greater__eq,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ).

% take_bit_int_greater_eq
tff(fact_1976_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)
            = $ite(aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),zero_zero(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),one_one(A))) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_1977_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(nat,nat,suc,Na)))),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)) ) ).

% signed_take_bit_int_greater_eq
tff(fact_1978_arsinh__real__aux,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))))) ).

% arsinh_real_aux
tff(fact_1979_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = zero_zero(nat) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = one_one(nat) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) ) ) ).

% mod_exhaust_less_4
tff(fact_1980_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [E2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E2)
         => ~ ! [N: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N)))),E2) ) ) ).

% nat_approx_posE
tff(fact_1981_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% compl_less_compl_iff
tff(fact_1982_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_1983_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => ? [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),X)) ) ) ).

% ex_less_of_nat_mult
tff(fact_1984_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_minus_bit1
tff(fact_1985_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [H: A,Z: A,K5: real,Na: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),K5)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H))),K5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),Na))),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),K5),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),real_V7770717601297561774m_norm(A,H))) ) ) ) ) ).

% lemma_termdiff3
tff(fact_1986_DiffI,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,A3)
     => ( ~ member(A,C2,B3)
       => member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ) ).

% DiffI
tff(fact_1987_Diff__iff,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
    <=> ( member(A,C2,A3)
        & ~ member(A,C2,B3) ) ) ).

% Diff_iff
tff(fact_1988_Diff__idemp,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) ) ).

% Diff_idemp
tff(fact_1989_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = aa(num,int,numeral_numeral(int),V) )
    <=> ( M = aa(num,nat,numeral_numeral(nat),V) ) ) ).

% int_eq_iff_numeral
tff(fact_1990_negative__eq__positive,axiom,
    ! [Na: nat,M: nat] :
      ( ( aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Na)) = aa(nat,int,semiring_1_of_nat(int),M) )
    <=> ( ( Na = zero_zero(nat) )
        & ( M = zero_zero(nat) ) ) ) ).

% negative_eq_positive
tff(fact_1991_negative__zle,axiom,
    ! [Na: nat,M: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Na))),aa(nat,int,semiring_1_of_nat(int),M)) ).

% negative_zle
tff(fact_1992_int__dvd__int__iff,axiom,
    ! [M: nat,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ).

% int_dvd_int_iff
tff(fact_1993_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,one_one(A)) = one_one(A) ) ) ).

% dbl_dec_simps(3)
tff(fact_1994_negative__zless,axiom,
    ! [Na: nat,M: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Na)))),aa(nat,int,semiring_1_of_nat(int),M)) ).

% negative_zless
tff(fact_1995_pred__numeral__simps_I1_J,axiom,
    pred_numeral(one2) = zero_zero(nat) ).

% pred_numeral_simps(1)
tff(fact_1996_eq__numeral__Suc,axiom,
    ! [K: num,Na: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,Na) )
    <=> ( pred_numeral(K) = Na ) ) ).

% eq_numeral_Suc
tff(fact_1997_Suc__eq__numeral,axiom,
    ! [Na: nat,K: num] :
      ( ( aa(nat,nat,suc,Na) = aa(num,nat,numeral_numeral(nat),K) )
    <=> ( Na = pred_numeral(K) ) ) ).

% Suc_eq_numeral
tff(fact_1998_pred__numeral__simps_I3_J,axiom,
    ! [K: num] : ( pred_numeral(aa(num,num,bit1,K)) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,K)) ) ).

% pred_numeral_simps(3)
tff(fact_1999_less__numeral__Suc,axiom,
    ! [K: num,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pred_numeral(K)),Na) ) ).

% less_numeral_Suc
tff(fact_2000_less__Suc__numeral,axiom,
    ! [Na: nat,K: num] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),pred_numeral(K)) ) ).

% less_Suc_numeral
tff(fact_2001_le__numeral__Suc,axiom,
    ! [K: num,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),pred_numeral(K)),Na) ) ).

% le_numeral_Suc
tff(fact_2002_le__Suc__numeral,axiom,
    ! [Na: nat,K: num] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),pred_numeral(K)) ) ).

% le_Suc_numeral
tff(fact_2003_diff__numeral__Suc,axiom,
    ! [K: num,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),pred_numeral(K)),Na) ) ).

% diff_numeral_Suc
tff(fact_2004_diff__Suc__numeral,axiom,
    ! [Na: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),pred_numeral(K)) ) ).

% diff_Suc_numeral
tff(fact_2005_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_dec_simps(2)
tff(fact_2006_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_numeral_bit0
tff(fact_2007_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% signed_take_bit_numeral_minus_bit0
tff(fact_2008_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_bit1
tff(fact_2009_DiffE,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
     => ~ ( member(A,C2,A3)
         => member(A,C2,B3) ) ) ).

% DiffE
tff(fact_2010_DiffD1,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
     => member(A,C2,A3) ) ).

% DiffD1
tff(fact_2011_DiffD2,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
     => ~ member(A,C2,B3) ) ).

% DiffD2
tff(fact_2012_take__bit__minus,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,uminus_uminus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K))) = aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,uminus_uminus(int),K)) ) ).

% take_bit_minus
tff(fact_2013_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N) )
     => ~ ! [N: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) ) ) ).

% int_cases2
tff(fact_2014_int__of__nat__induct,axiom,
    ! [P: fun(int,$o),Z: int] :
      ( ! [N: nat] : aa(int,$o,P,aa(nat,int,semiring_1_of_nat(int),N))
     => ( ! [N: nat] : aa(int,$o,P,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))))
       => aa(int,$o,P,Z) ) ) ).

% int_of_nat_induct
tff(fact_2015_int__cases,axiom,
    ! [Z: int] :
      ( ! [N: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N) )
     => ~ ! [N: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))) ) ) ).

% int_cases
tff(fact_2016_not__int__zless__negative,axiom,
    ! [Na: nat,M: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),Na)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),M))) ).

% not_int_zless_negative
tff(fact_2017_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M4: nat,N: nat] : ( Z != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),M4)),aa(nat,int,semiring_1_of_nat(int),N)) ) ).

% int_diff_cases
tff(fact_2018_int__cases4,axiom,
    ! [M: int] :
      ( ! [N: nat] : ( M != aa(nat,int,semiring_1_of_nat(int),N) )
     => ~ ! [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( M != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) ) ) ) ).

% int_cases4
tff(fact_2019_int__ops_I1_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),zero_zero(nat)) = zero_zero(int) ).

% int_ops(1)
tff(fact_2020_int__ops_I3_J,axiom,
    ! [Na: num] : ( aa(nat,int,semiring_1_of_nat(int),aa(num,nat,numeral_numeral(nat),Na)) = aa(num,int,numeral_numeral(int),Na) ) ).

% int_ops(3)
tff(fact_2021_int__zle__neg,axiom,
    ! [Na: nat,M: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),Na)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),M)))
    <=> ( ( Na = zero_zero(nat) )
        & ( M = zero_zero(nat) ) ) ) ).

% int_zle_neg
tff(fact_2022_nat__int__comparison_I2_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% nat_int_comparison(2)
tff(fact_2023_zle__int,axiom,
    ! [M: nat,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% zle_int
tff(fact_2024_nat__int__comparison_I3_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% nat_int_comparison(3)
tff(fact_2025_nonneg__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ~ ! [N: nat] : ( K != aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% nonneg_int_cases
tff(fact_2026_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ? [N: nat] : ( K = aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% zero_le_imp_eq_int
tff(fact_2027_negative__zle__0,axiom,
    ! [Na: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Na))),zero_zero(int)) ).

% negative_zle_0
tff(fact_2028_nonpos__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ~ ! [N: nat] : ( K != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) ) ) ).

% nonpos_int_cases
tff(fact_2029_int__plus,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Na)),aa(nat,int,semiring_1_of_nat(int),M)) ) ).

% int_plus
tff(fact_2030_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(5)
tff(fact_2031_zadd__int__left,axiom,
    ! [M: nat,Na: nat,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Na)),Z)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))),Z) ) ).

% zadd_int_left
tff(fact_2032_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(7)
tff(fact_2033_int__ops_I2_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),one_one(nat)) = one_one(int) ).

% int_ops(2)
tff(fact_2034_zle__iff__zadd,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z)
    <=> ? [N4: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),N4)) ) ) ).

% zle_iff_zadd
tff(fact_2035_zdiv__int,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zdiv_int
tff(fact_2036_numeral__eq__Suc,axiom,
    ! [K: num] : ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,pred_numeral(K)) ) ).

% numeral_eq_Suc
tff(fact_2037_zmod__int,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,A2,B2)) = modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zmod_int
tff(fact_2038_int__cases3,axiom,
    ! [K: int] :
      ( ( K != zero_zero(int) )
     => ( ! [N: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) )
       => ~ ! [N: nat] :
              ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) )
             => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ) ).

% int_cases3
tff(fact_2039_not__zle__0__negative,axiom,
    ! [Na: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Na)))) ).

% not_zle_0_negative
tff(fact_2040_negative__zless__0,axiom,
    ! [Na: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Na)))),zero_zero(int)) ).

% negative_zless_0
tff(fact_2041_negD,axiom,
    ! [X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),zero_zero(int))
     => ? [N: nat] : ( X = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N))) ) ) ).

% negD
tff(fact_2042_int__ops_I4_J,axiom,
    ! [A2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,A2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),one_one(int)) ) ).

% int_ops(4)
tff(fact_2043_int__Suc,axiom,
    ! [Na: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,Na)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Na)),one_one(int)) ) ).

% int_Suc
tff(fact_2044_zless__iff__Suc__zadd,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
    <=> ? [N4: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N4))) ) ) ).

% zless_iff_Suc_zadd
tff(fact_2045_pred__numeral__def,axiom,
    ! [K: num] : ( pred_numeral(K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),one_one(nat)) ) ).

% pred_numeral_def
tff(fact_2046_pos__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ~ ! [N: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% pos_int_cases
tff(fact_2047_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ? [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
          & ( K = aa(nat,int,semiring_1_of_nat(int),N) ) ) ) ).

% zero_less_imp_eq_int
tff(fact_2048_neg__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => ~ ! [N: nat] :
            ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% neg_int_cases
tff(fact_2049_zmult__zless__mono2__lemma,axiom,
    ! [I2: int,J2: int,K: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),J2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),I2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),J2)) ) ) ).

% zmult_zless_mono2_lemma
tff(fact_2050_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))) ) ).

% int_ops(6)
tff(fact_2051_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X7: fun(A,B)] :
          ( ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),K6) )
        <=> ? [N5: nat] :
            ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% lemma_NBseq_def2
tff(fact_2052_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X7: fun(A,B)] :
          ( ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),K6) )
        <=> ? [N5: nat] :
            ! [N4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% lemma_NBseq_def
tff(fact_2053_zdiff__int__split,axiom,
    ! [P: fun(int,$o),X: nat,Y: nat] :
      ( aa(int,$o,P,aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Y)))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y),X)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X)),aa(nat,int,semiring_1_of_nat(int),Y))) )
        & ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y)
         => aa(int,$o,P,zero_zero(int)) ) ) ) ).

% zdiff_int_split
tff(fact_2054_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ).

% take_bit_numeral_minus_bit0
tff(fact_2055_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X: A] : ( neg_numeral_dbl_dec(A,X) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),X)),one_one(A)) ) ) ).

% dbl_dec_def
tff(fact_2056_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_2057_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),Y)),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),X)),Y) ) ) ).

% compl_less_swap2
tff(fact_2058_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),aa(A,A,uminus_uminus(A),X))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% compl_less_swap1
tff(fact_2059_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
        ? [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(nat,A,semiring_1_of_nat(A),N)) ) ).

% reals_Archimedean2
tff(fact_2060_exists__least__lemma,axiom,
    ! [P: fun(nat,$o)] :
      ( ~ aa(nat,$o,P,zero_zero(nat))
     => ( ? [X_12: nat] : aa(nat,$o,P,X_12)
       => ? [N: nat] :
            ( ~ aa(nat,$o,P,N)
            & aa(nat,$o,P,aa(nat,nat,suc,N)) ) ) ) ).

% exists_least_lemma
tff(fact_2061_eq__diff__eq_H,axiom,
    ! [X: real,Y: real,Z: real] :
      ( ( X = aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),Z) )
    <=> ( Y = aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Z) ) ) ).

% eq_diff_eq'
tff(fact_2062_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_numeral_bit1
tff(fact_2063_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A2)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_divide_numeral
tff(fact_2064_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [W: num,A2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),W)),real_V7770717601297561774m_norm(A,A2)) ) ) ).

% norm_mult_numeral1
tff(fact_2065_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A2)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_mult_numeral2
tff(fact_2066_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = aa(num,real,numeral_numeral(real),W) ) ) ).

% norm_neg_numeral
tff(fact_2067_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,X)),zero_zero(real))
        <=> ( X = zero_zero(A) ) ) ) ).

% norm_le_zero_iff
tff(fact_2068_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V7770717601297561774m_norm(A,X))
        <=> ( X != zero_zero(A) ) ) ) ).

% zero_less_norm_iff
tff(fact_2069_norm__numeral,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [W: num] : ( real_V7770717601297561774m_norm(A,aa(num,A,numeral_numeral(A),W)) = aa(num,real,numeral_numeral(real),W) ) ) ).

% norm_numeral
tff(fact_2070_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] :
          ( ( real_V7770717601297561774m_norm(A,X) = zero_zero(real) )
        <=> ( X = zero_zero(A) ) ) ) ).

% norm_eq_zero
tff(fact_2071_norm__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( real_V7770717601297561774m_norm(A,zero_zero(A)) = zero_zero(real) ) ) ).

% norm_zero
tff(fact_2072_norm__one,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ( real_V7770717601297561774m_norm(A,one_one(A)) = one_one(real) ) ) ).

% norm_one
tff(fact_2073_nat__int__comparison_I1_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = B2 )
    <=> ( aa(nat,int,semiring_1_of_nat(int),A2) = aa(nat,int,semiring_1_of_nat(int),B2) ) ) ).

% nat_int_comparison(1)
tff(fact_2074_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( aa(nat,int,semiring_1_of_nat(int),$ite((P),A2,B2))
      = $ite((P),aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_if
tff(fact_2075_int__int__eq,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = aa(nat,int,semiring_1_of_nat(int),Na) )
    <=> ( M = Na ) ) ).

% int_int_eq
tff(fact_2076_norm__minus__commute,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ).

% norm_minus_commute
tff(fact_2077_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),zero_zero(real)) ) ).

% norm_not_less_zero
tff(fact_2078_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),real_V7770717601297561774m_norm(A,X)) ) ).

% norm_ge_zero
tff(fact_2079_norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,B2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2)) ) ) ).

% norm_divide
tff(fact_2080_norm__power,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X: A,Na: nat] : ( real_V7770717601297561774m_norm(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(A,X)),Na) ) ) ).

% norm_power
tff(fact_2081_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X)),Y)) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) ) ) ).

% norm_uminus_minus
tff(fact_2082_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2)) ) ) ) ).

% nonzero_norm_divide
tff(fact_2083_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,Na: nat,Z: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),W),Na) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),Na) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => ( real_V7770717601297561774m_norm(A,W) = real_V7770717601297561774m_norm(A,Z) ) ) ) ) ).

% power_eq_imp_eq_norm
tff(fact_2084_norm__mult__less,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [X: A,R2: real,Y: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),R2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Y)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),Y))),aa(real,real,aa(real,fun(real,real),times_times(real),R2),S)) ) ) ) ).

% norm_mult_less
tff(fact_2085_norm__add__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,R2: real,Y: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),R2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Y)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R2),S)) ) ) ) ).

% norm_add_less
tff(fact_2086_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,Y))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),E2) ) ) ).

% norm_triangle_lt
tff(fact_2087_norm__add__leD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),C2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A2)),C2)) ) ) ).

% norm_add_leD
tff(fact_2088_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,Y))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),E2) ) ) ).

% norm_triangle_le
tff(fact_2089_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,Y))) ) ).

% norm_triangle_ineq
tff(fact_2090_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,R2: real,B2: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,A2)),R2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R2),S)) ) ) ) ).

% norm_triangle_mono
tff(fact_2091_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A,E1: real,Z: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y))),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z))),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% norm_diff_triangle_less
tff(fact_2092_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X: A,Na: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(A,X)),Na)) ) ).

% norm_power_ineq
tff(fact_2093_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,Y))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y))),E2) ) ) ).

% norm_triangle_le_diff
tff(fact_2094_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A,E1: real,Z: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y))),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z))),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% norm_diff_triangle_le
tff(fact_2095_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))) ) ).

% norm_triangle_ineq4
tff(fact_2096_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,X)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Y)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)))) ) ).

% norm_triangle_sub
tff(fact_2097_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))) ) ).

% norm_diff_ineq
tff(fact_2098_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% norm_triangle_ineq2
tff(fact_2099_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,Na: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),W),Na) = one_one(A) )
         => ( ( real_V7770717601297561774m_norm(A,W) = one_one(real) )
            | ( Na = zero_zero(nat) ) ) ) ) ).

% power_eq_1_iff
tff(fact_2100_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: A,D2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)))) ) ).

% norm_diff_triangle_ineq
tff(fact_2101_square__norm__one,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
         => ( real_V7770717601297561774m_norm(A,X) = one_one(real) ) ) ) ).

% square_norm_one
tff(fact_2102_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A,W: A,M: nat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),one_one(real))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,W)),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),W),M)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W)))) ) ) ) ).

% norm_power_diff
tff(fact_2103_arcosh__1,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arcosh(A),one_one(A)) = zero_zero(A) ) ) ).

% arcosh_1
tff(fact_2104_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% take_bit_numeral_minus_bit1
tff(fact_2105_artanh__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ( aa(A,A,artanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% artanh_0
tff(fact_2106_arsinh__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arsinh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% arsinh_0
tff(fact_2107_take__bit__Suc__minus__bit1,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Na)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),one_one(int)) ) ).

% take_bit_Suc_minus_bit1
tff(fact_2108_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_2109_pochhammer__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,Na: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))),comm_s3205402744901411588hammer(A,Z,Na))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Na)) ) ) ).

% pochhammer_double
tff(fact_2110_pochhammer__1,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,one_one(nat)) = A2 ) ) ).

% pochhammer_1
tff(fact_2111_pochhammer__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,zero_zero(nat)) = one_one(A) ) ) ).

% pochhammer_0
tff(fact_2112_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% pochhammer_Suc0
tff(fact_2113_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,zero_zero(A)) = one_one(A) ) ) ).

% dbl_inc_simps(2)
tff(fact_2114_pred__numeral__inc,axiom,
    ! [K: num] : ( pred_numeral(inc(K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% pred_numeral_inc
tff(fact_2115_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_inc_simps(4)
tff(fact_2116_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,K)) ) ) ).

% dbl_inc_simps(5)
tff(fact_2117_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_inc_simps(1)
tff(fact_2118_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_dec_simps(1)
tff(fact_2119_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(M))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_2120_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Na))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_2121_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),inc(M)) ) ) ).

% diff_numeral_special(6)
tff(fact_2122_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),Na)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Na))) ) ) ).

% diff_numeral_special(5)
tff(fact_2123_num__induct,axiom,
    ! [P: fun(num,$o),X: num] :
      ( aa(num,$o,P,one2)
     => ( ! [X3: num] :
            ( aa(num,$o,P,X3)
           => aa(num,$o,P,inc(X3)) )
       => aa(num,$o,P,X) ) ) ).

% num_induct
tff(fact_2124_add__inc,axiom,
    ! [X: num,Y: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),X),inc(Y)) = inc(aa(num,num,aa(num,fun(num,num),plus_plus(num),X),Y)) ) ).

% add_inc
tff(fact_2125_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),comm_s3205402744901411588hammer(A,X,Na)) ) ) ).

% pochhammer_pos
tff(fact_2126_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Na: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,Na) = zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
           => ( comm_s3205402744901411588hammer(A,A2,M) = zero_zero(A) ) ) ) ) ).

% pochhammer_eq_0_mono
tff(fact_2127_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,M: nat,Na: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,M) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
           => ( comm_s3205402744901411588hammer(A,A2,Na) != zero_zero(A) ) ) ) ) ).

% pochhammer_neq_0_mono
tff(fact_2128_inc_Osimps_I1_J,axiom,
    inc(one2) = aa(num,num,bit0,one2) ).

% inc.simps(1)
tff(fact_2129_inc_Osimps_I2_J,axiom,
    ! [X: num] : ( inc(aa(num,num,bit0,X)) = aa(num,num,bit1,X) ) ).

% inc.simps(2)
tff(fact_2130_inc_Osimps_I3_J,axiom,
    ! [X: num] : ( inc(aa(num,num,bit1,X)) = aa(num,num,bit0,inc(X)) ) ).

% inc.simps(3)
tff(fact_2131_add__One,axiom,
    ! [X: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),X),one2) = inc(X) ) ).

% add_One
tff(fact_2132_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [X: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),comm_s3205402744901411588hammer(A,X,Na)) ) ) ).

% pochhammer_nonneg
tff(fact_2133_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Na: nat] :
          ( comm_s3205402744901411588hammer(A,zero_zero(A),Na)
          = $ite(Na = zero_zero(nat),one_one(A),zero_zero(A)) ) ) ).

% pochhammer_0_left
tff(fact_2134_mult__inc,axiom,
    ! [X: num,Y: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),X),inc(Y)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),times_times(num),X),Y)),X) ) ).

% mult_inc
tff(fact_2135_numeral__inc,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X: num] : ( aa(num,A,numeral_numeral(A),inc(X)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) ) ) ).

% numeral_inc
tff(fact_2136_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),Na)) ) ) ).

% pochhammer_rec
tff(fact_2137_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X: A] : ( neg_numeral_dbl_inc(A,X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),X)),one_one(A)) ) ) ).

% dbl_inc_def
tff(fact_2138_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,Na: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),Na))),comm_s3205402744901411588hammer(A,Z,Na)) ) ) ).

% pochhammer_rec'
tff(fact_2139_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,A2,Na)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),Na))) ) ) ).

% pochhammer_Suc
tff(fact_2140_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Na: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,Na) = zero_zero(A) )
        <=> ? [K3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K3),Na)
              & ( A2 = aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K3)) ) ) ) ) ).

% pochhammer_eq_0_iff
tff(fact_2141_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [Na: nat,K: nat] :
          ( ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Na)),K) = zero_zero(A) )
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),K) ) ) ).

% pochhammer_of_nat_eq_0_iff
tff(fact_2142_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Na: nat,K: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),K)
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Na)),K) = zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
tff(fact_2143_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Na)),K) != zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
tff(fact_2144_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,Na: nat,M: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,Na)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),Na)),M)) ) ) ).

% pochhammer_product'
tff(fact_2145_pochhammer__product,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M: nat,Na: nat,Z: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( comm_s3205402744901411588hammer(A,Z,Na) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,M)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))) ) ) ) ).

% pochhammer_product
tff(fact_2146_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [R2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),R2),aa(nat,A,semiring_1_of_nat(A),K))),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),R2),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),R2),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),R2)),one_one(A)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_2147_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)) ) ) ).

% pochhammer_minus
tff(fact_2148_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K)) ) ) ).

% pochhammer_minus'
tff(fact_2149_artanh__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X: A] : ( aa(A,A,artanh(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),X)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% artanh_def
tff(fact_2150_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,uminus_uminus(real),X)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),X))) ) ) ).

% ln_one_minus_pos_lower_bound
tff(fact_2151_central__binomial__lower__bound,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))),Na)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Na)))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),Na))) ) ).

% central_binomial_lower_bound
tff(fact_2152_arctan__half,axiom,
    ! [X: real] : ( aa(real,real,arctan,X) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),X),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))))) ) ).

% arctan_half
tff(fact_2153_fact__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Na: nat] : ( semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na))),semiring_char_0_fact(A,Na)) ) ) ).

% fact_double
tff(fact_2154_mask__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: num] : ( bit_se2239418461657761734s_mask(A,aa(num,nat,numeral_numeral(nat),Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,pred_numeral(Na)))) ) ) ).

% mask_numeral
tff(fact_2155_mask__nat__positive__iff,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),bit_se2239418461657761734s_mask(nat,Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ).

% mask_nat_positive_iff
tff(fact_2156_arctan__zero__zero,axiom,
    aa(real,real,arctan,zero_zero(real)) = zero_zero(real) ).

% arctan_zero_zero
tff(fact_2157_arctan__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( aa(real,real,arctan,X) = zero_zero(real) )
    <=> ( X = zero_zero(real) ) ) ).

% arctan_eq_zero_iff
tff(fact_2158_ln__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,ln_ln(A),one_one(A)) = zero_zero(A) ) ) ).

% ln_one
tff(fact_2159_fact__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,zero_zero(nat)) = one_one(A) ) ) ).

% fact_0
tff(fact_2160_mask__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,zero_zero(nat)) = zero_zero(A) ) ) ).

% mask_0
tff(fact_2161_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] :
          ( ( bit_se2239418461657761734s_mask(A,Na) = zero_zero(A) )
        <=> ( Na = zero_zero(nat) ) ) ) ).

% mask_eq_0_iff
tff(fact_2162_fact__1,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,one_one(nat)) = one_one(A) ) ) ).

% fact_1
tff(fact_2163_ln__inj__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( ( aa(real,real,ln_ln(real),X) = aa(real,real,ln_ln(real),Y) )
        <=> ( X = Y ) ) ) ) ).

% ln_inj_iff
tff(fact_2164_ln__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X)),aa(real,real,ln_ln(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ) ).

% ln_less_cancel_iff
tff(fact_2165_arctan__less__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real)) ) ).

% arctan_less_zero_iff
tff(fact_2166_zero__less__arctan__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,arctan,X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X) ) ).

% zero_less_arctan_iff
tff(fact_2167_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arctan,X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% zero_le_arctan_iff
tff(fact_2168_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arctan,X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ).

% arctan_le_zero_iff
tff(fact_2169_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% fact_Suc_0
tff(fact_2170_fact__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] : ( semiring_char_0_fact(A,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Na))),semiring_char_0_fact(A,Na)) ) ) ).

% fact_Suc
tff(fact_2171_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% mask_Suc_0
tff(fact_2172_ln__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X)),aa(real,real,ln_ln(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ) ).

% ln_le_cancel_iff
tff(fact_2173_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( ( aa(real,real,ln_ln(real),X) = zero_zero(real) )
      <=> ( X = one_one(real) ) ) ) ).

% ln_eq_zero_iff
tff(fact_2174_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X) ) ) ).

% ln_gt_zero_iff
tff(fact_2175_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real)) ) ) ).

% ln_less_zero_iff
tff(fact_2176_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,uminus_uminus(A),one_one(A))) = bit_se2239418461657761734s_mask(A,Na) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_2177_fact__2,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% fact_2
tff(fact_2178_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X) ) ) ).

% ln_ge_zero_iff
tff(fact_2179_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real)) ) ) ).

% ln_le_zero_iff
tff(fact_2180_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),bit_se2239418461657761734s_mask(nat,Na)) = bit_se2239418461657761734s_mask(A,Na) ) ) ).

% of_nat_mask_eq
tff(fact_2181_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semiri3467727345109120633visors(A) )
     => ! [Na: nat] : ( semiring_char_0_fact(A,Na) != zero_zero(A) ) ) ).

% fact_nonzero
tff(fact_2182_arctan__less__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,X)),aa(real,real,arctan,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ).

% arctan_less_iff
tff(fact_2183_arctan__monotone,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,X)),aa(real,real,arctan,Y)) ) ).

% arctan_monotone
tff(fact_2184_less__eq__mask,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),bit_se2239418461657761734s_mask(nat,Na)) ).

% less_eq_mask
tff(fact_2185_ln__less__self,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X)),X) ) ).

% ln_less_self
tff(fact_2186_fact__less__mono__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,Na)) ) ) ).

% fact_less_mono_nat
tff(fact_2187_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),semiring_char_0_fact(A,Na)) ) ).

% fact_ge_zero
tff(fact_2188_fact__not__neg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),semiring_char_0_fact(A,Na)),zero_zero(A)) ) ).

% fact_not_neg
tff(fact_2189_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),semiring_char_0_fact(A,Na)) ) ).

% fact_gt_zero
tff(fact_2190_fact__ge__1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),semiring_char_0_fact(A,Na)) ) ).

% fact_ge_1
tff(fact_2191_fact__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,M: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),semiring_char_0_fact(A,Na)),semiring_char_0_fact(A,M)) ) ) ).

% fact_dvd
tff(fact_2192_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_semiring_1(A) )
     => ! [Na: nat] : ( semiring_char_0_fact(A,Na) = comm_s3205402744901411588hammer(A,one_one(A),Na) ) ) ).

% pochhammer_fact
tff(fact_2193_mask__nonnegative__int,axiom,
    ! [Na: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se2239418461657761734s_mask(int,Na)) ).

% mask_nonnegative_int
tff(fact_2194_not__mask__negative__int,axiom,
    ! [Na: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se2239418461657761734s_mask(int,Na)),zero_zero(int)) ).

% not_mask_negative_int
tff(fact_2195_ln__bound,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X)),X) ) ).

% ln_bound
tff(fact_2196_ln__gt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X)) ) ).

% ln_gt_zero
tff(fact_2197_ln__less__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),X)),zero_zero(real)) ) ) ).

% ln_less_zero
tff(fact_2198_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),X))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X) ) ) ).

% ln_gt_zero_imp_gt_one
tff(fact_2199_ln__ge__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X)) ) ).

% ln_ge_zero
tff(fact_2200_fact__ge__Suc__0__nat,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),semiring_char_0_fact(nat,Na)) ).

% fact_ge_Suc_0_nat
tff(fact_2201_dvd__fact,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),semiring_char_0_fact(nat,Na)) ) ) ).

% dvd_fact
tff(fact_2202_fact__less__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),semiring_char_0_fact(A,M)),semiring_char_0_fact(A,Na)) ) ) ) ).

% fact_less_mono
tff(fact_2203_fact__mod,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom(A)
        & semidom_modulo(A) )
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( modulo_modulo(A,semiring_char_0_fact(A,Na),semiring_char_0_fact(A,M)) = zero_zero(A) ) ) ) ).

% fact_mod
tff(fact_2204_fact__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),semiring_char_0_fact(A,Na)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Na),Na))) ) ).

% fact_le_power
tff(fact_2205_less__mask,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),bit_se2239418461657761734s_mask(nat,Na)) ) ).

% less_mask
tff(fact_2206_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),X))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X) ) ) ).

% ln_ge_zero_imp_ge_one
tff(fact_2207_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X))),X) ) ).

% ln_add_one_self_le_self
tff(fact_2208_ln__mult,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),times_times(real),X),Y)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,ln_ln(real),X)),aa(real,real,ln_ln(real),Y)) ) ) ) ).

% ln_mult
tff(fact_2209_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( ( aa(real,real,ln_ln(real),X) = aa(real,real,aa(real,fun(real,real),minus_minus(real),X),one_one(real)) )
       => ( X = one_one(real) ) ) ) ).

% ln_eq_minus_one
tff(fact_2210_ln__div,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),X)),aa(real,real,ln_ln(real),Y)) ) ) ) ).

% ln_div
tff(fact_2211_fact__diff__Suc,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,suc,M))
     => ( semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),Na)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na))) ) ) ).

% fact_diff_Suc
tff(fact_2212_fact__div__fact__le__pow,axiom,
    ! [R2: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R2),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,Na)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),R2)))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Na),R2)) ) ).

% fact_div_fact_le_pow
tff(fact_2213_fact__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: num] : ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),semiring_char_0_fact(A,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_2214_binomial__mono,axiom,
    ! [K: nat,K7: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K7)),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,binomial(Na),K7)) ) ) ).

% binomial_mono
tff(fact_2215_binomial__maximum_H,axiom,
    ! [Na: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),Na)) ).

% binomial_maximum'
tff(fact_2216_ln__2__less__1,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),one_one(real)) ).

% ln_2_less_1
tff(fact_2217_binomial__maximum,axiom,
    ! [Na: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,binomial(Na),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ).

% binomial_maximum
tff(fact_2218_binomial__antimono,axiom,
    ! [K: nat,K7: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),K)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K7),Na)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Na),K7)),aa(nat,nat,binomial(Na),K)) ) ) ) ).

% binomial_antimono
tff(fact_2219_ln__le__minus__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X)),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),one_one(real))) ) ).

% ln_le_minus_one
tff(fact_2220_ln__diff__le,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),X)),aa(real,real,ln_ln(real),Y))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y)),Y)) ) ) ).

% ln_diff_le
tff(fact_2221_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X))),X) ) ).

% ln_add_one_self_le_self2
tff(fact_2222_ln__realpow,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,ln_ln(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,ln_ln(real),X)) ) ) ).

% ln_realpow
tff(fact_2223_take__bit__eq__mask__iff,axiom,
    ! [Na: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) = bit_se2239418461657761734s_mask(int,Na) )
    <=> ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = zero_zero(int) ) ) ).

% take_bit_eq_mask_iff
tff(fact_2224_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K7)),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,binomial(Na),K7)) ) ) ).

% binomial_strict_mono
tff(fact_2225_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),K7)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K7),Na)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(Na),K7)),aa(nat,nat,binomial(Na),K)) ) ) ) ).

% binomial_strict_antimono
tff(fact_2226_binomial__less__binomial__Suc,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,binomial(Na),aa(nat,nat,suc,K))) ) ).

% binomial_less_binomial_Suc
tff(fact_2227_central__binomial__odd,axiom,
    ! [Na: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(nat,nat,binomial(Na),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) = aa(nat,nat,binomial(Na),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% central_binomial_odd
tff(fact_2228_square__fact__le__2__fact,axiom,
    ! [Na: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),semiring_char_0_fact(real,Na)),semiring_char_0_fact(real,Na))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ).

% square_fact_le_2_fact
tff(fact_2229_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),X))),aa(real,real,uminus_uminus(real),X)) ) ) ).

% ln_one_minus_pos_upper_bound
tff(fact_2230_Suc__mask__eq__exp,axiom,
    ! [Na: nat] : ( aa(nat,nat,suc,bit_se2239418461657761734s_mask(nat,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ).

% Suc_mask_eq_exp
tff(fact_2231_mask__nat__less__exp,axiom,
    ! [Na: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),bit_se2239418461657761734s_mask(nat,Na)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ).

% mask_nat_less_exp
tff(fact_2232_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat] :
          ( semiring_char_0_fact(A,M)
          = $ite(M = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))) ) ) ).

% fact_num_eq_if
tff(fact_2233_fact__reduce,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( semiring_char_0_fact(A,Na) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_2234_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_ring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [Na: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Na)),Na) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),semiring_char_0_fact(A,Na)) ) ) ).

% pochhammer_same
tff(fact_2235_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,Na))
        <=> ( Na = zero_zero(nat) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
tff(fact_2236_ln__sqrt,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,ln_ln(real),aa(real,real,sqrt,X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),X)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% ln_sqrt
tff(fact_2237_arsinh__real__def,axiom,
    ! [X: real] : ( aa(real,real,arsinh(real),X) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))))) ) ).

% arsinh_real_def
tff(fact_2238_mask__half__int,axiom,
    ! [Na: nat] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),bit_se2239418461657761734s_mask(int,Na)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = bit_se2239418461657761734s_mask(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) ) ).

% mask_half_int
tff(fact_2239_mask__nat__def,axiom,
    ! [Na: nat] : ( bit_se2239418461657761734s_mask(nat,Na) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),one_one(nat)) ) ).

% mask_nat_def
tff(fact_2240_mask__int__def,axiom,
    ! [Na: nat] : ( bit_se2239418461657761734s_mask(int,Na) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),one_one(int)) ) ).

% mask_int_def
tff(fact_2241_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( bit_se2239418461657761734s_mask(A,Na) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),one_one(A)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_2242_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X))) ) ) ).

% ln_one_plus_pos_lower_bound
tff(fact_2243_arcosh__real__def,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
     => ( aa(real,real,arcosh(real),X) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))))) ) ) ).

% arcosh_real_def
tff(fact_2244_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [Na: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K) = bit_se2239418461657761734s_mask(int,Na) )
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) ) ).

% take_bit_eq_mask_iff_exp_dvd
tff(fact_2245_zero__less__binomial__iff,axiom,
    ! [Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(Na),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na) ) ).

% zero_less_binomial_iff
tff(fact_2246_choose__two,axiom,
    ! [Na: nat] : ( aa(nat,nat,binomial(Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% choose_two
tff(fact_2247_binomial__n__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,binomial(Na),zero_zero(nat)) = one_one(nat) ) ).

% binomial_n_0
tff(fact_2248_binomial__Suc__Suc,axiom,
    ! [Na: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,Na)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,binomial(Na),aa(nat,nat,suc,K))) ) ).

% binomial_Suc_Suc
tff(fact_2249_binomial__eq__0__iff,axiom,
    ! [Na: nat,K: nat] :
      ( ( aa(nat,nat,binomial(Na),K) = zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),K) ) ).

% binomial_eq_0_iff
tff(fact_2250_binomial__0__Suc,axiom,
    ! [K: nat] : ( aa(nat,nat,binomial(zero_zero(nat)),aa(nat,nat,suc,K)) = zero_zero(nat) ) ).

% binomial_0_Suc
tff(fact_2251_binomial__1,axiom,
    ! [Na: nat] : ( aa(nat,nat,binomial(Na),aa(nat,nat,suc,zero_zero(nat))) = Na ) ).

% binomial_1
tff(fact_2252_binomial__Suc__n,axiom,
    ! [Na: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,Na)),Na) = aa(nat,nat,suc,Na) ) ).

% binomial_Suc_n
tff(fact_2253_binomial__n__n,axiom,
    ! [Na: nat] : ( aa(nat,nat,binomial(Na),Na) = one_one(nat) ) ).

% binomial_n_n
tff(fact_2254_choose__one,axiom,
    ! [Na: nat] : ( aa(nat,nat,binomial(Na),one_one(nat)) = Na ) ).

% choose_one
tff(fact_2255_binomial__eq__0,axiom,
    ! [Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),K)
     => ( aa(nat,nat,binomial(Na),K) = zero_zero(nat) ) ) ).

% binomial_eq_0
tff(fact_2256_Suc__times__binomial,axiom,
    ! [K: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(aa(nat,nat,suc,Na)),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Na)),aa(nat,nat,binomial(Na),K)) ) ).

% Suc_times_binomial
tff(fact_2257_Suc__times__binomial__eq,axiom,
    ! [Na: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Na)),aa(nat,nat,binomial(Na),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,suc,Na)),aa(nat,nat,suc,K))),aa(nat,nat,suc,K)) ) ).

% Suc_times_binomial_eq
tff(fact_2258_binomial__symmetric,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
     => ( aa(nat,nat,binomial(Na),K) = aa(nat,nat,binomial(Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)) ) ) ).

% binomial_symmetric
tff(fact_2259_choose__mult__lemma,axiom,
    ! [M: nat,R2: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R2)),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R2)),K)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R2)),M)) ) ).

% choose_mult_lemma
tff(fact_2260_binomial__le__pow,axiom,
    ! [R2: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R2),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Na),R2)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Na),R2)) ) ).

% binomial_le_pow
tff(fact_2261_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,Na: nat] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,Na))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),Na))) ) ).

% fact_fact_dvd_fact
tff(fact_2262_zero__less__binomial,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(Na),K)) ) ).

% zero_less_binomial
tff(fact_2263_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,A2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),aa(nat,nat,suc,A2))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,B2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),A2)) ) ).

% Suc_times_binomial_add
tff(fact_2264_choose__mult,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Na),M)),aa(nat,nat,binomial(M),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K))) ) ) ) ).

% choose_mult
tff(fact_2265_binomial__fact__lemma,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)))),aa(nat,nat,binomial(Na),K)) = semiring_char_0_fact(nat,Na) ) ) ).

% binomial_fact_lemma
tff(fact_2266_binomial__Suc__Suc__eq__times,axiom,
    ! [Na: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,Na)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Na)),aa(nat,nat,binomial(Na),K))),aa(nat,nat,suc,K)) ) ).

% binomial_Suc_Suc_eq_times
tff(fact_2267_binomial__absorb__comp,axiom,
    ! [Na: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)),aa(nat,nat,binomial(Na),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),K)) ) ).

% binomial_absorb_comp
tff(fact_2268_choose__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)))),semiring_char_0_fact(A,Na)) ) ) ).

% choose_dvd
tff(fact_2269_binomial__absorption,axiom,
    ! [K: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(Na),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),K)) ) ).

% binomial_absorption
tff(fact_2270_binomial__altdef__nat,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
     => ( aa(nat,nat,binomial(Na),K) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,Na)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)))) ) ) ).

% binomial_altdef_nat
tff(fact_2271_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Na),K))) ) ) ).

% binomial_ge_n_over_k_pow_k
tff(fact_2272_binomial__le__pow2,axiom,
    ! [Na: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(Na),K)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ).

% binomial_le_pow2
tff(fact_2273_choose__reduce__nat,axiom,
    ! [Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( aa(nat,nat,binomial(Na),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),K)) ) ) ) ).

% choose_reduce_nat
tff(fact_2274_times__binomial__minus1__eq,axiom,
    ! [K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,binomial(Na),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ).

% times_binomial_minus1_eq
tff(fact_2275_binomial__addition__formula,axiom,
    ! [Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,binomial(Na),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(nat,nat,suc,K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),K)) ) ) ).

% binomial_addition_formula
tff(fact_2276_fact__binomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Na),K))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,Na)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K))) ) ) ) ).

% fact_binomial
tff(fact_2277_binomial__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Na),K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),semiring_char_0_fact(A,Na)),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)))) ) ) ) ).

% binomial_fact
tff(fact_2278_sin__coeff__def,axiom,
    ! [X4: nat] :
      ( sin_coeff(X4)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X4),zero_zero(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X4),aa(nat,nat,suc,zero_zero(nat)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),semiring_char_0_fact(real,X4))) ) ).

% sin_coeff_def
tff(fact_2279_binomial__code,axiom,
    ! [Na: nat,K: nat] :
      ( aa(nat,nat,binomial(Na),K)
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),K),
          zero_zero(nat),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)),aa(nat,nat,binomial(Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)),one_one(nat)),Na,one_one(nat))),semiring_char_0_fact(nat,K))) ) ) ).

% binomial_code
tff(fact_2280_cos__coeff__def,axiom,
    ! [X4: nat] :
      ( cos_coeff(X4)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),X4),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X4),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),semiring_char_0_fact(real,X4)),zero_zero(real)) ) ).

% cos_coeff_def
tff(fact_2281_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X))),X))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
tff(fact_2282_tanh__ln__real,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,tanh(real),aa(real,real,ln_ln(real),X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real))) ) ) ).

% tanh_ln_real
tff(fact_2283_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X))),X))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% abs_ln_one_plus_x_minus_x_bound
tff(fact_2284_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_idempotent
tff(fact_2285_abs__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_abs
tff(fact_2286_abs__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_zero
tff(fact_2287_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_eq_0
tff(fact_2288_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,abs_abs(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_0_eq
tff(fact_2289_abs__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_0
tff(fact_2290_abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num] : ( aa(A,A,abs_abs(A),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),Na) ) ) ).

% abs_numeral
tff(fact_2291_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),A2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) ) ) ).

% abs_mult_self_eq
tff(fact_2292_abs__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_1
tff(fact_2293_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_add_abs
tff(fact_2294_abs__divide,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_divide
tff(fact_2295_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_minus_cancel
tff(fact_2296_abs__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_minus
tff(fact_2297_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),aa(A,A,abs_abs(A),K))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),K) ) ) ).

% dvd_abs_iff
tff(fact_2298_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,abs_abs(A),M)),K)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),K) ) ) ).

% abs_dvd_iff
tff(fact_2299_abs__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,semiring_1_of_nat(A),Na)) = aa(nat,A,semiring_1_of_nat(A),Na) ) ) ).

% abs_of_nat
tff(fact_2300_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: $o] : ( aa(A,A,abs_abs(A),aa($o,A,zero_neq_one_of_bool(A),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% abs_bool_eq
tff(fact_2301_tanh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tanh_0
tff(fact_2302_tanh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( aa(real,real,tanh(real),X) = zero_zero(real) )
    <=> ( X = zero_zero(real) ) ) ).

% tanh_real_zero_iff
tff(fact_2303_tanh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),X)),aa(real,real,tanh(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ).

% tanh_real_less_iff
tff(fact_2304_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),zero_zero(A))
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_le_zero_iff
tff(fact_2305_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% abs_le_self_iff
tff(fact_2306_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,A,abs_abs(A),A2) = A2 ) ) ) ).

% abs_of_nonneg
tff(fact_2307_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,abs_abs(A),A2))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% zero_less_abs_iff
tff(fact_2308_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(num,A,numeral_numeral(A),Na) ) ) ).

% abs_neg_numeral
tff(fact_2309_abs__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),one_one(A))) = one_one(A) ) ) ).

% abs_neg_one
tff(fact_2310_abs__power__minus,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),Na)) = aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% abs_power_minus
tff(fact_2311_real__sqrt__abs2,axiom,
    ! [X: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),X),X)) = aa(real,real,abs_abs(real),X) ) ).

% real_sqrt_abs2
tff(fact_2312_real__sqrt__mult__self,axiom,
    ! [A2: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,A2)),aa(real,real,sqrt,A2)) = aa(real,real,abs_abs(real),A2) ) ).

% real_sqrt_mult_self
tff(fact_2313_tanh__real__neg__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real)) ) ).

% tanh_real_neg_iff
tff(fact_2314_tanh__real__pos__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,tanh(real),X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X) ) ).

% tanh_real_pos_iff
tff(fact_2315_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tanh(real),X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ).

% tanh_real_nonpos_iff
tff(fact_2316_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,tanh(real),X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% tanh_real_nonneg_iff
tff(fact_2317_sin__coeff__0,axiom,
    sin_coeff(zero_zero(nat)) = zero_zero(real) ).

% sin_coeff_0
tff(fact_2318_cos__coeff__0,axiom,
    cos_coeff(zero_zero(nat)) = one_one(real) ).

% cos_coeff_0
tff(fact_2319_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,abs_abs(A),B2))),zero_zero(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_le_0_abs_iff
tff(fact_2320_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,abs_abs(A),B2)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            | ( B2 = zero_zero(A) ) ) ) ) ).

% zero_le_divide_abs_iff
tff(fact_2321_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,A,abs_abs(A),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% abs_of_nonpos
tff(fact_2322_artanh__minus__real,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,real,artanh(real),aa(real,real,uminus_uminus(real),X)) = aa(real,real,uminus_uminus(real),aa(real,real,artanh(real),X)) ) ) ).

% artanh_minus_real
tff(fact_2323_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),Na))
        <=> ( ( A2 != zero_zero(A) )
            | ( Na = zero_zero(nat) ) ) ) ) ).

% zero_less_power_abs_iff
tff(fact_2324_abs__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% abs_power2
tff(fact_2325_power2__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% power2_abs
tff(fact_2326_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: num,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),W))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),aa(num,nat,numeral_numeral(nat),W)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W)) ) ) ) ).

% power_even_abs_numeral
tff(fact_2327_real__sqrt__abs,axiom,
    ! [X: real] : ( aa(real,real,sqrt,aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(real,real,abs_abs(real),X) ) ).

% real_sqrt_abs
tff(fact_2328_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% abs_le_D1
tff(fact_2329_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_self
tff(fact_2330_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_eq_0_iff
tff(fact_2331_abs__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_mult
tff(fact_2332_abs__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_one
tff(fact_2333_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ).

% abs_minus_commute
tff(fact_2334_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,abs_abs(A),X) = aa(A,A,abs_abs(A),Y) )
        <=> ( ( X = Y )
            | ( X = aa(A,A,uminus_uminus(A),Y) ) ) ) ) ).

% abs_eq_iff
tff(fact_2335_power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),Na) ) ) ).

% power_abs
tff(fact_2336_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [L: A,K: A] :
          ( ( aa(A,A,abs_abs(A),L) = aa(A,A,abs_abs(A),K) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),L),K) ) ) ).

% dvd_if_abs_eq
tff(fact_2337_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_zero
tff(fact_2338_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),zero_zero(A)) ) ).

% abs_not_less_zero
tff(fact_2339_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,A,abs_abs(A),A2) = A2 ) ) ) ).

% abs_of_pos
tff(fact_2340_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) ) ).

% abs_triangle_ineq
tff(fact_2341_abs__mult__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),B2)),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2)) ) ) ) ).

% abs_mult_less
tff(fact_2342_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% abs_triangle_ineq2
tff(fact_2343_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% abs_triangle_ineq3
tff(fact_2344_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2345_abs__leI,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2) ) ) ) ).

% abs_leI
tff(fact_2346_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% abs_le_D2
tff(fact_2347_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ) ).

% abs_le_iff
tff(fact_2348_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_minus_self
tff(fact_2349_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% nonzero_abs_divide
tff(fact_2350_abs__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ) ).

% abs_less_iff
tff(fact_2351_sin__coeff__Suc,axiom,
    ! [Na: nat] : ( sin_coeff(aa(nat,nat,suc,Na)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),cos_coeff(Na)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Na))) ) ).

% sin_coeff_Suc
tff(fact_2352_tanh__real__lt__1,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),X)),one_one(real)) ).

% tanh_real_lt_1
tff(fact_2353_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs(A)
        & dense_linorder(A) )
     => ! [X: A] :
          ( ! [E: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X)),E) )
         => ( X = zero_zero(A) ) ) ) ).

% dense_eq0_I
tff(fact_2354_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),Y)),X) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),X)) ) ) ) ).

% abs_mult_pos
tff(fact_2355_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ordered_ring_abs(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
              | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% abs_eq_mult
tff(fact_2356_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,abs_abs(A),A2))),zero_zero(A)) ) ).

% abs_minus_le_zero
tff(fact_2357_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = B2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
            & ( ( A2 = B2 )
              | ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ) ).

% abs_eq_iff'
tff(fact_2358_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,abs_abs(A),B2) )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            & ( ( B2 = A2 )
              | ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ) ) ).

% eq_abs_iff'
tff(fact_2359_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),Na)) ) ).

% zero_le_power_abs
tff(fact_2360_abs__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,abs_abs(A),X)),Y) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y)) ) ) ) ).

% abs_div_pos
tff(fact_2361_abs__if__raw,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [X4: A] :
          ( aa(A,A,abs_abs(A),X4)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),zero_zero(A)),aa(A,A,uminus_uminus(A),X4),X4) ) ) ).

% abs_if_raw
tff(fact_2362_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,A,abs_abs(A),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% abs_of_neg
tff(fact_2363_abs__if,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [A2: A] :
          ( aa(A,A,abs_abs(A),A2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)),aa(A,A,uminus_uminus(A),A2),A2) ) ) ).

% abs_if
tff(fact_2364_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) ) ).

% abs_triangle_ineq4
tff(fact_2365_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A,C2: A,D2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)))) ) ).

% abs_diff_triangle_ineq
tff(fact_2366_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,A2: A,R2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),R2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),R2)),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),R2)) ) ) ) ).

% abs_diff_le_iff
tff(fact_2367_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,A2: A,R2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),R2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),R2)),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),R2)) ) ) ) ).

% abs_diff_less_iff
tff(fact_2368_abs__real__def,axiom,
    ! [A2: real] :
      ( aa(real,real,abs_abs(real),A2)
      = $ite(aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real)),aa(real,real,uminus_uminus(real),A2),A2) ) ).

% abs_real_def
tff(fact_2369_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [Y3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y3))),D4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),B2) ) ) ) ) ) ).

% lemma_interval_lt
tff(fact_2370_sin__bound__lemma,axiom,
    ! [X: real,Y: real,U: real,V: real] :
      ( ( X = Y )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),U)),V)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),U)),Y))),V) ) ) ).

% sin_bound_lemma
tff(fact_2371_cos__coeff__Suc,axiom,
    ! [Na: nat] : ( cos_coeff(aa(nat,nat,suc,Na)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),sin_coeff(Na))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Na))) ) ).

% cos_coeff_Suc
tff(fact_2372_tanh__real__gt__neg1,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(real,real,tanh(real),X)) ).

% tanh_real_gt_neg1
tff(fact_2373_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,abs_abs(A),X))) ) ).

% abs_add_one_gt_zero
tff(fact_2374_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [Y3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y3))),D4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),B2) ) ) ) ) ) ).

% lemma_interval
tff(fact_2375_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2)))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% norm_triangle_ineq3
tff(fact_2376_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X)),aa(A,A,abs_abs(A),Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% abs_le_square_iff
tff(fact_2377_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( aa(A,A,abs_abs(A),X) = one_one(A) ) ) ) ).

% abs_square_eq_1
tff(fact_2378_power__even__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),Na) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na) ) ) ) ).

% power_even_abs
tff(fact_2379_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType,F2: fun(nat,fun(A,A)),A2: nat,B2: nat,Acc: A] :
      ( set_fo6178422350223883121st_nat(A,F2,A2,B2,Acc)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),B2),A2),Acc,set_fo6178422350223883121st_nat(A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F2,A2),Acc))) ) ).

% fold_atLeastAtMost_nat.simps
tff(fact_2380_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: fun(nat,fun(A,A)),Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( set_fo6178422350223883121st_nat(A,X,Xa,Xb,Xc) = Y )
     => ( Y
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xb),Xa),Xc,set_fo6178422350223883121st_nat(A,X,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),X,Xa),Xc))) ) ) ).

% fold_atLeastAtMost_nat.elims
tff(fact_2381_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X)),Y) ) ) ) ).

% power2_le_iff_abs_le
tff(fact_2382_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X)),one_one(A)) ) ) ).

% abs_square_le_1
tff(fact_2383_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),X)),one_one(A)) ) ) ).

% abs_square_less_1
tff(fact_2384_power__mono__even,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) ) ) ) ).

% power_mono_even
tff(fact_2385_sqrt__ge__absD,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),aa(real,real,sqrt,Y))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Y) ) ).

% sqrt_ge_absD
tff(fact_2386_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_ge_abs1
tff(fact_2387_real__sqrt__ge__abs2,axiom,
    ! [Y: real,X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% real_sqrt_ge_abs2
tff(fact_2388_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),X)),aa(real,real,abs_abs(real),Y))) ).

% sqrt_sum_squares_le_sum_abs
tff(fact_2389_arctan__add,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,arctan,X)),aa(real,real,arctan,Y)) = aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),X),Y)))) ) ) ) ).

% arctan_add
tff(fact_2390_cos__x__y__le__one,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))),one_one(real)) ).

% cos_x_y_le_one
tff(fact_2391_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),U),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),U) ) ) ).

% real_sqrt_sum_squares_less
tff(fact_2392_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X))),X))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
tff(fact_2393_fact__code,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] : ( semiring_char_0_fact(A,Na) = aa(nat,A,semiring_1_of_nat(A),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),Na,one_one(nat))) ) ) ).

% fact_code
tff(fact_2394_arctan__double,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,arctan,X)) = aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% arctan_double
tff(fact_2395_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: fun(A,fun(A,$o)),X: A] :
          ( ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X3)
             => aa(A,$o,aa(A,fun(A,$o),P,X3),aa(nat,A,aa(A,fun(nat,A),power_power(A),X3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) )
         => aa(A,$o,aa(A,fun(A,$o),P,aa(A,A,abs_abs(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% abs_sqrt_wlog
tff(fact_2396_modulo__int__unfold,axiom,
    ! [K: int,M: nat,L: int,Na: nat] :
      ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),Na)))
      = $ite(
          ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( Na = zero_zero(nat) ) ),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,M,Na))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),M))))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,M,Na))))) ) ) ).

% modulo_int_unfold
tff(fact_2397_divide__int__unfold,axiom,
    ! [K: int,M: nat,L: int,Na: nat] :
      ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),Na)))
      = $ite(
          ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( Na = zero_zero(nat) ) ),
          zero_zero(int),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),M)))))) ) ) ).

% divide_int_unfold
tff(fact_2398_tanh__real__altdef,axiom,
    ! [X: real] : ( aa(real,real,tanh(real),X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)))) ) ).

% tanh_real_altdef
tff(fact_2399_and__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( ( K = zero_zero(int) )
          | ( L = zero_zero(int) ) ),
          zero_zero(int),
          $ite(
            K = aa(int,int,uminus_uminus(int),one_one(int)),
            L,
            $ite(L = aa(int,int,uminus_uminus(int),one_one(int)),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))))) ) ) ) ).

% and_int_unfold
tff(fact_2400_machin,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit0,one2))))))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))) ).

% machin
tff(fact_2401_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) ) ) ).

% and.right_idem
tff(fact_2402_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) ) ) ).

% and.left_idem
tff(fact_2403_and_Oidem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),A2) = A2 ) ) ).

% and.idem
tff(fact_2404_sgn__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,sgn_sgn(A),A2)) = aa(A,A,sgn_sgn(A),A2) ) ) ).

% sgn_sgn
tff(fact_2405_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),zero_zero(A)) = zero_zero(A) ) ) ).

% bit.conj_zero_right
tff(fact_2406_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),X) = zero_zero(A) ) ) ).

% bit.conj_zero_left
tff(fact_2407_zero__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% zero_and_eq
tff(fact_2408_and__zero__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% and_zero_eq
tff(fact_2409_sgn__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_0
tff(fact_2410_sgn__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_zero
tff(fact_2411_sgn__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_1
tff(fact_2412_sgn__one,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_one
tff(fact_2413_sgn__divide,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_divide
tff(fact_2414_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),A2)) ) ) ).

% idom_abs_sgn_class.sgn_minus
tff(fact_2415_power__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sgn_sgn(A),A2)),Na) ) ) ).

% power_sgn
tff(fact_2416_zdvd1__eq,axiom,
    ! [X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),X),one_one(int))
    <=> ( aa(int,int,abs_abs(int),X) = one_one(int) ) ) ).

% zdvd1_eq
tff(fact_2417_exp__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X)),aa(real,real,exp(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ).

% exp_less_cancel_iff
tff(fact_2418_exp__less__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X)),aa(real,real,exp(real),Y)) ) ).

% exp_less_mono
tff(fact_2419_take__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),B2)) ) ) ).

% take_bit_and
tff(fact_2420_sgn__greater,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,sgn_sgn(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% sgn_greater
tff(fact_2421_sgn__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,sgn_sgn(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% sgn_less
tff(fact_2422_exp__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,exp(A),zero_zero(A)) = one_one(A) ) ) ).

% exp_zero
tff(fact_2423_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))),A2) = A2 ) ) ).

% and.left_neutral
tff(fact_2424_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,uminus_uminus(A),one_one(A))) = A2 ) ) ).

% and.right_neutral
tff(fact_2425_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = X ) ) ).

% bit.conj_one_right
tff(fact_2426_divide__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,sgn_sgn(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% divide_sgn
tff(fact_2427_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),Z)),one_one(int))
    <=> ( Z = zero_zero(int) ) ) ).

% zabs_less_one_iff
tff(fact_2428_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( aa(real,real,exp(real),X) = one_one(real) )
    <=> ( X = zero_zero(real) ) ) ).

% exp_eq_one_iff
tff(fact_2429_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% and_nonnegative_int_iff
tff(fact_2430_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),zero_zero(int))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% and_negative_int_iff
tff(fact_2431_sgn__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,A,sgn_sgn(A),A2) = one_one(A) ) ) ) ).

% sgn_pos
tff(fact_2432_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = one_one(A) ) ) ).

% and_numerals(2)
tff(fact_2433_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),one_one(A)) = one_one(A) ) ) ).

% and_numerals(8)
tff(fact_2434_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2)) = one_one(A) ) ) ) ).

% abs_sgn_eq_1
tff(fact_2435_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% sgn_mult_self_eq
tff(fact_2436_sgn__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% sgn_abs
tff(fact_2437_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,abs_abs(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% idom_abs_sgn_class.abs_sgn
tff(fact_2438_one__less__exp__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,exp(real),X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X) ) ).

% one_less_exp_iff
tff(fact_2439_exp__less__one__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real)) ) ).

% exp_less_one_iff
tff(fact_2440_exp__le__one__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ).

% exp_le_one_iff
tff(fact_2441_one__le__exp__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,exp(real),X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% one_le_exp_iff
tff(fact_2442_exp__ln__iff,axiom,
    ! [X: real] :
      ( ( aa(real,real,exp(real),aa(real,real,ln_ln(real),X)) = X )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X) ) ).

% exp_ln_iff
tff(fact_2443_exp__ln,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,exp(real),aa(real,real,ln_ln(real),X)) = X ) ) ).

% exp_ln
tff(fact_2444_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(int,int,sgn_sgn(int),R2)))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( R2 = zero_zero(int) ) ) ) ).

% dvd_mult_sgn_iff
tff(fact_2445_dvd__sgn__mult__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R2)),K))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( R2 = zero_zero(int) ) ) ) ).

% dvd_sgn_mult_iff
tff(fact_2446_mult__sgn__dvd__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),aa(int,int,sgn_sgn(int),R2))),K)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        & ( ( R2 = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% mult_sgn_dvd_iff
tff(fact_2447_sgn__mult__dvd__iff,axiom,
    ! [R2: int,L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R2)),L)),K)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        & ( ( R2 = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% sgn_mult_dvd_iff
tff(fact_2448_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = zero_zero(A) ) ) ).

% and_numerals(1)
tff(fact_2449_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),one_one(A)) = zero_zero(A) ) ) ).

% and_numerals(5)
tff(fact_2450_sgn__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% sgn_neg
tff(fact_2451_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(3)
tff(fact_2452_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,semiring_1_of_nat(A),Na)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)) ) ) ).

% sgn_of_nat
tff(fact_2453_and__minus__numerals_I2_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = one_one(int) ) ).

% and_minus_numerals(2)
tff(fact_2454_and__minus__numerals_I6_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))),one_one(int)) = one_one(int) ) ).

% and_minus_numerals(6)
tff(fact_2455_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(4)
tff(fact_2456_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(6)
tff(fact_2457_and__minus__numerals_I5_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))),one_one(int)) = zero_zero(int) ) ).

% and_minus_numerals(5)
tff(fact_2458_and__minus__numerals_I1_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = zero_zero(int) ) ).

% and_minus_numerals(1)
tff(fact_2459_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% and_numerals(7)
tff(fact_2460_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) ) ) ).

% div_eq_sgn_abs
tff(fact_2461_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_and_eq
tff(fact_2462_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),C2)) ) ) ).

% and.left_commute
tff(fact_2463_and_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),A2) ) ) ).

% and.commute
tff(fact_2464_and_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),B2),C2)) ) ) ).

% and.assoc
tff(fact_2465_exp__less__cancel,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X)),aa(real,real,exp(real),Y))
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ).

% exp_less_cancel
tff(fact_2466_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% sgn_eq_0_iff
tff(fact_2467_sgn__0__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% sgn_0_0
tff(fact_2468_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] :
          ( ( aa(A,A,sgn_sgn(A),X) = zero_zero(A) )
        <=> ( X = zero_zero(A) ) ) ) ).

% sgn_zero_iff
tff(fact_2469_sgn__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_mult
tff(fact_2470_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A2) )
         => ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,sgn_sgn(A),A2) ) ) ) ).

% same_sgn_sgn_add
tff(fact_2471_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,exp(A),X) != zero_zero(A) ) ) ).

% exp_not_eq_zero
tff(fact_2472_pi__neq__zero,axiom,
    pi != zero_zero(real) ).

% pi_neq_zero
tff(fact_2473_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),A2)
       => ( aa(int,int,abs_abs(int),A2) = aa(int,int,abs_abs(int),B2) ) ) ) ).

% zdvd_antisym_abs
tff(fact_2474_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),L))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) ) ) ).

% div_sgn_abs_cancel
tff(fact_2475_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(int,int,sgn_sgn(int),L))),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L))) ) ) ).

% div_dvd_sgn_abs
tff(fact_2476_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( A2 = aa(A,A,uminus_uminus(A),one_one(A)) )
            & ( B2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_2477_not__exp__less__zero,axiom,
    ! [X: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),X)),zero_zero(real)) ).

% not_exp_less_zero
tff(fact_2478_exp__gt__zero,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,exp(real),X)) ).

% exp_gt_zero
tff(fact_2479_exp__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
     => ? [X3: real] : ( aa(real,real,exp(real),X3) = Y ) ) ).

% exp_total
tff(fact_2480_exp__ge__zero,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,exp(real),X)) ).

% exp_ge_zero
tff(fact_2481_not__exp__le__zero,axiom,
    ! [X: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X)),zero_zero(real)) ).

% not_exp_le_zero
tff(fact_2482_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) != aa(A,A,sgn_sgn(A),A2) )
         => ( ( aa(A,A,sgn_sgn(A),A2) != zero_zero(A) )
           => ( ( aa(A,A,sgn_sgn(A),B2) != zero_zero(A) )
             => ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),B2)) ) ) ) ) ) ).

% sgn_not_eq_imp
tff(fact_2483_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% sgn_minus_1
tff(fact_2484_AND__lower,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Y)) ) ).

% AND_lower
tff(fact_2485_AND__upper1,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Y)),X) ) ).

% AND_upper1
tff(fact_2486_AND__upper2,axiom,
    ! [Y: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Y)),Y) ) ).

% AND_upper2
tff(fact_2487_AND__upper1_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y),Ya)),Z) ) ) ).

% AND_upper1'
tff(fact_2488_AND__upper2_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Y)),Z) ) ) ).

% AND_upper2'
tff(fact_2489_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X)),aa(A,A,abs_abs(A),X)) = X ) ) ).

% mult_sgn_abs
tff(fact_2490_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,abs_abs(A),A2)) = A2 ) ) ).

% sgn_mult_abs
tff(fact_2491_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,sgn_sgn(A),A2)) = A2 ) ) ).

% abs_mult_sgn
tff(fact_2492_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [K: A] : ( aa(A,A,abs_abs(A),K) = aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,sgn_sgn(A),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_2493_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N: nat,L2: int] : ( K != aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L2)),aa(nat,int,semiring_1_of_nat(int),N)) ) ).

% int_sgnE
tff(fact_2494_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A2) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% same_sgn_abs_add
tff(fact_2495_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),Y)) = aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) ) ) ).

% mult_exp_exp
tff(fact_2496_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),X) )
         => ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),Y)) ) ) ) ).

% exp_add_commuting
tff(fact_2497_exp__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),Y)) ) ) ).

% exp_diff
tff(fact_2498_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),bit_se2239418461657761734s_mask(A,Na)) ) ) ).

% take_bit_eq_mask
tff(fact_2499_abs__zmult__eq__1,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),M),Na)) = one_one(int) )
     => ( aa(int,int,abs_abs(int),M) = one_one(int) ) ) ).

% abs_zmult_eq_1
tff(fact_2500_pi__not__less__zero,axiom,
    ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),zero_zero(real)) ).

% pi_not_less_zero
tff(fact_2501_pi__gt__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),pi) ).

% pi_gt_zero
tff(fact_2502_pi__ge__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),pi) ).

% pi_ge_zero
tff(fact_2503_abs__div,axiom,
    ! [Y: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Y),X)
     => ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X),Y)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),X)),aa(int,int,abs_abs(int),Y)) ) ) ).

% abs_div
tff(fact_2504_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
       => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)))),aa($o,int,zero_neq_one_of_bool(int),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K))) ) ) ) ).

% div_noneq_sgn_abs
tff(fact_2505_exp__gt__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,exp(real),X)) ) ).

% exp_gt_one
tff(fact_2506_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = one_one(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% sgn_1_pos
tff(fact_2507_exp__ge__add__one__self,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X)),aa(real,real,exp(real),X)) ).

% exp_ge_add_one_self
tff(fact_2508_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2))
          = $ite(A2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% abs_sgn_eq
tff(fact_2509_AND__upper2_H_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Y)),Z) ) ) ).

% AND_upper2''
tff(fact_2510_AND__upper1_H_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y),Ya)),Z) ) ) ).

% AND_upper1''
tff(fact_2511_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),K) ) ).

% and_less_eq
tff(fact_2512_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X))) = one_one(A) ) ) ).

% exp_minus_inverse
tff(fact_2513_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Na: nat,X: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),X)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),X)),Na) ) ) ).

% exp_of_nat_mult
tff(fact_2514_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Na: nat] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(nat,A,semiring_1_of_nat(A),Na))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),X)),Na) ) ) ).

% exp_of_nat2_mult
tff(fact_2515_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
       => ( aa(int,int,sgn_sgn(int),modulo_modulo(int,K,L)) = aa(int,int,sgn_sgn(int),L) ) ) ) ).

% sgn_mod
tff(fact_2516_zabs__def,axiom,
    ! [I2: int] :
      ( aa(int,int,abs_abs(int),I2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),zero_zero(int)),aa(int,int,uminus_uminus(int),I2),I2) ) ).

% zabs_def
tff(fact_2517_dvd__imp__le__int,axiom,
    ! [I2: int,D2: int] :
      ( ( I2 != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),I2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),D2)),aa(int,int,abs_abs(int),I2)) ) ) ).

% dvd_imp_le_int
tff(fact_2518_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),modulo_modulo(int,K,L))),aa(int,int,abs_abs(int),L)) ) ).

% abs_mod_less
tff(fact_2519_even__and__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_and_iff
tff(fact_2520_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% sgn_1_neg
tff(fact_2521_sgn__if,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( aa(A,A,sgn_sgn(A),X)
          = $ite(
              X = zero_zero(A),
              zero_zero(A),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X),one_one(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ) ).

% sgn_if
tff(fact_2522_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X)),aa(real,real,exp(real),X)) ) ).

% exp_ge_add_one_self_aux
tff(fact_2523_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
        | aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L) ) ) ).

% even_and_iff_int
tff(fact_2524_lemma__exp__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y)
     => ? [X3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),one_one(real)))
          & ( aa(real,real,exp(real),X3) = Y ) ) ) ).

% lemma_exp_total
tff(fact_2525_ln__ge__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,ln_ln(real),X))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Y)),X) ) ) ).

% ln_ge_iff
tff(fact_2526_zsgn__def,axiom,
    ! [I2: int] :
      ( aa(int,int,sgn_sgn(int),I2)
      = $ite(
          I2 = zero_zero(int),
          zero_zero(int),
          $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),I2),one_one(int),aa(int,int,uminus_uminus(int),one_one(int))) ) ) ).

% zsgn_def
tff(fact_2527_ln__x__over__x__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),Y)),Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),X)),X)) ) ) ).

% ln_x_over_x_mono
tff(fact_2528_norm__sgn,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] :
          ( real_V7770717601297561774m_norm(A,aa(A,A,sgn_sgn(A),X))
          = $ite(X = zero_zero(A),zero_zero(real),one_one(real)) ) ) ).

% norm_sgn
tff(fact_2529_pi__less__4,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) ).

% pi_less_4
tff(fact_2530_pi__ge__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi) ).

% pi_ge_two
tff(fact_2531_zdvd__mult__cancel1,axiom,
    ! [M: int,Na: int] :
      ( ( M != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),M),Na)),M)
      <=> ( aa(int,int,abs_abs(int),Na) = one_one(int) ) ) ) ).

% zdvd_mult_cancel1
tff(fact_2532_pi__half__neq__two,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) != aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)) ).

% pi_half_neq_two
tff(fact_2533_one__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),A2) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% one_and_eq
tff(fact_2534_and__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),one_one(A)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% and_one_eq
tff(fact_2535_exp__le,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))) ).

% exp_le
tff(fact_2536_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Na: nat,X: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),aa(nat,A,semiring_1_of_nat(A),Na)))),Na) = aa(A,A,exp(A),X) ) ) ) ).

% exp_divide_power_eq
tff(fact_2537_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),K)),L))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_abs_add_iff
tff(fact_2538_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,abs_abs(int),L)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_add_abs_iff
tff(fact_2539_pi__half__neq__zero,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) != zero_zero(real) ).

% pi_half_neq_zero
tff(fact_2540_pi__half__less__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% pi_half_less_two
tff(fact_2541_pi__half__le__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% pi_half_le_two
tff(fact_2542_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,tanh(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X)))) ) ) ).

% tanh_altdef
tff(fact_2543_exp__half__le2,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% exp_half_le2
tff(fact_2544_exp__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ).

% exp_double
tff(fact_2545_nat__intermed__int__val,axiom,
    ! [M: nat,Na: nat,F2: fun(nat,int),K: int] :
      ( ! [I3: nat] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),I3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Na) )
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F2,aa(nat,nat,suc,I3))),aa(nat,int,F2,I3)))),one_one(int)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F2,M)),K)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F2,Na))
           => ? [I3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),I3)
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),Na)
                & ( aa(nat,int,F2,I3) = K ) ) ) ) ) ) ).

% nat_intermed_int_val
tff(fact_2546_decr__lemma,axiom,
    ! [D2: int,X: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),Z))),one_one(int))),D2))),Z) ) ).

% decr_lemma
tff(fact_2547_incr__lemma,axiom,
    ! [D2: int,Z: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X),Z))),one_one(int))),D2))) ) ).

% incr_lemma
tff(fact_2548_pi__half__gt__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% pi_half_gt_zero
tff(fact_2549_pi__half__ge__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% pi_half_ge_zero
tff(fact_2550_m2pi__less__pi,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))),pi) ).

% m2pi_less_pi
tff(fact_2551_arctan__ubound,axiom,
    ! [Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% arctan_ubound
tff(fact_2552_arctan__one,axiom,
    aa(real,real,arctan,one_one(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) ).

% arctan_one
tff(fact_2553_and__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% and_int_rec
tff(fact_2554_nat__ivt__aux,axiom,
    ! [Na: nat,F2: fun(nat,int),K: int] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Na)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F2,aa(nat,nat,suc,I3))),aa(nat,int,F2,I3)))),one_one(int)) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F2,zero_zero(nat))),K)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F2,Na))
         => ? [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),Na)
              & ( aa(nat,int,F2,I3) = K ) ) ) ) ) ).

% nat_ivt_aux
tff(fact_2555_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% exp_bound_half
tff(fact_2556_minus__pi__half__less__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),zero_zero(real)) ).

% minus_pi_half_less_zero
tff(fact_2557_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),B2),A2))),real_V7770717601297561774m_norm(complex,B2))),real_V7770717601297561774m_norm(complex,A2)) ).

% complex_mod_triangle_ineq2
tff(fact_2558_arctan__lbound,axiom,
    ! [Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arctan,Y)) ).

% arctan_lbound
tff(fact_2559_arctan__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arctan,Y))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ).

% arctan_bounded
tff(fact_2560_exp__bound,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% exp_bound
tff(fact_2561_nat0__intermed__int__val,axiom,
    ! [Na: nat,F2: fun(nat,int),K: int] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Na)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),one_one(nat)))),aa(nat,int,F2,I3)))),one_one(int)) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F2,zero_zero(nat))),K)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F2,Na))
         => ? [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),Na)
              & ( aa(nat,int,F2,I3) = K ) ) ) ) ) ).

% nat0_intermed_int_val
tff(fact_2562_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),X)),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X))) ) ) ).

% real_exp_bound_lemma
tff(fact_2563_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [Na: nat,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),Na))),X)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),X),aa(nat,real,semiring_1_of_nat(real),Na)))),Na)),aa(real,real,exp(real),X)) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
tff(fact_2564_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(nat,real,semiring_1_of_nat(real),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),X),aa(nat,real,semiring_1_of_nat(real),Na)))),Na)),aa(real,real,exp(real),aa(real,real,uminus_uminus(real),X))) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
tff(fact_2565_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),real_V7770717601297561774m_norm(A,Z)))) ) ) ).

% exp_bound_lemma
tff(fact_2566_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,exp(real),X)) ) ).

% exp_lower_Taylor_quadratic
tff(fact_2567_machin__Euler,axiom,
    aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit0,one2)))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,one2))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) ).

% machin_Euler
tff(fact_2568_sin__cos__npi,axiom,
    ! [Na: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Na) ) ).

% sin_cos_npi
tff(fact_2569_cos__pi__eq__zero,axiom,
    ! [M: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M))))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = zero_zero(real) ) ).

% cos_pi_eq_zero
tff(fact_2570_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( cos(real,X) = zero_zero(real) )
    <=> ( ? [N4: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) )
        | ? [N4: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ) ) ) ).

% cos_zero_iff
tff(fact_2571_cot__less__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cot(real),X)),zero_zero(real)) ) ) ).

% cot_less_zero
tff(fact_2572_cos__zero__lemma,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( ( cos(real,X) = zero_zero(real) )
       => ? [N: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)
            & ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ) ).

% cos_zero_lemma
tff(fact_2573_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( sin(real,X) = zero_zero(real) )
    <=> ( ? [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) )
        | ? [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4)
            & ( X = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N4)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ) ) ) ).

% sin_zero_iff
tff(fact_2574_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sgn_sgn(real),X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% zero_le_sgn_iff
tff(fact_2575_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sgn_sgn(real),X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ).

% sgn_le_0_iff
tff(fact_2576_sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,zero_zero(A)) = zero_zero(A) ) ) ).

% sin_zero
tff(fact_2577_cot__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,cot(A),zero_zero(A)) = zero_zero(A) ) ) ).

% cot_zero
tff(fact_2578_cos__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,zero_zero(A)) = one_one(A) ) ) ).

% cos_zero
tff(fact_2579_sin__pi,axiom,
    sin(real,pi) = zero_zero(real) ).

% sin_pi
tff(fact_2580_sin__pi__minus,axiom,
    ! [X: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),X)) = sin(real,X) ) ).

% sin_pi_minus
tff(fact_2581_cot__pi,axiom,
    aa(real,real,cot(real),pi) = zero_zero(real) ).

% cot_pi
tff(fact_2582_cos__pi,axiom,
    cos(real,pi) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% cos_pi
tff(fact_2583_cos__pi__minus,axiom,
    ! [X: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),X)) = aa(real,real,uminus_uminus(real),cos(real,X)) ) ).

% cos_pi_minus
tff(fact_2584_cos__minus__pi,axiom,
    ! [X: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),pi)) = aa(real,real,uminus_uminus(real),cos(real,X)) ) ).

% cos_minus_pi
tff(fact_2585_sin__minus__pi,axiom,
    ! [X: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),pi)) = aa(real,real,uminus_uminus(real),sin(real,X)) ) ).

% sin_minus_pi
tff(fact_2586_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),cos(A,X))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X)),sin(A,X))) = one_one(A) ) ) ).

% sin_cos_squared_add3
tff(fact_2587_sin__npi2,axiom,
    ! [Na: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),Na))) = zero_zero(real) ) ).

% sin_npi2
tff(fact_2588_sin__npi,axiom,
    ! [Na: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),pi)) = zero_zero(real) ) ).

% sin_npi
tff(fact_2589_and__nat__numerals_I3_J,axiom,
    ! [X: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X))),aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% and_nat_numerals(3)
tff(fact_2590_and__nat__numerals_I1_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y))) = zero_zero(nat) ) ).

% and_nat_numerals(1)
tff(fact_2591_cot__npi,axiom,
    ! [Na: nat] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),pi)) = zero_zero(real) ) ).

% cot_npi
tff(fact_2592_and__nat__numerals_I4_J,axiom,
    ! [X: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X))),aa(nat,nat,suc,zero_zero(nat))) = one_one(nat) ) ).

% and_nat_numerals(4)
tff(fact_2593_and__nat__numerals_I2_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y))) = one_one(nat) ) ).

% and_nat_numerals(2)
tff(fact_2594_cos__pi__half,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = zero_zero(real) ).

% cos_pi_half
tff(fact_2595_sin__two__pi,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)) = zero_zero(real) ).

% sin_two_pi
tff(fact_2596_sin__pi__half,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = one_one(real) ).

% sin_pi_half
tff(fact_2597_cos__two__pi,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)) = one_one(real) ).

% cos_two_pi
tff(fact_2598_cos__periodic,axiom,
    ! [X: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = cos(real,X) ) ).

% cos_periodic
tff(fact_2599_sin__periodic,axiom,
    ! [X: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = sin(real,X) ) ).

% sin_periodic
tff(fact_2600_cos__2pi__minus,axiom,
    ! [X: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),X)) = cos(real,X) ) ).

% cos_2pi_minus
tff(fact_2601_Suc__0__and__eq,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),Na) = modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Suc_0_and_eq
tff(fact_2602_and__Suc__0__eq,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),Na),aa(nat,nat,suc,zero_zero(nat))) = modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% and_Suc_0_eq
tff(fact_2603_cos__npi,axiom,
    ! [Na: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),pi)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Na) ) ).

% cos_npi
tff(fact_2604_cos__npi2,axiom,
    ! [Na: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),Na))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Na) ) ).

% cos_npi2
tff(fact_2605_cot__periodic,axiom,
    ! [X: real] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = aa(real,real,cot(real),X) ) ).

% cot_periodic
tff(fact_2606_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add2
tff(fact_2607_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add
tff(fact_2608_sin__2npi,axiom,
    ! [Na: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)) = zero_zero(real) ) ).

% sin_2npi
tff(fact_2609_cos__2npi,axiom,
    ! [Na: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)) = one_one(real) ) ).

% cos_2npi
tff(fact_2610_sin__2pi__minus,axiom,
    ! [X: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),X)) = aa(real,real,uminus_uminus(real),sin(real,X)) ) ).

% sin_2pi_minus
tff(fact_2611_cos__3over2__pi,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi)) = zero_zero(real) ).

% cos_3over2_pi
tff(fact_2612_sin__3over2__pi,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi)) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% sin_3over2_pi
tff(fact_2613_sin__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X)),cos(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),sin(A,Y))) ) ) ).

% sin_diff
tff(fact_2614_cot__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X4: A] : ( aa(A,A,cot(A),X4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),cos(A,X4)),sin(A,X4)) ) ) ).

% cot_def
tff(fact_2615_sin__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X)),cos(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),sin(A,Y))) ) ) ).

% sin_add
tff(fact_2616_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cos(A,X) = one_one(A) )
         => ( sin(A,X) = zero_zero(A) ) ) ) ).

% cos_one_sin_zero
tff(fact_2617_cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),cos(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X)),sin(A,Y))) ) ) ).

% cos_add
tff(fact_2618_cos__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),cos(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X)),sin(A,Y))) ) ) ).

% cos_diff
tff(fact_2619_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( sin(A,X) = zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,cos(A,X)) = one_one(real) ) ) ) ).

% sin_zero_norm_cos_one
tff(fact_2620_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( sin(real,X) = zero_zero(real) )
     => ( aa(real,real,abs_abs(real),cos(real,X)) = one_one(real) ) ) ).

% sin_zero_abs_cos_one
tff(fact_2621_sin__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,X))),cos(A,X)) ) ) ).

% sin_double
tff(fact_2622_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Y4)
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),pi)
      & ( sin(real,Y4) = sin(real,X) )
      & ( cos(real,Y4) = cos(real,X) ) ) ).

% sincos_principal_value
tff(fact_2623_sin__x__le__x,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X)),X) ) ).

% sin_x_le_x
tff(fact_2624_sin__le__one,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X)),one_one(real)) ).

% sin_le_one
tff(fact_2625_cos__le__one,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,X)),one_one(real)) ).

% cos_le_one
tff(fact_2626_cos__arctan__not__zero,axiom,
    ! [X: real] : ( cos(real,aa(real,real,arctan,X)) != zero_zero(real) ) ).

% cos_arctan_not_zero
tff(fact_2627_sin__cos__le1,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),sin(real,X)),sin(real,Y))),aa(real,real,aa(real,fun(real,real),times_times(real),cos(real,X)),cos(real,Y))))),one_one(real)) ).

% sin_cos_le1
tff(fact_2628_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% sin_squared_eq
tff(fact_2629_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% cos_squared_eq
tff(fact_2630_sin__gt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),pi)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,X)) ) ) ).

% sin_gt_zero
tff(fact_2631_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),X)),sin(real,X)) ) ).

% sin_x_ge_neg_x
tff(fact_2632_sin__ge__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sin(real,X)) ) ) ).

% sin_ge_zero
tff(fact_2633_sin__ge__minus__one,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),sin(real,X)) ).

% sin_ge_minus_one
tff(fact_2634_cos__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),pi)
           => ( ( cos(real,X) = cos(real,Y) )
             => ( X = Y ) ) ) ) ) ) ).

% cos_inj_pi
tff(fact_2635_cos__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),pi)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,X)),cos(real,Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),X) ) ) ) ) ) ).

% cos_mono_le_eq
tff(fact_2636_cos__monotone__0__pi__le,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,X)),cos(real,Y)) ) ) ) ).

% cos_monotone_0_pi_le
tff(fact_2637_cos__ge__minus__one,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),cos(real,X)) ).

% cos_ge_minus_one
tff(fact_2638_abs__sin__le__one,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),sin(real,X))),one_one(real)) ).

% abs_sin_le_one
tff(fact_2639_abs__cos__le__one,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),cos(real,X))),one_one(real)) ).

% abs_cos_le_one
tff(fact_2640_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% cos_diff_cos
tff(fact_2641_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% sin_diff_sin
tff(fact_2642_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% sin_plus_sin
tff(fact_2643_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% cos_times_sin
tff(fact_2644_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% sin_times_cos
tff(fact_2645_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,W)),sin(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% sin_times_sin
tff(fact_2646_cos__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% cos_double
tff(fact_2647_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,W)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% cos_double_sin
tff(fact_2648_sgn__real__def,axiom,
    ! [A2: real] :
      ( aa(real,real,sgn_sgn(real),A2)
      = $ite(
          A2 = zero_zero(real),
          zero_zero(real),
          $ite(aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2),one_one(real),aa(real,real,uminus_uminus(real),one_one(real))) ) ) ).

% sgn_real_def
tff(fact_2649_cos__two__neq__zero,axiom,
    cos(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) != zero_zero(real) ).

% cos_two_neq_zero
tff(fact_2650_cos__monotone__0__pi,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,X)),cos(real,Y)) ) ) ) ).

% cos_monotone_0_pi
tff(fact_2651_cos__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),pi)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,X)),cos(real,Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X) ) ) ) ) ) ).

% cos_mono_less_eq
tff(fact_2652_sin__eq__0__pi,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),pi)
       => ( ( sin(real,X) = zero_zero(real) )
         => ( X = zero_zero(real) ) ) ) ) ).

% sin_eq_0_pi
tff(fact_2653_sin__zero__pi__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),pi)
     => ( ( sin(real,X) = zero_zero(real) )
      <=> ( X = zero_zero(real) ) ) ) ).

% sin_zero_pi_iff
tff(fact_2654_cos__monotone__minus__pi__0_H,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,Y)),cos(real,X)) ) ) ) ).

% cos_monotone_minus_pi_0'
tff(fact_2655_sincos__total__pi,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),pi)
            & ( X = cos(real,T3) )
            & ( Y = sin(real,T3) ) ) ) ) ).

% sincos_total_pi
tff(fact_2656_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sin(real,X))
     => ( sin(real,X) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),cos(real,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% sin_cos_sqrt
tff(fact_2657_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] : ( sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,M))),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) = cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ).

% sin_expansion_lemma
tff(fact_2658_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] : ( cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,M))),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) = aa(real,real,uminus_uminus(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))) ) ).

% cos_expansion_lemma
tff(fact_2659_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,X)) ) ) ).

% sin_gt_zero_02
tff(fact_2660_sgn__power__injE,axiom,
    ! [A2: real,Na: nat,X: real,B2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),A2)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),A2)),Na)) = X )
     => ( ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),B2)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),B2)),Na)) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
tff(fact_2661_cos__two__less__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),zero_zero(real)) ).

% cos_two_less_zero
tff(fact_2662_cos__two__le__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cos(real,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),zero_zero(real)) ).

% cos_two_le_zero
tff(fact_2663_cos__is__zero,axiom,
    ? [X3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X3)
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
      & ( cos(real,X3) = zero_zero(real) )
      & ! [Y3: real] :
          ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
            & ( cos(real,Y3) = zero_zero(real) ) )
         => ( Y3 = X3 ) ) ) ).

% cos_is_zero
tff(fact_2664_cos__monotone__minus__pi__0,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,Y)),cos(real,X)) ) ) ) ).

% cos_monotone_minus_pi_0
tff(fact_2665_cos__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ? [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),pi)
            & ( cos(real,X3) = Y )
            & ! [Y3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),pi)
                  & ( cos(real,Y3) = Y ) )
               => ( Y3 = X3 ) ) ) ) ) ).

% cos_total
tff(fact_2666_sincos__total__pi__half,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
         => ? [T3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
              & ( X = cos(real,T3) )
              & ( Y = sin(real,T3) ) ) ) ) ) ).

% sincos_total_pi_half
tff(fact_2667_sincos__total__2pi__le,axiom,
    ! [X: real,Y: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
     => ? [T3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
          & ( X = cos(real,T3) )
          & ( Y = sin(real,T3) ) ) ) ).

% sincos_total_2pi_le
tff(fact_2668_sincos__total__2pi,axiom,
    ! [X: real,Y: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) )
     => ~ ! [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
             => ( ( X = cos(real,T3) )
               => ( Y != sin(real,T3) ) ) ) ) ) ).

% sincos_total_2pi
tff(fact_2669_sin__pi__divide__n__ge__0,axiom,
    ! [Na: nat] :
      ( ( Na != zero_zero(nat) )
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(nat,real,semiring_1_of_nat(real),Na)))) ) ).

% sin_pi_divide_n_ge_0
tff(fact_2670_sin__45,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sin_45
tff(fact_2671_cos__45,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% cos_45
tff(fact_2672_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))),cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% cos_plus_cos
tff(fact_2673_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,W)),cos(A,Z)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% cos_times_cos
tff(fact_2674_sin__gt__zero2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,X)) ) ) ).

% sin_gt_zero2
tff(fact_2675_sin__lt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,X)),zero_zero(real)) ) ) ).

% sin_lt_zero
tff(fact_2676_cos__double__less__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X))),one_one(real)) ) ) ).

% cos_double_less_one
tff(fact_2677_sin__30,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sin_30
tff(fact_2678_cos__gt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),cos(real,X)) ) ) ).

% cos_gt_zero
tff(fact_2679_sin__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( ( sin(real,X) = sin(real,Y) )
             => ( X = Y ) ) ) ) ) ) ).

% sin_inj_pi
tff(fact_2680_sin__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X)),sin(real,Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ) ) ) ).

% sin_mono_le_eq
tff(fact_2681_sin__monotone__2pi__le,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,Y)),sin(real,X)) ) ) ) ).

% sin_monotone_2pi_le
tff(fact_2682_cos__60,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% cos_60
tff(fact_2683_sin__60,axiom,
    sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% sin_60
tff(fact_2684_cos__30,axiom,
    cos(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% cos_30
tff(fact_2685_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,W)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),one_one(A)) ) ) ).

% cos_double_cos
tff(fact_2686_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))),X)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))),cos(A,X))) ) ) ).

% cos_treble_cos
tff(fact_2687_and__nat__unfold,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),Na)
      = $ite(
          ( ( M = zero_zero(nat) )
          | ( Na = zero_zero(nat) ) ),
          zero_zero(nat),
          aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% and_nat_unfold
tff(fact_2688_sin__le__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),pi),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,X)),zero_zero(real)) ) ) ).

% sin_le_zero
tff(fact_2689_sin__less__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,X)),zero_zero(real)) ) ) ).

% sin_less_zero
tff(fact_2690_sin__monotone__2pi,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,Y)),sin(real,X)) ) ) ) ).

% sin_monotone_2pi
tff(fact_2691_sin__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),sin(real,X)),sin(real,Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ) ) ) ).

% sin_mono_less_eq
tff(fact_2692_sin__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ? [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
            & ( sin(real,X3) = Y )
            & ! [Y3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
                  & ( sin(real,Y3) = Y ) )
               => ( Y3 = X3 ) ) ) ) ) ).

% sin_total
tff(fact_2693_and__nat__rec,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),Na)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)
            & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% and_nat_rec
tff(fact_2694_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),cos(real,X)) ) ) ).

% cos_gt_zero_pi
tff(fact_2695_cos__ge__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),cos(real,X)) ) ) ).

% cos_ge_zero
tff(fact_2696_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( cos(real,X) = one_one(real) )
    <=> ( ? [X5: nat] : ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X5)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi) )
        | ? [X5: nat] : ( X = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X5)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi)) ) ) ) ).

% cos_one_2pi
tff(fact_2697_sin__pi__divide__n__gt__0,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sin(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(nat,real,semiring_1_of_nat(real),Na)))) ) ).

% sin_pi_divide_n_gt_0
tff(fact_2698_sin__arctan,axiom,
    ! [X: real] : ( sin(real,aa(real,real,arctan,X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),X),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% sin_arctan
tff(fact_2699_cos__arctan,axiom,
    ! [X: real] : ( cos(real,aa(real,real,arctan,X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% cos_arctan
tff(fact_2700_cot__gt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,cot(real),X)) ) ) ).

% cot_gt_zero
tff(fact_2701_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X != zero_zero(real) )
     => ( aa(real,real,arctan,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),X)),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(real,real,arctan,X)) ) ) ).

% arctan_inverse
tff(fact_2702_sin__zero__lemma,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( ( sin(real,X) = zero_zero(real) )
       => ? [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)
            & ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ) ).

% sin_zero_lemma
tff(fact_2703_tan__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => ( ( cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)) != zero_zero(A) )
           => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,tan(A),X))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,tan(A),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ) ).

% tan_double
tff(fact_2704_sin__tan,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => ( sin(real,X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,tan(real),X)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,tan(real),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% sin_tan
tff(fact_2705_cos__tan,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
     => ( cos(real,X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,tan(real),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% cos_tan
tff(fact_2706_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm(complex,Z) = one_one(real) )
     => ~ ! [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))
             => ( Z != complex2(cos(real,T3),sin(real,T3)) ) ) ) ) ).

% complex_unimodular_polar
tff(fact_2707_cos__arcsin,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => ( cos(real,aa(real,real,arcsin,X)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% cos_arcsin
tff(fact_2708_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
     => ( sin(real,aa(real,real,arccos,Y)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% sin_arccos_abs
tff(fact_2709_tan__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tan(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tan_zero
tff(fact_2710_arcsin__0,axiom,
    aa(real,real,arcsin,zero_zero(real)) = zero_zero(real) ).

% arcsin_0
tff(fact_2711_arccos__1,axiom,
    aa(real,real,arccos,one_one(real)) = zero_zero(real) ).

% arccos_1
tff(fact_2712_tan__pi,axiom,
    aa(real,real,tan(real),pi) = zero_zero(real) ).

% tan_pi
tff(fact_2713_arccos__minus__1,axiom,
    aa(real,real,arccos,aa(real,real,uminus_uminus(real),one_one(real))) = pi ).

% arccos_minus_1
tff(fact_2714_tan__npi,axiom,
    ! [Na: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),pi)) = zero_zero(real) ) ).

% tan_npi
tff(fact_2715_tan__periodic__n,axiom,
    ! [X: real,Na: num] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),Na)),pi))) = aa(real,real,tan(real),X) ) ).

% tan_periodic_n
tff(fact_2716_cos__arccos,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( cos(real,aa(real,real,arccos,Y)) = Y ) ) ) ).

% cos_arccos
tff(fact_2717_sin__arcsin,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( sin(real,aa(real,real,arcsin,Y)) = Y ) ) ) ).

% sin_arcsin
tff(fact_2718_norm__cos__sin,axiom,
    ! [T2: real] : ( real_V7770717601297561774m_norm(complex,complex2(cos(real,T2),sin(real,T2))) = one_one(real) ) ).

% norm_cos_sin
tff(fact_2719_arccos__0,axiom,
    aa(real,real,arccos,zero_zero(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% arccos_0
tff(fact_2720_arcsin__1,axiom,
    aa(real,real,arcsin,one_one(real)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% arcsin_1
tff(fact_2721_tan__periodic,axiom,
    ! [X: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) = aa(real,real,tan(real),X) ) ).

% tan_periodic
tff(fact_2722_arcsin__minus__1,axiom,
    aa(real,real,arcsin,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ).

% arcsin_minus_1
tff(fact_2723_zero__complex_Ocode,axiom,
    zero_zero(complex) = complex2(zero_zero(real),zero_zero(real)) ).

% zero_complex.code
tff(fact_2724_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = zero_zero(complex) )
    <=> ( ( A2 = zero_zero(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_0
tff(fact_2725_complex__diff,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),complex2(A2,B2)),complex2(C2,D2)) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),C2),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),D2)) ) ).

% complex_diff
tff(fact_2726_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = one_one(complex) )
    <=> ( ( A2 = one_one(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_1
tff(fact_2727_one__complex_Ocode,axiom,
    one_one(complex) = complex2(one_one(real),zero_zero(real)) ).

% one_complex.code
tff(fact_2728_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( complex2(A2,B2) = aa(num,complex,numeral_numeral(complex),W) )
    <=> ( ( A2 = aa(num,real,numeral_numeral(real),W) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_numeral
tff(fact_2729_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) )
    <=> ( ( A2 = aa(real,real,uminus_uminus(real),one_one(real)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_1
tff(fact_2730_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( complex2(A2,B2) = aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) )
    <=> ( ( A2 = aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_numeral
tff(fact_2731_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A2,B2)),complex2(C2,D2)) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A2),C2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A2),D2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),C2))) ) ).

% complex_mult
tff(fact_2732_arccos__le__arccos,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),aa(real,real,arccos,X)) ) ) ) ).

% arccos_le_arccos
tff(fact_2733_arccos__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real)) )
     => ( ( aa(real,real,arccos,X) = aa(real,real,arccos,Y) )
      <=> ( X = Y ) ) ) ).

% arccos_eq_iff
tff(fact_2734_arccos__le__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,X)),aa(real,real,arccos,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),X) ) ) ) ).

% arccos_le_mono
tff(fact_2735_arcsin__minus,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => ( aa(real,real,arcsin,aa(real,real,uminus_uminus(real),X)) = aa(real,real,uminus_uminus(real),aa(real,real,arcsin,X)) ) ) ) ).

% arcsin_minus
tff(fact_2736_arcsin__le__arcsin,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,X)),aa(real,real,arcsin,Y)) ) ) ) ).

% arcsin_le_arcsin
tff(fact_2737_arcsin__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( ( aa(real,real,arcsin,X) = aa(real,real,arcsin,Y) )
        <=> ( X = Y ) ) ) ) ).

% arcsin_eq_iff
tff(fact_2738_arcsin__le__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,X)),aa(real,real,arcsin,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ) ).

% arcsin_le_mono
tff(fact_2739_tan__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X4: A] : ( aa(A,A,tan(A),X4) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,X4)),cos(A,X4)) ) ) ).

% tan_def
tff(fact_2740_arccos__lbound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y)) ) ) ).

% arccos_lbound
tff(fact_2741_arccos__less__arccos,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Y)),aa(real,real,arccos,X)) ) ) ) ).

% arccos_less_arccos
tff(fact_2742_arccos__less__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,X)),aa(real,real,arccos,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X) ) ) ) ).

% arccos_less_mono
tff(fact_2743_arccos__ubound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),pi) ) ) ).

% arccos_ubound
tff(fact_2744_arccos__cos,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
       => ( aa(real,real,arccos,cos(real,X)) = X ) ) ) ).

% arccos_cos
tff(fact_2745_arcsin__less__arcsin,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,X)),aa(real,real,arcsin,Y)) ) ) ) ).

% arcsin_less_arcsin
tff(fact_2746_arcsin__less__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,X)),aa(real,real,arcsin,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ) ).

% arcsin_less_mono
tff(fact_2747_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
     => ( cos(real,aa(real,real,arccos,Y)) = Y ) ) ).

% cos_arccos_abs
tff(fact_2748_tan__45,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2))))) = one_one(real) ).

% tan_45
tff(fact_2749_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,arccos,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Y)),pi) ) ) ) ).

% arccos_lt_bounded
tff(fact_2750_arccos__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),pi) ) ) ) ).

% arccos_bounded
tff(fact_2751_tan__60,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))) ).

% tan_60
tff(fact_2752_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => ( sin(real,aa(real,real,arccos,X)) != zero_zero(real) ) ) ) ).

% sin_arccos_nonzero
tff(fact_2753_arccos__cos2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),X)
       => ( aa(real,real,arccos,cos(real,X)) = aa(real,real,uminus_uminus(real),X) ) ) ) ).

% arccos_cos2
tff(fact_2754_arccos__minus,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => ( aa(real,real,arccos,aa(real,real,uminus_uminus(real),X)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),aa(real,real,arccos,X)) ) ) ) ).

% arccos_minus
tff(fact_2755_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => ( cos(real,aa(real,real,arcsin,X)) != zero_zero(real) ) ) ) ).

% cos_arcsin_nonzero
tff(fact_2756_tan__gt__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,tan(real),X)) ) ) ).

% tan_gt_zero
tff(fact_2757_lemma__tan__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
     => ? [X3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,tan(real),X3)) ) ) ).

% lemma_tan_total
tff(fact_2758_tan__total,axiom,
    ! [Y: real] :
    ? [X3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X3)
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
      & ( aa(real,real,tan(real),X3) = Y )
      & ! [Y3: real] :
          ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
            & ( aa(real,real,tan(real),Y3) = Y ) )
         => ( Y3 = X3 ) ) ) ).

% tan_total
tff(fact_2759_tan__monotone,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Y)),aa(real,real,tan(real),X)) ) ) ) ).

% tan_monotone
tff(fact_2760_tan__monotone_H,axiom,
    ! [Y: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X)
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Y)),aa(real,real,tan(real),X)) ) ) ) ) ) ).

% tan_monotone'
tff(fact_2761_tan__mono__lt__eq,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),X)),aa(real,real,tan(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ) ) ) ).

% tan_mono_lt_eq
tff(fact_2762_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X3)
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
      & ( aa(real,real,tan(real),X3) = Y ) ) ).

% lemma_tan_total1
tff(fact_2763_tan__minus__45,axiom,
    aa(real,real,tan(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% tan_minus_45
tff(fact_2764_tan__inverse,axiom,
    ! [Y: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,tan(real),Y)) = aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),Y)) ) ).

% tan_inverse
tff(fact_2765_arccos,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),pi)
          & ( cos(real,aa(real,real,arccos,Y)) = Y ) ) ) ) ).

% arccos
tff(fact_2766_arccos__minus__abs,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,real,arccos,aa(real,real,uminus_uminus(real),X)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),aa(real,real,arccos,X)) ) ) ).

% arccos_minus_abs
tff(fact_2767_complex__norm,axiom,
    ! [X: real,Y: real] : ( real_V7770717601297561774m_norm(complex,complex2(X,Y)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_norm
tff(fact_2768_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => ( ( cos(A,Y) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),X)),aa(A,A,tan(A),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),cos(A,Y))) ) ) ) ) ).

% add_tan_eq
tff(fact_2769_tan__cot_H,axiom,
    ! [X: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)) = aa(real,real,cot(real),X) ) ).

% tan_cot'
tff(fact_2770_tan__total__pos,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ? [X3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
          & ( aa(real,real,tan(real),X3) = Y ) ) ) ).

% tan_total_pos
tff(fact_2771_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,tan(real),X)) ) ) ).

% tan_pos_pi2_le
tff(fact_2772_tan__less__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),X)),zero_zero(real)) ) ) ).

% tan_less_zero
tff(fact_2773_tan__mono__le,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tan(real),X)),aa(real,real,tan(real),Y)) ) ) ) ).

% tan_mono_le
tff(fact_2774_tan__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tan(real),X)),aa(real,real,tan(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ) ) ) ).

% tan_mono_le_eq
tff(fact_2775_tan__bound__pi2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,tan(real),X))),one_one(real)) ) ).

% tan_bound_pi2
tff(fact_2776_tan__30,axiom,
    aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,one2))))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) ).

% tan_30
tff(fact_2777_arctan,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arctan,Y))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
      & ( aa(real,real,tan(real),aa(real,real,arctan,Y)) = Y ) ) ).

% arctan
tff(fact_2778_arctan__tan,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,real,arctan,aa(real,real,tan(real),X)) = X ) ) ) ).

% arctan_tan
tff(fact_2779_arctan__unique,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( ( aa(real,real,tan(real),X) = Y )
         => ( aa(real,real,arctan,Y) = X ) ) ) ) ).

% arctan_unique
tff(fact_2780_tan__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => ( ( cos(A,Y) != zero_zero(A) )
           => ( ( cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),X)),aa(A,A,tan(A),Y))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X)),aa(A,A,tan(A),Y)))) ) ) ) ) ) ).

% tan_add
tff(fact_2781_tan__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => ( ( cos(A,Y) != zero_zero(A) )
           => ( ( cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,tan(A),X)),aa(A,A,tan(A),Y))),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X)),aa(A,A,tan(A),Y)))) ) ) ) ) ) ).

% tan_diff
tff(fact_2782_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => ( ( cos(A,Y) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),X)),aa(A,A,tan(A),Y))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),cos(A,Y))) ) ) ) ) ).

% lemma_tan_add1
tff(fact_2783_tan__total__pi4,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ? [Z2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))),Z2)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))))
          & ( aa(real,real,tan(real),Z2) = X ) ) ) ).

% tan_total_pi4
tff(fact_2784_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% arccos_le_pi2
tff(fact_2785_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% arcsin_lt_bounded
tff(fact_2786_arcsin__lbound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y)) ) ) ).

% arcsin_lbound
tff(fact_2787_arcsin__ubound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% arcsin_ubound
tff(fact_2788_arcsin__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% arcsin_bounded
tff(fact_2789_arcsin__sin,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
       => ( aa(real,real,arcsin,sin(real,X)) = X ) ) ) ).

% arcsin_sin
tff(fact_2790_tan__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,tan(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sin(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X))),aa(A,A,aa(A,fun(A,A),plus_plus(A),cos(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X))),one_one(A))) ) ) ).

% tan_half
tff(fact_2791_arcsin,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
          & ( sin(real,aa(real,real,arcsin,Y)) = Y ) ) ) ) ).

% arcsin
tff(fact_2792_arcsin__pi,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),pi)
          & ( sin(real,aa(real,real,arcsin,Y)) = Y ) ) ) ) ).

% arcsin_pi
tff(fact_2793_arcsin__le__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,X)),Y)
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),sin(real,Y)) ) ) ) ) ) ).

% arcsin_le_iff
tff(fact_2794_le__arcsin__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,arcsin,X))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sin(real,Y)),X) ) ) ) ) ) ).

% le_arcsin_iff
tff(fact_2795_sin__arccos,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => ( sin(real,aa(real,real,arccos,X)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% sin_arccos
tff(fact_2796_cos__npi__int,axiom,
    ! [Na: int] :
      ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),Na)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na),one_one(real),aa(real,real,uminus_uminus(real),one_one(real))) ) ).

% cos_npi_int
tff(fact_2797_log__base__10__eq1,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))),X) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))))),aa(real,real,ln_ln(real),X)) ) ) ).

% log_base_10_eq1
tff(fact_2798_modulo__int__def,axiom,
    ! [K: int,L: int] :
      ( modulo_modulo(int,K,L)
      = $ite(
          L = zero_zero(int),
          K,
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),L)),aa($o,int,zero_neq_one_of_bool(int),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))))) ) ) ).

% modulo_int_def
tff(fact_2799_divide__int__def,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)
      = $ite(
          L = zero_zero(int),
          zero_zero(int),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)))))) ) ) ).

% divide_int_def
tff(fact_2800_signed__take__bit__eq__take__bit__minus,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Na)),K)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(nat,nat,suc,Na))),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)))) ) ).

% signed_take_bit_eq_take_bit_minus
tff(fact_2801_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( sin(real,X) = zero_zero(real) )
    <=> ? [I: int] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),I)
          & ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% sin_zero_iff_int
tff(fact_2802_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: int,Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),W) = aa(int,A,ring_1_of_int(A),Z) )
        <=> ( W = Z ) ) ) ).

% of_int_eq_iff
tff(fact_2803_nat__int,axiom,
    ! [Na: nat] : ( aa(int,nat,nat2,aa(nat,int,semiring_1_of_nat(int),Na)) = Na ) ).

% nat_int
tff(fact_2804_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = zero_zero(A) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_eq_0_iff
tff(fact_2805_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( zero_zero(A) = aa(int,A,ring_1_of_int(A),Z) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_0_eq_iff
tff(fact_2806_of__int__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),zero_zero(int)) = zero_zero(A) ) ) ).

% of_int_0
tff(fact_2807_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ) ).

% of_int_le_iff
tff(fact_2808_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(num,int,numeral_numeral(int),K)) = aa(num,A,numeral_numeral(A),K) ) ) ).

% of_int_numeral
tff(fact_2809_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int,Na: num] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = aa(num,A,numeral_numeral(A),Na) )
        <=> ( Z = aa(num,int,numeral_numeral(int),Na) ) ) ) ).

% of_int_eq_numeral_iff
tff(fact_2810_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% of_int_less_iff
tff(fact_2811_of__int__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),one_one(int)) = one_one(A) ) ) ).

% of_int_1
tff(fact_2812_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = one_one(A) )
        <=> ( Z = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_2813_of__int__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_mult
tff(fact_2814_of__int__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_add
tff(fact_2815_of__int__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),Z)) = aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_minus
tff(fact_2816_nat__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(num,int,numeral_numeral(int),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_numeral
tff(fact_2817_of__int__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),minus_minus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_diff
tff(fact_2818_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] : ( aa(int,A,ring_1_of_int(A),aa(nat,int,semiring_1_of_nat(int),Na)) = aa(nat,A,semiring_1_of_nat(A),Na) ) ) ).

% of_int_of_nat_eq
tff(fact_2819_log__one,axiom,
    ! [A2: real] : ( aa(real,real,log(A2),one_one(real)) = zero_zero(real) ) ).

% log_one
tff(fact_2820_of__int__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,abs_abs(int),X)) = aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),X)) ) ) ).

% of_int_abs
tff(fact_2821_of__int__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int,Na: nat] : ( aa(int,A,ring_1_of_int(A),aa(nat,int,aa(int,fun(nat,int),power_power(int),Z),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),Z)),Na) ) ) ).

% of_int_power
tff(fact_2822_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [B2: int,W: nat,X: int] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W) = aa(int,A,ring_1_of_int(A),X) )
        <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W) = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
tff(fact_2823_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X: int,B2: int,W: nat] :
          ( ( aa(int,A,ring_1_of_int(A),X) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W) )
        <=> ( X = aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
tff(fact_2824_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: $o] : ( aa(int,A,ring_1_of_int(A),aa($o,int,zero_neq_one_of_bool(int),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_int_of_bool
tff(fact_2825_nat__of__bool,axiom,
    ! [P: $o] : ( aa(int,nat,nat2,aa($o,int,zero_neq_one_of_bool(int),P)) = aa($o,nat,zero_neq_one_of_bool(nat),P) ) ).

% nat_of_bool
tff(fact_2826_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,M))),aa(nat,nat,suc,Na))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),Na) ) ) ).

% bit_numeral_Bit0_Suc_iff
tff(fact_2827_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,M))),aa(nat,nat,suc,Na))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),Na) ) ) ).

% bit_numeral_Bit1_Suc_iff
tff(fact_2828_nat__1,axiom,
    aa(int,nat,nat2,one_one(int)) = aa(nat,nat,suc,zero_zero(nat)) ).

% nat_1
tff(fact_2829_nat__le__0,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int))
     => ( aa(int,nat,nat2,Z) = zero_zero(nat) ) ) ).

% nat_le_0
tff(fact_2830_nat__0__iff,axiom,
    ! [I2: int] :
      ( ( aa(int,nat,nat2,I2) = zero_zero(nat) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),zero_zero(int)) ) ).

% nat_0_iff
tff(fact_2831_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% zless_nat_conj
tff(fact_2832_nat__neg__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = zero_zero(nat) ) ).

% nat_neg_numeral
tff(fact_2833_log__eq__one,axiom,
    ! [A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),A2) = one_one(real) ) ) ) ).

% log_eq_one
tff(fact_2834_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),X)),aa(real,real,log(A2),Y))
          <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ) ) ).

% log_less_cancel_iff
tff(fact_2835_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),X)),one_one(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),A2) ) ) ) ).

% log_less_one_cancel_iff
tff(fact_2836_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,log(A2),X))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X) ) ) ) ).

% one_less_log_cancel_iff
tff(fact_2837_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),X)),zero_zero(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real)) ) ) ) ).

% log_less_zero_cancel_iff
tff(fact_2838_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,log(A2),X))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X) ) ) ) ).

% zero_less_log_cancel_iff
tff(fact_2839_nat__zminus__int,axiom,
    ! [Na: nat] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),Na))) = zero_zero(nat) ) ).

% nat_zminus_int
tff(fact_2840_int__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z),Z,zero_zero(int)) ) ).

% int_nat_eq
tff(fact_2841_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat,K: int] : ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K))) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ) ).

% of_nat_nat_take_bit_eq
tff(fact_2842_signed__take__bit__nonnegative__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) ) ).

% signed_take_bit_nonnegative_iff
tff(fact_2843_signed__take__bit__negative__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K)),zero_zero(int))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) ) ).

% signed_take_bit_negative_iff
tff(fact_2844_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),zero_zero(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int)) ) ) ).

% of_int_le_0_iff
tff(fact_2845_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) ) ) ).

% of_int_0_le_iff
tff(fact_2846_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),zero_zero(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),zero_zero(int)) ) ) ).

% of_int_less_0_iff
tff(fact_2847_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ) ).

% of_int_0_less_iff
tff(fact_2848_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),aa(num,A,numeral_numeral(A),Na))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),aa(num,int,numeral_numeral(int),Na)) ) ) ).

% of_int_le_numeral_iff
tff(fact_2849_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Na)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Na)),Z) ) ) ).

% of_int_numeral_le_iff
tff(fact_2850_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),aa(num,A,numeral_numeral(A),Na))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),aa(num,int,numeral_numeral(int),Na)) ) ) ).

% of_int_less_numeral_iff
tff(fact_2851_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),Na)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),Na)),Z) ) ) ).

% of_int_numeral_less_iff
tff(fact_2852_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),one_one(int)) ) ) ).

% of_int_le_1_iff
tff(fact_2853_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z) ) ) ).

% of_int_1_le_iff
tff(fact_2854_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),one_one(int)) ) ) ).

% of_int_less_1_iff
tff(fact_2855_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z) ) ) ).

% of_int_1_less_iff
tff(fact_2856_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ).

% zero_less_nat_eq
tff(fact_2857_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),X)),aa(real,real,log(A2),Y))
          <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ) ) ).

% log_le_cancel_iff
tff(fact_2858_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),X)),one_one(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),A2) ) ) ) ).

% log_le_one_cancel_iff
tff(fact_2859_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,log(A2),X))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X) ) ) ) ).

% one_le_log_cancel_iff
tff(fact_2860_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),X)),zero_zero(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real)) ) ) ) ).

% log_le_zero_cancel_iff
tff(fact_2861_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,log(A2),X))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X) ) ) ) ).

% zero_le_log_cancel_iff
tff(fact_2862_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: int,B2: int,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)) ) ) ).

% of_int_power_le_of_int_cancel_iff
tff(fact_2863_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,X: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W)),aa(int,A,ring_1_of_int(A),X))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)),X) ) ) ).

% of_int_le_of_int_power_cancel_iff
tff(fact_2864_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X: num,Na: nat,Y: int] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na) = aa(int,A,ring_1_of_int(A),Y) )
        <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na) = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
tff(fact_2865_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y: int,X: num,Na: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Y) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na) )
        <=> ( Y = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
tff(fact_2866_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: int,B2: int,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)) ) ) ).

% of_int_power_less_of_int_cancel_iff
tff(fact_2867_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,X: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W)),aa(int,A,ring_1_of_int(A),X))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)),X) ) ) ).

% of_int_less_of_int_power_cancel_iff
tff(fact_2868_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,Z)) = aa(int,A,ring_1_of_int(A),Z) ) ) ) ).

% of_nat_nat
tff(fact_2869_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Na: num] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,W))),aa(num,nat,numeral_numeral(nat),Na))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),pred_numeral(Na)) ) ) ).

% bit_numeral_simps(2)
tff(fact_2870_diff__nat__numeral,axiom,
    ! [V: num,V3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),aa(num,nat,numeral_numeral(nat),V3)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),V3))) ) ).

% diff_nat_numeral
tff(fact_2871_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W)))),aa(nat,nat,suc,Na))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),Na) ) ).

% bit_minus_numeral_Bit0_Suc_iff
tff(fact_2872_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Na: num] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,W))),aa(num,nat,numeral_numeral(nat),Na))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),pred_numeral(Na)) ) ) ).

% bit_numeral_simps(3)
tff(fact_2873_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,W)))),aa(nat,nat,suc,Na))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),Na) ) ).

% bit_minus_numeral_Bit1_Suc_iff
tff(fact_2874_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,X: num,Na: nat] :
      ( ( aa(int,nat,nat2,Y) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na) )
    <=> ( Y = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na) ) ) ).

% nat_eq_numeral_power_cancel_iff
tff(fact_2875_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,Na: nat,Y: int] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na) = aa(int,nat,nat2,Y) )
    <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na) = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
tff(fact_2876_sin__npi__int,axiom,
    ! [Na: int] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),Na))) = zero_zero(real) ) ).

% sin_npi_int
tff(fact_2877_dvd__nat__abs__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),aa(int,nat,nat2,aa(int,int,abs_abs(int),K)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,semiring_1_of_nat(int),Na)),K) ) ).

% dvd_nat_abs_iff
tff(fact_2878_nat__abs__dvd__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),Na)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(nat,int,semiring_1_of_nat(int),Na)) ) ).

% nat_abs_dvd_iff
tff(fact_2879_bit__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),zero_zero(nat))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% bit_0
tff(fact_2880_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z) ) ).

% one_less_nat_eq
tff(fact_2881_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),B2)) = aa(nat,real,semiring_1_of_nat(real),B2) ) ) ) ).

% log_pow_cancel
tff(fact_2882_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,Na: num] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,W)))),aa(num,nat,numeral_numeral(nat),Na))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),pred_numeral(Na)) ) ).

% bit_minus_numeral_int(1)
tff(fact_2883_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,Na: num] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,W)))),aa(num,nat,numeral_numeral(nat),Na))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),pred_numeral(Na)) ) ).

% bit_minus_numeral_int(2)
tff(fact_2884_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Na)
        <=> ( ( Na = zero_zero(nat) )
            & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% bit_mod_2_iff
tff(fact_2885_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: num,Na: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)),A2) ) ) ).

% numeral_power_le_of_int_cancel_iff
tff(fact_2886_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X: num,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)) ) ) ).

% of_int_le_numeral_power_cancel_iff
tff(fact_2887_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: num,Na: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)),A2) ) ) ).

% numeral_power_less_of_int_cancel_iff
tff(fact_2888_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X: num,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)) ) ) ).

% of_int_less_numeral_power_cancel_iff
tff(fact_2889_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [X: num,Na: nat,Y: int] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X))),Na) = aa(int,A,ring_1_of_int(A),Y) )
        <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X))),Na) = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
tff(fact_2890_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y: int,X: num,Na: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Y) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X))),Na) )
        <=> ( Y = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X))),Na) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
tff(fact_2891_nat__numeral__diff__1,axiom,
    ! [V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),one_one(int))) ) ).

% nat_numeral_diff_1
tff(fact_2892_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,A2)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)) ) ).

% nat_less_numeral_power_cancel_iff
tff(fact_2893_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,Na: nat,A2: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na)),aa(int,nat,nat2,A2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)),A2) ) ).

% numeral_power_less_nat_cancel_iff
tff(fact_2894_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,A2)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)) ) ).

% nat_le_numeral_power_cancel_iff
tff(fact_2895_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,Na: nat,A2: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),X)),Na)),aa(int,nat,nat2,A2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na)),A2) ) ).

% numeral_power_le_nat_cancel_iff
tff(fact_2896_sin__int__2pin,axiom,
    ! [Na: int] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),aa(int,real,ring_1_of_int(real),Na))) = zero_zero(real) ) ).

% sin_int_2pin
tff(fact_2897_cos__int__2pin,axiom,
    ! [Na: int] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),aa(int,real,ring_1_of_int(real),Na))) = one_one(real) ) ).

% cos_int_2pin
tff(fact_2898_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: num,Na: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X))),Na)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X))),Na)),A2) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
tff(fact_2899_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X: num,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X))),Na))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X))),Na)) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
tff(fact_2900_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,X: num,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X))),Na))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X))),Na)) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
tff(fact_2901_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: num,Na: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X))),Na)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),X))),Na)),A2) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
tff(fact_2902_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( ! [N: nat] :
              ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              | ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N) )
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),Na)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
              | aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Na) ) ) ) ) ).

% bit_disjunctive_add_iff
tff(fact_2903_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(nat,A,semiring_1_of_nat(A),M)),Na)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(nat,M),Na) ) ) ).

% bit_of_nat_iff_bit
tff(fact_2904_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),Na)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(num,nat,numeral_numeral(nat),M)),Na) ) ) ).

% bit_numeral_iff
tff(fact_2905_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
        ? [Z2: int] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z2)),X) ) ).

% ex_of_int_less
tff(fact_2906_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
        ? [Z2: int] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(int,A,ring_1_of_int(A),Z2)) ) ).

% ex_less_of_int
tff(fact_2907_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: int,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),X)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(int,A,ring_1_of_int(A),X)) ) ) ).

% mult_of_int_commute
tff(fact_2908_bit__and__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)),Na)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Na) ) ) ) ).

% bit_and_iff
tff(fact_2909_bit__and__int__iff,axiom,
    ! [K: int,L: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),Na)
    <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),Na) ) ) ).

% bit_and_int_iff
tff(fact_2910_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),M),A2)),Na)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
            & ( M != Na ) ) ) ) ).

% bit_unset_bit_iff
tff(fact_2911_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(nat,nat,suc,Na)) ) ).

% not_bit_1_Suc
tff(fact_2912_bit__1__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),Na)
        <=> ( Na = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_2913_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(num,nat,numeral_numeral(nat),Na)) ) ).

% bit_numeral_simps(1)
tff(fact_2914_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se2584673776208193580ke_bit(A,M),A2)),Na)
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ) ).

% bit_take_bit_iff
tff(fact_2915_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [B2: $o,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa($o,A,zero_neq_one_of_bool(A),B2)),Na)
        <=> ( (B2)
            & ( Na = zero_zero(nat) ) ) ) ) ).

% bit_of_bool_iff
tff(fact_2916_nat__zero__as__int,axiom,
    zero_zero(nat) = aa(int,nat,nat2,zero_zero(int)) ).

% nat_zero_as_int
tff(fact_2917_nat__numeral__as__int,axiom,
    ! [X4: num] : ( aa(num,nat,numeral_numeral(nat),X4) = aa(int,nat,nat2,aa(num,int,numeral_numeral(int),X4)) ) ).

% nat_numeral_as_int
tff(fact_2918_nat__mono,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),Y)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,X)),aa(int,nat,nat2,Y)) ) ).

% nat_mono
tff(fact_2919_ex__nat,axiom,
    ! [P: fun(nat,$o)] :
      ( ? [X_13: nat] : aa(nat,$o,P,X_13)
    <=> ? [X5: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X5)
          & aa(nat,$o,P,aa(int,nat,nat2,X5)) ) ) ).

% ex_nat
tff(fact_2920_all__nat,axiom,
    ! [P: fun(nat,$o)] :
      ( ! [X_13: nat] : aa(nat,$o,P,X_13)
    <=> ! [X5: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X5)
         => aa(nat,$o,P,aa(int,nat,nat2,X5)) ) ) ).

% all_nat
tff(fact_2921_eq__nat__nat__iff,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z4)
       => ( ( aa(int,nat,nat2,Z) = aa(int,nat,nat2,Z4) )
        <=> ( Z = Z4 ) ) ) ) ).

% eq_nat_nat_iff
tff(fact_2922_nat__one__as__int,axiom,
    one_one(nat) = aa(int,nat,nat2,one_one(int)) ).

% nat_one_as_int
tff(fact_2923_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Na: nat] :
          ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
         => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) ) ) ) ).

% signed_take_bit_eq_if_positive
tff(fact_2924_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,K: int] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(int,A,ring_1_of_int(A),K)) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ) ).

% take_bit_of_int
tff(fact_2925_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L)) ) ) ).

% of_int_and_eq
tff(fact_2926_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( aa(int,A,ring_1_of_int(A),K)
          = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),K)))),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,K))) ) ) ).

% of_int_of_nat
tff(fact_2927_unset__bit__nat__def,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se2638667681897837118et_bit(nat),M),Na) = aa(int,nat,nat2,aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),M),aa(nat,int,semiring_1_of_nat(int),Na))) ) ).

% unset_bit_nat_def
tff(fact_2928_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(int,A,ring_1_of_int(A),bit_se2239418461657761734s_mask(int,Na)) = bit_se2239418461657761734s_mask(A,Na) ) ) ).

% of_int_mask_eq
tff(fact_2929_nat__mask__eq,axiom,
    ! [Na: nat] : ( aa(int,nat,nat2,bit_se2239418461657761734s_mask(int,Na)) = bit_se2239418461657761734s_mask(nat,Na) ) ).

% nat_mask_eq
tff(fact_2930_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% nat_mono_iff
tff(fact_2931_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),M)),Z) ) ).

% zless_nat_eq_int_zless
tff(fact_2932_nat__le__iff,axiom,
    ! [X: int,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,X)),Na)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),aa(nat,int,semiring_1_of_nat(int),Na)) ) ).

% nat_le_iff
tff(fact_2933_nat__0__le,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z)) = Z ) ) ).

% nat_0_le
tff(fact_2934_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = Z )
    <=> ( ( M = aa(int,nat,nat2,Z) )
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) ) ) ).

% int_eq_iff
tff(fact_2935_bit__not__int__iff_H,axiom,
    ! [K: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int))),Na)
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) ) ).

% bit_not_int_iff'
tff(fact_2936_nat__int__add,axiom,
    ! [A2: nat,B2: nat] : ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2) ) ).

% nat_int_add
tff(fact_2937_int__minus,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) = aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),Na)),aa(nat,int,semiring_1_of_nat(int),M)))) ) ).

% int_minus
tff(fact_2938_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] : ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),W))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Z))) ) ).

% nat_abs_mult_distrib
tff(fact_2939_real__of__int__div4,axiom,
    ! [Na: int,X: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),X))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),Na)),aa(int,real,ring_1_of_int(real),X))) ).

% real_of_int_div4
tff(fact_2940_log__ln,axiom,
    ! [X: real] : ( aa(real,real,ln_ln(real),X) = aa(real,real,log(aa(real,real,exp(real),one_one(real))),X) ) ).

% log_ln
tff(fact_2941_real__of__int__div,axiom,
    ! [D2: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),Na)
     => ( aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),D2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),Na)),aa(int,real,ring_1_of_int(real),D2)) ) ) ).

% real_of_int_div
tff(fact_2942_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),Na),A2)
          = aa(A,A,
              aa(nat,fun(A,A),$ite(aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na),bit_se2638667681897837118et_bit(A),bit_se5668285175392031749et_bit(A)),Na),
              A2) ) ) ).

% flip_bit_eq_if
tff(fact_2943_and__nat__def,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),Na) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na))) ) ).

% and_nat_def
tff(fact_2944_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(B2),X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A2),X)),aa(real,real,log(A2),B2)) ) ) ) ).

% log_base_change
tff(fact_2945_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_nonneg
tff(fact_2946_of__int__leD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: int,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),Na))),X)
         => ( ( Na = zero_zero(int) )
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X) ) ) ) ).

% of_int_leD
tff(fact_2947_of__int__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_pos
tff(fact_2948_of__int__lessD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: int,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),Na))),X)
         => ( ( Na = zero_zero(int) )
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X) ) ) ) ).

% of_int_lessD
tff(fact_2949_log__of__power__eq,axiom,
    ! [M: nat,B2: real,Na: nat] :
      ( ( aa(nat,real,semiring_1_of_nat(real),M) = aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),Na) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,real,semiring_1_of_nat(real),Na) = aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M)) ) ) ) ).

% log_of_power_eq
tff(fact_2950_less__log__of__power,axiom,
    ! [B2: real,Na: nat,M: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),Na)),M)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,log(B2),M)) ) ) ).

% less_log_of_power
tff(fact_2951_floor__exists,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
        ? [Z2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z2)),X)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z2),one_one(int)))) ) ) ).

% floor_exists
tff(fact_2952_floor__exists1,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
        ? [X3: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),X3)),X)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),one_one(int))))
          & ! [Y3: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y3)),X)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),Y3),one_one(int)))) )
             => ( Y3 = X3 ) ) ) ) ).

% floor_exists1
tff(fact_2953_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_neg_numeral
tff(fact_2954_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% nat_less_eq_zless
tff(fact_2955_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,X: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(int,A,ring_1_of_int(A),X))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),Na)),X) ) ) ).

% of_nat_less_of_int_iff
tff(fact_2956_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),W)
        | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ) ).

% nat_le_eq_zle
tff(fact_2957_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M = aa(int,nat,nat2,W) )
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W),W = aa(nat,int,semiring_1_of_nat(int),M),M = zero_zero(nat)) ) ).

% nat_eq_iff2
tff(fact_2958_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( aa(int,nat,nat2,W) = M )
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W),W = aa(nat,int,semiring_1_of_nat(int),M),M = zero_zero(nat)) ) ).

% nat_eq_iff
tff(fact_2959_split__nat,axiom,
    ! [P: fun(nat,$o),I2: int] :
      ( aa(nat,$o,P,aa(int,nat,nat2,I2))
    <=> ( ! [N4: nat] :
            ( ( I2 = aa(nat,int,semiring_1_of_nat(int),N4) )
           => aa(nat,$o,P,N4) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),zero_zero(int))
         => aa(nat,$o,P,zero_zero(nat)) ) ) ) ).

% split_nat
tff(fact_2960_le__nat__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(int,nat,nat2,K))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),Na)),K) ) ) ).

% le_nat_iff
tff(fact_2961_nat__add__distrib,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z4)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4)) ) ) ) ).

% nat_add_distrib
tff(fact_2962_bit__imp__take__bit__positive,axiom,
    ! [Na: nat,M: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
     => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,M),K)) ) ) ).

% bit_imp_take_bit_positive
tff(fact_2963_nat__mult__distrib,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4)) ) ) ).

% nat_mult_distrib
tff(fact_2964_Suc__as__int,axiom,
    ! [X4: nat] : ( aa(nat,nat,suc,X4) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X4)),one_one(int))) ) ).

% Suc_as_int
tff(fact_2965_nat__diff__distrib_H,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),Y)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,X)),aa(int,nat,nat2,Y)) ) ) ) ).

% nat_diff_distrib'
tff(fact_2966_nat__diff__distrib,axiom,
    ! [Z4: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z4)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z4),Z)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4)) ) ) ) ).

% nat_diff_distrib
tff(fact_2967_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ).

% nat_abs_triangle_ineq
tff(fact_2968_nat__div__distrib,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),X),Y)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,X)),aa(int,nat,nat2,Y)) ) ) ).

% nat_div_distrib
tff(fact_2969_nat__div__distrib_H,axiom,
    ! [Y: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),X),Y)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,X)),aa(int,nat,nat2,Y)) ) ) ).

% nat_div_distrib'
tff(fact_2970_int__le__real__less,axiom,
    ! [Na: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Na),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(int,real,ring_1_of_int(real),Na)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),M)),one_one(real))) ) ).

% int_le_real_less
tff(fact_2971_int__less__real__le,axiom,
    ! [Na: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Na),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),Na)),one_one(real))),aa(int,real,ring_1_of_int(real),M)) ) ).

% int_less_real_le
tff(fact_2972_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_concat_bit(M,K),L)),Na)
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
          & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) )
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
          & aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) ) ) ) ).

% bit_concat_bit_iff
tff(fact_2973_nat__power__eq,axiom,
    ! [Z: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,nat,nat2,aa(nat,int,aa(int,fun(nat,int),power_power(int),Z),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(int,nat,nat2,Z)),Na) ) ) ).

% nat_power_eq
tff(fact_2974_nat__mod__distrib,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => ( aa(int,nat,nat2,modulo_modulo(int,X,Y)) = modulo_modulo(nat,aa(int,nat,nat2,X),aa(int,nat,nat2,Y)) ) ) ) ).

% nat_mod_distrib
tff(fact_2975_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( sin(real,X) = zero_zero(real) )
    <=> ? [I: int] : ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I)),pi) ) ) ).

% sin_zero_iff_int2
tff(fact_2976_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,abs_abs(int),K)),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% div_abs_eq_div_nat
tff(fact_2977_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% mod_abs_eq_div_nat
tff(fact_2978_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),X)),aa(int,real,ring_1_of_int(real),D2)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),X),D2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),modulo_modulo(int,X,D2))),aa(int,real,ring_1_of_int(real),D2))) ) ).

% real_of_int_div_aux
tff(fact_2979_nat__take__bit__eq,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),aa(int,nat,nat2,K)) ) ) ).

% nat_take_bit_eq
tff(fact_2980_take__bit__nat__eq,axiom,
    ! [K: int,Na: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ) ).

% take_bit_nat_eq
tff(fact_2981_signed__take__bit__eq__concat__bit,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,Na),K) = aa(int,int,bit_concat_bit(Na,K),aa(int,int,uminus_uminus(int),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)))) ) ).

% signed_take_bit_eq_concat_bit
tff(fact_2982_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat,A2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) = zero_zero(A) )
         => ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ).

% exp_eq_0_imp_not_bit
tff(fact_2983_bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,suc,Na))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Na) ) ) ).

% bit_Suc
tff(fact_2984_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( ! [N: nat] :
              ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) )
         => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 ) ) ) ).

% bit_iff_idd_imp_stable
tff(fact_2985_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% stable_imp_bit_iff_odd
tff(fact_2986_nat__2,axiom,
    aa(int,nat,nat2,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% nat_2
tff(fact_2987_log__mult,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
           => ( aa(real,real,log(A2),aa(real,real,aa(real,fun(real,real),times_times(real),X),Y)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(A2),X)),aa(real,real,log(A2),Y)) ) ) ) ) ) ).

% log_mult
tff(fact_2988_log__divide,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
           => ( aa(real,real,log(A2),aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(A2),X)),aa(real,real,log(A2),Y)) ) ) ) ) ) ).

% log_divide
tff(fact_2989_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N: nat] :
          ( ! [M2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),M2)
              <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) )
         => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))
              <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) ) ) ).

% int_bit_bound
tff(fact_2990_le__log__of__power,axiom,
    ! [B2: real,Na: nat,M: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),Na)),M)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,log(B2),M)) ) ) ).

% le_log_of_power
tff(fact_2991_log__base__pow,axiom,
    ! [A2: real,Na: nat,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( aa(real,real,log(aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),Na)),X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A2),X)),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ).

% log_base_pow
tff(fact_2992_log__nat__power,axiom,
    ! [X: real,B2: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,log(B2),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,log(B2),X)) ) ) ).

% log_nat_power
tff(fact_2993_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(nat,nat,suc,aa(int,nat,nat2,Z)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ) ).

% Suc_nat_eq_nat_zadd1
tff(fact_2994_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),M)
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(nat,int,semiring_1_of_nat(int),M)) ) ) ).

% nat_less_iff
tff(fact_2995_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z4: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z4)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z))),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z4))) ) ) ).

% nat_mult_distrib_neg
tff(fact_2996_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2)) ) ).

% nat_abs_int_diff
tff(fact_2997_real__of__int__div2,axiom,
    ! [Na: int,X: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),Na)),aa(int,real,ring_1_of_int(real),X))),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),X)))) ).

% real_of_int_div2
tff(fact_2998_real__of__int__div3,axiom,
    ! [Na: int,X: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),Na)),aa(int,real,ring_1_of_int(real),X))),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),divide_divide(int),Na),X)))),one_one(real)) ).

% real_of_int_div3
tff(fact_2999_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na))) ) ) ).

% bit_iff_odd
tff(fact_3000_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = zero_zero(A) )
        <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ).

% and_exp_eq_0_iff_not_bit
tff(fact_3001_log__of__power__less,axiom,
    ! [M: nat,B2: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),M)),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),Na))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ) ).

% log_of_power_less
tff(fact_3002_log2__of__power__eq,axiom,
    ! [M: nat,Na: nat] :
      ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) )
     => ( aa(nat,real,semiring_1_of_nat(real),Na) = aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),M)) ) ) ).

% log2_of_power_eq
tff(fact_3003_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
         => ( ( B2 != one_one(real) )
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
             => ( aa(real,real,log(A2),X) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),B2)),aa(real,real,ln_ln(real),A2))),aa(real,real,log(B2),X)) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
tff(fact_3004_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(int,A,ring_1_of_int(A),K))
        <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) ) ) ).

% even_of_int_iff
tff(fact_3005_bit__int__def,axiom,
    ! [K: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)
    <=> ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))) ) ).

% bit_int_def
tff(fact_3006_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(int,nat,nat2,Z)),M)
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z),aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Z),aa(nat,int,semiring_1_of_nat(int),M)),M = zero_zero(nat)) ) ).

% nat_dvd_iff
tff(fact_3007_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),Na)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
              | ( Na = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_3008_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),Na)
              | ( Na = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_3009_log__of__power__le,axiom,
    ! [M: nat,B2: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),M)),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),Na))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ) ).

% log_of_power_le
tff(fact_3010_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( cos(real,X) = one_one(real) )
    <=> ? [X5: int] : ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),X5)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),pi) ) ) ).

% cos_one_2pi_int
tff(fact_3011_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( ! [J3: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,suc,J3))
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),Na)
          <=> $ite(Na = zero_zero(nat),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)),Na)) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_3012_bit__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
        <=> $ite(Na = zero_zero(nat),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2),aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))) ) ) ).

% bit_rec
tff(fact_3013_less__log2__of__power,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),M)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),M))) ) ).

% less_log2_of_power
tff(fact_3014_le__log2__of__power,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),M)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),M))) ) ).

% le_log2_of_power
tff(fact_3015_even__nat__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(int,nat,nat2,K))
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) ) ) ).

% even_nat_iff
tff(fact_3016_set__bit__eq,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Na),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa($o,int,zero_neq_one_of_bool(int),~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))) ) ).

% set_bit_eq
tff(fact_3017_unset__bit__eq,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Na),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))) ) ).

% unset_bit_eq
tff(fact_3018_log2__of__power__less,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ).

% log2_of_power_less
tff(fact_3019_take__bit__Suc__from__most,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,Na)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)))),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)) ) ).

% take_bit_Suc_from_most
tff(fact_3020_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] : ( aa(real,real,arccos,cos(real,Theta)) != aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Theta),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),K2)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)))) ) ).

% arccos_cos_eq_abs_2pi
tff(fact_3021_log2__of__power__le,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ).

% log2_of_power_le
tff(fact_3022_log__base__10__eq2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))),X) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,one2))))),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),X)) ) ) ).

% log_base_10_eq2
tff(fact_3023_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( cos(real,X) = zero_zero(real) )
    <=> ? [I: int] :
          ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),I)
          & ( X = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I)),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ) ).

% cos_zero_iff_int
tff(fact_3024_round__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),Y))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))
           => ( archimedean_round(A,X) = Y ) ) ) ) ).

% round_unique
tff(fact_3025_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Na)),one_one(int)) )
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),Na)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)))) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
tff(fact_3026_round__unique_H,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(int,A,ring_1_of_int(A),Na)))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))
         => ( archimedean_round(A,X) = Na ) ) ) ).

% round_unique'
tff(fact_3027_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X))),X))),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ).

% of_int_round_abs_le
tff(fact_3028_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),Na)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat))))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
         => ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),Na)),one_one(int)) ) ) ) ) ).

% ceiling_log_nat_eq_if
tff(fact_3029_ceiling__log2__div2,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Na))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat)))))),one_one(int)) ) ) ).

% ceiling_log2_div2
tff(fact_3030_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X)) = X )
        <=> ? [N4: int] : ( X = aa(int,A,ring_1_of_int(A),N4) ) ) ) ).

% of_int_ceiling_cancel
tff(fact_3031_ceiling__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,zero_zero(A)) = zero_zero(int) ) ) ).

% ceiling_zero
tff(fact_3032_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% ceiling_numeral
tff(fact_3033_ceiling__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,one_one(A)) = one_one(int) ) ) ).

% ceiling_one
tff(fact_3034_round__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,zero_zero(A)) = zero_zero(int) ) ) ).

% round_0
tff(fact_3035_round__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Na: num] : ( archimedean_round(A,aa(num,A,numeral_numeral(A),Na)) = aa(num,int,numeral_numeral(int),Na) ) ) ).

% round_numeral
tff(fact_3036_round__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,one_one(A)) = one_one(int) ) ) ).

% round_1
tff(fact_3037_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X)),Z) ) ) ).

% ceiling_add_of_int
tff(fact_3038_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X)),Z) ) ) ).

% ceiling_diff_of_int
tff(fact_3039_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A)) ) ) ).

% ceiling_le_zero
tff(fact_3040_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X) ) ) ).

% zero_less_ceiling
tff(fact_3041_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(num,A,numeral_numeral(A),V)) ) ) ).

% ceiling_le_numeral
tff(fact_3042_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A)) ) ) ).

% ceiling_less_one
tff(fact_3043_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X) ) ) ).

% one_le_ceiling
tff(fact_3044_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),V)),X) ) ) ).

% numeral_less_ceiling
tff(fact_3045_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),one_one(A)) ) ) ).

% ceiling_le_one
tff(fact_3046_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X) ) ) ).

% one_less_ceiling
tff(fact_3047_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_add_numeral
tff(fact_3048_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_neg_numeral
tff(fact_3049_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_3050_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_diff_numeral
tff(fact_3051_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X)),one_one(int)) ) ) ).

% ceiling_diff_one
tff(fact_3052_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: num,Na: nat] : ( archimedean_ceiling(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na)) = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na) ) ) ).

% ceiling_numeral_power
tff(fact_3053_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Na: num] : ( archimedean_round(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na)) ) ) ).

% round_neg_numeral
tff(fact_3054_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,archimedean_ceiling(real,X))),A2)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(nat,real,semiring_1_of_nat(real),A2)) ) ).

% nat_ceiling_le_eq
tff(fact_3055_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ).

% ceiling_less_zero
tff(fact_3056_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),X) ) ) ).

% zero_le_ceiling
tff(fact_3057_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archimedean_ceiling(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),A2))),aa(num,int,numeral_numeral(int),B2))) ) ).

% ceiling_divide_eq_div_numeral
tff(fact_3058_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))) ) ) ).

% ceiling_less_numeral
tff(fact_3059_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X) ) ) ).

% numeral_le_ceiling
tff(fact_3060_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% ceiling_le_neg_numeral
tff(fact_3061_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),X) ) ) ).

% neg_numeral_less_ceiling
tff(fact_3062_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archimedean_ceiling(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),A2)),aa(num,int,numeral_numeral(int),B2))) ) ).

% ceiling_minus_divide_eq_div_numeral
tff(fact_3063_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_3064_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X) ) ) ).

% neg_numeral_le_ceiling
tff(fact_3065_bit__Suc__0__iff,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),Na)
    <=> ( Na = zero_zero(nat) ) ) ).

% bit_Suc_0_iff
tff(fact_3066_not__bit__Suc__0__Suc,axiom,
    ! [Na: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,suc,Na)) ).

% not_bit_Suc_0_Suc
tff(fact_3067_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X)),archimedean_ceiling(A,Y))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ).

% ceiling_less_cancel
tff(fact_3068_not__bit__Suc__0__numeral,axiom,
    ! [Na: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),Na)) ).

% not_bit_Suc_0_numeral
tff(fact_3069_ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),A2))
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,X)),A2) ) ) ).

% ceiling_le
tff(fact_3070_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),X) ) ) ).

% less_ceiling_iff
tff(fact_3071_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))),aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X)),archimedean_ceiling(A,Y))) ) ).

% ceiling_add_le
tff(fact_3072_real__nat__ceiling__ge,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(nat,real,semiring_1_of_nat(real),aa(int,nat,nat2,archimedean_ceiling(real,X)))) ).

% real_nat_ceiling_ge
tff(fact_3073_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,R2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),R2),one_one(A))) ) ).

% of_int_ceiling_le_add_one
tff(fact_3074_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,R2))),one_one(A))),R2) ) ).

% of_int_ceiling_diff_one_le
tff(fact_3075_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: int,B2: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),A2)),aa(int,A,ring_1_of_int(A),B2))) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),A2)),B2)) ) ) ).

% ceiling_divide_eq_div
tff(fact_3076_bit__nat__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(int,nat,nat2,K)),Na)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) ) ) ).

% bit_nat_iff
tff(fact_3077_ceiling__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,$o),T2: A] :
          ( aa(int,$o,P,archimedean_ceiling(A,T2))
        <=> ! [I: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),I)),one_one(A))),T2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),aa(int,A,ring_1_of_int(A),I)) )
             => aa(int,$o,P,I) ) ) ) ).

% ceiling_split
tff(fact_3078_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A2: int] :
          ( ( archimedean_ceiling(A,X) = A2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),A2)),one_one(A))),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),A2)) ) ) ) ).

% ceiling_eq_iff
tff(fact_3079_ceiling__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),Z))
           => ( archimedean_ceiling(A,X) = Z ) ) ) ) ).

% ceiling_unique
tff(fact_3080_ceiling__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X))),one_one(A))),X)
          & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X))) ) ) ).

% ceiling_correct
tff(fact_3081_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A2)),archimedean_ceiling(A,B2))) ) ) ) ).

% mult_ceiling_le
tff(fact_3082_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,X)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))) ) ) ).

% ceiling_less_iff
tff(fact_3083_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),archimedean_ceiling(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),X) ) ) ).

% le_ceiling_iff
tff(fact_3084_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q4: A,P3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P3),Q4)))),Q4)) ) ) ).

% ceiling_divide_upper
tff(fact_3085_bit__nat__def,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,M),Na)
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ) ).

% bit_nat_def
tff(fact_3086_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: A,M: int] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),aa(int,A,ring_1_of_int(A),archimedean_round(A,Z))))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),aa(int,A,ring_1_of_int(A),M)))) ) ).

% round_diff_minimal
tff(fact_3087_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q4: A,P3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P3),Q4)))),one_one(A))),Q4)),P3) ) ) ).

% ceiling_divide_lower
tff(fact_3088_ceiling__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Na: int,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Na)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Na)),one_one(A)))
           => ( archimedean_ceiling(A,X) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Na),one_one(int)) ) ) ) ) ).

% ceiling_eq
tff(fact_3089_of__int__round__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X))),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ).

% of_int_round_le
tff(fact_3090_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X))) ) ).

% of_int_round_ge
tff(fact_3091_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X))) ) ).

% of_int_round_gt
tff(fact_3092_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( ( archimedean_ceiling(real,aa(real,real,log(B2),X)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),K)),one_one(int)) )
        <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,B2,aa(nat,real,semiring_1_of_nat(real),K))),X)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),powr(real,B2,aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))))) ) ) ) ) ).

% ceiling_log_eq_powr_iff
tff(fact_3093_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),Na) )
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),Na)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)))) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
tff(fact_3094_floor__log__nat__eq__if,axiom,
    ! [B2: nat,Na: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),Na)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat))))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),B2)
         => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),Na) ) ) ) ) ).

% floor_log_nat_eq_if
tff(fact_3095_powr__int,axiom,
    ! [X: real,I2: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( powr(real,X,aa(int,real,ring_1_of_int(real),I2))
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I2),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(int,nat,nat2,I2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),I2))))) ) ) ).

% powr_int
tff(fact_3096_floor__log2__div2,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),Na))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))),one_one(int)) ) ) ).

% floor_log2_div2
tff(fact_3097_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [W: A,Z: A] :
          ( ( powr(A,W,Z) = zero_zero(A) )
        <=> ( W = zero_zero(A) ) ) ) ).

% powr_eq_0_iff
tff(fact_3098_powr__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Z: A] : ( powr(A,zero_zero(A),Z) = zero_zero(A) ) ) ).

% powr_0
tff(fact_3099_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [A2: A] : ( powr(A,one_one(A),A2) = one_one(A) ) ) ).

% powr_one_eq_one
tff(fact_3100_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X)) = X )
        <=> ? [N4: int] : ( X = aa(int,A,ring_1_of_int(A),N4) ) ) ) ).

% of_int_floor_cancel
tff(fact_3101_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X: A] :
          ( powr(A,X,zero_zero(A))
          = $ite(X = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% powr_zero_eq_one
tff(fact_3102_floor__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,zero_zero(A)) = zero_zero(int) ) ) ).

% floor_zero
tff(fact_3103_floor__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% floor_numeral
tff(fact_3104_powr__gt__zero,axiom,
    ! [X: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),powr(real,X,A2))
    <=> ( X != zero_zero(real) ) ) ).

% powr_gt_zero
tff(fact_3105_floor__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,one_one(A)) = one_one(int) ) ) ).

% floor_one
tff(fact_3106_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,A2,X)),zero_zero(real))
    <=> ( A2 = zero_zero(real) ) ) ).

% powr_nonneg_iff
tff(fact_3107_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X,A2)),powr(real,X,B2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2) ) ) ).

% powr_less_cancel_iff
tff(fact_3108_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( ( powr(real,A2,X) = one_one(real) )
      <=> ( X = zero_zero(real) ) ) ) ).

% powr_eq_one_iff
tff(fact_3109_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( powr(real,X,one_one(real)) = X )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% powr_one_gt_zero_iff
tff(fact_3110_powr__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( powr(real,X,one_one(real)) = X ) ) ).

% powr_one
tff(fact_3111_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X,A2)),powr(real,X,B2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2) ) ) ).

% powr_le_cancel_iff
tff(fact_3112_numeral__powr__numeral__real,axiom,
    ! [M: num,Na: num] : ( powr(real,aa(num,real,numeral_numeral(real),M),aa(num,real,numeral_numeral(real),Na)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),M)),aa(num,nat,numeral_numeral(nat),Na)) ) ).

% numeral_powr_numeral_real
tff(fact_3113_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X)),Z) ) ) ).

% floor_diff_of_int
tff(fact_3114_zero__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X) ) ) ).

% zero_le_floor
tff(fact_3115_floor__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),zero_zero(A)) ) ) ).

% floor_less_zero
tff(fact_3116_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),V)),X) ) ) ).

% numeral_le_floor
tff(fact_3117_zero__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X) ) ) ).

% zero_less_floor
tff(fact_3118_floor__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),one_one(A)) ) ) ).

% floor_le_zero
tff(fact_3119_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(num,A,numeral_numeral(A),V)) ) ) ).

% floor_less_numeral
tff(fact_3120_one__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X) ) ) ).

% one_le_floor
tff(fact_3121_floor__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),one_one(A)) ) ) ).

% floor_less_one
tff(fact_3122_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_neg_numeral
tff(fact_3123_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_diff_numeral
tff(fact_3124_floor__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X)),one_one(int)) ) ) ).

% floor_diff_one
tff(fact_3125_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: num,Na: nat] : ( archim6421214686448440834_floor(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),X)),Na)) = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),X)),Na) ) ) ).

% floor_numeral_power
tff(fact_3126_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),powr(real,A2,Y)) = Y ) ) ) ).

% log_powr_cancel
tff(fact_3127_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( powr(real,A2,aa(real,real,log(A2),X)) = X ) ) ) ) ).

% powr_log_cancel
tff(fact_3128_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),A2)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_divide_eq_div_numeral
tff(fact_3129_powr__numeral,axiom,
    ! [X: real,Na: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( powr(real,X,aa(num,real,numeral_numeral(real),Na)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),Na)) ) ) ).

% powr_numeral
tff(fact_3130_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X) ) ) ).

% numeral_less_floor
tff(fact_3131_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))) ) ) ).

% floor_le_numeral
tff(fact_3132_one__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X) ) ) ).

% one_less_floor
tff(fact_3133_floor__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% floor_le_one
tff(fact_3134_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),X) ) ) ).

% neg_numeral_le_floor
tff(fact_3135_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% floor_less_neg_numeral
tff(fact_3136_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),one_one(int)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_one_divide_eq_div_numeral
tff(fact_3137_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),A2)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),A2))),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_divide_eq_div_numeral
tff(fact_3138_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X) ) ) ).

% neg_numeral_less_floor
tff(fact_3139_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))) ) ) ).

% floor_le_neg_numeral
tff(fact_3140_square__powr__half,axiom,
    ! [X: real] : ( powr(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(real,real,abs_abs(real),X) ) ).

% square_powr_half
tff(fact_3141_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),B2)))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_one_divide_eq_div_numeral
tff(fact_3142_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ).

% floor_less_cancel
tff(fact_3143_powr__non__neg,axiom,
    ! [A2: real,X: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,A2,X)),zero_zero(real)) ).

% powr_non_neg
tff(fact_3144_powr__less__mono2__neg,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,Y,A2)),powr(real,X,A2)) ) ) ) ).

% powr_less_mono2_neg
tff(fact_3145_powr__ge__pzero,axiom,
    ! [X: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),powr(real,X,Y)) ).

% powr_ge_pzero
tff(fact_3146_powr__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X,A2)),powr(real,Y,A2)) ) ) ) ).

% powr_mono2
tff(fact_3147_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X,A2)),powr(real,X,B2)) ) ) ).

% powr_less_mono
tff(fact_3148_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X,A2)),powr(real,X,B2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2) ) ) ).

% powr_less_cancel
tff(fact_3149_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X,A2)),powr(real,X,B2)) ) ) ).

% powr_mono
tff(fact_3150_floor__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,X)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% floor_less_iff
tff(fact_3151_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,Y,A2)),powr(real,X,A2)) ) ) ) ).

% powr_mono2'
tff(fact_3152_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,X,A2)),powr(real,Y,A2)) ) ) ) ).

% powr_less_mono2
tff(fact_3153_le__floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))) ) ).

% le_floor_add
tff(fact_3154_powr__inj,axiom,
    ! [A2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( ( powr(real,A2,X) = powr(real,A2,Y) )
        <=> ( X = Y ) ) ) ) ).

% powr_inj
tff(fact_3155_gr__one__powr,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),powr(real,X,Y)) ) ) ).

% gr_one_powr
tff(fact_3156_floor__add__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),Z) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% floor_add_int
tff(fact_3157_int__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),archim6421214686448440834_floor(A,X)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),X)) ) ) ).

% int_add_floor
tff(fact_3158_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),powr(real,X,A2)) ) ) ).

% ge_one_powr_ge_zero
tff(fact_3159_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X,A2)),powr(real,Y,B2)) ) ) ) ) ).

% powr_mono_both
tff(fact_3160_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,X,A2)),one_one(real)) ) ) ) ).

% powr_le1
tff(fact_3161_powr__divide,axiom,
    ! [X: real,Y: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( powr(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y),A2) = aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,X,A2)),powr(real,Y,A2)) ) ) ) ).

% powr_divide
tff(fact_3162_powr__mult,axiom,
    ! [X: real,Y: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( powr(real,aa(real,real,aa(real,fun(real,real),times_times(real),X),Y),A2) = aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,X,A2)),powr(real,Y,A2)) ) ) ) ).

% powr_mult
tff(fact_3163_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [K: int,L: int] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) ) ) ).

% floor_divide_of_int_eq
tff(fact_3164_floor__power,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Na: nat] :
          ( ( X = aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X)) )
         => ( archim6421214686448440834_floor(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) = aa(nat,int,aa(int,fun(nat,int),power_power(int),archim6421214686448440834_floor(A,X)),Na) ) ) ) ).

% floor_power
tff(fact_3165_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2 != zero_zero(real) )
     => ( aa(real,real,log(powr(real,A2,B2)),X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(A2),X)),B2) ) ) ).

% log_base_powr
tff(fact_3166_ln__powr,axiom,
    ! [X: real,Y: real] :
      ( ( X != zero_zero(real) )
     => ( aa(real,real,ln_ln(real),powr(real,X,Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y),aa(real,real,ln_ln(real),X)) ) ) ).

% ln_powr
tff(fact_3167_log__powr,axiom,
    ! [X: real,B2: real,Y: real] :
      ( ( X != zero_zero(real) )
     => ( aa(real,real,log(B2),powr(real,X,Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y),aa(real,real,log(B2),X)) ) ) ).

% log_powr
tff(fact_3168_powr__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X: A,A2: A,B2: A] : ( powr(A,X,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),powr(A,X,A2)),powr(A,X,B2)) ) ) ).

% powr_add
tff(fact_3169_powr__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [W: A,Z1: A,Z22: A] : ( powr(A,W,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z1),Z22)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),powr(A,W,Z1)),powr(A,W,Z22)) ) ) ).

% powr_diff
tff(fact_3170_of__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),R2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,archim6421214686448440834_floor(A,R2)))),R2) ) ) ).

% of_nat_floor
tff(fact_3171_one__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),one_one(int)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))) ) ) ).

% one_add_floor
tff(fact_3172_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(B2),X)) = K )
        <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,B2,aa(int,real,ring_1_of_int(real),K))),X)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),powr(real,B2,aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))))) ) ) ) ) ).

% floor_log_eq_powr_iff
tff(fact_3173_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,archim6421214686448440834_floor(A,A2))),aa(int,nat,nat2,archim6421214686448440834_floor(A,B2)))),aa(int,nat,nat2,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))) ) ).

% le_mult_nat_floor
tff(fact_3174_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [M: nat,Na: nat] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na))) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)) ) ) ).

% floor_divide_of_nat_eq
tff(fact_3175_nat__floor__neg,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
     => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X)) = zero_zero(nat) ) ) ).

% nat_floor_neg
tff(fact_3176_powr__realpow,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( powr(real,X,aa(nat,real,semiring_1_of_nat(real),Na)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na) ) ) ).

% powr_realpow
tff(fact_3177_floor__eq3,axiom,
    ! [Na: nat,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),Na)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Na)))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X)) = Na ) ) ) ).

% floor_eq3
tff(fact_3178_less__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,log(B2),X))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,B2,Y)),X) ) ) ) ).

% less_log_iff
tff(fact_3179_log__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),X)),Y)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),powr(real,B2,Y)) ) ) ) ).

% log_less_iff
tff(fact_3180_less__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),powr(real,B2,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),X)),Y) ) ) ) ).

% less_powr_iff
tff(fact_3181_powr__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),powr(real,B2,Y)),X)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,log(B2),X)) ) ) ) ).

% powr_less_iff
tff(fact_3182_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),X)),A2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),aa(int,nat,nat2,archim6421214686448440834_floor(real,A2))) ) ).

% le_nat_floor
tff(fact_3183_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( archimedean_ceiling(A,X)
          = $ite(X = aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,X),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),one_one(int))) ) ) ).

% ceiling_altdef
tff(fact_3184_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X)),archim6421214686448440834_floor(A,X))),one_one(int)) ) ).

% ceiling_diff_floor_le_1
tff(fact_3185_real__of__int__floor__add__one__gt,axiom,
    ! [R2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),R2),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2))),one_one(real))) ).

% real_of_int_floor_add_one_gt
tff(fact_3186_floor__eq,axiom,
    ! [Na: int,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(int,real,ring_1_of_int(real),Na)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),Na)),one_one(real)))
       => ( archim6421214686448440834_floor(real,X) = Na ) ) ) ).

% floor_eq
tff(fact_3187_real__of__int__floor__add__one__ge,axiom,
    ! [R2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),R2),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2))),one_one(real))) ).

% real_of_int_floor_add_one_ge
tff(fact_3188_real__of__int__floor__gt__diff__one,axiom,
    ! [R2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),one_one(real))),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2))) ).

% real_of_int_floor_gt_diff_one
tff(fact_3189_real__of__int__floor__ge__diff__one,axiom,
    ! [R2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),one_one(real))),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R2))) ).

% real_of_int_floor_ge_diff_one
tff(fact_3190_floor__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A)))
           => ( archim6421214686448440834_floor(A,X) = Z ) ) ) ) ).

% floor_unique
tff(fact_3191_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A2: int] :
          ( ( archim6421214686448440834_floor(A,X) = A2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A2)),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),A2)),one_one(A))) ) ) ) ).

% floor_eq_iff
tff(fact_3192_floor__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,$o),T2: A] :
          ( aa(int,$o,P,archim6421214686448440834_floor(A,T2))
        <=> ! [I: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),I)),T2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),I)),one_one(A))) )
             => aa(int,$o,P,I) ) ) ) ).

% floor_split
tff(fact_3193_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [X: A,A2: A] : ( powr(A,X,aa(A,A,uminus_uminus(A),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),powr(A,X,A2)) ) ) ).

% powr_minus_divide
tff(fact_3194_le__mult__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A2)),archim6421214686448440834_floor(A,B2))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ) ).

% le_mult_floor
tff(fact_3195_less__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,X: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),archim6421214686448440834_floor(A,X))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),X) ) ) ).

% less_floor_iff
tff(fact_3196_floor__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,X)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))) ) ) ).

% floor_le_iff
tff(fact_3197_floor__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X))),X)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),one_one(int)))) ) ) ).

% floor_correct
tff(fact_3198_powr__neg__one,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( powr(real,X,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X) ) ) ).

% powr_neg_one
tff(fact_3199_powr__mult__base,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),X),powr(real,X,Y)) = powr(real,X,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Y)) ) ) ).

% powr_mult_base
tff(fact_3200_floor__eq4,axiom,
    ! [Na: nat,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Na)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Na)))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,X)) = Na ) ) ) ).

% floor_eq4
tff(fact_3201_powr__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,B2,Y)),X)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,log(B2),X)) ) ) ) ).

% powr_le_iff
tff(fact_3202_le__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),powr(real,B2,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),X)),Y) ) ) ) ).

% le_powr_iff
tff(fact_3203_log__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),X)),Y)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),powr(real,B2,Y)) ) ) ) ).

% log_le_iff
tff(fact_3204_le__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,log(B2),X))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,B2,Y)),X) ) ) ) ).

% le_log_iff
tff(fact_3205_floor__eq2,axiom,
    ! [Na: int,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(int,real,ring_1_of_int(real),Na)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),Na)),one_one(real)))
       => ( archim6421214686448440834_floor(real,X) = Na ) ) ) ).

% floor_eq2
tff(fact_3206_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),B2)
     => ( archim6421214686448440834_floor(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),aa(int,real,ring_1_of_int(real),B2))) = aa(int,int,aa(int,fun(int,int),divide_divide(int),archim6421214686448440834_floor(real,A2)),B2) ) ) ).

% floor_divide_real_eq_div
tff(fact_3207_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q4: A,P3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P3),Q4)))),Q4)),P3) ) ) ).

% floor_divide_lower
tff(fact_3208_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),X)),aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,X,A2)),A2)) ) ) ).

% ln_powr_bound
tff(fact_3209_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),powr(real,aa(real,real,ln_ln(real),X),A2)),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,A2,A2)),X)) ) ) ).

% ln_powr_bound2
tff(fact_3210_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(B2),X)),Y) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),X),powr(real,B2,Y))) ) ) ) ) ).

% log_add_eq_powr
tff(fact_3211_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),Y),aa(real,real,log(B2),X)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,B2,Y)),X)) ) ) ) ) ).

% add_log_eq_powr
tff(fact_3212_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),aa(real,real,log(B2),X)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),divide_divide(real),powr(real,B2,Y)),X)) ) ) ) ) ).

% minus_log_eq_powr
tff(fact_3213_powr__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X: A,A2: A] :
          ( powr(A,X,A2)
          = $ite(X = zero_zero(A),zero_zero(A),aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,ln_ln(A),X)))) ) ) ).

% powr_def
tff(fact_3214_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q4: A,P3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),P3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),P3),Q4)))),one_one(A))),Q4)) ) ) ).

% floor_divide_upper
tff(fact_3215_round__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_round(A,X) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% round_def
tff(fact_3216_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(B2),X)),Y) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),X),powr(real,B2,aa(real,real,uminus_uminus(real),Y)))) ) ) ) ) ).

% log_minus_eq_powr
tff(fact_3217_powr__half__sqrt,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( powr(real,X,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(real,real,sqrt,X) ) ) ).

% powr_half_sqrt
tff(fact_3218_powr__neg__numeral,axiom,
    ! [X: real,Na: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( powr(real,X,aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),Na))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),Na))) ) ) ).

% powr_neg_numeral
tff(fact_3219_arcosh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X: A] : ( aa(A,A,arcosh(A),X) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),powr(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)),real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))))) ) ) ).

% arcosh_def
tff(fact_3220_round__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( archimedean_round(A,X)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),archimedean_frac(A,X)),archimedean_ceiling(A,X),archim6421214686448440834_floor(A,X)) ) ) ).

% round_altdef
tff(fact_3221_arsinh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [X: A] : ( aa(A,A,arsinh(A),X) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),powr(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)),real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))))) ) ) ).

% arsinh_def
tff(fact_3222_powr__real__of__int,axiom,
    ! [X: real,Na: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( powr(real,X,aa(int,real,ring_1_of_int(real),Na))
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(int,nat,nat2,Na)),aa(real,real,inverse_inverse(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Na))))) ) ) ).

% powr_real_of_int
tff(fact_3223_cis__2pi,axiom,
    cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)) = one_one(complex) ).

% cis_2pi
tff(fact_3224_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A2)) = A2 ) ) ).

% inverse_inverse_eq
tff(fact_3225_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
        <=> ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
tff(fact_3226_inverse__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% inverse_zero
tff(fact_3227_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% inverse_nonzero_iff_nonzero
tff(fact_3228_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% inverse_mult_distrib
tff(fact_3229_inverse__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),one_one(A)) = one_one(A) ) ) ).

% inverse_1
tff(fact_3230_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A] :
          ( ( aa(A,A,inverse_inverse(A),X) = one_one(A) )
        <=> ( X = one_one(A) ) ) ) ).

% inverse_eq_1_iff
tff(fact_3231_inverse__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2) ) ) ).

% inverse_divide
tff(fact_3232_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A2)) ) ) ).

% inverse_minus_eq
tff(fact_3233_abs__inverse,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A2)) ) ) ).

% abs_inverse
tff(fact_3234_inverse__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,sgn_sgn(A),A2)) = aa(A,A,sgn_sgn(A),A2) ) ) ).

% inverse_sgn
tff(fact_3235_sgn__inverse,axiom,
    ! [A: $tType] :
      ( field_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,sgn_sgn(A),A2)) ) ) ).

% sgn_inverse
tff(fact_3236_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% inverse_nonpositive_iff_nonpositive
tff(fact_3237_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% inverse_nonnegative_iff_nonnegative
tff(fact_3238_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% inverse_less_iff_less
tff(fact_3239_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% inverse_less_iff_less_neg
tff(fact_3240_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% inverse_negative_iff_negative
tff(fact_3241_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% inverse_positive_iff_positive
tff(fact_3242_of__real__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ( real_Vector_of_real(A,zero_zero(real)) = zero_zero(A) ) ) ).

% of_real_0
tff(fact_3243_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X: real] :
          ( ( real_Vector_of_real(A,X) = zero_zero(A) )
        <=> ( X = zero_zero(real) ) ) ) ).

% of_real_eq_0_iff
tff(fact_3244_of__real__1,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ( real_Vector_of_real(A,one_one(real)) = one_one(A) ) ) ).

% of_real_1
tff(fact_3245_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X: real] :
          ( ( real_Vector_of_real(A,X) = one_one(A) )
        <=> ( X = one_one(real) ) ) ) ).

% of_real_eq_1_iff
tff(fact_3246_of__real__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : ( real_Vector_of_real(A,aa(num,real,numeral_numeral(real),W)) = aa(num,A,numeral_numeral(A),W) ) ) ).

% of_real_numeral
tff(fact_3247_of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X: real,Y: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,X)),real_Vector_of_real(A,Y)) ) ) ).

% of_real_divide
tff(fact_3248_of__real__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X: real,Y: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,X)),real_Vector_of_real(A,Y)) ) ) ).

% of_real_add
tff(fact_3249_of__real__power,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X: real,Na: nat] : ( real_Vector_of_real(A,aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),real_Vector_of_real(A,X)),Na) ) ) ).

% of_real_power
tff(fact_3250_of__real__diff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [X: real,Y: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),real_Vector_of_real(A,X)),real_Vector_of_real(A,Y)) ) ) ).

% of_real_diff
tff(fact_3251_frac__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archimedean_frac(A,aa(int,A,ring_1_of_int(A),Z)) = zero_zero(A) ) ) ).

% frac_of_int
tff(fact_3252_norm__cis,axiom,
    ! [A2: real] : ( real_V7770717601297561774m_norm(complex,cis(A2)) = one_one(real) ) ).

% norm_cis
tff(fact_3253_cis__zero,axiom,
    cis(zero_zero(real)) = one_one(complex) ).

% cis_zero
tff(fact_3254_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% inverse_le_iff_le
tff(fact_3255_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% inverse_le_iff_le_neg
tff(fact_3256_left__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),A2) = one_one(A) ) ) ) ).

% left_inverse
tff(fact_3257_right__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),A2)) = one_one(A) ) ) ) ).

% right_inverse
tff(fact_3258_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),W)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),W)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_3259_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,real_Vector_of_real(A,pi)) = zero_zero(A) ) ) ).

% sin_of_real_pi
tff(fact_3260_cis__pi,axiom,
    cis(pi) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% cis_pi
tff(fact_3261_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_3262_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : ( real_Vector_of_real(A,aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) ) ) ).

% of_real_neg_numeral
tff(fact_3263_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,real_Vector_of_real(A,pi)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% cos_of_real_pi
tff(fact_3264_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X: real] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,X)),one_one(A))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),one_one(real))) ) ) ).

% norm_of_real_add1
tff(fact_3265_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X: real,B2: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,X)),aa(num,A,numeral_numeral(A),B2))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(num,real,numeral_numeral(real),B2))) ) ) ).

% norm_of_real_addn
tff(fact_3266_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cos(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = zero_zero(A) ) ) ).

% cos_of_real_pi_half
tff(fact_3267_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sin(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% sin_of_real_pi_half
tff(fact_3268_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X: real] :
          ( ( X != zero_zero(real) )
         => ( real_Vector_of_real(A,aa(real,real,inverse_inverse(real),X)) = aa(A,A,inverse_inverse(A),real_Vector_of_real(A,X)) ) ) ) ).

% nonzero_of_real_inverse
tff(fact_3269_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),A2)) = aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,A2)) ) ) ) ).

% nonzero_norm_inverse
tff(fact_3270_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A2) != zero_zero(A) ) ) ) ).

% nonzero_imp_inverse_nonzero
tff(fact_3271_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A2)) = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
tff(fact_3272_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
         => ( ( A2 != zero_zero(A) )
           => ( ( B2 != zero_zero(A) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
tff(fact_3273_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = zero_zero(A) )
         => ( A2 = zero_zero(A) ) ) ) ).

% inverse_zero_imp_zero
tff(fact_3274_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( field(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% field_class.field_inverse_zero
tff(fact_3275_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Y: A,X: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Y),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Y)),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,inverse_inverse(A),Y)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_3276_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
tff(fact_3277_power__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),A2)),Na) = aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) ) ) ).

% power_inverse
tff(fact_3278_real__sqrt__inverse,axiom,
    ! [X: real] : ( aa(real,real,sqrt,aa(real,real,inverse_inverse(real),X)) = aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X)) ) ).

% real_sqrt_inverse
tff(fact_3279_cis__divide,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),cis(A2)),cis(B2)) = cis(aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)) ) ).

% cis_divide
tff(fact_3280_cis__neq__zero,axiom,
    ! [A2: real] : ( cis(A2) != zero_zero(complex) ) ).

% cis_neq_zero
tff(fact_3281_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [R2: real,X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),R2),real_V7770717601297561774m_norm(A,X))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),X))),aa(real,real,inverse_inverse(real),R2)) ) ) ) ).

% norm_inverse_le_norm
tff(fact_3282_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% inverse_less_imp_less
tff(fact_3283_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% less_imp_inverse_less
tff(fact_3284_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% inverse_less_imp_less_neg
tff(fact_3285_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% less_imp_inverse_less_neg
tff(fact_3286_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
         => ( ( A2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% inverse_negative_imp_negative
tff(fact_3287_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
         => ( ( A2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ).

% inverse_positive_imp_positive
tff(fact_3288_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A)) ) ) ).

% negative_imp_inverse_negative
tff(fact_3289_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ).

% positive_imp_inverse_positive
tff(fact_3290_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_3291_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% nonzero_inverse_minus_eq
tff(fact_3292_inverse__unique,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = one_one(A) )
         => ( aa(A,A,inverse_inverse(A),A2) = B2 ) ) ) ).

% inverse_unique
tff(fact_3293_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),one2)) = aa(num,A,numeral_numeral(A),one2) ) ) ).

% inverse_numeral_1
tff(fact_3294_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% field_class.field_divide_inverse
tff(fact_3295_divide__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% divide_inverse
tff(fact_3296_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),A2) ) ) ).

% divide_inverse_commute
tff(fact_3297_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) ) ) ).

% inverse_eq_divide
tff(fact_3298_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: nat,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_3299_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(A,A,inverse_inverse(A),X)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)) ) ) ).

% power_mult_inverse_distrib
tff(fact_3300_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: nat,X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_3301_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A2)) ) ) ) ).

% nonzero_abs_inverse
tff(fact_3302_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: int,X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_3303_divide__real__def,axiom,
    ! [X: real,Y: real] : ( aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y) = aa(real,real,aa(real,fun(real,real),times_times(real),X),aa(real,real,inverse_inverse(real),Y)) ) ).

% divide_real_def
tff(fact_3304_complex__eq__cancel__iff2,axiom,
    ! [X: real,Y: real,Xa: real] :
      ( ( complex2(X,Y) = real_Vector_of_real(complex,Xa) )
    <=> ( ( X = Xa )
        & ( Y = zero_zero(real) ) ) ) ).

% complex_eq_cancel_iff2
tff(fact_3305_complex__of__real__code,axiom,
    ! [X4: real] : ( real_Vector_of_real(complex,X4) = complex2(X4,zero_zero(real)) ) ).

% complex_of_real_code
tff(fact_3306_complex__of__real__def,axiom,
    ! [R2: real] : ( real_Vector_of_real(complex,R2) = complex2(R2,zero_zero(real)) ) ).

% complex_of_real_def
tff(fact_3307_DeMoivre,axiom,
    ! [A2: real,Na: nat] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cis(A2)),Na) = cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),A2)) ) ).

% DeMoivre
tff(fact_3308_frac__ge__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),archimedean_frac(A,X)) ) ).

% frac_ge_0
tff(fact_3309_frac__lt__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),archimedean_frac(A,X)),one_one(A)) ) ).

% frac_lt_1
tff(fact_3310_frac__1__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))) = archimedean_frac(A,X) ) ) ).

% frac_1_eq
tff(fact_3311_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% inverse_le_imp_le
tff(fact_3312_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% le_imp_inverse_le
tff(fact_3313_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% inverse_le_imp_le_neg
tff(fact_3314_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% le_imp_inverse_le_neg
tff(fact_3315_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),X)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X) ) ) ) ).

% inverse_le_1_iff
tff(fact_3316_one__less__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% one_less_inverse
tff(fact_3317_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),X))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),one_one(A)) ) ) ) ).

% one_less_inverse_iff
tff(fact_3318_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),A2) = one_one(A) ) ) ) ).

% field_class.field_inverse
tff(fact_3319_inverse__add,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,inverse_inverse(A),A2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% inverse_add
tff(fact_3320_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_3321_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_3322_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),A2) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_3323_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [Y: real,X: real] :
          ( ( Y != zero_zero(real) )
         => ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,X)),real_Vector_of_real(A,Y)) ) ) ) ).

% nonzero_of_real_divide
tff(fact_3324_inverse__powr,axiom,
    ! [Y: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( powr(real,aa(real,real,inverse_inverse(real),Y),A2) = aa(real,real,inverse_inverse(real),powr(real,Y,A2)) ) ) ).

% inverse_powr
tff(fact_3325_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ) ).

% inverse_less_iff
tff(fact_3326_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ).

% inverse_le_iff
tff(fact_3327_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),X))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),one_one(A)) ) ) ) ).

% one_le_inverse_iff
tff(fact_3328_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),X)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X) ) ) ) ).

% inverse_less_1_iff
tff(fact_3329_one__le__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% one_le_inverse
tff(fact_3330_norm__less__p1,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,real_V7770717601297561774m_norm(A,X))),one_one(A)))) ) ).

% norm_less_p1
tff(fact_3331_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(A,A,inverse_inverse(A),B2))) ) ) ) ) ).

% inverse_diff_inverse
tff(fact_3332_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => ? [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N)))),X) ) ) ).

% reals_Archimedean
tff(fact_3333_forall__pos__mono__1,axiom,
    ! [P: fun(real,$o),E2: real] :
      ( ! [D4: real,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),D4),E)
         => ( aa(real,$o,P,D4)
           => aa(real,$o,P,E) ) )
     => ( ! [N: nat] : aa(real,$o,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => aa(real,$o,P,E2) ) ) ) ).

% forall_pos_mono_1
tff(fact_3334_real__arch__inverse,axiom,
    ! [E2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
    <=> ? [N4: nat] :
          ( ( N4 != zero_zero(nat) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N4)))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N4))),E2) ) ) ).

% real_arch_inverse
tff(fact_3335_forall__pos__mono,axiom,
    ! [P: fun(real,$o),E2: real] :
      ( ! [D4: real,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),D4),E)
         => ( aa(real,$o,P,D4)
           => aa(real,$o,P,E) ) )
     => ( ! [N: nat] :
            ( ( N != zero_zero(nat) )
           => aa(real,$o,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N))) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => aa(real,$o,P,E2) ) ) ) ).

% forall_pos_mono
tff(fact_3336_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,sqrt,X)),X) = aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X)) ) ) ).

% sqrt_divide_self_eq
tff(fact_3337_ln__inverse,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,real,ln_ln(real),aa(real,real,inverse_inverse(real),X)) = aa(real,real,uminus_uminus(real),aa(real,real,ln_ln(real),X)) ) ) ).

% ln_inverse
tff(fact_3338_frac__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_frac(A,X) = aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,X))) ) ) ).

% frac_def
tff(fact_3339_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => ? [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),N))),X) ) ) ) ).

% ex_inverse_of_nat_less
tff(fact_3340_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: nat,Na: nat] :
          ( ( X != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),M)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_3341_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [B2: real,A2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),real_Vector_of_real(A,B2)),real_Vector_of_real(A,A2)))),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2))) ) ).

% norm_of_real_diff
tff(fact_3342_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,real,log(A2),aa(real,real,inverse_inverse(real),X)) = aa(real,real,uminus_uminus(real),aa(real,real,log(A2),X)) ) ) ) ) ).

% log_inverse
tff(fact_3343_frac__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( archimedean_frac(A,X) = X )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),one_one(A)) ) ) ) ).

% frac_eq
tff(fact_3344_frac__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A))) ) ) ).

% frac_add
tff(fact_3345_exp__plus__inverse__exp,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,exp(real),X)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X)))) ).

% exp_plus_inverse_exp
tff(fact_3346_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,inverse_inverse(real),X))) ) ).

% plus_inverse_ge_2
tff(fact_3347_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(real,real,inverse_inverse(real),X) ) ) ).

% real_inv_sqrt_pow2
tff(fact_3348_tan__cot,axiom,
    ! [X: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),X)) = aa(real,real,inverse_inverse(real),aa(real,real,tan(real),X)) ) ).

% tan_cot
tff(fact_3349_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( sin(A,X) = cos(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),X)) ) ) ).

% sin_cos_eq
tff(fact_3350_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( cos(A,X) = sin(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),X)) ) ) ).

% cos_sin_eq
tff(fact_3351_floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y))),one_one(int))) ) ) ).

% floor_add
tff(fact_3352_real__le__x__sinh,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),X)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ).

% real_le_x_sinh
tff(fact_3353_real__le__abs__sinh,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),X)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),X)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ).

% real_le_abs_sinh
tff(fact_3354_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,uminus_uminus(A),sin(A,X)) = cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),divide_divide(A),real_Vector_of_real(A,pi)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% minus_sin_cos_eq
tff(fact_3355_tan__sec,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,tan(A),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),cos(A,X))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ) ) ).

% tan_sec
tff(fact_3356_cis__minus__pi__half,axiom,
    cis(aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) = aa(complex,complex,uminus_uminus(complex),imaginary_unit) ).

% cis_minus_pi_half
tff(fact_3357_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(arg(Z)) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z))
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),arg(Z)),pi) ) ) ).

% Arg_correct
tff(fact_3358_sinh__ln__real,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( sinh(real,aa(real,real,ln_ln(real),X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),aa(real,real,inverse_inverse(real),X))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% sinh_ln_real
tff(fact_3359_cis__multiple__2pi,axiom,
    ! [Na: real] :
      ( member(real,Na,ring_1_Ints(real))
     => ( cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),Na)) = one_one(complex) ) ) ).

% cis_multiple_2pi
tff(fact_3360_cosh__ln__real,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( cosh(real,aa(real,real,ln_ln(real),X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),aa(real,real,inverse_inverse(real),X))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ).

% cosh_ln_real
tff(fact_3361_sinh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( sinh(A,zero_zero(A)) = zero_zero(A) ) ) ).

% sinh_0
tff(fact_3362_sinh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( sinh(real,X) = zero_zero(real) )
    <=> ( X = zero_zero(real) ) ) ).

% sinh_real_zero_iff
tff(fact_3363_sinh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),sinh(real,X)),sinh(real,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ).

% sinh_real_less_iff
tff(fact_3364_cosh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( cosh(A,zero_zero(A)) = one_one(A) ) ) ).

% cosh_0
tff(fact_3365_sinh__real__neg__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),sinh(real,X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real)) ) ).

% sinh_real_neg_iff
tff(fact_3366_sinh__real__pos__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),sinh(real,X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X) ) ).

% sinh_real_pos_iff
tff(fact_3367_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),sinh(real,X)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ).

% sinh_real_nonpos_iff
tff(fact_3368_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),sinh(real,X))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X) ) ).

% sinh_real_nonneg_iff
tff(fact_3369_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( archimedean_frac(A,X) = zero_zero(A) )
        <=> member(A,X,ring_1_Ints(A)) ) ) ).

% frac_eq_0_iff
tff(fact_3370_norm__ii,axiom,
    real_V7770717601297561774m_norm(complex,imaginary_unit) = one_one(real) ).

% norm_ii
tff(fact_3371_floor__add2,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( ( member(A,X,ring_1_Ints(A))
            | member(A,Y,ring_1_Ints(A)) )
         => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y)) ) ) ) ).

% floor_add2
tff(fact_3372_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),archimedean_frac(A,X))
        <=> ~ member(A,X,ring_1_Ints(A)) ) ) ).

% frac_gt_0_iff
tff(fact_3373_i__squared,axiom,
    aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),imaginary_unit) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% i_squared
tff(fact_3374_divide__numeral__i,axiom,
    ! [Z: complex,Na: num] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),Na)),imaginary_unit)) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z))),aa(num,complex,numeral_numeral(complex),Na)) ) ).

% divide_numeral_i
tff(fact_3375_exp__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,pi)),imaginary_unit)) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i
tff(fact_3376_exp__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,pi))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i'
tff(fact_3377_cis__pi__half,axiom,
    cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = imaginary_unit ).

% cis_pi_half
tff(fact_3378_Arg__ii,axiom,
    arg(imaginary_unit) = aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% Arg_ii
tff(fact_3379_power2__i,axiom,
    aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),imaginary_unit),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% power2_i
tff(fact_3380_i__even__power,axiom,
    ! [Na: nat] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),imaginary_unit),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),aa(complex,complex,uminus_uminus(complex),one_one(complex))),Na) ) ).

% i_even_power
tff(fact_3381_exp__two__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),aa(num,num,bit0,one2))),real_Vector_of_real(complex,pi))),imaginary_unit)) = one_one(complex) ).

% exp_two_pi_i
tff(fact_3382_exp__two__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,pi)),aa(num,complex,numeral_numeral(complex),aa(num,num,bit0,one2))))) = one_one(complex) ).

% exp_two_pi_i'
tff(fact_3383_Arg__minus__ii,axiom,
    arg(aa(complex,complex,uminus_uminus(complex),imaginary_unit)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),pi)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ).

% Arg_minus_ii
tff(fact_3384_Ints__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => member(A,zero_zero(A),ring_1_Ints(A)) ) ).

% Ints_0
tff(fact_3385_cosh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X)),cosh(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X)),sinh(A,Y))) ) ) ).

% cosh_add
tff(fact_3386_sinh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X)),cosh(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X)),sinh(A,Y))) ) ) ).

% sinh_add
tff(fact_3387_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X)),cosh(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X)),sinh(A,Y))) ) ) ).

% sinh_diff
tff(fact_3388_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),cosh(A,X)),cosh(A,Y))),aa(A,A,aa(A,fun(A,A),times_times(A),sinh(A,X)),sinh(A,Y))) ) ) ).

% cosh_diff
tff(fact_3389_sinh__less__cosh__real,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),sinh(real,X)),cosh(real,X)) ).

% sinh_less_cosh_real
tff(fact_3390_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),sinh(A,X)),cosh(A,X)) = aa(A,A,exp(A),X) ) ) ).

% sinh_plus_cosh
tff(fact_3391_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),cosh(A,X)),sinh(A,X)) = aa(A,A,exp(A),X) ) ) ).

% cosh_plus_sinh
tff(fact_3392_cosh__real__nonzero,axiom,
    ! [X: real] : ( cosh(real,X) != zero_zero(real) ) ).

% cosh_real_nonzero
tff(fact_3393_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: num] : member(A,aa(num,A,numeral_numeral(A),Na),ring_1_Ints(A)) ) ).

% Ints_numeral
tff(fact_3394_Ints__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( member(A,B2,ring_1_Ints(A))
           => member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),ring_1_Ints(A)) ) ) ) ).

% Ints_mult
tff(fact_3395_Ints__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => member(A,one_one(A),ring_1_Ints(A)) ) ).

% Ints_1
tff(fact_3396_Ints__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( member(A,B2,ring_1_Ints(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),ring_1_Ints(A)) ) ) ) ).

% Ints_add
tff(fact_3397_Ints__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( member(A,B2,ring_1_Ints(A))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),ring_1_Ints(A)) ) ) ) ).

% Ints_diff
tff(fact_3398_Ints__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => member(A,aa(A,A,uminus_uminus(A),A2),ring_1_Ints(A)) ) ) ).

% Ints_minus
tff(fact_3399_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A] :
          ( member(A,aa(A,A,uminus_uminus(A),X),ring_1_Ints(A))
        <=> member(A,X,ring_1_Ints(A)) ) ) ).

% minus_in_Ints_iff
tff(fact_3400_tanh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,tanh(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),sinh(A,X)),cosh(A,X)) ) ) ).

% tanh_def
tff(fact_3401_Ints__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,Na: nat] :
          ( member(A,A2,ring_1_Ints(A))
         => member(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na),ring_1_Ints(A)) ) ) ).

% Ints_power
tff(fact_3402_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Na: nat] : member(A,aa(nat,A,semiring_1_of_nat(A),Na),ring_1_Ints(A)) ) ).

% Ints_of_nat
tff(fact_3403_Ints__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => member(A,aa(A,A,abs_abs(A),A2),ring_1_Ints(A)) ) ) ).

% Ints_abs
tff(fact_3404_Ints__cases,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Q4: A] :
          ( member(A,Q4,ring_1_Ints(A))
         => ~ ! [Z2: int] : ( Q4 != aa(int,A,ring_1_of_int(A),Z2) ) ) ) ).

% Ints_cases
tff(fact_3405_Ints__induct,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Q4: A,P: fun(A,$o)] :
          ( member(A,Q4,ring_1_Ints(A))
         => ( ! [Z2: int] : aa(A,$o,P,aa(int,A,ring_1_of_int(A),Z2))
           => aa(A,$o,P,Q4) ) ) ) ).

% Ints_induct
tff(fact_3406_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] : member(A,aa(int,A,ring_1_of_int(A),Z),ring_1_Ints(A)) ) ).

% Ints_of_int
tff(fact_3407_complex__i__not__zero,axiom,
    imaginary_unit != zero_zero(complex) ).

% complex_i_not_zero
tff(fact_3408_complex__i__not__one,axiom,
    imaginary_unit != one_one(complex) ).

% complex_i_not_one
tff(fact_3409_complex__i__not__numeral,axiom,
    ! [W: num] : ( imaginary_unit != aa(num,complex,numeral_numeral(complex),W) ) ).

% complex_i_not_numeral
tff(fact_3410_cosh__minus__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),cosh(A,X)),sinh(A,X)) = aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X)) ) ) ).

% cosh_minus_sinh
tff(fact_3411_sinh__minus__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),sinh(A,X)),cosh(A,X)) = aa(A,A,uminus_uminus(A),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X))) ) ) ).

% sinh_minus_cosh
tff(fact_3412_cosh__real__pos,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),cosh(real,X)) ).

% cosh_real_pos
tff(fact_3413_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),zero_zero(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cosh(real,X)),cosh(real,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),X) ) ) ) ).

% cosh_real_nonpos_le_iff
tff(fact_3414_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),cosh(real,X)),cosh(real,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ) ).

% cosh_real_nonneg_le_iff
tff(fact_3415_cosh__real__nonneg,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),cosh(real,X)) ).

% cosh_real_nonneg
tff(fact_3416_cosh__real__ge__1,axiom,
    ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),cosh(real,X)) ).

% cosh_real_ge_1
tff(fact_3417_sinh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( sinh(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),sinh(A,X))),cosh(A,X)) ) ) ).

% sinh_double
tff(fact_3418_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% Ints_double_eq_0_iff
tff(fact_3419_complex__i__not__neg__numeral,axiom,
    ! [W: num] : ( imaginary_unit != aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) ) ).

% complex_i_not_neg_numeral
tff(fact_3420_cosh__real__strict__mono,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),cosh(real,X)),cosh(real,Y)) ) ) ).

% cosh_real_strict_mono
tff(fact_3421_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),cosh(real,X)),cosh(real,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ) ).

% cosh_real_nonneg_less_iff
tff(fact_3422_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),zero_zero(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),cosh(real,X)),cosh(real,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),X) ) ) ) ).

% cosh_real_nonpos_less_iff
tff(fact_3423_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),A2) != zero_zero(A) ) ) ) ).

% Ints_odd_nonzero
tff(fact_3424_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),cosh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),sinh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% cosh_square_eq
tff(fact_3425_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),cosh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),sinh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(A) ) ) ).

% hyperbolic_pythagoras
tff(fact_3426_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),sinh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),cosh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% sinh_square_eq
tff(fact_3427_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: int,A2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),A2)
         => member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),A2)),aa(int,A,ring_1_of_int(A),B2)),ring_1_Ints(A)) ) ) ).

% of_int_divide_in_Ints
tff(fact_3428_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,real,arcosh(real),cosh(real,X)) = X ) ) ).

% arcosh_cosh_real
tff(fact_3429_imaginary__unit_Ocode,axiom,
    imaginary_unit = complex2(zero_zero(real),one_one(real)) ).

% imaginary_unit.code
tff(fact_3430_Complex__eq__i,axiom,
    ! [X: real,Y: real] :
      ( ( complex2(X,Y) = imaginary_unit )
    <=> ( ( X = zero_zero(real) )
        & ( Y = one_one(real) ) ) ) ).

% Complex_eq_i
tff(fact_3431_Arg__zero,axiom,
    arg(zero_zero(complex)) = zero_zero(real) ).

% Arg_zero
tff(fact_3432_complex__of__real__i,axiom,
    ! [R2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R2)),imaginary_unit) = complex2(zero_zero(real),R2) ) ).

% complex_of_real_i
tff(fact_3433_i__complex__of__real,axiom,
    ! [R2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,R2)) = complex2(zero_zero(real),R2) ) ).

% i_complex_of_real
tff(fact_3434_cosh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : ( cosh(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),cosh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),sinh(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% cosh_double
tff(fact_3435_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( cis(arg(Z)) = aa(complex,complex,sgn_sgn(complex),Z) ) ) ).

% cis_Arg
tff(fact_3436_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),A2)),zero_zero(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% Ints_odd_less_0
tff(fact_3437_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( member(A,X,ring_1_Ints(A))
         => ( ( X != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,abs_abs(A),X)) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_3438_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( member(A,X,ring_1_Ints(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),X)),one_one(A))
           => ( X = zero_zero(A) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_3439_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( member(A,X,ring_1_Ints(A))
         => ( member(A,Y,ring_1_Ints(A))
           => ( ( X = Y )
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y))),one_one(A)) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_3440_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),X),pi)) = zero_zero(real) )
    <=> member(real,X,ring_1_Ints(real)) ) ).

% sin_times_pi_eq_0
tff(fact_3441_frac__neg,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X))
          = $ite(member(A,X,ring_1_Ints(A)),zero_zero(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),archimedean_frac(A,X))) ) ) ).

% frac_neg
tff(fact_3442_le__mult__floor__Ints,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & linordered_idom(B) )
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( member(A,A2,ring_1_Ints(A))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A2)),archim6421214686448440834_floor(A,B2)))),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_3443_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A2: A] :
          ( ( archimedean_frac(A,X) = A2 )
        <=> ( member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2),ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) ) ) ) ).

% frac_unique_iff
tff(fact_3444_mult__ceiling__le__Ints,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & linordered_idom(B) )
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( member(A,A2,ring_1_Ints(A))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))),aa(int,B,ring_1_of_int(B),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A2)),archimedean_ceiling(A,B2)))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_3445_Arg__bounded,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z))
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),arg(Z)),pi) ) ).

% Arg_bounded
tff(fact_3446_tanh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] :
          ( ( cosh(A,X) != zero_zero(A) )
         => ( ( cosh(A,Y) != zero_zero(A) )
           => ( aa(A,A,tanh(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tanh(A),X)),aa(A,A,tanh(A),Y))),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tanh(A),X)),aa(A,A,tanh(A),Y)))) ) ) ) ) ).

% tanh_add
tff(fact_3447_sin__integer__2pi,axiom,
    ! [Na: real] :
      ( member(real,Na,ring_1_Ints(real))
     => ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),Na)) = zero_zero(real) ) ) ).

% sin_integer_2pi
tff(fact_3448_cos__integer__2pi,axiom,
    ! [Na: real] :
      ( member(real,Na,ring_1_Ints(real))
     => ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),Na)) = one_one(real) ) ) ).

% cos_integer_2pi
tff(fact_3449_cmod__unit__one,axiom,
    ! [A2: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,cos(real,A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,sin(real,A2))))) = one_one(real) ) ).

% cmod_unit_one
tff(fact_3450_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( cosh(A,Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% cosh_field_def
tff(fact_3451_complex__inverse,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,inverse_inverse(complex),complex2(A2,B2)) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),A2),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% complex_inverse
tff(fact_3452_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( sinh(A,Z) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% sinh_field_def
tff(fact_3453_cis__Arg__unique,axiom,
    ! [Z: complex,X: real] :
      ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(X) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),X)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
         => ( arg(Z) = X ) ) ) ) ).

% cis_Arg_unique
tff(fact_3454_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cosh(A,X) = zero_zero(A) )
        <=> ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% cosh_zero_iff
tff(fact_3455_csqrt__ii,axiom,
    csqrt(imaginary_unit) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),one_one(complex)),imaginary_unit)),real_Vector_of_real(complex,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ).

% csqrt_ii
tff(fact_3456_Suc__0__xor__eq,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),Na) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ) ).

% Suc_0_xor_eq
tff(fact_3457_xor__Suc__0__eq,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Na),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ) ).

% xor_Suc_0_eq
tff(fact_3458_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_3459_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list($o)] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(list($o),int,aa(int,fun(list($o),int),aa(fun($o,int),fun(int,fun(list($o),int)),groups4207007520872428315er_sum($o,int),zero_neq_one_of_bool(int)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Bs)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(list($o),nat,size_size(list($o)),Bs))) ).

% horner_sum_of_bool_2_less
tff(fact_3460_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),Y)) = Y ) ) ).

% bit.xor_left_self
tff(fact_3461_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),zero_zero(A)) = A2 ) ) ).

% xor.right_neutral
tff(fact_3462_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),zero_zero(A)),A2) = A2 ) ) ).

% xor.left_neutral
tff(fact_3463_xor__self__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),A2) = zero_zero(A) ) ) ).

% xor_self_eq
tff(fact_3464_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),X) = zero_zero(A) ) ) ).

% bit.xor_self
tff(fact_3465_take__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),B2)) ) ) ).

% take_bit_xor
tff(fact_3466_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),one_one(nat)) = A2 ) ) ).

% gbinomial_1
tff(fact_3467_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( csqrt(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% csqrt_eq_0
tff(fact_3468_csqrt__0,axiom,
    csqrt(zero_zero(complex)) = zero_zero(complex) ).

% csqrt_0
tff(fact_3469_csqrt__1,axiom,
    csqrt(one_one(complex)) = one_one(complex) ).

% csqrt_1
tff(fact_3470_csqrt__eq__1,axiom,
    ! [Z: complex] :
      ( ( csqrt(Z) = one_one(complex) )
    <=> ( Z = one_one(complex) ) ) ).

% csqrt_eq_1
tff(fact_3471_gbinomial__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [K: nat] : ( aa(nat,A,gbinomial(A,zero_zero(A)),aa(nat,nat,suc,K)) = zero_zero(A) ) ) ).

% gbinomial_0(2)
tff(fact_3472_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),zero_zero(nat)) = one_one(A) ) ) ).

% gbinomial_0(1)
tff(fact_3473_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% gbinomial_Suc0
tff(fact_3474_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(3)
tff(fact_3475_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% xor_numerals(1)
tff(fact_3476_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y)) ) ) ).

% xor_numerals(2)
tff(fact_3477_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X)) ) ) ).

% xor_numerals(5)
tff(fact_3478_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,X)) ) ) ).

% xor_numerals(8)
tff(fact_3479_power2__csqrt,axiom,
    ! [Z: complex] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),csqrt(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = Z ) ).

% power2_csqrt
tff(fact_3480_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(7)
tff(fact_3481_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y)) ) ).

% xor_nat_numerals(1)
tff(fact_3482_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y)) ) ).

% xor_nat_numerals(2)
tff(fact_3483_xor__nat__numerals_I3_J,axiom,
    ! [X: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X)) ) ).

% xor_nat_numerals(3)
tff(fact_3484_xor__nat__numerals_I4_J,axiom,
    ! [X: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X)) ) ).

% xor_nat_numerals(4)
tff(fact_3485_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(4)
tff(fact_3486_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(6)
tff(fact_3487_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_xor_eq
tff(fact_3488_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),C2)) ) ) ).

% xor.left_commute
tff(fact_3489_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),A2) ) ) ).

% xor.commute
tff(fact_3490_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),B2),C2)) ) ) ).

% xor.assoc
tff(fact_3491_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L)) ) ) ).

% of_int_xor_eq
tff(fact_3492_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y: A,Z: A,X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Y),Z)),X) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y),X)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Z),X)) ) ) ).

% bit.conj_xor_distrib2
tff(fact_3493_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Y)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Z)) ) ) ).

% bit.conj_xor_distrib
tff(fact_3494_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)),Na)
        <=> ~ ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
            <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Na) ) ) ) ).

% bit_xor_iff
tff(fact_3495_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,A2),K)),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_3496_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Na)),K) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Na)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)) ) ) ) ).

% gbinomial_of_nat_symmetric
tff(fact_3497_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_3498_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,A2),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_3499_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),K)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% gbinomial_ge_n_over_k_pow_k
tff(fact_3500_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A2),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_3501_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,A2),K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A2),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_3502_even__xor__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_xor_iff
tff(fact_3503_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_3504_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_absorption
tff(fact_3505_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,M: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),M)),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),M)),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_3506_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_3507_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% gbinomial_factors
tff(fact_3508_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),K)),A2)),one_one(A))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_3509_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),Na))),one_one(A))),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),Na)) ) ) ).

% gbinomial_index_swap
tff(fact_3510_of__real__sqrt,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( real_Vector_of_real(complex,aa(real,real,sqrt,X)) = csqrt(real_Vector_of_real(complex,X)) ) ) ).

% of_real_sqrt
tff(fact_3511_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),A2)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),K)) ) ) ).

% gbinomial_minus
tff(fact_3512_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_3513_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),A2),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_3514_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_3515_xor__nat__unfold,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),Na)
      = $ite(
          M = zero_zero(nat),
          Na,
          $ite(Na = zero_zero(nat),M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% xor_nat_unfold
tff(fact_3516_xor__nat__rec,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),Na)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M) )
             != ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% xor_nat_rec
tff(fact_3517_one__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)))),aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% one_xor_eq
tff(fact_3518_xor__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),one_one(A)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)))),aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% xor_one_eq
tff(fact_3519_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Bs: list($o),Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(list($o),A,aa(A,fun(list($o),A),aa(fun($o,A),fun(A,fun(list($o),A)),groups4207007520872428315er_sum($o,A),zero_neq_one_of_bool(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Bs)),Na)
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list($o),nat,size_size(list($o)),Bs))
            & aa(nat,$o,nth($o,Bs),Na) ) ) ) ).

% bit_horner_sum_bit_iff
tff(fact_3520_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),Na)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),Na))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_3521_minus__apply,axiom,
    ! [A: $tType,B: $tType] :
      ( minus(A)
     => ! [A3: fun(B,A),B3: fun(B,A),X: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),minus_minus(fun(B,A)),A3),B3),X) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,A3,X)),aa(B,A,B3,X)) ) ) ).

% minus_apply
tff(fact_3522_Cauchy__iff2,axiom,
    ! [X7: fun(nat,real)] :
      ( topolo3814608138187158403Cauchy(real,X7)
    <=> ! [J: nat] :
        ? [M7: nat] :
        ! [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M3)
         => ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N4)
             => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,X7,M3)),aa(nat,real,X7,N4)))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J)))) ) ) ) ).

% Cauchy_iff2
tff(fact_3523_length__subseqs,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),subseqs(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_subseqs
tff(fact_3524_intind,axiom,
    ! [A: $tType,I2: nat,Na: nat,P: fun(A,$o),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Na)
     => ( aa(A,$o,P,X)
       => aa(A,$o,P,aa(nat,A,nth(A,replicate(A,Na,X)),I2)) ) ) ).

% intind
tff(fact_3525_inthall,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),Na: nat] :
      ( ! [X3: A] :
          ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X3) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(A,$o,P,aa(nat,A,nth(A,Xs),Na)) ) ) ).

% inthall
tff(fact_3526_push__bit__nonnegative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% push_bit_nonnegative_int_iff
tff(fact_3527_push__bit__negative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% push_bit_negative_int_iff
tff(fact_3528_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),zero_zero(A)) = zero_zero(A) ) ) ).

% push_bit_of_0
tff(fact_3529_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,A2: A] :
          ( ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% push_bit_eq_0_iff
tff(fact_3530_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)) = aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),A2) ) ) ).

% push_bit_push_bit
tff(fact_3531_push__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),B2)) ) ) ).

% push_bit_and
tff(fact_3532_push__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),B2)) ) ) ).

% push_bit_xor
tff(fact_3533_concat__bit__of__zero__1,axiom,
    ! [Na: nat,L: int] : ( aa(int,int,bit_concat_bit(Na,zero_zero(int)),L) = aa(int,int,bit_se4730199178511100633sh_bit(int,Na),L) ) ).

% concat_bit_of_zero_1
tff(fact_3534_nth__replicate,axiom,
    ! [A: $tType,I2: nat,Na: nat,X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Na)
     => ( aa(nat,A,nth(A,replicate(A,Na,X)),I2) = X ) ) ).

% nth_replicate
tff(fact_3535_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% xor_nonnegative_int_iff
tff(fact_3536_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),zero_zero(int))
    <=> ~ ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% xor_negative_int_iff
tff(fact_3537_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Na)),aa(num,A,numeral_numeral(A),K)) = aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) ) ) ).

% push_bit_Suc_numeral
tff(fact_3538_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Na)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)))) ) ) ).

% push_bit_Suc_minus_numeral
tff(fact_3539_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),K)) = aa(A,A,bit_se4730199178511100633sh_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) ) ) ).

% push_bit_numeral
tff(fact_3540_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Na)),A2) = aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% push_bit_Suc
tff(fact_3541_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),one_one(A)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) ) ) ).

% push_bit_of_1
tff(fact_3542_push__bit__of__Suc__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,Na),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ).

% push_bit_of_Suc_0
tff(fact_3543_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2))
        <=> ( ( Na != zero_zero(nat) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ) ).

% even_push_bit_iff
tff(fact_3544_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,bit_se4730199178511100633sh_bit(A,pred_numeral(L)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)))) ) ) ).

% push_bit_minus_numeral
tff(fact_3545_bit__xor__int__iff,axiom,
    ! [K: int,L: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),Na)
    <=> ~ ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),Na) ) ) ).

% bit_xor_int_iff
tff(fact_3546_flip__bit__int__def,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se8732182000553998342ip_bit(int),Na),K) = aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),one_one(int))) ) ).

% flip_bit_int_def
tff(fact_3547_push__bit__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),B2)) ) ) ).

% push_bit_add
tff(fact_3548_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,K: int] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(int,A,ring_1_of_int(A),K)) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),K)) ) ) ).

% push_bit_of_int
tff(fact_3549_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,M: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,Na),M)) ) ) ).

% push_bit_of_nat
tff(fact_3550_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),Na)) = aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_push_bit
tff(fact_3551_push__bit__nat__eq,axiom,
    ! [Na: nat,K: int] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,Na),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se4730199178511100633sh_bit(int,Na),K)) ) ).

% push_bit_nat_eq
tff(fact_3552_push__bit__minus,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)) ) ) ).

% push_bit_minus
tff(fact_3553_nth__equalityI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
     => ( ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Ys),I3) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
tff(fact_3554_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: fun(nat,fun(A,$o))] :
      ( ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),K)
         => ? [X_13: A] : aa(A,$o,aa(nat,fun(A,$o),P,I),X_13) )
    <=> ? [Xs3: list(A)] :
          ( ( aa(list(A),nat,size_size(list(A)),Xs3) = K )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),K)
             => aa(A,$o,aa(nat,fun(A,$o),P,I),aa(nat,A,nth(A,Xs3),I)) ) ) ) ).

% Skolem_list_nth
tff(fact_3555_list__eq__iff__nth__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs = Ys )
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Ys),I) ) ) ) ) ).

% list_eq_iff_nth_eq
tff(fact_3556_XOR__lower,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),X),Y)) ) ) ).

% XOR_lower
tff(fact_3557_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),aa(A,A,bit_se4730199178511100633sh_bit(A,M),A2)) ) ) ).

% push_bit_take_bit
tff(fact_3558_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)) = aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),A2)) ) ) ).

% take_bit_push_bit
tff(fact_3559_flip__bit__nat__def,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se8732182000553998342ip_bit(nat),M),Na) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),Na),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),one_one(nat))) ) ).

% flip_bit_nat_def
tff(fact_3560_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( ! [X5: A] :
          ( member(A,X5,aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X5) )
    <=> ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I)) ) ) ).

% all_set_conv_all_nth
tff(fact_3561_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),X: A] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I3)) )
     => ( member(A,X,aa(list(A),set(A),set2(A),Xs))
       => aa(A,$o,P,X) ) ) ).

% all_nth_imp_all_set
tff(fact_3562_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs: list(A)] :
      ( member(A,X,aa(list(A),set(A),set2(A),Xs))
    <=> ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
          & ( aa(nat,A,nth(A,Xs),I) = X ) ) ) ).

% in_set_conv_nth
tff(fact_3563_list__ball__nth,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),P: fun(A,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( ! [X3: A] :
            ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
           => aa(A,$o,P,X3) )
       => aa(A,$o,P,aa(nat,A,nth(A,Xs),Na)) ) ) ).

% list_ball_nth
tff(fact_3564_nth__mem,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => member(A,aa(nat,A,nth(A,Xs),Na),aa(list(A),set(A),set2(A),Xs)) ) ).

% nth_mem
tff(fact_3565_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_se4730199178511100633sh_bit(int,M),K)),Na)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) ) ) ).

% bit_push_bit_iff_int
tff(fact_3566_xor__nat__def,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),Na) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na))) ) ).

% xor_nat_def
tff(fact_3567_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( minus(B)
     => ! [A3: fun(A,B),B3: fun(A,B),X4: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),minus_minus(fun(A,B)),A3),B3),X4) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A3,X4)),aa(A,B,B3,X4)) ) ) ).

% fun_diff_def
tff(fact_3568_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q4: nat,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),Q4)),Na)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(nat,Q4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) ) ) ).

% bit_push_bit_iff_nat
tff(fact_3569_concat__bit__eq,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(Na,K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),L)) ) ).

% concat_bit_eq
tff(fact_3570_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),Na),A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),one_one(A))) ) ) ).

% flip_bit_eq_xor
tff(fact_3571_push__bit__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% push_bit_double
tff(fact_3572_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),one_one(A))) != zero_zero(A) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_3573_push__bit__int__def,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_se4730199178511100633sh_bit(int,Na),K) = aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% push_bit_int_def
tff(fact_3574_push__bit__nat__def,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,Na),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% push_bit_nat_def
tff(fact_3575_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ) ).

% push_bit_eq_mult
tff(fact_3576_exp__dvdE,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),A2)
         => ~ ! [B4: A] : ( A2 != aa(A,A,bit_se4730199178511100633sh_bit(A,Na),B4) ) ) ) ).

% exp_dvdE
tff(fact_3577_push__bit__minus__one,axiom,
    ! [Na: nat] : ( aa(int,int,bit_se4730199178511100633sh_bit(int,Na),aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% push_bit_minus_one
tff(fact_3578_CauchyD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),E2: real] :
          ( topolo3814608138187158403Cauchy(A,X7)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => ? [M8: nat] :
              ! [M2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M2)
               => ! [N6: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N6)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M2)),aa(nat,A,X7,N6)))),E2) ) ) ) ) ) ).

% CauchyD
tff(fact_3579_CauchyI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M4)
                 => ! [N: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),N)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M4)),aa(nat,A,X7,N)))),E) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% CauchyI
tff(fact_3580_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M7: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M3)
                 => ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,M3)),aa(nat,A,X7,N4)))),E3) ) ) ) ) ) ).

% Cauchy_iff
tff(fact_3581_XOR__upper,axiom,
    ! [X: int,Na: nat,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
         => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),X),Y)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ) ) ).

% XOR_upper
tff(fact_3582_xor__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ( ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) )
             != ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L) ) ))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% xor_int_rec
tff(fact_3583_xor__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)
      = $ite(
          K = aa(int,int,uminus_uminus(int),one_one(int)),
          aa(int,int,bit_ri4277139882892585799ns_not(int),L),
          $ite(
            L = aa(int,int,uminus_uminus(int),one_one(int)),
            aa(int,int,bit_ri4277139882892585799ns_not(int),K),
            $ite(
              K = zero_zero(int),
              L,
              $ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))))) ) ) ) ) ).

% xor_int_unfold
tff(fact_3584_length__mul__elem,axiom,
    ! [A: $tType,Xs: list(list(A)),Na: nat] :
      ( ! [X3: list(A)] :
          ( member(list(A),X3,aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
         => ( aa(list(A),nat,size_size(list(A)),X3) = Na ) )
     => ( aa(list(A),nat,size_size(list(A)),concat(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(list(A)),nat,size_size(list(list(A))),Xs)),Na) ) ) ).

% length_mul_elem
tff(fact_3585_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] : ( re(csqrt(Z)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ).

% csqrt.simps(1)
tff(fact_3586_sinh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( sinh(A,X) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X)))) ) ) ).

% sinh_def
tff(fact_3587_cosh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( cosh(A,X) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),X)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),X)))) ) ) ).

% cosh_def
tff(fact_3588_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,bit_ri4277139882892585799ns_not(A),X) = aa(A,A,bit_ri4277139882892585799ns_not(A),Y) )
        <=> ( X = Y ) ) ) ).

% bit.compl_eq_compl_iff
tff(fact_3589_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)) = X ) ) ).

% bit.double_compl
tff(fact_3590_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X: A,B2: real] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X) = aa(A,A,real_V8093663219630862766scaleR(A,B2),X) )
        <=> ( ( A2 = B2 )
            | ( X = zero_zero(A) ) ) ) ) ).

% scaleR_cancel_right
tff(fact_3591_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),zero_zero(A)) = zero_zero(A) ) ) ).

% scaleR_zero_right
tff(fact_3592_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X: A,Y: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X) = aa(A,A,real_V8093663219630862766scaleR(A,A2),Y) )
        <=> ( ( X = Y )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% scaleR_cancel_left
tff(fact_3593_scaleR__one,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,one_one(real)),X) = X ) ) ).

% scaleR_one
tff(fact_3594_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),Y)) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),Y)) ) ) ).

% bit.xor_compl_right
tff(fact_3595_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),Y) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),Y)) ) ) ).

% bit.xor_compl_left
tff(fact_3596_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(real) )
            | ( X = zero_zero(A) ) ) ) ) ).

% scaleR_eq_0_iff
tff(fact_3597_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,zero_zero(real)),X) = zero_zero(A) ) ) ).

% scaleR_zero_left
tff(fact_3598_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: A,U: real,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,U),B2)) )
        <=> ( ( A2 = B2 )
            | ( U = one_one(real) ) ) ) ) ).

% scaleR_eq_iff
tff(fact_3599_scaleR__power,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X: real,Y: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,real_V8093663219630862766scaleR(A,X),Y)),Na) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),Na)) ) ) ).

% scaleR_power
tff(fact_3600_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),X) = zero_zero(A) ) ) ).

% bit.conj_cancel_left
tff(fact_3601_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),X)) = zero_zero(A) ) ) ).

% bit.conj_cancel_right
tff(fact_3602_complex__Re__numeral,axiom,
    ! [V: num] : ( re(aa(num,complex,numeral_numeral(complex),V)) = aa(num,real,numeral_numeral(real),V) ) ).

% complex_Re_numeral
tff(fact_3603_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.compl_zero
tff(fact_3604_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% bit.compl_one
tff(fact_3605_scaleR__minus1__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,uminus_uminus(real),one_one(real))),X) = aa(A,A,uminus_uminus(A),X) ) ) ).

% scaleR_minus1_left
tff(fact_3606_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),U)),A2)),aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) = A2 ) ) ).

% scaleR_collapse
tff(fact_3607_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),X)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_right
tff(fact_3608_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_left
tff(fact_3609_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),X) ) ) ).

% bit.xor_one_right
tff(fact_3610_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,uminus_uminus(A),one_one(A))),X) = aa(A,A,bit_ri4277139882892585799ns_not(A),X) ) ) ).

% bit.xor_one_left
tff(fact_3611_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% not_nonnegative_int_iff
tff(fact_3612_not__negative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% not_negative_int_iff
tff(fact_3613_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,uminus_uminus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),Na))) = aa(num,A,numeral_numeral(A),inc(Na)) ) ) ).

% minus_not_numeral_eq
tff(fact_3614_even__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_ri4277139882892585799ns_not(A),A2))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% even_not_iff
tff(fact_3615_scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),U)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),A2) ) ) ).

% scaleR_times
tff(fact_3616_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Na)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_3617_Re__divide__numeral,axiom,
    ! [Z: complex,W: num] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(num,complex,numeral_numeral(complex),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),aa(num,real,numeral_numeral(real),W)) ) ).

% Re_divide_numeral
tff(fact_3618_cos__Arg__i__mult__zero,axiom,
    ! [Y: complex] :
      ( ( Y != zero_zero(complex) )
     => ( ( re(Y) = zero_zero(real) )
       => ( cos(real,arg(Y)) = zero_zero(real) ) ) ) ).

% cos_Arg_i_mult_zero
tff(fact_3619_not__one__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% not_one_eq
tff(fact_3620_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [V: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),W)),aa(num,real,numeral_numeral(real),V))),A2) ) ) ).

% inverse_scaleR_times
tff(fact_3621_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,V: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),aa(num,real,numeral_numeral(real),V))),A2) ) ) ).

% fraction_scaleR_times
tff(fact_3622_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)) = A2 ) ) ).

% scaleR_half_double
tff(fact_3623_scaleR__right__diff__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X: A,Y: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ).

% scaleR_right_diff_distrib
tff(fact_3624_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A,B2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),B2) ) ) ) ).

% take_bit_not_iff
tff(fact_3625_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2))) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) ) ) ).

% take_bit_not_take_bit
tff(fact_3626_bit__not__int__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),K)),Na)
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) ) ).

% bit_not_int_iff
tff(fact_3627_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X: A,Y: A] :
          ( ( A2 != zero_zero(real) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X) = aa(A,A,real_V8093663219630862766scaleR(A,A2),Y) )
           => ( X = Y ) ) ) ) ).

% scaleR_left_imp_eq
tff(fact_3628_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,X: A,Y: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ).

% scaleR_right_distrib
tff(fact_3629_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,A2: real,B2: real] :
          ( ( X != zero_zero(A) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),X) = aa(A,A,real_V8093663219630862766scaleR(A,B2),X) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
tff(fact_3630_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,bit_ri4277139882892585799ns_not(int),K)) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(int,A,ring_1_of_int(A),K)) ) ) ).

% of_int_not_eq
tff(fact_3631_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_not_numeral
tff(fact_3632_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),B2) ) ) ).

% not_diff_distrib
tff(fact_3633_not__add__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),B2) ) ) ).

% not_add_distrib
tff(fact_3634_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: real,Y: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,X),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,Y),Xa)) ) ) ).

% scaleR_left.add
tff(fact_3635_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,X: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X)) ) ) ).

% scaleR_left_distrib
tff(fact_3636_of__real__def,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [R2: real] : ( real_Vector_of_real(A,R2) = aa(A,A,real_V8093663219630862766scaleR(A,R2),one_one(A)) ) ) ).

% of_real_def
tff(fact_3637_scaleR__left_Odiff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: real,Y: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y)),Xa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,X),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,Y),Xa)) ) ) ).

% scaleR_left.diff
tff(fact_3638_scaleR__left__diff__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,X: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),X) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X)) ) ) ).

% scaleR_left_diff_distrib
tff(fact_3639_imaginary__unit_Osimps_I1_J,axiom,
    re(imaginary_unit) = zero_zero(real) ).

% imaginary_unit.simps(1)
tff(fact_3640_zero__complex_Osimps_I1_J,axiom,
    re(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(1)
tff(fact_3641_one__complex_Osimps_I1_J,axiom,
    re(one_one(complex)) = one_one(real) ).

% one_complex.simps(1)
tff(fact_3642_minus__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),X),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),re(X)),re(Y)) ) ).

% minus_complex.simps(1)
tff(fact_3643_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X)) ) ) ) ).

% scaleR_right_mono
tff(fact_3644_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: real,A2: real,C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),C2)) ) ) ) ).

% scaleR_right_mono_neg
tff(fact_3645_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% scaleR_le_cancel_left_pos
tff(fact_3646_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% scaleR_le_cancel_left_neg
tff(fact_3647_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% scaleR_le_cancel_left
tff(fact_3648_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [X: A,Y: A,A2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ) ).

% scaleR_left_mono
tff(fact_3649_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: A,A2: A,C2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),zero_zero(real))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2)) ) ) ) ).

% scaleR_left_mono_neg
tff(fact_3650_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),one_one(A)) ) ) ).

% minus_eq_not_plus_1
tff(fact_3651_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))) ) ) ).

% minus_eq_not_minus_1
tff(fact_3652_not__eq__complement,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),one_one(A)) ) ) ).

% not_eq_complement
tff(fact_3653_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,V: real,A2: A,X: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),U),V)),A2) = X )
        <=> $ite(V = zero_zero(real),X = zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,U),A2) = aa(A,A,real_V8093663219630862766scaleR(A,V),X)) ) ) ).

% vector_fraction_eq_iff
tff(fact_3654_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,U: real,V: real,A2: A] :
          ( ( X = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),U),V)),A2) )
        <=> $ite(V = zero_zero(real),X = zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,V),X) = aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) ) ) ).

% eq_vector_fraction_iff
tff(fact_3655_not__int__def,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int)) ) ).

% not_int_def
tff(fact_3656_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),E2)),C2)),D2) ) ) ).

% Real_Vector_Spaces.le_add_iff1
tff(fact_3657_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E2)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),E2)),D2)) ) ) ).

% Real_Vector_Spaces.le_add_iff2
tff(fact_3658_and__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = zero_zero(int) ).

% and_not_numerals(1)
tff(fact_3659_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [B2: A,A2: A] :
          ( ! [N: nat] :
              ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N)
             => aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) ) ) ) ).

% disjunctive_diff
tff(fact_3660_Re__csqrt,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(csqrt(Z))) ).

% Re_csqrt
tff(fact_3661_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),bit_se2239418461657761734s_mask(A,Na)),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)) ) ) ).

% take_bit_not_eq_mask_diff
tff(fact_3662_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(Na))) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% minus_numeral_inc_eq
tff(fact_3663_unset__bit__int__def,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Na),K) = aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),one_one(int)))) ) ).

% unset_bit_int_def
tff(fact_3664_not__int__div__2,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) ) ).

% not_int_div_2
tff(fact_3665_even__not__iff__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),K))
    <=> ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K) ) ).

% even_not_iff_int
tff(fact_3666_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% zero_le_scaleR_iff
tff(fact_3667_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)),zero_zero(A))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% scaleR_le_0_iff
tff(fact_3668_scaleR__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,X: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Y)) ) ) ) ) ) ).

% scaleR_mono
tff(fact_3669_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),D2)) ) ) ) ) ) ).

% scaleR_mono'
tff(fact_3670_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X: A] :
          ( ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A)) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),zero_zero(A)) ) ) ).

% split_scaleR_neg_le
tff(fact_3671_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)) ) ) ).

% split_scaleR_pos_le
tff(fact_3672_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)) ) ) ) ).

% scaleR_nonneg_nonneg
tff(fact_3673_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),zero_zero(A)) ) ) ) ).

% scaleR_nonneg_nonpos
tff(fact_3674_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),zero_zero(A)) ) ) ) ).

% scaleR_nonpos_nonneg
tff(fact_3675_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)) ) ) ) ).

% scaleR_nonpos_nonpos
tff(fact_3676_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [X: A,A2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),one_one(real))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),X) ) ) ) ).

% scaleR_left_le_one_le
tff(fact_3677_scaleR__2,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X),X) ) ) ).

% scaleR_2
tff(fact_3678_and__not__numerals_I4_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),aa(num,num,bit0,M)) ) ).

% and_not_numerals(4)
tff(fact_3679_and__not__numerals_I2_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = one_one(int) ) ).

% and_not_numerals(2)
tff(fact_3680_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na))) ) ) ).

% not_numeral_Bit0_eq
tff(fact_3681_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [M: real,X: A,C2: A,Y: A] :
          ( ( M != zero_zero(real) )
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,M),X)),C2) = Y )
          <=> ( X = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),Y)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),C2)) ) ) ) ) ).

% real_vector_affinity_eq
tff(fact_3682_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [M: real,Y: A,X: A,C2: A] :
          ( ( M != zero_zero(real) )
         => ( ( Y = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,M),X)),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),Y)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),C2)) = X ) ) ) ) ).

% real_vector_eq_affinity
tff(fact_3683_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_divideR_le_eq
tff(fact_3684_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% pos_le_divideR_eq
tff(fact_3685_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% neg_divideR_le_eq
tff(fact_3686_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_le_divideR_eq
tff(fact_3687_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_less_divideR_eq
tff(fact_3688_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% neg_divideR_less_eq
tff(fact_3689_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% pos_less_divideR_eq
tff(fact_3690_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_divideR_less_eq
tff(fact_3691_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A2: real,X: A] :
          ( ( A2 != zero_zero(real) )
         => ( ( X != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),A2)),aa(A,A,inverse_inverse(A),X)) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
tff(fact_3692_bit__minus__int__iff,axiom,
    ! [K: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),K)),Na)
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))),Na) ) ).

% bit_minus_int_iff
tff(fact_3693_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Na))) = zero_zero(A) ) ) ) ).

% take_bit_not_mask_eq_0
tff(fact_3694_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),bit_se2239418461657761734s_mask(A,Na)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,M))) ) ) ).

% push_bit_mask_eq
tff(fact_3695_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se2638667681897837118et_bit(A),Na),A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),one_one(A)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_3696_and__not__numerals_I5_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na)))) ) ).

% and_not_numerals(5)
tff(fact_3697_and__not__numerals_I7_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),aa(num,num,bit0,M)) ) ).

% and_not_numerals(7)
tff(fact_3698_and__not__numerals_I3_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = zero_zero(int) ) ).

% and_not_numerals(3)
tff(fact_3699_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divideR_le_eq
tff(fact_3700_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_le_minus_divideR_eq
tff(fact_3701_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_minus_divideR_le_eq
tff(fact_3702_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_le_minus_divideR_eq
tff(fact_3703_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_less_minus_divideR_eq
tff(fact_3704_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_minus_divideR_less_eq
tff(fact_3705_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_less_minus_divideR_eq
tff(fact_3706_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divideR_less_eq
tff(fact_3707_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),zero_zero(real))
    <=> ( re(Z) = aa(real,real,uminus_uminus(real),real_V7770717601297561774m_norm(complex,Z)) ) ) ).

% cmod_plus_Re_le_0_iff
tff(fact_3708_cos__n__Re__cis__pow__n,axiom,
    ! [Na: nat,A2: real] : ( cos(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),A2)) = re(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cis(A2)),Na)) ) ).

% cos_n_Re_cis_pow_n
tff(fact_3709_and__not__numerals_I9_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na)))) ) ).

% and_not_numerals(9)
tff(fact_3710_and__not__numerals_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na)))) ) ).

% and_not_numerals(6)
tff(fact_3711_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),Na)
        <=> ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) != zero_zero(A) )
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ) ).

% bit_not_iff_eq
tff(fact_3712_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] : ( aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Na)) ) ) ).

% minus_exp_eq_not_mask
tff(fact_3713_and__not__numerals_I8_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))))) ) ).

% and_not_numerals(8)
tff(fact_3714_not__int__rec,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa($o,int,zero_neq_one_of_bool(int),aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% not_int_rec
tff(fact_3715_in__children__def,axiom,
    ! [Na: nat,TreeList: list(vEBT_VEBT),X: nat] :
      ( vEBT_V5917875025757280293ildren(Na,TreeList,X)
    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),vEBT_VEBT_high(X,Na))),vEBT_VEBT_low(X,Na)) ) ).

% in_children_def
tff(fact_3716_csqrt_Ocode,axiom,
    ! [Z: complex] :
      ( csqrt(Z)
      = complex2(aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),
          aa(real,real,
            aa(real,fun(real,real),times_times(real),$ite(im(Z) = zero_zero(real),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),
            aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))) ) ).

% csqrt.code
tff(fact_3717_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( im(csqrt(Z))
      = aa(real,real,
          aa(real,fun(real,real),times_times(real),$ite(im(Z) = zero_zero(real),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),
          aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))) ) ).

% csqrt.simps(2)
tff(fact_3718_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( im(X) = zero_zero(real) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(X)),zero_zero(real))
       => ( csqrt(X) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sqrt,aa(real,real,abs_abs(real),re(X))))) ) ) ) ).

% csqrt_of_real_nonpos
tff(fact_3719_Complex__divide,axiom,
    ! [X: complex,Y: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X),Y) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),im(Y)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),im(Y)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% Complex_divide
tff(fact_3720_complex__Im__of__int,axiom,
    ! [Z: int] : ( im(aa(int,complex,ring_1_of_int(complex),Z)) = zero_zero(real) ) ).

% complex_Im_of_int
tff(fact_3721_complex__Im__of__nat,axiom,
    ! [Na: nat] : ( im(aa(nat,complex,semiring_1_of_nat(complex),Na)) = zero_zero(real) ) ).

% complex_Im_of_nat
tff(fact_3722_complex__Im__fact,axiom,
    ! [Na: nat] : ( im(semiring_char_0_fact(complex,Na)) = zero_zero(real) ) ).

% complex_Im_fact
tff(fact_3723_Im__complex__of__real,axiom,
    ! [Z: real] : ( im(real_Vector_of_real(complex,Z)) = zero_zero(real) ) ).

% Im_complex_of_real
tff(fact_3724_Im__power__real,axiom,
    ! [X: complex,Na: nat] :
      ( ( im(X) = zero_zero(real) )
     => ( im(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),X),Na)) = zero_zero(real) ) ) ).

% Im_power_real
tff(fact_3725_complex__Im__numeral,axiom,
    ! [V: num] : ( im(aa(num,complex,numeral_numeral(complex),V)) = zero_zero(real) ) ).

% complex_Im_numeral
tff(fact_3726_Re__power__real,axiom,
    ! [X: complex,Na: nat] :
      ( ( im(X) = zero_zero(real) )
     => ( re(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),X),Na)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),re(X)),Na) ) ) ).

% Re_power_real
tff(fact_3727_Im__divide__numeral,axiom,
    ! [Z: complex,W: num] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),Z),aa(num,complex,numeral_numeral(complex),W))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),aa(num,real,numeral_numeral(real),W)) ) ).

% Im_divide_numeral
tff(fact_3728_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( im(X) = zero_zero(real) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(X))
       => ( csqrt(X) = real_Vector_of_real(complex,aa(real,real,sqrt,re(X))) ) ) ) ).

% csqrt_of_real_nonneg
tff(fact_3729_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(X)),zero_zero(real))
        | ( ( im(X) = zero_zero(real) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(X)) ) )
     => ( csqrt(aa(complex,complex,uminus_uminus(complex),X)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),csqrt(X)) ) ) ).

% csqrt_minus
tff(fact_3730_imaginary__unit_Osimps_I2_J,axiom,
    im(imaginary_unit) = one_one(real) ).

% imaginary_unit.simps(2)
tff(fact_3731_zero__complex_Osimps_I2_J,axiom,
    im(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(2)
tff(fact_3732_one__complex_Osimps_I2_J,axiom,
    im(one_one(complex)) = zero_zero(real) ).

% one_complex.simps(2)
tff(fact_3733_minus__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),X),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),im(X)),im(Y)) ) ).

% minus_complex.simps(2)
tff(fact_3734_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( member(complex,Z,ring_1_Ints(complex))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I: int] : ( re(Z) = aa(int,real,ring_1_of_int(real),I) ) ) ) ).

% complex_is_Int_iff
tff(fact_3735_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( aa(real,real,abs_abs(real),re(Z)) = real_V7770717601297561774m_norm(complex,Z) )
     => ( im(Z) = zero_zero(real) ) ) ).

% Im_eq_0
tff(fact_3736_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( re(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),im(Z)) ) ) ).

% cmod_eq_Im
tff(fact_3737_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( im(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),re(Z)) ) ) ).

% cmod_eq_Re
tff(fact_3738_times__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),im(Y))) ) ).

% times_complex.simps(1)
tff(fact_3739_minus__complex_Ocode,axiom,
    ! [X: complex,Y: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),X),Y) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),re(X)),re(Y)),aa(real,real,aa(real,fun(real,real),minus_minus(real),im(X)),im(Y))) ) ).

% minus_complex.code
tff(fact_3740_csqrt__principal,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(csqrt(Z)))
      | ( ( re(csqrt(Z)) = zero_zero(real) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(csqrt(Z))) ) ) ).

% csqrt_principal
tff(fact_3741_sin__n__Im__cis__pow__n,axiom,
    ! [Na: nat,A2: real] : ( sin(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),A2)) = im(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cis(A2)),Na)) ) ).

% sin_n_Im_cis_pow_n
tff(fact_3742_times__complex_Ocode,axiom,
    ! [X: complex,Y: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),X),Y) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),im(Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),im(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),re(Y)))) ) ).

% times_complex.code
tff(fact_3743_cmod__power2,axiom,
    ! [Z: complex] : ( aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% cmod_power2
tff(fact_3744_Im__power2,axiom,
    ! [X: complex] : ( im(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),re(X))),im(X)) ) ).

% Im_power2
tff(fact_3745_Re__power2,axiom,
    ! [X: complex] : ( re(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ).

% Re_power2
tff(fact_3746_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z = zero_zero(complex) )
    <=> ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = zero_zero(real) ) ) ).

% complex_eq_0
tff(fact_3747_norm__complex__def,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% norm_complex_def
tff(fact_3748_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] : ( re(aa(complex,complex,inverse_inverse(complex),X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),re(X)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% inverse_complex.simps(1)
tff(fact_3749_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_neq_0
tff(fact_3750_Re__divide,axiom,
    ! [X: complex,Y: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X),Y)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),im(Y)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% Re_divide
tff(fact_3751_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(B2))
        | ( ( re(B2) = zero_zero(real) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(B2)) ) )
     => ( csqrt(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),B2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = B2 ) ) ).

% csqrt_square
tff(fact_3752_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),W),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = Z )
     => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(W))
          | ( ( re(W) = zero_zero(real) )
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(W)) ) )
       => ( csqrt(Z) = W ) ) ) ).

% csqrt_unique
tff(fact_3753_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] : ( im(aa(complex,complex,inverse_inverse(complex),X)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),im(X))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% inverse_complex.simps(2)
tff(fact_3754_Im__divide,axiom,
    ! [X: complex,Y: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),X),Y)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(X)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),re(X)),im(Y)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% Im_divide
tff(fact_3755_complex__abs__le__norm,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),re(Z))),aa(real,real,abs_abs(real),im(Z)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),real_V7770717601297561774m_norm(complex,Z))) ).

% complex_abs_le_norm
tff(fact_3756_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),re(Z)),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),im(Z)),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = one_one(real) ) ) ).

% complex_unit_circle
tff(fact_3757_inverse__complex_Ocode,axiom,
    ! [X: complex] : ( aa(complex,complex,inverse_inverse(complex),X) = complex2(aa(real,real,aa(real,fun(real,real),divide_divide(real),re(X)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),im(X))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% inverse_complex.code
tff(fact_3758_Im__Reals__divide,axiom,
    ! [R2: complex,Z: complex] :
      ( member(complex,R2,real_Vector_Reals(complex))
     => ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),R2),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),re(R2))),im(Z))),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% Im_Reals_divide
tff(fact_3759_Re__Reals__divide,axiom,
    ! [R2: complex,Z: complex] :
      ( member(complex,R2,real_Vector_Reals(complex))
     => ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),R2),Z)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(R2)),re(Z))),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% Re_Reals_divide
tff(fact_3760_complex__diff__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Z),cnj(Z)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),im(Z)))),imaginary_unit) ) ).

% complex_diff_cnj
tff(fact_3761_complex__mult__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_mult_cnj
tff(fact_3762_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( cnj(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% complex_cnj_zero_iff
tff(fact_3763_complex__cnj__zero,axiom,
    cnj(zero_zero(complex)) = zero_zero(complex) ).

% complex_cnj_zero
tff(fact_3764_complex__cnj__one,axiom,
    cnj(one_one(complex)) = one_one(complex) ).

% complex_cnj_one
tff(fact_3765_complex__cnj__one__iff,axiom,
    ! [Z: complex] :
      ( ( cnj(Z) = one_one(complex) )
    <=> ( Z = one_one(complex) ) ) ).

% complex_cnj_one_iff
tff(fact_3766_complex__cnj__power,axiom,
    ! [X: complex,Na: nat] : ( cnj(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),X),Na)) = aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cnj(X)),Na) ) ).

% complex_cnj_power
tff(fact_3767_complex__cnj__numeral,axiom,
    ! [W: num] : ( cnj(aa(num,complex,numeral_numeral(complex),W)) = aa(num,complex,numeral_numeral(complex),W) ) ).

% complex_cnj_numeral
tff(fact_3768_complex__cnj__diff,axiom,
    ! [X: complex,Y: complex] : ( cnj(aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),X),Y)) = aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),cnj(X)),cnj(Y)) ) ).

% complex_cnj_diff
tff(fact_3769_complex__cnj__neg__numeral,axiom,
    ! [W: num] : ( cnj(aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W))) = aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) ) ).

% complex_cnj_neg_numeral
tff(fact_3770_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = zero_zero(real) ) ).

% complex_In_mult_cnj_zero
tff(fact_3771_real__eq__imaginary__iff,axiom,
    ! [Y: complex,X: complex] :
      ( member(complex,Y,real_Vector_Reals(complex))
     => ( member(complex,X,real_Vector_Reals(complex))
       => ( ( X = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y) )
        <=> ( ( X = zero_zero(complex) )
            & ( Y = zero_zero(complex) ) ) ) ) ) ).

% real_eq_imaginary_iff
tff(fact_3772_imaginary__eq__real__iff,axiom,
    ! [Y: complex,X: complex] :
      ( member(complex,Y,real_Vector_Reals(complex))
     => ( member(complex,X,real_Vector_Reals(complex))
       => ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y) = X )
        <=> ( ( X = zero_zero(complex) )
            & ( Y = zero_zero(complex) ) ) ) ) ) ).

% imaginary_eq_real_iff
tff(fact_3773_Reals__numeral,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [W: num] : member(A,aa(num,A,numeral_numeral(A),W),real_Vector_Reals(A)) ) ).

% Reals_numeral
tff(fact_3774_Reals__1,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => member(A,one_one(A),real_Vector_Reals(A)) ) ).

% Reals_1
tff(fact_3775_Reals__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),real_Vector_Reals(A)) ) ) ) ).

% Reals_add
tff(fact_3776_Reals__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => member(A,zero_zero(A),real_Vector_Reals(A)) ) ).

% Reals_0
tff(fact_3777_Reals__power,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,Na: nat] :
          ( member(A,A2,real_Vector_Reals(A))
         => member(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na),real_Vector_Reals(A)) ) ) ).

% Reals_power
tff(fact_3778_Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2),real_Vector_Reals(A)) ) ) ) ).

% Reals_divide
tff(fact_3779_Reals__diff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),real_Vector_Reals(A)) ) ) ) ).

% Reals_diff
tff(fact_3780_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( member(complex,Z,real_Vector_Reals(complex))
    <=> ( im(Z) = zero_zero(real) ) ) ).

% complex_is_Real_iff
tff(fact_3781_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => ( ( B2 != zero_zero(A) )
             => member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2),real_Vector_Reals(A)) ) ) ) ) ).

% nonzero_Reals_divide
tff(fact_3782_Complex__in__Reals,axiom,
    ! [X: real] : member(complex,complex2(X,zero_zero(real)),real_Vector_Reals(complex)) ).

% Complex_in_Reals
tff(fact_3783_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( ( A2 != zero_zero(A) )
           => member(A,aa(A,A,inverse_inverse(A),A2),real_Vector_Reals(A)) ) ) ) ).

% nonzero_Reals_inverse
tff(fact_3784_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)) = zero_zero(real) )
    <=> ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))) = zero_zero(real) ) ) ).

% Re_complex_div_eq_0
tff(fact_3785_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)) = zero_zero(real) )
    <=> ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))) = zero_zero(real) ) ) ).

% Im_complex_div_eq_0
tff(fact_3786_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Re_complex_div_lt_0
tff(fact_3787_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Re_complex_div_gt_0
tff(fact_3788_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Re_complex_div_ge_0
tff(fact_3789_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Re_complex_div_le_0
tff(fact_3790_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Im_complex_div_lt_0
tff(fact_3791_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Im_complex_div_gt_0
tff(fact_3792_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Im_complex_div_ge_0
tff(fact_3793_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Im_complex_div_le_0
tff(fact_3794_complex__mod__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% complex_mod_mult_cnj
tff(fact_3795_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) )
      & ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2)))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ) ).

% complex_div_gt_0
tff(fact_3796_complex__norm__square,axiom,
    ! [Z: complex] : ( real_Vector_of_real(complex,aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) ) ).

% complex_norm_square
tff(fact_3797_complex__add__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),Z),cnj(Z)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),re(Z))) ) ).

% complex_add_cnj
tff(fact_3798_complex__div__cnj,axiom,
    ! [A2: complex,B2: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),A2),B2) = aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))),real_Vector_of_real(complex,aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,B2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% complex_div_cnj
tff(fact_3799_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(Z)),W)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))))) ) ).

% cnj_add_mult_eq_Re
tff(fact_3800_or__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            | ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ).

% or_int_rec
tff(fact_3801_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_numeral_minus_bit1
tff(fact_3802_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(7)
tff(fact_3803_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(6)
tff(fact_3804_or_Oidem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),A2) = A2 ) ) ).

% or.idem
tff(fact_3805_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ).

% or.left_idem
tff(fact_3806_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ).

% or.right_idem
tff(fact_3807_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),zero_zero(A)) = A2 ) ) ).

% or.right_neutral
tff(fact_3808_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),zero_zero(A)),A2) = A2 ) ) ).

% or.left_neutral
tff(fact_3809_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),zero_zero(A)) = zero_zero(A) ) ) ).

% drop_bit_of_0
tff(fact_3810_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)) = aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),A2) ) ) ).

% drop_bit_drop_bit
tff(fact_3811_take__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),B2)) ) ) ).

% take_bit_or
tff(fact_3812_push__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),A2)),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),B2)) ) ) ).

% push_bit_or
tff(fact_3813_drop__bit__and,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)),aa(A,A,bit_se4197421643247451524op_bit(A,Na),B2)) ) ) ).

% drop_bit_and
tff(fact_3814_drop__bit__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)),aa(A,A,bit_se4197421643247451524op_bit(A,Na),B2)) ) ) ).

% drop_bit_or
tff(fact_3815_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A,B2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)),aa(A,A,bit_se4197421643247451524op_bit(A,Na),B2)) ) ) ).

% drop_bit_xor
tff(fact_3816_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_right
tff(fact_3817_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,uminus_uminus(A),one_one(A))),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_left
tff(fact_3818_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,B2: $o] :
          ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa($o,A,zero_neq_one_of_bool(A),B2))
          = aa($o,A,zero_neq_one_of_bool(A),
              ( Na = zero_zero(nat) )
            & (B2)) ) ) ).

% drop_bit_of_bool
tff(fact_3819_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% or_nonnegative_int_iff
tff(fact_3820_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),zero_zero(int))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        | aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% or_negative_int_iff
tff(fact_3821_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Y)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y)) ) ) ).

% bit.de_Morgan_conj
tff(fact_3822_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),Y)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y)) ) ) ).

% bit.de_Morgan_disj
tff(fact_3823_drop__bit__nonnegative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se4197421643247451524op_bit(int,Na),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% drop_bit_nonnegative_int_iff
tff(fact_3824_drop__bit__negative__int__iff,axiom,
    ! [Na: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se4197421643247451524op_bit(int,Na),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% drop_bit_negative_int_iff
tff(fact_3825_drop__bit__minus__one,axiom,
    ! [Na: nat] : ( aa(int,int,bit_se4197421643247451524op_bit(int,Na),aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% drop_bit_minus_one
tff(fact_3826_or__nat__numerals_I4_J,axiom,
    ! [X: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X)) ) ).

% or_nat_numerals(4)
tff(fact_3827_or__nat__numerals_I2_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y)) ) ).

% or_nat_numerals(2)
tff(fact_3828_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X)) ) ) ).

% or_numerals(8)
tff(fact_3829_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(2)
tff(fact_3830_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit0
tff(fact_3831_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,Na)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit1
tff(fact_3832_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),X)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_right
tff(fact_3833_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_left
tff(fact_3834_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),one_one(A)) = aa($o,A,zero_neq_one_of_bool(A),( Na = zero_zero(nat) )) ) ) ).

% drop_bit_of_1
tff(fact_3835_or__nat__numerals_I3_J,axiom,
    ! [X: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,X))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,X)) ) ).

% or_nat_numerals(3)
tff(fact_3836_or__nat__numerals_I1_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y)) ) ).

% or_nat_numerals(1)
tff(fact_3837_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% or_numerals(3)
tff(fact_3838_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X)) ) ) ).

% or_numerals(5)
tff(fact_3839_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(1)
tff(fact_3840_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,bit_se4197421643247451524op_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_numeral_bit0
tff(fact_3841_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,bit_se4197421643247451524op_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_numeral_bit1
tff(fact_3842_or__minus__numerals_I6_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na))) ) ).

% or_minus_numerals(6)
tff(fact_3843_or__minus__numerals_I2_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na))) ) ).

% or_minus_numerals(2)
tff(fact_3844_drop__bit__Suc__minus__bit0,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,Na)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,Na),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_Suc_minus_bit0
tff(fact_3845_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_numeral_minus_bit0
tff(fact_3846_drop__bit__Suc__minus__bit1,axiom,
    ! [Na: nat,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,Na)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,Na),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_Suc_minus_bit1
tff(fact_3847_and__minus__minus__numerals,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Na)),one_one(int)))) ) ).

% and_minus_minus_numerals
tff(fact_3848_or__minus__minus__numerals,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Na)),one_one(int)))) ) ).

% or_minus_minus_numerals
tff(fact_3849_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(4)
tff(fact_3850_or__nat__def,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),Na) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na))) ) ).

% or_nat_def
tff(fact_3851_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),Na)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_or_eq
tff(fact_3852_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,M: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4197421643247451524op_bit(nat,Na),M)) ) ) ).

% drop_bit_of_nat
tff(fact_3853_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4197421643247451524op_bit(nat,M),Na)) = aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% of_nat_drop_bit
tff(fact_3854_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,L: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(int,A,ring_1_of_int(A),K)),aa(int,A,ring_1_of_int(A),L)) ) ) ).

% of_int_or_eq
tff(fact_3855_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y: A,Z: A,X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y),Z)),X) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y),X)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Z),X)) ) ) ).

% bit.disj_conj_distrib2
tff(fact_3856_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Y: A,Z: A,X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y),Z)),X) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y),X)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Z),X)) ) ) ).

% bit.conj_disj_distrib2
tff(fact_3857_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),Y)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),Z)) ) ) ).

% bit.disj_conj_distrib
tff(fact_3858_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Y)),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Z)) ) ) ).

% bit.conj_disj_distrib
tff(fact_3859_bit__or__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)),Na)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
            | aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),Na) ) ) ) ).

% bit_or_iff
tff(fact_3860_or_Oassoc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),C2)) ) ) ).

% or.assoc
tff(fact_3861_or_Ocommute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),A2) ) ) ).

% or.commute
tff(fact_3862_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),B2),C2)) ) ) ).

% or.left_commute
tff(fact_3863_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),zero_zero(A)) = X ) ) ).

% bit.disj_zero_right
tff(fact_3864_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% or_eq_0_iff
tff(fact_3865_bit__or__int__iff,axiom,
    ! [K: int,L: int,Na: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),Na)
    <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na)
        | aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),Na) ) ) ).

% bit_or_int_iff
tff(fact_3866_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)) ) ).

% or_greater_eq
tff(fact_3867_OR__lower,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X),Y)) ) ) ).

% OR_lower
tff(fact_3868_disjunctive__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( ! [N: nat] :
              ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              | ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ) ).

% disjunctive_add
tff(fact_3869_plus__and__or,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Y)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),X),Y) ) ).

% plus_and_or
tff(fact_3870_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),aa(A,A,bit_ri4277139882892585799ns_not(A),B2))) ) ) ).

% and_eq_not_not_or
tff(fact_3871_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),aa(A,A,bit_ri4277139882892585799ns_not(A),B2))) ) ) ).

% or_eq_not_not_and
tff(fact_3872_or__int__def,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),aa(int,int,bit_ri4277139882892585799ns_not(int),L))) ) ).

% or_int_def
tff(fact_3873_set__bit__nat__def,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5668285175392031749et_bit(nat),M),Na) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Na),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),one_one(nat))) ) ).

% set_bit_nat_def
tff(fact_3874_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = A2 )
        <=> ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2) = zero_zero(A) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
tff(fact_3875_drop__bit__push__bit__int,axiom,
    ! [M: nat,Na: nat,K: int] : ( aa(int,int,bit_se4197421643247451524op_bit(int,M),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),K)) = aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),aa(int,int,bit_se4730199178511100633sh_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)),K)) ) ).

% drop_bit_push_bit_int
tff(fact_3876_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)) = aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),A2)) ) ) ).

% take_bit_drop_bit
tff(fact_3877_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)),aa(A,A,bit_se4197421643247451524op_bit(A,M),A2)) ) ) ).

% drop_bit_take_bit
tff(fact_3878_or__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ).

% or_not_numerals(1)
tff(fact_3879_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),Y) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),Y))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),Y)) ) ) ).

% bit.xor_def
tff(fact_3880_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),Y) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),Y)),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),aa(A,A,bit_ri4277139882892585799ns_not(A),Y))) ) ) ).

% bit.xor_def2
tff(fact_3881_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),Na),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),one_one(A))) ) ) ).

% set_bit_eq_or
tff(fact_3882_xor__int__def,axiom,
    ! [K: int,L: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),L))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),L)) ) ).

% xor_int_def
tff(fact_3883_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),one_one(A))) = aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_3884_concat__bit__def,axiom,
    ! [Na: nat,K: int,L: int] : ( aa(int,int,bit_concat_bit(Na,K),L) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,bit_se2584673776208193580ke_bit(int,Na),K)),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),L)) ) ).

% concat_bit_def
tff(fact_3885_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)),one_one(A)) = one_one(A) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_3886_set__bit__int__def,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Na),K) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),aa(int,int,bit_se4730199178511100633sh_bit(int,Na),one_one(int))) ) ).

% set_bit_int_def
tff(fact_3887_bits__ident,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2))),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)) = A2 ) ) ).

% bits_ident
tff(fact_3888_even__or__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2) ) ) ) ).

% even_or_iff
tff(fact_3889_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),X) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),X) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),Y) = zero_zero(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_3890_or__not__numerals_I2_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na))) ) ).

% or_not_numerals(2)
tff(fact_3891_or__not__numerals_I4_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int)) ) ).

% or_not_numerals(4)
tff(fact_3892_drop__bit__half,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% drop_bit_half
tff(fact_3893_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A2 )
         => ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2) = A2 ) ) ) ).

% stable_imp_drop_bit_eq
tff(fact_3894_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Y) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( aa(A,A,bit_ri4277139882892585799ns_not(A),X) = Y ) ) ) ) ).

% bit.compl_unique
tff(fact_3895_or__not__numerals_I3_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na))) ) ).

% or_not_numerals(3)
tff(fact_3896_or__not__numerals_I7_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ) ).

% or_not_numerals(7)
tff(fact_3897_drop__bit__int__def,axiom,
    ! [Na: nat,K: int] : ( aa(int,int,bit_se4197421643247451524op_bit(int,Na),K) = aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ).

% drop_bit_int_def
tff(fact_3898_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
         => ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Na))) ) ) ) ).

% signed_take_bit_eq_if_negative
tff(fact_3899_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,Na)),A2) = aa(A,A,bit_se4197421643247451524op_bit(A,Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% drop_bit_Suc
tff(fact_3900_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) ) ) ).

% drop_bit_eq_div
tff(fact_3901_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)) ) ) ).

% bit_iff_odd_drop_bit
tff(fact_3902_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2))
        <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ).

% even_drop_bit_iff_not_bit
tff(fact_3903_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),bit_se2239418461657761734s_mask(A,Na)) ) ) ).

% mask_Suc_exp
tff(fact_3904_or__not__numerals_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na)))) ) ).

% or_not_numerals(6)
tff(fact_3905_or__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),one_one(A)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% or_one_eq
tff(fact_3906_one__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2))) ) ) ).

% one_or_eq
tff(fact_3907_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,Na))) ) ) ).

% mask_Suc_double
tff(fact_3908_OR__upper,axiom,
    ! [X: int,Na: nat,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na))
         => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),X),Y)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)) ) ) ) ).

% OR_upper
tff(fact_3909_or__not__numerals_I5_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))))) ) ).

% or_not_numerals(5)
tff(fact_3910_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,M: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,Na),aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2))) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Na)))) ) ) ).

% slice_eq_mask
tff(fact_3911_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,Na)))) ) ) ).

% signed_take_bit_def
tff(fact_3912_Suc__0__or__eq,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),Na) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ) ).

% Suc_0_or_eq
tff(fact_3913_or__Suc__0__eq,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),Na),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) ) ).

% or_Suc_0_eq
tff(fact_3914_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)
          = $ite(Na = zero_zero(nat),A2,aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% drop_bit_rec
tff(fact_3915_or__not__numerals_I8_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))))) ) ).

% or_not_numerals(8)
tff(fact_3916_or__not__numerals_I9_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))))) ) ).

% or_not_numerals(9)
tff(fact_3917_or__nat__rec,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),Na)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)
            | ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ).

% or_nat_rec
tff(fact_3918_or__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)
      = $ite(
          ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
          | ( L = aa(int,int,uminus_uminus(int),one_one(int)) ) ),
          aa(int,int,uminus_uminus(int),one_one(int)),
          $ite(
            K = zero_zero(int),
            L,
            $ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),ord_max(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))))) ) ) ) ).

% or_int_unfold
tff(fact_3919_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea3799213064322606851m_diff(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A)),bit_se5824344971392196577ns_xor(A)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_3920_or__minus__numerals_I4_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,aa(num,num,bit0,Na)))) ) ).

% or_minus_numerals(4)
tff(fact_3921_or__minus__numerals_I8_J,axiom,
    ! [Na: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))),aa(num,int,numeral_numeral(int),M)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,aa(num,num,bit0,Na)))) ) ).

% or_minus_numerals(8)
tff(fact_3922_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),Z)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Z) ) ) ) ).

% max_less_iff_conj
tff(fact_3923_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = B2 ) ) ) ).

% max.absorb4
tff(fact_3924_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = A2 ) ) ) ).

% max.absorb3
tff(fact_3925_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o,Q: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),
              (P)
            | (Q))
          = aa(A,A,aa(A,fun(A,A),ord_max(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_or_iff
tff(fact_3926_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),V),aa(num,A,numeral_numeral(A),U)) ) ) ).

% max_number_of(1)
tff(fact_3927_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X)),zero_zero(A)) = aa(num,A,numeral_numeral(A),X) ) ) ).

% max_0_1(4)
tff(fact_3928_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),aa(num,A,numeral_numeral(A),X)) = aa(num,A,numeral_numeral(A),X) ) ) ).

% max_0_1(3)
tff(fact_3929_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),one_one(A)) = one_one(A) ) ) ).

% max_0_1(1)
tff(fact_3930_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),zero_zero(A)) = one_one(A) ) ) ).

% max_0_1(2)
tff(fact_3931_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) = aa(num,A,numeral_numeral(A),X) ) ) ).

% max_0_1(6)
tff(fact_3932_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),aa(num,A,numeral_numeral(A),X)) = aa(num,A,numeral_numeral(A),X) ) ) ).

% max_0_1(5)
tff(fact_3933_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))) ) ) ).

% max_number_of(4)
tff(fact_3934_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),V),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))) ) ) ).

% max_number_of(3)
tff(fact_3935_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),U)) ) ) ).

% max_number_of(2)
tff(fact_3936_drop__bit__of__Suc__0,axiom,
    ! [Na: nat] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,Na),aa(nat,nat,suc,zero_zero(nat))) = aa($o,nat,zero_neq_one_of_bool(nat),( Na = zero_zero(nat) )) ) ).

% drop_bit_of_Suc_0
tff(fact_3937_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ).

% max.strict_coboundedI2
tff(fact_3938_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ).

% max.strict_coboundedI1
tff(fact_3939_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% max.strict_order_iff
tff(fact_3940_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A2)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% max.strict_boundedE
tff(fact_3941_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X)
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),Y) ) ) ) ).

% less_max_iff_disj
tff(fact_3942_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z)) ) ) ).

% max_diff_distrib_left
tff(fact_3943_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),ord_max(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z)) ) ) ).

% max_add_distrib_right
tff(fact_3944_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z)) ) ) ).

% max_add_distrib_left
tff(fact_3945_of__int__max,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: int,Y: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),ord_max(int),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(int,A,ring_1_of_int(A),X)),aa(int,A,ring_1_of_int(A),Y)) ) ) ).

% of_int_max
tff(fact_3946_of__nat__max,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: nat,Y: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,semiring_1_of_nat(A),X)),aa(nat,A,semiring_1_of_nat(A),Y)) ) ) ).

% of_nat_max
tff(fact_3947_or__not__num__neg_Osimps_I1_J,axiom,
    bit_or_not_num_neg(one2,one2) = one2 ).

% or_not_num_neg.simps(1)
tff(fact_3948_drop__bit__nat__eq,axiom,
    ! [Na: nat,K: int] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,Na),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se4197421643247451524op_bit(int,Na),K)) ) ).

% drop_bit_nat_eq
tff(fact_3949_or__not__num__neg_Osimps_I4_J,axiom,
    ! [Na: num] : ( bit_or_not_num_neg(aa(num,num,bit0,Na),one2) = aa(num,num,bit0,one2) ) ).

% or_not_num_neg.simps(4)
tff(fact_3950_or__not__num__neg_Osimps_I6_J,axiom,
    ! [Na: num,M: num] : ( bit_or_not_num_neg(aa(num,num,bit0,Na),aa(num,num,bit1,M)) = aa(num,num,bit0,bit_or_not_num_neg(Na,M)) ) ).

% or_not_num_neg.simps(6)
tff(fact_3951_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] : ( bit_or_not_num_neg(one2,aa(num,num,bit1,M)) = aa(num,num,bit1,M) ) ).

% or_not_num_neg.simps(3)
tff(fact_3952_or__not__num__neg_Osimps_I7_J,axiom,
    ! [Na: num] : ( bit_or_not_num_neg(aa(num,num,bit1,Na),one2) = one2 ) ).

% or_not_num_neg.simps(7)
tff(fact_3953_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] : ( bit_or_not_num_neg(one2,aa(num,num,bit0,M)) = aa(num,num,bit1,M) ) ).

% or_not_num_neg.simps(2)
tff(fact_3954_drop__bit__nat__def,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,Na),M) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)) ) ).

% drop_bit_nat_def
tff(fact_3955_numeral__or__not__num__eq,axiom,
    ! [M: num,Na: num] : ( aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,Na)) = aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na)))) ) ).

% numeral_or_not_num_eq
tff(fact_3956_int__numeral__not__or__num__neg,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),Na)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(Na,M))) ) ).

% int_numeral_not_or_num_neg
tff(fact_3957_int__numeral__or__not__num__neg,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,Na))) ) ).

% int_numeral_or_not_num_neg
tff(fact_3958_or__minus__numerals_I5_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(Na)))) ) ).

% or_minus_numerals(5)
tff(fact_3959_or__minus__numerals_I1_J,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(Na)))) ) ).

% or_minus_numerals(1)
tff(fact_3960_or__nat__unfold,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),Na)
      = $ite(
          M = zero_zero(nat),
          Na,
          $ite(Na = zero_zero(nat),M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),modulo_modulo(nat,Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% or_nat_unfold
tff(fact_3961_or__minus__numerals_I7_J,axiom,
    ! [Na: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))),aa(num,int,numeral_numeral(int),M)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,bitM(Na)))) ) ).

% or_minus_numerals(7)
tff(fact_3962_max__enat__simps_I3_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),zero_zero(extended_enat)),Q4) = Q4 ) ).

% max_enat_simps(3)
tff(fact_3963_max__enat__simps_I2_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q4),zero_zero(extended_enat)) = Q4 ) ).

% max_enat_simps(2)
tff(fact_3964_max__Suc__Suc,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,Na)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),Na)) ) ).

% max_Suc_Suc
tff(fact_3965_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),B2) = zero_zero(nat) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.eq_neutr_iff
tff(fact_3966_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),A2) = A2 ) ).

% max_nat.left_neutral
tff(fact_3967_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),B2) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.neutr_eq_iff
tff(fact_3968_max__nat_Oright__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),zero_zero(nat)) = A2 ) ).

% max_nat.right_neutral
tff(fact_3969_max__0L,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),Na) = Na ) ).

% max_0L
tff(fact_3970_max__0R,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Na),zero_zero(nat)) = Na ) ).

% max_0R
tff(fact_3971_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% dbl_dec_simps(5)
tff(fact_3972_pred__numeral__simps_I2_J,axiom,
    ! [K: num] : ( pred_numeral(aa(num,num,bit0,K)) = aa(num,nat,numeral_numeral(nat),bitM(K)) ) ).

% pred_numeral_simps(2)
tff(fact_3973_max__Suc__numeral,axiom,
    ! [Na: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Na),pred_numeral(K))) ) ).

% max_Suc_numeral
tff(fact_3974_max__numeral__Suc,axiom,
    ! [K: num,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Na)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),pred_numeral(K)),Na)) ) ).

% max_numeral_Suc
tff(fact_3975_or__minus__numerals_I3_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(M,bitM(Na)))) ) ).

% or_minus_numerals(3)
tff(fact_3976_nat__mult__max__right,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Na),Q4)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q4)) ) ).

% nat_mult_max_right
tff(fact_3977_nat__mult__max__left,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),Na)),Q4) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q4)) ) ).

% nat_mult_max_left
tff(fact_3978_nat__add__max__right,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Na),Q4)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q4)) ) ).

% nat_add_max_right
tff(fact_3979_nat__add__max__left,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),Na)),Q4) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q4)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),Q4)) ) ).

% nat_add_max_left
tff(fact_3980_semiring__norm_I26_J,axiom,
    bitM(one2) = one2 ).

% semiring_norm(26)
tff(fact_3981_nat__minus__add__max,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)),M) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Na),M) ) ).

% nat_minus_add_max
tff(fact_3982_semiring__norm_I28_J,axiom,
    ! [Na: num] : ( bitM(aa(num,num,bit1,Na)) = aa(num,num,bit1,aa(num,num,bit0,Na)) ) ).

% semiring_norm(28)
tff(fact_3983_semiring__norm_I27_J,axiom,
    ! [Na: num] : ( bitM(aa(num,num,bit0,Na)) = aa(num,num,bit1,bitM(Na)) ) ).

% semiring_norm(27)
tff(fact_3984_or__not__num__neg_Osimps_I5_J,axiom,
    ! [Na: num,M: num] : ( bit_or_not_num_neg(aa(num,num,bit0,Na),aa(num,num,bit0,M)) = bitM(bit_or_not_num_neg(Na,M)) ) ).

% or_not_num_neg.simps(5)
tff(fact_3985_inc__BitM__eq,axiom,
    ! [Na: num] : ( inc(bitM(Na)) = aa(num,num,bit0,Na) ) ).

% inc_BitM_eq
tff(fact_3986_or__not__num__neg_Osimps_I9_J,axiom,
    ! [Na: num,M: num] : ( bit_or_not_num_neg(aa(num,num,bit1,Na),aa(num,num,bit1,M)) = bitM(bit_or_not_num_neg(Na,M)) ) ).

% or_not_num_neg.simps(9)
tff(fact_3987_BitM__inc__eq,axiom,
    ! [Na: num] : ( bitM(inc(Na)) = aa(num,num,bit1,Na) ) ).

% BitM_inc_eq
tff(fact_3988_eval__nat__numeral_I2_J,axiom,
    ! [Na: num] : ( aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,Na)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),bitM(Na))) ) ).

% eval_nat_numeral(2)
tff(fact_3989_BitM__plus__one,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bitM(Na)),one2) = aa(num,num,bit0,Na) ) ).

% BitM_plus_one
tff(fact_3990_one__plus__BitM,axiom,
    ! [Na: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bitM(Na)) = aa(num,num,bit0,Na) ) ).

% one_plus_BitM
tff(fact_3991_or__not__num__neg_Osimps_I8_J,axiom,
    ! [Na: num,M: num] : ( bit_or_not_num_neg(aa(num,num,bit1,Na),aa(num,num,bit0,M)) = bitM(bit_or_not_num_neg(Na,M)) ) ).

% or_not_num_neg.simps(8)
tff(fact_3992_numeral__BitM,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(num,A,numeral_numeral(A),bitM(Na)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na))),one_one(A)) ) ) ).

% numeral_BitM
tff(fact_3993_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [W: num] : ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,A,numeral_numeral(A),bitM(W))) ) ).

% odd_numeral_BitM
tff(fact_3994_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(num,A,numeral_numeral(A),bitM(Na))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na))) ) ) ).

% not_numeral_BitM_eq
tff(fact_3995_or__not__num__neg_Oelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( bit_or_not_num_neg(X,Xa) = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [M4: num] :
                ( ( Xa = aa(num,num,bit0,M4) )
               => ( Y != aa(num,num,bit1,M4) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa = aa(num,num,bit1,M4) )
                 => ( Y != aa(num,num,bit1,M4) ) ) )
           => ( ( ? [N: num] : ( X = aa(num,num,bit0,N) )
               => ( ( Xa = one2 )
                 => ( Y != aa(num,num,bit0,one2) ) ) )
             => ( ! [N: num] :
                    ( ( X = aa(num,num,bit0,N) )
                   => ! [M4: num] :
                        ( ( Xa = aa(num,num,bit0,M4) )
                       => ( Y != bitM(bit_or_not_num_neg(N,M4)) ) ) )
               => ( ! [N: num] :
                      ( ( X = aa(num,num,bit0,N) )
                     => ! [M4: num] :
                          ( ( Xa = aa(num,num,bit1,M4) )
                         => ( Y != aa(num,num,bit0,bit_or_not_num_neg(N,M4)) ) ) )
                 => ( ( ? [N: num] : ( X = aa(num,num,bit1,N) )
                     => ( ( Xa = one2 )
                       => ( Y != one2 ) ) )
                   => ( ! [N: num] :
                          ( ( X = aa(num,num,bit1,N) )
                         => ! [M4: num] :
                              ( ( Xa = aa(num,num,bit0,M4) )
                             => ( Y != bitM(bit_or_not_num_neg(N,M4)) ) ) )
                     => ~ ! [N: num] :
                            ( ( X = aa(num,num,bit1,N) )
                           => ! [M4: num] :
                                ( ( Xa = aa(num,num,bit1,M4) )
                               => ( Y != bitM(bit_or_not_num_neg(N,M4)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
tff(fact_3996_nth__rotate1,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,rotate1(A,Xs)),Na) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,suc,Na),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate1
tff(fact_3997_root__powr__inverse,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(real,real,root(Na),X) = powr(real,X,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),Na))) ) ) ) ).

% root_powr_inverse
tff(fact_3998_xor__minus__numerals_I2_J,axiom,
    ! [K: int,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),neg_numeral_sub(int,Na,one2))) ) ).

% xor_minus_numerals(2)
tff(fact_3999_xor__minus__numerals_I1_J,axiom,
    ! [Na: num,K: int] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))),K) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),neg_numeral_sub(int,Na,one2)),K)) ) ).

% xor_minus_numerals(1)
tff(fact_4000_real__root__zero,axiom,
    ! [Na: nat] : ( aa(real,real,root(Na),zero_zero(real)) = zero_zero(real) ) ).

% real_root_zero
tff(fact_4001_length__rotate1,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),rotate1(A,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rotate1
tff(fact_4002_real__root__Suc__0,axiom,
    ! [X: real] : ( aa(real,real,root(aa(nat,nat,suc,zero_zero(nat))),X) = X ) ).

% real_root_Suc_0
tff(fact_4003_root__0,axiom,
    ! [X: real] : ( aa(real,real,root(zero_zero(nat)),X) = zero_zero(real) ) ).

% root_0
tff(fact_4004_real__root__eq__iff,axiom,
    ! [Na: nat,X: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( aa(real,real,root(Na),X) = aa(real,real,root(Na),Y) )
      <=> ( X = Y ) ) ) ).

% real_root_eq_iff
tff(fact_4005_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_sub(A,one2,one2) = zero_zero(A) ) ) ).

% sub_num_simps(1)
tff(fact_4006_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = neg_numeral_sub(A,M,Na) ) ) ).

% diff_numeral_simps(1)
tff(fact_4007_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit0,K),aa(num,num,bit0,L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(6)
tff(fact_4008_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),aa(num,num,bit1,L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(9)
tff(fact_4009_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,W,V)),Y) ) ) ).

% semiring_norm(167)
tff(fact_4010_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,V,W)),Y) ) ) ).

% semiring_norm(166)
tff(fact_4011_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),Na)) = neg_numeral_sub(A,Na,M) ) ) ).

% add_neg_numeral_simps(2)
tff(fact_4012_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = neg_numeral_sub(A,M,Na) ) ) ).

% add_neg_numeral_simps(1)
tff(fact_4013_real__root__eq__0__iff,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( aa(real,real,root(Na),X) = zero_zero(real) )
      <=> ( X = zero_zero(real) ) ) ) ).

% real_root_eq_0_iff
tff(fact_4014_real__root__less__iff,axiom,
    ! [Na: nat,X: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Na),X)),aa(real,real,root(Na),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y) ) ) ).

% real_root_less_iff
tff(fact_4015_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = neg_numeral_sub(A,Na,M) ) ) ).

% diff_numeral_simps(4)
tff(fact_4016_real__root__le__iff,axiom,
    ! [Na: nat,X: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Na),X)),aa(real,real,root(Na),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y) ) ) ).

% real_root_le_iff
tff(fact_4017_real__root__one,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,root(Na),one_one(real)) = one_one(real) ) ) ).

% real_root_one
tff(fact_4018_real__root__eq__1__iff,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( aa(real,real,root(Na),X) = one_one(real) )
      <=> ( X = one_one(real) ) ) ) ).

% real_root_eq_1_iff
tff(fact_4019_rotate1__length01,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => ( rotate1(A,Xs) = Xs ) ) ).

% rotate1_length01
tff(fact_4020_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),aa(num,num,bit0,L)) = neg_numeral_dbl_inc(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(8)
tff(fact_4021_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit0,K),aa(num,num,bit1,L)) = neg_numeral_dbl_dec(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(7)
tff(fact_4022_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(num,A,numeral_numeral(A),Na)) = neg_numeral_sub(A,one2,Na) ) ) ).

% diff_numeral_special(1)
tff(fact_4023_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),one_one(A)) = neg_numeral_sub(A,M,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_4024_real__root__gt__0__iff,axiom,
    ! [Na: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,root(Na),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y) ) ) ).

% real_root_gt_0_iff
tff(fact_4025_real__root__lt__0__iff,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Na),X)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real)) ) ) ).

% real_root_lt_0_iff
tff(fact_4026_real__root__ge__0__iff,axiom,
    ! [Na: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(Na),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y) ) ) ).

% real_root_ge_0_iff
tff(fact_4027_real__root__le__0__iff,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Na),X)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real)) ) ) ).

% real_root_le_0_iff
tff(fact_4028_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),one2) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,K)) ) ) ).

% sub_num_simps(5)
tff(fact_4029_real__root__gt__1__iff,axiom,
    ! [Na: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,root(Na),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Y) ) ) ).

% real_root_gt_1_iff
tff(fact_4030_real__root__lt__1__iff,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Na),X)),one_one(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real)) ) ) ).

% real_root_lt_1_iff
tff(fact_4031_real__root__ge__1__iff,axiom,
    ! [Na: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,root(Na),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y) ) ) ).

% real_root_ge_1_iff
tff(fact_4032_real__root__le__1__iff,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Na),X)),one_one(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real)) ) ) ).

% real_root_le_1_iff
tff(fact_4033_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = neg_numeral_sub(A,Na,one2) ) ) ).

% not_minus_numeral_eq
tff(fact_4034_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,aa(num,num,bit0,K),one2) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% sub_num_simps(4)
tff(fact_4035_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),Na)) = neg_numeral_sub(A,Na,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_4036_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,M,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_4037_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) = neg_numeral_sub(A,one2,M) ) ) ).

% add_neg_numeral_special(2)
tff(fact_4038_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) = neg_numeral_sub(A,one2,M) ) ) ).

% add_neg_numeral_special(1)
tff(fact_4039_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,one2,M) ) ) ).

% diff_numeral_special(8)
tff(fact_4040_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = neg_numeral_sub(A,Na,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_4041_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),neg_numeral_sub(A,M,one2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) ) ) ).

% minus_sub_one_diff_one
tff(fact_4042_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,aa(num,num,bit1,L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,L))) ) ) ).

% sub_num_simps(3)
tff(fact_4043_real__root__pow__pos2,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
       => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),Na) = X ) ) ) ).

% real_root_pow_pos2
tff(fact_4044_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,aa(num,num,bit0,L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bitM(L))) ) ) ).

% sub_num_simps(2)
tff(fact_4045_real__root__divide,axiom,
    ! [Na: nat,X: real,Y: real] : ( aa(real,real,root(Na),aa(real,real,aa(real,fun(real,real),divide_divide(real),X),Y)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,root(Na),X)),aa(real,real,root(Na),Y)) ) ).

% real_root_divide
tff(fact_4046_real__root__commute,axiom,
    ! [M: nat,Na: nat,X: real] : ( aa(real,real,root(M),aa(real,real,root(Na),X)) = aa(real,real,root(Na),aa(real,real,root(M),X)) ) ).

% real_root_commute
tff(fact_4047_real__root__minus,axiom,
    ! [Na: nat,X: real] : ( aa(real,real,root(Na),aa(real,real,uminus_uminus(real),X)) = aa(real,real,uminus_uminus(real),aa(real,real,root(Na),X)) ) ).

% real_root_minus
tff(fact_4048_real__root__mult,axiom,
    ! [Na: nat,X: real,Y: real] : ( aa(real,real,root(Na),aa(real,real,aa(real,fun(real,real),times_times(real),X),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,root(Na),X)),aa(real,real,root(Na),Y)) ) ).

% real_root_mult
tff(fact_4049_real__root__mult__exp,axiom,
    ! [M: nat,Na: nat,X: real] : ( aa(real,real,root(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),X) = aa(real,real,root(M),aa(real,real,root(Na),X)) ) ).

% real_root_mult_exp
tff(fact_4050_real__root__inverse,axiom,
    ! [Na: nat,X: real] : ( aa(real,real,root(Na),aa(real,real,inverse_inverse(real),X)) = aa(real,real,inverse_inverse(real),aa(real,real,root(Na),X)) ) ).

% real_root_inverse
tff(fact_4051_real__root__pos__pos__le,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(Na),X)) ) ).

% real_root_pos_pos_le
tff(fact_4052_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,K,L) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) ) ) ).

% neg_numeral_class.sub_def
tff(fact_4053_real__root__less__mono,axiom,
    ! [Na: nat,X: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Na),X)),aa(real,real,root(Na),Y)) ) ) ).

% real_root_less_mono
tff(fact_4054_real__root__le__mono,axiom,
    ! [Na: nat,X: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Na),X)),aa(real,real,root(Na),Y)) ) ) ).

% real_root_le_mono
tff(fact_4055_real__root__power,axiom,
    ! [Na: nat,X: real,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,root(Na),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),K)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),K) ) ) ).

% real_root_power
tff(fact_4056_real__root__abs,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,root(Na),aa(real,real,abs_abs(real),X)) = aa(real,real,abs_abs(real),aa(real,real,root(Na),X)) ) ) ).

% real_root_abs
tff(fact_4057_sgn__root,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,sgn_sgn(real),aa(real,real,root(Na),X)) = aa(real,real,sgn_sgn(real),X) ) ) ).

% sgn_root
tff(fact_4058_sub__non__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),neg_numeral_sub(A,Na,M)),zero_zero(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Na),M) ) ) ).

% sub_non_positive
tff(fact_4059_sub__non__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),neg_numeral_sub(A,Na,M))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na) ) ) ).

% sub_non_negative
tff(fact_4060_sub__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),neg_numeral_sub(A,Na,M))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na) ) ) ).

% sub_positive
tff(fact_4061_sub__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),neg_numeral_sub(A,Na,M)),zero_zero(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),Na),M) ) ) ).

% sub_negative
tff(fact_4062_real__root__gt__zero,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,root(Na),X)) ) ) ).

% real_root_gt_zero
tff(fact_4063_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Na: num] : ( neg_numeral_sub(A,inc(Na),one2) = aa(num,A,numeral_numeral(A),Na) ) ) ).

% sub_inc_One_eq
tff(fact_4064_real__root__strict__decreasing,axiom,
    ! [Na: nat,N3: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N3),X)),aa(real,real,root(Na),X)) ) ) ) ).

% real_root_strict_decreasing
tff(fact_4065_sqrt__def,axiom,
    sqrt = root(aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ).

% sqrt_def
tff(fact_4066_root__abs__power,axiom,
    ! [Na: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,abs_abs(real),aa(real,real,root(Na),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),Na))) = aa(real,real,abs_abs(real),Y) ) ) ).

% root_abs_power
tff(fact_4067_real__root__pos__pos,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(Na),X)) ) ) ).

% real_root_pos_pos
tff(fact_4068_real__root__strict__increasing,axiom,
    ! [Na: nat,N3: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(Na),X)),aa(real,real,root(N3),X)) ) ) ) ) ).

% real_root_strict_increasing
tff(fact_4069_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na)) = aa(A,A,bit_ri4277139882892585799ns_not(A),neg_numeral_sub(A,Na,one2)) ) ) ).

% minus_numeral_eq_not_sub_one
tff(fact_4070_real__root__decreasing,axiom,
    ! [Na: nat,N3: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),X)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N3),X)),aa(real,real,root(Na),X)) ) ) ) ).

% real_root_decreasing
tff(fact_4071_real__root__pow__pos,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),Na) = X ) ) ) ).

% real_root_pow_pos
tff(fact_4072_real__root__power__cancel,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
       => ( aa(real,real,root(Na),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na)) = X ) ) ) ).

% real_root_power_cancel
tff(fact_4073_real__root__pos__unique,axiom,
    ! [Na: nat,Y: real,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),Na) = X )
         => ( aa(real,real,root(Na),X) = Y ) ) ) ) ).

% real_root_pos_unique
tff(fact_4074_odd__real__root__power__cancel,axiom,
    ! [Na: nat,X: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(real,real,root(Na),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na)) = X ) ) ).

% odd_real_root_power_cancel
tff(fact_4075_odd__real__root__unique,axiom,
    ! [Na: nat,Y: real,X: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),Na) = X )
       => ( aa(real,real,root(Na),X) = Y ) ) ) ).

% odd_real_root_unique
tff(fact_4076_odd__real__root__pow,axiom,
    ! [Na: nat,X: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),Na) = X ) ) ).

% odd_real_root_pow
tff(fact_4077_real__root__increasing,axiom,
    ! [Na: nat,N3: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),N3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(Na),X)),aa(real,real,root(N3),X)) ) ) ) ) ).

% real_root_increasing
tff(fact_4078_sub__BitM__One__eq,axiom,
    ! [Na: num] : ( neg_numeral_sub(int,bitM(Na),one2) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),neg_numeral_sub(int,Na,one2)) ) ).

% sub_BitM_One_eq
tff(fact_4079_sgn__power__root,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),aa(real,real,root(Na),X))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),aa(real,real,root(Na),X))),Na)) = X ) ) ).

% sgn_power_root
tff(fact_4080_root__sgn__power,axiom,
    ! [Na: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,real,root(Na),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Y)),Na))) = Y ) ) ).

% root_sgn_power
tff(fact_4081_ln__root,axiom,
    ! [Na: nat,B2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
       => ( aa(real,real,ln_ln(real),aa(real,real,root(Na),B2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),B2)),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ) ).

% ln_root
tff(fact_4082_log__root,axiom,
    ! [Na: nat,A2: real,B2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ( aa(real,real,log(B2),aa(real,real,root(Na),A2)) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,log(B2),A2)),aa(nat,real,semiring_1_of_nat(real),Na)) ) ) ) ).

% log_root
tff(fact_4083_log__base__root,axiom,
    ! [Na: nat,B2: real,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
       => ( aa(real,real,log(aa(real,real,root(Na),B2)),X) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(real,real,log(B2),X)) ) ) ) ).

% log_base_root
tff(fact_4084_split__root,axiom,
    ! [P: fun(real,$o),Na: nat,X: real] :
      ( aa(real,$o,P,aa(real,real,root(Na),X))
    <=> ( ( ( Na = zero_zero(nat) )
         => aa(real,$o,P,zero_zero(real)) )
        & ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ! [Y5: real] :
              ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y5)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Y5)),Na)) = X )
             => aa(real,$o,P,Y5) ) ) ) ) ).

% split_root
tff(fact_4085_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea2506097494486148201lgebra(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_4086_a,axiom,
    vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,suc,va))) = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,va)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),vEBT_vebt_buildup(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ).

% a
tff(fact_4087_nat__descend__induct,axiom,
    ! [Na: nat,P: fun(nat,$o),M: nat] :
      ( ! [K2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),K2)
         => aa(nat,$o,P,K2) )
     => ( ! [K2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),Na)
           => ( ! [I4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),I4)
                 => aa(nat,$o,P,I4) )
             => aa(nat,$o,P,K2) ) )
       => aa(nat,$o,P,M) ) ) ).

% nat_descend_induct
tff(fact_4088_num__of__nat_Osimps_I2_J,axiom,
    ! [Na: nat] :
      ( num_of_nat(aa(nat,nat,suc,Na))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na),inc(num_of_nat(Na)),one2) ) ).

% num_of_nat.simps(2)
tff(fact_4089_VEBT_Oinject_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,Y11: option(product_prod(nat,nat)),Y12: nat,Y13: list(vEBT_VEBT),Y14: vEBT_VEBT] :
      ( ( vEBT_Node(X11,X12,X13,X14) = vEBT_Node(Y11,Y12,Y13,Y14) )
    <=> ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
tff(fact_4090_num__of__nat__numeral__eq,axiom,
    ! [Q4: num] : ( num_of_nat(aa(num,nat,numeral_numeral(nat),Q4)) = Q4 ) ).

% num_of_nat_numeral_eq
tff(fact_4091_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list(vEBT_VEBT),Uy: vEBT_VEBT,Uz: nat] : ~ vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux,Uy),Uz) ).

% VEBT_internal.membermima.simps(2)
tff(fact_4092_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT,Ux: nat] : ~ vEBT_V5719532721284313246member(vEBT_Node(Uu,zero_zero(nat),Uv,Uw),Ux) ).

% VEBT_internal.naive_member.simps(2)
tff(fact_4093_num__of__nat_Osimps_I1_J,axiom,
    num_of_nat(zero_zero(nat)) = one2 ).

% num_of_nat.simps(1)
tff(fact_4094_numeral__num__of__nat,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(num,nat,numeral_numeral(nat),num_of_nat(Na)) = Na ) ) ).

% numeral_num_of_nat
tff(fact_4095_num__of__nat__One,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),one_one(nat))
     => ( num_of_nat(Na) = one2 ) ) ).

% num_of_nat_One
tff(fact_4096_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList: list(vEBT_VEBT),Na: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
         => vEBT_invar_vebt(X3,Na) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M) )
         => ( ( M = Na )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M) )
             => ( ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X_1)
               => ( ! [X3: vEBT_VEBT] :
                      ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                     => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
tff(fact_4097_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList: list(vEBT_VEBT),Na: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
         => vEBT_invar_vebt(X3,Na) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M) )
         => ( ( M = aa(nat,nat,suc,Na) )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M) )
             => ( ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X_1)
               => ( ! [X3: vEBT_VEBT] :
                      ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                     => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
tff(fact_4098_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] :
          ( aa(num,A,numeral_numeral(A),num_of_nat(Na))
          = $ite(Na = zero_zero(nat),one_one(A),aa(nat,A,semiring_1_of_nat(A),Na)) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_4099_num__of__nat__double,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),Na)) = aa(num,num,bit0,num_of_nat(Na)) ) ) ).

% num_of_nat_double
tff(fact_4100_num__of__nat__plus__distrib,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),num_of_nat(M)),num_of_nat(Na)) ) ) ) ).

% num_of_nat_plus_distrib
tff(fact_4101_option_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(option(A),nat,size_size(option(A)),none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(3)
tff(fact_4102_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList: list(vEBT_VEBT),Na: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
         => vEBT_invar_vebt(X3,Na) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M) )
         => ( ( M = aa(nat,nat,suc,Na) )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M) )
             => ( ! [I3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M))
                   => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),X_13)
                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),I3) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                       => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) ) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi),Ma)
                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Deg))
                     => ( ( ( Mi != Ma )
                         => ! [I3: nat] :
                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M))
                             => ( ( ( vEBT_VEBT_high(Ma,Na) = I3 )
                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(Ma,Na)) )
                                & ! [X3: nat] :
                                    ( ( ( vEBT_VEBT_high(X3,Na) = I3 )
                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(X3,Na)) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi),X3)
                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Ma) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
tff(fact_4103_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList: list(vEBT_VEBT),Na: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
         => vEBT_invar_vebt(X3,Na) )
     => ( vEBT_invar_vebt(Summary,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M) )
         => ( ( M = Na )
           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M) )
             => ( ! [I3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M))
                   => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),X_13)
                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),I3) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                       => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) ) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi),Ma)
                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Deg))
                     => ( ( ( Mi != Ma )
                         => ! [I3: nat] :
                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M))
                             => ( ( ( vEBT_VEBT_high(Ma,Na) = I3 )
                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(Ma,Na)) )
                                & ! [X3: nat] :
                                    ( ( ( vEBT_VEBT_high(X3,Na) = I3 )
                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I3)),vEBT_VEBT_low(X3,Na)) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi),X3)
                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Ma) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma)),Deg,TreeList,Summary),Deg) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
tff(fact_4104_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y22: $o] :
      ( ( vEBT_Leaf(X21,X222) = vEBT_Leaf(Y21,Y22) )
    <=> ( ( (X21)
        <=> (Y21) )
        & ( (X222)
        <=> (Y22) ) ) ) ).

% VEBT.inject(2)
tff(fact_4105_VEBT_Oexhaust,axiom,
    ! [Y: vEBT_VEBT] :
      ( ! [X112: option(product_prod(nat,nat)),X122: nat,X132: list(vEBT_VEBT),X142: vEBT_VEBT] : ( Y != vEBT_Node(X112,X122,X132,X142) )
     => ~ ! [X212: $o,X223: $o] : ( Y != vEBT_Leaf(X212,X223) ) ) ).

% VEBT.exhaust
tff(fact_4106_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,X21: $o,X222: $o] : ( vEBT_Node(X11,X12,X13,X14) != vEBT_Leaf(X21,X222) ) ).

% VEBT.distinct(1)
tff(fact_4107_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size(4)
tff(fact_4108_option_Osize_I4_J,axiom,
    ! [A: $tType,X2: A] : ( aa(option(A),nat,size_size(option(A)),some(A,X2)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(4)
tff(fact_4109_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod(nat,nat)] :
      ~ ! [K2: nat,M4: nat] : ( X != aa(nat,product_prod(nat,nat),product_Pair(nat,nat,K2),M4) ) ).

% prod_decode_aux.cases
tff(fact_4110_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] : ~ vEBT_VEBT_membermima(vEBT_Leaf(Uu,Uv),Uw) ).

% VEBT_internal.membermima.simps(1)
tff(fact_4111_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Vaa: list(vEBT_VEBT),Vb: vEBT_VEBT,X: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma)),zero_zero(nat),Vaa,Vb),X)
    <=> ( ( X = Mi )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
tff(fact_4112_vebt__buildup_Osimps_I1_J,axiom,
    vEBT_vebt_buildup(zero_zero(nat)) = vEBT_Leaf($false,$false) ).

% vebt_buildup.simps(1)
tff(fact_4113_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( vEBT_VEBT_valid(vEBT_Leaf(Uu,Uv),D2)
    <=> ( D2 = one_one(nat) ) ) ).

% VEBT_internal.valid'.simps(1)
tff(fact_4114_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : vEBT_invar_vebt(vEBT_Leaf(A2,B2),aa(nat,nat,suc,zero_zero(nat))) ).

% invar_vebt.intros(1)
tff(fact_4115_option_Osize__neq,axiom,
    ! [A: $tType,X: option(A)] : ( aa(option(A),nat,size_size(option(A)),X) != zero_zero(nat) ) ).

% option.size_neq
tff(fact_4116_vebt__buildup_Osimps_I2_J,axiom,
    vEBT_vebt_buildup(aa(nat,nat,suc,zero_zero(nat))) = vEBT_Leaf($false,$false) ).

% vebt_buildup.simps(2)
tff(fact_4117_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Leaf(A2,B2),X)
    <=> $ite(
          X = zero_zero(nat),
          (A2),
          $ite(X = one_one(nat),(B2),$false) ) ) ).

% VEBT_internal.naive_member.simps(1)
tff(fact_4118_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
     => ( ( ? [A4: $o,B4: $o] : ( A1 = vEBT_Leaf(A4,B4) )
         => ( A22 != aa(nat,nat,suc,zero_zero(nat)) ) )
       => ( ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg2,TreeList2,Summary2) )
             => ( ( A22 = Deg2 )
               => ( ! [X4: vEBT_VEBT] :
                      ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                     => vEBT_invar_vebt(X4,N) )
                 => ( vEBT_invar_vebt(Summary2,M4)
                   => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4) )
                     => ( ( M4 = N )
                       => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4) )
                         => ( ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X_12)
                           => ~ ! [X4: vEBT_VEBT] :
                                  ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                                 => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg2,TreeList2,Summary2) )
               => ( ( A22 = Deg2 )
                 => ( ! [X4: vEBT_VEBT] :
                        ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                       => vEBT_invar_vebt(X4,N) )
                   => ( vEBT_invar_vebt(Summary2,M4)
                     => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4) )
                       => ( ( M4 = aa(nat,nat,suc,N) )
                         => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4) )
                           => ( ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X_12)
                             => ~ ! [X4: vEBT_VEBT] :
                                    ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                                   => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                  ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),Deg2,TreeList2,Summary2) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X4: vEBT_VEBT] :
                          ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                         => vEBT_invar_vebt(X4,N) )
                     => ( vEBT_invar_vebt(Summary2,M4)
                       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4) )
                         => ( ( M4 = N )
                           => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4) )
                             => ( ! [I4: nat] :
                                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4))
                                   => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),X_13)
                                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),I4) ) )
                               => ( ( ( Mi2 = Ma2 )
                                   => ! [X4: vEBT_VEBT] :
                                        ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                                       => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) )
                                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi2),Ma2)
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Deg2))
                                     => ~ ( ( Mi2 != Ma2 )
                                         => ! [I4: nat] :
                                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4))
                                             => ( ( ( vEBT_VEBT_high(Ma2,N) = I4 )
                                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(Ma2,N)) )
                                                & ! [X4: nat] :
                                                    ( ( ( vEBT_VEBT_high(X4,N) = I4 )
                                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(X4,N)) )
                                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi2),X4)
                                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Ma2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                    ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),Deg2,TreeList2,Summary2) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X4: vEBT_VEBT] :
                            ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                           => vEBT_invar_vebt(X4,N) )
                       => ( vEBT_invar_vebt(Summary2,M4)
                         => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4) )
                           => ( ( M4 = aa(nat,nat,suc,N) )
                             => ( ( Deg2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4) )
                               => ( ! [I4: nat] :
                                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4))
                                     => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),X_13)
                                      <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),I4) ) )
                                 => ( ( ( Mi2 = Ma2 )
                                     => ! [X4: vEBT_VEBT] :
                                          ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                                         => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi2),Ma2)
                                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Deg2))
                                       => ~ ( ( Mi2 != Ma2 )
                                           => ! [I4: nat] :
                                                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4))
                                               => ( ( ( vEBT_VEBT_high(Ma2,N) = I4 )
                                                   => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(Ma2,N)) )
                                                  & ! [X4: nat] :
                                                      ( ( ( vEBT_VEBT_high(X4,N) = I4 )
                                                        & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I4)),vEBT_VEBT_low(X4,N)) )
                                                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi2),X4)
                                                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Ma2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
tff(fact_4119_invar__vebt_Osimps,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
    <=> ( ( ? [A6: $o,B7: $o] : ( A1 = vEBT_Leaf(A6,B7) )
          & ( A22 = aa(nat,nat,suc,zero_zero(nat)) ) )
        | ? [TreeList3: list(vEBT_VEBT),N4: nat,Summary3: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList3,Summary3) )
            & ! [X5: vEBT_VEBT] :
                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X5,N4) )
            & vEBT_invar_vebt(Summary3,N4)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),N4) )
            & ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),X_13)
            & ! [X5: vEBT_VEBT] :
                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X_13) ) )
        | ? [TreeList3: list(vEBT_VEBT),N4: nat,Summary3: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList3,Summary3) )
            & ! [X5: vEBT_VEBT] :
                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X5,N4) )
            & vEBT_invar_vebt(Summary3,aa(nat,nat,suc,N4))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),aa(nat,nat,suc,N4)) )
            & ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),X_13)
            & ! [X5: vEBT_VEBT] :
                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X_13) ) )
        | ? [TreeList3: list(vEBT_VEBT),N4: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma3)),A22,TreeList3,Summary3) )
            & ! [X5: vEBT_VEBT] :
                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X5,N4) )
            & vEBT_invar_vebt(Summary3,N4)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),N4) )
            & ! [I: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4))
               => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I)),X_13)
                <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),I) ) )
            & ( ( Mi3 = Ma3 )
             => ! [X5: vEBT_VEBT] :
                  ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
                 => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X_13) ) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Ma3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A22))
            & ( ( Mi3 != Ma3 )
             => ! [I: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N4))
                 => ( ( ( vEBT_VEBT_high(Ma3,N4) = I )
                     => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I)),vEBT_VEBT_low(Ma3,N4)) )
                    & ! [X5: nat] :
                        ( ( ( vEBT_VEBT_high(X5,N4) = I )
                          & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I)),vEBT_VEBT_low(X5,N4)) )
                       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi3),X5)
                          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X5),Ma3) ) ) ) ) ) )
        | ? [TreeList3: list(vEBT_VEBT),N4: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma3)),A22,TreeList3,Summary3) )
            & ! [X5: vEBT_VEBT] :
                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X5,N4) )
            & vEBT_invar_vebt(Summary3,aa(nat,nat,suc,N4))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N4),aa(nat,nat,suc,N4)) )
            & ! [I: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)))
               => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I)),X_13)
                <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),I) ) )
            & ( ( Mi3 = Ma3 )
             => ! [X5: vEBT_VEBT] :
                  ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
                 => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X_13) ) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Ma3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A22))
            & ( ( Mi3 != Ma3 )
             => ! [I: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,N4)))
                 => ( ( ( vEBT_VEBT_high(Ma3,N4) = I )
                     => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I)),vEBT_VEBT_low(Ma3,N4)) )
                    & ! [X5: nat] :
                        ( ( ( vEBT_VEBT_high(X5,N4) = I )
                          & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I)),vEBT_VEBT_low(X5,N4)) )
                       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi3),X5)
                          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X5),Ma3) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
tff(fact_4120_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Q4: A,R2: A] :
          ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),product_Pair(A,A,Q4),R2))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R2),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q4)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),R2),aa(num,A,numeral_numeral(A),L))),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q4)),R2)) ) ) ).

% divmod_step_eq
tff(fact_4121_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q4: A,R2: A] :
          ( unique5940410009612947441es_aux(A,aa(A,product_prod(A,A),product_Pair(A,A,Q4),R2))
        <=> ( R2 = zero_zero(A) ) ) ) ).

% divides_aux_eq
tff(fact_4122_product__nth,axiom,
    ! [A: $tType,B: $tType,Na: nat,Xs: list(A),Ys: list(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)))
     => ( aa(nat,product_prod(A,B),nth(product_prod(A,B),product(A,B,Xs,Ys)),Na) = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Na),aa(list(B),nat,size_size(list(B)),Ys)))),aa(nat,B,nth(B,Ys),modulo_modulo(nat,Na,aa(list(B),nat,size_size(list(B)),Ys)))) ) ) ).

% product_nth
tff(fact_4123_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: fun(A,nat),X2: A] : ( size_option(A,X,some(A,X2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X,X2)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% option.size_gen(2)
tff(fact_4124_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),nat,size_size(list(product_prod(A,B))),product(A,B,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)) ) ).

% length_product
tff(fact_4125_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: $o,Uv2: $o,D4: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),D4) )
     => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT,Deg3: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Deg3) ) ) ).

% VEBT_internal.valid'.cases
tff(fact_4126_xor__num_Ocases,axiom,
    ! [X: product_prod(num,num)] :
      ( ( X != aa(num,product_prod(num,num),product_Pair(num,num,one2),one2) )
     => ( ! [N: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit0,N)) )
       => ( ! [N: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit1,N)) )
         => ( ! [M4: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),one2) )
           => ( ! [M4: num,N: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit0,N)) )
             => ( ! [M4: num,N: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit1,N)) )
               => ( ! [M4: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),one2) )
                 => ( ! [M4: num,N: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit0,N)) )
                   => ~ ! [M4: num,N: num] : ( X != aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit1,N)) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
tff(fact_4127_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod(vEBT_VEBT,nat)] :
      ( ! [A4: $o,B4: $o,X3: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),X3) )
     => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT,Ux2: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Ux2) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT),S2: vEBT_VEBT,X3: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2)),X3) ) ) ) ).

% VEBT_internal.naive_member.cases
tff(fact_4128_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Uw2) )
     => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT,Uz2: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Uz2) )
       => ( ! [Mi2: nat,Ma2: nat,Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT,X3: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2)),X3) )
         => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT,X3: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc)),X3) )
           => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT,X3: nat] : ( X != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd)),X3) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
tff(fact_4129_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: fun(A,nat)] : ( size_option(A,X,none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size_gen(1)
tff(fact_4130_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] :
          ( unique8689654367752047608divmod(A,aa(num,num,bit1,M),aa(num,num,bit1,Na))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na),aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,M))),unique1321980374590559556d_step(A,aa(num,num,bit1,Na),unique8689654367752047608divmod(A,aa(num,num,bit1,M),aa(num,num,bit0,aa(num,num,bit1,Na))))) ) ) ).

% divmod_algorithm_code(8)
tff(fact_4131_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] :
          ( unique8689654367752047608divmod(A,aa(num,num,bit0,M),aa(num,num,bit1,Na))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),Na),aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,M))),unique1321980374590559556d_step(A,aa(num,num,bit1,Na),unique8689654367752047608divmod(A,aa(num,num,bit0,M),aa(num,num,bit0,aa(num,num,bit1,Na))))) ) ) ).

% divmod_algorithm_code(7)
tff(fact_4132_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q4: int,R2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),zero_zero(int))
     => ( eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),A2),one_one(int)),B2,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2),aa(int,product_prod(int,int),product_Pair(int,int,Q4),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R2)),one_one(int)))) ) ) ).

% neg_eucl_rel_int_mult_2
tff(fact_4133_Divides_Oadjust__div__eq,axiom,
    ! [Q4: int,R2: int] : ( adjust_div(aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Q4),aa($o,int,zero_neq_one_of_bool(int),( R2 != zero_zero(int) ))) ) ).

% Divides.adjust_div_eq
tff(fact_4134_numeral__div__minus__numeral,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,M,Na))) ) ).

% numeral_div_minus_numeral
tff(fact_4135_minus__numeral__div__numeral,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),Na)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,M,Na))) ) ).

% minus_numeral_div_numeral
tff(fact_4136_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na))
        <=> unique5940410009612947441es_aux(A,unique8689654367752047608divmod(A,Na,M)) ) ) ).

% dvd_numeral_simp
tff(fact_4137_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num] : ( unique8689654367752047608divmod(A,M,one2) = aa(A,product_prod(A,A),product_Pair(A,A,aa(num,A,numeral_numeral(A),M)),zero_zero(A)) ) ) ).

% divmod_algorithm_code(2)
tff(fact_4138_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit0,Na)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(3)
tff(fact_4139_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit1,Na)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(4)
tff(fact_4140_one__div__minus__numeral,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,Na))) ) ).

% one_div_minus_numeral
tff(fact_4141_minus__one__div__numeral,axiom,
    ! [Na: num] : ( aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(num,int,numeral_numeral(int),Na)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,Na))) ) ).

% minus_one_div_numeral
tff(fact_4142_divmod__BitM__2__eq,axiom,
    ! [M: num] : ( unique8689654367752047608divmod(int,bitM(M),aa(num,num,bit0,one2)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),one_one(int)) ) ).

% divmod_BitM_2_eq
tff(fact_4143_unique__remainder,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int,Q6: int,R4: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q6),R4))
       => ( R2 = R4 ) ) ) ).

% unique_remainder
tff(fact_4144_unique__quotient,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int,Q6: int,R4: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q6),R4))
       => ( Q4 = Q6 ) ) ) ).

% unique_quotient
tff(fact_4145_eucl__rel__int__by0,axiom,
    ! [K: int] : eucl_rel_int(K,zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),K)) ).

% eucl_rel_int_by0
tff(fact_4146_div__int__unique,axiom,
    ! [K: int,L: int,Q4: int,R2: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
     => ( aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L) = Q4 ) ) ).

% div_int_unique
tff(fact_4147_mod__int__unique,axiom,
    ! [K: int,L: int,Q4: int,R2: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
     => ( modulo_modulo(int,K,L) = R2 ) ) ).

% mod_int_unique
tff(fact_4148_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q4: int] :
      ( ( L != zero_zero(int) )
     => ( ( K = aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L) )
       => eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q4),zero_zero(int))) ) ) ).

% eucl_rel_int_dividesI
tff(fact_4149_eucl__rel__int,axiom,
    ! [K: int,L: int] : eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),K),L)),modulo_modulo(int,K,L))) ).

% eucl_rel_int
tff(fact_4150_divmod__int__def,axiom,
    ! [M: num,Na: num] : ( unique8689654367752047608divmod(int,M,Na) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),Na))),modulo_modulo(int,aa(num,int,numeral_numeral(int),M),aa(num,int,numeral_numeral(int),Na))) ) ).

% divmod_int_def
tff(fact_4151_divmod__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] : ( unique8689654367752047608divmod(A,M,Na) = aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na))),modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Na))) ) ) ).

% divmod_def
tff(fact_4152_divmod_H__nat__def,axiom,
    ! [M: num,Na: num] : ( unique8689654367752047608divmod(nat,M,Na) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),Na))),modulo_modulo(nat,aa(num,nat,numeral_numeral(nat),M),aa(num,nat,numeral_numeral(nat),Na))) ) ).

% divmod'_nat_def
tff(fact_4153_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q4: int,R2: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
     => ( ( B2 != zero_zero(int) )
       => eucl_rel_int(aa(int,int,uminus_uminus(int),A2),B2,
            aa(int,product_prod(int,int),
              product_Pair(int,int,$ite(R2 = zero_zero(int),aa(int,int,uminus_uminus(int),Q4),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),Q4)),one_one(int)))),
              $ite(R2 = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),R2)))) ) ) ).

% zminus1_lemma
tff(fact_4154_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q4: int,R2: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
    <=> ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),Q4)),R2) )
        & $ite(
            aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L),
            ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R2)
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),R2),L) ),
            $ite(
              aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)),
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),R2)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R2),zero_zero(int)) ),
              Q4 = zero_zero(int) ) ) ) ) ).

% eucl_rel_int_iff
tff(fact_4155_eucl__rel__int__remainderI,axiom,
    ! [R2: int,L: int,K: int,Q4: int] :
      ( ( aa(int,int,sgn_sgn(int),R2) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R2)),aa(int,int,abs_abs(int),L))
       => ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L)),R2) )
         => eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2)) ) ) ) ).

% eucl_rel_int_remainderI
tff(fact_4156_eucl__rel__int_Osimps,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
    <=> ( ? [K3: int] :
            ( ( A1 = K3 )
            & ( A22 = zero_zero(int) )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),K3) ) )
        | ? [L3: int,K3: int,Q5: int] :
            ( ( A1 = K3 )
            & ( A22 = L3 )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q5),zero_zero(int)) )
            & ( L3 != zero_zero(int) )
            & ( K3 = aa(int,int,aa(int,fun(int,int),times_times(int),Q5),L3) ) )
        | ? [R5: int,L3: int,K3: int,Q5: int] :
            ( ( A1 = K3 )
            & ( A22 = L3 )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q5),R5) )
            & ( aa(int,int,sgn_sgn(int),R5) = aa(int,int,sgn_sgn(int),L3) )
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R5)),aa(int,int,abs_abs(int),L3))
            & ( K3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q5),L3)),R5) ) ) ) ) ).

% eucl_rel_int.simps
tff(fact_4157_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
     => ( ( ( A22 = zero_zero(int) )
         => ( A32 != aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),A1) ) )
       => ( ! [Q2: int] :
              ( ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q2),zero_zero(int)) )
             => ( ( A22 != zero_zero(int) )
               => ( A1 != aa(int,int,aa(int,fun(int,int),times_times(int),Q2),A22) ) ) )
         => ~ ! [R: int,Q2: int] :
                ( ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q2),R) )
               => ( ( aa(int,int,sgn_sgn(int),R) = aa(int,int,sgn_sgn(int),A22) )
                 => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R)),aa(int,int,abs_abs(int),A22))
                   => ( A1 != aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q2),A22)),R) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
tff(fact_4158_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] :
          ( unique8689654367752047608divmod(A,M,Na)
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),Na),aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),M)),unique1321980374590559556d_step(A,Na,unique8689654367752047608divmod(A,M,aa(num,num,bit0,Na)))) ) ) ).

% divmod_divmod_step
tff(fact_4159_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q4: int,R2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),B2)
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q4),R2))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2),aa(int,product_prod(int,int),product_Pair(int,int,Q4),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R2)))) ) ) ).

% pos_eucl_rel_int_mult_2
tff(fact_4160_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_membermima(X,Xa)
     => ( ! [Uu2: $o,Uv2: $o] : ( X != vEBT_Leaf(Uu2,Uv2) )
       => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( X != vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2) )
               => ( ( Xa = Mi2 )
                  | ( Xa = Ma2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT)] :
                  ( ? [Vc: vEBT_VEBT] : ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc) )
                 => ( ( Xa = Mi2 )
                    | ( Xa = Ma2 )
                    | $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) )
             => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT)] :
                    ( ? [Vd: vEBT_VEBT] : ( X = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd) )
                   => $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
tff(fact_4161_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( vEBT_VEBT_membermima(X,Xa)
      <=> (Y) )
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X = vEBT_Leaf(Uu2,Uv2) )
         => (Y) )
       => ( ( ? [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( X = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
           => (Y) )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2) )
               => ( (Y)
                <=> ~ ( ( Xa = Mi2 )
                      | ( Xa = Ma2 ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT)] :
                  ( ? [Vc: vEBT_VEBT] : ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc) )
                 => ( (Y)
                  <=> ~ ( ( Xa = Mi2 )
                        | ( Xa = Ma2 )
                        | $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) )
             => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT)] :
                    ( ? [Vd: vEBT_VEBT] : ( X = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd) )
                   => ( (Y)
                    <=> ~ $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
tff(fact_4162_prod__decode__aux_Osimps,axiom,
    ! [K: nat,M: nat] :
      ( aa(nat,product_prod(nat,nat),nat_prod_decode_aux(K),M)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),K),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),M)),aa(nat,product_prod(nat,nat),nat_prod_decode_aux(aa(nat,nat,suc,K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,K)))) ) ).

% prod_decode_aux.simps
tff(fact_4163_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(nat,nat)] :
      ( ( aa(nat,product_prod(nat,nat),nat_prod_decode_aux(X),Xa) = Y )
     => ( Y
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),X),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa)),aa(nat,product_prod(nat,nat),nat_prod_decode_aux(aa(nat,nat,suc,X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X)))) ) ) ).

% prod_decode_aux.elims
tff(fact_4164_max__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X4: A,Xa2: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),X4),Xa2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Xa2),Xa2,X4) ) ) ).

% max_def_raw
tff(fact_4165_nat__less__as__int,axiom,
    ! [X4: nat,Xa2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),Xa2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa2)) ) ).

% nat_less_as_int
tff(fact_4166_nat__leq__as__int,axiom,
    ! [X4: nat,Xa2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Xa2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa2)) ) ).

% nat_leq_as_int
tff(fact_4167_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),collect(A,aTP_Lamp_aa(A,fun(A,$o),A2))),collect(A,aTP_Lamp_aa(A,fun(A,$o),B2)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
            & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ) ).

% strict_subset_divisors_dvd
tff(fact_4168_less__set__def,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
    <=> aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less(fun(A,$o)),aTP_Lamp_a(set(A),fun(A,$o),A3)),aTP_Lamp_a(set(A),fun(A,$o),B3)) ) ).

% less_set_def
tff(fact_4169_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aa(A,fun(A,$o),A2))),collect(A,aTP_Lamp_aa(A,fun(A,$o),B2)))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% subset_divisors_dvd
tff(fact_4170_lambda__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ( aTP_Lamp_ab(A,A) = aa(A,fun(A,A),times_times(A),zero_zero(A)) ) ) ).

% lambda_zero
tff(fact_4171_lambda__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aTP_Lamp_ac(A,A) = aa(A,fun(A,A),times_times(A),one_one(A)) ) ) ).

% lambda_one
tff(fact_4172_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Na: num] :
          ( aa(num,A,numeral_numeral(A),aa(num,num,bit0,Na))
          = $let(
              m: A,
              m := aa(num,A,numeral_numeral(A),Na),
              aa(A,A,aa(A,fun(A,A),plus_plus(A),m),m) ) ) ) ).

% numeral_code(2)
tff(fact_4173_set__diff__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = collect(A,aa(set(A),fun(A,$o),aTP_Lamp_ad(set(A),fun(set(A),fun(A,$o)),A3),B3)) ) ).

% set_diff_eq
tff(fact_4174_minus__set__def,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = collect(A,aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),minus_minus(fun(A,$o)),aTP_Lamp_a(set(A),fun(A,$o),A3)),aTP_Lamp_a(set(A),fun(A,$o),B3))) ) ).

% minus_set_def
tff(fact_4175_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Na: num] :
          ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,Na))
          = $let(
              m: A,
              m := aa(num,A,numeral_numeral(A),Na),
              aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),m),m)),one_one(A)) ) ) ) ).

% numeral_code(3)
tff(fact_4176_power__numeral__even,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,W)))
          = $let(
              w: A,
              w := aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),W)),
              aa(A,A,aa(A,fun(A,A),times_times(A),w),w) ) ) ) ).

% power_numeral_even
tff(fact_4177_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W)))
          = $let(
              w: A,
              w := aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),W)),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),w)),w) ) ) ) ).

% power_numeral_odd
tff(fact_4178_nat__plus__as__int,axiom,
    ! [X4: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X4),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_plus_as_int
tff(fact_4179_nat__times__as__int,axiom,
    ! [X4: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X4),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_times_as_int
tff(fact_4180_nat__minus__as__int,axiom,
    ! [X4: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X4),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_minus_as_int
tff(fact_4181_nat__div__as__int,axiom,
    ! [X4: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X4),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(nat,int,semiring_1_of_nat(int),X4)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_div_as_int
tff(fact_4182_nat__mod__as__int,axiom,
    ! [X4: nat,Xa2: nat] : ( modulo_modulo(nat,X4,Xa2) = aa(int,nat,nat2,modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),X4),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_mod_as_int
tff(fact_4183_diff__nat__eq__if,axiom,
    ! [Z: int,Z4: int] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z4))
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z4),zero_zero(int)),
          aa(int,nat,nat2,Z),
          $let(
            d: int,
            d := aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z4),
            $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),d),zero_zero(int)),zero_zero(nat),aa(int,nat,nat2,d)) ) ) ) ).

% diff_nat_eq_if
tff(fact_4184_set__decode__def,axiom,
    ! [X: nat] : ( nat_set_decode(X) = collect(nat,aTP_Lamp_ae(nat,fun(nat,$o),X)) ) ).

% set_decode_def
tff(fact_4185_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2)
          = $let(
              l: A,
              l := aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,Na)),A2),
              $ite(aa(nat,$o,bit_se5641148757651400278ts_bit(A,l),Na),aa(A,A,aa(A,fun(A,A),plus_plus(A),l),aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,Na)),aa(A,A,uminus_uminus(A),one_one(A)))),l) ) ) ) ).

% signed_take_bit_code
tff(fact_4186_pochhammer__code,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] :
          ( comm_s3205402744901411588hammer(A,A2,Na)
          = $ite(Na = zero_zero(nat),one_one(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_af(A,fun(nat,fun(A,A)),A2),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),one_one(A))) ) ) ).

% pochhammer_code
tff(fact_4187_gbinomial__code,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] :
          ( aa(nat,A,gbinomial(A,A2),K)
          = $ite(K = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_ag(A,fun(nat,fun(A,A)),A2),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(A))),semiring_char_0_fact(A,K))) ) ) ).

% gbinomial_code
tff(fact_4188_vebt__buildup_Osimps_I3_J,axiom,
    ! [Vaa: nat] :
      ( vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,suc,Vaa)))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Vaa))),
          $let(
            half: nat,
            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Vaa))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Vaa)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),half),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(half)) ),
          $let(
            half: nat,
            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Vaa))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Vaa)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,half)),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(aa(nat,nat,suc,half))) ) ) ) ).

% vebt_buildup.simps(3)
tff(fact_4189_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option(product_prod(nat,nat)),V: nat,TreeList: list(vEBT_VEBT),S: vEBT_VEBT,X: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Node(Uy,aa(nat,nat,suc,V),TreeList,S),X)
    <=> $let(
          pos: nat,
          pos := vEBT_VEBT_high(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ).

% VEBT_internal.naive_member.simps(3)
tff(fact_4190_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( vEBT_vebt_buildup(X) = Y )
     => ( ( ( X = zero_zero(nat) )
         => ( Y != vEBT_Leaf($false,$false) ) )
       => ( ( ( X = aa(nat,nat,suc,zero_zero(nat)) )
           => ( Y != vEBT_Leaf($false,$false) ) )
         => ~ ! [Va: nat] :
                ( ( X = aa(nat,nat,suc,aa(nat,nat,suc,Va)) )
               => ( Y
                 != $ite(
                      aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))),
                      $let(
                        half: nat,
                        half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),half),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(half)) ),
                      $let(
                        half: nat,
                        half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,half)),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(aa(nat,nat,suc,half))) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
tff(fact_4191_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList: list(vEBT_VEBT),Vd2: vEBT_VEBT,X: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V),TreeList,Vd2),X)
    <=> $let(
          pos: nat,
          pos := vEBT_VEBT_high(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ).

% VEBT_internal.membermima.simps(5)
tff(fact_4192_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V: nat,TreeList: list(vEBT_VEBT),Vc2: vEBT_VEBT,X: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma)),aa(nat,nat,suc,V),TreeList,Vc2),X)
    <=> ( ( X = Mi )
        | ( X = Ma )
        | $let(
            pos: nat,
            pos := vEBT_VEBT_high(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(X,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ).

% VEBT_internal.membermima.simps(4)
tff(fact_4193_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( vEBT_V5719532721284313246member(X,Xa)
      <=> (Y) )
     => ( ! [A4: $o,B4: $o] :
            ( ( X = vEBT_Leaf(A4,B4) )
           => ( (Y)
            <=> ~ $ite(
                    Xa = zero_zero(nat),
                    (A4),
                    $ite(Xa = one_one(nat),(B4),$false) ) ) )
       => ( ( ? [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] : ( X = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
           => (Y) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT)] :
                ( ? [S2: vEBT_VEBT] : ( X = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2) )
               => ( (Y)
                <=> ~ $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
tff(fact_4194_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( vEBT_V5719532721284313246member(X,Xa)
     => ( ! [A4: $o,B4: $o] :
            ( ( X = vEBT_Leaf(A4,B4) )
           => ~ $ite(
                  Xa = zero_zero(nat),
                  (A4),
                  $ite(Xa = one_one(nat),(B4),$false) ) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT)] :
              ( ? [S2: vEBT_VEBT] : ( X = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2) )
             => ~ $let(
                    pos: nat,
                    pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                    $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
tff(fact_4195_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_V5719532721284313246member(X,Xa)
     => ( ! [A4: $o,B4: $o] :
            ( ( X = vEBT_Leaf(A4,B4) )
           => $ite(
                Xa = zero_zero(nat),
                (A4),
                $ite(Xa = one_one(nat),(B4),$false) ) )
       => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] : ( X != vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT)] :
                ( ? [S2: vEBT_VEBT] : ( X = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2) )
               => $let(
                    pos: nat,
                    pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                    $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
tff(fact_4196_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(X,Xa)
     => ( ! [Mi2: nat,Ma2: nat] :
            ( ? [Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT] : ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2) )
           => ~ ( ( Xa = Mi2 )
                | ( Xa = Ma2 ) ) )
       => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT)] :
              ( ? [Vc: vEBT_VEBT] : ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc) )
             => ~ ( ( Xa = Mi2 )
                  | ( Xa = Ma2 )
                  | $let(
                      pos: nat,
                      pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                      $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) )
         => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT)] :
                ( ? [Vd: vEBT_VEBT] : ( X = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd) )
               => ~ $let(
                      pos: nat,
                      pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                      $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
tff(fact_4197_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( aa(int,A,ring_1_of_int(A),K)
          = $ite(
              K = zero_zero(int),
              zero_zero(A),
              $ite(
                aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
                aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),K))),
                $let(
                  l: A,
                  l := aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),
                  $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = zero_zero(int),l,aa(A,A,aa(A,fun(A,A),plus_plus(A),l),one_one(A))) ) ) ) ) ) ).

% of_int_code_if
tff(fact_4198_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => topological_monoseq(real,aTP_Lamp_ah(real,fun(nat,real),X)) ) ).

% monoseq_arctan_series
tff(fact_4199_ln__series,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
       => ( aa(real,real,ln_ln(real),X) = suminf(real,aTP_Lamp_ai(real,fun(nat,real),X)) ) ) ) ).

% ln_series
tff(fact_4200_arctan__series,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => ( aa(real,real,arctan,X) = suminf(real,aTP_Lamp_aj(real,fun(nat,real),X)) ) ) ).

% arctan_series
tff(fact_4201_powser__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [F2: fun(nat,A)] : ( suminf(A,aTP_Lamp_ak(fun(nat,A),fun(nat,A),F2)) = aa(nat,A,F2,zero_zero(nat)) ) ) ).

% powser_zero
tff(fact_4202_sin__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X4: A] : ( sin(A,X4) = suminf(A,aTP_Lamp_al(A,fun(nat,A),X4)) ) ) ).

% sin_def
tff(fact_4203_cos__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X4: A] : ( cos(A,X4) = suminf(A,aTP_Lamp_am(A,fun(nat,A),X4)) ) ) ).

% cos_def
tff(fact_4204_exp__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X4: A] : ( aa(A,A,exp(A),X4) = suminf(A,aTP_Lamp_an(A,fun(nat,A),X4)) ) ) ).

% exp_def
tff(fact_4205_monoseq__realpow,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => topological_monoseq(real,aa(real,fun(nat,real),power_power(real),X)) ) ) ).

% monoseq_realpow
tff(fact_4206_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,exp(A),X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),suminf(A,aTP_Lamp_ao(A,fun(nat,A),X))) ) ) ).

% exp_first_term
tff(fact_4207_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : ( aa(A,A,exp(A),X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),X)),suminf(A,aTP_Lamp_ap(A,fun(nat,A),X))) ) ) ).

% exp_first_two_terms
tff(fact_4208_pi__series,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,aa(num,num,bit0,one2)))) = suminf(real,aTP_Lamp_aq(nat,real)) ).

% pi_series
tff(fact_4209_suminf__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => ( suminf(A,aa(A,fun(nat,A),power_power(A),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2)) ) ) ) ).

% suminf_geometric
tff(fact_4210_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ( suminf(A,aTP_Lamp_ar(nat,A)) = zero_zero(A) ) ) ).

% suminf_zero
tff(fact_4211_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,Na: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => bij_betw(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,root(Na),real_V7770717601297561774m_norm(complex,C2)))),cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),arg(C2)),aa(nat,real,semiring_1_of_nat(real),Na))))),collect(complex,aTP_Lamp_as(nat,fun(complex,$o),Na)),collect(complex,aa(nat,fun(complex,$o),aTP_Lamp_at(complex,fun(nat,fun(complex,$o)),C2),Na))) ) ) ).

% bij_betw_nth_root_unity
tff(fact_4212_summable__arctan__series,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => summable(real,aTP_Lamp_aj(real,fun(nat,real),X)) ) ).

% summable_arctan_series
tff(fact_4213_summable__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I2: nat,F2: fun(nat,A)] : summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_au(nat,fun(fun(nat,A),fun(nat,A)),I2),F2)) ) ).

% summable_single
tff(fact_4214_summable__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,aTP_Lamp_av(nat,A)) ) ).

% summable_zero
tff(fact_4215_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),K))
        <=> summable(A,F2) ) ) ).

% summable_iff_shift
tff(fact_4216_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F2) ) ) ) ).

% summable_cmult_iff
tff(fact_4217_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(A,fun(nat,A)),F2),C2))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F2) ) ) ) ).

% summable_divide_iff
tff(fact_4218_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( summable(A,aa(A,fun(nat,A),power_power(A),C2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real)) ) ) ).

% summable_geometric_iff
tff(fact_4219_suminf__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F2)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,F2)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G)) ) ) ) ) ).

% suminf_add
tff(fact_4220_suminf__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),suminf(A,F2)),C2) ) ) ) ).

% suminf_divide
tff(fact_4221_summable__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F2)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G)) ) ) ) ).

% summable_diff
tff(fact_4222_suminf__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F2)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F2)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G)) ) ) ) ) ).

% suminf_diff
tff(fact_4223_summable__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,F2)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ).

% summable_divide
tff(fact_4224_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,aa(A,fun(nat,A),power_power(A),zero_zero(A))) ) ).

% summable_zero_power
tff(fact_4225_summable__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
         => ( ( C2 != zero_zero(A) )
           => summable(A,F2) ) ) ) ).

% summable_mult_D
tff(fact_4226_summable__const__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [C2: A] :
          ( summable(A,aTP_Lamp_bb(A,fun(nat,A),C2))
        <=> ( C2 = zero_zero(A) ) ) ) ).

% summable_const_iff
tff(fact_4227_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,F2)
         => summable(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),K)) ) ) ).

% summable_ignore_initial_segment
tff(fact_4228_summable__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F2)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G)) ) ) ) ).

% summable_add
tff(fact_4229_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,aTP_Lamp_bc(fun(nat,A),fun(nat,A),F2))
        <=> summable(A,F2) ) ) ).

% summable_Suc_iff
tff(fact_4230_powser__insidea,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A),X: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),F2),X))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,X))
           => summable(real,aa(A,fun(nat,real),aTP_Lamp_be(fun(nat,A),fun(A,fun(nat,real)),F2),Z)) ) ) ) ).

% powser_insidea
tff(fact_4231_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),suminf(A,F2)) ) ) ) ).

% suminf_nonneg
tff(fact_4232_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N))
           => ( ( suminf(A,F2) = zero_zero(A) )
            <=> ! [N4: nat] : ( aa(nat,A,F2,N4) = zero_zero(A) ) ) ) ) ) ).

% suminf_eq_zero_iff
tff(fact_4233_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F2,N))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F2)) ) ) ) ).

% suminf_pos
tff(fact_4234_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A)] : summable(A,aTP_Lamp_bf(fun(nat,A),fun(nat,A),F2)) ) ).

% summable_zero_power'
tff(fact_4235_summable__0__powser,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A)] : summable(A,aTP_Lamp_bg(fun(nat,A),fun(nat,A),F2)) ) ).

% summable_0_powser
tff(fact_4236_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bh(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ).

% summable_powser_split_head
tff(fact_4237_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_bj(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ).

% powser_split_head(3)
tff(fact_4238_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F2: fun(nat,A),M: nat,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_bk(fun(nat,A),fun(nat,fun(A,fun(nat,A))),F2),M),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ).

% summable_powser_ignore_initial_segment
tff(fact_4239_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F2))
            <=> ? [I: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F2,I)) ) ) ) ) ).

% suminf_pos_iff
tff(fact_4240_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),I2: nat] :
          ( summable(A,F2)
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F2,I2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F2)) ) ) ) ) ).

% suminf_pos2
tff(fact_4241_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),one_one(real))
         => summable(A,aa(A,fun(nat,A),power_power(A),X)) ) ) ).

% complete_algebra_summable_geometric
tff(fact_4242_summable__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => summable(A,aa(A,fun(nat,A),power_power(A),C2)) ) ) ).

% summable_geometric
tff(fact_4243_suminf__split__head,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => ( suminf(A,aTP_Lamp_bc(fun(nat,A),fun(nat,A),F2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F2)),aa(nat,A,F2,zero_zero(nat))) ) ) ) ).

% suminf_split_head
tff(fact_4244_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [G: fun(nat,complex),N3: nat,F2: fun(nat,A)] :
          ( summable(complex,G)
         => ( ! [N: nat] : member(complex,aa(nat,complex,G,N),real_Vector_Reals(complex))
           => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(nat,complex,G,N)))
             => ( ! [N: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N3),N)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N))),real_V7770717601297561774m_norm(complex,aa(nat,complex,G,N))) )
               => summable(A,F2) ) ) ) ) ) ).

% series_comparison_complex
tff(fact_4245_powser__inside,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),X: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),X))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,X))
           => summable(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) ) ) ) ).

% powser_inside
tff(fact_4246_summable__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] : summable(A,aTP_Lamp_bl(A,fun(nat,A),X)) ) ).

% summable_exp
tff(fact_4247_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : summable(A,aTP_Lamp_an(A,fun(nat,A),X)) ) ).

% summable_exp_generic
tff(fact_4248_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,F2,zero_zero(nat))),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_bj(fun(nat,A),fun(A,fun(nat,A)),F2),Z))),Z)) ) ) ) ).

% powser_split_head(1)
tff(fact_4249_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),Z))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_bj(fun(nat,A),fun(A,fun(nat,A)),F2),Z))),Z) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),F2),Z))),aa(nat,A,F2,zero_zero(nat))) ) ) ) ).

% powser_split_head(2)
tff(fact_4250_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : summable(real,aTP_Lamp_bm(A,fun(nat,real),X)) ) ).

% summable_norm_sin
tff(fact_4251_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R2: real,F2: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
         => ( summable(A,F2)
           => ? [N7: nat] :
              ! [N6: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N6)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,suminf(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),N6)))),R2) ) ) ) ) ).

% suminf_exist_split
tff(fact_4252_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : summable(real,aTP_Lamp_bn(A,fun(nat,real),X)) ) ).

% summable_norm_cos
tff(fact_4253_summable__power__series,axiom,
    ! [F2: fun(nat,real),Z: real] :
      ( ! [I3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,I3)),one_one(real))
     => ( ! [I3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,I3))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Z)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z),one_one(real))
           => summable(real,aa(real,fun(nat,real),aTP_Lamp_bo(fun(nat,real),fun(real,fun(nat,real)),F2),Z)) ) ) ) ) ).

% summable_power_series
tff(fact_4254_Abel__lemma,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R2: real,R0: real,A2: fun(nat,A),M10: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),R2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),R2),R0)
           => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,A2,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),R0),N))),M10)
             => summable(real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_bp(real,fun(fun(nat,A),fun(nat,real)),R2),A2)) ) ) ) ) ).

% Abel_lemma
tff(fact_4255_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [C2: real,N3: nat,F2: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),one_one(real))
         => ( ! [N: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N3),N)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,aa(nat,nat,suc,N)))),aa(real,real,aa(real,fun(real,real),times_times(real),C2),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N)))) )
           => summable(A,F2) ) ) ) ).

% summable_ratio_test
tff(fact_4256_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : summable(real,aTP_Lamp_bq(A,fun(nat,real),X)) ) ).

% summable_norm_exp
tff(fact_4257_sin__paired,axiom,
    ! [X: real] : sums(real,aTP_Lamp_br(real,fun(nat,real),X),sin(real,X)) ).

% sin_paired
tff(fact_4258_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_membermima(X,Xa)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X = vEBT_Leaf(Uu2,Uv2) )
             => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa)) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( X = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xa)) )
           => ( ! [Mi2: nat,Ma2: nat,Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
                  ( ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2) )
                 => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2)),Xa))
                   => ( ( Xa = Mi2 )
                      | ( Xa = Ma2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                    ( ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc) )
                   => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc)),Xa))
                     => ( ( Xa = Mi2 )
                        | ( Xa = Ma2 )
                        | $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) )
               => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                      ( ( X = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd) )
                     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd)),Xa))
                       => $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
tff(fact_4259_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( vEBT_VEBT_membermima(X,Xa)
      <=> (Y) )
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X = vEBT_Leaf(Uu2,Uv2) )
             => ( ~ (Y)
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa)) ) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( X = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ( ~ (Y)
                 => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xa)) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
                  ( ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2) )
                 => ( ( (Y)
                    <=> ( ( Xa = Mi2 )
                        | ( Xa = Ma2 ) ) )
                   => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2)),Xa)) ) )
             => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                    ( ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc) )
                   => ( ( (Y)
                      <=> ( ( Xa = Mi2 )
                          | ( Xa = Ma2 )
                          | $let(
                              pos: nat,
                              pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                              $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) )
                     => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc)),Xa)) ) )
               => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                      ( ( X = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd) )
                     => ( ( (Y)
                        <=> $let(
                              pos: nat,
                              pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                              $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) )
                       => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd)),Xa)) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
tff(fact_4260_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),one_one(real))
         => sums(A,aTP_Lamp_bs(A,fun(nat,A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Z)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% geometric_deriv_sums
tff(fact_4261_sums__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => sums(A,aTP_Lamp_av(nat,A),zero_zero(A)) ) ).

% sums_zero
tff(fact_4262_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: fun(nat,A),X: A] :
          ( sums(A,aTP_Lamp_bg(fun(nat,A),fun(nat,A),A2),X)
        <=> ( aa(nat,A,A2,zero_zero(nat)) = X ) ) ) ).

% powser_sums_zero_iff
tff(fact_4263_sums__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),A2: A,G: fun(nat,A),B2: A] :
          ( sums(A,F2,A2)
         => ( sums(A,G,B2)
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% sums_diff
tff(fact_4264_sums__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A)] :
          ( ! [N: nat] : ( aa(nat,A,F2,N) = zero_zero(A) )
         => sums(A,F2,zero_zero(A)) ) ) ).

% sums_0
tff(fact_4265_sums__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),A2: A,C2: A] :
          ( sums(A,F2,A2)
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(A,fun(nat,A)),F2),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)) ) ) ).

% sums_divide
tff(fact_4266_sums__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I2: nat,F2: fun(nat,A)] : sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_au(nat,fun(fun(nat,A),fun(nat,A)),I2),F2),aa(nat,A,F2,I2)) ) ).

% sums_single
tff(fact_4267_sums__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),A2: A,G: fun(nat,A),B2: A] :
          ( sums(A,F2,A2)
         => ( sums(A,G,B2)
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% sums_add
tff(fact_4268_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F2: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bt(A,fun(fun(nat,A),fun(nat,A)),C2),F2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2))
          <=> sums(A,F2,D2) ) ) ) ).

% sums_mult_iff
tff(fact_4269_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F2: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bu(A,fun(fun(nat,A),fun(nat,A)),C2),F2),aa(A,A,aa(A,fun(A,A),times_times(A),D2),C2))
          <=> sums(A,F2,D2) ) ) ) ).

% sums_mult2_iff
tff(fact_4270_sums__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A),A2: A] :
          ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(A,fun(fun(nat,A),fun(nat,A)),C2),F2),A2)
         => ( ( C2 != zero_zero(A) )
           => sums(A,F2,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),C2)) ) ) ) ).

% sums_mult_D
tff(fact_4271_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),S: A] :
          ( ( aa(nat,A,F2,zero_zero(nat)) = zero_zero(A) )
         => ( sums(A,aTP_Lamp_bc(fun(nat,A),fun(nat,A),F2),S)
           => sums(A,F2,S) ) ) ) ).

% sums_Suc_imp
tff(fact_4272_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),S: A] :
          ( sums(A,aTP_Lamp_bc(fun(nat,A),fun(nat,A),F2),S)
        <=> sums(A,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(nat,A,F2,zero_zero(nat)))) ) ) ).

% sums_Suc_iff
tff(fact_4273_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F2: fun(nat,A),L: A] :
          ( sums(A,aTP_Lamp_bv(fun(nat,A),fun(nat,A),F2),L)
         => sums(A,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),L),aa(nat,A,F2,zero_zero(nat)))) ) ) ).

% sums_Suc
tff(fact_4274_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Na: nat,F2: fun(nat,A),S: A] :
          ( ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Na)
             => ( aa(nat,A,F2,I3) = zero_zero(A) ) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(nat,fun(fun(nat,A),fun(nat,A)),Na),F2),S)
          <=> sums(A,F2,S) ) ) ) ).

% sums_zero_iff_shift
tff(fact_4275_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [M: nat,Z: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_bx(nat,fun(A,fun(nat,A)),M),Z),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),M)) ) ).

% powser_sums_if
tff(fact_4276_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: fun(nat,A)] : sums(A,aTP_Lamp_bg(fun(nat,A),fun(nat,A),A2),aa(nat,A,A2,zero_zero(nat))) ) ).

% powser_sums_zero
tff(fact_4277_sin__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_al(A,fun(nat,A),X),sin(A,X)) ) ).

% sin_converges
tff(fact_4278_cos__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_am(A,fun(nat,A),X),cos(A,X)) ) ).

% cos_converges
tff(fact_4279_exp__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_an(A,fun(nat,A),X),aa(A,A,exp(A),X)) ) ).

% exp_converges
tff(fact_4280_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_by(A,fun(nat,A),X),sin(A,X)) ) ).

% sin_minus_converges
tff(fact_4281_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_bz(A,fun(nat,A),X),cos(A,X)) ) ).

% cos_minus_converges
tff(fact_4282_geometric__sums,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => sums(A,aa(A,fun(nat,A),power_power(A),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2))) ) ) ).

% geometric_sums
tff(fact_4283_power__half__series,axiom,
    sums(real,aTP_Lamp_ca(nat,real),one_one(real)) ).

% power_half_series
tff(fact_4284_sums__if_H,axiom,
    ! [G: fun(nat,real),X: real] :
      ( sums(real,G,X)
     => sums(real,aTP_Lamp_cb(fun(nat,real),fun(nat,real),G),X) ) ).

% sums_if'
tff(fact_4285_sums__if,axiom,
    ! [G: fun(nat,real),X: real,F2: fun(nat,real),Y: real] :
      ( sums(real,G,X)
     => ( sums(real,F2,Y)
       => sums(real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_cc(fun(nat,real),fun(fun(nat,real),fun(nat,real)),G),F2),aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)) ) ) ).

% sums_if
tff(fact_4286_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_cd(A,fun(nat,A),X),cosh(A,X)) ) ).

% cosh_converges
tff(fact_4287_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A] : sums(A,aTP_Lamp_ce(A,fun(nat,A),X),sinh(A,X)) ) ).

% sinh_converges
tff(fact_4288_cos__paired,axiom,
    ! [X: real] : sums(real,aTP_Lamp_cf(real,fun(nat,real),X),cos(real,X)) ).

% cos_paired
tff(fact_4289_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(X,Xa)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [Mi2: nat,Ma2: nat,Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT] :
              ( ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),zero_zero(nat),Va2,Vb2)),Xa))
               => ~ ( ( Xa = Mi2 )
                    | ( Xa = Ma2 ) ) ) )
         => ( ! [Mi2: nat,Ma2: nat,V4: nat,TreeList2: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                ( ( X = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma2)),aa(nat,nat,suc,V4),TreeList2,Vc)),Xa))
                 => ~ ( ( Xa = Mi2 )
                      | ( Xa = Ma2 )
                      | $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) )
           => ~ ! [V4: nat,TreeList2: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                  ( ( X = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd) )
                 => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList2,Vd)),Xa))
                   => ~ $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
tff(fact_4290_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( vEBT_V5719532721284313246member(X,Xa)
      <=> (Y) )
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [A4: $o,B4: $o] :
              ( ( X = vEBT_Leaf(A4,B4) )
             => ( ( (Y)
                <=> $ite(
                      Xa = zero_zero(nat),
                      (A4),
                      $ite(Xa = one_one(nat),(B4),$false) ) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),Xa)) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] :
                ( ( X = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
               => ( ~ (Y)
                 => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Xa)) ) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT),S2: vEBT_VEBT] :
                  ( ( X = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2) )
                 => ( ( (Y)
                    <=> $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) )
                   => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2)),Xa)) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
tff(fact_4291_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( vEBT_V5719532721284313246member(X,Xa)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [A4: $o,B4: $o] :
              ( ( X = vEBT_Leaf(A4,B4) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),Xa))
               => ~ $ite(
                      Xa = zero_zero(nat),
                      (A4),
                      $ite(Xa = one_one(nat),(B4),$false) ) ) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT),S2: vEBT_VEBT] :
                ( ( X = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2)),Xa))
                 => ~ $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
tff(fact_4292_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_V5719532721284313246member(X,Xa)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [A4: $o,B4: $o] :
              ( ( X = vEBT_Leaf(A4,B4) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),Xa))
               => $ite(
                    Xa = zero_zero(nat),
                    (A4),
                    $ite(Xa = one_one(nat),(B4),$false) ) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT] :
                ( ( X = vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv2,Uw2)),Xa)) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList2: list(vEBT_VEBT),S2: vEBT_VEBT] :
                  ( ( X = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2) )
                 => ( accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList2,S2)),Xa))
                   => $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,V4)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
tff(fact_4293_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [C2: fun(nat,A),X: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cg(fun(nat,A),fun(A,fun(nat,A)),C2),X))
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),C2),X),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cg(fun(nat,A),fun(A,fun(nat,A)),C2),X))) ) ) ).

% diffs_equiv
tff(fact_4294_diffs__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [C2: fun(nat,A),X4: nat] : ( aa(nat,A,diffs(A,C2),X4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,X4))),aa(nat,A,C2,aa(nat,nat,suc,X4))) ) ) ).

% diffs_def
tff(fact_4295_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X: A] :
          ( ! [X3: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),X3))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X)) ) ) ).

% termdiff_converges_all
tff(fact_4296_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,K5: real,C2: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),K5)
         => ( ! [X3: A] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X3)),K5)
               => summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),X3)) )
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ck(A,fun(fun(nat,A),fun(nat,A)),X),C2)) ) ) ) ).

% termdiff_converges
tff(fact_4297_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( topological_monoseq(A,X7)
        <=> ( ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,N4)),aa(nat,A,X7,aa(nat,nat,suc,N4)))
            | ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N4))),aa(nat,A,X7,N4)) ) ) ) ).

% monoseq_Suc
tff(fact_4298_mono__SucI2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N))),aa(nat,A,X7,N))
         => topological_monoseq(A,X7) ) ) ).

% mono_SucI2
tff(fact_4299_mono__SucI1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,N)),aa(nat,A,X7,aa(nat,nat,suc,N)))
         => topological_monoseq(A,X7) ) ) ).

% mono_SucI1
tff(fact_4300_of__nat__code,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),Na) = semiri8178284476397505188at_aux(A,aTP_Lamp_cl(A,A),Na,zero_zero(A)) ) ) ).

% of_nat_code
tff(fact_4301_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),Na: nat,I2: A] : ( semiri8178284476397505188at_aux(A,Inc,aa(nat,nat,suc,Na),I2) = semiri8178284476397505188at_aux(A,Inc,Na,aa(A,A,Inc,I2)) ) ) ).

% of_nat_aux.simps(2)
tff(fact_4302_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),I2: A] : ( semiri8178284476397505188at_aux(A,Inc,zero_zero(nat),I2) = I2 ) ) ).

% of_nat_aux.simps(1)
tff(fact_4303_Arg__def,axiom,
    ! [Z: complex] :
      ( arg(Z)
      = $ite(Z = zero_zero(complex),zero_zero(real),fChoice(real,aTP_Lamp_cm(complex,fun(real,$o),Z))) ) ).

% Arg_def
tff(fact_4304_set__vebt__def,axiom,
    ! [T2: vEBT_VEBT] : ( vEBT_set_vebt(T2) = collect(nat,vEBT_V8194947554948674370ptions(T2)) ) ).

% set_vebt_def
tff(fact_4305_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_co(A,fun(A,fun(nat,A)),X),Y),aa(A,A,aa(A,fun(A,A),times_times(A),sin(A,X)),sin(A,Y))) ) ).

% sin_x_sin_y
tff(fact_4306_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_cq(A,fun(A,fun(nat,A)),X),Y),cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y))) ) ).

% sums_cos_x_plus_y
tff(fact_4307_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => member(B,aa(A,B,F2,X3),ring_1_Ints(B)) )
         => member(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3),ring_1_Ints(B)) ) ) ).

% Ints_sum
tff(fact_4308_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [F2: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_cr(fun(B,nat),fun(B,A),F2)),A3) ) ) ).

% of_nat_sum
tff(fact_4309_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [F2: fun(B,int),A3: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_cs(fun(B,int),fun(B,A),F2)),A3) ) ) ).

% of_int_sum
tff(fact_4310_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,Na))),aa(nat,A,G,aa(nat,nat,suc,Na))) ) ) ).

% sum.atMost_Suc
tff(fact_4311_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linord2810124833399127020strict(A)
        & topolo1944317154257567458pology(A) )
     => ! [A2: fun(nat,A),B3: A] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,A2,N))
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A2),set_ord_atMost(nat,N))),B3)
           => summable(A,A2) ) ) ) ).

% bounded_imp_summable
tff(fact_4312_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,Na))) ) ) ).

% sum.atMost_Suc_shift
tff(fact_4313_sum__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),I2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_cu(fun(nat,A),fun(nat,A),F2)),set_ord_atMost(nat,I2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),aa(nat,A,F2,aa(nat,nat,suc,I2))) ) ) ).

% sum_telescope
tff(fact_4314_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X: A,P: fun(A,$o),P2: fun(A,$o)] :
      ( ( X = fChoice(A,aTP_Lamp_cv(fun(A,$o),fun(A,$o),P)) )
     => ( ! [X3: A] :
            ( aa(A,$o,P,X3)
          <=> aa(A,$o,P2,X3) )
       => ( ! [X_13: A] : aa(A,$o,P2,X_13)
        <=> aa(A,$o,P,X) ) ) ) ).

% verit_sko_forall_indirect2
tff(fact_4315_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X: A,P: fun(A,$o)] :
      ( ( X = fChoice(A,aTP_Lamp_cv(fun(A,$o),fun(A,$o),P)) )
     => ( ! [X_13: A] : aa(A,$o,P,X_13)
      <=> aa(A,$o,P,X) ) ) ).

% verit_sko_forall_indirect
tff(fact_4316_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X: A,P: fun(A,$o),P2: fun(A,$o)] :
      ( ( X = fChoice(A,P) )
     => ( ! [X3: A] :
            ( aa(A,$o,P,X3)
          <=> aa(A,$o,P2,X3) )
       => ( ? [X_13: A] : aa(A,$o,P2,X_13)
        <=> aa(A,$o,P,X) ) ) ) ).

% verit_sko_ex_indirect2
tff(fact_4317_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X: A,P: fun(A,$o)] :
      ( ( X = fChoice(A,P) )
     => ( ? [X_13: A] : aa(A,$o,P,X_13)
      <=> aa(A,$o,P,X) ) ) ).

% verit_sko_ex_indirect
tff(fact_4318_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B3: A,A3: A,P: fun(A,$o)] :
      ( ( B3 = A3 )
     => ( ( fChoice(A,P) = A3 )
      <=> ( fChoice(A,P) = B3 ) ) ) ).

% verit_sko_forall''
tff(fact_4319_verit__sko__forall_H,axiom,
    ! [A: $tType,P: fun(A,$o),A3: $o] :
      ( ( aa(A,$o,P,fChoice(A,aTP_Lamp_cv(fun(A,$o),fun(A,$o),P)))
      <=> (A3) )
     => ( ! [X_13: A] : aa(A,$o,P,X_13)
      <=> (A3) ) ) ).

% verit_sko_forall'
tff(fact_4320_verit__sko__forall,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ! [X_13: A] : aa(A,$o,P,X_13)
    <=> aa(A,$o,P,fChoice(A,aTP_Lamp_cv(fun(A,$o),fun(A,$o),P))) ) ).

% verit_sko_forall
tff(fact_4321_verit__sko__ex_H,axiom,
    ! [A: $tType,P: fun(A,$o),A3: $o] :
      ( ( aa(A,$o,P,fChoice(A,P))
      <=> (A3) )
     => ( ? [X_13: A] : aa(A,$o,P,X_13)
      <=> (A3) ) ) ).

% verit_sko_ex'
tff(fact_4322_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F2: fun(B,A),A2: A,A3: set(B)] : ( modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_cw(fun(B,A),fun(A,fun(B,A)),F2),A2)),A3),A2) = modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3),A2) ) ) ).

% mod_sum_eq
tff(fact_4323_sum__choose__upper,axiom,
    ! [M: nat,Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_cx(nat,fun(nat,nat),M)),set_ord_atMost(nat,Na)) = aa(nat,nat,binomial(aa(nat,nat,suc,Na)),aa(nat,nat,suc,M)) ) ).

% sum_choose_upper
tff(fact_4324_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Na: nat,D2: fun(nat,A)] :
          ( ! [X5: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),X5)),set_ord_atMost(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),D2),X5)),set_ord_atMost(nat,Na)) )
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),Na)
             => ( aa(nat,A,C2,I) = aa(nat,A,D2,I) ) ) ) ) ).

% polyfun_eq_coeffs
tff(fact_4325_sum__choose__lower,axiom,
    ! [R2: nat,Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_cz(nat,fun(nat,nat),R2)),set_ord_atMost(nat,Na)) = aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),R2),Na))),Na) ) ).

% sum_choose_lower
tff(fact_4326_choose__rising__sum_I2_J,axiom,
    ! [Na: nat,M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_da(nat,fun(nat,nat),Na)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)),one_one(nat))),M) ) ).

% choose_rising_sum(2)
tff(fact_4327_choose__rising__sum_I1_J,axiom,
    ! [Na: nat,M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_da(nat,fun(nat,nat),Na)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat))) ) ).

% choose_rising_sum(1)
tff(fact_4328_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [C2: fun(nat,A),Na: nat,K: nat] :
          ( ! [W2: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_db(fun(nat,A),fun(A,fun(nat,A)),C2),W2)),set_ord_atMost(nat,Na)) = zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
           => ( aa(nat,A,C2,K) = zero_zero(A) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
tff(fact_4329_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Na: nat] :
          ( ! [X5: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),X5)),set_ord_atMost(nat,Na)) = zero_zero(A) )
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),Na)
             => ( aa(nat,A,C2,I) = zero_zero(A) ) ) ) ) ).

% polyfun_eq_0
tff(fact_4330_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dc(A,fun(nat,A),A2)),set_ord_atMost(nat,Na)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),Na))),one_one(A))),Na) ) ) ).

% gbinomial_parallel_sum
tff(fact_4331_sum__choose__diagonal,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_dd(nat,fun(nat,fun(nat,nat)),M),Na)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,suc,Na)),M) ) ) ).

% sum_choose_diagonal
tff(fact_4332_vandermonde,axiom,
    ! [M: nat,Na: nat,R2: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_de(nat,fun(nat,fun(nat,fun(nat,nat))),M),Na),R2)),set_ord_atMost(nat,R2)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),R2) ) ).

% vandermonde
tff(fact_4333_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,Na))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,Na))) ) ) ).

% sum_gp_basic
tff(fact_4334_choose__row__sum,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(Na)),set_ord_atMost(nat,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na) ) ).

% choose_row_sum
tff(fact_4335_binomial,axiom,
    ! [A2: nat,B2: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),Na) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_df(nat,fun(nat,fun(nat,fun(nat,nat))),A2),B2),Na)),set_ord_atMost(nat,Na)) ) ).

% binomial
tff(fact_4336_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),B2))
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)) ) ) ) ).

% summable_Cauchy_product
tff(fact_4337_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A2)),suminf(A,B2)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)) ) ) ) ) ).

% Cauchy_product
tff(fact_4338_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dj(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,Na)) ) ) ).

% sum.in_pairs_0
tff(fact_4339_polynomial__product,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [M: nat,A2: fun(nat,A),Na: nat,B2: fun(nat,A),X: A] :
          ( ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),I3)
             => ( aa(nat,A,A2,I3) = zero_zero(A) ) )
         => ( ! [J3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),J3)
               => ( aa(nat,A,B2,J3) = zero_zero(A) ) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),A2),X)),set_ord_atMost(nat,M))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),B2),X)),set_ord_atMost(nat,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_dm(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),A2),B2),X)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))) ) ) ) ) ).

% polynomial_product
tff(fact_4340_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dn(A,fun(nat,A),A2)),set_ord_atMost(nat,M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),M)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),M)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_4341_binomial__ring,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,B2: A,Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),Na) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_do(A,fun(A,fun(nat,fun(nat,A))),A2),B2),Na)),set_ord_atMost(nat,Na)) ) ) ).

% binomial_ring
tff(fact_4342_polynomial__product__nat,axiom,
    ! [M: nat,A2: fun(nat,nat),Na: nat,B2: fun(nat,nat),X: nat] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),I3)
         => ( aa(nat,nat,A2,I3) = zero_zero(nat) ) )
     => ( ! [J3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),J3)
           => ( aa(nat,nat,B2,J3) = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_dp(fun(nat,nat),fun(nat,fun(nat,nat)),A2),X)),set_ord_atMost(nat,M))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_dp(fun(nat,nat),fun(nat,fun(nat,nat)),B2),X)),set_ord_atMost(nat,Na))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_dr(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),A2),B2),X)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))) ) ) ) ).

% polynomial_product_nat
tff(fact_4343_choose__square__sum,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ds(nat,fun(nat,nat),Na)),set_ord_atMost(nat,Na)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),Na) ) ).

% choose_square_sum
tff(fact_4344_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A2: A,B2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),Na) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dt(A,fun(A,fun(nat,fun(nat,A))),A2),B2),Na)),set_ord_atMost(nat,Na)) ) ) ).

% pochhammer_binomial_sum
tff(fact_4345_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),B2))
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A2)),suminf(A,B2))) ) ) ) ).

% Cauchy_product_sums
tff(fact_4346_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,M: nat,I5: set(nat)] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_du(A,fun(nat,fun(nat,A)),X),M)),I5) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),I5)) ) ) ).

% sum_power_add
tff(fact_4347_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [P3: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P3)
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_dv(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,P3)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_dw(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P3),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% sum.zero_middle
tff(fact_4348_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,A2: A,X: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_dx(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),X),Y)),set_ord_atMost(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_dy(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),X),Y)),set_ord_atMost(nat,M)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_4349_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A,Y: A,Na: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),X) )
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Na))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dz(A,fun(A,fun(nat,fun(nat,A))),X),Y),Na)),set_ord_atMost(nat,Na)) ) ) ) ).

% exp_series_add_commuting
tff(fact_4350_root__polyfun,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Na: nat,Z: A,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Na)
         => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),Na) = A2 )
          <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_ea(nat,fun(A,fun(A,fun(nat,A))),Na),Z),A2)),set_ord_atMost(nat,Na)) = zero_zero(A) ) ) ) ) ).

% root_polyfun
tff(fact_4351_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,Na))
          = $ite(X = one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat))),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,Na)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X))) ) ) ).

% sum_gp0
tff(fact_4352_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Na: nat] :
          ( ( Na != one_one(nat) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eb(nat,fun(nat,A),Na)),set_ord_atMost(nat,Na)) = zero_zero(A) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_4353_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ec(nat,fun(nat,A),M)),set_ord_atMost(nat,M)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M) ) ) ).

% gbinomial_sum_nat_pow2
tff(fact_4354_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,A2: A,X: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_dx(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),X),Y)),set_ord_atMost(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ed(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),X),Y)),set_ord_atMost(nat,M)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_4355_binomial__r__part__sum,axiom,
    ! [M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)),one_one(nat)))),set_ord_atMost(nat,M)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)) ) ).

% binomial_r_part_sum
tff(fact_4356_choose__linear__sum,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ee(nat,fun(nat,nat),Na)),set_ord_atMost(nat,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))) ) ).

% choose_linear_sum
tff(fact_4357_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(nat,fun(nat,A),Na)),set_ord_atMost(nat,Na)) = zero_zero(A) ) ) ) ).

% choose_alternating_sum
tff(fact_4358_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [E2: real,C2: fun(nat,A),Na: nat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => ? [M8: real] :
            ! [Z3: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),M8),real_V7770717601297561774m_norm(A,Z3))
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,Na)))),aa(real,real,aa(real,fun(real,real),times_times(real),E2),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(A,Z3)),aa(nat,nat,suc,Na)))) ) ) ) ).

% polyfun_extremal_lemma
tff(fact_4359_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,semiring_1_of_nat(A),M))),one_one(A)))),set_ord_atMost(nat,M)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M)) ) ) ).

% gbinomial_r_part_sum
tff(fact_4360_choose__even__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eg(nat,fun(nat,A),Na)),set_ord_atMost(nat,Na))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) ) ) ) ).

% choose_even_sum
tff(fact_4361_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eh(nat,fun(nat,A),Na)),set_ord_atMost(nat,Na))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) ) ) ) ).

% choose_odd_sum
tff(fact_4362_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ei(A,fun(nat,A),A2)),set_ord_atMost(nat,M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M)),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_4363_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [Na: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),one_one(A)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Na))) ) ) ).

% mask_eq_sum_exp
tff(fact_4364_mask__eq__sum__exp__nat,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),aa(nat,nat,suc,zero_zero(nat))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Na))) ) ).

% mask_eq_sum_exp_nat
tff(fact_4365_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,Y: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_el(A,fun(A,fun(nat,A)),X),Y),aa(A,A,aa(A,fun(A,A),times_times(A),cos(A,X)),cos(A,Y))) ) ).

% cos_x_cos_y
tff(fact_4366_sum__abs__ge__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [F2: fun(B,A),A3: set(B)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_em(fun(B,A),fun(B,A),F2)),A3)) ) ).

% sum_abs_ge_zero
tff(fact_4367_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),X: fun(A,B),A2: fun(A,B),B2: B,Delta: B] :
          ( ! [I3: A] :
              ( member(A,I3,I5)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,X,I3)) )
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),X),I5) = one_one(B) )
           => ( ! [I3: A] :
                  ( member(A,I3,I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A2,I3)),B2))),Delta) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_en(fun(A,B),fun(fun(A,B),fun(A,B)),X),A2)),I5)),B2))),Delta) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_4368_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_eo(B,A)),A3) = zero_zero(A) ) ) ).

% sum.neutral_const
tff(fact_4369_Maclaurin__cos__expansion2,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),X)
            & ( cos(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ep(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ).

% Maclaurin_cos_expansion2
tff(fact_4370_of__nat__id,axiom,
    ! [Na: nat] : ( aa(nat,nat,semiring_1_of_nat(nat),Na) = Na ) ).

% of_nat_id
tff(fact_4371_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I2: A,K: A] :
          ( member(A,I2,set_ord_lessThan(A,K))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),I2),K) ) ) ).

% lessThan_iff
tff(fact_4372_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,Na))),aa(nat,A,G,Na)) ) ) ).

% sum.lessThan_Suc
tff(fact_4373_sumr__cos__zero__one,axiom,
    ! [Na: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_eq(nat,real)),set_ord_lessThan(nat,aa(nat,nat,suc,Na))) = one_one(real) ) ).

% sumr_cos_zero_one
tff(fact_4374_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Q: fun(A,nat),P: fun(A,nat),Na: A] :
          ( ! [X3: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Q,X3)),aa(A,nat,P,X3))
         => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),P),set_ord_lessThan(A,Na))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),Q),set_ord_lessThan(A,Na))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_er(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Q),P)),set_ord_lessThan(A,Na)) ) ) ) ).

% sum_diff_distrib
tff(fact_4375_Complex__sum_H,axiom,
    ! [A: $tType,F2: fun(A,real),S: set(A)] : ( aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),aTP_Lamp_es(fun(A,real),fun(A,complex),F2)),S) = complex2(aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),F2),S),zero_zero(real)) ) ).

% Complex_sum'
tff(fact_4376_int__sum,axiom,
    ! [A: $tType,F2: fun(A,nat),A3: set(A)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)) = aa(set(A),int,aa(fun(A,int),fun(set(A),int),groups7311177749621191930dd_sum(A,int),aTP_Lamp_et(fun(A,nat),fun(A,int),F2)),A3) ) ).

% int_sum
tff(fact_4377_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set(A),G: fun(A,nat),F2: fun(A,nat)] :
      ( ! [X3: A] :
          ( member(A,X3,A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,G,X3)),aa(A,nat,F2,X3)) )
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_eu(fun(A,nat),fun(fun(A,nat),fun(A,nat)),G),F2)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),G),A3)) ) ) ).

% sum_subtractf_nat
tff(fact_4378_lessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( set_ord_lessThan(A,U) = collect(A,aTP_Lamp_ev(A,fun(A,$o),U)) ) ) ).

% lessThan_def
tff(fact_4379_sum__SucD,axiom,
    ! [A: $tType,F2: fun(A,nat),A3: set(A),Na: nat] :
      ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3) = aa(nat,nat,suc,Na) )
     => ? [X3: A] :
          ( member(A,X3,A3)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,F2,X3)) ) ) ).

% sum_SucD
tff(fact_4380_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: A,Na: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),set_ord_lessThan(A,M)),set_ord_lessThan(A,Na))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),Na) ) ) ).

% lessThan_strict_subset_iff
tff(fact_4381_lessThan__Suc__atMost,axiom,
    ! [K: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,K)) = set_ord_atMost(nat,K) ) ).

% lessThan_Suc_atMost
tff(fact_4382_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atMost(A,A2)),set_ord_lessThan(A,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% Iic_subset_Iio_iff
tff(fact_4383_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ew(fun(nat,A),fun(nat,fun(nat,A)),G),Na)),set_ord_lessThan(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,Na)) ) ) ).

% sum.nat_diff_reindex
tff(fact_4384_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [F2: fun(nat,A),Na: nat,R2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,Na))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),R2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ex(fun(nat,A),fun(A,fun(nat,A)),F2),R2)),set_ord_lessThan(nat,Na)) ) ) ).

% sumr_diff_mult_const2
tff(fact_4385_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,Na))) ) ) ).

% sum.lessThan_Suc_shift
tff(fact_4386_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ey(fun(nat,A),fun(nat,A),F2)),set_ord_lessThan(nat,M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,M)),aa(nat,A,F2,zero_zero(nat))) ) ) ).

% sum_lessThan_telescope
tff(fact_4387_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_cu(fun(nat,A),fun(nat,A),F2)),set_ord_lessThan(nat,M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),aa(nat,A,F2,M)) ) ) ).

% sum_lessThan_telescope'
tff(fact_4388_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),X: A] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N))
         => ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,N))),X)
           => summable(A,F2) ) ) ) ).

% summableI_nonneg_bounded
tff(fact_4389_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),Na: nat,S: A] :
          ( sums(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),Na),S)
        <=> sums(A,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,Na)))) ) ) ).

% sums_iff_shift
tff(fact_4390_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),Na: nat,S: A] :
          ( sums(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),Na),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,Na))))
        <=> sums(A,F2,S) ) ) ).

% sums_iff_shift'
tff(fact_4391_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),S: A,Na: nat] :
          ( sums(A,F2,S)
         => sums(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),Na),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,Na)))) ) ) ).

% sums_split_initial_segment
tff(fact_4392_sum__nth__roots,axiom,
    ! [Na: nat,C2: complex] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),Na)
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_ez(complex,complex)),collect(complex,aa(complex,fun(complex,$o),aTP_Lamp_fa(nat,fun(complex,fun(complex,$o)),Na),C2))) = zero_zero(complex) ) ) ).

% sum_nth_roots
tff(fact_4393_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,Na))) ) ) ).

% one_diff_power_eq
tff(fact_4394_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,Na))) ) ) ).

% power_diff_1_eq
tff(fact_4395_geometric__sum,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Na: nat] :
          ( ( X != one_one(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) ) ) ) ).

% geometric_sum
tff(fact_4396_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,Na))) ) ) ).

% sum.atMost_shift
tff(fact_4397_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,F2)
         => ( suminf(A,F2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),K))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,K))) ) ) ) ).

% suminf_split_initial_segment
tff(fact_4398_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( summable(A,F2)
         => ( suminf(A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),F2),K)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,K))) ) ) ) ).

% suminf_minus_initial_segment
tff(fact_4399_sum__roots__unity,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),Na)
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_ez(complex,complex)),collect(complex,aTP_Lamp_as(nat,fun(complex,$o),Na))) = zero_zero(complex) ) ) ).

% sum_roots_unity
tff(fact_4400_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),Na: nat] :
          ( summable(A,F2)
         => ( ! [M4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M4)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F2,M4)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,Na))),suminf(A,F2)) ) ) ) ).

% sum_less_suminf
tff(fact_4401_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,Na))
          = $ite(X = one_one(A),aa(nat,A,semiring_1_of_nat(A),Na),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X))) ) ) ).

% sum_gp_strict
tff(fact_4402_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Z: A,H: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fb(A,fun(A,fun(nat,fun(nat,A))),Z),H),M)),set_ord_lessThan(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fc(A,fun(A,fun(nat,fun(nat,A))),Z),H),M)),set_ord_lessThan(nat,M)) ) ) ).

% lemma_termdiff1
tff(fact_4403_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fd(A,fun(nat,fun(A,fun(nat,A))),X),Na),Y)),set_ord_lessThan(nat,Na))) ) ) ).

% power_diff_sumr2
tff(fact_4404_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,Na))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fe(A,fun(nat,fun(A,fun(nat,A))),X),Na),Y)),set_ord_lessThan(nat,aa(nat,nat,suc,Na)))) ) ) ).

% diff_power_eq_sum
tff(fact_4405_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),A2: A,Na: nat] :
          ( ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),A2)),set_ord_atMost(nat,Na)) = zero_zero(A) )
         => ~ ! [B4: fun(nat,A)] :
                ~ ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),B4),Z3)),set_ord_lessThan(nat,Na))) ) ) ) ).

% polyfun_linear_factor_root
tff(fact_4406_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),Na: nat,A2: A] :
        ? [B4: fun(nat,A)] :
        ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),B4),Z3)),set_ord_lessThan(nat,Na)))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),C2),A2)),set_ord_atMost(nat,Na))) ) ) ).

% polyfun_linear_factor
tff(fact_4407_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Na: nat,F2: fun(nat,A),K5: A,K: nat] :
          ( ! [P4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),P4),Na)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,P4)),K5) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),K5)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),K5)) ) ) ) ).

% real_sum_nat_ivl_bounded2
tff(fact_4408_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),Na: nat,I2: nat] :
          ( summable(A,F2)
         => ( ! [M4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M4)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,M4)) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),I2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F2,I2))
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_lessThan(nat,Na))),suminf(A,F2)) ) ) ) ) ) ).

% sum_less_suminf2
tff(fact_4409_sum_Oneutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => ( aa(A,B,G,X3) = zero_zero(B) ) )
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = zero_zero(B) ) ) ) ).

% sum.neutral
tff(fact_4410_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) != zero_zero(A) )
         => ~ ! [A4: B] :
                ( member(B,A4,A3)
               => ( aa(B,A,G,A4) = zero_zero(A) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
tff(fact_4411_dvd__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: set(A),D2: B,F2: fun(A,B)] :
          ( ! [A4: A] :
              ( member(A,A4,A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D2),aa(A,B,F2,A4)) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),D2),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)) ) ) ).

% dvd_sum
tff(fact_4412_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ff(A,fun(nat,fun(nat,A)),X),Na)),set_ord_lessThan(nat,Na))) ) ) ).

% one_diff_power_eq'
tff(fact_4413_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X: real,Na: nat,Diff: fun(nat,fun(A,real))] :
          ( ( X = zero_zero(real) )
         => ( ( Na != zero_zero(nat) )
           => ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_fg(real,fun(fun(nat,fun(A,real)),fun(nat,real)),X),Diff)),set_ord_lessThan(nat,Na)) = aa(A,real,aa(nat,fun(A,real),Diff,zero_zero(nat)),zero_zero(A)) ) ) ) ) ).

% Maclaurin_zero
tff(fact_4414_Maclaurin__lemma,axiom,
    ! [H: real,F2: fun(real,real),J2: fun(nat,real),Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ? [B8: real] : ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_fh(real,fun(fun(nat,real),fun(nat,real)),H),J2)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),B8),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),Na)),semiring_char_0_fact(real,Na)))) ) ) ).

% Maclaurin_lemma
tff(fact_4415_sum__split__even__odd,axiom,
    ! [F2: fun(nat,real),G: fun(nat,real),Na: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_fi(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F2),G)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fj(fun(nat,real),fun(nat,real),F2)),set_ord_lessThan(nat,Na))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fk(fun(nat,real),fun(nat,real),G)),set_ord_lessThan(nat,Na))) ) ).

% sum_split_even_odd
tff(fact_4416_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),H: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_fl(fun(B,A),fun(fun(B,A),fun(B,A)),G),H)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),A3)) ) ) ).

% sum.distrib
tff(fact_4417_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)) ) ) ).

% sum_subtractf
tff(fact_4418_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F2: fun(B,A),A3: set(B),R2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F2),A3)),R2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_fn(fun(B,A),fun(A,fun(B,A)),F2),R2)),A3) ) ) ).

% sum_divide_distrib
tff(fact_4419_Maclaurin__exp__le,axiom,
    ! [X: real,Na: nat] :
    ? [T3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
      & ( aa(real,real,exp(real),X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fo(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,exp(real),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ).

% Maclaurin_exp_le
tff(fact_4420_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Na: nat,A2: fun(nat,A),X: A,Y: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Na)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),A2),X)),set_ord_atMost(nat,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),A2),Y)),set_ord_atMost(nat,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_fq(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Na),A2),X),Y)),set_ord_lessThan(nat,Na))) ) ) ) ).

% polyfun_diff_alt
tff(fact_4421_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X: A,K: nat] : ( aa(A,A,exp(A),X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_an(A,fun(nat,A),X)),set_ord_lessThan(nat,K))),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_fr(A,fun(nat,fun(nat,A)),X),K))) ) ) ).

% exp_first_terms
tff(fact_4422_Maclaurin__sin__bound,axiom,
    ! [X: real,Na: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),sin(real,X)),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fs(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),X)),Na))) ).

% Maclaurin_sin_bound
tff(fact_4423_sum__pos__lt__pair,axiom,
    ! [F2: fun(nat,real),K: nat] :
      ( summable(real,F2)
     => ( ! [D4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D4)))),aa(nat,real,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D4)),one_one(nat))))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),F2),set_ord_lessThan(nat,K))),suminf(real,F2)) ) ) ).

% sum_pos_lt_pair
tff(fact_4424_sum__nonpos,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,X3)),zero_zero(B)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),zero_zero(B)) ) ) ).

% sum_nonpos
tff(fact_4425_sum__nonneg,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X3)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)) ) ) ).

% sum_nonneg
tff(fact_4426_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(nat),F2: fun(nat,A),G: fun(nat,A)] :
          ( ~ member(nat,zero_zero(nat),A3)
         => ( ! [X3: nat] :
                ( member(nat,aa(nat,nat,suc,X3),A3)
               => ( aa(nat,A,F2,aa(nat,nat,suc,X3)) = aa(nat,A,G,aa(nat,nat,suc,X3)) ) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),A3) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),A3) ) ) ) ) ).

% sum_cong_Suc
tff(fact_4427_Maclaurin__exp__lt,axiom,
    ! [X: real,Na: nat] :
      ( ( X != zero_zero(real) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T3))
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
            & ( aa(real,real,exp(real),X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fo(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,exp(real),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ).

% Maclaurin_exp_lt
tff(fact_4428_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [H: A,Z: A,Na: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),Na))),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),times_times(A),H),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fu(A,fun(A,fun(nat,fun(nat,A))),H),Z),Na)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ) ).

% lemma_termdiff2
tff(fact_4429_Maclaurin__sin__expansion,axiom,
    ! [X: real,Na: nat] :
    ? [T3: real] : ( sin(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fs(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ).

% Maclaurin_sin_expansion
tff(fact_4430_Maclaurin__sin__expansion2,axiom,
    ! [X: real,Na: nat] :
    ? [T3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
      & ( sin(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fs(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ).

% Maclaurin_sin_expansion2
tff(fact_4431_Maclaurin__cos__expansion,axiom,
    ! [X: real,Na: nat] :
    ? [T3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
      & ( cos(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ep(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ).

% Maclaurin_cos_expansion
tff(fact_4432_Maclaurin__sin__expansion4,axiom,
    ! [X: real,Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => ? [T3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),X)
          & ( sin(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fs(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ).

% Maclaurin_sin_expansion4
tff(fact_4433_Maclaurin__sin__expansion3,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),X)
            & ( sin(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_fs(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),sin(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ).

% Maclaurin_sin_expansion3
tff(fact_4434_Maclaurin__minus__cos__expansion,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),zero_zero(real))
            & ( cos(real,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ep(real,fun(nat,real),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),T3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,real,semiring_1_of_nat(real),Na))),pi)))),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
tff(fact_4435_bij__betw__roots__unity,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => bij_betw(nat,complex,aTP_Lamp_fv(nat,fun(nat,complex),Na),set_ord_lessThan(nat,Na),collect(complex,aTP_Lamp_as(nat,fun(complex,$o),Na))) ) ).

% bij_betw_roots_unity
tff(fact_4436_sum__gp,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M,Na))
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M),
              zero_zero(A),
              $ite(X = one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat))),M)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,Na)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X))) ) ) ) ).

% sum_gp
tff(fact_4437_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [R2: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ei(A,fun(nat,A),R2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,R2),aa(nat,nat,suc,M))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_4438_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_4439_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,Na)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Na)),M),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))),aa(nat,A,G,aa(nat,nat,suc,Na)))) ) ) ).

% sum.cl_ivl_Suc
tff(fact_4440_all__nat__less,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ! [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),Na)
         => aa(nat,$o,P,M3) )
    <=> ! [X5: nat] :
          ( member(nat,X5,set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))
         => aa(nat,$o,P,X5) ) ) ).

% all_nat_less
tff(fact_4441_ex__nat__less,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ? [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),Na)
          & aa(nat,$o,P,M3) )
    <=> ? [X5: nat] :
          ( member(nat,X5,set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))
          & aa(nat,$o,P,X5) ) ) ).

% ex_nat_less
tff(fact_4442_atMost__atLeast0,axiom,
    ! [Na: nat] : ( set_ord_atMost(nat,Na) = set_or1337092689740270186AtMost(nat,zero_zero(nat),Na) ) ).

% atMost_atLeast0
tff(fact_4443_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
tff(fact_4444_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_fw(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% sum.shift_bounds_cl_nat_ivl
tff(fact_4445_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
              | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2)
                & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
                  | aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) )
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2) ) ) ) ).

% atLeastatMost_psubset_iff
tff(fact_4446_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,Na,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_fx(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Na),M)),set_or1337092689740270186AtMost(nat,Na,M)) ) ) ).

% sum.atLeastAtMost_rev
tff(fact_4447_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F2,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0
tff(fact_4448_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))),aa(nat,A,G,aa(nat,nat,suc,Na))) ) ) ).

% sum.atLeast0_atMost_Suc
tff(fact_4449_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,aa(nat,nat,suc,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))) ) ) ) ).

% sum.nat_ivl_Suc'
tff(fact_4450_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),Na))) ) ) ) ).

% sum.atLeast_Suc_atMost
tff(fact_4451_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))),aa(nat,A,G,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,Na))) ) ) ) ).

% sum.Suc_reindex_ivl
tff(fact_4452_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,Na: nat,F2: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ey(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,aa(nat,nat,suc,Na))),aa(nat,A,F2,M)) ) ) ) ).

% sum_Suc_diff
tff(fact_4453_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,Na)) ) ) ).

% sum.atLeast1_atMost_eq
tff(fact_4454_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),Mm: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),F2)),set_ord_lessThan(nat,Mm)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,one_one(nat),Mm)) ) ) ).

% sum_bounds_lt_plus1
tff(fact_4455_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fy(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_ord_atMost(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ga(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Na)),set_ord_lessThan(nat,Na)) ) ) ).

% sum.nested_swap'
tff(fact_4456_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),A2: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,A2,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_gb(fun(nat,A),fun(nat,fun(A,A)),F2),A2,B2,zero_zero(A)) ) ) ).

% sum_atLeastAtMost_code
tff(fact_4457_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A),P3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),P3))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),P3)))) ) ) ) ).

% sum.ub_add_nat
tff(fact_4458_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_ord_atMost(nat,M))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)))) ) ) ).

% sum_up_index_split
tff(fact_4459_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gc(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,M,Na))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,M)),aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)))),zero_zero(A)) ) ) ).

% sum_natinterval_diff
tff(fact_4460_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,Na: nat,F2: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gd(fun(nat,A),fun(nat,A),F2)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),Na)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,Na)),aa(nat,A,F2,M)) ) ) ) ).

% sum_telescope''
tff(fact_4461_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M: nat,Na: nat,X: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)))) ) ) ) ).

% sum_power_shift
tff(fact_4462_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),E2: real] :
          ( summable(A,F2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => ~ ! [N7: nat] :
                  ~ ! [M2: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),M2)
                     => ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or1337092689740270186AtMost(nat,M2,N6)))),E2) ) ) ) ) ).

% summable_partial_sum_bound
tff(fact_4463_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M: nat,Na: nat,X: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M,Na))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,Na))) ) ) ) ).

% sum_gp_multiplied
tff(fact_4464_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dj(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% sum.in_pairs
tff(fact_4465_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Na: nat,K: A] :
          ( ! [X5: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),X5)),set_ord_atMost(nat,Na)) = K )
        <=> ( ( aa(nat,A,C2,zero_zero(nat)) = K )
            & ! [X5: nat] :
                ( member(nat,X5,set_or1337092689740270186AtMost(nat,one_one(nat),Na))
               => ( aa(nat,A,C2,X5) = zero_zero(A) ) ) ) ) ) ).

% polyfun_eq_const
tff(fact_4466_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ge(nat,fun(nat,A),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_4467_gauss__sum__nat,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,suc,Na))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% gauss_sum_nat
tff(fact_4468_double__arith__series,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,D2: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gg(A,fun(A,fun(nat,A)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),D2))) ) ) ).

% double_arith_series
tff(fact_4469_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A))) ) ) ).

% double_gauss_sum
tff(fact_4470_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_gh(nat,fun(nat,fun(nat,nat)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,Na)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),A2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),D2)))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% arith_series_nat
tff(fact_4471_Sum__Icc__nat,axiom,
    ! [M: nat,Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,M,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Icc_nat
tff(fact_4472_arith__series,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,D2: A,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gi(A,fun(A,fun(nat,A)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),D2)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% arith_series
tff(fact_4473_gauss__sum,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A)))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum
tff(fact_4474_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_4475_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)))
          = $ite(X = one_one(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Na)),one_one(A)),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,Na))))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X))) ) ) ).

% sum_gp_offset
tff(fact_4476_polyfun__diff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Na: nat,A2: fun(nat,A),X: A,Y: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Na)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),A2),X)),set_ord_atMost(nat,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),A2),Y)),set_ord_atMost(nat,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_gk(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Na),A2),X),Y)),set_ord_lessThan(nat,Na))) ) ) ) ).

% polyfun_diff
tff(fact_4477_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,Na: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,Na))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gl(A,fun(nat,A),Z)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_4478_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( vEBT_vebt_buildup(X) = Y )
     => ( accp(nat,vEBT_v4011308405150292612up_rel,X)
       => ( ( ( X = zero_zero(nat) )
           => ( ( Y = vEBT_Leaf($false,$false) )
             => ~ accp(nat,vEBT_v4011308405150292612up_rel,zero_zero(nat)) ) )
         => ( ( ( X = aa(nat,nat,suc,zero_zero(nat)) )
             => ( ( Y = vEBT_Leaf($false,$false) )
               => ~ accp(nat,vEBT_v4011308405150292612up_rel,aa(nat,nat,suc,zero_zero(nat))) ) )
           => ~ ! [Va: nat] :
                  ( ( X = aa(nat,nat,suc,aa(nat,nat,suc,Va)) )
                 => ( ( Y
                      = $ite(
                          aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,aa(nat,nat,suc,Va))),
                          $let(
                            half: nat,
                            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),half),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(half)) ),
                          $let(
                            half: nat,
                            half := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,Va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                            vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,aa(nat,nat,suc,Va)),replicate(vEBT_VEBT,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,suc,half)),vEBT_vebt_buildup(half)),vEBT_vebt_buildup(aa(nat,nat,suc,half))) ) ) )
                   => ~ accp(nat,vEBT_v4011308405150292612up_rel,aa(nat,nat,suc,aa(nat,nat,suc,Va))) ) ) ) ) ) ) ).

% vebt_buildup.pelims
tff(fact_4479_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit1,M),aa(num,num,bit0,Na)) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_gm(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M,Na)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_4480_arctan__def,axiom,
    ! [Y: real] : ( aa(real,real,arctan,Y) = the(real,aTP_Lamp_gn(real,fun(real,$o),Y)) ) ).

% arctan_def
tff(fact_4481_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(B)
        & ring_1(B) )
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => member(B,aa(A,B,F2,X3),ring_1_Ints(B)) )
         => member(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3),ring_1_Ints(B)) ) ) ).

% Ints_prod
tff(fact_4482_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_go(B,A)),A3) = one_one(A) ) ) ).

% prod.neutral_const
tff(fact_4483_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7121269368397514597t_prod(B,nat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_gp(fun(B,nat),fun(B,A),F2)),A3) ) ) ).

% of_nat_prod
tff(fact_4484_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [F2: fun(B,int),A3: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7121269368397514597t_prod(B,int),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_gq(fun(B,int),fun(B,A),F2)),A3) ) ) ).

% of_int_prod
tff(fact_4485_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,Na))),aa(nat,A,G,Na)) ) ) ).

% prod.lessThan_Suc
tff(fact_4486_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,Na))),aa(nat,A,G,aa(nat,nat,suc,Na))) ) ) ).

% prod.atMost_Suc
tff(fact_4487_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,Na)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Na)),M),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))),aa(nat,A,G,aa(nat,nat,suc,Na)))) ) ) ).

% prod.cl_ivl_Suc
tff(fact_4488_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit0,M),aa(num,num,bit0,Na)) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_gr(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M,Na)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_4489_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [F2: fun(B,A),A2: A,A3: set(B)] : ( modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(A,fun(B,A),aTP_Lamp_cw(fun(B,A),fun(A,fun(B,A)),F2),A2)),A3),A2) = modulo_modulo(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3),A2) ) ) ).

% mod_prod_eq
tff(fact_4490_prod__dvd__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( ! [A4: A] :
              ( member(A,A4,A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F2,A4)),aa(A,B,G,A4)) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)) ) ) ).

% prod_dvd_prod
tff(fact_4491_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) != one_one(A) )
         => ~ ! [A4: B] :
                ( member(B,A4,A3)
               => ( aa(B,A,G,A4) = one_one(A) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
tff(fact_4492_prod_Oneutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => ( aa(A,B,G,X3) = one_one(B) ) )
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = one_one(B) ) ) ) ).

% prod.neutral
tff(fact_4493_prod__power__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A3: set(B),Na: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),Na) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(nat,fun(B,A),aTP_Lamp_gs(fun(B,A),fun(nat,fun(B,A)),F2),Na)),A3) ) ) ).

% prod_power_distrib
tff(fact_4494_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F2: fun(B,A),G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_gt(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G)),A3) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F2),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)) ) ) ).

% prod_dividef
tff(fact_4495_prod__nonneg,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X3)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ).

% prod_nonneg
tff(fact_4496_prod__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( ! [I3: A] :
              ( member(A,I3,A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,I3))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,I3)),aa(A,B,G,I3)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)) ) ) ).

% prod_mono
tff(fact_4497_prod__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F2,X3)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ).

% prod_pos
tff(fact_4498_prod__ge__1,axiom,
    ! [B: $tType,A: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F2,X3)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ).

% prod_ge_1
tff(fact_4499_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
tff(fact_4500_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C2: A,F2: fun(B,nat),A3: set(B)] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F2),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,nat),fun(B,A),aTP_Lamp_gv(A,fun(fun(B,nat),fun(B,A)),C2),F2)),A3) ) ) ).

% power_sum
tff(fact_4501_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_gw(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% prod.shift_bounds_cl_nat_ivl
tff(fact_4502_prod__le__1,axiom,
    ! [A: $tType,B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X3))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,X3)),one_one(B)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),one_one(B)) ) ) ).

% prod_le_1
tff(fact_4503_aset_I2_J,axiom,
    ! [D5: int,A3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb2: int] :
                  ( member(int,Xb2,A3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X3)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D5)) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb2: int] :
                    ( member(int,Xb2,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X3)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D5)) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
           => ( ( aa(int,$o,P,X4)
                | aa(int,$o,Q,X4) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5))
                | aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)) ) ) ) ) ) ).

% aset(2)
tff(fact_4504_aset_I1_J,axiom,
    ! [D5: int,A3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb2: int] :
                  ( member(int,Xb2,A3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X3)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D5)) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb2: int] :
                    ( member(int,Xb2,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X3)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D5)) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
           => ( ( aa(int,$o,P,X4)
                & aa(int,$o,Q,X4) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5))
                & aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)) ) ) ) ) ) ).

% aset(1)
tff(fact_4505_bset_I2_J,axiom,
    ! [D5: int,B3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb2: int] :
                  ( member(int,Xb2,B3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X3)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D5)) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb2: int] :
                    ( member(int,Xb2,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X3)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D5)) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
           => ( ( aa(int,$o,P,X4)
                | aa(int,$o,Q,X4) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5))
                | aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)) ) ) ) ) ) ).

% bset(2)
tff(fact_4506_bset_I1_J,axiom,
    ! [D5: int,B3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb2: int] :
                  ( member(int,Xb2,B3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X3)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D5)) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb2: int] :
                    ( member(int,Xb2,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X3)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D5)) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
           => ( ( aa(int,$o,P,X4)
                & aa(int,$o,Q,X4) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5))
                & aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)) ) ) ) ) ) ).

% bset(1)
tff(fact_4507_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_gx(fun(nat,A),fun(nat,fun(nat,A)),G),Na)),set_ord_lessThan(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,Na)) ) ) ).

% prod.nat_diff_reindex
tff(fact_4508_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,Na,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_gy(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Na),M)),set_or1337092689740270186AtMost(nat,Na,M)) ) ) ).

% prod.atLeastAtMost_rev
tff(fact_4509_ln__neg__is__const,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),zero_zero(real))
     => ( aa(real,real,ln_ln(real),X) = the(real,aTP_Lamp_gz(real,$o)) ) ) ).

% ln_neg_is_const
tff(fact_4510_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))),aa(nat,A,G,aa(nat,nat,suc,Na))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_4511_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,aa(nat,nat,suc,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_4512_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),Na))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_4513_aset_I10_J,axiom,
    ! [D2: int,D5: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
         => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),T2))
           => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)),T2)) ) ) ) ).

% aset(10)
tff(fact_4514_aset_I9_J,axiom,
    ! [D2: int,D5: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),T2))
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)),T2)) ) ) ) ).

% aset(9)
tff(fact_4515_bset_I10_J,axiom,
    ! [D2: int,D5: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
         => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),T2))
           => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)),T2)) ) ) ) ).

% bset(10)
tff(fact_4516_bset_I9_J,axiom,
    ! [D2: int,D5: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),T2))
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)),T2)) ) ) ) ).

% bset(9)
tff(fact_4517_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,Na))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_4518_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))),aa(nat,A,G,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,Na))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_4519_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,Na))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_4520_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,Na)) ) ) ).

% prod.atLeast1_atMost_eq
tff(fact_4521_fact__prod,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] : ( semiring_char_0_fact(A,Na) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,one_one(nat),Na))) ) ) ).

% fact_prod
tff(fact_4522_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_ha(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_ord_atMost(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Na)),set_ord_lessThan(nat,Na)) ) ) ).

% prod.nested_swap'
tff(fact_4523_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [F2: fun(nat,A),A2: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),F2),set_or1337092689740270186AtMost(nat,A2,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_hd(fun(nat,A),fun(nat,fun(A,A)),F2),A2,B2,one_one(A)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_4524_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,Na: nat,G: fun(nat,A),P3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),P3))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),P3)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_4525_periodic__finite__ex,axiom,
    ! [D2: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X3: int,K2: int] :
            ( aa(int,$o,P,X3)
          <=> aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D2))) )
       => ( ? [X_13: int] : aa(int,$o,P,X_13)
        <=> ? [X5: int] :
              ( member(int,X5,set_or1337092689740270186AtMost(int,one_one(int),D2))
              & aa(int,$o,P,X5) ) ) ) ) ).

% periodic_finite_ex
tff(fact_4526_aset_I7_J,axiom,
    ! [D5: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),X4)
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)) ) ) ) ).

% aset(7)
tff(fact_4527_aset_I5_J,axiom,
    ! [D5: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,T2,A3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X4),T2)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)),T2) ) ) ) ) ).

% aset(5)
tff(fact_4528_aset_I4_J,axiom,
    ! [D5: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,T2,A3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
           => ( ( X4 != T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5) != T2 ) ) ) ) ) ).

% aset(4)
tff(fact_4529_aset_I3_J,axiom,
    ! [D5: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int)),A3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
           => ( ( X4 = T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5) = T2 ) ) ) ) ) ).

% aset(3)
tff(fact_4530_bset_I7_J,axiom,
    ! [D5: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,T2,B3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),X4)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)) ) ) ) ) ).

% bset(7)
tff(fact_4531_bset_I5_J,axiom,
    ! [D5: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X4),T2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)),T2) ) ) ) ).

% bset(5)
tff(fact_4532_bset_I4_J,axiom,
    ! [D5: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,T2,B3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
           => ( ( X4 != T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5) != T2 ) ) ) ) ) ).

% bset(4)
tff(fact_4533_bset_I3_J,axiom,
    ! [D5: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int)),B3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
           => ( ( X4 = T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5) = T2 ) ) ) ) ) ).

% bset(3)
tff(fact_4534_norm__prod__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [I5: set(A),Z: fun(A,B),W: fun(A,B)] :
          ( ! [I3: A] :
              ( member(A,I3,I5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Z,I3))),one_one(real)) )
         => ( ! [I3: A] :
                ( member(A,I3,I5)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,W,I3))),one_one(real)) )
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),Z),I5)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),W),I5)))),aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aa(fun(A,B),fun(A,real),aTP_Lamp_he(fun(A,B),fun(fun(A,B),fun(A,real)),Z),W)),I5)) ) ) ) ).

% norm_prod_diff
tff(fact_4535_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,Na))) ) ) ).

% prod.atMost_shift
tff(fact_4536_fact__eq__fact__times,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
     => ( semiring_char_0_fact(nat,M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,Na)),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Na),M))) ) ) ).

% fact_eq_fact_times
tff(fact_4537_aset_I8_J,axiom,
    ! [D5: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),X4)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)) ) ) ) ).

% aset(8)
tff(fact_4538_aset_I6_J,axiom,
    ! [D5: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int)),A3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa3) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X4),T2)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X4),D5)),T2) ) ) ) ) ).

% aset(6)
tff(fact_4539_bset_I8_J,axiom,
    ! [D5: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( member(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int)),B3)
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),X4)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)) ) ) ) ) ).

% bset(8)
tff(fact_4540_bset_I6_J,axiom,
    ! [D5: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( member(int,Xa3,set_or1337092689740270186AtMost(int,one_one(int),D5))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X4 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa3) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X4),T2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X4),D5)),T2) ) ) ) ).

% bset(6)
tff(fact_4541_cpmi,axiom,
    ! [D5: int,P: fun(int,$o),P2: fun(int,$o),B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( ? [Z3: int] :
          ! [X3: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X3),Z3)
           => ( aa(int,$o,P,X3)
            <=> aa(int,$o,P2,X3) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
                 => ! [Xb2: int] :
                      ( member(int,Xb2,B3)
                     => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
             => ( aa(int,$o,P,X3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D5)) ) )
         => ( ! [X3: int,K2: int] :
                ( aa(int,$o,P2,X3)
              <=> aa(int,$o,P2,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D5))) )
           => ( ? [X_13: int] : aa(int,$o,P,X_13)
            <=> ( ? [X5: int] :
                    ( member(int,X5,set_or1337092689740270186AtMost(int,one_one(int),D5))
                    & aa(int,$o,P2,X5) )
                | ? [X5: int] :
                    ( member(int,X5,set_or1337092689740270186AtMost(int,one_one(int),D5))
                    & ? [Xa4: int] :
                        ( member(int,Xa4,B3)
                        & aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa4),X5)) ) ) ) ) ) ) ) ) ).

% cpmi
tff(fact_4542_cppi,axiom,
    ! [D5: int,P: fun(int,$o),P2: fun(int,$o),A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D5)
     => ( ? [Z3: int] :
          ! [X3: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z3),X3)
           => ( aa(int,$o,P,X3)
            <=> aa(int,$o,P2,X3) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D5))
                 => ! [Xb2: int] :
                      ( member(int,Xb2,A3)
                     => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
             => ( aa(int,$o,P,X3)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D5)) ) )
         => ( ! [X3: int,K2: int] :
                ( aa(int,$o,P2,X3)
              <=> aa(int,$o,P2,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K2),D5))) )
           => ( ? [X_13: int] : aa(int,$o,P,X_13)
            <=> ( ? [X5: int] :
                    ( member(int,X5,set_or1337092689740270186AtMost(int,one_one(int),D5))
                    & aa(int,$o,P2,X5) )
                | ? [X5: int] :
                    ( member(int,X5,set_or1337092689740270186AtMost(int,one_one(int),D5))
                    & ? [Xa4: int] :
                        ( member(int,Xa4,A3)
                        & aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa4),X5)) ) ) ) ) ) ) ) ) ).

% cppi
tff(fact_4543_arccos__def,axiom,
    ! [Y: real] : ( aa(real,real,arccos,Y) = the(real,aTP_Lamp_hf(real,fun(real,$o),Y)) ) ).

% arccos_def
tff(fact_4544_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hg(A,fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) ) ) ).

% pochhammer_Suc_prod
tff(fact_4545_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,A2,Na) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hh(A,fun(nat,fun(nat,A)),A2),Na)),set_or1337092689740270186AtMost(nat,one_one(nat),Na)) ) ) ).

% pochhammer_prod_rev
tff(fact_4546_fact__div__fact,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,Na)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)),M)) ) ) ).

% fact_div_fact
tff(fact_4547_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hi(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% prod.in_pairs
tff(fact_4548_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hi(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,Na)) ) ) ).

% prod.in_pairs_0
tff(fact_4549_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hh(A,fun(nat,fun(nat,A)),A2),Na)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) ) ) ).

% pochhammer_Suc_prod_rev
tff(fact_4550_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P3: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P3)
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_hj(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,P3)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_hk(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P3),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_4551_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hl(A,fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),K))),semiring_char_0_fact(A,aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc
tff(fact_4552_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_hm(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_4553_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_hn(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_4554_pi__half,axiom,
    aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) = the(real,aTP_Lamp_ho(real,$o)) ).

% pi_half
tff(fact_4555_pi__def,axiom,
    pi = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),the(real,aTP_Lamp_ho(real,$o))) ).

% pi_def
tff(fact_4556_Sum__Icc__int,axiom,
    ! [M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M),Na)
     => ( aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7311177749621191930dd_sum(int,int),aTP_Lamp_hp(int,int)),set_or1337092689740270186AtMost(int,M,Na)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Na),aa(int,int,aa(int,fun(int,int),plus_plus(int),Na),one_one(int)))),aa(int,int,aa(int,fun(int,int),times_times(int),M),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),one_one(int))))),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) ) ) ).

% Sum_Icc_int
tff(fact_4557_divmod__step__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Qr: product_prod(A,A)] : ( unique1321980374590559556d_step(A,L,Qr) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_hq(num,fun(A,fun(A,product_prod(A,A))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_4558_arcsin__def,axiom,
    ! [Y: real] : ( aa(real,real,arcsin,Y) = the(real,aTP_Lamp_hr(real,fun(real,$o),Y)) ) ).

% arcsin_def
tff(fact_4559_divmod__nat__if,axiom,
    ! [M: nat,Na: nat] :
      ( divmod_nat(M,Na)
      = $ite(
          ( ( Na = zero_zero(nat) )
          | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ),
          aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),M),
          aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_hs(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na),Na)) ) ) ).

% divmod_nat_if
tff(fact_4560_set__n__lists,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,Na,Xs)) = collect(list(A),aa(list(A),fun(list(A),$o),aTP_Lamp_ht(nat,fun(list(A),fun(list(A),$o)),Na),Xs)) ) ).

% set_n_lists
tff(fact_4561_set__encode__def,axiom,
    nat_set_encode = aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ).

% set_encode_def
tff(fact_4562_VEBT_Osize_I3_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_list(vEBT_VEBT,size_size(vEBT_VEBT),X13)),aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size(3)
tff(fact_4563_set__decode__inverse,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,nat_set_encode,nat_set_decode(Na)) = Na ) ).

% set_decode_inverse
tff(fact_4564_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7121269368397514597t_prod(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_hu(nat,fun(nat,fun(nat,$o)),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hw(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_atMost(nat,Na)) ) ) ).

% prod.triangle_reindex_eq
tff(fact_4565_int__prod,axiom,
    ! [A: $tType,F2: fun(A,nat),A3: set(A)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7121269368397514597t_prod(A,nat),F2),A3)) = aa(set(A),int,aa(fun(A,int),fun(set(A),int),groups7121269368397514597t_prod(A,int),aTP_Lamp_et(fun(A,nat),fun(A,int),F2)),A3) ) ).

% int_prod
tff(fact_4566_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7121269368397514597t_prod(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_hx(nat,fun(nat,fun(nat,$o)),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hw(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_lessThan(nat,Na)) ) ) ).

% prod.triangle_reindex
tff(fact_4567_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_hu(nat,fun(nat,fun(nat,$o)),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_hz(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_atMost(nat,Na)) ) ) ).

% sum.triangle_reindex_eq
tff(fact_4568_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_hx(nat,fun(nat,fun(nat,$o)),Na)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_hz(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_lessThan(nat,Na)) ) ) ).

% sum.triangle_reindex
tff(fact_4569_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: nat,F2: fun(A,nat)] :
      ( member(A,X,aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y),aa(A,nat,F2,X))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y),size_list(A,F2,Xs)) ) ) ).

% size_list_estimation
tff(fact_4570_prod__int__plus__eq,axiom,
    ! [I2: nat,J2: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2))) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_hp(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I2),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2)))) ) ).

% prod_int_plus_eq
tff(fact_4571_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list(A),Na: nat,Xs: list(A)] :
      ( member(list(A),Ys,aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,Na,Xs)))
     => ( aa(list(A),nat,size_size(list(A)),Ys) = Na ) ) ).

% length_n_lists_elem
tff(fact_4572_divmod__nat__def,axiom,
    ! [M: nat,Na: nat] : ( divmod_nat(M,Na) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)),modulo_modulo(nat,M,Na)) ) ).

% divmod_nat_def
tff(fact_4573_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] :
          ( aa(nat,A,semiring_1_of_nat(A),Na)
          = $ite(Na = zero_zero(nat),zero_zero(A),aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_ia(nat,fun(nat,A))),divmod_nat(Na,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% of_nat_code_if
tff(fact_4574_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_list(vEBT_VEBT,vEBT_size_VEBT,X13)),aa(vEBT_VEBT,nat,vEBT_size_VEBT,X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size_gen(1)
tff(fact_4575_length__n__lists,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(list(A)),nat,size_size(list(list(A))),n_lists(A,Na,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na) ) ).

% length_n_lists
tff(fact_4576_Sum__Ico__nat,axiom,
    ! [M: nat,Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gf(nat,nat)),set_or7035219750837199246ssThan(nat,M,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% Sum_Ico_nat
tff(fact_4577_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I2: A,L: A,U: A] :
          ( member(A,I2,set_or7035219750837199246ssThan(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),I2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),I2),U) ) ) ) ).

% atLeastLessThan_iff
tff(fact_4578_ivl__diff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [I2: A,Na: A,M: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I2),Na)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or7035219750837199246ssThan(A,I2,M)),set_or7035219750837199246ssThan(A,I2,Na)) = set_or7035219750837199246ssThan(A,Na,M) ) ) ) ).

% ivl_diff
tff(fact_4579_lessThan__minus__lessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Na: A,M: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_ord_lessThan(A,Na)),set_ord_lessThan(A,M)) = set_or7035219750837199246ssThan(A,M,Na) ) ) ).

% lessThan_minus_lessThan
tff(fact_4580_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,Na)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na))),aa(nat,A,G,Na))) ) ) ).

% sum.op_ivl_Suc
tff(fact_4581_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,Na)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na))),aa(nat,A,G,Na))) ) ) ).

% prod.op_ivl_Suc
tff(fact_4582_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( set_or7035219750837199246ssThan(A,A2,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
tff(fact_4583_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( set_or7035219750837199246ssThan(A,A2,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
tff(fact_4584_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( ( set_or7035219750837199246ssThan(A,A2,B2) = set_or7035219750837199246ssThan(A,C2,D2) )
            <=> ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
tff(fact_4585_ex__nat__less__eq,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ? [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Na)
          & aa(nat,$o,P,M3) )
    <=> ? [X5: nat] :
          ( member(nat,X5,set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))
          & aa(nat,$o,P,X5) ) ) ).

% ex_nat_less_eq
tff(fact_4586_all__nat__less__eq,axiom,
    ! [Na: nat,P: fun(nat,$o)] :
      ( ! [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),Na)
         => aa(nat,$o,P,M3) )
    <=> ! [X5: nat] :
          ( member(nat,X5,set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))
         => aa(nat,$o,P,X5) ) ) ).

% all_nat_less_eq
tff(fact_4587_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] : ( set_or7035219750837199246ssThan(nat,L,aa(nat,nat,suc,U)) = set_or1337092689740270186AtMost(nat,L,U) ) ).

% atLeastLessThanSuc_atLeastAtMost
tff(fact_4588_lessThan__atLeast0,axiom,
    ! [Na: nat] : ( set_ord_lessThan(nat,Na) = set_or7035219750837199246ssThan(nat,zero_zero(nat),Na) ) ).

% lessThan_atLeast0
tff(fact_4589_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ct(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% sum.shift_bounds_Suc_ivl
tff(fact_4590_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_fw(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% sum.shift_bounds_nat_ivl
tff(fact_4591_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_gu(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% prod.shift_bounds_Suc_ivl
tff(fact_4592_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_gw(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% prod.shift_bounds_nat_ivl
tff(fact_4593_sum_Oivl__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & comm_monoid_add(B) )
     => ! [A2: A,C2: A,B2: A,D2: A,G: fun(A,B),H: fun(A,B)] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),D2)
                   => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),set_or7035219750837199246ssThan(A,A2,B2)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),set_or7035219750837199246ssThan(A,C2,D2)) ) ) ) ) ) ).

% sum.ivl_cong
tff(fact_4594_prod_Oivl__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & comm_monoid_mult(B) )
     => ! [A2: A,C2: A,B2: A,D2: A,G: fun(A,B),H: fun(A,B)] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),D2)
                   => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),set_or7035219750837199246ssThan(A,A2,B2)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),set_or7035219750837199246ssThan(A,C2,D2)) ) ) ) ) ) ).

% prod.ivl_cong
tff(fact_4595_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,P3: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),P3)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Na,P3))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,P3)) ) ) ) ) ).

% sum.atLeastLessThan_concat
tff(fact_4596_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,Na: nat,P3: nat,F2: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),P3)
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,M,P3))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,M,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,Na,P3)) ) ) ) ) ).

% sum_diff_nat_ivl
tff(fact_4597_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
tff(fact_4598_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
tff(fact_4599_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F2,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
tff(fact_4600_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))),aa(nat,A,G,Na)) ) ) ).

% sum.atLeast0_lessThan_Suc
tff(fact_4601_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),Na))) ) ) ) ).

% sum.atLeast_Suc_lessThan
tff(fact_4602_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: nat,B2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A2,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A2,B2))),aa(nat,A,G,B2)) ) ) ) ).

% sum.atLeastLessThan_Suc
tff(fact_4603_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))),aa(nat,A,G,Na)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_4604_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),Na))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_4605_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: nat,B2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A2,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A2,B2))),aa(nat,A,G,B2)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_4606_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,Na)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na))) ) ) ) ).

% sum.last_plus
tff(fact_4607_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,Na: nat,F2: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ey(fun(nat,A),fun(nat,A),F2)),set_or7035219750837199246ssThan(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,Na)),aa(nat,A,F2,M)) ) ) ) ).

% sum_Suc_diff'
tff(fact_4608_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Na,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ib(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Na),M)),set_or7035219750837199246ssThan(nat,Na,M)) ) ) ).

% sum.atLeastLessThan_rev
tff(fact_4609_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ic(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ga(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Na)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) ) ) ).

% sum.nested_swap
tff(fact_4610_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,Na,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_id(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Na),M)),set_or7035219750837199246ssThan(nat,Na,M)) ) ) ).

% prod.atLeastLessThan_rev
tff(fact_4611_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: fun(nat,fun(nat,A)),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_ie(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),Na)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) ) ) ).

% prod.nested_swap
tff(fact_4612_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_if(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_ord_lessThan(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K))) ) ) ).

% sum.nat_group
tff(fact_4613_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ig(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_ord_lessThan(nat,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),K))) ) ) ).

% prod.nat_group
tff(fact_4614_prod__Suc__fact,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) = semiring_char_0_fact(nat,Na) ) ).

% prod_Suc_fact
tff(fact_4615_prod__Suc__Suc__fact,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),Na)) = semiring_char_0_fact(nat,Na) ) ).

% prod_Suc_Suc_fact
tff(fact_4616_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na))),aa(nat,A,G,Na))) ) ) ).

% sum.head_if
tff(fact_4617_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na))),aa(nat,A,G,Na))) ) ) ).

% prod.head_if
tff(fact_4618_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] : ( semiring_char_0_fact(A,Na) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))) ) ) ).

% fact_prod_Suc
tff(fact_4619_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,Na,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_fx(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Na),M)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Na),M)) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4620_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,Na,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_gy(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),Na),M)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Na),M)) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4621_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,Na: nat] : ( comm_s3205402744901411588hammer(A,A2,Na) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hg(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) ) ) ).

% pochhammer_prod
tff(fact_4622_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A2: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ih(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F2),A2),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4623_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Na: nat] : ( semiring_char_0_fact(A,Na) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aa(nat,fun(nat,nat),minus_minus(nat),Na)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))) ) ) ).

% fact_prod_rev
tff(fact_4624_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [N5: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N5),M3)
                 => ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,M3,N4)))),E3) ) ) ) ) ).

% summable_Cauchy
tff(fact_4625_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size_gen(2)
tff(fact_4626_sums__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A),S: A,K: nat] :
          ( sums(A,F2,S)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
           => sums(A,aa(nat,fun(nat,A),aTP_Lamp_ii(fun(nat,A),fun(nat,fun(nat,A)),F2),K),S) ) ) ) ).

% sums_group
tff(fact_4627_take__bit__sum,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ij(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) ) ) ).

% take_bit_sum
tff(fact_4628_fact__split,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( semiring_char_0_fact(A,Na) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K),Na)))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),K))) ) ) ) ).

% fact_split
tff(fact_4629_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Na),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ik(nat,fun(nat,fun(nat,A)),K),Na)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% binomial_altdef_of_nat
tff(fact_4630_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_il(A,fun(nat,fun(nat,A)),A2),K)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_altdef_of_nat
tff(fact_4631_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),semiring_char_0_fact(A,K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_im(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_4632_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,gbinomial(A,A2),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_im(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_4633_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hl(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K))),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_prod_rev
tff(fact_4634_sum__power2,axiom,
    ! [K: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)),one_one(nat)) ) ).

% sum_power2
tff(fact_4635_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Na: nat,A2: fun(nat,A),B2: fun(nat,A)] :
          ( ! [I3: nat,J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J3)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),Na)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A2,I3)),aa(nat,A,A2,J3)) ) )
         => ( ! [I3: nat,J3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J3)
               => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),Na)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,B2,J3)),aa(nat,A,B2,I3)) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_in(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)))) ) ) ) ).

% Chebyshev_sum_upper
tff(fact_4636_Chebyshev__sum__upper__nat,axiom,
    ! [Na: nat,A2: fun(nat,nat),B2: fun(nat,nat)] :
      ( ! [I3: nat,J3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),Na)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,A2,I3)),aa(nat,nat,A2,J3)) ) )
     => ( ! [I3: nat,J3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J3)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),Na)
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,B2,J3)),aa(nat,nat,B2,I3)) ) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_io(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),A2),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)))) ) ) ).

% Chebyshev_sum_upper_nat
tff(fact_4637_Code__Target__Int_Opositive__def,axiom,
    code_Target_positive = numeral_numeral(int) ).

% Code_Target_Int.positive_def
tff(fact_4638_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L: int,U: int] : ( set_or7035219750837199246ssThan(int,L,aa(int,int,aa(int,fun(int,int),plus_plus(int),U),one_one(int))) = set_or1337092689740270186AtMost(int,L,U) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
tff(fact_4639_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_ip(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_4640_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: fun(nat,fun(A,A)),V: num,Na: nat] :
      ( aa(nat,A,rec_nat(A,A2,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),Na))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(A,A,aa(nat,fun(A,A),F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),Na)),aa(nat,A,rec_nat(A,A2,F2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),Na))) ) ) ).

% rec_nat_add_eq_if
tff(fact_4641_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: fun(nat,A),V: num,Na: nat] : ( case_nat(A,A2,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),Na)) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),Na)) ) ).

% case_nat_add_eq_if
tff(fact_4642_old_Onat_Osimps_I7_J,axiom,
    ! [A: $tType,F1: A,F22: fun(nat,fun(A,A)),Nat: nat] : ( aa(nat,A,rec_nat(A,F1,F22),aa(nat,nat,suc,Nat)) = aa(A,A,aa(nat,fun(A,A),F22,Nat),aa(nat,A,rec_nat(A,F1,F22),Nat)) ) ).

% old.nat.simps(7)
tff(fact_4643_old_Onat_Osimps_I6_J,axiom,
    ! [A: $tType,F1: A,F22: fun(nat,fun(A,A))] : ( aa(nat,A,rec_nat(A,F1,F22),zero_zero(nat)) = F1 ) ).

% old.nat.simps(6)
tff(fact_4644_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: fun(nat,A),V: num] : ( case_nat(A,A2,F2,aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,F2,pred_numeral(V)) ) ).

% case_nat_numeral
tff(fact_4645_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: fun(nat,fun(A,A)),V: num] :
      ( aa(nat,A,rec_nat(A,A2,F2),aa(num,nat,numeral_numeral(nat),V))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(A,A,aa(nat,fun(A,A),F2,pv),aa(nat,A,rec_nat(A,A2,F2),pv)) ) ) ).

% rec_nat_numeral
tff(fact_4646_divmod__integer_H__def,axiom,
    ! [M: num,Na: num] : ( unique8689654367752047608divmod(code_integer,M,Na) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),aa(num,code_integer,numeral_numeral(code_integer),M)),aa(num,code_integer,numeral_numeral(code_integer),Na))),modulo_modulo(code_integer,aa(num,code_integer,numeral_numeral(code_integer),M),aa(num,code_integer,numeral_numeral(code_integer),Na))) ) ).

% divmod_integer'_def
tff(fact_4647_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: B,F22: fun(nat,B),Nat: nat] : ( aa(B,A,H,case_nat(B,F1,F22,Nat)) = case_nat(A,aa(B,A,H,F1),aa(fun(nat,B),fun(nat,A),aTP_Lamp_iq(fun(B,A),fun(fun(nat,B),fun(nat,A)),H),F22),Nat) ) ).

% nat.case_distrib
tff(fact_4648_times__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),K),zero_zero(code_integer)) = zero_zero(code_integer) ) ).

% times_integer_code(1)
tff(fact_4649_times__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),zero_zero(code_integer)),L) = zero_zero(code_integer) ) ).

% times_integer_code(2)
tff(fact_4650_less__eq__integer__code_I1_J,axiom,
    aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ).

% less_eq_integer_code(1)
tff(fact_4651_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),K),zero_zero(code_integer)) = K ) ).

% plus_integer_code(1)
tff(fact_4652_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),zero_zero(code_integer)),L) = L ) ).

% plus_integer_code(2)
tff(fact_4653_sgn__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,code_integer,sgn_sgn(code_integer),K)
      = $ite(
          K = zero_zero(code_integer),
          zero_zero(code_integer),
          $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),aa(code_integer,code_integer,uminus_uminus(code_integer),one_one(code_integer)),one_one(code_integer)) ) ) ).

% sgn_integer_code
tff(fact_4654_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),zero_zero(code_integer)),L) = aa(code_integer,code_integer,uminus_uminus(code_integer),L) ) ).

% minus_integer_code(2)
tff(fact_4655_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),K),zero_zero(code_integer)) = K ) ).

% minus_integer_code(1)
tff(fact_4656_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: fun(nat,A),X2: nat] : ( case_nat(A,F1,F22,aa(nat,nat,suc,X2)) = aa(nat,A,F22,X2) ) ).

% old.nat.simps(5)
tff(fact_4657_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: fun(nat,A)] : ( case_nat(A,F1,F22,zero_zero(nat)) = F1 ) ).

% old.nat.simps(4)
tff(fact_4658_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( Nat != zero_zero(nat) )
    <=> case_nat($o,$false,aTP_Lamp_ir(nat,$o),Nat) ) ).

% nat.disc_eq_case(2)
tff(fact_4659_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat = zero_zero(nat) )
    <=> case_nat($o,$true,aTP_Lamp_is(nat,$o),Nat) ) ).

% nat.disc_eq_case(1)
tff(fact_4660_zero__natural_Orsp,axiom,
    zero_zero(nat) = zero_zero(nat) ).

% zero_natural.rsp
tff(fact_4661_zero__integer_Orsp,axiom,
    zero_zero(int) = zero_zero(int) ).

% zero_integer.rsp
tff(fact_4662_one__integer_Orsp,axiom,
    one_one(int) = one_one(int) ).

% one_integer.rsp
tff(fact_4663_one__natural_Orsp,axiom,
    one_one(nat) = one_one(nat) ).

% one_natural.rsp
tff(fact_4664_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),Na)
    <=> case_nat($o,$false,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% less_eq_nat.simps(2)
tff(fact_4665_max__Suc1,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,Na)),M) = case_nat(nat,aa(nat,nat,suc,Na),aTP_Lamp_it(nat,fun(nat,nat),Na),M) ) ).

% max_Suc1
tff(fact_4666_max__Suc2,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),aa(nat,nat,suc,Na)) = case_nat(nat,aa(nat,nat,suc,Na),aTP_Lamp_iu(nat,fun(nat,nat),Na),M) ) ).

% max_Suc2
tff(fact_4667_diff__Suc,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,Na)) = case_nat(nat,zero_zero(nat),aTP_Lamp_gf(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)) ) ).

% diff_Suc
tff(fact_4668_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,W))),Na)
        <=> case_nat($o,$false,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),Na) ) ) ).

% bit_numeral_rec(1)
tff(fact_4669_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [W: num,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,W))),Na)
        <=> case_nat($o,$true,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),W)),Na) ) ) ).

% bit_numeral_rec(2)
tff(fact_4670_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType,X: A,F2: fun(nat,A),Na: nat] :
      ( case_nat(A,X,F2,Na)
      = $ite(Na = zero_zero(nat),X,aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))) ) ).

% Nitpick.case_nat_unfold
tff(fact_4671_old_Orec__nat__def,axiom,
    ! [A: $tType,X4: A,Xa2: fun(nat,fun(A,A)),Xb2: nat] : ( aa(nat,A,rec_nat(A,X4,Xa2),Xb2) = the(A,rec_set_nat(A,X4,Xa2,Xb2)) ) ).

% old.rec_nat_def
tff(fact_4672_integer__of__int__code,axiom,
    ! [K: int] :
      ( code_integer_of_int(K)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
          aa(code_integer,code_integer,uminus_uminus(code_integer),code_integer_of_int(aa(int,int,uminus_uminus(int),K))),
          $ite(
            K = zero_zero(int),
            zero_zero(code_integer),
            $let(
              l: code_integer,
              l := aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))),
              $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))) = zero_zero(int),l,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),l),one_one(code_integer))) ) ) ) ) ).

% integer_of_int_code
tff(fact_4673_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: fun(nat,A),F1: A,F22: fun(nat,fun(A,A))] :
      ( ( F2 = rec_nat(A,F1,F22) )
     => ( aa(nat,A,F2,zero_zero(nat)) = F1 ) ) ).

% rec_nat_0_imp
tff(fact_4674_divide__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),X)) ) ).

% divide_integer.abs_eq
tff(fact_4675_uminus__integer__code_I1_J,axiom,
    aa(code_integer,code_integer,uminus_uminus(code_integer),zero_zero(code_integer)) = zero_zero(code_integer) ).

% uminus_integer_code(1)
tff(fact_4676_zero__integer__def,axiom,
    zero_zero(code_integer) = code_integer_of_int(zero_zero(int)) ).

% zero_integer_def
tff(fact_4677_unset__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X: int] : ( aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se2638667681897837118et_bit(code_integer),Xa),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),Xa),X)) ) ).

% unset_bit_integer.abs_eq
tff(fact_4678_flip__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X: int] : ( aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se8732182000553998342ip_bit(code_integer),Xa),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(nat,fun(int,int),bit_se8732182000553998342ip_bit(int),Xa),X)) ) ).

% flip_bit_integer.abs_eq
tff(fact_4679_set__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X: int] : ( aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se5668285175392031749et_bit(code_integer),Xa),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),Xa),X)) ) ).

% set_bit_integer.abs_eq
tff(fact_4680_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa),X) ) ).

% less_integer.abs_eq
tff(fact_4681_abs__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,code_integer,abs_abs(code_integer),K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),aa(code_integer,code_integer,uminus_uminus(code_integer),K),K) ) ).

% abs_integer_code
tff(fact_4682_less__integer__code_I1_J,axiom,
    ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ).

% less_integer_code(1)
tff(fact_4683_one__integer__def,axiom,
    one_one(code_integer) = code_integer_of_int(one_one(int)) ).

% one_integer_def
tff(fact_4684_minus__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),X)) ) ).

% minus_integer.abs_eq
tff(fact_4685_floor__real__def,axiom,
    ! [X: real] : ( archim6421214686448440834_floor(real,X) = the(int,aTP_Lamp_iv(real,fun(int,$o),X)) ) ).

% floor_real_def
tff(fact_4686_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: fun(nat,A),F1: A,F22: fun(nat,fun(A,A)),Na: nat] :
      ( ( F2 = rec_nat(A,F1,F22) )
     => ( aa(nat,A,F2,aa(nat,nat,suc,Na)) = aa(A,A,aa(nat,fun(A,A),F22,Na),aa(nat,A,F2,Na)) ) ) ).

% rec_nat_Suc_imp
tff(fact_4687_Code__Numeral_Opositive__def,axiom,
    code_positive = numeral_numeral(code_integer) ).

% Code_Numeral.positive_def
tff(fact_4688_floor__rat__def,axiom,
    ! [X: rat] : ( archim6421214686448440834_floor(rat,X) = the(int,aTP_Lamp_iw(rat,fun(int,$o),X)) ) ).

% floor_rat_def
tff(fact_4689_integer__of__num_I3_J,axiom,
    ! [Na: num] :
      ( aa(num,code_integer,code_integer_of_num,aa(num,num,bit1,Na))
      = $let(
          k: code_integer,
          k := aa(num,code_integer,code_integer_of_num,Na),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k)),one_one(code_integer)) ) ) ).

% integer_of_num(3)
tff(fact_4690_less__eq__rat__def,axiom,
    ! [X: rat,Y: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),X),Y)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),X),Y)
        | ( X = Y ) ) ) ).

% less_eq_rat_def
tff(fact_4691_obtain__pos__sum,axiom,
    ! [R2: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R2)
     => ~ ! [S2: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),S2)
           => ! [T3: rat] :
                ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),T3)
               => ( R2 != aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),S2),T3) ) ) ) ) ).

% obtain_pos_sum
tff(fact_4692_sgn__rat__def,axiom,
    ! [A2: rat] :
      ( aa(rat,rat,sgn_sgn(rat),A2)
      = $ite(
          A2 = zero_zero(rat),
          zero_zero(rat),
          $ite(aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),A2),one_one(rat),aa(rat,rat,uminus_uminus(rat),one_one(rat))) ) ) ).

% sgn_rat_def
tff(fact_4693_abs__rat__def,axiom,
    ! [A2: rat] :
      ( aa(rat,rat,abs_abs(rat),A2)
      = $ite(aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),A2),zero_zero(rat)),aa(rat,rat,uminus_uminus(rat),A2),A2) ) ).

% abs_rat_def
tff(fact_4694_integer__of__num__def,axiom,
    code_integer_of_num = numeral_numeral(code_integer) ).

% integer_of_num_def
tff(fact_4695_integer__of__num__triv_I1_J,axiom,
    aa(num,code_integer,code_integer_of_num,one2) = one_one(code_integer) ).

% integer_of_num_triv(1)
tff(fact_4696_integer__of__num_I2_J,axiom,
    ! [Na: num] :
      ( aa(num,code_integer,code_integer_of_num,aa(num,num,bit0,Na))
      = $let(
          k: code_integer,
          k := aa(num,code_integer,code_integer_of_num,Na),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k) ) ) ).

% integer_of_num(2)
tff(fact_4697_integer__of__num__triv_I2_J,axiom,
    aa(num,code_integer,code_integer_of_num,aa(num,num,bit0,one2)) = aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)) ).

% integer_of_num_triv(2)
tff(fact_4698_rat__inverse__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_ix(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_inverse_code
tff(fact_4699_normalize__negative,axiom,
    ! [Q4: int,P3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Q4),zero_zero(int))
     => ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P3),Q4)) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),P3)),aa(int,int,uminus_uminus(int),Q4))) ) ) ).

% normalize_negative
tff(fact_4700_bit__cut__integer__def,axiom,
    ! [K: code_integer] : ( code_bit_cut_integer(K) = aa($o,product_prod(code_integer,$o),product_Pair(code_integer,$o,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),K),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),dvd_dvd(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),K)) ) ).

% bit_cut_integer_def
tff(fact_4701_quotient__of__number_I3_J,axiom,
    ! [K: num] : ( quotient_of(aa(num,rat,numeral_numeral(rat),K)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% quotient_of_number(3)
tff(fact_4702_normalize__denom__zero,axiom,
    ! [P3: int] : ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P3),zero_zero(int))) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ) ).

% normalize_denom_zero
tff(fact_4703_rat__one__code,axiom,
    quotient_of(one_one(rat)) = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int)) ).

% rat_one_code
tff(fact_4704_rat__zero__code,axiom,
    quotient_of(zero_zero(rat)) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ).

% rat_zero_code
tff(fact_4705_quotient__of__number_I5_J,axiom,
    ! [K: num] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K))) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% quotient_of_number(5)
tff(fact_4706_quotient__of__number_I4_J,axiom,
    quotient_of(aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),one_one(int))),one_one(int)) ).

% quotient_of_number(4)
tff(fact_4707_diff__rat__def,axiom,
    ! [Q4: rat,R2: rat] : ( aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),Q4),R2) = aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),Q4),aa(rat,rat,uminus_uminus(rat),R2)) ) ).

% diff_rat_def
tff(fact_4708_rat__minus__code,axiom,
    ! [P3: rat,Q4: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P3),Q4)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_iz(rat,fun(int,fun(int,product_prod(int,int))),Q4)),quotient_of(P3)) ) ).

% rat_minus_code
tff(fact_4709_quotient__of__denom__pos,axiom,
    ! [R2: rat,P3: int,Q4: int] :
      ( ( quotient_of(R2) = aa(int,product_prod(int,int),product_Pair(int,int,P3),Q4) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q4) ) ).

% quotient_of_denom_pos
tff(fact_4710_normalize__denom__pos,axiom,
    ! [R2: product_prod(int,int),P3: int,Q4: int] :
      ( ( normalize(R2) = aa(int,product_prod(int,int),product_Pair(int,int,P3),Q4) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q4) ) ).

% normalize_denom_pos
tff(fact_4711_normalize__crossproduct,axiom,
    ! [Q4: int,S: int,P3: int,R2: int] :
      ( ( Q4 != zero_zero(int) )
     => ( ( S != zero_zero(int) )
       => ( ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P3),Q4)) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,R2),S)) )
         => ( aa(int,int,aa(int,fun(int,int),times_times(int),P3),S) = aa(int,int,aa(int,fun(int,int),times_times(int),R2),Q4) ) ) ) ) ).

% normalize_crossproduct
tff(fact_4712_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( code_bit_cut_integer(K)
      = $ite(K = zero_zero(code_integer),aa($o,product_prod(code_integer,$o),product_Pair(code_integer,$o,zero_zero(code_integer)),$false),aa(product_prod(code_integer,code_integer),product_prod(code_integer,$o),product_case_prod(code_integer,code_integer,product_prod(code_integer,$o),aTP_Lamp_ja(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% bit_cut_integer_code
tff(fact_4713_quotient__of__int,axiom,
    ! [A2: int] : ( quotient_of(of_int(A2)) = aa(int,product_prod(int,int),product_Pair(int,int,A2),one_one(int)) ) ).

% quotient_of_int
tff(fact_4714_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o),F1: A,F22: fun(nat,A),Nat: nat] :
      ( aa(A,$o,P,case_nat(A,F1,F22,Nat))
    <=> ( ( ( Nat = zero_zero(nat) )
         => aa(A,$o,P,F1) )
        & ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
         => aa(A,$o,P,aa(nat,A,F22,pred(Nat))) ) ) ) ).

% nat.split_sels(1)
tff(fact_4715_divmod__abs__code_I6_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(zero_zero(code_integer),J2) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)) ) ).

% divmod_abs_code(6)
tff(fact_4716_divmod__abs__code_I5_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(J2,zero_zero(code_integer)) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),aa(code_integer,code_integer,abs_abs(code_integer),J2)) ) ).

% divmod_abs_code(5)
tff(fact_4717_pred__def,axiom,
    ! [Nat: nat] : ( pred(Nat) = case_nat(nat,zero_zero(nat),aTP_Lamp_gf(nat,nat),Nat) ) ).

% pred_def
tff(fact_4718_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),F1: A,F22: fun(nat,A),Nat: nat] :
      ( aa(A,$o,P,case_nat(A,F1,F22,Nat))
    <=> ~ ( ( ( Nat = zero_zero(nat) )
            & ~ aa(A,$o,P,F1) )
          | ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
            & ~ aa(A,$o,P,aa(nat,A,F22,pred(Nat))) ) ) ) ).

% nat.split_sels(2)
tff(fact_4719_Frct__code__post_I5_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),aa(num,int,numeral_numeral(int),K))) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),one_one(rat)),aa(num,rat,numeral_numeral(rat),K)) ) ).

% Frct_code_post(5)
tff(fact_4720_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),L),
            $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),K),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_jb(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L))),
            $ite(
              L = zero_zero(code_integer),
              aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),K),
              aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_jc(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ).

% divmod_integer_code
tff(fact_4721_bezw__0,axiom,
    ! [X: nat] : ( bezw(X,zero_zero(nat)) = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)) ) ).

% bezw_0
tff(fact_4722_Frct__code__post_I2_J,axiom,
    ! [A2: int] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,A2),zero_zero(int))) = zero_zero(rat) ) ).

% Frct_code_post(2)
tff(fact_4723_Frct__code__post_I1_J,axiom,
    ! [A2: int] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),A2)) = zero_zero(rat) ) ).

% Frct_code_post(1)
tff(fact_4724_Frct__code__post_I3_J,axiom,
    frct(aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))) = one_one(rat) ).

% Frct_code_post(3)
tff(fact_4725_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),aa(num,int,numeral_numeral(int),L))) = aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),aa(num,rat,numeral_numeral(rat),K)),aa(num,rat,numeral_numeral(rat),L)) ) ).

% Frct_code_post(6)
tff(fact_4726_Frct__code__post_I4_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),one_one(int))) = aa(num,rat,numeral_numeral(rat),K) ) ).

% Frct_code_post(4)
tff(fact_4727_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: fun(nat,A),D2: fun(nat,A),A3: set(nat)] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_jd(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A3)
          = $ite(
              ( aa(set(nat),$o,finite_finite(nat),A3)
              & member(nat,zero_zero(nat),A3) ),
              aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,C2,zero_zero(nat))),aa(nat,A,D2,zero_zero(nat))),
              zero_zero(A) ) ) ) ).

% sum_zero_power'
tff(fact_4728_Suc__0__div__numeral,axiom,
    ! [K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_fst(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_div_numeral
tff(fact_4729_Suc__0__mod__numeral,axiom,
    ! [K: num] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_snd(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_mod_numeral
tff(fact_4730_sum_Oinfinite,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = zero_zero(B) ) ) ) ).

% sum.infinite
tff(fact_4731_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [F3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),F3)
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),F3) = zero_zero(B) )
          <=> ! [X5: A] :
                ( member(A,X5,F3)
               => ( aa(A,B,F2,X5) = zero_zero(B) ) ) ) ) ) ).

% sum_eq_0_iff
tff(fact_4732_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( semidom(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3) = zero_zero(B) )
          <=> ? [X5: A] :
                ( member(A,X5,A3)
                & ( aa(A,B,F2,X5) = zero_zero(B) ) ) ) ) ) ).

% prod_zero_iff
tff(fact_4733_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(set(A),$o,finite_finite(A),set_or1337092689740270186AtMost(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Icc_iff
tff(fact_4734_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(set(A),$o,finite_finite(A),set_or7035219750837199246ssThan(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Ico_iff
tff(fact_4735_prod_Oinfinite,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = one_one(B) ) ) ) ).

% prod.infinite
tff(fact_4736_dvd__prodI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: set(A),A2: A,F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ) ).

% dvd_prodI
tff(fact_4737_dvd__prod__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: set(A),A2: A,B2: B,F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => ( ( B2 = aa(A,B,F2,A2) )
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),B2),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ) ) ).

% dvd_prod_eqI
tff(fact_4738_sum_Odelta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_je(A,fun(fun(A,B),fun(A,B)),A2),B2)),S3)
            = $ite(member(A,A2,S3),aa(A,B,B2,A2),zero_zero(B)) ) ) ) ).

% sum.delta
tff(fact_4739_sum_Odelta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_jf(A,fun(fun(A,B),fun(A,B)),A2),B2)),S3)
            = $ite(member(A,A2,S3),aa(A,B,B2,A2),zero_zero(B)) ) ) ) ).

% sum.delta'
tff(fact_4740_prod__eq__1__iff,axiom,
    ! [A: $tType,A3: set(A),F2: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7121269368397514597t_prod(A,nat),F2),A3) = one_one(nat) )
      <=> ! [X5: A] :
            ( member(A,X5,A3)
           => ( aa(A,nat,F2,X5) = one_one(nat) ) ) ) ) ).

% prod_eq_1_iff
tff(fact_4741_prod_Odelta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_jg(A,fun(fun(A,B),fun(A,B)),A2),B2)),S3)
            = $ite(member(A,A2,S3),aa(A,B,B2,A2),one_one(B)) ) ) ) ).

% prod.delta
tff(fact_4742_prod_Odelta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_jh(A,fun(fun(A,B),fun(A,B)),A2),B2)),S3)
            = $ite(member(A,A2,S3),aa(A,B,B2,A2),one_one(B)) ) ) ) ).

% prod.delta'
tff(fact_4743_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,$o),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),collect(nat,P))
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ji(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),P),F2)) ) ) ).

% summable_If_finite
tff(fact_4744_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A3: set(nat),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),A3)
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_jj(set(nat),fun(fun(nat,A),fun(nat,A)),A3),F2)) ) ) ).

% summable_If_finite_set
tff(fact_4745_set__encode__inverse,axiom,
    ! [A3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( nat_set_decode(aa(set(nat),nat,nat_set_encode,A3)) = A3 ) ) ).

% set_encode_inverse
tff(fact_4746_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [K: num,L: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,K,L)) ) ) ).

% numeral_div_numeral
tff(fact_4747_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [K: num,L: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),K),aa(num,A,numeral_numeral(A),L)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,K,L)) ) ) ).

% numeral_mod_numeral
tff(fact_4748_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set(A),F2: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7121269368397514597t_prod(A,nat),F2),A3))
      <=> ! [X5: A] :
            ( member(A,X5,A3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,F2,X5)) ) ) ) ).

% prod_pos_nat_iff
tff(fact_4749_fst__divmod__nat,axiom,
    ! [M: nat,Na: nat] : ( aa(product_prod(nat,nat),nat,product_fst(nat,nat),divmod_nat(M,Na)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na) ) ).

% fst_divmod_nat
tff(fact_4750_snd__divmod__nat,axiom,
    ! [M: nat,Na: nat] : ( aa(product_prod(nat,nat),nat,product_snd(nat,nat),divmod_nat(M,Na)) = modulo_modulo(nat,M,Na) ) ).

% snd_divmod_nat
tff(fact_4751_one__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(num,A,numeral_numeral(A),Na)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,one2,Na)) ) ) ).

% one_div_numeral
tff(fact_4752_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Na: num] : ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),Na)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,one2,Na)) ) ) ).

% one_mod_numeral
tff(fact_4753_sum__zero__power,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: fun(nat,A),A3: set(nat)] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jk(fun(nat,A),fun(nat,A),C2)),A3)
          = $ite(
              ( aa(set(nat),$o,finite_finite(nat),A3)
              & member(nat,zero_zero(nat),A3) ),
              aa(nat,A,C2,zero_zero(nat)),
              zero_zero(A) ) ) ) ).

% sum_zero_power
tff(fact_4754_set__encode__eq,axiom,
    ! [A3: set(nat),B3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( aa(set(nat),$o,finite_finite(nat),B3)
       => ( ( aa(set(nat),nat,nat_set_encode,A3) = aa(set(nat),nat,nat_set_encode,B3) )
        <=> ( A3 = B3 ) ) ) ) ).

% set_encode_eq
tff(fact_4755_finite__set__decode,axiom,
    ! [Na: nat] : aa(set(nat),$o,finite_finite(nat),nat_set_decode(Na)) ).

% finite_set_decode
tff(fact_4756_bounded__nat__set__is__finite,axiom,
    ! [N3: set(nat),Na: nat] :
      ( ! [X3: nat] :
          ( member(nat,X3,N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),Na) )
     => aa(set(nat),$o,finite_finite(nat),N3) ) ).

% bounded_nat_set_is_finite
tff(fact_4757_finite__nat__set__iff__bounded,axiom,
    ! [N3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),N3)
    <=> ? [M3: nat] :
        ! [X5: nat] :
          ( member(nat,X5,N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X5),M3) ) ) ).

% finite_nat_set_iff_bounded
tff(fact_4758_finite__M__bounded__by__nat,axiom,
    ! [P: fun(nat,$o),I2: nat] : aa(set(nat),$o,finite_finite(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_jl(fun(nat,$o),fun(nat,fun(nat,$o)),P),I2))) ).

% finite_M_bounded_by_nat
tff(fact_4759_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),Na: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(list(A)),$o,finite_finite(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_jm(set(A),fun(nat,fun(list(A),$o)),A3),Na))) ) ).

% finite_lists_length_eq
tff(fact_4760_prod__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ? [X4: A] :
                ( member(A,X4,A3)
                & ( aa(A,B,F2,X4) = zero_zero(B) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3) = zero_zero(B) ) ) ) ) ).

% prod_zero
tff(fact_4761_infinite__Icc,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(set(A),$o,finite_finite(A),set_or1337092689740270186AtMost(A,A2,B2)) ) ) ).

% infinite_Icc
tff(fact_4762_infinite__Ico,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(set(A),$o,finite_finite(A),set_or7035219750837199246ssThan(A,A2,B2)) ) ) ).

% infinite_Ico
tff(fact_4763_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),Na: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(list(A)),$o,finite_finite(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_jn(set(A),fun(nat,fun(list(A),$o)),A3),Na))) ) ).

% finite_lists_length_le
tff(fact_4764_summable__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N3: set(nat),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),N3)
         => ( ! [N: nat] :
                ( ~ member(nat,N,N3)
               => ( aa(nat,A,F2,N) = zero_zero(A) ) )
           => summable(A,F2) ) ) ) ).

% summable_finite
tff(fact_4765_sum_Ofinite__Collect__op,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),X: fun(A,B),Y: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jo(set(A),fun(fun(A,B),fun(A,$o)),I5),X)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jo(set(A),fun(fun(A,B),fun(A,$o)),I5),Y)))
           => aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_jp(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),I5),X),Y))) ) ) ) ).

% sum.finite_Collect_op
tff(fact_4766_prod_Ofinite__Collect__op,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),X: fun(A,B),Y: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jq(set(A),fun(fun(A,B),fun(A,$o)),I5),X)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jq(set(A),fun(fun(A,B),fun(A,$o)),I5),Y)))
           => aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_jr(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),I5),X),Y))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_4767_sum_Ointer__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),P: fun(A,$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_js(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_jt(fun(A,B),fun(fun(A,$o),fun(A,B)),G),P)),A3) ) ) ) ).

% sum.inter_filter
tff(fact_4768_set__encode__inf,axiom,
    ! [A3: set(nat)] :
      ( ~ aa(set(nat),$o,finite_finite(nat),A3)
     => ( aa(set(nat),nat,nat_set_encode,A3) = zero_zero(nat) ) ) ).

% set_encode_inf
tff(fact_4769_prod_Ointer__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),P: fun(A,$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_js(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_ju(fun(A,B),fun(fun(A,$o),fun(A,B)),G),P)),A3) ) ) ) ).

% prod.inter_filter
tff(fact_4770_divides__aux__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Qr: product_prod(A,A)] :
          ( unique5940410009612947441es_aux(A,Qr)
        <=> ( aa(product_prod(A,A),A,product_snd(A,A),Qr) = zero_zero(A) ) ) ) ).

% divides_aux_def
tff(fact_4771_fst__divmod,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] : ( aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,M,Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% fst_divmod
tff(fact_4772_snd__divmod,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Na: num] : ( aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,M,Na)) = modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% snd_divmod
tff(fact_4773_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X3: A] :
                ( member(A,X3,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X3)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3) = zero_zero(B) )
            <=> ! [X5: A] :
                  ( member(A,X5,A3)
                 => ( aa(A,B,F2,X5) = zero_zero(B) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
tff(fact_4774_sum__le__included,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [S: set(A),T2: set(B),G: fun(B,C),I2: fun(B,A),F2: fun(A,C)] :
          ( aa(set(A),$o,finite_finite(A),S)
         => ( aa(set(B),$o,finite_finite(B),T2)
           => ( ! [X3: B] :
                  ( member(B,X3,T2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,G,X3)) )
             => ( ! [X3: A] :
                    ( member(A,X3,S)
                   => ? [Xa2: B] :
                        ( member(B,Xa2,T2)
                        & ( aa(B,A,I2,Xa2) = X3 )
                        & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F2,X3)),aa(B,C,G,Xa2)) ) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),F2),S)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T2)) ) ) ) ) ) ).

% sum_le_included
tff(fact_4775_sum__strict__mono__ex1,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X3: A] :
                ( member(A,X3,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,G,X3)) )
           => ( ? [X4: A] :
                  ( member(A,X4,A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X4)),aa(A,B,G,X4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum_strict_mono_ex1
tff(fact_4776_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [R3: fun(A,fun(A,$o)),S3: set(B),H: fun(B,A),G: fun(B,A)] :
          ( aa(A,$o,aa(A,fun(A,$o),R3,zero_zero(A)),zero_zero(A))
         => ( ! [X1: A,Y1: A,X22: A,Y23: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),R3,X1),X22)
                  & aa(A,$o,aa(A,fun(A,$o),R3,Y1),Y23) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X22),Y23)) )
           => ( aa(set(B),$o,finite_finite(B),S3)
             => ( ! [X3: B] :
                    ( member(B,X3,S3)
                   => aa(A,$o,aa(A,fun(A,$o),R3,aa(B,A,H,X3)),aa(B,A,G,X3)) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),S3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S3)) ) ) ) ) ) ).

% sum.related
tff(fact_4777_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [R3: fun(A,fun(A,$o)),S3: set(B),H: fun(B,A),G: fun(B,A)] :
          ( aa(A,$o,aa(A,fun(A,$o),R3,one_one(A)),one_one(A))
         => ( ! [X1: A,Y1: A,X22: A,Y23: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),R3,X1),X22)
                  & aa(A,$o,aa(A,fun(A,$o),R3,Y1),Y23) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(A,A,aa(A,fun(A,A),times_times(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),times_times(A),X22),Y23)) )
           => ( aa(set(B),$o,finite_finite(B),S3)
             => ( ! [X3: B] :
                    ( member(B,X3,S3)
                   => aa(A,$o,aa(A,fun(A,$o),R3,aa(B,A,H,X3)),aa(B,A,G,X3)) )
               => aa(A,$o,aa(A,fun(A,$o),R3,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H),S3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S3)) ) ) ) ) ) ).

% prod.related
tff(fact_4778_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S4: set(A),T4: set(B),S3: set(A),I2: fun(B,A),J2: fun(A,B),T5: set(B),G: fun(A,C),H: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S4)
         => ( aa(set(B),$o,finite_finite(B),T4)
           => ( ! [A4: A] :
                  ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4))
                 => ( aa(B,A,I2,aa(A,B,J2,A4)) = A4 ) )
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4))
                   => member(B,aa(A,B,J2,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4)) )
               => ( ! [B4: B] :
                      ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4))
                     => ( aa(A,B,J2,aa(B,A,I2,B4)) = B4 ) )
                 => ( ! [B4: B] :
                        ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4))
                       => member(A,aa(B,A,I2,B4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4)) )
                   => ( ! [A4: A] :
                          ( member(A,A4,S4)
                         => ( aa(A,C,G,A4) = zero_zero(C) ) )
                     => ( ! [B4: B] :
                            ( member(B,B4,T4)
                           => ( aa(B,C,H,B4) = zero_zero(C) ) )
                       => ( ! [A4: A] :
                              ( member(A,A4,S3)
                             => ( aa(B,C,H,aa(A,B,J2,A4)) = aa(A,C,G,A4) ) )
                         => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),G),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H),T5) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
tff(fact_4779_prod__dvd__prod__subset2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [B3: set(A),A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F2,A4)),aa(A,B,G,A4)) )
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ).

% prod_dvd_prod_subset2
tff(fact_4780_prod__dvd__prod__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B3: set(A),A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),B3)) ) ) ) ).

% prod_dvd_prod_subset
tff(fact_4781_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S4: set(A),T4: set(B),S3: set(A),I2: fun(B,A),J2: fun(A,B),T5: set(B),G: fun(A,C),H: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S4)
         => ( aa(set(B),$o,finite_finite(B),T4)
           => ( ! [A4: A] :
                  ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4))
                 => ( aa(B,A,I2,aa(A,B,J2,A4)) = A4 ) )
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4))
                   => member(B,aa(A,B,J2,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4)) )
               => ( ! [B4: B] :
                      ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4))
                     => ( aa(A,B,J2,aa(B,A,I2,B4)) = B4 ) )
                 => ( ! [B4: B] :
                        ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4))
                       => member(A,aa(B,A,I2,B4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4)) )
                   => ( ! [A4: A] :
                          ( member(A,A4,S4)
                         => ( aa(A,C,G,A4) = one_one(C) ) )
                     => ( ! [B4: B] :
                            ( member(B,B4,T4)
                           => ( aa(B,C,H,B4) = one_one(C) ) )
                       => ( ! [A4: A] :
                              ( member(A,A4,S3)
                             => ( aa(B,C,H,aa(A,B,J2,A4)) = aa(A,C,G,A4) ) )
                         => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),G),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H),T5) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
tff(fact_4782_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set(A),F2: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3) = aa(nat,nat,suc,zero_zero(nat)) )
      <=> ? [X5: A] :
            ( member(A,X5,A3)
            & ( aa(A,nat,F2,X5) = aa(nat,nat,suc,zero_zero(nat)) )
            & ! [Xa4: A] :
                ( member(A,Xa4,A3)
               => ( ( X5 != Xa4 )
                 => ( aa(A,nat,F2,Xa4) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
tff(fact_4783_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set(A),F2: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3) = one_one(nat) )
      <=> ? [X5: A] :
            ( member(A,X5,A3)
            & ( aa(A,nat,F2,X5) = one_one(nat) )
            & ! [Xa4: A] :
                ( member(A,Xa4,A3)
               => ( ( X5 != Xa4 )
                 => ( aa(A,nat,F2,Xa4) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_1_iff
tff(fact_4784_sum__nonneg__leq__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [S: set(A),F2: fun(A,B),B3: B,I2: A] :
          ( aa(set(A),$o,finite_finite(A),S)
         => ( ! [I3: A] :
                ( member(A,I3,S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,I3)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),S) = B3 )
             => ( member(A,I2,S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,I2)),B3) ) ) ) ) ) ).

% sum_nonneg_leq_bound
tff(fact_4785_sum__nonneg__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [S: set(A),F2: fun(A,B),I2: A] :
          ( aa(set(A),$o,finite_finite(A),S)
         => ( ! [I3: A] :
                ( member(A,I3,S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,I3)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),S) = zero_zero(B) )
             => ( member(A,I2,S)
               => ( aa(A,B,F2,I2) = zero_zero(B) ) ) ) ) ) ) ).

% sum_nonneg_0
tff(fact_4786_sum_Osetdiff__irrelevant,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),collect(A,aTP_Lamp_jv(fun(A,B),fun(A,$o),G)))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) ) ) ) ).

% sum.setdiff_irrelevant
tff(fact_4787_prod_Osetdiff__irrelevant,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),collect(A,aTP_Lamp_jw(fun(A,B),fun(A,$o),G)))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_4788_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => aa(set(nat),$o,finite_finite(nat),collect(nat,aTP_Lamp_jx(nat,fun(nat,$o),M))) ) ).

% finite_divisors_nat
tff(fact_4789_sums__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N3: set(nat),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),N3)
         => ( ! [N: nat] :
                ( ~ member(nat,N,N3)
               => ( aa(nat,A,F2,N) = zero_zero(A) ) )
           => sums(A,F2,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),N3)) ) ) ) ).

% sums_finite
tff(fact_4790_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,$o),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),collect(nat,P))
         => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ji(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),P),F2),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),collect(nat,P))) ) ) ).

% sums_If_finite
tff(fact_4791_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A3: set(nat),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),A3)
         => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_jj(set(nat),fun(fun(nat,A),fun(nat,A)),A3),F2),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),A3)) ) ) ).

% sums_If_finite_set
tff(fact_4792_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [N3: set(nat),F2: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),N3)
         => ( ! [N: nat] :
                ( ~ member(nat,N,N3)
               => ( aa(nat,A,F2,N) = zero_zero(A) ) )
           => ( suminf(A,F2) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),N3) ) ) ) ) ).

% suminf_finite
tff(fact_4793_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N3: set(nat),Na: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N3),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))
     => aa(set(nat),$o,finite_finite(nat),N3) ) ).

% subset_eq_atLeast0_atMost_finite
tff(fact_4794_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N3: set(nat),Na: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N3),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))
     => aa(set(nat),$o,finite_finite(nat),N3) ) ).

% subset_eq_atLeast0_lessThan_finite
tff(fact_4795_sum__pos2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),I2: A,F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( member(A,I2,I5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F2,I2))
             => ( ! [I3: A] :
                    ( member(A,I3,I5)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,I3)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),I5)) ) ) ) ) ) ).

% sum_pos2
tff(fact_4796_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),I2: A,F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( member(A,I2,I5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(A,B,F2,I2))
             => ( ! [I3: A] :
                    ( member(A,I3,I5)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F2,I3)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),I5)) ) ) ) ) ) ).

% less_1_prod2
tff(fact_4797_sum_Omono__neutral__cong__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,G,X3) = zero_zero(B) ) )
             => ( ! [X3: A] :
                    ( member(A,X3,S3)
                   => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),S3) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
tff(fact_4798_sum_Omono__neutral__cong__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S3: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,H,X3) = zero_zero(B) ) )
             => ( ! [X3: A] :
                    ( member(A,X3,S3)
                   => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),T5) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
tff(fact_4799_sum_Omono__neutral__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,G,X3) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) ) ) ) ) ) ).

% sum.mono_neutral_right
tff(fact_4800_sum_Omono__neutral__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,G,X3) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T5) ) ) ) ) ) ).

% sum.mono_neutral_left
tff(fact_4801_sum_Osame__carrierI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [C6: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3))
                   => ( aa(A,B,G,A4) = zero_zero(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),B3))
                     => ( aa(A,B,H,B4) = zero_zero(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),C6) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),C6) )
                   => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),B3) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
tff(fact_4802_sum_Osame__carrier,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [C6: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3))
                   => ( aa(A,B,G,A4) = zero_zero(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),B3))
                     => ( aa(A,B,H,B4) = zero_zero(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),B3) )
                  <=> ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),C6) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),C6) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
tff(fact_4803_sum_Osubset__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [B3: set(A),A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ).

% sum.subset_diff
tff(fact_4804_sum__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),B3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),B3)) ) ) ) ) ).

% sum_diff
tff(fact_4805_prod_Osubset__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B3: set(A),A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ).

% prod.subset_diff
tff(fact_4806_prod_Osame__carrier,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [C6: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3))
                   => ( aa(A,B,G,A4) = one_one(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),B3))
                     => ( aa(A,B,H,B4) = one_one(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),B3) )
                  <=> ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),C6) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),C6) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_4807_prod_Osame__carrierI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [C6: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C6)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),A3))
                   => ( aa(A,B,G,A4) = one_one(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C6),B3))
                     => ( aa(A,B,H,B4) = one_one(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),C6) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),C6) )
                   => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),B3) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_4808_prod_Omono__neutral__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,G,X3) = one_one(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),T5) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_4809_prod_Omono__neutral__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,G,X3) = one_one(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S3) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_4810_prod_Omono__neutral__cong__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S3: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,H,X3) = one_one(B) ) )
             => ( ! [X3: A] :
                    ( member(A,X3,S3)
                   => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),T5) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_4811_prod_Omono__neutral__cong__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,G,X3) = one_one(B) ) )
             => ( ! [X3: A] :
                    ( member(A,X3,S3)
                   => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),S3) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_4812_sum__diff__nat,axiom,
    ! [A: $tType,B3: set(A),A3: set(A),F2: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),B3)) ) ) ) ).

% sum_diff_nat
tff(fact_4813_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Na)
         => aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_jy(nat,fun(A,$o),Na))) ) ) ).

% finite_roots_unity
tff(fact_4814_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S4: set(A),T4: set(B),H: fun(A,B),S3: set(A),T5: set(B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S4)
         => ( aa(set(B),$o,finite_finite(B),T4)
           => ( bij_betw(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4))
             => ( ! [A4: A] :
                    ( member(A,A4,S4)
                   => ( aa(B,C,G,aa(A,B,H,A4)) = zero_zero(C) ) )
               => ( ! [B4: B] :
                      ( member(B,B4,T4)
                     => ( aa(B,C,G,B4) = zero_zero(C) ) )
                 => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_jz(fun(A,B),fun(fun(B,C),fun(A,C)),H),G)),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T5) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
tff(fact_4815_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,A),S3: A,A3: set(nat),S4: A,F2: fun(nat,A)] :
          ( sums(A,G,S3)
         => ( aa(set(nat),$o,finite_finite(nat),A3)
           => ( ( S4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),S3),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_ka(fun(nat,A),fun(fun(nat,A),fun(nat,A)),G),F2)),A3)) )
             => sums(A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_kb(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),G),A3),F2),S4) ) ) ) ) ).

% sums_If_finite_set'
tff(fact_4816_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S4: set(A),T4: set(B),H: fun(A,B),S3: set(A),T5: set(B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S4)
         => ( aa(set(B),$o,finite_finite(B),T4)
           => ( bij_betw(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),S4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T4))
             => ( ! [A4: A] :
                    ( member(A,A4,S4)
                   => ( aa(B,C,G,aa(A,B,H,A4)) = one_one(C) ) )
               => ( ! [B4: B] :
                      ( member(B,B4,T4)
                     => ( aa(B,C,G,B4) = one_one(C) ) )
                 => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_kc(fun(A,B),fun(fun(B,C),fun(A,C)),H),G)),S3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),T5) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_4817_ln__prod,axiom,
    ! [A: $tType,I5: set(A),F2: fun(A,real)] :
      ( aa(set(A),$o,finite_finite(A),I5)
     => ( ! [I3: A] :
            ( member(A,I3,I5)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F2,I3)) )
       => ( aa(real,real,ln_ln(real),aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7121269368397514597t_prod(A,real),F2),I5)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_kd(fun(A,real),fun(A,real),F2)),I5) ) ) ) ).

% ln_prod
tff(fact_4818_sum__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [B3: set(A),A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [B4: A] :
                  ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,B4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),B3)) ) ) ) ) ).

% sum_mono2
tff(fact_4819_even__prod__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_parity(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3))
          <=> ? [X5: A] :
                ( member(A,X5,A3)
                & aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(A,B,F2,X5)) ) ) ) ) ).

% even_prod_iff
tff(fact_4820_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A),I5: set(nat)] :
          ( summable(A,F2)
         => ( aa(set(nat),$o,finite_finite(nat),I5)
           => ( ! [N: nat] :
                  ( member(nat,N,aa(set(nat),set(nat),uminus_uminus(set(nat)),I5))
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F2,N)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),I5)),suminf(A,F2)) ) ) ) ) ).

% sum_le_suminf
tff(fact_4821_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [B3: set(A),A3: set(A),B2: A,F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( member(A,B2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F2,B2))
               => ( ! [X3: A] :
                      ( member(A,X3,B3)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X3)) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),B3)) ) ) ) ) ) ) ).

% sum_strict_mono2
tff(fact_4822_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [B3: set(A),A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [B4: A] :
                  ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F2,B4)) )
             => ( ! [A4: A] :
                    ( member(A,A4,A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,A4)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),B3)) ) ) ) ) ) ).

% prod_mono2
tff(fact_4823_even__set__encode__iff,axiom,
    ! [A3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(nat),nat,nat_set_encode,A3))
      <=> ~ member(nat,zero_zero(nat),A3) ) ) ).

% even_set_encode_iff
tff(fact_4824_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,Na: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
           => aa(set(A),$o,finite_finite(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_ke(fun(nat,A),fun(nat,fun(A,$o)),C2),Na))) ) ) ) ).

% polyfun_roots_finite
tff(fact_4825_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),Na: nat] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_ke(fun(nat,A),fun(nat,fun(A,$o)),C2),Na)))
        <=> ? [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),Na)
              & ( aa(nat,A,C2,I) != zero_zero(A) ) ) ) ) ).

% polyfun_finite_roots
tff(fact_4826_finite__Collect__less__nat,axiom,
    ! [K: nat] : aa(set(nat),$o,finite_finite(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),K))) ).

% finite_Collect_less_nat
tff(fact_4827_finite__Diff2,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
      <=> aa(set(A),$o,finite_finite(A),A3) ) ) ).

% finite_Diff2
tff(fact_4828_finite__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% finite_Diff
tff(fact_4829_finite__interval__int1,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_kf(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int1
tff(fact_4830_finite__interval__int4,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_kg(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int4
tff(fact_4831_finite__interval__int2,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_kh(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int2
tff(fact_4832_finite__interval__int3,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_ki(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int3
tff(fact_4833_finite__nth__roots,axiom,
    ! [Na: nat,C2: complex] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => aa(set(complex),$o,finite_finite(complex),collect(complex,aa(complex,fun(complex,$o),aTP_Lamp_fa(nat,fun(complex,fun(complex,$o)),Na),C2))) ) ).

% finite_nth_roots
tff(fact_4834_finite__maxlen,axiom,
    ! [A: $tType,M10: set(list(A))] :
      ( aa(set(list(A)),$o,finite_finite(list(A)),M10)
     => ? [N: nat] :
        ! [X4: list(A)] :
          ( member(list(A),X4,M10)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),X4)),N) ) ) ).

% finite_maxlen
tff(fact_4835_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : aa(set(int),$o,finite_finite(int),set_or7035219750837199246ssThan(int,zero_zero(int),U)) ).

% finite_atLeastZeroLessThan_int
tff(fact_4836_finite__divisors__int,axiom,
    ! [I2: int] :
      ( ( I2 != zero_zero(int) )
     => aa(set(int),$o,finite_finite(int),collect(int,aTP_Lamp_kj(int,fun(int,$o),I2))) ) ).

% finite_divisors_int
tff(fact_4837_quotient__of__denom__pos_H,axiom,
    ! [R2: rat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),quotient_of(R2))) ).

% quotient_of_denom_pos'
tff(fact_4838_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Y)
     => ( bezw(X,Y) = aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),Y))))) ) ) ).

% bezw_non_0
tff(fact_4839_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(int,int)] :
      ( ( bezw(X,Xa) = Y )
     => ( Y
        = $ite(Xa = zero_zero(nat),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),Xa)))))) ) ) ).

% bezw.elims
tff(fact_4840_bezw_Osimps,axiom,
    ! [X: nat,Y: nat] :
      ( bezw(X,Y)
      = $ite(Y = zero_zero(nat),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),Y)))))) ) ).

% bezw.simps
tff(fact_4841_rat__sgn__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,sgn_sgn(rat),P3)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,sgn_sgn(int),aa(product_prod(int,int),int,product_fst(int,int),quotient_of(P3)))),one_one(int)) ) ).

% rat_sgn_code
tff(fact_4842_Diff__infinite__finite,axiom,
    ! [A: $tType,T5: set(A),S3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),T5)
     => ( ~ aa(set(A),$o,finite_finite(A),S3)
       => ~ aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),T5)) ) ) ).

% Diff_infinite_finite
tff(fact_4843_finite__psubset__induct,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ! [A7: set(A)] :
            ( aa(set(A),$o,finite_finite(A),A7)
           => ( ! [B9: set(A)] :
                  ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B9),A7)
                 => aa(set(A),$o,P,B9) )
             => aa(set(A),$o,P,A7) ) )
       => aa(set(A),$o,P,A3) ) ) ).

% finite_psubset_induct
tff(fact_4844_minus__one__mod__numeral,axiom,
    ! [Na: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(num,int,numeral_numeral(int),Na)) = adjust_mod(aa(num,int,numeral_numeral(int),Na),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,Na))) ) ).

% minus_one_mod_numeral
tff(fact_4845_one__mod__minus__numeral,axiom,
    ! [Na: num] : ( modulo_modulo(int,one_one(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),Na),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,Na)))) ) ).

% one_mod_minus_numeral
tff(fact_4846_minus__numeral__mod__numeral,axiom,
    ! [M: num,Na: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),Na)) = adjust_mod(aa(num,int,numeral_numeral(int),Na),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,M,Na))) ) ).

% minus_numeral_mod_numeral
tff(fact_4847_numeral__mod__minus__numeral,axiom,
    ! [M: num,Na: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),Na),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,M,Na)))) ) ).

% numeral_mod_minus_numeral
tff(fact_4848_Divides_Oadjust__mod__def,axiom,
    ! [L: int,R2: int] :
      ( adjust_mod(L,R2)
      = $ite(R2 = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),R2)) ) ).

% Divides.adjust_mod_def
tff(fact_4849_size__prod__simp,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,nat),G: fun(B,nat),P3: product_prod(A,B)] : ( basic_BNF_size_prod(A,B,F2,G,P3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F2,aa(product_prod(A,B),A,product_fst(A,B),P3))),aa(B,nat,G,aa(product_prod(A,B),B,product_snd(A,B),P3)))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% size_prod_simp
tff(fact_4850_in__set__enumerate__eq,axiom,
    ! [A: $tType,P3: product_prod(nat,A),Na: nat,Xs: list(A)] :
      ( member(product_prod(nat,A),P3,aa(list(product_prod(nat,A)),set(product_prod(nat,A)),set2(product_prod(nat,A)),enumerate(A,Na,Xs)))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(product_prod(nat,A),nat,product_fst(nat,A),P3))
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P3)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na))
        & ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P3)),Na)) = aa(product_prod(nat,A),A,product_snd(nat,A),P3) ) ) ) ).

% in_set_enumerate_eq
tff(fact_4851_infinite__int__iff__unbounded,axiom,
    ! [S3: set(int)] :
      ( ~ aa(set(int),$o,finite_finite(int),S3)
    <=> ! [M3: int] :
        ? [N4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),M3),aa(int,int,abs_abs(int),N4))
          & member(int,N4,S3) ) ) ).

% infinite_int_iff_unbounded
tff(fact_4852_length__enumerate,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(product_prod(nat,A)),nat,size_size(list(product_prod(nat,A))),enumerate(A,Na,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_enumerate
tff(fact_4853_unbounded__k__infinite,axiom,
    ! [K: nat,S3: set(nat)] :
      ( ! [M4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),M4)
         => ? [N6: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N6)
              & member(nat,N6,S3) ) )
     => ~ aa(set(nat),$o,finite_finite(nat),S3) ) ).

% unbounded_k_infinite
tff(fact_4854_infinite__nat__iff__unbounded,axiom,
    ! [S3: set(nat)] :
      ( ~ aa(set(nat),$o,finite_finite(nat),S3)
    <=> ! [M3: nat] :
        ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N4)
          & member(nat,N4,S3) ) ) ).

% infinite_nat_iff_unbounded
tff(fact_4855_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list(A),Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,product_prod(nat,A),nth(product_prod(nat,A),enumerate(A,Na,Xs)),M) = aa(A,product_prod(nat,A),product_Pair(nat,A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M)),aa(nat,A,nth(A,Xs),M)) ) ) ).

% nth_enumerate_eq
tff(fact_4856_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(int,int)] :
      ( ( bezw(X,Xa) = Y )
     => ( accp(product_prod(nat,nat),bezw_rel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Xa))
       => ~ ( ( Y
              = $ite(Xa = zero_zero(nat),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),Xa)))))) )
           => ~ accp(product_prod(nat,nat),bezw_rel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Xa)) ) ) ) ).

% bezw.pelims
tff(fact_4857_normalize__def,axiom,
    ! [P3: product_prod(int,int)] :
      ( normalize(P3)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P3)),
          $let(
            a2: int,
            a2 := aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3)),
            aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),a2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P3)),a2)) ),
          $ite(
            aa(product_prod(int,int),int,product_snd(int,int),P3) = zero_zero(int),
            aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),
            $let(
              a2: int,
              a2 := aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3))),
              aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),a2)),aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(product_prod(int,int),int,product_snd(int,int),P3)),a2)) ) ) ) ) ).

% normalize_def
tff(fact_4858_sum__count__set,axiom,
    ! [A: $tType,Xs: list(A),X7: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X7)
     => ( aa(set(A),$o,finite_finite(A),X7)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),count_list(A,Xs)),X7) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ) ).

% sum_count_set
tff(fact_4859_gcd__right__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_right_idem
tff(fact_4860_gcd__left__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_left_idem
tff(fact_4861_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% gcd_eq_0_iff
tff(fact_4862_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),one_one(A)),A2) = one_one(A) ) ) ).

% gcd.bottom_left_bottom
tff(fact_4863_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),one_one(A)) = one_one(A) ) ) ).

% gcd.bottom_right_bottom
tff(fact_4864_gcd__add2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,Na: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),aa(A,A,aa(A,fun(A,A),plus_plus(A),M),Na)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) ) ) ).

% gcd_add2
tff(fact_4865_gcd__add1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,Na: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),M),Na)),Na) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) ) ) ).

% gcd_add1
tff(fact_4866_gcd__neg2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_neg2
tff(fact_4867_gcd__neg1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_neg1
tff(fact_4868_gcd__exp,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A2: A,Na: nat,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),Na) ) ) ).

% gcd_exp
tff(fact_4869_gcd__dvd1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),A2) ) ).

% gcd_dvd1
tff(fact_4870_gcd__dvd2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),B2) ) ).

% gcd_dvd2
tff(fact_4871_gcd__greatest__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% gcd_greatest_iff
tff(fact_4872_gcd__1__int,axiom,
    ! [M: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),one_one(int)) = one_one(int) ) ).

% gcd_1_int
tff(fact_4873_gcd__neg1__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X)),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) ) ).

% gcd_neg1_int
tff(fact_4874_gcd__neg2__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),aa(int,int,uminus_uminus(int),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) ) ).

% gcd_neg2_int
tff(fact_4875_abs__gcd__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) ) ).

% abs_gcd_int
tff(fact_4876_gcd__abs1__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,abs_abs(int),X)),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) ) ).

% gcd_abs1_int
tff(fact_4877_gcd__abs2__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),aa(int,int,abs_abs(int),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) ) ).

% gcd_abs2_int
tff(fact_4878_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,Na: num] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% gcd_neg_numeral_2
tff(fact_4879_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [Na: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))),A2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(num,A,numeral_numeral(A),Na)),A2) ) ) ).

% gcd_neg_numeral_1
tff(fact_4880_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),one_one(A))
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) ) ) ) ).

% is_unit_gcd_iff
tff(fact_4881_gcd__pos__int,axiom,
    ! [M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),Na))
    <=> ( ( M != zero_zero(int) )
        | ( Na != zero_zero(int) ) ) ) ).

% gcd_pos_int
tff(fact_4882_gcd__neg__numeral__2__int,axiom,
    ! [X: int,Na: num] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),aa(num,int,numeral_numeral(int),Na)) ) ).

% gcd_neg_numeral_2_int
tff(fact_4883_gcd__neg__numeral__1__int,axiom,
    ! [Na: num,X: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))),X) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(num,int,numeral_numeral(int),Na)),X) ) ).

% gcd_neg_numeral_1_int
tff(fact_4884_gcd__0__int,axiom,
    ! [X: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),zero_zero(int)) = aa(int,int,abs_abs(int),X) ) ).

% gcd_0_int
tff(fact_4885_gcd__0__left__int,axiom,
    ! [X: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),zero_zero(int)),X) = aa(int,int,abs_abs(int),X) ) ).

% gcd_0_left_int
tff(fact_4886_gcd__proj2__if__dvd__int,axiom,
    ! [Y: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Y),X)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) = aa(int,int,abs_abs(int),Y) ) ) ).

% gcd_proj2_if_dvd_int
tff(fact_4887_gcd__proj1__if__dvd__int,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),X),Y)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) = aa(int,int,abs_abs(int),X) ) ) ).

% gcd_proj1_if_dvd_int
tff(fact_4888_count__notin,axiom,
    ! [A: $tType,X: A,Xs: list(A)] :
      ( ~ member(A,X,aa(list(A),set(A),set2(A),Xs))
     => ( aa(A,nat,count_list(A,Xs),X) = zero_zero(nat) ) ) ).

% count_notin
tff(fact_4889_gcd__idem__int,axiom,
    ! [X: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),X) = aa(int,int,abs_abs(int),X) ) ).

% gcd_idem_int
tff(fact_4890_gcd__mono,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2)) ) ) ) ).

% gcd_mono
tff(fact_4891_dvd__gcdD1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_gcdD1
tff(fact_4892_dvd__gcdD2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ).

% dvd_gcdD2
tff(fact_4893_gcd__dvdI1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),C2) ) ) ).

% gcd_dvdI1
tff(fact_4894_gcd__dvdI2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),C2) ) ) ).

% gcd_dvdI2
tff(fact_4895_gcd__greatest,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) ) ) ) ).

% gcd_greatest
tff(fact_4896_gcd__dvd__antisym,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2))
           => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2) ) ) ) ) ).

% gcd_dvd_antisym
tff(fact_4897_gcd__red__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Y),modulo_modulo(int,X,Y)) ) ).

% gcd_red_int
tff(fact_4898_gcd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2)) ) ) ).

% gcd.left_commute
tff(fact_4899_gcd_Ocommute,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),A2) ) ) ).

% gcd.commute
tff(fact_4900_gcd_Oassoc,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2)) ) ) ).

% gcd.assoc
tff(fact_4901_gcd__diff1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [M: A,Na: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),M),Na)),Na) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) ) ) ).

% gcd_diff1
tff(fact_4902_gcd__diff2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [Na: A,M: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Na),M)),Na) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) ) ) ).

% gcd_diff2
tff(fact_4903_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,K: A,Na: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),M)),Na)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) ) ) ).

% gcd_add_mult
tff(fact_4904_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,K: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2)) ) ).

% gcd_dvd_prod
tff(fact_4905_gcd__ge__0__int,axiom,
    ! [X: int,Y: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y)) ).

% gcd_ge_0_int
tff(fact_4906_bezout__int,axiom,
    ! [X: int,Y: int] :
    ? [U2: int,V4: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),U2),X)),aa(int,int,aa(int,fun(int,int),times_times(int),V4),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) ) ).

% bezout_int
tff(fact_4907_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,Na: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),K)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),Na)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),Na)) ) ).

% gcd_mult_distrib_int
tff(fact_4908_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_4909_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_4910_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_4911_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_4912_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)),A2) ) ).

% gcd_le1_int
tff(fact_4913_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)),B2) ) ).

% gcd_le2_int
tff(fact_4914_gcd__cases__int,axiom,
    ! [X: int,Y: int,P: fun(int,$o)] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y)) ) )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),zero_zero(int))
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),aa(int,int,uminus_uminus(int),Y))) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),zero_zero(int))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X)),Y)) ) )
         => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),zero_zero(int))
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),zero_zero(int))
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),X)),aa(int,int,uminus_uminus(int),Y))) ) )
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y)) ) ) ) ) ).

% gcd_cases_int
tff(fact_4915_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),D2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),A2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),B2)
        & ! [E3: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),A2)
              & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),B2) )
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),D2) ) )
    <=> ( D2 = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2) ) ) ).

% gcd_unique_int
tff(fact_4916_gcd__non__0__int,axiom,
    ! [Y: int,X: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Y)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Y),modulo_modulo(int,X,Y)) ) ) ).

% gcd_non_0_int
tff(fact_4917_gcd__code__int,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),K),L)
      = aa(int,int,abs_abs(int),$ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),L),modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L))))) ) ).

% gcd_code_int
tff(fact_4918_count__le__length,axiom,
    ! [A: $tType,Xs: list(A),X: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,count_list(A,Xs),X)),aa(list(A),nat,size_size(list(A)),Xs)) ).

% count_le_length
tff(fact_4919_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(nat,nat)] :
      ( ( aa(nat,product_prod(nat,nat),nat_prod_decode_aux(X),Xa) = Y )
     => ( accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Xa))
       => ~ ( ( Y
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),X),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa)),aa(nat,product_prod(nat,nat),nat_prod_decode_aux(aa(nat,nat,suc,X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X)))) )
           => ~ accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Xa)) ) ) ) ).

% prod_decode_aux.pelims
tff(fact_4920_set__encode__insert,axiom,
    ! [A3: set(nat),Na: nat] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( ~ member(nat,Na,A3)
       => ( aa(set(nat),nat,nat_set_encode,aa(set(nat),set(nat),insert(nat,Na),A3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),aa(set(nat),nat,nat_set_encode,A3)) ) ) ) ).

% set_encode_insert
tff(fact_4921_even__sum__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_parity(B)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(A),nat,finite_card(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(A,$o)),A3),F2)))) ) ) ) ).

% even_sum_iff
tff(fact_4922_gcd__0__left__nat,axiom,
    ! [X: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),X) = X ) ).

% gcd_0_left_nat
tff(fact_4923_gcd__0__nat,axiom,
    ! [X: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),zero_zero(nat)) = X ) ).

% gcd_0_nat
tff(fact_4924_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),zero_zero(nat)) = A2 ) ).

% gcd_nat.right_neutral
tff(fact_4925_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.neutr_eq_iff
tff(fact_4926_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),A2) = A2 ) ).

% gcd_nat.left_neutral
tff(fact_4927_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = zero_zero(nat) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.eq_neutr_iff
tff(fact_4928_gcd__1__nat,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),one_one(nat)) = one_one(nat) ) ).

% gcd_1_nat
tff(fact_4929_gcd__nat_Oabsorb1,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = A2 ) ) ).

% gcd_nat.absorb1
tff(fact_4930_gcd__nat_Oabsorb2,axiom,
    ! [B2: nat,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = B2 ) ) ).

% gcd_nat.absorb2
tff(fact_4931_gcd__nat_Obounded__iff,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2) ) ) ).

% gcd_nat.bounded_iff
tff(fact_4932_gcd__proj1__if__dvd__nat,axiom,
    ! [X: nat,Y: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),X),Y)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y) = X ) ) ).

% gcd_proj1_if_dvd_nat
tff(fact_4933_gcd__proj2__if__dvd__nat,axiom,
    ! [Y: nat,X: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Y),X)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y) = Y ) ) ).

% gcd_proj2_if_dvd_nat
tff(fact_4934_card__Collect__less__nat,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Na))) = Na ) ).

% card_Collect_less_nat
tff(fact_4935_gcd__Suc__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% gcd_Suc_0
tff(fact_4936_gcd__pos__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na))
    <=> ( ( M != zero_zero(nat) )
        | ( Na != zero_zero(nat) ) ) ) ).

% gcd_pos_nat
tff(fact_4937_insert__Diff1,axiom,
    ! [A: $tType,X: A,B3: set(A),A3: set(A)] :
      ( member(A,X,B3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,X),A3)),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) ) ) ).

% insert_Diff1
tff(fact_4938_Diff__insert0,axiom,
    ! [A: $tType,X: A,A3: set(A),B3: set(A)] :
      ( ~ member(A,X,A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) ) ) ).

% Diff_insert0
tff(fact_4939_card__atMost,axiom,
    ! [U: nat] : ( aa(set(nat),nat,finite_card(nat),set_ord_atMost(nat,U)) = aa(nat,nat,suc,U) ) ).

% card_atMost
tff(fact_4940_card__atLeastLessThan,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or7035219750837199246ssThan(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),L) ) ).

% card_atLeastLessThan
tff(fact_4941_gcd__int__int__eq,axiom,
    ! [M: nat,Na: nat] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na)) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na)) ) ).

% gcd_int_int_eq
tff(fact_4942_card__Collect__le__nat,axiom,
    ! [Na: nat] : ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_kl(nat,fun(nat,$o)),Na))) = aa(nat,nat,suc,Na) ) ).

% card_Collect_le_nat
tff(fact_4943_card_Oinfinite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) ) ) ).

% card.infinite
tff(fact_4944_finite__Diff__insert,axiom,
    ! [A: $tType,A3: set(A),A2: A,B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3)))
    <=> aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% finite_Diff_insert
tff(fact_4945_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or1337092689740270186AtMost(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,U)),L) ) ).

% card_atLeastAtMost
tff(fact_4946_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y: A,A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_km(A,fun(B,A),Y)),A3) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(set(B),nat,finite_card(B),A3)) ) ) ).

% prod_constant
tff(fact_4947_card__atLeastLessThan__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or7035219750837199246ssThan(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L)) ) ).

% card_atLeastLessThan_int
tff(fact_4948_sum_Oinsert,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),X: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ~ member(A,X,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,X),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum.insert
tff(fact_4949_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ~ member(A,X,A3)
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,X),A3)) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),A3)) ) ) ) ).

% card_insert_disjoint
tff(fact_4950_gcd__nat__abs__right__eq,axiom,
    ! [Na: nat,K: int] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Na),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(nat,int,semiring_1_of_nat(int),Na)),K)) ) ).

% gcd_nat_abs_right_eq
tff(fact_4951_gcd__nat__abs__left__eq,axiom,
    ! [K: int,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),Na) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),K),aa(nat,int,semiring_1_of_nat(int),Na))) ) ).

% gcd_nat_abs_left_eq
tff(fact_4952_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set(A),B3: set(A)] :
      ( member(A,A2,A3)
     => ( ~ member(A,A2,B3)
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),one_one(nat)) ) ) ) ).

% card_Diff_insert
tff(fact_4953_card__atLeastAtMost__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or1337092689740270186AtMost(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L)),one_one(int))) ) ).

% card_atLeastAtMost_int
tff(fact_4954_gcd__nat_Omono,axiom,
    ! [A2: nat,C2: nat,B2: nat,D2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),D2)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),C2),D2)) ) ) ).

% gcd_nat.mono
tff(fact_4955_gcd__nat_OorderE,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ).

% gcd_nat.orderE
tff(fact_4956_gcd__nat_OorderI,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2) ) ).

% gcd_nat.orderI
tff(fact_4957_gcd__nat_Oabsorb3,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = A2 ) ) ).

% gcd_nat.absorb3
tff(fact_4958_gcd__nat_Oabsorb4,axiom,
    ! [B2: nat,A2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
        & ( B2 != A2 ) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = B2 ) ) ).

% gcd_nat.absorb4
tff(fact_4959_gcd__nat_OboundedE,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2))
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
         => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2) ) ) ).

% gcd_nat.boundedE
tff(fact_4960_gcd__nat_OboundedI,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2)) ) ) ).

% gcd_nat.boundedI
tff(fact_4961_gcd__nat_Oorder__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
    <=> ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ).

% gcd_nat.order_iff
tff(fact_4962_gcd__nat_Ocobounded1,axiom,
    ! [A2: nat,B2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),A2) ).

% gcd_nat.cobounded1
tff(fact_4963_gcd__nat_Ocobounded2,axiom,
    ! [A2: nat,B2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) ).

% gcd_nat.cobounded2
tff(fact_4964_gcd__nat_Oabsorb__iff1,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = A2 ) ) ).

% gcd_nat.absorb_iff1
tff(fact_4965_gcd__nat_Oabsorb__iff2,axiom,
    ! [B2: nat,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = B2 ) ) ).

% gcd_nat.absorb_iff2
tff(fact_4966_gcd__nat_OcoboundedI1,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2) ) ).

% gcd_nat.coboundedI1
tff(fact_4967_gcd__nat_OcoboundedI2,axiom,
    ! [B2: nat,C2: nat,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2) ) ).

% gcd_nat.coboundedI2
tff(fact_4968_gcd__nat_Ostrict__boundedE,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2))
        & ( A2 != aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2) ) )
     => ~ ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
            & ( A2 != B2 ) )
         => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
              & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_boundedE
tff(fact_4969_gcd__nat_Ostrict__order__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
    <=> ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
        & ( A2 != B2 ) ) ) ).

% gcd_nat.strict_order_iff
tff(fact_4970_gcd__nat_Ostrict__coboundedI1,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
        & ( A2 != C2 ) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2)
        & ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) != C2 ) ) ) ).

% gcd_nat.strict_coboundedI1
tff(fact_4971_gcd__nat_Ostrict__coboundedI2,axiom,
    ! [B2: nat,C2: nat,A2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
        & ( B2 != C2 ) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2)
        & ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) != C2 ) ) ) ).

% gcd_nat.strict_coboundedI2
tff(fact_4972_gcd__unique__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),B2)
        & ! [E3: nat] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),E3),A2)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),E3),B2) )
           => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),E3),D2) ) )
    <=> ( D2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ).

% gcd_unique_nat
tff(fact_4973_gcd__red__nat,axiom,
    ! [X: nat,Y: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y),modulo_modulo(nat,X,Y)) ) ).

% gcd_red_nat
tff(fact_4974_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),Na)) ) ).

% gcd_mult_distrib_nat
tff(fact_4975_card__insert__if,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,X),A3))
        = $ite(member(A,X,A3),aa(set(A),nat,finite_card(A),A3),aa(nat,nat,suc,aa(set(A),nat,finite_card(A),A3))) ) ) ).

% card_insert_if
tff(fact_4976_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
    <=> ? [B7: A,B10: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B7),B10) )
          & ~ member(A,B7,B10)
          & ( aa(set(A),nat,finite_card(A),B10) = K )
          & aa(set(A),$o,finite_finite(A),B10) ) ) ).

% card_Suc_eq_finite
tff(fact_4977_card__le__Suc__iff,axiom,
    ! [A: $tType,Na: nat,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),aa(set(A),nat,finite_card(A),A3))
    <=> ? [A6: A,B10: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,A6),B10) )
          & ~ member(A,A6,B10)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(set(A),nat,finite_card(A),B10))
          & aa(set(A),$o,finite_finite(A),B10) ) ) ).

% card_le_Suc_iff
tff(fact_4978_insert__Diff__if,axiom,
    ! [A: $tType,X: A,A3: set(A),B3: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,X),A3)),B3)
      = $ite(member(A,X,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3),aa(set(A),set(A),insert(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ).

% insert_Diff_if
tff(fact_4979_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2 != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) ) ).

% gcd_le2_nat
tff(fact_4980_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),A2) ) ).

% gcd_le1_nat
tff(fact_4981_gcd__diff1__nat,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),M)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),Na) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na) ) ) ).

% gcd_diff1_nat
tff(fact_4982_gcd__diff2__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)),Na) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na) ) ) ).

% gcd_diff2_nat
tff(fact_4983_gcd__non__0__nat,axiom,
    ! [Y: nat,X: nat] :
      ( ( Y != zero_zero(nat) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y),modulo_modulo(nat,X,Y)) ) ) ).

% gcd_non_0_nat
tff(fact_4984_gcd__nat_Osimps,axiom,
    ! [X: nat,Y: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y)
      = $ite(Y = zero_zero(nat),X,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y),modulo_modulo(nat,X,Y))) ) ).

% gcd_nat.simps
tff(fact_4985_gcd__nat_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Xa) = Y )
     => ( Y
        = $ite(Xa = zero_zero(nat),X,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),modulo_modulo(nat,X,Xa))) ) ) ).

% gcd_nat.elims
tff(fact_4986_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),X: A,C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),aa(set(A),set(A),insert(A,X),C6)))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C6))
        & ~ member(A,X,A3) ) ) ).

% subset_Diff_insert
tff(fact_4987_lessThan__Suc,axiom,
    ! [K: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),insert(nat,K),set_ord_lessThan(nat,K)) ) ).

% lessThan_Suc
tff(fact_4988_gcd__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),X)) ) ).

% gcd_integer.abs_eq
tff(fact_4989_atMost__Suc,axiom,
    ! [K: nat] : ( set_ord_atMost(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),set_ord_atMost(nat,K)) ) ).

% atMost_Suc
tff(fact_4990_card__insert__le__m1,axiom,
    ! [A: $tType,Na: nat,Y: set(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),Y)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,X),Y))),Na) ) ) ).

% card_insert_le_m1
tff(fact_4991_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),Na: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_jm(set(A),fun(nat,fun(list(A),$o)),A3),Na))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(set(A),nat,finite_card(A),A3)),Na) ) ) ).

% card_lists_length_eq
tff(fact_4992_card__eq__sum,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),nat,finite_card(A),A3) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_kn(A,nat)),A3) ) ).

% card_eq_sum
tff(fact_4993_card__2__iff_H,axiom,
    ! [A: $tType,S3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S3) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X5: A] :
          ( member(A,X5,S3)
          & ? [Xa4: A] :
              ( member(A,Xa4,S3)
              & ( X5 != Xa4 )
              & ! [Xb4: A] :
                  ( member(A,Xb4,S3)
                 => ( ( Xb4 = X5 )
                    | ( Xb4 = Xa4 ) ) ) ) ) ) ).

% card_2_iff'
tff(fact_4994_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3))
     => aa(set(A),$o,finite_finite(A),A3) ) ).

% card_ge_0_finite
tff(fact_4995_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => ? [X3: nat,Y4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)) ) ) ).

% bezout_nat
tff(fact_4996_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X3: nat,Y4: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) )
      | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X3))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y4)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ) ).

% bezout_gcd_nat'
tff(fact_4997_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))) ) ) ) ).

% card_less_sym_Diff
tff(fact_4998_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))) ) ) ) ).

% card_le_sym_Diff
tff(fact_4999_card__length,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% card_length
tff(fact_5000_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M10: set(A)] :
      ( aa(set(A),$o,finite_finite(A),M10)
     => ? [H2: fun(A,nat)] : bij_betw(A,nat,H2,M10,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(A),nat,finite_card(A),M10))) ) ).

% ex_bij_betw_finite_nat
tff(fact_5001_psubset__card__mono,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ).

% psubset_card_mono
tff(fact_5002_sum_Oinsert__if,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,X),A3))
            = $ite(member(A,X,A3),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3))) ) ) ) ).

% sum.insert_if
tff(fact_5003_atLeast0__atMost__Suc,axiom,
    ! [Na: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,Na)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na)) ) ).

% atLeast0_atMost_Suc
tff(fact_5004_atLeast0__lessThan__Suc,axiom,
    ! [Na: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,Na),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) ) ).

% atLeast0_lessThan_Suc
tff(fact_5005_atLeastAtMost__insertL,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( aa(set(nat),set(nat),insert(nat,M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),Na)) = set_or1337092689740270186AtMost(nat,M,Na) ) ) ).

% atLeastAtMost_insertL
tff(fact_5006_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,Na))
     => ( set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,Na)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% atLeastAtMostSuc_conv
tff(fact_5007_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( set_or1337092689740270186AtMost(nat,M,Na) = aa(set(nat),set(nat),insert(nat,M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),Na)) ) ) ).

% Icc_eq_insert_lb_nat
tff(fact_5008_lessThan__nat__numeral,axiom,
    ! [K: num] : ( set_ord_lessThan(nat,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert(nat,pred_numeral(K)),set_ord_lessThan(nat,pred_numeral(K))) ) ).

% lessThan_nat_numeral
tff(fact_5009_card__less__Suc2,axiom,
    ! [M10: set(nat),I2: nat] :
      ( ~ member(nat,zero_zero(nat),M10)
     => ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ko(set(nat),fun(nat,fun(nat,$o)),M10),I2))) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_kp(set(nat),fun(nat,fun(nat,$o)),M10),I2))) ) ) ).

% card_less_Suc2
tff(fact_5010_card__less__Suc,axiom,
    ! [M10: set(nat),I2: nat] :
      ( member(nat,zero_zero(nat),M10)
     => ( aa(nat,nat,suc,aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ko(set(nat),fun(nat,fun(nat,$o)),M10),I2)))) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_kp(set(nat),fun(nat,fun(nat,$o)),M10),I2))) ) ) ).

% card_less_Suc
tff(fact_5011_card__less,axiom,
    ! [M10: set(nat),I2: nat] :
      ( member(nat,zero_zero(nat),M10)
     => ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_kp(set(nat),fun(nat,fun(nat,$o)),M10),I2))) != zero_zero(nat) ) ) ).

% card_less
tff(fact_5012_atMost__nat__numeral,axiom,
    ! [K: num] : ( set_ord_atMost(nat,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert(nat,aa(num,nat,numeral_numeral(nat),K)),set_ord_atMost(nat,pred_numeral(K))) ) ).

% atMost_nat_numeral
tff(fact_5013_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( aa(set(int),nat,finite_card(int),set_or7035219750837199246ssThan(int,zero_zero(int),U)) = aa(int,nat,nat2,U) ) ).

% card_atLeastZeroLessThan_int
tff(fact_5014_sum__Suc,axiom,
    ! [A: $tType,F2: fun(A,nat),A3: set(A)] : ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_kq(fun(A,nat),fun(A,nat),F2)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,finite_card(A),A3)) ) ).

% sum_Suc
tff(fact_5015_subset__card__intvl__is__intvl,axiom,
    ! [A3: set(nat),K: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),A3),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(set(nat),nat,finite_card(nat),A3))))
     => ( A3 = set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(set(nat),nat,finite_card(nat),A3))) ) ) ).

% subset_card_intvl_is_intvl
tff(fact_5016_real__of__card,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(nat,real,semiring_1_of_nat(real),aa(set(A),nat,finite_card(A),A3)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_kr(A,real)),A3) ) ).

% real_of_card
tff(fact_5017_gcd__code__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),K),L)
      = aa(code_integer,code_integer,abs_abs(code_integer),$ite(L = zero_zero(code_integer),K,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),L),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))))) ) ).

% gcd_code_integer
tff(fact_5018_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(nat,nat,suc,zero_zero(nat)))
      <=> ! [X5: A] :
            ( member(A,X5,A3)
           => ! [Xa4: A] :
                ( member(A,Xa4,A3)
               => ( X5 = Xa4 ) ) ) ) ) ).

% card_le_Suc0_iff_eq
tff(fact_5019_card__Diff__subset,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ).

% card_Diff_subset
tff(fact_5020_card__psubset,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3) ) ) ) ).

% card_psubset
tff(fact_5021_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ).

% diff_card_le_card_Diff
tff(fact_5022_card__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),Na: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_jn(set(A),fun(nat,fun(list(A),$o)),A3),Na))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(set(A),nat,finite_card(A),A3))),set_ord_atMost(nat,Na)) ) ) ).

% card_lists_length_le
tff(fact_5023_gcd__int__def,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),X),Y) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),X))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Y)))) ) ).

% gcd_int_def
tff(fact_5024_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M10: set(A)] :
      ( aa(set(A),$o,finite_finite(A),M10)
     => ? [H2: fun(nat,A)] : bij_betw(nat,A,H2,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(A),nat,finite_card(A),M10)),M10) ) ).

% ex_bij_betw_nat_finite
tff(fact_5025_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M10: set(A)] :
      ( aa(set(A),$o,finite_finite(A),M10)
     => ? [H2: fun(nat,A)] : bij_betw(nat,A,H2,set_or1337092689740270186AtMost(nat,one_one(nat),aa(set(A),nat,finite_card(A),M10)),M10) ) ).

% ex_bij_betw_nat_finite_1
tff(fact_5026_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Na: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),Na)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aTP_Lamp_jy(nat,fun(A,$o),Na)))),Na) ) ) ).

% card_roots_unity
tff(fact_5027_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N3: set(nat),Na: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N3),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,finite_card(nat),N3)),Na) ) ).

% subset_eq_atLeast0_lessThan_card
tff(fact_5028_card__sum__le__nat__sum,axiom,
    ! [S3: set(nat)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gf(nat,nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(nat),nat,finite_card(nat),S3)))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_gf(nat,nat)),S3)) ).

% card_sum_le_nat_sum
tff(fact_5029_card__nth__roots,axiom,
    ! [C2: complex,Na: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ( aa(set(complex),nat,finite_card(complex),collect(complex,aa(nat,fun(complex,$o),aTP_Lamp_at(complex,fun(nat,fun(complex,$o)),C2),Na))) = Na ) ) ) ).

% card_nth_roots
tff(fact_5030_card__roots__unity__eq,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(set(complex),nat,finite_card(complex),collect(complex,aTP_Lamp_as(nat,fun(complex,$o),Na))) = Na ) ) ).

% card_roots_unity_eq
tff(fact_5031_prod__le__power,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F2: fun(A,B),Na: B,K: nat] :
          ( ! [I3: A] :
              ( member(A,I3,A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,I3))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,I3)),Na) ) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),K)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),Na)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Na),K)) ) ) ) ) ).

% prod_le_power
tff(fact_5032_sum__bounded__above__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere8940638589300402666id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),F2: fun(A,B),K5: B] :
          ( ! [I3: A] :
              ( member(A,I3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,I3)),K5) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),A3))),K5)) ) ) ) ).

% sum_bounded_above_strict
tff(fact_5033_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,Na: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_ke(fun(nat,A),fun(nat,fun(A,$o)),C2),Na)))),Na) ) ) ) ).

% polyfun_roots_card
tff(fact_5034_prod__gen__delta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B),C2: B] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(B,fun(A,B),aa(fun(A,B),fun(B,fun(A,B)),aTP_Lamp_ks(A,fun(fun(A,B),fun(B,fun(A,B))),A2),B2),C2)),S3)
            = $ite(member(A,A2,S3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,B2,A2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),S3)),one_one(nat)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),C2),aa(set(A),nat,finite_card(A),S3))) ) ) ) ).

% prod_gen_delta
tff(fact_5035_bezw__aux,axiom,
    ! [X: nat,Y: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(X,Y))),aa(nat,int,semiring_1_of_nat(int),X))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(X,Y))),aa(nat,int,semiring_1_of_nat(int),Y))) ) ).

% bezw_aux
tff(fact_5036_set__decode__plus__power__2,axiom,
    ! [Na: nat,Z: nat] :
      ( ~ member(nat,Na,nat_set_decode(Z))
     => ( nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),Z)) = aa(set(nat),set(nat),insert(nat,Na),nat_set_decode(Z)) ) ) ).

% set_decode_plus_power_2
tff(fact_5037_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,Na: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
           => ( aa(set(A),$o,finite_finite(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_ke(fun(nat,A),fun(nat,fun(A,$o)),C2),Na)))
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_ke(fun(nat,A),fun(nat,fun(A,$o)),C2),Na)))),Na) ) ) ) ) ).

% polyfun_rootbound
tff(fact_5038_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Xa) = Y )
     => ( accp(product_prod(nat,nat),gcd_nat_rel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Xa))
       => ~ ( ( Y
              = $ite(Xa = zero_zero(nat),X,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),modulo_modulo(nat,X,Xa))) )
           => ~ accp(product_prod(nat,nat),gcd_nat_rel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Xa)) ) ) ) ).

% gcd_nat.pelims
tff(fact_5039_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(set(A),nat,finite_card(A),A3))
       => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),$o)),A3),K))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A3))) ) ) ) ).

% card_lists_distinct_length_eq
tff(fact_5040_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(set(A),nat,finite_card(A),A3))
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(set(A),fun(list(A),$o),aTP_Lamp_ku(nat,fun(set(A),fun(list(A),$o)),K),A3))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_gf(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A3))) ) ) ).

% card_lists_distinct_length_eq'
tff(fact_5041_gcd__idem__nat,axiom,
    ! [X: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),X) = X ) ).

% gcd_idem_nat
tff(fact_5042_gcd__nat_Oright__idem,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ).

% gcd_nat.right_idem
tff(fact_5043_gcd__nat_Oleft__idem,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ).

% gcd_nat.left_idem
tff(fact_5044_gcd__nat_Oidem,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),A2) = A2 ) ).

% gcd_nat.idem
tff(fact_5045_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),Na: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(list(A)),$o,finite_finite(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),$o)),A3),Na))) ) ).

% finite_lists_distinct_length_eq
tff(fact_5046_card__distinct,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) )
     => distinct(A,Xs) ) ).

% card_distinct
tff(fact_5047_distinct__card,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
     => ( aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ).

% distinct_card
tff(fact_5048_distinct__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( distinct(A,Xs)
    <=> ! [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
         => ! [J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
             => ( ( I != J )
               => ( aa(nat,A,nth(A,Xs),I) != aa(nat,A,nth(A,Xs),J) ) ) ) ) ) ).

% distinct_conv_nth
tff(fact_5049_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list(A),I2: nat,J2: nat] :
      ( distinct(A,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
         => ( ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Xs),J2) )
          <=> ( I2 = J2 ) ) ) ) ) ).

% nth_eq_iff_index_eq
tff(fact_5050_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list(A),X: A] :
      ( distinct(A,Xs)
     => ( member(A,X,aa(list(A),set(A),set2(A),Xs))
       => ? [X3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),aa(list(A),nat,size_size(list(A)),Xs))
            & ( aa(nat,A,nth(A,Xs),X3) = X )
            & ! [Y3: nat] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y3),aa(list(A),nat,size_size(list(A)),Xs))
                  & ( aa(nat,A,nth(A,Xs),Y3) = X ) )
               => ( Y3 = X3 ) ) ) ) ) ).

% distinct_Ex1
tff(fact_5051_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Na))
     => ( set_or1337092689740270186AtMost(int,M,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Na)) = aa(set(int),set(int),insert(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Na)),set_or1337092689740270186AtMost(int,M,Na)) ) ) ).

% atLeastAtMostPlus1_int_conv
tff(fact_5052_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list(A),A3: set(nat),B3: set(A)] :
      ( distinct(A,Xs)
     => ( ( A3 = set_ord_lessThan(nat,aa(list(A),nat,size_size(list(A)),Xs)) )
       => ( ( B3 = aa(list(A),set(A),set2(A),Xs) )
         => bij_betw(nat,A,nth(A,Xs),A3,B3) ) ) ) ).

% bij_betw_nth
tff(fact_5053_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( member(int,K,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
          & member(int,L,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
          aa(int,int,uminus_uminus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
          aa(int,int,
            aa(int,fun(int,int),plus_plus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
            aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ).

% and_int.simps
tff(fact_5054_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Xa) = Y )
     => ( Y
        = $ite(
            ( member(int,X,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & member(int,Xa,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.elims
tff(fact_5055_finite__enumerate,axiom,
    ! [S3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),S3)
     => ? [R: fun(nat,nat)] :
          ( strict_mono_on(nat,nat,R,set_ord_lessThan(nat,aa(set(nat),nat,finite_card(nat),S3)))
          & ! [N6: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N6),aa(set(nat),nat,finite_card(nat),S3))
             => member(nat,aa(nat,nat,R,N6),S3) ) ) ) ).

% finite_enumerate
tff(fact_5056_Diff__empty,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),bot_bot(set(A))) = A3 ) ).

% Diff_empty
tff(fact_5057_empty__Diff,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),bot_bot(set(A))),A3) = bot_bot(set(A)) ) ).

% empty_Diff
tff(fact_5058_Diff__cancel,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),A3) = bot_bot(set(A)) ) ).

% Diff_cancel
tff(fact_5059_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty
tff(fact_5060_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastatMost_empty
tff(fact_5061_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( ( set_or7035219750837199246ssThan(A,A2,B2) = bot_bot(set(A)) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_5062_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or7035219750837199246ssThan(A,A2,B2) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_5063_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty
tff(fact_5064_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = bot_bot(set(A)) )
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% Diff_eq_empty_iff
tff(fact_5065_card_Oempty,axiom,
    ! [A: $tType] : ( aa(set(A),nat,finite_card(A),bot_bot(set(A))) = zero_zero(nat) ) ).

% card.empty
tff(fact_5066_insert__Diff__single,axiom,
    ! [A: $tType,A2: A,A3: set(A)] : ( aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) = aa(set(A),set(A),insert(A,A2),A3) ) ).

% insert_Diff_single
tff(fact_5067_card__0__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) )
      <=> ( A3 = bot_bot(set(A)) ) ) ) ).

% card_0_eq
tff(fact_5068_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,K),bot_bot(set(A)))),set_ord_lessThan(A,K)) = aa(set(A),set(A),insert(A,K),bot_bot(set(A))) ) ) ).

% single_Diff_lessThan
tff(fact_5069_set__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( ( Na != zero_zero(nat) )
     => ( aa(list(A),set(A),set2(A),replicate(A,Na,X)) = aa(set(A),set(A),insert(A,X),bot_bot(set(A))) ) ) ).

% set_replicate
tff(fact_5070_not__psubset__empty,axiom,
    ! [A: $tType,A3: set(A)] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),bot_bot(set(A))) ).

% not_psubset_empty
tff(fact_5071_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y) = bot_bot(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ).

% diff_shunt_var
tff(fact_5072_infinite__growing,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X7: set(A)] :
          ( ( X7 != bot_bot(set(A)) )
         => ( ! [X3: A] :
                ( member(A,X3,X7)
               => ? [Xa2: A] :
                    ( member(A,Xa2,X7)
                    & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Xa2) ) )
           => ~ aa(set(A),$o,finite_finite(A),X7) ) ) ) ).

% infinite_growing
tff(fact_5073_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [S3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ? [X3: A] :
                ( member(A,X3,S3)
                & ~ ? [Xa2: A] :
                      ( member(A,Xa2,S3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa2),X3) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_5074_Diff__insert__absorb,axiom,
    ! [A: $tType,X: A,A3: set(A)] :
      ( ~ member(A,X,A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,X),A3)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = A3 ) ) ).

% Diff_insert_absorb
tff(fact_5075_Diff__insert2,axiom,
    ! [A: $tType,A3: set(A),A2: A,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))),B3) ) ).

% Diff_insert2
tff(fact_5076_insert__Diff,axiom,
    ! [A: $tType,A2: A,A3: set(A)] :
      ( member(A,A2,A3)
     => ( aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) = A3 ) ) ).

% insert_Diff
tff(fact_5077_Diff__insert,axiom,
    ! [A: $tType,A3: set(A),A2: A,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))) ) ).

% Diff_insert
tff(fact_5078_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),P: fun(set(A),$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,P,bot_bot(set(A)))
           => ( ! [B4: A,A7: set(A)] :
                  ( aa(set(A),$o,finite_finite(A),A7)
                 => ( ! [X4: A] :
                        ( member(A,X4,A7)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B4),X4) )
                   => ( aa(set(A),$o,P,A7)
                     => aa(set(A),$o,P,aa(set(A),set(A),insert(A,B4),A7)) ) ) )
             => aa(set(A),$o,P,A3) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_5079_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),P: fun(set(A),$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,P,bot_bot(set(A)))
           => ( ! [B4: A,A7: set(A)] :
                  ( aa(set(A),$o,finite_finite(A),A7)
                 => ( ! [X4: A] :
                        ( member(A,X4,A7)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),B4) )
                   => ( aa(set(A),$o,P,A7)
                     => aa(set(A),$o,P,aa(set(A),set(A),insert(A,B4),A7)) ) ) )
             => aa(set(A),$o,P,A3) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_5080_sum__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( strict7427464778891057005id_add(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [X3: A] :
                  ( member(A,X3,A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X3)),aa(A,B,G,X3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum_strict_mono
tff(fact_5081_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) )
    <=> ( ( A3 = bot_bot(set(A)) )
        | ~ aa(set(A),$o,finite_finite(A),A3) ) ) ).

% card_eq_0_iff
tff(fact_5082_finite__empty__induct,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,P,A3)
       => ( ! [A4: A,A7: set(A)] :
              ( aa(set(A),$o,finite_finite(A),A7)
             => ( member(A,A4,A7)
               => ( aa(set(A),$o,P,A7)
                 => aa(set(A),$o,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) ) ) )
         => aa(set(A),$o,P,bot_bot(set(A))) ) ) ) ).

% finite_empty_induct
tff(fact_5083_infinite__coinduct,axiom,
    ! [A: $tType,X7: fun(set(A),$o),A3: set(A)] :
      ( aa(set(A),$o,X7,A3)
     => ( ! [A7: set(A)] :
            ( aa(set(A),$o,X7,A7)
           => ? [X4: A] :
                ( member(A,X4,A7)
                & ( aa(set(A),$o,X7,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert(A,X4),bot_bot(set(A)))))
                  | ~ aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert(A,X4),bot_bot(set(A))))) ) ) )
       => ~ aa(set(A),$o,finite_finite(A),A3) ) ) ).

% infinite_coinduct
tff(fact_5084_infinite__remove,axiom,
    ! [A: $tType,S3: set(A),A2: A] :
      ( ~ aa(set(A),$o,finite_finite(A),S3)
     => ~ aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) ) ).

% infinite_remove
tff(fact_5085_subset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),X: A,B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,X),B3))
    <=> $ite(member(A,X,A3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),B3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)) ) ).

% subset_insert_iff
tff(fact_5086_Diff__single__insert,axiom,
    ! [A: $tType,A3: set(A),X: A,B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,X),B3)) ) ).

% Diff_single_insert
tff(fact_5087_card__1__singletonE,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = one_one(nat) )
     => ~ ! [X3: A] : ( A3 != aa(set(A),set(A),insert(A,X3),bot_bot(set(A))) ) ) ).

% card_1_singletonE
tff(fact_5088_Compl__insert,axiom,
    ! [A: $tType,X: A,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,X),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) ) ).

% Compl_insert
tff(fact_5089_sum__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I3: A] :
                  ( member(A,I3,I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F2,I3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),I5)) ) ) ) ) ).

% sum_pos
tff(fact_5090_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I3: A] :
                  ( member(A,I3,I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(A,B,F2,I3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),I5)) ) ) ) ) ).

% less_1_prod
tff(fact_5091_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3))
    <=> ( ( A3 != bot_bot(set(A)) )
        & aa(set(A),$o,finite_finite(A),A3) ) ) ).

% card_gt_0_iff
tff(fact_5092_card__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
    <=> ? [B7: A,B10: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B7),B10) )
          & ~ member(A,B7,B10)
          & ( aa(set(A),nat,finite_card(A),B10) = K )
          & ( ( K = zero_zero(nat) )
           => ( B10 = bot_bot(set(A)) ) ) ) ) ).

% card_Suc_eq
tff(fact_5093_card__eq__SucD,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
     => ? [B4: A,B8: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B4),B8) )
          & ~ member(A,B4,B8)
          & ( aa(set(A),nat,finite_card(A),B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(A)) ) ) ) ) ).

% card_eq_SucD
tff(fact_5094_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X5: A] : ( A3 = aa(set(A),set(A),insert(A,X5),bot_bot(set(A))) ) ) ).

% card_1_singleton_iff
tff(fact_5095_finite__remove__induct,axiom,
    ! [A: $tType,B3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,P,bot_bot(set(A)))
       => ( ! [A7: set(A)] :
              ( aa(set(A),$o,finite_finite(A),A7)
             => ( ( A7 != bot_bot(set(A)) )
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A7),B3)
                 => ( ! [X4: A] :
                        ( member(A,X4,A7)
                       => aa(set(A),$o,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert(A,X4),bot_bot(set(A))))) )
                   => aa(set(A),$o,P,A7) ) ) ) )
         => aa(set(A),$o,P,B3) ) ) ) ).

% finite_remove_induct
tff(fact_5096_remove__induct,axiom,
    ! [A: $tType,P: fun(set(A),$o),B3: set(A)] :
      ( aa(set(A),$o,P,bot_bot(set(A)))
     => ( ( ~ aa(set(A),$o,finite_finite(A),B3)
         => aa(set(A),$o,P,B3) )
       => ( ! [A7: set(A)] :
              ( aa(set(A),$o,finite_finite(A),A7)
             => ( ( A7 != bot_bot(set(A)) )
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A7),B3)
                 => ( ! [X4: A] :
                        ( member(A,X4,A7)
                       => aa(set(A),$o,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A7),aa(set(A),set(A),insert(A,X4),bot_bot(set(A))))) )
                   => aa(set(A),$o,P,A7) ) ) ) )
         => aa(set(A),$o,P,B3) ) ) ) ).

% remove_induct
tff(fact_5097_card__Diff1__le,axiom,
    ! [A: $tType,A3: set(A),X: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)) ).

% card_Diff1_le
tff(fact_5098_finite__induct__select,axiom,
    ! [A: $tType,S3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),S3)
     => ( aa(set(A),$o,P,bot_bot(set(A)))
       => ( ! [T6: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),T6),S3)
             => ( aa(set(A),$o,P,T6)
               => ? [X4: A] :
                    ( member(A,X4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),T6))
                    & aa(set(A),$o,P,aa(set(A),set(A),insert(A,X4),T6)) ) ) )
         => aa(set(A),$o,P,S3) ) ) ) ).

% finite_induct_select
tff(fact_5099_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),X: A,B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),aa(set(A),set(A),insert(A,X),B3))
    <=> $ite(
          member(A,X,B3),
          aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3),
          $ite(member(A,X,A3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),B3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)) ) ) ).

% psubset_insert_iff
tff(fact_5100_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] : ( set_or7035219750837199246ssThan(A,A2,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_5101_set__replicate__Suc,axiom,
    ! [A: $tType,Na: nat,X: A] : ( aa(list(A),set(A),set2(A),replicate(A,aa(nat,nat,suc,Na),X)) = aa(set(A),set(A),insert(A,X),bot_bot(set(A))) ) ).

% set_replicate_Suc
tff(fact_5102_set__replicate__conv__if,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( aa(list(A),set(A),set2(A),replicate(A,Na,X))
      = $ite(Na = zero_zero(nat),bot_bot(set(A)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) ) ).

% set_replicate_conv_if
tff(fact_5103_sum__diff1__nat,axiom,
    ! [A: $tType,F2: fun(A,nat),A3: set(A),A2: A] :
      ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
      = $ite(member(A,A2,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(A,nat,F2,A2)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)) ) ).

% sum_diff1_nat
tff(fact_5104_simp__from__to,axiom,
    ! [I2: int,J2: int] :
      ( set_or1337092689740270186AtMost(int,I2,J2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I2),bot_bot(set(int)),aa(set(int),set(int),insert(int,I2),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2))) ) ).

% simp_from_to
tff(fact_5105_prod__mono__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [I3: A] :
                ( member(A,I3,A3)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,I3))
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,I3)),aa(A,B,G,I3)) ) )
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)) ) ) ) ) ).

% prod_mono_strict
tff(fact_5106_card__2__iff,axiom,
    ! [A: $tType,S3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S3) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X5: A,Y5: A] :
          ( ( S3 = aa(set(A),set(A),insert(A,X5),aa(set(A),set(A),insert(A,Y5),bot_bot(set(A)))) )
          & ( X5 != Y5 ) ) ) ).

% card_2_iff
tff(fact_5107_sum_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,X),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ).

% sum.insert_remove
tff(fact_5108_sum_Oremove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),X: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,X)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% sum.remove
tff(fact_5109_sum__diff1,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),F2: fun(A,B),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
            = $ite(member(A,A2,A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(A,B,F2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)) ) ) ) ).

% sum_diff1
tff(fact_5110_card__3__iff,axiom,
    ! [A: $tType,S3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),S3) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
    <=> ? [X5: A,Y5: A,Z5: A] :
          ( ( S3 = aa(set(A),set(A),insert(A,X5),aa(set(A),set(A),insert(A,Y5),aa(set(A),set(A),insert(A,Z5),bot_bot(set(A))))) )
          & ( X5 != Y5 )
          & ( Y5 != Z5 )
          & ( X5 != Z5 ) ) ) ).

% card_3_iff
tff(fact_5111_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(A),nat,finite_card(A),A3))
     => ( A3 != bot_bot(set(A)) ) ) ).

% odd_card_imp_not_empty
tff(fact_5112_prod_Oremove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),X: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,X)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% prod.remove
tff(fact_5113_prod_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),insert(A,X),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,X)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ).

% prod.insert_remove
tff(fact_5114_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,X,A3)
       => ( aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) = aa(set(A),nat,finite_card(A),A3) ) ) ) ).

% card_Suc_Diff1
tff(fact_5115_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,X),A3)) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ).

% card.insert_remove
tff(fact_5116_card_Oremove,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,X,A3)
       => ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ).

% card.remove
tff(fact_5117_card__Diff1__less,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,X,A3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)) ) ) ).

% card_Diff1_less
tff(fact_5118_card__Diff2__less,axiom,
    ! [A: $tType,A3: set(A),X: A,Y: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,X,A3)
       => ( member(A,Y,A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)) ) ) ) ).

% card_Diff2_less
tff(fact_5119_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3))
    <=> ( aa(set(A),$o,finite_finite(A),A3)
        & member(A,X,A3) ) ) ).

% card_Diff1_less_iff
tff(fact_5120_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A3: set(A)] :
      ( member(A,X,A3)
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),one_one(nat)) ) ) ).

% card_Diff_singleton
tff(fact_5121_card__Diff__singleton__if,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))
      = $ite(member(A,X,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),one_one(nat)),aa(set(A),nat,finite_card(A),A3)) ) ).

% card_Diff_singleton_if
tff(fact_5122_sum_Odelta__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B),C2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_kv(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),B2),C2)),S3)
            = $ite(member(A,A2,S3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,B2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% sum.delta_remove
tff(fact_5123_prod_Odelta__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),A2: A,B2: fun(A,B),C2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_kw(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),B2),C2)),S3)
            = $ite(member(A,A2,S3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,B2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% prod.delta_remove
tff(fact_5124_member__le__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [I2: A,A3: set(A),F2: fun(A,B)] :
          ( member(A,I2,A3)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,I2),bot_bot(set(A)))))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F2,X3)) )
           => ( aa(set(A),$o,finite_finite(A),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,I2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)) ) ) ) ) ).

% member_le_sum
tff(fact_5125_sum__bounded__above__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(B)
     => ! [A3: set(A),F2: fun(A,B),K5: B] :
          ( ! [I3: A] :
              ( member(A,I3,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,I3)),aa(B,B,aa(B,fun(B,B),divide_divide(B),K5),aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),A3)))) )
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),K5) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_5126_prod__diff1,axiom,
    ! [B: $tType,A: $tType] :
      ( semidom_divide(B)
     => ! [A3: set(A),F2: fun(A,B),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( aa(A,B,F2,A2) != zero_zero(B) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
              = $ite(member(A,A2,A3),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(A,B,F2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ) ) ).

% prod_diff1
tff(fact_5127_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( sinh(A,X) = zero_zero(A) )
        <=> member(A,aa(A,A,exp(A),X),aa(set(A),set(A),insert(A,one_one(A)),aa(set(A),set(A),insert(A,aa(A,A,uminus_uminus(A),one_one(A))),bot_bot(set(A))))) ) ) ).

% sinh_zero_iff
tff(fact_5128_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set(A),A2: A] :
      ( ~ aa(set(A),$o,finite_finite(A),A3)
     => ? [H2: fun(A,A)] : bij_betw(A,A,H2,A3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw
tff(fact_5129_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),product_Pair(int,int,K),L))
     => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
        = $ite(
            ( member(int,K,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & member(int,L,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),K)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),L))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),K),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.psimps
tff(fact_5130_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Xa) = Y )
     => ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),product_Pair(int,int,X),Xa))
       => ~ ( ( Y
              = $ite(
                  ( member(int,X,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                  & member(int,Xa,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
                  aa(int,int,uminus_uminus(int),
                    aa($o,int,zero_neq_one_of_bool(int),
                      ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X)
                    & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
                  aa(int,int,
                    aa(int,fun(int,int),plus_plus(int),
                      aa($o,int,zero_neq_one_of_bool(int),
                        ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),X)
                      & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Xa))),
                    aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),X),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),Xa),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) )
           => ~ accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),product_Pair(int,int,X),Xa)) ) ) ) ).

% and_int.pelims
tff(fact_5131_bit__0__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( bit_se5641148757651400278ts_bit(A,zero_zero(A)) = bot_bot(fun(nat,$o)) ) ) ).

% bit_0_eq
tff(fact_5132_lessThan__0,axiom,
    set_ord_lessThan(nat,zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_5133_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_5134_set__encode__empty,axiom,
    aa(set(nat),nat,nat_set_encode,bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_5135_atLeastLessThan__singleton,axiom,
    ! [M: nat] : ( set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,M)) = aa(set(nat),set(nat),insert(nat,M),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_5136_atMost__0,axiom,
    set_ord_atMost(nat,zero_zero(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_5137_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_5138_bot__enat__def,axiom,
    bot_bot(extended_enat) = zero_zero(extended_enat) ).

% bot_enat_def
tff(fact_5139_atLeastLessThan0,axiom,
    ! [M: nat] : ( set_or7035219750837199246ssThan(nat,M,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_5140_lessThan__empty__iff,axiom,
    ! [Na: nat] :
      ( ( set_ord_lessThan(nat,Na) = bot_bot(set(nat)) )
    <=> ( Na = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_5141_atLeastLessThanSuc,axiom,
    ! [M: nat,Na: nat] :
      ( set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,Na))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na),aa(set(nat),set(nat),insert(nat,Na),set_or7035219750837199246ssThan(nat,M,Na)),bot_bot(set(nat))) ) ).

% atLeastLessThanSuc
tff(fact_5142_atLeast1__lessThan__eq__remove0,axiom,
    ! [Na: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),Na) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_lessThan(nat,Na)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_5143_atLeast1__atMost__eq__remove0,axiom,
    ! [Na: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),Na) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atMost(nat,Na)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_5144_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( set_or7035219750837199246ssThan(nat,M,aa(num,nat,numeral_numeral(nat),K))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),pred_numeral(K)),aa(set(nat),set(nat),insert(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M,pred_numeral(K))),bot_bot(set(nat))) ) ).

% atLeastLessThan_nat_numeral
tff(fact_5145_dependent__nat__choice,axiom,
    ! [A: $tType,P: fun(nat,fun(A,$o)),Q: fun(nat,fun(A,fun(A,$o)))] :
      ( ? [X_12: A] : aa(A,$o,aa(nat,fun(A,$o),P,zero_zero(nat)),X_12)
     => ( ! [X3: A,N: nat] :
            ( aa(A,$o,aa(nat,fun(A,$o),P,N),X3)
           => ? [Y3: A] :
                ( aa(A,$o,aa(nat,fun(A,$o),P,aa(nat,nat,suc,N)),Y3)
                & aa(A,$o,aa(A,fun(A,$o),aa(nat,fun(A,fun(A,$o)),Q,N),X3),Y3) ) )
       => ? [F4: fun(nat,A)] :
          ! [N6: nat] :
            ( aa(A,$o,aa(nat,fun(A,$o),P,N6),aa(nat,A,F4,N6))
            & aa(A,$o,aa(A,fun(A,$o),aa(nat,fun(A,fun(A,$o)),Q,N6),aa(nat,A,F4,N6)),aa(nat,A,F4,aa(nat,nat,suc,N6))) ) ) ) ).

% dependent_nat_choice
tff(fact_5146_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,$o))] :
      ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),product_Pair(int,int,A0),A1))
     => ( ! [K2: int,L2: int] :
            ( accp(product_prod(int,int),bit_and_int_rel,aa(int,product_prod(int,int),product_Pair(int,int,K2),L2))
           => ( ( ~ ( member(int,K2,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                    & member(int,L2,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) )
               => aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),divide_divide(int),K2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),aa(int,int,aa(int,fun(int,int),divide_divide(int),L2),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) )
             => aa(int,$o,aa(int,fun(int,$o),P,K2),L2) ) )
       => aa(int,$o,aa(int,fun(int,$o),P,A0),A1) ) ) ).

% and_int.pinduct
tff(fact_5147_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,$o))] :
      ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),product_Pair(int,int,A0),A1))
     => ( ! [I3: int,J3: int] :
            ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),product_Pair(int,int,I3),J3))
           => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J3)
               => aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))),J3) )
             => aa(int,$o,aa(int,fun(int,$o),P,I3),J3) ) )
       => aa(int,$o,aa(int,fun(int,$o),P,A0),A1) ) ) ).

% upto.pinduct
tff(fact_5148_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [F3: set(A),I5: set(A),F2: fun(A,B),I2: A] :
          ( aa(set(A),$o,finite_finite(A),F3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_kx(set(A),fun(fun(A,B),fun(A,$o)),I5),F2))),F3)
           => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert(A,I2),bot_bot(set(A)))))
              = $ite(member(A,I2,I5),aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F2,I5)),aa(A,B,F2,I2)),groups1027152243600224163dd_sum(A,B,F2,I5)) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_5149_set__update__distinct,axiom,
    ! [A: $tType,Xs: list(A),Na: nat,X: A] :
      ( distinct(A,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(list(A),set(A),set2(A),list_update(A,Xs,Na,X)) = aa(set(A),set(A),insert(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),Na)),bot_bot(set(A))))) ) ) ) ).

% set_update_distinct
tff(fact_5150_length__list__update,axiom,
    ! [A: $tType,Xs: list(A),I2: nat,X: A] : ( aa(list(A),nat,size_size(list(A)),list_update(A,Xs,I2,X)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_list_update
tff(fact_5151_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P3: fun(B,A)] : ( groups1027152243600224163dd_sum(B,A,P3,bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty'
tff(fact_5152_list__update__beyond,axiom,
    ! [A: $tType,Xs: list(A),I2: nat,X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),I2)
     => ( list_update(A,Xs,I2,X) = Xs ) ) ).

% list_update_beyond
tff(fact_5153_nth__list__update__eq,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,list_update(A,Xs,I2,X)),I2) = X ) ) ).

% nth_list_update_eq
tff(fact_5154_set__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(list(A),set(A),set2(A),list_update(A,list_update(A,Xs,I2,aa(nat,A,nth(A,Xs),J2)),J2,aa(nat,A,nth(A,Xs),I2))) = aa(list(A),set(A),set2(A),Xs) ) ) ) ).

% set_swap
tff(fact_5155_distinct__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
       => ( distinct(A,list_update(A,list_update(A,Xs,I2,aa(nat,A,nth(A,Xs),J2)),J2,aa(nat,A,nth(A,Xs),I2)))
        <=> distinct(A,Xs) ) ) ) ).

% distinct_swap
tff(fact_5156_sum_Oinsert_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),P3: fun(A,B),I2: A] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jo(set(A),fun(fun(A,B),fun(A,$o)),I5),P3)))
         => ( groups1027152243600224163dd_sum(A,B,P3,aa(set(A),set(A),insert(A,I2),I5))
            = $ite(member(A,I2,I5),groups1027152243600224163dd_sum(A,B,P3,I5),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,P3,I2)),groups1027152243600224163dd_sum(A,B,P3,I5))) ) ) ) ).

% sum.insert'
tff(fact_5157_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1027152243600224163dd_sum(B,A,G,collect(B,aa(set(B),fun(B,$o),aTP_Lamp_ky(fun(B,A),fun(set(B),fun(B,$o)),G),I5))) = groups1027152243600224163dd_sum(B,A,G,I5) ) ) ).

% sum.non_neutral'
tff(fact_5158_sum_Odistrib__triv_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( groups1027152243600224163dd_sum(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_kz(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),plus_plus(B),groups1027152243600224163dd_sum(A,B,G,I5)),groups1027152243600224163dd_sum(A,B,H,I5)) ) ) ) ).

% sum.distrib_triv'
tff(fact_5159_set__update__memI,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => member(A,X,aa(list(A),set(A),set2(A),list_update(A,Xs,Na,X))) ) ).

% set_update_memI
tff(fact_5160_list__update__same__conv,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( ( list_update(A,Xs,I2,X) = Xs )
      <=> ( aa(nat,A,nth(A,Xs),I2) = X ) ) ) ).

% list_update_same_conv
tff(fact_5161_nth__list__update,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),X: A,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,list_update(A,Xs,I2,X)),J2)
        = $ite(I2 = J2,X,aa(nat,A,nth(A,Xs),J2)) ) ) ).

% nth_list_update
tff(fact_5162_sum_Omono__neutral__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,G,X3) = zero_zero(B) ) )
           => ( groups1027152243600224163dd_sum(A,B,G,S3) = groups1027152243600224163dd_sum(A,B,G,T5) ) ) ) ) ).

% sum.mono_neutral_left'
tff(fact_5163_sum_Omono__neutral__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,G,X3) = zero_zero(B) ) )
           => ( groups1027152243600224163dd_sum(A,B,G,T5) = groups1027152243600224163dd_sum(A,B,G,S3) ) ) ) ) ).

% sum.mono_neutral_right'
tff(fact_5164_sum_Omono__neutral__cong__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T5: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [I3: A] :
                ( member(A,I3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,H,I3) = zero_zero(B) ) )
           => ( ! [X3: A] :
                  ( member(A,X3,S3)
                 => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
             => ( groups1027152243600224163dd_sum(A,B,G,S3) = groups1027152243600224163dd_sum(A,B,H,T5) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
tff(fact_5165_sum_Omono__neutral__cong__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S3: set(A),T5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,G,X3) = zero_zero(B) ) )
           => ( ! [X3: A] :
                  ( member(A,X3,S3)
                 => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
             => ( groups1027152243600224163dd_sum(A,B,G,T5) = groups1027152243600224163dd_sum(A,B,H,S3) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
tff(fact_5166_sum_Odistrib_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jo(set(A),fun(fun(A,B),fun(A,$o)),I5),G)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jo(set(A),fun(fun(A,B),fun(A,$o)),I5),H)))
           => ( groups1027152243600224163dd_sum(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_kz(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),plus_plus(B),groups1027152243600224163dd_sum(A,B,G,I5)),groups1027152243600224163dd_sum(A,B,H,I5)) ) ) ) ) ).

% sum.distrib'
tff(fact_5167_sum_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P3: fun(B,A),I5: set(B)] :
          ( groups1027152243600224163dd_sum(B,A,P3,I5)
          = $ite(aa(set(B),$o,finite_finite(B),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_ky(fun(B,A),fun(set(B),fun(B,$o)),P3),I5))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),P3),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_ky(fun(B,A),fun(set(B),fun(B,$o)),P3),I5))),zero_zero(A)) ) ) ).

% sum.G_def
tff(fact_5168_distinct__list__update,axiom,
    ! [A: $tType,Xs: list(A),A2: A,I2: nat] :
      ( distinct(A,Xs)
     => ( ~ member(A,A2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),I2)),bot_bot(set(A)))))
       => distinct(A,list_update(A,Xs,I2,A2)) ) ) ).

% distinct_list_update
tff(fact_5169_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [I5: set(A),F2: fun(A,B),I2: A] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_kx(set(A),fun(fun(A,B),fun(A,$o)),I5),F2)))
         => ( groups1027152243600224163dd_sum(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert(A,I2),bot_bot(set(A)))))
            = $ite(member(A,I2,I5),aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F2,I5)),aa(A,B,F2,I2)),groups1027152243600224163dd_sum(A,B,F2,I5)) ) ) ) ).

% sum_diff1'
tff(fact_5170_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [F2: fun(A,B),A3: set(A)] :
          ( strict_mono_on(A,B,F2,A3)
        <=> ! [R5: A,S5: A] :
              ( ( member(A,R5,A3)
                & member(A,S5,A3)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),R5),S5) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,R5)),aa(A,B,F2,S5)) ) ) ) ).

% strict_mono_on_def
tff(fact_5171_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [R: A,S2: A] :
              ( member(A,R,A3)
             => ( member(A,S2,A3)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),R),S2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,R)),aa(A,B,F2,S2)) ) ) )
         => strict_mono_on(A,B,F2,A3) ) ) ).

% strict_mono_onI
tff(fact_5172_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & ord(B) )
     => ! [F2: fun(A,B),A3: set(A),R2: A,S: A] :
          ( strict_mono_on(A,B,F2,A3)
         => ( member(A,R2,A3)
           => ( member(A,S,A3)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),R2),S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,R2)),aa(A,B,F2,S)) ) ) ) ) ) ).

% strict_mono_onD
tff(fact_5173_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            L = zero_zero(code_integer),
            aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),K),
            aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),$ite(aa(code_integer,code_integer,sgn_sgn(code_integer),K) = aa(code_integer,code_integer,sgn_sgn(code_integer),L),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_la(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_5174_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list(A),X: A] :
      ( distinct(A,Xs)
     => ( aa(list(A),set(A),set2(A),remove1(A,X,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) ) ) ).

% set_remove1_eq
tff(fact_5175_card__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or5935395276787703475ssThan(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),U),aa(int,int,aa(int,fun(int,int),plus_plus(int),L),one_one(int)))) ) ).

% card_greaterThanLessThan_int
tff(fact_5176_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I2: A,L: A,U: A] :
          ( member(A,I2,set_or5935395276787703475ssThan(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),I2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),I2),U) ) ) ) ).

% greaterThanLessThan_iff
tff(fact_5177_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(set(A),$o,finite_finite(A),set_or5935395276787703475ssThan(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Ioo_iff
tff(fact_5178_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(set(A),$o,finite_finite(A),set_or5935395276787703475ssThan(A,A2,B2)) ) ) ).

% infinite_Ioo
tff(fact_5179_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(B)
        & comm_monoid_add(A) )
     => ! [H: fun(B,A),G: fun(C,B),A3: set(C)] :
          ( ( aa(B,A,H,zero_zero(B)) = zero_zero(A) )
         => ( ! [X3: B,Y4: B] : ( aa(B,A,H,aa(B,B,aa(B,fun(B,B),plus_plus(B),X3),Y4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,H,X3)),aa(B,A,H,Y4)) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(C,B),fun(C,A),comp(B,A,C,H),G)),A3) = aa(B,A,H,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A3)) ) ) ) ) ).

% sum_comp_morphism
tff(fact_5180_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or5935395276787703475ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
tff(fact_5181_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] : ( set_or7035219750837199246ssThan(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),L),one_one(int)),U) = set_or5935395276787703475ssThan(int,L,U) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
tff(fact_5182_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
tff(fact_5183_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
tff(fact_5184_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))) = set_or5935395276787703475ssThan(A,A2,B2) ) ) ).

% atLeastAtMost_diff_ends
tff(fact_5185_length__remove1,axiom,
    ! [A: $tType,X: A,Xs: list(A)] :
      ( aa(list(A),nat,size_size(list(A)),remove1(A,X,Xs))
      = $ite(member(A,X,aa(list(A),set(A),set2(A),Xs)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_remove1
tff(fact_5186_div__add__self2__no__field,axiom,
    ! [A: $tType,B: $tType] :
      ( ( euclid4440199948858584721cancel(B)
        & field(A) )
     => ! [X: A,B2: B,A2: B] :
          ( nO_MATCH(A,B,X,B2)
         => ( ( B2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A2),B2)),one_one(B)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_5187_div__add__self1__no__field,axiom,
    ! [A: $tType,B: $tType] :
      ( ( euclid4440199948858584721cancel(B)
        & field(A) )
     => ! [X: A,B2: B,A2: B] :
          ( nO_MATCH(A,B,X,B2)
         => ( ( B2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),A2)),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),divide_divide(B),A2),B2)),one_one(B)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_5188_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A2: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_lb(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F2),A2),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_5189_Suc__funpow,axiom,
    ! [Na: nat] : ( aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),compow(fun(nat,nat)),Na),suc) = aa(nat,fun(nat,nat),plus_plus(nat),Na) ) ).

% Suc_funpow
tff(fact_5190_funpow__0,axiom,
    ! [A: $tType,F2: fun(A,A),X: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F2),X) = X ) ).

% funpow_0
tff(fact_5191_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or5935395276787703475ssThan(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),aa(nat,nat,suc,L)) ) ).

% card_greaterThanLessThan
tff(fact_5192_comp__funpow,axiom,
    ! [A: $tType,B: $tType,Na: nat,F2: fun(B,B)] : ( aa(fun(fun(A,B),fun(A,B)),fun(fun(A,B),fun(A,B)),aa(nat,fun(fun(fun(A,B),fun(A,B)),fun(fun(A,B),fun(A,B))),compow(fun(fun(A,B),fun(A,B))),Na),comp(B,B,A,F2)) = comp(B,B,A,aa(fun(B,B),fun(B,B),aa(nat,fun(fun(B,B),fun(B,B)),compow(fun(B,B)),Na),F2)) ) ).

% comp_funpow
tff(fact_5193_card_Ocomp__fun__commute__on,axiom,
    aa(fun(nat,nat),fun(nat,nat),comp(nat,nat,nat,suc),suc) = aa(fun(nat,nat),fun(nat,nat),comp(nat,nat,nat,suc),suc) ).

% card.comp_fun_commute_on
tff(fact_5194_funpow__mod__eq,axiom,
    ! [A: $tType,Na: nat,F2: fun(A,A),X: A,M: nat] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),X) = X )
     => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),modulo_modulo(nat,M,Na)),F2),X) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2),X) ) ) ).

% funpow_mod_eq
tff(fact_5195_funpow__swap1,axiom,
    ! [A: $tType,F2: fun(A,A),Na: nat,X: A] : ( aa(A,A,F2,aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),X)) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),aa(A,A,F2,X)) ) ).

% funpow_swap1
tff(fact_5196_funpow__mult,axiom,
    ! [A: $tType,Na: nat,M: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),F2) ) ).

% funpow_mult
tff(fact_5197_bij__betw__funpow,axiom,
    ! [A: $tType,F2: fun(A,A),S3: set(A),Na: nat] :
      ( bij_betw(A,A,F2,S3,S3)
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),S3,S3) ) ).

% bij_betw_funpow
tff(fact_5198_funpow__times__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [F2: fun(A,nat),X: A] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(A,nat,F2,X)),aa(A,fun(A,A),times_times(A),X)) = aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(A,nat,F2,X))) ) ) ).

% funpow_times_power
tff(fact_5199_funpow__Suc__right,axiom,
    ! [A: $tType,Na: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,Na)),F2) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2)),F2) ) ).

% funpow_Suc_right
tff(fact_5200_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,Na: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,Na)),F2) = aa(fun(A,A),fun(A,A),comp(A,A,A,F2),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2)) ) ).

% funpow.simps(2)
tff(fact_5201_funpow__add,axiom,
    ! [A: $tType,M: nat,Na: nat,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),F2) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2)),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2)) ) ).

% funpow_add
tff(fact_5202_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,L),U) = set_or5935395276787703475ssThan(nat,L,U) ) ).

% atLeastSucLessThan_greaterThanLessThan
tff(fact_5203_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
tff(fact_5204_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
tff(fact_5205_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% sum.atLeastAtMost_shift_bounds
tff(fact_5206_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% sum.atLeastLessThan_shift_bounds
tff(fact_5207_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
tff(fact_5208_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
tff(fact_5209_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% prod.atLeastAtMost_shift_bounds
tff(fact_5210_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% prod.atLeastLessThan_shift_bounds
tff(fact_5211_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [Na: nat,A2: A] : ( bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se4197421643247451524op_bit(A,Na),A2)) = aa(fun(nat,nat),fun(nat,$o),comp(nat,$o,nat,bit_se5641148757651400278ts_bit(A,A2)),aa(nat,fun(nat,nat),plus_plus(nat),Na)) ) ) ).

% bit_drop_bit_eq
tff(fact_5212_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),comp(A,A,nat,inverse_inverse(A)),F2))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_lc(fun(nat,A),fun(A,fun(nat,A)),F2),C2)) ) ) ).

% summable_inverse_divide
tff(fact_5213_tanh__real__bounds,axiom,
    ! [X: real] : member(real,aa(real,real,tanh(real),X),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real))) ).

% tanh_real_bounds
tff(fact_5214_of__nat__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] : ( aa(nat,A,semiring_1_of_nat(A),Na) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% of_nat_def
tff(fact_5215_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),K)),A2) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),A2) ) ) ).

% numeral_add_unfold_funpow
tff(fact_5216_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,Y: A,A2: real] :
          ( nO_MATCH(A,real,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),A2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ) ).

% scale_right_distrib_NO_MATCH
tff(fact_5217_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,Y: A,A2: real] :
          ( nO_MATCH(A,real,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),A2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
tff(fact_5218_distrib__left__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring(B)
     => ! [X: A,Y: A,A2: B,B2: B,C2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),A2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A2),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_5219_distrib__right__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring(B)
     => ! [X: A,Y: A,C2: B,A2: B,B2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),C2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),B2),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_5220_right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( ring(B)
     => ! [X: A,Y: A,A2: B,B2: B,C2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),A2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),B2),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_5221_left__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( ring(B)
     => ! [X: A,Y: A,C2: B,A2: B,B2: B] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),C2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A2),B2)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),B2),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_5222_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),K) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% numeral_unfold_funpow
tff(fact_5223_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))) ) ) ).

% sum.atLeast0_atMost_Suc_shift
tff(fact_5224_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
tff(fact_5225_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_5226_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Na))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_5227_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))) ) ) ).

% sum.atLeastLessThan_shift_0
tff(fact_5228_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))) ) ) ).

% prod.atLeastLessThan_shift_0
tff(fact_5229_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ld(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_5230_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ld(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_5231_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ld(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_5232_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,Na: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ld(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,Na)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_5233_power__minus_H,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A,Na: nat] :
          ( nO_MATCH(A,A,one_one(A),X)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),X)),Na) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na)) ) ) ) ).

% power_minus'
tff(fact_5234_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))) ) ) ) ).

% sum.atLeastAtMost_shift_0
tff(fact_5235_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))) ) ) ) ).

% prod.atLeastAtMost_shift_0
tff(fact_5236_scale__left__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,Y: A,C2: B,A2: real,B2: real] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X)) ) ) ) ).

% scale_left_distrib_NO_MATCH
tff(fact_5237_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,Y: A,C2: B,A2: real,B2: real] :
          ( nO_MATCH(A,B,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),X) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),X)),aa(A,A,real_V8093663219630862766scaleR(A,B2),X)) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
tff(fact_5238_Code__Numeral_Onegative__def,axiom,
    code_negative = aa(fun(num,code_integer),fun(num,code_integer),comp(code_integer,code_integer,num,uminus_uminus(code_integer)),numeral_numeral(code_integer)) ).

% Code_Numeral.negative_def
tff(fact_5239_Code__Target__Int_Onegative__def,axiom,
    code_Target_negative = aa(fun(num,int),fun(num,int),comp(int,int,num,uminus_uminus(int)),numeral_numeral(int)) ).

% Code_Target_Int.negative_def
tff(fact_5240_relpowp__fun__conv,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Y: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),X),Y)
    <=> ? [F5: fun(nat,A)] :
          ( ( aa(nat,A,F5,zero_zero(nat)) = X )
          & ( aa(nat,A,F5,Na) = Y )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Na)
             => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,F5,I)),aa(nat,A,F5,aa(nat,nat,suc,I))) ) ) ) ).

% relpowp_fun_conv
tff(fact_5241_relpowp__1,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o))] : ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),one_one(nat)),P) = P ) ).

% relpowp_1
tff(fact_5242_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X: A,Y: A,Na: nat,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),P,X),Y)
     => ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),Y),Z)
       => aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Na)),P),X),Z) ) ) ).

% relpowp_Suc_I2
tff(fact_5243_relpowp__Suc__E2,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Na)),P),X),Z)
     => ~ ! [Y4: A] :
            ( aa(A,$o,aa(A,fun(A,$o),P,X),Y4)
           => ~ aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),Y4),Z) ) ) ).

% relpowp_Suc_E2
tff(fact_5244_relpowp__Suc__D2,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Na)),P),X),Z)
     => ? [Y4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),P,X),Y4)
          & aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),Y4),Z) ) ) ).

% relpowp_Suc_D2
tff(fact_5245_relpowp__Suc__I,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Y: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),X),Y)
     => ( aa(A,$o,aa(A,fun(A,$o),P,Y),Z)
       => aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Na)),P),X),Z) ) ) ).

% relpowp_Suc_I
tff(fact_5246_relpowp__Suc__E,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,Na)),P),X),Z)
     => ~ ! [Y4: A] :
            ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),X),Y4)
           => ~ aa(A,$o,aa(A,fun(A,$o),P,Y4),Z) ) ) ).

% relpowp_Suc_E
tff(fact_5247_relpowp__0__I,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X: A] : aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),P),X),X) ).

% relpowp_0_I
tff(fact_5248_relpowp__0__E,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),X: A,Y: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),P),X),Y)
     => ( X = Y ) ) ).

% relpowp_0_E
tff(fact_5249_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R3: fun(A,fun(A,$o))] : ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),R3) = fequal(A) ) ).

% relpowp.simps(1)
tff(fact_5250_relpowp__E,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),X),Z)
     => ( ( ( Na = zero_zero(nat) )
         => ( X != Z ) )
       => ~ ! [Y4: A,M4: nat] :
              ( ( Na = aa(nat,nat,suc,M4) )
             => ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),M4),P),X),Y4)
               => ~ aa(A,$o,aa(A,fun(A,$o),P,Y4),Z) ) ) ) ) ).

% relpowp_E
tff(fact_5251_relpowp__E2,axiom,
    ! [A: $tType,Na: nat,P: fun(A,fun(A,$o)),X: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),P),X),Z)
     => ( ( ( Na = zero_zero(nat) )
         => ( X != Z ) )
       => ~ ! [Y4: A,M4: nat] :
              ( ( Na = aa(nat,nat,suc,M4) )
             => ( aa(A,$o,aa(A,fun(A,$o),P,X),Y4)
               => ~ aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),M4),P),Y4),Z) ) ) ) ) ).

% relpowp_E2
tff(fact_5252_relpowp__bot,axiom,
    ! [A: $tType,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),Na),bot_bot(fun(A,fun(A,$o)))) = bot_bot(fun(A,fun(A,$o))) ) ) ).

% relpowp_bot
tff(fact_5253_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] : ( funpow(A) = compow(fun(A,A)) ) ).

% Nat.funpow_code_def
tff(fact_5254_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer))
     => ( aa(code_integer,nat,code_nat_of_integer,K) = zero_zero(nat) ) ) ).

% nat_of_integer_non_positive
tff(fact_5255_max__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,ord_max(nat),zero_zero(nat),aTP_Lamp_kl(nat,fun(nat,$o)),aTP_Lamp_ej(nat,fun(nat,$o))) ).

% max_nat.semilattice_neutr_order_axioms
tff(fact_5256_of__nat__of__integer,axiom,
    ! [K: code_integer] : ( aa(nat,code_integer,semiring_1_of_nat(code_integer),aa(code_integer,nat,code_nat_of_integer,K)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),ord_max(code_integer),zero_zero(code_integer)),K) ) ).

% of_nat_of_integer
tff(fact_5257_nat__of__integer__code__post_I1_J,axiom,
    aa(code_integer,nat,code_nat_of_integer,zero_zero(code_integer)) = zero_zero(nat) ).

% nat_of_integer_code_post(1)
tff(fact_5258_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] : ( aa(code_integer,nat,code_nat_of_integer,aa(num,code_integer,numeral_numeral(code_integer),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_of_integer_code_post(3)
tff(fact_5259_nat__of__integer__code__post_I2_J,axiom,
    aa(code_integer,nat,code_nat_of_integer,one_one(code_integer)) = one_one(nat) ).

% nat_of_integer_code_post(2)
tff(fact_5260_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,gcd_gcd(nat),zero_zero(nat),dvd_dvd(nat),aTP_Lamp_le(nat,fun(nat,$o))) ).

% gcd_nat.semilattice_neutr_order_axioms
tff(fact_5261_nat__of__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,nat,code_nat_of_integer,K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer)),zero_zero(nat),aa(product_prod(code_integer,code_integer),nat,product_case_prod(code_integer,code_integer,nat,aTP_Lamp_lf(code_integer,fun(code_integer,nat))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% nat_of_integer_code
tff(fact_5262_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),removeAll(A,X,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) ) ).

% set_removeAll
tff(fact_5263_int__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_int_of_integer(K)
      = $ite(
          aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),
          aa(int,int,uminus_uminus(int),code_int_of_integer(aa(code_integer,code_integer,uminus_uminus(code_integer),K))),
          $ite(K = zero_zero(code_integer),zero_zero(int),aa(product_prod(code_integer,code_integer),int,product_case_prod(code_integer,code_integer,int,aTP_Lamp_lg(code_integer,fun(code_integer,int))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ) ).

% int_of_integer_code
tff(fact_5264_zero__integer_Orep__eq,axiom,
    code_int_of_integer(zero_zero(code_integer)) = zero_zero(int) ).

% zero_integer.rep_eq
tff(fact_5265_int__of__integer__numeral,axiom,
    ! [K: num] : ( code_int_of_integer(aa(num,code_integer,numeral_numeral(code_integer),K)) = aa(num,int,numeral_numeral(int),K) ) ).

% int_of_integer_numeral
tff(fact_5266_one__integer_Orep__eq,axiom,
    code_int_of_integer(one_one(code_integer)) = one_one(int) ).

% one_integer.rep_eq
tff(fact_5267_minus__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),X),Xa)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),code_int_of_integer(X)),code_int_of_integer(Xa)) ) ).

% minus_integer.rep_eq
tff(fact_5268_divide__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),X),Xa)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),code_int_of_integer(X)),code_int_of_integer(Xa)) ) ).

% divide_integer.rep_eq
tff(fact_5269_integer__less__iff,axiom,
    ! [K: code_integer,L: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),L)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),code_int_of_integer(K)),code_int_of_integer(L)) ) ).

% integer_less_iff
tff(fact_5270_less__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),X),Xa)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),code_int_of_integer(X)),code_int_of_integer(Xa)) ) ).

% less_integer.rep_eq
tff(fact_5271_gcd__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),X),Xa)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),code_int_of_integer(X)),code_int_of_integer(Xa)) ) ).

% gcd_integer.rep_eq
tff(fact_5272_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),removeAll(A,X,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_removeAll_less_eq
tff(fact_5273_unset__bit__integer_Orep__eq,axiom,
    ! [X: nat,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se2638667681897837118et_bit(code_integer),X),Xa)) = aa(int,int,aa(nat,fun(int,int),bit_se2638667681897837118et_bit(int),X),code_int_of_integer(Xa)) ) ).

% unset_bit_integer.rep_eq
tff(fact_5274_set__bit__integer_Orep__eq,axiom,
    ! [X: nat,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se5668285175392031749et_bit(code_integer),X),Xa)) = aa(int,int,aa(nat,fun(int,int),bit_se5668285175392031749et_bit(int),X),code_int_of_integer(Xa)) ) ).

% set_bit_integer.rep_eq
tff(fact_5275_flip__bit__integer_Orep__eq,axiom,
    ! [X: nat,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(nat,fun(code_integer,code_integer),bit_se8732182000553998342ip_bit(code_integer),X),Xa)) = aa(int,int,aa(nat,fun(int,int),bit_se8732182000553998342ip_bit(int),X),code_int_of_integer(Xa)) ) ).

% flip_bit_integer.rep_eq
tff(fact_5276_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs: list(A)] :
      ( member(A,X,aa(list(A),set(A),set2(A),Xs))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),removeAll(A,X,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_removeAll_less
tff(fact_5277_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_li(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% times_int.abs_eq
tff(fact_5278_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ~ ? [X4: A] :
                  ( member(A,X4,S3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X4)),aa(A,B,F2,lattic7623131987881927897min_on(A,B,F2,S3))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_5279_Gcd__remove0__nat,axiom,
    ! [M10: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M10)
     => ( gcd_Gcd(nat,M10) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M10),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_5280_Gcd__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_empty
tff(fact_5281_Gcd__insert,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),gcd_Gcd(A,A3)) ) ) ).

% Gcd_insert
tff(fact_5282_Gcd__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,B2: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% Gcd_2
tff(fact_5283_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Gcd(A,A3) = zero_zero(A) )
        <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A)))) ) ) ).

% Gcd_0_iff
tff(fact_5284_Gcd__nat__eq__one,axiom,
    ! [N3: set(nat)] :
      ( member(nat,one_one(nat),N3)
     => ( gcd_Gcd(nat,N3) = one_one(nat) ) ) ).

% Gcd_nat_eq_one
tff(fact_5285_Gcd__1,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( member(A,one_one(A),A3)
         => ( gcd_Gcd(A,A3) = one_one(A) ) ) ) ).

% Gcd_1
tff(fact_5286_Gcd__dvd__nat,axiom,
    ! [A2: nat,A3: set(nat)] :
      ( member(nat,A2,A3)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),gcd_Gcd(nat,A3)),A2) ) ).

% Gcd_dvd_nat
tff(fact_5287_Gcd__greatest__nat,axiom,
    ! [A3: set(nat),A2: nat] :
      ( ! [B4: nat] :
          ( member(nat,B4,A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B4) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),gcd_Gcd(nat,A3)) ) ).

% Gcd_greatest_nat
tff(fact_5288_Gcd__dvd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),gcd_Gcd(A,A3)),A2) ) ) ).

% Gcd_dvd
tff(fact_5289_dvd__GcdD,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [X: A,A3: set(A),Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),gcd_Gcd(A,A3))
         => ( member(A,Y,A3)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y) ) ) ) ).

% dvd_GcdD
tff(fact_5290_dvd__Gcd__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [X: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),gcd_Gcd(A,A3))
        <=> ! [X5: A] :
              ( member(A,X5,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),X5) ) ) ) ).

% dvd_Gcd_iff
tff(fact_5291_Gcd__greatest,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),A2: A] :
          ( ! [B4: A] :
              ( member(A,B4,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),gcd_Gcd(A,A3)) ) ) ).

% Gcd_greatest
tff(fact_5292_int_Oabs__induct,axiom,
    ! [P: fun(int,$o),X: int] :
      ( ! [Y4: product_prod(nat,nat)] : aa(int,$o,P,aa(product_prod(nat,nat),int,abs_Integ,Y4))
     => aa(int,$o,P,X) ) ).

% int.abs_induct
tff(fact_5293_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X3: nat,Y4: nat] : ( Z != aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Y4)) ) ).

% eq_Abs_Integ
tff(fact_5294_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( member(A,A2,A3)
           => ( gcd_Gcd(A,A3) = one_one(A) ) ) ) ) ).

% Gcd_eq_1_I
tff(fact_5295_nat_Oabs__eq,axiom,
    ! [X: product_prod(nat,nat)] : ( aa(int,nat,nat2,aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),nat,product_case_prod(nat,nat,nat,minus_minus(nat)),X) ) ).

% nat.abs_eq
tff(fact_5296_Gcd__in,axiom,
    ! [A3: set(nat)] :
      ( ! [A4: nat,B4: nat] :
          ( member(nat,A4,A3)
         => ( member(nat,B4,A3)
           => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A4),B4),A3) ) )
     => ( ( A3 != bot_bot(set(nat)) )
       => member(nat,gcd_Gcd(nat,A3),A3) ) ) ).

% Gcd_in
tff(fact_5297_zero__int__def,axiom,
    zero_zero(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))) ).

% zero_int_def
tff(fact_5298_int__def,axiom,
    ! [Na: nat] : ( aa(nat,int,semiring_1_of_nat(int),Na) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Na),zero_zero(nat))) ) ).

% int_def
tff(fact_5299_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_lj(nat,fun(nat,product_prod(nat,nat)))),X)) ) ).

% uminus_int.abs_eq
tff(fact_5300_one__int__def,axiom,
    one_one(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))) ).

% one_int_def
tff(fact_5301_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: product_prod(nat,nat)] : ( aa(int,A,ring_1_of_int(A),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_lk(nat,fun(nat,A))),X) ) ) ).

% of_int.abs_eq
tff(fact_5302_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa),X) ) ).

% less_int.abs_eq
tff(fact_5303_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa),X) ) ).

% less_eq_int.abs_eq
tff(fact_5304_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_lq(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% plus_int.abs_eq
tff(fact_5305_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ls(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% minus_int.abs_eq
tff(fact_5306_semiring__char__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: itself(A)] : ( semiri4206861660011772517g_char(A,Uu) = gcd_Gcd(nat,collect(nat,aTP_Lamp_lt(nat,$o))) ) ) ).

% semiring_char_def
tff(fact_5307_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_5308_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X)) = one_one(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_5309_abs__Gcd__eq,axiom,
    ! [K5: set(int)] : ( aa(int,int,abs_abs(int),gcd_Gcd(int,K5)) = gcd_Gcd(int,K5) ) ).

% abs_Gcd_eq
tff(fact_5310_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: num] :
          ( ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ) ).

% iszero_neg_numeral
tff(fact_5311_Gcd__greatest__int,axiom,
    ! [A3: set(int),A2: int] :
      ( ! [B4: int] :
          ( member(int,B4,A3)
         => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),B4) )
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),gcd_Gcd(int,A3)) ) ).

% Gcd_greatest_int
tff(fact_5312_Gcd__dvd__int,axiom,
    ! [A2: int,A3: set(int)] :
      ( member(int,A2,A3)
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),gcd_Gcd(int,A3)),A2) ) ).

% Gcd_dvd_int
tff(fact_5313_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: num] : ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ).

% not_iszero_numeral
tff(fact_5314_iszero__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] :
          ( ring_1_iszero(A,Z)
        <=> ( Z = zero_zero(A) ) ) ) ).

% iszero_def
tff(fact_5315_iszero__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ring_1_iszero(A,zero_zero(A)) ) ).

% iszero_0
tff(fact_5316_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,one_one(A)) ) ).

% not_iszero_1
tff(fact_5317_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A,Y: A] :
          ( ( X = Y )
        <=> ring_1_iszero(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) ) ) ).

% eq_iff_iszero_diff
tff(fact_5318_Gcd__int__greater__eq__0,axiom,
    ! [K5: set(int)] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),gcd_Gcd(int,K5)) ).

% Gcd_int_greater_eq_0
tff(fact_5319_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num] :
          ( ( aa(num,A,numeral_numeral(A),X) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),X)) ) ) ).

% eq_numeral_iff_iszero(9)
tff(fact_5320_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( zero_zero(A) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y)) ) ) ).

% eq_numeral_iff_iszero(10)
tff(fact_5321_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),one2)) ) ).

% not_iszero_Numeral1
tff(fact_5322_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_iszero_neg_1
tff(fact_5323_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num,Y: num] :
          ( ( aa(num,A,numeral_numeral(A),X) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X,Y)) ) ) ).

% eq_numeral_iff_iszero(1)
tff(fact_5324_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y)) ) ) ).

% eq_numeral_iff_iszero(12)
tff(fact_5325_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X)) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),X)) ) ) ).

% eq_numeral_iff_iszero(11)
tff(fact_5326_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) ) ).

% not_iszero_neg_Numeral1
tff(fact_5327_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num,Y: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X)) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X),Y))) ) ) ).

% eq_numeral_iff_iszero(3)
tff(fact_5328_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num,Y: num] :
          ( ( aa(num,A,numeral_numeral(A),X) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X),Y))) ) ) ).

% eq_numeral_iff_iszero(2)
tff(fact_5329_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num,Y: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,Y,X)) ) ) ).

% eq_numeral_iff_iszero(4)
tff(fact_5330_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,one2,Y)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_5331_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num] :
          ( ( aa(num,A,numeral_numeral(A),X) = one_one(A) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_5332_less__eq__int_Orep__eq,axiom,
    ! [X: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),Xa)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,X)),aa(int,product_prod(nat,nat),rep_Integ,Xa)) ) ).

% less_eq_int.rep_eq
tff(fact_5333_less__int_Orep__eq,axiom,
    ! [X: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),Xa)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,X)),aa(int,product_prod(nat,nat),rep_Integ,Xa)) ) ).

% less_int.rep_eq
tff(fact_5334_prod__encode__def,axiom,
    nat_prod_encode = product_case_prod(nat,nat,nat,aTP_Lamp_lu(nat,fun(nat,nat))) ).

% prod_encode_def
tff(fact_5335_prod__encode__eq,axiom,
    ! [X: product_prod(nat,nat),Y: product_prod(nat,nat)] :
      ( ( aa(product_prod(nat,nat),nat,nat_prod_encode,X) = aa(product_prod(nat,nat),nat,nat_prod_encode,Y) )
    <=> ( X = Y ) ) ).

% prod_encode_eq
tff(fact_5336_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),B2))) ).

% le_prod_encode_2
tff(fact_5337_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),B2))) ).

% le_prod_encode_1
tff(fact_5338_nat_Orep__eq,axiom,
    ! [X: int] : ( aa(int,nat,nat2,X) = aa(product_prod(nat,nat),nat,product_case_prod(nat,nat,nat,minus_minus(nat)),aa(int,product_prod(nat,nat),rep_Integ,X)) ) ).

% nat.rep_eq
tff(fact_5339_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: int] : ( aa(int,A,ring_1_of_int(A),X) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_lk(nat,fun(nat,A))),aa(int,product_prod(nat,nat),rep_Integ,X)) ) ) ).

% of_int.rep_eq
tff(fact_5340_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] : ( aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),nat_prod_decode_aux(K),M)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(K)),M) ) ).

% prod_encode_prod_decode_aux
tff(fact_5341_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_lj(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_5342_prod_Oinsert_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),P3: fun(A,B),I2: A] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jq(set(A),fun(fun(A,B),fun(A,$o)),I5),P3)))
         => ( groups1962203154675924110t_prod(A,B,P3,aa(set(A),set(A),insert(A,I2),I5))
            = $ite(member(A,I2,I5),groups1962203154675924110t_prod(A,B,P3,I5),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,P3,I2)),groups1962203154675924110t_prod(A,B,P3,I5))) ) ) ) ).

% prod.insert'
tff(fact_5343_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))) = remove1(A,X,linord4507533701916653071of_set(A,A3)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_5344_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P3: fun(B,A)] : ( groups1962203154675924110t_prod(B,A,P3,bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty'
tff(fact_5345_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : ( aa(list(A),nat,size_size(list(A)),linord4507533701916653071of_set(A,A3)) = aa(set(A),nat,finite_card(A),A3) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
tff(fact_5346_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1962203154675924110t_prod(B,A,G,collect(B,aa(set(B),fun(B,$o),aTP_Lamp_lv(fun(B,A),fun(set(B),fun(B,$o)),G),I5))) = groups1962203154675924110t_prod(B,A,G,I5) ) ) ).

% prod.non_neutral'
tff(fact_5347_prod_Omono__neutral__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,G,X3) = one_one(B) ) )
           => ( groups1962203154675924110t_prod(A,B,G,S3) = groups1962203154675924110t_prod(A,B,G,T5) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_5348_prod_Omono__neutral__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,G,X3) = one_one(B) ) )
           => ( groups1962203154675924110t_prod(A,B,G,T5) = groups1962203154675924110t_prod(A,B,G,S3) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_5349_prod_Omono__neutral__cong__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),T5: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [I3: A] :
                ( member(A,I3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,H,I3) = one_one(B) ) )
           => ( ! [X3: A] :
                  ( member(A,X3,S3)
                 => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
             => ( groups1962203154675924110t_prod(A,B,G,S3) = groups1962203154675924110t_prod(A,B,H,T5) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_5350_prod_Omono__neutral__cong__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S3: set(A),T5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),T5)
         => ( ! [X3: A] :
                ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
               => ( aa(A,B,G,X3) = one_one(B) ) )
           => ( ! [X3: A] :
                  ( member(A,X3,S3)
                 => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
             => ( groups1962203154675924110t_prod(A,B,G,T5) = groups1962203154675924110t_prod(A,B,H,S3) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_5351_prod_Odistrib_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jq(set(A),fun(fun(A,B),fun(A,$o)),I5),G)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_jq(set(A),fun(fun(A,B),fun(A,$o)),I5),H)))
           => ( groups1962203154675924110t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_lw(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),times_times(B),groups1962203154675924110t_prod(A,B,G,I5)),groups1962203154675924110t_prod(A,B,H,I5)) ) ) ) ) ).

% prod.distrib'
tff(fact_5352_prod_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P3: fun(B,A),I5: set(B)] :
          ( groups1962203154675924110t_prod(B,A,P3,I5)
          = $ite(aa(set(B),$o,finite_finite(B),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_lv(fun(B,A),fun(set(B),fun(B,$o)),P3),I5))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),P3),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_lv(fun(B,A),fun(set(B),fun(B,$o)),P3),I5))),one_one(A)) ) ) ).

% prod.G_def
tff(fact_5353_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [Na: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),aa(nat,nat,suc,I2)))
     => ( aa(nat,nat,nth(nat,linord4507533701916653071of_set(nat,set_or5935395276787703475ssThan(nat,I2,J2))),Na) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),Na)) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
tff(fact_5354_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_li(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_5355_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ls(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_5356_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_lq(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_5357_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( linord4507533701916653071of_set(A,aa(set(A),set(A),insert(A,X),A3)) = linorder_insort_key(A,A,aTP_Lamp_lx(A,A),X,linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_5358_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [Na: nat,J2: nat,I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2))
     => ( aa(nat,nat,nth(nat,linord4507533701916653071of_set(nat,set_or3652927894154168847AtMost(nat,I2,J2))),Na) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),Na)) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
tff(fact_5359_pow_Osimps_I3_J,axiom,
    ! [X: num,Y: num] : ( pow(X,aa(num,num,bit1,Y)) = aa(num,num,aa(num,fun(num,num),times_times(num),sqr(pow(X,Y))),X) ) ).

% pow.simps(3)
tff(fact_5360_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I2: A,L: A,U: A] :
          ( member(A,I2,set_or3652927894154168847AtMost(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),I2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I2),U) ) ) ) ).

% greaterThanAtMost_iff
tff(fact_5361_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_5362_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( bot_bot(set(A)) = set_or3652927894154168847AtMost(A,K,L) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_5363_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(set(A),$o,finite_finite(A),set_or3652927894154168847AtMost(A,A2,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% infinite_Ioc_iff
tff(fact_5364_length__insort,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F2: fun(A,B),X: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),linorder_insort_key(A,B,F2,X,Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% length_insort
tff(fact_5365_card__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or3652927894154168847AtMost(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),L) ) ).

% card_greaterThanAtMost
tff(fact_5366_sqr_Osimps_I2_J,axiom,
    ! [Na: num] : ( sqr(aa(num,num,bit0,Na)) = aa(num,num,bit0,aa(num,num,bit0,sqr(Na))) ) ).

% sqr.simps(2)
tff(fact_5367_sqr_Osimps_I1_J,axiom,
    sqr(one2) = one2 ).

% sqr.simps(1)
tff(fact_5368_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,L),U) = set_or3652927894154168847AtMost(nat,L,U) ) ).

% atLeastSucAtMost_greaterThanAtMost
tff(fact_5369_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(set(A),$o,finite_finite(A),set_or3652927894154168847AtMost(A,A2,B2)) ) ) ).

% infinite_Ioc
tff(fact_5370_sqr__conv__mult,axiom,
    ! [X: num] : ( sqr(X) = aa(num,num,aa(num,fun(num,num),times_times(num),X),X) ) ).

% sqr_conv_mult
tff(fact_5371_numeral__sqr,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),sqr(K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% numeral_sqr
tff(fact_5372_sum_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,Na: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,Na)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or3652927894154168847AtMost(nat,M,Na))) ) ) ) ).

% sum.head
tff(fact_5373_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
tff(fact_5374_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
tff(fact_5375_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or3652927894154168847AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
tff(fact_5376_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] : ( set_or3652927894154168847AtMost(A,A2,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_5377_pow_Osimps_I2_J,axiom,
    ! [X: num,Y: num] : ( pow(X,aa(num,num,bit0,Y)) = sqr(pow(X,Y)) ) ).

% pow.simps(2)
tff(fact_5378_sqr_Osimps_I3_J,axiom,
    ! [Na: num] : ( sqr(aa(num,num,bit1,Na)) = aa(num,num,bit1,aa(num,num,bit0,aa(num,num,aa(num,fun(num,num),plus_plus(num),sqr(Na)),Na))) ) ).

% sqr.simps(3)
tff(fact_5379_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( linord4507533701916653071of_set(A,A3) = linorder_insort_key(A,A,aTP_Lamp_lx(A,A),X,linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_5380_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list(A),Xss: list(list(A))] :
      ( member(list(A),Xs,aa(list(list(A)),set(list(A)),set2(list(A)),product_lists(A,Xss)))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Xss) ) ) ).

% in_set_product_lists_length
tff(fact_5381_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),bot_bot(A)) ) ).

% bot.extremum_strict
tff(fact_5382_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] :
          ( ( A2 != bot_bot(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),bot_bot(A)),A2) ) ) ).

% bot.not_eq_extremum
tff(fact_5383_card__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or3652927894154168847AtMost(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L)) ) ).

% card_greaterThanAtMost_int
tff(fact_5384_lt__ex,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X: A] :
        ? [Y4: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y4),X) ) ).

% lt_ex
tff(fact_5385_gt__ex,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X: A] :
        ? [X_1: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X_1) ) ).

% gt_ex
tff(fact_5386_dense,axiom,
    ! [A: $tType] :
      ( dense_order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ? [Z2: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z2),Y) ) ) ) ).

% dense
tff(fact_5387_less__imp__neq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( X != Y ) ) ) ).

% less_imp_neq
tff(fact_5388_order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% order.asym
tff(fact_5389_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% ord_eq_less_trans
tff(fact_5390_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ( B2 = C2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% ord_less_eq_trans
tff(fact_5391_less__induct,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o),A2: A] :
          ( ! [X3: A] :
              ( ! [Y3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y3),X3)
                 => aa(A,$o,P,Y3) )
             => aa(A,$o,P,X3) )
         => aa(A,$o,P,A2) ) ) ).

% less_induct
tff(fact_5392_antisym__conv3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
          <=> ( X = Y ) ) ) ) ).

% antisym_conv3
tff(fact_5393_linorder__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( ( X != Y )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ) ).

% linorder_cases
tff(fact_5394_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% dual_order.asym
tff(fact_5395_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),A2) ) ).

% dual_order.irrefl
tff(fact_5396_exists__least__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o)] :
          ( ? [X_13: A] : aa(A,$o,P,X_13)
        <=> ? [N4: A] :
              ( aa(A,$o,P,N4)
              & ! [M3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M3),N4)
                 => ~ aa(A,$o,P,M3) ) ) ) ) ).

% exists_least_iff
tff(fact_5397_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,$o)),A2: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A4),B4)
             => aa(A,$o,aa(A,fun(A,$o),P,A4),B4) )
         => ( ! [A4: A] : aa(A,$o,aa(A,fun(A,$o),P,A4),A4)
           => ( ! [A4: A,B4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),P,B4),A4)
                 => aa(A,$o,aa(A,fun(A,$o),P,A4),B4) )
             => aa(A,$o,aa(A,fun(A,$o),P,A2),B2) ) ) ) ) ).

% linorder_less_wlog
tff(fact_5398_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans
tff(fact_5399_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_5400_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans
tff(fact_5401_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
tff(fact_5402_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_5403_linorder__neqE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ) ).

% linorder_neqE
tff(fact_5404_order__less__asym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% order_less_asym
tff(fact_5405_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ( X != Y )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ) ).

% linorder_neq_iff
tff(fact_5406_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% order_less_asym'
tff(fact_5407_order__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z) ) ) ) ).

% order_less_trans
tff(fact_5408_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A2: A,F2: fun(B,A),B2: B,C2: B] :
          ( ( A2 = aa(B,A,F2,B2) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X3: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,X3)),aa(B,A,F2,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,C2)) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_5409_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A2: A,B2: A,F2: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ( aa(A,B,F2,B2) = C2 )
           => ( ! [X3: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,A2)),C2) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_5410_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X) ) ).

% order_less_irrefl
tff(fact_5411_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F2: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X3: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,X3)),aa(B,A,F2,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,C2)) ) ) ) ) ).

% order_less_subst1
tff(fact_5412_order__less__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F2: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,B2)),C2)
           => ( ! [X3: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,A2)),C2) ) ) ) ) ).

% order_less_subst2
tff(fact_5413_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% order_less_not_sym
tff(fact_5414_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
           => (P) ) ) ) ).

% order_less_imp_triv
tff(fact_5415_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
          | ( X = Y )
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% linorder_less_linear
tff(fact_5416_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
tff(fact_5417_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
tff(fact_5418_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% order_less_imp_not_less
tff(fact_5419_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] : ( set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),L),one_one(int)),U) = set_or3652927894154168847AtMost(int,L,U) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
tff(fact_5420_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less(fun(A,B)),F2),G)
        <=> ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F2),G)
            & ~ aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),G),F2) ) ) ) ).

% less_fun_def
tff(fact_5421_leD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ).

% leD
tff(fact_5422_leI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X) ) ) ).

% leI
tff(fact_5423_nless__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            | ( A2 = B2 ) ) ) ) ).

% nless_le
tff(fact_5424_antisym__conv1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
          <=> ( X = Y ) ) ) ) ).

% antisym_conv1
tff(fact_5425_antisym__conv2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
          <=> ( X = Y ) ) ) ) ).

% antisym_conv2
tff(fact_5426_dense__ge,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,Y: A] :
          ( ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X3) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ).

% dense_ge
tff(fact_5427_dense__le,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Y: A,Z: A] :
          ( ! [X3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Z) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ).

% dense_le
tff(fact_5428_less__le__not__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X) ) ) ) ).

% less_le_not_le
tff(fact_5429_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ).

% not_le_imp_less
tff(fact_5430_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
            | ( A2 = B2 ) ) ) ) ).

% order.order_iff_strict
tff(fact_5431_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & ( A2 != B2 ) ) ) ) ).

% order.strict_iff_order
tff(fact_5432_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans1
tff(fact_5433_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans2
tff(fact_5434_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% order.strict_iff_not
tff(fact_5435_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X)
         => ( ! [W2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),W2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W2),X)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),W2) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ) ).

% dense_ge_bounded
tff(fact_5436_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( ! [W2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),W2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W2),Y)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W2),Z) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ) ).

% dense_le_bounded
tff(fact_5437_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
            | ( A2 = B2 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_5438_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ( A2 != B2 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_5439_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans1
tff(fact_5440_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans2
tff(fact_5441_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_5442_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% order.strict_implies_order
tff(fact_5443_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% dual_order.strict_implies_order
tff(fact_5444_order__le__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
            | ( X = Y ) ) ) ) ).

% order_le_less
tff(fact_5445_order__less__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
            & ( X != Y ) ) ) ) ).

% order_less_le
tff(fact_5446_linorder__not__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% linorder_not_le
tff(fact_5447_linorder__not__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X) ) ) ).

% linorder_not_less
tff(fact_5448_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ).

% order_less_imp_le
tff(fact_5449_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( ( A2 != B2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% order_le_neq_trans
tff(fact_5450_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% order_neq_le_trans
tff(fact_5451_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z) ) ) ) ).

% order_le_less_trans
tff(fact_5452_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z) ) ) ) ).

% order_less_le_trans
tff(fact_5453_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F2: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(B,A,F2,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X3: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,X3)),aa(B,A,F2,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,C2)) ) ) ) ) ).

% order_le_less_subst1
tff(fact_5454_order__le__less__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F2: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,B2)),C2)
           => ( ! [X3: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,A2)),C2) ) ) ) ) ).

% order_le_less_subst2
tff(fact_5455_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F2: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B2),C2)
           => ( ! [X3: B,Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Y4)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F2,X3)),aa(B,A,F2,Y4)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,C2)) ) ) ) ) ).

% order_less_le_subst1
tff(fact_5456_order__less__le__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F2: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,B2)),C2)
           => ( ! [X3: A,Y4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,A2)),C2) ) ) ) ) ).

% order_less_le_subst2
tff(fact_5457_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X) ) ) ).

% linorder_le_less_linear
tff(fact_5458_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_5459_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,X: nat,Y: nat] :
      ( image(nat,nat,aTP_Lamp_ly(nat,fun(nat,nat),C2),set_or7035219750837199246ssThan(nat,X,Y))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),C2),Y),
          set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y),C2)),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))),bot_bot(set(nat))) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_5460_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2))),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      & aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2)),one_one(int)))) ) ).

% rat_floor_lemma
tff(fact_5461_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_of_int(A) = aa(fun(product_prod(nat,nat),A),fun(int,A),map_fun(int,product_prod(nat,nat),A,A,rep_Integ,id(A)),product_case_prod(nat,nat,A,aTP_Lamp_lk(nat,fun(nat,A)))) ) ) ).

% ring_1_class.of_int_def
tff(fact_5462_of__nat__eq__id,axiom,
    semiring_1_of_nat(nat) = id(nat) ).

% of_nat_eq_id
tff(fact_5463_id__funpow,axiom,
    ! [A: $tType,Na: nat] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),id(A)) = id(A) ) ).

% id_funpow
tff(fact_5464_bij__betw__Suc,axiom,
    ! [M10: set(nat),N3: set(nat)] :
      ( bij_betw(nat,nat,suc,M10,N3)
    <=> ( image(nat,nat,suc,M10) = N3 ) ) ).

% bij_betw_Suc
tff(fact_5465_image__add__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [S3: set(A)] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),S3) = S3 ) ) ).

% image_add_0
tff(fact_5466_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A,J2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),K),set_or1337092689740270186AtMost(A,I2,J2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastAtMost
tff(fact_5467_image__diff__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [D2: A,A2: A,B2: A] : ( image(A,A,aa(A,fun(A,A),minus_minus(A),D2),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),D2),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),D2),A2)) ) ) ).

% image_diff_atLeastAtMost
tff(fact_5468_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A,J2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),K),set_or7035219750837199246ssThan(A,I2,J2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastLessThan
tff(fact_5469_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [C2: A,A2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),C2),set_ord_atMost(A,A2)) = set_ord_atMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)) ) ) ).

% image_add_atMost
tff(fact_5470_bij__betw__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A),B3: set(A)] :
          ( bij_betw(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3,B3)
        <=> ( image(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3) = B3 ) ) ) ).

% bij_betw_add
tff(fact_5471_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [C2: A,A2: A,B2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),C2),set_or3652927894154168847AtMost(A,A2,B2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% image_add_greaterThanAtMost
tff(fact_5472_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se4730199178511100633sh_bit(A,zero_zero(nat)) = id(A) ) ) ).

% push_bit_0_id
tff(fact_5473_drop__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se4197421643247451524op_bit(A,zero_zero(nat)) = id(A) ) ) ).

% drop_bit_0
tff(fact_5474_image__Suc__atLeastAtMost,axiom,
    ! [I2: nat,J2: nat] : ( image(nat,nat,suc,set_or1337092689740270186AtMost(nat,I2,J2)) = set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,I2),aa(nat,nat,suc,J2)) ) ).

% image_Suc_atLeastAtMost
tff(fact_5475_image__Suc__atLeastLessThan,axiom,
    ! [I2: nat,J2: nat] : ( image(nat,nat,suc,set_or7035219750837199246ssThan(nat,I2,J2)) = set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,I2),aa(nat,nat,suc,J2)) ) ).

% image_Suc_atLeastLessThan
tff(fact_5476_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A,J2: A] : ( image(A,A,aTP_Lamp_lz(A,fun(A,A),K),set_or1337092689740270186AtMost(A,I2,J2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastAtMost'
tff(fact_5477_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [D2: A,A2: A,B2: A] : ( image(A,A,aTP_Lamp_ma(A,fun(A,A),D2),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ).

% image_minus_const_atLeastAtMost'
tff(fact_5478_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A,J2: A] : ( image(A,A,aTP_Lamp_lz(A,fun(A,A),K),set_or7035219750837199246ssThan(A,I2,J2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I2),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),K)) ) ) ).

% image_add_atLeastLessThan'
tff(fact_5479_floor__Fract,axiom,
    ! [A2: int,B2: int] : ( archim6421214686448440834_floor(rat,aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)) = aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),B2) ) ).

% floor_Fract
tff(fact_5480_image__minus__const__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A,B2: A] : ( image(A,A,aa(A,fun(A,A),minus_minus(A),C2),set_or3652927894154168847AtMost(A,A2,B2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)) ) ) ).

% image_minus_const_greaterThanAtMost
tff(fact_5481_image__diff__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A,B2: A] : ( image(A,A,aa(A,fun(A,A),minus_minus(A),C2),set_or7035219750837199246ssThan(A,A2,B2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)) ) ) ).

% image_diff_atLeastLessThan
tff(fact_5482_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D2)
         => ( image(A,A,aa(A,fun(A,A),times_times(A),D2),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),D2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),D2),B2)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_5483_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D2)
         => ( image(A,A,aTP_Lamp_mb(A,fun(A,A),D2),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),D2),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),D2)) ) ) ) ).

% image_divide_atLeastAtMost
tff(fact_5484_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))) ) ) ) ).

% less_rat
tff(fact_5485_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ) ) ).

% add_rat
tff(fact_5486_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))) ) ) ) ).

% le_rat
tff(fact_5487_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ) ) ).

% diff_rat
tff(fact_5488_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),A2) = aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),C2) ) ).

% eq_rat(3)
tff(fact_5489_zero__notin__Suc__image,axiom,
    ! [A3: set(nat)] : ~ member(nat,zero_zero(nat),image(nat,nat,suc,A3)) ).

% zero_notin_Suc_image
tff(fact_5490_translation__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),image(A,A,aa(A,fun(A,A),plus_plus(A),A2),S)),image(A,A,aa(A,fun(A,A),plus_plus(A),A2),T2)) ) ) ).

% translation_diff
tff(fact_5491_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F2) = id(A) ) ).

% funpow_simps_right(1)
tff(fact_5492_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B),B3: set(B)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),image(B,A,F2,A3)),image(B,A,F2,B3))),image(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B3))) ).

% image_diff_subset
tff(fact_5493_eq__rat_I2_J,axiom,
    ! [A2: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,A2),zero_zero(int)) = aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),one_one(int)) ) ).

% eq_rat(2)
tff(fact_5494_Rat__induct__pos,axiom,
    ! [P: fun(rat,$o),Q4: rat] :
      ( ! [A4: int,B4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
         => aa(rat,$o,P,aa(int,rat,aa(int,fun(int,rat),fract,A4),B4)) )
     => aa(rat,$o,P,Q4) ) ).

% Rat_induct_pos
tff(fact_5495_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( ( aa(int,rat,aa(int,fun(int,rat),fract,A2),B2) = aa(int,rat,aa(int,fun(int,rat),fract,C2),D2) )
        <=> ( aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2) = aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2) ) ) ) ) ).

% eq_rat(1)
tff(fact_5496_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2 != zero_zero(int) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),times_times(int),C2),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)) = aa(int,rat,aa(int,fun(int,rat),fract,A2),B2) ) ) ).

% mult_rat_cancel
tff(fact_5497_Fract__of__nat__eq,axiom,
    ! [K: nat] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(nat,int,semiring_1_of_nat(int),K)),one_one(int)) = aa(nat,rat,semiring_1_of_nat(rat),K) ) ).

% Fract_of_nat_eq
tff(fact_5498_translation__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,T2: set(A)] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),image(A,A,aa(A,fun(A,A),plus_plus(A),A2),T2)) ) ) ).

% translation_Compl
tff(fact_5499_rat__number__collapse_I1_J,axiom,
    ! [K: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),K) = zero_zero(rat) ) ).

% rat_number_collapse(1)
tff(fact_5500_rat__number__collapse_I6_J,axiom,
    ! [K: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,K),zero_zero(int)) = zero_zero(rat) ) ).

% rat_number_collapse(6)
tff(fact_5501_Fract__coprime,axiom,
    ! [A2: int,B2: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),divide_divide(int),A2),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2))),aa(int,int,aa(int,fun(int,int),divide_divide(int),B2),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2))) = aa(int,rat,aa(int,fun(int,rat),fract,A2),B2) ) ).

% Fract_coprime
tff(fact_5502_One__rat__def,axiom,
    one_one(rat) = aa(int,rat,aa(int,fun(int,rat),fract,one_one(int)),one_one(int)) ).

% One_rat_def
tff(fact_5503_less__int__def,axiom,
    ord_less(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(int,fun(int,$o)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(int,$o),rep_Integ,map_fun(int,product_prod(nat,nat),$o,$o,rep_Integ,id($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_int_def
tff(fact_5504_less__eq__int__def,axiom,
    ord_less_eq(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(int,fun(int,$o)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(int,$o),rep_Integ,map_fun(int,product_prod(nat,nat),$o,$o,rep_Integ,id($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_eq_int_def
tff(fact_5505_Fract__of__int__eq,axiom,
    ! [K: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,K),one_one(int)) = aa(int,rat,ring_1_of_int(rat),K) ) ).

% Fract_of_int_eq
tff(fact_5506_finite__conv__nat__seg__image,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
    <=> ? [N4: nat,F5: fun(nat,A)] : ( A3 = image(nat,A,F5,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),N4))) ) ) ).

% finite_conv_nat_seg_image
tff(fact_5507_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set(A),F2: fun(nat,A),Na: nat] :
      ( ( A3 = image(nat,A,F2,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Na))) )
     => aa(set(A),$o,finite_finite(A),A3) ) ).

% nat_seg_image_imp_finite
tff(fact_5508_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),S)),image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),T2)) ) ) ).

% translation_subtract_diff
tff(fact_5509_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,T2: set(A)] : ( image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),T2)) ) ) ).

% translation_subtract_Compl
tff(fact_5510_Gcd__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F2,X3)),aa(A,B,G,X3)) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),gcd_Gcd(B,image(A,B,F2,A3))),gcd_Gcd(B,image(A,B,G,A3))) ) ) ).

% Gcd_mono
tff(fact_5511_nat__def,axiom,
    nat2 = aa(fun(product_prod(nat,nat),nat),fun(int,nat),map_fun(int,product_prod(nat,nat),nat,nat,rep_Integ,id(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))) ).

% nat_def
tff(fact_5512_Zero__rat__def,axiom,
    zero_zero(rat) = aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),one_one(int)) ).

% Zero_rat_def
tff(fact_5513_rat__number__collapse_I3_J,axiom,
    ! [W: num] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(num,int,numeral_numeral(int),W)),one_one(int)) = aa(num,rat,numeral_numeral(rat),W) ) ).

% rat_number_collapse(3)
tff(fact_5514_rat__number__expand_I3_J,axiom,
    ! [K: num] : ( aa(num,rat,numeral_numeral(rat),K) = aa(int,rat,aa(int,fun(int,rat),fract,aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% rat_number_expand(3)
tff(fact_5515_sum_Oreindex__nontrivial,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(A),H: fun(A,B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X3: A,Y4: A] :
                ( member(A,X3,A3)
               => ( member(A,Y4,A3)
                 => ( ( X3 != Y4 )
                   => ( ( aa(A,B,H,X3) = aa(A,B,H,Y4) )
                     => ( aa(B,C,G,aa(A,B,H,X3)) = zero_zero(C) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),image(A,B,H,A3)) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(A,B),fun(A,C),comp(B,C,A,G),H)),A3) ) ) ) ) ).

% sum.reindex_nontrivial
tff(fact_5516_prod_Oreindex__nontrivial,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(A),H: fun(A,B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X3: A,Y4: A] :
                ( member(A,X3,A3)
               => ( member(A,Y4,A3)
                 => ( ( X3 != Y4 )
                   => ( ( aa(A,B,H,X3) = aa(A,B,H,Y4) )
                     => ( aa(B,C,G,aa(A,B,H,X3)) = one_one(C) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),image(A,B,H,A3)) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(fun(A,B),fun(A,C),comp(B,C,A,G),H)),A3) ) ) ) ) ).

% prod.reindex_nontrivial
tff(fact_5517_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,X: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( image(A,A,real_V8093663219630862766scaleR(A,C2),set_or1337092689740270186AtMost(A,X,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,real_V8093663219630862766scaleR(A,C2),X),aa(A,A,real_V8093663219630862766scaleR(A,C2),Y)) ) ) ) ).

% scaleR_image_atLeastAtMost
tff(fact_5518_image__Suc__lessThan,axiom,
    ! [Na: nat] : ( image(nat,nat,suc,set_ord_lessThan(nat,Na)) = set_or1337092689740270186AtMost(nat,one_one(nat),Na) ) ).

% image_Suc_lessThan
tff(fact_5519_image__Suc__atMost,axiom,
    ! [Na: nat] : ( image(nat,nat,suc,set_ord_atMost(nat,Na)) = set_or1337092689740270186AtMost(nat,one_one(nat),aa(nat,nat,suc,Na)) ) ).

% image_Suc_atMost
tff(fact_5520_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [Na: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),image(nat,nat,suc,set_or1337092689740270186AtMost(nat,zero_zero(nat),Na))) ) ).

% atLeast0_atMost_Suc_eq_insert_0
tff(fact_5521_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [Na: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),image(nat,nat,suc,set_or7035219750837199246ssThan(nat,zero_zero(nat),Na))) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
tff(fact_5522_lessThan__Suc__eq__insert__0,axiom,
    ! [Na: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),image(nat,nat,suc,set_ord_lessThan(nat,Na))) ) ).

% lessThan_Suc_eq_insert_0
tff(fact_5523_atMost__Suc__eq__insert__0,axiom,
    ! [Na: nat] : ( set_ord_atMost(nat,aa(nat,nat,suc,Na)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),image(nat,nat,suc,set_ord_atMost(nat,Na))) ) ).

% atMost_Suc_eq_insert_0
tff(fact_5524_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),zero_zero(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int)) ) ) ).

% Fract_less_zero_iff
tff(fact_5525_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2) ) ) ).

% zero_less_Fract_iff
tff(fact_5526_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),one_one(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),A2) ) ) ).

% one_less_Fract_iff
tff(fact_5527_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),one_one(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),B2) ) ) ).

% Fract_less_one_iff
tff(fact_5528_rat__number__collapse_I5_J,axiom,
    aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,uminus_uminus(int),one_one(int))),one_one(int)) = aa(rat,rat,uminus_uminus(rat),one_one(rat)) ).

% rat_number_collapse(5)
tff(fact_5529_Fract__add__one,axiom,
    ! [Na: int,M: int] :
      ( ( Na != zero_zero(int) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),Na)),Na) = aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(int,rat,aa(int,fun(int,rat),fract,M),Na)),one_one(rat)) ) ) ).

% Fract_add_one
tff(fact_5530_sum__image__le,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),G: fun(C,B),F2: fun(A,C)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( ! [I3: A] :
                ( member(A,I3,I5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(C,B,G,aa(A,C,F2,I3))) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),image(A,C,F2,I5))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,C),fun(A,B),comp(C,B,A,G),F2)),I5)) ) ) ) ).

% sum_image_le
tff(fact_5531_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),zero_zero(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2) ) ) ).

% zero_le_Fract_iff
tff(fact_5532_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),zero_zero(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int)) ) ) ).

% Fract_le_zero_iff
tff(fact_5533_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),one_one(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),B2) ) ) ).

% Fract_le_one_iff
tff(fact_5534_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),one_one(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),A2) ) ) ).

% one_le_Fract_iff
tff(fact_5535_rat__number__expand_I5_J,axiom,
    ! [K: num] : ( aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% rat_number_expand(5)
tff(fact_5536_rat__number__collapse_I4_J,axiom,
    ! [W: num] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),one_one(int)) = aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),W)) ) ).

% rat_number_collapse(4)
tff(fact_5537_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X: A,Y: A] :
          ( image(A,A,aa(A,fun(A,A),times_times(A),C2),set_or1337092689740270186AtMost(A,X,Y))
          = $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),X),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y),aa(A,A,aa(A,fun(A,A),times_times(A),C2),X)),bot_bot(set(A))) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_5538_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X: A,Y: A] :
          ( image(A,A,aTP_Lamp_md(A,fun(A,A),C2),set_or1337092689740270186AtMost(A,X,Y))
          = $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2),aa(A,A,aa(A,fun(A,A),times_times(A),X),C2))),
              bot_bot(set(A)) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_5539_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( image(A,A,aa(A,fun(A,A),aTP_Lamp_me(A,fun(A,fun(A,A)),M),C2),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_5540_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( image(A,A,aa(A,fun(A,A),aTP_Lamp_mf(A,fun(A,fun(A,A)),M),C2),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_5541_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( image(A,A,aa(A,fun(A,A),aTP_Lamp_mg(A,fun(A,fun(A,A)),M),C2),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),M)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),M)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_5542_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( image(A,A,aa(A,fun(A,A),aTP_Lamp_mh(A,fun(A,fun(A,A)),M),C2),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),M)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),M)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),M)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_5543_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,Na: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = case_option(int,num,zero_zero(int),aTP_Lamp_mi(num,fun(num,int),M),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M),Na)) ) ).

% take_bit_numeral_minus_numeral_int
tff(fact_5544_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( aa(rat,$o,positive,aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),A2),B2)) ) ).

% positive_rat
tff(fact_5545_complete__interval,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,P,A2)
           => ( ~ aa(A,$o,P,B2)
             => ? [C3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C3),B2)
                  & ! [X4: A] :
                      ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X4)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),C3) )
                     => aa(A,$o,P,X4) )
                  & ! [D6: A] :
                      ( ! [X3: A] :
                          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X3)
                            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),D6) )
                         => aa(A,$o,P,X3) )
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D6),C3) ) ) ) ) ) ) ).

% complete_interval
tff(fact_5546_take__bit__num__simps_I1_J,axiom,
    ! [M: num] : ( bit_take_bit_num(zero_zero(nat),M) = none(num) ) ).

% take_bit_num_simps(1)
tff(fact_5547_Gcd__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,image(int,int,abs_abs(int),K5)) = gcd_Gcd(int,K5) ) ).

% Gcd_abs_eq
tff(fact_5548_take__bit__num__simps_I2_J,axiom,
    ! [Na: nat] : ( bit_take_bit_num(aa(nat,nat,suc,Na),one2) = some(num,one2) ) ).

% take_bit_num_simps(2)
tff(fact_5549_take__bit__num__simps_I5_J,axiom,
    ! [R2: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),one2) = some(num,one2) ) ).

% take_bit_num_simps(5)
tff(fact_5550_Gcd__int__eq,axiom,
    ! [N3: set(nat)] : ( gcd_Gcd(int,image(nat,int,semiring_1_of_nat(int),N3)) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,N3)) ) ).

% Gcd_int_eq
tff(fact_5551_Gcd__nat__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(nat,image(int,nat,aTP_Lamp_mj(int,nat),K5)) = aa(int,nat,nat2,gcd_Gcd(int,K5)) ) ).

% Gcd_nat_abs_eq
tff(fact_5552_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: num,Na: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),M)),aa(num,A,numeral_numeral(A),Na)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M),Na)) ) ) ).

% take_bit_numeral_numeral
tff(fact_5553_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [Na: nat] : ( bit_take_bit_num(Na,one2) = case_nat(option(num),none(num),aTP_Lamp_mk(nat,option(num)),Na) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
tff(fact_5554_Rat_Opositive__zero,axiom,
    ~ aa(rat,$o,positive,zero_zero(rat)) ).

% Rat.positive_zero
tff(fact_5555_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: num,Q4: num] :
          ( ( bit_take_bit_num(M,Na) = some(num,Q4) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),Q4) ) ) ) ).

% take_bit_num_eq_Some_imp
tff(fact_5556_in__image__insert__iff,axiom,
    ! [A: $tType,B3: set(set(A)),X: A,A3: set(A)] :
      ( ! [C7: set(A)] :
          ( member(set(A),C7,B3)
         => ~ member(A,X,C7) )
     => ( member(set(A),A3,image(set(A),set(A),insert(A,X),B3))
      <=> ( member(A,X,A3)
          & member(set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))),B3) ) ) ) ).

% in_image_insert_iff
tff(fact_5557_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( condit5016429287641298734tinuum(A)
     => ! [A2: A] :
        ? [B4: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B4)
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),B4),A2) ) ) ).

% ex_gt_or_lt
tff(fact_5558_Rat_Opositive__minus,axiom,
    ! [X: rat] :
      ( ~ aa(rat,$o,positive,X)
     => ( ( X != zero_zero(rat) )
       => aa(rat,$o,positive,aa(rat,rat,uminus_uminus(rat),X)) ) ) ).

% Rat.positive_minus
tff(fact_5559_less__rat__def,axiom,
    ! [X: rat,Y: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),X),Y)
    <=> aa(rat,$o,positive,aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),Y),X)) ) ).

% less_rat_def
tff(fact_5560_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: num] :
          ( ( bit_take_bit_num(M,Na) = none(num) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(num,A,numeral_numeral(A),Na)) = zero_zero(A) ) ) ) ).

% take_bit_num_eq_None_imp
tff(fact_5561_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] : ( image(int,int,aTP_Lamp_ml(int,fun(int,int),L),set_or7035219750837199246ssThan(int,zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L))) = set_or7035219750837199246ssThan(int,L,U) ) ).

% image_add_int_atLeastLessThan
tff(fact_5562_take__bit__num__def,axiom,
    ! [Na: nat,M: num] :
      ( bit_take_bit_num(Na,M)
      = $ite(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),aa(num,nat,numeral_numeral(nat),M)) = zero_zero(nat),none(num),some(num,num_of_nat(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,Na),aa(num,nat,numeral_numeral(nat),M))))) ) ).

% take_bit_num_def
tff(fact_5563_Gcd__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,image(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int)),K5))) ) ).

% Gcd_int_def
tff(fact_5564_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),U)
     => ( set_or7035219750837199246ssThan(int,zero_zero(int),U) = image(nat,int,semiring_1_of_nat(int),set_ord_lessThan(nat,aa(int,nat,nat2,U))) ) ) ).

% image_atLeastZeroLessThan_int
tff(fact_5565_and__minus__numerals_I3_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,bitM(Na))) ) ).

% and_minus_numerals(3)
tff(fact_5566_and__minus__numerals_I7_J,axiom,
    ! [Na: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,Na)))),aa(num,int,numeral_numeral(int),M)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,bitM(Na))) ) ).

% and_minus_numerals(7)
tff(fact_5567_and__minus__numerals_I4_J,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,aa(num,num,bit0,Na))) ) ).

% and_minus_numerals(4)
tff(fact_5568_take__bit__num__simps_I4_J,axiom,
    ! [Na: nat,M: num] : ( bit_take_bit_num(aa(nat,nat,suc,Na),aa(num,num,bit1,M)) = some(num,case_option(num,num,one2,bit1,bit_take_bit_num(Na,M))) ) ).

% take_bit_num_simps(4)
tff(fact_5569_take__bit__num__simps_I3_J,axiom,
    ! [Na: nat,M: num] : ( bit_take_bit_num(aa(nat,nat,suc,Na),aa(num,num,bit0,M)) = case_option(option(num),num,none(num),aTP_Lamp_mm(num,option(num)),bit_take_bit_num(Na,M)) ) ).

% take_bit_num_simps(3)
tff(fact_5570_take__bit__num__simps_I7_J,axiom,
    ! [R2: num,M: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),aa(num,num,bit1,M)) = some(num,case_option(num,num,one2,bit1,bit_take_bit_num(pred_numeral(R2),M))) ) ).

% take_bit_num_simps(7)
tff(fact_5571_take__bit__num__simps_I6_J,axiom,
    ! [R2: num,M: num] : ( bit_take_bit_num(aa(num,nat,numeral_numeral(nat),R2),aa(num,num,bit0,M)) = case_option(option(num),num,none(num),aTP_Lamp_mm(num,option(num)),bit_take_bit_num(pred_numeral(R2),M)) ) ).

% take_bit_num_simps(6)
tff(fact_5572_and__minus__numerals_I8_J,axiom,
    ! [Na: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,Na)))),aa(num,int,numeral_numeral(int),M)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,aa(num,num,bit0,Na))) ) ).

% and_minus_numerals(8)
tff(fact_5573_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,Na: num] : ( bit_and_not_num(aa(num,num,bit1,M),aa(num,num,bit0,Na)) = case_option(option(num),num,some(num,one2),aTP_Lamp_mn(num,option(num)),bit_and_not_num(M,Na)) ) ).

% and_not_num.simps(8)
tff(fact_5574_and__not__num_Osimps_I1_J,axiom,
    bit_and_not_num(one2,one2) = none(num) ).

% and_not_num.simps(1)
tff(fact_5575_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] : ( bit_and_not_num(aa(num,num,bit0,M),one2) = some(num,aa(num,num,bit0,M)) ) ).

% and_not_num.simps(4)
tff(fact_5576_and__not__num_Osimps_I2_J,axiom,
    ! [Na: num] : ( bit_and_not_num(one2,aa(num,num,bit0,Na)) = some(num,one2) ) ).

% and_not_num.simps(2)
tff(fact_5577_and__not__num_Osimps_I3_J,axiom,
    ! [Na: num] : ( bit_and_not_num(one2,aa(num,num,bit1,Na)) = none(num) ) ).

% and_not_num.simps(3)
tff(fact_5578_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [Na: nat,M: num] : ( bit_take_bit_num(Na,aa(num,num,bit0,M)) = case_nat(option(num),none(num),aTP_Lamp_mo(num,fun(nat,option(num)),M),Na) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
tff(fact_5579_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] : ( bit_and_not_num(aa(num,num,bit1,M),one2) = some(num,aa(num,num,bit0,M)) ) ).

% and_not_num.simps(7)
tff(fact_5580_and__not__num__eq__Some__iff,axiom,
    ! [M: num,Na: num,Q4: num] :
      ( ( bit_and_not_num(M,Na) = some(num,Q4) )
    <=> ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))) = aa(num,int,numeral_numeral(int),Q4) ) ) ).

% and_not_num_eq_Some_iff
tff(fact_5581_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [Na: nat,M: num] : ( bit_take_bit_num(Na,aa(num,num,bit1,M)) = case_nat(option(num),none(num),aTP_Lamp_mp(num,fun(nat,option(num)),M),Na) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
tff(fact_5582_and__not__num__eq__None__iff,axiom,
    ! [M: num,Na: num] :
      ( ( bit_and_not_num(M,Na) = none(num) )
    <=> ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))) = zero_zero(int) ) ) ).

% and_not_num_eq_None_iff
tff(fact_5583_int__numeral__not__and__num,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),Na)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(Na,M)) ) ).

% int_numeral_not_and_num
tff(fact_5584_int__numeral__and__not__num,axiom,
    ! [M: num,Na: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),Na))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,Na)) ) ).

% int_numeral_and_not_num
tff(fact_5585_Rat_Opositive_Orep__eq,axiom,
    ! [X: rat] :
      ( aa(rat,$o,positive,X)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),aa(rat,product_prod(int,int),rep_Rat,X))),aa(product_prod(int,int),int,product_snd(int,int),aa(rat,product_prod(int,int),rep_Rat,X)))) ) ).

% Rat.positive.rep_eq
tff(fact_5586_measure__function__int,axiom,
    fun_is_measure(int,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))) ).

% measure_function_int
tff(fact_5587_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),L),aa(list(A),nat,size_size(list(A)),Xs))
     => ( image(nat,A,nth(A,Xs),set_or7035219750837199246ssThan(nat,zero_zero(nat),L)) = aa(list(A),set(A),set2(A),take(A,L,Xs)) ) ) ).

% nth_image
tff(fact_5588_take__all__iff,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( take(A,Na,Xs) = Xs )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na) ) ).

% take_all_iff
tff(fact_5589_take__all,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na)
     => ( take(A,Na,Xs) = Xs ) ) ).

% take_all
tff(fact_5590_nth__take,axiom,
    ! [A: $tType,I2: nat,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),Na)
     => ( aa(nat,A,nth(A,take(A,Na,Xs)),I2) = aa(nat,A,nth(A,Xs),I2) ) ) ).

% nth_take
tff(fact_5591_measure__size,axiom,
    ! [A: $tType] :
      ( size(A)
     => fun_is_measure(A,size_size(A)) ) ).

% measure_size
tff(fact_5592_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Ys: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Ys))
       => ( ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),K)
             => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Ys),I3) ) )
         => ( take(A,K,Xs) = take(A,K,Ys) ) ) ) ) ).

% nth_take_lemma
tff(fact_5593_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,Bs: list($o)] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,Na),aa(list($o),A,aa(A,fun(list($o),A),aa(fun($o,A),fun(A,fun(list($o),A)),groups4207007520872428315er_sum($o,A),zero_neq_one_of_bool(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Bs)) = aa(list($o),A,aa(A,fun(list($o),A),aa(fun($o,A),fun(A,fun(list($o),A)),groups4207007520872428315er_sum($o,A),zero_neq_one_of_bool(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),take($o,Na,Bs)) ) ) ).

% take_bit_horner_sum_bit_eq
tff(fact_5594_Rat_Opositive__def,axiom,
    positive = aa(fun(product_prod(int,int),$o),fun(rat,$o),map_fun(rat,product_prod(int,int),$o,$o,rep_Rat,id($o)),aTP_Lamp_mq(product_prod(int,int),$o)) ).

% Rat.positive_def
tff(fact_5595_and__not__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X,Xa) = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y != none(num) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N: num] : ( Xa = aa(num,num,bit0,N) )
             => ( Y != some(num,one2) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N: num] : ( Xa = aa(num,num,bit1,N) )
               => ( Y != none(num) ) ) )
           => ( ! [M4: num] :
                  ( ( X = aa(num,num,bit0,M4) )
                 => ( ( Xa = one2 )
                   => ( Y != some(num,aa(num,num,bit0,M4)) ) ) )
             => ( ! [M4: num] :
                    ( ( X = aa(num,num,bit0,M4) )
                   => ! [N: num] :
                        ( ( Xa = aa(num,num,bit0,N) )
                       => ( Y != map_option(num,num,bit0,bit_and_not_num(M4,N)) ) ) )
               => ( ! [M4: num] :
                      ( ( X = aa(num,num,bit0,M4) )
                     => ! [N: num] :
                          ( ( Xa = aa(num,num,bit1,N) )
                         => ( Y != map_option(num,num,bit0,bit_and_not_num(M4,N)) ) ) )
                 => ( ! [M4: num] :
                        ( ( X = aa(num,num,bit1,M4) )
                       => ( ( Xa = one2 )
                         => ( Y != some(num,aa(num,num,bit0,M4)) ) ) )
                   => ( ! [M4: num] :
                          ( ( X = aa(num,num,bit1,M4) )
                         => ! [N: num] :
                              ( ( Xa = aa(num,num,bit0,N) )
                             => ( Y != case_option(option(num),num,some(num,one2),aTP_Lamp_mn(num,option(num)),bit_and_not_num(M4,N)) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X = aa(num,num,bit1,M4) )
                           => ! [N: num] :
                                ( ( Xa = aa(num,num,bit1,N) )
                               => ( Y != map_option(num,num,bit0,bit_and_not_num(M4,N)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
tff(fact_5596_Bit__Operations_Otake__bit__num__code,axiom,
    ! [Na: nat,M: num] : ( bit_take_bit_num(Na,M) = aa(product_prod(nat,num),option(num),product_case_prod(nat,num,option(num),aTP_Lamp_mu(nat,fun(num,option(num)))),aa(num,product_prod(nat,num),product_Pair(nat,num,Na),M)) ) ).

% Bit_Operations.take_bit_num_code
tff(fact_5597_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: B,F22: fun(num,B),F32: fun(num,B),Num: num] : ( aa(B,A,H,aa(num,B,aa(fun(num,B),fun(num,B),aa(fun(num,B),fun(fun(num,B),fun(num,B)),aa(B,fun(fun(num,B),fun(fun(num,B),fun(num,B))),case_num(B),F1),F22),F32),Num)) = aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),aa(B,A,H,F1)),aa(fun(num,B),fun(num,A),aTP_Lamp_mv(fun(B,A),fun(fun(num,B),fun(num,A)),H),F22)),aa(fun(num,B),fun(num,A),aTP_Lamp_mv(fun(B,A),fun(fun(num,B),fun(num,A)),H),F32)),Num) ) ).

% num.case_distrib
tff(fact_5598_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,Na: num] : ( bit_and_not_num(aa(num,num,bit0,M),aa(num,num,bit0,Na)) = map_option(num,num,bit0,bit_and_not_num(M,Na)) ) ).

% and_not_num.simps(5)
tff(fact_5599_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: fun(num,A),F32: fun(num,A),X2: num] : ( aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),F1),F22),F32),aa(num,num,bit0,X2)) = aa(num,A,F22,X2) ) ).

% verit_eq_simplify(17)
tff(fact_5600_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: fun(num,A),F32: fun(num,A)] : ( aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),F1),F22),F32),one2) = F1 ) ).

% verit_eq_simplify(16)
tff(fact_5601_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F22: fun(num,A),F32: fun(num,A),X32: num] : ( aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),F1),F22),F32),aa(num,num,bit1,X32)) = aa(num,A,F32,X32) ) ).

% verit_eq_simplify(18)
tff(fact_5602_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,Na: num] : ( bit_and_not_num(aa(num,num,bit0,M),aa(num,num,bit1,Na)) = map_option(num,num,bit0,bit_and_not_num(M,Na)) ) ).

% and_not_num.simps(6)
tff(fact_5603_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,Na: num] : ( bit_and_not_num(aa(num,num,bit1,M),aa(num,num,bit1,Na)) = map_option(num,num,bit0,bit_and_not_num(M,Na)) ) ).

% and_not_num.simps(9)
tff(fact_5604_and__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,X),Xa) = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y != some(num,one2) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N: num] : ( Xa = aa(num,num,bit0,N) )
             => ( Y != none(num) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N: num] : ( Xa = aa(num,num,bit1,N) )
               => ( Y != some(num,one2) ) ) )
           => ( ( ? [M4: num] : ( X = aa(num,num,bit0,M4) )
               => ( ( Xa = one2 )
                 => ( Y != none(num) ) ) )
             => ( ! [M4: num] :
                    ( ( X = aa(num,num,bit0,M4) )
                   => ! [N: num] :
                        ( ( Xa = aa(num,num,bit0,N) )
                       => ( Y != map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) ) ) )
               => ( ! [M4: num] :
                      ( ( X = aa(num,num,bit0,M4) )
                     => ! [N: num] :
                          ( ( Xa = aa(num,num,bit1,N) )
                         => ( Y != map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) ) ) )
                 => ( ( ? [M4: num] : ( X = aa(num,num,bit1,M4) )
                     => ( ( Xa = one2 )
                       => ( Y != some(num,one2) ) ) )
                   => ( ! [M4: num] :
                          ( ( X = aa(num,num,bit1,M4) )
                         => ! [N: num] :
                              ( ( Xa = aa(num,num,bit0,N) )
                             => ( Y != map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X = aa(num,num,bit1,M4) )
                           => ! [N: num] :
                                ( ( Xa = aa(num,num,bit1,N) )
                               => ( Y != case_option(option(num),num,some(num,one2),aTP_Lamp_mn(num,option(num)),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
tff(fact_5605_xor__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,X),Xa) = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y != none(num) ) ) )
       => ( ( ( X = one2 )
           => ! [N: num] :
                ( ( Xa = aa(num,num,bit0,N) )
               => ( Y != some(num,aa(num,num,bit1,N)) ) ) )
         => ( ( ( X = one2 )
             => ! [N: num] :
                  ( ( Xa = aa(num,num,bit1,N) )
                 => ( Y != some(num,aa(num,num,bit0,N)) ) ) )
           => ( ! [M4: num] :
                  ( ( X = aa(num,num,bit0,M4) )
                 => ( ( Xa = one2 )
                   => ( Y != some(num,aa(num,num,bit1,M4)) ) ) )
             => ( ! [M4: num] :
                    ( ( X = aa(num,num,bit0,M4) )
                   => ! [N: num] :
                        ( ( Xa = aa(num,num,bit0,N) )
                       => ( Y != map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N)) ) ) )
               => ( ! [M4: num] :
                      ( ( X = aa(num,num,bit0,M4) )
                     => ! [N: num] :
                          ( ( Xa = aa(num,num,bit1,N) )
                         => ( Y != some(num,case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N))) ) ) )
                 => ( ! [M4: num] :
                        ( ( X = aa(num,num,bit1,M4) )
                       => ( ( Xa = one2 )
                         => ( Y != some(num,aa(num,num,bit0,M4)) ) ) )
                   => ( ! [M4: num] :
                          ( ( X = aa(num,num,bit1,M4) )
                         => ! [N: num] :
                              ( ( Xa = aa(num,num,bit0,N) )
                             => ( Y != some(num,case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N))) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X = aa(num,num,bit1,M4) )
                           => ! [N: num] :
                                ( ( Xa = aa(num,num,bit1,N) )
                               => ( Y != map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N)) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
tff(fact_5606_of__rat__def,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( field_char_0_of_rat(A) = aa(fun(product_prod(int,int),A),fun(rat,A),map_fun(rat,product_prod(int,int),A,A,rep_Rat,id(A)),aTP_Lamp_mw(product_prod(int,int),A)) ) ) ).

% of_rat_def
tff(fact_5607_of__rat__0,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),zero_zero(rat)) = zero_zero(A) ) ) ).

% of_rat_0
tff(fact_5608_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( aa(rat,A,field_char_0_of_rat(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(rat) ) ) ) ).

% of_rat_eq_0_iff
tff(fact_5609_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( zero_zero(A) = aa(rat,A,field_char_0_of_rat(A),A2) )
        <=> ( zero_zero(rat) = A2 ) ) ) ).

% zero_eq_of_rat_iff
tff(fact_5610_of__rat__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),one_one(rat)) = one_one(A) ) ) ).

% of_rat_1
tff(fact_5611_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( aa(rat,A,field_char_0_of_rat(A),A2) = one_one(A) )
        <=> ( A2 = one_one(rat) ) ) ) ).

% of_rat_eq_1_iff
tff(fact_5612_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( one_one(A) = aa(rat,A,field_char_0_of_rat(A),A2) )
        <=> ( one_one(rat) = A2 ) ) ) ).

% one_eq_of_rat_iff
tff(fact_5613_of__rat__numeral__eq,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [W: num] : ( aa(rat,A,field_char_0_of_rat(A),aa(num,rat,numeral_numeral(rat),W)) = aa(num,A,numeral_numeral(A),W) ) ) ).

% of_rat_numeral_eq
tff(fact_5614_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(rat,A,field_char_0_of_rat(A),R2))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R2) ) ) ).

% zero_less_of_rat_iff
tff(fact_5615_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(rat,A,field_char_0_of_rat(A),R2)),zero_zero(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R2),zero_zero(rat)) ) ) ).

% of_rat_less_0_iff
tff(fact_5616_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(rat,A,field_char_0_of_rat(A),R2)),one_one(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R2),one_one(rat)) ) ) ).

% of_rat_less_1_iff
tff(fact_5617_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(rat,A,field_char_0_of_rat(A),R2))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),one_one(rat)),R2) ) ) ).

% one_less_of_rat_iff
tff(fact_5618_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(rat,A,field_char_0_of_rat(A),R2))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),zero_zero(rat)),R2) ) ) ).

% zero_le_of_rat_iff
tff(fact_5619_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(rat,A,field_char_0_of_rat(A),R2)),zero_zero(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R2),zero_zero(rat)) ) ) ).

% of_rat_le_0_iff
tff(fact_5620_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% of_rat_neg_one
tff(fact_5621_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(rat,A,field_char_0_of_rat(A),R2))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),one_one(rat)),R2) ) ) ).

% one_le_of_rat_iff
tff(fact_5622_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(rat,A,field_char_0_of_rat(A),R2)),one_one(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R2),one_one(rat)) ) ) ).

% of_rat_le_1_iff
tff(fact_5623_of__rat__neg__numeral__eq,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [W: num] : ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),W))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) ) ) ).

% of_rat_neg_numeral_eq
tff(fact_5624_of__rat__dense,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
     => ? [Q2: rat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(rat,real,field_char_0_of_rat(real),Q2))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(rat,real,field_char_0_of_rat(real),Q2)),Y) ) ) ).

% of_rat_dense
tff(fact_5625_of__rat__power,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,Na: nat] : ( aa(rat,A,field_char_0_of_rat(A),aa(nat,rat,aa(rat,fun(nat,rat),power_power(rat),A2),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(rat,A,field_char_0_of_rat(A),A2)),Na) ) ) ).

% of_rat_power
tff(fact_5626_of__rat__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R2: rat,S: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(rat,A,field_char_0_of_rat(A),R2)),aa(rat,A,field_char_0_of_rat(A),S))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R2),S) ) ) ).

% of_rat_less
tff(fact_5627_of__rat__add,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,B2: rat] : ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(rat,A,field_char_0_of_rat(A),A2)),aa(rat,A,field_char_0_of_rat(A),B2)) ) ) ).

% of_rat_add
tff(fact_5628_of__rat__diff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,B2: rat] : ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(rat,A,field_char_0_of_rat(A),A2)),aa(rat,A,field_char_0_of_rat(A),B2)) ) ) ).

% of_rat_diff
tff(fact_5629_of__rat__divide,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,B2: rat] : ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(rat,A,field_char_0_of_rat(A),A2)),aa(rat,A,field_char_0_of_rat(A),B2)) ) ) ).

% of_rat_divide
tff(fact_5630_and__num_Osimps_I1_J,axiom,
    aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,one2),one2) = some(num,one2) ).

% and_num.simps(1)
tff(fact_5631_xor__num_Osimps_I1_J,axiom,
    aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,one2),one2) = none(num) ).

% xor_num.simps(1)
tff(fact_5632_xor__num_Osimps_I5_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit0,M)),aa(num,num,bit0,Na)) = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na)) ) ).

% xor_num.simps(5)
tff(fact_5633_and__num_Osimps_I5_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit0,M)),aa(num,num,bit0,Na)) = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na)) ) ).

% and_num.simps(5)
tff(fact_5634_nonzero__of__rat__inverse,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( A2 != zero_zero(rat) )
         => ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,inverse_inverse(rat),A2)) = aa(A,A,inverse_inverse(A),aa(rat,A,field_char_0_of_rat(A),A2)) ) ) ) ).

% nonzero_of_rat_inverse
tff(fact_5635_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [B2: rat,A2: rat] :
          ( ( B2 != zero_zero(rat) )
         => ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,aa(rat,fun(rat,rat),divide_divide(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(rat,A,field_char_0_of_rat(A),A2)),aa(rat,A,field_char_0_of_rat(A),B2)) ) ) ) ).

% nonzero_of_rat_divide
tff(fact_5636_and__num_Osimps_I3_J,axiom,
    ! [Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,one2),aa(num,num,bit1,Na)) = some(num,one2) ) ).

% and_num.simps(3)
tff(fact_5637_and__num_Osimps_I7_J,axiom,
    ! [M: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit1,M)),one2) = some(num,one2) ) ).

% and_num.simps(7)
tff(fact_5638_and__num_Osimps_I2_J,axiom,
    ! [Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,one2),aa(num,num,bit0,Na)) = none(num) ) ).

% and_num.simps(2)
tff(fact_5639_and__num_Osimps_I4_J,axiom,
    ! [M: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit0,M)),one2) = none(num) ) ).

% and_num.simps(4)
tff(fact_5640_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: num,Q4: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na) = some(num,Q4) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),Q4) ) ) ) ).

% and_num_eq_Some_iff
tff(fact_5641_of__rat__rat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [B2: int,A2: int] :
          ( ( B2 != zero_zero(int) )
         => ( aa(rat,A,field_char_0_of_rat(A),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),A2)),aa(int,A,ring_1_of_int(A),B2)) ) ) ) ).

% of_rat_rat
tff(fact_5642_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: num,Q4: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na) = some(num,Q4) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = aa(num,A,numeral_numeral(A),Q4) ) ) ) ).

% xor_num_eq_Some_iff
tff(fact_5643_and__num_Osimps_I8_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit1,M)),aa(num,num,bit0,Na)) = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na)) ) ).

% and_num.simps(8)
tff(fact_5644_and__num_Osimps_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit0,M)),aa(num,num,bit1,Na)) = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na)) ) ).

% and_num.simps(6)
tff(fact_5645_xor__num_Osimps_I9_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit1,M)),aa(num,num,bit1,Na)) = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na)) ) ).

% xor_num.simps(9)
tff(fact_5646_xor__num_Osimps_I7_J,axiom,
    ! [M: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit1,M)),one2) = some(num,aa(num,num,bit0,M)) ) ).

% xor_num.simps(7)
tff(fact_5647_xor__num_Osimps_I4_J,axiom,
    ! [M: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit0,M)),one2) = some(num,aa(num,num,bit1,M)) ) ).

% xor_num.simps(4)
tff(fact_5648_xor__num_Osimps_I3_J,axiom,
    ! [Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,one2),aa(num,num,bit1,Na)) = some(num,aa(num,num,bit0,Na)) ) ).

% xor_num.simps(3)
tff(fact_5649_xor__num_Osimps_I2_J,axiom,
    ! [Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,one2),aa(num,num,bit0,Na)) = some(num,aa(num,num,bit1,Na)) ) ).

% xor_num.simps(2)
tff(fact_5650_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na) = none(num) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = zero_zero(A) ) ) ) ).

% and_num_eq_None_iff
tff(fact_5651_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: num] :
          ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na) = none(num) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = zero_zero(A) ) ) ) ).

% xor_num_eq_None_iff
tff(fact_5652_of__rat_Orep__eq,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [X: rat] : ( aa(rat,A,field_char_0_of_rat(A),X) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_fst(int,int),aa(rat,product_prod(int,int),rep_Rat,X)))),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_snd(int,int),aa(rat,product_prod(int,int),rep_Rat,X)))) ) ) ).

% of_rat.rep_eq
tff(fact_5653_numeral__and__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = case_option(A,num,zero_zero(A),numeral_numeral(A),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na)) ) ) ).

% numeral_and_num
tff(fact_5654_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),Na)) = case_option(A,num,zero_zero(A),numeral_numeral(A),aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na)) ) ) ).

% numeral_xor_num
tff(fact_5655_and__num_Osimps_I9_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,aa(num,num,bit1,M)),aa(num,num,bit1,Na)) = case_option(option(num),num,some(num,one2),aTP_Lamp_mn(num,option(num)),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M),Na)) ) ).

% and_num.simps(9)
tff(fact_5656_xor__num_Osimps_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit0,M)),aa(num,num,bit1,Na)) = some(num,case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na))) ) ).

% xor_num.simps(6)
tff(fact_5657_xor__num_Osimps_I8_J,axiom,
    ! [M: num,Na: num] : ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,aa(num,num,bit1,M)),aa(num,num,bit0,Na)) = some(num,case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M),Na))) ) ).

% xor_num.simps(8)
tff(fact_5658_inverse__rat__def,axiom,
    inverse_inverse(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_mx(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat_def
tff(fact_5659_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
tff(fact_5660_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
tff(fact_5661_one__rat__def,axiom,
    one_one(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))) ).

% one_rat_def
tff(fact_5662_Fract_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( aa(int,rat,aa(int,fun(int,rat),fract,Xa),X)
      = aa(product_prod(int,int),rat,abs_Rat,$ite(X = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,Xa),X))) ) ).

% Fract.abs_eq
tff(fact_5663_zero__rat__def,axiom,
    zero_zero(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))) ).

% zero_rat_def
tff(fact_5664_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
     => ( aa(rat,rat,inverse_inverse(rat),aa(product_prod(int,int),rat,abs_Rat,X))
        = aa(product_prod(int,int),rat,abs_Rat,$ite(aa(product_prod(int,int),int,product_fst(int,int),X) = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),X)),aa(product_prod(int,int),int,product_fst(int,int),X)))) ) ) ).

% inverse_rat.abs_eq
tff(fact_5665_Rat_Opositive_Oabs__eq,axiom,
    ! [X: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
     => ( aa(rat,$o,positive,aa(product_prod(int,int),rat,abs_Rat,X))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X)),aa(product_prod(int,int),int,product_snd(int,int),X))) ) ) ).

% Rat.positive.abs_eq
tff(fact_5666_lex__take__index,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),lex(A,R2))
     => ~ ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Ys))
             => ( ( take(A,I3,Xs) = take(A,I3,Ys) )
               => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Ys),I3)),R2) ) ) ) ) ).

% lex_take_index
tff(fact_5667_ratrel__iff,axiom,
    ! [X: product_prod(int,int),Y: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),Y)
    <=> ( ( aa(product_prod(int,int),int,product_snd(int,int),X) != zero_zero(int) )
        & ( aa(product_prod(int,int),int,product_snd(int,int),Y) != zero_zero(int) )
        & ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X)),aa(product_prod(int,int),int,product_snd(int,int),Y)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Y)),aa(product_prod(int,int),int,product_snd(int,int),X)) ) ) ) ).

% ratrel_iff
tff(fact_5668_one__rat_Orsp,axiom,
    aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))) ).

% one_rat.rsp
tff(fact_5669_zero__rat_Orsp,axiom,
    aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))) ).

% zero_rat.rsp
tff(fact_5670_ratrel__def,axiom,
    ! [X4: product_prod(int,int),Xa2: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X4),Xa2)
    <=> ( ( aa(product_prod(int,int),int,product_snd(int,int),X4) != zero_zero(int) )
        & ( aa(product_prod(int,int),int,product_snd(int,int),Xa2) != zero_zero(int) )
        & ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X4)),aa(product_prod(int,int),int,product_snd(int,int),Xa2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa2)),aa(product_prod(int,int),int,product_snd(int,int),X4)) ) ) ) ).

% ratrel_def
tff(fact_5671_of__rat_Oabs__eq,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [X: product_prod(int,int)] :
          ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
         => ( aa(rat,A,field_char_0_of_rat(A),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_fst(int,int),X))),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_snd(int,int),X))) ) ) ) ).

% of_rat.abs_eq
tff(fact_5672_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),listrel1(A,R2))
    <=> ? [Y5: A,N4: nat] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,nth(A,Xs),N4)),Y5),R2)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N4),aa(list(A),nat,size_size(list(A)),Xs))
          & ( Ys = list_update(A,Xs,N4,Y5) ) ) ) ).

% listrel1_iff_update
tff(fact_5673_num__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_num_of_integer(K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),one_one(code_integer)),one2,aa(product_prod(code_integer,code_integer),num,product_case_prod(code_integer,code_integer,num,aTP_Lamp_my(code_integer,fun(code_integer,num))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% num_of_integer_code
tff(fact_5674_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat,M: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na))),one_one(A)) ) ) ).

% mask_mod_exp
tff(fact_5675_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = A2 ) ) ) ).

% min.absorb3
tff(fact_5676_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = B2 ) ) ) ).

% min.absorb4
tff(fact_5677_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),Y) ) ) ) ).

% min_less_iff_conj
tff(fact_5678_min__Suc__Suc,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,Na)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)) ) ).

% min_Suc_Suc
tff(fact_5679_min__0R,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Na),zero_zero(nat)) = zero_zero(nat) ) ).

% min_0R
tff(fact_5680_min__0L,axiom,
    ! [Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),zero_zero(nat)),Na) = zero_zero(nat) ) ).

% min_0L
tff(fact_5681_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)),A2) ) ) ).

% take_bit_take_bit
tff(fact_5682_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,M),aa(A,A,bit_ri4674362597316999326ke_bit(A,Na),A2)) = aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)),A2) ) ) ).

% signed_take_bit_signed_take_bit
tff(fact_5683_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),U),aa(num,A,numeral_numeral(A),V)) ) ) ).

% min_number_of(1)
tff(fact_5684_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),aa(num,A,numeral_numeral(A),X)) = zero_zero(A) ) ) ).

% min_0_1(3)
tff(fact_5685_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(4)
tff(fact_5686_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(2)
tff(fact_5687_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),one_one(A)) = zero_zero(A) ) ) ).

% min_0_1(1)
tff(fact_5688_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),aa(num,A,numeral_numeral(A),X)) = one_one(A) ) ) ).

% min_0_1(5)
tff(fact_5689_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) = one_one(A) ) ) ).

% min_0_1(6)
tff(fact_5690_length__take,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),take(A,Na,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na) ) ).

% length_take
tff(fact_5691_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),bit_se2239418461657761734s_mask(A,Na)) = bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)) ) ) ).

% take_bit_of_mask
tff(fact_5692_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(num,A,numeral_numeral(A),U),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% min_number_of(2)
tff(fact_5693_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) ) ) ).

% min_number_of(3)
tff(fact_5694_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% min_number_of(4)
tff(fact_5695_min__Suc__numeral,axiom,
    ! [Na: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,Na)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Na),pred_numeral(K))) ) ).

% min_Suc_numeral
tff(fact_5696_min__numeral__Suc,axiom,
    ! [K: num,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,Na)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),pred_numeral(K)),Na)) ) ).

% min_numeral_Suc
tff(fact_5697_of__nat__min,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: nat,Y: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(nat,A,semiring_1_of_nat(A),X)),aa(nat,A,semiring_1_of_nat(A),Y)) ) ) ).

% of_nat_min
tff(fact_5698_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_max_eq_min
tff(fact_5699_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_min_eq_max
tff(fact_5700_of__int__min,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: int,Y: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),ord_min(int),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(int,A,ring_1_of_int(A),X)),aa(int,A,ring_1_of_int(A),Y)) ) ) ).

% of_int_min
tff(fact_5701_nat__mult__min__right,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Na),Q4)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q4)) ) ).

% nat_mult_min_right
tff(fact_5702_nat__mult__min__left,axiom,
    ! [M: nat,Na: nat,Q4: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)),Q4) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q4)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na),Q4)) ) ).

% nat_mult_min_left
tff(fact_5703_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z)) ) ) ).

% min_add_distrib_left
tff(fact_5704_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),ord_min(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z)) ) ) ).

% min_add_distrib_right
tff(fact_5705_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z)) ) ) ).

% min_diff_distrib_left
tff(fact_5706_min__diff,axiom,
    ! [M: nat,I2: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),I2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),I2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)),I2) ) ).

% min_diff
tff(fact_5707_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Z)
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Z) ) ) ) ).

% min_less_iff_disj
tff(fact_5708_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% min.strict_boundedE
tff(fact_5709_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% min.strict_order_iff
tff(fact_5710_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),C2) ) ) ).

% min.strict_coboundedI1
tff(fact_5711_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),C2) ) ) ).

% min.strict_coboundedI2
tff(fact_5712_min__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X4: A,Xa2: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),X4),Xa2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Xa2),X4,Xa2) ) ) ).

% min_def_raw
tff(fact_5713_concat__bit__assoc__sym,axiom,
    ! [M: nat,Na: nat,K: int,L: int,R2: int] : ( aa(int,int,bit_concat_bit(M,aa(int,int,bit_concat_bit(Na,K),L)),R2) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na),K),aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na),L),R2)) ) ).

% concat_bit_assoc_sym
tff(fact_5714_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),listrel1(A,R2))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) ) ) ).

% listrel1_eq_len
tff(fact_5715_take__bit__concat__bit__eq,axiom,
    ! [M: nat,Na: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,M),aa(int,int,bit_concat_bit(Na,K),L)) = aa(int,int,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na),K),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na)),L)) ) ).

% take_bit_concat_bit_eq
tff(fact_5716_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P3: A,X: A,Y: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P3),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y))) ) ) ).

% max_mult_distrib_left
tff(fact_5717_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P3: A,X: A,Y: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P3),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y))) ) ) ).

% min_mult_distrib_left
tff(fact_5718_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A,P3: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),P3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P3),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3))) ) ) ).

% max_mult_distrib_right
tff(fact_5719_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A,P3: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),P3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P3),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3))) ) ) ).

% min_mult_distrib_right
tff(fact_5720_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A,P3: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),P3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P3),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),P3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),P3)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),P3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),P3))) ) ) ).

% max_divide_distrib_right
tff(fact_5721_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A,P3: A] :
          ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),P3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P3),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),P3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),P3)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),P3)),aa(A,A,aa(A,fun(A,A),divide_divide(A),Y),P3))) ) ) ).

% min_divide_distrib_right
tff(fact_5722_min__Suc2,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),aa(nat,nat,suc,Na)) = case_nat(nat,zero_zero(nat),aTP_Lamp_mz(nat,fun(nat,nat),Na),M) ) ).

% min_Suc2
tff(fact_5723_min__Suc1,axiom,
    ! [Na: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,Na)),M) = case_nat(nat,zero_zero(nat),aTP_Lamp_na(nat,fun(nat,nat),Na),M) ) ).

% min_Suc1
tff(fact_5724_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,M: nat,Na: nat] : ( modulo_modulo(A,modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)) = modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na))) ) ) ).

% mod_exp_eq
tff(fact_5725_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X),Y),lexord(A,R2))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),X)),aa(list(A),nat,size_size(list(A)),Y))
          & ( take(A,aa(list(A),nat,size_size(list(A)),X),Y) = X ) )
        | ? [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),X)),aa(list(A),nat,size_size(list(A)),Y)))
            & ( take(A,I,X) = take(A,I,Y) )
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,nth(A,X),I)),aa(nat,A,nth(A,Y),I)),R2) ) ) ) ).

% lexord_take_index_conv
tff(fact_5726_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: fun(A,$o),Xs: list(A)] :
      ( ( some(A,X) = find(A,P,Xs) )
    <=> ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
          & aa(A,$o,P,aa(nat,A,nth(A,Xs),I))
          & ( X = aa(nat,A,nth(A,Xs),I) )
          & ! [J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),I)
             => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),J)) ) ) ) ).

% find_Some_iff2
tff(fact_5727_find__Some__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A),X: A] :
      ( ( find(A,P,Xs) = some(A,X) )
    <=> ? [I: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
          & aa(A,$o,P,aa(nat,A,nth(A,Xs),I))
          & ( X = aa(nat,A,nth(A,Xs),I) )
          & ! [J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),I)
             => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),J)) ) ) ) ).

% find_Some_iff
tff(fact_5728_min__enat__simps_I2_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q4),zero_zero(extended_enat)) = zero_zero(extended_enat) ) ).

% min_enat_simps(2)
tff(fact_5729_min__enat__simps_I3_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),zero_zero(extended_enat)),Q4) = zero_zero(extended_enat) ) ).

% min_enat_simps(3)
tff(fact_5730_lexord__lex,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X),Y),lex(A,R2))
    <=> ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),X),Y),lexord(A,R2))
        & ( aa(list(A),nat,size_size(list(A)),X) = aa(list(A),nat,size_size(list(A)),Y) ) ) ) ).

% lexord_lex
tff(fact_5731_card__Pow,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(set(A)),nat,finite_card(set(A)),pow2(A,A3)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(set(A),nat,finite_card(A),A3)) ) ) ).

% card_Pow
tff(fact_5732_nth__rotate,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),rotate(A,M),Xs)),Na) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate
tff(fact_5733_nth__zip,axiom,
    ! [A: $tType,B: $tType,I2: nat,Xs: list(A),Ys: list(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(B),nat,size_size(list(B)),Ys))
       => ( aa(nat,product_prod(A,B),nth(product_prod(A,B),zip(A,B,Xs,Ys)),I2) = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),I2)),aa(nat,B,nth(B,Ys),I2)) ) ) ) ).

% nth_zip
tff(fact_5734_rotate0,axiom,
    ! [A: $tType] : ( rotate(A,zero_zero(nat)) = id(list(A)) ) ).

% rotate0
tff(fact_5735_length__rotate,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),rotate(A,Na),Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rotate
tff(fact_5736_rotate__Suc,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,aa(nat,nat,suc,Na)),Xs) = rotate1(A,aa(list(A),list(A),rotate(A,Na),Xs)) ) ).

% rotate_Suc
tff(fact_5737_rotate__length01,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => ( aa(list(A),list(A),rotate(A,Na),Xs) = Xs ) ) ).

% rotate_length01
tff(fact_5738_rotate__id,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( modulo_modulo(nat,Na,aa(list(A),nat,size_size(list(A)),Xs)) = zero_zero(nat) )
     => ( aa(list(A),list(A),rotate(A,Na),Xs) = Xs ) ) ).

% rotate_id
tff(fact_5739_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),nat,size_size(list(product_prod(A,B))),zip(A,B,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)) ) ).

% length_zip
tff(fact_5740_rotate__rotate,axiom,
    ! [A: $tType,M: nat,Na: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,M),aa(list(A),list(A),rotate(A,Na),Xs)) = aa(list(A),list(A),rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)),Xs) ) ).

% rotate_rotate
tff(fact_5741_rotate__add,axiom,
    ! [A: $tType,M: nat,Na: nat] : ( rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),rotate(A,M)),rotate(A,Na)) ) ).

% rotate_add
tff(fact_5742_rotate__conv__mod,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,Na),Xs) = aa(list(A),list(A),rotate(A,modulo_modulo(nat,Na,aa(list(A),nat,size_size(list(A)),Xs))),Xs) ) ).

% rotate_conv_mod
tff(fact_5743_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),P: fun(list(product_prod(A,B)),$o)] :
      ( ! [Zs: list(A),Ws: list(B),N: nat] :
          ( ( aa(list(A),nat,size_size(list(A)),Zs) = aa(list(B),nat,size_size(list(B)),Ws) )
         => ( ( N = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)) )
           => ( ( Zs = take(A,N,Xs) )
             => ( ( Ws = take(B,N,Ys) )
               => aa(list(product_prod(A,B)),$o,P,zip(A,B,Zs,Ws)) ) ) ) )
     => aa(list(product_prod(A,B)),$o,P,zip(A,B,Xs,Ys)) ) ).

% zip_obtain_same_length
tff(fact_5744_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),X: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( member(A,X,aa(list(A),set(A),set2(A),Xs))
       => ~ ! [Y4: B] : ~ member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,X),Y4),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))) ) ) ).

% in_set_impl_in_set_zip1
tff(fact_5745_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Y: B] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( member(B,Y,aa(list(B),set(B),set2(B),Ys))
       => ~ ! [X3: A] : ~ member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,X3),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))) ) ) ).

% in_set_impl_in_set_zip2
tff(fact_5746_binomial__def,axiom,
    ! [Na: nat,K: nat] : ( aa(nat,nat,binomial(Na),K) = aa(set(set(nat)),nat,finite_card(set(nat)),collect(set(nat),aa(nat,fun(set(nat),$o),aTP_Lamp_nb(nat,fun(nat,fun(set(nat),$o)),Na),K))) ) ).

% binomial_def
tff(fact_5747_in__set__zip,axiom,
    ! [A: $tType,B: $tType,P3: product_prod(A,B),Xs: list(A),Ys: list(B)] :
      ( member(product_prod(A,B),P3,aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)))
    <=> ? [N4: nat] :
          ( ( aa(nat,A,nth(A,Xs),N4) = aa(product_prod(A,B),A,product_fst(A,B),P3) )
          & ( aa(nat,B,nth(B,Ys),N4) = aa(product_prod(A,B),B,product_snd(A,B),P3) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N4),aa(list(A),nat,size_size(list(A)),Xs))
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N4),aa(list(B),nat,size_size(list(B)),Ys)) ) ) ).

% in_set_zip
tff(fact_5748_set__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)) = collect(product_prod(A,B),aa(list(B),fun(product_prod(A,B),$o),aTP_Lamp_nc(list(A),fun(list(B),fun(product_prod(A,B),$o)),Xs),Ys)) ) ).

% set_zip
tff(fact_5749_quotient__of__def,axiom,
    ! [X: rat] : ( quotient_of(X) = the(product_prod(int,int),aTP_Lamp_nd(rat,fun(product_prod(int,int),$o),X)) ) ).

% quotient_of_def
tff(fact_5750_sum__list__update,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [K: nat,Xs: list(A),X: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
         => ( aa(list(A),A,groups8242544230860333062m_list(A),list_update(A,Xs,K,X)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),X)),aa(nat,A,nth(A,Xs),K)) ) ) ) ).

% sum_list_update
tff(fact_5751_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,C2,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( algebr8660921524188924756oprime(A,C2,A2)
            & algebr8660921524188924756oprime(A,C2,B2) ) ) ) ).

% coprime_mult_right_iff
tff(fact_5752_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2)
        <=> ( algebr8660921524188924756oprime(A,A2,C2)
            & algebr8660921524188924756oprime(A,B2,C2) ) ) ) ).

% coprime_mult_left_iff
tff(fact_5753_coprime__minus__left__iff,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,uminus_uminus(A),A2),B2)
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_minus_left_iff
tff(fact_5754_coprime__minus__right__iff,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,aa(A,A,uminus_uminus(A),B2))
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_minus_right_iff
tff(fact_5755_coprime__abs__left__iff,axiom,
    ! [K: int,L: int] :
      ( algebr8660921524188924756oprime(int,aa(int,int,abs_abs(int),K),L)
    <=> algebr8660921524188924756oprime(int,K,L) ) ).

% coprime_abs_left_iff
tff(fact_5756_coprime__abs__right__iff,axiom,
    ! [K: int,L: int] :
      ( algebr8660921524188924756oprime(int,K,aa(int,int,abs_abs(int),L))
    <=> algebr8660921524188924756oprime(int,K,L) ) ).

% coprime_abs_right_iff
tff(fact_5757_coprime__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,A2,A2)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% coprime_self
tff(fact_5758_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( algebr8660921524188924756oprime(A,modulo_modulo(A,A2,B2),B2)
          <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mod_left_iff
tff(fact_5759_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( algebr8660921524188924756oprime(A,A2,modulo_modulo(A,B2,A2))
          <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mod_right_iff
tff(fact_5760_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,Na: nat] :
          ( algebr8660921524188924756oprime(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na))
        <=> ( algebr8660921524188924756oprime(A,A2,B2)
            | ( Na = zero_zero(nat) ) ) ) ) ).

% coprime_power_right_iff
tff(fact_5761_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,Na: nat,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na),B2)
        <=> ( algebr8660921524188924756oprime(A,A2,B2)
            | ( Na = zero_zero(nat) ) ) ) ) ).

% coprime_power_left_iff
tff(fact_5762_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Ns: list(A)] :
          ( ( aa(list(A),A,groups8242544230860333062m_list(A),Ns) = zero_zero(A) )
        <=> ! [X5: A] :
              ( member(A,X5,aa(list(A),set(A),set2(A),Ns))
             => ( X5 = zero_zero(A) ) ) ) ) ).

% sum_list_eq_0_iff
tff(fact_5763_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) ) ) ) ).

% coprime_imp_gcd_eq_1
tff(fact_5764_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,zero_zero(A),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% coprime_0_left_iff
tff(fact_5765_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,A2,zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% coprime_0_right_iff
tff(fact_5766_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
            & algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mult_self_left_iff
tff(fact_5767_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
            & algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mult_self_right_iff
tff(fact_5768_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),one_one(A))
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% is_unit_gcd
tff(fact_5769_coprime__right__2__iff__odd,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% coprime_right_2_iff_odd
tff(fact_5770_coprime__left__2__iff__odd,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A2)
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2) ) ) ).

% coprime_left_2_iff_odd
tff(fact_5771_normalize__stable,axiom,
    ! [Q4: int,P3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q4)
     => ( algebr8660921524188924756oprime(int,P3,Q4)
       => ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P3),Q4)) = aa(int,product_prod(int,int),product_Pair(int,int,P3),Q4) ) ) ) ).

% normalize_stable
tff(fact_5772_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A2: A] :
          ( algebr8660921524188924756oprime(A,B2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_left_left_cancel
tff(fact_5773_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A2: A] :
          ( algebr8660921524188924756oprime(A,B2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_left_right_cancel
tff(fact_5774_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_right_left_cancel
tff(fact_5775_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_right_right_cancel
tff(fact_5776_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) ) ) ) ).

% coprime_iff_gcd_eq_1
tff(fact_5777_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% gcd_eq_1_imp_coprime
tff(fact_5778_coprime__crossproduct__int,axiom,
    ! [A2: int,D2: int,B2: int,C2: int] :
      ( algebr8660921524188924756oprime(int,A2,D2)
     => ( algebr8660921524188924756oprime(int,B2,C2)
       => ( ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),A2)),aa(int,int,abs_abs(int),C2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),B2)),aa(int,int,abs_abs(int),D2)) )
        <=> ( ( aa(int,int,abs_abs(int),A2) = aa(int,int,abs_abs(int),B2) )
            & ( aa(int,int,abs_abs(int),C2) = aa(int,int,abs_abs(int),D2) ) ) ) ) ) ).

% coprime_crossproduct_int
tff(fact_5779_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [Na: A,A2: A,M: A,B2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),Na),A2),M) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),Na),B2),M) )
         => ( algebr8660921524188924756oprime(A,M,Na)
           => ( modulo_modulo(A,A2,M) = modulo_modulo(A,B2,M) ) ) ) ) ).

% mult_mod_cancel_left
tff(fact_5780_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [A2: A,Na: A,M: A,B2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),Na),M) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),Na),M) )
         => ( algebr8660921524188924756oprime(A,M,Na)
           => ( modulo_modulo(A,A2,M) = modulo_modulo(A,B2,M) ) ) ) ) ).

% mult_mod_cancel_right
tff(fact_5781_divides__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => ( algebr8660921524188924756oprime(A,A2,B2)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ) ) ).

% divides_mult
tff(fact_5782_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% coprime_dvd_mult_left_iff
tff(fact_5783_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% coprime_dvd_mult_right_iff
tff(fact_5784_coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ! [C3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),B2)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),one_one(A)) ) )
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprimeI
tff(fact_5785_coprime__def,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
        <=> ! [C4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),B2)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),one_one(A)) ) ) ) ) ).

% coprime_def
tff(fact_5786_not__coprimeE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ~ algebr8660921524188924756oprime(A,A2,B2)
         => ~ ! [C3: A] :
                ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),A2)
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),B2)
                 => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),one_one(A)) ) ) ) ) ).

% not_coprimeE
tff(fact_5787_not__coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
             => ~ algebr8660921524188924756oprime(A,A2,B2) ) ) ) ) ).

% not_coprimeI
tff(fact_5788_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),Y)
         => ( algebr8660921524188924756oprime(A,X,Y)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),one_one(A)) ) ) ) ).

% coprime_absorb_left
tff(fact_5789_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,D2: A,A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,C2,D2)
         => ( ! [E: A] :
                ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),one_one(A))
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),A2)
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),B2)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),C2) ) ) )
           => ( ! [E: A] :
                  ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),one_one(A))
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),A2)
                   => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),B2)
                     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E),D2) ) ) )
             => algebr8660921524188924756oprime(A,A2,B2) ) ) ) ) ).

% coprime_imp_coprime
tff(fact_5790_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y),X)
         => ( algebr8660921524188924756oprime(A,X,Y)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y),one_one(A)) ) ) ) ).

% coprime_absorb_right
tff(fact_5791_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A)) ) ) ) ) ).

% coprime_common_divisor
tff(fact_5792_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% is_unit_left_imp_coprime
tff(fact_5793_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% is_unit_right_imp_coprime
tff(fact_5794_prod__coprime__right,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(A),A2: B,F2: fun(A,B)] :
          ( ! [I3: A] :
              ( member(A,I3,A3)
             => algebr8660921524188924756oprime(B,A2,aa(A,B,F2,I3)) )
         => algebr8660921524188924756oprime(B,A2,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)) ) ) ).

% prod_coprime_right
tff(fact_5795_prod__coprime__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(A),F2: fun(A,B),A2: B] :
          ( ! [I3: A] :
              ( member(A,I3,A3)
             => algebr8660921524188924756oprime(B,aa(A,B,F2,I3),A2) )
         => algebr8660921524188924756oprime(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3),A2) ) ) ).

% prod_coprime_left
tff(fact_5796_coprime__1__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,one_one(A),A2) ) ).

% coprime_1_left
tff(fact_5797_coprime__1__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,A2,one_one(A)) ) ).

% coprime_1_right
tff(fact_5798_coprime__divisors,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D2)
           => ( algebr8660921524188924756oprime(A,C2,D2)
             => algebr8660921524188924756oprime(A,A2,B2) ) ) ) ) ).

% coprime_divisors
tff(fact_5799_coprime__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( algebr8660921524188924756oprime(A,B2,A2)
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_commute
tff(fact_5800_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A)),A2) ) ).

% coprime_diff_one_left
tff(fact_5801_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,A2,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))) ) ).

% coprime_doff_one_right
tff(fact_5802_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,A2,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))) ) ).

% coprime_add_one_right
tff(fact_5803_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),A2) ) ).

% coprime_add_one_left
tff(fact_5804_invertible__coprime,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A2,C2) ) ) ).

% invertible_coprime
tff(fact_5805_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) != zero_zero(A) )
         => ? [A8: A,B6: A] :
              ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),A8),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
              & ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),B6),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
              & algebr8660921524188924756oprime(A,A8,B6) ) ) ) ).

% gcd_coprime_exists
tff(fact_5806_gcd__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,A5: A,B5: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) != zero_zero(A) )
         => ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),A5),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
           => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),B5),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
             => algebr8660921524188924756oprime(A,A5,B5) ) ) ) ) ).

% gcd_coprime
tff(fact_5807_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( ( A2 != zero_zero(A) )
            | ( B2 != zero_zero(A) ) )
         => algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2))) ) ) ).

% div_gcd_coprime
tff(fact_5808_Rat__induct,axiom,
    ! [P: fun(rat,$o),Q4: rat] :
      ( ! [A4: int,B4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
         => ( algebr8660921524188924756oprime(int,A4,B4)
           => aa(rat,$o,P,aa(int,rat,aa(int,fun(int,rat),fract,A4),B4)) ) )
     => aa(rat,$o,P,Q4) ) ).

% Rat_induct
tff(fact_5809_Rat__cases,axiom,
    ! [Q4: rat] :
      ~ ! [A4: int,B4: int] :
          ( ( Q4 = aa(int,rat,aa(int,fun(int,rat),fract,A4),B4) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
           => ~ algebr8660921524188924756oprime(int,A4,B4) ) ) ).

% Rat_cases
tff(fact_5810_coprime__common__divisor__int,axiom,
    ! [A2: int,B2: int,X: int] :
      ( algebr8660921524188924756oprime(int,A2,B2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),X),A2)
       => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),X),B2)
         => ( aa(int,int,abs_abs(int),X) = one_one(int) ) ) ) ) ).

% coprime_common_divisor_int
tff(fact_5811_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X3: A] :
              ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),zero_zero(A)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),zero_zero(A)) ) ) ).

% sum_list_nonpos
tff(fact_5812_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X3: A] :
              ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X3) )
         => ( ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = zero_zero(A) )
          <=> ! [X5: A] :
                ( member(A,X5,aa(list(A),set(A),set2(A),Xs))
               => ( X5 = zero_zero(A) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
tff(fact_5813_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X3: A] :
              ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X3) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(list(A),A,groups8242544230860333062m_list(A),Xs)) ) ) ).

% Groups_List.sum_list_nonneg
tff(fact_5814_Rat__cases__nonzero,axiom,
    ! [Q4: rat] :
      ( ! [A4: int,B4: int] :
          ( ( Q4 = aa(int,rat,aa(int,fun(int,rat),fract,A4),B4) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
           => ( ( A4 != zero_zero(int) )
             => ~ algebr8660921524188924756oprime(int,A4,B4) ) ) )
     => ( Q4 = zero_zero(rat) ) ) ).

% Rat_cases_nonzero
tff(fact_5815_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [K: nat,Ns: list(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Ns))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Ns),K)),aa(list(A),A,groups8242544230860333062m_list(A),Ns)) ) ) ).

% elem_le_sum_list
tff(fact_5816_set__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),Xs) = collect(A,aTP_Lamp_ne(list(A),fun(A,$o),Xs)) ) ).

% set_conv_nth
tff(fact_5817_card__length__sum__list__rec,axiom,
    ! [M: nat,N3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),M)
     => ( aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_nf(nat,fun(nat,fun(list(nat),$o)),M),N3))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_ng(nat,fun(nat,fun(list(nat),$o)),M),N3)))),aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_nh(nat,fun(nat,fun(list(nat),$o)),M),N3)))) ) ) ).

% card_length_sum_list_rec
tff(fact_5818_card__length__sum__list,axiom,
    ! [M: nat,N3: nat] : ( aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_nf(nat,fun(nat,fun(list(nat),$o)),M),N3))) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),M)),one_one(nat))),N3) ) ).

% card_length_sum_list
tff(fact_5819_quotient__of__unique,axiom,
    ! [R2: rat] :
    ? [X3: product_prod(int,int)] :
      ( ( R2 = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),X3)),aa(product_prod(int,int),int,product_snd(int,int),X3)) )
      & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),X3))
      & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),X3),aa(product_prod(int,int),int,product_snd(int,int),X3))
      & ! [Y3: product_prod(int,int)] :
          ( ( ( R2 = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),Y3)),aa(product_prod(int,int),int,product_snd(int,int),Y3)) )
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),Y3))
            & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),Y3),aa(product_prod(int,int),int,product_snd(int,int),Y3)) )
         => ( Y3 = X3 ) ) ) ).

% quotient_of_unique
tff(fact_5820_sum__list__sum__nth,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),nth(A,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% sum_list_sum_nth
tff(fact_5821_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( vEBT_VEBT_valid(X,Xa)
      <=> (Y) )
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X = vEBT_Leaf(Uu2,Uv2) )
         => ( (Y)
          <=> ( Xa != one_one(nat) ) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
             => ( (Y)
              <=> ~ ( ( Deg2 = Xa )
                    & $let(
                        n: nat,
                        n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        $let(
                          m: nat,
                          m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),n),
                          ( ! [X5: vEBT_VEBT] :
                              ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                             => vEBT_VEBT_valid(X5,n) )
                          & vEBT_VEBT_valid(Summary2,m)
                          & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
                          & case_option($o,product_prod(nat,nat),
                              ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X8)
                            & ! [X5: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                               => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                              product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg2),TreeList2),Summary2),n),m)),Mima) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
tff(fact_5822_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_valid(X,Xa)
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X = vEBT_Leaf(Uu2,Uv2) )
         => ( Xa != one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
             => ~ ( ( Deg2 = Xa )
                  & $let(
                      n: nat,
                      n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                      $let(
                        m: nat,
                        m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),n),
                        ( ! [X5: vEBT_VEBT] :
                            ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                           => vEBT_VEBT_valid(X5,n) )
                        & vEBT_VEBT_valid(Summary2,m)
                        & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
                        & case_option($o,product_prod(nat,nat),
                            ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X8)
                          & ! [X5: vEBT_VEBT] :
                              ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                             => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                            product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg2),TreeList2),Summary2),n),m)),Mima) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
tff(fact_5823_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_valid(X,Xa)
     => ( ( ? [Uu2: $o,Uv2: $o] : ( X = vEBT_Leaf(Uu2,Uv2) )
         => ( Xa = one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
              ( ( X = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
             => ( ( Deg2 = Xa )
                & $let(
                    n: nat,
                    n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                    $let(
                      m: nat,
                      m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),n),
                      ( ! [X5: vEBT_VEBT] :
                          ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                         => vEBT_VEBT_valid(X5,n) )
                      & vEBT_VEBT_valid(Summary2,m)
                      & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
                      & case_option($o,product_prod(nat,nat),
                          ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X8)
                        & ! [X5: vEBT_VEBT] :
                            ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                           => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                          product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg2),TreeList2),Summary2),n),m)),Mima) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
tff(fact_5824_coprime__int__iff,axiom,
    ! [M: nat,Na: nat] :
      ( algebr8660921524188924756oprime(int,aa(nat,int,semiring_1_of_nat(int),M),aa(nat,int,semiring_1_of_nat(int),Na))
    <=> algebr8660921524188924756oprime(nat,M,Na) ) ).

% coprime_int_iff
tff(fact_5825_coprime__nat__abs__left__iff,axiom,
    ! [K: int,Na: nat] :
      ( algebr8660921524188924756oprime(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),Na)
    <=> algebr8660921524188924756oprime(int,K,aa(nat,int,semiring_1_of_nat(int),Na)) ) ).

% coprime_nat_abs_left_iff
tff(fact_5826_coprime__nat__abs__right__iff,axiom,
    ! [Na: nat,K: int] :
      ( algebr8660921524188924756oprime(nat,Na,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)))
    <=> algebr8660921524188924756oprime(int,aa(nat,int,semiring_1_of_nat(int),Na),K) ) ).

% coprime_nat_abs_right_iff
tff(fact_5827_coprime__Suc__0__right,axiom,
    ! [Na: nat] : algebr8660921524188924756oprime(nat,Na,aa(nat,nat,suc,zero_zero(nat))) ).

% coprime_Suc_0_right
tff(fact_5828_coprime__Suc__0__left,axiom,
    ! [Na: nat] : algebr8660921524188924756oprime(nat,aa(nat,nat,suc,zero_zero(nat)),Na) ).

% coprime_Suc_0_left
tff(fact_5829_coprime__Suc__left__nat,axiom,
    ! [Na: nat] : algebr8660921524188924756oprime(nat,aa(nat,nat,suc,Na),Na) ).

% coprime_Suc_left_nat
tff(fact_5830_coprime__Suc__right__nat,axiom,
    ! [Na: nat] : algebr8660921524188924756oprime(nat,Na,aa(nat,nat,suc,Na)) ).

% coprime_Suc_right_nat
tff(fact_5831_coprime__crossproduct__nat,axiom,
    ! [A2: nat,D2: nat,B2: nat,C2: nat] :
      ( algebr8660921524188924756oprime(nat,A2,D2)
     => ( algebr8660921524188924756oprime(nat,B2,C2)
       => ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),C2) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),D2) )
        <=> ( ( A2 = B2 )
            & ( C2 = D2 ) ) ) ) ) ).

% coprime_crossproduct_nat
tff(fact_5832_coprime__common__divisor__nat,axiom,
    ! [A2: nat,B2: nat,X: nat] :
      ( algebr8660921524188924756oprime(nat,A2,B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),X),A2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),X),B2)
         => ( X = one_one(nat) ) ) ) ) ).

% coprime_common_divisor_nat
tff(fact_5833_coprime__diff__one__right__nat,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => algebr8660921524188924756oprime(nat,Na,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) ) ).

% coprime_diff_one_right_nat
tff(fact_5834_coprime__diff__one__left__nat,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => algebr8660921524188924756oprime(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),Na) ) ).

% coprime_diff_one_left_nat
tff(fact_5835_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,Deg4: nat] :
      ( vEBT_VEBT_valid(vEBT_Node(Mima2,Deg,TreeList,Summary),Deg4)
    <=> ( ( Deg = Deg4 )
        & $let(
            n: nat,
            n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
            $let(
              m: nat,
              m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
              ( ! [X5: vEBT_VEBT] :
                  ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                 => vEBT_VEBT_valid(X5,n) )
              & vEBT_VEBT_valid(Summary,m)
              & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
              & case_option($o,product_prod(nat,nat),
                  ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X8)
                & ! [X5: vEBT_VEBT] :
                    ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                   => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                  product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima2) ) ) ) ) ) ).

% VEBT_internal.valid'.simps(2)
tff(fact_5836_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ vEBT_VEBT_valid(X,Xa)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X = vEBT_Leaf(Uu2,Uv2) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa))
               => ( Xa = one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Xa))
                 => ( ( Deg2 = Xa )
                    & $let(
                        n: nat,
                        n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                        $let(
                          m: nat,
                          m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),n),
                          ( ! [X5: vEBT_VEBT] :
                              ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                             => vEBT_VEBT_valid(X5,n) )
                          & vEBT_VEBT_valid(Summary2,m)
                          & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
                          & case_option($o,product_prod(nat,nat),
                              ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X8)
                            & ! [X5: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                               => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                              product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg2),TreeList2),Summary2),n),m)),Mima) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
tff(fact_5837_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_valid(X,Xa)
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X = vEBT_Leaf(Uu2,Uv2) )
             => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa))
               => ( Xa != one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
               => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Xa))
                 => ~ ( ( Deg2 = Xa )
                      & $let(
                          n: nat,
                          n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                          $let(
                            m: nat,
                            m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),n),
                            ( ! [X5: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                               => vEBT_VEBT_valid(X5,n) )
                            & vEBT_VEBT_valid(Summary2,m)
                            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
                            & case_option($o,product_prod(nat,nat),
                                ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X8)
                              & ! [X5: vEBT_VEBT] :
                                  ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                                 => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                                product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg2),TreeList2),Summary2),n),m)),Mima) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
tff(fact_5838_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( vEBT_VEBT_valid(X,Xa)
      <=> (Y) )
     => ( accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,X),Xa))
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X = vEBT_Leaf(Uu2,Uv2) )
             => ( ( (Y)
                <=> ( Xa = one_one(nat) ) )
               => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv2)),Xa)) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg2: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT] :
                ( ( X = vEBT_Node(Mima,Deg2,TreeList2,Summary2) )
               => ( ( (Y)
                  <=> ( ( Deg2 = Xa )
                      & $let(
                          n: nat,
                          n := aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Deg2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),
                          $let(
                            m: nat,
                            m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg2),n),
                            ( ! [X5: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                               => vEBT_VEBT_valid(X5,n) )
                            & vEBT_VEBT_valid(Summary2,m)
                            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),m) )
                            & case_option($o,product_prod(nat,nat),
                                ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X8)
                              & ! [X5: vEBT_VEBT] :
                                  ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                                 => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
                                product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg2),TreeList2),Summary2),n),m)),Mima) ) ) ) ) )
                 => ~ accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel,aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg2,TreeList2,Summary2)),Xa)) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
tff(fact_5839_list__eq__iff__zip__eq,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs = Ys )
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
        & ! [X5: product_prod(A,A)] :
            ( member(product_prod(A,A),X5,aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),zip(A,A,Xs,Ys)))
           => aa(product_prod(A,A),$o,product_case_prod(A,A,$o,fequal(A)),X5) ) ) ) ).

% list_eq_iff_zip_eq
tff(fact_5840_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),R2: set(product_prod(A,B))] :
      ( member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys),listrel(A,B,R2))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [X5: product_prod(A,B)] :
            ( member(product_prod(A,B),X5,aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)))
           => aa(product_prod(A,B),$o,product_case_prod(A,B,$o,aTP_Lamp_nj(set(product_prod(A,B)),fun(A,fun(B,$o)),R2)),X5) ) ) ) ).

% listrel_iff_zip
tff(fact_5841_set__nths,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] : ( aa(list(A),set(A),set2(A),nths(A,Xs,I5)) = collect(A,aa(set(nat),fun(A,$o),aTP_Lamp_nk(list(A),fun(set(nat),fun(A,$o)),Xs),I5)) ) ).

% set_nths
tff(fact_5842_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [X: A] :
          ( member(A,X,field_char_0_Rats(A))
         => ~ ! [A4: int,B4: int] :
                ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
               => ( algebr8660921524188924756oprime(int,A4,B4)
                 => ( X != aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),A4)),aa(int,A,ring_1_of_int(A),B4)) ) ) ) ) ) ).

% Rats_cases'
tff(fact_5843_Rats__abs__iff,axiom,
    ! [X: real] :
      ( member(real,aa(real,real,abs_abs(real),X),field_char_0_Rats(real))
    <=> member(real,X,field_char_0_Rats(real)) ) ).

% Rats_abs_iff
tff(fact_5844_Rats__number__of,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [W: num] : member(A,aa(num,A,numeral_numeral(A),W),field_char_0_Rats(A)) ) ).

% Rats_number_of
tff(fact_5845_Rats__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => member(A,one_one(A),field_char_0_Rats(A)) ) ).

% Rats_1
tff(fact_5846_Rats__add,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,field_char_0_Rats(A))
         => ( member(A,B2,field_char_0_Rats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),field_char_0_Rats(A)) ) ) ) ).

% Rats_add
tff(fact_5847_Rats__0,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => member(A,zero_zero(A),field_char_0_Rats(A)) ) ).

% Rats_0
tff(fact_5848_Rats__divide,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,field_char_0_Rats(A))
         => ( member(A,B2,field_char_0_Rats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2),field_char_0_Rats(A)) ) ) ) ).

% Rats_divide
tff(fact_5849_Rats__diff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,field_char_0_Rats(A))
         => ( member(A,B2,field_char_0_Rats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),field_char_0_Rats(A)) ) ) ) ).

% Rats_diff
tff(fact_5850_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( member(real,X3,field_char_0_Rats(real))
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),X3) ) ).

% Rats_no_top_le
tff(fact_5851_Rats__dense__in__real,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
     => ? [X3: real] :
          ( member(real,X3,field_char_0_Rats(real))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),X3)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),Y) ) ) ).

% Rats_dense_in_real
tff(fact_5852_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( member(real,X3,field_char_0_Rats(real))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),X) ) ).

% Rats_no_bot_less
tff(fact_5853_Rats__power,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,Na: nat] :
          ( member(A,A2,field_char_0_Rats(A))
         => member(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na),field_char_0_Rats(A)) ) ) ).

% Rats_power
tff(fact_5854_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),R2: set(product_prod(A,B))] :
      ( member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys),listrel(A,B,R2))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) ) ) ).

% listrel_eq_len
tff(fact_5855_nths__all,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
         => member(nat,I3,I5) )
     => ( nths(A,Xs,I5) = Xs ) ) ).

% nths_all
tff(fact_5856_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys: list(list(A))] :
      ( ! [X3: product_prod(list(A),list(A))] :
          ( member(product_prod(list(A),list(A)),X3,aa(list(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),set2(product_prod(list(A),list(A))),zip(list(A),list(A),Xs,Ys)))
         => aa(product_prod(list(A),list(A)),$o,product_case_prod(list(A),list(A),$o,aTP_Lamp_nl(list(A),fun(list(A),$o))),X3) )
     => ( ( aa(list(list(A)),nat,size_size(list(list(A))),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Ys) )
       => ( ( concat(A,Xs) = concat(A,Ys) )
        <=> ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
tff(fact_5857_concat__injective,axiom,
    ! [A: $tType,Xs: list(list(A)),Ys: list(list(A))] :
      ( ( concat(A,Xs) = concat(A,Ys) )
     => ( ( aa(list(list(A)),nat,size_size(list(list(A))),Xs) = aa(list(list(A)),nat,size_size(list(list(A))),Ys) )
       => ( ! [X3: product_prod(list(A),list(A))] :
              ( member(product_prod(list(A),list(A)),X3,aa(list(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),set2(product_prod(list(A),list(A))),zip(list(A),list(A),Xs,Ys)))
             => aa(product_prod(list(A),list(A)),$o,product_case_prod(list(A),list(A),$o,aTP_Lamp_nl(list(A),fun(list(A),$o))),X3) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
tff(fact_5858_rat__less__code,axiom,
    ! [P3: rat,Q4: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),P3),Q4)
    <=> aa(product_prod(int,int),$o,product_case_prod(int,int,$o,aTP_Lamp_nn(rat,fun(int,fun(int,$o)),Q4)),quotient_of(P3)) ) ).

% rat_less_code
tff(fact_5859_length__nths,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] : ( aa(list(A),nat,size_size(list(A)),nths(A,Xs,I5)) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(set(nat),fun(nat,$o),aTP_Lamp_no(list(A),fun(set(nat),fun(nat,$o)),Xs),I5))) ) ).

% length_nths
tff(fact_5860_listrel__iff__nth,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),R2: set(product_prod(A,B))] :
      ( member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),product_Pair(list(A),list(B),Xs),Ys),listrel(A,B,R2))
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N4),aa(list(A),nat,size_size(list(A)),Xs))
           => member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),N4)),aa(nat,B,nth(B,Ys),N4)),R2) ) ) ) ).

% listrel_iff_nth
tff(fact_5861_Rats__abs__nat__div__natE,axiom,
    ! [X: real] :
      ( member(real,X,field_char_0_Rats(real))
     => ~ ! [M4: nat,N: nat] :
            ( ( N != zero_zero(nat) )
           => ( ( aa(real,real,abs_abs(real),X) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,semiring_1_of_nat(real),M4)),aa(nat,real,semiring_1_of_nat(real),N)) )
             => ~ algebr8660921524188924756oprime(nat,M4,N) ) ) ) ).

% Rats_abs_nat_div_natE
tff(fact_5862_int__ge__less__than2__def,axiom,
    ! [D2: int] : ( int_ge_less_than2(D2) = collect(product_prod(int,int),product_case_prod(int,int,$o,aTP_Lamp_np(int,fun(int,fun(int,$o)),D2))) ) ).

% int_ge_less_than2_def
tff(fact_5863_int__ge__less__than__def,axiom,
    ! [D2: int] : ( int_ge_less_than(D2) = collect(product_prod(int,int),product_case_prod(int,int,$o,aTP_Lamp_nq(int,fun(int,fun(int,$o)),D2))) ) ).

% int_ge_less_than_def
tff(fact_5864_lenlex__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lenlex(A,R2) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),$o,aTP_Lamp_nr(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),R2))) ) ).

% lenlex_conv
tff(fact_5865_lenlex__length,axiom,
    ! [A: $tType,Ms: list(A),Ns: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ms),Ns),lenlex(A,R2))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Ms)),aa(list(A),nat,size_size(list(A)),Ns)) ) ).

% lenlex_length
tff(fact_5866_Rats__eq__int__div__nat,axiom,
    field_char_0_Rats(real) = collect(real,aTP_Lamp_ns(real,$o)) ).

% Rats_eq_int_div_nat
tff(fact_5867_Rat_Opositive_Orsp,axiom,
    aa(fun(product_prod(int,int),$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),$o,$o,ratrel,fequal($o)),aTP_Lamp_mq(product_prod(int,int),$o)),aTP_Lamp_mq(product_prod(int,int),$o)) ).

% Rat.positive.rsp
tff(fact_5868_and__not__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X,Xa) = Y )
     => ( accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N: num] :
                  ( ( Xa = aa(num,num,bit0,N) )
                 => ( ( Y = some(num,one2) )
                   => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit0,N))) ) ) )
           => ( ( ( X = one2 )
               => ! [N: num] :
                    ( ( Xa = aa(num,num,bit1,N) )
                   => ( ( Y = none(num) )
                     => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit1,N))) ) ) )
             => ( ! [M4: num] :
                    ( ( X = aa(num,num,bit0,M4) )
                   => ( ( Xa = one2 )
                     => ( ( Y = some(num,aa(num,num,bit0,M4)) )
                       => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),one2)) ) ) )
               => ( ! [M4: num] :
                      ( ( X = aa(num,num,bit0,M4) )
                     => ! [N: num] :
                          ( ( Xa = aa(num,num,bit0,N) )
                         => ( ( Y = map_option(num,num,bit0,bit_and_not_num(M4,N)) )
                           => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit0,N))) ) ) )
                 => ( ! [M4: num] :
                        ( ( X = aa(num,num,bit0,M4) )
                       => ! [N: num] :
                            ( ( Xa = aa(num,num,bit1,N) )
                           => ( ( Y = map_option(num,num,bit0,bit_and_not_num(M4,N)) )
                             => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit1,N))) ) ) )
                   => ( ! [M4: num] :
                          ( ( X = aa(num,num,bit1,M4) )
                         => ( ( Xa = one2 )
                           => ( ( Y = some(num,aa(num,num,bit0,M4)) )
                             => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),one2)) ) ) )
                     => ( ! [M4: num] :
                            ( ( X = aa(num,num,bit1,M4) )
                           => ! [N: num] :
                                ( ( Xa = aa(num,num,bit0,N) )
                               => ( ( Y = case_option(option(num),num,some(num,one2),aTP_Lamp_mn(num,option(num)),bit_and_not_num(M4,N)) )
                                 => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit0,N))) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X = aa(num,num,bit1,M4) )
                             => ! [N: num] :
                                  ( ( Xa = aa(num,num,bit1,N) )
                                 => ( ( Y = map_option(num,num,bit0,bit_and_not_num(M4,N)) )
                                   => ~ accp(product_prod(num,num),bit_and_not_num_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit1,N))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
tff(fact_5869_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1(B)
        & ring_1(A) )
     => ! [R3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R3,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R3,one_one(A)),one_one(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R3,bNF_rel_fun(A,B,A,B,R3,R3)),plus_plus(A)),plus_plus(B))
             => ( aa(fun(B,B),$o,aa(fun(A,A),fun(fun(B,B),$o),bNF_rel_fun(A,B,A,B,R3,R3),uminus_uminus(A)),uminus_uminus(B))
               => aa(fun(int,B),$o,aa(fun(int,A),fun(fun(int,B),$o),bNF_rel_fun(int,int,A,B,fequal(int),R3),ring_1_of_int(A)),ring_1_of_int(B)) ) ) ) ) ) ).

% transfer_rule_of_int
tff(fact_5870_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & semiring_numeral(B)
        & monoid_add(A)
        & semiring_numeral(A) )
     => ! [R3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R3,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R3,one_one(A)),one_one(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R3,bNF_rel_fun(A,B,A,B,R3,R3)),plus_plus(A)),plus_plus(B))
             => aa(fun(num,B),$o,aa(fun(num,A),fun(fun(num,B),$o),bNF_rel_fun(num,num,A,B,fequal(num),R3),numeral_numeral(A)),numeral_numeral(B)) ) ) ) ) ).

% transfer_rule_numeral
tff(fact_5871_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & power(A) )
     => ! [R3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R3,one_one(A)),one_one(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R3,bNF_rel_fun(A,B,A,B,R3,R3)),times_times(A)),times_times(B))
           => aa(fun(B,fun(nat,B)),$o,aa(fun(A,fun(nat,A)),fun(fun(B,fun(nat,B)),$o),bNF_rel_fun(A,B,fun(nat,A),fun(nat,B),R3,bNF_rel_fun(nat,nat,A,B,fequal(nat),R3)),power_power(A)),power_power(B)) ) ) ) ).

% power_transfer
tff(fact_5872_Rats__eq__int__div__int,axiom,
    field_char_0_Rats(real) = collect(real,aTP_Lamp_nt(real,$o)) ).

% Rats_eq_int_div_int
tff(fact_5873_of__rat_Orsp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => aa(fun(product_prod(int,int),A),$o,aa(fun(product_prod(int,int),A),fun(fun(product_prod(int,int),A),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),A,A,ratrel,fequal(A)),aTP_Lamp_mw(product_prod(int,int),A)),aTP_Lamp_mw(product_prod(int,int),A)) ) ).

% of_rat.rsp
tff(fact_5874_and__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,X),Xa) = Y )
     => ( accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = some(num,one2) )
               => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N: num] :
                  ( ( Xa = aa(num,num,bit0,N) )
                 => ( ( Y = none(num) )
                   => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit0,N))) ) ) )
           => ( ( ( X = one2 )
               => ! [N: num] :
                    ( ( Xa = aa(num,num,bit1,N) )
                   => ( ( Y = some(num,one2) )
                     => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit1,N))) ) ) )
             => ( ! [M4: num] :
                    ( ( X = aa(num,num,bit0,M4) )
                   => ( ( Xa = one2 )
                     => ( ( Y = none(num) )
                       => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),one2)) ) ) )
               => ( ! [M4: num] :
                      ( ( X = aa(num,num,bit0,M4) )
                     => ! [N: num] :
                          ( ( Xa = aa(num,num,bit0,N) )
                         => ( ( Y = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) )
                           => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit0,N))) ) ) )
                 => ( ! [M4: num] :
                        ( ( X = aa(num,num,bit0,M4) )
                       => ! [N: num] :
                            ( ( Xa = aa(num,num,bit1,N) )
                           => ( ( Y = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) )
                             => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit1,N))) ) ) )
                   => ( ! [M4: num] :
                          ( ( X = aa(num,num,bit1,M4) )
                         => ( ( Xa = one2 )
                           => ( ( Y = some(num,one2) )
                             => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),one2)) ) ) )
                     => ( ! [M4: num] :
                            ( ( X = aa(num,num,bit1,M4) )
                           => ! [N: num] :
                                ( ( Xa = aa(num,num,bit0,N) )
                               => ( ( Y = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) )
                                 => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit0,N))) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X = aa(num,num,bit1,M4) )
                             => ! [N: num] :
                                  ( ( Xa = aa(num,num,bit1,N) )
                                 => ( ( Y = case_option(option(num),num,some(num,one2),aTP_Lamp_mn(num,option(num)),aa(num,option(num),aa(num,fun(num,option(num)),bit_un7362597486090784418nd_num,M4),N)) )
                                   => ~ accp(product_prod(num,num),bit_un4731106466462545111um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit1,N))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
tff(fact_5875_xor__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,X),Xa) = Y )
     => ( accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N: num] :
                  ( ( Xa = aa(num,num,bit0,N) )
                 => ( ( Y = some(num,aa(num,num,bit1,N)) )
                   => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit0,N))) ) ) )
           => ( ( ( X = one2 )
               => ! [N: num] :
                    ( ( Xa = aa(num,num,bit1,N) )
                   => ( ( Y = some(num,aa(num,num,bit0,N)) )
                     => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit1,N))) ) ) )
             => ( ! [M4: num] :
                    ( ( X = aa(num,num,bit0,M4) )
                   => ( ( Xa = one2 )
                     => ( ( Y = some(num,aa(num,num,bit1,M4)) )
                       => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),one2)) ) ) )
               => ( ! [M4: num] :
                      ( ( X = aa(num,num,bit0,M4) )
                     => ! [N: num] :
                          ( ( Xa = aa(num,num,bit0,N) )
                         => ( ( Y = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N)) )
                           => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit0,N))) ) ) )
                 => ( ! [M4: num] :
                        ( ( X = aa(num,num,bit0,M4) )
                       => ! [N: num] :
                            ( ( Xa = aa(num,num,bit1,N) )
                           => ( ( Y = some(num,case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N))) )
                             => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,M4)),aa(num,num,bit1,N))) ) ) )
                   => ( ! [M4: num] :
                          ( ( X = aa(num,num,bit1,M4) )
                         => ( ( Xa = one2 )
                           => ( ( Y = some(num,aa(num,num,bit0,M4)) )
                             => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),one2)) ) ) )
                     => ( ! [M4: num] :
                            ( ( X = aa(num,num,bit1,M4) )
                           => ! [N: num] :
                                ( ( Xa = aa(num,num,bit0,N) )
                               => ( ( Y = some(num,case_option(num,num,one2,bit1,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N))) )
                                 => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit0,N))) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X = aa(num,num,bit1,M4) )
                             => ! [N: num] :
                                  ( ( Xa = aa(num,num,bit1,N) )
                                 => ( ( Y = map_option(num,num,bit0,aa(num,option(num),aa(num,fun(num,option(num)),bit_un2480387367778600638or_num,M4),N)) )
                                   => ~ accp(product_prod(num,num),bit_un2901131394128224187um_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,M4)),aa(num,num,bit1,N))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
tff(fact_5876_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1(B)
        & semiring_1(A) )
     => ! [R3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R3,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R3,one_one(A)),one_one(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R3,bNF_rel_fun(A,B,A,B,R3,R3)),plus_plus(A)),plus_plus(B))
             => aa(fun(nat,B),$o,aa(fun(nat,A),fun(fun(nat,B),$o),bNF_rel_fun(nat,nat,A,B,fequal(nat),R3),semiring_1_of_nat(A)),semiring_1_of_nat(B)) ) ) ) ) ).

% transfer_rule_of_nat
tff(fact_5877_Fract_Orsp,axiom,
    aa(fun(int,fun(int,product_prod(int,int))),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,product_prod(int,int))),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,product_prod(int,int)),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),product_prod(int,int),fequal(int),ratrel)),aTP_Lamp_nu(int,fun(int,product_prod(int,int)))),aTP_Lamp_nu(int,fun(int,product_prod(int,int)))) ).

% Fract.rsp
tff(fact_5878_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S3: fun(A,fun(B,$o))] : aa(fun(B,fun(fun(num,B),fun(fun(num,B),fun(num,B)))),$o,aa(fun(A,fun(fun(num,A),fun(fun(num,A),fun(num,A)))),fun(fun(B,fun(fun(num,B),fun(fun(num,B),fun(num,B)))),$o),bNF_rel_fun(A,B,fun(fun(num,A),fun(fun(num,A),fun(num,A))),fun(fun(num,B),fun(fun(num,B),fun(num,B))),S3,bNF_rel_fun(fun(num,A),fun(num,B),fun(fun(num,A),fun(num,A)),fun(fun(num,B),fun(num,B)),bNF_rel_fun(num,num,A,B,fequal(num),S3),bNF_rel_fun(fun(num,A),fun(num,B),fun(num,A),fun(num,B),bNF_rel_fun(num,num,A,B,fequal(num),S3),bNF_rel_fun(num,num,A,B,fequal(num),S3)))),case_num(A)),case_num(B)) ).

% num.case_transfer
tff(fact_5879_gcd__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),gcd_gcd(int)),gcd_gcd(int)) ).

% gcd_integer.rsp
tff(fact_5880_set__bit__integer_Orsp,axiom,
    aa(fun(nat,fun(int,int)),$o,aa(fun(nat,fun(int,int)),fun(fun(nat,fun(int,int)),$o),bNF_rel_fun(nat,nat,fun(int,int),fun(int,int),fequal(nat),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),bit_se5668285175392031749et_bit(int)),bit_se5668285175392031749et_bit(int)) ).

% set_bit_integer.rsp
tff(fact_5881_set__bit__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),bit_se5668285175392031749et_bit(nat)),bit_se5668285175392031749et_bit(nat)) ).

% set_bit_natural.rsp
tff(fact_5882_flip__bit__integer_Orsp,axiom,
    aa(fun(nat,fun(int,int)),$o,aa(fun(nat,fun(int,int)),fun(fun(nat,fun(int,int)),$o),bNF_rel_fun(nat,nat,fun(int,int),fun(int,int),fequal(nat),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),bit_se8732182000553998342ip_bit(int)),bit_se8732182000553998342ip_bit(int)) ).

% flip_bit_integer.rsp
tff(fact_5883_flip__bit__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),bit_se8732182000553998342ip_bit(nat)),bit_se8732182000553998342ip_bit(nat)) ).

% flip_bit_natural.rsp
tff(fact_5884_unset__bit__integer_Orsp,axiom,
    aa(fun(nat,fun(int,int)),$o,aa(fun(nat,fun(int,int)),fun(fun(nat,fun(int,int)),$o),bNF_rel_fun(nat,nat,fun(int,int),fun(int,int),fequal(nat),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),bit_se2638667681897837118et_bit(int)),bit_se2638667681897837118et_bit(int)) ).

% unset_bit_integer.rsp
tff(fact_5885_unset__bit__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),bit_se2638667681897837118et_bit(nat)),bit_se2638667681897837118et_bit(nat)) ).

% unset_bit_natural.rsp
tff(fact_5886_Suc_Orsp,axiom,
    aa(fun(nat,nat),$o,aa(fun(nat,nat),fun(fun(nat,nat),$o),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat)),suc),suc) ).

% Suc.rsp
tff(fact_5887_plus__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),plus_plus(nat)),plus_plus(nat)) ).

% plus_natural.rsp
tff(fact_5888_divide__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),divide_divide(int)),divide_divide(int)) ).

% divide_integer.rsp
tff(fact_5889_divide__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),divide_divide(nat)),divide_divide(nat)) ).

% divide_natural.rsp
tff(fact_5890_minus__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),minus_minus(nat)),minus_minus(nat)) ).

% minus_natural.rsp
tff(fact_5891_minus__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),minus_minus(int)),minus_minus(int)) ).

% minus_integer.rsp
tff(fact_5892_sub_Orsp,axiom,
    aa(fun(num,fun(num,int)),$o,aa(fun(num,fun(num,int)),fun(fun(num,fun(num,int)),$o),bNF_rel_fun(num,num,fun(num,int),fun(num,int),fequal(num),bNF_rel_fun(num,num,int,int,fequal(num),fequal(int))),aTP_Lamp_nv(num,fun(num,int))),aTP_Lamp_nv(num,fun(num,int))) ).

% sub.rsp
tff(fact_5893_less__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,$o)),$o,aa(fun(nat,fun(nat,$o)),fun(fun(nat,fun(nat,$o)),$o),bNF_rel_fun(nat,nat,fun(nat,$o),fun(nat,$o),fequal(nat),bNF_rel_fun(nat,nat,$o,$o,fequal(nat),fequal($o))),ord_less(nat)),ord_less(nat)) ).

% less_natural.rsp
tff(fact_5894_less__integer_Orsp,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(int,fun(int,$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(int,int,fun(int,$o),fun(int,$o),fequal(int),bNF_rel_fun(int,int,$o,$o,fequal(int),fequal($o))),ord_less(int)),ord_less(int)) ).

% less_integer.rsp
tff(fact_5895_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( zero_neq_one(B)
        & zero_neq_one(A) )
     => ! [R3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R3,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R3,one_one(A)),one_one(B))
           => aa(fun($o,B),$o,aa(fun($o,A),fun(fun($o,B),$o),bNF_rel_fun($o,$o,A,B,fequal($o),R3),zero_neq_one_of_bool(A)),zero_neq_one_of_bool(B)) ) ) ) ).

% transfer_rule_of_bool
tff(fact_5896_inverse__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),product_prod(int,int)),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_mx(product_prod(int,int),product_prod(int,int))),aTP_Lamp_mx(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat.rsp
tff(fact_5897_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( bit_or_not_num_neg(X,Xa) = Y )
     => ( accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa = aa(num,num,bit0,M4) )
                 => ( ( Y = aa(num,num,bit1,M4) )
                   => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit0,M4))) ) ) )
           => ( ( ( X = one2 )
               => ! [M4: num] :
                    ( ( Xa = aa(num,num,bit1,M4) )
                   => ( ( Y = aa(num,num,bit1,M4) )
                     => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,one2),aa(num,num,bit1,M4))) ) ) )
             => ( ! [N: num] :
                    ( ( X = aa(num,num,bit0,N) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,num,bit0,one2) )
                       => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,N)),one2)) ) ) )
               => ( ! [N: num] :
                      ( ( X = aa(num,num,bit0,N) )
                     => ! [M4: num] :
                          ( ( Xa = aa(num,num,bit0,M4) )
                         => ( ( Y = bitM(bit_or_not_num_neg(N,M4)) )
                           => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,N)),aa(num,num,bit0,M4))) ) ) )
                 => ( ! [N: num] :
                        ( ( X = aa(num,num,bit0,N) )
                       => ! [M4: num] :
                            ( ( Xa = aa(num,num,bit1,M4) )
                           => ( ( Y = aa(num,num,bit0,bit_or_not_num_neg(N,M4)) )
                             => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit0,N)),aa(num,num,bit1,M4))) ) ) )
                   => ( ! [N: num] :
                          ( ( X = aa(num,num,bit1,N) )
                         => ( ( Xa = one2 )
                           => ( ( Y = one2 )
                             => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,N)),one2)) ) ) )
                     => ( ! [N: num] :
                            ( ( X = aa(num,num,bit1,N) )
                           => ! [M4: num] :
                                ( ( Xa = aa(num,num,bit0,M4) )
                               => ( ( Y = bitM(bit_or_not_num_neg(N,M4)) )
                                 => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,N)),aa(num,num,bit0,M4))) ) ) )
                       => ~ ! [N: num] :
                              ( ( X = aa(num,num,bit1,N) )
                             => ! [M4: num] :
                                  ( ( Xa = aa(num,num,bit1,M4) )
                                 => ( ( Y = bitM(bit_or_not_num_neg(N,M4)) )
                                   => ~ accp(product_prod(num,num),bit_or3848514188828904588eg_rel,aa(num,product_prod(num,num),product_Pair(num,num,aa(num,num,bit1,N)),aa(num,num,bit1,M4))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
tff(fact_5898_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
tff(fact_5899_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
tff(fact_5900_inverse__rat_Otransfer,axiom,
    aa(fun(rat,rat),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),$o),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_mx(product_prod(int,int),product_prod(int,int))),inverse_inverse(rat)) ).

% inverse_rat.transfer
tff(fact_5901_Rat_Opositive_Otransfer,axiom,
    aa(fun(rat,$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(rat,$o),$o),bNF_rel_fun(product_prod(int,int),rat,$o,$o,pcr_rat,fequal($o)),aTP_Lamp_mq(product_prod(int,int),$o)),positive) ).

% Rat.positive.transfer
tff(fact_5902_times__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_li(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),times_times(int)) ).

% times_int.transfer
tff(fact_5903_zero__int_Otransfer,axiom,
    aa(int,$o,aa(product_prod(nat,nat),fun(int,$o),pcr_int,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))),zero_zero(int)) ).

% zero_int.transfer
tff(fact_5904_one__rat_Otransfer,axiom,
    aa(rat,$o,aa(product_prod(int,int),fun(rat,$o),pcr_rat,aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))),one_one(rat)) ).

% one_rat.transfer
tff(fact_5905_int__transfer,axiom,
    aa(fun(nat,int),$o,aa(fun(nat,product_prod(nat,nat)),fun(fun(nat,int),$o),bNF_rel_fun(nat,nat,product_prod(nat,nat),int,fequal(nat),pcr_int),aTP_Lamp_nw(nat,product_prod(nat,nat))),semiring_1_of_nat(int)) ).

% int_transfer
tff(fact_5906_uminus__int_Otransfer,axiom,
    aa(fun(int,int),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(int,int),$o),bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_lj(nat,fun(nat,product_prod(nat,nat))))),uminus_uminus(int)) ).

% uminus_int.transfer
tff(fact_5907_nat_Otransfer,axiom,
    aa(fun(int,nat),$o,aa(fun(product_prod(nat,nat),nat),fun(fun(int,nat),$o),bNF_rel_fun(product_prod(nat,nat),int,nat,nat,pcr_int,fequal(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))),nat2) ).

% nat.transfer
tff(fact_5908_one__int_Otransfer,axiom,
    aa(int,$o,aa(product_prod(nat,nat),fun(int,$o),pcr_int,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))),one_one(int)) ).

% one_int.transfer
tff(fact_5909_zero__rat_Otransfer,axiom,
    aa(rat,$o,aa(product_prod(int,int),fun(rat,$o),pcr_rat,aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))),zero_zero(rat)) ).

% zero_rat.transfer
tff(fact_5910_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(fun(int,A),$o,aa(fun(product_prod(nat,nat),A),fun(fun(int,A),$o),bNF_rel_fun(product_prod(nat,nat),int,A,A,pcr_int,fequal(A)),product_case_prod(nat,nat,A,aTP_Lamp_lk(nat,fun(nat,A)))),ring_1_of_int(A)) ) ).

% of_int.transfer
tff(fact_5911_Fract_Otransfer,axiom,
    aa(fun(int,fun(int,rat)),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,rat)),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),rat,fequal(int),pcr_rat)),aTP_Lamp_nu(int,fun(int,product_prod(int,int)))),fract) ).

% Fract.transfer
tff(fact_5912_less__int_Otransfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o))))),ord_less(int)) ).

% less_int.transfer
tff(fact_5913_less__eq__int_Otransfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o))))),ord_less_eq(int)) ).

% less_eq_int.transfer
tff(fact_5914_of__rat_Otransfer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => aa(fun(rat,A),$o,aa(fun(product_prod(int,int),A),fun(fun(rat,A),$o),bNF_rel_fun(product_prod(int,int),rat,A,A,pcr_rat,fequal(A)),aTP_Lamp_mw(product_prod(int,int),A)),field_char_0_of_rat(A)) ) ).

% of_rat.transfer
tff(fact_5915_plus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_lq(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),plus_plus(int)) ).

% plus_int.transfer
tff(fact_5916_minus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ls(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),minus_minus(int)) ).

% minus_int.transfer
tff(fact_5917_num_Orec__transfer,axiom,
    ! [A: $tType,B: $tType,S3: fun(A,fun(B,$o))] : aa(fun(B,fun(fun(num,fun(B,B)),fun(fun(num,fun(B,B)),fun(num,B)))),$o,aa(fun(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)))),fun(fun(B,fun(fun(num,fun(B,B)),fun(fun(num,fun(B,B)),fun(num,B)))),$o),bNF_rel_fun(A,B,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),fun(fun(num,fun(B,B)),fun(fun(num,fun(B,B)),fun(num,B))),S3,bNF_rel_fun(fun(num,fun(A,A)),fun(num,fun(B,B)),fun(fun(num,fun(A,A)),fun(num,A)),fun(fun(num,fun(B,B)),fun(num,B)),bNF_rel_fun(num,num,fun(A,A),fun(B,B),fequal(num),bNF_rel_fun(A,B,A,B,S3,S3)),bNF_rel_fun(fun(num,fun(A,A)),fun(num,fun(B,B)),fun(num,A),fun(num,B),bNF_rel_fun(num,num,fun(A,A),fun(B,B),fequal(num),bNF_rel_fun(A,B,A,B,S3,S3)),bNF_rel_fun(num,num,A,B,fequal(num),S3)))),rec_num(A)),rec_num(B)) ).

% num.rec_transfer
tff(fact_5918_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( semiring_1_Nats(A) = collect(A,aTP_Lamp_nx(A,$o)) ) ) ).

% Nats_altdef1
tff(fact_5919_times__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_li(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_li(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int.rsp
tff(fact_5920_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V: nat] :
      ( aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Y)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,U),V))
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),V) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),U),Y) ) ) ).

% intrel_iff
tff(fact_5921_int_Orel__eq__transfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),intrel),fequal(int)) ).

% int.rel_eq_transfer
tff(fact_5922_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] : member(A,aa(nat,A,semiring_1_of_nat(A),Na),semiring_1_Nats(A)) ) ).

% of_nat_in_Nats
tff(fact_5923_Nats__induct,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X: A,P: fun(A,$o)] :
          ( member(A,X,semiring_1_Nats(A))
         => ( ! [N: nat] : aa(A,$o,P,aa(nat,A,semiring_1_of_nat(A),N))
           => aa(A,$o,P,X) ) ) ) ).

% Nats_induct
tff(fact_5924_Nats__cases,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X: A] :
          ( member(A,X,semiring_1_Nats(A))
         => ~ ! [N: nat] : ( X != aa(nat,A,semiring_1_of_nat(A),N) ) ) ) ).

% Nats_cases
tff(fact_5925_int_Oabs__eq__iff,axiom,
    ! [X: product_prod(nat,nat),Y: product_prod(nat,nat)] :
      ( ( aa(product_prod(nat,nat),int,abs_Integ,X) = aa(product_prod(nat,nat),int,abs_Integ,Y) )
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,X),Y) ) ).

% int.abs_eq_iff
tff(fact_5926_Nats__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [W: num] : member(A,aa(num,A,numeral_numeral(A),W),semiring_1_Nats(A)) ) ).

% Nats_numeral
tff(fact_5927_Nats__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,semiring_1_Nats(A))
         => ( member(A,B2,semiring_1_Nats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),semiring_1_Nats(A)) ) ) ) ).

% Nats_mult
tff(fact_5928_Nats__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => member(A,zero_zero(A),semiring_1_Nats(A)) ) ).

% Nats_0
tff(fact_5929_Nats__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,semiring_1_Nats(A))
         => ( member(A,B2,semiring_1_Nats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),semiring_1_Nats(A)) ) ) ) ).

% Nats_add
tff(fact_5930_Nats__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => member(A,one_one(A),semiring_1_Nats(A)) ) ).

% Nats_1
tff(fact_5931_verit__eq__simplify_I20_J,axiom,
    ! [A: $tType,F1: A,F22: fun(num,fun(A,A)),F32: fun(num,fun(A,A)),X2: num] : ( aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F22),F32),aa(num,num,bit0,X2)) = aa(A,A,aa(num,fun(A,A),F22,X2),aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F22),F32),X2)) ) ).

% verit_eq_simplify(20)
tff(fact_5932_verit__eq__simplify_I19_J,axiom,
    ! [A: $tType,F1: A,F22: fun(num,fun(A,A)),F32: fun(num,fun(A,A))] : ( aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F22),F32),one2) = F1 ) ).

% verit_eq_simplify(19)
tff(fact_5933_verit__eq__simplify_I21_J,axiom,
    ! [A: $tType,F1: A,F22: fun(num,fun(A,A)),F32: fun(num,fun(A,A)),X32: num] : ( aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F22),F32),aa(num,num,bit1,X32)) = aa(A,A,aa(num,fun(A,A),F32,X32),aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F22),F32),X32)) ) ).

% verit_eq_simplify(21)
tff(fact_5934_zero__int_Orsp,axiom,
    aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))) ).

% zero_int.rsp
tff(fact_5935_Nats__diff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,semiring_1_Nats(A))
         => ( member(A,B2,semiring_1_Nats(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
             => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),semiring_1_Nats(A)) ) ) ) ) ).

% Nats_diff
tff(fact_5936_uminus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),product_prod(nat,nat)),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),product_prod(nat,nat)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_lj(nat,fun(nat,product_prod(nat,nat))))),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_lj(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int.rsp
tff(fact_5937_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),semiring_1_Nats(A)),ring_1_Ints(A)) ) ).

% Nats_subset_Ints
tff(fact_5938_nat_Orsp,axiom,
    aa(fun(product_prod(nat,nat),nat),$o,aa(fun(product_prod(nat,nat),nat),fun(fun(product_prod(nat,nat),nat),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),nat,nat,intrel,fequal(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))),product_case_prod(nat,nat,nat,minus_minus(nat))) ).

% nat.rsp
tff(fact_5939_one__int_Orsp,axiom,
    aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))) ).

% one_int.rsp
tff(fact_5940_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(fun(product_prod(nat,nat),A),$o,aa(fun(product_prod(nat,nat),A),fun(fun(product_prod(nat,nat),A),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),A,A,intrel,fequal(A)),product_case_prod(nat,nat,A,aTP_Lamp_lk(nat,fun(nat,A)))),product_case_prod(nat,nat,A,aTP_Lamp_lk(nat,fun(nat,A)))) ) ).

% of_int.rsp
tff(fact_5941_intrel__def,axiom,
    intrel = product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nz(nat,fun(nat,fun(product_prod(nat,nat),$o)))) ).

% intrel_def
tff(fact_5942_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( semiring_1_Nats(A) = collect(A,aTP_Lamp_oa(A,$o)) ) ) ).

% Nats_altdef2
tff(fact_5943_less__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(product_prod(nat,nat),$o),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),$o,$o,intrel,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_int.rsp
tff(fact_5944_less__eq__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(product_prod(nat,nat),$o),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),$o,$o,intrel,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_eq_int.rsp
tff(fact_5945_plus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_lq(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_lq(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int.rsp
tff(fact_5946_minus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ls(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_ls(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int.rsp
tff(fact_5947_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( member(complex,Z,semiring_1_Nats(complex))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I: nat] : ( re(Z) = aa(nat,real,semiring_1_of_nat(real),I) ) ) ) ).

% complex_is_Nat_iff
tff(fact_5948_rcis__inverse,axiom,
    ! [R2: real,A2: real] : ( aa(complex,complex,inverse_inverse(complex),rcis(R2,A2)) = rcis(aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),R2),aa(real,real,uminus_uminus(real),A2)) ) ).

% rcis_inverse
tff(fact_5949_power_Opower__eq__if,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A)),P3: A,M: nat] :
      ( power2(A,One,Times,P3,M)
      = $ite(M = zero_zero(nat),One,aa(A,A,aa(A,fun(A,A),Times,P3),power2(A,One,Times,P3,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))) ) ).

% power.power_eq_if
tff(fact_5950_range__mod,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( image(nat,nat,aTP_Lamp_ob(nat,fun(nat,nat),Na),top_top(set(nat))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),Na) ) ) ).

% range_mod
tff(fact_5951_range__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),A2),top_top(set(A))) = top_top(set(A)) ) ) ).

% range_add
tff(fact_5952_surj__plus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),A2),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_plus
tff(fact_5953_range__diff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( image(A,A,aa(A,fun(A,A),minus_minus(A),A2),top_top(set(A))) = top_top(set(A)) ) ) ).

% range_diff
tff(fact_5954_Diff__UNIV,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),top_top(set(A))) = bot_bot(set(A)) ) ).

% Diff_UNIV
tff(fact_5955_surj__fn,axiom,
    ! [A: $tType,F2: fun(A,A),Na: nat] :
      ( ( image(A,A,F2,top_top(set(A))) = top_top(set(A)) )
     => ( image(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_fn
tff(fact_5956_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,top_top(set(A))) = one_one(A) ) ) ).

% Gcd_UNIV
tff(fact_5957_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_diff_right
tff(fact_5958_rcis__zero__arg,axiom,
    ! [R2: real] : ( rcis(R2,zero_zero(real)) = real_Vector_of_real(complex,R2) ) ).

% rcis_zero_arg
tff(fact_5959_rcis__eq__zero__iff,axiom,
    ! [R2: real,A2: real] :
      ( ( rcis(R2,A2) = zero_zero(complex) )
    <=> ( R2 = zero_zero(real) ) ) ).

% rcis_eq_zero_iff
tff(fact_5960_rcis__zero__mod,axiom,
    ! [A2: real] : ( rcis(zero_zero(real),A2) = zero_zero(complex) ) ).

% rcis_zero_mod
tff(fact_5961_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( aa(set(fun(A,B)),$o,finite_finite(fun(A,B)),top_top(set(fun(A,B))))
     => ( ( aa(set(B),nat,finite_card(B),top_top(set(B))) != aa(nat,nat,suc,zero_zero(nat)) )
       => aa(set(A),$o,finite_finite(A),top_top(set(A))) ) ) ).

% finite_fun_UNIVD1
tff(fact_5962_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] :
          ( ( A2 != top_top(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),top_top(A)) ) ) ).

% top.not_eq_extremum
tff(fact_5963_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),top_top(A)),A2) ) ).

% top.extremum_strict
tff(fact_5964_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A)),A2: A,Na: nat] : ( power2(A,One,Times,A2,aa(nat,nat,suc,Na)) = aa(A,A,aa(A,fun(A,A),Times,A2),power2(A,One,Times,A2,Na)) ) ).

% power.power.power_Suc
tff(fact_5965_power_Opower_Opower__0,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A)),A2: A] : ( power2(A,One,Times,A2,zero_zero(nat)) = One ) ).

% power.power.power_0
tff(fact_5966_Compl__eq__Diff__UNIV,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),A3) ) ).

% Compl_eq_Diff_UNIV
tff(fact_5967_bij__fn,axiom,
    ! [A: $tType,F2: fun(A,A),Na: nat] :
      ( bij_betw(A,A,F2,top_top(set(A)),top_top(set(A)))
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),top_top(set(A)),top_top(set(A))) ) ).

% bij_fn
tff(fact_5968_cis__rcis__eq,axiom,
    ! [A2: real] : ( cis(A2) = rcis(one_one(real),A2) ) ).

% cis_rcis_eq
tff(fact_5969_Nats__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( semiring_1_Nats(A) = image(nat,A,semiring_1_of_nat(A),top_top(set(nat))) ) ) ).

% Nats_def
tff(fact_5970_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( aa(set(A),$o,finite_finite(A),top_top(set(A)))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),top_top(set(A)))) ) ).

% finite_UNIV_card_ge_0
tff(fact_5971_rcis__divide,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),divide_divide(complex),rcis(R1,A2)),rcis(R22,B2)) = rcis(aa(real,real,aa(real,fun(real,real),divide_divide(real),R1),R22),aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)) ) ).

% rcis_divide
tff(fact_5972_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A)] :
      ( aa(set(A),$o,finite_finite(A),image(B,A,F2,top_top(set(B))))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),image(B,A,F2,top_top(set(B))))) ) ).

% card_range_greater_zero
tff(fact_5973_DeMoivre2,axiom,
    ! [R2: real,A2: real,Na: nat] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),rcis(R2,A2)),Na) = rcis(aa(nat,real,aa(real,fun(nat,real),power_power(real),R2),Na),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),A2)) ) ).

% DeMoivre2
tff(fact_5974_UNIV__nat__eq,axiom,
    top_top(set(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),image(nat,nat,suc,top_top(set(nat)))) ).

% UNIV_nat_eq
tff(fact_5975_suminf__eq__SUP__real,axiom,
    ! [X7: fun(nat,real)] :
      ( summable(real,X7)
     => ( ! [I3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,X7,I3))
       => ( suminf(real,X7) = complete_Sup_Sup(real,image(nat,real,aTP_Lamp_oc(fun(nat,real),fun(nat,real),X7),top_top(set(nat)))) ) ) ) ).

% suminf_eq_SUP_real
tff(fact_5976_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: fun(nat,set(A)),S3: set(A)] :
      ( ! [I3: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F2,I3)),S3)
     => ( aa(set(A),$o,finite_finite(A),S3)
       => ( ? [N8: nat] :
              ( ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N8)
                 => ! [M4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N8)
                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N)
                       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(nat,set(A),F2,M4)),aa(nat,set(A),F2,N)) ) ) )
              & ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N)
                 => ( aa(nat,set(A),F2,N8) = aa(nat,set(A),F2,N) ) ) )
         => ( aa(nat,set(A),F2,aa(set(A),nat,finite_card(A),S3)) = complete_Sup_Sup(set(A),image(nat,set(A),F2,top_top(set(nat)))) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
tff(fact_5977_card__UNIV__unit,axiom,
    aa(set(product_unit),nat,finite_card(product_unit),top_top(set(product_unit))) = one_one(nat) ).

% card_UNIV_unit
tff(fact_5978_range__mult,axiom,
    ! [A2: real] :
      ( image(real,real,aa(real,fun(real,real),times_times(real),A2),top_top(set(real)))
      = $ite(A2 = zero_zero(real),aa(set(real),set(real),insert(real,zero_zero(real)),bot_bot(set(real))),top_top(set(real))) ) ).

% range_mult
tff(fact_5979_range__abs__Nats,axiom,
    image(int,int,abs_abs(int),top_top(set(int))) = semiring_1_Nats(int) ).

% range_abs_Nats
tff(fact_5980_card__UNIV__bool,axiom,
    aa(set($o),nat,finite_card($o),top_top(set($o))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) ).

% card_UNIV_bool
tff(fact_5981_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( complete_Sup_Sup(A,set_or7035219750837199246ssThan(A,X,Y)) = Y ) ) ) ).

% Sup_atLeastLessThan
tff(fact_5982_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( complete_Sup_Sup(A,set_or7035219750837199246ssThan(A,Y,X)) = X ) ) ) ).

% cSup_atLeastLessThan
tff(fact_5983_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( complete_Sup_Sup(A,set_or5935395276787703475ssThan(A,X,Y)) = Y ) ) ) ).

% Sup_greaterThanLessThan
tff(fact_5984_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( complete_Sup_Sup(A,set_or5935395276787703475ssThan(A,Y,X)) = X ) ) ) ).

% cSup_greaterThanLessThan
tff(fact_5985_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( complete_Sup_Sup(A,set_or3652927894154168847AtMost(A,X,Y)) = Y ) ) ) ).

% Sup_greaterThanAtMost
tff(fact_5986_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( complete_Sup_Sup(A,set_or3652927894154168847AtMost(A,Y,X)) = X ) ) ) ).

% cSup_greaterThanAtMost
tff(fact_5987_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] : sums(A,F2,complete_Sup_Sup(A,image(nat,A,aTP_Lamp_od(fun(nat,A),fun(nat,A),F2),top_top(set(nat))))) ) ).

% sums_SUP
tff(fact_5988_infinite__UNIV__int,axiom,
    ~ aa(set(int),$o,finite_finite(int),top_top(set(int))) ).

% infinite_UNIV_int
tff(fact_5989_Union__maximal__sets,axiom,
    ! [A: $tType,F6: set(set(A))] :
      ( aa(set(set(A)),$o,finite_finite(set(A)),F6)
     => ( complete_Sup_Sup(set(A),collect(set(A),aTP_Lamp_oe(set(set(A)),fun(set(A),$o),F6))) = complete_Sup_Sup(set(A),F6) ) ) ).

% Union_maximal_sets
tff(fact_5990_less__cSupE,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [Y: A,X7: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),complete_Sup_Sup(A,X7))
         => ( ( X7 != bot_bot(set(A)) )
           => ~ ! [X3: A] :
                  ( member(A,X3,X7)
                 => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X3) ) ) ) ) ).

% less_cSupE
tff(fact_5991_less__cSupD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),complete_Sup_Sup(A,X7))
           => ? [X3: A] :
                ( member(A,X3,X7)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X3) ) ) ) ) ).

% less_cSupD
tff(fact_5992_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),X: A,A2: A] :
          ( aa(set(A),$o,finite_finite(A),X7)
         => ( member(A,X,X7)
           => ( ! [X3: A] :
                  ( member(A,X3,X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),A2) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Sup_Sup(A,X7)),A2) ) ) ) ) ).

% finite_imp_Sup_less
tff(fact_5993_bij__prod__encode,axiom,
    bij_betw(product_prod(nat,nat),nat,nat_prod_encode,top_top(set(product_prod(nat,nat))),top_top(set(nat))) ).

% bij_prod_encode
tff(fact_5994_surj__prod__encode,axiom,
    image(product_prod(nat,nat),nat,nat_prod_encode,top_top(set(product_prod(nat,nat)))) = top_top(set(nat)) ).

% surj_prod_encode
tff(fact_5995_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),X7)
         => ( ( X7 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Sup_Sup(A,X7)),A2)
            <=> ! [X5: A] :
                  ( member(A,X5,X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),A2) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_5996_sum_OUnion__comp,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [B3: set(set(A)),G: fun(A,B)] :
          ( ! [X3: set(A)] :
              ( member(set(A),X3,B3)
             => aa(set(A),$o,finite_finite(A),X3) )
         => ( ! [A12: set(A)] :
                ( member(set(A),A12,B3)
               => ! [A23: set(A)] :
                    ( member(set(A),A23,B3)
                   => ( ( A12 != A23 )
                     => ! [X3: A] :
                          ( member(A,X3,A12)
                         => ( member(A,X3,A23)
                           => ( aa(A,B,G,X3) = zero_zero(B) ) ) ) ) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),complete_Sup_Sup(set(A),B3)) = aa(set(set(A)),B,aa(fun(A,B),fun(set(set(A)),B),aa(fun(fun(A,B),fun(set(A),B)),fun(fun(A,B),fun(set(set(A)),B)),comp(fun(set(A),B),fun(set(set(A)),B),fun(A,B),groups7311177749621191930dd_sum(set(A),B)),groups7311177749621191930dd_sum(A,B)),G),B3) ) ) ) ) ).

% sum.Union_comp
tff(fact_5997_prod_OUnion__comp,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B3: set(set(A)),G: fun(A,B)] :
          ( ! [X3: set(A)] :
              ( member(set(A),X3,B3)
             => aa(set(A),$o,finite_finite(A),X3) )
         => ( ! [A12: set(A)] :
                ( member(set(A),A12,B3)
               => ! [A23: set(A)] :
                    ( member(set(A),A23,B3)
                   => ( ( A12 != A23 )
                     => ! [X3: A] :
                          ( member(A,X3,A12)
                         => ( member(A,X3,A23)
                           => ( aa(A,B,G,X3) = one_one(B) ) ) ) ) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),complete_Sup_Sup(set(A),B3)) = aa(set(set(A)),B,aa(fun(A,B),fun(set(set(A)),B),aa(fun(fun(A,B),fun(set(A),B)),fun(fun(A,B),fun(set(set(A)),B)),comp(fun(set(A),B),fun(set(set(A)),B),fun(A,B),groups7121269368397514597t_prod(set(A),B)),groups7121269368397514597t_prod(A,B)),G),B3) ) ) ) ) ).

% prod.Union_comp
tff(fact_5998_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A))] : ( complete_Sup_Sup(set(A),image(nat,set(A),aTP_Lamp_of(fun(nat,set(A)),fun(nat,set(A)),A3),top_top(set(nat)))) = complete_Sup_Sup(set(A),image(nat,set(A),A3,top_top(set(nat)))) ) ).

% UN_UN_finite_eq
tff(fact_5999_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M10: fun(nat,set(A)),K: nat,Na: nat] : ( complete_Sup_Sup(set(A),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_og(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M10),K),set_ord_lessThan(nat,Na))) = complete_Sup_Sup(set(A),image(nat,set(A),M10,set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K)))) ) ).

% UN_le_add_shift_strict
tff(fact_6000_UN__le__add__shift,axiom,
    ! [A: $tType,M10: fun(nat,set(A)),K: nat,Na: nat] : ( complete_Sup_Sup(set(A),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_og(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M10),K),set_ord_atMost(nat,Na))) = complete_Sup_Sup(set(A),image(nat,set(A),M10,set_or1337092689740270186AtMost(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),K)))) ) ).

% UN_le_add_shift
tff(fact_6001_Ints__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_Ints(A) = image(int,A,ring_1_of_int(A),top_top(set(int))) ) ) ).

% Ints_def
tff(fact_6002_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S3: set(A),L: A,E2: A] :
          ( ( S3 != bot_bot(set(A)) )
         => ( ! [X3: A] :
                ( member(A,X3,S3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),L))),E2) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),complete_Sup_Sup(A,S3)),L))),E2) ) ) ) ).

% cSup_asclose
tff(fact_6003_int__in__range__abs,axiom,
    ! [Na: nat] : member(int,aa(nat,int,semiring_1_of_nat(int),Na),image(int,int,abs_abs(int),top_top(set(int)))) ).

% int_in_range_abs
tff(fact_6004_UN__finite__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),C6: set(A)] :
      ( ! [N: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),complete_Sup_Sup(set(A),image(nat,set(A),A3,set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),C6)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),complete_Sup_Sup(set(A),image(nat,set(A),A3,top_top(set(nat))))),C6) ) ).

% UN_finite_subset
tff(fact_6005_UN__finite2__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B3: fun(nat,set(A)),K: nat] :
      ( ! [N: nat] : ( complete_Sup_Sup(set(A),image(nat,set(A),A3,set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) = complete_Sup_Sup(set(A),image(nat,set(A),B3,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) )
     => ( complete_Sup_Sup(set(A),image(nat,set(A),A3,top_top(set(nat)))) = complete_Sup_Sup(set(A),image(nat,set(A),B3,top_top(set(nat)))) ) ) ).

% UN_finite2_eq
tff(fact_6006_UN__finite2__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B3: fun(nat,set(A)),K: nat] :
      ( ! [N: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),complete_Sup_Sup(set(A),image(nat,set(A),A3,set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),complete_Sup_Sup(set(A),image(nat,set(A),B3,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))))
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),complete_Sup_Sup(set(A),image(nat,set(A),A3,top_top(set(nat))))),complete_Sup_Sup(set(A),image(nat,set(A),B3,top_top(set(nat))))) ) ).

% UN_finite2_subset
tff(fact_6007_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F2: fun(nat,A)] : ( suminf(A,F2) = complete_Sup_Sup(A,image(nat,A,aTP_Lamp_od(fun(nat,A),fun(nat,A),F2),top_top(set(nat)))) ) ) ).

% suminf_eq_SUP
tff(fact_6008_SUP__eq__top__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B)] :
          ( ( complete_Sup_Sup(A,image(B,A,F2,A3)) = top_top(A) )
        <=> ! [X5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),top_top(A))
             => ? [Xa4: B] :
                  ( member(B,Xa4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),aa(B,A,F2,Xa4)) ) ) ) ) ).

% SUP_eq_top_iff
tff(fact_6009_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( ( complete_Sup_Sup(A,A3) = top_top(A) )
        <=> ! [X5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),top_top(A))
             => ? [Xa4: A] :
                  ( member(A,Xa4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Xa4) ) ) ) ) ).

% Sup_eq_top_iff
tff(fact_6010_Sup__nat__empty,axiom,
    complete_Sup_Sup(nat,bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_6011_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: A,S3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),complete_Sup_Sup(A,S3))
        <=> ? [X5: A] :
              ( member(A,X5,S3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X5) ) ) ) ).

% less_Sup_iff
tff(fact_6012_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [X: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),complete_Sup_Sup(A,A3))
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X)
             => ? [X5: A] :
                  ( member(A,X5,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X5) ) ) ) ) ).

% le_Sup_iff
tff(fact_6013_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(B,A),A3: set(B),Y: A,I2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Sup_Sup(A,image(B,A,F2,A3))),Y)
         => ( member(B,I2,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,I2)),Y) ) ) ) ).

% SUP_lessD
tff(fact_6014_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A2: A,F2: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),complete_Sup_Sup(A,image(B,A,F2,A3)))
        <=> ? [X5: B] :
              ( member(B,X5,A3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F2,X5)) ) ) ) ).

% less_SUP_iff
tff(fact_6015_UN__extend__simps_I6_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),complete_Sup_Sup(set(A),image(B,set(A),A3,C6))),B3) = complete_Sup_Sup(set(A),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_oh(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B3),C6)) ) ).

% UN_extend_simps(6)
tff(fact_6016_le__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [X: A,F2: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),complete_Sup_Sup(A,image(B,A,F2,A3)))
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X)
             => ? [X5: B] :
                  ( member(B,X5,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),aa(B,A,F2,X5)) ) ) ) ) ).

% le_SUP_iff
tff(fact_6017_card__UNION,axiom,
    ! [A: $tType,A3: set(set(A))] :
      ( aa(set(set(A)),$o,finite_finite(set(A)),A3)
     => ( ! [X3: set(A)] :
            ( member(set(A),X3,A3)
           => aa(set(A),$o,finite_finite(A),X3) )
       => ( aa(set(A),nat,finite_card(A),complete_Sup_Sup(set(A),A3)) = aa(int,nat,nat2,aa(set(set(set(A))),int,aa(fun(set(set(A)),int),fun(set(set(set(A))),int),groups7311177749621191930dd_sum(set(set(A)),int),aTP_Lamp_oi(set(set(A)),int)),collect(set(set(A)),aTP_Lamp_oj(set(set(A)),fun(set(set(A)),$o),A3)))) ) ) ) ).

% card_UNION
tff(fact_6018_root__def,axiom,
    ! [Na: nat,X: real] :
      ( aa(real,real,root(Na),X)
      = $ite(Na = zero_zero(nat),zero_zero(real),the_inv_into(real,real,top_top(set(real)),aTP_Lamp_ok(nat,fun(real,real),Na),X)) ) ).

% root_def
tff(fact_6019_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A)] :
          ( ( complete_Inf_Inf(A,A3) = bot_bot(A) )
        <=> ! [X5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),bot_bot(A)),X5)
             => ? [Xa4: A] :
                  ( member(A,Xa4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa4),X5) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_6020_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( complete_Inf_Inf(A,set_or7035219750837199246ssThan(A,X,Y)) = X ) ) ) ).

% Inf_atLeastLessThan
tff(fact_6021_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( complete_Inf_Inf(A,set_or7035219750837199246ssThan(A,Y,X)) = Y ) ) ) ).

% cInf_atLeastLessThan
tff(fact_6022_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( complete_Inf_Inf(A,set_or5935395276787703475ssThan(A,X,Y)) = X ) ) ) ).

% Inf_greaterThanLessThan
tff(fact_6023_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( complete_Inf_Inf(A,set_or5935395276787703475ssThan(A,Y,X)) = Y ) ) ) ).

% cInf_greaterThanLessThan
tff(fact_6024_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & dense_linorder(A) )
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( complete_Inf_Inf(A,set_or3652927894154168847AtMost(A,X,Y)) = X ) ) ) ).

% Inf_greaterThanAtMost
tff(fact_6025_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & dense_linorder(A) )
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( complete_Inf_Inf(A,set_or3652927894154168847AtMost(A,Y,X)) = Y ) ) ) ).

% cInf_greaterThanAtMost
tff(fact_6026_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B)] :
          ( ( complete_Inf_Inf(A,image(B,A,F2,A3)) = bot_bot(A) )
        <=> ! [X5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),bot_bot(A)),X5)
             => ? [Xa4: B] :
                  ( member(B,Xa4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,Xa4)),X5) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_6027_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),top_top(A)),X)
         => ( complete_Inf_Inf(A,set_ord_lessThan(A,X)) = bot_bot(A) ) ) ) ).

% Inf_atMostLessThan
tff(fact_6028_INT__simps_I3_J,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),B3: set(A),C6: set(B)] :
      ( complete_Inf_Inf(set(A),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_oh(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B3),C6))
      = $ite(C6 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),complete_Inf_Inf(set(A),image(B,set(A),A3,C6))),B3)) ) ).

% INT_simps(3)
tff(fact_6029_INT__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(B,set(A)),C6: set(B)] :
      ( complete_Inf_Inf(set(A),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ol(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B3),C6))
      = $ite(C6 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),complete_Sup_Sup(set(A),image(B,set(A),B3,C6)))) ) ).

% INT_simps(4)
tff(fact_6030_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),X: A,A2: A] :
          ( aa(set(A),$o,finite_finite(A),X7)
         => ( member(A,X,X7)
           => ( ! [X3: A] :
                  ( member(A,X3,X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X3) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),complete_Inf_Inf(A,X7)) ) ) ) ) ).

% finite_imp_less_Inf
tff(fact_6031_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A),X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),complete_Inf_Inf(A,A3)),X)
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y5)
             => ? [X5: A] :
                  ( member(A,X5,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5) ) ) ) ) ).

% Inf_le_iff
tff(fact_6032_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [S3: set(A),A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Inf_Inf(A,S3)),A2)
        <=> ? [X5: A] :
              ( member(A,X5,S3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),A2) ) ) ) ).

% Inf_less_iff
tff(fact_6033_cInf__lessD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Z: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Inf_Inf(A,X7)),Z)
           => ? [X3: A] :
                ( member(A,X3,X7)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z) ) ) ) ) ).

% cInf_lessD
tff(fact_6034_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Y: A,F2: fun(B,A),A3: set(B),I2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),complete_Inf_Inf(A,image(B,A,F2,A3)))
         => ( member(B,I2,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),aa(B,A,F2,I2)) ) ) ) ).

% less_INF_D
tff(fact_6035_INF__less__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B),A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Inf_Inf(A,image(B,A,F2,A3))),A2)
        <=> ? [X5: B] :
              ( member(B,X5,A3)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,X5)),A2) ) ) ) ).

% INF_less_iff
tff(fact_6036_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F2: fun(B,A),A3: set(B),X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),complete_Inf_Inf(A,image(B,A,F2,A3))),X)
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y5)
             => ? [X5: B] :
                  ( member(B,X5,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,X5)),Y5) ) ) ) ) ).

% INF_le_iff
tff(fact_6037_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),X7)
         => ( ( X7 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),complete_Inf_Inf(A,X7))
            <=> ! [X5: A] :
                  ( member(A,X5,X7)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X5) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_6038_UN__extend__simps_I7_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(B,set(A)),C6: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),complete_Inf_Inf(set(A),image(B,set(A),B3,C6))) = complete_Sup_Sup(set(A),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ol(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B3),C6)) ) ).

% UN_extend_simps(7)
tff(fact_6039_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S3: set(A),L: A,E2: A] :
          ( ( S3 != bot_bot(set(A)) )
         => ( ! [X3: A] :
                ( member(A,X3,S3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),L))),E2) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),complete_Inf_Inf(A,S3)),L))),E2) ) ) ) ).

% cInf_asclose
tff(fact_6040_INT__extend__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C6: set(B),B3: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),complete_Inf_Inf(set(A),image(B,set(A),A3,C6))),B3)
      = $ite(C6 = bot_bot(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),B3),complete_Inf_Inf(set(A),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_oh(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B3),C6))) ) ).

% INT_extend_simps(3)
tff(fact_6041_INT__extend__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(B,set(A)),C6: set(B)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),complete_Sup_Sup(set(A),image(B,set(A),B3,C6)))
      = $ite(C6 = bot_bot(set(B)),A3,complete_Inf_Inf(set(A),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ol(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B3),C6))) ) ).

% INT_extend_simps(4)
tff(fact_6042_card__UNIV__char,axiom,
    aa(set(char),nat,finite_card(char),top_top(set(char))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))) ).

% card_UNIV_char
tff(fact_6043_DERIV__even__real__root,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
         => has_field_derivative(real,root(Na),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ).

% DERIV_even_real_root
tff(fact_6044_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,A2)),aa(real,real,F2,B2)) ) ) ).

% DERIV_pos_imp_increasing
tff(fact_6045_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),zero_zero(real)) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) ) ) ).

% DERIV_neg_imp_decreasing
tff(fact_6046_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y3) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F2,A2)),aa(real,real,F2,B2)) ) ) ).

% DERIV_nonneg_imp_nondecreasing
tff(fact_6047_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),zero_zero(real)) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) ) ) ).

% DERIV_nonpos_imp_nonincreasing
tff(fact_6048_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: fun(real,real),G2: fun(real,real)] :
      ( ! [X3: real] :
          ( member(real,X3,set_or1337092689740270186AtMost(real,A2,B2))
         => has_field_derivative(real,G,aa(real,real,G2,X3),topolo174197925503356063within(real,X3,top_top(set(real)))) )
     => ( ! [X3: real] :
            ( member(real,X3,set_or1337092689740270186AtMost(real,A2,B2))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,G2,X3)) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,G,A2)),aa(real,real,G,B2)) ) ) ) ).

% deriv_nonneg_imp_mono
tff(fact_6049_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y: A,Z: A,X: A,S3: set(A)] :
          ( has_field_derivative(A,F2,Y,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),X),image(A,A,aa(A,fun(A,A),plus_plus(A),Z),S3)))
         => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F2),aa(A,fun(A,A),plus_plus(A),Z)),Y,topolo174197925503356063within(A,X,S3)) ) ) ).

% DERIV_at_within_shift_lemma
tff(fact_6050_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y: A,Z: A,X: A,S3: set(A)] :
          ( has_field_derivative(A,F2,Y,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),X),image(A,A,aa(A,fun(A,A),plus_plus(A),Z),S3)))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_om(fun(A,A),fun(A,fun(A,A)),F2),Z),Y,topolo174197925503356063within(A,X,S3)) ) ) ).

% DERIV_at_within_shift
tff(fact_6051_has__real__derivative__neg__dec__right,axiom,
    ! [F2: fun(real,real),L: real,X: real,S3: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( member(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),H3),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),H3))),aa(real,real,F2,X)) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
tff(fact_6052_has__real__derivative__pos__inc__right,axiom,
    ! [F2: fun(real,real),L: real,X: real,S3: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( member(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),H3),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,X)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),H3))) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
tff(fact_6053_has__real__derivative__neg__dec__left,axiom,
    ! [F2: fun(real,real),L: real,X: real,S3: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( member(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),H3),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,X)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),H3))) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
tff(fact_6054_has__real__derivative__pos__inc__left,axiom,
    ! [F2: fun(real,real),L: real,X: real,S3: set(real)] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,S3))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( member(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),H3),S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),H3))),aa(real,real,F2,X)) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
tff(fact_6055_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A)] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => ( ( aa(A,A,F2,X) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_on(fun(A,A),fun(A,A),F2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(A,A,F2,X))),D5)),aa(A,A,inverse_inverse(A),aa(A,A,F2,X)))),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_inverse'
tff(fact_6056_DERIV__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X,S))
           => ( ( aa(A,A,G,X) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_oo(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D5),aa(A,A,G,X))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F2,X)),E4))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G,X)),aa(A,A,G,X))),topolo174197925503356063within(A,X,S)) ) ) ) ) ).

% DERIV_divide
tff(fact_6057_DERIV__diff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_op(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),D5),E4),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_diff
tff(fact_6058_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),F7: A,F3: filter(A),G: fun(A,A),G2: A] :
          ( has_field_derivative(A,F2,F7,F3)
         => ( has_field_derivative(A,G,G2,F3)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_op(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),F7),G2),F3) ) ) ) ).

% field_differentiable_diff
tff(fact_6059_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_oq(fun(A,A),fun(A,fun(A,A)),F2),C2),aa(A,A,aa(A,fun(A,A),divide_divide(A),D5),C2),topolo174197925503356063within(A,X,S)) ) ) ).

% DERIV_cdivide
tff(fact_6060_DERIV__const,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [K: A,F3: filter(A)] : has_field_derivative(A,aTP_Lamp_or(A,fun(A,A),K),zero_zero(A),F3) ) ).

% DERIV_const
tff(fact_6061_DERIV__ident,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: filter(A)] : has_field_derivative(A,aTP_Lamp_os(A,A),one_one(A),F3) ) ).

% DERIV_ident
tff(fact_6062_DERIV__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Da: A,X: A,S: set(A),G: fun(A,A),Db: A] :
          ( has_field_derivative(A,F2,Da,topolo174197925503356063within(A,X,S))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ot(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Da),aa(A,A,G,X))),aa(A,A,aa(A,fun(A,A),times_times(A),Db),aa(A,A,F2,X))),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_mult
tff(fact_6063_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ot(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F2,X)),E4)),aa(A,A,aa(A,fun(A,A),times_times(A),D5),aa(A,A,G,X))),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_mult'
tff(fact_6064_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),F7: A,F3: filter(A),G: fun(A,A),G2: A] :
          ( has_field_derivative(A,F2,F7,F3)
         => ( has_field_derivative(A,G,G2,F3)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ou(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),F7),G2),F3) ) ) ) ).

% field_differentiable_add
tff(fact_6065_DERIV__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,X,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ou(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),D5),E4),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_add
tff(fact_6066_DERIV__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Y: A,X: A,Z: A] :
          ( has_field_derivative(A,F2,Y,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z),top_top(set(A))))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_ov(fun(A,A),fun(A,fun(A,A)),F2),Z),Y,topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ).

% DERIV_shift
tff(fact_6067_DERIV__isconst__all,axiom,
    ! [F2: fun(real,real),X: real,Y: real] :
      ( ! [X3: real] : has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( aa(real,real,F2,X) = aa(real,real,F2,Y) ) ) ).

% DERIV_isconst_all
tff(fact_6068_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : has_field_derivative(real,F2,K,topolo174197925503356063within(real,X3,top_top(set(real))))
       => ( aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2))),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)) = K ) ) ) ).

% DERIV_const_ratio_const2
tff(fact_6069_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : has_field_derivative(real,F2,K,topolo174197925503356063within(real,X3,top_top(set(real))))
       => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),K) ) ) ) ).

% DERIV_const_ratio_const
tff(fact_6070_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X: real,Y: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( member(real,X,set_or5935395276787703475ssThan(real,A2,B2))
       => ( member(real,Y,set_or5935395276787703475ssThan(real,A2,B2))
         => ( ! [X3: real] :
                ( member(real,X3,set_or5935395276787703475ssThan(real,A2,B2))
               => has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X3,top_top(set(real)))) )
           => ( aa(real,real,F2,X) = aa(real,real,F2,Y) ) ) ) ) ) ).

% DERIV_isconst3
tff(fact_6071_DERIV__neg__dec__left,axiom,
    ! [F2: fun(real,real),L: real,X: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,X)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),H3))) ) ) ) ) ) ).

% DERIV_neg_dec_left
tff(fact_6072_DERIV__pos__inc__left,axiom,
    ! [F2: fun(real,real),L: real,X: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),minus_minus(real),X),H3))),aa(real,real,F2,X)) ) ) ) ) ) ).

% DERIV_pos_inc_left
tff(fact_6073_DERIV__neg__dec__right,axiom,
    ! [F2: fun(real,real),L: real,X: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),H3))),aa(real,real,F2,X)) ) ) ) ) ) ).

% DERIV_neg_dec_right
tff(fact_6074_DERIV__pos__inc__right,axiom,
    ! [F2: fun(real,real),L: real,X: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
            & ! [H3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H3),D4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,X)),aa(real,real,F2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),H3))) ) ) ) ) ) ).

% DERIV_pos_inc_right
tff(fact_6075_MVT2,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),F7: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
             => has_field_derivative(real,F2,aa(real,real,F7,X3),topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
       => ? [Z2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
            & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(real,real,F7,Z2)) ) ) ) ) ).

% MVT2
tff(fact_6076_DERIV__local__const,axiom,
    ! [F2: fun(real,real),L: real,X: real,D2: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y4))),D2)
             => ( aa(real,real,F2,X) = aa(real,real,F2,Y4) ) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_const
tff(fact_6077_DERIV__ln,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => has_field_derivative(real,ln_ln(real),aa(real,real,inverse_inverse(real),X),topolo174197925503356063within(real,X,top_top(set(real)))) ) ).

% DERIV_ln
tff(fact_6078_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K: A,Xa: A] : has_field_derivative(A,aTP_Lamp_ow(A,fun(A,A),K),aa(A,A,uminus_uminus(A),sin(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),K))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ).

% DERIV_cos_add
tff(fact_6079_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),Na: nat] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_ox(fun(A,A),fun(nat,fun(A,A)),F2),Na),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Na))),aa(A,A,aa(A,fun(A,A),times_times(A),D5),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,F2,X)),Na))),topolo174197925503356063within(A,X,S)) ) ) ).

% DERIV_power_Suc
tff(fact_6080_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : has_field_derivative(real,V,K,topolo174197925503356063within(real,X3,top_top(set(real))))
       => ( aa(real,real,V,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,V,A2)),aa(real,real,V,B2))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) ) ) ).

% DERIV_const_average
tff(fact_6081_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X: A,S: set(A)] :
          ( ( X != zero_zero(A) )
         => has_field_derivative(A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,X,S)) ) ) ).

% DERIV_inverse
tff(fact_6082_DERIV__power,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S: set(A),Na: nat] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_oy(fun(A,A),fun(nat,fun(A,A)),F2),Na),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Na)),aa(A,A,aa(A,fun(A,A),times_times(A),D5),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,F2,X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(A,X,S)) ) ) ).

% DERIV_power
tff(fact_6083_DERIV__local__min,axiom,
    ! [F2: fun(real,real),L: real,X: real,D2: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y4))),D2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F2,X)),aa(real,real,F2,Y4)) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_min
tff(fact_6084_DERIV__local__max,axiom,
    ! [F2: fun(real,real),L: real,X: real,D2: real] :
      ( has_field_derivative(real,F2,L,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y4))),D2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F2,Y4)),aa(real,real,F2,X)) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_max
tff(fact_6085_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => has_field_derivative(real,ln_ln(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),X),topolo174197925503356063within(real,X,top_top(set(real)))) ) ).

% DERIV_ln_divide
tff(fact_6086_DERIV__pow,axiom,
    ! [Na: nat,X: real,S: set(real)] : has_field_derivative(real,aTP_Lamp_oz(nat,fun(real,real),Na),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(real,X,S)) ).

% DERIV_pow
tff(fact_6087_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X: A] :
          ( ! [Y4: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Y4))
         => has_field_derivative(A,aTP_Lamp_pa(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X)),topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ).

% termdiffs_strong_converges_everywhere
tff(fact_6088_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,X: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B2)
           => ( topolo174197925503356063within(A,X,set_or1337092689740270186AtMost(A,A2,B2)) = topolo174197925503356063within(A,X,top_top(set(A))) ) ) ) ) ).

% at_within_Icc_at
tff(fact_6089_DERIV__fun__pow,axiom,
    ! [G: fun(real,real),M: real,X: real,Na: nat] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,X,top_top(set(real))))
     => has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_pb(fun(real,real),fun(nat,fun(real,real)),G),Na),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,G,X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))))),M),topolo174197925503356063within(real,X,top_top(set(real)))) ) ).

% DERIV_fun_pow
tff(fact_6090_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( topolo174197925503356063within(A,B2,set_or1337092689740270186AtMost(A,A2,B2)) = topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2)) ) ) ) ).

% at_within_Icc_at_left
tff(fact_6091_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D2: A,X: A,S: set(A),G: fun(A,A),E2: A] :
          ( has_field_derivative(A,F2,D2,topolo174197925503356063within(A,X,S))
         => ( has_field_derivative(A,G,E2,topolo174197925503356063within(A,X,S))
           => ( ( aa(A,A,G,X) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_oo(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,G,X))),aa(A,A,aa(A,fun(A,A),times_times(A),E2),aa(A,A,F2,X)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,G,X)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,X,S)) ) ) ) ) ).

% DERIV_quotient
tff(fact_6092_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D2: A,X: A,S: set(A)] :
          ( has_field_derivative(A,F2,D2,topolo174197925503356063within(A,X,S))
         => ( ( aa(A,A,F2,X) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_on(fun(A,A),fun(A,A),F2),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,F2,X)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))))),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_inverse_fun
tff(fact_6093_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K5: real,C2: fun(nat,A),F2: fun(A,A),F7: A,Z: A] :
          ( ! [Z2: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z2)),K5)
             => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Z2),aa(A,A,F2,Z2)) )
         => ( has_field_derivative(A,F2,F7,topolo174197925503356063within(A,Z,top_top(set(A))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K5)
             => sums(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),Z),F7) ) ) ) ) ).

% termdiffs_sums_strong
tff(fact_6094_has__real__derivative__powr,axiom,
    ! [Z: real,R2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Z)
     => has_field_derivative(real,aTP_Lamp_pc(real,fun(real,real),R2),aa(real,real,aa(real,fun(real,real),times_times(real),R2),powr(real,Z,aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),one_one(real)))),topolo174197925503356063within(real,Z,top_top(set(real)))) ) ).

% has_real_derivative_powr
tff(fact_6095_termdiffs,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
           => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_pd(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,K5))
               => has_field_derivative(A,aTP_Lamp_pa(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X)),topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ) ) ) ).

% termdiffs
tff(fact_6096_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,K5))
           => has_field_derivative(A,aTP_Lamp_pa(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),X)),topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ) ).

% termdiffs_strong
tff(fact_6097_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K5: real,C2: fun(nat,A),Z: A] :
          ( ! [Z2: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z2)),K5)
             => summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Z2)) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K5)
           => has_field_derivative(A,aTP_Lamp_pa(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),C2),Z)),topolo174197925503356063within(A,Z,top_top(set(A)))) ) ) ) ).

% termdiffs_strong'
tff(fact_6098_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => has_field_derivative(real,log(B2),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,ln_ln(real),B2)),X)),topolo174197925503356063within(real,X,top_top(set(real)))) ) ).

% DERIV_log
tff(fact_6099_DERIV__fun__powr,axiom,
    ! [G: fun(real,real),M: real,X: real,R2: real] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,G,X))
       => has_field_derivative(real,aa(real,fun(real,real),aTP_Lamp_pe(fun(real,real),fun(real,fun(real,real)),G),R2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),R2),powr(real,aa(real,real,G,X),aa(real,real,aa(real,fun(real,real),minus_minus(real),R2),aa(nat,real,semiring_1_of_nat(real),one_one(nat)))))),M),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ).

% DERIV_fun_powr
tff(fact_6100_DERIV__powr,axiom,
    ! [G: fun(real,real),M: real,X: real,F2: fun(real,real),R2: real] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,G,X))
       => ( has_field_derivative(real,F2,R2,topolo174197925503356063within(real,X,top_top(set(real))))
         => has_field_derivative(real,aa(fun(real,real),fun(real,real),aTP_Lamp_pf(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,aa(real,real,G,X),aa(real,real,F2,X))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),R2),aa(real,real,ln_ln(real),aa(real,real,G,X)))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),M),aa(real,real,F2,X))),aa(real,real,G,X)))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ).

% DERIV_powr
tff(fact_6101_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => has_field_derivative(A,tan(A),aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),cos(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ).

% DERIV_tan
tff(fact_6102_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
     => has_field_derivative(real,sqrt,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ).

% DERIV_real_sqrt
tff(fact_6103_DERIV__series_H,axiom,
    ! [F2: fun(real,fun(nat,real)),F7: fun(real,fun(nat,real)),X0: real,A2: real,B2: real,L4: fun(nat,real)] :
      ( ! [N: nat] : has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_pg(fun(real,fun(nat,real)),fun(nat,fun(real,real)),F2),N),aa(nat,real,aa(real,fun(nat,real),F7,X0),N),topolo174197925503356063within(real,X0,top_top(set(real))))
     => ( ! [X3: real] :
            ( member(real,X3,set_or5935395276787703475ssThan(real,A2,B2))
           => summable(real,aa(real,fun(nat,real),F2,X3)) )
       => ( member(real,X0,set_or5935395276787703475ssThan(real,A2,B2))
         => ( summable(real,aa(real,fun(nat,real),F7,X0))
           => ( summable(real,L4)
             => ( ! [N: nat,X3: real,Y4: real] :
                    ( member(real,X3,set_or5935395276787703475ssThan(real,A2,B2))
                   => ( member(real,Y4,set_or5935395276787703475ssThan(real,A2,B2))
                     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),F2,X3),N)),aa(nat,real,aa(real,fun(nat,real),F2,Y4),N)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,L4,N)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X3),Y4)))) ) )
               => has_field_derivative(real,aTP_Lamp_ph(fun(real,fun(nat,real)),fun(real,real),F2),suminf(real,aa(real,fun(nat,real),F7,X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_series'
tff(fact_6104_DERIV__arctan,axiom,
    ! [X: real] : has_field_derivative(real,arctan,aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),topolo174197925503356063within(real,X,top_top(set(real)))) ).

% DERIV_arctan
tff(fact_6105_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A3: set(real)] : has_field_derivative(real,arsinh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real)))),topolo174197925503356063within(real,X,A3)) ).

% arsinh_real_has_field_derivative
tff(fact_6106_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( sin(A,X) != zero_zero(A) )
         => has_field_derivative(A,cot(A),aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),sin(A,X)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ).

% DERIV_cot
tff(fact_6107_Inf__real__def,axiom,
    ! [X7: set(real)] : ( complete_Inf_Inf(real,X7) = aa(real,real,uminus_uminus(real),complete_Sup_Sup(real,image(real,real,uminus_uminus(real),X7))) ) ).

% Inf_real_def
tff(fact_6108_has__field__derivative__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),X: A,Db: A,S: set(A)] :
          ( ( cosh(A,aa(A,A,G,X)) != zero_zero(A) )
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,X,S))
           => has_field_derivative(A,aTP_Lamp_pi(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,tanh(A),aa(A,A,G,X))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),Db),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_field_derivative_tanh
tff(fact_6109_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X != zero_zero(real) )
     => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
         => ( D5 = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) )
       => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
           => ( D5 = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,X)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))) ) )
         => has_field_derivative(real,sqrt,D5,topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ).

% DERIV_real_sqrt_generic
tff(fact_6110_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A3: set(real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => has_field_derivative(real,arcosh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(real)))),topolo174197925503356063within(real,X,A3)) ) ).

% arcosh_real_has_field_derivative
tff(fact_6111_artanh__real__has__field__derivative,axiom,
    ! [X: real,A3: set(real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => has_field_derivative(real,artanh(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),topolo174197925503356063within(real,X,A3)) ) ).

% artanh_real_has_field_derivative
tff(fact_6112_DERIV__power__series_H,axiom,
    ! [R3: real,F2: fun(nat,real),X0: real] :
      ( ! [X3: real] :
          ( member(real,X3,set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R3),R3))
         => summable(real,aa(real,fun(nat,real),aTP_Lamp_pj(fun(nat,real),fun(real,fun(nat,real)),F2),X3)) )
     => ( member(real,X0,set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R3),R3))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R3)
         => has_field_derivative(real,aTP_Lamp_pl(fun(nat,real),fun(real,real),F2),suminf(real,aa(real,fun(nat,real),aTP_Lamp_pj(fun(nat,real),fun(real,fun(nat,real)),F2),X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ).

% DERIV_power_series'
tff(fact_6113_DERIV__real__root,axiom,
    ! [Na: nat,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
       => has_field_derivative(real,root(Na),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ).

% DERIV_real_root
tff(fact_6114_DERIV__arccos,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => has_field_derivative(real,arccos,aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ).

% DERIV_arccos
tff(fact_6115_DERIV__arcsin,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => has_field_derivative(real,arcsin,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ).

% DERIV_arcsin
tff(fact_6116_Maclaurin__all__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),X: real,Na: nat] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
     => ( ! [M4: nat,X3: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),X3),topolo174197925503356063within(real,X3,top_top(set(real))))
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
            & ( aa(real,real,F2,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_pm(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ).

% Maclaurin_all_le
tff(fact_6117_Maclaurin__all__le__objl,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),X: real,Na: nat] :
      ( ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
        & ! [M4: nat,X3: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),X3),topolo174197925503356063within(real,X3,top_top(set(real)))) )
     => ? [T3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
          & ( aa(real,real,F2,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_pm(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ).

% Maclaurin_all_le_objl
tff(fact_6118_DERIV__odd__real__root,axiom,
    ! [Na: nat,X: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
     => ( ( X != zero_zero(real) )
       => has_field_derivative(real,root(Na),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ).

% DERIV_odd_real_root
tff(fact_6119_Maclaurin__minus,axiom,
    ! [H: real,Na: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H),zero_zero(real))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
         => ( ! [M4: nat,T3: real] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),H),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),zero_zero(real)) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
           => ? [T3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),zero_zero(real))
                & ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_pn(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),Na))) ) ) ) ) ) ) ).

% Maclaurin_minus
tff(fact_6120_Maclaurin2,axiom,
    ! [H: real,Diff: fun(nat,fun(real,real)),F2: fun(real,real),Na: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ? [T3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H)
              & ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_pn(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),Na))) ) ) ) ) ) ).

% Maclaurin2
tff(fact_6121_Maclaurin,axiom,
    ! [H: real,Na: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
         => ( ! [M4: nat,T3: real] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
           => ? [T3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),H)
                & ( aa(real,real,F2,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_pn(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),Na))) ) ) ) ) ) ) ).

% Maclaurin
tff(fact_6122_Maclaurin__all__lt,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),Na: nat,X: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => ( ( X != zero_zero(real) )
         => ( ! [M4: nat,X3: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),X3),topolo174197925503356063within(real,X3,top_top(set(real))))
           => ? [T3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T3))
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
                & ( aa(real,real,F2,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_pm(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ) ) ).

% Maclaurin_all_lt
tff(fact_6123_Maclaurin__bi__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F2: fun(real,real),Na: nat,X: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
     => ( ! [M4: nat,T3: real] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X)) )
           => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
       => ? [T3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T3)),aa(real,real,abs_abs(real),X))
            & ( aa(real,real,F2,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_pm(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),X),Na))) ) ) ) ) ).

% Maclaurin_bi_le
tff(fact_6124_Taylor__down,axiom,
    ! [Na: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real),A2: real,B2: real,C2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),B2)
             => ? [T3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),C2)
                  & ( aa(real,real,F2,A2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_po(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),A2),C2)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),C2)),Na))) ) ) ) ) ) ) ) ).

% Taylor_down
tff(fact_6125_Taylor__up,axiom,
    ! [Na: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real),A2: real,B2: real,C2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),B2)
             => ? [T3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),T3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),B2)
                  & ( aa(real,real,F2,B2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_po(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),B2),C2)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),C2)),Na))) ) ) ) ) ) ) ) ).

% Taylor_up
tff(fact_6126_Taylor,axiom,
    ! [Na: nat,Diff: fun(nat,fun(real,real)),F2: fun(real,real),A2: real,B2: real,C2: real,X: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F2 )
       => ( ! [M4: nat,T3: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),B2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
                 => ( ( X != C2 )
                   => ? [T3: real] :
                        ( $ite(
                            aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),C2),
                            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),T3)
                            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),C2) ),
                            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),T3)
                            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T3),X) ) )
                        & ( aa(real,real,F2,X) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_pp(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),C2),X)),set_ord_lessThan(nat,Na))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Diff,Na),T3)),semiring_char_0_fact(real,Na))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),C2)),Na))) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
tff(fact_6127_Maclaurin__lemma2,axiom,
    ! [Na: nat,H: real,Diff: fun(nat,fun(real,real)),K: nat,B3: real] :
      ( ! [M4: nat,T3: real] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T3)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T3),H) )
         => has_field_derivative(real,aa(nat,fun(real,real),Diff,M4),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M4)),T3),topolo174197925503356063within(real,T3,top_top(set(real)))) )
     => ( ( Na = aa(nat,nat,suc,K) )
       => ! [M2: nat,T7: real] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),Na)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T7)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T7),H) )
           => has_field_derivative(real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_pr(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),Na),Diff),B3),M2),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T7)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_ps(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Diff),M2),T7)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,M2))))),aa(real,real,aa(real,fun(real,real),times_times(real),B3),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),T7),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,M2)))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,M2))))))),topolo174197925503356063within(real,T7,top_top(set(real)))) ) ) ) ).

% Maclaurin_lemma2
tff(fact_6128_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => has_field_derivative(real,aTP_Lamp_pt(real,real),suminf(real,aTP_Lamp_pu(real,fun(nat,real),X)),topolo174197925503356063within(real,X,top_top(set(real)))) ) ).

% DERIV_arctan_series
tff(fact_6129_DERIV__real__root__generic,axiom,
    ! [Na: nat,X: real,D5: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( ( X != zero_zero(real) )
       => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
             => ( D5 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))) ) ) )
         => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),zero_zero(real))
               => ( D5 = aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat))))))) ) ) )
           => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
               => ( D5 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),Na)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(Na),X)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(nat,nat,suc,zero_zero(nat)))))) ) )
             => has_field_derivative(real,root(Na),D5,topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ) ) ).

% DERIV_real_root_generic
tff(fact_6130_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,X))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,G,X)),one_one(real))
           => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,S))
             => has_derivative(A,real,aTP_Lamp_pv(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_pw(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X),G2),topolo174197925503356063within(A,X,S)) ) ) ) ) ).

% has_derivative_arcsin
tff(fact_6131_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,X))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,G,X)),one_one(real))
           => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,S))
             => has_derivative(A,real,aTP_Lamp_px(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_py(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X),G2),topolo174197925503356063within(A,X,S)) ) ) ) ) ).

% has_derivative_arccos
tff(fact_6132_has__derivative__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,real),F7: fun(A,real),X: A,S: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,real,F2,F7,topolo174197925503356063within(A,X,S))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X,S))
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_pz(fun(A,real),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qa(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F2),F7),X),G),G2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_scaleR
tff(fact_6133_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),F3: filter(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F2,F7,F3)
         => ( has_derivative(A,B,G,G2,F3)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qb(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aTP_Lamp_qb(fun(A,B),fun(fun(A,B),fun(A,B)),F7),G2),F3) ) ) ) ).

% has_derivative_add
tff(fact_6134_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [C2: B,F3: filter(A)] : has_derivative(A,B,aTP_Lamp_qc(B,fun(A,B),C2),aTP_Lamp_qd(A,B),F3) ) ).

% has_derivative_const
tff(fact_6135_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),F3: filter(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F2,F7,F3)
         => ( has_derivative(A,B,G,G2,F3)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qe(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aTP_Lamp_qe(fun(A,B),fun(fun(A,B),fun(A,B)),F7),G2),F3) ) ) ) ).

% has_derivative_diff
tff(fact_6136_has__derivative__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X,S))
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qf(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qg(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F2),F7),X),G),G2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_mult
tff(fact_6137_has__derivative__zero__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,B),X: A] :
          ( has_derivative(A,B,aTP_Lamp_qd(A,B),F3,topolo174197925503356063within(A,X,top_top(set(A))))
         => ! [X4: A] : ( aa(A,B,F3,X4) = zero_zero(B) ) ) ) ).

% has_derivative_zero_unique
tff(fact_6138_has__derivative__divide_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S3: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S3))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X,S3))
           => ( ( aa(A,B,G,X) != zero_zero(B) )
             => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qh(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qi(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F2),F7),X),G),G2),topolo174197925503356063within(A,X,S3)) ) ) ) ) ).

% has_derivative_divide'
tff(fact_6139_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X: A,S3: set(A)] :
          ( ( X != zero_zero(A) )
         => has_derivative(A,A,inverse_inverse(A),aTP_Lamp_qj(A,fun(A,A),X),topolo174197925503356063within(A,X,S3)) ) ) ).

% has_derivative_inverse'
tff(fact_6140_has__derivative__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [F2: fun(B,A),X: B,F7: fun(B,A),S3: set(B)] :
          ( ( aa(B,A,F2,X) != zero_zero(A) )
         => ( has_derivative(B,A,F2,F7,topolo174197925503356063within(B,X,S3))
           => has_derivative(B,A,aTP_Lamp_qk(fun(B,A),fun(B,A),F2),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_ql(fun(B,A),fun(B,fun(fun(B,A),fun(B,A))),F2),X),F7),topolo174197925503356063within(B,X,S3)) ) ) ) ).

% has_derivative_inverse
tff(fact_6141_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S3: set(A),Na: nat] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S3))
         => has_derivative(A,B,aa(nat,fun(A,B),aTP_Lamp_qm(fun(A,B),fun(nat,fun(A,B)),F2),Na),aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_qn(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),F2),F7),X),Na),topolo174197925503356063within(A,X,S3)) ) ) ).

% has_derivative_power
tff(fact_6142_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X))
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,S))
           => has_derivative(A,real,aTP_Lamp_qo(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_qp(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X),G2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_ln
tff(fact_6143_has__derivative__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S3: set(A),G: fun(A,B),G2: fun(A,B)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S3))
         => ( has_derivative(A,B,G,G2,topolo174197925503356063within(A,X,S3))
           => ( ( aa(A,B,G,X) != zero_zero(B) )
             => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qr(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F2),F7),X),G),G2),topolo174197925503356063within(A,X,S3)) ) ) ) ) ).

% has_derivative_divide
tff(fact_6144_has__derivative__prod,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(C) )
     => ! [I5: set(A),F2: fun(A,fun(B,C)),F7: fun(A,fun(B,C)),X: B,S3: set(B)] :
          ( ! [I3: A] :
              ( member(A,I3,I5)
             => has_derivative(B,C,aa(A,fun(B,C),F2,I3),aa(A,fun(B,C),F7,I3),topolo174197925503356063within(B,X,S3)) )
         => has_derivative(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_qt(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F2),aa(B,fun(B,C),aa(fun(A,fun(B,C)),fun(B,fun(B,C)),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C))),aTP_Lamp_qv(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C)))),I5),F2),F7),X),topolo174197925503356063within(B,X,S3)) ) ) ).

% has_derivative_prod
tff(fact_6145_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X: A,X7: set(A),F2: fun(A,real),F7: fun(A,real)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,X7))
         => ( has_derivative(A,real,F2,F7,topolo174197925503356063within(A,X,X7))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X))
             => ( member(A,X,X7)
               => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_qw(fun(A,real),fun(fun(A,real),fun(A,real)),G),F2),aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_qx(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),G),G2),X),F2),F7),topolo174197925503356063within(A,X,X7)) ) ) ) ) ) ).

% has_derivative_powr
tff(fact_6146_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X: A,G2: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X))
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,S))
           => has_derivative(A,real,aTP_Lamp_qy(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_qz(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X),G2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_real_sqrt
tff(fact_6147_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G2: fun(A,real),X: A,S: set(A)] :
          ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,S))
         => has_derivative(A,real,aTP_Lamp_ra(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_rb(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G2),X),topolo174197925503356063within(A,X,S)) ) ) ).

% has_derivative_arctan
tff(fact_6148_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),X: A,G2: fun(A,real),S: set(A)] :
          ( ( cos(real,aa(A,real,G,X)) != zero_zero(real) )
         => ( has_derivative(A,real,G,G2,topolo174197925503356063within(A,X,S))
           => has_derivative(A,real,aTP_Lamp_rc(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_rd(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),X),G2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_tan
tff(fact_6149_UNIV__char__of__nat,axiom,
    top_top(set(char)) = image(nat,char,unique5772411509450598832har_of(nat),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) ).

% UNIV_char_of_nat
tff(fact_6150_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: A] : ( aa(A,char,unique5772411509450598832har_of(A),modulo_modulo(A,Na,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) = aa(A,char,unique5772411509450598832har_of(A),Na) ) ) ).

% char_of_mod_256
tff(fact_6151_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: A,Na: A] :
          ( ( aa(A,char,unique5772411509450598832har_of(A),M) = aa(A,char,unique5772411509450598832har_of(A),Na) )
        <=> ( modulo_modulo(A,M,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) = modulo_modulo(A,Na,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ) ) ) ).

% char_of_quasi_inj
tff(fact_6152_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: nat,M: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))),Na)
         => ( aa(A,char,unique5772411509450598832har_of(A),aa(A,A,bit_se2584673776208193580ke_bit(A,Na),M)) = aa(A,char,unique5772411509450598832har_of(A),M) ) ) ) ).

% char_of_take_bit_eq
tff(fact_6153_of__char__of,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [A2: A] : ( aa(char,A,comm_s6883823935334413003f_char(A),aa(A,char,unique5772411509450598832har_of(A),A2)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ) ) ).

% of_char_of
tff(fact_6154_char__of__def,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: A] : ( aa(A,char,unique5772411509450598832har_of(A),Na) = char2(~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),one_one(nat)),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit0,one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit1,one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Na),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit1,one2))))) ) ) ).

% char_of_def
tff(fact_6155_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [C2: char] : ( modulo_modulo(A,aa(char,A,comm_s6883823935334413003f_char(A),C2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) = aa(char,A,comm_s6883823935334413003f_char(A),C2) ) ) ).

% of_char_mod_256
tff(fact_6156_char_Osize_I2_J,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] : ( aa(char,nat,size_size(char),char2(X15,X2,X32,X42,X52,X62,X72,X82)) = zero_zero(nat) ) ).

% char.size(2)
tff(fact_6157_nat__of__char__less__256,axiom,
    ! [C2: char] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(char,nat,comm_s6883823935334413003f_char(nat),C2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ).

% nat_of_char_less_256
tff(fact_6158_range__nat__of__char,axiom,
    image(char,nat,comm_s6883823935334413003f_char(nat),top_top(set(char))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2)))))))))) ).

% range_nat_of_char
tff(fact_6159_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Na: A,C2: char] :
          ( ( aa(A,char,unique5772411509450598832har_of(A),Na) = C2 )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))),Na) = aa(char,A,comm_s6883823935334413003f_char(A),C2) ) ) ) ).

% char_of_eq_iff
tff(fact_6160_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] : ( integer_of_char(char2(B0,B1,B22,B32,B42,B52,B62,B72)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B72)),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B62))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B52))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B42))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B32))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B22))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B1))),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B0)) ) ).

% integer_of_char_code
tff(fact_6161_char_Osize__gen,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] : ( size_char(char2(X15,X2,X32,X42,X52,X62,X72,X82)) = zero_zero(nat) ) ).

% char.size_gen
tff(fact_6162_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] : ( aa(char,nat,comm_s6883823935334413003f_char(nat),ascii_of(C2)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit1,one2)))),aa(char,nat,comm_s6883823935334413003f_char(nat),C2)) ) ).

% String.char_of_ascii_of
tff(fact_6163_has__derivative__floor,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [G: fun(B,real),X: B,F2: fun(real,A),G2: fun(B,real),S: set(B)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,aa(B,real,G,X),top_top(set(real))),F2)
         => ( ~ member(A,aa(real,A,F2,aa(B,real,G,X)),ring_1_Ints(A))
           => ( has_derivative(B,real,G,G2,topolo174197925503356063within(B,X,S))
             => has_derivative(B,real,aa(fun(real,A),fun(B,real),aTP_Lamp_re(fun(B,real),fun(fun(real,A),fun(B,real)),G),F2),aTP_Lamp_rf(fun(B,real),fun(B,real),G2),topolo174197925503356063within(B,X,S)) ) ) ) ) ).

% has_derivative_floor
tff(fact_6164_continuous__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [F3: filter(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( topolo3448309680560233919inuous(A,B,F3,G)
           => topolo3448309680560233919inuous(A,B,F3,aa(fun(A,B),fun(A,B),aTP_Lamp_rg(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% continuous_add
tff(fact_6165_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [F3: filter(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( topolo3448309680560233919inuous(A,B,F3,G)
           => topolo3448309680560233919inuous(A,B,F3,aa(fun(A,B),fun(A,B),aTP_Lamp_rh(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% continuous_diff
tff(fact_6166_continuous__power_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [F3: filter(A),F2: fun(A,B),G: fun(A,nat)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( topolo3448309680560233919inuous(A,nat,F3,G)
           => topolo3448309680560233919inuous(A,B,F3,aa(fun(A,nat),fun(A,B),aTP_Lamp_ri(fun(A,B),fun(fun(A,nat),fun(A,B)),F2),G)) ) ) ) ).

% continuous_power'
tff(fact_6167_continuous__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F3: filter(A),F2: fun(A,B),Na: nat] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => topolo3448309680560233919inuous(A,B,F3,aa(nat,fun(A,B),aTP_Lamp_rj(fun(A,B),fun(nat,fun(A,B)),F2),Na)) ) ) ).

% continuous_power
tff(fact_6168_isCont__real__sqrt,axiom,
    ! [X: real] : topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),sqrt) ).

% isCont_real_sqrt
tff(fact_6169_isCont__real__root,axiom,
    ! [X: real,Na: nat] : topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),root(Na)) ).

% isCont_real_root
tff(fact_6170_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,S: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),G)
           => ( ( aa(A,B,G,A2) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aa(fun(A,B),fun(A,B),aTP_Lamp_rk(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% continuous_at_within_divide
tff(fact_6171_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [A2: A,F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_rg(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% isCont_add
tff(fact_6172_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_rl(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% isCont_diff
tff(fact_6173_isCont__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [A2: A,F2: fun(A,B),Na: nat] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(nat,fun(A,B),aTP_Lamp_rj(fun(A,B),fun(nat,fun(A,B)),F2),Na)) ) ) ).

% isCont_power
tff(fact_6174_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [A2: A,S: set(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F2)
         => ( ( aa(A,B,F2,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aTP_Lamp_rm(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_at_within_inverse
tff(fact_6175_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,S: set(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F2)
         => ( ( aa(A,B,F2,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aTP_Lamp_rn(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_at_within_sgn
tff(fact_6176_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G: fun(real,real),F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
       => ( ! [Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
               => ( aa(real,real,G,aa(real,real,F2,Z2)) = Z2 ) ) )
         => ( ! [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
                 => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),F2) ) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F2,X),top_top(set(real))),G) ) ) ) ) ).

% isCont_inverse_function2
tff(fact_6177_isCont__ln,axiom,
    ! [X: real] :
      ( ( X != zero_zero(real) )
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),ln_ln(real)) ) ).

% isCont_ln
tff(fact_6178_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( ( aa(A,B,G,A2) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_rk(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% isCont_divide
tff(fact_6179_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( ( aa(A,B,F2,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_rn(fun(A,B),fun(A,B),F2)) ) ) ) ).

% isCont_sgn
tff(fact_6180_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,S: set(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,S),F2)
         => ( ( cos(A,aa(A,A,F2,X)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,S),aTP_Lamp_ro(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_within_tan
tff(fact_6181_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A,S: set(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,S),F2)
         => ( ( sin(A,aa(A,A,F2,X)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,S),aTP_Lamp_rp(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_within_cot
tff(fact_6182_continuous__at__within__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [X: A,A3: set(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X,A3),F2)
         => ( ( cosh(B,aa(A,B,F2,X)) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X,A3),aTP_Lamp_rq(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_at_within_tanh
tff(fact_6183_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),L: A,X: A] :
          ( has_field_derivative(A,F2,L,topolo174197925503356063within(A,X,top_top(set(A))))
        <=> ? [G3: fun(A,A)] :
              ( ! [Z5: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,F2,Z5)),aa(A,A,F2,X)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G3,Z5)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z5),X)) )
              & topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,top_top(set(A))),G3)
              & ( aa(A,A,G3,X) = L ) ) ) ) ).

% CARAT_DERIV
tff(fact_6184_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: real,B2: real,F2: fun(real,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( ! [X3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X3,top_top(set(real))),F2) )
           => ? [M8: A] :
                ( ! [X4: real] :
                    ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X4)
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),B2) )
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(real,A,F2,X4)),M8) )
                & ! [N8: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N8),M8)
                   => ? [X3: real] :
                        ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less(A),N8),aa(real,A,F2,X3)) ) ) ) ) ) ) ).

% isCont_has_Ub
tff(fact_6185_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cos(A,X) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,top_top(set(A))),tan(A)) ) ) ).

% isCont_tan
tff(fact_6186_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( sin(A,X) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,top_top(set(A))),cot(A)) ) ) ).

% isCont_cot
tff(fact_6187_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( ( cosh(A,X) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,top_top(set(A))),tanh(A)) ) ) ).

% isCont_tanh
tff(fact_6188_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( ( cos(A,aa(A,A,F2,A2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ro(fun(A,A),fun(A,A),F2)) ) ) ) ).

% isCont_tan'
tff(fact_6189_isCont__arcosh,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),arcosh(real)) ) ).

% isCont_arcosh
tff(fact_6190_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( ( sin(A,aa(A,A,F2,A2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_rp(fun(A,A),fun(A,A),F2)) ) ) ) ).

% isCont_cot'
tff(fact_6191_DERIV__inverse__function,axiom,
    ! [F2: fun(real,real),D5: real,G: fun(real,real),X: real,A2: real,B2: real] :
      ( has_field_derivative(real,F2,D5,topolo174197925503356063within(real,aa(real,real,G,X),top_top(set(real))))
     => ( ( D5 != zero_zero(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
           => ( ! [Y4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Y4)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),B2)
                   => ( aa(real,real,F2,aa(real,real,G,Y4)) = Y4 ) ) )
             => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),G)
               => has_field_derivative(real,G,aa(real,real,inverse_inverse(real),D5),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_inverse_function
tff(fact_6192_isCont__polynom,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: A,C2: fun(nat,A),Na: nat] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aa(nat,fun(A,A),aTP_Lamp_rr(fun(nat,A),fun(nat,fun(A,A)),C2),Na)) ) ).

% isCont_polynom
tff(fact_6193_isCont__arccos,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),arccos) ) ) ).

% isCont_arccos
tff(fact_6194_isCont__arcsin,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),arcsin) ) ) ).

% isCont_arcsin
tff(fact_6195_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),X: A] :
          ( ! [Y4: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),Y4))
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,top_top(set(A))),aTP_Lamp_pa(fun(nat,A),fun(A,A),C2)) ) ) ).

% isCont_powser_converges_everywhere
tff(fact_6196_LIM__less__bound,axiom,
    ! [B2: real,X: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),B2),X)
     => ( ! [X3: real] :
            ( member(real,X3,set_or5935395276787703475ssThan(real,B2,X))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,F2,X3)) )
       => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),F2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,F2,X)) ) ) ) ).

% LIM_less_bound
tff(fact_6197_isCont__artanh,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),artanh(real)) ) ) ).

% isCont_artanh
tff(fact_6198_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G: fun(real,real),F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
     => ( ! [Z2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z2),X))),D2)
           => ( aa(real,real,G,aa(real,real,F2,Z2)) = Z2 ) )
       => ( ! [Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z2),X))),D2)
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),F2) )
         => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F2,X),top_top(set(real))),G) ) ) ) ).

% isCont_inverse_function
tff(fact_6199_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),G: fun(real,real),G2: fun(real,real),F7: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [Z2: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),F2) ) )
       => ( ! [Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z2),B2)
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z2,top_top(set(real))),G) ) )
         => ( ! [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                 => has_field_derivative(real,G,aa(real,real,G2,Z2),topolo174197925503356063within(real,Z2,top_top(set(real)))) ) )
           => ( ! [Z2: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                   => has_field_derivative(real,F2,aa(real,real,F7,Z2),topolo174197925503356063within(real,Z2,top_top(set(real)))) ) )
             => ? [C3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),C3),B2)
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2))),aa(real,real,G2,C3)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A2))),aa(real,real,F7,C3)) ) ) ) ) ) ) ) ).

% GMVT'
tff(fact_6200_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [X: real,F2: fun(real,A)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X,top_top(set(real))),F2)
         => ( ~ member(A,aa(real,A,F2,X),ring_1_Ints(A))
           => has_field_derivative(real,aTP_Lamp_rs(fun(real,A),fun(real,real),F2),zero_zero(real),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ).

% floor_has_real_derivative
tff(fact_6201_isCont__powser_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B)
        & topological_t2_space(A) )
     => ! [A2: A,F2: fun(A,B),C2: fun(nat,B),K5: B] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( summable(B,aa(B,fun(nat,B),aTP_Lamp_rt(fun(nat,B),fun(B,fun(nat,B)),C2),K5))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,A2))),real_V7770717601297561774m_norm(B,K5))
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(nat,B),fun(A,B),aTP_Lamp_rv(fun(A,B),fun(fun(nat,B),fun(A,B)),F2),C2)) ) ) ) ) ).

% isCont_powser'
tff(fact_6202_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,K5))
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,X,top_top(set(A))),aTP_Lamp_pa(fun(nat,A),fun(A,A),C2)) ) ) ) ).

% isCont_powser
tff(fact_6203_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K5: A,X: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_pd(fun(nat,A),fun(A,fun(nat,A)),C2),K5))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),real_V7770717601297561774m_norm(A,K5))
           => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_rx(fun(nat,A),fun(A,fun(A,A)),C2),X),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% termdiffs_aux
tff(fact_6204_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),remdups(A,concat(A,Xss))) = aa(set(A),nat,finite_card(A),complete_Sup_Sup(set(A),image(list(A),set(A),set2(A),aa(list(list(A)),set(list(A)),set2(list(A)),Xss)))) ) ).

% length_remdups_concat
tff(fact_6205_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups(A,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ( remdups(A,Xs) = Xs ) ) ).

% length_remdups_eq
tff(fact_6206_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_remdups_leq
tff(fact_6207_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F2: fun(B,A),L: A,F3: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ry(A,fun(fun(B,A),fun(B,A)),C2),F2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),L),C2)),F3)
          <=> filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% tendsto_mult_right_iff
tff(fact_6208_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F2: fun(B,A),L: A,F3: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_rz(A,fun(fun(B,A),fun(B,A)),C2),F2),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),L)),F3)
          <=> filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,L),F3) ) ) ) ).

% tendsto_mult_left_iff
tff(fact_6209_power__tendsto__0__iff,axiom,
    ! [A: $tType,Na: nat,F2: fun(A,real),F3: filter(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sa(nat,fun(fun(A,real),fun(A,real)),Na),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
      <=> filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% power_tendsto_0_iff
tff(fact_6210_continuous__real__root,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real),Na: nat] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => topolo3448309680560233919inuous(A,real,F3,aa(nat,fun(A,real),aTP_Lamp_sb(fun(A,real),fun(nat,fun(A,real)),F2),Na)) ) ) ).

% continuous_real_root
tff(fact_6211_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_sc(fun(A,real),fun(A,real),F2)) ) ) ).

% continuous_real_sqrt
tff(fact_6212_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(A,real),A2: A,G: fun(A,real)] :
          ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,G,X3)) )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,G,X3)),aa(A,real,F2,X3)) )
             => filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% real_LIM_sandwich_zero
tff(fact_6213_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),L: B,A2: A,G: fun(A,C),M: C] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(A,C,G,X3)),M))),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X3)),L))) )
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,M),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ).

% LIM_imp_LIM
tff(fact_6214_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S3: set(A)] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S3))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_sd(fun(A,A),fun(A,fun(A,A)),F2),X),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,X,S3)) ) ) ).

% has_field_derivativeD
tff(fact_6215_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A,S3: set(A)] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,S3))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_sd(fun(A,A),fun(A,fun(A,A)),F2),X),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,X,S3)) ) ) ).

% has_field_derivative_iff
tff(fact_6216_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A2: A,L4: B] :
          ( filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_se(fun(A,B),fun(A,fun(A,B)),F2),A2),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIM_offset_zero_cancel
tff(fact_6217_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),L4: B,A2: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_se(fun(A,B),fun(A,fun(A,B)),F2),A2),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_offset_zero
tff(fact_6218_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A2: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,A2)),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_se(fun(A,B),fun(A,fun(A,B)),F2),A2),topolo7230453075368039082e_nhds(B,aa(A,B,F2,A2)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_isCont_iff
tff(fact_6219_LIM__not__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo8386298272705272623_space(B)
        & zero(A)
        & topological_t2_space(A) )
     => ! [K: A,A2: B] :
          ( ( K != zero_zero(A) )
         => ~ filterlim(B,A,aTP_Lamp_sf(A,fun(B,A),K),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(B,A2,top_top(set(B)))) ) ) ).

% LIM_not_zero
tff(fact_6220_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),L4: B,A2: A,K: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_sg(fun(A,B),fun(A,fun(A,B)),F2),K),topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),K),top_top(set(A)))) ) ) ).

% LIM_offset
tff(fact_6221_tendsto__null__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [I5: set(A),F2: fun(B,fun(A,C)),F3: filter(B)] :
          ( ! [I3: A] :
              ( member(A,I3,I5)
             => filterlim(B,C,aa(A,fun(B,C),aTP_Lamp_sh(fun(B,fun(A,C)),fun(A,fun(B,C)),F2),I3),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) )
         => filterlim(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_si(set(A),fun(fun(B,fun(A,C)),fun(B,C)),I5),F2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ).

% tendsto_null_sum
tff(fact_6222_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B) )
     => ! [F2: fun(A,B),A2: B,F3: filter(A),Na: nat] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_sj(fun(A,B),fun(nat,fun(A,B)),F2),Na),topolo7230453075368039082e_nhds(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),A2),Na)),F3) ) ) ).

% tendsto_power
tff(fact_6223_tendsto__power__strong,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A),G: fun(A,nat),B2: nat] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( filterlim(A,nat,G,topolo7230453075368039082e_nhds(nat,B2),F3)
           => filterlim(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_sk(fun(A,B),fun(fun(A,nat),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),A2),B2)),F3) ) ) ) ).

% tendsto_power_strong
tff(fact_6224_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F2: fun(A,B),F3: filter(A),Na: nat] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_sl(fun(A,B),fun(nat,fun(A,B)),F2),Na),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_null_power
tff(fact_6225_tendsto__log,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
         => ( ( A2 != one_one(real) )
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
             => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sm(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,aa(real,real,log(A2),B2)),F3) ) ) ) ) ) ).

% tendsto_log
tff(fact_6226_tendsto__arcosh,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
       => filterlim(A,real,aTP_Lamp_sn(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A2)),F3) ) ) ).

% tendsto_arcosh
tff(fact_6227_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_so(fun(A,B),fun(B,fun(A,B)),F2),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% LIM_zero
tff(fact_6228_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_so(fun(A,B),fun(B,fun(A,B)),F2),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
        <=> filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ).

% LIM_zero_iff
tff(fact_6229_Lim__transform,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [G: fun(A,B),A2: B,F3: filter(A),F2: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sp(fun(A,B),fun(fun(A,B),fun(A,B)),G),F2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3) ) ) ) ).

% Lim_transform
tff(fact_6230_Lim__transform2,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
           => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F3) ) ) ) ).

% Lim_transform2
tff(fact_6231_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_so(fun(A,B),fun(B,fun(A,B)),F2),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ).

% LIM_zero_cancel
tff(fact_6232_Lim__transform__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),G: fun(A,B),F3: filter(A),A2: B] :
          ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
          <=> filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F3) ) ) ) ).

% Lim_transform_eq
tff(fact_6233_tendsto__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sr(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A2),B2)),F3) ) ) ) ).

% tendsto_diff
tff(fact_6234_tendsto__divide__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ss(fun(A,B),fun(B,fun(A,B)),F2),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_divide_zero
tff(fact_6235_tendsto__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F3)
           => ( ( B2 != zero_zero(B) )
             => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_st(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),divide_divide(B),A2),B2)),F3) ) ) ) ) ).

% tendsto_divide
tff(fact_6236_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_su(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_rabs_zero_cancel
tff(fact_6237_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_su(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
    <=> filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_rabs_zero_iff
tff(fact_6238_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => filterlim(A,real,aTP_Lamp_su(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_rabs_zero
tff(fact_6239_tendsto__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),A2: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( ( cosh(B,A2) != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_sv(fun(A,B),fun(A,B),F2),topolo7230453075368039082e_nhds(B,aa(B,B,tanh(B),A2)),F3) ) ) ) ).

% tendsto_tanh
tff(fact_6240_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(A,A),A2: A,F3: filter(A)] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,A2),F3)
         => ( ( sin(A,A2) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_rp(fun(A,A),fun(A,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,cot(A),A2)),F3) ) ) ) ).

% tendsto_cot
tff(fact_6241_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(A,A),A2: A,F3: filter(A)] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,A2),F3)
         => ( ( cos(A,A2) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_ro(fun(A,A),fun(A,A),F2),topolo7230453075368039082e_nhds(A,aa(A,A,tan(A),A2)),F3) ) ) ) ).

% tendsto_tan
tff(fact_6242_tendsto__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( ( A2 != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_sw(fun(A,B),fun(A,B),F2),topolo7230453075368039082e_nhds(B,aa(B,B,inverse_inverse(B),A2)),F3) ) ) ) ).

% tendsto_inverse
tff(fact_6243_tendsto__powr,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( ( A2 != zero_zero(real) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sx(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,powr(real,A2,B2)),F3) ) ) ) ).

% tendsto_powr
tff(fact_6244_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_sy(fun(A,B),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_norm_zero_cancel
tff(fact_6245_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_sy(fun(A,B),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
        <=> filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_norm_zero_iff
tff(fact_6246_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,real,aTP_Lamp_sy(fun(A,B),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% tendsto_norm_zero
tff(fact_6247_tendsto__ln,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( ( A2 != zero_zero(real) )
       => filterlim(A,real,aTP_Lamp_kd(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,ln_ln(real),A2)),F3) ) ) ).

% tendsto_ln
tff(fact_6248_tendsto__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => ( ( L != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_sz(fun(A,B),fun(A,B),F2),topolo7230453075368039082e_nhds(B,aa(B,B,sgn_sgn(B),L)),F3) ) ) ) ).

% tendsto_sgn
tff(fact_6249_tendsto__mult__one,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,one_one(B)),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,one_one(B)),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ta(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,one_one(B)),F3) ) ) ) ).

% tendsto_mult_one
tff(fact_6250_tendsto__mult__right__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_tb(fun(A,B),fun(B,fun(A,B)),F2),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_mult_right_zero
tff(fact_6251_tendsto__mult__left__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_tc(fun(A,B),fun(B,fun(A,B)),F2),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ).

% tendsto_mult_left_zero
tff(fact_6252_tendsto__mult__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_td(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_mult_zero
tff(fact_6253_tendsto__add__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_te(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_add_zero
tff(fact_6254_tendsto__add,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_te(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),F3) ) ) ) ).

% tendsto_add
tff(fact_6255_tendsto__add__const__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [C2: B,F2: fun(A,B),D2: B,F3: filter(A)] :
          ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_tf(B,fun(fun(A,B),fun(A,B)),C2),F2),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),D2)),F3)
        <=> filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,D2),F3) ) ) ).

% tendsto_add_const_iff
tff(fact_6256_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: fun(A,real),X: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,X),F3)
     => filterlim(A,real,aTP_Lamp_tg(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,sqrt,X)),F3) ) ).

% tendsto_real_sqrt
tff(fact_6257_tendsto__real__root,axiom,
    ! [A: $tType,F2: fun(A,real),X: real,F3: filter(A),Na: nat] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,X),F3)
     => filterlim(A,real,aa(nat,fun(A,real),aTP_Lamp_th(fun(A,real),fun(nat,fun(A,real)),F2),Na),topolo7230453075368039082e_nhds(real,aa(real,real,root(Na),X)),F3) ) ).

% tendsto_real_root
tff(fact_6258_tendsto__artanh,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),one_one(real))
         => filterlim(A,real,aTP_Lamp_ti(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,artanh(real),A2)),F3) ) ) ) ).

% tendsto_artanh
tff(fact_6259_tendsto__one__prod_H,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [I5: set(A),F2: fun(B,fun(A,C)),F3: filter(B)] :
          ( ! [I3: A] :
              ( member(A,I3,I5)
             => filterlim(B,C,aa(A,fun(B,C),aTP_Lamp_tj(fun(B,fun(A,C)),fun(A,fun(B,C)),F2),I3),topolo7230453075368039082e_nhds(C,one_one(C)),F3) )
         => filterlim(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_tk(set(A),fun(fun(B,fun(A,C)),fun(B,C)),I5),F2),topolo7230453075368039082e_nhds(C,one_one(C)),F3) ) ) ).

% tendsto_one_prod'
tff(fact_6260_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [X: A,F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,X,top_top(set(A))),F2)
        <=> filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_tl(A,fun(fun(A,B),fun(A,B)),X),F2),topolo7230453075368039082e_nhds(B,aa(A,B,F2,X)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% isCont_iff
tff(fact_6261_LIM__offset__zero__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C)
        & zero(A) )
     => ! [A2: B,F2: fun(B,C),L4: C] :
          ( nO_MATCH(A,B,zero_zero(A),A2)
         => ( filterlim(B,C,F2,topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,A2,top_top(set(B))))
          <=> filterlim(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_tm(B,fun(fun(B,C),fun(B,C)),A2),F2),topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,zero_zero(B),top_top(set(B)))) ) ) ) ).

% LIM_offset_zero_iff
tff(fact_6262_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),L4: B,A2: A,R2: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => ? [S2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S2)
                & ! [X4: A] :
                    ( ( ( X4 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A2))),S2) )
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X4)),L4))),R2) ) ) ) ) ) ).

% LIM_D
tff(fact_6263_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F2: fun(A,B),L4: B] :
          ( ! [R: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A2))),S6) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X3)),L4))),R) ) ) )
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIM_I
tff(fact_6264_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),L4: B,A2: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S5)
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X5),A2))),S5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X5)),L4))),R5) ) ) ) ) ) ).

% LIM_eq
tff(fact_6265_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [R3: real,A2: A,F2: fun(A,B),G: fun(A,B),L: B] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R3)
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A2))),R3)
                 => ( aa(A,B,F2,X3) = aa(A,B,G,X3) ) ) )
           => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
             => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_equal2
tff(fact_6266_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [F2: fun(A,A),A2: A,D5: A] :
          ( filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_tn(fun(A,A),fun(A,fun(A,A)),F2),A2),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_to(fun(A,A),fun(A,fun(A,A)),F2),A2),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% DERIV_LIM_iff
tff(fact_6267_LIM__fun__less__zero,axiom,
    ! [F2: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [R: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
            & ! [X4: real] :
                ( ( ( X4 != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X4))),R) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,X4)),zero_zero(real)) ) ) ) ) ).

% LIM_fun_less_zero
tff(fact_6268_LIM__fun__not__zero,axiom,
    ! [F2: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( ( L != zero_zero(real) )
       => ? [R: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
            & ! [X4: real] :
                ( ( ( X4 != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X4))),R) )
               => ( aa(real,real,F2,X4) != zero_zero(real) ) ) ) ) ) ).

% LIM_fun_not_zero
tff(fact_6269_LIM__fun__gt__zero,axiom,
    ! [F2: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [R: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
            & ! [X4: real] :
                ( ( ( X4 != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X4))),R) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,F2,X4)) ) ) ) ) ).

% LIM_fun_gt_zero
tff(fact_6270_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F2: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A2))),D6) )
                     => ( aa(A,B,F2,X3) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tp(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_compose2
tff(fact_6271_continuous__at__within__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),F2)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),G)
           => ( ( aa(A,real,F2,A2) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),aa(fun(A,real),fun(A,real),aTP_Lamp_tq(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ).

% continuous_at_within_powr
tff(fact_6272_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X: A,S: set(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X,S),F2)
         => ( ( aa(A,real,F2,X) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X,S),aTP_Lamp_tr(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_within_ln
tff(fact_6273_DERIV__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_ts(fun(A,A),fun(A,fun(A,A)),F2),X),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_def
tff(fact_6274_DERIV__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A] :
          ( has_field_derivative(A,F2,D5,topolo174197925503356063within(A,X,top_top(set(A))))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_ts(fun(A,A),fun(A,fun(A,A)),F2),X),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_D
tff(fact_6275_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => filterlim(A,A,aTP_Lamp_tt(A,A),topolo7230453075368039082e_nhds(A,one_one(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% lim_exp_minus_1
tff(fact_6276_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F2: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F2,A2),top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A2))),D6) )
                     => ( aa(A,B,F2,X3) != aa(A,B,F2,A2) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tp(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% isCont_LIM_compose2
tff(fact_6277_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),remdups(A,Xs)) = aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs)) ) ).

% length_remdups_card_conv
tff(fact_6278_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [K: real,F2: fun(A,B),K5: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K)
         => ( ! [H2: A] :
                ( ( H2 != zero_zero(A) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,H2)),K)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,H2))),aa(real,real,aa(real,fun(real,real),times_times(real),K5),real_V7770717601297561774m_norm(A,H2))) ) )
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% lemma_termdiff4
tff(fact_6279_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D5: A,X: A] :
          ( has_derivative(A,A,F2,aa(A,fun(A,A),times_times(A),D5),topolo174197925503356063within(A,X,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_ts(fun(A,A),fun(A,fun(A,A)),F2),X),topolo7230453075368039082e_nhds(A,D5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% field_has_derivative_at
tff(fact_6280_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(A,B),F3: filter(B),A2: A] :
          ( filterlim(A,B,F2,F3,topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_tu(fun(A,B),fun(A,fun(A,B)),F2),A2),F3,topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% filterlim_at_to_0
tff(fact_6281_isCont__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( ( aa(A,real,F2,A2) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_tq(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ).

% isCont_powr
tff(fact_6282_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [X: A,F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X,top_top(set(A))),F2)
         => ( ( aa(A,real,F2,X) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,X,top_top(set(A))),aTP_Lamp_tr(fun(A,real),fun(A,real),F2)) ) ) ) ).

% isCont_ln'
tff(fact_6283_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(A,B),D2: A,F3: filter(B),A2: A] :
          ( filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F2),aa(A,fun(A,A),plus_plus(A),D2)),F3,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A))))
        <=> filterlim(A,B,F2,F3,topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% filterlim_shift_iff
tff(fact_6284_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(A,B),F3: filter(B),A2: A,D2: A] :
          ( filterlim(A,B,F2,F3,topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F2),aa(A,fun(A,A),plus_plus(A),D2)),F3,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A)))) ) ) ).

% filterlim_shift
tff(fact_6285_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A2: fun(nat,A),F2: fun(A,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S)
         => ( ! [X3: A] :
                ( ( X3 != zero_zero(A) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X3)),S)
                 => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),A2),X3),aa(A,A,F2,X3)) ) )
           => filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,aa(nat,A,A2,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0_strong
tff(fact_6286_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A2: fun(nat,A),F2: fun(A,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S)
         => ( ! [X3: A] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X3)),S)
               => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),A2),X3),aa(A,A,F2,X3)) )
           => filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,aa(nat,A,A2,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0
tff(fact_6287_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [K: real,F2: fun(nat,real),G: fun(A,fun(nat,B))] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K)
         => ( summable(real,F2)
           => ( ! [H2: A,N: nat] :
                  ( ( H2 != zero_zero(A) )
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,H2)),K)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(nat,B,aa(A,fun(nat,B),G,H2),N))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,F2,N)),real_V7770717601297561774m_norm(A,H2))) ) )
             => filterlim(A,B,aTP_Lamp_tv(fun(A,fun(nat,B)),fun(A,B),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% lemma_termdiff5
tff(fact_6288_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),F2)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F2,A2))
             => ( ( aa(A,real,F2,A2) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,A2))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),aa(fun(A,real),fun(A,real),aTP_Lamp_tw(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% continuous_at_within_log
tff(fact_6289_LIM__cos__div__sin,axiom,
    filterlim(real,real,aTP_Lamp_tx(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),top_top(set(real)))) ).

% LIM_cos_div_sin
tff(fact_6290_isCont__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F2,A2))
             => ( ( aa(A,real,F2,A2) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,A2))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_tw(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% isCont_log
tff(fact_6291_summable__Leibniz_I2_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(nat,real,A2,zero_zero(nat)))
         => ! [N6: nat] : member(real,suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N6))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N6)),one_one(nat)))))) ) ) ) ).

% summable_Leibniz(2)
tff(fact_6292_summable__Leibniz_I3_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,A2,zero_zero(nat))),zero_zero(real))
         => ! [N6: nat] : member(real,suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N6)),one_one(nat)))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N6))))) ) ) ) ).

% summable_Leibniz(3)
tff(fact_6293_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_tz(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_left_iff
tff(fact_6294_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ua(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_right_iff
tff(fact_6295_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ub(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_divide_iff
tff(fact_6296_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( dense_linorder(A)
        & topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ? [U2: fun(nat,A)] :
              ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(nat,A,U2,N6))
              & filterlim(nat,A,U2,topolo7230453075368039082e_nhds(A,X),at_top(nat)) ) ) ) ).

% approx_from_above_dense_linorder
tff(fact_6297_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( dense_linorder(A)
        & topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ? [U2: fun(nat,A)] :
              ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,U2,N6)),X)
              & filterlim(nat,A,U2,topolo7230453075368039082e_nhds(A,X),at_top(nat)) ) ) ) ).

% approx_from_below_dense_linorder
tff(fact_6298_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),L: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,aTP_Lamp_uc(fun(nat,A),fun(nat,A),F2),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% LIMSEQ_Suc
tff(fact_6299_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),L: A] :
          ( filterlim(nat,A,aTP_Lamp_uc(fun(nat,A),fun(nat,A),F2),topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% LIMSEQ_imp_Suc
tff(fact_6300_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),A2: A,K: nat] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ud(fun(nat,A),fun(nat,fun(nat,A)),F2),K),topolo7230453075368039082e_nhds(A,A2),at_top(nat)) ) ) ).

% LIMSEQ_ignore_initial_segment
tff(fact_6301_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),K: nat,A2: A] :
          ( filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ud(fun(nat,A),fun(nat,fun(nat,A)),F2),K),topolo7230453075368039082e_nhds(A,A2),at_top(nat))
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) ) ) ).

% LIMSEQ_offset
tff(fact_6302_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),L: A,K: nat] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ue(fun(nat,A),fun(nat,fun(nat,A)),F2),K),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% seq_offset_neg
tff(fact_6303_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( summable(A,F2)
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% summable_LIMSEQ_zero
tff(fact_6304_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
     => filterlim(nat,nat,aTP_Lamp_uf(nat,fun(nat,nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_right_at_top
tff(fact_6305_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
     => filterlim(nat,nat,aa(nat,fun(nat,nat),times_times(nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_left_at_top
tff(fact_6306_LIMSEQ__root,axiom,
    filterlim(nat,real,aTP_Lamp_ug(nat,real),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ).

% LIMSEQ_root
tff(fact_6307_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A] : filterlim(nat,A,aTP_Lamp_uh(A,fun(nat,A),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_const_over_n
tff(fact_6308_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ui(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_inverse_n
tff(fact_6309_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X7: fun(nat,A),X: A,L: nat] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,X),at_top(nat))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),L)
           => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_uj(fun(nat,A),fun(nat,fun(nat,A)),X7),L),topolo7230453075368039082e_nhds(A,X),at_top(nat)) ) ) ) ).

% LIMSEQ_linear
tff(fact_6310_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => summable(A,aTP_Lamp_uk(fun(nat,A),fun(nat,A),F2)) ) ) ).

% telescope_summable'
tff(fact_6311_telescope__summable,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => summable(A,aTP_Lamp_ul(fun(nat,A),fun(nat,A),F2)) ) ) ).

% telescope_summable
tff(fact_6312_nested__sequence__unique,axiom,
    ! [F2: fun(nat,real),G: fun(nat,real)] :
      ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,N)),aa(nat,real,F2,aa(nat,nat,suc,N)))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,G,aa(nat,nat,suc,N))),aa(nat,real,G,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,N)),aa(nat,real,G,N))
         => ( filterlim(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_um(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F2),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => ? [L2: real] :
                ( ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,N6)),L2)
                & filterlim(nat,real,F2,topolo7230453075368039082e_nhds(real,L2),at_top(nat))
                & ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L2),aa(nat,real,G,N6))
                & filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ) ).

% nested_sequence_unique
tff(fact_6313_LIMSEQ__inverse__zero,axiom,
    ! [X7: fun(nat,real)] :
      ( ! [R: real] :
        ? [N8: nat] :
        ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),R),aa(nat,real,X7,N)) )
     => filterlim(nat,real,aTP_Lamp_un(fun(nat,real),fun(nat,real),X7),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_zero
tff(fact_6314_lim__inverse__n_H,axiom,
    filterlim(nat,real,aTP_Lamp_uo(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% lim_inverse_n'
tff(fact_6315_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
     => filterlim(nat,real,aTP_Lamp_up(real,fun(nat,real),C2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ) ).

% LIMSEQ_root_const
tff(fact_6316_LIMSEQ__inverse__real__of__nat,axiom,
    filterlim(nat,real,aTP_Lamp_uq(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat
tff(fact_6317_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R2: real] : filterlim(nat,real,aTP_Lamp_ur(real,fun(nat,real),R2),topolo7230453075368039082e_nhds(real,R2),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add
tff(fact_6318_increasing__LIMSEQ,axiom,
    ! [F2: fun(nat,real),L: real] :
      ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,N)),aa(nat,real,F2,aa(nat,nat,suc,N)))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,N)),L)
       => ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F2,N6)),E)) )
         => filterlim(nat,real,F2,topolo7230453075368039082e_nhds(real,L),at_top(nat)) ) ) ) ).

% increasing_LIMSEQ
tff(fact_6319_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_us(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_1_over_n
tff(fact_6320_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_ut(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_n_over_Suc_n
tff(fact_6321_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_uu(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_Suc_n_over_n
tff(fact_6322_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
       => filterlim(nat,real,aa(real,fun(nat,real),power_power(real),X),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ) ).

% LIMSEQ_realpow_zero
tff(fact_6323_telescope__sums,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => sums(A,aTP_Lamp_ul(fun(nat,A),fun(nat,A),F2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(nat,A,F2,zero_zero(nat)))) ) ) ).

% telescope_sums
tff(fact_6324_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => sums(A,aTP_Lamp_uk(fun(nat,A),fun(nat,A),F2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F2,zero_zero(nat))),C2)) ) ) ).

% telescope_sums'
tff(fact_6325_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_uv(real,fun(real,fun(nat,real)),X),A2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_divide_realpow_zero
tff(fact_6326_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real))
     => filterlim(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),C2)),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero
tff(fact_6327_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real))
     => filterlim(nat,real,aa(real,fun(nat,real),power_power(real),C2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero2
tff(fact_6328_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),X)
     => filterlim(nat,real,aTP_Lamp_uw(real,fun(nat,real),X),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_realpow_zero
tff(fact_6329_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F2: fun(nat,A),S: A] :
          ( sums(A,F2,S)
        <=> filterlim(nat,A,aTP_Lamp_ux(fun(nat,A),fun(nat,A),F2),topolo7230453075368039082e_nhds(A,S),at_top(nat)) ) ) ).

% sums_def'
tff(fact_6330_root__test__convergence,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),X: real] :
          ( filterlim(nat,real,aTP_Lamp_uy(fun(nat,A),fun(nat,real),F2),topolo7230453075368039082e_nhds(real,X),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),one_one(real))
           => summable(A,F2) ) ) ) ).

% root_test_convergence
tff(fact_6331_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R2: real] : filterlim(nat,real,aTP_Lamp_uz(real,fun(nat,real),R2),topolo7230453075368039082e_nhds(real,R2),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus
tff(fact_6332_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N4)),L4))),R5) ) ) ) ) ).

% LIMSEQ_iff
tff(fact_6333_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( ! [R: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
             => ? [No2: nat] :
                ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No2),N)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N)),L4))),R) ) )
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat)) ) ) ).

% LIMSEQ_I
tff(fact_6334_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A),L4: A,R2: real] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => ? [No3: nat] :
              ! [N6: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N6)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X7,N6)),L4))),R2) ) ) ) ) ).

% LIMSEQ_D
tff(fact_6335_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),one_one(real))
         => filterlim(nat,A,aa(A,fun(nat,A),power_power(A),X),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_power_zero
tff(fact_6336_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] : filterlim(nat,real,aTP_Lamp_va(real,fun(nat,real),X),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X)),at_top(nat)) ).

% tendsto_exp_limit_sequentially
tff(fact_6337_tendsto__at__iff__sequentially,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A2: B,X: A,S: set(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),topolo174197925503356063within(A,X,S))
        <=> ! [X8: fun(nat,A)] :
              ( ! [I: nat] : member(A,aa(nat,A,X8,I),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))
             => ( filterlim(nat,A,X8,topolo7230453075368039082e_nhds(A,X),at_top(nat))
               => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),comp(A,B,nat,F2),X8),topolo7230453075368039082e_nhds(B,A2),at_top(nat)) ) ) ) ) ).

% tendsto_at_iff_sequentially
tff(fact_6338_tendsto__power__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F2: fun(A,nat),F3: filter(A),X: B] :
          ( filterlim(A,nat,F2,at_top(nat),F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,X)),one_one(real))
           => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_vb(fun(A,nat),fun(B,fun(A,B)),F2),X),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_power_zero
tff(fact_6339_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R2: real] : filterlim(nat,real,aTP_Lamp_vc(real,fun(nat,real),R2),topolo7230453075368039082e_nhds(real,R2),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
tff(fact_6340_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,F2,N))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))))
         => filterlim(nat,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_norm_0
tff(fact_6341_summable__Leibniz_I1_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => summable(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)) ) ) ).

% summable_Leibniz(1)
tff(fact_6342_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),Df: A,Z: A,S: fun(nat,A),A2: A] :
          ( has_field_derivative(A,F2,Df,topolo174197925503356063within(A,Z,top_top(set(A))))
         => ( filterlim(nat,A,S,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
           => ( ! [N: nat] : ( aa(nat,A,S,N) != zero_zero(A) )
             => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_vd(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),F2),Z),S),topolo7230453075368039082e_nhds(A,A2),at_top(nat))
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
tff(fact_6343_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),one_one(real))
         => filterlim(nat,A,aTP_Lamp_ve(A,fun(nat,A),X),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% powser_times_n_limit_0
tff(fact_6344_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,X))
         => filterlim(nat,A,aTP_Lamp_vf(A,fun(nat,A),X),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% lim_n_over_pown
tff(fact_6345_summable,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => summable(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)) ) ) ) ).

% summable
tff(fact_6346_cos__diff__limit__1,axiom,
    ! [Theta: fun(nat,real),Theta2: real] :
      ( filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_vg(fun(nat,real),fun(real,fun(nat,real)),Theta),Theta2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ~ ! [K2: fun(nat,int)] : ~ filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_vh(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K2),topolo7230453075368039082e_nhds(real,Theta2),at_top(nat)) ) ).

% cos_diff_limit_1
tff(fact_6347_cos__limit__1,axiom,
    ! [Theta: fun(nat,real)] :
      ( filterlim(nat,real,aTP_Lamp_vi(fun(nat,real),fun(nat,real),Theta),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ? [K2: fun(nat,int)] : filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_vh(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% cos_limit_1
tff(fact_6348_summable__Leibniz_I4_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => filterlim(nat,real,aTP_Lamp_vj(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ).

% summable_Leibniz(4)
tff(fact_6349_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),X)),one_one(real))
     => filterlim(nat,real,aTP_Lamp_ah(real,fun(nat,real),X),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% zeroseq_arctan_series
tff(fact_6350_summable__Leibniz_H_I2_J,axiom,
    ! [A2: fun(nat,real),Na: nat] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)))),suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2))) ) ) ) ).

% summable_Leibniz'(2)
tff(fact_6351_summable__Leibniz_H_I3_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => filterlim(nat,real,aTP_Lamp_vj(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(3)
tff(fact_6352_sums__alternating__upper__lower,axiom,
    ! [A2: fun(nat,real)] :
      ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
         => ? [L2: real] :
              ( ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N6)))),L2)
              & filterlim(nat,real,aTP_Lamp_vj(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,L2),at_top(nat))
              & ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L2),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N6)),one_one(nat)))))
              & filterlim(nat,real,aTP_Lamp_vk(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ).

% sums_alternating_upper_lower
tff(fact_6353_summable__Leibniz_I5_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => filterlim(nat,real,aTP_Lamp_vk(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ).

% summable_Leibniz(5)
tff(fact_6354_summable__Leibniz_H_I5_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => filterlim(nat,real,aTP_Lamp_vk(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(5)
tff(fact_6355_summable__Leibniz_H_I4_J,axiom,
    ! [A2: fun(nat,real),Na: nat] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N))
       => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N))),aa(nat,real,A2,N))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),suminf(real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)),one_one(nat))))) ) ) ) ).

% summable_Leibniz'(4)
tff(fact_6356_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: fun(nat,A),F3: filter(A)] :
      ( filterlim(nat,A,aTP_Lamp_vl(fun(nat,A),fun(nat,A),F2),F3,at_top(nat))
    <=> filterlim(nat,A,F2,F3,at_top(nat)) ) ).

% filterlim_sequentially_Suc
tff(fact_6357_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_vm(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F2),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F2) ) ) ) ).

% summable_bounded_partials
tff(fact_6358_eventually__sequentially__Suc,axiom,
    ! [P: fun(nat,$o)] :
      ( eventually(nat,aTP_Lamp_vn(fun(nat,$o),fun(nat,$o),P),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_Suc
tff(fact_6359_eventually__sequentially__seg,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_vo(fun(nat,$o),fun(nat,fun(nat,$o)),P),K),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_seg
tff(fact_6360_filterlim__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,at_top(B),F3)
        <=> ! [Z6: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_vp(fun(A,B),fun(B,fun(A,$o)),F2),Z6),F3) ) ) ).

% filterlim_at_top_dense
tff(fact_6361_sequentially__offset,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( eventually(nat,P,at_top(nat))
     => eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_vo(fun(nat,$o),fun(nat,fun(nat,$o)),P),K),at_top(nat)) ) ).

% sequentially_offset
tff(fact_6362_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_top(A))
        <=> ? [N5: A] :
            ! [N4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N5),N4)
             => aa(A,$o,P,N4) ) ) ) ).

% eventually_at_top_dense
tff(fact_6363_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_top(A) )
     => ! [C2: A] : eventually(A,aa(A,fun(A,$o),ord_less(A),C2),at_top(A)) ) ).

% eventually_gt_at_top
tff(fact_6364_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( order_top(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),top_top(A))
         => ( eventually(A,P,topolo7230453075368039082e_nhds(A,top_top(A)))
          <=> ? [B7: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B7),top_top(A))
                & ! [Z5: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B7),Z5)
                   => aa(A,$o,P,Z5) ) ) ) ) ) ).

% eventually_nhds_top
tff(fact_6365_eventually__at__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Y: A,X: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( eventually(A,P,topolo174197925503356063within(A,X,set_ord_lessThan(A,X)))
          <=> ? [B7: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B7),X)
                & ! [Y5: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B7),Y5)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X)
                     => aa(A,$o,P,Y5) ) ) ) ) ) ) ).

% eventually_at_left
tff(fact_6366_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [P: fun(A,$o),X: A] :
          ( eventually(A,P,topolo174197925503356063within(A,X,set_ord_lessThan(A,X)))
        <=> ? [B7: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B7),X)
              & ! [Y5: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B7),Y5)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X)
                   => aa(A,$o,P,Y5) ) ) ) ) ) ).

% eventually_at_left_field
tff(fact_6367_filterlim__at__top__gt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_top(B),F3)
        <=> ! [Z6: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Z6)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vq(fun(A,B),fun(B,fun(A,$o)),F2),Z6),F3) ) ) ) ).

% filterlim_at_top_gt
tff(fact_6368_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),X: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,X),F3)
        <=> ( ! [L3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L3),X)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vr(fun(A,B),fun(B,fun(A,$o)),F2),L3),F3) )
            & ! [U3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),U3)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vs(fun(A,B),fun(B,fun(A,$o)),F2),U3),F3) ) ) ) ) ).

% order_tendsto_iff
tff(fact_6369_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Y: A,F2: fun(B,A),F3: filter(B)] :
          ( ! [A4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A4),Y)
             => eventually(B,aa(A,fun(B,$o),aTP_Lamp_vt(fun(B,A),fun(A,fun(B,$o)),F2),A4),F3) )
         => ( ! [A4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),A4)
               => eventually(B,aa(A,fun(B,$o),aTP_Lamp_vu(fun(B,A),fun(A,fun(B,$o)),F2),A4),F3) )
           => filterlim(B,A,F2,topolo7230453075368039082e_nhds(A,Y),F3) ) ) ) ).

% order_tendstoI
tff(fact_6370_order__tendstoD_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),Y: B,F3: filter(A),A2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,Y),F3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),Y)
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vr(fun(A,B),fun(B,fun(A,$o)),F2),A2),F3) ) ) ) ).

% order_tendstoD(1)
tff(fact_6371_order__tendstoD_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),Y: B,F3: filter(A),A2: B] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,Y),F3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),A2)
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vs(fun(A,B),fun(B,fun(A,$o)),F2),A2),F3) ) ) ) ).

% order_tendstoD(2)
tff(fact_6372_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( ! [X3: A] :
              ( member(A,X3,set_or5935395276787703475ssThan(A,A2,B2))
             => aa(A,$o,P,X3) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => eventually(A,P,topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2))) ) ) ) ).

% eventually_at_leftI
tff(fact_6373_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> eventually(A,aa(A,fun(A,$o),aTP_Lamp_vv(fun(A,$o),fun(A,fun(A,$o)),P),A2),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% eventually_at_to_0
tff(fact_6374_increasing__tendsto,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_vw(fun(A,B),fun(B,fun(A,$o)),F2),L),F3)
         => ( ! [X3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),L)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vr(fun(A,B),fun(B,fun(A,$o)),F2),X3),F3) )
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ) ).

% increasing_tendsto
tff(fact_6375_decreasing__tendsto,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [L: B,F2: fun(A,B),F3: filter(A)] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_vx(B,fun(fun(A,B),fun(A,$o)),L),F2),F3)
         => ( ! [X3: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),X3)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_vs(fun(A,B),fun(B,fun(A,$o)),F2),X3),F3) )
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ) ).

% decreasing_tendsto
tff(fact_6376_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( eventually(A,aTP_Lamp_vy(fun(A,real),fun(A,$o),F2),F3)
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_vz(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_arcosh_strong
tff(fact_6377_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),L4: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),F3)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_vs(fun(A,B),fun(B,fun(A,$o)),F2),L4),F3)
           => filterlim(A,B,F2,topolo174197925503356063within(B,L4,set_ord_lessThan(B,L4)),F3) ) ) ) ).

% tendsto_imp_filterlim_at_left
tff(fact_6378_tendsto__arcosh__strong,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),A2)
       => ( eventually(A,aTP_Lamp_wa(fun(A,real),fun(A,$o),F2),F3)
         => filterlim(A,real,aTP_Lamp_sn(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A2)),F3) ) ) ) ).

% tendsto_arcosh_strong
tff(fact_6379_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F2: fun(A,B),P: fun(B,$o),G: fun(B,A),A2: A] :
          ( ! [X3: A,Y4: A] :
              ( aa(A,$o,Q,X3)
             => ( aa(A,$o,Q,Y4)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) ) ) )
         => ( ! [X3: B] :
                ( aa(B,$o,P,X3)
               => ( aa(A,B,F2,aa(B,A,G,X3)) = X3 ) )
           => ( ! [X3: B] :
                  ( aa(B,$o,P,X3)
                 => aa(A,$o,Q,aa(B,A,G,X3)) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2)))
               => ( ! [B4: A] :
                      ( aa(A,$o,Q,B4)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B4),A2) )
                 => ( eventually(B,P,at_top(B))
                   => filterlim(A,B,F2,at_top(B),topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2))) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
tff(fact_6380_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,C),K5: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
         => ( eventually(A,aa(real,fun(A,$o),aa(fun(A,C),fun(real,fun(A,$o)),aTP_Lamp_wb(fun(A,B),fun(fun(A,C),fun(real,fun(A,$o))),F2),G),K5),F3)
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ) ).

% tendsto_0_le
tff(fact_6381_filterlim__at__withinI,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F2: fun(A,B),C2: B,F3: filter(A),A3: set(B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,C2),F3)
         => ( eventually(A,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_wc(fun(A,B),fun(B,fun(set(B),fun(A,$o))),F2),C2),A3),F3)
           => filterlim(A,B,F2,topolo174197925503356063within(B,C2,A3),F3) ) ) ) ).

% filterlim_at_withinI
tff(fact_6382_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( eventually(A,aTP_Lamp_wd(fun(A,real),fun(A,$o),F2),F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sx(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ) ) ).

% tendsto_zero_powrI
tff(fact_6383_tendsto__powr2,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( eventually(A,aTP_Lamp_wd(fun(A,real),fun(A,$o),F2),F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sx(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,powr(real,A2,B2)),F3) ) ) ) ) ).

% tendsto_powr2
tff(fact_6384_tendsto__powr_H,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F3)
       => ( ( ( A2 != zero_zero(real) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
              & eventually(A,aTP_Lamp_wd(fun(A,real),fun(A,$o),F2),F3) ) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sx(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,powr(real,A2,B2)),F3) ) ) ) ).

% tendsto_powr'
tff(fact_6385_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => ( ~ member(B,L,ring_1_Ints(B))
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_we(fun(A,B),fun(B,fun(A,$o)),F2),L),F3) ) ) ) ).

% eventually_floor_less
tff(fact_6386_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => ( ~ member(B,L,ring_1_Ints(B))
           => eventually(A,aa(B,fun(A,$o),aTP_Lamp_wf(fun(A,B),fun(B,fun(A,$o)),F2),L),F3) ) ) ) ).

% eventually_less_ceiling
tff(fact_6387_filterlim__Suc,axiom,
    filterlim(nat,nat,suc,at_top(nat),at_top(nat)) ).

% filterlim_Suc
tff(fact_6388_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F2: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_wg(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F2),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F2) ) ) ) ).

% summable_Cauchy'
tff(fact_6389_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [C2: fun(nat,A),K: nat,Na: nat,B3: real] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),K)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),Na)
             => eventually(A,aa(real,fun(A,$o),aa(nat,fun(real,fun(A,$o)),aTP_Lamp_wh(fun(nat,A),fun(nat,fun(real,fun(A,$o))),C2),Na),B3),at_infinity(A)) ) ) ) ) ).

% polyfun_extremal
tff(fact_6390_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F7)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_wi(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F2),F7),X),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X,top_top(set(A)))) ) ) ) ).

% has_derivative_at2
tff(fact_6391_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,at_infinity(real),F3)
     => ( eventually(A,aTP_Lamp_wj(fun(A,real),fun(A,$o),F2),F3)
       => filterlim(A,real,F2,at_top(real),F3) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
tff(fact_6392_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qb(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% bounded_linear_add
tff(fact_6393_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => real_V3181309239436604168linear(A,B,aTP_Lamp_qd(A,B)) ) ).

% bounded_linear_zero
tff(fact_6394_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Y: A] : real_V3181309239436604168linear(A,A,aTP_Lamp_wk(A,fun(A,A),Y)) ) ).

% bounded_linear_divide
tff(fact_6395_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qe(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% bounded_linear_sub
tff(fact_6396_sqrt__at__top,axiom,
    filterlim(real,real,sqrt,at_top(real),at_top(real)) ).

% sqrt_at_top
tff(fact_6397_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),G: fun(C,A),F3: filter(C)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ( filterlim(C,A,G,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_wl(fun(A,B),fun(fun(C,A),fun(C,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% bounded_linear.tendsto_zero
tff(fact_6398_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),B2),A2)
     => eventually(real,aa(real,fun(real,$o),aTP_Lamp_wm(real,fun(real,fun(real,$o)),B2),A2),topolo174197925503356063within(real,A2,set_ord_lessThan(real,A2))) ) ).

% eventually_at_left_real
tff(fact_6399_lhopital__at__top,axiom,
    ! [G: fun(real,real),X: real,G2: fun(real,real),F2: fun(real,real),F7: fun(real,real),Y: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X,top_top(set(real))))
     => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,X,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,X,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top
tff(fact_6400_lhospital__at__top__at__top,axiom,
    ! [G: fun(real,real),G2: fun(real,real),F2: fun(real,real),F7: fun(real,real),X: real] :
      ( filterlim(real,real,G,at_top(real),at_top(real))
     => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),at_top(real))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),at_top(real))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),at_top(real))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),topolo7230453075368039082e_nhds(real,X),at_top(real))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,X),at_top(real)) ) ) ) ) ) ).

% lhospital_at_top_at_top
tff(fact_6401_lhopital__left__at__top,axiom,
    ! [G: fun(real,real),X: real,G2: fun(real,real),F2: fun(real,real),F7: fun(real,real),Y: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
     => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,X,set_ord_lessThan(real,X))) ) ) ) ) ) ).

% lhopital_left_at_top
tff(fact_6402_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ? [K8: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),K8)
              & ! [X4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X4)),K8)) ) ) ) ).

% bounded_linear.nonneg_bounded
tff(fact_6403_filterlim__pow__at__top,axiom,
    ! [A: $tType,Na: nat,F2: fun(A,real),F3: filter(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( filterlim(A,real,F2,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sa(nat,fun(fun(A,real),fun(A,real)),Na),F2),at_top(real),F3) ) ) ).

% filterlim_pow_at_top
tff(fact_6404_tanh__real__at__top,axiom,
    filterlim(real,real,tanh(real),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(real)) ).

% tanh_real_at_top
tff(fact_6405_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B),C2: B] :
          ( filterlim(A,B,F2,at_infinity(B),F3)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_wq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),at_infinity(B),F3) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
tff(fact_6406_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),C2: B,F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,C2),F3)
         => ( filterlim(A,B,G,at_infinity(B),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_wq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),at_infinity(B),F3) ) ) ) ).

% tendsto_add_filterlim_at_infinity
tff(fact_6407_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( filterlim(A,real,G,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wr(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% real_tendsto_divide_at_top
tff(fact_6408_artanh__real__at__left__1,axiom,
    filterlim(real,real,artanh(real),at_top(real),topolo174197925503356063within(real,one_one(real),set_ord_lessThan(real,one_one(real)))) ).

% artanh_real_at_left_1
tff(fact_6409_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,at_top(real),F3)
     => filterlim(A,real,aTP_Lamp_ws(fun(A,real),fun(A,real),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ).

% tendsto_inverse_0_at_top
tff(fact_6410_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F2)
         => ? [K8: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K8)
              & ! [X4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X4)),K8)) ) ) ) ).

% bounded_linear.pos_bounded
tff(fact_6411_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),K5: real] :
          ( ! [X3: A,Y4: A] : ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),Y4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) )
         => ( ! [R: real,X3: A] : ( aa(A,B,F2,aa(A,A,real_V8093663219630862766scaleR(A,R),X3)) = aa(B,B,real_V8093663219630862766scaleR(B,R),aa(A,B,F2,X3)) )
           => ( ! [X3: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F2,X3))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),K5))
             => real_V3181309239436604168linear(A,B,F2) ) ) ) ) ).

% bounded_linear_intro
tff(fact_6412_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_infinity(A)) ) ).

% tendsto_inverse_0
tff(fact_6413_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_top(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wt(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
tff(fact_6414_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_top(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
tff(fact_6415_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F2: fun(A,real),F3: filter(A)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),S),zero_zero(real))
     => ( filterlim(A,real,F2,at_top(real),F3)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wv(real,fun(fun(A,real),fun(A,real)),S),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% tendsto_neg_powr
tff(fact_6416_tendsto__mult__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F2: fun(A,B),C2: B,F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,C2),F3)
         => ( ( C2 != zero_zero(B) )
           => ( filterlim(A,B,G,at_infinity(B),F3)
             => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ww(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),at_infinity(B),F3) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
tff(fact_6417_ln__x__over__x__tendsto__0,axiom,
    filterlim(real,real,aTP_Lamp_wx(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% ln_x_over_x_tendsto_0
tff(fact_6418_tendsto__divide__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F2: fun(A,B),C2: B,F3: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,C2),F3)
         => ( filterlim(A,B,G,at_infinity(B),F3)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_wy(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% tendsto_divide_0
tff(fact_6419_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F2: fun(A,B),F3: filter(A),Na: nat] :
          ( filterlim(A,B,F2,at_infinity(B),F3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_wz(fun(A,B),fun(nat,fun(A,B)),F2),Na),at_infinity(B),F3) ) ) ) ).

% filterlim_power_at_infinity
tff(fact_6420_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),at_infinity(A),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% filterlim_inverse_at_infinity
tff(fact_6421_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: fun(A,real),A2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,A2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
         => ( eventually(A,aTP_Lamp_wj(fun(A,real),fun(A,$o),G),F3)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wr(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_top(real),F3) ) ) ) ) ).

% LIM_at_top_divide
tff(fact_6422_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => ( eventually(A,aTP_Lamp_wj(fun(A,real),fun(A,$o),F2),F3)
       => filterlim(A,real,aTP_Lamp_ws(fun(A,real),fun(A,real),F2),at_top(real),F3) ) ) ).

% filterlim_inverse_at_top
tff(fact_6423_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( eventually(A,aTP_Lamp_wj(fun(A,real),fun(A,$o),F2),F3)
     => ( filterlim(A,real,aTP_Lamp_ws(fun(A,real),fun(A,real),F2),at_top(real),F3)
      <=> filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% filterlim_inverse_at_top_iff
tff(fact_6424_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( eventually(A,aTP_Lamp_wj(fun(A,real),fun(A,$o),F2),F3)
     => ( filterlim(A,real,F2,at_top(real),F3)
      <=> filterlim(A,real,aa(fun(A,real),fun(A,real),comp(real,real,A,inverse_inverse(real)),F2),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% filterlim_at_top_iff_inverse_0
tff(fact_6425_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P3: fun(A,$o)] :
          ( eventually(A,P3,at_infinity(A))
        <=> ? [B7: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B7)
              & ! [X5: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B7),real_V7770717601297561774m_norm(A,X5))
                 => aa(A,$o,P3,X5) ) ) ) ) ).

% eventually_at_infinity_pos
tff(fact_6426_tendsto__power__div__exp__0,axiom,
    ! [K: nat] : filterlim(real,real,aTP_Lamp_xa(nat,fun(real,real),K),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% tendsto_power_div_exp_0
tff(fact_6427_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [G: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,aTP_Lamp_sw(fun(A,B),fun(A,B),G),topolo174197925503356063within(B,zero_zero(B),top_top(set(B))),F3)
        <=> filterlim(A,B,G,at_infinity(B),F3) ) ) ).

% filterlim_inverse_at_iff
tff(fact_6428_lhopital,axiom,
    ! [F2: fun(real,real),X: real,G: fun(real,real),G2: fun(real,real),F7: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X,top_top(set(real))))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X,top_top(set(real))))
       => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,X,top_top(set(real))))
         => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X,top_top(set(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,X,top_top(set(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X,top_top(set(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),F3,topolo174197925503356063within(real,X,top_top(set(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xb(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),F3,topolo174197925503356063within(real,X,top_top(set(real)))) ) ) ) ) ) ) ) ).

% lhopital
tff(fact_6429_lhopital__left,axiom,
    ! [F2: fun(real,real),X: real,G: fun(real,real),G2: fun(real,real),F7: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
       => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
         => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),F3,topolo174197925503356063within(real,X,set_ord_lessThan(real,X)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xb(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),F3,topolo174197925503356063within(real,X,set_ord_lessThan(real,X))) ) ) ) ) ) ) ) ).

% lhopital_left
tff(fact_6430_tendsto__exp__limit__at__top,axiom,
    ! [X: real] : filterlim(real,real,aTP_Lamp_xc(real,fun(real,real),X),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X)),at_top(real)) ).

% tendsto_exp_limit_at_top
tff(fact_6431_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),C2: A,F3: filter(A),G: fun(A,A)] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,C2),F3)
         => ( filterlim(A,A,G,topolo174197925503356063within(A,zero_zero(A),top_top(set(A))),F3)
           => ( ( C2 != zero_zero(A) )
             => filterlim(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_oo(fun(A,A),fun(fun(A,A),fun(A,A)),F2),G),at_infinity(A),F3) ) ) ) ) ).

% filterlim_divide_at_infinity
tff(fact_6432_filterlim__tan__at__left,axiom,
    filterlim(real,real,tan(real),at_top(real),topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),set_ord_lessThan(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))))) ).

% filterlim_tan_at_left
tff(fact_6433_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S: set(A)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S))
        <=> ( real_V3181309239436604168linear(A,B,F7)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_xd(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F2),F7),X),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_iff_norm
tff(fact_6434_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: fun(real,real),Flim: real] :
      ( ! [X3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),X3)
         => ? [Y3: real] :
              ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),zero_zero(real)) ) )
     => ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,Flim),at_top(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Flim),aa(real,real,F2,B2)) ) ) ).

% DERIV_neg_imp_decreasing_at_top
tff(fact_6435_tendsto__arctan__at__top,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),at_top(real)) ).

% tendsto_arctan_at_top
tff(fact_6436_filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [C2: real,F2: fun(A,B),F3: filter(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),C2)
         => ( filterlim(A,B,F2,at_infinity(B),F3)
          <=> ! [R5: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),R5)
               => eventually(A,aa(real,fun(A,$o),aTP_Lamp_xe(fun(A,B),fun(real,fun(A,$o)),F2),R5),F3) ) ) ) ) ).

% filterlim_at_infinity
tff(fact_6437_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [X: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,X))
         => filterlim(nat,A,aa(A,fun(nat,A),power_power(A),X),at_infinity(A),at_top(nat)) ) ) ).

% filterlim_realpow_sequentially_gt1
tff(fact_6438_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),L: A] :
          ( filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,L),at_infinity(A))
        <=> filterlim(A,A,aa(fun(A,A),fun(A,A),comp(A,A,A,F2),inverse_inverse(A)),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% lim_at_infinity_0
tff(fact_6439_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F7: fun(A,B),X: A,F2: fun(A,B),S: set(A)] :
          ( real_V3181309239436604168linear(A,B,F7)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_xf(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),F7),X),F2),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X,S))
           => has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivativeI
tff(fact_6440_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S: set(A)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S))
        <=> ( real_V3181309239436604168linear(A,B,F7)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_xg(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F2),F7),X),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_at_within
tff(fact_6441_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),L: A] :
          ( filterlim(A,A,aTP_Lamp_xh(fun(A,A),fun(A,A),F2),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,A,F2,topolo7230453075368039082e_nhds(A,L),at_infinity(A)) ) ) ).

% lim_zero_infinity
tff(fact_6442_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F7)
            & ? [E3: fun(A,B)] :
                ( ! [H4: A] : ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),H4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X)),aa(A,B,F7,H4))),aa(A,B,E3,H4)) )
                & filterlim(A,real,aTP_Lamp_xi(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% has_derivative_iff_Ex
tff(fact_6443_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S: set(A)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S))
        <=> ( real_V3181309239436604168linear(A,B,F7)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_wi(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F2),F7),X),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,X,S)) ) ) ) ).

% has_derivative_within
tff(fact_6444_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),D5: fun(A,B),X: A] :
          ( has_derivative(A,B,F2,D5,topolo174197925503356063within(A,X,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,D5)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_xj(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F2),D5),X),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% has_derivative_at
tff(fact_6445_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),F3: filter(A)] :
          ( has_derivative(A,B,F2,F7,F3)
        <=> ( real_V3181309239436604168linear(A,B,F7)
            & filterlim(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_xl(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),F2),F7),F3),topolo7230453075368039082e_nhds(B,zero_zero(B)),F3) ) ) ) ).

% has_derivative_def
tff(fact_6446_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [X: A,S3: set(A),F2: fun(A,B),F7: fun(A,B)] :
          ( member(A,X,S3)
         => ( topolo1002775350975398744n_open(A,S3)
           => ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S3))
            <=> ( real_V3181309239436604168linear(A,B,F7)
                & ? [E3: fun(A,B)] :
                    ( ! [H4: A] :
                        ( member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),H4),S3)
                       => ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),H4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X)),aa(A,B,F7,H4))),aa(A,B,E3,H4)) ) )
                    & filterlim(A,real,aTP_Lamp_xi(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
tff(fact_6447_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [A3: set(A),X: A] :
          ( topolo1002775350975398744n_open(A,A3)
         => ( ! [X3: A] :
                ( member(A,X3,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X3) )
           => ~ member(A,complete_Inf_Inf(A,A3),A3) ) ) ) ).

% Inf_notin_open
tff(fact_6448_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [A3: set(A),X: A] :
          ( topolo1002775350975398744n_open(A,A3)
         => ( ! [X3: A] :
                ( member(A,X3,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),X) )
           => ~ member(A,complete_Sup_Sup(A,A3),A3) ) ) ) ).

% Sup_notin_open
tff(fact_6449_open__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S3: set(A),X: A,Y: A] :
          ( topolo1002775350975398744n_open(A,S3)
         => ( member(A,X,S3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
             => ? [B4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B4)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,X,B4)),S3) ) ) ) ) ) ).

% open_right
tff(fact_6450_open__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S3: set(A),X: A,Y: A] :
          ( topolo1002775350975398744n_open(A,S3)
         => ( member(A,X,S3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
             => ? [B4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B4),X)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,B4,X)),S3) ) ) ) ) ) ).

% open_left
tff(fact_6451_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo1002775350975398744n_open(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_xm(product_prod(A,A),$o))) ) ).

% open_superdiagonal
tff(fact_6452_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo1002775350975398744n_open(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_xn(product_prod(A,A),$o))) ) ).

% open_subdiagonal
tff(fact_6453_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: filter(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( topolo3448309680560233919inuous(A,B,F3,G)
           => ( ( aa(A,B,G,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,F3,aa(fun(A,B),fun(A,B),aTP_Lamp_rk(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% continuous_divide
tff(fact_6454_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F3: filter(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aTP_Lamp_rm(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_inverse
tff(fact_6455_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: filter(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aTP_Lamp_rn(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_sgn
tff(fact_6456_continuous__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( topolo3448309680560233919inuous(A,real,F3,G)
           => ( ( aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,F3,aa(fun(A,real),fun(A,real),aTP_Lamp_tq(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ).

% continuous_powr
tff(fact_6457_continuous__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( ( aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_tr(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_ln
tff(fact_6458_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: filter(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F3,F2)
         => ( ( cos(A,aa(A,A,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xp(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F3,aTP_Lamp_ro(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_tan
tff(fact_6459_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: filter(A),F2: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F3,F2)
         => ( ( sin(A,aa(A,A,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xp(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F3,aTP_Lamp_rp(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_cot
tff(fact_6460_continuous__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: filter(A),F2: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( cosh(B,aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A)))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aTP_Lamp_rq(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_tanh
tff(fact_6461_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))))
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_vz(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_arcosh
tff(fact_6462_tendsto__offset__zero__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C)
        & zero(A) )
     => ! [A2: B,S3: set(B),F2: fun(B,C),L4: C] :
          ( nO_MATCH(A,B,zero_zero(A),A2)
         => ( member(B,A2,S3)
           => ( topolo1002775350975398744n_open(B,S3)
             => ( filterlim(B,C,F2,topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,A2,S3))
              <=> filterlim(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_tm(B,fun(fun(B,C),fun(B,C)),A2),F2),topolo7230453075368039082e_nhds(C,L4),topolo174197925503356063within(B,zero_zero(B),top_top(set(B)))) ) ) ) ) ) ).

% tendsto_offset_zero_iff
tff(fact_6463_continuous__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( topolo3448309680560233919inuous(A,real,F3,G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))))
             => ( ( aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))))
                 => topolo3448309680560233919inuous(A,real,F3,aa(fun(A,real),fun(A,real),aTP_Lamp_tw(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% continuous_log
tff(fact_6464_continuous__artanh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F3: filter(A),F2: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F3,F2)
         => ( member(real,aa(A,real,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)))
           => topolo3448309680560233919inuous(A,real,F3,aTP_Lamp_xq(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_artanh
tff(fact_6465_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [E2: real,F7: fun(A,B),S: set(A),X: A,F2: fun(A,B),H5: fun(A,real)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
         => ( real_V3181309239436604168linear(A,B,F7)
           => ( ! [Y4: A] :
                  ( member(A,Y4,S)
                 => ( ( Y4 != X )
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y4,X)),E2)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,Y4)),aa(A,B,F2,X))),aa(A,B,F7,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),X))))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y4),X)))),aa(A,real,H5,Y4)) ) ) )
             => ( filterlim(A,real,H5,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,X,S))
               => has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S)) ) ) ) ) ) ).

% has_derivativeI_sandwich
tff(fact_6466_filterlim__pow__at__bot__even,axiom,
    ! [Na: nat,F2: fun(real,real),F3: filter(real)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( filterlim(real,real,F2,at_bot(real),F3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xr(nat,fun(fun(real,real),fun(real,real)),Na),F2),at_top(real),F3) ) ) ) ).

% filterlim_pow_at_bot_even
tff(fact_6467_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [B2: A,A2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel2
tff(fact_6468_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel
tff(fact_6469_dist__self,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A] : ( real_V557655796197034286t_dist(A,X,X) = zero_zero(real) ) ) ).

% dist_self
tff(fact_6470_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Y: A] :
          ( ( real_V557655796197034286t_dist(A,X,Y) = zero_zero(real) )
        <=> ( X = Y ) ) ) ).

% dist_eq_0_iff
tff(fact_6471_dist__0__norm,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] : ( real_V557655796197034286t_dist(A,zero_zero(A),X) = real_V7770717601297561774m_norm(A,X) ) ) ).

% dist_0_norm
tff(fact_6472_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X,Y))
        <=> ( X != Y ) ) ) ).

% zero_less_dist_iff
tff(fact_6473_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,X,Y)),zero_zero(real))
        <=> ( X = Y ) ) ) ).

% dist_le_zero_iff
tff(fact_6474_dist__diff_I1_J,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : ( real_V557655796197034286t_dist(A,A2,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = real_V7770717601297561774m_norm(A,B2) ) ) ).

% dist_diff(1)
tff(fact_6475_dist__diff_I2_J,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),A2) = real_V7770717601297561774m_norm(A,B2) ) ) ).

% dist_diff(2)
tff(fact_6476_dist__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: real,A2: A,Y: real] : ( real_V557655796197034286t_dist(A,aa(A,A,real_V8093663219630862766scaleR(A,X),A2),aa(A,A,real_V8093663219630862766scaleR(A,Y),A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y))),real_V7770717601297561774m_norm(A,A2)) ) ) ).

% dist_scaleR
tff(fact_6477_open__ball,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,D2: real] : topolo1002775350975398744n_open(A,collect(A,aa(real,fun(A,$o),aTP_Lamp_xs(A,fun(real,fun(A,$o)),X),D2))) ) ).

% open_ball
tff(fact_6478_dist__complex__def,axiom,
    ! [X: complex,Y: complex] : ( real_V557655796197034286t_dist(complex,X,Y) = real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),X),Y)) ) ).

% dist_complex_def
tff(fact_6479_dist__real__def,axiom,
    ! [X: real,Y: real] : ( real_V557655796197034286t_dist(real,X,Y) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y)) ) ).

% dist_real_def
tff(fact_6480_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X: A] : ( real_V7770717601297561774m_norm(A,X) = real_V557655796197034286t_dist(A,X,zero_zero(A)) ) ) ).

% norm_conv_dist
tff(fact_6481_dist__norm,axiom,
    ! [A: $tType] :
      ( real_V6936659425649961206t_norm(A)
     => ! [X: A,Y: A] : ( real_V557655796197034286t_dist(A,X,Y) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) ) ) ).

% dist_norm
tff(fact_6482_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X,Y)) ) ) ).

% dist_pos_lt
tff(fact_6483_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Y: A] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,Y)),zero_zero(real)) ) ).

% dist_not_less_zero
tff(fact_6484_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Y: A,X: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y,X)),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,Y)),E2) ) ) ).

% dist_commute_lessI
tff(fact_6485_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Z: A,Y: A,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,X,Z)),real_V557655796197034286t_dist(A,Y,Z))),E2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,Y)),E2) ) ) ).

% dist_triangle_lt
tff(fact_6486_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,Y: A,E1: real,X2: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,Y)),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X2,Y)),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% dist_triangle_less_add
tff(fact_6487_zero__le__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),real_V557655796197034286t_dist(A,X,Y)) ) ).

% zero_le_dist
tff(fact_6488_open__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S3: set(A)] :
          ( topolo1002775350975398744n_open(A,S3)
        <=> ! [X5: A] :
              ( member(A,X5,S3)
             => ? [E3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
                  & ! [Y5: A] :
                      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y5,X5)),E3)
                     => member(A,Y5,S3) ) ) ) ) ) ).

% open_dist
tff(fact_6489_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [A2: A,B2: A,C2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V557655796197034286t_dist(A,A2,B2)),real_V557655796197034286t_dist(A,B2,C2)))),real_V557655796197034286t_dist(A,A2,C2)) ) ).

% abs_dist_diff_le
tff(fact_6490_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & no_bot(A) )
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_bot(A))
        <=> ? [N5: A] :
            ! [N4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N4),N5)
             => aa(A,$o,P,N4) ) ) ) ).

% eventually_at_bot_dense
tff(fact_6491_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [G: fun(A,B),G4: filter(B),X: A,S3: set(A),F3: filter(B),D2: real,F2: fun(A,B)] :
          ( filterlim(A,B,G,G4,topolo174197925503356063within(A,X,S3))
         => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),G4),F3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
             => ( ! [X9: A] :
                    ( member(A,X9,S3)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X9,X))
                     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X9,X)),D2)
                       => ( aa(A,B,F2,X9) = aa(A,B,G,X9) ) ) ) )
               => filterlim(A,B,F2,F3,topolo174197925503356063within(A,X,S3)) ) ) ) ) ) ).

% filterlim_transform_within
tff(fact_6492_eventually__at,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A,S3: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S3))
        <=> ? [D3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
              & ! [X5: A] :
                  ( member(A,X5,S3)
                 => ( ( ( X5 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X5,A2)),D3) )
                   => aa(A,$o,P,X5) ) ) ) ) ) ).

% eventually_at
tff(fact_6493_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo7230453075368039082e_nhds(A,A2))
        <=> ? [D3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
              & ! [X5: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X5,A2)),D3)
                 => aa(A,$o,P,X5) ) ) ) ) ).

% eventually_nhds_metric
tff(fact_6494_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),F7: A,A2: A,S3: set(A),D2: real,G: fun(A,A)] :
          ( has_field_derivative(A,F2,F7,topolo174197925503356063within(A,A2,S3))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( member(A,A2,S3)
             => ( ! [X3: A] :
                    ( member(A,X3,S3)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),D2)
                     => ( aa(A,A,F2,X3) = aa(A,A,G,X3) ) ) )
               => has_field_derivative(A,G,F7,topolo174197925503356063within(A,A2,S3)) ) ) ) ) ) ).

% has_field_derivative_transform_within
tff(fact_6495_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F7: fun(A,B),X: A,S: set(A),D2: real,G: fun(A,B)] :
          ( has_derivative(A,B,F2,F7,topolo174197925503356063within(A,X,S))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( member(A,X,S)
             => ( ! [X9: A] :
                    ( member(A,X9,S)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X9,X)),D2)
                     => ( aa(A,B,F2,X9) = aa(A,B,G,X9) ) ) )
               => has_derivative(A,B,G,F7,topolo174197925503356063within(A,X,S)) ) ) ) ) ) ).

% has_derivative_transform_within
tff(fact_6496_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [C2: A] : eventually(A,aTP_Lamp_xt(A,fun(A,$o),C2),at_bot(A)) ) ).

% eventually_gt_at_bot
tff(fact_6497_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M4)
                 => ! [N: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),N)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M4),aa(nat,A,X7,N))),E) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% metric_CauchyI
tff(fact_6498_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),E2: real] :
          ( topolo3814608138187158403Cauchy(A,X7)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => ? [M8: nat] :
              ! [M2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M2)
               => ! [N6: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N6)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M2),aa(nat,A,X7,N6))),E2) ) ) ) ) ) ).

% metric_CauchyD
tff(fact_6499_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,S)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [N5: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N5),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,S,N4),aa(nat,A,S,N5))),E3) ) ) ) ) ).

% Cauchy_altdef2
tff(fact_6500_Cauchy__def,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M7: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M3)
                 => ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M3),aa(nat,A,X7,N4))),E3) ) ) ) ) ) ).

% Cauchy_def
tff(fact_6501_dist__of__int,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [M: int,Na: int] : ( real_V557655796197034286t_dist(A,aa(int,A,ring_1_of_int(A),M),aa(int,A,ring_1_of_int(A),Na)) = aa(int,real,ring_1_of_int(real),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),Na))) ) ) ).

% dist_of_int
tff(fact_6502_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),L: B,X: A,S3: set(A),D2: real,G: fun(A,B)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,X,S3))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( ! [X9: A] :
                  ( member(A,X9,S3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X9,X))
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X9,X)),D2)
                     => ( aa(A,B,F2,X9) = aa(A,B,G,X9) ) ) ) )
             => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,X,S3)) ) ) ) ) ).

% Lim_transform_within
tff(fact_6503_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Y: A,X15: A,E2: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y,X15)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y,X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X2)),E2) ) ) ) ).

% dist_triangle_half_r
tff(fact_6504_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,Y: A,E2: real,X2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X2,Y)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X2)),E2) ) ) ) ).

% dist_triangle_half_l
tff(fact_6505_eventually__at__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A,S3: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S3))
        <=> ? [D3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
              & ! [X5: A] :
                  ( member(A,X5,S3)
                 => ( ( ( X5 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,X5,A2)),D3) )
                   => aa(A,$o,P,X5) ) ) ) ) ) ).

% eventually_at_le
tff(fact_6506_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X15: A,X2: A,E2: real,X32: A,X42: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X2)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X2,X32)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X32,X42)),aa(real,real,aa(real,fun(real,real),divide_divide(real),E2),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))))
             => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X15,X42)),E2) ) ) ) ) ).

% dist_triangle_third
tff(fact_6507_exp__at__bot,axiom,
    filterlim(real,real,exp(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_bot(real)) ).

% exp_at_bot
tff(fact_6508_CauchyI_H,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M4)
                 => ! [N: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M4),aa(nat,A,X7,N))),E) ) ) )
         => topolo3814608138187158403Cauchy(A,X7) ) ) ).

% CauchyI'
tff(fact_6509_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F2: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,F2)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M7: nat] :
                ! [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M3)
                 => ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,F2,M3),aa(nat,A,F2,N4))),E3) ) ) ) ) ) ).

% Cauchy_altdef
tff(fact_6510_dist__of__nat,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [M: nat,Na: nat] : ( real_V557655796197034286t_dist(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),Na)) = aa(int,real,ring_1_of_int(real),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na)))) ) ) ).

% dist_of_nat
tff(fact_6511_tendstoD,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A),E2: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
           => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_xu(fun(A,B),fun(B,fun(real,fun(A,$o))),F2),L),E2),F3) ) ) ) ).

% tendstoD
tff(fact_6512_tendstoI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( ! [E: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
             => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_xu(fun(A,B),fun(B,fun(real,fun(A,$o))),F2),L),E),F3) )
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3) ) ) ).

% tendstoI
tff(fact_6513_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_xu(fun(A,B),fun(B,fun(real,fun(A,$o))),F2),L),E3),F3) ) ) ) ).

% tendsto_iff
tff(fact_6514_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),L: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),F3)
        <=> filterlim(A,real,aa(B,fun(A,real),aTP_Lamp_xv(fun(A,B),fun(B,fun(A,real)),F2),L),topolo7230453075368039082e_nhds(real,zero_zero(real)),F3) ) ) ).

% tendsto_dist_iff
tff(fact_6515_filterlim__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( filterlim(A,B,F2,at_bot(B),F3)
        <=> ! [Z6: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_xw(fun(A,B),fun(B,fun(A,$o)),F2),Z6),F3) ) ) ).

% filterlim_at_bot_dense
tff(fact_6516_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F2: fun(A,B),L4: B,A2: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S5)
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X5,A2)),S5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X5),L4)),R5) ) ) ) ) ) ).

% LIM_def
tff(fact_6517_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F2: fun(A,B),L4: B,A2: A,R2: real] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => ? [S2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S2)
                & ! [X4: A] :
                    ( ( ( X4 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),S2) )
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X4),L4)),R2) ) ) ) ) ) ).

% metric_LIM_D
tff(fact_6518_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [A2: A,F2: fun(A,B),L4: B] :
          ( ! [R: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),S6) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X3),L4)),R) ) ) )
         => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% metric_LIM_I
tff(fact_6519_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [G: fun(A,B),L: B,A2: A,R3: real,F2: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R3)
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),R3)
                   => ( aa(A,B,F2,X3) = aa(A,B,G,X3) ) ) )
             => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_equal2
tff(fact_6520_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A,R2: real] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => ? [No3: nat] :
              ! [N6: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N6)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N6),L4)),R2) ) ) ) ) ).

% metric_LIMSEQ_D
tff(fact_6521_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( ! [R: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
             => ? [No2: nat] :
                ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No2),N)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N),L4)),R) ) )
         => filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat)) ) ) ).

% metric_LIMSEQ_I
tff(fact_6522_lim__sequentially,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N4),L4)),R5) ) ) ) ) ).

% lim_sequentially
tff(fact_6523_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X7)
        <=> ! [J: nat] :
            ? [M7: nat] :
            ! [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M3)
             => ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N4)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,M3),aa(nat,A,X7,N4))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J)))) ) ) ) ) ).

% metric_Cauchy_iff2
tff(fact_6524_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F2: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),D6) )
                     => ( aa(A,B,F2,X3) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_xx(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_compose2
tff(fact_6525_tanh__real__at__bot,axiom,
    filterlim(real,real,tanh(real),topolo7230453075368039082e_nhds(real,aa(real,real,uminus_uminus(real),one_one(real))),at_bot(real)) ).

% tanh_real_at_bot
tff(fact_6526_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_bot(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_bot(real),F3) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
tff(fact_6527_filterlim__inverse__at__bot__neg,axiom,
    filterlim(real,real,inverse_inverse(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),set_ord_lessThan(real,zero_zero(real)))) ).

% filterlim_inverse_at_bot_neg
tff(fact_6528_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,at_infinity(real),F3)
     => ( eventually(A,aTP_Lamp_xy(fun(A,real),fun(A,$o),F2),F3)
       => filterlim(A,real,F2,at_bot(real),F3) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
tff(fact_6529_filterlim__at__bot__lt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F2: fun(A,B),F3: filter(A),C2: B] :
          ( filterlim(A,B,F2,at_bot(B),F3)
        <=> ! [Z6: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z6),C2)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_xz(fun(A,B),fun(B,fun(A,$o)),F2),Z6),F3) ) ) ) ).

% filterlim_at_bot_lt
tff(fact_6530_metric__isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F2: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F2)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F2,A2),top_top(set(B))))
           => ( ? [D6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),D6) )
                     => ( aa(A,B,F2,X3) != aa(A,B,F2,A2) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_xx(fun(A,B),fun(fun(B,C),fun(A,C)),F2),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_isCont_LIM_compose2
tff(fact_6531_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),F3: filter(A)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),F3)
     => ( eventually(A,aTP_Lamp_xy(fun(A,real),fun(A,$o),F2),F3)
       => filterlim(A,real,aTP_Lamp_ws(fun(A,real),fun(A,real),F2),at_bot(real),F3) ) ) ).

% filterlim_inverse_at_bot
tff(fact_6532_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: fun(A,real),C2: real,F3: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F2,topolo7230453075368039082e_nhds(real,C2),F3)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
       => ( filterlim(A,real,G,at_top(real),F3)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wu(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G),at_bot(real),F3) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
tff(fact_6533_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),L4: A] :
          ( filterlim(nat,A,X7,topolo7230453075368039082e_nhds(A,L4),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),No)
                  & ! [N4: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No),N4)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X7,N4),L4)),R5) ) ) ) ) ) ).

% LIMSEQ_iff_nz
tff(fact_6534_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: fun(real,real),Flim: real] :
      ( ! [X3: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2)
         => ? [Y3: real] :
              ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3) ) )
     => ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,Flim),at_bot(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Flim),aa(real,real,F2,B2)) ) ) ).

% DERIV_pos_imp_increasing_at_bot
tff(fact_6535_filterlim__pow__at__bot__odd,axiom,
    ! [Na: nat,F2: fun(real,real),F3: filter(real)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( filterlim(real,real,F2,at_bot(real),F3)
       => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Na)
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xr(nat,fun(fun(real,real),fun(real,real)),Na),F2),at_bot(real),F3) ) ) ) ).

% filterlim_pow_at_bot_odd
tff(fact_6536_tendsto__arctan__at__bot,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),at_bot(real)) ).

% tendsto_arctan_at_bot
tff(fact_6537_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S3: set(A)] :
          ( topolo6688025880775521714ounded(A,S3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [K3: set(A)] :
                  ( aa(set(A),$o,finite_finite(A),K3)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S3),complete_Sup_Sup(set(A),image(A,set(A),aTP_Lamp_yb(real,fun(A,set(A)),E3),K3))) ) ) ) ) ).

% totally_bounded_metric
tff(fact_6538_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( bfun(A,B,F2,F3)
        <=> ? [Y5: B,K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_yc(fun(A,B),fun(B,fun(real,fun(A,$o))),F2),Y5),K6),F3) ) ) ) ).

% Bfun_metric_def
tff(fact_6539_less__filter__def,axiom,
    ! [A: $tType,F3: filter(A),F8: filter(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less(filter(A)),F3),F8)
    <=> ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F3),F8)
        & ~ aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F8),F3) ) ) ).

% less_filter_def
tff(fact_6540_Bseq__add,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( bfun(nat,A,F2,at_top(nat))
         => bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_yd(fun(nat,A),fun(A,fun(nat,A)),F2),C2),at_top(nat)) ) ) ).

% Bseq_add
tff(fact_6541_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_yd(fun(nat,A),fun(A,fun(nat,A)),F2),C2),at_top(nat))
        <=> bfun(nat,A,F2,at_top(nat)) ) ) ).

% Bseq_add_iff
tff(fact_6542_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(nat,A)] :
          ( bfun(nat,A,aTP_Lamp_bc(fun(nat,A),fun(nat,A),F2),at_top(nat))
        <=> bfun(nat,A,F2,at_top(nat)) ) ) ).

% Bseq_Suc_iff
tff(fact_6543_Bseq__offset,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),K: nat] :
          ( bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ye(fun(nat,A),fun(nat,fun(nat,A)),X7),K),at_top(nat))
         => bfun(nat,A,X7,at_top(nat)) ) ) ).

% Bseq_offset
tff(fact_6544_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X7: fun(nat,A),K: nat] :
          ( bfun(nat,A,X7,at_top(nat))
         => bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ye(fun(nat,A),fun(nat,fun(nat,A)),X7),K),at_top(nat)) ) ) ).

% Bseq_ignore_initial_segment
tff(fact_6545_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(A,fun(fun(nat,A),fun(nat,A)),C2),F2),at_top(nat))
          <=> bfun(nat,A,F2,at_top(nat)) ) ) ) ).

% Bseq_cmult_iff
tff(fact_6546_BseqD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => ? [K8: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K8)
              & ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N6))),K8) ) ) ) ).

% BseqD
tff(fact_6547_BseqE,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
         => ~ ! [K8: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K8)
               => ~ ! [N6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N6))),K8) ) ) ) ).

% BseqE
tff(fact_6548_BseqI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [K5: real,X7: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
         => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N))),K5)
           => bfun(nat,A,X7,at_top(nat)) ) ) ) ).

% BseqI
tff(fact_6549_Bseq__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N4))),K6) ) ) ) ).

% Bseq_def
tff(fact_6550_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [N5: nat] :
            ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% Bseq_iff1a
tff(fact_6551_Bseq__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [N5: nat] :
            ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X7,N4))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N5))) ) ) ).

% Bseq_iff
tff(fact_6552_Bseq__realpow,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => bfun(nat,real,aa(real,fun(nat,real),power_power(real),X),at_top(nat)) ) ) ).

% Bseq_realpow
tff(fact_6553_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K3)
              & ? [N5: nat] :
                ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X7,N4)),aa(A,A,uminus_uminus(A),aa(nat,A,X7,N5))))),K3) ) ) ) ).

% Bseq_iff3
tff(fact_6554_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X7: fun(nat,A)] :
          ( bfun(nat,A,X7,at_top(nat))
        <=> ? [K3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K3)
              & ? [X5: A] :
                ! [N4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X7,N4)),aa(A,A,uminus_uminus(A),X5)))),K3) ) ) ) ).

% Bseq_iff2
tff(fact_6555_Bfun__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( ( A2 != zero_zero(B) )
           => bfun(A,B,aTP_Lamp_sw(fun(A,B),fun(A,B),F2),F3) ) ) ) ).

% Bfun_inverse
tff(fact_6556_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( bfun(A,B,F2,F3)
         => ~ ! [B8: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B8)
               => ~ eventually(A,aa(real,fun(A,$o),aTP_Lamp_yf(fun(A,B),fun(real,fun(A,$o)),F2),B8),F3) ) ) ) ).

% BfunE
tff(fact_6557_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( bfun(A,B,F2,F3)
        <=> ? [K6: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
              & eventually(A,aa(real,fun(A,$o),aTP_Lamp_yf(fun(A,B),fun(real,fun(A,$o)),F2),K6),F3) ) ) ) ).

% Bfun_def
tff(fact_6558_tendsto__exp__limit__at__right,axiom,
    ! [X: real] : filterlim(real,real,aTP_Lamp_yg(real,fun(real,real),X),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),X)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% tendsto_exp_limit_at_right
tff(fact_6559_filterlim__tan__at__right,axiom,
    filterlim(real,real,tan(real),at_bot(real),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),set_ord_greaterThan(real,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))))) ).

% filterlim_tan_at_right
tff(fact_6560_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I2: A,K: A] :
          ( member(A,I2,set_ord_greaterThan(A,K))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),I2) ) ) ).

% greaterThan_iff
tff(fact_6561_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),top_top(A))
         => ( complete_Sup_Sup(A,set_ord_greaterThan(A,X)) = top_top(A) ) ) ) ).

% Sup_greaterThanAtLeast
tff(fact_6562_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( set_ord_greaterThan(A,L) = collect(A,aa(A,fun(A,$o),ord_less(A),L)) ) ) ).

% greaterThan_def
tff(fact_6563_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [P: fun(A,$o),X: A] :
          ( eventually(A,P,topolo174197925503356063within(A,X,set_ord_greaterThan(A,X)))
        <=> ? [B7: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B7)
              & ! [Y5: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y5)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),B7)
                   => aa(A,$o,P,Y5) ) ) ) ) ) ).

% eventually_at_right_field
tff(fact_6564_eventually__at__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X: A,Y: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( eventually(A,P,topolo174197925503356063within(A,X,set_ord_greaterThan(A,X)))
          <=> ? [B7: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B7)
                & ! [Y5: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y5)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),B7)
                     => aa(A,$o,P,Y5) ) ) ) ) ) ) ).

% eventually_at_right
tff(fact_6565_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( topolo174197925503356063within(A,A2,set_or1337092689740270186AtMost(A,A2,B2)) = topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2)) ) ) ) ).

% at_within_Icc_at_right
tff(fact_6566_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( no_top(A)
        & topolo1944317154257567458pology(A) )
     => ! [X: A] : eventually(A,aa(A,fun(A,$o),ord_less(A),X),topolo174197925503356063within(A,X,set_ord_greaterThan(A,X))) ) ).

% eventually_at_right_less
tff(fact_6567_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( ! [X3: A] :
              ( member(A,X3,set_or5935395276787703475ssThan(A,A2,B2))
             => aa(A,$o,P,X3) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => eventually(A,P,topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2))) ) ) ) ).

% eventually_at_rightI
tff(fact_6568_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: fun(real,A),F3: filter(A),A2: real] :
      ( filterlim(real,A,F2,F3,topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2)))
    <=> filterlim(real,A,aa(real,fun(real,A),aTP_Lamp_yh(fun(real,A),fun(real,fun(real,A)),F2),A2),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% filterlim_at_right_to_0
tff(fact_6569_eventually__at__right__to__0,axiom,
    ! [P: fun(real,$o),A2: real] :
      ( eventually(real,P,topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2)))
    <=> eventually(real,aa(real,fun(real,$o),aTP_Lamp_yi(fun(real,$o),fun(real,fun(real,$o)),P),A2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% eventually_at_right_to_0
tff(fact_6570_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => eventually(real,aa(real,fun(real,$o),aTP_Lamp_wm(real,fun(real,fun(real,$o)),A2),B2),topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2))) ) ).

% eventually_at_right_real
tff(fact_6571_filterlim__times__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field(B)
        & topolo1944317154257567458pology(B) )
     => ! [F2: fun(A,B),P3: B,F12: filter(A),C2: B,L: B] :
          ( filterlim(A,B,F2,topolo174197925503356063within(B,P3,set_ord_greaterThan(B,P3)),F12)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => ( ( L = aa(B,B,aa(B,fun(B,B),times_times(B),C2),P3) )
             => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_yj(fun(A,B),fun(B,fun(A,B)),F2),C2),topolo174197925503356063within(B,L,set_ord_greaterThan(B,L)),F12) ) ) ) ) ).

% filterlim_times_pos
tff(fact_6572_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: fun(real,A),F3: filter(A)] :
      ( filterlim(real,A,F2,F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
    <=> filterlim(real,A,aTP_Lamp_yk(fun(real,A),fun(real,A),F2),F3,at_top(real)) ) ).

% filterlim_at_right_to_top
tff(fact_6573_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: fun(real,A),F3: filter(A)] :
      ( filterlim(real,A,F2,F3,at_top(real))
    <=> filterlim(real,A,aTP_Lamp_yk(fun(real,A),fun(real,A),F2),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% filterlim_at_top_to_right
tff(fact_6574_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F2: fun(A,B),L4: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,L4),F3)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_vr(fun(A,B),fun(B,fun(A,$o)),F2),L4),F3)
           => filterlim(A,B,F2,topolo174197925503356063within(B,L4,set_ord_greaterThan(B,L4)),F3) ) ) ) ).

% tendsto_imp_filterlim_at_right
tff(fact_6575_filterlim__inverse__at__right__top,axiom,
    filterlim(real,real,inverse_inverse(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))),at_top(real)) ).

% filterlim_inverse_at_right_top
tff(fact_6576_filterlim__inverse__at__top__right,axiom,
    filterlim(real,real,inverse_inverse(real),at_top(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% filterlim_inverse_at_top_right
tff(fact_6577_eventually__at__top__to__right,axiom,
    ! [P: fun(real,$o)] :
      ( eventually(real,P,at_top(real))
    <=> eventually(real,aTP_Lamp_yl(fun(real,$o),fun(real,$o),P),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% eventually_at_top_to_right
tff(fact_6578_eventually__at__right__to__top,axiom,
    ! [P: fun(real,$o)] :
      ( eventually(real,P,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
    <=> eventually(real,aTP_Lamp_yl(fun(real,$o),fun(real,$o),P),at_top(real)) ) ).

% eventually_at_right_to_top
tff(fact_6579_ln__at__0,axiom,
    filterlim(real,real,ln_ln(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% ln_at_0
tff(fact_6580_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F2: fun(A,B),P: fun(B,$o),G: fun(B,A),A2: A] :
          ( ! [X3: A,Y4: A] :
              ( aa(A,$o,Q,X3)
             => ( aa(A,$o,Q,Y4)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) ) ) )
         => ( ! [X3: B] :
                ( aa(B,$o,P,X3)
               => ( aa(A,B,F2,aa(B,A,G,X3)) = X3 ) )
           => ( ! [X3: B] :
                  ( aa(B,$o,P,X3)
                 => aa(A,$o,Q,aa(B,A,G,X3)) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2)))
               => ( ! [B4: A] :
                      ( aa(A,$o,Q,B4)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B4) )
                 => ( eventually(B,P,at_bot(B))
                   => filterlim(A,B,F2,at_bot(B),topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2))) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
tff(fact_6581_tendsto__arcosh__at__left__1,axiom,
    filterlim(real,real,arcosh(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,one_one(real),set_ord_greaterThan(real,one_one(real)))) ).

% tendsto_arcosh_at_left_1
tff(fact_6582_artanh__real__at__right__1,axiom,
    filterlim(real,real,artanh(real),at_bot(real),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),one_one(real)),set_ord_greaterThan(real,aa(real,real,uminus_uminus(real),one_one(real))))) ).

% artanh_real_at_right_1
tff(fact_6583_lhopital__right,axiom,
    ! [F2: fun(real,real),X: real,G: fun(real,real),G2: fun(real,real),F7: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F2,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
       => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
         => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),F3,topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xb(fun(real,real),fun(fun(real,real),fun(real,real)),F2),G),F3,topolo174197925503356063within(real,X,set_ord_greaterThan(real,X))) ) ) ) ) ) ) ) ).

% lhopital_right
tff(fact_6584_lhopital__right__0,axiom,
    ! [F0: fun(real,real),G0: fun(real,real),G2: fun(real,real),F7: fun(real,real),F3: filter(real)] :
      ( filterlim(real,real,F0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
     => ( filterlim(real,real,G0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
       => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G0),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
         => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F0),F7),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G0),G2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xb(fun(real,real),fun(fun(real,real),fun(real,real)),F0),G0),F3,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ) ) ) ) ) ) ).

% lhopital_right_0
tff(fact_6585_lhopital__right__0__at__top,axiom,
    ! [G: fun(real,real),G2: fun(real,real),F2: fun(real,real),F7: fun(real,real),X: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
     => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),topolo7230453075368039082e_nhds(real,X),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,X),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ) ) ) ) ).

% lhopital_right_0_at_top
tff(fact_6586_lhopital__right__at__top,axiom,
    ! [G: fun(real,real),X: real,G2: fun(real,real),F2: fun(real,real),F7: fun(real,real),Y: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
     => ( eventually(real,aTP_Lamp_wn(fun(real,real),fun(real,$o),G2),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),F2),F7),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G2),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G2),F7),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),G),F2),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,X,set_ord_greaterThan(real,X))) ) ) ) ) ) ).

% lhopital_right_at_top
tff(fact_6587_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ! [F4: fun(nat,A)] :
                ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(nat,A,F4,N6))
               => ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F4,N6)),B2)
                 => ( order_antimono(nat,A,F4)
                   => ( filterlim(nat,A,F4,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_ym(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F4),at_top(nat)) ) ) ) )
           => eventually(A,P,topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2))) ) ) ) ).

% sequentially_imp_eventually_at_right
tff(fact_6588_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist(A)
        & topolo7287701948861334536_space(A) )
     => ! [F3: filter(A)] :
          ( topolo6773858410816713723filter(A,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [P5: fun(A,$o)] :
                  ( eventually(A,P5,F3)
                  & ! [X5: A,Y5: A] :
                      ( ( aa(A,$o,P5,X5)
                        & aa(A,$o,P5,Y5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X5,Y5)),E3) ) ) ) ) ) ).

% cauchy_filter_metric
tff(fact_6589_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( order_antimono(nat,A,F2)
        <=> ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,aa(nat,nat,suc,N4))),aa(nat,A,F2,N4)) ) ) ).

% decseq_Suc_iff
tff(fact_6590_decseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,aa(nat,nat,suc,N))),aa(nat,A,X7,N))
         => order_antimono(nat,A,X7) ) ) ).

% decseq_SucI
tff(fact_6591_decseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: fun(nat,A),I2: nat] :
          ( order_antimono(nat,A,A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A3,aa(nat,nat,suc,I2))),aa(nat,A,A3,I2)) ) ) ).

% decseq_SucD
tff(fact_6592_greaterThan__0,axiom,
    set_ord_greaterThan(nat,zero_zero(nat)) = image(nat,nat,suc,top_top(set(nat))) ).

% greaterThan_0
tff(fact_6593_greaterThan__Suc,axiom,
    ! [K: nat] : ( set_ord_greaterThan(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_greaterThan(nat,K)),aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_6594_tendsto__at__right__sequentially,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,B2: A,X7: fun(A,B),L4: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( ! [S7: fun(nat,A)] :
                ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(nat,A,S7,N6))
               => ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,S7,N6)),B2)
                 => ( order_antimono(nat,A,S7)
                   => ( filterlim(nat,A,S7,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_yn(fun(A,B),fun(fun(nat,A),fun(nat,B)),X7),S7),topolo7230453075368039082e_nhds(B,L4),at_top(nat)) ) ) ) )
           => filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2))) ) ) ) ).

% tendsto_at_right_sequentially
tff(fact_6595_GMVT,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),G: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X3: real] :
            ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),F2) )
       => ( ! [X3: real] :
              ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2) )
             => differentiable(real,real,F2,topolo174197925503356063within(real,X3,top_top(set(real)))) )
         => ( ! [X3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X3,top_top(set(real))),G) )
           => ( ! [X3: real] :
                  ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
                    & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2) )
                 => differentiable(real,real,G,topolo174197925503356063within(real,X3,top_top(set(real)))) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( has_field_derivative(real,G,G_c,topolo174197925503356063within(real,C3,top_top(set(real))))
                  & has_field_derivative(real,F2,F_c,topolo174197925503356063within(real,C3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),C3),B2)
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2))),G_c) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A2))),F_c) ) ) ) ) ) ) ) ).

% GMVT
tff(fact_6596_surj__int__encode,axiom,
    image(int,nat,nat_int_encode,top_top(set(int))) = top_top(set(nat)) ).

% surj_int_encode
tff(fact_6597_differentiable__cmult__left__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [C2: B,Q4: fun(A,B),T2: A] :
          ( differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_yo(B,fun(fun(A,B),fun(A,B)),C2),Q4),topolo174197925503356063within(A,T2,top_top(set(A))))
        <=> ( ( C2 = zero_zero(B) )
            | differentiable(A,B,Q4,topolo174197925503356063within(A,T2,top_top(set(A)))) ) ) ) ).

% differentiable_cmult_left_iff
tff(fact_6598_differentiable__cmult__right__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Q4: fun(A,B),C2: B,T2: A] :
          ( differentiable(A,B,aa(B,fun(A,B),aTP_Lamp_yp(fun(A,B),fun(B,fun(A,B)),Q4),C2),topolo174197925503356063within(A,T2,top_top(set(A))))
        <=> ( ( C2 = zero_zero(B) )
            | differentiable(A,B,Q4,topolo174197925503356063within(A,T2,top_top(set(A)))) ) ) ) ).

% differentiable_cmult_right_iff
tff(fact_6599_int__encode__eq,axiom,
    ! [X: int,Y: int] :
      ( ( aa(int,nat,nat_int_encode,X) = aa(int,nat,nat_int_encode,Y) )
    <=> ( X = Y ) ) ).

% int_encode_eq
tff(fact_6600_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F2,F3)
         => ( differentiable(A,B,G,F3)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qb(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),F3) ) ) ) ).

% differentiable_add
tff(fact_6601_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F2,F3)
         => ( differentiable(A,B,G,F3)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qe(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),F3) ) ) ) ).

% differentiable_diff
tff(fact_6602_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X: A,S: set(A),Na: nat] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X,S))
         => differentiable(A,B,aa(nat,fun(A,B),aTP_Lamp_qm(fun(A,B),fun(nat,fun(A,B)),F2),Na),topolo174197925503356063within(A,X,S)) ) ) ).

% differentiable_power
tff(fact_6603_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,X,S))
           => ( ( aa(A,B,G,X) != zero_zero(B) )
             => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qh(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),topolo174197925503356063within(A,X,S)) ) ) ) ) ).

% differentiable_divide
tff(fact_6604_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X: A,S: set(A)] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X,S))
         => ( ( aa(A,B,F2,X) != zero_zero(B) )
           => differentiable(A,B,aTP_Lamp_yq(fun(A,B),fun(A,B),F2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% differentiable_inverse
tff(fact_6605_bij__int__encode,axiom,
    bij_betw(int,nat,nat_int_encode,top_top(set(int)),top_top(set(nat))) ).

% bij_int_encode
tff(fact_6606_MVT,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
       => ( ! [X3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
               => differentiable(real,real,F2,topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
         => ? [L2: real,Z2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
              & has_field_derivative(real,F2,L2,topolo174197925503356063within(real,Z2,top_top(set(real))))
              & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),L2) ) ) ) ) ) ).

% MVT
tff(fact_6607_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: A,A2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( ! [F4: fun(nat,A)] :
                ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(nat,A,F4,N6))
               => ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F4,N6)),A2)
                 => ( order_mono(nat,A,F4)
                   => ( filterlim(nat,A,F4,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => eventually(nat,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_ym(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),P),F4),at_top(nat)) ) ) ) )
           => eventually(A,P,topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2))) ) ) ) ).

% sequentially_imp_eventually_at_left
tff(fact_6608_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X: A,Y: A] :
          ( order_mono(A,B,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y) ) ) ) ).

% mono_invE
tff(fact_6609_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X: A,Y: A] :
          ( order_mono(A,B,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ) ).

% mono_strict_invE
tff(fact_6610_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( aa(A,real,F2,X3) != zero_zero(real) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_yr(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_on_ln
tff(fact_6611_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_mono(nat,A,aTP_Lamp_ys(fun(A,A),fun(nat,A),Q)) ) ) ).

% mono_funpow
tff(fact_6612_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( aa(A,B,F2,X3) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_yt(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_on_sgn
tff(fact_6613_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( aa(A,B,F2,X3) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_yu(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_on_inverse
tff(fact_6614_continuous__on__power,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F2: fun(A,B),Na: nat] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => topolo81223032696312382ous_on(A,B,S,aa(nat,fun(A,B),aTP_Lamp_yv(fun(A,B),fun(nat,fun(A,B)),F2),Na)) ) ) ).

% continuous_on_power
tff(fact_6615_continuous__on__power_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,nat)] :
          ( topolo81223032696312382ous_on(A,B,A3,F2)
         => ( topolo81223032696312382ous_on(A,nat,A3,G)
           => topolo81223032696312382ous_on(A,B,A3,aa(fun(A,nat),fun(A,B),aTP_Lamp_yw(fun(A,B),fun(fun(A,nat),fun(A,B)),F2),G)) ) ) ) ).

% continuous_on_power'
tff(fact_6616_mono__pow,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),Na: nat] :
          ( order_mono(A,A,F2)
         => order_mono(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2)) ) ) ).

% mono_pow
tff(fact_6617_continuous__on__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [S: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_yx(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% continuous_on_diff
tff(fact_6618_continuous__on__op__minus,axiom,
    ! [A: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [S: set(A),X: A] : topolo81223032696312382ous_on(A,A,S,aa(A,fun(A,A),minus_minus(A),X)) ) ).

% continuous_on_op_minus
tff(fact_6619_mono__add,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A] : order_mono(A,A,aa(A,fun(A,A),plus_plus(A),A2)) ) ).

% mono_add
tff(fact_6620_continuous__on__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [S: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_yy(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% continuous_on_add
tff(fact_6621_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_yz(fun(A,real),fun(A,real),F2)) ) ) ).

% continuous_on_real_sqrt
tff(fact_6622_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),Na: nat] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => topolo81223032696312382ous_on(A,real,S,aa(nat,fun(A,real),aTP_Lamp_za(fun(A,real),fun(nat,fun(A,real)),F2),Na)) ) ) ).

% continuous_on_real_root
tff(fact_6623_mono__Suc,axiom,
    order_mono(nat,nat,suc) ).

% mono_Suc
tff(fact_6624_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => ( ! [X3: A] :
                  ( member(A,X3,S)
                 => ( aa(A,B,G,X3) != zero_zero(B) ) )
             => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_zb(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ) ).

% continuous_on_divide
tff(fact_6625_continuous__on__powr,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X3: A] :
                  ( member(A,X3,S)
                 => ( aa(A,real,F2,X3) != zero_zero(real) ) )
             => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_zc(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ).

% continuous_on_powr
tff(fact_6626_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( order_mono(nat,A,F2)
        <=> ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,N4)),aa(nat,A,F2,aa(nat,nat,suc,N4))) ) ) ).

% incseq_Suc_iff
tff(fact_6627_incseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X7: fun(nat,A)] :
          ( ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X7,N)),aa(nat,A,X7,aa(nat,nat,suc,N)))
         => order_mono(nat,A,X7) ) ) ).

% incseq_SucI
tff(fact_6628_incseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: fun(nat,A),I2: nat] :
          ( order_mono(nat,A,A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A3,I2)),aa(nat,A,A3,aa(nat,nat,suc,I2))) ) ) ).

% incseq_SucD
tff(fact_6629_funpow__mono,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(A,A),A3: A,B3: A,Na: nat] :
          ( order_mono(A,A,F2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A3),B3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),A3)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),B3)) ) ) ) ).

% funpow_mono
tff(fact_6630_mono__times__nat,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => order_mono(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Na)) ) ).

% mono_times_nat
tff(fact_6631_mono__mult,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => order_mono(A,A,aa(A,fun(A,A),times_times(A),A2)) ) ) ).

% mono_mult
tff(fact_6632_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [F2: fun(A,B),M: A,Na: A,M6: B,N2: B] :
          ( order_mono(A,B,F2)
         => ( ( image(A,B,F2,set_or7035219750837199246ssThan(A,M,Na)) = set_or7035219750837199246ssThan(B,M6,N2) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),Na)
             => ( aa(A,B,F2,M) = M6 ) ) ) ) ) ).

% mono_image_least
tff(fact_6633_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [F2: fun(A,A),P3: A,K: nat] :
          ( order_mono(A,A,F2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P3),aa(A,A,F2,P3))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P3),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),top_top(A))) ) ) ) ).

% Kleene_iter_gpfp
tff(fact_6634_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [F2: fun(A,A),P3: A,K: nat] :
          ( order_mono(A,A,F2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,F2,P3)),P3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),bot_bot(A))),P3) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_6635_funpow__mono2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(A,A),I2: nat,J2: nat,X: A,Y: A] :
          ( order_mono(A,A,F2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,F2,X))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),I2),F2),X)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),J2),F2),Y)) ) ) ) ) ) ).

% funpow_mono2
tff(fact_6636_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F2)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => topolo1002775350975398744n_open(A,collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_zd(fun(A,B),fun(fun(A,B),fun(A,$o)),F2),G))) ) ) ) ).

% open_Collect_less
tff(fact_6637_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F2: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( cos(A,aa(A,A,F2,X3)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_ro(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_on_tan
tff(fact_6638_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F2: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( sin(A,aa(A,A,F2,X3)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_rp(fun(A,A),fun(A,A),F2)) ) ) ) ).

% continuous_on_cot
tff(fact_6639_continuous__on__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F2)
         => ( ! [X3: A] :
                ( member(A,X3,A3)
               => ( cosh(B,aa(A,B,F2,X3)) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_ze(fun(A,B),fun(A,B),F2)) ) ) ) ).

% continuous_on_tanh
tff(fact_6640_continuous__on__arcosh_H,axiom,
    ! [A3: set(real),F2: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F2)
     => ( ! [X3: real] :
            ( member(real,X3,A3)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,F2,X3)) )
       => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_zf(fun(real,real),fun(real,real),F2)) ) ) ).

% continuous_on_arcosh'
tff(fact_6641_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_antimono(nat,A,aTP_Lamp_zg(fun(A,A),fun(nat,A),Q)) ) ) ).

% antimono_funpow
tff(fact_6642_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [M: nat,Na: nat,F2: fun(A,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( order_mono(A,A,F2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),top_top(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2),top_top(A))) ) ) ) ).

% funpow_increasing
tff(fact_6643_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [M: nat,Na: nat,F2: fun(A,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
         => ( order_mono(A,A,F2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F2),bot_bot(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),bot_bot(A))) ) ) ) ).

% funpow_decreasing
tff(fact_6644_continuous__on__powr_H,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X3: A] :
                  ( member(A,X3,S)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,F2,X3))
                    & ( ( aa(A,real,F2,X3) = zero_zero(real) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X3)) ) ) )
             => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_zc(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ).

% continuous_on_powr'
tff(fact_6645_continuous__on__log,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X3: A] :
                  ( member(A,X3,S)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F2,X3)) )
             => ( ! [X3: A] :
                    ( member(A,X3,S)
                   => ( aa(A,real,F2,X3) != one_one(real) ) )
               => ( ! [X3: A] :
                      ( member(A,X3,S)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X3)) )
                 => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_zh(fun(A,real),fun(fun(A,real),fun(A,real)),F2),G)) ) ) ) ) ) ) ).

% continuous_on_log
tff(fact_6646_continuous__on__arccos_H,axiom,
    topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)),arccos) ).

% continuous_on_arccos'
tff(fact_6647_continuous__on__arcsin_H,axiom,
    topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)),arcsin) ).

% continuous_on_arcsin'
tff(fact_6648_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F2,X3))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,F2,X3)),one_one(real)) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_zi(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_on_arccos
tff(fact_6649_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F2,X3))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,F2,X3)),one_one(real)) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_zj(fun(A,real),fun(A,real),F2)) ) ) ) ).

% continuous_on_arcsin
tff(fact_6650_continuous__on__artanh,axiom,
    ! [A3: set(real)] :
      ( aa(set(real),$o,aa(set(real),fun(set(real),$o),ord_less_eq(set(real)),A3),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)))
     => topolo81223032696312382ous_on(real,real,A3,artanh(real)) ) ).

% continuous_on_artanh
tff(fact_6651_continuous__on__artanh_H,axiom,
    ! [A3: set(real),F2: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F2)
     => ( ! [X3: real] :
            ( member(real,X3,A3)
           => member(real,aa(real,real,F2,X3),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real))) )
       => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_zk(fun(real,real),fun(real,real),F2)) ) ) ).

% continuous_on_artanh'
tff(fact_6652_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),F7: fun(real,fun(real,real))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ( aa(real,real,F2,A2) = aa(real,real,F2,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
         => ( ! [X3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
                 => has_derivative(real,real,F2,aa(real,fun(real,real),F7,X3),topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
           => ? [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                & ! [X4: real] : ( aa(real,real,aa(real,fun(real,real),F7,Z2),X4) = zero_zero(real) ) ) ) ) ) ) ).

% Rolle_deriv
tff(fact_6653_mvt,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),F7: fun(real,fun(real,real))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
       => ( ! [X3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
               => has_derivative(real,real,F2,aa(real,fun(real,real),F7,X3),topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
         => ~ ! [Xi: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xi)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xi),B2)
                 => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) != aa(real,real,aa(real,fun(real,real),F7,Xi),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)) ) ) ) ) ) ) ).

% mvt
tff(fact_6654_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),ring_1_Ints(A)),aTP_Lamp_zl(A,B)) ) ).

% continuous_on_of_int_floor
tff(fact_6655_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),ring_1_Ints(A)),aTP_Lamp_zm(A,B)) ) ).

% continuous_on_of_int_ceiling
tff(fact_6656_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,B2: A,F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,B2)),topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2))) ) ) ) ).

% continuous_on_Icc_at_leftD
tff(fact_6657_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,B2: A,F2: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,A2)),topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2))) ) ) ) ).

% continuous_on_Icc_at_rightD
tff(fact_6658_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),K)
     => order_mono(nat,nat,aTP_Lamp_zn(nat,fun(nat,nat),K)) ) ).

% mono_ge2_power_minus_self
tff(fact_6659_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
       => ( ! [X3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
               => has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
         => ( aa(real,real,F2,B2) = aa(real,real,F2,A2) ) ) ) ) ).

% DERIV_isconst_end
tff(fact_6660_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),zero_zero(real)) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,B2)),aa(real,real,F2,A2)) ) ) ) ).

% DERIV_neg_imp_decreasing_open
tff(fact_6661_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X3: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
             => ? [Y3: real] :
                  ( has_field_derivative(real,F2,Y3,topolo174197925503356063within(real,X3,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y3) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F2,A2)),aa(real,real,F2,B2)) ) ) ) ).

% DERIV_pos_imp_increasing_open
tff(fact_6662_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( aa(set(A),$o,finite_finite(A),image(nat,A,F2,top_top(set(nat))))
         => ( order_mono(nat,A,F2)
           => ( ! [N: nat] :
                  ( ( aa(nat,A,F2,N) = aa(nat,A,F2,aa(nat,nat,suc,N)) )
                 => ( aa(nat,A,F2,aa(nat,nat,suc,N)) = aa(nat,A,F2,aa(nat,nat,suc,aa(nat,nat,suc,N))) ) )
             => ? [N7: nat] :
                  ( ! [N6: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N7)
                     => ! [M2: nat] :
                          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N7)
                         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N6)
                           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F2,M2)),aa(nat,A,F2,N6)) ) ) )
                  & ! [N6: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N6)
                     => ( aa(nat,A,F2,N7) = aa(nat,A,F2,N6) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
tff(fact_6663_tendsto__at__left__sequentially,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [B2: A,A2: A,X7: fun(A,B),L4: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( ! [S7: fun(nat,A)] :
                ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,S7,N6)),A2)
               => ( ! [N6: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(nat,A,S7,N6))
                 => ( order_mono(nat,A,S7)
                   => ( filterlim(nat,A,S7,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
                     => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_yn(fun(A,B),fun(fun(nat,A),fun(nat,B)),X7),S7),topolo7230453075368039082e_nhds(B,L4),at_top(nat)) ) ) ) )
           => filterlim(A,B,X7,topolo7230453075368039082e_nhds(B,L4),topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2))) ) ) ) ).

% tendsto_at_left_sequentially
tff(fact_6664_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: fun(real,real),X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
       => ( ! [X3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
               => has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
             => ( aa(real,real,F2,X) = aa(real,real,F2,A2) ) ) ) ) ) ) ).

% DERIV_isconst2
tff(fact_6665_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [F2: fun(A,B),A2: A,B2: A] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,A2)),topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2)))
         => ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,B2)),topolo174197925503356063within(A,B2,set_ord_lessThan(A,B2)))
           => ( ! [X3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),B2)
                   => filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,aa(A,B,F2,X3)),topolo174197925503356063within(A,X3,top_top(set(A)))) ) )
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
               => topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F2) ) ) ) ) ) ).

% continuous_on_IccI
tff(fact_6666_Rolle,axiom,
    ! [A2: real,B2: real,F2: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ( aa(real,real,F2,A2) = aa(real,real,F2,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F2)
         => ( ! [X3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X3)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X3),B2)
                 => differentiable(real,real,F2,topolo174197925503356063within(real,X3,top_top(set(real)))) ) )
           => ? [Z2: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z2)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z2),B2)
                & has_field_derivative(real,F2,zero_zero(real),topolo174197925503356063within(real,Z2,top_top(set(real)))) ) ) ) ) ) ).

% Rolle
tff(fact_6667_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( remdups_adj(A,Xs) = Ys )
    <=> ? [F5: fun(nat,nat)] :
          ( order_mono(nat,nat,F5)
          & ( image(nat,nat,F5,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Ys)) )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
             => ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Ys),aa(nat,nat,F5,I)) ) )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat))),aa(list(A),nat,size_size(list(A)),Xs))
             => ( ( aa(nat,A,nth(A,Xs),I) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat))) )
              <=> ( aa(nat,nat,F5,I) = aa(nat,nat,F5,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat))) ) ) ) ) ) ).

% remdups_adj_altdef
tff(fact_6668_inj__sgn__power,axiom,
    ! [Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => inj_on(real,real,aTP_Lamp_ok(nat,fun(real,real),Na),top_top(set(real))) ) ).

% inj_sgn_power
tff(fact_6669_inj__mult__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A] :
          ( inj_on(A,A,aa(A,fun(A,A),times_times(A),A2),top_top(set(A)))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% inj_mult_left
tff(fact_6670_inj__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] :
          ( inj_on(A,A,aTP_Lamp_zo(A,fun(A,A),A2),top_top(set(A)))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% inj_divide_right
tff(fact_6671_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A2: A,A3: set(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),insert(A,A2),A3))
    <=> ( inj_on(A,B,F2,A3)
        & ~ member(B,aa(A,B,F2,A2),image(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% inj_on_insert
tff(fact_6672_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% remdups_adj_length
tff(fact_6673_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : inj_on(A,A,aTP_Lamp_mc(A,fun(A,A),A2),top_top(set(A))) ) ).

% inj_diff_right
tff(fact_6674_inj__add__left,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A2),top_top(set(A))) ) ).

% inj_add_left
tff(fact_6675_inj__fn,axiom,
    ! [A: $tType,F2: fun(A,A),Na: nat] :
      ( inj_on(A,A,F2,top_top(set(A)))
     => inj_on(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),top_top(set(A))) ) ).

% inj_fn
tff(fact_6676_inj__on__diff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,A3)
     => inj_on(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% inj_on_diff
tff(fact_6677_inj__on__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A)] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3) ) ).

% inj_on_add
tff(fact_6678_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A)] : inj_on(A,A,aTP_Lamp_zp(A,fun(A,A),A2),A3) ) ).

% inj_on_add'
tff(fact_6679_inj__on__mult,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,A3: set(A)] :
          ( ( A2 != zero_zero(A) )
         => inj_on(A,A,aa(A,fun(A,A),times_times(A),A2),A3) ) ) ).

% inj_on_mult
tff(fact_6680_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [F2: fun(A,B)] :
          ( ! [X3: A,Y4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
             => ( aa(A,B,F2,X3) != aa(A,B,F2,Y4) ) )
         => inj_on(A,B,F2,top_top(set(A))) ) ) ).

% linorder_injI
tff(fact_6681_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),B3: set(A),A3: set(A)] :
      ( inj_on(A,B,F2,B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),image(A,B,F2,A3)),image(A,B,F2,B3)) ) ) ).

% inj_on_strict_subset
tff(fact_6682_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( order(A)
     => ! [A3: set(A),F2: fun(A,B)] :
          ( ! [X3: A,Y4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
             => ( member(A,X3,A3)
               => ( member(A,Y4,A3)
                 => ( aa(A,B,F2,X3) != aa(A,B,F2,Y4) ) ) ) )
         => ( ! [X3: A,Y4: A] :
                ( member(A,X3,A3)
               => ( member(A,Y4,A3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y4)
                    | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y4),X3) ) ) )
           => inj_on(A,B,F2,A3) ) ) ) ).

% linorder_inj_onI
tff(fact_6683_image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,top_top(set(A)))
     => ( image(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),image(A,B,F2,A3)),image(A,B,F2,B3)) ) ) ).

% image_set_diff
tff(fact_6684_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,B),C6: set(A),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,C6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),C6)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C6)
         => ( image(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),image(A,B,F2,A3)),image(A,B,F2,B3)) ) ) ) ) ).

% inj_on_image_set_diff
tff(fact_6685_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),A3: set(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),image(B,A,F2,A3))),aa(set(B),nat,finite_card(B),A3))
     => ~ inj_on(B,A,F2,A3) ) ).

% pigeonhole
tff(fact_6686_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo8458572112393995274pology(A)
        & topolo1944317154257567458pology(B) )
     => ! [A2: A,X: A,B2: A,F2: fun(A,B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B2)
           => ( topolo81223032696312382ous_on(A,B,set_or1337092689740270186AtMost(A,A2,B2),F2)
             => ( inj_on(A,B,F2,set_or1337092689740270186AtMost(A,A2,B2))
               => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,A2)),aa(A,B,F2,X))
                    & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,B2)) )
                  | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,B2)),aa(A,B,F2,X))
                    & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,A2)) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
tff(fact_6687_injective__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [C2: real] :
          ( ( C2 != zero_zero(real) )
         => inj_on(A,A,real_V8093663219630862766scaleR(A,C2),top_top(set(A))) ) ) ).

% injective_scaleR
tff(fact_6688_remdups__adj__adjacent,axiom,
    ! [A: $tType,I2: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I2)),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)))
     => ( aa(nat,A,nth(A,remdups_adj(A,Xs)),I2) != aa(nat,A,nth(A,remdups_adj(A,Xs)),aa(nat,nat,suc,I2)) ) ) ).

% remdups_adj_adjacent
tff(fact_6689_log__inj,axiom,
    ! [B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => inj_on(real,real,log(B2),set_ord_greaterThan(real,zero_zero(real))) ) ).

% log_inj
tff(fact_6690_funpow__inj__finite,axiom,
    ! [A: $tType,P3: fun(A,A),X: A] :
      ( inj_on(A,A,P3,top_top(set(A)))
     => ( aa(set(A),$o,finite_finite(A),collect(A,aa(A,fun(A,$o),aTP_Lamp_zq(fun(A,A),fun(A,fun(A,$o)),P3),X)))
       => ~ ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),P3),X) != X ) ) ) ) ).

% funpow_inj_finite
tff(fact_6691_surj__int__decode,axiom,
    image(nat,int,nat_int_decode,top_top(set(nat))) = top_top(set(int)) ).

% surj_int_decode
tff(fact_6692_has__derivative__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(A) )
     => ! [F2: fun(B,A),X: B,F7: fun(B,A),S3: set(B),Na: int] :
          ( ( aa(B,A,F2,X) != zero_zero(A) )
         => ( has_derivative(B,A,F2,F7,topolo174197925503356063within(B,X,S3))
           => has_derivative(B,A,aa(int,fun(B,A),aTP_Lamp_zr(fun(B,A),fun(int,fun(B,A)),F2),Na),aa(int,fun(B,A),aa(fun(B,A),fun(int,fun(B,A)),aa(B,fun(fun(B,A),fun(int,fun(B,A))),aTP_Lamp_zs(fun(B,A),fun(B,fun(fun(B,A),fun(int,fun(B,A)))),F2),X),F7),Na),topolo174197925503356063within(B,X,S3)) ) ) ) ).

% has_derivative_power_int
tff(fact_6693_power__int__1__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Na: int] : ( power_int(A,one_one(A),Na) = one_one(A) ) ) ).

% power_int_1_left
tff(fact_6694_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & monoid_mult(A) )
     => ! [Y: A] : ( power_int(A,Y,one_one(int)) = Y ) ) ).

% power_int_1_right
tff(fact_6695_power__int__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,Na: int] : ( aa(A,A,sgn_sgn(A),power_int(A,A2,Na)) = power_int(A,aa(A,A,sgn_sgn(A),A2),Na) ) ) ).

% power_int_sgn
tff(fact_6696_int__encode__inverse,axiom,
    ! [X: int] : ( aa(nat,int,nat_int_decode,aa(int,nat,nat_int_encode,X)) = X ) ).

% int_encode_inverse
tff(fact_6697_int__decode__inverse,axiom,
    ! [Na: nat] : ( aa(int,nat,nat_int_encode,aa(nat,int,nat_int_decode,Na)) = Na ) ).

% int_decode_inverse
tff(fact_6698_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,W: num,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(num,A,numeral_numeral(A),W)),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M)),power_int(A,aa(num,A,numeral_numeral(A),W),M)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_6699_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [W: num,Y: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(num,A,numeral_numeral(A),W),M)),power_int(A,Y,M)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_6700_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,Na: int] :
          ( ( power_int(A,X,Na) = zero_zero(A) )
        <=> ( ( X = zero_zero(A) )
            & ( Na != zero_zero(int) ) ) ) ) ).

% power_int_eq_0_iff
tff(fact_6701_power__int__0__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] :
          ( ( M != zero_zero(int) )
         => ( power_int(A,zero_zero(A),M) = zero_zero(A) ) ) ) ).

% power_int_0_left
tff(fact_6702_power__int__0__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [X: A] : ( power_int(A,X,zero_zero(int)) = one_one(A) ) ) ).

% power_int_0_right
tff(fact_6703_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,Na: int] : ( aa(A,A,abs_abs(A),power_int(A,aa(A,A,uminus_uminus(A),A2),Na)) = aa(A,A,abs_abs(A),power_int(A,A2,Na)) ) ) ).

% abs_power_int_minus
tff(fact_6704_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [X: A,Na: nat] : ( power_int(A,X,aa(nat,int,semiring_1_of_nat(int),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),X),Na) ) ) ).

% power_int_of_nat
tff(fact_6705_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: num,Na: num] : ( power_int(A,power_int(A,X,aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),Na)) = power_int(A,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),times_times(num),M),Na))) ) ) ).

% power_int_mult_numeral
tff(fact_6706_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)) = one_one(A) ) ) ).

% power_int_minus_one_mult_self
tff(fact_6707_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),B2)) = B2 ) ) ).

% power_int_minus_one_mult_self'
tff(fact_6708_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [X: A,Na: num] : ( power_int(A,X,aa(num,int,numeral_numeral(int),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),Na)) ) ) ).

% power_int_numeral
tff(fact_6709_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [Y: real,X: num,Na: int] :
          ( ( real_Vector_of_real(A,Y) = power_int(A,aa(num,A,numeral_numeral(A),X),Na) )
        <=> ( Y = power_int(real,aa(num,real,numeral_numeral(real),X),Na) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
tff(fact_6710_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [X: num,Na: int,Y: real] :
          ( ( power_int(A,aa(num,A,numeral_numeral(A),X),Na) = real_Vector_of_real(A,Y) )
        <=> ( power_int(real,aa(num,real,numeral_numeral(real),X),Na) = Y ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
tff(fact_6711_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & monoid_mult(A) )
     => ! [Y: A] : ( power_int(A,Y,aa(int,int,uminus_uminus(int),one_one(int))) = aa(A,A,inverse_inverse(A),Y) ) ) ).

% power_int_minus1_right
tff(fact_6712_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: num,Na: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),M))),power_int(A,X,aa(num,int,numeral_numeral(int),Na))) = power_int(A,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na))) ) ) ).

% power_int_add_numeral
tff(fact_6713_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: num,Na: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),M))),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),Na))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)))),B2) ) ) ).

% power_int_add_numeral2
tff(fact_6714_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,A2,Na)),power_int(A,B2,Na))
              <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ) ).

% power_int_mono_iff
tff(fact_6715_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Na: int,A2: A] :
          ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)
         => ( power_int(A,aa(A,A,uminus_uminus(A),A2),Na) = aa(A,A,uminus_uminus(A),power_int(A,A2,Na)) ) ) ) ).

% power_int_minus_left_odd
tff(fact_6716_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Na: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na)
         => ( power_int(A,aa(A,A,uminus_uminus(A),A2),Na) = power_int(A,A2,Na) ) ) ) ).

% power_int_minus_left_even
tff(fact_6717_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: num,Na: num] : ( power_int(A,aa(num,A,numeral_numeral(A),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))) = aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),pow(M,Na))) ) ) ).

% power_int_numeral_neg_numeral
tff(fact_6718_continuous__on__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F2: fun(A,B),Na: int] :
          ( topolo81223032696312382ous_on(A,B,S,F2)
         => ( ! [X3: A] :
                ( member(A,X3,S)
               => ( aa(A,B,F2,X3) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aa(int,fun(A,B),aTP_Lamp_zt(fun(A,B),fun(int,fun(A,B)),F2),Na)) ) ) ) ).

% continuous_on_power_int
tff(fact_6719_inj__on__diff__nat,axiom,
    ! [N3: set(nat),K: nat] :
      ( ! [N: nat] :
          ( member(nat,N,N3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N) )
     => inj_on(nat,nat,aTP_Lamp_ly(nat,fun(nat,nat),K),N3) ) ).

% inj_on_diff_nat
tff(fact_6720_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),power_int(A,X,Na)) ) ) ).

% zero_le_power_int
tff(fact_6721_inj__on__set__encode,axiom,
    inj_on(set(nat),nat,nat_set_encode,collect(set(nat),finite_finite(nat))) ).

% inj_on_set_encode
tff(fact_6722_inj__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => inj_on(nat,A,semiring_1_of_nat(A),top_top(set(nat))) ) ).

% inj_of_nat
tff(fact_6723_inj__prod__encode,axiom,
    ! [A3: set(product_prod(nat,nat))] : inj_on(product_prod(nat,nat),nat,nat_prod_encode,A3) ).

% inj_prod_encode
tff(fact_6724_inj__int__decode,axiom,
    ! [A3: set(nat)] : inj_on(nat,int,nat_int_decode,A3) ).

% inj_int_decode
tff(fact_6725_inj__Suc,axiom,
    ! [N3: set(nat)] : inj_on(nat,nat,suc,N3) ).

% inj_Suc
tff(fact_6726_inj__int__encode,axiom,
    ! [A3: set(int)] : inj_on(int,nat,nat_int_encode,A3) ).

% inj_int_encode
tff(fact_6727_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),power_int(A,X,Na)) ) ) ).

% zero_less_power_int
tff(fact_6728_power__int__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,Na: int] : ( power_int(A,X,aa(int,int,uminus_uminus(int),Na)) = aa(A,A,inverse_inverse(A),power_int(A,X,Na)) ) ) ).

% power_int_minus
tff(fact_6729_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),X),Y),M) = aa(A,A,aa(A,fun(A,A),divide_divide(A),power_int(A,X,M)),power_int(A,Y,M)) ) ) ).

% power_int_divide_distrib
tff(fact_6730_power__int__abs,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,Na: int] : ( aa(A,A,abs_abs(A),power_int(A,A2,Na)) = power_int(A,aa(A,A,abs_abs(A),A2),Na) ) ) ).

% power_int_abs
tff(fact_6731_power__int__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,Na: int] : ( power_int(A,aa(A,A,inverse_inverse(A),X),Na) = aa(A,A,inverse_inverse(A),power_int(A,X,Na)) ) ) ).

% power_int_inverse
tff(fact_6732_int__decode__eq,axiom,
    ! [X: nat,Y: nat] :
      ( ( aa(nat,int,nat_int_decode,X) = aa(nat,int,nat_int_decode,Y) )
    <=> ( X = Y ) ) ).

% int_decode_eq
tff(fact_6733_power__int__mult,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: int,Na: int] : ( power_int(A,X,aa(int,int,aa(int,fun(int,int),times_times(int),M),Na)) = power_int(A,power_int(A,X,M),Na) ) ) ).

% power_int_mult
tff(fact_6734_power__int__commutes,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,Na: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,Na)),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),power_int(A,X,Na)) ) ) ).

% power_int_commutes
tff(fact_6735_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),Y),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M)),power_int(A,Y,M)) ) ) ).

% power_int_mult_distrib
tff(fact_6736_power__int__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,Na: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),X),Na) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),power_int(A,X,Na)) ) ) ).

% power_int_one_over
tff(fact_6737_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,Na: int] :
          ( ( ( X != zero_zero(A) )
            | ( Na = zero_zero(int) ) )
         => ( power_int(A,X,Na) != zero_zero(A) ) ) ) ).

% power_int_not_zero
tff(fact_6738_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] :
          ( power_int(A,zero_zero(A),M)
          = $ite(M = zero_zero(int),one_one(A),zero_zero(A)) ) ) ).

% power_int_0_left_If
tff(fact_6739_power__int__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Na: int,N3: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,A2,Na)),power_int(A,A2,N3)) ) ) ) ).

% power_int_increasing
tff(fact_6740_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Na: int,N3: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,A2,Na)),power_int(A,A2,N3)) ) ) ) ).

% power_int_strict_increasing
tff(fact_6741_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Na: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,uminus_uminus(int),Na)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),Na) ) ) ).

% power_int_minus_one_minus
tff(fact_6742_power__int__diff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,M: int,Na: int] :
          ( ( ( X != zero_zero(A) )
            | ( M != Na ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),minus_minus(int),M),Na)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),power_int(A,X,M)),power_int(A,X,Na)) ) ) ) ).

% power_int_diff
tff(fact_6743_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: int,B2: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),A2),B2)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),A2)) ) ) ).

% power_int_minus_one_diff_commute
tff(fact_6744_tendsto__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A),Na: int] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
         => ( ( A2 != zero_zero(B) )
           => filterlim(A,B,aa(int,fun(A,B),aTP_Lamp_zu(fun(A,B),fun(int,fun(A,B)),F2),Na),topolo7230453075368039082e_nhds(B,power_int(B,A2,Na)),F3) ) ) ) ).

% tendsto_power_int
tff(fact_6745_continuous__at__within__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [A2: A,S: set(A),F2: fun(A,B),Na: int] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F2)
         => ( ( aa(A,B,F2,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aa(int,fun(A,B),aTP_Lamp_zv(fun(A,B),fun(int,fun(A,B)),F2),Na)) ) ) ) ).

% continuous_at_within_power_int
tff(fact_6746_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ? [N: nat,F4: fun(nat,A)] :
          ( ( A3 = image(nat,A,F4,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),N))) )
          & inj_on(nat,A,F4,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),N))) ) ) ).

% finite_imp_nat_seg_image_inj_on
tff(fact_6747_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F2: fun(A,B),X: A,S: set(A),Na: int] :
          ( differentiable(A,B,F2,topolo174197925503356063within(A,X,S))
         => ( ( aa(A,B,F2,X) != zero_zero(B) )
           => differentiable(A,B,aa(int,fun(A,B),aTP_Lamp_zw(fun(A,B),fun(int,fun(A,B)),F2),Na),topolo174197925503356063within(A,X,S)) ) ) ) ).

% differentiable_power_int
tff(fact_6748_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ? [F4: fun(A,nat),N: nat] :
          ( ( image(A,nat,F4,A3) = collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),N)) )
          & inj_on(A,nat,F4,A3) ) ) ).

% finite_imp_inj_to_nat_seg
tff(fact_6749_continuous__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [F3: filter(A),F2: fun(A,B),Na: int] :
          ( topolo3448309680560233919inuous(A,B,F3,F2)
         => ( ( aa(A,B,F2,topolo3827282254853284352ce_Lim(A,A,F3,aTP_Lamp_xo(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F3,aa(int,fun(A,B),aTP_Lamp_zv(fun(A,B),fun(int,fun(A,B)),F2),Na)) ) ) ) ).

% continuous_power_int
tff(fact_6750_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Na: int,N3: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,A2,N3)),power_int(A,A2,Na)) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_6751_power__int__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,X,Na)),power_int(A,Y,Na)) ) ) ) ) ).

% power_int_mono
tff(fact_6752_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Na),zero_zero(int))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,B2,Na)),power_int(A,A2,Na)) ) ) ) ) ).

% power_int_strict_antimono
tff(fact_6753_one__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),X)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),power_int(A,X,Na)) ) ) ) ).

% one_le_power_int
tff(fact_6754_one__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),power_int(A,A2,Na)) ) ) ) ).

% one_less_power_int
tff(fact_6755_power__int__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: int,Na: int] :
          ( ( ( X != zero_zero(A) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M),Na) != zero_zero(int) ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),Na)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M)),power_int(A,X,Na)) ) ) ) ).

% power_int_add
tff(fact_6756_inj__on__nth,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] :
      ( distinct(A,Xs)
     => ( ! [X3: nat] :
            ( member(nat,X3,I5)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),aa(list(A),nat,size_size(list(A)),Xs)) )
       => inj_on(nat,A,nth(A,Xs),I5) ) ) ).

% inj_on_nth
tff(fact_6757_power__int__minus__left__distrib,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( division_ring(C)
        & one(A)
        & uminus(A) )
     => ! [X: B,A2: C,Na: int] :
          ( nO_MATCH(A,B,aa(A,A,uminus_uminus(A),one_one(A)),X)
         => ( power_int(C,aa(C,C,uminus_uminus(C),A2),Na) = aa(C,C,aa(C,fun(C,C),times_times(C),power_int(C,aa(C,C,uminus_uminus(C),one_one(C)),Na)),power_int(C,A2,Na)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_6758_summable__reindex,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F2)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X3))
         => summable(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F2),G)) ) ) ) ).

% summable_reindex
tff(fact_6759_inj__on__funpow__least,axiom,
    ! [A: $tType,Na: nat,F2: fun(A,A),S: A] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Na),F2),S) = S )
     => ( ! [M4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M4)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),Na)
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M4),F2),S) != S ) ) )
       => inj_on(nat,A,aa(A,fun(nat,A),aTP_Lamp_zx(fun(A,A),fun(A,fun(nat,A)),F2),S),set_or7035219750837199246ssThan(nat,zero_zero(nat),Na)) ) ) ).

% inj_on_funpow_least
tff(fact_6760_bij__int__decode,axiom,
    bij_betw(nat,int,nat_int_decode,top_top(set(nat)),top_top(set(int))) ).

% bij_int_decode
tff(fact_6761_power__int__antimono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Na),zero_zero(int))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,B2,Na)),power_int(A,A2,Na)) ) ) ) ) ).

% power_int_antimono
tff(fact_6762_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,A2,Na)),power_int(A,B2,Na)) ) ) ) ) ).

% power_int_strict_mono
tff(fact_6763_power__int__le__one,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,X,Na)),one_one(A)) ) ) ) ) ).

% power_int_le_one
tff(fact_6764_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Na: int,N3: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Na),N3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
             => ( ( ( A2 != zero_zero(A) )
                  | ( N3 != zero_zero(int) )
                  | ( Na = zero_zero(int) ) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,A2,N3)),power_int(A,A2,Na)) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_6765_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,M: int,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,X,M)),power_int(A,X,Na))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M),Na) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_6766_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,M: int,Na: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),X)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,X,M)),power_int(A,X,Na))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),M),Na) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_6767_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Na: int] :
          ( ( ( X != zero_zero(A) )
            | ( Na != zero_zero(int) ) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(int,int,aa(int,fun(int,int),minus_minus(int),Na),one_one(int)))),X) = power_int(A,X,Na) ) ) ) ).

% power_int_minus_mult
tff(fact_6768_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Na: int] :
          ( power_int(A,aa(A,A,uminus_uminus(A),A2),Na)
          = $ite(aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Na),power_int(A,A2,Na),aa(A,A,uminus_uminus(A),power_int(A,A2,Na))) ) ) ).

% power_int_minus_left
tff(fact_6769_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: int] :
          ( ( ( X != zero_zero(A) )
            | ( M != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),X),power_int(A,X,M)) ) ) ) ).

% power_int_add_1'
tff(fact_6770_power__int__add__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M: int] :
          ( ( ( X != zero_zero(A) )
            | ( M != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M)),X) ) ) ) ).

% power_int_add_1
tff(fact_6771_suminf__reindex__mono,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F2)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X3))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F2),G))),suminf(real,F2)) ) ) ) ).

% suminf_reindex_mono
tff(fact_6772_power__int__def,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [X: A,Na: int] :
          ( power_int(A,X,Na)
          = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Na),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(int,nat,nat2,Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Na)))) ) ) ).

% power_int_def
tff(fact_6773_powr__real__of__int_H,axiom,
    ! [X: real,Na: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( ( ( X != zero_zero(real) )
          | aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Na) )
       => ( powr(real,X,aa(int,real,ring_1_of_int(real),Na)) = power_int(real,X,Na) ) ) ) ).

% powr_real_of_int'
tff(fact_6774_inj__on__char__of__nat,axiom,
    inj_on(nat,char,unique5772411509450598832har_of(nat),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))) ).

% inj_on_char_of_nat
tff(fact_6775_suminf__reindex,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F2)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X3))
         => ( ! [X3: nat] :
                ( ~ member(nat,X3,image(nat,nat,G,top_top(set(nat))))
               => ( aa(nat,real,F2,X3) = zero_zero(real) ) )
           => ( suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F2),G)) = suminf(real,F2) ) ) ) ) ) ).

% suminf_reindex
tff(fact_6776_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(A,A),D2: A,X: A,S: set(A),Na: int] :
          ( has_field_derivative(A,F2,D2,topolo174197925503356063within(A,X,S))
         => ( ( aa(A,A,F2,X) != zero_zero(A) )
           => has_field_derivative(A,aa(int,fun(A,A),aTP_Lamp_zy(fun(A,A),fun(int,fun(A,A)),F2),Na),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Na)),power_int(A,aa(A,A,F2,X),aa(int,int,aa(int,fun(int,int),minus_minus(int),Na),one_one(int))))),D2),topolo174197925503356063within(A,X,S)) ) ) ) ).

% DERIV_power_int
tff(fact_6777_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [X: A,Na: int,S3: set(A)] :
          ( ( X != zero_zero(A) )
         => has_derivative(A,A,aTP_Lamp_zz(int,fun(A,A),Na),aa(int,fun(A,A),aTP_Lamp_aaa(A,fun(int,fun(A,A)),X),Na),topolo174197925503356063within(A,X,S3)) ) ) ).

% has_derivative_power_int'
tff(fact_6778_UN__le__eq__Un0,axiom,
    ! [A: $tType,M10: fun(nat,set(A)),Na: nat] : ( complete_Sup_Sup(set(A),image(nat,set(A),M10,set_ord_atMost(nat,Na))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),complete_Sup_Sup(set(A),image(nat,set(A),M10,set_or1337092689740270186AtMost(nat,one_one(nat),Na)))),aa(nat,set(A),M10,zero_zero(nat))) ) ).

% UN_le_eq_Un0
tff(fact_6779_pos__deriv__imp__strict__mono,axiom,
    ! [F2: fun(real,real),F7: fun(real,real)] :
      ( ! [X3: real] : has_field_derivative(real,F2,aa(real,real,F7,X3),topolo174197925503356063within(real,X3,top_top(set(real))))
     => ( ! [X3: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,F7,X3))
       => order_strict_mono(real,real,F2) ) ) ).

% pos_deriv_imp_strict_mono
tff(fact_6780_Un__Diff__cancel,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3) ) ).

% Un_Diff_cancel
tff(fact_6781_Un__Diff__cancel2,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),A3) ) ).

% Un_Diff_cancel2
tff(fact_6782_Compl__Diff__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),B3) ) ).

% Compl_Diff_eq
tff(fact_6783_Un__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)),C6) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C6)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C6)) ) ).

% Un_Diff
tff(fact_6784_strict__mono__add,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A] : order_strict_mono(A,A,aTP_Lamp_lz(A,fun(A,A),K)) ) ).

% strict_mono_add
tff(fact_6785_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B),X: A,Y: A] :
          ( order_strict_mono(A,B,F2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,Y)) ) ) ) ).

% strict_monoD
tff(fact_6786_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( ! [X3: A,Y4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X3)),aa(A,B,F2,Y4)) )
         => order_strict_mono(A,B,F2) ) ) ).

% strict_monoI
tff(fact_6787_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F2: fun(A,B)] :
          ( order_strict_mono(A,B,F2)
        <=> ! [X5: A,Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X5)),aa(A,B,F2,Y5)) ) ) ) ).

% strict_mono_def
tff(fact_6788_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F2: fun(A,B),X: A,Y: A] :
          ( order_strict_mono(A,B,F2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X)),aa(A,B,F2,Y))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y) ) ) ) ).

% strict_mono_less
tff(fact_6789_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% sup.strict_coboundedI2
tff(fact_6790_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% sup.strict_coboundedI1
tff(fact_6791_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% sup.strict_order_iff
tff(fact_6792_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A2)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% sup.strict_boundedE
tff(fact_6793_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = B2 ) ) ) ).

% sup.absorb4
tff(fact_6794_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = A2 ) ) ) ).

% sup.absorb3
tff(fact_6795_less__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% less_supI2
tff(fact_6796_less__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% less_supI1
tff(fact_6797_Diff__partition,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) = B3 ) ) ).

% Diff_partition
tff(fact_6798_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),C6)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C6)) ) ).

% Diff_subset_conv
tff(fact_6799_card__Un__le,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))) ).

% card_Un_le
tff(fact_6800_atLeastLessThan__add__Un,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( set_or7035219750837199246ssThan(nat,I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),set_or7035219750837199246ssThan(nat,I2,J2)),set_or7035219750837199246ssThan(nat,J2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K))) ) ) ).

% atLeastLessThan_add_Un
tff(fact_6801_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
tff(fact_6802_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
tff(fact_6803_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(1)
tff(fact_6804_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or5935395276787703475ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(2)
tff(fact_6805_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_atMost(A,L)),set_or5935395276787703475ssThan(A,L,U)) = set_ord_lessThan(A,U) ) ) ) ).

% ivl_disj_un_one(1)
tff(fact_6806_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
tff(fact_6807_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semila1105856199041335345_order(A,sup_sup(A),bot_bot(A),aTP_Lamp_aab(A,fun(A,$o)),aTP_Lamp_aac(A,fun(A,$o))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_6808_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or5935395276787703475ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(4)
tff(fact_6809_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,L),bot_bot(set(A)))),set_or5935395276787703475ssThan(A,L,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_6810_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(5)
tff(fact_6811_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_6812_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),complete_Sup_Sup(A,image(nat,A,aTP_Lamp_aad(A,fun(nat,A),B3),collect(nat,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B3) ) ) ).

% SUP_nat_binary
tff(fact_6813_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I2: B,B3: set(A),J4: set(B)] :
      ( complete_Sup_Sup(set(A),image(B,set(A),fun_upd(B,set(A),A3,I2,B3),J4))
      = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),complete_Sup_Sup(set(A),image(B,set(A),A3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),J4),aa(set(B),set(B),insert(B,I2),bot_bot(set(B))))))),$ite(member(B,I2,J4),B3,bot_bot(set(A)))) ) ).

% UNION_fun_upd
tff(fact_6814_sup__int__def,axiom,
    sup_sup(int) = ord_max(int) ).

% sup_int_def
tff(fact_6815_sup__enat__def,axiom,
    sup_sup(extended_enat) = ord_max(extended_enat) ).

% sup_enat_def
tff(fact_6816_sup__nat__def,axiom,
    sup_sup(nat) = ord_max(nat) ).

% sup_nat_def
tff(fact_6817_strict__mono__imp__increasing,axiom,
    ! [F2: fun(nat,nat),Na: nat] :
      ( order_strict_mono(nat,nat,F2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(nat,nat,F2,Na)) ) ).

% strict_mono_imp_increasing
tff(fact_6818_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F2: fun(nat,A)] :
          ( order_strict_mono(nat,A,F2)
        <=> ! [N4: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F2,N4)),aa(nat,A,F2,aa(nat,nat,suc,N4))) ) ) ).

% strict_mono_Suc_iff
tff(fact_6819_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),X: B,Y: A,A3: set(B)] :
      ( image(B,A,fun_upd(B,A,F2,X,Y),A3)
      = $ite(member(B,X,A3),aa(set(A),set(A),insert(A,Y),image(B,A,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X),bot_bot(set(B)))))),image(B,A,F2,A3)) ) ).

% fun_upd_image
tff(fact_6820_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(nat,nat),F2: fun(nat,A)] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N: nat] :
                ( ~ member(nat,N,image(nat,nat,G,top_top(set(nat))))
               => ( aa(nat,A,F2,N) = zero_zero(A) ) )
           => ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aae(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F2))
            <=> summable(A,F2) ) ) ) ) ).

% summable_mono_reindex
tff(fact_6821_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: fun(nat,real),G: fun(nat,nat)] :
      ( ! [X3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F2,X3))
     => ( order_mono(nat,real,F2)
       => ( order_strict_mono(nat,nat,G)
         => ( bfun(nat,real,aa(fun(nat,nat),fun(nat,real),aTP_Lamp_aaf(fun(nat,real),fun(fun(nat,nat),fun(nat,real)),F2),G),at_top(nat))
          <=> bfun(nat,real,F2,at_top(nat)) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
tff(fact_6822_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(nat,nat),F2: fun(nat,A),C2: A] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N: nat] :
                ( ~ member(nat,N,image(nat,nat,G,top_top(set(nat))))
               => ( aa(nat,A,F2,N) = zero_zero(A) ) )
           => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aae(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F2),C2)
            <=> sums(A,F2,C2) ) ) ) ) ).

% sums_mono_reindex
tff(fact_6823_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,nat),F2: fun(nat,A)] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N: nat] :
                ( ~ member(nat,N,image(nat,nat,G,top_top(set(nat))))
               => ( aa(nat,A,F2,N) = zero_zero(A) ) )
           => ( suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aag(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F2)) = suminf(A,F2) ) ) ) ) ).

% suminf_mono_reindex
tff(fact_6824_mult__inj__if__coprime__nat,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,nat),A3: set(A),G: fun(B,nat),B3: set(B)] :
      ( inj_on(A,nat,F2,A3)
     => ( inj_on(B,nat,G,B3)
       => ( ! [A4: A,B4: B] :
              ( member(A,A4,A3)
             => ( member(B,B4,B3)
               => algebr8660921524188924756oprime(nat,aa(A,nat,F2,A4),aa(B,nat,G,B4)) ) )
         => inj_on(product_prod(A,B),nat,product_case_prod(A,B,nat,aa(fun(B,nat),fun(A,fun(B,nat)),aTP_Lamp_aah(fun(A,nat),fun(fun(B,nat),fun(A,fun(B,nat))),F2),G)),product_Sigma(A,B,A3,aTP_Lamp_aai(set(B),fun(A,set(B)),B3))) ) ) ) ).

% mult_inj_if_coprime_nat
tff(fact_6825_nth__Cons__pos,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,A,nth(A,cons(A,X,Xs)),Na) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) ) ) ).

% nth_Cons_pos
tff(fact_6826_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs: list(A),Na: nat] : ( aa(nat,A,nth(A,cons(A,X,Xs)),aa(nat,nat,suc,Na)) = aa(nat,A,nth(A,Xs),Na) ) ).

% nth_Cons_Suc
tff(fact_6827_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs: list(A)] : ( aa(nat,A,nth(A,cons(A,X,Xs)),zero_zero(nat)) = X ) ).

% nth_Cons_0
tff(fact_6828_take__Suc__Cons,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] : ( take(A,aa(nat,nat,suc,Na),cons(A,X,Xs)) = cons(A,X,take(A,Na,Xs)) ) ).

% take_Suc_Cons
tff(fact_6829_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [X: A,Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),cons(A,X,Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(list(A),A,groups8242544230860333062m_list(A),Xs)) ) ) ).

% sum_list.Cons
tff(fact_6830_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A2: A,X: B,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),cons(B,X,Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F2,X)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_6831_enumerate__simps_I2_J,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] : ( enumerate(A,Na,cons(A,X,Xs)) = cons(product_prod(nat,A),aa(A,product_prod(nat,A),product_Pair(nat,A,Na),X),enumerate(A,aa(nat,nat,suc,Na),Xs)) ) ).

% enumerate_simps(2)
tff(fact_6832_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs: list(A),V: num] : ( aa(nat,A,nth(A,cons(A,X,Xs)),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat))) ) ).

% nth_Cons_numeral
tff(fact_6833_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs: list(A)] : ( take(A,aa(num,nat,numeral_numeral(nat),V),cons(A,X,Xs)) = cons(A,X,take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs)) ) ).

% take_Cons_numeral
tff(fact_6834_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: A,Ys: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),cons(A,X,Xs)),cons(A,Y,Ys)),lex(A,R2))
    <=> ( ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),R2)
          & ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) ) )
        | ( ( X = Y )
          & member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),lex(A,R2)) ) ) ) ).

% Cons_in_lex
tff(fact_6835_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,Na) )
    <=> ? [Y5: A,Ys3: list(A)] :
          ( ( Xs = cons(A,Y5,Ys3) )
          & ( aa(list(A),nat,size_size(list(A)),Ys3) = Na ) ) ) ).

% length_Suc_conv
tff(fact_6836_Suc__length__conv,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( aa(nat,nat,suc,Na) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ? [Y5: A,Ys3: list(A)] :
          ( ( Xs = cons(A,Y5,Ys3) )
          & ( aa(list(A),nat,size_size(list(A)),Ys3) = Na ) ) ) ).

% Suc_length_conv
tff(fact_6837_length__Cons,axiom,
    ! [A: $tType,X: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),cons(A,X,Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_Cons
tff(fact_6838_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list(A),I2: nat,Y: A] : ( list_update(A,cons(A,X,Xs),aa(nat,nat,suc,I2),Y) = cons(A,X,list_update(A,Xs,I2,Y)) ) ).

% list_update_code(3)
tff(fact_6839_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: A] : ( list_update(A,cons(A,X,Xs),zero_zero(nat),Y) = cons(A,Y,Xs) ) ).

% list_update_code(2)
tff(fact_6840_replicate__Suc,axiom,
    ! [A: $tType,Na: nat,X: A] : ( replicate(A,aa(nat,nat,suc,Na),X) = cons(A,X,replicate(A,Na,X)) ) ).

% replicate_Suc
tff(fact_6841_impossible__Cons,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))
     => ( Xs != cons(A,X,Ys) ) ) ).

% impossible_Cons
tff(fact_6842_Suc__le__length__iff,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,Na)),aa(list(A),nat,size_size(list(A)),Xs))
    <=> ? [X5: A,Ys3: list(A)] :
          ( ( Xs = cons(A,X5,Ys3) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(list(A),nat,size_size(list(A)),Ys3)) ) ) ).

% Suc_le_length_iff
tff(fact_6843_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: A] :
      ( aa(A,nat,count_list(A,cons(A,X,Xs)),Y)
      = $ite(X = Y,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,count_list(A,Xs),Y)),one_one(nat)),aa(A,nat,count_list(A,Xs),Y)) ) ).

% count_list.simps(2)
tff(fact_6844_product__atMost__eq__Un,axiom,
    ! [A3: set(nat),M: nat] : ( product_Sigma(nat,nat,A3,aTP_Lamp_aaj(nat,fun(nat,set(nat)),M)) = aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),sup_sup(set(product_prod(nat,nat))),product_Sigma(nat,nat,A3,aTP_Lamp_aak(nat,fun(nat,set(nat)),M))),product_Sigma(nat,nat,A3,aTP_Lamp_aal(nat,fun(nat,set(nat)),M))) ) ).

% product_atMost_eq_Un
tff(fact_6845_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),nat,size_size(list(A)),cons(A,X21,X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),X222)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size(4)
tff(fact_6846_nth__Cons_H,axiom,
    ! [A: $tType,X: A,Xs: list(A),Na: nat] :
      ( aa(nat,A,nth(A,cons(A,X,Xs)),Na)
      = $ite(Na = zero_zero(nat),X,aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))) ) ).

% nth_Cons'
tff(fact_6847_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: fun(A,nat),X21: A,X222: list(A)] : ( size_list(A,X,cons(A,X21,X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,X,X21)),size_list(A,X,X222))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size_gen(2)
tff(fact_6848_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,I2)),J2)
     => ( linord4507533701916653071of_set(nat,set_or3652927894154168847AtMost(nat,I2,J2)) = cons(nat,aa(nat,nat,suc,I2),linord4507533701916653071of_set(nat,set_or3652927894154168847AtMost(nat,aa(nat,nat,suc,I2),J2))) ) ) ).

% sorted_list_of_set_greaterThanAtMost
tff(fact_6849_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I2)),J2)
     => ( linord4507533701916653071of_set(nat,set_or5935395276787703475ssThan(nat,I2,J2)) = cons(nat,aa(nat,nat,suc,I2),linord4507533701916653071of_set(nat,set_or5935395276787703475ssThan(nat,aa(nat,nat,suc,I2),J2))) ) ) ).

% sorted_list_of_set_greaterThanLessThan
tff(fact_6850_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs: list(A),Na: nat] :
      ( ~ member(A,X,aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
       => ( ( aa(nat,A,nth(A,cons(A,X,Xs)),Na) = X )
        <=> ( Na = zero_zero(nat) ) ) ) ) ).

% nth_equal_first_eq
tff(fact_6851_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list(A),Na: nat] :
      ( ( X != Y )
     => ( ( aa(nat,A,nth(A,cons(A,X,Xs)),Na) = Y )
      <=> ( ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat))) = Y )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ) ).

% nth_non_equal_first_eq
tff(fact_6852_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs: list(A),Na: nat,Y: A] :
      ( ( cons(A,X,Xs) = replicate(A,Na,Y) )
    <=> ( ( X = Y )
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
        & ( Xs = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),X) ) ) ) ).

% Cons_replicate_eq
tff(fact_6853_pairs__le__eq__Sigma,axiom,
    ! [M: nat] : ( collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_hu(nat,fun(nat,fun(nat,$o)),M))) = product_Sigma(nat,nat,set_ord_atMost(nat,M),aTP_Lamp_aak(nat,fun(nat,set(nat)),M)) ) ).

% pairs_le_eq_Sigma
tff(fact_6854_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list(A),Na: A,Ns: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),cons(A,M,Ms)),cons(A,Na,Ns)),lenlex(A,R2))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Ms)),aa(list(A),nat,size_size(list(A)),Ns))
        | ( ( aa(list(A),nat,size_size(list(A)),Ms) = aa(list(A),nat,size_size(list(A)),Ns) )
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,M),Na),R2) )
        | ( ( M = Na )
          & member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Ms),Ns),lenlex(A,R2)) ) ) ) ).

% Cons_lenlex_iff
tff(fact_6855_of__char__Char,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] : ( aa(char,A,comm_s6883823935334413003f_char(A),char2(B0,B1,B22,B32,B42,B52,B62,B72)) = aa(list($o),A,aa(A,fun(list($o),A),aa(fun($o,A),fun(A,fun(list($o),A)),groups4207007520872428315er_sum($o,A),zero_neq_one_of_bool(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),cons($o,B0,cons($o,B1,cons($o,B22,cons($o,B32,cons($o,B42,cons($o,B52,cons($o,B62,cons($o,B72,nil($o)))))))))) ) ) ).

% of_char_Char
tff(fact_6856_upto__aux__rec,axiom,
    ! [I2: int,J2: int,Js: list(int)] :
      ( upto_aux(I2,J2,Js)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I2),Js,upto_aux(I2,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)),cons(int,J2,Js))) ) ).

% upto_aux_rec
tff(fact_6857_length__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = zero_zero(nat) )
    <=> ( Xs = nil(A) ) ) ).

% length_0_conv
tff(fact_6858_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( aa(list(A),A,groups8242544230860333062m_list(A),nil(A)) = zero_zero(A) ) ) ).

% sum_list.Nil
tff(fact_6859_take0,axiom,
    ! [A: $tType,X4: list(A)] : ( take(A,zero_zero(nat),X4) = nil(A) ) ).

% take0
tff(fact_6860_take__eq__Nil,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( take(A,Na,Xs) = nil(A) )
    <=> ( ( Na = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil
tff(fact_6861_take__eq__Nil2,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( nil(A) = take(A,Na,Xs) )
    <=> ( ( Na = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil2
tff(fact_6862_empty__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( ( nil(A) = replicate(A,Na,X) )
    <=> ( Na = zero_zero(nat) ) ) ).

% empty_replicate
tff(fact_6863_replicate__empty,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( ( replicate(A,Na,X) = nil(A) )
    <=> ( Na = zero_zero(nat) ) ) ).

% replicate_empty
tff(fact_6864_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A2: A] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),nil(B)) = zero_zero(A) ) ) ).

% horner_sum_simps(1)
tff(fact_6865_n__lists__Nil,axiom,
    ! [A: $tType,Na: nat] :
      ( n_lists(A,Na,nil(A))
      = $ite(Na = zero_zero(nat),cons(list(A),nil(A),nil(list(A))),nil(list(A))) ) ).

% n_lists_Nil
tff(fact_6866_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs))
    <=> ( Xs != nil(A) ) ) ).

% length_greater_0_conv
tff(fact_6867_nths__singleton,axiom,
    ! [A: $tType,X: A,A3: set(nat)] :
      ( nths(A,cons(A,X,nil(A)),A3)
      = $ite(member(nat,zero_zero(nat),A3),cons(A,X,nil(A)),nil(A)) ) ).

% nths_singleton
tff(fact_6868_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list(A),Ys: list(B),Zs2: list(C),Ws2: list(D),P: fun(list(A),fun(list(B),fun(list(C),fun(list(D),$o))))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( ( aa(list(B),nat,size_size(list(B)),Ys) = aa(list(C),nat,size_size(list(C)),Zs2) )
       => ( ( aa(list(C),nat,size_size(list(C)),Zs2) = aa(list(D),nat,size_size(list(D)),Ws2) )
         => ( aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,nil(A)),nil(B)),nil(C)),nil(D))
           => ( ! [X3: A,Xs2: list(A),Y4: B,Ys4: list(B),Z2: C,Zs: list(C),W2: D,Ws: list(D)] :
                  ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys4) )
                 => ( ( aa(list(B),nat,size_size(list(B)),Ys4) = aa(list(C),nat,size_size(list(C)),Zs) )
                   => ( ( aa(list(C),nat,size_size(list(C)),Zs) = aa(list(D),nat,size_size(list(D)),Ws) )
                     => ( aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,Xs2),Ys4),Zs),Ws)
                       => aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,cons(A,X3,Xs2)),cons(B,Y4,Ys4)),cons(C,Z2,Zs)),cons(D,W2,Ws)) ) ) ) )
             => aa(list(D),$o,aa(list(C),fun(list(D),$o),aa(list(B),fun(list(C),fun(list(D),$o)),aa(list(A),fun(list(B),fun(list(C),fun(list(D),$o))),P,Xs),Ys),Zs2),Ws2) ) ) ) ) ) ).

% list_induct4
tff(fact_6869_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys: list(B),Zs2: list(C),P: fun(list(A),fun(list(B),fun(list(C),$o)))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( ( aa(list(B),nat,size_size(list(B)),Ys) = aa(list(C),nat,size_size(list(C)),Zs2) )
       => ( aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,nil(A)),nil(B)),nil(C))
         => ( ! [X3: A,Xs2: list(A),Y4: B,Ys4: list(B),Z2: C,Zs: list(C)] :
                ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys4) )
               => ( ( aa(list(B),nat,size_size(list(B)),Ys4) = aa(list(C),nat,size_size(list(C)),Zs) )
                 => ( aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,Xs2),Ys4),Zs)
                   => aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,cons(A,X3,Xs2)),cons(B,Y4,Ys4)),cons(C,Z2,Zs)) ) ) )
           => aa(list(C),$o,aa(list(B),fun(list(C),$o),aa(list(A),fun(list(B),fun(list(C),$o)),P,Xs),Ys),Zs2) ) ) ) ) ).

% list_induct3
tff(fact_6870_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),P: fun(list(A),fun(list(B),$o))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( aa(list(B),$o,aa(list(A),fun(list(B),$o),P,nil(A)),nil(B))
       => ( ! [X3: A,Xs2: list(A),Y4: B,Ys4: list(B)] :
              ( ( aa(list(A),nat,size_size(list(A)),Xs2) = aa(list(B),nat,size_size(list(B)),Ys4) )
             => ( aa(list(B),$o,aa(list(A),fun(list(B),$o),P,Xs2),Ys4)
               => aa(list(B),$o,aa(list(A),fun(list(B),$o),P,cons(A,X3,Xs2)),cons(B,Y4,Ys4)) ) )
         => aa(list(B),$o,aa(list(A),fun(list(B),$o),P,Xs),Ys) ) ) ) ).

% list_induct2
tff(fact_6871_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( n_lists(A,zero_zero(nat),Xs) = cons(list(A),nil(A),nil(list(A))) ) ).

% n_lists.simps(1)
tff(fact_6872_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] : ( aa(A,nat,count_list(A,nil(A)),Y) = zero_zero(nat) ) ).

% count_list.simps(1)
tff(fact_6873_take__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( take(A,zero_zero(nat),Xs) = nil(A) ) ).

% take_0
tff(fact_6874_replicate__0,axiom,
    ! [A: $tType,X: A] : ( replicate(A,zero_zero(nat),X) = nil(A) ) ).

% replicate_0
tff(fact_6875_list_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(list(A),nat,size_size(list(A)),nil(A)) = zero_zero(nat) ) ).

% list.size(3)
tff(fact_6876_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: fun(A,nat)] : ( size_list(A,X,nil(A)) = zero_zero(nat) ) ).

% list.size_gen(1)
tff(fact_6877_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ord(A)
     => order_mono(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)),aTP_Lamp_aam(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)))) ) ).

% lexordp.mono
tff(fact_6878_remdups__adj__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( remdups_adj(A,replicate(A,Na,X))
      = $ite(Na = zero_zero(nat),nil(A),cons(A,X,nil(A))) ) ).

% remdups_adj_replicate
tff(fact_6879_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list(A),X: A] :
      ( ( remdups_adj(A,Xs) = cons(A,X,nil(A)) )
     => ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),X) ) ) ).

% remdups_adj_singleton
tff(fact_6880_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))) ) ).

% remdups_adj_length_ge1
tff(fact_6881_take__Cons_H,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] :
      ( take(A,Na,cons(A,X,Xs))
      = $ite(Na = zero_zero(nat),nil(A),cons(A,X,take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),Xs))) ) ).

% take_Cons'
tff(fact_6882_concat__inth,axiom,
    ! [A: $tType,Xs: list(A),X: A,Ys: list(A)] : ( aa(nat,A,nth(A,append(A,Xs,append(A,cons(A,X,nil(A)),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) = X ) ).

% concat_inth
tff(fact_6883_Sigma__Diff__distrib2,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B)),B3: fun(A,set(B))] : ( product_Sigma(A,B,I5,aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_aan(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),A3),B3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,I5,A3)),product_Sigma(A,B,I5,B3)) ) ).

% Sigma_Diff_distrib2
tff(fact_6884_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Us: list(A),Vs: list(A)] :
      ( ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
        | ( aa(list(A),nat,size_size(list(A)),Us) = aa(list(A),nat,size_size(list(A)),Vs) ) )
     => ( ( append(A,Xs,Us) = append(A,Ys,Vs) )
      <=> ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
tff(fact_6885_length__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),nat,size_size(list(A)),append(A,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ).

% length_append
tff(fact_6886_sum__list__append,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A),Ys: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),append(A,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),aa(list(A),A,groups8242544230860333062m_list(A),Ys)) ) ) ).

% sum_list_append
tff(fact_6887_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Us: list(B),Ys: list(A),Vs: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Us) )
     => ( zip(A,B,append(A,Xs,Ys),append(B,Us,Vs)) = append(product_prod(A,B),zip(A,B,Xs,Us),zip(A,B,Ys,Vs)) ) ) ).

% zip_append
tff(fact_6888_size__list__append,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A),Ys: list(A)] : ( size_list(A,F2,append(A,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_list(A,F2,Xs)),size_list(A,F2,Ys)) ) ).

% size_list_append
tff(fact_6889_nth__append__length,axiom,
    ! [A: $tType,Xs: list(A),X: A,Ys: list(A)] : ( aa(nat,A,nth(A,append(A,Xs,cons(A,X,Ys))),aa(list(A),nat,size_size(list(A)),Xs)) = X ) ).

% nth_append_length
tff(fact_6890_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Na: nat] : ( aa(nat,A,nth(A,append(A,Xs,Ys)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na)) = aa(nat,A,nth(A,Ys),Na) ) ).

% nth_append_length_plus
tff(fact_6891_take__append,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),Ys: list(A)] : ( take(A,Na,append(A,Xs,Ys)) = append(A,take(A,Na,Xs),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% take_append
tff(fact_6892_list__update__length,axiom,
    ! [A: $tType,Xs: list(A),X: A,Ys: list(A),Y: A] : ( list_update(A,append(A,Xs,cons(A,X,Ys)),aa(list(A),nat,size_size(list(A)),Xs),Y) = append(A,Xs,cons(A,Y,Ys)) ) ).

% list_update_length
tff(fact_6893_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] : ( linord4507533701916653071of_set(nat,set_ord_lessThan(nat,aa(nat,nat,suc,K))) = append(nat,linord4507533701916653071of_set(nat,set_ord_lessThan(nat,K)),cons(nat,K,nil(nat))) ) ).

% sorted_list_of_set_lessThan_Suc
tff(fact_6894_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] : ( linord4507533701916653071of_set(nat,set_ord_atMost(nat,aa(nat,nat,suc,K))) = append(nat,linord4507533701916653071of_set(nat,set_ord_atMost(nat,K)),cons(nat,aa(nat,nat,suc,K),nil(nat))) ) ).

% sorted_list_of_set_atMost_Suc
tff(fact_6895_list__encode_Ocases,axiom,
    ! [X: list(nat)] :
      ( ( X != nil(nat) )
     => ~ ! [X3: nat,Xs2: list(nat)] : ( X != cons(nat,X3,Xs2) ) ) ).

% list_encode.cases
tff(fact_6896_rotate__append,axiom,
    ! [A: $tType,L: list(A),Q4: list(A)] : ( aa(list(A),list(A),rotate(A,aa(list(A),nat,size_size(list(A)),L)),append(A,L,Q4)) = append(A,Q4,L) ) ).

% rotate_append
tff(fact_6897_enumerate__append__eq,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),Ys: list(A)] : ( enumerate(A,Na,append(A,Xs,Ys)) = append(product_prod(nat,A),enumerate(A,Na,Xs),enumerate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% enumerate_append_eq
tff(fact_6898_replicate__add,axiom,
    ! [A: $tType,Na: nat,M: nat,X: A] : ( replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M),X) = append(A,replicate(A,Na,X),replicate(A,M,X)) ) ).

% replicate_add
tff(fact_6899_same__length__different,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != Ys )
     => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
       => ? [Pre: list(A),X3: A,Xs4: list(A),Y4: A,Ys5: list(A)] :
            ( ( X3 != Y4 )
            & ( Xs = append(A,Pre,append(A,cons(A,X3,nil(A)),Xs4)) )
            & ( Ys = append(A,Pre,append(A,cons(A,Y4,nil(A)),Ys5)) ) ) ) ) ).

% same_length_different
tff(fact_6900_list__update__append1,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),Ys: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( list_update(A,append(A,Xs,Ys),I2,X) = append(A,list_update(A,Xs,I2,X),Ys) ) ) ).

% list_update_append1
tff(fact_6901_lexord__sufE,axiom,
    ! [A: $tType,Xs: list(A),Zs2: list(A),Ys: list(A),Qs: list(A),R2: set(product_prod(A,A))] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),append(A,Xs,Zs2)),append(A,Ys,Qs)),lexord(A,R2))
     => ( ( Xs != Ys )
       => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),Ys) )
         => ( ( aa(list(A),nat,size_size(list(A)),Zs2) = aa(list(A),nat,size_size(list(A)),Qs) )
           => member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),lexord(A,R2)) ) ) ) ) ).

% lexord_sufE
tff(fact_6902_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R2: set(product_prod(A,A)),Vs: list(A),Us: list(A)] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),lex(A,R2))
     => ( ( aa(list(A),nat,size_size(list(A)),Vs) = aa(list(A),nat,size_size(list(A)),Us) )
       => member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),append(A,Xs,Us)),append(A,Ys,Vs)),lex(A,R2)) ) ) ).

% lex_append_rightI
tff(fact_6903_lenlex__append1,axiom,
    ! [A: $tType,Us: list(A),Xs: list(A),R3: set(product_prod(A,A)),Vs: list(A),Ys: list(A)] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Us),Xs),lenlex(A,R3))
     => ( ( aa(list(A),nat,size_size(list(A)),Vs) = aa(list(A),nat,size_size(list(A)),Ys) )
       => member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),append(A,Us,Vs)),append(A,Xs,Ys)),lenlex(A,R3)) ) ) ).

% lenlex_append1
tff(fact_6904_nths__append,axiom,
    ! [A: $tType,L: list(A),L5: list(A),A3: set(nat)] : ( nths(A,append(A,L,L5),A3) = append(A,nths(A,L,A3),nths(A,L5,collect(nat,aa(set(nat),fun(nat,$o),aTP_Lamp_aao(list(A),fun(set(nat),fun(nat,$o)),L),A3)))) ) ).

% nths_append
tff(fact_6905_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,Na) )
    <=> ? [Y5: A,Ys3: list(A)] :
          ( ( Xs = append(A,Ys3,cons(A,Y5,nil(A))) )
          & ( aa(list(A),nat,size_size(list(A)),Ys3) = Na ) ) ) ).

% length_Suc_conv_rev
tff(fact_6906_length__append__singleton,axiom,
    ! [A: $tType,Xs: list(A),X: A] : ( aa(list(A),nat,size_size(list(A)),append(A,Xs,cons(A,X,nil(A)))) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_append_singleton
tff(fact_6907_nth__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Na: nat] :
      ( aa(nat,A,nth(A,append(A,Xs,Ys)),Na)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,A,nth(A,Xs),Na),aa(nat,A,nth(A,Ys),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)))) ) ).

% nth_append
tff(fact_6908_list__update__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Na: nat,X: A] :
      ( list_update(A,append(A,Xs,Ys),Na,X)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)),append(A,list_update(A,Xs,Na,X),Ys),append(A,Xs,list_update(A,Ys,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)),X))) ) ).

% list_update_append
tff(fact_6909_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != nil(A) )
     => ( ( Ys != nil(A) )
       => ( ( append(A,Xs,Ys) = append(A,Ys,Xs) )
         => ? [N: nat,Zs: list(A)] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),N)
              & ( concat(A,replicate(list(A),N,Zs)) = append(A,Xs,Ys) ) ) ) ) ) ).

% comm_append_is_replicate
tff(fact_6910_lexord__sufI,axiom,
    ! [A: $tType,U: list(A),W: list(A),R2: set(product_prod(A,A)),V: list(A),Z: list(A)] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),U),W),lexord(A,R2))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),W)),aa(list(A),nat,size_size(list(A)),U))
       => member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),append(A,U,V)),append(A,W,Z)),lexord(A,R2)) ) ) ).

% lexord_sufI
tff(fact_6911_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F2: fun(B,A),A2: A,Xs: list(B),Ys: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),append(B,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),Xs)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(list(B),nat,size_size(list(B)),Xs))),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),Ys))) ) ) ).

% horner_sum_append
tff(fact_6912_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list(A),A3: set(nat)] :
      ( nths(A,cons(A,X,L),A3)
      = append(A,$ite(member(nat,zero_zero(nat),A3),cons(A,X,nil(A)),nil(A)),nths(A,L,collect(nat,aTP_Lamp_aap(set(nat),fun(nat,$o),A3)))) ) ).

% nths_Cons
tff(fact_6913_lex__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lex(A,R2) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),$o,aTP_Lamp_aaq(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),R2))) ) ).

% lex_conv
tff(fact_6914_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I2: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( take(A,aa(nat,nat,suc,I2),Xs) = append(A,take(A,I2,Xs),cons(A,aa(nat,A,nth(A,Xs),I2),nil(A))) ) ) ).

% take_Suc_conv_app_nth
tff(fact_6915_Sigma__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,I5: set(A),J4: set(A),C6: fun(A,set(B))] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),J4),C6) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,I5,C6)),product_Sigma(A,B,J4,C6)) ) ).

% Sigma_Diff_distrib1
tff(fact_6916_Times__Diff__distrib1,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: set(A),C6: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3),aTP_Lamp_aai(set(B),fun(A,set(B)),C6)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_aai(set(B),fun(A,set(B)),C6))),product_Sigma(A,B,B3,aTP_Lamp_aai(set(B),fun(A,set(B)),C6))) ) ).

% Times_Diff_distrib1
tff(fact_6917_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list(A),Na: nat,X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
       => ( ( M != Na )
         => ( aa(nat,A,nth(A,append(A,take(A,Na,Xs),append(A,cons(A,X,nil(A)),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),one_one(nat)),Xs)))),M) = aa(nat,A,nth(A,Xs),M) ) ) ) ) ).

% nth_repl
tff(fact_6918_pos__n__replace,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),Y: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),append(A,take(A,Na,Xs),append(A,cons(A,Y,nil(A)),drop(A,aa(nat,nat,suc,Na),Xs)))) ) ) ).

% pos_n_replace
tff(fact_6919_drop0,axiom,
    ! [A: $tType,X4: list(A)] : ( drop(A,zero_zero(nat),X4) = X4 ) ).

% drop0
tff(fact_6920_drop__drop,axiom,
    ! [A: $tType,Na: nat,M: nat,Xs: list(A)] : ( drop(A,Na,drop(A,M,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M),Xs) ) ).

% drop_drop
tff(fact_6921_drop__Suc__Cons,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,Na),cons(A,X,Xs)) = drop(A,Na,Xs) ) ).

% drop_Suc_Cons
tff(fact_6922_length__drop,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),drop(A,Na,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na) ) ).

% length_drop
tff(fact_6923_drop__update__cancel,axiom,
    ! [A: $tType,Na: nat,M: nat,Xs: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M)
     => ( drop(A,M,list_update(A,Xs,Na,X)) = drop(A,M,Xs) ) ) ).

% drop_update_cancel
tff(fact_6924_drop__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] : ( drop(A,I2,replicate(A,K,X)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I2),X) ) ).

% drop_replicate
tff(fact_6925_drop__all,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na)
     => ( drop(A,Na,Xs) = nil(A) ) ) ).

% drop_all
tff(fact_6926_drop__eq__Nil,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( drop(A,Na,Xs) = nil(A) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na) ) ).

% drop_eq_Nil
tff(fact_6927_drop__eq__Nil2,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( ( nil(A) = drop(A,Na,Xs) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na) ) ).

% drop_eq_Nil2
tff(fact_6928_drop__append,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),Ys: list(A)] : ( drop(A,Na,append(A,Xs,Ys)) = append(A,drop(A,Na,Xs),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% drop_append
tff(fact_6929_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs: list(A)] : ( drop(A,aa(num,nat,numeral_numeral(nat),V),cons(A,X,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs) ) ).

% drop_Cons_numeral
tff(fact_6930_nth__drop,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),I2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,drop(A,Na,Xs)),I2) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),I2)) ) ) ).

% nth_drop
tff(fact_6931_drop__take,axiom,
    ! [A: $tType,Na: nat,M: nat,Xs: list(A)] : ( drop(A,Na,take(A,M,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),Na),drop(A,Na,Xs)) ) ).

% drop_take
tff(fact_6932_drop__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( drop(A,zero_zero(nat),Xs) = Xs ) ).

% drop_0
tff(fact_6933_take__drop,axiom,
    ! [A: $tType,Na: nat,M: nat,Xs: list(A)] : ( take(A,Na,drop(A,M,Xs)) = drop(A,M,take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M),Xs)) ) ).

% take_drop
tff(fact_6934_take__add,axiom,
    ! [A: $tType,I2: nat,J2: nat,Xs: list(A)] : ( take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),J2),Xs) = append(A,take(A,I2,Xs),take(A,J2,drop(A,I2,Xs))) ) ).

% take_add
tff(fact_6935_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ( append(A,Xs,Ys) = Zs2 )
    <=> ( ( Xs = take(A,aa(list(A),nat,size_size(list(A)),Xs),Zs2) )
        & ( Ys = drop(A,aa(list(A),nat,size_size(list(A)),Xs),Zs2) ) ) ) ).

% append_eq_conv_conj
tff(fact_6936_drop__update__swap,axiom,
    ! [A: $tType,M: nat,Na: nat,Xs: list(A),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
     => ( drop(A,M,list_update(A,Xs,Na,X)) = list_update(A,drop(A,M,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M),X) ) ) ).

% drop_update_swap
tff(fact_6937_nths__drop,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),I5: set(nat)] : ( nths(A,drop(A,Na,Xs),I5) = nths(A,Xs,image(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),I5)) ) ).

% nths_drop
tff(fact_6938_drop__Cons_H,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] :
      ( drop(A,Na,cons(A,X,Xs))
      = $ite(Na = zero_zero(nat),cons(A,X,Xs),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),Xs)) ) ).

% drop_Cons'
tff(fact_6939_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list(A),Xs_2: list(A),Ys_1: list(A),Ys_2: list(A)] :
      ( ( append(A,Xs_1,Xs_2) = append(A,Ys_1,Ys_2) )
    <=> $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs_1)),aa(list(A),nat,size_size(list(A)),Ys_1)),
          ( ( Xs_1 = take(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1) )
          & ( Xs_2 = append(A,drop(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1),Ys_2) ) ),
          ( ( take(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1) = Ys_1 )
          & ( append(A,drop(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1),Xs_2) = Ys_2 ) ) ) ) ).

% append_eq_append_conv_if
tff(fact_6940_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(A),Zs2: list(B)] : ( zip(A,B,append(A,Xs,Ys),Zs2) = append(product_prod(A,B),zip(A,B,Xs,take(B,aa(list(A),nat,size_size(list(A)),Xs),Zs2)),zip(A,B,Ys,drop(B,aa(list(A),nat,size_size(list(A)),Xs),Zs2))) ) ).

% zip_append1
tff(fact_6941_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Zs2: list(B)] : ( zip(A,B,Xs,append(B,Ys,Zs2)) = append(product_prod(A,B),zip(A,B,take(A,aa(list(B),nat,size_size(list(B)),Ys),Xs),Ys),zip(A,B,drop(A,aa(list(B),nat,size_size(list(B)),Ys),Xs),Zs2)) ) ).

% zip_append2
tff(fact_6942_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I2: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( cons(A,aa(nat,A,nth(A,Xs),I2),drop(A,aa(nat,nat,suc,I2),Xs)) = drop(A,I2,Xs) ) ) ).

% Cons_nth_drop_Suc
tff(fact_6943_rotate__drop__take,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,Na),Xs) = append(A,drop(A,modulo_modulo(nat,Na,aa(list(A),nat,size_size(list(A)),Xs)),Xs),take(A,modulo_modulo(nat,Na,aa(list(A),nat,size_size(list(A)),Xs)),Xs)) ) ).

% rotate_drop_take
tff(fact_6944_id__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( Xs = append(A,take(A,I2,Xs),cons(A,aa(nat,A,nth(A,Xs),I2),drop(A,aa(nat,nat,suc,I2),Xs))) ) ) ).

% id_take_nth_drop
tff(fact_6945_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list(A),A2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
     => ( list_update(A,Xs,I2,A2) = append(A,take(A,I2,Xs),cons(A,A2,drop(A,aa(nat,nat,suc,I2),Xs))) ) ) ).

% upd_conv_take_nth_drop
tff(fact_6946_lexn__conv,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Na: nat] : ( lexn(A,R2,Na) = collect(product_prod(list(A),list(A)),product_case_prod(list(A),list(A),$o,aa(nat,fun(list(A),fun(list(A),$o)),aTP_Lamp_aar(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),$o))),R2),Na))) ) ).

% lexn_conv
tff(fact_6947_list__encode_Oelims,axiom,
    ! [X: list(nat),Y: nat] :
      ( ( aa(list(nat),nat,nat_list_encode,X) = Y )
     => ( ( ( X = nil(nat) )
         => ( Y != zero_zero(nat) ) )
       => ~ ! [X3: nat,Xs2: list(nat)] :
              ( ( X = cons(nat,X3,Xs2) )
             => ( Y != aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),aa(list(nat),nat,nat_list_encode,Xs2)))) ) ) ) ) ).

% list_encode.elims
tff(fact_6948_list__encode__eq,axiom,
    ! [X: list(nat),Y: list(nat)] :
      ( ( aa(list(nat),nat,nat_list_encode,X) = aa(list(nat),nat,nat_list_encode,Y) )
    <=> ( X = Y ) ) ).

% list_encode_eq
tff(fact_6949_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lexn(A,R2,zero_zero(nat)) = bot_bot(set(product_prod(list(A),list(A)))) ) ).

% lexn.simps(1)
tff(fact_6950_surj__list__encode,axiom,
    image(list(nat),nat,nat_list_encode,top_top(set(list(nat)))) = top_top(set(nat)) ).

% surj_list_encode
tff(fact_6951_bij__list__encode,axiom,
    bij_betw(list(nat),nat,nat_list_encode,top_top(set(list(nat))),top_top(set(nat))) ).

% bij_list_encode
tff(fact_6952_inj__list__encode,axiom,
    ! [A3: set(list(nat))] : inj_on(list(nat),nat,nat_list_encode,A3) ).

% inj_list_encode
tff(fact_6953_list__encode_Osimps_I1_J,axiom,
    aa(list(nat),nat,nat_list_encode,nil(nat)) = zero_zero(nat) ).

% list_encode.simps(1)
tff(fact_6954_lexn__length,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R2: set(product_prod(A,A)),Na: nat] :
      ( member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),lexn(A,R2,Na))
     => ( ( aa(list(A),nat,size_size(list(A)),Xs) = Na )
        & ( aa(list(A),nat,size_size(list(A)),Ys) = Na ) ) ) ).

% lexn_length
tff(fact_6955_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs: list(nat)] : ( aa(list(nat),nat,nat_list_encode,cons(nat,X,Xs)) = aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),aa(list(nat),nat,nat_list_encode,Xs)))) ) ).

% list_encode.simps(2)
tff(fact_6956_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list(int)] :
      ( ( upto(X,Xa) = Y )
     => ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),product_Pair(int,int,X),Xa))
       => ~ ( ( Y
              = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),Xa),cons(int,X,upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X),one_one(int)),Xa)),nil(int)) )
           => ~ accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),product_Pair(int,int,X),Xa)) ) ) ) ).

% upto.pelims
tff(fact_6957_upto_Opsimps,axiom,
    ! [I2: int,J2: int] :
      ( accp(product_prod(int,int),upto_rel,aa(int,product_prod(int,int),product_Pair(int,int,I2),J2))
     => ( upto(I2,J2)
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2),cons(int,I2,upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2)),nil(int)) ) ) ).

% upto.psimps
tff(fact_6958_upto__Nil,axiom,
    ! [I2: int,J2: int] :
      ( ( upto(I2,J2) = nil(int) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I2) ) ).

% upto_Nil
tff(fact_6959_upto__Nil2,axiom,
    ! [I2: int,J2: int] :
      ( ( nil(int) = upto(I2,J2) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I2) ) ).

% upto_Nil2
tff(fact_6960_upto__empty,axiom,
    ! [J2: int,I2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I2)
     => ( upto(I2,J2) = nil(int) ) ) ).

% upto_empty
tff(fact_6961_length__upto,axiom,
    ! [I2: int,J2: int] : ( aa(list(int),nat,size_size(list(int)),upto(I2,J2)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),I2)),one_one(int))) ) ).

% length_upto
tff(fact_6962_upto__rec__numeral_I1_J,axiom,
    ! [M: num,Na: num] :
      ( upto(aa(num,int,numeral_numeral(int),M),aa(num,int,numeral_numeral(int),Na))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),Na)),cons(int,aa(num,int,numeral_numeral(int),M),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),M)),one_one(int)),aa(num,int,numeral_numeral(int),Na))),nil(int)) ) ).

% upto_rec_numeral(1)
tff(fact_6963_upto__rec__numeral_I4_J,axiom,
    ! [M: num,Na: num] :
      ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na)))),nil(int)) ) ).

% upto_rec_numeral(4)
tff(fact_6964_upto__rec__numeral_I3_J,axiom,
    ! [M: num,Na: num] :
      ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),Na))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),Na)),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),one_one(int)),aa(num,int,numeral_numeral(int),Na))),nil(int)) ) ).

% upto_rec_numeral(3)
tff(fact_6965_upto__rec__numeral_I2_J,axiom,
    ! [M: num,Na: num] :
      ( upto(aa(num,int,numeral_numeral(int),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na))),cons(int,aa(num,int,numeral_numeral(int),M),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),M)),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Na)))),nil(int)) ) ).

% upto_rec_numeral(2)
tff(fact_6966_upto__split2,axiom,
    ! [I2: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J2),K)
       => ( upto(I2,K) = append(int,upto(I2,J2),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J2),one_one(int)),K)) ) ) ) ).

% upto_split2
tff(fact_6967_upto__split1,axiom,
    ! [I2: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J2),K)
       => ( upto(I2,K) = append(int,upto(I2,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int))),upto(J2,K)) ) ) ) ).

% upto_split1
tff(fact_6968_atLeastLessThan__upto,axiom,
    ! [I2: int,J2: int] : ( set_or7035219750837199246ssThan(int,I2,J2) = aa(list(int),set(int),set2(int),upto(I2,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))) ) ).

% atLeastLessThan_upto
tff(fact_6969_greaterThanAtMost__upto,axiom,
    ! [I2: int,J2: int] : ( set_or3652927894154168847AtMost(int,I2,J2) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2)) ) ).

% greaterThanAtMost_upto
tff(fact_6970_upto__rec1,axiom,
    ! [I2: int,J2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2)
     => ( upto(I2,J2) = cons(int,I2,upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2)) ) ) ).

% upto_rec1
tff(fact_6971_upto_Oelims,axiom,
    ! [X: int,Xa: int,Y: list(int)] :
      ( ( upto(X,Xa) = Y )
     => ( Y
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),Xa),cons(int,X,upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X),one_one(int)),Xa)),nil(int)) ) ) ).

% upto.elims
tff(fact_6972_upto_Osimps,axiom,
    ! [I2: int,J2: int] :
      ( upto(I2,J2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2),cons(int,I2,upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),J2)),nil(int)) ) ).

% upto.simps
tff(fact_6973_upto__rec2,axiom,
    ! [I2: int,J2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2)
     => ( upto(I2,J2) = append(int,upto(I2,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int))),cons(int,J2,nil(int))) ) ) ).

% upto_rec2
tff(fact_6974_greaterThanLessThan__upto,axiom,
    ! [I2: int,J2: int] : ( set_or5935395276787703475ssThan(int,I2,J2) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int)),aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int)))) ) ).

% greaterThanLessThan_upto
tff(fact_6975_upto__split3,axiom,
    ! [I2: int,J2: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J2),K)
       => ( upto(I2,K) = append(int,upto(I2,aa(int,int,aa(int,fun(int,int),minus_minus(int),J2),one_one(int))),cons(int,J2,upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J2),one_one(int)),K))) ) ) ) ).

% upto_split3
tff(fact_6976_take__hd__drop,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( append(A,take(A,Na,Xs),cons(A,hd(A,drop(A,Na,Xs)),nil(A))) = take(A,aa(nat,nat,suc,Na),Xs) ) ) ).

% take_hd_drop
tff(fact_6977_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),M: fun(A,option(B)),X: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys))
     => ( map_upds(A,B,M,append(A,Xs,cons(A,X,nil(A))),Ys) = fun_upd(A,option(B),map_upds(A,B,M,Xs,Ys),X,some(B,aa(nat,B,nth(B,Ys),aa(list(A),nat,size_size(list(A)),Xs)))) ) ) ).

% map_upds_append1
tff(fact_6978_hd__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( ( Na != zero_zero(nat) )
     => ( hd(A,replicate(A,Na,X)) = X ) ) ).

% hd_replicate
tff(fact_6979_fun__upds__append2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),M: fun(A,option(B)),Zs2: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( map_upds(A,B,M,Xs,append(B,Ys,Zs2)) = map_upds(A,B,M,Xs,Ys) ) ) ).

% fun_upds_append2_drop
tff(fact_6980_fun__upds__append__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),M: fun(A,option(B)),Zs2: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( map_upds(A,B,M,append(A,Xs,Zs2),Ys) = map_upds(A,B,M,Xs,Ys) ) ) ).

% fun_upds_append_drop
tff(fact_6981_hd__take,axiom,
    ! [A: $tType,J2: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),J2)
     => ( hd(A,take(A,J2,Xs)) = hd(A,Xs) ) ) ).

% hd_take
tff(fact_6982_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),I2: nat,M: fun(A,option(B)),Ys: list(B),Y: B] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),I2)
     => ( map_upds(A,B,M,Xs,list_update(B,Ys,I2,Y)) = map_upds(A,B,M,Xs,Ys) ) ) ).

% map_upds_list_update2_drop
tff(fact_6983_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( hd(A,Xs) = aa(nat,A,nth(A,Xs),zero_zero(nat)) ) ) ).

% hd_conv_nth
tff(fact_6984_map__upd__upds__conv__if,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,option(B)),X: A,Y: B,Xs: list(A),Ys: list(B)] :
      ( map_upds(A,B,fun_upd(A,option(B),F2,X,some(B,Y)),Xs,Ys)
      = $ite(member(A,X,aa(list(A),set(A),set2(A),take(A,aa(list(B),nat,size_size(list(B)),Ys),Xs))),map_upds(A,B,F2,Xs,Ys),fun_upd(A,option(B),map_upds(A,B,F2,Xs,Ys),X,some(B,Y))) ) ).

% map_upd_upds_conv_if
tff(fact_6985_hd__drop__conv__nth,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( hd(A,drop(A,Na,Xs)) = aa(nat,A,nth(A,Xs),Na) ) ) ).

% hd_drop_conv_nth
tff(fact_6986_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( ( Xs != nil(A) )
     => ( hd(A,aa(list(A),list(A),rotate(A,Na),Xs)) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,Na,aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% hd_rotate_conv_nth
tff(fact_6987_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( Xs != nil(A) )
        & ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),hd(A,Xs)) ) ) ) ).

% remdups_adj_singleton_iff
tff(fact_6988_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),D5: set(A),M: fun(A,option(B))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),D5)
       => ( restrict_map(A,B,map_upds(A,B,M,Xs,Ys),D5) = map_upds(A,B,restrict_map(A,B,M,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D5),aa(list(A),set(A),set2(A),Xs))),Xs,Ys) ) ) ) ).

% restrict_map_upds
tff(fact_6989_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,M: fun(A,option(B)),D5: set(A),X: A] :
      ( fun_upd(A,option(B),restrict_map(A,B,M,D5),X,none(B))
      = $ite(member(A,X,D5),restrict_map(A,B,M,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D5),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),restrict_map(A,B,M,D5)) ) ).

% fun_upd_None_restrict
tff(fact_6990_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,M: fun(A,option(B)),X: A,Y: option(B),D5: set(A)] :
      ( restrict_map(A,B,fun_upd(A,option(B),M,X,Y),D5)
      = $ite(member(A,X,D5),fun_upd(A,option(B),restrict_map(A,B,M,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D5),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),X,Y),restrict_map(A,B,M,D5)) ) ).

% restrict_fun_upd
tff(fact_6991_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X: A,D5: set(A),M: fun(A,option(B)),Y: option(B)] :
      ( member(A,X,D5)
     => ( fun_upd(A,option(B),restrict_map(A,B,M,D5),X,Y) = fun_upd(A,option(B),restrict_map(A,B,M,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D5),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),X,Y) ) ) ).

% fun_upd_restrict_conv
tff(fact_6992_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M: fun(A,option(B)),D5: set(A),X: A,Y: option(B)] : ( fun_upd(A,option(B),restrict_map(A,B,M,D5),X,Y) = fun_upd(A,option(B),restrict_map(A,B,M,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D5),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))),X,Y) ) ).

% fun_upd_restrict
tff(fact_6993_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] :
      ( size_list(A,F2,Xs)
      = $ite(Xs = nil(A),zero_zero(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F2,hd(A,Xs))),size_list(A,F2,tl(A,Xs))))) ) ).

% Nitpick.size_list_simp(1)
tff(fact_6994_map__of__zip__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),I2: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( distinct(A,Xs)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(B),nat,size_size(list(B)),Ys))
         => ( aa(A,option(B),map_of(A,B,zip(A,B,Xs,Ys)),aa(nat,A,nth(A,Xs),I2)) = some(B,aa(nat,B,nth(B,Ys),I2)) ) ) ) ) ).

% map_of_zip_nth
tff(fact_6995_length__tl,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),tl(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) ).

% length_tl
tff(fact_6996_tl__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] : ( tl(A,replicate(A,Na,X)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),X) ) ).

% tl_replicate
tff(fact_6997_map__of__zip__is__None,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),X: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( ( aa(A,option(B),map_of(A,B,zip(A,B,Xs,Ys)),X) = none(B) )
      <=> ~ member(A,X,aa(list(A),set(A),set2(A),Xs)) ) ) ).

% map_of_zip_is_None
tff(fact_6998_drop__Suc,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,Na),Xs) = drop(A,Na,tl(A,Xs)) ) ).

% drop_Suc
tff(fact_6999_take__tl,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( take(A,Na,tl(A,Xs)) = tl(A,take(A,aa(nat,nat,suc,Na),Xs)) ) ).

% take_tl
tff(fact_7000_tl__take,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( tl(A,take(A,Na,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),tl(A,Xs)) ) ).

% tl_take
tff(fact_7001_map__of__zip__inject,axiom,
    ! [B: $tType,A: $tType,Ys: list(A),Xs: list(B),Zs2: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Ys) = aa(list(B),nat,size_size(list(B)),Xs) )
     => ( ( aa(list(A),nat,size_size(list(A)),Zs2) = aa(list(B),nat,size_size(list(B)),Xs) )
       => ( distinct(B,Xs)
         => ( ( map_of(B,A,zip(B,A,Xs,Ys)) = map_of(B,A,zip(B,A,Xs,Zs2)) )
           => ( Ys = Zs2 ) ) ) ) ) ).

% map_of_zip_inject
tff(fact_7002_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(list(A),nat,size_size(list(A)),Xs)
      = $ite(Xs = nil(A),zero_zero(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),tl(A,Xs)))) ) ).

% Nitpick.size_list_simp(2)
tff(fact_7003_nth__tl,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),tl(A,Xs)))
     => ( aa(nat,A,nth(A,tl(A,Xs)),Na) = aa(nat,A,nth(A,Xs),aa(nat,nat,suc,Na)) ) ) ).

% nth_tl
tff(fact_7004_map__of__zip__is__Some,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),X: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( member(A,X,aa(list(A),set(A),set2(A),Xs))
      <=> ? [Y5: B] : ( aa(A,option(B),map_of(A,B,zip(A,B,Xs,Ys)),X) = some(B,Y5) ) ) ) ).

% map_of_zip_is_Some
tff(fact_7005_take__Suc,axiom,
    ! [A: $tType,Xs: list(A),Na: nat] :
      ( ( Xs != nil(A) )
     => ( take(A,aa(nat,nat,suc,Na),Xs) = cons(A,hd(A,Xs),take(A,Na,tl(A,Xs))) ) ) ).

% take_Suc
tff(fact_7006_map__of__zip__upd,axiom,
    ! [B: $tType,A: $tType,Ys: list(A),Xs: list(B),Zs2: list(A),X: B,Y: A,Z: A] :
      ( ( aa(list(A),nat,size_size(list(A)),Ys) = aa(list(B),nat,size_size(list(B)),Xs) )
     => ( ( aa(list(A),nat,size_size(list(A)),Zs2) = aa(list(B),nat,size_size(list(B)),Xs) )
       => ( ~ member(B,X,aa(list(B),set(B),set2(B),Xs))
         => ( ( fun_upd(B,option(A),map_of(B,A,zip(B,A,Xs,Ys)),X,some(A,Y)) = fun_upd(B,option(A),map_of(B,A,zip(B,A,Xs,Zs2)),X,some(A,Z)) )
           => ( map_of(B,A,zip(B,A,Xs,Ys)) = map_of(B,A,zip(B,A,Xs,Zs2)) ) ) ) ) ) ).

% map_of_zip_upd
tff(fact_7007_ran__map__of__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( distinct(A,Xs)
       => ( ran(A,B,map_of(A,B,zip(A,B,Xs,Ys))) = aa(list(B),set(B),set2(B),Ys) ) ) ) ).

% ran_map_of_zip
tff(fact_7008_list__encode_Opelims,axiom,
    ! [X: list(nat),Y: nat] :
      ( ( aa(list(nat),nat,nat_list_encode,X) = Y )
     => ( accp(list(nat),nat_list_encode_rel,X)
       => ( ( ( X = nil(nat) )
           => ( ( Y = zero_zero(nat) )
             => ~ accp(list(nat),nat_list_encode_rel,nil(nat)) ) )
         => ~ ! [X3: nat,Xs2: list(nat)] :
                ( ( X = cons(nat,X3,Xs2) )
               => ( ( Y = aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),aa(list(nat),nat,nat_list_encode,Xs2)))) )
                 => ~ accp(list(nat),nat_list_encode_rel,cons(nat,X3,Xs2)) ) ) ) ) ) ).

% list_encode.pelims
tff(fact_7009_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M: fun(B,option(A)),X: B,Y: A,Z: A] :
      ( ( aa(B,option(A),M,X) = some(A,Y) )
     => ( inj_on(B,option(A),M,dom(B,A,M))
       => ( ~ member(A,Z,ran(B,A,M))
         => ( ran(B,A,fun_upd(B,option(A),M,X,some(A,Z))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),ran(B,A,M)),aa(set(A),set(A),insert(A,Y),bot_bot(set(A))))),aa(set(A),set(A),insert(A,Z),bot_bot(set(A)))) ) ) ) ) ).

% ran_map_upd_Some
tff(fact_7010_upt__rec__numeral,axiom,
    ! [M: num,Na: num] :
      ( upt(aa(num,nat,numeral_numeral(nat),M),aa(num,nat,numeral_numeral(nat),Na))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),Na)),cons(nat,aa(num,nat,numeral_numeral(nat),M),upt(aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),Na))),nil(nat)) ) ).

% upt_rec_numeral
tff(fact_7011_tl__upt,axiom,
    ! [M: nat,Na: nat] : ( tl(nat,upt(M,Na)) = upt(aa(nat,nat,suc,M),Na) ) ).

% tl_upt
tff(fact_7012_hd__upt,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( hd(nat,upt(I2,J2)) = I2 ) ) ).

% hd_upt
tff(fact_7013_drop__upt,axiom,
    ! [M: nat,I2: nat,J2: nat] : ( drop(nat,M,upt(I2,J2)) = upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),M),J2) ) ).

% drop_upt
tff(fact_7014_take__upt,axiom,
    ! [I2: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),M)),Na)
     => ( take(nat,M,upt(I2,Na)) = upt(I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),M)) ) ) ).

% take_upt
tff(fact_7015_length__upt,axiom,
    ! [I2: nat,J2: nat] : ( aa(list(nat),nat,size_size(list(nat)),upt(I2,J2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),I2) ) ).

% length_upt
tff(fact_7016_upt__eq__Nil__conv,axiom,
    ! [I2: nat,J2: nat] :
      ( ( upt(I2,J2) = nil(nat) )
    <=> ( ( J2 = zero_zero(nat) )
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I2) ) ) ).

% upt_eq_Nil_conv
tff(fact_7017_nth__upt,axiom,
    ! [I2: nat,K: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K)),J2)
     => ( aa(nat,nat,nth(nat,upt(I2,J2)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),K) ) ) ).

% nth_upt
tff(fact_7018_dom__map__of__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( dom(A,B,map_of(A,B,zip(A,B,Xs,Ys))) = aa(list(A),set(A),set2(A),Xs) ) ) ).

% dom_map_of_zip
tff(fact_7019_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,option(B)),X: A,Y: option(B)] :
      ( dom(A,B,fun_upd(A,option(B),F2,X,Y))
      = $ite(Y = none(B),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),dom(A,B,F2)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))),aa(set(A),set(A),insert(A,X),dom(A,B,F2))) ) ).

% dom_fun_upd
tff(fact_7020_dom__map__upds,axiom,
    ! [B: $tType,A: $tType,M: fun(A,option(B)),Xs: list(A),Ys: list(B)] : ( dom(A,B,map_upds(A,B,M,Xs,Ys)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),take(A,aa(list(B),nat,size_size(list(B)),Ys),Xs))),dom(A,B,M)) ) ).

% dom_map_upds
tff(fact_7021_upt__0,axiom,
    ! [I2: nat] : ( upt(I2,zero_zero(nat)) = nil(nat) ) ).

% upt_0
tff(fact_7022_upt__conv__Cons__Cons,axiom,
    ! [M: nat,Na: nat,Ns: list(nat),Q4: nat] :
      ( ( cons(nat,M,cons(nat,Na,Ns)) = upt(M,Q4) )
    <=> ( cons(nat,Na,Ns) = upt(aa(nat,nat,suc,M),Q4) ) ) ).

% upt_conv_Cons_Cons
tff(fact_7023_greaterThanLessThan__upt,axiom,
    ! [Na: nat,M: nat] : ( set_or5935395276787703475ssThan(nat,Na,M) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,Na),M)) ) ).

% greaterThanLessThan_upt
tff(fact_7024_greaterThanAtMost__upt,axiom,
    ! [Na: nat,M: nat] : ( set_or3652927894154168847AtMost(nat,Na,M) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,Na),aa(nat,nat,suc,M))) ) ).

% greaterThanAtMost_upt
tff(fact_7025_atLeastAtMost__upt,axiom,
    ! [Na: nat,M: nat] : ( set_or1337092689740270186AtMost(nat,Na,M) = aa(list(nat),set(nat),set2(nat),upt(Na,aa(nat,nat,suc,M))) ) ).

% atLeastAtMost_upt
tff(fact_7026_atLeast__upt,axiom,
    ! [Na: nat] : ( set_ord_lessThan(nat,Na) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),Na)) ) ).

% atLeast_upt
tff(fact_7027_dom__minus,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,option(A)),X: B,A3: set(B)] :
      ( ( aa(B,option(A),F2,X) = none(A) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),dom(B,A,F2)),aa(set(B),set(B),insert(B,X),A3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),dom(B,A,F2)),A3) ) ) ).

% dom_minus
tff(fact_7028_atMost__upto,axiom,
    ! [Na: nat] : ( set_ord_atMost(nat,Na) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),aa(nat,nat,suc,Na))) ) ).

% atMost_upto
tff(fact_7029_upt__conv__Cons,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( upt(I2,J2) = cons(nat,I2,upt(aa(nat,nat,suc,I2),J2)) ) ) ).

% upt_conv_Cons
tff(fact_7030_enumerate__eq__zip,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( enumerate(A,Na,Xs) = zip(nat,A,upt(Na,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))),Xs) ) ).

% enumerate_eq_zip
tff(fact_7031_upt__add__eq__append,axiom,
    ! [I2: nat,J2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( upt(I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K)) = append(nat,upt(I2,J2),upt(J2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),K))) ) ) ).

% upt_add_eq_append
tff(fact_7032_upt__eq__Cons__conv,axiom,
    ! [I2: nat,J2: nat,X: nat,Xs: list(nat)] :
      ( ( upt(I2,J2) = cons(nat,X,Xs) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
        & ( I2 = X )
        & ( upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),one_one(nat)),J2) = Xs ) ) ) ).

% upt_eq_Cons_conv
tff(fact_7033_upt__rec,axiom,
    ! [I2: nat,J2: nat] :
      ( upt(I2,J2)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2),cons(nat,I2,upt(aa(nat,nat,suc,I2),J2)),nil(nat)) ) ).

% upt_rec
tff(fact_7034_upt__Suc,axiom,
    ! [I2: nat,J2: nat] :
      ( upt(I2,aa(nat,nat,suc,J2))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2),append(nat,upt(I2,J2),cons(nat,J2,nil(nat))),nil(nat)) ) ).

% upt_Suc
tff(fact_7035_upt__Suc__append,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
     => ( upt(I2,aa(nat,nat,suc,J2)) = append(nat,upt(I2,J2),cons(nat,J2,nil(nat))) ) ) ).

% upt_Suc_append
tff(fact_7036_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,Na: nat] : ( aa(list($o),A,aa(A,fun(list($o),A),aa(fun($o,A),fun(A,fun(list($o),A)),groups4207007520872428315er_sum($o,A),zero_neq_one_of_bool(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),map(nat,$o,bit_se5641148757651400278ts_bit(A,A2),upt(zero_zero(nat),Na))) = aa(A,A,bit_se2584673776208193580ke_bit(A,Na),A2) ) ) ).

% horner_sum_bit_eq_take_bit
tff(fact_7037_map__fst__enumerate,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( map(product_prod(nat,A),nat,product_fst(nat,A),enumerate(A,Na,Xs)) = upt(Na,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))) ) ).

% map_fst_enumerate
tff(fact_7038_length__map,axiom,
    ! [A: $tType,B: $tType,F2: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_size(list(A)),map(B,A,F2,Xs)) = aa(list(B),nat,size_size(list(B)),Xs) ) ).

% length_map
tff(fact_7039_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aTP_Lamp_aas(B,A),Xs)) = zero_zero(A) ) ) ).

% sum_list_0
tff(fact_7040_nth__map,axiom,
    ! [B: $tType,A: $tType,Na: nat,Xs: list(A),F2: fun(A,B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,B,nth(B,map(A,B,F2,Xs)),Na) = aa(A,B,F2,aa(nat,A,nth(A,Xs),Na)) ) ) ).

% nth_map
tff(fact_7041_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( map(product_prod(A,B),A,product_fst(A,B),zip(A,B,Xs,Ys)) = Xs ) ) ).

% map_fst_zip
tff(fact_7042_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( map(product_prod(A,B),B,product_snd(A,B),zip(A,B,Xs,Ys)) = Ys ) ) ).

% map_snd_zip
tff(fact_7043_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list(B)] : ( map(B,A,aTP_Lamp_aat(A,fun(B,A),K),Lst) = replicate(A,aa(list(B),nat,size_size(list(B)),Lst),K) ) ).

% map_replicate_const
tff(fact_7044_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: fun(B,A),Xs: list(B),G: fun(C,A),Ys: list(C)] :
      ( ( map(B,A,F2,Xs) = map(C,A,G,Ys) )
     => ( aa(list(B),nat,size_size(list(B)),Xs) = aa(list(C),nat,size_size(list(C)),Ys) ) ) ).

% map_eq_imp_length_eq
tff(fact_7045_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),Xs)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F2,Xs))),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,G,Xs))) ) ) ).

% sum_list_subtractf
tff(fact_7046_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [F2: fun(B,A),G: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fl(fun(B,A),fun(fun(B,A),fun(B,A)),F2),G),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F2,Xs))),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,G,Xs))) ) ) ).

% sum_list_addf
tff(fact_7047_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I2: nat] : ( map(nat,A,aTP_Lamp_aau(A,fun(nat,A),X),upt(zero_zero(nat),I2)) = replicate(A,I2,X) ) ).

% map_replicate_trivial
tff(fact_7048_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & strict9044650504122735259up_add(B) )
     => ! [Xs: list(A),F2: fun(A,B),G: fun(A,B)] :
          ( ( Xs != nil(A) )
         => ( ! [X3: A] :
                ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X3)),aa(A,B,G,X3)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F2,Xs))),aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,G,Xs))) ) ) ) ).

% sum_list_strict_mono
tff(fact_7049_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Zs2: list(product_prod(A,B))] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( ( zip(A,B,Xs,Ys) = Zs2 )
      <=> ( ( map(product_prod(A,B),A,product_fst(A,B),Zs2) = Xs )
          & ( map(product_prod(A,B),B,product_snd(A,B),Zs2) = Ys ) ) ) ) ).

% zip_eq_conv
tff(fact_7050_sum__list__map__remove1,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [X: A,Xs: list(A),F2: fun(A,B)] :
          ( member(A,X,aa(list(A),set(A),set2(A),Xs))
         => ( aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F2,Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X)),aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F2,remove1(A,X,Xs)))) ) ) ) ).

% sum_list_map_remove1
tff(fact_7051_sum__list__triv,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [R2: A,Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aTP_Lamp_aav(A,fun(B,A),R2),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(list(B),nat,size_size(list(B)),Xs))),R2) ) ) ).

% sum_list_triv
tff(fact_7052_map__upt__Suc,axiom,
    ! [A: $tType,F2: fun(nat,A),Na: nat] : ( map(nat,A,F2,upt(zero_zero(nat),aa(nat,nat,suc,Na))) = cons(A,aa(nat,A,F2,zero_zero(nat)),map(nat,A,aTP_Lamp_vl(fun(nat,A),fun(nat,A),F2),upt(zero_zero(nat),Na))) ) ).

% map_upt_Suc
tff(fact_7053_map__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( map(nat,A,nth(A,Xs),upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = Xs ) ).

% map_nth
tff(fact_7054_size__list__conv__sum__list,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] : ( size_list(A,F2,Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F2,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% size_list_conv_sum_list
tff(fact_7055_sum__list__Suc,axiom,
    ! [A: $tType,F2: fun(A,nat),Xs: list(A)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,aTP_Lamp_kq(fun(A,nat),fun(A,nat),F2),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F2,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% sum_list_Suc
tff(fact_7056_nth__map__upt,axiom,
    ! [A: $tType,I2: nat,Na: nat,M: nat,F2: fun(nat,A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))
     => ( aa(nat,A,nth(A,map(nat,A,F2,upt(M,Na))),I2) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I2)) ) ) ).

% nth_map_upt
tff(fact_7057_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( map(product_prod(A,B),A,product_fst(A,B),zip(A,B,Xs,Ys)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)),Xs) ) ).

% map_fst_zip_take
tff(fact_7058_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list(B),Ys: list(A)] : ( map(product_prod(B,A),A,product_snd(B,A),zip(B,A,Xs,Ys)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(B),nat,size_size(list(B)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)),Ys) ) ).

% map_snd_zip_take
tff(fact_7059_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list(A),Na: nat,M: nat,F2: fun(nat,A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M) )
     => ( ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,F2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I3)) ) )
       => ( map(nat,A,F2,upt(M,Na)) = Xs ) ) ) ).

% map_upt_eqI
tff(fact_7060_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list(list(A)),Na: nat] :
      ( ( ( Xs = nil(list(A)) )
       => ( Na = zero_zero(nat) ) )
     => ( ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
           => ( aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I3)) = Na ) )
       => ( transpose(A,Xs) = map(nat,list(A),aTP_Lamp_aax(list(list(A)),fun(nat,list(A)),Xs),upt(zero_zero(nat),Na)) ) ) ) ).

% transpose_rectangle
tff(fact_7061_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [F2: fun(nat,A),Ns: list(nat)] :
          ( ! [X3: nat,Y4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Y4)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F2,X3)),aa(nat,A,F2,Y4)) )
         => ( sorted_wrt(nat,ord_less(nat),Ns)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F2),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(nat),nat,size_size(list(nat)),Ns)))),aa(list(A),A,groups8242544230860333062m_list(A),map(nat,A,F2,Ns))) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
tff(fact_7062_map__Suc__upt,axiom,
    ! [M: nat,Na: nat] : ( map(nat,nat,suc,upt(M,Na)) = upt(aa(nat,nat,suc,M),aa(nat,nat,suc,Na)) ) ).

% map_Suc_upt
tff(fact_7063_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => ( sorted_wrt(A,ord_less(A),Ys)
           => ( ( aa(list(A),set(A),set2(A),Ys) = aa(list(A),set(A),set2(A),Xs) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
tff(fact_7064_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Ys: list(A)] :
          ( sorted_wrt(A,ord_less(A),cons(A,X,Ys))
        <=> ( ! [X5: A] :
                ( member(A,X5,aa(list(A),set(A),set2(A),Ys))
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X5) )
            & sorted_wrt(A,ord_less(A),Ys) ) ) ) ).

% strict_sorted_simps(2)
tff(fact_7065_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( n_lists(A,aa(nat,nat,suc,Na),Xs) = concat(list(A),map(list(A),list(list(A)),aTP_Lamp_aaz(list(A),fun(list(A),list(list(A))),Xs),n_lists(A,Na,Xs))) ) ).

% n_lists.simps(2)
tff(fact_7066_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => sorted_wrt(A,ord_less(A),nil(A)) ) ).

% strict_sorted_simps(1)
tff(fact_7067_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : sorted_wrt(A,ord_less(A),linord4507533701916653071of_set(A,A3)) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
tff(fact_7068_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% strict_sorted_imp_sorted
tff(fact_7069_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: list(A)] :
          ( sorted_wrt(A,ord_less(A),L)
        <=> ( sorted_wrt(A,ord_less_eq(A),L)
            & distinct(A,L) ) ) ) ).

% strict_sorted_iff
tff(fact_7070_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,fun(A,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => sorted_wrt(A,P,Xs) ) ).

% sorted_wrt01
tff(fact_7071_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A)] :
      ( sorted_wrt(A,P,Xs)
    <=> ! [I: nat,J: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J)) ) ) ) ).

% sorted_wrt_iff_nth_less
tff(fact_7072_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A),I2: nat,J2: nat] :
      ( sorted_wrt(A,P,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
         => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Xs),J2)) ) ) ) ).

% sorted_wrt_nth_less
tff(fact_7073_sorted__wrt__upt,axiom,
    ! [M: nat,Na: nat] : sorted_wrt(nat,ord_less(nat),upt(M,Na)) ).

% sorted_wrt_upt
tff(fact_7074_length__concat,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),concat(A,Xss)) = aa(list(nat),nat,groups8242544230860333062m_list(nat),map(list(A),nat,size_size(list(A)),Xss)) ) ).

% length_concat
tff(fact_7075_map__add__upt,axiom,
    ! [Na: nat,M: nat] : ( map(nat,nat,aTP_Lamp_aba(nat,fun(nat,nat),Na),upt(zero_zero(nat),M)) = upt(Na,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) ) ).

% map_add_upt
tff(fact_7076_sorted01,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted01
tff(fact_7077_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I: nat,J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J)) ) ) ) ) ).

% sorted_iff_nth_mono_less
tff(fact_7078_map__decr__upt,axiom,
    ! [M: nat,Na: nat] : ( map(nat,nat,aTP_Lamp_ld(nat,nat),upt(aa(nat,nat,suc,M),aa(nat,nat,suc,Na))) = upt(M,Na) ) ).

% map_decr_upt
tff(fact_7079_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I))) ) ) ) ).

% sorted_iff_nth_Suc
tff(fact_7080_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ~ ! [L2: list(A)] :
                ( sorted_wrt(A,ord_less(A),L2)
               => ( ( aa(list(A),set(A),set2(A),L2) = A3 )
                 => ( aa(list(A),nat,size_size(list(A)),L2) != aa(set(A),nat,finite_card(A),A3) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
tff(fact_7081_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I2: nat,J2: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I2)),aa(nat,A,nth(A,Xs),J2)) ) ) ) ) ).

% sorted_nth_mono
tff(fact_7082_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I: nat,J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J)) ) ) ) ) ).

% sorted_iff_nth_mono
tff(fact_7083_sorted__wrt__less__idx,axiom,
    ! [Ns: list(nat),I2: nat] :
      ( sorted_wrt(nat,ord_less(nat),Ns)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(nat),nat,size_size(list(nat)),Ns))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),aa(nat,nat,nth(nat,Ns),I2)) ) ) ).

% sorted_wrt_less_idx
tff(fact_7084_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),L: list(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( sorted_wrt(A,ord_less(A),L)
              & ( aa(list(A),set(A),set2(A),L) = A3 )
              & ( aa(list(A),nat,size_size(list(A)),L) = aa(set(A),nat,finite_card(A),A3) ) )
          <=> ( linord4507533701916653071of_set(A,A3) = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
tff(fact_7085_enumerate__replicate__eq,axiom,
    ! [A: $tType,Na: nat,M: nat,A2: A] : ( enumerate(A,Na,replicate(A,M,A2)) = map(nat,product_prod(nat,A),aTP_Lamp_abb(A,fun(nat,product_prod(nat,A)),A2),upt(Na,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),M))) ) ).

% enumerate_replicate_eq
tff(fact_7086_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F2: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ~ ! [L2: list(B)] :
                ( sorted_wrt(A,Less,map(B,A,F2,L2))
               => ( ( aa(list(B),set(B),set2(B),L2) = A3 )
                 => ( aa(list(B),nat,size_size(list(B)),L2) != aa(set(B),nat,finite_card(B),A3) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
tff(fact_7087_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))
        = $ite(Xs = nil(list(A)),zero_zero(nat),aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),zero_zero(nat)))) ) ) ).

% length_transpose_sorted
tff(fact_7088_length__rev,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),rev(A,Xs)) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% length_rev
tff(fact_7089_sorted__wrt__upto,axiom,
    ! [I2: int,J2: int] : sorted_wrt(int,ord_less(int),upto(I2,J2)) ).

% sorted_wrt_upto
tff(fact_7090_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( zip(A,B,rev(A,Xs),rev(B,Ys)) = rev(product_prod(A,B),zip(A,B,Xs,Ys)) ) ) ).

% zip_rev
tff(fact_7091_take__rev,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( take(A,Na,rev(A,Xs)) = rev(A,drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na),Xs)) ) ).

% take_rev
tff(fact_7092_rev__take,axiom,
    ! [A: $tType,I2: nat,Xs: list(A)] : ( rev(A,take(A,I2,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I2),rev(A,Xs)) ) ).

% rev_take
tff(fact_7093_rev__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list(A)] : ( rev(A,drop(A,I2,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I2),rev(A,Xs)) ) ).

% rev_drop
tff(fact_7094_drop__rev,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( drop(A,Na,rev(A,Xs)) = rev(A,take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na),Xs)) ) ).

% drop_rev
tff(fact_7095_rotate__rev,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,Na),rev(A,Xs)) = rev(A,aa(list(A),list(A),rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),modulo_modulo(nat,Na,aa(list(A),nat,size_size(list(A)),Xs)))),Xs)) ) ).

% rotate_rev
tff(fact_7096_sorted__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),transpose(A,Xs)))) ).

% sorted_transpose
tff(fact_7097_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => folding_insort_key(A,A,ord_less_eq(A),ord_less(A),top_top(set(A)),aTP_Lamp_lx(A,A)) ) ).

% sorted_list_of_set.folding_insort_key_axioms
tff(fact_7098_rev__nth,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,rev(A,Xs)),Na) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,suc,Na))) ) ) ).

% rev_nth
tff(fact_7099_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Y: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
     => ( rev(A,list_update(A,Xs,K,Y)) = list_update(A,rev(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),K)),one_one(nat)),Y) ) ) ).

% rev_update
tff(fact_7100_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
        <=> ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I))),aa(nat,A,nth(A,Xs),I)) ) ) ) ).

% sorted_rev_iff_nth_Suc
tff(fact_7101_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I2: nat,J2: nat] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),J2)),aa(nat,A,nth(A,Xs),I2)) ) ) ) ) ).

% sorted_rev_nth_mono
tff(fact_7102_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
        <=> ! [I: nat,J: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),J)),aa(nat,A,nth(A,Xs),I)) ) ) ) ) ).

% sorted_rev_iff_nth_mono
tff(fact_7103_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A)),I2: nat,J2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(list(A)),nat,size_size(list(list(A))),filter2(list(A),aTP_Lamp_abc(nat,fun(list(A),$o),I2),Xs)))
         => ( aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),transpose(A,Xs)),I2)),J2) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Xs),J2)),I2) ) ) ) ) ).

% nth_nth_transpose_sorted
tff(fact_7104_transpose__column,axiom,
    ! [A: $tType,Xs: list(list(A)),I2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
       => ( map(list(A),A,aTP_Lamp_abd(nat,fun(list(A),A),I2),filter2(list(A),aTP_Lamp_abc(nat,fun(list(A),$o),I2),transpose(A,Xs))) = aa(nat,list(A),nth(list(A),Xs),I2) ) ) ) ).

% transpose_column
tff(fact_7105_length__concat__rev,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(A),nat,size_size(list(A)),concat(A,rev(list(A),Xs))) = aa(list(A),nat,size_size(list(A)),concat(A,Xs)) ) ).

% length_concat_rev
tff(fact_7106_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F2: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_size(list(A)),filter2(A,P,map(B,A,F2,Xs))) = aa(list(B),nat,size_size(list(B)),filter2(B,aa(fun(B,A),fun(B,$o),comp(A,$o,B,P),F2),Xs)) ) ).

% length_filter_map
tff(fact_7107_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs: list(A),P: fun(A,$o)] :
      ( member(A,X,aa(list(A),set(A),set2(A),Xs))
     => ( ~ aa(A,$o,P,X)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),filter2(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% length_filter_less
tff(fact_7108_length__filter__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),filter2(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_filter_le
tff(fact_7109_sum__length__filter__compl,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),filter2(A,P,Xs))),aa(list(A),nat,size_size(list(A)),filter2(A,aTP_Lamp_cv(fun(A,$o),fun(A,$o),P),Xs))) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% sum_length_filter_compl
tff(fact_7110_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs: list(A)] : ( replicate(A,aa(list(A),nat,size_size(list(A)),filter2(A,aa(A,fun(A,$o),fequal(A),X),Xs)),X) = filter2(A,aa(A,fun(A,$o),fequal(A),X),Xs) ) ).

% replicate_length_filter
tff(fact_7111_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [F2: fun(B,A),P: fun(B,$o),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F2,filter2(B,P,Xs))) = aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,$o),fun(B,A),aTP_Lamp_abe(fun(B,A),fun(fun(B,$o),fun(B,A)),F2),P),Xs)) ) ) ).

% sum_list_map_filter'
tff(fact_7112_sum__list__map__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(A),P: fun(A,$o),F2: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
             => ( ~ aa(A,$o,P,X3)
               => ( aa(A,B,F2,X3) = zero_zero(B) ) ) )
         => ( aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F2,filter2(A,P,Xs))) = aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F2,Xs)) ) ) ) ).

% sum_list_map_filter
tff(fact_7113_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list(A),Y: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) = aa(list(A),set(A),set2(A),filter2(A,aTP_Lamp_abf(A,fun(A,$o),Y),Xs)) ) ).

% set_minus_filter_out
tff(fact_7114_filter__eq__nths,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( filter2(A,P,Xs) = nths(A,Xs,collect(nat,aa(list(A),fun(nat,$o),aTP_Lamp_abg(fun(A,$o),fun(list(A),fun(nat,$o)),P),Xs))) ) ).

% filter_eq_nths
tff(fact_7115_length__filter__conv__card,axiom,
    ! [A: $tType,P3: fun(A,$o),Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),filter2(A,P3,Xs)) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(list(A),fun(nat,$o),aTP_Lamp_abg(fun(A,$o),fun(list(A),fun(nat,$o)),P3),Xs))) ) ).

% length_filter_conv_card
tff(fact_7116_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs: list(list(A))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)))
     => ( aa(nat,list(A),nth(list(A),transpose(A,Xs)),I2) = map(list(A),A,aTP_Lamp_abd(nat,fun(list(A),A),I2),filter2(list(A),aTP_Lamp_abc(nat,fun(list(A),$o),I2),Xs)) ) ) ).

% nth_transpose
tff(fact_7117_transpose__column__length,axiom,
    ! [A: $tType,Xs: list(list(A)),I2: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
       => ( aa(list(list(A)),nat,size_size(list(list(A))),filter2(list(A),aTP_Lamp_abc(nat,fun(list(A),$o),I2),transpose(A,Xs))) = aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I2)) ) ) ) ).

% transpose_column_length
tff(fact_7118_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F2: fun(B,A),A3: set(B),L: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( ( sorted_wrt(A,Less,map(B,A,F2,L))
              & ( aa(list(B),set(B),set2(B),L) = A3 )
              & ( aa(list(B),nat,size_size(list(B)),L) = aa(set(B),nat,finite_card(B),A3) ) )
          <=> ( sorted8670434370408473282of_set(A,B,Less_eq,F2,A3) = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
tff(fact_7119_transpose__max__length,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( foldr(list(A),nat,aTP_Lamp_abh(list(A),fun(nat,nat)),transpose(A,Xs),zero_zero(nat)) = aa(list(list(A)),nat,size_size(list(list(A))),filter2(list(A),aTP_Lamp_abi(list(A),$o),Xs)) ) ).

% transpose_max_length
tff(fact_7120_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = foldr(A,A,plus_plus(A),Xs,zero_zero(A)) ) ) ).

% sum_list.eq_foldr
tff(fact_7121_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: fun(nat,$o),Xs: list(A),Is: list(nat)] : ( map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_abj(fun(nat,$o),fun(product_prod(A,nat),$o),P),zip(A,nat,Xs,Is))) = map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_abk(fun(nat,$o),fun(product_prod(A,nat),$o),P),zip(A,nat,Xs,map(nat,nat,suc,Is)))) ) ).

% nths_shift_lemma_Suc
tff(fact_7122_horner__sum__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F2: fun(B,A),A2: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F2),A2),Xs) = foldr(B,A,aa(A,fun(B,fun(A,A)),aTP_Lamp_abl(fun(B,A),fun(A,fun(B,fun(A,A))),F2),A2),Xs,zero_zero(A)) ) ) ).

% horner_sum_foldr
tff(fact_7123_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F2: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S3)
       => ( aa(list(B),nat,size_size(list(B)),sorted8670434370408473282of_set(A,B,Less_eq,F2,A3)) = aa(set(B),nat,finite_card(B),A3) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
tff(fact_7124_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set(nat),Xs: list(A),I2: nat] : ( map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_abm(set(nat),fun(product_prod(A,nat),$o),A3),zip(A,nat,Xs,upt(I2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),aa(list(A),nat,size_size(list(A)),Xs)))))) = map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aa(nat,fun(product_prod(A,nat),$o),aTP_Lamp_abn(set(nat),fun(nat,fun(product_prod(A,nat),$o)),A3),I2),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_shift_lemma
tff(fact_7125_nths__def,axiom,
    ! [A: $tType,Xs: list(A),A3: set(nat)] : ( nths(A,Xs,A3) = map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_abm(set(nat),fun(product_prod(A,nat),$o),A3),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_def
tff(fact_7126_length__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = foldr(list(A),nat,aTP_Lamp_abh(list(A),fun(nat,nat)),Xs,zero_zero(nat)) ) ).

% length_transpose
tff(fact_7127_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Y: A] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
         => ( foldr(A,A,ord_max(A),Xs,Y)
            = $ite(Xs = nil(A),Y,aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,nth(A,Xs),zero_zero(nat))),Y)) ) ) ) ).

% foldr_max_sorted
tff(fact_7128_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Xss: list(list(B))] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs))),foldr(list(B),nat,aTP_Lamp_abo(list(B),fun(nat,nat)),Xss,zero_zero(nat))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Xs)),foldr(list(B),nat,aTP_Lamp_abp(list(B),fun(nat,nat)),filter2(list(B),aTP_Lamp_abq(list(B),$o),Xss),zero_zero(nat)))) ) ).

% transpose_aux_max
tff(fact_7129_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F2: fun(B,A),X: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X),A3)),S3)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X),bot_bot(set(B))))) = remove1(B,X,sorted8670434370408473282of_set(A,B,Less_eq,F2,A3)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_7130_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S3: set(B),F2: fun(B,A),X: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S3,F2)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,X),A3)),S3)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F2,aa(set(B),set(B),insert(B,X),A3)) = insort_key(A,B,Less_eq,F2,X,sorted8670434370408473282of_set(A,B,Less_eq,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_7131_transpose__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( transpose(A,transpose(A,Xs)) = takeWhile(list(A),aTP_Lamp_abi(list(A),$o),Xs) ) ) ).

% transpose_transpose
tff(fact_7132_takeWhile__eq__take,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( takeWhile(A,P,Xs) = take(A,aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)),Xs) ) ).

% takeWhile_eq_take
tff(fact_7133_length__takeWhile__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_takeWhile_le
tff(fact_7134_nth__length__takeWhile,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs))
     => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ).

% nth_length_takeWhile
tff(fact_7135_takeWhile__nth,axiom,
    ! [A: $tType,J2: nat,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))
     => ( aa(nat,A,nth(A,takeWhile(A,P,Xs)),J2) = aa(nat,A,nth(A,Xs),J2) ) ) ).

% takeWhile_nth
tff(fact_7136_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J2: nat,P: fun(A,$o),Xs: list(A)] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J2)
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I3)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))) ) ) ).

% length_takeWhile_less_P_nth
tff(fact_7137_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,Na: nat,Xs: list(A),P: fun(A,$o)] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),Na)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(A,$o,P,aa(nat,A,nth(A,Xs),I3)) ) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
         => ~ aa(A,$o,P,aa(nat,A,nth(A,Xs),Na)) )
       => ( takeWhile(A,P,Xs) = take(A,Na,Xs) ) ) ) ).

% takeWhile_eq_take_P_nth
tff(fact_7138_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F2: fun(B,A),Xs: list(B),T2: A] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,map(B,A,F2,Xs)))
         => ( filter2(B,aa(A,fun(B,$o),aTP_Lamp_abr(fun(B,A),fun(A,fun(B,$o)),F2),T2),Xs) = takeWhile(B,aa(A,fun(B,$o),aTP_Lamp_abr(fun(B,A),fun(A,fun(B,$o)),F2),T2),Xs) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
tff(fact_7139_length__product__lists,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),product_lists(A,Xss)) = foldr(nat,nat,times_times(nat),map(list(A),nat,size_size(list(A)),Xss),one_one(nat)) ) ).

% length_product_lists
tff(fact_7140_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( linord4507533701916653071of_set(A,A3) = cons(A,lattic643756798350308766er_Min(A,A3),linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,lattic643756798350308766er_Min(A,A3)),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set_nonempty
tff(fact_7141_Gcd__eq__Max,axiom,
    ! [M10: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M10)
     => ( ( M10 != bot_bot(set(nat)) )
       => ( ~ member(nat,zero_zero(nat),M10)
         => ( gcd_Gcd(nat,M10) = lattic643756798349783984er_Max(nat,complete_Inf_Inf(set(nat),image(nat,set(nat),aTP_Lamp_abs(nat,set(nat)),M10))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_7142_Max__divisors__self__nat,axiom,
    ! [Na: nat] :
      ( ( Na != zero_zero(nat) )
     => ( lattic643756798349783984er_Max(nat,collect(nat,aTP_Lamp_jx(nat,fun(nat,$o),Na))) = Na ) ) ).

% Max_divisors_self_nat
tff(fact_7143_Max__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),lattic643756798349783984er_Max(A,A3)),X)
            <=> ! [X5: A] :
                  ( member(A,X5,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),X) ) ) ) ) ) ).

% Max_less_iff
tff(fact_7144_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),lattic643756798350308766er_Min(A,A3))
            <=> ! [X5: A] :
                  ( member(A,X5,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X5) ) ) ) ) ) ).

% Min_gr_iff
tff(fact_7145_Min__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),lattic643756798350308766er_Min(A,A3)),X)
            <=> ? [X5: A] :
                  ( member(A,X5,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),X) ) ) ) ) ) ).

% Min_less_iff
tff(fact_7146_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),lattic643756798349783984er_Max(A,A3))
            <=> ? [X5: A] :
                  ( member(A,X5,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),X5) ) ) ) ) ) ).

% Max_gr_iff
tff(fact_7147_card__le__Suc__Max,axiom,
    ! [S3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),S3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,finite_card(nat),S3)),aa(nat,nat,suc,lattic643756798349783984er_Max(nat,S3))) ) ).

% card_le_Suc_Max
tff(fact_7148_Min__add__commute,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [S3: set(A),F2: fun(A,B),K: B] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ( lattic643756798350308766er_Min(B,image(A,B,aa(B,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(B,fun(A,B)),F2),K),S3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),lattic643756798350308766er_Min(B,image(A,B,F2,S3))),K) ) ) ) ) ).

% Min_add_commute
tff(fact_7149_Sup__nat__def,axiom,
    ! [X7: set(nat)] :
      ( complete_Sup_Sup(nat,X7)
      = $ite(X7 = bot_bot(set(nat)),zero_zero(nat),lattic643756798349783984er_Max(nat,X7)) ) ).

% Sup_nat_def
tff(fact_7150_divide__nat__def,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),M),Na)
      = $ite(Na = zero_zero(nat),zero_zero(nat),lattic643756798349783984er_Max(nat,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_abu(nat,fun(nat,fun(nat,$o)),M),Na)))) ) ).

% divide_nat_def
tff(fact_7151_Max__add__commute,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [S3: set(A),F2: fun(A,B),K: B] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( ( S3 != bot_bot(set(A)) )
           => ( lattic643756798349783984er_Max(B,image(A,B,aa(B,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(B,fun(A,B)),F2),K),S3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),lattic643756798349783984er_Max(B,image(A,B,F2,S3))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_7152_gcd__is__Max__divisors__nat,axiom,
    ! [Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na) = lattic643756798349783984er_Max(nat,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_abv(nat,fun(nat,fun(nat,$o)),Na),M))) ) ) ).

% gcd_is_Max_divisors_nat
tff(fact_7153_Min_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( lattic643756798350308766er_Min(A,A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),ord_min(A),X),lattic643756798350308766er_Min(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ) ).

% Min.remove
tff(fact_7154_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( lattic643756798350308766er_Min(A,aa(set(A),set(A),insert(A,X),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),ord_min(A),X),lattic643756798350308766er_Min(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ).

% Min.insert_remove
tff(fact_7155_Max_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( lattic643756798349783984er_Max(A,A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),ord_max(A),X),lattic643756798349783984er_Max(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ) ).

% Max.remove
tff(fact_7156_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( lattic643756798349783984er_Max(A,aa(set(A),set(A),insert(A,X),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),ord_max(A),X),lattic643756798349783984er_Max(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ).

% Max.insert_remove
tff(fact_7157_cauchy__def,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
    <=> ! [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
         => ? [K3: nat] :
            ! [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),M3)
             => ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
                 => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,X7,M3)),aa(nat,rat,X7,N4)))),R5) ) ) ) ) ).

% cauchy_def
tff(fact_7158_cauchyI,axiom,
    ! [X7: fun(nat,rat)] :
      ( ! [R: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R)
         => ? [K4: nat] :
            ! [M4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K4),M4)
             => ! [N: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K4),N)
                 => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,X7,M4)),aa(nat,rat,X7,N)))),R) ) ) )
     => cauchy(X7) ) ).

% cauchyI
tff(fact_7159_Max__divisors__self__int,axiom,
    ! [Na: int] :
      ( ( Na != zero_zero(int) )
     => ( lattic643756798349783984er_Max(int,collect(int,aTP_Lamp_kj(int,fun(int,$o),Na))) = aa(int,int,abs_abs(int),Na) ) ) ).

% Max_divisors_self_int
tff(fact_7160_cauchy__minus,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => cauchy(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat)),X7)) ) ).

% cauchy_minus
tff(fact_7161_cauchy__add,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => cauchy(aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X7),Y6)) ) ) ).

% cauchy_add
tff(fact_7162_cauchy__const,axiom,
    ! [X: rat] : cauchy(aTP_Lamp_aby(rat,fun(nat,rat),X)) ).

% cauchy_const
tff(fact_7163_cauchy__mult,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => cauchy(aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X7),Y6)) ) ) ).

% cauchy_mult
tff(fact_7164_cauchy__diff,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => cauchy(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6)) ) ) ).

% cauchy_diff
tff(fact_7165_gcd__is__Max__divisors__int,axiom,
    ! [Na: int,M: int] :
      ( ( Na != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),Na) = lattic643756798349783984er_Max(int,collect(int,aa(int,fun(int,$o),aTP_Lamp_acb(int,fun(int,fun(int,$o)),Na),M))) ) ) ).

% gcd_is_Max_divisors_int
tff(fact_7166_cauchy__imp__bounded,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ? [B4: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),B4)
          & ! [N6: nat] : aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X7,N6))),B4) ) ) ).

% cauchy_imp_bounded
tff(fact_7167_cauchyD,axiom,
    ! [X7: fun(nat,rat),R2: rat] :
      ( cauchy(X7)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R2)
       => ? [K2: nat] :
          ! [M2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),M2)
           => ! [N6: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N6)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,X7,M2)),aa(nat,rat,X7,N6)))),R2) ) ) ) ) ).

% cauchyD
tff(fact_7168_le__Real,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(fun(nat,rat),real,real2,X7)),aa(fun(nat,rat),real,real2,Y6))
        <=> ! [R5: rat] :
              ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
             => ? [K3: nat] :
                ! [N4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
                 => aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(nat,rat,X7,N4)),aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(nat,rat,Y6,N4)),R5)) ) ) ) ) ) ).

% le_Real
tff(fact_7169_cauchy__not__vanishes,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( ~ vanishes(X7)
       => ? [B4: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),B4)
            & ? [K2: nat] :
              ! [N6: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N6)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),B4),aa(rat,rat,abs_abs(rat),aa(nat,rat,X7,N6))) ) ) ) ) ).

% cauchy_not_vanishes
tff(fact_7170_vanishes__const,axiom,
    ! [C2: rat] :
      ( vanishes(aTP_Lamp_aby(rat,fun(nat,rat),C2))
    <=> ( C2 = zero_zero(rat) ) ) ).

% vanishes_const
tff(fact_7171_Real__induct,axiom,
    ! [P: fun(real,$o),X: real] :
      ( ! [X10: fun(nat,rat)] :
          ( cauchy(X10)
         => aa(real,$o,P,aa(fun(nat,rat),real,real2,X10)) )
     => aa(real,$o,P,X) ) ).

% Real_induct
tff(fact_7172_mult__Real,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(fun(nat,rat),real,real2,X7)),aa(fun(nat,rat),real,real2,Y6)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X7),Y6)) ) ) ) ).

% mult_Real
tff(fact_7173_inverse__Real,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( aa(real,real,inverse_inverse(real),aa(fun(nat,rat),real,real2,X7))
        = $ite(vanishes(X7),zero_zero(real),aa(fun(nat,rat),real,real2,aTP_Lamp_acc(fun(nat,rat),fun(nat,rat),X7))) ) ) ).

% inverse_Real
tff(fact_7174_eq__Real,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => ( ( aa(fun(nat,rat),real,real2,X7) = aa(fun(nat,rat),real,real2,Y6) )
        <=> vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6)) ) ) ) ).

% eq_Real
tff(fact_7175_vanishes__diff,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( vanishes(X7)
     => ( vanishes(Y6)
       => vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6)) ) ) ).

% vanishes_diff
tff(fact_7176_zero__real__def,axiom,
    zero_zero(real) = aa(fun(nat,rat),real,real2,aTP_Lamp_acd(nat,rat)) ).

% zero_real_def
tff(fact_7177_of__rat__Real,axiom,
    ! [X: rat] : ( aa(rat,real,field_char_0_of_rat(real),X) = aa(fun(nat,rat),real,real2,aTP_Lamp_aby(rat,fun(nat,rat),X)) ) ).

% of_rat_Real
tff(fact_7178_vanishes__add,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( vanishes(X7)
     => ( vanishes(Y6)
       => vanishes(aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X7),Y6)) ) ) ).

% vanishes_add
tff(fact_7179_vanishes__minus,axiom,
    ! [X7: fun(nat,rat)] :
      ( vanishes(X7)
     => vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat)),X7)) ) ).

% vanishes_minus
tff(fact_7180_one__real__def,axiom,
    one_one(real) = aa(fun(nat,rat),real,real2,aTP_Lamp_ace(nat,rat)) ).

% one_real_def
tff(fact_7181_of__int__Real,axiom,
    ! [X: int] : ( aa(int,real,ring_1_of_int(real),X) = aa(fun(nat,rat),real,real2,aTP_Lamp_acf(int,fun(nat,rat),X)) ) ).

% of_int_Real
tff(fact_7182_cauchy__inverse,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( ~ vanishes(X7)
       => cauchy(aTP_Lamp_acc(fun(nat,rat),fun(nat,rat),X7)) ) ) ).

% cauchy_inverse
tff(fact_7183_of__nat__Real,axiom,
    ! [X: nat] : ( aa(nat,real,semiring_1_of_nat(real),X) = aa(fun(nat,rat),real,real2,aTP_Lamp_acg(nat,fun(nat,rat),X)) ) ).

% of_nat_Real
tff(fact_7184_less__RealD,axiom,
    ! [Y6: fun(nat,rat),X: real] :
      ( cauchy(Y6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(fun(nat,rat),real,real2,Y6))
       => ? [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),aa(rat,real,field_char_0_of_rat(real),aa(nat,rat,Y6,N))) ) ) ).

% less_RealD
tff(fact_7185_Real__leI,axiom,
    ! [X7: fun(nat,rat),Y: real] :
      ( cauchy(X7)
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(rat,real,field_char_0_of_rat(real),aa(nat,rat,X7,N))),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(fun(nat,rat),real,real2,X7)),Y) ) ) ).

% Real_leI
tff(fact_7186_le__RealI,axiom,
    ! [Y6: fun(nat,rat),X: real] :
      ( cauchy(Y6)
     => ( ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(rat,real,field_char_0_of_rat(real),aa(nat,rat,Y6,N)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(fun(nat,rat),real,real2,Y6)) ) ) ).

% le_RealI
tff(fact_7187_minus__Real,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( aa(real,real,uminus_uminus(real),aa(fun(nat,rat),real,real2,X7)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat)),X7)) ) ) ).

% minus_Real
tff(fact_7188_add__Real,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(fun(nat,rat),real,real2,X7)),aa(fun(nat,rat),real,real2,Y6)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X7),Y6)) ) ) ) ).

% add_Real
tff(fact_7189_diff__Real,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(fun(nat,rat),real,real2,X7)),aa(fun(nat,rat),real,real2,Y6)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6)) ) ) ) ).

% diff_Real
tff(fact_7190_vanishes__mult__bounded,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( ? [A9: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),A9)
          & ! [N: nat] : aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X7,N))),A9) )
     => ( vanishes(Y6)
       => vanishes(aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X7),Y6)) ) ) ).

% vanishes_mult_bounded
tff(fact_7191_vanishes__diff__inverse,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( ~ vanishes(X7)
       => ( cauchy(Y6)
         => ( ~ vanishes(Y6)
           => ( vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6))
             => vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_ach(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6)) ) ) ) ) ) ).

% vanishes_diff_inverse
tff(fact_7192_vanishes__def,axiom,
    ! [X7: fun(nat,rat)] :
      ( vanishes(X7)
    <=> ! [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
         => ? [K3: nat] :
            ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X7,N4))),R5) ) ) ) ).

% vanishes_def
tff(fact_7193_vanishesI,axiom,
    ! [X7: fun(nat,rat)] :
      ( ! [R: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R)
         => ? [K4: nat] :
            ! [N: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K4),N)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X7,N))),R) ) )
     => vanishes(X7) ) ).

% vanishesI
tff(fact_7194_vanishesD,axiom,
    ! [X7: fun(nat,rat),R2: rat] :
      ( vanishes(X7)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R2)
       => ? [K2: nat] :
          ! [N6: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N6)
           => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X7,N6))),R2) ) ) ) ).

% vanishesD
tff(fact_7195_cauchy__not__vanishes__cases,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( ~ vanishes(X7)
       => ? [B4: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),B4)
            & ? [K2: nat] :
                ( ! [N6: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N6)
                   => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),B4),aa(rat,rat,uminus_uminus(rat),aa(nat,rat,X7,N6))) )
                | ! [N6: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N6)
                   => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),B4),aa(nat,rat,X7,N6)) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
tff(fact_7196_not__positive__Real,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( ~ aa(real,$o,positive2,aa(fun(nat,rat),real,real2,X7))
      <=> ! [R5: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
           => ? [K3: nat] :
              ! [N4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(nat,rat,X7,N4)),R5) ) ) ) ) ).

% not_positive_Real
tff(fact_7197_positive__Real,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => ( aa(real,$o,positive2,aa(fun(nat,rat),real,real2,X7))
      <=> ? [R5: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
            & ? [K3: nat] :
              ! [N4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,X7,N4)) ) ) ) ) ).

% positive_Real
tff(fact_7198_Real_Opositive__mult,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,positive2,X)
     => ( aa(real,$o,positive2,Y)
       => aa(real,$o,positive2,aa(real,real,aa(real,fun(real,real),times_times(real),X),Y)) ) ) ).

% Real.positive_mult
tff(fact_7199_Real_Opositive__add,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,positive2,X)
     => ( aa(real,$o,positive2,Y)
       => aa(real,$o,positive2,aa(real,real,aa(real,fun(real,real),plus_plus(real),X),Y)) ) ) ).

% Real.positive_add
tff(fact_7200_Real_Opositive__zero,axiom,
    ~ aa(real,$o,positive2,zero_zero(real)) ).

% Real.positive_zero
tff(fact_7201_Real_Opositive__minus,axiom,
    ! [X: real] :
      ( ~ aa(real,$o,positive2,X)
     => ( ( X != zero_zero(real) )
       => aa(real,$o,positive2,aa(real,real,uminus_uminus(real),X)) ) ) ).

% Real.positive_minus
tff(fact_7202_less__real__def,axiom,
    ! [X: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),Y)
    <=> aa(real,$o,positive2,aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),X)) ) ).

% less_real_def
tff(fact_7203_Real_Opositive_Otransfer,axiom,
    aa(fun(real,$o),$o,aa(fun(fun(nat,rat),$o),fun(fun(real,$o),$o),bNF_rel_fun(fun(nat,rat),real,$o,$o,pcr_real,fequal($o)),aTP_Lamp_aci(fun(nat,rat),$o)),positive2) ).

% Real.positive.transfer
tff(fact_7204_Real_Opositive_Orep__eq,axiom,
    ! [X: real] :
      ( aa(real,$o,positive2,X)
    <=> ? [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
          & ? [K3: nat] :
            ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,aa(real,fun(nat,rat),rep_real,X),N4)) ) ) ) ).

% Real.positive.rep_eq
tff(fact_7205_zero__real_Otransfer,axiom,
    aa(real,$o,aa(fun(nat,rat),fun(real,$o),pcr_real,aTP_Lamp_acd(nat,rat)),zero_zero(real)) ).

% zero_real.transfer
tff(fact_7206_one__real_Otransfer,axiom,
    aa(real,$o,aa(fun(nat,rat),fun(real,$o),pcr_real,aTP_Lamp_ace(nat,rat)),one_one(real)) ).

% one_real.transfer
tff(fact_7207_cr__real__eq,axiom,
    ! [X4: fun(nat,rat),Xa2: real] :
      ( aa(real,$o,aa(fun(nat,rat),fun(real,$o),pcr_real,X4),Xa2)
    <=> ( cauchy(X4)
        & ( aa(fun(nat,rat),real,real2,X4) = Xa2 ) ) ) ).

% cr_real_eq
tff(fact_7208_uminus__real_Otransfer,axiom,
    aa(fun(real,real),$o,aa(fun(fun(nat,rat),fun(nat,rat)),fun(fun(real,real),$o),bNF_rel_fun(fun(nat,rat),real,fun(nat,rat),real,pcr_real,pcr_real),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat))),uminus_uminus(real)) ).

% uminus_real.transfer
tff(fact_7209_plus__real_Otransfer,axiom,
    aa(fun(real,fun(real,real)),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(fun(real,fun(real,real)),$o),bNF_rel_fun(fun(nat,rat),real,fun(fun(nat,rat),fun(nat,rat)),fun(real,real),pcr_real,bNF_rel_fun(fun(nat,rat),real,fun(nat,rat),real,pcr_real,pcr_real)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))),plus_plus(real)) ).

% plus_real.transfer
tff(fact_7210_times__real_Otransfer,axiom,
    aa(fun(real,fun(real,real)),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(fun(real,fun(real,real)),$o),bNF_rel_fun(fun(nat,rat),real,fun(fun(nat,rat),fun(nat,rat)),fun(real,real),pcr_real,bNF_rel_fun(fun(nat,rat),real,fun(nat,rat),real,pcr_real,pcr_real)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))),times_times(real)) ).

% times_real.transfer
tff(fact_7211_inverse__real_Otransfer,axiom,
    aa(fun(real,real),$o,aa(fun(fun(nat,rat),fun(nat,rat)),fun(fun(real,real),$o),bNF_rel_fun(fun(nat,rat),real,fun(nat,rat),real,pcr_real,pcr_real),aTP_Lamp_acj(fun(nat,rat),fun(nat,rat))),inverse_inverse(real)) ).

% inverse_real.transfer
tff(fact_7212_Real_Opositive__def,axiom,
    positive2 = aa(fun(fun(nat,rat),$o),fun(real,$o),map_fun(real,fun(nat,rat),$o,$o,rep_real,id($o)),aTP_Lamp_aci(fun(nat,rat),$o)) ).

% Real.positive_def
tff(fact_7213_inverse__real__def,axiom,
    inverse_inverse(real) = aa(fun(fun(nat,rat),fun(nat,rat)),fun(real,real),map_fun(real,fun(nat,rat),fun(nat,rat),real,rep_real,real2),aTP_Lamp_acj(fun(nat,rat),fun(nat,rat))) ).

% inverse_real_def
tff(fact_7214_uminus__real__def,axiom,
    uminus_uminus(real) = aa(fun(fun(nat,rat),fun(nat,rat)),fun(real,real),map_fun(real,fun(nat,rat),fun(nat,rat),real,rep_real,real2),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat))) ).

% uminus_real_def
tff(fact_7215_times__real__def,axiom,
    times_times(real) = aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(real,fun(real,real)),map_fun(real,fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),fun(real,real),rep_real,map_fun(real,fun(nat,rat),fun(nat,rat),real,rep_real,real2)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))) ).

% times_real_def
tff(fact_7216_plus__real__def,axiom,
    plus_plus(real) = aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(real,fun(real,real)),map_fun(real,fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),fun(real,real),rep_real,map_fun(real,fun(nat,rat),fun(nat,rat),real,rep_real,real2)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))) ).

% plus_real_def
tff(fact_7217_Real_Opositive_Orsp,axiom,
    aa(fun(fun(nat,rat),$o),$o,aa(fun(fun(nat,rat),$o),fun(fun(fun(nat,rat),$o),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),$o,$o,realrel,fequal($o)),aTP_Lamp_aci(fun(nat,rat),$o)),aTP_Lamp_aci(fun(nat,rat),$o)) ).

% Real.positive.rsp
tff(fact_7218_inverse__real_Oabs__eq,axiom,
    ! [X: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X),X)
     => ( aa(real,real,inverse_inverse(real),aa(fun(nat,rat),real,real2,X))
        = aa(fun(nat,rat),real,real2,$ite(vanishes(X),aTP_Lamp_acd(nat,rat),aTP_Lamp_acc(fun(nat,rat),fun(nat,rat),X))) ) ) ).

% inverse_real.abs_eq
tff(fact_7219_real_Oabs__induct,axiom,
    ! [P: fun(real,$o),X: real] :
      ( ! [Y4: fun(nat,rat)] :
          ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Y4),Y4)
         => aa(real,$o,P,aa(fun(nat,rat),real,real2,Y4)) )
     => aa(real,$o,P,X) ) ).

% real.abs_induct
tff(fact_7220_zero__real_Orsp,axiom,
    aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,aTP_Lamp_acd(nat,rat)),aTP_Lamp_acd(nat,rat)) ).

% zero_real.rsp
tff(fact_7221_one__real_Orsp,axiom,
    aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,aTP_Lamp_ace(nat,rat)),aTP_Lamp_ace(nat,rat)) ).

% one_real.rsp
tff(fact_7222_realrel__refl,axiom,
    ! [X7: fun(nat,rat)] :
      ( cauchy(X7)
     => aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X7),X7) ) ).

% realrel_refl
tff(fact_7223_times__real_Orsp,axiom,
    aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),fun(fun(nat,rat),fun(nat,rat)),realrel,bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(nat,rat),fun(nat,rat),realrel,realrel)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))) ).

% times_real.rsp
tff(fact_7224_uminus__real_Orsp,axiom,
    aa(fun(fun(nat,rat),fun(nat,rat)),$o,aa(fun(fun(nat,rat),fun(nat,rat)),fun(fun(fun(nat,rat),fun(nat,rat)),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(nat,rat),fun(nat,rat),realrel,realrel),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat))),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat))) ).

% uminus_real.rsp
tff(fact_7225_plus__real_Orsp,axiom,
    aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),fun(fun(nat,rat),fun(nat,rat)),realrel,bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(nat,rat),fun(nat,rat),realrel,realrel)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))) ).

% plus_real.rsp
tff(fact_7226_real_Orel__eq__transfer,axiom,
    aa(fun(real,fun(real,$o)),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),$o)),fun(fun(real,fun(real,$o)),$o),bNF_rel_fun(fun(nat,rat),real,fun(fun(nat,rat),$o),fun(real,$o),pcr_real,bNF_rel_fun(fun(nat,rat),real,$o,$o,pcr_real,fequal($o))),realrel),fequal(real)) ).

% real.rel_eq_transfer
tff(fact_7227_uminus__real_Oabs__eq,axiom,
    ! [X: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X),X)
     => ( aa(real,real,uminus_uminus(real),aa(fun(nat,rat),real,real2,X)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat)),X)) ) ) ).

% uminus_real.abs_eq
tff(fact_7228_plus__real_Oabs__eq,axiom,
    ! [Xa: fun(nat,rat),X: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Xa),Xa)
     => ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X),X)
       => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(fun(nat,rat),real,real2,Xa)),aa(fun(nat,rat),real,real2,X)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),Xa),X)) ) ) ) ).

% plus_real.abs_eq
tff(fact_7229_times__real_Oabs__eq,axiom,
    ! [Xa: fun(nat,rat),X: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Xa),Xa)
     => ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X),X)
       => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(fun(nat,rat),real,real2,Xa)),aa(fun(nat,rat),real,real2,X)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),Xa),X)) ) ) ) ).

% times_real.abs_eq
tff(fact_7230_realrelI,axiom,
    ! [X7: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X7)
     => ( cauchy(Y6)
       => ( vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X7),Y6))
         => aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X7),Y6) ) ) ) ).

% realrelI
tff(fact_7231_inverse__real_Orsp,axiom,
    aa(fun(fun(nat,rat),fun(nat,rat)),$o,aa(fun(fun(nat,rat),fun(nat,rat)),fun(fun(fun(nat,rat),fun(nat,rat)),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(nat,rat),fun(nat,rat),realrel,realrel),aTP_Lamp_acj(fun(nat,rat),fun(nat,rat))),aTP_Lamp_acj(fun(nat,rat),fun(nat,rat))) ).

% inverse_real.rsp
tff(fact_7232_realrel__def,axiom,
    ! [X4: fun(nat,rat),Xa2: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X4),Xa2)
    <=> ( cauchy(X4)
        & cauchy(Xa2)
        & vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X4),Xa2)) ) ) ).

% realrel_def
tff(fact_7233_Real_Opositive_Oabs__eq,axiom,
    ! [X: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X),X)
     => ( aa(real,$o,positive2,aa(fun(nat,rat),real,real2,X))
      <=> ? [R5: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
            & ? [K3: nat] :
              ! [N4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,X,N4)) ) ) ) ) ).

% Real.positive.abs_eq
tff(fact_7234_cr__real__def,axiom,
    ! [X4: fun(nat,rat),Xa2: real] :
      ( aa(real,$o,aa(fun(nat,rat),fun(real,$o),cr_real,X4),Xa2)
    <=> ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X4),X4)
        & ( aa(fun(nat,rat),real,real2,X4) = Xa2 ) ) ) ).

% cr_real_def
tff(fact_7235_butlast__take,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),list(A),butlast(A),take(A,Na,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)),Xs) ) ) ).

% butlast_take
tff(fact_7236_length__butlast,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),butlast(A),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) ).

% length_butlast
tff(fact_7237_nth__butlast,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),butlast(A),Xs)))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),butlast(A),Xs)),Na) = aa(nat,A,nth(A,Xs),Na) ) ) ).

% nth_butlast
tff(fact_7238_real_Opcr__cr__eq,axiom,
    pcr_real = cr_real ).

% real.pcr_cr_eq
tff(fact_7239_take__butlast,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( take(A,Na,aa(list(A),list(A),butlast(A),Xs)) = take(A,Na,Xs) ) ) ).

% take_butlast
tff(fact_7240_butlast__power,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),list(A),aa(fun(list(A),list(A)),fun(list(A),list(A)),aa(nat,fun(fun(list(A),list(A)),fun(list(A),list(A))),compow(fun(list(A),list(A))),Na),butlast(A)),Xs) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),Na),Xs) ) ).

% butlast_power
tff(fact_7241_butlast__conv__take,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),list(A),butlast(A),Xs) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),Xs) ) ).

% butlast_conv_take
tff(fact_7242_butlast__list__update,axiom,
    ! [A: $tType,Xs: list(A),K: nat,X: A] :
      ( aa(list(A),list(A),butlast(A),list_update(A,Xs,K,X))
      = $ite(K = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),aa(list(A),list(A),butlast(A),Xs),list_update(A,aa(list(A),list(A),butlast(A),Xs),K,X)) ) ).

% butlast_list_update
tff(fact_7243_remove__def,axiom,
    ! [A: $tType,X: A,A3: set(A)] : ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),remove(A),X),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) ) ).

% remove_def
tff(fact_7244_finite__enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),M: nat,Na: nat] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(set(A),nat,finite_card(A),S3))
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(set(A),nat,finite_card(A),S3))
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S3,M)),infini527867602293511546merate(A,S3,Na))
              <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ) ) ) ).

% finite_enumerate_mono_iff
tff(fact_7245_enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),M: nat,Na: nat] :
          ( ~ aa(set(A),$o,finite_finite(A),S3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S3,M)),infini527867602293511546merate(A,S3,Na))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ) ) ).

% enumerate_mono_iff
tff(fact_7246_enumerate__step,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] :
          ( ~ aa(set(A),$o,finite_finite(A),S3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S3,Na)),infini527867602293511546merate(A,S3,aa(nat,nat,suc,Na))) ) ) ).

% enumerate_step
tff(fact_7247_enumerate__mono,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [M: nat,Na: nat,S3: set(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
         => ( ~ aa(set(A),$o,finite_finite(A),S3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S3,M)),infini527867602293511546merate(A,S3,Na)) ) ) ) ).

% enumerate_mono
tff(fact_7248_finite__enumerate__in__set,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(set(A),nat,finite_card(A),S3))
           => member(A,infini527867602293511546merate(A,S3,Na),S3) ) ) ) ).

% finite_enumerate_in_set
tff(fact_7249_finite__enumerate__Ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),S: A] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( member(A,S,S3)
           => ? [N: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(set(A),nat,finite_card(A),S3))
                & ( infini527867602293511546merate(A,S3,N) = S ) ) ) ) ) ).

% finite_enumerate_Ex
tff(fact_7250_finite__enum__ext,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [X7: set(A),Y6: set(A)] :
          ( ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(set(A),nat,finite_card(A),X7))
             => ( infini527867602293511546merate(A,X7,I3) = infini527867602293511546merate(A,Y6,I3) ) )
         => ( aa(set(A),$o,finite_finite(A),X7)
           => ( aa(set(A),$o,finite_finite(A),Y6)
             => ( ( aa(set(A),nat,finite_card(A),X7) = aa(set(A),nat,finite_card(A),Y6) )
               => ( X7 = Y6 ) ) ) ) ) ) ).

% finite_enum_ext
tff(fact_7251_finite__enumerate__mono,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [M: nat,Na: nat,S3: set(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na)
         => ( aa(set(A),$o,finite_finite(A),S3)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(set(A),nat,finite_card(A),S3))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S3,M)),infini527867602293511546merate(A,S3,Na)) ) ) ) ) ).

% finite_enumerate_mono
tff(fact_7252_finite__le__enumerate,axiom,
    ! [S3: set(nat),Na: nat] :
      ( aa(set(nat),$o,finite_finite(nat),S3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(set(nat),nat,finite_card(nat),S3))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Na),infini527867602293511546merate(nat,S3,Na)) ) ) ).

% finite_le_enumerate
tff(fact_7253_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Na)),aa(set(A),nat,finite_card(A),S3))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S3,Na)),infini527867602293511546merate(A,S3,aa(nat,nat,suc,Na))) ) ) ) ).

% finite_enumerate_step
tff(fact_7254_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] : ( infini527867602293511546merate(A,S3,aa(nat,nat,suc,Na)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,infini527867602293511546merate(A,S3,zero_zero(nat))),bot_bot(set(A)))),Na) ) ) ).

% enumerate_Suc'
tff(fact_7255_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [X7: set(A),Y6: set(A)] :
          ( ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(set(A),nat,finite_card(A),X7))
             => ( infini527867602293511546merate(A,X7,I3) = infini527867602293511546merate(A,Y6,I3) ) )
         => ( aa(set(A),$o,finite_finite(A),X7)
           => ( aa(set(A),$o,finite_finite(A),Y6)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),X7)),aa(set(A),nat,finite_card(A),Y6))
               => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X7),Y6) ) ) ) ) ) ).

% finite_enum_subset
tff(fact_7256_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,Na)),aa(set(A),nat,finite_card(A),S3))
           => ( infini527867602293511546merate(A,S3,aa(nat,nat,suc,Na)) = ord_Least(A,aa(nat,fun(A,$o),aTP_Lamp_ack(set(A),fun(nat,fun(A,$o)),S3),Na)) ) ) ) ) ).

% finite_enumerate_Suc''
tff(fact_7257_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] : ( infini527867602293511546merate(A,S3,aa(nat,nat,suc,Na)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,ord_Least(A,aTP_Lamp_acl(set(A),fun(A,$o),S3))),bot_bot(set(A)))),Na) ) ) ).

% enumerate_Suc
tff(fact_7258_Least__eq__0,axiom,
    ! [P: fun(nat,$o)] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ord_Least(nat,P) = zero_zero(nat) ) ) ).

% Least_eq_0
tff(fact_7259_not__less__Least,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [K: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),ord_Least(A,P))
         => ~ aa(A,$o,P,K) ) ) ).

% not_less_Least
tff(fact_7260_Least__Suc2,axiom,
    ! [P: fun(nat,$o),Na: nat,Q: fun(nat,$o),M: nat] :
      ( aa(nat,$o,P,Na)
     => ( aa(nat,$o,Q,M)
       => ( ~ aa(nat,$o,P,zero_zero(nat))
         => ( ! [K2: nat] :
                ( aa(nat,$o,P,aa(nat,nat,suc,K2))
              <=> aa(nat,$o,Q,K2) )
           => ( ord_Least(nat,P) = aa(nat,nat,suc,ord_Least(nat,Q)) ) ) ) ) ) ).

% Least_Suc2
tff(fact_7261_Least__Suc,axiom,
    ! [P: fun(nat,$o),Na: nat] :
      ( aa(nat,$o,P,Na)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ( ord_Least(nat,P) = aa(nat,nat,suc,ord_Least(nat,aTP_Lamp_vn(fun(nat,$o),fun(nat,$o),P))) ) ) ) ).

% Least_Suc
tff(fact_7262_enumerate__0,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A)] : ( infini527867602293511546merate(A,S3,zero_zero(nat)) = ord_Least(A,aTP_Lamp_acl(set(A),fun(A,$o),S3)) ) ) ).

% enumerate_0
tff(fact_7263_Sup__real__def,axiom,
    ! [X7: set(real)] : ( complete_Sup_Sup(real,X7) = ord_Least(real,aTP_Lamp_acm(set(real),fun(real,$o),X7)) ) ).

% Sup_real_def
tff(fact_7264_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat] :
          ( ~ aa(set(A),$o,finite_finite(A),S3)
         => ( infini527867602293511546merate(A,S3,aa(nat,nat,suc,Na)) = ord_Least(A,aa(nat,fun(A,$o),aTP_Lamp_ack(set(A),fun(nat,fun(A,$o)),S3),Na)) ) ) ) ).

% enumerate_Suc''
tff(fact_7265_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A)] :
          ( ~ real_V358717886546972837endent(A,A3)
        <=> ! [S8: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S8),A3)
             => ( aa(set(A),$o,finite_finite(A),S8)
               => ! [U3: fun(A,real)] :
                    ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),U3)),S8) = zero_zero(A) )
                   => ! [X5: A] :
                        ( member(A,X5,S8)
                       => ( aa(A,real,U3,X5) = zero_zero(real) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
tff(fact_7266_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A)] :
          ( ~ real_V358717886546972837endent(A,S)
        <=> ! [T8: set(A),U3: fun(A,real),V5: A] :
              ( aa(set(A),$o,finite_finite(A),T8)
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T8),S)
               => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),U3)),T8) = zero_zero(A) )
                 => ( member(A,V5,T8)
                   => ( aa(A,real,U3,V5) = zero_zero(real) ) ) ) ) ) ) ) ).

% independent_explicit_module
tff(fact_7267_dependent__single,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A] :
          ( real_V358717886546972837endent(A,aa(set(A),set(A),insert(A,X),bot_bot(set(A))))
        <=> ( X = zero_zero(A) ) ) ) ).

% dependent_single
tff(fact_7268_dependent__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A)] :
          ( member(A,zero_zero(A),A3)
         => real_V358717886546972837endent(A,A3) ) ) ).

% dependent_zero
tff(fact_7269_unique__representation,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( ! [V4: A] :
                ( ( aa(A,real,F2,V4) != zero_zero(real) )
               => member(A,V4,Basis) )
           => ( ! [V4: A] :
                  ( ( aa(A,real,G,V4) != zero_zero(real) )
                 => member(A,V4,Basis) )
             => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F2)))
               => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),G)))
                 => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),F2)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F2))) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),G)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),G))) )
                   => ( F2 = G ) ) ) ) ) ) ) ) ).

% unique_representation
tff(fact_7270_independent__if__scalars__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [F4: fun(A,real),X3: A] :
                ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),F4)),A3) = zero_zero(A) )
               => ( member(A,X3,A3)
                 => ( aa(A,real,F4,X3) = zero_zero(real) ) ) )
           => ~ real_V358717886546972837endent(A,A3) ) ) ) ).

% independent_if_scalars_zero
tff(fact_7271_dependent__finite,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( real_V358717886546972837endent(A,S3)
          <=> ? [U3: fun(A,real)] :
                ( ? [X5: A] :
                    ( member(A,X5,S3)
                    & ( aa(A,real,U3,X5) != zero_zero(real) ) )
                & ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),U3)),S3) = zero_zero(A) ) ) ) ) ) ).

% dependent_finite
tff(fact_7272_independentD__unique,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),X7: fun(A,real),Y6: fun(A,real)] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X7)))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X7))),B3)
             => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),Y6)))
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),Y6))),B3)
                 => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),X7)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X7))) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),Y6)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),Y6))) )
                   => ( X7 = Y6 ) ) ) ) ) ) ) ) ).

% independentD_unique
tff(fact_7273_independentD,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A),T2: set(A),U: fun(A,real),V: A] :
          ( ~ real_V358717886546972837endent(A,S)
         => ( aa(set(A),$o,finite_finite(A),T2)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
             => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),U)),T2) = zero_zero(A) )
               => ( member(A,V,T2)
                 => ( aa(A,real,U,V) = zero_zero(real) ) ) ) ) ) ) ) ).

% independentD
tff(fact_7274_dependent__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] :
          ( real_V358717886546972837endent(A,B3)
        <=> ? [X8: fun(A,real)] :
              ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X8)))
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X8))),B3)
              & ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),X8)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X8))) = zero_zero(A) )
              & ? [X5: A] : ( aa(A,real,X8,X5) != zero_zero(real) ) ) ) ) ).

% dependent_alt
tff(fact_7275_independent__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] :
          ( ~ real_V358717886546972837endent(A,B3)
        <=> ! [X8: fun(A,real)] :
              ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X8)))
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X8))),B3)
               => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),X8)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X8))) = zero_zero(A) )
                 => ! [X5: A] : ( aa(A,real,X8,X5) = zero_zero(real) ) ) ) ) ) ) ).

% independent_alt
tff(fact_7276_independentD__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),X7: fun(A,real),X: A] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X7)))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X7))),B3)
             => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),X7)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),X7))) = zero_zero(A) )
               => ( aa(A,real,X7,X) = zero_zero(real) ) ) ) ) ) ) ).

% independentD_alt
tff(fact_7277_dependent__explicit,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A)] :
          ( real_V358717886546972837endent(A,S)
        <=> ? [T8: set(A)] :
              ( aa(set(A),$o,finite_finite(A),T8)
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T8),S)
              & ? [U3: fun(A,real)] :
                  ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),U3)),T8) = zero_zero(A) )
                  & ? [X5: A] :
                      ( member(A,X5,T8)
                      & ( aa(A,real,U3,X5) != zero_zero(real) ) ) ) ) ) ) ).

% dependent_explicit
tff(fact_7278_isUCont__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [F2: fun(A,B)] :
          ( topolo6026614971017936543ous_on(A,B,top_top(set(A)),F2)
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S5)
                  & ! [X5: A,Y5: A] :
                      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X5,Y5)),S5)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,X5),aa(A,B,F2,Y5))),R5) ) ) ) ) ) ).

% isUCont_def
tff(fact_7279_possible__bit__def,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Tyrep: itself(A),Na: nat] :
          ( bit_se6407376104438227557le_bit(A,Tyrep,Na)
        <=> ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) != zero_zero(A) ) ) ) ).

% possible_bit_def
tff(fact_7280_possible__bit__min,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Tyrep: itself(A),I2: nat,J2: nat] :
          ( bit_se6407376104438227557le_bit(A,Tyrep,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),I2),J2))
        <=> ( bit_se6407376104438227557le_bit(A,Tyrep,I2)
            | bit_se6407376104438227557le_bit(A,Tyrep,J2) ) ) ) ).

% possible_bit_min
tff(fact_7281_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Tyrep: itself(A),I2: nat,J2: nat] :
          ( bit_se6407376104438227557le_bit(A,Tyrep,I2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),I2)
           => bit_se6407376104438227557le_bit(A,Tyrep,J2) ) ) ) ).

% possible_bit_less_imp
tff(fact_7282_possible__bit__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ty: itself(A)] : bit_se6407376104438227557le_bit(A,Ty,zero_zero(nat)) ) ).

% possible_bit_0
tff(fact_7283_uniformly__continuous__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [S: set(A),F2: fun(A,B)] :
          ( topolo6026614971017936543ous_on(A,B,S,F2)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [D3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D3)
                  & ! [X5: A] :
                      ( member(A,X5,S)
                     => ! [Xa4: A] :
                          ( member(A,Xa4,S)
                         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Xa4,X5)),D3)
                           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F2,Xa4),aa(A,B,F2,X5))),E3) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
tff(fact_7284_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] :
          ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na))
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                aa($o,A,zero_neq_one_of_bool(A),
                  aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
                & bit_se6407376104438227557le_bit(A,type2(A),Na))),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M))) ) ) ).

% drop_bit_exp_eq
tff(fact_7285_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na) ) ) ) ).

% bit_minus_2_iff
tff(fact_7286_CHAR__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiri4206861660011772517g_char(A,type2(A)) = zero_zero(nat) ) ) ).

% CHAR_eq_0
tff(fact_7287_of__nat__CHAR,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),semiri4206861660011772517g_char(A,type2(A))) = zero_zero(A) ) ) ).

% of_nat_CHAR
tff(fact_7288_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),one_one(A))),Na)
        <=> bit_se6407376104438227557le_bit(A,type2(A),Na) ) ) ).

% bit_minus_1_iff
tff(fact_7289_bit__imp__possible__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
         => bit_se6407376104438227557le_bit(A,type2(A),Na) ) ) ).

% bit_imp_possible_bit
tff(fact_7290_impossible__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat,A2: A] :
          ( ~ bit_se6407376104438227557le_bit(A,type2(A),Na)
         => ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ).

% impossible_bit
tff(fact_7291_bit__eq__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ! [N4: nat] :
              ( bit_se6407376104438227557le_bit(A,type2(A),N4)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N4)
              <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N4) ) ) ) ) ).

% bit_eq_iff
tff(fact_7292_bit__eqI,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] :
          ( ! [N: nat] :
              ( bit_se6407376104438227557le_bit(A,type2(A),N)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N) ) )
         => ( A2 = B2 ) ) ) ).

% bit_eqI
tff(fact_7293_bit__not__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) ) ) ) ).

% bit_not_iff
tff(fact_7294_bit__set__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(nat,fun(A,A),bit_se5668285175392031749et_bit(A),M),A2)),Na)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na)
            | ( ( M = Na )
              & bit_se6407376104438227557le_bit(A,type2(A),Na) ) ) ) ) ).

% bit_set_bit_iff
tff(fact_7295_bit__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(nat,fun(A,A),bit_se8732182000553998342ip_bit(A),M),A2)),Na)
        <=> ( ( ( M = Na )
            <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),Na) )
            & bit_se6407376104438227557le_bit(A,type2(A),Na) ) ) ) ).

% bit_flip_bit_iff
tff(fact_7296_bit__mask__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,bit_se2239418461657761734s_mask(A,M)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M) ) ) ) ).

% bit_mask_iff
tff(fact_7297_of__nat__eq__0__iff__char__dvd,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Na: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Na) = zero_zero(A) )
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),semiri4206861660011772517g_char(A,type2(A))),Na) ) ) ).

% of_nat_eq_0_iff_char_dvd
tff(fact_7298_CHAR__eqI,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [C2: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),C2) = zero_zero(A) )
         => ( ! [X3: nat] :
                ( ( aa(nat,A,semiring_1_of_nat(A),X3) = zero_zero(A) )
               => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),C2),X3) )
           => ( semiri4206861660011772517g_char(A,type2(A)) = C2 ) ) ) ) ).

% CHAR_eqI
tff(fact_7299_bit__of__int__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: int,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(int,A,ring_1_of_int(A),K)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),Na) ) ) ) ).

% bit_of_int_iff
tff(fact_7300_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(nat,A,semiring_1_of_nat(A),M)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(nat,M),Na) ) ) ) ).

% bit_of_nat_iff
tff(fact_7301_bit__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4674362597316999326ke_bit(A,M),A2)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)) ) ) ) ).

% bit_signed_take_bit_iff
tff(fact_7302_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),A2)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),Na) ) ) ) ).

% bit_minus_iff
tff(fact_7303_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se4730199178511100633sh_bit(A,M),A2)),Na)
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na)
            & bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),M)) ) ) ) ).

% bit_push_bit_iff
tff(fact_7304_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),semiri4206861660011772517g_char(A,type2(A)))
      <=> ? [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N4)
            & ( aa(nat,A,semiring_1_of_nat(A),N4) = zero_zero(A) ) ) ) ) ).

% CHAR_pos_iff
tff(fact_7305_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [C2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
         => ( ( aa(nat,A,semiring_1_of_nat(A),C2) = zero_zero(A) )
           => ( ! [X3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X3)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),C2)
                   => ( aa(nat,A,semiring_1_of_nat(A),X3) != zero_zero(A) ) ) )
             => ( semiri4206861660011772517g_char(A,type2(A)) = C2 ) ) ) ) ) ).

% CHAR_eq_posI
tff(fact_7306_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( ( semiri4206861660011772517g_char(A,type2(A)) = zero_zero(nat) )
      <=> ! [N4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N4)
           => ( aa(nat,A,semiring_1_of_nat(A),N4) != zero_zero(A) ) ) ) ) ).

% CHAR_eq0_iff
tff(fact_7307_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na) = zero_zero(A) )
        <=> ~ bit_se6407376104438227557le_bit(A,type2(A),Na) ) ) ).

% fold_possible_bit
tff(fact_7308_bit__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & ( M = Na ) ) ) ) ).

% bit_exp_iff
tff(fact_7309_bit__2__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),one_one(nat))
            & ( Na = one_one(nat) ) ) ) ) ).

% bit_2_iff
tff(fact_7310_bit__not__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4277139882892585799ns_not(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M))),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & ( Na != M ) ) ) ) ).

% bit_not_exp_iff
tff(fact_7311_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M))),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ) ) ).

% bit_minus_exp_iff
tff(fact_7312_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M)),one_one(A))),Na)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),Na)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),M) ) ) ) ).

% bit_mask_sub_iff
tff(fact_7313_bit__double__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,Na: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A2)),Na)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Na),one_one(nat)))
            & ( Na != zero_zero(nat) )
            & bit_se6407376104438227557le_bit(A,type2(A),Na) ) ) ) ).

% bit_double_iff
tff(fact_7314_prod__Un,axiom,
    ! [B: $tType,A: $tType] :
      ( field(B)
     => ! [A3: set(A),B3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
                 => ( aa(A,B,F2,X3) != zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ) ).

% prod_Un
tff(fact_7315_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = zero_zero(A) )
        <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))))
            & aa(set(A),$o,finite_finite(A),A3) ) ) ) ).

% Gcd_fin_0_iff
tff(fact_7316_Diff__disjoint,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) = bot_bot(set(A)) ) ).

% Diff_disjoint
tff(fact_7317_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_fin.empty
tff(fact_7318_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ).

% Gcd_fin.infinite
tff(fact_7319_Diff__Compl,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) ) ).

% Diff_Compl
tff(fact_7320_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),one_one(A))
        <=> ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ).

% is_unit_Gcd_fin_iff
tff(fact_7321_Gcd__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) ) ) ).

% Gcd_fin.insert
tff(fact_7322_Gcd__fin__eq__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = gcd_Gcd(A,A3) ) ) ) ).

% Gcd_fin_eq_Gcd
tff(fact_7323_Diff__Un,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C6)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C6)) ) ).

% Diff_Un
tff(fact_7324_Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C6)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C6)) ) ).

% Diff_Int
tff(fact_7325_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = A3 ) ).

% Int_Diff_Un
tff(fact_7326_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = A3 ) ).

% Un_Diff_Int
tff(fact_7327_Diff__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B3)) ) ).

% Diff_eq
tff(fact_7328_diff__eq,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% diff_eq
tff(fact_7329_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),C6) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C6)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C6)) ) ).

% Diff_Int_distrib2
tff(fact_7330_Diff__Int__distrib,axiom,
    ! [A: $tType,C6: set(A),A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C6),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C6),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C6),B3)) ) ).

% Diff_Int_distrib
tff(fact_7331_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) ) ).

% Diff_Diff_Int
tff(fact_7332_Diff__Int2,axiom,
    ! [A: $tType,A3: set(A),C6: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C6)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C6)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C6)),B3) ) ).

% Diff_Int2
tff(fact_7333_Int__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C6: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),C6) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C6)) ) ).

% Int_Diff
tff(fact_7334_Gcd__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B3: set(A),A3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),B3)),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) = aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) ) ) ) ).

% Gcd_fin.subset
tff(fact_7335_less__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,X: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),X) ) ) ).

% less_infI1
tff(fact_7336_less__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,X: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),X)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),X) ) ) ).

% less_infI2
tff(fact_7337_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = A2 ) ) ) ).

% inf.absorb3
tff(fact_7338_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = B2 ) ) ) ).

% inf.absorb4
tff(fact_7339_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% inf.strict_boundedE
tff(fact_7340_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ( A2 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) )
            & ( A2 != B2 ) ) ) ) ).

% inf.strict_order_iff
tff(fact_7341_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),C2) ) ) ).

% inf.strict_coboundedI1
tff(fact_7342_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),C2) ) ) ).

% inf.strict_coboundedI2
tff(fact_7343_Gcd__fin__greatest,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) ) ) ) ).

% Gcd_fin_greatest
tff(fact_7344_dvd__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3))
          <=> ! [X5: A] :
                ( member(A,X5,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),X5) ) ) ) ) ).

% dvd_Gcd_fin_iff
tff(fact_7345_Gcd__fin__dvd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),A2) ) ) ).

% Gcd_fin_dvd
tff(fact_7346_Gcd__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) = aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) ) ) ) ).

% Gcd_fin.in_idem
tff(fact_7347_Gcd__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),aa(set(A),A,semiring_gcd_Gcd_fin(A),B3)) ) ) ).

% Gcd_fin.union
tff(fact_7348_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = bot_bot(set(A)) ) ).

% Int_Diff_disjoint
tff(fact_7349_Diff__triv,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = A3 ) ) ).

% Diff_triv
tff(fact_7350_gcd__list__greatest,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Bs: list(A),A2: A] :
          ( ! [B4: A] :
              ( member(A,B4,aa(list(A),set(A),set2(A),Bs))
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(list(A),set(A),set2(A),Bs))) ) ) ).

% gcd_list_greatest
tff(fact_7351_dvd__gcd__list__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,Xs: list(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(list(A),set(A),set2(A),Xs)))
        <=> ! [X5: A] :
              ( member(A,X5,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),X5) ) ) ) ).

% dvd_gcd_list_iff
tff(fact_7352_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),S)),image(A,A,aTP_Lamp_mc(A,fun(A,A),A2),T2)) ) ) ).

% translation_subtract_Int
tff(fact_7353_translation__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),image(A,A,aa(A,fun(A,A),plus_plus(A),A2),S)),image(A,A,aa(A,fun(A,A),plus_plus(A),A2),T2)) ) ) ).

% translation_Int
tff(fact_7354_sum_Ointer__restrict,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(set(A),fun(A,B),aTP_Lamp_acp(fun(A,B),fun(set(A),fun(A,B)),G),B3)),A3) ) ) ) ).

% sum.inter_restrict
tff(fact_7355_prod_Ointer__restrict,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(set(A),fun(A,B),aTP_Lamp_acq(fun(A,B),fun(set(A),fun(A,B)),G),B3)),A3) ) ) ) ).

% prod.inter_restrict
tff(fact_7356_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ? [A7: set(A)] :
                ( topolo1002775350975398744n_open(A,A7)
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),S) = collect(A,aa(fun(A,real),fun(A,$o),aa(fun(A,real),fun(fun(A,real),fun(A,$o)),aTP_Lamp_acr(set(A),fun(fun(A,real),fun(fun(A,real),fun(A,$o))),S),F2),G)) ) ) ) ) ) ).

% open_Collect_less_Int
tff(fact_7357_sum_Omono__neutral__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S3: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,finite_finite(A),S3)
           => ( ! [I3: A] :
                  ( member(A,I3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,H,I3) = zero_zero(B) ) )
             => ( ! [I3: A] :
                    ( member(A,I3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),T5))
                   => ( aa(A,B,G,I3) = zero_zero(B) ) )
               => ( ! [X3: A] :
                      ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S3),T5))
                     => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
                 => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),T5) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_7358_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [K: A,X: A] :
          ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,K)),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),K),aa(set(A),set(A),insert(A,X),bot_bot(set(A))),bot_bot(set(A))) ) ) ).

% Iio_Int_singleton
tff(fact_7359_sum_Ounion__inter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ).

% sum.union_inter
tff(fact_7360_sum_OInt__Diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ) ) ).

% sum.Int_Diff
tff(fact_7361_prod_OInt__Diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ) ) ).

% prod.Int_Diff
tff(fact_7362_prod_Omono__neutral__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S3: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,finite_finite(A),S3)
           => ( ! [I3: A] :
                  ( member(A,I3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S3))
                 => ( aa(A,B,H,I3) = one_one(B) ) )
             => ( ! [I3: A] :
                    ( member(A,I3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),T5))
                   => ( aa(A,B,G,I3) = one_one(B) ) )
               => ( ! [X3: A] :
                      ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S3),T5))
                     => ( aa(A,B,G,X3) = aa(A,B,H,X3) ) )
                 => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),T5) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
tff(fact_7363_card__Un__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% card_Un_Int
tff(fact_7364_less__separate,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ? [A4: A,B4: A] :
              ( member(A,X,set_ord_lessThan(A,A4))
              & member(A,Y,set_ord_greaterThan(A,B4))
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,A4)),set_ord_greaterThan(A,B4)) = bot_bot(set(A)) ) ) ) ) ).

% less_separate
tff(fact_7365_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semila1105856199041335345_order(A,inf_inf(A),top_top(A),ord_less_eq(A),ord_less(A)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_7366_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ).

% card_Diff_subset_Int
tff(fact_7367_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),complete_Inf_Inf(A,image(nat,A,aTP_Lamp_aad(A,fun(nat,A),B3),collect(nat,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B3) ) ) ).

% INF_nat_binary
tff(fact_7368_sum_OIf__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),P: fun(A,$o),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_acs(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),P),H),G)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),collect(A,P))))) ) ) ) ).

% sum.If_cases
tff(fact_7369_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F2: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F2)
         => ? [A7: set(A)] :
              ( topolo1002775350975398744n_open(A,A7)
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A7),S) = collect(A,aa(fun(A,real),fun(A,$o),aTP_Lamp_act(set(A),fun(fun(A,real),fun(A,$o)),S),F2)) ) ) ) ) ).

% open_Collect_positive
tff(fact_7370_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% Gcd_fin.insert_remove
tff(fact_7371_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% Gcd_fin.remove
tff(fact_7372_sum_Ounion__inter__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
                 => ( aa(A,B,G,X3) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_7373_sum__Un,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),B3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% sum_Un
tff(fact_7374_sum_Ounion__disjoint,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_7375_prod_Ounion__inter__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X3: A] :
                  ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
                 => ( aa(A,B,G,X3) = one_one(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_7376_sum_Ounion__diff2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% sum.union_diff2
tff(fact_7377_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),F2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% sum_Un2
tff(fact_7378_prod_Ounion__diff2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% prod.union_diff2
tff(fact_7379_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
         => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_7380_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))
    <=> ( inj_on(A,B,F2,A3)
        & inj_on(A,B,F2,B3)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),image(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),image(A,B,F2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))) = bot_bot(set(B)) ) ) ) ).

% inj_on_Un
tff(fact_7381_dvd__partition,axiom,
    ! [A: $tType,C6: set(set(A)),K: nat] :
      ( aa(set(A),$o,finite_finite(A),complete_Sup_Sup(set(A),C6))
     => ( ! [X3: set(A)] :
            ( member(set(A),X3,C6)
           => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(set(A),nat,finite_card(A),X3)) )
       => ( ! [X3: set(A)] :
              ( member(set(A),X3,C6)
             => ! [Xa3: set(A)] :
                  ( member(set(A),Xa3,C6)
                 => ( ( X3 != Xa3 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X3),Xa3) = bot_bot(set(A)) ) ) ) )
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(set(A),nat,finite_card(A),complete_Sup_Sup(set(A),C6))) ) ) ) ).

% dvd_partition
tff(fact_7382_at__within__nhd,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X: A,S3: set(A),T5: set(A),U4: set(A)] :
          ( member(A,X,S3)
         => ( topolo1002775350975398744n_open(A,S3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),T5),S3)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U4),S3)),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) )
             => ( topolo174197925503356063within(A,X,T5) = topolo174197925503356063within(A,X,U4) ) ) ) ) ) ).

% at_within_nhd
tff(fact_7383_sum__Un__nat,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),F2: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),B3))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% sum_Un_nat
tff(fact_7384_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S3: set(A),Na: nat,S: A] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S3),set_ord_lessThan(A,S))))
           => ( infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S3),set_ord_lessThan(A,S)),Na) = infini527867602293511546merate(A,S3,Na) ) ) ) ) ).

% finite_enumerate_initial_segment
tff(fact_7385_sum__div__partition,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: set(A),F2: fun(A,B),B2: B] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),A3)),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(B,fun(A,B),aTP_Lamp_acu(fun(A,B),fun(B,fun(A,B)),F2),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,aa(B,fun(A,$o),aTP_Lamp_acv(fun(A,B),fun(B,fun(A,$o)),F2),B2))))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,aa(B,fun(A,$o),aTP_Lamp_acw(fun(A,B),fun(B,fun(A,$o)),F2),B2))))),B2)) ) ) ) ).

% sum_div_partition
tff(fact_7386_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o)] :
      ( distinct(A,Xs)
     => ( aa(list(A),nat,size_size(list(A)),filter2(A,P,Xs)) = aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),collect(A,P)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% distinct_length_filter
tff(fact_7387_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F2: fun(A,option(B)),G: fun(A,option(B)),A3: set(A)] : ( dom(A,B,override_on(A,option(B),F2,G,A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),dom(A,B,F2)),collect(A,aa(set(A),fun(A,$o),aTP_Lamp_acx(fun(A,option(B)),fun(set(A),fun(A,$o)),G),A3)))),collect(A,aa(set(A),fun(A,$o),aTP_Lamp_acy(fun(A,option(B)),fun(set(A),fun(A,$o)),G),A3))) ) ).

% dom_override_on
tff(fact_7388_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),nat,finite_card(list(A)),shuffles(A,Xs,Ys)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_7389_inf__enat__def,axiom,
    inf_inf(extended_enat) = ord_min(extended_enat) ).

% inf_enat_def
tff(fact_7390_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_7391_inf__int__def,axiom,
    inf_inf(int) = ord_min(int) ).

% inf_int_def
tff(fact_7392_length__shuffles,axiom,
    ! [A: $tType,Zs2: list(A),Xs: list(A),Ys: list(A)] :
      ( member(list(A),Zs2,shuffles(A,Xs,Ys))
     => ( aa(list(A),nat,size_size(list(A)),Zs2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ) ).

% length_shuffles
tff(fact_7393_at__within__order,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X: A,S: set(A)] :
          ( ( top_top(set(A)) != aa(set(A),set(A),insert(A,X),bot_bot(set(A))) )
         => ( topolo174197925503356063within(A,X,S) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),complete_Inf_Inf(filter(A),image(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_acz(A,fun(set(A),fun(A,filter(A))),X),S),set_ord_greaterThan(A,X)))),complete_Inf_Inf(filter(A),image(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_ada(A,fun(set(A),fun(A,filter(A))),X),S),set_ord_lessThan(A,X)))) ) ) ) ).

% at_within_order
tff(fact_7394_eventually__filtercomap__at__topological,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [P: fun(A,$o),F2: fun(A,B),A3: B,B3: set(B)] :
          ( eventually(A,P,filtercomap(A,B,F2,topolo174197925503356063within(B,A3,B3)))
        <=> ? [S8: set(B)] :
              ( topolo1002775350975398744n_open(B,S8)
              & member(B,A3,S8)
              & ! [X5: A] :
                  ( member(B,aa(A,B,F2,X5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S8),B3)),aa(set(B),set(B),insert(B,A3),bot_bot(set(B)))))
                 => aa(A,$o,P,X5) ) ) ) ) ).

% eventually_filtercomap_at_topological
tff(fact_7395_eventually__filtercomap__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(B)
        & no_top(B) )
     => ! [P: fun(A,$o),F2: fun(A,B)] :
          ( eventually(A,P,filtercomap(A,B,F2,at_top(B)))
        <=> ? [N5: B] :
            ! [X5: A] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),N5),aa(A,B,F2,X5))
             => aa(A,$o,P,X5) ) ) ) ).

% eventually_filtercomap_at_top_dense
tff(fact_7396_eventually__filtercomap__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(B)
        & no_bot(B) )
     => ! [P: fun(A,$o),F2: fun(A,B)] :
          ( eventually(A,P,filtercomap(A,B,F2,at_bot(B)))
        <=> ? [N5: B] :
            ! [X5: A] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X5)),N5)
             => aa(A,$o,P,X5) ) ) ) ).

% eventually_filtercomap_at_bot_dense
tff(fact_7397_at__left__eq,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Y: A,X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
         => ( topolo174197925503356063within(A,X,set_ord_lessThan(A,X)) = complete_Inf_Inf(filter(A),image(A,filter(A),aTP_Lamp_adb(A,fun(A,filter(A)),X),set_ord_lessThan(A,X))) ) ) ) ).

% at_left_eq
tff(fact_7398_at__right__eq,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( topolo174197925503356063within(A,X,set_ord_greaterThan(A,X)) = complete_Inf_Inf(filter(A),image(A,filter(A),aTP_Lamp_adc(A,fun(A,filter(A)),X),set_ord_greaterThan(A,X))) ) ) ) ).

% at_right_eq
tff(fact_7399_at__within__def,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A2: A,S: set(A)] : ( topolo174197925503356063within(A,A2,S) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),topolo7230453075368039082e_nhds(A,A2)),principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% at_within_def
tff(fact_7400_nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X: A] : ( topolo7230453075368039082e_nhds(A,X) = complete_Inf_Inf(filter(A),image(real,filter(A),aTP_Lamp_ade(A,fun(real,filter(A)),X),set_ord_greaterThan(real,zero_zero(real)))) ) ) ).

% nhds_metric
tff(fact_7401_at__within__eq,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X: A,S: set(A)] : ( topolo174197925503356063within(A,X,S) = complete_Inf_Inf(filter(A),image(set(A),filter(A),aa(set(A),fun(set(A),filter(A)),aTP_Lamp_adf(A,fun(set(A),fun(set(A),filter(A))),X),S),collect(set(A),aTP_Lamp_adg(A,fun(set(A),$o),X)))) ) ) ).

% at_within_eq
tff(fact_7402_uniformity__dist,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ( topolo7806501430040627800ormity(A) = complete_Inf_Inf(filter(product_prod(A,A)),image(real,filter(product_prod(A,A)),aTP_Lamp_adi(real,filter(product_prod(A,A))),set_ord_greaterThan(real,zero_zero(real)))) ) ) ).

% uniformity_dist
tff(fact_7403_uniformity__complex__def,axiom,
    topolo7806501430040627800ormity(complex) = complete_Inf_Inf(filter(product_prod(complex,complex)),image(real,filter(product_prod(complex,complex)),aTP_Lamp_adk(real,filter(product_prod(complex,complex))),set_ord_greaterThan(real,zero_zero(real)))) ).

% uniformity_complex_def
tff(fact_7404_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [P: fun(product_prod(A,A),$o)] :
          ( eventually(product_prod(A,A),P,topolo7806501430040627800ormity(A))
        <=> ? [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
              & ! [X5: A,Y5: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X5,Y5)),E3)
                 => aa(product_prod(A,A),$o,P,aa(A,product_prod(A,A),product_Pair(A,A,X5),Y5)) ) ) ) ) ).

% eventually_uniformity_metric
tff(fact_7405_uniformity__real__def,axiom,
    topolo7806501430040627800ormity(real) = complete_Inf_Inf(filter(product_prod(real,real)),image(real,filter(product_prod(real,real)),aTP_Lamp_adm(real,filter(product_prod(real,real))),set_ord_greaterThan(real,zero_zero(real)))) ).

% uniformity_real_def
tff(fact_7406_continuous__on__arcosh,axiom,
    ! [A3: set(real)] :
      ( aa(set(real),$o,aa(set(real),fun(set(real),$o),ord_less_eq(set(real)),A3),set_ord_atLeast(real,one_one(real)))
     => topolo81223032696312382ous_on(real,real,A3,arcosh(real)) ) ).

% continuous_on_arcosh
tff(fact_7407_last__list__update,axiom,
    ! [A: $tType,Xs: list(A),K: nat,X: A] :
      ( ( Xs != nil(A) )
     => ( last(A,list_update(A,Xs,K,X))
        = $ite(K = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),X,last(A,Xs)) ) ) ).

% last_list_update
tff(fact_7408_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I2: A] : ( image(A,A,aa(A,fun(A,A),plus_plus(A),K),set_ord_atLeast(A,I2)) = set_ord_atLeast(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),K),I2)) ) ) ).

% image_add_atLeast
tff(fact_7409_last__replicate,axiom,
    ! [A: $tType,Na: nat,X: A] :
      ( ( Na != zero_zero(nat) )
     => ( last(A,replicate(A,Na,X)) = X ) ) ).

% last_replicate
tff(fact_7410_image__minus__const__AtMost,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] : ( image(A,A,aa(A,fun(A,A),minus_minus(A),C2),set_ord_atMost(A,B2)) = set_ord_atLeast(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% image_minus_const_AtMost
tff(fact_7411_image__minus__const__atLeast,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] : ( image(A,A,aa(A,fun(A,A),minus_minus(A),C2),set_ord_atLeast(A,A2)) = set_ord_atMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)) ) ) ).

% image_minus_const_atLeast
tff(fact_7412_last__upt,axiom,
    ! [I2: nat,J2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
     => ( last(nat,upt(I2,J2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J2),one_one(nat)) ) ) ).

% last_upt
tff(fact_7413_last__drop,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Na),aa(list(A),nat,size_size(list(A)),Xs))
     => ( last(A,drop(A,Na,Xs)) = last(A,Xs) ) ) ).

% last_drop
tff(fact_7414_last__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] :
      ( ( Xs != nil(A) )
     => ( ( Ys != nil(B) )
       => ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
         => ( last(product_prod(A,B),zip(A,B,Xs,Ys)) = aa(B,product_prod(A,B),product_Pair(A,B,last(A,Xs)),last(B,Ys)) ) ) ) ) ).

% last_zip
tff(fact_7415_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atLeast(A,A2)),set_ord_greaterThan(A,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% Ici_subset_Ioi_iff
tff(fact_7416_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),set_ord_atLeast(A,U)) = set_ord_greaterThan(A,L) ) ) ) ).

% ivl_disj_un_one(6)
tff(fact_7417_last__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( last(A,Xs) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))) ) ) ).

% last_conv_nth
tff(fact_7418_VEBT_Osimps_I7_J,axiom,
    ! [A: $tType,F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),F22: fun($o,fun($o,A)),X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( vEBT_rec_VEBT(A,F1,F22,vEBT_Node(X11,X12,X13,X14)) = aa(A,A,aa(vEBT_VEBT,fun(A,A),aa(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A)),aa(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))),aa(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A)))),F1,X11),X12),map(vEBT_VEBT,product_prod(vEBT_VEBT,A),aa(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A)),aTP_Lamp_adn(fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),fun(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A))),F1),F22),X13)),X14),vEBT_rec_VEBT(A,F1,F22,X14)) ) ).

% VEBT.simps(7)
tff(fact_7419_minus__coset__filter,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),coset(A,Xs)) = aa(list(A),set(A),set2(A),filter2(A,aTP_Lamp_a(set(A),fun(A,$o),A3),Xs)) ) ).

% minus_coset_filter
tff(fact_7420_atLeast__0,axiom,
    set_ord_atLeast(nat,zero_zero(nat)) = top_top(set(nat)) ).

% atLeast_0
tff(fact_7421_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] : ( set_ord_atLeast(nat,aa(nat,nat,suc,K)) = set_ord_greaterThan(nat,K) ) ).

% atLeast_Suc_greaterThan
tff(fact_7422_VEBT_Osimps_I8_J,axiom,
    ! [A: $tType,F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),F22: fun($o,fun($o,A)),X21: $o,X222: $o] : ( vEBT_rec_VEBT(A,F1,F22,vEBT_Leaf(X21,X222)) = aa($o,A,aa($o,fun($o,A),F22,X21),X222) ) ).

% VEBT.simps(8)
tff(fact_7423_atLeast__Suc,axiom,
    ! [K: nat] : ( set_ord_atLeast(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atLeast(nat,K)),aa(set(nat),set(nat),insert(nat,K),bot_bot(set(nat)))) ) ).

% atLeast_Suc
tff(fact_7424_flat__lub__def,axiom,
    ! [A: $tType,B2: A,A3: set(A)] :
      ( partial_flat_lub(A,B2,A3)
      = $ite(aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))),B2,the(A,aa(set(A),fun(A,$o),aTP_Lamp_ado(A,fun(set(A),fun(A,$o)),B2),A3))) ) ).

% flat_lub_def
tff(fact_7425_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,F2: fun(A,nat),Fs: list(fun(A,nat))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),measures(A,cons(fun(A,nat),F2,Fs)))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,X)),aa(A,nat,F2,Y))
        | ( ( aa(A,nat,F2,X) = aa(A,nat,F2,Y) )
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),measures(A,Fs)) ) ) ) ).

% in_measures(2)
tff(fact_7426_measures__less,axiom,
    ! [A: $tType,F2: fun(A,nat),X: A,Y: A,Fs: list(fun(A,nat))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,X)),aa(A,nat,F2,Y))
     => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),measures(A,cons(fun(A,nat),F2,Fs))) ) ).

% measures_less
tff(fact_7427_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,X),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),sup_sup(A),X),lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ).

% Sup_fin.insert_remove
tff(fact_7428_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( lattic5882676163264333800up_fin(A,A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),sup_sup(A),X),lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ) ).

% Sup_fin.remove
tff(fact_7429_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( lattic7752659483105999362nf_fin(A,A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),inf_inf(A),X),lattic7752659483105999362nf_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ) ).

% Inf_fin.remove
tff(fact_7430_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),X: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( lattic7752659483105999362nf_fin(A,aa(set(A),set(A),insert(A,X),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))) = bot_bot(set(A)),X,aa(A,A,aa(A,fun(A,A),inf_inf(A),X),lattic7752659483105999362nf_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A))))))) ) ) ) ).

% Inf_fin.insert_remove
tff(fact_7431_Bseq__monoseq__convergent_H__dec,axiom,
    ! [F2: fun(nat,real),M10: nat] :
      ( bfun(nat,real,aa(nat,fun(nat,real),aTP_Lamp_adp(fun(nat,real),fun(nat,fun(nat,real)),F2),M10),at_top(nat))
     => ( ! [M4: nat,N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M10),M4)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,N)),aa(nat,real,F2,M4)) ) )
       => topolo6863149650580417670ergent(real,F2) ) ) ).

% Bseq_monoseq_convergent'_dec
tff(fact_7432_Bseq__monoseq__convergent_H__inc,axiom,
    ! [F2: fun(nat,real),M10: nat] :
      ( bfun(nat,real,aa(nat,fun(nat,real),aTP_Lamp_adp(fun(nat,real),fun(nat,fun(nat,real)),F2),M10),at_top(nat))
     => ( ! [M4: nat,N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M10),M4)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F2,M4)),aa(nat,real,F2,N)) ) )
       => topolo6863149650580417670ergent(real,F2) ) ) ).

% Bseq_monoseq_convergent'_inc
tff(fact_7433_convergent__mult__const__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_tz(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
          <=> topolo6863149650580417670ergent(A,F2) ) ) ) ).

% convergent_mult_const_iff
tff(fact_7434_convergent__mult__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ua(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
          <=> topolo6863149650580417670ergent(A,F2) ) ) ) ).

% convergent_mult_const_right_iff
tff(fact_7435_convergent__Suc__iff,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,aTP_Lamp_uc(fun(nat,A),fun(nat,A),F2))
        <=> topolo6863149650580417670ergent(A,F2) ) ) ).

% convergent_Suc_iff
tff(fact_7436_convergent__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F2: fun(nat,A),M: nat] :
          ( topolo6863149650580417670ergent(A,aa(nat,fun(nat,A),aTP_Lamp_ud(fun(nat,A),fun(nat,fun(nat,A)),F2),M))
        <=> topolo6863149650580417670ergent(A,F2) ) ) ).

% convergent_ignore_initial_segment
tff(fact_7437_convergent__add__const__right__iff,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( topolo6863149650580417670ergent(A,aa(A,fun(nat,A),aTP_Lamp_adq(fun(nat,A),fun(A,fun(nat,A)),F2),C2))
        <=> topolo6863149650580417670ergent(A,F2) ) ) ).

% convergent_add_const_right_iff
tff(fact_7438_convergent__add__const__iff,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [C2: A,F2: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adr(A,fun(fun(nat,A),fun(nat,A)),C2),F2))
        <=> topolo6863149650580417670ergent(A,F2) ) ) ).

% convergent_add_const_iff
tff(fact_7439_convergent__add,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [X7: fun(nat,A),Y6: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,X7)
         => ( topolo6863149650580417670ergent(A,Y6)
           => topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ads(fun(nat,A),fun(fun(nat,A),fun(nat,A)),X7),Y6)) ) ) ) ).

% convergent_add
tff(fact_7440_convergent__diff,axiom,
    ! [A: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [X7: fun(nat,A),Y6: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,X7)
         => ( topolo6863149650580417670ergent(A,Y6)
           => topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adt(fun(nat,A),fun(fun(nat,A),fun(nat,A)),X7),Y6)) ) ) ) ).

% convergent_diff
tff(fact_7441_convergent__diff__const__right__iff,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [F2: fun(nat,A),C2: A] :
          ( topolo6863149650580417670ergent(A,aa(A,fun(nat,A),aTP_Lamp_adu(fun(nat,A),fun(A,fun(nat,A)),F2),C2))
        <=> topolo6863149650580417670ergent(A,F2) ) ) ).

% convergent_diff_const_right_iff
tff(fact_7442_convergent__realpow,axiom,
    ! [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),one_one(real))
       => topolo6863149650580417670ergent(real,aa(real,fun(nat,real),power_power(real),X)) ) ) ).

% convergent_realpow
tff(fact_7443_pair__lessI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),S),T2)
       => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),product_Pair(product_prod(nat,nat),product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),S)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,B2),T2)),fun_pair_less) ) ) ).

% pair_lessI2
tff(fact_7444_cauchy__filter__metric__filtermap,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V768167426530841204y_dist(A)
        & topolo7287701948861334536_space(A) )
     => ! [F2: fun(B,A),F3: filter(B)] :
          ( topolo6773858410816713723filter(A,filtermap(B,A,F2,F3))
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [P5: fun(B,$o)] :
                  ( eventually(B,P5,F3)
                  & ! [X5: B,Y5: B] :
                      ( ( aa(B,$o,P5,X5)
                        & aa(B,$o,P5,Y5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(B,A,F2,X5),aa(B,A,F2,Y5))),E3) ) ) ) ) ) ).

% cauchy_filter_metric_filtermap
tff(fact_7445_pair__less__iff1,axiom,
    ! [X: nat,Y: nat,Z: nat] :
      ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),product_Pair(product_prod(nat,nat),product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Y)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Z)),fun_pair_less)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y),Z) ) ).

% pair_less_iff1
tff(fact_7446_filtermap__nhds__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [D2: A,A2: A] : ( filtermap(A,A,aTP_Lamp_adv(A,fun(A,A),D2),topolo7230453075368039082e_nhds(A,A2)) = topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2)) ) ) ).

% filtermap_nhds_shift
tff(fact_7447_filtermap__nhds__times,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( filtermap(A,A,aa(A,fun(A,A),times_times(A),C2),topolo7230453075368039082e_nhds(A,A2)) = topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ) ).

% filtermap_nhds_times
tff(fact_7448_filtermap__at__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [D2: A,A2: A] : ( filtermap(A,A,aTP_Lamp_adv(A,fun(A,A),D2),topolo174197925503356063within(A,A2,top_top(set(A)))) = topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A))) ) ) ).

% filtermap_at_shift
tff(fact_7449_filtermap__at__right__shift,axiom,
    ! [D2: real,A2: real] : ( filtermap(real,real,aTP_Lamp_adw(real,fun(real,real),D2),topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2))) = topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),D2),set_ord_greaterThan(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),D2))) ) ).

% filtermap_at_right_shift
tff(fact_7450_pair__lessI1,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
     => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),product_Pair(product_prod(nat,nat),product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),S)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,B2),T2)),fun_pair_less) ) ).

% pair_lessI1
tff(fact_7451_at__to__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A] : ( topolo174197925503356063within(A,A2,top_top(set(A))) = filtermap(A,A,aTP_Lamp_adx(A,fun(A,A),A2),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% at_to_0
tff(fact_7452_at__right__to__0,axiom,
    ! [A2: real] : ( topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2)) = filtermap(real,real,aTP_Lamp_ady(real,fun(real,real),A2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% at_right_to_0
tff(fact_7453_filtermap__times__pos__at__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [C2: A,P3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( filtermap(A,A,aa(A,fun(A,A),times_times(A),C2),topolo174197925503356063within(A,P3,set_ord_greaterThan(A,P3))) = topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),P3),set_ord_greaterThan(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),P3))) ) ) ) ).

% filtermap_times_pos_at_right
tff(fact_7454_at__to__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ( topolo174197925503356063within(A,zero_zero(A),top_top(set(A))) = filtermap(A,A,inverse_inverse(A),at_infinity(A)) ) ) ).

% at_to_infinity
tff(fact_7455_at__right__to__top,axiom,
    topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))) = filtermap(real,real,inverse_inverse(real),at_top(real)) ).

% at_right_to_top
tff(fact_7456_at__top__to__right,axiom,
    at_top(real) = filtermap(real,real,inverse_inverse(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% at_top_to_right
tff(fact_7457_filtermap__ln__at__right,axiom,
    filtermap(real,real,ln_ln(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) = at_bot(real) ).

% filtermap_ln_at_right
tff(fact_7458_pair__leqI1,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
     => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),product_Pair(product_prod(nat,nat),product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),S)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,B2),T2)),fun_pair_leq) ) ).

% pair_leqI1
tff(fact_7459_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( comm_semiring_0(B)
        & comm_semiring_0(A) )
     => ! [A3: fun(A,fun(B,$o)),B3: fun(C,fun(D,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),A3,zero_zero(A)),zero_zero(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),plus_plus(A)),plus_plus(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),times_times(A)),times_times(B))
             => aa(fun(fun(D,B),fun(B,fun(list(D),B))),$o,aa(fun(fun(C,A),fun(A,fun(list(C),A))),fun(fun(fun(D,B),fun(B,fun(list(D),B))),$o),bNF_rel_fun(fun(C,A),fun(D,B),fun(A,fun(list(C),A)),fun(B,fun(list(D),B)),bNF_rel_fun(C,D,A,B,B3,A3),bNF_rel_fun(A,B,fun(list(C),A),fun(list(D),B),A3,bNF_rel_fun(list(C),list(D),A,B,list_all2(C,D,B3),A3))),groups4207007520872428315er_sum(C,A)),groups4207007520872428315er_sum(D,B)) ) ) ) ) ).

% horner_sum_transfer
tff(fact_7460_length__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,$o))] : aa(fun(list(B),nat),$o,aa(fun(list(A),nat),fun(fun(list(B),nat),$o),bNF_rel_fun(list(A),list(B),nat,nat,list_all2(A,B,A3),fequal(nat)),size_size(list(A))),size_size(list(B))) ).

% length_transfer
tff(fact_7461_list__all2__lengthD,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Ys)
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) ) ) ).

% list_all2_lengthD
tff(fact_7462_list__all2__append,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),P: fun(A,fun(B,$o)),Us: list(A),Vs: list(B)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
     => ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),append(A,Xs,Us)),append(B,Ys,Vs))
      <=> ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Ys)
          & aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Us),Vs) ) ) ) ).

% list_all2_append
tff(fact_7463_list__all2__append1,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(A),Zs2: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),append(A,Xs,Ys)),Zs2)
    <=> ? [Us2: list(B),Vs2: list(B)] :
          ( ( Zs2 = append(B,Us2,Vs2) )
          & ( aa(list(B),nat,size_size(list(B)),Us2) = aa(list(A),nat,size_size(list(A)),Xs) )
          & ( aa(list(B),nat,size_size(list(B)),Vs2) = aa(list(A),nat,size_size(list(A)),Ys) )
          & aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Us2)
          & aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Ys),Vs2) ) ) ).

% list_all2_append1
tff(fact_7464_list__all2__append2,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(B),Zs2: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),append(B,Ys,Zs2))
    <=> ? [Us2: list(A),Vs2: list(A)] :
          ( ( Xs = append(A,Us2,Vs2) )
          & ( aa(list(A),nat,size_size(list(A)),Us2) = aa(list(B),nat,size_size(list(B)),Ys) )
          & ( aa(list(A),nat,size_size(list(A)),Vs2) = aa(list(B),nat,size_size(list(B)),Zs2) )
          & aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Us2),Ys)
          & aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Vs2),Zs2) ) ) ).

% list_all2_append2
tff(fact_7465_list__all2__conv__all__nth,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Ys)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(B,$o,aa(A,fun(B,$o),P,aa(nat,A,nth(A,Xs),I)),aa(nat,B,nth(B,Ys),I)) ) ) ) ).

% list_all2_conv_all_nth
tff(fact_7466_list__all2__all__nthI,axiom,
    ! [A: $tType,B: $tType,A2: list(A),B2: list(B),P: fun(A,fun(B,$o))] :
      ( ( aa(list(A),nat,size_size(list(A)),A2) = aa(list(B),nat,size_size(list(B)),B2) )
     => ( ! [N: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),A2))
           => aa(B,$o,aa(A,fun(B,$o),P,aa(nat,A,nth(A,A2),N)),aa(nat,B,nth(B,B2),N)) )
       => aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),A2),B2) ) ) ).

% list_all2_all_nthI
tff(fact_7467_list__all2__nthD2,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(B),P3: nat] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Ys)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),P3),aa(list(B),nat,size_size(list(B)),Ys))
       => aa(B,$o,aa(A,fun(B,$o),P,aa(nat,A,nth(A,Xs),P3)),aa(nat,B,nth(B,Ys),P3)) ) ) ).

% list_all2_nthD2
tff(fact_7468_list__all2__nthD,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(B),P3: nat] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Ys)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),P3),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(B,$o,aa(A,fun(B,$o),P,aa(nat,A,nth(A,Xs),P3)),aa(nat,B,nth(B,Ys),P3)) ) ) ).

% list_all2_nthD
tff(fact_7469_list__all2I,axiom,
    ! [A: $tType,B: $tType,A2: list(A),B2: list(B),P: fun(A,fun(B,$o))] :
      ( ! [X3: product_prod(A,B)] :
          ( member(product_prod(A,B),X3,aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,A2,B2)))
         => aa(product_prod(A,B),$o,product_case_prod(A,B,$o,P),X3) )
     => ( ( aa(list(A),nat,size_size(list(A)),A2) = aa(list(B),nat,size_size(list(B)),B2) )
       => aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),A2),B2) ) ) ).

% list_all2I
tff(fact_7470_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & monoid_add(A) )
     => ! [A3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),A3,zero_zero(A)),zero_zero(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),plus_plus(A)),plus_plus(B))
           => aa(fun(list(B),B),$o,aa(fun(list(A),A),fun(fun(list(B),B),$o),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A3),A3),groups8242544230860333062m_list(A)),groups8242544230860333062m_list(B)) ) ) ) ).

% sum_list_transfer
tff(fact_7471_list__all2__iff,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,$o)),Xs: list(A),Ys: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,P),Xs),Ys)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(B),nat,size_size(list(B)),Ys) )
        & ! [X5: product_prod(A,B)] :
            ( member(product_prod(A,B),X5,aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)))
           => aa(product_prod(A,B),$o,product_case_prod(A,B,$o,P),X5) ) ) ) ).

% list_all2_iff
tff(fact_7472_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_mult(B)
        & monoid_mult(A) )
     => ! [A3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),A3,one_one(A)),one_one(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),times_times(A)),times_times(B))
           => aa(fun(list(B),B),$o,aa(fun(list(A),A),fun(fun(list(B),B),$o),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A3),A3),groups5270119922927024881d_list(A)),groups5270119922927024881d_list(B)) ) ) ) ).

% prod_list_transfer
tff(fact_7473_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ordering_top(A,aTP_Lamp_adz(A,fun(A,$o)),aTP_Lamp_aea(A,fun(A,$o)),bot_bot(A)) ) ).

% bot.ordering_top_axioms
tff(fact_7474_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aa(list(A),A,groups5270119922927024881d_list(A),nil(A)) = one_one(A) ) ) ).

% prod_list.Nil
tff(fact_7475_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [Xs: list(A)] :
          ( ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = zero_zero(A) )
        <=> member(A,zero_zero(A),aa(list(A),set(A),set2(A),Xs)) ) ) ).

% prod_list_zero_iff
tff(fact_7476_prod__list__coprime__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A),A2: A] :
          ( ! [X3: A] :
              ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
             => algebr8660921524188924756oprime(A,X3,A2) )
         => algebr8660921524188924756oprime(A,aa(list(A),A,groups5270119922927024881d_list(A),Xs),A2) ) ) ).

% prod_list_coprime_left
tff(fact_7477_prod__list__coprime__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A),A2: A] :
          ( ! [X3: A] :
              ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
             => algebr8660921524188924756oprime(A,A2,X3) )
         => algebr8660921524188924756oprime(A,A2,aa(list(A),A,groups5270119922927024881d_list(A),Xs)) ) ) ).

% prod_list_coprime_right
tff(fact_7478_gcd__nat_Oordering__top__axioms,axiom,
    ordering_top(nat,dvd_dvd(nat),aTP_Lamp_le(nat,fun(nat,$o)),zero_zero(nat)) ).

% gcd_nat.ordering_top_axioms
tff(fact_7479_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = foldr(A,A,times_times(A),Xs,one_one(A)) ) ) ).

% prod_list.eq_foldr
tff(fact_7480_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ordering_top(A,ord_less_eq(A),ord_less(A),top_top(A)) ) ).

% top.ordering_top_axioms
tff(fact_7481_bot__nat__0_Oordering__top__axioms,axiom,
    ordering_top(nat,aTP_Lamp_kl(nat,fun(nat,$o)),aTP_Lamp_ej(nat,fun(nat,$o)),zero_zero(nat)) ).

% bot_nat_0.ordering_top_axioms
tff(fact_7482_dropWhile__nth,axiom,
    ! [A: $tType,J2: nat,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs)))
     => ( aa(nat,A,nth(A,dropWhile(A,P,Xs)),J2) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J2),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ) ).

% dropWhile_nth
tff(fact_7483_set__encode__vimage__Suc,axiom,
    ! [A3: set(nat)] : ( aa(set(nat),nat,nat_set_encode,vimage(nat,nat,suc,A3)) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(set(nat),nat,nat_set_encode,A3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% set_encode_vimage_Suc
tff(fact_7484_vimage__Suc__insert__0,axiom,
    ! [A3: set(nat)] : ( vimage(nat,nat,suc,aa(set(nat),set(nat),insert(nat,zero_zero(nat)),A3)) = vimage(nat,nat,suc,A3) ) ).

% vimage_Suc_insert_0
tff(fact_7485_finite__vimage__Suc__iff,axiom,
    ! [F3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),vimage(nat,nat,suc,F3))
    <=> aa(set(nat),$o,finite_finite(nat),F3) ) ).

% finite_vimage_Suc_iff
tff(fact_7486_vimage__Suc__insert__Suc,axiom,
    ! [Na: nat,A3: set(nat)] : ( vimage(nat,nat,suc,aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,Na)),A3)) = aa(set(nat),set(nat),insert(nat,Na),vimage(nat,nat,suc,A3)) ) ).

% vimage_Suc_insert_Suc
tff(fact_7487_vimage__Diff,axiom,
    ! [A: $tType,B: $tType,F2: fun(A,B),A3: set(B),B3: set(B)] : ( vimage(A,B,F2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),vimage(A,B,F2,A3)),vimage(A,B,F2,B3)) ) ).

% vimage_Diff
tff(fact_7488_length__dropWhile__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_dropWhile_le
tff(fact_7489_dropWhile__eq__drop,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( dropWhile(A,P,Xs) = drop(A,aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)),Xs) ) ).

% dropWhile_eq_drop
tff(fact_7490_set__decode__div__2,axiom,
    ! [X: nat] : ( nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) = vimage(nat,nat,suc,nat_set_decode(X)) ) ).

% set_decode_div_2
tff(fact_7491_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),B2)),aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ) ) ).

% euclidean_size_times_nonunit
tff(fact_7492_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),Na: nat] : ( collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_aeb(set(A),fun(nat,fun(list(A),$o)),A3),Na)) = image(product_prod(list(A),A),list(A),product_case_prod(list(A),A,list(A),aTP_Lamp_aay(list(A),fun(A,list(A)))),product_Sigma(list(A),A,collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_jm(set(A),fun(nat,fun(list(A),$o)),A3),Na)),aTP_Lamp_aec(set(A),fun(list(A),set(A)),A3))) ) ).

% lists_length_Suc_eq
tff(fact_7493_euclidean__size__of__nat,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat] : ( aa(A,nat,euclid6346220572633701492n_size(A),aa(nat,A,semiring_1_of_nat(A),Na)) = Na ) ) ).

% euclidean_size_of_nat
tff(fact_7494_size__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ( aa(A,nat,euclid6346220572633701492n_size(A),zero_zero(A)) = zero_zero(nat) ) ) ).

% size_0
tff(fact_7495_euclidean__size__eq__0__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A] :
          ( ( aa(A,nat,euclid6346220572633701492n_size(A),B2) = zero_zero(nat) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% euclidean_size_eq_0_iff
tff(fact_7496_euclidean__size__numeral,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [K: num] : ( aa(A,nat,euclid6346220572633701492n_size(A),aa(num,A,numeral_numeral(A),K)) = aa(num,nat,numeral_numeral(nat),K) ) ) ).

% euclidean_size_numeral
tff(fact_7497_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( aa(A,nat,euclid6346220572633701492n_size(A),one_one(A)) = one_one(nat) ) ) ).

% euclidean_size_1
tff(fact_7498_euclidean__size__greater__0__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,euclid6346220572633701492n_size(A),B2))
        <=> ( B2 != zero_zero(A) ) ) ) ).

% euclidean_size_greater_0_iff
tff(fact_7499_dvd__euclidean__size__eq__imp__dvd,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( aa(A,nat,euclid6346220572633701492n_size(A),A2) = aa(A,nat,euclid6346220572633701492n_size(A),B2) )
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ) ).

% dvd_euclidean_size_eq_imp_dvd
tff(fact_7500_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,nat,euclid6346220572633701492n_size(A),A2) = aa(A,nat,euclid6346220572633701492n_size(A),one_one(A)) ) ) ) ).

% euclidean_size_unit
tff(fact_7501_euclidean__size__nat__def,axiom,
    euclid6346220572633701492n_size(nat) = id(nat) ).

% euclidean_size_nat_def
tff(fact_7502_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A] : ( aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,euclid6346220572633701492n_size(A),A2)),aa(A,nat,euclid6346220572633701492n_size(A),B2)) ) ) ).

% euclidean_size_mult
tff(fact_7503_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
        <=> ( ( aa(A,nat,euclid6346220572633701492n_size(A),A2) = aa(A,nat,euclid6346220572633701492n_size(A),one_one(A)) )
            & ( A2 != zero_zero(A) ) ) ) ) ).

% unit_iff_euclidean_size
tff(fact_7504_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,euclid6346220572633701492n_size(A),A2)),aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2))) ) ) ).

% size_mult_mono'
tff(fact_7505_size__mult__mono,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,euclid6346220572633701492n_size(A),A2)),aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ).

% size_mult_mono
tff(fact_7506_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,nat,euclid6346220572633701492n_size(A),B2) ) ) ) ).

% euclidean_size_times_unit
tff(fact_7507_dvd__proper__imp__size__less,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( ( B2 != zero_zero(A) )
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),A2)),aa(A,nat,euclid6346220572633701492n_size(A),B2)) ) ) ) ) ).

% dvd_proper_imp_size_less
tff(fact_7508_dvd__imp__size__le,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( ( B2 != zero_zero(A) )
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,euclid6346220572633701492n_size(A),A2)),aa(A,nat,euclid6346220572633701492n_size(A),B2)) ) ) ) ).

% dvd_imp_size_le
tff(fact_7509_mod__size__less,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),modulo_modulo(A,A2,B2))),aa(A,nat,euclid6346220572633701492n_size(A),B2)) ) ) ).

% mod_size_less
tff(fact_7510_euclidean__size__int__def,axiom,
    euclid6346220572633701492n_size(int) = aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int)) ).

% euclidean_size_int_def
tff(fact_7511_divmod__cases,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,A2: A] :
          ( ( ( B2 != zero_zero(A) )
           => ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
             => ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)),B2) ) ) )
         => ( ( ( B2 != zero_zero(A) )
             => ! [Q2: A,R: A] :
                  ( ( euclid7384307370059645450egment(A,R) = euclid7384307370059645450egment(A,B2) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R)),aa(A,nat,euclid6346220572633701492n_size(A),B2))
                   => ( ( R != zero_zero(A) )
                     => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = Q2 )
                       => ( ( modulo_modulo(A,A2,B2) = R )
                         => ( A2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q2),B2)),R) ) ) ) ) ) ) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% divmod_cases
tff(fact_7512_mod__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R2: A,Q4: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B2) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R2)),aa(A,nat,euclid6346220572633701492n_size(A),B2))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q4),B2)),R2) = A2 )
               => ( modulo_modulo(A,A2,B2) = R2 ) ) ) ) ) ) ).

% mod_eqI
tff(fact_7513_abs__division__segment,axiom,
    ! [K: int] : ( aa(int,int,abs_abs(int),euclid7384307370059645450egment(int,K)) = one_one(int) ) ).

% abs_division_segment
tff(fact_7514_division__segment__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( euclid7384307370059645450egment(A,one_one(A)) = one_one(A) ) ) ).

% division_segment_1
tff(fact_7515_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [K: num] : ( euclid7384307370059645450egment(A,aa(num,A,numeral_numeral(A),K)) = one_one(A) ) ) ).

% division_segment_numeral
tff(fact_7516_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Na: nat] : ( euclid7384307370059645450egment(A,aa(nat,A,semiring_1_of_nat(A),Na)) = one_one(A) ) ) ).

% division_segment_of_nat
tff(fact_7517_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A2)),aa(nat,A,semiring_1_of_nat(A),aa(A,nat,euclid6346220572633701492n_size(A),A2))) = A2 ) ) ).

% division_segment_euclidean_size
tff(fact_7518_division__segment__eq__iff,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,B2: A] :
          ( ( euclid7384307370059645450egment(A,A2) = euclid7384307370059645450egment(A,B2) )
         => ( ( aa(A,nat,euclid6346220572633701492n_size(A),A2) = aa(A,nat,euclid6346220572633701492n_size(A),B2) )
           => ( A2 = B2 ) ) ) ) ).

% division_segment_eq_iff
tff(fact_7519_division__segment__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( euclid7384307370059645450egment(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A2)),euclid7384307370059645450egment(A,B2)) ) ) ) ) ).

% division_segment_mult
tff(fact_7520_division__segment__not__0,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A] : ( euclid7384307370059645450egment(A,A2) != zero_zero(A) ) ) ).

% division_segment_not_0
tff(fact_7521_division__segment__nat__def,axiom,
    ! [Na: nat] : ( euclid7384307370059645450egment(nat,Na) = one_one(nat) ) ).

% division_segment_nat_def
tff(fact_7522_division__segment__eq__sgn,axiom,
    ! [K: int] :
      ( ( K != zero_zero(int) )
     => ( euclid7384307370059645450egment(int,K) = aa(int,int,sgn_sgn(int),K) ) ) ).

% division_segment_eq_sgn
tff(fact_7523_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),euclid7384307370059645450egment(A,A2)),one_one(A)) ) ).

% is_unit_division_segment
tff(fact_7524_division__segment__mod,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( euclid7384307370059645450egment(A,modulo_modulo(A,A2,B2)) = euclid7384307370059645450egment(A,B2) ) ) ) ) ).

% division_segment_mod
tff(fact_7525_of__nat__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] : ( aa(nat,A,semiring_1_of_nat(A),aa(A,nat,euclid6346220572633701492n_size(A),A2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),euclid7384307370059645450egment(A,A2)) ) ) ).

% of_nat_euclidean_size
tff(fact_7526_division__segment__int__def,axiom,
    ! [K: int] :
      ( euclid7384307370059645450egment(int,K)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K),one_one(int),aa(int,int,uminus_uminus(int),one_one(int))) ) ).

% division_segment_int_def
tff(fact_7527_unique__euclidean__semiring__class_Odiv__eq__0__iff,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A] :
          ( ( euclid7384307370059645450egment(A,A2) = euclid7384307370059645450egment(A,B2) )
         => ( ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = zero_zero(A) )
          <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),A2)),aa(A,nat,euclid6346220572633701492n_size(A),B2))
              | ( B2 = zero_zero(A) ) ) ) ) ) ).

% unique_euclidean_semiring_class.div_eq_0_iff
tff(fact_7528_div__bounded,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R2: A,Q4: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B2) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R2)),aa(A,nat,euclid6346220572633701492n_size(A),B2))
             => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q4),B2)),R2)),B2) = Q4 ) ) ) ) ) ).

% div_bounded
tff(fact_7529_div__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R2: A,Q4: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B2) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R2)),aa(A,nat,euclid6346220572633701492n_size(A),B2))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q4),B2)),R2) = A2 )
               => ( aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2) = Q4 ) ) ) ) ) ) ).

% div_eqI
tff(fact_7530_sorted__wrt__iff__nth__Suc__transp,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A)] :
      ( transp(A,P)
     => ( sorted_wrt(A,P,Xs)
      <=> ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I))) ) ) ) ).

% sorted_wrt_iff_nth_Suc_transp
tff(fact_7531_less__eq__enat__def,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),M),Na)
    <=> aa(extended_enat,$o,aa($o,fun(extended_enat,$o),aa(fun(nat,$o),fun($o,fun(extended_enat,$o)),extended_case_enat($o),aTP_Lamp_aed(extended_enat,fun(nat,$o),M)),$true),Na) ) ).

% less_eq_enat_def
tff(fact_7532_transp__realrel,axiom,
    transp(fun(nat,rat),realrel) ).

% transp_realrel
tff(fact_7533_less__enat__def,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),M),Na)
    <=> aa(extended_enat,$o,aa($o,fun(extended_enat,$o),aa(fun(nat,$o),fun($o,fun(extended_enat,$o)),extended_case_enat($o),aTP_Lamp_aee(extended_enat,fun(nat,$o),Na)),$false),M) ) ).

% less_enat_def
tff(fact_7534_transp__gr,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => transp(A,aTP_Lamp_aef(A,fun(A,$o))) ) ).

% transp_gr
tff(fact_7535_transp__less,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => transp(A,ord_less(A)) ) ).

% transp_less
tff(fact_7536_mlex__eq,axiom,
    ! [A: $tType,F2: fun(A,nat),R3: set(product_prod(A,A))] : ( mlex_prod(A,F2,R3) = collect(product_prod(A,A),product_case_prod(A,A,$o,aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aTP_Lamp_aeg(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,$o))),F2),R3))) ) ).

% mlex_eq
tff(fact_7537_span__explicit_H,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: set(A)] : ( real_Vector_span(A,B2) = collect(A,aTP_Lamp_aeh(set(A),fun(A,$o),B2)) ) ) ).

% span_explicit'
tff(fact_7538_span__insert__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S3: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),insert(A,zero_zero(A)),S3)) = real_Vector_span(A,S3) ) ) ).

% span_insert_0
tff(fact_7539_span__empty,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ( real_Vector_span(A,bot_bot(set(A))) = aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))) ) ) ).

% span_empty
tff(fact_7540_span__delete__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S3: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))))) = real_Vector_span(A,S3) ) ) ).

% span_delete_0
tff(fact_7541_span__breakdown__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,A2: A,S3: set(A)] :
          ( member(A,X,real_Vector_span(A,aa(set(A),set(A),insert(A,A2),S3)))
        <=> ? [K3: real] : member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,real_V8093663219630862766scaleR(A,K3),A2)),real_Vector_span(A,S3)) ) ) ).

% span_breakdown_eq
tff(fact_7542_eq__span__insert__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,Y: A,S3: set(A)] :
          ( member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y),real_Vector_span(A,S3))
         => ( real_Vector_span(A,aa(set(A),set(A),insert(A,X),S3)) = real_Vector_span(A,aa(set(A),set(A),insert(A,Y),S3)) ) ) ) ).

% eq_span_insert_eq
tff(fact_7543_span__diff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,S3: set(A),Y: A] :
          ( member(A,X,real_Vector_span(A,S3))
         => ( member(A,Y,real_Vector_span(A,S3))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y),real_Vector_span(A,S3)) ) ) ) ).

% span_diff
tff(fact_7544_span__add,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,S3: set(A),Y: A] :
          ( member(A,X,real_Vector_span(A,S3))
         => ( member(A,Y,real_Vector_span(A,S3))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y),real_Vector_span(A,S3)) ) ) ) ).

% span_add
tff(fact_7545_span__add__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,S3: set(A),Y: A] :
          ( member(A,X,real_Vector_span(A,S3))
         => ( member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y),real_Vector_span(A,S3))
          <=> member(A,Y,real_Vector_span(A,S3)) ) ) ) ).

% span_add_eq
tff(fact_7546_span__add__eq2,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Y: A,S3: set(A),X: A] :
          ( member(A,Y,real_Vector_span(A,S3))
         => ( member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y),real_Vector_span(A,S3))
          <=> member(A,X,real_Vector_span(A,S3)) ) ) ) ).

% span_add_eq2
tff(fact_7547_span__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S3: set(A)] : member(A,zero_zero(A),real_Vector_span(A,S3)) ) ).

% span_0
tff(fact_7548_span__induct__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [X: A,S3: set(A),H: fun(A,$o)] :
          ( member(A,X,real_Vector_span(A,S3))
         => ( aa(A,$o,H,zero_zero(A))
           => ( ! [C3: real,X3: A,Y4: A] :
                  ( member(A,X3,S3)
                 => ( aa(A,$o,H,Y4)
                   => aa(A,$o,H,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,C3),X3)),Y4)) ) )
             => aa(A,$o,H,X) ) ) ) ) ).

% span_induct_alt
tff(fact_7549_in__span__delete,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A,S3: set(A),B2: A] :
          ( member(A,A2,real_Vector_span(A,S3))
         => ( ~ member(A,A2,real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))))
           => member(A,B2,real_Vector_span(A,aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))))) ) ) ) ).

% in_span_delete
tff(fact_7550_span__Un,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S3: set(A),T5: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S3),T5)) = collect(A,aa(set(A),fun(A,$o),aTP_Lamp_aei(set(A),fun(set(A),fun(A,$o)),S3),T5)) ) ) ).

% span_Un
tff(fact_7551_span__insert,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A,S3: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),insert(A,A2),S3)) = collect(A,aa(set(A),fun(A,$o),aTP_Lamp_aej(A,fun(set(A),fun(A,$o)),A2),S3)) ) ) ).

% span_insert
tff(fact_7552_dependent__def,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [P: set(A)] :
          ( real_V358717886546972837endent(A,P)
        <=> ? [X5: A] :
              ( member(A,X5,P)
              & member(A,X5,real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),P),aa(set(A),set(A),insert(A,X5),bot_bot(set(A)))))) ) ) ) ).

% dependent_def
tff(fact_7553_span__image__scale,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S3: set(A),C2: fun(A,real)] :
          ( aa(set(A),$o,finite_finite(A),S3)
         => ( ! [X3: A] :
                ( member(A,X3,S3)
               => ( aa(A,real,C2,X3) != zero_zero(real) ) )
           => ( real_Vector_span(A,image(A,A,aTP_Lamp_acn(fun(A,real),fun(A,A),C2),S3)) = real_Vector_span(A,S3) ) ) ) ) ).

% span_image_scale
tff(fact_7554_span__breakdown,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: A,S3: set(A),A2: A] :
          ( member(A,B2,S3)
         => ( member(A,A2,real_Vector_span(A,S3))
           => ? [K2: real] : member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,K2),B2)),real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))))) ) ) ) ).

% span_breakdown
tff(fact_7555_span__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] : ( real_Vector_span(A,B3) = collect(A,aTP_Lamp_aek(set(A),fun(A,$o),B3)) ) ) ).

% span_alt
tff(fact_7556_mlex__less,axiom,
    ! [A: $tType,F2: fun(A,nat),X: A,Y: A,R3: set(product_prod(A,A))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,X)),aa(A,nat,F2,Y))
     => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),mlex_prod(A,F2,R3)) ) ).

% mlex_less
tff(fact_7557_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F2: fun(A,nat),R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),mlex_prod(A,F2,R3))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,X)),aa(A,nat,F2,Y))
        | ( ( aa(A,nat,F2,X) = aa(A,nat,F2,Y) )
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),R3) ) ) ) ).

% mlex_iff
tff(fact_7558_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F2: fun(A,nat)] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),measure(A,F2))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,X)),aa(A,nat,F2,Y)) ) ).

% in_measure
tff(fact_7559_in__finite__psubset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),product_Pair(set(A),set(A),A3),B3),finite_psubset(A))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
        & aa(set(A),$o,finite_finite(A),B3) ) ) ).

% in_finite_psubset
tff(fact_7560_finite__psubset__def,axiom,
    ! [A: $tType] : ( finite_psubset(A) = collect(product_prod(set(A),set(A)),product_case_prod(set(A),set(A),$o,aTP_Lamp_ael(set(A),fun(set(A),$o)))) ) ).

% finite_psubset_def
tff(fact_7561_representation__def,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A] :
          ( real_V7696804695334737415tation(A,Basis,V)
          = $ite(
              ( ~ real_V358717886546972837endent(A,Basis)
              & member(A,V,real_Vector_span(A,Basis)) ),
              fChoice(fun(A,real),aa(A,fun(fun(A,real),$o),aTP_Lamp_aem(set(A),fun(A,fun(fun(A,real),$o)),Basis),V)),
              aTP_Lamp_aen(A,real) ) ) ) ).

% representation_def
tff(fact_7562_representation__eqI,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,F2: fun(A,real)] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( ! [B4: A] :
                  ( ( aa(A,real,F2,B4) != zero_zero(real) )
                 => member(A,B4,Basis) )
             => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F2)))
               => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),F2)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F2))) = V )
                 => ( real_V7696804695334737415tation(A,Basis,V) = F2 ) ) ) ) ) ) ) ).

% representation_eqI
tff(fact_7563_representation__ne__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,B2: A] :
          ( ( aa(A,real,real_V7696804695334737415tation(A,Basis,V),B2) != zero_zero(real) )
         => member(A,B2,Basis) ) ) ).

% representation_ne_zero
tff(fact_7564_representation__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),X4: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,zero_zero(A)),X4) = zero_zero(real) ) ) ).

% representation_zero
tff(fact_7565_finite__representation,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A] : aa(set(A),$o,finite_finite(A),collect(A,aa(A,fun(A,$o),aTP_Lamp_aeo(set(A),fun(A,fun(A,$o)),Basis),V))) ) ).

% finite_representation
tff(fact_7566_representation__basis,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),B2: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,B2,Basis)
           => ! [X4: A] :
                ( aa(A,real,real_V7696804695334737415tation(A,Basis,B2),X4)
                = $ite(X4 = B2,one_one(real),zero_zero(real)) ) ) ) ) ).

% representation_basis
tff(fact_7567_representation__add,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,U: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( member(A,U,real_Vector_span(A,Basis))
             => ! [X4: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V)),X4) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(A,real,real_V7696804695334737415tation(A,Basis,U),X4)),aa(A,real,real_V7696804695334737415tation(A,Basis,V),X4)) ) ) ) ) ) ).

% representation_add
tff(fact_7568_representation__diff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,U: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( member(A,U,real_Vector_span(A,Basis))
             => ! [X4: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,aa(A,A,aa(A,fun(A,A),minus_minus(A),U),V)),X4) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(A,real,real_V7696804695334737415tation(A,Basis,U),X4)),aa(A,real,real_V7696804695334737415tation(A,Basis,V),X4)) ) ) ) ) ) ).

% representation_diff
tff(fact_7569_sum__nonzero__representation__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aa(A,fun(A,A),aTP_Lamp_aep(set(A),fun(A,fun(A,A)),Basis),V)),collect(A,aa(A,fun(A,$o),aTP_Lamp_aeo(set(A),fun(A,fun(A,$o)),Basis),V))) = V ) ) ) ) ).

% sum_nonzero_representation_eq
tff(fact_7570_pred__nat__def,axiom,
    pred_nat = collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_aeq(nat,fun(nat,$o)))) ).

% pred_nat_def
tff(fact_7571_dim__def,axiom,
    ! [V2: set(a)] :
      ( real_Vector_dim(a,V2)
      = $ite(
          ? [B7: set(a)] :
            ( ~ real_V358717886546972837endent(a,B7)
            & ( real_Vector_span(a,B7) = real_Vector_span(a,V2) ) ),
          aa(set(a),nat,finite_card(a),fChoice(set(a),aTP_Lamp_aer(set(a),fun(set(a),$o),V2))),
          zero_zero(nat) ) ) ).

% dim_def
tff(fact_7572_linear__indep__image__lemma,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B),B3: set(A),X: A] :
          ( real_Vector_linear(A,B,F2)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ~ real_V358717886546972837endent(B,image(A,B,F2,B3))
             => ( inj_on(A,B,F2,B3)
               => ( member(A,X,real_Vector_span(A,B3))
                 => ( ( aa(A,B,F2,X) = zero_zero(B) )
                   => ( X = zero_zero(A) ) ) ) ) ) ) ) ) ).

% linear_indep_image_lemma
tff(fact_7573_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Ys)
        <=> member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Xs),Ys),lexord(A,collect(product_prod(A,A),product_case_prod(A,A,$o,ord_less(A))))) ) ) ).

% lexordp_conv_lexord
tff(fact_7574_lexordp__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Xs: list(A),Y: A,Ys: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),cons(A,X,Xs)),cons(A,Y,Ys))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
            | ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
              & aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Ys) ) ) ) ) ).

% lexordp_simps(3)
tff(fact_7575_linear__eq__0__on__span,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [F2: fun(A,B),B2: set(A),X: A] :
          ( real_Vector_linear(A,B,F2)
         => ( ! [X3: A] :
                ( member(A,X3,B2)
               => ( aa(A,B,F2,X3) = zero_zero(B) ) )
           => ( member(A,X,real_Vector_span(A,B2))
             => ( aa(A,B,F2,X) = zero_zero(B) ) ) ) ) ) ).

% linear_eq_0_on_span
tff(fact_7576_lexordp_OCons,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Y: A,Xs: list(A),Ys: list(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),cons(A,X,Xs)),cons(A,Y,Ys)) ) ) ).

% lexordp.Cons
tff(fact_7577_lexordp_OCons__eq,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Y: A,Xs: list(A),Ys: list(A)] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X)
           => ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Ys)
             => aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),cons(A,X,Xs)),cons(A,Y,Ys)) ) ) ) ) ).

% lexordp.Cons_eq
tff(fact_7578_linearI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B)] :
          ( ! [B12: A,B23: A] : ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),B12),B23)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,B12)),aa(A,B,F2,B23)) )
         => ( ! [R: real,B4: A] : ( aa(A,B,F2,aa(A,A,real_V8093663219630862766scaleR(A,R),B4)) = aa(B,B,real_V8093663219630862766scaleR(B,R),aa(A,B,F2,B4)) )
           => real_Vector_linear(A,B,F2) ) ) ) ).

% linearI
tff(fact_7579_Real__Vector__Spaces_Olinear__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_Vector_linear(A,B,F2)
        <=> ( ! [X5: A,Y5: A] : ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X5),Y5)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,X5)),aa(A,B,F2,Y5)) )
            & ! [C4: real,X5: A] : ( aa(A,B,F2,aa(A,A,real_V8093663219630862766scaleR(A,C4),X5)) = aa(B,B,real_V8093663219630862766scaleR(B,C4),aa(A,B,F2,X5)) ) ) ) ) ).

% Real_Vector_Spaces.linear_iff
tff(fact_7580_linear__compose__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( real_Vector_linear(A,B,F2)
         => ( real_Vector_linear(A,B,G)
           => real_Vector_linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aes(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% linear_compose_add
tff(fact_7581_linear__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [F2: fun(A,B)] :
          ( real_Vector_linear(A,B,F2)
         => ( aa(A,B,F2,zero_zero(A)) = zero_zero(B) ) ) ) ).

% linear_0
tff(fact_7582_module__hom__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => real_Vector_linear(A,B,aTP_Lamp_aet(A,B)) ) ).

% module_hom_zero
tff(fact_7583_linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B),B1: A,B22: A] :
          ( real_Vector_linear(A,B,F2)
         => ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),plus_plus(A),B1),B22)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F2,B1)),aa(A,B,F2,B22)) ) ) ) ).

% linear_add
tff(fact_7584_lexordp__irreflexive,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Xs: list(A)] :
          ( ! [X3: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),X3)
         => ~ aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Xs) ) ) ).

% lexordp_irreflexive
tff(fact_7585_linear__compose__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B),G: fun(A,B)] :
          ( real_Vector_linear(A,B,F2)
         => ( real_Vector_linear(A,B,G)
           => real_Vector_linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aeu(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G)) ) ) ) ).

% linear_compose_sub
tff(fact_7586_linear__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B),X: A,Y: A] :
          ( real_Vector_linear(A,B,F2)
         => ( aa(A,B,F2,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F2,X)),aa(A,B,F2,Y)) ) ) ) ).

% linear_diff
tff(fact_7587_lexordp__append__leftD,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Xs: list(A),Us: list(A),Vs: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),append(A,Xs,Us)),append(A,Xs,Vs))
         => ( ! [A4: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A4),A4)
           => aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Us),Vs) ) ) ) ).

% lexordp_append_leftD
tff(fact_7588_linear__injective__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F2: fun(A,B)] :
          ( real_Vector_linear(A,B,F2)
         => ( inj_on(A,B,F2,top_top(set(A)))
          <=> ! [X5: A] :
                ( ( aa(A,B,F2,X5) = zero_zero(B) )
               => ( X5 = zero_zero(A) ) ) ) ) ) ).

% linear_injective_0
tff(fact_7589_lexordp__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A),P: fun(list(A),fun(list(A),$o))] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Ys)
         => ( ! [Y4: A,Ys4: list(A)] : aa(list(A),$o,aa(list(A),fun(list(A),$o),P,nil(A)),cons(A,Y4,Ys4))
           => ( ! [X3: A,Xs2: list(A),Y4: A,Ys4: list(A)] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
                 => aa(list(A),$o,aa(list(A),fun(list(A),$o),P,cons(A,X3,Xs2)),cons(A,Y4,Ys4)) )
             => ( ! [X3: A,Xs2: list(A),Ys4: list(A)] :
                    ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs2),Ys4)
                   => ( aa(list(A),$o,aa(list(A),fun(list(A),$o),P,Xs2),Ys4)
                     => aa(list(A),$o,aa(list(A),fun(list(A),$o),P,cons(A,X3,Xs2)),cons(A,X3,Ys4)) ) )
               => aa(list(A),$o,aa(list(A),fun(list(A),$o),P,Xs),Ys) ) ) ) ) ) ).

% lexordp_induct
tff(fact_7590_lexordp__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Ys)
         => ( ( ( Xs = nil(A) )
             => ! [Y4: A,Ys5: list(A)] : ( Ys != cons(A,Y4,Ys5) ) )
           => ( ! [X3: A] :
                  ( ? [Xs4: list(A)] : ( Xs = cons(A,X3,Xs4) )
                 => ! [Y4: A] :
                      ( ? [Ys5: list(A)] : ( Ys = cons(A,Y4,Ys5) )
                     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4) ) )
             => ~ ! [X3: A,Xs4: list(A)] :
                    ( ( Xs = cons(A,X3,Xs4) )
                   => ! [Ys5: list(A)] :
                        ( ( Ys = cons(A,X3,Ys5) )
                       => ~ aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs4),Ys5) ) ) ) ) ) ) ).

% lexordp_cases
tff(fact_7591_lexordp_Osimps,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A1: list(A),A22: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),A1),A22)
        <=> ( ? [Y5: A,Ys3: list(A)] :
                ( ( A1 = nil(A) )
                & ( A22 = cons(A,Y5,Ys3) ) )
            | ? [X5: A,Y5: A,Xs3: list(A),Ys3: list(A)] :
                ( ( A1 = cons(A,X5,Xs3) )
                & ( A22 = cons(A,Y5,Ys3) )
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5) )
            | ? [X5: A,Y5: A,Xs3: list(A),Ys3: list(A)] :
                ( ( A1 = cons(A,X5,Xs3) )
                & ( A22 = cons(A,Y5,Ys3) )
                & ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5)
                & ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X5)
                & aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs3),Ys3) ) ) ) ) ).

% lexordp.simps
tff(fact_7592_lexordp_Ocases,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A1: list(A),A22: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),A1),A22)
         => ( ( ( A1 = nil(A) )
             => ! [Y4: A,Ys4: list(A)] : ( A22 != cons(A,Y4,Ys4) ) )
           => ( ! [X3: A] :
                  ( ? [Xs2: list(A)] : ( A1 = cons(A,X3,Xs2) )
                 => ! [Y4: A] :
                      ( ? [Ys4: list(A)] : ( A22 = cons(A,Y4,Ys4) )
                     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4) ) )
             => ~ ! [X3: A,Y4: A,Xs2: list(A)] :
                    ( ( A1 = cons(A,X3,Xs2) )
                   => ! [Ys4: list(A)] :
                        ( ( A22 = cons(A,Y4,Ys4) )
                       => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Y4)
                         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y4),X3)
                           => ~ aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs2),Ys4) ) ) ) ) ) ) ) ) ).

% lexordp.cases
tff(fact_7593_lexordp__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),Xs),Ys)
        <=> ( ? [X5: A,Vs2: list(A)] : ( Ys = append(A,Xs,cons(A,X5,Vs2)) )
            | ? [Us2: list(A),A6: A,B7: A,Vs2: list(A),Ws3: list(A)] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A6),B7)
                & ( Xs = append(A,Us2,cons(A,A6,Vs2)) )
                & ( Ys = append(A,Us2,cons(A,B7,Ws3)) ) ) ) ) ) ).

% lexordp_iff
tff(fact_7594_lexordp__append__left__rightI,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Y: A,Us: list(A),Xs: list(A),Ys: list(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
         => aa(list(A),$o,aa(list(A),fun(list(A),$o),ord_lexordp(A),append(A,Us,cons(A,X,Xs))),append(A,Us,cons(A,Y,Ys))) ) ) ).

% lexordp_append_left_rightI
tff(fact_7595_ord__class_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ( ord_lexordp(A) = complete_lattice_lfp(fun(list(A),fun(list(A),$o)),aTP_Lamp_aam(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)))) ) ) ).

% ord_class.lexordp_def
tff(fact_7596_bounded__bilinear__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
        <=> ( ! [A6: A,A10: A,B7: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),plus_plus(A),A6),A10)),B7) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A6),B7)),aa(B,C,aa(A,fun(B,C),Prod,A10),B7)) )
            & ! [A6: A,B7: B,B11: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A6),aa(B,B,aa(B,fun(B,B),plus_plus(B),B7),B11)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A6),B7)),aa(B,C,aa(A,fun(B,C),Prod,A6),B11)) )
            & ! [R5: real,A6: A,B7: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,real_V8093663219630862766scaleR(A,R5),A6)),B7) = aa(C,C,real_V8093663219630862766scaleR(C,R5),aa(B,C,aa(A,fun(B,C),Prod,A6),B7)) )
            & ! [A6: A,R5: real,B7: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A6),aa(B,B,real_V8093663219630862766scaleR(B,R5),B7)) = aa(C,C,real_V8093663219630862766scaleR(C,R5),aa(B,C,aa(A,fun(B,C),Prod,A6),B7)) )
            & ? [K6: real] :
              ! [A6: A,B7: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A6),B7))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A6)),real_V7770717601297561774m_norm(B,B7))),K6)) ) ) ) ).

% bounded_bilinear_def
tff(fact_7597_bounded__bilinear_Odiff__right,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,B2: B,B5: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),B2),B5)) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A2),B5)) ) ) ) ).

% bounded_bilinear.diff_right
tff(fact_7598_bounded__bilinear_Odiff__left,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,A5: A,B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A5)),B2) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A5),B2)) ) ) ) ).

% bounded_bilinear.diff_left
tff(fact_7599_bounded__bilinear_Oprod__diff__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),X: A,Y: B,A2: A,B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,aa(A,fun(B,C),Prod,X),Y)),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),B2))),aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2)),B2))),aa(B,C,aa(A,fun(B,C),Prod,A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),B2))) ) ) ) ).

% bounded_bilinear.prod_diff_prod
tff(fact_7600_bounded__bilinear_Oadd__left,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,A5: A,B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A5)),B2) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A5),B2)) ) ) ) ).

% bounded_bilinear.add_left
tff(fact_7601_bounded__bilinear_Oadd__right,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,B2: B,B5: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,A2),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),B5)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A2),B5)) ) ) ) ).

% bounded_bilinear.add_right
tff(fact_7602_bounded__bilinear_Ozero__left,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,zero_zero(A)),B2) = zero_zero(C) ) ) ) ).

% bounded_bilinear.zero_left
tff(fact_7603_bounded__bilinear_Ozero__right,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),A2: A] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,A2),zero_zero(B)) = zero_zero(C) ) ) ) ).

% bounded_bilinear.zero_right
tff(fact_7604_bounded__bilinear_Otendsto__right__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C)),F2: fun(D,B),F3: filter(D),C2: A] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( filterlim(D,B,F2,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
           => filterlim(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_aev(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Prod),F2),C2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ) ).

% bounded_bilinear.tendsto_right_zero
tff(fact_7605_bounded__bilinear_Otendsto__left__zero,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C)),F2: fun(D,A),F3: filter(D),C2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( filterlim(D,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => filterlim(D,C,aa(B,fun(D,C),aa(fun(D,A),fun(B,fun(D,C)),aTP_Lamp_aew(fun(A,fun(B,C)),fun(fun(D,A),fun(B,fun(D,C))),Prod),F2),C2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ) ).

% bounded_bilinear.tendsto_left_zero
tff(fact_7606_bounded__bilinear_Otendsto__zero,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C)),F2: fun(D,A),F3: filter(D),G: fun(D,B)] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( filterlim(D,A,F2,topolo7230453075368039082e_nhds(A,zero_zero(A)),F3)
           => ( filterlim(D,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F3)
             => filterlim(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_aex(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Prod),F2),G),topolo7230453075368039082e_nhds(C,zero_zero(C)),F3) ) ) ) ) ).

% bounded_bilinear.tendsto_zero
tff(fact_7607_lfp__funpow,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),Na: nat] :
          ( order_mono(A,A,F2)
         => ( complete_lattice_lfp(A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,Na)),F2)) = complete_lattice_lfp(A,F2) ) ) ) ).

% lfp_funpow
tff(fact_7608_bounded__bilinear_OFDERIV,axiom,
    ! [B: $tType,C: $tType,A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),F2: fun(D,A),F7: fun(D,A),X: D,S: set(D),G: fun(D,B),G2: fun(D,B)] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( has_derivative(D,A,F2,F7,topolo174197925503356063within(D,X,S))
           => ( has_derivative(D,B,G,G2,topolo174197925503356063within(D,X,S))
             => has_derivative(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_aey(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Prod),F2),G),aa(fun(D,B),fun(D,C),aa(fun(D,B),fun(fun(D,B),fun(D,C)),aa(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))),aa(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))),aa(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))))),aTP_Lamp_aez(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))))),Prod),F2),F7),X),G),G2),topolo174197925503356063within(D,X,S)) ) ) ) ) ).

% bounded_bilinear.FDERIV
tff(fact_7609_bounded__bilinear_Ononneg__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ? [K8: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),K8)
              & ! [A9: A,B13: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A9),B13))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A9)),real_V7770717601297561774m_norm(B,B13))),K8)) ) ) ) ).

% bounded_bilinear.nonneg_bounded
tff(fact_7610_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),K: nat] :
          ( order_mono(A,A,F2)
         => ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,K)),F2),bot_bot(A)) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),bot_bot(A)) )
           => ( complete_lattice_lfp(A,F2) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),bot_bot(A)) ) ) ) ) ).

% lfp_Kleene_iter
tff(fact_7611_bounded__bilinear_Opos__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ? [K8: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K8)
              & ! [A9: A,B13: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A9),B13))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A9)),real_V7770717601297561774m_norm(B,B13))),K8)) ) ) ) ).

% bounded_bilinear.pos_bounded
tff(fact_7612_bounded__bilinear_Ointro,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( ! [A4: A,A8: A,B4: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A8)),B4) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)),aa(B,C,aa(A,fun(B,C),Prod,A8),B4)) )
         => ( ! [A4: A,B4: B,B6: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B4),B6)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)),aa(B,C,aa(A,fun(B,C),Prod,A4),B6)) )
           => ( ! [R: real,A4: A,B4: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,real_V8093663219630862766scaleR(A,R),A4)),B4) = aa(C,C,real_V8093663219630862766scaleR(C,R),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)) )
             => ( ! [A4: A,R: real,B4: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A4),aa(B,B,real_V8093663219630862766scaleR(B,R),B4)) = aa(C,C,real_V8093663219630862766scaleR(C,R),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)) )
               => ( ? [K9: real] :
                    ! [A4: A,B4: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A4),B4))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A4)),real_V7770717601297561774m_norm(B,B4))),K9))
                 => real_V2442710119149674383linear(A,B,C,Prod) ) ) ) ) ) ) ).

% bounded_bilinear.intro
tff(fact_7613_Divides_Oadjust__div__def,axiom,
    ! [Qr: product_prod(int,int)] : ( adjust_div(Qr) = aa(product_prod(int,int),int,product_case_prod(int,int,int,aTP_Lamp_afa(int,fun(int,int))),Qr) ) ).

% Divides.adjust_div_def
tff(fact_7614_prod__decode__triangle__add,axiom,
    ! [K: nat,M: nat] : ( aa(nat,product_prod(nat,nat),nat_prod_decode,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(K)),M)) = aa(nat,product_prod(nat,nat),nat_prod_decode_aux(K),M) ) ).

% prod_decode_triangle_add
tff(fact_7615_prod__decode__eq,axiom,
    ! [X: nat,Y: nat] :
      ( ( aa(nat,product_prod(nat,nat),nat_prod_decode,X) = aa(nat,product_prod(nat,nat),nat_prod_decode,Y) )
    <=> ( X = Y ) ) ).

% prod_decode_eq
tff(fact_7616_prod__encode__inverse,axiom,
    ! [X: product_prod(nat,nat)] : ( aa(nat,product_prod(nat,nat),nat_prod_decode,aa(product_prod(nat,nat),nat,nat_prod_encode,X)) = X ) ).

% prod_encode_inverse
tff(fact_7617_prod__decode__inverse,axiom,
    ! [Na: nat] : ( aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),nat_prod_decode,Na)) = Na ) ).

% prod_decode_inverse
tff(fact_7618_inj__prod__decode,axiom,
    ! [A3: set(nat)] : inj_on(nat,product_prod(nat,nat),nat_prod_decode,A3) ).

% inj_prod_decode
tff(fact_7619_prod__decode__def,axiom,
    nat_prod_decode = nat_prod_decode_aux(zero_zero(nat)) ).

% prod_decode_def
tff(fact_7620_bij__prod__decode,axiom,
    bij_betw(nat,product_prod(nat,nat),nat_prod_decode,top_top(set(nat)),top_top(set(product_prod(nat,nat)))) ).

% bij_prod_decode
tff(fact_7621_surj__prod__decode,axiom,
    image(nat,product_prod(nat,nat),nat_prod_decode,top_top(set(nat))) = top_top(set(product_prod(nat,nat))) ).

% surj_prod_decode
tff(fact_7622_rat__floor__code,axiom,
    ! [P3: rat] : ( archim6421214686448440834_floor(rat,P3) = aa(product_prod(int,int),int,product_case_prod(int,int,int,divide_divide(int)),quotient_of(P3)) ) ).

% rat_floor_code
tff(fact_7623_list__decode_Opinduct,axiom,
    ! [A0: nat,P: fun(nat,$o)] :
      ( accp(nat,nat_list_decode_rel,A0)
     => ( ( accp(nat,nat_list_decode_rel,zero_zero(nat))
         => aa(nat,$o,P,zero_zero(nat)) )
       => ( ! [N: nat] :
              ( accp(nat,nat_list_decode_rel,aa(nat,nat,suc,N))
             => ( ! [X4: nat,Y3: nat] :
                    ( ( aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X4),Y3) = aa(nat,product_prod(nat,nat),nat_prod_decode,N) )
                   => aa(nat,$o,P,Y3) )
               => aa(nat,$o,P,aa(nat,nat,suc,N)) ) )
         => aa(nat,$o,P,A0) ) ) ) ).

% list_decode.pinduct
tff(fact_7624_list__decode_Oelims,axiom,
    ! [X: nat,Y: list(nat)] :
      ( ( aa(nat,list(nat),nat_list_decode,X) = Y )
     => ( ( ( X = zero_zero(nat) )
         => ( Y != nil(nat) ) )
       => ~ ! [N: nat] :
              ( ( X = aa(nat,nat,suc,N) )
             => ( Y != aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_afb(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,N)) ) ) ) ) ).

% list_decode.elims
tff(fact_7625_list__decode__inverse,axiom,
    ! [Na: nat] : ( aa(list(nat),nat,nat_list_encode,aa(nat,list(nat),nat_list_decode,Na)) = Na ) ).

% list_decode_inverse
tff(fact_7626_list__encode__inverse,axiom,
    ! [X: list(nat)] : ( aa(nat,list(nat),nat_list_decode,aa(list(nat),nat,nat_list_encode,X)) = X ) ).

% list_encode_inverse
tff(fact_7627_inj__list__decode,axiom,
    ! [A3: set(nat)] : inj_on(nat,list(nat),nat_list_decode,A3) ).

% inj_list_decode
tff(fact_7628_list__decode__eq,axiom,
    ! [X: nat,Y: nat] :
      ( ( aa(nat,list(nat),nat_list_decode,X) = aa(nat,list(nat),nat_list_decode,Y) )
    <=> ( X = Y ) ) ).

% list_decode_eq
tff(fact_7629_list__decode_Opsimps_I1_J,axiom,
    ( accp(nat,nat_list_decode_rel,zero_zero(nat))
   => ( aa(nat,list(nat),nat_list_decode,zero_zero(nat)) = nil(nat) ) ) ).

% list_decode.psimps(1)
tff(fact_7630_list__decode_Osimps_I1_J,axiom,
    aa(nat,list(nat),nat_list_decode,zero_zero(nat)) = nil(nat) ).

% list_decode.simps(1)
tff(fact_7631_list__decode_Opsimps_I2_J,axiom,
    ! [Na: nat] :
      ( accp(nat,nat_list_decode_rel,aa(nat,nat,suc,Na))
     => ( aa(nat,list(nat),nat_list_decode,aa(nat,nat,suc,Na)) = aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_afb(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,Na)) ) ) ).

% list_decode.psimps(2)
tff(fact_7632_bij__list__decode,axiom,
    bij_betw(nat,list(nat),nat_list_decode,top_top(set(nat)),top_top(set(list(nat)))) ).

% bij_list_decode
tff(fact_7633_surj__list__decode,axiom,
    image(nat,list(nat),nat_list_decode,top_top(set(nat))) = top_top(set(list(nat))) ).

% surj_list_decode
tff(fact_7634_list__decode_Osimps_I2_J,axiom,
    ! [Na: nat] : ( aa(nat,list(nat),nat_list_decode,aa(nat,nat,suc,Na)) = aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_afb(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,Na)) ) ).

% list_decode.simps(2)
tff(fact_7635_list__decode_Opelims,axiom,
    ! [X: nat,Y: list(nat)] :
      ( ( aa(nat,list(nat),nat_list_decode,X) = Y )
     => ( accp(nat,nat_list_decode_rel,X)
       => ( ( ( X = zero_zero(nat) )
           => ( ( Y = nil(nat) )
             => ~ accp(nat,nat_list_decode_rel,zero_zero(nat)) ) )
         => ~ ! [N: nat] :
                ( ( X = aa(nat,nat,suc,N) )
               => ( ( Y = aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_afb(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,N)) )
                 => ~ accp(nat,nat_list_decode_rel,aa(nat,nat,suc,N)) ) ) ) ) ) ).

% list_decode.pelims
tff(fact_7636_Max_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => lattic4895041142388067077er_set(A,ord_max(A),aTP_Lamp_afc(A,fun(A,$o)),aTP_Lamp_afd(A,fun(A,$o))) ) ).

% Max.semilattice_order_set_axioms
tff(fact_7637_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Gcd_fin(A) = bounde2362111253966948842tice_F(A,gcd_gcd(A),zero_zero(A),one_one(A)) ) ) ).

% Gcd_fin_def
tff(fact_7638_bounded__quasi__semilattice__set_OF_Ocong,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A] : ( bounde2362111253966948842tice_F(A,F2,Top,Bot) = bounde2362111253966948842tice_F(A,F2,Top,Bot) ) ).

% bounded_quasi_semilattice_set.F.cong
tff(fact_7639_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => lattic4895041142388067077er_set(A,inf_inf(A),ord_less_eq(A),ord_less(A)) ) ).

% Inf_fin.semilattice_order_set_axioms
tff(fact_7640_Min_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => lattic4895041142388067077er_set(A,ord_min(A),ord_less_eq(A),ord_less(A)) ) ).

% Min.semilattice_order_set_axioms
tff(fact_7641_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => lattic4895041142388067077er_set(A,sup_sup(A),aTP_Lamp_afe(A,fun(A,$o)),aTP_Lamp_aff(A,fun(A,$o))) ) ).

% Sup_fin.semilattice_order_set_axioms
tff(fact_7642_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( member(A,A2,A3)
       => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3) = aa(A,A,aa(A,fun(A,A),F2,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% bounded_quasi_semilattice_set.remove
tff(fact_7643_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),F2,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
tff(fact_7644_bounded__quasi__semilattice__set_Oin__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( member(A,A2,A3)
       => ( aa(A,A,aa(A,fun(A,A),F2,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3)) = aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3) ) ) ) ).

% bounded_quasi_semilattice_set.in_idem
tff(fact_7645_bounded__quasi__semilattice__set_Onormalize,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,Normalize,aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3)) = aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3) ) ) ).

% bounded_quasi_semilattice_set.normalize
tff(fact_7646_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),bot_bot(set(A))) = Top ) ) ).

% bounded_quasi_semilattice_set.empty
tff(fact_7647_bounded__quasi__semilattice__set_Oinfinite,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( ~ aa(set(A),$o,finite_finite(A),A3)
       => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3) = Bot ) ) ) ).

% bounded_quasi_semilattice_set.infinite
tff(fact_7648_bounded__quasi__semilattice__set_Osubset,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),B3: set(A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( aa(A,A,aa(A,fun(A,A),F2,aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),B3)),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3)) = aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3) ) ) ) ).

% bounded_quasi_semilattice_set.subset
tff(fact_7649_bounded__quasi__semilattice__set_Oinsert,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),F2,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3)) ) ) ).

% bounded_quasi_semilattice_set.insert
tff(fact_7650_bounded__quasi__semilattice__set_Ounion,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A),B3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(A,A,aa(A,fun(A,A),F2,aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3)),aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),B3)) ) ) ).

% bounded_quasi_semilattice_set.union
tff(fact_7651_gen__length__def,axiom,
    ! [A: $tType,Na: nat,Xs: list(A)] : ( aa(list(A),nat,gen_length(A,Na),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Na),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% gen_length_def
tff(fact_7652_compute__powr__real,axiom,
    ! [B2: real,I2: real] :
      ( powr_real(B2,I2)
      = $ite(
          aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),zero_zero(real)),
          abort(real,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$false,$true,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$true,$false,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($false,$false,$true,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$true,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($false,$false,$false,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($true,$true,$false,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$true,$true,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$false,$false,$false,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($true,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,zero_zero(literal)))))))))))))))))))))))))))))))),aa(real,fun(product_unit,real),aTP_Lamp_afg(real,fun(real,fun(product_unit,real)),B2),I2)),
          $ite(
            aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,I2)) = I2,
            $ite(aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),I2),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(int,nat,nat2,archim6421214686448440834_floor(real,I2))),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(int,nat,nat2,archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),I2)))))),
            abort(real,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$false,$true,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$true,$false,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($false,$false,$true,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$true,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($false,$false,$false,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$false,$true,$true,$false,$true,$false,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$true,$true,$false,$false,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$false,$false,$true,$true,$true,$true,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,zero_zero(literal)))))))))))))))))))))))))))))))))))),aa(real,fun(product_unit,real),aTP_Lamp_afg(real,fun(real,fun(product_unit,real)),B2),I2)) ) ) ) ).

% compute_powr_real
tff(fact_7653_String_Oempty__neq__Literal,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,S: literal] : ( zero_zero(literal) != literal2(B0,B1,B22,B32,B42,B52,B62,S) ) ).

% String.empty_neq_Literal
tff(fact_7654_gen__length__code_I2_J,axiom,
    ! [A: $tType,Na: nat,X: A,Xs: list(A)] : ( aa(list(A),nat,gen_length(A,Na),cons(A,X,Xs)) = aa(list(A),nat,gen_length(A,aa(nat,nat,suc,Na)),Xs) ) ).

% gen_length_code(2)
tff(fact_7655_length__code,axiom,
    ! [A: $tType] : ( size_size(list(A)) = gen_length(A,zero_zero(nat)) ) ).

% length_code
tff(fact_7656_uniformity__Abort,axiom,
    ! [A: $tType] :
      ( topolo4638772830378233104ormity(A)
     => ( topolo7806501430040627800ormity(A) = abstract_filter(product_prod(A,A),aTP_Lamp_afi(product_unit,filter(product_prod(A,A)))) ) ) ).

% uniformity_Abort
tff(fact_7657_card__def,axiom,
    ! [A: $tType] : ( finite_card(A) = finite_folding_F(A,nat,aTP_Lamp_afj(A,fun(nat,nat)),zero_zero(nat)) ) ).

% card_def
tff(fact_7658_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S3: set(A),F2: fun(A,fun(B,B)),A3: set(A),X: A,Z: B] :
      ( finite_folding_on(A,B,S3,F2)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S3)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( aa(set(A),B,finite_folding_F(A,B,F2,Z),A3) = aa(B,B,aa(A,fun(B,B),F2,X),aa(set(A),B,finite_folding_F(A,B,F2,Z),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% folding_on.remove
tff(fact_7659_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S3: set(A),F2: fun(A,fun(B,B)),X: A,A3: set(A),Z: B] :
      ( finite_folding_on(A,B,S3,F2)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,X),A3)),S3)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,finite_folding_F(A,B,F2,Z),aa(set(A),set(A),insert(A,X),A3)) = aa(B,B,aa(A,fun(B,B),F2,X),aa(set(A),B,finite_folding_F(A,B,F2,Z),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% folding_on.insert_remove
tff(fact_7660_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] : finite_folding_on(A,nat,top_top(set(A)),aTP_Lamp_afj(A,fun(nat,nat))) ).

% card.folding_on_axioms
tff(fact_7661_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)
          = $ite(aa(set(A),$o,finite_finite(A),A3),finite_fold(A,A,gcd_gcd(A),zero_zero(A),A3),one_one(A)) ) ) ).

% Gcd_fin.eq_fold
tff(fact_7662_less__than__iff,axiom,
    ! [X: nat,Y: nat] :
      ( member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Y),less_than)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y) ) ).

% less_than_iff
tff(fact_7663_card_Oeq__fold,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),nat,finite_card(A),A3) = finite_fold(A,nat,aTP_Lamp_afj(A,fun(nat,nat)),zero_zero(nat),A3) ) ).

% card.eq_fold
tff(fact_7664_minus__fold__remove,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3) = finite_fold(A,set(A),remove(A),B3,A3) ) ) ).

% minus_fold_remove
tff(fact_7665_bounded__quasi__semilattice__set_Oeq__fold,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),A3)
        = $ite(aa(set(A),$o,finite_finite(A),A3),finite_fold(A,A,F2,Top,A3),Bot) ) ) ).

% bounded_quasi_semilattice_set.eq_fold
tff(fact_7666_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,plus_plus(A)),G),zero_zero(A),A3) ) ) ).

% sum.eq_fold
tff(fact_7667_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,times_times(A)),G),one_one(A),A3) ) ) ).

% prod.eq_fold
tff(fact_7668_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S3: set(A),F2: fun(A,fun(B,B)),X: A,A3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S3,F2)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,X),A3)),S3)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( finite_fold(A,B,F2,Z,aa(set(A),set(A),insert(A,X),A3)) = aa(B,B,aa(A,fun(B,B),F2,X),finite_fold(A,B,F2,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
tff(fact_7669_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S3: set(A),F2: fun(A,fun(B,B)),A3: set(A),X: A,Z: B] :
      ( finite4664212375090638736ute_on(A,B,S3,F2)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S3)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,X,A3)
           => ( finite_fold(A,B,F2,Z,A3) = aa(B,B,aa(A,fun(B,B),F2,X),finite_fold(A,B,F2,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
tff(fact_7670_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S3: set(A),F2: fun(A,fun(B,B)),A3: set(A),Z: B,Y: B,A2: A] :
      ( finite4664212375090638736ute_on(A,B,S3,F2)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S3)
       => ( finite_fold_graph(A,B,F2,Z,A3,Y)
         => ( member(A,A2,A3)
           => ? [Y7: B] :
                ( ( Y = aa(B,B,aa(A,fun(B,B),F2,A2),Y7) )
                & finite_fold_graph(A,B,F2,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))),Y7) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
tff(fact_7671_tendsto__add__Pair,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [A2: A,B2: A] : filterlim(product_prod(A,A),A,aTP_Lamp_afk(product_prod(A,A),A),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),prod_filter(A,A,topolo7230453075368039082e_nhds(A,A2),topolo7230453075368039082e_nhds(A,B2))) ) ).

% tendsto_add_Pair
tff(fact_7672_Gcd__int__set__eq__fold,axiom,
    ! [Xs: list(int)] : ( gcd_Gcd(int,aa(list(int),set(int),set2(int),Xs)) = aa(int,int,fold(int,int,gcd_gcd(int),Xs),zero_zero(int)) ) ).

% Gcd_int_set_eq_fold
tff(fact_7673_numeral__le__enat__iff,axiom,
    ! [M: num,Na: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),extended_enat2(Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),M)),Na) ) ).

% numeral_le_enat_iff
tff(fact_7674_enat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( extended_enat2(Nat) = extended_enat2(Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% enat.inject
tff(fact_7675_enat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: fun(nat,A),F22: A,Nat: nat] : ( aa(extended_enat,A,aa(A,fun(extended_enat,A),aa(fun(nat,A),fun(A,fun(extended_enat,A)),extended_case_enat(A),F1),F22),extended_enat2(Nat)) = aa(nat,A,F1,Nat) ) ).

% enat.simps(4)
tff(fact_7676_enat__ord__simps_I2_J,axiom,
    ! [M: nat,Na: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(M)),extended_enat2(Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% enat_ord_simps(2)
tff(fact_7677_enat__ord__simps_I1_J,axiom,
    ! [M: nat,Na: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(M)),extended_enat2(Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),Na) ) ).

% enat_ord_simps(1)
tff(fact_7678_plus__enat__simps_I1_J,axiom,
    ! [M: nat,Na: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extended_enat2(M)),extended_enat2(Na)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na)) ) ).

% plus_enat_simps(1)
tff(fact_7679_idiff__enat__0,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(zero_zero(nat))),Na) = extended_enat2(zero_zero(nat)) ) ).

% idiff_enat_0
tff(fact_7680_idiff__enat__0__right,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Na),extended_enat2(zero_zero(nat))) = Na ) ).

% idiff_enat_0_right
tff(fact_7681_idiff__enat__enat,axiom,
    ! [A2: nat,B2: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A2)),extended_enat2(B2)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2)) ) ).

% idiff_enat_enat
tff(fact_7682_times__enat__simps_I1_J,axiom,
    ! [M: nat,Na: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extended_enat2(Na)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na)) ) ).

% times_enat_simps(1)
tff(fact_7683_max__enat__simps_I1_J,axiom,
    ! [M: nat,Na: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),extended_enat2(M)),extended_enat2(Na)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),Na)) ) ).

% max_enat_simps(1)
tff(fact_7684_min__enat__simps_I1_J,axiom,
    ! [M: nat,Na: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),extended_enat2(M)),extended_enat2(Na)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),Na)) ) ).

% min_enat_simps(1)
tff(fact_7685_numeral__less__enat__iff,axiom,
    ! [M: num,Na: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),extended_enat2(Na))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),Na) ) ).

% numeral_less_enat_iff
tff(fact_7686_numeral__eq__enat,axiom,
    ! [K: num] : ( aa(num,extended_enat,numeral_numeral(extended_enat),K) = extended_enat2(aa(num,nat,numeral_numeral(nat),K)) ) ).

% numeral_eq_enat
tff(fact_7687_of__nat__eq__enat,axiom,
    ! [Na: nat] : ( aa(nat,extended_enat,semiring_1_of_nat(extended_enat),Na) = extended_enat2(Na) ) ).

% of_nat_eq_enat
tff(fact_7688_one__enat__def,axiom,
    one_one(extended_enat) = extended_enat2(one_one(nat)) ).

% one_enat_def
tff(fact_7689_enat__1__iff_I1_J,axiom,
    ! [X: nat] :
      ( ( extended_enat2(X) = one_one(extended_enat) )
    <=> ( X = one_one(nat) ) ) ).

% enat_1_iff(1)
tff(fact_7690_enat__1__iff_I2_J,axiom,
    ! [X: nat] :
      ( ( one_one(extended_enat) = extended_enat2(X) )
    <=> ( X = one_one(nat) ) ) ).

% enat_1_iff(2)
tff(fact_7691_less__enatE,axiom,
    ! [Na: extended_enat,M: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Na),extended_enat2(M))
     => ~ ! [K2: nat] :
            ( ( Na = extended_enat2(K2) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),M) ) ) ).

% less_enatE
tff(fact_7692_enat__iless,axiom,
    ! [Na: extended_enat,M: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Na),extended_enat2(M))
     => ? [K2: nat] : ( Na = extended_enat2(K2) ) ) ).

% enat_iless
tff(fact_7693_chain__incr,axiom,
    ! [A: $tType,Y6: fun(A,extended_enat),K: nat] :
      ( ! [I3: A] :
        ? [J5: A] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(A,extended_enat,Y6,I3)),aa(A,extended_enat,Y6,J5))
     => ? [J3: A] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(K)),aa(A,extended_enat,Y6,J3)) ) ).

% chain_incr
tff(fact_7694_enat__ile,axiom,
    ! [Na: extended_enat,M: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Na),extended_enat2(M))
     => ? [K2: nat] : ( Na = extended_enat2(K2) ) ) ).

% enat_ile
tff(fact_7695_finite__enat__bounded,axiom,
    ! [A3: set(extended_enat),Na: nat] :
      ( ! [Y4: extended_enat] :
          ( member(extended_enat,Y4,A3)
         => aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Y4),extended_enat2(Na)) )
     => aa(set(extended_enat),$o,finite_finite(extended_enat),A3) ) ).

% finite_enat_bounded
tff(fact_7696_enat__0__iff_I2_J,axiom,
    ! [X: nat] :
      ( ( zero_zero(extended_enat) = extended_enat2(X) )
    <=> ( X = zero_zero(nat) ) ) ).

% enat_0_iff(2)
tff(fact_7697_enat__0__iff_I1_J,axiom,
    ! [X: nat] :
      ( ( extended_enat2(X) = zero_zero(extended_enat) )
    <=> ( X = zero_zero(nat) ) ) ).

% enat_0_iff(1)
tff(fact_7698_zero__enat__def,axiom,
    zero_zero(extended_enat) = extended_enat2(zero_zero(nat)) ).

% zero_enat_def
tff(fact_7699_Suc__ile__eq,axiom,
    ! [M: nat,Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(aa(nat,nat,suc,M))),Na)
    <=> aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(M)),Na) ) ).

% Suc_ile_eq
tff(fact_7700_fold__plus__sum__list__rev,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( fold(A,A,plus_plus(A),Xs) = aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),rev(A,Xs))) ) ) ).

% fold_plus_sum_list_rev
tff(fact_7701_bounded__quasi__semilattice__set_Oset__eq__fold,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),Xs: list(A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F2,Top,Bot),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,F2,Xs),Top) ) ) ).

% bounded_quasi_semilattice_set.set_eq_fold
tff(fact_7702_iadd__le__enat__iff,axiom,
    ! [X: extended_enat,Y: extended_enat,Na: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X),Y)),extended_enat2(Na))
    <=> ? [Y8: nat,X16: nat] :
          ( ( X = extended_enat2(X16) )
          & ( Y = extended_enat2(Y8) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X16),Y8)),Na) ) ) ).

% iadd_le_enat_iff
tff(fact_7703_Gcd__set__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xs: list(A)] : ( gcd_Gcd(A,aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_gcd(A),Xs),zero_zero(A)) ) ) ).

% Gcd_set_eq_fold
tff(fact_7704_Gcd__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_gcd(A),Xs),zero_zero(A)) ) ) ).

% Gcd_fin.set_eq_fold
tff(fact_7705_the__enat_Osimps,axiom,
    ! [Na: nat] : ( extended_the_enat(extended_enat2(Na)) = Na ) ).

% the_enat.simps
tff(fact_7706_enat_Osimps_I6_J,axiom,
    ! [A: $tType,F1: fun(nat,A),F22: A,Nat: nat] : ( aa(extended_enat,A,aa(A,fun(extended_enat,A),aa(fun(nat,A),fun(A,fun(extended_enat,A)),extended_rec_enat(A),F1),F22),extended_enat2(Nat)) = aa(nat,A,F1,Nat) ) ).

% enat.simps(6)
tff(fact_7707_minus__set__fold,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(list(A),set(A),set2(A),Xs)) = aa(set(A),set(A),fold(A,set(A),remove(A),Xs),A3) ) ).

% minus_set_fold
tff(fact_7708_case__enat__def,axiom,
    ! [A: $tType] : ( extended_case_enat(A) = extended_rec_enat(A) ) ).

% case_enat_def
tff(fact_7709_Gcd__nat__set__eq__fold,axiom,
    ! [Xs: list(nat)] : ( gcd_Gcd(nat,aa(list(nat),set(nat),set2(nat),Xs)) = aa(nat,nat,fold(nat,nat,gcd_gcd(nat),Xs),zero_zero(nat)) ) ).

% Gcd_nat_set_eq_fold
tff(fact_7710_rec__enat__def,axiom,
    ! [A: $tType,X4: fun(nat,A),Xa2: A,Xb2: extended_enat] : ( aa(extended_enat,A,aa(A,fun(extended_enat,A),aa(fun(nat,A),fun(A,fun(extended_enat,A)),extended_rec_enat(A),X4),Xa2),Xb2) = the(A,extend4933016492236175606t_enat(A,X4,Xa2,Xb2)) ) ).

% rec_enat_def
tff(fact_7711_times__enat__def,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),Na)
      = aa(extended_enat,extended_enat,
          aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afm(extended_enat,fun(nat,extended_enat),Na)),$ite(Na = zero_zero(extended_enat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat))),
          M) ) ).

% times_enat_def
tff(fact_7712_not__infinity__eq,axiom,
    ! [X: extended_enat] :
      ( ( X != extend4730790105801354508finity(extended_enat) )
    <=> ? [I: nat] : ( X = extended_enat2(I) ) ) ).

% not_infinity_eq
tff(fact_7713_not__enat__eq,axiom,
    ! [X: extended_enat] :
      ( ! [Y5: nat] : ( X != extended_enat2(Y5) )
    <=> ( X = extend4730790105801354508finity(extended_enat) ) ) ).

% not_enat_eq
tff(fact_7714_enat__ord__simps_I6_J,axiom,
    ! [Q4: extended_enat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extend4730790105801354508finity(extended_enat)),Q4) ).

% enat_ord_simps(6)
tff(fact_7715_enat__ord__simps_I4_J,axiom,
    ! [Q4: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Q4),extend4730790105801354508finity(extended_enat))
    <=> ( Q4 != extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(4)
tff(fact_7716_plus__enat__simps_I3_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Q4),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ).

% plus_enat_simps(3)
tff(fact_7717_plus__enat__simps_I2_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extend4730790105801354508finity(extended_enat)),Q4) = extend4730790105801354508finity(extended_enat) ) ).

% plus_enat_simps(2)
tff(fact_7718_enat__ord__code_I3_J,axiom,
    ! [Q4: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Q4),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_code(3)
tff(fact_7719_enat__ord__simps_I5_J,axiom,
    ! [Q4: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),Q4)
    <=> ( Q4 = extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(5)
tff(fact_7720_idiff__infinity,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extend4730790105801354508finity(extended_enat)),Na) = extend4730790105801354508finity(extended_enat) ) ).

% idiff_infinity
tff(fact_7721_enat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: fun(nat,A),F22: A] : ( aa(extended_enat,A,aa(A,fun(extended_enat,A),aa(fun(nat,A),fun(A,fun(extended_enat,A)),extended_case_enat(A),F1),F22),extend4730790105801354508finity(extended_enat)) = F22 ) ).

% enat.simps(5)
tff(fact_7722_times__enat__simps_I2_J,axiom,
    aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ).

% times_enat_simps(2)
tff(fact_7723_max__enat__simps_I5_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),extend4730790105801354508finity(extended_enat)),Q4) = extend4730790105801354508finity(extended_enat) ) ).

% max_enat_simps(5)
tff(fact_7724_max__enat__simps_I4_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q4),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ).

% max_enat_simps(4)
tff(fact_7725_min__enat__simps_I4_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q4),extend4730790105801354508finity(extended_enat)) = Q4 ) ).

% min_enat_simps(4)
tff(fact_7726_min__enat__simps_I5_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),extend4730790105801354508finity(extended_enat)),Q4) = Q4 ) ).

% min_enat_simps(5)
tff(fact_7727_enat_Osimps_I7_J,axiom,
    ! [A: $tType,F1: fun(nat,A),F22: A] : ( aa(extended_enat,A,aa(A,fun(extended_enat,A),aa(fun(nat,A),fun(A,fun(extended_enat,A)),extended_rec_enat(A),F1),F22),extend4730790105801354508finity(extended_enat)) = F22 ) ).

% enat.simps(7)
tff(fact_7728_idiff__self,axiom,
    ! [Na: extended_enat] :
      ( ( Na != extend4730790105801354508finity(extended_enat) )
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Na),Na) = zero_zero(extended_enat) ) ) ).

% idiff_self
tff(fact_7729_add__diff__cancel__enat,axiom,
    ! [X: extended_enat,Y: extended_enat] :
      ( ( X != extend4730790105801354508finity(extended_enat) )
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),X),Y)),X) = Y ) ) ).

% add_diff_cancel_enat
tff(fact_7730_idiff__infinity__right,axiom,
    ! [A2: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A2)),extend4730790105801354508finity(extended_enat)) = zero_zero(extended_enat) ) ).

% idiff_infinity_right
tff(fact_7731_times__enat__simps_I3_J,axiom,
    ! [Na: nat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(Na))
      = $ite(Na = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)) ) ).

% times_enat_simps(3)
tff(fact_7732_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extend4730790105801354508finity(extended_enat))
      = $ite(M = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)) ) ).

% times_enat_simps(4)
tff(fact_7733_Sup__enat__def,axiom,
    ! [A3: set(extended_enat)] :
      ( complete_Sup_Sup(extended_enat,A3)
      = $ite(
          A3 = bot_bot(set(extended_enat)),
          zero_zero(extended_enat),
          $ite(aa(set(extended_enat),$o,finite_finite(extended_enat),A3),lattic643756798349783984er_Max(extended_enat,A3),extend4730790105801354508finity(extended_enat)) ) ) ).

% Sup_enat_def
tff(fact_7734_Inf__enat__def,axiom,
    ! [A3: set(extended_enat)] :
      ( complete_Inf_Inf(extended_enat,A3)
      = $ite(A3 = bot_bot(set(extended_enat)),extend4730790105801354508finity(extended_enat),ord_Least(extended_enat,aTP_Lamp_afn(set(extended_enat),fun(extended_enat,$o),A3))) ) ).

% Inf_enat_def
tff(fact_7735_top__enat__def,axiom,
    top_top(extended_enat) = extend4730790105801354508finity(extended_enat) ).

% top_enat_def
tff(fact_7736_numeral__ne__infinity,axiom,
    ! [K: num] : ( aa(num,extended_enat,numeral_numeral(extended_enat),K) != extend4730790105801354508finity(extended_enat) ) ).

% numeral_ne_infinity
tff(fact_7737_infinity__ne__i1,axiom,
    extend4730790105801354508finity(extended_enat) != one_one(extended_enat) ).

% infinity_ne_i1
tff(fact_7738_enat__add__left__cancel,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),B2) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),C2) )
    <=> ( ( A2 = extend4730790105801354508finity(extended_enat) )
        | ( B2 = C2 ) ) ) ).

% enat_add_left_cancel
tff(fact_7739_plus__eq__infty__iff__enat,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),Na) = extend4730790105801354508finity(extended_enat) )
    <=> ( ( M = extend4730790105801354508finity(extended_enat) )
        | ( Na = extend4730790105801354508finity(extended_enat) ) ) ) ).

% plus_eq_infty_iff_enat
tff(fact_7740_enat__add__left__cancel__less,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),B2)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),C2))
    <=> ( ( A2 != extend4730790105801354508finity(extended_enat) )
        & aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),B2),C2) ) ) ).

% enat_add_left_cancel_less
tff(fact_7741_enat__add__left__cancel__le,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),B2)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),A2),C2))
    <=> ( ( A2 = extend4730790105801354508finity(extended_enat) )
        | aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),B2),C2) ) ) ).

% enat_add_left_cancel_le
tff(fact_7742_enat__ord__simps_I3_J,axiom,
    ! [Q4: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Q4),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_simps(3)
tff(fact_7743_infinity__ne__i0,axiom,
    extend4730790105801354508finity(extended_enat) != zero_zero(extended_enat) ).

% infinity_ne_i0
tff(fact_7744_imult__is__infinity,axiom,
    ! [A2: extended_enat,B2: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),A2),B2) = extend4730790105801354508finity(extended_enat) )
    <=> ( ( ( A2 = extend4730790105801354508finity(extended_enat) )
          & ( B2 != zero_zero(extended_enat) ) )
        | ( ( B2 = extend4730790105801354508finity(extended_enat) )
          & ( A2 != zero_zero(extended_enat) ) ) ) ) ).

% imult_is_infinity
tff(fact_7745_enat__ord__code_I5_J,axiom,
    ! [Na: nat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(Na)) ).

% enat_ord_code(5)
tff(fact_7746_infinity__ileE,axiom,
    ! [M: nat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(M)) ).

% infinity_ileE
tff(fact_7747_infinity__ilessE,axiom,
    ! [M: nat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extend4730790105801354508finity(extended_enat)),extended_enat2(M)) ).

% infinity_ilessE
tff(fact_7748_less__infinityE,axiom,
    ! [Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Na),extend4730790105801354508finity(extended_enat))
     => ~ ! [K2: nat] : ( Na != extended_enat2(K2) ) ) ).

% less_infinityE
tff(fact_7749_enat__ord__code_I4_J,axiom,
    ! [M: nat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(M)),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_code(4)
tff(fact_7750_enat__ex__split,axiom,
    ! [P: fun(extended_enat,$o)] :
      ( ? [X_13: extended_enat] : aa(extended_enat,$o,P,X_13)
    <=> ( aa(extended_enat,$o,P,extend4730790105801354508finity(extended_enat))
        | ? [X5: nat] : aa(extended_enat,$o,P,extended_enat2(X5)) ) ) ).

% enat_ex_split
tff(fact_7751_enat3__cases,axiom,
    ! [Y: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] : ( Y = extended_enat2(Nat3) )
       => ( ? [Nata: nat] : ( Ya = extended_enat2(Nata) )
         => ! [Natb: nat] : ( Yb != extended_enat2(Natb) ) ) )
     => ( ( ? [Nat3: nat] : ( Y = extended_enat2(Nat3) )
         => ( ? [Nata: nat] : ( Ya = extended_enat2(Nata) )
           => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
       => ( ( ? [Nat3: nat] : ( Y = extended_enat2(Nat3) )
           => ( ( Ya = extend4730790105801354508finity(extended_enat) )
             => ! [Nata: nat] : ( Yb != extended_enat2(Nata) ) ) )
         => ( ( ? [Nat3: nat] : ( Y = extended_enat2(Nat3) )
             => ( ( Ya = extend4730790105801354508finity(extended_enat) )
               => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
           => ( ( ( Y = extend4730790105801354508finity(extended_enat) )
               => ( ? [Nat3: nat] : ( Ya = extended_enat2(Nat3) )
                 => ! [Nata: nat] : ( Yb != extended_enat2(Nata) ) ) )
             => ( ( ( Y = extend4730790105801354508finity(extended_enat) )
                 => ( ? [Nat3: nat] : ( Ya = extended_enat2(Nat3) )
                   => ( Yb != extend4730790105801354508finity(extended_enat) ) ) )
               => ( ( ( Y = extend4730790105801354508finity(extended_enat) )
                   => ( ( Ya = extend4730790105801354508finity(extended_enat) )
                     => ! [Nat3: nat] : ( Yb != extended_enat2(Nat3) ) ) )
                 => ~ ( ( Y = extend4730790105801354508finity(extended_enat) )
                     => ( ( Ya = extend4730790105801354508finity(extended_enat) )
                       => ( Yb != extend4730790105801354508finity(extended_enat) ) ) ) ) ) ) ) ) ) ) ).

% enat3_cases
tff(fact_7752_enat2__cases,axiom,
    ! [Y: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] : ( Y = extended_enat2(Nat3) )
       => ! [Nata: nat] : ( Ya != extended_enat2(Nata) ) )
     => ( ( ? [Nat3: nat] : ( Y = extended_enat2(Nat3) )
         => ( Ya != extend4730790105801354508finity(extended_enat) ) )
       => ( ( ( Y = extend4730790105801354508finity(extended_enat) )
           => ! [Nat3: nat] : ( Ya != extended_enat2(Nat3) ) )
         => ~ ( ( Y = extend4730790105801354508finity(extended_enat) )
             => ( Ya != extend4730790105801354508finity(extended_enat) ) ) ) ) ) ).

% enat2_cases
tff(fact_7753_enat_Oexhaust,axiom,
    ! [Y: extended_enat] :
      ( ! [Nat3: nat] : ( Y != extended_enat2(Nat3) )
     => ( Y = extend4730790105801354508finity(extended_enat) ) ) ).

% enat.exhaust
tff(fact_7754_enat_Odistinct_I1_J,axiom,
    ! [Nat: nat] : ( extended_enat2(Nat) != extend4730790105801354508finity(extended_enat) ) ).

% enat.distinct(1)
tff(fact_7755_enat_Odistinct_I2_J,axiom,
    ! [Nat: nat] : ( extend4730790105801354508finity(extended_enat) != extended_enat2(Nat) ) ).

% enat.distinct(2)
tff(fact_7756_imult__infinity__right,axiom,
    ! [Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Na)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),Na),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ) ) ).

% imult_infinity_right
tff(fact_7757_imult__infinity,axiom,
    ! [Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),Na)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),Na) = extend4730790105801354508finity(extended_enat) ) ) ).

% imult_infinity
tff(fact_7758_plus__enat__def,axiom,
    ! [M: extended_enat,Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),Na) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afp(extended_enat,fun(nat,extended_enat),Na)),extend4730790105801354508finity(extended_enat)),M) ) ).

% plus_enat_def
tff(fact_7759_diff__enat__def,axiom,
    ! [A2: extended_enat,B2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),A2),B2) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afr(extended_enat,fun(nat,extended_enat),B2)),extend4730790105801354508finity(extended_enat)),A2) ) ).

% diff_enat_def
tff(fact_7760_eSuc__def,axiom,
    ! [I2: extended_enat] : ( aa(extended_enat,extended_enat,extended_eSuc,I2) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afs(nat,extended_enat)),extend4730790105801354508finity(extended_enat)),I2) ) ).

% eSuc_def
tff(fact_7761_iless__Suc__eq,axiom,
    ! [M: nat,Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(M)),aa(extended_enat,extended_enat,extended_eSuc,Na))
    <=> aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(M)),Na) ) ).

% iless_Suc_eq
tff(fact_7762_eSuc__inject,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( ( aa(extended_enat,extended_enat,extended_eSuc,M) = aa(extended_enat,extended_enat,extended_eSuc,Na) )
    <=> ( M = Na ) ) ).

% eSuc_inject
tff(fact_7763_eSuc__infinity,axiom,
    aa(extended_enat,extended_enat,extended_eSuc,extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ).

% eSuc_infinity
tff(fact_7764_eSuc__mono,axiom,
    ! [Na: extended_enat,M: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,Na)),aa(extended_enat,extended_enat,extended_eSuc,M))
    <=> aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Na),M) ) ).

% eSuc_mono
tff(fact_7765_eSuc__ile__mono,axiom,
    ! [Na: extended_enat,M: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,Na)),aa(extended_enat,extended_enat,extended_eSuc,M))
    <=> aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Na),M) ) ).

% eSuc_ile_mono
tff(fact_7766_eSuc__minus__eSuc,axiom,
    ! [Na: extended_enat,M: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,Na)),aa(extended_enat,extended_enat,extended_eSuc,M)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Na),M) ) ).

% eSuc_minus_eSuc
tff(fact_7767_iless__eSuc0,axiom,
    ! [Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),Na),aa(extended_enat,extended_enat,extended_eSuc,zero_zero(extended_enat)))
    <=> ( Na = zero_zero(extended_enat) ) ) ).

% iless_eSuc0
tff(fact_7768_eSuc__minus__1,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,Na)),one_one(extended_enat)) = Na ) ).

% eSuc_minus_1
tff(fact_7769_eSuc__numeral,axiom,
    ! [K: num] : ( aa(extended_enat,extended_enat,extended_eSuc,aa(num,extended_enat,numeral_numeral(extended_enat),K)) = aa(num,extended_enat,numeral_numeral(extended_enat),aa(num,num,aa(num,fun(num,num),plus_plus(num),K),one2)) ) ).

% eSuc_numeral
tff(fact_7770_eSuc__enat,axiom,
    ! [Na: nat] : ( aa(extended_enat,extended_enat,extended_eSuc,extended_enat2(Na)) = extended_enat2(aa(nat,nat,suc,Na)) ) ).

% eSuc_enat
tff(fact_7771_eSuc__enat__iff,axiom,
    ! [X: extended_enat,Y: nat] :
      ( ( aa(extended_enat,extended_enat,extended_eSuc,X) = extended_enat2(Y) )
    <=> ? [N4: nat] :
          ( ( Y = aa(nat,nat,suc,N4) )
          & ( X = extended_enat2(N4) ) ) ) ).

% eSuc_enat_iff
tff(fact_7772_enat__eSuc__iff,axiom,
    ! [Y: nat,X: extended_enat] :
      ( ( extended_enat2(Y) = aa(extended_enat,extended_enat,extended_eSuc,X) )
    <=> ? [N4: nat] :
          ( ( Y = aa(nat,nat,suc,N4) )
          & ( extended_enat2(N4) = X ) ) ) ).

% enat_eSuc_iff
tff(fact_7773_i0__iless__eSuc,axiom,
    ! [Na: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),aa(extended_enat,extended_enat,extended_eSuc,Na)) ).

% i0_iless_eSuc
tff(fact_7774_zero__ne__eSuc,axiom,
    ! [Na: extended_enat] : ( zero_zero(extended_enat) != aa(extended_enat,extended_enat,extended_eSuc,Na) ) ).

% zero_ne_eSuc
tff(fact_7775_not__eSuc__ilei0,axiom,
    ! [Na: extended_enat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,Na)),zero_zero(extended_enat)) ).

% not_eSuc_ilei0
tff(fact_7776_one__eSuc,axiom,
    one_one(extended_enat) = aa(extended_enat,extended_enat,extended_eSuc,zero_zero(extended_enat)) ).

% one_eSuc
tff(fact_7777_eSuc__Sup,axiom,
    ! [A3: set(extended_enat)] :
      ( ( A3 != bot_bot(set(extended_enat)) )
     => ( aa(extended_enat,extended_enat,extended_eSuc,complete_Sup_Sup(extended_enat,A3)) = complete_Sup_Sup(extended_enat,image(extended_enat,extended_enat,extended_eSuc,A3)) ) ) ).

% eSuc_Sup
tff(fact_7778_eSuc__plus__1,axiom,
    ! [Na: extended_enat] : ( aa(extended_enat,extended_enat,extended_eSuc,Na) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Na),one_one(extended_enat)) ) ).

% eSuc_plus_1
tff(fact_7779_plus__1__eSuc_I1_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),one_one(extended_enat)),Q4) = aa(extended_enat,extended_enat,extended_eSuc,Q4) ) ).

% plus_1_eSuc(1)
tff(fact_7780_plus__1__eSuc_I2_J,axiom,
    ! [Q4: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Q4),one_one(extended_enat)) = aa(extended_enat,extended_enat,extended_eSuc,Q4) ) ).

% plus_1_eSuc(2)
tff(fact_7781_mult__eSuc__right,axiom,
    ! [M: extended_enat,Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),aa(extended_enat,extended_enat,extended_eSuc,Na)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),Na)) ) ).

% mult_eSuc_right
tff(fact_7782_mult__eSuc,axiom,
    ! [M: extended_enat,Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,M)),Na) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Na),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),Na)) ) ).

% mult_eSuc
tff(fact_7783_mono__eSuc,axiom,
    order_mono(extended_enat,extended_enat,extended_eSuc) ).

% mono_eSuc
tff(fact_7784_ile__eSuc,axiom,
    ! [Na: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Na),aa(extended_enat,extended_enat,extended_eSuc,Na)) ).

% ile_eSuc
tff(fact_7785_eSuc__max,axiom,
    ! [X: extended_enat,Y: extended_enat] : ( aa(extended_enat,extended_enat,extended_eSuc,aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),X),Y)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,X)),aa(extended_enat,extended_enat,extended_eSuc,Y)) ) ).

% eSuc_max
tff(fact_7786_iadd__Suc__right,axiom,
    ! [M: extended_enat,Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),aa(extended_enat,extended_enat,extended_eSuc,Na)) = aa(extended_enat,extended_enat,extended_eSuc,aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),Na)) ) ).

% iadd_Suc_right
tff(fact_7787_iadd__Suc,axiom,
    ! [M: extended_enat,Na: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,M)),Na) = aa(extended_enat,extended_enat,extended_eSuc,aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),Na)) ) ).

% iadd_Suc
tff(fact_7788_ileI1,axiom,
    ! [M: extended_enat,Na: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),M),Na)
     => aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,extended_eSuc,M)),Na) ) ).

% ileI1
tff(fact_7789_eSuc__Max,axiom,
    ! [A3: set(extended_enat)] :
      ( aa(set(extended_enat),$o,finite_finite(extended_enat),A3)
     => ( ( A3 != bot_bot(set(extended_enat)) )
       => ( aa(extended_enat,extended_enat,extended_eSuc,lattic643756798349783984er_Max(extended_enat,A3)) = lattic643756798349783984er_Max(extended_enat,image(extended_enat,extended_enat,extended_eSuc,A3)) ) ) ) ).

% eSuc_Max
tff(fact_7790_has__vector__derivative__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(real,real),F7: real,X: real,S: set(real),G: fun(real,A),G2: A] :
          ( has_field_derivative(real,F2,F7,topolo174197925503356063within(real,X,S))
         => ( has_ve8173657378732805170vative(A,G,G2,topolo174197925503356063within(real,X,S))
           => has_ve8173657378732805170vative(A,aa(fun(real,A),fun(real,A),aTP_Lamp_aft(fun(real,real),fun(fun(real,A),fun(real,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,F2,X)),G2)),aa(A,A,real_V8093663219630862766scaleR(A,F7),aa(real,A,G,X))),topolo174197925503356063within(real,X,S)) ) ) ) ).

% has_vector_derivative_scaleR
tff(fact_7791_Quotient__real,axiom,
    quotient(fun(nat,rat),real,realrel,real2,rep_real,cr_real) ).

% Quotient_real
tff(fact_7792_has__vector__derivative__id,axiom,
    ! [Net: filter(real)] : has_ve8173657378732805170vative(real,aTP_Lamp_afu(real,real),one_one(real),Net) ).

% has_vector_derivative_id
tff(fact_7793_has__vector__derivative__add,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(real,A),F7: A,Net: filter(real),G: fun(real,A),G2: A] :
          ( has_ve8173657378732805170vative(A,F2,F7,Net)
         => ( has_ve8173657378732805170vative(A,G,G2,Net)
           => has_ve8173657378732805170vative(A,aa(fun(real,A),fun(real,A),aTP_Lamp_afv(fun(real,A),fun(fun(real,A),fun(real,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),F7),G2),Net) ) ) ) ).

% has_vector_derivative_add
tff(fact_7794_has__vector__derivative__add__const,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(real,A),Z: A,F7: A,Net: filter(real)] :
          ( has_ve8173657378732805170vative(A,aa(A,fun(real,A),aTP_Lamp_afw(fun(real,A),fun(A,fun(real,A)),G),Z),F7,Net)
        <=> has_ve8173657378732805170vative(A,G,F7,Net) ) ) ).

% has_vector_derivative_add_const
tff(fact_7795_has__vector__derivative__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F2: fun(real,A),X: A,F3: filter(real),A2: A] :
          ( has_ve8173657378732805170vative(A,F2,X,F3)
         => has_ve8173657378732805170vative(A,aa(A,fun(real,A),aTP_Lamp_afx(fun(real,A),fun(A,fun(real,A)),F2),A2),aa(A,A,aa(A,fun(A,A),divide_divide(A),X),A2),F3) ) ) ).

% has_vector_derivative_divide
tff(fact_7796_has__vector__derivative__diff__const,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(real,A),Z: A,F7: A,Net: filter(real)] :
          ( has_ve8173657378732805170vative(A,aa(A,fun(real,A),aTP_Lamp_afy(fun(real,A),fun(A,fun(real,A)),G),Z),F7,Net)
        <=> has_ve8173657378732805170vative(A,G,F7,Net) ) ) ).

% has_vector_derivative_diff_const
tff(fact_7797_has__vector__derivative__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F2: fun(real,A),F7: A,Net: filter(real),G: fun(real,A),G2: A] :
          ( has_ve8173657378732805170vative(A,F2,F7,Net)
         => ( has_ve8173657378732805170vative(A,G,G2,Net)
           => has_ve8173657378732805170vative(A,aa(fun(real,A),fun(real,A),aTP_Lamp_afz(fun(real,A),fun(fun(real,A),fun(real,A)),F2),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),F7),G2),Net) ) ) ) ).

% has_vector_derivative_diff
tff(fact_7798_has__vector__derivative__const,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [C2: A,Net: filter(real)] : has_ve8173657378732805170vative(A,aTP_Lamp_aga(A,fun(real,A),C2),zero_zero(A),Net) ) ).

% has_vector_derivative_const
tff(fact_7799_has__vector__derivative__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F2: fun(real,A),F7: A,X: real,S: set(real),G: fun(real,A),G2: A] :
          ( has_ve8173657378732805170vative(A,F2,F7,topolo174197925503356063within(real,X,S))
         => ( has_ve8173657378732805170vative(A,G,G2,topolo174197925503356063within(real,X,S))
           => has_ve8173657378732805170vative(A,aa(fun(real,A),fun(real,A),aTP_Lamp_agb(fun(real,A),fun(fun(real,A),fun(real,A)),F2),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(real,A,F2,X)),G2)),aa(A,A,aa(A,fun(A,A),times_times(A),F7),aa(real,A,G,X))),topolo174197925503356063within(real,X,S)) ) ) ) ).

% has_vector_derivative_mult
tff(fact_7800_bounded__bilinear_Ohas__vector__derivative,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),F2: fun(real,A),F7: A,X: real,S: set(real),G: fun(real,B),G2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( has_ve8173657378732805170vative(A,F2,F7,topolo174197925503356063within(real,X,S))
           => ( has_ve8173657378732805170vative(B,G,G2,topolo174197925503356063within(real,X,S))
             => has_ve8173657378732805170vative(C,aa(fun(real,B),fun(real,C),aa(fun(real,A),fun(fun(real,B),fun(real,C)),aTP_Lamp_agc(fun(A,fun(B,C)),fun(fun(real,A),fun(fun(real,B),fun(real,C))),Prod),F2),G),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,aa(real,A,F2,X)),G2)),aa(B,C,aa(A,fun(B,C),Prod,F7),aa(real,B,G,X))),topolo174197925503356063within(real,X,S)) ) ) ) ) ).

% bounded_bilinear.has_vector_derivative
tff(fact_7801_is__singleton__altdef,axiom,
    ! [A: $tType,A3: set(A)] :
      ( is_singleton(A,A3)
    <=> ( aa(set(A),nat,finite_card(A),A3) = one_one(nat) ) ) ).

% is_singleton_altdef
tff(fact_7802_lcm__code__integer,axiom,
    ! [A2: code_integer,B2: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_lcm(code_integer),A2),B2) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),divide_divide(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),A2)),aa(code_integer,code_integer,abs_abs(code_integer),B2))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),A2),B2)) ) ).

% lcm_code_integer
tff(fact_7803_lcm__right__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm_right_idem
tff(fact_7804_lcm__left__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm_left_idem
tff(fact_7805_lcm_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% lcm.bottom_left_bottom
tff(fact_7806_lcm_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% lcm.bottom_right_bottom
tff(fact_7807_lcm__neg1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm_neg1
tff(fact_7808_lcm__neg2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm_neg2
tff(fact_7809_dvd__lcm1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) ) ).

% dvd_lcm1
tff(fact_7810_dvd__lcm2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) ) ).

% dvd_lcm2
tff(fact_7811_lcm__least__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),C2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% lcm_least_iff
tff(fact_7812_lcm__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [Na: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))),A2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(num,A,numeral_numeral(A),Na)),A2) ) ) ).

% lcm_neg_numeral_1
tff(fact_7813_lcm__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,Na: num] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Na))) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(num,A,numeral_numeral(A),Na)) ) ) ).

% lcm_neg_numeral_2
tff(fact_7814_lcm__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = one_one(A) )
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A)) ) ) ) ).

% lcm_eq_1_iff
tff(fact_7815_zero__eq__lcm__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% zero_eq_lcm_iff
tff(fact_7816_lcm__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% lcm_eq_0_iff
tff(fact_7817_lcm__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),aa(A,A,aa(A,fun(A,A),divide_divide(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_div_unit2
tff(fact_7818_lcm__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_div_unit1
tff(fact_7819_lcm__mono,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),C2),D2)) ) ) ) ).

% lcm_mono
tff(fact_7820_dvd__lcmI1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2)) ) ) ).

% dvd_lcmI1
tff(fact_7821_dvd__lcmI2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2)) ) ) ).

% dvd_lcmI2
tff(fact_7822_lcm__dvdD1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ).

% lcm_dvdD1
tff(fact_7823_lcm__dvdD2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ).

% lcm_dvdD2
tff(fact_7824_lcm__least,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),C2) ) ) ) ).

% lcm_least
tff(fact_7825_lcm_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2)) ) ) ).

% lcm.left_commute
tff(fact_7826_lcm_Ocommute,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),A2) ) ) ).

% lcm.commute
tff(fact_7827_lcm_Oassoc,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2)) ) ) ).

% lcm.assoc
tff(fact_7828_gcd__dvd__lcm,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) ) ).

% gcd_dvd_lcm
tff(fact_7829_lcm__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_mult_unit2
tff(fact_7830_lcm__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_mult_unit1
tff(fact_7831_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)
          = $ite(aa(set(A),$o,finite_finite(A),A3),finite_fold(A,A,gcd_lcm(A),one_one(A),A3),zero_zero(A)) ) ) ).

% Lcm_fin.eq_fold
tff(fact_7832_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Lcm_fin(A) = bounde2362111253966948842tice_F(A,gcd_lcm(A),one_one(A),zero_zero(A)) ) ) ).

% Lcm_fin_def
tff(fact_7833_lcm__0__iff__nat,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        | ( Na = zero_zero(nat) ) ) ) ).

% lcm_0_iff_nat
tff(fact_7834_lcm__0__iff__int,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na) = zero_zero(int) )
    <=> ( ( M = zero_zero(int) )
        | ( Na = zero_zero(int) ) ) ) ).

% lcm_0_iff_int
tff(fact_7835_lcm__proj1__iff__nat,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na) = M )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Na),M) ) ).

% lcm_proj1_iff_nat
tff(fact_7836_lcm__proj2__iff__nat,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na) = Na )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),Na) ) ).

% lcm_proj2_iff_nat
tff(fact_7837_lcm__proj1__if__dvd__nat,axiom,
    ! [X: nat,Y: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),X),Y)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),Y),X) = Y ) ) ).

% lcm_proj1_if_dvd_nat
tff(fact_7838_lcm__proj2__if__dvd__nat,axiom,
    ! [X: nat,Y: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),X),Y)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),X),Y) = Y ) ) ).

% lcm_proj2_if_dvd_nat
tff(fact_7839_lcm__int__int__eq,axiom,
    ! [M: nat,Na: nat] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),Na)) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na)) ) ).

% lcm_int_int_eq
tff(fact_7840_abs__lcm__int,axiom,
    ! [I2: int,J2: int] : ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),gcd_lcm(int),I2),J2)) = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),I2),J2) ) ).

% abs_lcm_int
tff(fact_7841_lcm__abs1__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),aa(int,int,abs_abs(int),X)),Y) = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y) ) ).

% lcm_abs1_int
tff(fact_7842_lcm__abs2__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),aa(int,int,abs_abs(int),Y)) = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y) ) ).

% lcm_abs2_int
tff(fact_7843_lcm__1__iff__nat,axiom,
    ! [M: nat,Na: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( Na = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% lcm_1_iff_nat
tff(fact_7844_lcm__1__iff__int,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na) = one_one(int) )
    <=> ( ( ( M = one_one(int) )
          | ( M = aa(int,int,uminus_uminus(int),one_one(int)) ) )
        & ( ( Na = one_one(int) )
          | ( Na = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ) ).

% lcm_1_iff_int
tff(fact_7845_lcm__proj1__iff__int,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na) = aa(int,int,abs_abs(int),M) )
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Na),M) ) ).

% lcm_proj1_iff_int
tff(fact_7846_lcm__proj2__iff__int,axiom,
    ! [M: int,Na: int] :
      ( ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na) = aa(int,int,abs_abs(int),Na) )
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),Na) ) ).

% lcm_proj2_iff_int
tff(fact_7847_lcm__proj1__if__dvd__int,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),X),Y)
     => ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),Y),X) = aa(int,int,abs_abs(int),Y) ) ) ).

% lcm_proj1_if_dvd_int
tff(fact_7848_lcm__proj2__if__dvd__int,axiom,
    ! [X: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),X),Y)
     => ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y) = aa(int,int,abs_abs(int),Y) ) ) ).

% lcm_proj2_if_dvd_int
tff(fact_7849_Lcm__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = zero_zero(A) ) ) ) ).

% Lcm_fin.infinite
tff(fact_7850_Lcm__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),bot_bot(set(A))) = one_one(A) ) ) ).

% Lcm_fin.empty
tff(fact_7851_is__unit__Lcm__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)),one_one(A))
        <=> ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = one_one(A) ) ) ) ).

% is_unit_Lcm_fin_iff
tff(fact_7852_lcm__nat__abs__left__eq,axiom,
    ! [K: int,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),Na) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),K),aa(nat,int,semiring_1_of_nat(int),Na))) ) ).

% lcm_nat_abs_left_eq
tff(fact_7853_lcm__nat__abs__right__eq,axiom,
    ! [Na: nat,K: int] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),Na),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),aa(nat,int,semiring_1_of_nat(int),Na)),K)) ) ).

% lcm_nat_abs_right_eq
tff(fact_7854_Lcm__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)) ) ) ).

% Lcm_fin.insert
tff(fact_7855_lcm__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),D2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),D2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),D2)
        & ! [E3: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),E3)
              & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),E3) )
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),E3) ) )
    <=> ( D2 = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),A2),B2) ) ) ).

% lcm_unique_int
tff(fact_7856_lcm__pos__int,axiom,
    ! [M: int,Na: int] :
      ( ( M != zero_zero(int) )
     => ( ( Na != zero_zero(int) )
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na)) ) ) ).

% lcm_pos_int
tff(fact_7857_lcm__pos__nat,axiom,
    ! [M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na)) ) ) ).

% lcm_pos_nat
tff(fact_7858_lcm__ge__0__int,axiom,
    ! [X: int,Y: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y)) ).

% lcm_ge_0_int
tff(fact_7859_lcm__cases__int,axiom,
    ! [X: int,Y: int,P: fun(int,$o)] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y)) ) )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),zero_zero(int))
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),aa(int,int,uminus_uminus(int),Y))) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),zero_zero(int))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),aa(int,int,uminus_uminus(int),X)),Y)) ) )
         => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),zero_zero(int))
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),zero_zero(int))
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),aa(int,int,uminus_uminus(int),X)),aa(int,int,uminus_uminus(int),Y))) ) )
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y)) ) ) ) ) ).

% lcm_cases_int
tff(fact_7860_prod__gcd__lcm__int,axiom,
    ! [M: int,Na: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),M)),aa(int,int,abs_abs(int),Na)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),Na)),aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na)) ) ).

% prod_gcd_lcm_int
tff(fact_7861_lcm__nat__def,axiom,
    ! [X: nat,Y: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),X),Y) = aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X),Y)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Y)) ) ).

% lcm_nat_def
tff(fact_7862_Lcm__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B3: set(A),A3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),B3)),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)) = aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) ) ) ) ).

% Lcm_fin.subset
tff(fact_7863_lcm__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_lcm(code_integer),X),Xa)) = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),code_int_of_integer(X)),code_int_of_integer(Xa)) ) ).

% lcm_integer.rep_eq
tff(fact_7864_dvd__lcm__I1__nat,axiom,
    ! [K: nat,M: nat,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na)) ) ).

% dvd_lcm_I1_nat
tff(fact_7865_dvd__lcm__I2__nat,axiom,
    ! [K: nat,Na: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),Na)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na)) ) ).

% dvd_lcm_I2_nat
tff(fact_7866_lcm__unique__nat,axiom,
    ! [A2: nat,D2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),D2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),D2)
        & ! [E3: nat] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),E3)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),E3) )
           => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),E3) ) )
    <=> ( D2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),A2),B2) ) ) ).

% lcm_unique_nat
tff(fact_7867_dvd__lcm__I2__int,axiom,
    ! [I2: int,Na: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),I2),Na)
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),I2),aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na)) ) ).

% dvd_lcm_I2_int
tff(fact_7868_dvd__lcm__I1__int,axiom,
    ! [I2: int,M: int,Na: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),I2),M)
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),I2),aa(int,int,aa(int,fun(int,int),gcd_lcm(int),M),Na)) ) ).

% dvd_lcm_I1_int
tff(fact_7869_lcm__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_lcm(code_integer),code_integer_of_int(Xa)),code_integer_of_int(X)) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),gcd_lcm(int),Xa),X)) ) ).

% lcm_integer.abs_eq
tff(fact_7870_Lcm__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)) = aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) ) ) ) ).

% Lcm_fin.in_idem
tff(fact_7871_lcm__neg2__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),aa(int,int,uminus_uminus(int),Y)) = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y) ) ).

% lcm_neg2_int
tff(fact_7872_lcm__neg1__int,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),aa(int,int,uminus_uminus(int),X)),Y) = aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y) ) ).

% lcm_neg1_int
tff(fact_7873_Lcm__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B3: set(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)),aa(set(A),A,semiring_gcd_Lcm_fin(A),B3)) ) ) ).

% Lcm_fin.union
tff(fact_7874_prod__gcd__lcm__nat,axiom,
    ! [M: nat,Na: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Na) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),Na)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M),Na)) ) ).

% prod_gcd_lcm_nat
tff(fact_7875_lcm__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),gcd_lcm(int)),gcd_lcm(int)) ).

% lcm_integer.rsp
tff(fact_7876_lcm__int__def,axiom,
    ! [X: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),X),Y) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),X))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Y)))) ) ).

% lcm_int_def
tff(fact_7877_Lcm__fin__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = zero_zero(A) )
          <=> member(A,zero_zero(A),A3) ) ) ) ).

% Lcm_fin_0_iff
tff(fact_7878_Lcm__fin__dvd__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)),B2)
          <=> ! [X5: A] :
                ( member(A,X5,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),B2) ) ) ) ) ).

% Lcm_fin_dvd_iff
tff(fact_7879_Lcm__fin__least,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B4),A2) )
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)),A2) ) ) ) ).

% Lcm_fin_least
tff(fact_7880_lcm__list__least,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Bs: list(A),A2: A] :
          ( ! [B4: A] :
              ( member(A,B4,aa(list(A),set(A),set2(A),Bs))
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B4),A2) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(list(A),set(A),set2(A),Bs))),A2) ) ) ).

% lcm_list_least
tff(fact_7881_lcm__list__dvd__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A),B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(list(A),set(A),set2(A),Xs))),B2)
        <=> ! [X5: A] :
              ( member(A,X5,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),B2) ) ) ) ).

% lcm_list_dvd_iff
tff(fact_7882_dvd__Lcm__fin,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)) ) ) ).

% dvd_Lcm_fin
tff(fact_7883_Lcm__fin__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = one_one(A) )
        <=> ( ! [X5: A] :
                ( member(A,X5,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),one_one(A)) )
            & aa(set(A),$o,finite_finite(A),A3) ) ) ) ).

% Lcm_fin_1_iff
tff(fact_7884_lcm__altdef__int,axiom,
    ! [A2: int,B2: int] : ( aa(int,int,aa(int,fun(int,int),gcd_lcm(int),A2),B2) = aa(int,int,aa(int,fun(int,int),divide_divide(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),A2)),aa(int,int,abs_abs(int),B2))),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)) ) ).

% lcm_altdef_int
tff(fact_7885_Lcm__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% Lcm_fin.remove
tff(fact_7886_Lcm__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% Lcm_fin.insert_remove
tff(fact_7887_Lcm__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_lcm(A),Xs),one_one(A)) ) ) ).

% Lcm_fin.set_eq_fold
tff(fact_7888_Lcm__eq__Max__nat,axiom,
    ! [M10: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M10)
     => ( ( M10 != bot_bot(set(nat)) )
       => ( ~ member(nat,zero_zero(nat),M10)
         => ( ! [M4: nat,N: nat] :
                ( member(nat,M4,M10)
               => ( member(nat,N,M10)
                 => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M4),N),M10) ) )
           => ( gcd_Lcm(nat,M10) = lattic643756798349783984er_Max(nat,M10) ) ) ) ) ) ).

% Lcm_eq_Max_nat
tff(fact_7889_Lcm__int__set__eq__fold,axiom,
    ! [Xs: list(int)] : ( gcd_Lcm(int,aa(list(int),set(int),set2(int),Xs)) = aa(int,int,fold(int,int,gcd_lcm(int),Xs),one_one(int)) ) ).

% Lcm_int_set_eq_fold
tff(fact_7890_Lcm__eq__0__I__nat,axiom,
    ! [A3: set(nat)] :
      ( member(nat,zero_zero(nat),A3)
     => ( gcd_Lcm(nat,A3) = zero_zero(nat) ) ) ).

% Lcm_eq_0_I_nat
tff(fact_7891_abs__Lcm__eq,axiom,
    ! [K5: set(int)] : ( aa(int,int,abs_abs(int),gcd_Lcm(int,K5)) = gcd_Lcm(int,K5) ) ).

% abs_Lcm_eq
tff(fact_7892_Lcm__UNIV,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Lcm(A,top_top(set(A))) = zero_zero(A) ) ) ).

% Lcm_UNIV
tff(fact_7893_Lcm__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Lcm(A,bot_bot(set(A))) = one_one(A) ) ) ).

% Lcm_empty
tff(fact_7894_Lcm__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Lcm(A,A3) = one_one(A) )
        <=> ! [X5: A] :
              ( member(A,X5,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),one_one(A)) ) ) ) ).

% Lcm_1_iff
tff(fact_7895_Lcm__insert,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] : ( gcd_Lcm(A,aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),gcd_Lcm(A,A3)) ) ) ).

% Lcm_insert
tff(fact_7896_Lcm__fin__eq__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) = gcd_Lcm(A,A3) ) ) ) ).

% Lcm_fin_eq_Lcm
tff(fact_7897_Lcm__0__iff__nat,axiom,
    ! [A3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( ( gcd_Lcm(nat,A3) = zero_zero(nat) )
      <=> member(nat,zero_zero(nat),A3) ) ) ).

% Lcm_0_iff_nat
tff(fact_7898_Lcm__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,B2: A] : ( gcd_Lcm(A,aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% Lcm_2
tff(fact_7899_Lcm__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(int,image(int,int,abs_abs(int),K5)) = gcd_Lcm(int,K5) ) ).

% Lcm_abs_eq
tff(fact_7900_Lcm__int__eq,axiom,
    ! [N3: set(nat)] : ( gcd_Lcm(int,image(nat,int,semiring_1_of_nat(int),N3)) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,N3)) ) ).

% Lcm_int_eq
tff(fact_7901_Lcm__nat__abs__eq,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(nat,image(int,nat,aTP_Lamp_mj(int,nat),K5)) = aa(int,nat,nat2,gcd_Lcm(int,K5)) ) ).

% Lcm_nat_abs_eq
tff(fact_7902_Lcm__nat__insert,axiom,
    ! [Na: nat,M10: set(nat)] : ( gcd_Lcm(nat,aa(set(nat),set(nat),insert(nat,Na),M10)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),Na),gcd_Lcm(nat,M10)) ) ).

% Lcm_nat_insert
tff(fact_7903_Lcm__Un,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),B3: set(A)] : ( gcd_Lcm(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),gcd_Lcm(A,A3)),gcd_Lcm(A,B3)) ) ) ).

% Lcm_Un
tff(fact_7904_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M10: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M10)
     => ( ( M10 != bot_bot(set(nat)) )
       => ( ! [M4: nat,N: nat] :
              ( member(nat,M4,M10)
             => ( member(nat,N,M10)
               => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M4),N),M10) ) )
         => member(nat,gcd_Lcm(nat,M10),M10) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
tff(fact_7905_Lcm__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(A),F2: fun(A,B),G: fun(A,B)] :
          ( ! [X3: A] :
              ( member(A,X3,A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F2,X3)),aa(A,B,G,X3)) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),gcd_Lcm(B,image(A,B,F2,A3))),gcd_Lcm(B,image(A,B,G,A3))) ) ) ).

% Lcm_mono
tff(fact_7906_Lcm__eq__0__I,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( member(A,zero_zero(A),A3)
         => ( gcd_Lcm(A,A3) = zero_zero(A) ) ) ) ).

% Lcm_eq_0_I
tff(fact_7907_Lcm__0__iff_H,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Lcm(A,A3) = zero_zero(A) )
        <=> ~ ? [L3: A] :
                ( ( L3 != zero_zero(A) )
                & ! [X5: A] :
                    ( member(A,X5,A3)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),L3) ) ) ) ) ).

% Lcm_0_iff'
tff(fact_7908_Lcm__no__multiple,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ! [M4: A] :
              ( ( M4 != zero_zero(A) )
             => ? [X4: A] :
                  ( member(A,X4,A3)
                  & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X4),M4) ) )
         => ( gcd_Lcm(A,A3) = zero_zero(A) ) ) ) ).

% Lcm_no_multiple
tff(fact_7909_Lcm__int__greater__eq__0,axiom,
    ! [K5: set(int)] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),gcd_Lcm(int,K5)) ).

% Lcm_int_greater_eq_0
tff(fact_7910_Gcd__nat__def,axiom,
    ! [M10: set(nat)] : ( gcd_Gcd(nat,M10) = gcd_Lcm(nat,collect(nat,aTP_Lamp_agd(set(nat),fun(nat,$o),M10))) ) ).

% Gcd_nat_def
tff(fact_7911_Lcm__subset,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),gcd_Lcm(A,A3)),gcd_Lcm(A,B3)) ) ) ).

% Lcm_subset
tff(fact_7912_Lcm__dvd__nat,axiom,
    ! [M10: set(nat),Na: nat] :
      ( ! [X3: nat] :
          ( member(nat,X3,M10)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),X3),Na) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),gcd_Lcm(nat,M10)),Na) ) ).

% Lcm_dvd_nat
tff(fact_7913_dvd__Lcm__nat,axiom,
    ! [M: nat,M10: set(nat)] :
      ( member(nat,M,M10)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),gcd_Lcm(nat,M10)) ) ).

% dvd_Lcm_nat
tff(fact_7914_dvd__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),gcd_Lcm(A,A3)) ) ) ).

% dvd_Lcm
tff(fact_7915_Lcm__dvdD,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),X: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),gcd_Lcm(A,A3)),X)
         => ( member(A,Y,A3)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y),X) ) ) ) ).

% Lcm_dvdD
tff(fact_7916_Lcm__least,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),A2: A] :
          ( ! [B4: A] :
              ( member(A,B4,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B4),A2) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),gcd_Lcm(A,A3)),A2) ) ) ).

% Lcm_least
tff(fact_7917_Lcm__dvd__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),X: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),gcd_Lcm(A,A3)),X)
        <=> ! [X5: A] :
              ( member(A,X5,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),X) ) ) ) ).

% Lcm_dvd_iff
tff(fact_7918_Lcm__least__int,axiom,
    ! [A3: set(int),A2: int] :
      ( ! [B4: int] :
          ( member(int,B4,A3)
         => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B4),A2) )
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),gcd_Lcm(int,A3)),A2) ) ).

% Lcm_least_int
tff(fact_7919_dvd__Lcm__int,axiom,
    ! [M: int,M10: set(int)] :
      ( member(int,M,M10)
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),gcd_Lcm(int,M10)) ) ).

% dvd_Lcm_int
tff(fact_7920_Lcm__nat__infinite,axiom,
    ! [M10: set(nat)] :
      ( ~ aa(set(nat),$o,finite_finite(nat),M10)
     => ( gcd_Lcm(nat,M10) = zero_zero(nat) ) ) ).

% Lcm_nat_infinite
tff(fact_7921_Lcm__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( gcd_Lcm(A,A3) = zero_zero(A) )
          <=> member(A,zero_zero(A),A3) ) ) ) ).

% Lcm_0_iff
tff(fact_7922_Lcm__nat__empty,axiom,
    gcd_Lcm(nat,bot_bot(set(nat))) = one_one(nat) ).

% Lcm_nat_empty
tff(fact_7923_Lcm__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,image(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int)),K5))) ) ).

% Lcm_int_def
tff(fact_7924_Lcm__no__units,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Lcm(A,A3) = gcd_Lcm(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),collect(A,aTP_Lamp_age(A,$o)))) ) ) ).

% Lcm_no_units
tff(fact_7925_Gcd__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Gcd(A,A3) = gcd_Lcm(A,collect(A,aTP_Lamp_agf(set(A),fun(A,$o),A3))) ) ) ).

% Gcd_Lcm
tff(fact_7926_Lcm__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Lcm(A,A3) = gcd_Gcd(A,collect(A,aTP_Lamp_agg(set(A),fun(A,$o),A3))) ) ) ).

% Lcm_Gcd
tff(fact_7927_Lcm__set__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xs: list(A)] : ( gcd_Lcm(A,aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_lcm(A),Xs),one_one(A)) ) ) ).

% Lcm_set_eq_fold
tff(fact_7928_Lcm__nat__set__eq__fold,axiom,
    ! [Xs: list(nat)] : ( gcd_Lcm(nat,aa(list(nat),set(nat),set2(nat),Xs)) = aa(nat,nat,fold(nat,nat,gcd_lcm(nat),Xs),one_one(nat)) ) ).

% Lcm_nat_set_eq_fold
tff(fact_7929_Lcm__nat__def,axiom,
    ! [M10: set(nat)] :
      ( gcd_Lcm(nat,M10)
      = $ite(aa(set(nat),$o,finite_finite(nat),M10),lattic5214292709420241887eutr_F(nat,gcd_lcm(nat),one_one(nat),M10),zero_zero(nat)) ) ).

% Lcm_nat_def
tff(fact_7930_Lcm__coprime_H,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),nat,finite_card(A),A3) != zero_zero(nat) )
         => ( ! [A4: A,B4: A] :
                ( member(A,A4,A3)
               => ( member(A,B4,A3)
                 => ( ( A4 != B4 )
                   => algebr8660921524188924756oprime(A,A4,B4) ) ) )
           => ( gcd_Lcm(A,A3) = aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_agh(A,A)),A3)) ) ) ) ) ).

% Lcm_coprime'
tff(fact_7931_normalize__idem,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,normal6383669964737779283malize(A),A2)) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% normalize_idem
tff(fact_7932_lcm_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(A,A,normal6383669964737779283malize(A),zero_zero(A)) = zero_zero(A) ) ) ).

% lcm.normalize_bottom
tff(fact_7933_normalize__0,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( aa(A,A,normal6383669964737779283malize(A),zero_zero(A)) = zero_zero(A) ) ) ).

% normalize_0
tff(fact_7934_normalize__eq__0__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% normalize_eq_0_iff
tff(fact_7935_normalize__mult__normalize__right,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,normal6383669964737779283malize(A),B2))) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% normalize_mult_normalize_right
tff(fact_7936_normalize__mult__normalize__left,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A2)),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% normalize_mult_normalize_left
tff(fact_7937_gcd_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(A,A,normal6383669964737779283malize(A),one_one(A)) = one_one(A) ) ) ).

% gcd.normalize_bottom
tff(fact_7938_normalize__1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( aa(A,A,normal6383669964737779283malize(A),one_one(A)) = one_one(A) ) ) ).

% normalize_1
tff(fact_7939_normalize__dvd__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,normal6383669964737779283malize(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% normalize_dvd_iff
tff(fact_7940_dvd__normalize__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,normal6383669964737779283malize(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_normalize_iff
tff(fact_7941_gcd_Onormalize__right__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,normal6383669964737779283malize(A),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd.normalize_right_idem
tff(fact_7942_gcd_Onormalize__left__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,normal6383669964737779283malize(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd.normalize_left_idem
tff(fact_7943_gcd_Onormalize__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd.normalize_idem
tff(fact_7944_gcd_Oidem__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),A2) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% gcd.idem_normalize
tff(fact_7945_lcm_Onormalize__right__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),aa(A,A,normal6383669964737779283malize(A),B2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm.normalize_right_idem
tff(fact_7946_lcm_Onormalize__left__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,normal6383669964737779283malize(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm.normalize_left_idem
tff(fact_7947_lcm_Onormalize__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ).

% lcm.normalize_idem
tff(fact_7948_lcm_Oidem__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),A2) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% lcm.idem_normalize
tff(fact_7949_coprime__normalize__right__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,aa(A,A,normal6383669964737779283malize(A),B2))
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_normalize_right_iff
tff(fact_7950_coprime__normalize__left__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,normal6383669964737779283malize(A),A2),B2)
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_normalize_left_iff
tff(fact_7951_normalize__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( aa(A,A,normal6383669964737779283malize(A),gcd_Lcm(A,A3)) = gcd_Lcm(A,A3) ) ) ).

% normalize_Lcm
tff(fact_7952_normalize__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( aa(A,A,normal6383669964737779283malize(A),gcd_Gcd(A,A3)) = gcd_Gcd(A,A3) ) ) ).

% normalize_Gcd
tff(fact_7953_Lcm__fin_Onormalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] : ( aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3)) = aa(set(A),A,semiring_gcd_Lcm_fin(A),A3) ) ) ).

% Lcm_fin.normalize
tff(fact_7954_Gcd__fin_Onormalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] : ( aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) = aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) ) ) ).

% Gcd_fin.normalize
tff(fact_7955_gcd_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),zero_zero(A)),A2) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% gcd.top_left_normalize
tff(fact_7956_gcd_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),zero_zero(A)) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% gcd.top_right_normalize
tff(fact_7957_lcm_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),one_one(A)),A2) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% lcm.top_left_normalize
tff(fact_7958_lcm_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),one_one(A)) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% lcm.top_right_normalize
tff(fact_7959_Gcd__image__normalize,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] : ( gcd_Gcd(A,image(A,A,normal6383669964737779283malize(A),A3)) = gcd_Gcd(A,A3) ) ) ).

% Gcd_image_normalize
tff(fact_7960_normalize__mult__unit__left,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,normal6383669964737779283malize(A),B2) ) ) ) ).

% normalize_mult_unit_left
tff(fact_7961_normalize__mult__unit__right,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ) ).

% normalize_mult_unit_right
tff(fact_7962_gcd__mult__lcm,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A2)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ).

% gcd_mult_lcm
tff(fact_7963_lcm__mult__gcd,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A2)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ).

% lcm_mult_gcd
tff(fact_7964_Lcm__singleton,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A] : ( gcd_Lcm(A,aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% Lcm_singleton
tff(fact_7965_Gcd__singleton,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ).

% Gcd_singleton
tff(fact_7966_lcm__proj2__if__dvd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),B2) ) ) ) ).

% lcm_proj2_if_dvd
tff(fact_7967_lcm__proj1__if__dvd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ) ).

% lcm_proj1_if_dvd
tff(fact_7968_lcm__proj2__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,Na: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),M),Na) = aa(A,A,normal6383669964737779283malize(A),Na) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),Na) ) ) ).

% lcm_proj2_iff
tff(fact_7969_lcm__proj1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,Na: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),M),Na) = aa(A,A,normal6383669964737779283malize(A),M) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Na),M) ) ) ).

% lcm_proj1_iff
tff(fact_7970_lcm__unique,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,D2: A,B2: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),D2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D2)
            & ( aa(A,A,normal6383669964737779283malize(A),D2) = D2 )
            & ! [E3: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),E3)
                  & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),E3) )
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),E3) ) )
        <=> ( D2 = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ) ).

% lcm_unique
tff(fact_7971_lcmI,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => ( ! [D4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),D4)
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D4)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D4) ) )
             => ( ( aa(A,A,normal6383669964737779283malize(A),C2) = C2 )
               => ( C2 = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) ) ) ) ) ) ) ).

% lcmI
tff(fact_7972_lcm__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% lcm_coprime
tff(fact_7973_lcm__gcd__prod,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% lcm_gcd_prod
tff(fact_7974_lcm__mult__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2))) ) ) ).

% lcm_mult_left
tff(fact_7975_lcm__mult__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),A2)),C2)) ) ) ).

% lcm_mult_right
tff(fact_7976_lcm__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),C2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% lcm_mult_distrib'
tff(fact_7977_LcmI,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),B2: A] :
          ( ! [A4: A] :
              ( member(A,A4,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A4),B2) )
         => ( ! [C3: A] :
                ( ! [A9: A] :
                    ( member(A,A9,A3)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A9),C3) )
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C3) )
           => ( ( aa(A,A,normal6383669964737779283malize(A),B2) = B2 )
             => ( B2 = gcd_Lcm(A,A3) ) ) ) ) ) ).

% LcmI
tff(fact_7978_Lcm__eqI,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = A2 )
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B4),A2) )
           => ( ! [C3: A] :
                  ( ! [B13: A] :
                      ( member(A,B13,A3)
                     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B13),C3) )
                 => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C3) )
             => ( gcd_Lcm(A,A3) = A2 ) ) ) ) ) ).

% Lcm_eqI
tff(fact_7979_normalize__mult,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [A2: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A2)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ).

% normalize_mult
tff(fact_7980_gcd__mult__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2))) ) ) ).

% gcd_mult_left
tff(fact_7981_gcd__mult__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),A2)),C2)) ) ) ).

% gcd_mult_right
tff(fact_7982_gcd__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),C2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% gcd_mult_distrib'
tff(fact_7983_coprime__crossproduct,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,D2: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A2,D2)
         => ( algebr8660921524188924756oprime(A,B2,C2)
           => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A2)),aa(A,A,normal6383669964737779283malize(A),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),B2)),aa(A,A,normal6383669964737779283malize(A),D2)) )
            <=> ( ( aa(A,A,normal6383669964737779283malize(A),A2) = aa(A,A,normal6383669964737779283malize(A),B2) )
                & ( aa(A,A,normal6383669964737779283malize(A),C2) = aa(A,A,normal6383669964737779283malize(A),D2) ) ) ) ) ) ) ).

% coprime_crossproduct
tff(fact_7984_normalize__nat__def,axiom,
    normal6383669964737779283malize(nat) = id(nat) ).

% normalize_nat_def
tff(fact_7985_gcd__proj2__if__dvd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),B2) ) ) ) ).

% gcd_proj2_if_dvd
tff(fact_7986_gcd__proj1__if__dvd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),A2) ) ) ) ).

% gcd_proj1_if_dvd
tff(fact_7987_gcd__proj2__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,Na: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) = aa(A,A,normal6383669964737779283malize(A),Na) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Na),M) ) ) ).

% gcd_proj2_iff
tff(fact_7988_gcd__proj1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,Na: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),Na) = aa(A,A,normal6383669964737779283malize(A),M) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),Na) ) ) ).

% gcd_proj1_iff
tff(fact_7989_gcd__unique,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [D2: A,A2: A,B2: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),A2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),B2)
            & ( aa(A,A,normal6383669964737779283malize(A),D2) = D2 )
            & ! [E3: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E3),A2)
                  & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E3),B2) )
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E3),D2) ) )
        <=> ( D2 = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_unique
tff(fact_7990_gcdI,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( ! [D4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D4),A2)
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D4),B2)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D4),C2) ) )
             => ( ( aa(A,A,normal6383669964737779283malize(A),C2) = C2 )
               => ( C2 = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ) ) ) ).

% gcdI
tff(fact_7991_normalize__idem__imp__is__unit__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = A2 )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
          <=> ( A2 = one_one(A) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
tff(fact_7992_is__unit__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,normal6383669964737779283malize(A),A2) = one_one(A) ) ) ) ).

% is_unit_normalize
tff(fact_7993_normalize__1__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = one_one(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% normalize_1_iff
tff(fact_7994_associated__unit,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = aa(A,A,normal6383669964737779283malize(A),B2) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A)) ) ) ) ).

% associated_unit
tff(fact_7995_associated__iff__dvd,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = aa(A,A,normal6383669964737779283malize(A),B2) )
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ) ).

% associated_iff_dvd
tff(fact_7996_associated__eqI,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( ( aa(A,A,normal6383669964737779283malize(A),A2) = A2 )
             => ( ( aa(A,A,normal6383669964737779283malize(A),B2) = B2 )
               => ( A2 = B2 ) ) ) ) ) ) ).

% associated_eqI
tff(fact_7997_associatedD2,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = aa(A,A,normal6383669964737779283malize(A),B2) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% associatedD2
tff(fact_7998_associatedD1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = aa(A,A,normal6383669964737779283malize(A),B2) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% associatedD1
tff(fact_7999_associatedI,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,A,normal6383669964737779283malize(A),A2) = aa(A,A,normal6383669964737779283malize(A),B2) ) ) ) ) ).

% associatedI
tff(fact_8000_normalize__int__def,axiom,
    normal6383669964737779283malize(int) = abs_abs(int) ).

% normalize_int_def
tff(fact_8001_dvd__normalize__div,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,normal6383669964737779283malize(A),A2)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ) ).

% dvd_normalize_div
tff(fact_8002_GcdI,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),B2: A] :
          ( ! [A4: A] :
              ( member(A,A4,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A4) )
         => ( ! [C3: A] :
                ( ! [A9: A] :
                    ( member(A,A9,A3)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),A9) )
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),B2) )
           => ( ( aa(A,A,normal6383669964737779283malize(A),B2) = B2 )
             => ( B2 = gcd_Gcd(A,A3) ) ) ) ) ) ).

% GcdI
tff(fact_8003_Gcd__eqI,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A2) = A2 )
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
           => ( ! [C3: A] :
                  ( ! [B13: A] :
                      ( member(A,B13,A3)
                     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),B13) )
                 => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),A2) )
             => ( gcd_Gcd(A,A3) = A2 ) ) ) ) ) ).

% Gcd_eqI
tff(fact_8004_normalize__power,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [A2: A,Na: nat] : ( aa(A,A,normal6383669964737779283malize(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,normal6383669964737779283malize(A),A2)),Na) ) ) ).

% normalize_power
tff(fact_8005_gcd__exp__weak,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,Na: nat,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),Na)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Na)) = aa(A,A,normal6383669964737779283malize(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),Na)) ) ) ).

% gcd_exp_weak
tff(fact_8006_Gcd__mult,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [C2: A,A3: set(A)] : ( gcd_Gcd(A,image(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),gcd_Gcd(A,A3))) ) ) ).

% Gcd_mult
tff(fact_8007_lcm__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2))) ) ) ).

% lcm_gcd
tff(fact_8008_Lcm__mult,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),C2: A] :
          ( ( A3 != bot_bot(set(A)) )
         => ( gcd_Lcm(A,image(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),gcd_Lcm(A,A3))) ) ) ) ).

% Lcm_mult
tff(fact_8009_Lcm__fin__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B2: A] :
          ( ( A3 != bot_bot(set(A)) )
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),image(A,A,aa(A,fun(A,A),times_times(A),B2),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(set(A),A,semiring_gcd_Lcm_fin(A),A3))) ) ) ) ).

% Lcm_fin_mult
tff(fact_8010_Gcd__fin__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),image(A,A,aa(A,fun(A,A),times_times(A),B2),A3)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3))) ) ) ) ).

% Gcd_fin_mult
tff(fact_8011_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde6485984586167503788ce_set(A,gcd_gcd(A),zero_zero(A),one_one(A),normal6383669964737779283malize(A)) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
tff(fact_8012_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde6485984586167503788ce_set(A,gcd_lcm(A),one_one(A),zero_zero(A),normal6383669964737779283malize(A)) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
tff(fact_8013_gcd__lcm,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A2),B2))) ) ) ) ) ).

% gcd_lcm
tff(fact_8014_Lcm__coprime,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A4: A,B4: A] :
                  ( member(A,A4,A3)
                 => ( member(A,B4,A3)
                   => ( ( A4 != B4 )
                     => algebr8660921524188924756oprime(A,A4,B4) ) ) )
             => ( gcd_Lcm(A,A3) = aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_agh(A,A)),A3)) ) ) ) ) ) ).

% Lcm_coprime
tff(fact_8015_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,A3: set(A),X: A] :
      ( lattic5652469242046573047tr_set(A,F2,Z)
     => ( aa(set(A),$o,finite_finite(A),A3)
       => ( lattic5214292709420241887eutr_F(A,F2,Z,aa(set(A),set(A),insert(A,X),A3)) = aa(A,A,aa(A,fun(A,A),F2,X),lattic5214292709420241887eutr_F(A,F2,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ).

% semilattice_neutr_set.insert_remove
tff(fact_8016_semilattice__neutr__set_Oremove,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,A3: set(A),X: A] :
      ( lattic5652469242046573047tr_set(A,F2,Z)
     => ( aa(set(A),$o,finite_finite(A),A3)
       => ( member(A,X,A3)
         => ( lattic5214292709420241887eutr_F(A,F2,Z,A3) = aa(A,A,aa(A,fun(A,A),F2,X),lattic5214292709420241887eutr_F(A,F2,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% semilattice_neutr_set.remove
tff(fact_8017_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde8507323023520639062attice(A,gcd_lcm(A),one_one(A),zero_zero(A),normal6383669964737779283malize(A)) ) ).

% lcm.bounded_quasi_semilattice_axioms
tff(fact_8018_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde8507323023520639062attice(A,gcd_gcd(A),zero_zero(A),one_one(A),normal6383669964737779283malize(A)) ) ).

% gcd.bounded_quasi_semilattice_axioms
tff(fact_8019_bounded__quasi__semilattice__set__def,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
    <=> bounde8507323023520639062attice(A,F2,Top,Bot,Normalize) ) ).

% bounded_quasi_semilattice_set_def
tff(fact_8020_bounded__quasi__semilattice__set_Oaxioms,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize)
     => bounde8507323023520639062attice(A,F2,Top,Bot,Normalize) ) ).

% bounded_quasi_semilattice_set.axioms
tff(fact_8021_bounded__quasi__semilattice__set_Ointro,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => bounde6485984586167503788ce_set(A,F2,Top,Bot,Normalize) ) ).

% bounded_quasi_semilattice_set.intro
tff(fact_8022_bounded__quasi__semilattice_Oleft__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,B2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),aa(A,A,aa(A,fun(A,A),F2,A2),B2)) = aa(A,A,aa(A,fun(A,A),F2,A2),B2) ) ) ).

% bounded_quasi_semilattice.left_idem
tff(fact_8023_bounded__quasi__semilattice_Oright__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,B2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,aa(A,fun(A,A),F2,A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),F2,A2),B2) ) ) ).

% bounded_quasi_semilattice.right_idem
tff(fact_8024_bounded__quasi__semilattice_Onormalize__top,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,Normalize,Top) = Top ) ) ).

% bounded_quasi_semilattice.normalize_top
tff(fact_8025_bounded__quasi__semilattice_Oidem__normalize,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),A2) = aa(A,A,Normalize,A2) ) ) ).

% bounded_quasi_semilattice.idem_normalize
tff(fact_8026_bounded__quasi__semilattice_Onormalize__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,B2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,Normalize,aa(A,A,aa(A,fun(A,A),F2,A2),B2)) = aa(A,A,aa(A,fun(A,A),F2,A2),B2) ) ) ).

% bounded_quasi_semilattice.normalize_idem
tff(fact_8027_bounded__quasi__semilattice_Onormalize__bottom,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,Normalize,Bot) = Bot ) ) ).

% bounded_quasi_semilattice.normalize_bottom
tff(fact_8028_bounded__quasi__semilattice_Obottom__left__bottom,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,Bot),A2) = Bot ) ) ).

% bounded_quasi_semilattice.bottom_left_bottom
tff(fact_8029_bounded__quasi__semilattice_Otop__left__normalize,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,Top),A2) = aa(A,A,Normalize,A2) ) ) ).

% bounded_quasi_semilattice.top_left_normalize
tff(fact_8030_bounded__quasi__semilattice_Obottom__right__bottom,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),Bot) = Bot ) ) ).

% bounded_quasi_semilattice.bottom_right_bottom
tff(fact_8031_bounded__quasi__semilattice_Onormalize__left__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,B2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Normalize,A2)),B2) = aa(A,A,aa(A,fun(A,A),F2,A2),B2) ) ) ).

% bounded_quasi_semilattice.normalize_left_idem
tff(fact_8032_bounded__quasi__semilattice_Otop__right__normalize,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),Top) = aa(A,A,Normalize,A2) ) ) ).

% bounded_quasi_semilattice.top_right_normalize
tff(fact_8033_bounded__quasi__semilattice_Onormalize__right__idem,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,B2: A] :
      ( bounde8507323023520639062attice(A,F2,Top,Bot,Normalize)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),aa(A,A,Normalize,B2)) = aa(A,A,aa(A,fun(A,A),F2,A2),B2) ) ) ).

% bounded_quasi_semilattice.normalize_right_idem
tff(fact_8034_prod__list__def,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( groups5270119922927024881d_list(A) = groups_monoid_F(A,times_times(A),one_one(A)) ) ) ).

% prod_list_def
tff(fact_8035_Zfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( zfun(A,B,F2,F3)
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => eventually(A,aa(real,fun(A,$o),aTP_Lamp_agi(fun(A,B),fun(real,fun(A,$o)),F2),R5),F3) ) ) ) ).

% Zfun_def
tff(fact_8036_Zfun__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: filter(A)] : zfun(A,B,aTP_Lamp_agj(A,B),F3) ) ).

% Zfun_zero
tff(fact_8037_Zfun__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( zfun(A,B,F2,F3)
         => ( zfun(A,B,G,F3)
           => zfun(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),F3) ) ) ) ).

% Zfun_diff
tff(fact_8038_Zfun__add,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A),G: fun(A,B)] :
          ( zfun(A,B,F2,F3)
         => ( zfun(A,B,G,F3)
           => zfun(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_wq(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),F3) ) ) ) ).

% Zfun_add
tff(fact_8039_tendsto__Zfun__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),A2: B,F3: filter(A)] :
          ( filterlim(A,B,F2,topolo7230453075368039082e_nhds(B,A2),F3)
        <=> zfun(A,B,aa(B,fun(A,B),aTP_Lamp_so(fun(A,B),fun(B,fun(A,B)),F2),A2),F3) ) ) ).

% tendsto_Zfun_iff
tff(fact_8040_sum__list__def,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( groups8242544230860333062m_list(A) = groups_monoid_F(A,plus_plus(A),zero_zero(A)) ) ) ).

% sum_list_def
tff(fact_8041_ZfunD,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A),R2: real] :
          ( zfun(A,B,F2,F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => eventually(A,aa(real,fun(A,$o),aTP_Lamp_agi(fun(A,B),fun(real,fun(A,$o)),F2),R2),F3) ) ) ) ).

% ZfunD
tff(fact_8042_ZfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F2: fun(A,B),F3: filter(A)] :
          ( ! [R: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
             => eventually(A,aa(real,fun(A,$o),aTP_Lamp_agi(fun(A,B),fun(real,fun(A,$o)),F2),R),F3) )
         => zfun(A,B,F2,F3) ) ) ).

% ZfunI
tff(fact_8043_cr__int__def,axiom,
    ! [X4: product_prod(nat,nat)] : ( aa(product_prod(nat,nat),fun(int,$o),cr_int,X4) = aa(int,fun(int,$o),fequal(int),aa(product_prod(nat,nat),int,abs_Integ,X4)) ) ).

% cr_int_def
tff(fact_8044_gfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),K: nat] :
          ( order_mono(A,A,F2)
         => ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,K)),F2),top_top(A)) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),top_top(A)) )
           => ( complete_lattice_gfp(A,F2) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F2),top_top(A)) ) ) ) ) ).

% gfp_Kleene_iter
tff(fact_8045_gfp__funpow,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F2: fun(A,A),Na: nat] :
          ( order_mono(A,A,F2)
         => ( complete_lattice_gfp(A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,Na)),F2)) = complete_lattice_gfp(A,F2) ) ) ) ).

% gfp_funpow
tff(fact_8046_int_Opcr__cr__eq,axiom,
    pcr_int = cr_int ).

% int.pcr_cr_eq
tff(fact_8047_Quotient__int,axiom,
    quotient(product_prod(nat,nat),int,intrel,abs_Integ,rep_Integ,cr_int) ).

% Quotient_int
tff(fact_8048_strict__sorted__equal__Uniq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : uniq(list(A),aTP_Lamp_agk(set(A),fun(list(A),$o),A3)) ) ).

% strict_sorted_equal_Uniq
tff(fact_8049_list__ex__length,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] :
      ( list_ex(A,P,Xs)
    <=> ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N4),aa(list(A),nat,size_size(list(A)),Xs))
          & aa(A,$o,P,aa(nat,A,nth(A,Xs),N4)) ) ) ).

% list_ex_length
tff(fact_8050_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => semilattice_neutr(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.semilattice_neutr_axioms
tff(fact_8051_max__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr(nat,ord_max(nat),zero_zero(nat)) ).

% max_nat.semilattice_neutr_axioms
tff(fact_8052_or_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => semilattice_neutr(A,bit_se1065995026697491101ons_or(A),zero_zero(A)) ) ).

% or.semilattice_neutr_axioms
tff(fact_8053_gcd__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr(nat,gcd_gcd(nat),zero_zero(nat)) ).

% gcd_nat.semilattice_neutr_axioms
tff(fact_8054_finite__sequence__to__countable__set,axiom,
    ! [A: $tType,X7: set(A)] :
      ( countable_countable(A,X7)
     => ~ ! [F9: fun(nat,set(A))] :
            ( ! [I4: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F9,I4)),X7)
           => ( ! [I4: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F9,I4)),aa(nat,set(A),F9,aa(nat,nat,suc,I4)))
             => ( ! [I4: nat] : aa(set(A),$o,finite_finite(A),aa(nat,set(A),F9,I4))
               => ( complete_Sup_Sup(set(A),image(nat,set(A),F9,top_top(set(nat)))) != X7 ) ) ) ) ) ).

% finite_sequence_to_countable_set
tff(fact_8055_card__Un__disjnt,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( disjnt(A,A3,B3)
         => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ) ).

% card_Un_disjnt
tff(fact_8056_countable__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( countable_countable(A,A3)
     => countable_countable(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% countable_Diff
tff(fact_8057_countable__Diff__eq,axiom,
    ! [A: $tType,A3: set(A),X: A] :
      ( countable_countable(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,X),bot_bot(set(A)))))
    <=> countable_countable(A,A3) ) ).

% countable_Diff_eq
tff(fact_8058_less__ccSUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice(B)
        & linorder(B) )
     => ! [A3: set(A),A2: B,F2: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),complete_Sup_Sup(B,image(A,B,F2,A3)))
          <=> ? [X5: A] :
                ( member(A,X5,A3)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),aa(A,B,F2,X5)) ) ) ) ) ).

% less_ccSUP_iff
tff(fact_8059_ccINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice(B)
        & linorder(B) )
     => ! [A3: set(A),F2: fun(A,B),A2: B] :
          ( countable_countable(A,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),complete_Inf_Inf(B,image(A,B,F2,A3))),A2)
          <=> ? [X5: A] :
                ( member(A,X5,A3)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X5)),A2) ) ) ) ) ).

% ccINF_less_iff
tff(fact_8060_uncountable__minus__countable,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ~ countable_countable(A,A3)
     => ( countable_countable(A,B3)
       => ~ countable_countable(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ) ).

% uncountable_minus_countable
tff(fact_8061_ccInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice(A)
        & linorder(A) )
     => ! [S3: set(A),A2: A] :
          ( countable_countable(A,S3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Inf_Inf(A,S3)),A2)
          <=> ? [X5: A] :
                ( member(A,X5,S3)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),A2) ) ) ) ) ).

% ccInf_less_iff
tff(fact_8062_less__ccSup__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice(A)
        & linorder(A) )
     => ! [S3: set(A),A2: A] :
          ( countable_countable(A,S3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),complete_Sup_Sup(A,S3))
          <=> ? [X5: A] :
                ( member(A,X5,S3)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),X5) ) ) ) ) ).

% less_ccSup_iff
tff(fact_8063_disjnt__ge__max,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y6: set(A),X7: set(A)] :
          ( aa(set(A),$o,finite_finite(A),Y6)
         => ( ! [X3: A] :
                ( member(A,X3,X7)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),lattic643756798349783984er_Max(A,Y6)),X3) )
           => disjnt(A,X7,Y6) ) ) ) ).

% disjnt_ge_max
tff(fact_8064_construct__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [B3: set(B),G: fun(B,A),V: B] : ( real_V4425403222259421789struct(B,A,B3,G,V) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(B,fun(B,A),aa(fun(B,A),fun(B,fun(B,A)),aTP_Lamp_agl(set(B),fun(fun(B,A),fun(B,fun(B,A))),B3),G),V)),collect(B,aa(B,fun(B,$o),aTP_Lamp_agm(set(B),fun(B,fun(B,$o)),B3),V))) ) ) ).

% construct_def
tff(fact_8065_natLess__def,axiom,
    bNF_Ca8459412986667044542atLess = collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,ord_less(nat))) ).

% natLess_def
tff(fact_8066_construct__outside,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [B3: set(A),V: A,F2: fun(A,B)] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( member(A,V,real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),real_V4986007116245087402_basis(A,B3)),B3)))
           => ( real_V4425403222259421789struct(A,B,B3,F2,V) = zero_zero(B) ) ) ) ) ).

% construct_outside
tff(fact_8067_construct__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [B3: set(A),F2: fun(A,B),G: fun(A,B),V: A] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( real_V4425403222259421789struct(A,B,B3,aa(fun(A,B),fun(A,B),aTP_Lamp_aes(fun(A,B),fun(fun(A,B),fun(A,B)),F2),G),V) = aa(B,B,aa(B,fun(B,B),plus_plus(B),real_V4425403222259421789struct(A,B,B3,F2,V)),real_V4425403222259421789struct(A,B,B3,G,V)) ) ) ) ).

% construct_add
tff(fact_8068_Restr__natLeq,axiom,
    ! [Na: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Na)),aTP_Lamp_agn(nat,fun(nat,set(nat)),Na))) = collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_ago(nat,fun(nat,fun(nat,$o)),Na))) ) ).

% Restr_natLeq
tff(fact_8069_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( zero(B)
     => ! [F2: fun(fun(A,B),C),G: C] :
          ( ! [X3: fun(A,B)] : ( aa(fun(A,B),C,F2,X3) = G )
         => ( aa(fun(A,B),C,F2,aTP_Lamp_agp(A,B)) = G ) ) ) ).

% fun_cong_unused_0
tff(fact_8070_Restr__natLeq2,axiom,
    ! [Na: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,order_underS(nat,bNF_Ca8665028551170535155natLeq,Na),aTP_Lamp_agq(nat,fun(nat,set(nat)),Na))) = collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_ago(nat,fun(nat,fun(nat,$o)),Na))) ) ).

% Restr_natLeq2
tff(fact_8071_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => group(A,plus_plus(A),zero_zero(A),uminus_uminus(A)) ) ).

% add.group_axioms
tff(fact_8072_natLeq__underS__less,axiom,
    ! [Na: nat] : ( order_underS(nat,bNF_Ca8665028551170535155natLeq,Na) = collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Na)) ) ).

% natLeq_underS_less
tff(fact_8073_group_Oleft__cancel,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A,B2: A,C2: A] :
      ( group(A,F2,Z,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,A2),B2) = aa(A,A,aa(A,fun(A,A),F2,A2),C2) )
      <=> ( B2 = C2 ) ) ) ).

% group.left_cancel
tff(fact_8074_group_Oleft__inverse,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A] :
      ( group(A,F2,Z,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Inverse,A2)),A2) = Z ) ) ).

% group.left_inverse
tff(fact_8075_group_Oright__cancel,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),B2: A,A2: A,C2: A] :
      ( group(A,F2,Z,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,B2),A2) = aa(A,A,aa(A,fun(A,A),F2,C2),A2) )
      <=> ( B2 = C2 ) ) ) ).

% group.right_cancel
tff(fact_8076_group_Oright__inverse,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A] :
      ( group(A,F2,Z,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),aa(A,A,Inverse,A2)) = Z ) ) ).

% group.right_inverse
tff(fact_8077_group_Oinverse__unique,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A,B2: A] :
      ( group(A,F2,Z,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F2,A2),B2) = Z )
       => ( aa(A,A,Inverse,A2) = B2 ) ) ) ).

% group.inverse_unique
tff(fact_8078_group_Oinverse__inverse,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A] :
      ( group(A,F2,Z,Inverse)
     => ( aa(A,A,Inverse,aa(A,A,Inverse,A2)) = A2 ) ) ).

% group.inverse_inverse
tff(fact_8079_group_Oinverse__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A)] :
      ( group(A,F2,Z,Inverse)
     => ( aa(A,A,Inverse,Z) = Z ) ) ).

% group.inverse_neutral
tff(fact_8080_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A] :
      ( group(A,F2,Z,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F2,Z),A2) = A2 ) ) ).

% group.group_left_neutral
tff(fact_8081_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,Inverse: fun(A,A),A2: A,B2: A] :
      ( group(A,F2,Z,Inverse)
     => ( aa(A,A,Inverse,aa(A,A,aa(A,fun(A,A),F2,A2),B2)) = aa(A,A,aa(A,fun(A,A),F2,aa(A,A,Inverse,B2)),aa(A,A,Inverse,A2)) ) ) ).

% group.inverse_distrib_swap
tff(fact_8082_sub_Oabs__eq,axiom,
    ! [Xa: num,X: num] : ( code_sub(Xa,X) = code_integer_of_int(aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Xa)),aa(num,int,numeral_numeral(int),X))) ) ).

% sub.abs_eq
tff(fact_8083_finite__subset__wf,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => wf(set(A),collect(product_prod(set(A),set(A)),product_case_prod(set(A),set(A),$o,aTP_Lamp_agr(set(A),fun(set(A),fun(set(A),$o)),A3)))) ) ).

% finite_subset_wf
tff(fact_8084_Code__Numeral_Osub__code_I1_J,axiom,
    code_sub(one2,one2) = zero_zero(code_integer) ).

% Code_Numeral.sub_code(1)
tff(fact_8085_wf__no__infinite__down__chainE,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),F2: fun(nat,A)] :
      ( wf(A,R2)
     => ~ ! [K2: nat] : member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,F2,aa(nat,nat,suc,K2))),aa(nat,A,F2,K2)),R2) ) ).

% wf_no_infinite_down_chainE
tff(fact_8086_wf__iff__no__infinite__down__chain,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( wf(A,R2)
    <=> ~ ? [F5: fun(nat,A)] :
          ! [I: nat] : member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,F5,aa(nat,nat,suc,I))),aa(nat,A,F5,I)),R2) ) ).

% wf_iff_no_infinite_down_chain
tff(fact_8087_wf__bounded__measure,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),Ub: fun(A,nat),F2: fun(A,nat)] :
      ( ! [A4: A,B4: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B4),A4),R2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Ub,B4)),aa(A,nat,Ub,A4))
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F2,B4)),aa(A,nat,Ub,A4))
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,A4)),aa(A,nat,F2,B4)) ) )
     => wf(A,R2) ) ).

% wf_bounded_measure
tff(fact_8088_wf__if__measure,axiom,
    ! [A: $tType,P: fun(A,$o),F2: fun(A,nat),G: fun(A,A)] :
      ( ! [X3: A] :
          ( aa(A,$o,P,X3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F2,aa(A,A,G,X3))),aa(A,nat,F2,X3)) )
     => wf(A,collect(product_prod(A,A),product_case_prod(A,A,$o,aa(fun(A,A),fun(A,fun(A,$o)),aTP_Lamp_ags(fun(A,$o),fun(fun(A,A),fun(A,fun(A,$o))),P),G)))) ) ).

% wf_if_measure
tff(fact_8089_wf,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => wf(A,collect(product_prod(A,A),product_case_prod(A,A,$o,ord_less(A)))) ) ).

% wf
tff(fact_8090_wf__bounded__set,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,A)),Ub: fun(A,set(B)),F2: fun(A,set(B))] :
      ( ! [A4: A,B4: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B4),A4),R2)
         => ( aa(set(B),$o,finite_finite(B),aa(A,set(B),Ub,A4))
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),Ub,B4)),aa(A,set(B),Ub,A4))
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F2,B4)),aa(A,set(B),Ub,A4))
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(A,set(B),F2,A4)),aa(A,set(B),F2,B4)) ) )
     => wf(A,R2) ) ).

% wf_bounded_set
tff(fact_8091_sub_Orep__eq,axiom,
    ! [X: num,Xa: num] : ( code_int_of_integer(code_sub(X,Xa)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),X)),aa(num,int,numeral_numeral(int),Xa)) ) ).

% sub.rep_eq
tff(fact_8092_Code__Numeral_Osub__code_I9_J,axiom,
    ! [M: num,Na: num] : ( code_sub(aa(num,num,bit0,M),aa(num,num,bit1,Na)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),code_dup(code_sub(M,Na))),one_one(code_integer)) ) ).

% Code_Numeral.sub_code(9)
tff(fact_8093_Code__Numeral_Osub__code_I8_J,axiom,
    ! [M: num,Na: num] : ( code_sub(aa(num,num,bit1,M),aa(num,num,bit0,Na)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),code_dup(code_sub(M,Na))),one_one(code_integer)) ) ).

% Code_Numeral.sub_code(8)
tff(fact_8094_wf__int__ge__less__than,axiom,
    ! [D2: int] : wf(int,int_ge_less_than(D2)) ).

% wf_int_ge_less_than
tff(fact_8095_wf__int__ge__less__than2,axiom,
    ! [D2: int] : wf(int,int_ge_less_than2(D2)) ).

% wf_int_ge_less_than2
tff(fact_8096_wf__less,axiom,
    wf(nat,collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,ord_less(nat)))) ).

% wf_less
tff(fact_8097_Code__Numeral_Odup__code_I1_J,axiom,
    code_dup(zero_zero(code_integer)) = zero_zero(code_integer) ).

% Code_Numeral.dup_code(1)
tff(fact_8098_Code__Numeral_Osub__code_I6_J,axiom,
    ! [M: num,Na: num] : ( code_sub(aa(num,num,bit0,M),aa(num,num,bit0,Na)) = code_dup(code_sub(M,Na)) ) ).

% Code_Numeral.sub_code(6)
tff(fact_8099_Code__Numeral_Osub__code_I4_J,axiom,
    ! [Na: num] : ( code_sub(one2,aa(num,num,bit0,Na)) = code_Neg(bitM(Na)) ) ).

% Code_Numeral.sub_code(4)
tff(fact_8100_Code__Numeral_Osub__code_I2_J,axiom,
    ! [M: num] : ( code_sub(aa(num,num,bit0,M),one2) = aa(num,code_integer,code_Pos,bitM(M)) ) ).

% Code_Numeral.sub_code(2)
tff(fact_8101_Code__Numeral_Odup__code_I3_J,axiom,
    ! [Na: num] : ( code_dup(code_Neg(Na)) = code_Neg(aa(num,num,bit0,Na)) ) ).

% Code_Numeral.dup_code(3)
tff(fact_8102_Code__Numeral_Odup__code_I2_J,axiom,
    ! [Na: num] : ( code_dup(aa(num,code_integer,code_Pos,Na)) = aa(num,code_integer,code_Pos,aa(num,num,bit0,Na)) ) ).

% Code_Numeral.dup_code(2)
tff(fact_8103_less__eq__integer__code_I3_J,axiom,
    ! [L: num] : ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),zero_zero(code_integer)),code_Neg(L)) ).

% less_eq_integer_code(3)
tff(fact_8104_less__eq__integer__code_I7_J,axiom,
    ! [K: num] : aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),code_Neg(K)),zero_zero(code_integer)) ).

% less_eq_integer_code(7)
tff(fact_8105_less__integer__code_I7_J,axiom,
    ! [K: num] : aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),code_Neg(K)),zero_zero(code_integer)) ).

% less_integer_code(7)
tff(fact_8106_less__integer__code_I3_J,axiom,
    ! [L: num] : ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),code_Neg(L)) ).

% less_integer_code(3)
tff(fact_8107_less__integer__code_I4_J,axiom,
    ! [K: num] : ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),aa(num,code_integer,code_Pos,K)),zero_zero(code_integer)) ).

% less_integer_code(4)
tff(fact_8108_less__integer__code_I2_J,axiom,
    ! [L: num] : aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),aa(num,code_integer,code_Pos,L)) ).

% less_integer_code(2)
tff(fact_8109_less__eq__integer__code_I2_J,axiom,
    ! [L: num] : aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),zero_zero(code_integer)),aa(num,code_integer,code_Pos,L)) ).

% less_eq_integer_code(2)
tff(fact_8110_less__eq__integer__code_I4_J,axiom,
    ! [K: num] : ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(num,code_integer,code_Pos,K)),zero_zero(code_integer)) ).

% less_eq_integer_code(4)
tff(fact_8111_less__integer__code_I9_J,axiom,
    ! [K: num,L: num] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),code_Neg(K)),code_Neg(L))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),L),K) ) ).

% less_integer_code(9)
tff(fact_8112_less__integer__code_I5_J,axiom,
    ! [K: num,L: num] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),aa(num,code_integer,code_Pos,K)),aa(num,code_integer,code_Pos,L))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),K),L) ) ).

% less_integer_code(5)
tff(fact_8113_plus__integer__code_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),code_Neg(M)),code_Neg(Na)) = code_Neg(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% plus_integer_code(6)
tff(fact_8114_plus__integer__code_I3_J,axiom,
    ! [M: num,Na: num] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(num,code_integer,code_Pos,M)),aa(num,code_integer,code_Pos,Na)) = aa(num,code_integer,code_Pos,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% plus_integer_code(3)
tff(fact_8115_minus__integer__code_I4_J,axiom,
    ! [M: num,Na: num] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(num,code_integer,code_Pos,M)),code_Neg(Na)) = aa(num,code_integer,code_Pos,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% minus_integer_code(4)
tff(fact_8116_minus__integer__code_I5_J,axiom,
    ! [M: num,Na: num] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),code_Neg(M)),aa(num,code_integer,code_Pos,Na)) = code_Neg(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),Na)) ) ).

% minus_integer_code(5)
tff(fact_8117_one__integer__code,axiom,
    one_one(code_integer) = aa(num,code_integer,code_Pos,one2) ).

% one_integer_code
tff(fact_8118_less__integer__code_I6_J,axiom,
    ! [K: num,L: num] : ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),aa(num,code_integer,code_Pos,K)),code_Neg(L)) ).

% less_integer_code(6)
tff(fact_8119_less__integer__code_I8_J,axiom,
    ! [K: num,L: num] : aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),code_Neg(K)),aa(num,code_integer,code_Pos,L)) ).

% less_integer_code(8)
tff(fact_8120_Code__Numeral_OPos__def,axiom,
    code_Pos = numeral_numeral(code_integer) ).

% Code_Numeral.Pos_def
tff(fact_8121_Pos__fold_I1_J,axiom,
    aa(num,code_integer,numeral_numeral(code_integer),one2) = aa(num,code_integer,code_Pos,one2) ).

% Pos_fold(1)
tff(fact_8122_Pos__fold_I2_J,axiom,
    ! [K: num] : ( aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,K)) = aa(num,code_integer,code_Pos,aa(num,num,bit0,K)) ) ).

% Pos_fold(2)
tff(fact_8123_Pos__fold_I3_J,axiom,
    ! [K: num] : ( aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit1,K)) = aa(num,code_integer,code_Pos,aa(num,num,bit1,K)) ) ).

% Pos_fold(3)
tff(fact_8124_minus__integer__code_I6_J,axiom,
    ! [M: num,Na: num] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),code_Neg(M)),code_Neg(Na)) = code_sub(Na,M) ) ).

% minus_integer_code(6)
tff(fact_8125_minus__integer__code_I3_J,axiom,
    ! [M: num,Na: num] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(num,code_integer,code_Pos,M)),aa(num,code_integer,code_Pos,Na)) = code_sub(M,Na) ) ).

% minus_integer_code(3)
tff(fact_8126_Code__Numeral_Osub__code_I3_J,axiom,
    ! [M: num] : ( code_sub(aa(num,num,bit1,M),one2) = aa(num,code_integer,code_Pos,aa(num,num,bit0,M)) ) ).

% Code_Numeral.sub_code(3)
tff(fact_8127_Code__Numeral_Osub__code_I5_J,axiom,
    ! [Na: num] : ( code_sub(one2,aa(num,num,bit1,Na)) = code_Neg(aa(num,num,bit0,Na)) ) ).

% Code_Numeral.sub_code(5)
tff(fact_8128_splice__replicate,axiom,
    ! [A: $tType,M: nat,X: A,Na: nat] : ( splice(A,replicate(A,M,X),replicate(A,Na,X)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Na),X) ) ).

% splice_replicate
tff(fact_8129_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => monoid(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.monoid_axioms
tff(fact_8130_length__splice,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),nat,size_size(list(A)),splice(A,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ).

% length_splice
tff(fact_8131_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => monoid(A,times_times(A),one_one(A)) ) ).

% mult.monoid_axioms
tff(fact_8132_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,A2: A] :
      ( monoid(A,F2,Z)
     => ( aa(A,A,aa(A,fun(A,A),F2,Z),A2) = A2 ) ) ).

% monoid.left_neutral
tff(fact_8133_monoid_Oright__neutral,axiom,
    ! [A: $tType,F2: fun(A,fun(A,A)),Z: A,A2: A] :
      ( monoid(A,F2,Z)
     => ( aa(A,A,aa(A,fun(A,A),F2,A2),Z) = A2 ) ) ).

% monoid.right_neutral
tff(fact_8134_or_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => monoid(A,bit_se1065995026697491101ons_or(A),zero_zero(A)) ) ).

% or.monoid_axioms
tff(fact_8135_gcd__nat_Omonoid__axioms,axiom,
    monoid(nat,gcd_gcd(nat),zero_zero(nat)) ).

% gcd_nat.monoid_axioms
tff(fact_8136_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => monoid(A,plus_plus(A),zero_zero(A)) ) ).

% add.monoid_axioms
tff(fact_8137_xor_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => monoid(A,bit_se5824344971392196577ns_xor(A),zero_zero(A)) ) ).

% xor.monoid_axioms
tff(fact_8138_max__nat_Omonoid__axioms,axiom,
    monoid(nat,ord_max(nat),zero_zero(nat)) ).

% max_nat.monoid_axioms
tff(fact_8139_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,Na: nat,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3))
    <=> ? [F5: fun(nat,A)] :
          ( ( aa(nat,A,F5,zero_zero(nat)) = A2 )
          & ( aa(nat,A,F5,Na) = B2 )
          & ! [I: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),Na)
             => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,F5,I)),aa(nat,A,F5,aa(nat,nat,suc,I))),R3) ) ) ) ).

% relpow_fun_conv
tff(fact_8140_less__cSUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [A3: set(A),F2: fun(A,B),A2: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(B,image(A,B,F2,A3))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),complete_Sup_Sup(B,image(A,B,F2,A3)))
            <=> ? [X5: A] :
                  ( member(A,X5,A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A2),aa(A,B,F2,X5)) ) ) ) ) ) ).

% less_cSUP_iff
tff(fact_8141_relpow__1,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),one_one(nat)),R3) = R3 ) ).

% relpow_1
tff(fact_8142_finite__relpow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Na: nat] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
       => aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3)) ) ) ).

% finite_relpow
tff(fact_8143_relpow__E2,axiom,
    ! [A: $tType,X: A,Z: A,Na: nat,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3))
     => ( ( ( Na = zero_zero(nat) )
         => ( X != Z ) )
       => ~ ! [Y4: A,M4: nat] :
              ( ( Na = aa(nat,nat,suc,M4) )
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y4),R3)
               => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y4),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M4),R3)) ) ) ) ) ).

% relpow_E2
tff(fact_8144_relpow__E,axiom,
    ! [A: $tType,X: A,Z: A,Na: nat,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3))
     => ( ( ( Na = zero_zero(nat) )
         => ( X != Z ) )
       => ~ ! [Y4: A,M4: nat] :
              ( ( Na = aa(nat,nat,suc,M4) )
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y4),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M4),R3))
               => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y4),Z),R3) ) ) ) ) ).

% relpow_E
tff(fact_8145_relpow__0__I,axiom,
    ! [A: $tType,X: A,R3: set(product_prod(A,A))] : member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),X),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R3)) ).

% relpow_0_I
tff(fact_8146_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R3))
     => ( X = Y ) ) ).

% relpow_0_E
tff(fact_8147_relpow__Suc__E,axiom,
    ! [A: $tType,X: A,Z: A,Na: nat,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Na)),R3))
     => ~ ! [Y4: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y4),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3))
           => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y4),Z),R3) ) ) ).

% relpow_Suc_E
tff(fact_8148_relpow__Suc__I,axiom,
    ! [A: $tType,X: A,Y: A,Na: nat,R3: set(product_prod(A,A)),Z: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),R3)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Na)),R3)) ) ) ).

% relpow_Suc_I
tff(fact_8149_relpow__Suc__D2,axiom,
    ! [A: $tType,X: A,Z: A,Na: nat,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Na)),R3))
     => ? [Y4: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y4),R3)
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y4),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3)) ) ) ).

% relpow_Suc_D2
tff(fact_8150_relpow__Suc__E2,axiom,
    ! [A: $tType,X: A,Z: A,Na: nat,R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Na)),R3))
     => ~ ! [Y4: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y4),R3)
           => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y4),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3)) ) ) ).

% relpow_Suc_E2
tff(fact_8151_relpow__Suc__I2,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Z: A,Na: nat] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y),R3)
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),R3))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,Na)),R3)) ) ) ).

% relpow_Suc_I2
tff(fact_8152_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Y: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,X7)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),complete_Sup_Sup(A,X7))
            <=> ? [X5: A] :
                  ( member(A,X5,X7)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),X5) ) ) ) ) ) ).

% less_cSup_iff
tff(fact_8153_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F2: fun(B,A),A3: set(B),Y: A,I2: B] :
          ( condit941137186595557371_above(A,image(B,A,F2,A3))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Sup_Sup(A,image(B,A,F2,A3))),Y)
           => ( member(B,I2,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F2,I2)),Y) ) ) ) ) ).

% cSUP_lessD
tff(fact_8154_relpow__empty,axiom,
    ! [A: $tType,Na: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Na)
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Na),bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ) ).

% relpow_empty
tff(fact_8155_relpow__finite__bounded1,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),K: nat] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R3)),complete_Sup_Sup(set(product_prod(A,A)),image(nat,set(product_prod(A,A)),aTP_Lamp_agt(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3),collect(nat,aTP_Lamp_agu(set(product_prod(A,A)),fun(nat,$o),R3))))) ) ) ).

% relpow_finite_bounded1
tff(fact_8156_ntrancl__def,axiom,
    ! [A: $tType,Na: nat,R3: set(product_prod(A,A))] : ( transitive_ntrancl(A,Na,R3) = complete_Sup_Sup(set(product_prod(A,A)),image(nat,set(product_prod(A,A)),aTP_Lamp_agt(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3),collect(nat,aTP_Lamp_agv(nat,fun(nat,$o),Na)))) ) ).

% ntrancl_def
tff(fact_8157_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R3)
     => ( transitive_trancl(A,R3) = complete_Sup_Sup(set(product_prod(A,A)),image(nat,set(product_prod(A,A)),aTP_Lamp_agt(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R3),collect(nat,aTP_Lamp_agu(set(product_prod(A,A)),fun(nat,$o),R3)))) ) ) ).

% trancl_finite_eq_relpow
tff(fact_8158_ntrancl__Zero,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( transitive_ntrancl(A,zero_zero(nat),R3) = R3 ) ).

% ntrancl_Zero
tff(fact_8159_trancl__power,axiom,
    ! [A: $tType,P3: product_prod(A,A),R3: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P3,transitive_trancl(A,R3))
    <=> ? [N4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N4)
          & member(product_prod(A,A),P3,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N4),R3)) ) ) ).

% trancl_power
tff(fact_8160_less__eq,axiom,
    ! [M: nat,Na: nat] :
      ( member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,M),Na),transitive_trancl(nat,pred_nat))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),Na) ) ).

% less_eq
tff(fact_8161_finite__trancl__ntranl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R3)
     => ( transitive_trancl(A,R3) = transitive_ntrancl(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),R3)),one_one(nat)),R3) ) ) ).

% finite_trancl_ntranl
tff(fact_8162_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list(product_prod(A,A))] : ( transitive_trancl(A,aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) = transitive_ntrancl(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs))),one_one(nat)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) ) ).

% trancl_set_ntrancl
tff(fact_8163_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [A3: set(A),F2: fun(A,B),A2: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(B,image(A,B,F2,A3))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),complete_Inf_Inf(B,image(A,B,F2,A3))),A2)
            <=> ? [X5: A] :
                  ( member(A,X5,A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F2,X5)),A2) ) ) ) ) ) ).

% cINF_less_iff
tff(fact_8164_lenlex__def,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( lenlex(A,R2) = inv_image(product_prod(nat,list(A)),list(A),lex_prod(nat,list(A),less_than,lex(A,R2)),aTP_Lamp_agw(list(A),product_prod(nat,list(A)))) ) ).

% lenlex_def
tff(fact_8165_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F2: fun(B,A),A3: set(B),Y: A,I2: B] :
          ( condit1013018076250108175_below(A,image(B,A,F2,A3))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),complete_Inf_Inf(A,image(B,A,F2,A3)))
           => ( member(B,I2,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),aa(B,A,F2,I2)) ) ) ) ) ).

% less_cINF_D
tff(fact_8166_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X7: set(A),Y: A] :
          ( ( X7 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,X7)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),complete_Inf_Inf(A,X7)),Y)
            <=> ? [X5: A] :
                  ( member(A,X5,X7)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y) ) ) ) ) ) ).

% cInf_less_iff
tff(fact_8167_pairwise__alt,axiom,
    ! [A: $tType,R3: fun(A,fun(A,$o)),S3: set(A)] :
      ( pairwise(A,R3,S3)
    <=> ! [X5: A] :
          ( member(A,X5,S3)
         => ! [Xa4: A] :
              ( member(A,Xa4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S3),aa(set(A),set(A),insert(A,X5),bot_bot(set(A)))))
             => aa(A,$o,aa(A,fun(A,$o),R3,X5),Xa4) ) ) ) ).

% pairwise_alt
tff(fact_8168_divmod__nat__code,axiom,
    ! [M: nat,Na: nat] :
      ( divmod_nat(M,Na)
      = $let(
          k: code_integer,
          k := code_integer_of_nat(M),
          $let(
            l: code_integer,
            l := code_integer_of_nat(Na),
            product_map_prod(code_integer,nat,code_integer,nat,code_nat_of_integer,code_nat_of_integer,
              $ite(
                k = zero_zero(code_integer),
                aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)),
                $ite(l = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),k),code_divmod_abs(k,l)) )) ) ) ) ).

% divmod_nat_code
tff(fact_8169_integer__of__nat__0,axiom,
    code_integer_of_nat(zero_zero(nat)) = zero_zero(code_integer) ).

% integer_of_nat_0
tff(fact_8170_integer__of__nat__numeral,axiom,
    ! [Na: num] : ( code_integer_of_nat(aa(num,nat,numeral_numeral(nat),Na)) = aa(num,code_integer,numeral_numeral(code_integer),Na) ) ).

% integer_of_nat_numeral
tff(fact_8171_integer__of__nat__1,axiom,
    code_integer_of_nat(one_one(nat)) = one_one(code_integer) ).

% integer_of_nat_1
tff(fact_8172_normalize__div,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,normal6383669964737779283malize(A),A2)),A2) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),unit_f5069060285200089521factor(A,A2)) ) ) ).

% normalize_div
tff(fact_8173_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,normal6383669964737779283malize(A),unit_f5069060285200089521factor(A,A2)) = one_one(A) ) ) ) ).

% normalize_unit_factor
tff(fact_8174_unit__factor__simps_I1_J,axiom,
    unit_f5069060285200089521factor(nat,zero_zero(nat)) = zero_zero(nat) ).

% unit_factor_simps(1)
tff(fact_8175_unit__factor__idem,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] : ( unit_f5069060285200089521factor(A,unit_f5069060285200089521factor(A,A2)) = unit_f5069060285200089521factor(A,A2) ) ) ).

% unit_factor_idem
tff(fact_8176_unit__factor__simps_I2_J,axiom,
    ! [Na: nat] : ( unit_f5069060285200089521factor(nat,aa(nat,nat,suc,Na)) = one_one(nat) ) ).

% unit_factor_simps(2)
tff(fact_8177_unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] :
          ( ( unit_f5069060285200089521factor(A,A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% unit_factor_eq_0_iff
tff(fact_8178_unit__factor__0,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ( unit_f5069060285200089521factor(A,zero_zero(A)) = zero_zero(A) ) ) ).

% unit_factor_0
tff(fact_8179_unit__factor__1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( unit_f5069060285200089521factor(A,one_one(A)) = one_one(A) ) ) ).

% unit_factor_1
tff(fact_8180_unit__factor__mult__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,A2)),aa(A,A,normal6383669964737779283malize(A),A2)) = A2 ) ) ).

% unit_factor_mult_normalize
tff(fact_8181_ATP_Olambda__1,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_mx(product_prod(int,int),product_prod(int,int)),Uu)
      = $ite(aa(product_prod(int,int),int,product_fst(int,int),Uu) = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uu))) ) ).

% ATP.lambda_1
tff(fact_8182_ATP_Olambda__2,axiom,
    ! [Uu: fun(nat,rat)] :
      ( aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_acj(fun(nat,rat),fun(nat,rat)),Uu)
      = $ite(vanishes(Uu),aTP_Lamp_acd(nat,rat),aTP_Lamp_acc(fun(nat,rat),fun(nat,rat),Uu)) ) ).

% ATP.lambda_2
tff(fact_8183_ATP_Olambda__3,axiom,
    ! [A: $tType] :
      ( topolo4638772830378233104ormity(A)
     => ! [Uu: product_unit] : ( aa(product_unit,filter(product_prod(A,A)),aTP_Lamp_afi(product_unit,filter(product_prod(A,A))),Uu) = abort(filter(product_prod(A,A)),literal2($true,$false,$true,$false,$true,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$true,$true,$false,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$true,$false,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$false,$false,$true,$false,$true,$true,literal2($true,$true,$false,$false,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$false,$false,$true,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$true,$false,$false,$false,$true,$true,literal2($true,$false,$true,$false,$true,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($false,$true,$false,$false,$false,$true,$true,literal2($false,$false,$true,$true,$false,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,zero_zero(literal))))))))))))))))))))))))))))),aTP_Lamp_afh(product_unit,filter(product_prod(A,A)))) ) ) ).

% ATP.lambda_3
tff(fact_8184_ATP_Olambda__4,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_aq(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uu)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat)))) ) ).

% ATP.lambda_4
tff(fact_8185_ATP_Olambda__5,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_tt(A,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Uu)),one_one(A))),Uu) ) ) ).

% ATP.lambda_5
tff(fact_8186_ATP_Olambda__6,axiom,
    ! [A: $tType,Uu: set(set(A))] : ( aa(set(set(A)),int,aTP_Lamp_oi(set(set(A)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(set(A)),nat,finite_card(set(A)),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,finite_card(A),complete_Inf_Inf(set(A),Uu)))) ) ).

% ATP.lambda_6
tff(fact_8187_ATP_Olambda__7,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A] :
          ( aa(A,$o,aTP_Lamp_oa(A,$o),Uu)
        <=> ( member(A,Uu,ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Uu) ) ) ) ).

% ATP.lambda_7
tff(fact_8188_ATP_Olambda__8,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_ca(nat,real),Uu) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_8
tff(fact_8189_ATP_Olambda__9,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_ho(real,$o),Uu)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Uu)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uu),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))
        & ( cos(real,Uu) = zero_zero(real) ) ) ) ).

% ATP.lambda_9
tff(fact_8190_ATP_Olambda__10,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),A,aTP_Lamp_mw(product_prod(int,int),A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(int,A,ring_1_of_int(A),aa(product_prod(int,int),int,product_snd(int,int),Uu))) ) ) ).

% ATP.lambda_10
tff(fact_8191_ATP_Olambda__11,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_uu(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_11
tff(fact_8192_ATP_Olambda__12,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_eq(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),times_times(real),cos_coeff(Uu)),aa(nat,real,aa(real,fun(nat,real),power_power(real),zero_zero(real)),Uu)) ) ).

% ATP.lambda_12
tff(fact_8193_ATP_Olambda__13,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ut(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))) ) ) ).

% ATP.lambda_13
tff(fact_8194_ATP_Olambda__14,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_tx(real,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),cos(real,Uu)),sin(real,Uu)) ) ).

% ATP.lambda_14
tff(fact_8195_ATP_Olambda__15,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [Uu: product_prod(A,A)] : ( aa(product_prod(A,A),A,aTP_Lamp_afk(product_prod(A,A),A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(product_prod(A,A),A,product_fst(A,A),Uu)),aa(product_prod(A,A),A,product_snd(A,A),Uu)) ) ) ).

% ATP.lambda_15
tff(fact_8196_ATP_Olambda__16,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_wx(real,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,ln_ln(real),Uu)),Uu) ) ).

% ATP.lambda_16
tff(fact_8197_ATP_Olambda__17,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),product_prod(nat,list(A)),aTP_Lamp_agw(list(A),product_prod(nat,list(A))),Uu) = aa(list(A),product_prod(nat,list(A)),product_Pair(nat,list(A),aa(list(A),nat,size_size(list(A)),Uu)),Uu) ) ).

% ATP.lambda_17
tff(fact_8198_ATP_Olambda__18,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat] :
          ( aa(nat,$o,aTP_Lamp_lt(nat,$o),Uu)
        <=> ( aa(nat,A,semiring_1_of_nat(A),Uu) = zero_zero(A) ) ) ) ).

% ATP.lambda_18
tff(fact_8199_ATP_Olambda__19,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_ug(nat,real),Uu) = aa(real,real,root(Uu),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_19
tff(fact_8200_ATP_Olambda__20,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_ld(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_20
tff(fact_8201_ATP_Olambda__21,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_cl(A,A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_21
tff(fact_8202_ATP_Olambda__22,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: A] :
          ( aa(A,$o,aTP_Lamp_age(A,$o),Uu)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_22
tff(fact_8203_ATP_Olambda__23,axiom,
    ! [Uu: nat] : ( aa(nat,product_prod(nat,nat),aTP_Lamp_nw(nat,product_prod(nat,nat)),Uu) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Uu),zero_zero(nat)) ) ).

% ATP.lambda_23
tff(fact_8204_ATP_Olambda__24,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_mq(product_prod(int,int),$o),Uu)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uu))) ) ).

% ATP.lambda_24
tff(fact_8205_ATP_Olambda__25,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_uo(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_25
tff(fact_8206_ATP_Olambda__26,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_us(nat,A),Uu) = aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_26
tff(fact_8207_ATP_Olambda__27,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_abp(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(nat,nat,suc,zero_zero(nat)))) ) ).

% ATP.lambda_27
tff(fact_8208_ATP_Olambda__28,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_abq(list(B),$o),Uu)
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_28
tff(fact_8209_ATP_Olambda__29,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_abi(list(A),$o),Uu)
    <=> ( Uu != nil(A) ) ) ).

% ATP.lambda_29
tff(fact_8210_ATP_Olambda__30,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_pt(real,real),Uu) = suminf(real,aTP_Lamp_aj(real,fun(nat,real),Uu)) ) ).

% ATP.lambda_30
tff(fact_8211_ATP_Olambda__31,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_abs(nat,set(nat)),Uu) = collect(nat,aTP_Lamp_jx(nat,fun(nat,$o),Uu)) ) ).

% ATP.lambda_31
tff(fact_8212_ATP_Olambda__32,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(real,real)),aTP_Lamp_adm(real,filter(product_prod(real,real))),Uu) = principal(product_prod(real,real),collect(product_prod(real,real),product_case_prod(real,real,$o,aTP_Lamp_adl(real,fun(real,fun(real,$o)),Uu)))) ) ).

% ATP.lambda_32
tff(fact_8213_ATP_Olambda__33,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(complex,complex)),aTP_Lamp_adk(real,filter(product_prod(complex,complex))),Uu) = principal(product_prod(complex,complex),collect(product_prod(complex,complex),product_case_prod(complex,complex,$o,aTP_Lamp_adj(real,fun(complex,fun(complex,$o)),Uu)))) ) ).

% ATP.lambda_33
tff(fact_8214_ATP_Olambda__34,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real] : ( aa(real,filter(product_prod(A,A)),aTP_Lamp_adi(real,filter(product_prod(A,A))),Uu) = principal(product_prod(A,A),collect(product_prod(A,A),product_case_prod(A,A,$o,aTP_Lamp_adh(real,fun(A,fun(A,$o)),Uu)))) ) ) ).

% ATP.lambda_34
tff(fact_8215_ATP_Olambda__35,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_uq(nat,real),Uu) = aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uu))) ) ).

% ATP.lambda_35
tff(fact_8216_ATP_Olambda__36,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ui(nat,A),Uu) = aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_36
tff(fact_8217_ATP_Olambda__37,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_abo(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Uu)) ) ).

% ATP.lambda_37
tff(fact_8218_ATP_Olambda__38,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),fun(nat,nat),aTP_Lamp_abh(list(A),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Uu)) ) ).

% ATP.lambda_38
tff(fact_8219_ATP_Olambda__39,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_zl(A,B),Uu) = aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(A,Uu)) ) ) ).

% ATP.lambda_39
tff(fact_8220_ATP_Olambda__40,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_zm(A,B),Uu) = aa(int,B,ring_1_of_int(B),archimedean_ceiling(A,Uu)) ) ) ).

% ATP.lambda_40
tff(fact_8221_ATP_Olambda__41,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_mn(num,option(num)),Uu) = some(num,aa(num,num,bit1,Uu)) ) ).

% ATP.lambda_41
tff(fact_8222_ATP_Olambda__42,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_mm(num,option(num)),Uu) = some(num,aa(num,num,bit0,Uu)) ) ).

% ATP.lambda_42
tff(fact_8223_ATP_Olambda__43,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_hs(nat,fun(nat,product_prod(nat,nat))),Uu) = product_Pair(nat,nat,aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_43
tff(fact_8224_ATP_Olambda__44,axiom,
    ! [Uu: nat] : ( aa(nat,extended_enat,aTP_Lamp_afs(nat,extended_enat),Uu) = extended_enat2(aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_44
tff(fact_8225_ATP_Olambda__45,axiom,
    ! [Uu: int] : ( aa(int,nat,aTP_Lamp_mj(int,nat),Uu) = aa(int,nat,nat2,aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_45
tff(fact_8226_ATP_Olambda__46,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: A] :
          ( aa(A,$o,aTP_Lamp_nx(A,$o),Uu)
        <=> ? [N4: int] :
              ( ( Uu = aa(int,A,ring_1_of_int(A),N4) )
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N4) ) ) ) ).

% ATP.lambda_46
tff(fact_8227_ATP_Olambda__47,axiom,
    ! [Uu: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aTP_Lamp_aci(fun(nat,rat),$o),Uu)
    <=> ? [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
          & ? [K3: nat] :
            ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N4)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,Uu,N4)) ) ) ) ).

% ATP.lambda_47
tff(fact_8228_ATP_Olambda__48,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_ns(real,$o),Uu)
    <=> ? [I: int,N4: nat] :
          ( ( Uu = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),I)),aa(nat,real,semiring_1_of_nat(real),N4)) )
          & ( N4 != zero_zero(nat) ) ) ) ).

% ATP.lambda_48
tff(fact_8229_ATP_Olambda__49,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_nt(real,$o),Uu)
    <=> ? [I: int,J: int] :
          ( ( Uu = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),I)),aa(int,real,ring_1_of_int(real),J)) )
          & ( J != zero_zero(int) ) ) ) ).

% ATP.lambda_49
tff(fact_8230_ATP_Olambda__50,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_xn(product_prod(A,A),$o),Uu)
        <=> ? [X5: A,Y5: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X5),Y5) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5) ) ) ) ).

% ATP.lambda_50
tff(fact_8231_ATP_Olambda__51,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_xm(product_prod(A,A),$o),Uu)
        <=> ? [X5: A,Y5: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X5),Y5) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X5) ) ) ) ).

% ATP.lambda_51
tff(fact_8232_ATP_Olambda__52,axiom,
    ! [Uu: nat] : ( aa(nat,option(num),aTP_Lamp_mk(nat,option(num)),Uu) = some(num,one2) ) ).

% ATP.lambda_52
tff(fact_8233_ATP_Olambda__53,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_mt(num,fun(nat,option(num)),Uu),Uua) = aa(num,option(num),aa(fun(num,option(num)),fun(num,option(num)),aa(fun(num,option(num)),fun(fun(num,option(num)),fun(num,option(num))),aa(option(num),fun(fun(num,option(num)),fun(fun(num,option(num)),fun(num,option(num)))),case_num(option(num)),some(num,one2)),aTP_Lamp_mr(nat,fun(num,option(num)),Uua)),aTP_Lamp_ms(nat,fun(num,option(num)),Uua)),Uu) ) ).

% ATP.lambda_53
tff(fact_8234_ATP_Olambda__54,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_cd(A,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_54
tff(fact_8235_ATP_Olambda__55,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_eg(nat,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_55
tff(fact_8236_ATP_Olambda__56,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_ce(A,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_56
tff(fact_8237_ATP_Olambda__57,axiom,
    ! [Uu: fun(nat,real),Uua: nat] :
      ( aa(nat,real,aTP_Lamp_cb(fun(nat,real),fun(nat,real),Uu),Uua)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),zero_zero(real),aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% ATP.lambda_57
tff(fact_8238_ATP_Olambda__58,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ix(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uu = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_58
tff(fact_8239_ATP_Olambda__59,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_nu(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uua = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,Uu),Uua)) ) ).

% ATP.lambda_59
tff(fact_8240_ATP_Olambda__60,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,extended_enat,aTP_Lamp_afm(extended_enat,fun(nat,extended_enat),Uu),Uua)
      = aa(extended_enat,extended_enat,
          aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afl(nat,fun(nat,extended_enat),Uua)),$ite(Uua = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat))),
          Uu) ) ).

% ATP.lambda_60
tff(fact_8241_ATP_Olambda__61,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_afr(extended_enat,fun(nat,extended_enat),Uu),Uua) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afq(nat,fun(nat,extended_enat),Uua)),zero_zero(extended_enat)),Uu) ) ).

% ATP.lambda_61
tff(fact_8242_ATP_Olambda__62,axiom,
    ! [Uu: extended_enat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_afp(extended_enat,fun(nat,extended_enat),Uu),Uua) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),aa(fun(nat,extended_enat),fun(extended_enat,fun(extended_enat,extended_enat)),extended_case_enat(extended_enat),aTP_Lamp_afo(nat,fun(nat,extended_enat),Uua)),extend4730790105801354508finity(extended_enat)),Uu) ) ).

% ATP.lambda_62
tff(fact_8243_ATP_Olambda__63,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aed(extended_enat,fun(nat,$o),Uu),Uua)
    <=> aa(extended_enat,$o,aa($o,fun(extended_enat,$o),aa(fun(nat,$o),fun($o,fun(extended_enat,$o)),extended_case_enat($o),aa(nat,fun(nat,$o),aTP_Lamp_kl(nat,fun(nat,$o)),Uua)),$false),Uu) ) ).

% ATP.lambda_63
tff(fact_8244_ATP_Olambda__64,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_eh(nat,fun(nat,A),Uu),Uua)
          = $ite(~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_64
tff(fact_8245_ATP_Olambda__65,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aee(extended_enat,fun(nat,$o),Uu),Uua)
    <=> aa(extended_enat,$o,aa($o,fun(extended_enat,$o),aa(fun(nat,$o),fun($o,fun(extended_enat,$o)),extended_case_enat($o),aa(nat,fun(nat,$o),ord_less(nat),Uua)),$true),Uu) ) ).

% ATP.lambda_65
tff(fact_8246_ATP_Olambda__66,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_zg(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),top_top(A)) ) ) ).

% ATP.lambda_66
tff(fact_8247_ATP_Olambda__67,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ys(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),bot_bot(A)) ) ) ).

% ATP.lambda_67
tff(fact_8248_ATP_Olambda__68,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aa(nat,fun(num,option(num)),aTP_Lamp_mu(nat,fun(num,option(num))),Uu),Uua) = case_nat(option(num),none(num),aTP_Lamp_mt(num,fun(nat,option(num)),Uua),Uu) ) ).

% ATP.lambda_68
tff(fact_8249_ATP_Olambda__69,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_mr(nat,fun(num,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_mm(num,option(num)),bit_take_bit_num(Uu,Uua)) ) ).

% ATP.lambda_69
tff(fact_8250_ATP_Olambda__70,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_mo(num,fun(nat,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_mm(num,option(num)),bit_take_bit_num(Uua,Uu)) ) ).

% ATP.lambda_70
tff(fact_8251_ATP_Olambda__71,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_aax(list(list(A)),fun(nat,list(A)),Uu),Uua) = map(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aaw(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),upt(zero_zero(nat),aa(list(list(A)),nat,size_size(list(list(A))),Uu))) ) ).

% ATP.lambda_71
tff(fact_8252_ATP_Olambda__72,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_hw(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hv(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_72
tff(fact_8253_ATP_Olambda__73,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_hz(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hy(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_73
tff(fact_8254_ATP_Olambda__74,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ai(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Uu),one_one(real))),aa(nat,nat,suc,Uua))) ) ).

% ATP.lambda_74
tff(fact_8255_ATP_Olambda__75,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_br(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_75
tff(fact_8256_ATP_Olambda__76,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_cf(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_76
tff(fact_8257_ATP_Olambda__77,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_eb(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),Uua))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_77
tff(fact_8258_ATP_Olambda__78,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ec(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_78
tff(fact_8259_ATP_Olambda__79,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_hr(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
        & ( sin(real,Uua) = Uu ) ) ) ).

% ATP.lambda_79
tff(fact_8260_ATP_Olambda__80,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_gn(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Uua),aa(real,real,aa(real,fun(real,real),divide_divide(real),pi),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))))
        & ( aa(real,real,tan(real),Uua) = Uu ) ) ) ).

% ATP.lambda_80
tff(fact_8261_ATP_Olambda__81,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,int,aa(code_integer,fun(code_integer,int),aTP_Lamp_lg(code_integer,fun(code_integer,int)),Uu),Uua)
      = $let(
          l2: int,
          l2 := aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),code_int_of_integer(Uu)),
          $ite(Uua = zero_zero(code_integer),l2,aa(int,int,aa(int,fun(int,int),plus_plus(int),l2),one_one(int))) ) ) ).

% ATP.lambda_81
tff(fact_8262_ATP_Olambda__82,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,a,aa(nat,fun(nat,a),aTP_Lamp_ia(nat,fun(nat,a)),Uu),Uua)
      = $let(
          m2: a,
          m2 := aa(a,a,aa(a,fun(a,a),times_times(a),aa(num,a,numeral_numeral(a),aa(num,num,bit0,one2))),aa(nat,a,semiring_1_of_nat(a),Uu)),
          $ite(Uua = zero_zero(nat),m2,aa(a,a,aa(a,fun(a,a),plus_plus(a),m2),one_one(a))) ) ) ).

% ATP.lambda_82
tff(fact_8263_ATP_Olambda__83,axiom,
    ! [Uu: complex,Uua: real] :
      ( aa(real,$o,aTP_Lamp_cm(complex,fun(real,$o),Uu),Uua)
    <=> ( ( aa(complex,complex,sgn_sgn(complex),Uu) = cis(Uua) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),pi) ) ) ).

% ATP.lambda_83
tff(fact_8264_ATP_Olambda__84,axiom,
    ! [Uu: real,Uua: int] :
      ( aa(int,$o,aTP_Lamp_iv(real,fun(int,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(int,real,ring_1_of_int(real),Uua)),Uu)
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Uu),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_84
tff(fact_8265_ATP_Olambda__85,axiom,
    ! [Uu: rat,Uua: int] :
      ( aa(int,$o,aTP_Lamp_iw(rat,fun(int,$o),Uu),Uua)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),Uua)),Uu)
        & aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),Uu),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_85
tff(fact_8266_ATP_Olambda__86,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_aj(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat))))) ) ).

% ATP.lambda_86
tff(fact_8267_ATP_Olambda__87,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_pu(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% ATP.lambda_87
tff(fact_8268_ATP_Olambda__88,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ty(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_88
tff(fact_8269_ATP_Olambda__89,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ef(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_89
tff(fact_8270_ATP_Olambda__90,axiom,
    ! [Uu: rat,Uua: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_nd(rat,fun(product_prod(int,int),$o),Uu),Uua)
    <=> ( ( Uu = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uua)) )
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),Uua))
        & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),Uua),aa(product_prod(int,int),int,product_snd(int,int),Uua)) ) ) ).

% ATP.lambda_90
tff(fact_8271_ATP_Olambda__91,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dc(A,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))),Uua) ) ) ).

% ATP.lambda_91
tff(fact_8272_ATP_Olambda__92,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ei(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_92
tff(fact_8273_ATP_Olambda__93,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dn(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)) ) ) ).

% ATP.lambda_93
tff(fact_8274_ATP_Olambda__94,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_le(nat,fun(nat,$o)),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uu),Uua)
        & ( Uu != Uua ) ) ) ).

% ATP.lambda_94
tff(fact_8275_ATP_Olambda__95,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( aa(set(set(A)),$o,aTP_Lamp_oj(set(set(A)),fun(set(set(A)),$o),Uu),Uua)
    <=> ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),Uua),Uu)
        & ( Uua != bot_bot(set(set(A))) ) ) ) ).

% ATP.lambda_95
tff(fact_8276_ATP_Olambda__96,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ds(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,binomial(Uu),Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) ) ).

% ATP.lambda_96
tff(fact_8277_ATP_Olambda__97,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_oe(set(set(A)),fun(set(A),$o),Uu),Uua)
    <=> ( member(set(A),Uua,Uu)
        & ! [X5: set(A)] :
            ( member(set(A),X5,Uu)
           => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),Uua),X5) ) ) ) ).

% ATP.lambda_97
tff(fact_8278_ATP_Olambda__98,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_fo(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)),semiring_char_0_fact(real,Uua)) ) ).

% ATP.lambda_98
tff(fact_8279_ATP_Olambda__99,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_xa(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uu)),aa(real,real,exp(real),Uua)) ) ).

% ATP.lambda_99
tff(fact_8280_ATP_Olambda__100,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),aTP_Lamp_ael(set(A),fun(set(A),$o)),Uu),Uua)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),Uu),Uua)
        & aa(set(A),$o,finite_finite(A),Uua) ) ) ).

% ATP.lambda_100
tff(fact_8281_ATP_Olambda__101,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_aal(nat,fun(nat,set(nat)),Uu),Uua) = set_or3652927894154168847AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua),Uu) ) ).

% ATP.lambda_101
tff(fact_8282_ATP_Olambda__102,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_zn(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_102
tff(fact_8283_ATP_Olambda__103,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_da(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uu) ) ).

% ATP.lambda_103
tff(fact_8284_ATP_Olambda__104,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_cz(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_104
tff(fact_8285_ATP_Olambda__105,axiom,
    ! [Uu: nat,Uua: complex] :
      ( aa(complex,$o,aTP_Lamp_as(nat,fun(complex,$o),Uu),Uua)
    <=> ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Uua),Uu) = one_one(complex) ) ) ).

% ATP.lambda_105
tff(fact_8286_ATP_Olambda__106,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: nat,Uua: A] :
          ( aa(A,$o,aTP_Lamp_jy(nat,fun(A,$o),Uu),Uua)
        <=> ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uu) = one_one(A) ) ) ) ).

% ATP.lambda_106
tff(fact_8287_ATP_Olambda__107,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_va(real,fun(nat,real),Uu),Uua) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),Uu),aa(nat,real,semiring_1_of_nat(real),Uua)))),Uua) ) ).

% ATP.lambda_107
tff(fact_8288_ATP_Olambda__108,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_yg(real,fun(real,real),Uu),Uua) = powr(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),Uu),Uua)),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),Uua)) ) ).

% ATP.lambda_108
tff(fact_8289_ATP_Olambda__109,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_xc(real,fun(real,real),Uu),Uua) = powr(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),divide_divide(real),Uu),Uua)),Uua) ) ).

% ATP.lambda_109
tff(fact_8290_ATP_Olambda__110,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ah(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(nat)))) ) ).

% ATP.lambda_110
tff(fact_8291_ATP_Olambda__111,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_hf(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),pi)
        & ( cos(real,Uua) = Uu ) ) ) ).

% ATP.lambda_111
tff(fact_8292_ATP_Olambda__112,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: set(A),Uua: list(A)] :
          ( aa(list(A),$o,aTP_Lamp_agk(set(A),fun(list(A),$o),Uu),Uua)
        <=> ( sorted_wrt(A,ord_less(A),Uua)
            & ( aa(list(A),set(A),set2(A),Uua) = Uu ) ) ) ) ).

% ATP.lambda_112
tff(fact_8293_ATP_Olambda__113,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_agu(set(product_prod(A,A)),fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu)) ) ) ).

% ATP.lambda_113
tff(fact_8294_ATP_Olambda__114,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_agv(nat,fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(nat,nat,suc,Uu)) ) ) ).

% ATP.lambda_114
tff(fact_8295_ATP_Olambda__115,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_hi(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_115
tff(fact_8296_ATP_Olambda__116,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_dj(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_116
tff(fact_8297_ATP_Olambda__117,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ul(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_117
tff(fact_8298_ATP_Olambda__118,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ey(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_118
tff(fact_8299_ATP_Olambda__119,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ie(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_119
tff(fact_8300_ATP_Olambda__120,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ic(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_120
tff(fact_8301_ATP_Olambda__121,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bg(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_121
tff(fact_8302_ATP_Olambda__122,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ak(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_122
tff(fact_8303_ATP_Olambda__123,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_jk(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_123
tff(fact_8304_ATP_Olambda__124,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bf(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_124
tff(fact_8305_ATP_Olambda__125,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_gd(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_125
tff(fact_8306_ATP_Olambda__126,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_gc(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_126
tff(fact_8307_ATP_Olambda__127,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_uk(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_127
tff(fact_8308_ATP_Olambda__128,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cu(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_128
tff(fact_8309_ATP_Olambda__129,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_ha(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_ord_lessThan(nat,Uua)) ) ) ).

% ATP.lambda_129
tff(fact_8310_ATP_Olambda__130,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_fy(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_ord_lessThan(nat,Uua)) ) ) ).

% ATP.lambda_130
tff(fact_8311_ATP_Olambda__131,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,A,aTP_Lamp_acn(fun(A,real),fun(A,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(A,real,Uu,Uua)),Uua) ) ) ).

% ATP.lambda_131
tff(fact_8312_ATP_Olambda__132,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_xy(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,Uu,Uua)),zero_zero(real)) ) ).

% ATP.lambda_132
tff(fact_8313_ATP_Olambda__133,axiom,
    ! [B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(B,real),Uua: B] : ( aa(B,real,aTP_Lamp_rf(fun(B,real),fun(B,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(B,real,Uu,Uua)),zero_zero(real)) ) ) ).

% ATP.lambda_133
tff(fact_8314_ATP_Olambda__134,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,complex,aTP_Lamp_es(fun(A,real),fun(A,complex),Uu),Uua) = complex2(aa(A,real,Uu,Uua),zero_zero(real)) ) ).

% ATP.lambda_134
tff(fact_8315_ATP_Olambda__135,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_jv(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = zero_zero(B) ) ) ) ).

% ATP.lambda_135
tff(fact_8316_ATP_Olambda__136,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_jw(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = one_one(B) ) ) ) ).

% ATP.lambda_136
tff(fact_8317_ATP_Olambda__137,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_vk(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),Uu)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_137
tff(fact_8318_ATP_Olambda__138,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_vj(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ty(fun(nat,real),fun(nat,real),Uu)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_138
tff(fact_8319_ATP_Olambda__139,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),list(list(A)),aTP_Lamp_aaz(list(A),fun(list(A),list(list(A))),Uu),Uua) = map(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_aay(list(A),fun(A,list(A))),Uua),Uu) ) ).

% ATP.lambda_139
tff(fact_8320_ATP_Olambda__140,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_lu(nat,fun(nat,nat)),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uu) ) ).

% ATP.lambda_140
tff(fact_8321_ATP_Olambda__141,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_xi(fun(A,B),fun(A,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua))),real_V7770717601297561774m_norm(A,Uua)) ) ) ).

% ATP.lambda_141
tff(fact_8322_ATP_Olambda__142,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ap(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% ATP.lambda_142
tff(fact_8323_ATP_Olambda__143,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ao(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,suc,Uua)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_143
tff(fact_8324_ATP_Olambda__144,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_aer(set(A),fun(set(A),$o),Uu),Uua)
        <=> ( ~ real_V358717886546972837endent(A,Uua)
            & ( real_Vector_span(A,Uua) = real_Vector_span(A,Uu) ) ) ) ) ).

% ATP.lambda_144
tff(fact_8325_ATP_Olambda__145,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_an(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_145
tff(fact_8326_ATP_Olambda__146,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bl(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_146
tff(fact_8327_ATP_Olambda__147,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bs(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_147
tff(fact_8328_ATP_Olambda__148,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aTP_Lamp_mi(num,fun(num,int),Uu),Uua) = aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Uu)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),Uu))),aa(num,int,numeral_numeral(int),Uua))) ) ).

% ATP.lambda_148
tff(fact_8329_ATP_Olambda__149,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bz(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uu)),Uua)) ) ) ).

% ATP.lambda_149
tff(fact_8330_ATP_Olambda__150,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_ok(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Uua)),Uu)) ) ).

% ATP.lambda_150
tff(fact_8331_ATP_Olambda__151,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_al(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_151
tff(fact_8332_ATP_Olambda__152,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_am(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_152
tff(fact_8333_ATP_Olambda__153,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_vf(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_153
tff(fact_8334_ATP_Olambda__154,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ve(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_154
tff(fact_8335_ATP_Olambda__155,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_fs(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),sin_coeff(Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)) ) ).

% ATP.lambda_155
tff(fact_8336_ATP_Olambda__156,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ep(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),cos_coeff(Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)) ) ).

% ATP.lambda_156
tff(fact_8337_ATP_Olambda__157,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_adg(A,fun(set(A),$o),Uu),Uua)
        <=> ( topolo1002775350975398744n_open(A,Uua)
            & member(A,Uu,Uua) ) ) ) ).

% ATP.lambda_157
tff(fact_8338_ATP_Olambda__158,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_lk(nat,fun(nat,A)),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_158
tff(fact_8339_ATP_Olambda__159,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aa(num,fun(num,int),aTP_Lamp_nv(num,fun(num,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Uu)),aa(num,int,numeral_numeral(int),Uua)) ) ).

% ATP.lambda_159
tff(fact_8340_ATP_Olambda__160,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_nl(list(A),fun(list(A),$o)),Uu),Uua)
    <=> ( aa(list(A),nat,size_size(list(A)),Uu) = aa(list(A),nat,size_size(list(A)),Uua) ) ) ).

% ATP.lambda_160
tff(fact_8341_ATP_Olambda__161,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,num,aa(code_integer,fun(code_integer,num),aTP_Lamp_my(code_integer,fun(code_integer,num)),Uu),Uua)
      = $let(
          l2: num,
          l2 := code_num_of_integer(Uu),
          $let(
            l3: num,
            l3 := aa(num,num,aa(num,fun(num,num),plus_plus(num),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(num,num,aa(num,fun(num,num),plus_plus(num),l3),one2)) ) ) ) ).

% ATP.lambda_161
tff(fact_8342_ATP_Olambda__162,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,nat,aa(code_integer,fun(code_integer,nat),aTP_Lamp_lf(code_integer,fun(code_integer,nat)),Uu),Uua)
      = $let(
          l2: nat,
          l2 := aa(code_integer,nat,code_nat_of_integer,Uu),
          $let(
            l3: nat,
            l3 := aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l3),one_one(nat))) ) ) ) ).

% ATP.lambda_162
tff(fact_8343_ATP_Olambda__163,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ge(nat,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Uua)),Uu) ) ) ).

% ATP.lambda_163
tff(fact_8344_ATP_Olambda__164,axiom,
    ! [A: $tType,Uu: set(nat),Uua: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aTP_Lamp_abm(set(nat),fun(product_prod(A,nat),$o),Uu),Uua)
    <=> member(nat,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua),Uu) ) ).

% ATP.lambda_164
tff(fact_8345_ATP_Olambda__165,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aap(set(nat),fun(nat,$o),Uu),Uua)
    <=> member(nat,aa(nat,nat,suc,Uua),Uu) ) ).

% ATP.lambda_165
tff(fact_8346_ATP_Olambda__166,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_gm(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))) ) ) ).

% ATP.lambda_166
tff(fact_8347_ATP_Olambda__167,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_gr(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_167
tff(fact_8348_ATP_Olambda__168,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_gl(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_168
tff(fact_8349_ATP_Olambda__169,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ee(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(nat,nat,binomial(Uu),Uua)) ) ).

% ATP.lambda_169
tff(fact_8350_ATP_Olambda__170,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_vc(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),Uu),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))))) ) ).

% ATP.lambda_170
tff(fact_8351_ATP_Olambda__171,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ux(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or1337092689740270186AtMost(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_171
tff(fact_8352_ATP_Olambda__172,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ij(A,fun(nat,A),Uu),Uua) = aa(A,A,bit_se4730199178511100633sh_bit(A,Uua),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Uu),Uua))) ) ) ).

% ATP.lambda_172
tff(fact_8353_ATP_Olambda__173,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_uy(fun(nat,A),fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua))) ) ) ).

% ATP.lambda_173
tff(fact_8354_ATP_Olambda__174,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aa(int,fun(int,int),aTP_Lamp_afa(int,fun(int,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),aa($o,int,zero_neq_one_of_bool(int),( Uua != zero_zero(int) ))) ) ).

% ATP.lambda_174
tff(fact_8355_ATP_Olambda__175,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_uz(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uu),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua))))) ) ).

% ATP.lambda_175
tff(fact_8356_ATP_Olambda__176,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ur(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uu),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))) ) ).

% ATP.lambda_176
tff(fact_8357_ATP_Olambda__177,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_oc(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),Uu),set_ord_lessThan(nat,Uua)) ) ).

% ATP.lambda_177
tff(fact_8358_ATP_Olambda__178,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & canoni5634975068530333245id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_od(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_ord_lessThan(nat,Uua)) ) ) ).

% ATP.lambda_178
tff(fact_8359_ATP_Olambda__179,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_uh(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_179
tff(fact_8360_ATP_Olambda__180,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_abc(nat,fun(list(A),$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uu),aa(list(A),nat,size_size(list(A)),Uua)) ) ).

% ATP.lambda_180
tff(fact_8361_ATP_Olambda__181,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_hl(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_181
tff(fact_8362_ATP_Olambda__182,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_im(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_182
tff(fact_8363_ATP_Olambda__183,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_hg(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_183
tff(fact_8364_ATP_Olambda__184,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,list(nat),aa(nat,fun(nat,list(nat)),aTP_Lamp_afb(nat,fun(nat,list(nat))),Uu),Uua) = cons(nat,Uu,aa(nat,list(nat),nat_list_decode,Uua)) ) ).

% ATP.lambda_184
tff(fact_8365_ATP_Olambda__185,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_aeq(nat,fun(nat,$o)),Uu),Uua)
    <=> ( Uua = aa(nat,nat,suc,Uu) ) ) ).

% ATP.lambda_185
tff(fact_8366_ATP_Olambda__186,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_kl(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uu) ) ).

% ATP.lambda_186
tff(fact_8367_ATP_Olambda__187,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aab(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_187
tff(fact_8368_ATP_Olambda__188,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_afe(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_188
tff(fact_8369_ATP_Olambda__189,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_adz(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_189
tff(fact_8370_ATP_Olambda__190,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_afc(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_190
tff(fact_8371_ATP_Olambda__191,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ob(nat,fun(nat,nat),Uu),Uua) = modulo_modulo(nat,Uua,Uu) ) ).

% ATP.lambda_191
tff(fact_8372_ATP_Olambda__192,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_wk(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_192
tff(fact_8373_ATP_Olambda__193,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_mb(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_193
tff(fact_8374_ATP_Olambda__194,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_zo(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),Uu) ) ) ).

% ATP.lambda_194
tff(fact_8375_ATP_Olambda__195,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu) ) ).

% ATP.lambda_195
tff(fact_8376_ATP_Olambda__196,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aac(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_196
tff(fact_8377_ATP_Olambda__197,axiom,
    ! [A: $tType] :
      ( unboun7993243217541854897norder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_xt(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_197
tff(fact_8378_ATP_Olambda__198,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aff(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_198
tff(fact_8379_ATP_Olambda__199,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aea(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_199
tff(fact_8380_ATP_Olambda__200,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aef(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_200
tff(fact_8381_ATP_Olambda__201,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_afd(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_201
tff(fact_8382_ATP_Olambda__202,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_ev(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_202
tff(fact_8383_ATP_Olambda__203,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_uf(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uu) ) ).

% ATP.lambda_203
tff(fact_8384_ATP_Olambda__204,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_md(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_204
tff(fact_8385_ATP_Olambda__205,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_adw(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),minus_minus(real),Uua),Uu) ) ).

% ATP.lambda_205
tff(fact_8386_ATP_Olambda__206,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ly(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_206
tff(fact_8387_ATP_Olambda__207,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_adv(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_207
tff(fact_8388_ATP_Olambda__208,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ma(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_208
tff(fact_8389_ATP_Olambda__209,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_mc(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_209
tff(fact_8390_ATP_Olambda__210,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_oz(nat,fun(real,real),Uu),Uua) = aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uu) ) ).

% ATP.lambda_210
tff(fact_8391_ATP_Olambda__211,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_ady(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uua),Uu) ) ).

% ATP.lambda_211
tff(fact_8392_ATP_Olambda__212,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aba(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uu) ) ).

% ATP.lambda_212
tff(fact_8393_ATP_Olambda__213,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aTP_Lamp_ml(int,fun(int,int),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),Uu) ) ).

% ATP.lambda_213
tff(fact_8394_ATP_Olambda__214,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_adx(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_214
tff(fact_8395_ATP_Olambda__215,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_zp(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_215
tff(fact_8396_ATP_Olambda__216,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_lz(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_216
tff(fact_8397_ATP_Olambda__217,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_pc(real,fun(real,real),Uu),Uua) = powr(real,Uua,Uu) ) ).

% ATP.lambda_217
tff(fact_8398_ATP_Olambda__218,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_jx(nat,fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uua),Uu) ) ).

% ATP.lambda_218
tff(fact_8399_ATP_Olambda__219,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,$o,aTP_Lamp_kj(int,fun(int,$o),Uu),Uua)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uua),Uu) ) ).

% ATP.lambda_219
tff(fact_8400_ATP_Olambda__220,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_aa(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Uua),Uu) ) ) ).

% ATP.lambda_220
tff(fact_8401_ATP_Olambda__221,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_lj(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Uua),Uu) ) ).

% ATP.lambda_221
tff(fact_8402_ATP_Olambda__222,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_abb(A,fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),product_Pair(nat,A,Uua),Uu) ) ).

% ATP.lambda_222
tff(fact_8403_ATP_Olambda__223,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_cx(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(Uua),Uu) ) ).

% ATP.lambda_223
tff(fact_8404_ATP_Olambda__224,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] : ( aa(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_aay(list(A),fun(A,list(A))),Uu),Uua) = cons(A,Uua,Uu) ) ).

% ATP.lambda_224
tff(fact_8405_ATP_Olambda__225,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: int,Uua: A] : ( aa(A,A,aTP_Lamp_zz(int,fun(A,A),Uu),Uua) = power_int(A,Uua,Uu) ) ) ).

% ATP.lambda_225
tff(fact_8406_ATP_Olambda__226,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_up(real,fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),Uu) ) ).

% ATP.lambda_226
tff(fact_8407_ATP_Olambda__227,axiom,
    ! [Uu: set(extended_enat),Uua: extended_enat] :
      ( aa(extended_enat,$o,aTP_Lamp_afn(set(extended_enat),fun(extended_enat,$o),Uu),Uua)
    <=> member(extended_enat,Uua,Uu) ) ).

% ATP.lambda_227
tff(fact_8408_ATP_Olambda__228,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_acl(set(A),fun(A,$o),Uu),Uua)
        <=> member(A,Uua,Uu) ) ) ).

% ATP.lambda_228
tff(fact_8409_ATP_Olambda__229,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_a(set(A),fun(A,$o),Uu),Uua)
    <=> member(A,Uua,Uu) ) ).

% ATP.lambda_229
tff(fact_8410_ATP_Olambda__230,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] : ( aa(nat,set(product_prod(A,A)),aTP_Lamp_agt(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),Uu),Uua) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Uua),Uu) ) ).

% ATP.lambda_230
tff(fact_8411_ATP_Olambda__231,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] : ( aa(list(A),A,aTP_Lamp_abd(nat,fun(list(A),A),Uu),Uua) = aa(nat,A,nth(A,Uua),Uu) ) ).

% ATP.lambda_231
tff(fact_8412_ATP_Olambda__232,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_wd(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_232
tff(fact_8413_ATP_Olambda__233,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] :
          ( aa(A,$o,aTP_Lamp_vy(fun(A,real),fun(A,$o),Uu),Uua)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_233
tff(fact_8414_ATP_Olambda__234,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_wa(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_234
tff(fact_8415_ATP_Olambda__235,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_wj(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_235
tff(fact_8416_ATP_Olambda__236,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_agq(nat,fun(nat,set(nat)),Uu),Uua) = order_underS(nat,bNF_Ca8665028551170535155natLeq,Uu) ) ).

% ATP.lambda_236
tff(fact_8417_ATP_Olambda__237,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_fk(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))) ) ).

% ATP.lambda_237
tff(fact_8418_ATP_Olambda__238,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_fj(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)) ) ).

% ATP.lambda_238
tff(fact_8419_ATP_Olambda__239,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_xh(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),divide_divide(A),one_one(A)),Uua)) ) ) ).

% ATP.lambda_239
tff(fact_8420_ATP_Olambda__240,axiom,
    ! [A: $tType,Uu: fun(nat,$o),Uua: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aTP_Lamp_abj(fun(nat,$o),fun(product_prod(A,nat),$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua))) ) ).

% ATP.lambda_240
tff(fact_8421_ATP_Olambda__241,axiom,
    ! [Uu: fun(real,$o),Uua: real] :
      ( aa(real,$o,aTP_Lamp_yl(fun(real,$o),fun(real,$o),Uu),Uua)
    <=> aa(real,$o,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_241
tff(fact_8422_ATP_Olambda__242,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real] : ( aa(real,A,aTP_Lamp_yk(fun(real,A),fun(real,A),Uu),Uua) = aa(real,A,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_242
tff(fact_8423_ATP_Olambda__243,axiom,
    ! [A: $tType,Uu: fun(nat,$o),Uua: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aTP_Lamp_abk(fun(nat,$o),fun(product_prod(A,nat),$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua)) ) ).

% ATP.lambda_243
tff(fact_8424_ATP_Olambda__244,axiom,
    ! [Uu: fun(nat,$o),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_vn(fun(nat,$o),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_244
tff(fact_8425_ATP_Olambda__245,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bc(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_245
tff(fact_8426_ATP_Olambda__246,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_uc(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_246
tff(fact_8427_ATP_Olambda__247,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bv(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_247
tff(fact_8428_ATP_Olambda__248,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_gu(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_248
tff(fact_8429_ATP_Olambda__249,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ct(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_249
tff(fact_8430_ATP_Olambda__250,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_vl(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_250
tff(fact_8431_ATP_Olambda__251,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_ms(nat,fun(num,option(num)),Uu),Uua) = some(num,case_option(num,num,one2,bit1,bit_take_bit_num(Uu,Uua))) ) ).

% ATP.lambda_251
tff(fact_8432_ATP_Olambda__252,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_mp(num,fun(nat,option(num)),Uu),Uua) = some(num,case_option(num,num,one2,bit1,bit_take_bit_num(Uua,Uu))) ) ).

% ATP.lambda_252
tff(fact_8433_ATP_Olambda__253,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_nz(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_ny(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_253
tff(fact_8434_ATP_Olambda__254,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ls(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_lr(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_254
tff(fact_8435_ATP_Olambda__255,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_lq(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_lp(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_255
tff(fact_8436_ATP_Olambda__256,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_lo(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_ln(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_256
tff(fact_8437_ATP_Olambda__257,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_lm(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_ll(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_257
tff(fact_8438_ATP_Olambda__258,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_li(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_lh(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_258
tff(fact_8439_ATP_Olambda__259,axiom,
    ! [Uu: fun(nat,real),Uua: real] : ( aa(real,real,aTP_Lamp_pl(fun(nat,real),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),aTP_Lamp_pk(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua)) ) ).

% ATP.lambda_259
tff(fact_8440_ATP_Olambda__260,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A] : ( aa(A,A,aTP_Lamp_pa(fun(nat,A),fun(A,A),Uu),Uua) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua)) ) ) ).

% ATP.lambda_260
tff(fact_8441_ATP_Olambda__261,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A] : ( aa(A,set(A),aTP_Lamp_yb(real,fun(A,set(A)),Uu),Uua) = collect(A,aa(A,fun(A,$o),aTP_Lamp_ya(real,fun(A,fun(A,$o)),Uu),Uua)) ) ) ).

% ATP.lambda_261
tff(fact_8442_ATP_Olambda__262,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,complex,aTP_Lamp_fv(nat,fun(nat,complex),Uu),Uua) = cis(aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi)),aa(nat,real,semiring_1_of_nat(real),Uua))),aa(nat,real,semiring_1_of_nat(real),Uu))) ) ).

% ATP.lambda_262
tff(fact_8443_ATP_Olambda__263,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_qj(A,fun(A,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Uu)),Uua)),aa(A,A,inverse_inverse(A),Uu))) ) ) ).

% ATP.lambda_263
tff(fact_8444_ATP_Olambda__264,axiom,
    ! [Uu: fun(real,real),Uua: real] :
      ( aa(real,$o,aTP_Lamp_wn(fun(real,real),fun(real,$o),Uu),Uua)
    <=> ( aa(real,real,Uu,Uua) != zero_zero(real) ) ) ).

% ATP.lambda_264
tff(fact_8445_ATP_Olambda__265,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: fun(A,real),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aco(fun(A,real),fun(A,$o),Uu),Uua)
        <=> ( aa(A,real,Uu,Uua) != zero_zero(real) ) ) ) ).

% ATP.lambda_265
tff(fact_8446_ATP_Olambda__266,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_bq(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_266
tff(fact_8447_ATP_Olambda__267,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ae(nat,fun(nat,$o),Uu),Uua)
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))) ) ).

% ATP.lambda_267
tff(fact_8448_ATP_Olambda__268,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_by(A,fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uu)),Uua))) ) ) ).

% ATP.lambda_268
tff(fact_8449_ATP_Olambda__269,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_bm(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,sin_coeff(Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_269
tff(fact_8450_ATP_Olambda__270,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_bn(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,cos_coeff(Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_270
tff(fact_8451_ATP_Olambda__271,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat] : ( aa(nat,set(A),aTP_Lamp_of(fun(nat,set(A)),fun(nat,set(A)),Uu),Uua) = complete_Sup_Sup(set(A),image(nat,set(A),Uu,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua))) ) ).

% ATP.lambda_271
tff(fact_8452_ATP_Olambda__272,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_ag(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_272
tff(fact_8453_ATP_Olambda__273,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_af(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_273
tff(fact_8454_ATP_Olambda__274,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_aak(nat,fun(nat,set(nat)),Uu),Uua) = set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua)) ) ).

% ATP.lambda_274
tff(fact_8455_ATP_Olambda__275,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_uw(real,fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)) ) ).

% ATP.lambda_275
tff(fact_8456_ATP_Olambda__276,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ow(A,fun(A,A),Uu),Uua) = cos(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)) ) ) ).

% ATP.lambda_276
tff(fact_8457_ATP_Olambda__277,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_afl(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uua)) ) ).

% ATP.lambda_277
tff(fact_8458_ATP_Olambda__278,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_afq(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua)) ) ).

% ATP.lambda_278
tff(fact_8459_ATP_Olambda__279,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,extended_enat,aTP_Lamp_afo(nat,fun(nat,extended_enat),Uu),Uua) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)) ) ).

% ATP.lambda_279
tff(fact_8460_ATP_Olambda__280,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: A] : ( aa(A,filter(A),aTP_Lamp_adc(A,fun(A,filter(A)),Uu),Uua) = principal(A,set_or5935395276787703475ssThan(A,Uu,Uua)) ) ) ).

% ATP.lambda_280
tff(fact_8461_ATP_Olambda__281,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: A] : ( aa(A,filter(A),aTP_Lamp_adb(A,fun(A,filter(A)),Uu),Uua) = principal(A,set_or5935395276787703475ssThan(A,Uua,Uu)) ) ) ).

% ATP.lambda_281
tff(fact_8462_ATP_Olambda__282,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_na(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uu),Uua)) ) ).

% ATP.lambda_282
tff(fact_8463_ATP_Olambda__283,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_mz(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uua),Uu)) ) ).

% ATP.lambda_283
tff(fact_8464_ATP_Olambda__284,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_it(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uu),Uua)) ) ).

% ATP.lambda_284
tff(fact_8465_ATP_Olambda__285,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_iu(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uua),Uu)) ) ).

% ATP.lambda_285
tff(fact_8466_ATP_Olambda__286,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aTP_Lamp_abf(A,fun(A,$o),Uu),Uua)
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_286
tff(fact_8467_ATP_Olambda__287,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_dg(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_287
tff(fact_8468_ATP_Olambda__288,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_sy(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_288
tff(fact_8469_ATP_Olambda__289,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_un(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_289
tff(fact_8470_ATP_Olambda__290,axiom,
    ! [Uu: fun(nat,rat),Uua: nat] : ( aa(nat,rat,aTP_Lamp_acc(fun(nat,rat),fun(nat,rat),Uu),Uua) = aa(rat,rat,inverse_inverse(rat),aa(nat,rat,Uu,Uua)) ) ).

% ATP.lambda_290
tff(fact_8471_ATP_Olambda__291,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_qk(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_291
tff(fact_8472_ATP_Olambda__292,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_yq(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_292
tff(fact_8473_ATP_Olambda__293,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_yu(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_293
tff(fact_8474_ATP_Olambda__294,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_on(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_294
tff(fact_8475_ATP_Olambda__295,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_rm(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_295
tff(fact_8476_ATP_Olambda__296,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ws(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_296
tff(fact_8477_ATP_Olambda__297,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_sw(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_297
tff(fact_8478_ATP_Olambda__298,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_gp(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_298
tff(fact_8479_ATP_Olambda__299,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_cr(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_299
tff(fact_8480_ATP_Olambda__300,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,int,aTP_Lamp_et(fun(A,nat),fun(A,int),Uu),Uua) = aa(nat,int,semiring_1_of_nat(int),aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_300
tff(fact_8481_ATP_Olambda__301,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_qo(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_301
tff(fact_8482_ATP_Olambda__302,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_yr(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_302
tff(fact_8483_ATP_Olambda__303,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tr(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_303
tff(fact_8484_ATP_Olambda__304,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_kd(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_304
tff(fact_8485_ATP_Olambda__305,axiom,
    ! [Uu: fun(nat,rat),Uua: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_abw(fun(nat,rat),fun(nat,rat)),Uu),Uua) = aa(rat,rat,uminus_uminus(rat),aa(nat,rat,Uu,Uua)) ) ).

% ATP.lambda_305
tff(fact_8486_ATP_Olambda__306,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_hd(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_306
tff(fact_8487_ATP_Olambda__307,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_gq(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_307
tff(fact_8488_ATP_Olambda__308,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_cs(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_308
tff(fact_8489_ATP_Olambda__309,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_gb(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_309
tff(fact_8490_ATP_Olambda__310,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_zk(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,artanh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_310
tff(fact_8491_ATP_Olambda__311,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_xq(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_311
tff(fact_8492_ATP_Olambda__312,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ti(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_312
tff(fact_8493_ATP_Olambda__313,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ra(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_313
tff(fact_8494_ATP_Olambda__314,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_pv(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_314
tff(fact_8495_ATP_Olambda__315,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_zj(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_315
tff(fact_8496_ATP_Olambda__316,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_zf(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,arcosh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_316
tff(fact_8497_ATP_Olambda__317,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_vz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_317
tff(fact_8498_ATP_Olambda__318,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_sn(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_318
tff(fact_8499_ATP_Olambda__319,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_px(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_319
tff(fact_8500_ATP_Olambda__320,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_zi(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_320
tff(fact_8501_ATP_Olambda__321,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_yt(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_321
tff(fact_8502_ATP_Olambda__322,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_rn(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_322
tff(fact_8503_ATP_Olambda__323,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_sz(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_323
tff(fact_8504_ATP_Olambda__324,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_em(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,abs_abs(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_324
tff(fact_8505_ATP_Olambda__325,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_su(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_325
tff(fact_8506_ATP_Olambda__326,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ze(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_326
tff(fact_8507_ATP_Olambda__327,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_rq(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_327
tff(fact_8508_ATP_Olambda__328,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_pi(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tanh(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_328
tff(fact_8509_ATP_Olambda__329,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_sv(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_329
tff(fact_8510_ATP_Olambda__330,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_rc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,tan(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_330
tff(fact_8511_ATP_Olambda__331,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_ro(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tan(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_331
tff(fact_8512_ATP_Olambda__332,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_rp(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,cot(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_332
tff(fact_8513_ATP_Olambda__333,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_vi(fun(nat,real),fun(nat,real),Uu),Uua) = cos(real,aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_333
tff(fact_8514_ATP_Olambda__334,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: real] : ( aa(real,real,aTP_Lamp_ph(fun(real,fun(nat,real)),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),Uu,Uua)) ) ).

% ATP.lambda_334
tff(fact_8515_ATP_Olambda__335,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [Uu: fun(A,fun(nat,B)),Uua: A] : ( aa(A,B,aTP_Lamp_tv(fun(A,fun(nat,B)),fun(A,B),Uu),Uua) = suminf(B,aa(A,fun(nat,B),Uu,Uua)) ) ) ).

% ATP.lambda_335
tff(fact_8516_ATP_Olambda__336,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_qy(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_336
tff(fact_8517_ATP_Olambda__337,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_yz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_337
tff(fact_8518_ATP_Olambda__338,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_sc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_338
tff(fact_8519_ATP_Olambda__339,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tg(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_339
tff(fact_8520_ATP_Olambda__340,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,nat,aTP_Lamp_kq(fun(A,nat),fun(A,nat),Uu),Uua) = aa(nat,nat,suc,aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_340
tff(fact_8521_ATP_Olambda__341,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A] :
      ( aa(A,$o,aTP_Lamp_cv(fun(A,$o),fun(A,$o),Uu),Uua)
    <=> ~ aa(A,$o,Uu,Uua) ) ).

% ATP.lambda_341
tff(fact_8522_ATP_Olambda__342,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_agn(nat,fun(nat,set(nat)),Uu),Uua) = collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ej(nat,fun(nat,$o)),Uu)) ) ).

% ATP.lambda_342
tff(fact_8523_ATP_Olambda__343,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real] : ( aa(real,filter(A),aTP_Lamp_ade(A,fun(real,filter(A)),Uu),Uua) = principal(A,collect(A,aa(real,fun(A,$o),aTP_Lamp_add(A,fun(real,fun(A,$o)),Uu),Uua))) ) ) ).

% ATP.lambda_343
tff(fact_8524_ATP_Olambda__344,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(real,A),Uua: real] : ( aa(real,real,aTP_Lamp_rs(fun(real,A),fun(real,real),Uu),Uua) = aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(A,aa(real,A,Uu,Uua))) ) ) ).

% ATP.lambda_344
tff(fact_8525_ATP_Olambda__345,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aek(set(A),fun(A,$o),Uu),Uua)
        <=> ? [F5: fun(A,real)] :
              ( ( Uua = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),F5)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F5))) )
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F5))),Uu)
              & aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F5))) ) ) ) ).

% ATP.lambda_345
tff(fact_8526_ATP_Olambda__346,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aeh(set(A),fun(A,$o),Uu),Uua)
        <=> ? [F5: fun(A,real)] :
              ( ( Uua = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),F5)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F5))) )
              & aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),F5)))
              & ! [V5: A] :
                  ( ( aa(A,real,F5,V5) != zero_zero(real) )
                 => member(A,V5,Uu) ) ) ) ) ).

% ATP.lambda_346
tff(fact_8527_ATP_Olambda__347,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_ne(list(A),fun(A,$o),Uu),Uua)
    <=> ? [I: nat] :
          ( ( Uua = aa(nat,A,nth(A,Uu),I) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Uu)) ) ) ).

% ATP.lambda_347
tff(fact_8528_ATP_Olambda__348,axiom,
    ! [Uu: set(real),Uua: real] :
      ( aa(real,$o,aTP_Lamp_acm(set(real),fun(real,$o),Uu),Uua)
    <=> ! [X5: real] :
          ( member(real,X5,Uu)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X5),Uua) ) ) ).

% ATP.lambda_348
tff(fact_8529_ATP_Olambda__349,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_agd(set(nat),fun(nat,$o),Uu),Uua)
    <=> ! [X5: nat] :
          ( member(nat,X5,Uu)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uua),X5) ) ) ).

% ATP.lambda_349
tff(fact_8530_ATP_Olambda__350,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_agf(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X5: A] :
              ( member(A,X5,Uu)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Uua),X5) ) ) ) ).

% ATP.lambda_350
tff(fact_8531_ATP_Olambda__351,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_agg(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X5: A] :
              ( member(A,X5,Uu)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X5),Uua) ) ) ) ).

% ATP.lambda_351
tff(fact_8532_ATP_Olambda__352,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_aaj(nat,fun(nat,set(nat)),Uu),Uua) = set_ord_atMost(nat,Uu) ) ).

% ATP.lambda_352
tff(fact_8533_ATP_Olambda__353,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,rat,aTP_Lamp_acg(nat,fun(nat,rat),Uu),Uua) = aa(nat,rat,semiring_1_of_nat(rat),Uu) ) ).

% ATP.lambda_353
tff(fact_8534_ATP_Olambda__354,axiom,
    ! [Uu: int,Uua: nat] : ( aa(nat,rat,aTP_Lamp_acf(int,fun(nat,rat),Uu),Uua) = aa(int,rat,ring_1_of_int(rat),Uu) ) ).

% ATP.lambda_354
tff(fact_8535_ATP_Olambda__355,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] :
      ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_cc(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub),aa(nat,real,Uua,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),one_one(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ).

% ATP.lambda_355
tff(fact_8536_ATP_Olambda__356,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] :
      ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_fi(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub),aa(nat,real,Uu,Uub),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_356
tff(fact_8537_ATP_Olambda__357,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_ip(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_357
tff(fact_8538_ATP_Olambda__358,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] :
      ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_hm(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_358
tff(fact_8539_ATP_Olambda__359,axiom,
    ! [Uu: num,Uua: int,Uub: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_hn(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_359
tff(fact_8540_ATP_Olambda__360,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: num,Uua: A,Uub: A] :
          ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_hq(num,fun(A,fun(A,product_prod(A,A))),Uu),Uua),Uub)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Uu)),Uub),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(num,A,numeral_numeral(A),Uu))),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_360
tff(fact_8541_ATP_Olambda__361,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: set(nat),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_jj(set(nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(member(nat,Uub,Uu),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_361
tff(fact_8542_ATP_Olambda__362,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: set(A),Uub: A] :
          ( aa(A,B,aa(set(A),fun(A,B),aTP_Lamp_acp(fun(A,B),fun(set(A),fun(A,B)),Uu),Uua),Uub)
          = $ite(member(A,Uub,Uua),aa(A,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_362
tff(fact_8543_ATP_Olambda__363,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: set(A),Uub: A] :
          ( aa(A,B,aa(set(A),fun(A,B),aTP_Lamp_acq(fun(A,B),fun(set(A),fun(A,B)),Uu),Uua),Uub)
          = $ite(member(A,Uub,Uua),aa(A,B,Uu,Uub),one_one(B)) ) ) ).

% ATP.lambda_363
tff(fact_8544_ATP_Olambda__364,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_jf(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(A,B,Uua,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_364
tff(fact_8545_ATP_Olambda__365,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_jh(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(A,B,Uua,Uub),one_one(B)) ) ) ).

% ATP.lambda_365
tff(fact_8546_ATP_Olambda__366,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_au(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_366
tff(fact_8547_ATP_Olambda__367,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_je(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(A,B,Uua,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_367
tff(fact_8548_ATP_Olambda__368,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_jg(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(A,B,Uua,Uub),one_one(B)) ) ) ).

% ATP.lambda_368
tff(fact_8549_ATP_Olambda__369,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_jc(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_369
tff(fact_8550_ATP_Olambda__370,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_la(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_370
tff(fact_8551_ATP_Olambda__371,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_jb(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_371
tff(fact_8552_ATP_Olambda__372,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,$o),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ji(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(aa(nat,$o,Uu,Uub),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_372
tff(fact_8553_ATP_Olambda__373,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,$o),Uub: B] :
          ( aa(B,A,aa(fun(B,$o),fun(B,A),aTP_Lamp_abe(fun(B,A),fun(fun(B,$o),fun(B,A)),Uu),Uua),Uub)
          = $ite(aa(B,$o,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_373
tff(fact_8554_ATP_Olambda__374,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_jt(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(A,$o,Uua,Uub),aa(A,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_374
tff(fact_8555_ATP_Olambda__375,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_ju(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(A,$o,Uua,Uub),aa(A,B,Uu,Uub),one_one(B)) ) ) ).

% ATP.lambda_375
tff(fact_8556_ATP_Olambda__376,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] :
      ( aa(real,$o,aa(fun(real,real),fun(real,$o),aTP_Lamp_wo(fun(real,real),fun(fun(real,real),fun(real,$o)),Uu),Uua),Uub)
    <=> has_field_derivative(real,Uu,aa(real,real,Uua,Uub),topolo174197925503356063within(real,Uub,top_top(set(real)))) ) ).

% ATP.lambda_376
tff(fact_8557_ATP_Olambda__377,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_zx(fun(A,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uub),Uu),Uua) ) ).

% ATP.lambda_377
tff(fact_8558_ATP_Olambda__378,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hv(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_378
tff(fact_8559_ATP_Olambda__379,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hy(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_379
tff(fact_8560_ATP_Olambda__380,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_pg(fun(real,fun(nat,real)),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),Uu,Uub),Uua) ) ).

% ATP.lambda_380
tff(fact_8561_ATP_Olambda__381,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hb(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_381
tff(fact_8562_ATP_Olambda__382,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_fz(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_382
tff(fact_8563_ATP_Olambda__383,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_tj(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_383
tff(fact_8564_ATP_Olambda__384,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_sh(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_384
tff(fact_8565_ATP_Olambda__385,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_qs(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_385
tff(fact_8566_ATP_Olambda__386,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_el(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ek(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_386
tff(fact_8567_ATP_Olambda__387,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_di(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_dh(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_387
tff(fact_8568_ATP_Olambda__388,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cq(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_cp(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_388
tff(fact_8569_ATP_Olambda__389,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_co(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_cn(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_389
tff(fact_8570_ATP_Olambda__390,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: A,Uub: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bx(nat,fun(A,fun(nat,A)),Uu),Uua),Uub)
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),$ite(Uub = Uu,one_one(A),zero_zero(A))),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_390
tff(fact_8571_ATP_Olambda__391,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,$o),aa(code_integer,fun(code_integer,product_prod(code_integer,$o)),aTP_Lamp_ja(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),Uu),Uua),Uub)
      = aa($o,product_prod(code_integer,$o),
          product_Pair(code_integer,$o,$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),
          ( Uub = one_one(code_integer) )) ) ).

% ATP.lambda_391
tff(fact_8572_ATP_Olambda__392,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_aep(set(A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(A,real,real_V7696804695334737415tation(A,Uu,Uua),Uub)),Uub) ) ) ).

% ATP.lambda_392
tff(fact_8573_ATP_Olambda__393,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hb(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_393
tff(fact_8574_ATP_Olambda__394,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ga(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_fz(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_394
tff(fact_8575_ATP_Olambda__395,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_rr(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_395
tff(fact_8576_ATP_Olambda__396,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_nn(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,product_case_prod(int,int,$o,aa(int,fun(int,fun(int,$o)),aTP_Lamp_nm(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_396
tff(fact_8577_ATP_Olambda__397,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_iz(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_iy(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_397
tff(fact_8578_ATP_Olambda__398,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_qt(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(B,fun(A,C),aTP_Lamp_qs(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_398
tff(fact_8579_ATP_Olambda__399,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_pm(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uub),zero_zero(real))),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uub)) ) ).

% ATP.lambda_399
tff(fact_8580_ATP_Olambda__400,axiom,
    ! [Uu: real,Uua: fun(nat,fun(real,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_pn(real,fun(fun(nat,fun(real,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uua,Uub),zero_zero(real))),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ).

% ATP.lambda_400
tff(fact_8581_ATP_Olambda__401,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [Uu: real,Uua: fun(nat,fun(A,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_fg(real,fun(fun(nat,fun(A,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(A,real,aa(nat,fun(A,real),Uua,Uub),zero_zero(A))),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ) ).

% ATP.lambda_401
tff(fact_8582_ATP_Olambda__402,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] :
          ( aa(A,$o,aa(nat,fun(A,$o),aTP_Lamp_ke(fun(nat,A),fun(nat,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),set_ord_atMost(nat,Uua)) = zero_zero(A) ) ) ) ).

% ATP.lambda_402
tff(fact_8583_ATP_Olambda__403,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ts(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua))),Uub) ) ) ).

% ATP.lambda_403
tff(fact_8584_ATP_Olambda__404,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_tn(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua))),Uub) ) ) ).

% ATP.lambda_404
tff(fact_8585_ATP_Olambda__405,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_jd(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uub))),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_405
tff(fact_8586_ATP_Olambda__406,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_sd(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_406
tff(fact_8587_ATP_Olambda__407,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_to(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_407
tff(fact_8588_ATP_Olambda__408,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_pj(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uub)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uub)) ) ).

% ATP.lambda_408
tff(fact_8589_ATP_Olambda__409,axiom,
    ! [Uu: real,Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_fh(real,fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,Uua,Uub)),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ).

% ATP.lambda_409
tff(fact_8590_ATP_Olambda__410,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_ng(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),one_one(nat)) )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_410
tff(fact_8591_ATP_Olambda__411,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),aa(nat,A,Uu,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat))))) ) ) ).

% ATP.lambda_411
tff(fact_8592_ATP_Olambda__412,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_nr(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(list(A),nat,size_size(list(A)),Uua)),aa(list(A),nat,size_size(list(A)),Uub))
        | ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
          & member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),product_Pair(list(A),list(A),Uua),Uub),lex(A,Uu)) ) ) ) ).

% ATP.lambda_412
tff(fact_8593_ATP_Olambda__413,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_aaq(set(product_prod(A,A)),fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uua) = aa(list(A),nat,size_size(list(A)),Uub) )
        & ? [Xys: list(A),X5: A,Y5: A,Xs5: list(A),Ys6: list(A)] :
            ( ( Uua = append(A,Xys,cons(A,X5,Xs5)) )
            & ( Uub = append(A,Xys,cons(A,Y5,Ys6)) )
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X5),Y5),Uu) ) ) ) ).

% ATP.lambda_413
tff(fact_8594_ATP_Olambda__414,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_nh(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub)),one_one(nat)) = Uua ) ) ) ).

% ATP.lambda_414
tff(fact_8595_ATP_Olambda__415,axiom,
    ! [A: $tType,Uu: nat,Uua: set(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(set(A),fun(list(A),$o),aTP_Lamp_ku(nat,fun(set(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & distinct(A,Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uua) ) ) ).

% ATP.lambda_415
tff(fact_8596_ATP_Olambda__416,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_kt(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & distinct(A,Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu) ) ) ).

% ATP.lambda_416
tff(fact_8597_ATP_Olambda__417,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_aeb(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & ( aa(list(A),nat,size_size(list(A)),Uub) = aa(nat,nat,suc,Uua) ) ) ) ).

% ATP.lambda_417
tff(fact_8598_ATP_Olambda__418,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_ht(nat,fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),aa(list(A),set(A),set2(A),Uua)) ) ) ).

% ATP.lambda_418
tff(fact_8599_ATP_Olambda__419,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_jn(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Uub)),Uua) ) ) ).

% ATP.lambda_419
tff(fact_8600_ATP_Olambda__420,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_jm(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & ( aa(list(A),nat,size_size(list(A)),Uub) = Uua ) ) ) ).

% ATP.lambda_420
tff(fact_8601_ATP_Olambda__421,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_nf(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_421
tff(fact_8602_ATP_Olambda__422,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_pd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,diffs(A,Uu)),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_422
tff(fact_8603_ATP_Olambda__423,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ko(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( member(nat,aa(nat,nat,suc,Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_423
tff(fact_8604_ATP_Olambda__424,axiom,
    ! [A: $tType,Uu: set(nat),Uua: nat,Uub: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aa(nat,fun(product_prod(A,nat),$o),aTP_Lamp_abn(set(nat),fun(nat,fun(product_prod(A,nat),$o)),Uu),Uua),Uub)
    <=> member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(product_prod(A,nat),nat,product_snd(A,nat),Uub)),Uua),Uu) ) ).

% ATP.lambda_424
tff(fact_8605_ATP_Olambda__425,axiom,
    ! [Uu: nat,Uua: nat,Uub: set(nat)] :
      ( aa(set(nat),$o,aa(nat,fun(set(nat),$o),aTP_Lamp_nb(nat,fun(nat,fun(set(nat),$o)),Uu),Uua),Uub)
    <=> ( member(set(nat),Uub,pow2(nat,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uu)))
        & ( aa(set(nat),nat,finite_card(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_425
tff(fact_8606_ATP_Olambda__426,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_no(list(A),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu))
        & member(nat,Uub,Uua) ) ) ).

% ATP.lambda_426
tff(fact_8607_ATP_Olambda__427,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: list(A),Uub: nat] :
      ( aa(nat,$o,aa(list(A),fun(nat,$o),aTP_Lamp_abg(fun(A,$o),fun(list(A),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(list(A),nat,size_size(list(A)),Uua))
        & aa(A,$o,Uu,aa(nat,A,nth(A,Uua),Uub)) ) ) ).

% ATP.lambda_427
tff(fact_8608_ATP_Olambda__428,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_il(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_428
tff(fact_8609_ATP_Olambda__429,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_aao(list(A),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu)),Uua) ) ).

% ATP.lambda_429
tff(fact_8610_ATP_Olambda__430,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ago(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uub) ) ) ).

% ATP.lambda_430
tff(fact_8611_ATP_Olambda__431,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: nat,Uub: A] :
          ( aa(A,$o,aa(nat,fun(A,$o),aTP_Lamp_ack(set(A),fun(nat,fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,Uu,Uua)),Uub) ) ) ) ).

% ATP.lambda_431
tff(fact_8612_ATP_Olambda__432,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_kp(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( member(nat,Uub,Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_432
tff(fact_8613_ATP_Olambda__433,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cg(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_433
tff(fact_8614_ATP_Olambda__434,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cj(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_434
tff(fact_8615_ATP_Olambda__435,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ck(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uua),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uub)) ) ) ).

% ATP.lambda_435
tff(fact_8616_ATP_Olambda__436,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_dd(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub)) ) ).

% ATP.lambda_436
tff(fact_8617_ATP_Olambda__437,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_nq(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uua)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_437
tff(fact_8618_ATP_Olambda__438,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_kf(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_438
tff(fact_8619_ATP_Olambda__439,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_np(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_439
tff(fact_8620_ATP_Olambda__440,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_kh(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_440
tff(fact_8621_ATP_Olambda__441,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_ki(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_441
tff(fact_8622_ATP_Olambda__442,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_kg(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_442
tff(fact_8623_ATP_Olambda__443,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),aTP_Lamp_agr(set(A),fun(set(A),fun(set(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),Uua),Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uub),Uu) ) ) ).

% ATP.lambda_443
tff(fact_8624_ATP_Olambda__444,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_abv(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uu) ) ) ).

% ATP.lambda_444
tff(fact_8625_ATP_Olambda__445,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_acb(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uua)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uu) ) ) ).

% ATP.lambda_445
tff(fact_8626_ATP_Olambda__446,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: A] :
          ( aa(A,$o,aa(fun(A,real),fun(A,$o),aTP_Lamp_act(set(A),fun(fun(A,real),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,Uua,Uub)) ) ) ) ).

% ATP.lambda_446
tff(fact_8627_ATP_Olambda__447,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_js(set(A),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( member(A,Uub,Uu)
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_447
tff(fact_8628_ATP_Olambda__448,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_jo(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_448
tff(fact_8629_ATP_Olambda__449,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_kx(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_449
tff(fact_8630_ATP_Olambda__450,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_jq(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ( aa(A,B,Uua,Uub) != one_one(B) ) ) ) ) ).

% ATP.lambda_450
tff(fact_8631_ATP_Olambda__451,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ky(fun(B,A),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( member(B,Uub,Uua)
            & ( aa(B,A,Uu,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_451
tff(fact_8632_ATP_Olambda__452,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_lv(fun(B,A),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( member(B,Uub,Uua)
            & ( aa(B,A,Uu,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_452
tff(fact_8633_ATP_Olambda__453,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_parity(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_kk(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(A,B,Uua,Uub)) ) ) ) ).

% ATP.lambda_453
tff(fact_8634_ATP_Olambda__454,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ad(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( member(A,Uub,Uu)
        & ~ member(A,Uub,Uua) ) ) ).

% ATP.lambda_454
tff(fact_8635_ATP_Olambda__455,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_abu(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uu) ) ).

% ATP.lambda_455
tff(fact_8636_ATP_Olambda__456,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_hu(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_456
tff(fact_8637_ATP_Olambda__457,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_xs(A,fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_457
tff(fact_8638_ATP_Olambda__458,axiom,
    ! [Uu: real,Uua: complex,Uub: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aTP_Lamp_adj(real,fun(complex,fun(complex,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(complex,Uua,Uub)),Uu) ) ).

% ATP.lambda_458
tff(fact_8639_ATP_Olambda__459,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_adl(real,fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(real,Uua,Uub)),Uu) ) ).

% ATP.lambda_459
tff(fact_8640_ATP_Olambda__460,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_adh(real,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_460
tff(fact_8641_ATP_Olambda__461,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ya(real,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_461
tff(fact_8642_ATP_Olambda__462,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_add(A,fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_462
tff(fact_8643_ATP_Olambda__463,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_hx(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_463
tff(fact_8644_ATP_Olambda__464,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_mh(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_464
tff(fact_8645_ATP_Olambda__465,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_mf(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_465
tff(fact_8646_ATP_Olambda__466,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_mg(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),Uub),Uu)),Uua) ) ) ).

% ATP.lambda_466
tff(fact_8647_ATP_Olambda__467,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_me(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_467
tff(fact_8648_ATP_Olambda__468,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_nj(set(product_prod(A,B)),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Uua),Uub),Uu) ) ).

% ATP.lambda_468
tff(fact_8649_ATP_Olambda__469,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aaw(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Uu),Uub)),Uua) ) ).

% ATP.lambda_469
tff(fact_8650_ATP_Olambda__470,axiom,
    ! [Uu: nat,Uua: complex,Uub: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aTP_Lamp_fa(nat,fun(complex,fun(complex,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Uub),Uu) = Uua ) ) ).

% ATP.lambda_470
tff(fact_8651_ATP_Olambda__471,axiom,
    ! [Uu: complex,Uua: nat,Uub: complex] :
      ( aa(complex,$o,aa(nat,fun(complex,$o),aTP_Lamp_at(complex,fun(nat,fun(complex,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Uub),Uua) = Uu ) ) ).

% ATP.lambda_471
tff(fact_8652_ATP_Olambda__472,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bh(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_472
tff(fact_8653_ATP_Olambda__473,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bj(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_473
tff(fact_8654_ATP_Olambda__474,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,int),Uub: nat] : ( aa(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_vh(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),aa(nat,int,Uua,Uub))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2))),pi))) ) ).

% ATP.lambda_474
tff(fact_8655_ATP_Olambda__475,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_pk(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),aa(nat,nat,suc,Uub))) ) ).

% ATP.lambda_475
tff(fact_8656_ATP_Olambda__476,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_bo(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uub)) ) ).

% ATP.lambda_476
tff(fact_8657_ATP_Olambda__477,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_dp(fun(nat,nat),fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uua),Uub)) ) ).

% ATP.lambda_477
tff(fact_8658_ATP_Olambda__478,axiom,
    ! [B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(nat,B),Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_rt(fun(nat,B),fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uub)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),Uub)) ) ) ).

% ATP.lambda_478
tff(fact_8659_ATP_Olambda__479,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_479
tff(fact_8660_ATP_Olambda__480,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_480
tff(fact_8661_ATP_Olambda__481,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_bi(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_481
tff(fact_8662_ATP_Olambda__482,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_482
tff(fact_8663_ATP_Olambda__483,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_db(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_483
tff(fact_8664_ATP_Olambda__484,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_dk(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_484
tff(fact_8665_ATP_Olambda__485,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_jl(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,Uu,Uub)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_485
tff(fact_8666_ATP_Olambda__486,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,real),Uua: fun(real,A),Uub: real] : ( aa(real,A,aa(fun(real,A),fun(real,A),aTP_Lamp_aft(fun(real,real),fun(fun(real,A),fun(real,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,Uu,Uub)),aa(real,A,Uua,Uub)) ) ) ).

% ATP.lambda_486
tff(fact_8667_ATP_Olambda__487,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_pz(fun(A,real),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_487
tff(fact_8668_ATP_Olambda__488,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xb(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,Uu,Uub)),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_488
tff(fact_8669_ATP_Olambda__489,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_gt(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_489
tff(fact_8670_ATP_Olambda__490,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_490
tff(fact_8671_ATP_Olambda__491,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qh(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_491
tff(fact_8672_ATP_Olambda__492,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_zb(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_492
tff(fact_8673_ATP_Olambda__493,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_oo(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_493
tff(fact_8674_ATP_Olambda__494,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rk(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_494
tff(fact_8675_ATP_Olambda__495,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wr(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_495
tff(fact_8676_ATP_Olambda__496,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_wy(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_496
tff(fact_8677_ATP_Olambda__497,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_st(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_497
tff(fact_8678_ATP_Olambda__498,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_wp(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,Uua,Uub)),aa(real,real,Uu,Uub)) ) ).

% ATP.lambda_498
tff(fact_8679_ATP_Olambda__499,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_zd(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_499
tff(fact_8680_ATP_Olambda__500,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(real,A),Uua: fun(real,A),Uub: real] : ( aa(real,A,aa(fun(real,A),fun(real,A),aTP_Lamp_agb(fun(real,A),fun(fun(real,A),fun(real,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(real,A,Uu,Uub)),aa(real,A,Uua,Uub)) ) ) ).

% ATP.lambda_500
tff(fact_8681_ATP_Olambda__501,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abz(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),aa(nat,rat,Uu,Uub)),aa(nat,rat,Uua,Uub)) ) ).

% ATP.lambda_501
tff(fact_8682_ATP_Olambda__502,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_io(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_502
tff(fact_8683_ATP_Olambda__503,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_in(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_503
tff(fact_8684_ATP_Olambda__504,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qf(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_504
tff(fact_8685_ATP_Olambda__505,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_ot(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_505
tff(fact_8686_ATP_Olambda__506,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wu(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_506
tff(fact_8687_ATP_Olambda__507,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_td(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_507
tff(fact_8688_ATP_Olambda__508,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ww(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_508
tff(fact_8689_ATP_Olambda__509,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ta(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_509
tff(fact_8690_ATP_Olambda__510,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_lw(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_510
tff(fact_8691_ATP_Olambda__511,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wt(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_511
tff(fact_8692_ATP_Olambda__512,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_en(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_512
tff(fact_8693_ATP_Olambda__513,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,A),Uua: fun(real,A),Uub: real] : ( aa(real,A,aa(fun(real,A),fun(real,A),aTP_Lamp_afz(fun(real,A),fun(fun(real,A),fun(real,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(real,A,Uu,Uub)),aa(real,A,Uua,Uub)) ) ) ).

% ATP.lambda_513
tff(fact_8694_ATP_Olambda__514,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_um(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_514
tff(fact_8695_ATP_Olambda__515,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_aca(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,Uu,Uub)),aa(nat,rat,Uua,Uub)) ) ).

% ATP.lambda_515
tff(fact_8696_ATP_Olambda__516,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ba(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_516
tff(fact_8697_ATP_Olambda__517,axiom,
    ! [A: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adt(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_517
tff(fact_8698_ATP_Olambda__518,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fm(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_518
tff(fact_8699_ATP_Olambda__519,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qe(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_519
tff(fact_8700_ATP_Olambda__520,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_yx(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_520
tff(fact_8701_ATP_Olambda__521,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_op(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_521
tff(fact_8702_ATP_Olambda__522,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aeu(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_522
tff(fact_8703_ATP_Olambda__523,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rl(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_523
tff(fact_8704_ATP_Olambda__524,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rh(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_524
tff(fact_8705_ATP_Olambda__525,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_aan(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(A,set(B),Uu,Uub)),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_525
tff(fact_8706_ATP_Olambda__526,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_526
tff(fact_8707_ATP_Olambda__527,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sr(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_527
tff(fact_8708_ATP_Olambda__528,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ka(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uua,Uub)),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_528
tff(fact_8709_ATP_Olambda__529,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_er(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_529
tff(fact_8710_ATP_Olambda__530,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_eu(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_530
tff(fact_8711_ATP_Olambda__531,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sp(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_531
tff(fact_8712_ATP_Olambda__532,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,nat),Uub: A] : ( aa(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_yw(fun(A,B),fun(fun(A,nat),fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ) ).

% ATP.lambda_532
tff(fact_8713_ATP_Olambda__533,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1898628316856586783d_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,nat),Uub: A] : ( aa(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_ri(fun(A,B),fun(fun(A,nat),fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ) ).

% ATP.lambda_533
tff(fact_8714_ATP_Olambda__534,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,nat),Uub: A] : ( aa(A,B,aa(fun(A,nat),fun(A,B),aTP_Lamp_sk(fun(A,B),fun(fun(A,nat),fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),aa(A,nat,Uua,Uub)) ) ) ).

% ATP.lambda_534
tff(fact_8715_ATP_Olambda__535,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,A),Uua: fun(real,A),Uub: real] : ( aa(real,A,aa(fun(real,A),fun(real,A),aTP_Lamp_afv(fun(real,A),fun(fun(real,A),fun(real,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(real,A,Uu,Uub)),aa(real,A,Uua,Uub)) ) ) ).

% ATP.lambda_535
tff(fact_8716_ATP_Olambda__536,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_abx(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(nat,rat,Uu,Uub)),aa(nat,rat,Uua,Uub)) ) ).

% ATP.lambda_536
tff(fact_8717_ATP_Olambda__537,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_az(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_537
tff(fact_8718_ATP_Olambda__538,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ads(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_538
tff(fact_8719_ATP_Olambda__539,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_fl(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_539
tff(fact_8720_ATP_Olambda__540,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_qb(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_540
tff(fact_8721_ATP_Olambda__541,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_yy(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_541
tff(fact_8722_ATP_Olambda__542,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_ou(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_542
tff(fact_8723_ATP_Olambda__543,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aes(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_543
tff(fact_8724_ATP_Olambda__544,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rg(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_544
tff(fact_8725_ATP_Olambda__545,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_wq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_545
tff(fact_8726_ATP_Olambda__546,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_te(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_546
tff(fact_8727_ATP_Olambda__547,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_kz(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_547
tff(fact_8728_ATP_Olambda__548,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_pf(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = powr(real,aa(real,real,Uu,Uub),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_548
tff(fact_8729_ATP_Olambda__549,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_qw(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_549
tff(fact_8730_ATP_Olambda__550,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zc(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_550
tff(fact_8731_ATP_Olambda__551,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tq(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_551
tff(fact_8732_ATP_Olambda__552,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sx(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_552
tff(fact_8733_ATP_Olambda__553,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zh(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_553
tff(fact_8734_ATP_Olambda__554,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tw(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_554
tff(fact_8735_ATP_Olambda__555,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sm(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_555
tff(fact_8736_ATP_Olambda__556,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_wf(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,Uua))) ) ) ).

% ATP.lambda_556
tff(fact_8737_ATP_Olambda__557,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_ox(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,Uu,Uub)),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_557
tff(fact_8738_ATP_Olambda__558,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: set(A),Uua: fun(B,fun(A,C)),Uub: B] : ( aa(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_tk(set(A),fun(fun(B,fun(A,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(B,fun(A,C),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_558
tff(fact_8739_ATP_Olambda__559,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: set(A),Uua: fun(B,fun(A,C)),Uub: B] : ( aa(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_si(set(A),fun(fun(B,fun(A,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_559
tff(fact_8740_ATP_Olambda__560,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,real,aa(B,fun(A,real),aTP_Lamp_xv(fun(A,B),fun(B,fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_560
tff(fact_8741_ATP_Olambda__561,axiom,
    ! [A: $tType,B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_xz(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_561
tff(fact_8742_ATP_Olambda__562,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_vw(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_562
tff(fact_8743_ATP_Olambda__563,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_cw(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = modulo_modulo(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_563
tff(fact_8744_ATP_Olambda__564,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(real,A),Uua: A,Uub: real] : ( aa(real,A,aa(A,fun(real,A),aTP_Lamp_afx(fun(real,A),fun(A,fun(real,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(real,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_564
tff(fact_8745_ATP_Olambda__565,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_565
tff(fact_8746_ATP_Olambda__566,axiom,
    ! [B: $tType,A: $tType] :
      ( field(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_fn(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_566
tff(fact_8747_ATP_Olambda__567,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_oq(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_567
tff(fact_8748_ATP_Olambda__568,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_acu(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_568
tff(fact_8749_ATP_Olambda__569,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_ss(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_569
tff(fact_8750_ATP_Olambda__570,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ub(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_570
tff(fact_8751_ATP_Olambda__571,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_vu(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_571
tff(fact_8752_ATP_Olambda__572,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_vs(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_572
tff(fact_8753_ATP_Olambda__573,axiom,
    ! [A: $tType,B: $tType] :
      ( ( dense_linorder(B)
        & no_bot(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_xw(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_573
tff(fact_8754_ATP_Olambda__574,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_yp(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_574
tff(fact_8755_ATP_Olambda__575,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_tc(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_575
tff(fact_8756_ATP_Olambda__576,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bu(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_576
tff(fact_8757_ATP_Olambda__577,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ua(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_577
tff(fact_8758_ATP_Olambda__578,axiom,
    ! [B: $tType,A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ry(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_578
tff(fact_8759_ATP_Olambda__579,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,A),Uua: A,Uub: real] : ( aa(real,A,aa(A,fun(real,A),aTP_Lamp_afy(fun(real,A),fun(A,fun(real,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(real,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_579
tff(fact_8760_ATP_Olambda__580,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_adu(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_580
tff(fact_8761_ATP_Olambda__581,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ex(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_581
tff(fact_8762_ATP_Olambda__582,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] : ( aa(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_oh(fun(B,set(A)),fun(set(A),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_582
tff(fact_8763_ATP_Olambda__583,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_so(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_583
tff(fact_8764_ATP_Olambda__584,axiom,
    ! [Uu: fun(real,real),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_pb(fun(real,real),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,Uu,Uub)),Uua) ) ).

% ATP.lambda_584
tff(fact_8765_ATP_Olambda__585,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: nat,Uub: B] : ( aa(B,A,aa(nat,fun(B,A),aTP_Lamp_gs(fun(B,A),fun(nat,fun(B,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_585
tff(fact_8766_ATP_Olambda__586,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_qm(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_586
tff(fact_8767_ATP_Olambda__587,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_yv(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_587
tff(fact_8768_ATP_Olambda__588,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_oy(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_588
tff(fact_8769_ATP_Olambda__589,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_rj(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_589
tff(fact_8770_ATP_Olambda__590,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_wz(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_590
tff(fact_8771_ATP_Olambda__591,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_sl(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_591
tff(fact_8772_ATP_Olambda__592,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_sj(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_592
tff(fact_8773_ATP_Olambda__593,axiom,
    ! [Uu: nat,Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_xr(nat,fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_593
tff(fact_8774_ATP_Olambda__594,axiom,
    ! [A: $tType,Uu: nat,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sa(nat,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_594
tff(fact_8775_ATP_Olambda__595,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,A),Uua: A,Uub: real] : ( aa(real,A,aa(A,fun(real,A),aTP_Lamp_afw(fun(real,A),fun(A,fun(real,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(real,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_595
tff(fact_8776_ATP_Olambda__596,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_yd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_596
tff(fact_8777_ATP_Olambda__597,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_adq(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_597
tff(fact_8778_ATP_Olambda__598,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_598
tff(fact_8779_ATP_Olambda__599,axiom,
    ! [Uu: fun(real,real),Uua: real,Uub: real] : ( aa(real,real,aa(real,fun(real,real),aTP_Lamp_pe(fun(real,real),fun(real,fun(real,real)),Uu),Uua),Uub) = powr(real,aa(real,real,Uu,Uub),Uua) ) ).

% ATP.lambda_599
tff(fact_8780_ATP_Olambda__600,axiom,
    ! [A: $tType,Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_wv(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = powr(real,aa(A,real,Uua,Uub),Uu) ) ).

% ATP.lambda_600
tff(fact_8781_ATP_Olambda__601,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(B,A),Uua: int,Uub: B] : ( aa(B,A,aa(int,fun(B,A),aTP_Lamp_zr(fun(B,A),fun(int,fun(B,A)),Uu),Uua),Uub) = power_int(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_601
tff(fact_8782_ATP_Olambda__602,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_zw(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_602
tff(fact_8783_ATP_Olambda__603,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_zt(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_603
tff(fact_8784_ATP_Olambda__604,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: int,Uub: A] : ( aa(A,A,aa(int,fun(A,A),aTP_Lamp_zy(fun(A,A),fun(int,fun(A,A)),Uu),Uua),Uub) = power_int(A,aa(A,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_604
tff(fact_8785_ATP_Olambda__605,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_zv(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_605
tff(fact_8786_ATP_Olambda__606,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_zu(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_606
tff(fact_8787_ATP_Olambda__607,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ik(nat,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub))) ) ) ).

% ATP.lambda_607
tff(fact_8788_ATP_Olambda__608,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(nat,A),Uub: nat] : ( aa(nat,real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_bp(real,fun(fun(nat,A),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uua,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ) ).

% ATP.lambda_608
tff(fact_8789_ATP_Olambda__609,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_ach(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(rat,rat,inverse_inverse(rat),aa(nat,rat,Uu,Uub))),aa(rat,rat,inverse_inverse(rat),aa(nat,rat,Uua,Uub))) ) ).

% ATP.lambda_609
tff(fact_8790_ATP_Olambda__610,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_yf(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))),Uua) ) ) ).

% ATP.lambda_610
tff(fact_8791_ATP_Olambda__611,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_agi(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))),Uua) ) ) ).

% ATP.lambda_611
tff(fact_8792_ATP_Olambda__612,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_fr(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ) ).

% ATP.lambda_612
tff(fact_8793_ATP_Olambda__613,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & topolo2564578578187576103pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_we(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(B,Uua))),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_613
tff(fact_8794_ATP_Olambda__614,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A,Uub: fun(A,real)] :
          ( aa(fun(A,real),$o,aa(A,fun(fun(A,real),$o),aTP_Lamp_aem(set(A),fun(A,fun(fun(A,real),$o)),Uu),Uua),Uub)
        <=> ( ! [V5: A] :
                ( ( aa(A,real,Uub,V5) != zero_zero(real) )
               => member(A,V5,Uu) )
            & aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),Uub)))
            & ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_acn(fun(A,real),fun(A,A),Uub)),collect(A,aTP_Lamp_aco(fun(A,real),fun(A,$o),Uub))) = Uua ) ) ) ) ).

% ATP.lambda_614
tff(fact_8795_ATP_Olambda__615,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(list(A),fun(list(A),$o)),Uua: list(A),Uub: list(A)] :
          ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aa(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o)),aTP_Lamp_aam(fun(list(A),fun(list(A),$o)),fun(list(A),fun(list(A),$o))),Uu),Uua),Uub)
        <=> ( ? [Y5: A,Ys3: list(A)] :
                ( ( Uua = nil(A) )
                & ( Uub = cons(A,Y5,Ys3) ) )
            | ? [X5: A,Y5: A,Xs3: list(A),Ys3: list(A)] :
                ( ( Uua = cons(A,X5,Xs3) )
                & ( Uub = cons(A,Y5,Ys3) )
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5) )
            | ? [X5: A,Y5: A,Xs3: list(A),Ys3: list(A)] :
                ( ( Uua = cons(A,X5,Xs3) )
                & ( Uub = cons(A,Y5,Ys3) )
                & ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),X5),Y5)
                & ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X5)
                & aa(list(A),$o,aa(list(A),fun(list(A),$o),Uu,Xs3),Ys3) ) ) ) ) ).

% ATP.lambda_615
tff(fact_8796_ATP_Olambda__616,axiom,
    ! [A: $tType,Uu: fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),Uua: fun($o,fun($o,A)),Uub: vEBT_VEBT] : ( aa(vEBT_VEBT,product_prod(vEBT_VEBT,A),aa(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A)),aTP_Lamp_adn(fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),fun(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A))),Uu),Uua),Uub) = aa(A,product_prod(vEBT_VEBT,A),product_Pair(vEBT_VEBT,A,Uub),vEBT_rec_VEBT(A,Uu,Uua,Uub)) ) ).

% ATP.lambda_616
tff(fact_8797_ATP_Olambda__617,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ig(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_617
tff(fact_8798_ATP_Olambda__618,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ii(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_618
tff(fact_8799_ATP_Olambda__619,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_if(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_619
tff(fact_8800_ATP_Olambda__620,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: int,Uub: A] : ( aa(A,A,aa(int,fun(A,A),aTP_Lamp_aaa(A,fun(int,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Uua)),power_int(A,Uu,aa(int,int,aa(int,fun(int,int),minus_minus(int),Uua),one_one(int))))) ) ) ).

% ATP.lambda_620
tff(fact_8801_ATP_Olambda__621,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_gi(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_621
tff(fact_8802_ATP_Olambda__622,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_gg(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_622
tff(fact_8803_ATP_Olambda__623,axiom,
    ! [A: $tType,Uu: A,Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ado(A,fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uua),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ).

% ATP.lambda_623
tff(fact_8804_ATP_Olambda__624,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ff(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_624
tff(fact_8805_ATP_Olambda__625,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_acx(fun(A,option(B)),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uua),dom(A,B,Uu))) ) ).

% ATP.lambda_625
tff(fact_8806_ATP_Olambda__626,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_acy(fun(A,option(B)),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uua),dom(A,B,Uu))) ) ).

% ATP.lambda_626
tff(fact_8807_ATP_Olambda__627,axiom,
    ! [Uu: real,Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_uv(real,fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),divide_divide(real),Uua),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ).

% ATP.lambda_627
tff(fact_8808_ATP_Olambda__628,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_du(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_628
tff(fact_8809_ATP_Olambda__629,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_gh(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ).

% ATP.lambda_629
tff(fact_8810_ATP_Olambda__630,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_wm(real,fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> member(real,Uub,set_or5935395276787703475ssThan(real,Uu,Uua)) ) ).

% ATP.lambda_630
tff(fact_8811_ATP_Olambda__631,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_vx(B,fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_631
tff(fact_8812_ATP_Olambda__632,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_vq(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_632
tff(fact_8813_ATP_Olambda__633,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_lc(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),divide_divide(A),Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_633
tff(fact_8814_ATP_Olambda__634,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_vt(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_634
tff(fact_8815_ATP_Olambda__635,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_abr(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_635
tff(fact_8816_ATP_Olambda__636,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_vp(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_636
tff(fact_8817_ATP_Olambda__637,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_vr(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_637
tff(fact_8818_ATP_Olambda__638,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_yo(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_638
tff(fact_8819_ATP_Olambda__639,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ax(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_639
tff(fact_8820_ATP_Olambda__640,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bt(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_640
tff(fact_8821_ATP_Olambda__641,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_tz(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_641
tff(fact_8822_ATP_Olambda__642,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_rz(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_642
tff(fact_8823_ATP_Olambda__643,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_tb(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_643
tff(fact_8824_ATP_Olambda__644,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field(B)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_yj(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_644
tff(fact_8825_ATP_Olambda__645,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ol(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_645
tff(fact_8826_ATP_Olambda__646,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: fun(B,nat),Uub: B] : ( aa(B,A,aa(fun(B,nat),fun(B,A),aTP_Lamp_gv(A,fun(fun(B,nat),fun(B,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(B,nat,Uua,Uub)) ) ) ).

% ATP.lambda_646
tff(fact_8827_ATP_Olambda__647,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,nat),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_vb(fun(A,nat),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_647
tff(fact_8828_ATP_Olambda__648,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_tf(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_648
tff(fact_8829_ATP_Olambda__649,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adr(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_649
tff(fact_8830_ATP_Olambda__650,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_acv(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_650
tff(fact_8831_ATP_Olambda__651,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_za(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ) ).

% ATP.lambda_651
tff(fact_8832_ATP_Olambda__652,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_sb(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ) ).

% ATP.lambda_652
tff(fact_8833_ATP_Olambda__653,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: nat,Uub: A] : ( aa(A,real,aa(nat,fun(A,real),aTP_Lamp_th(fun(A,real),fun(nat,fun(A,real)),Uu),Uua),Uub) = aa(real,real,root(Uua),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_653
tff(fact_8834_ATP_Olambda__654,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hh(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_654
tff(fact_8835_ATP_Olambda__655,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_xe(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_655
tff(fact_8836_ATP_Olambda__656,axiom,
    ! [Uu: real,Uua: real,Uub: product_unit] : ( aa(product_unit,real,aa(real,fun(product_unit,real),aTP_Lamp_afg(real,fun(real,fun(product_unit,real)),Uu),Uua),Uub) = powr_real(Uu,Uua) ) ).

% ATP.lambda_656
tff(fact_8837_ATP_Olambda__657,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_gx(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_657
tff(fact_8838_ATP_Olambda__658,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ew(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_658
tff(fact_8839_ATP_Olambda__659,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_uj(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ) ).

% ATP.lambda_659
tff(fact_8840_ATP_Olambda__660,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ue(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_660
tff(fact_8841_ATP_Olambda__661,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_se(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_661
tff(fact_8842_ATP_Olambda__662,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_om(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_662
tff(fact_8843_ATP_Olambda__663,axiom,
    ! [Uu: fun(real,$o),Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_yi(fun(real,$o),fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_663
tff(fact_8844_ATP_Olambda__664,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real,Uub: real] : ( aa(real,A,aa(real,fun(real,A),aTP_Lamp_yh(fun(real,A),fun(real,fun(real,A)),Uu),Uua),Uub) = aa(real,A,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_664
tff(fact_8845_ATP_Olambda__665,axiom,
    ! [Uu: fun(nat,real),Uua: nat,Uub: nat] : ( aa(nat,real,aa(nat,fun(nat,real),aTP_Lamp_adp(fun(nat,real),fun(nat,fun(nat,real)),Uu),Uua),Uub) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_665
tff(fact_8846_ATP_Olambda__666,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_vo(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_666
tff(fact_8847_ATP_Olambda__667,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat,Uub: nat] : ( aa(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_og(fun(nat,set(A)),fun(nat,fun(nat,set(A))),Uu),Uua),Uub) = aa(nat,set(A),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_667
tff(fact_8848_ATP_Olambda__668,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_668
tff(fact_8849_ATP_Olambda__669,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ud(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_669
tff(fact_8850_ATP_Olambda__670,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ye(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_670
tff(fact_8851_ATP_Olambda__671,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_gw(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_671
tff(fact_8852_ATP_Olambda__672,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_fw(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_672
tff(fact_8853_ATP_Olambda__673,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,$o),Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_vv(fun(A,$o),fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_673
tff(fact_8854_ATP_Olambda__674,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_sg(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_674
tff(fact_8855_ATP_Olambda__675,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_tu(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_675
tff(fact_8856_ATP_Olambda__676,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ov(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_676
tff(fact_8857_ATP_Olambda__677,axiom,
    ! [C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: B,Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_tm(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),Uub)) ) ) ).

% ATP.lambda_677
tff(fact_8858_ATP_Olambda__678,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_tl(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uub)) ) ) ).

% ATP.lambda_678
tff(fact_8859_ATP_Olambda__679,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bw(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uu)) ) ) ).

% ATP.lambda_679
tff(fact_8860_ATP_Olambda__680,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,real,aa(fun(nat,nat),fun(nat,real),aTP_Lamp_aaf(fun(nat,real),fun(fun(nat,nat),fun(nat,real)),Uu),Uua),Uub) = aa(nat,real,Uu,aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_680
tff(fact_8861_ATP_Olambda__681,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(num,B),Uub: num] : ( aa(num,A,aa(fun(num,B),fun(num,A),aTP_Lamp_mv(fun(B,A),fun(fun(num,B),fun(num,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(num,B,Uua,Uub)) ) ).

% ATP.lambda_681
tff(fact_8862_ATP_Olambda__682,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(nat,B),Uub: nat] : ( aa(nat,A,aa(fun(nat,B),fun(nat,A),aTP_Lamp_iq(fun(B,A),fun(fun(nat,B),fun(nat,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(nat,B,Uua,Uub)) ) ).

% ATP.lambda_682
tff(fact_8863_ATP_Olambda__683,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A) )
     => ! [Uu: fun(A,$o),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,A),fun(nat,$o),aTP_Lamp_ym(fun(A,$o),fun(fun(nat,A),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_683
tff(fact_8864_ATP_Olambda__684,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,A),Uub: nat] : ( aa(nat,B,aa(fun(nat,A),fun(nat,B),aTP_Lamp_yn(fun(A,B),fun(fun(nat,A),fun(nat,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_684
tff(fact_8865_ATP_Olambda__685,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_wl(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_685
tff(fact_8866_ATP_Olambda__686,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aae(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,Uu,Uub)) ) ) ).

% ATP.lambda_686
tff(fact_8867_ATP_Olambda__687,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aag(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,Uu,Uub)) ) ) ).

% ATP.lambda_687
tff(fact_8868_ATP_Olambda__688,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tp(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_688
tff(fact_8869_ATP_Olambda__689,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_xx(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_689
tff(fact_8870_ATP_Olambda__690,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_kc(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_690
tff(fact_8871_ATP_Olambda__691,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_jz(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_691
tff(fact_8872_ATP_Olambda__692,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_rx(fun(nat,A),fun(A,fun(A,A)),Uu),Uua),Uub) = suminf(A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_rw(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_692
tff(fact_8873_ATP_Olambda__693,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,B),Uub: A] : ( aa(A,B,aa(fun(nat,B),fun(A,B),aTP_Lamp_rv(fun(A,B),fun(fun(nat,B),fun(A,B)),Uu),Uua),Uub) = suminf(B,aa(A,fun(nat,B),aa(fun(nat,B),fun(A,fun(nat,B)),aTP_Lamp_ru(fun(A,B),fun(fun(nat,B),fun(A,fun(nat,B))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_693
tff(fact_8874_ATP_Olambda__694,axiom,
    ! [B: $tType] :
      ( real_V4867850818363320053vector(B)
     => ! [Uu: set(B),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_agm(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,real,real_V7696804695334737415tation(B,real_V4986007116245087402_basis(B,Uu),Uua),Uub) != zero_zero(real) ) ) ) ).

% ATP.lambda_694
tff(fact_8875_ATP_Olambda__695,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aeo(set(A),fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,real,real_V7696804695334737415tation(A,Uu,Uua),Uub) != zero_zero(real) ) ) ) ).

% ATP.lambda_695
tff(fact_8876_ATP_Olambda__696,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: set(A),Uub: A] : ( aa(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_ada(A,fun(set(A),fun(A,filter(A))),Uu),Uua),Uub) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_greaterThan(A,Uub)),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_696
tff(fact_8877_ATP_Olambda__697,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: set(A),Uub: A] : ( aa(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_acz(A,fun(set(A),fun(A,filter(A))),Uu),Uua),Uub) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,Uub)),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_697
tff(fact_8878_ATP_Olambda__698,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: set(A),Uub: set(A)] : ( aa(set(A),filter(A),aa(set(A),fun(set(A),filter(A)),aTP_Lamp_adf(A,fun(set(A),fun(set(A),filter(A))),Uu),Uua),Uub) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uub),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_698
tff(fact_8879_ATP_Olambda__699,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,real,aa(A,fun(nat,real),aTP_Lamp_be(fun(nat,A),fun(A,fun(nat,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub))) ) ) ).

% ATP.lambda_699
tff(fact_8880_ATP_Olambda__700,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_he(fun(A,B),fun(fun(A,B),fun(A,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub))) ) ) ).

% ATP.lambda_700
tff(fact_8881_ATP_Olambda__701,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_vg(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = cos(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),Uua)) ) ).

% ATP.lambda_701
tff(fact_8882_ATP_Olambda__702,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_acw(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_702
tff(fact_8883_ATP_Olambda__703,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(B,real),Uua: fun(real,A),Uub: B] : ( aa(B,real,aa(fun(real,A),fun(B,real),aTP_Lamp_re(fun(B,real),fun(fun(real,A),fun(B,real)),Uu),Uua),Uub) = aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(A,aa(real,A,Uua,aa(B,real,Uu,Uub)))) ) ) ).

% ATP.lambda_703
tff(fact_8884_ATP_Olambda__704,axiom,
    ! [A: $tType,B: $tType,Uu: list(A),Uua: list(B),Uub: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aa(list(B),fun(product_prod(A,B),$o),aTP_Lamp_nc(list(A),fun(list(B),fun(product_prod(A,B),$o)),Uu),Uua),Uub)
    <=> ? [I: nat] :
          ( ( Uub = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Uu),I)),aa(nat,B,nth(B,Uua),I)) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(list(A),nat,size_size(list(A)),Uu)),aa(list(B),nat,size_size(list(B)),Uua))) ) ) ).

% ATP.lambda_704
tff(fact_8885_ATP_Olambda__705,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: A] :
      ( aa(A,$o,aa(set(nat),fun(A,$o),aTP_Lamp_nk(list(A),fun(set(nat),fun(A,$o)),Uu),Uua),Uub)
    <=> ? [I: nat] :
          ( ( Uub = aa(nat,A,nth(A,Uu),I) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Uu))
          & member(nat,I,Uua) ) ) ).

% ATP.lambda_705
tff(fact_8886_ATP_Olambda__706,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: A,Uua: set(A),Uub: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_aej(A,fun(set(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ? [K3: real] : member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(A,A,real_V8093663219630862766scaleR(A,K3),Uu)),real_Vector_span(A,Uua)) ) ) ).

% ATP.lambda_706
tff(fact_8887_ATP_Olambda__707,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_wg(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> ! [N4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uub),N4)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,Uub,N4)))),aa(nat,real,Uua,Uub)) ) ) ) ).

% ATP.lambda_707
tff(fact_8888_ATP_Olambda__708,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_vm(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> ! [A6: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uub),A6)
             => ! [B7: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A6),B7)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or3652927894154168847AtMost(nat,A6,B7)))),aa(nat,real,Uua,A6)) ) ) ) ) ).

% ATP.lambda_708
tff(fact_8889_ATP_Olambda__709,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_zq(fun(A,A),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> ? [N4: nat] : ( Uub = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N4),Uu),Uua) ) ) ).

% ATP.lambda_709
tff(fact_8890_ATP_Olambda__710,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_aei(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ? [X5: A,Y5: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),plus_plus(A),X5),Y5) )
              & member(A,X5,real_Vector_span(A,Uu))
              & member(A,Y5,real_Vector_span(A,Uua)) ) ) ) ).

% ATP.lambda_710
tff(fact_8891_ATP_Olambda__711,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ek(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uuc) ),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),
              zero_zero(A) ) ) ) ).

% ATP.lambda_711
tff(fact_8892_ATP_Olambda__712,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_cn(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub)
              & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uuc) ),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),
              zero_zero(A) ) ) ) ).

% ATP.lambda_712
tff(fact_8893_ATP_Olambda__713,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_cp(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc))))),semiring_char_0_fact(real,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),zero_zero(A)) ) ) ).

% ATP.lambda_713
tff(fact_8894_ATP_Olambda__714,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_dv(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,A,Uua,Uuc),
              $ite(Uuc = Uu,zero_zero(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_714
tff(fact_8895_ATP_Olambda__715,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_hj(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,A,Uua,Uuc),
              $ite(Uuc = Uu,one_one(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_715
tff(fact_8896_ATP_Olambda__716,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_hk(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_716
tff(fact_8897_ATP_Olambda__717,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_dw(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_717
tff(fact_8898_ATP_Olambda__718,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: set(nat),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_kb(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(member(nat,Uuc,Uua),aa(nat,A,Uub,Uuc),aa(nat,A,Uu,Uuc)) ) ) ).

% ATP.lambda_718
tff(fact_8899_ATP_Olambda__719,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_kw(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_719
tff(fact_8900_ATP_Olambda__720,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_kv(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_720
tff(fact_8901_ATP_Olambda__721,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: B,Uuc: A] :
          ( aa(A,B,aa(B,fun(A,B),aa(fun(A,B),fun(B,fun(A,B)),aTP_Lamp_ks(A,fun(fun(A,B),fun(B,fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_721
tff(fact_8902_ATP_Olambda__722,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_acs(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uu,Uuc),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_722
tff(fact_8903_ATP_Olambda__723,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_lb(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uuc),aa(A,fun(A,A),times_times(A),Uua)),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))) ) ) ).

% ATP.lambda_723
tff(fact_8904_ATP_Olambda__724,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(real,A),Uub: fun(real,B),Uuc: real] : ( aa(real,C,aa(fun(real,B),fun(real,C),aa(fun(real,A),fun(fun(real,B),fun(real,C)),aTP_Lamp_agc(fun(A,fun(B,C)),fun(fun(real,A),fun(fun(real,B),fun(real,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(real,A,Uua,Uuc)),aa(real,B,Uub,Uuc)) ) ) ).

% ATP.lambda_724
tff(fact_8905_ATP_Olambda__725,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: fun(D,B),Uuc: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_aey(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),aa(D,B,Uub,Uuc)) ) ) ).

% ATP.lambda_725
tff(fact_8906_ATP_Olambda__726,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: fun(D,B),Uuc: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_aex(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),aa(D,B,Uub,Uuc)) ) ) ).

% ATP.lambda_726
tff(fact_8907_ATP_Olambda__727,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: B,Uuc: D] : ( aa(D,C,aa(B,fun(D,C),aa(fun(D,A),fun(B,fun(D,C)),aTP_Lamp_aew(fun(A,fun(B,C)),fun(fun(D,A),fun(B,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),Uub) ) ) ).

% ATP.lambda_727
tff(fact_8908_ATP_Olambda__728,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,B),Uub: A,Uuc: D] : ( aa(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_aev(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,Uub),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_728
tff(fact_8909_ATP_Olambda__729,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fu(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ft(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat)))),Uuc))) ) ) ).

% ATP.lambda_729
tff(fact_8910_ATP_Olambda__730,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_ea(nat,fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                $ite(
                  Uuc = zero_zero(nat),
                  aa(A,A,uminus_uminus(A),Uub),
                  $ite(Uuc = Uu,one_one(A),zero_zero(A)) )),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_730
tff(fact_8911_ATP_Olambda__731,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B,Uuc: B] :
          ( aa(B,A,aa(B,fun(B,A),aa(fun(B,A),fun(B,fun(B,A)),aTP_Lamp_agl(set(B),fun(fun(B,A),fun(B,fun(B,A))),Uu),Uua),Uub),Uuc)
          = aa(A,A,real_V8093663219630862766scaleR(A,aa(B,real,real_V7696804695334737415tation(B,real_V4986007116245087402_basis(B,Uu),Uub),Uuc)),$ite(member(B,Uuc,Uu),aa(B,A,Uua,Uuc),zero_zero(A))) ) ) ).

% ATP.lambda_731
tff(fact_8912_ATP_Olambda__732,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_dr(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_dq(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uuc)),set_ord_atMost(nat,Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uub),Uuc)) ) ).

% ATP.lambda_732
tff(fact_8913_ATP_Olambda__733,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_dm(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_dl(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uuc)),set_ord_atMost(nat,Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uuc)) ) ) ).

% ATP.lambda_733
tff(fact_8914_ATP_Olambda__734,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_ps(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,Uua)),Uuc)),zero_zero(real))),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uub),Uuc)) ) ).

% ATP.lambda_734
tff(fact_8915_ATP_Olambda__735,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_pq(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)),zero_zero(real))),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uub),Uuc)) ) ).

% ATP.lambda_735
tff(fact_8916_ATP_Olambda__736,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_pp(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uua)),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Uub),Uua)),Uuc)) ) ).

% ATP.lambda_736
tff(fact_8917_ATP_Olambda__737,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_po(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uub)),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Uua),Uub)),Uuc)) ) ).

% ATP.lambda_737
tff(fact_8918_ATP_Olambda__738,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fb(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uub)) ) ) ).

% ATP.lambda_738
tff(fact_8919_ATP_Olambda__739,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_lh(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_739
tff(fact_8920_ATP_Olambda__740,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ft(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),Uuc))) ) ) ).

% ATP.lambda_740
tff(fact_8921_ATP_Olambda__741,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_vd(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),aa(nat,A,Uub,Uuc)))),aa(A,A,Uu,Uua))),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_741
tff(fact_8922_ATP_Olambda__742,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: set(product_prod(A,A)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aTP_Lamp_aeg(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc))
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc))
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uub),Uuc),Uua) ) ) ) ).

% ATP.lambda_742
tff(fact_8923_ATP_Olambda__743,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_yc(fun(A,B),fun(B,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub) ) ) ).

% ATP.lambda_743
tff(fact_8924_ATP_Olambda__744,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_xu(fun(A,B),fun(B,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub) ) ) ).

% ATP.lambda_744
tff(fact_8925_ATP_Olambda__745,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dt(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),comm_s3205402744901411588hammer(A,Uu,Uuc))),comm_s3205402744901411588hammer(A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_745
tff(fact_8926_ATP_Olambda__746,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_df(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,semiring_1_of_nat(nat),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_746
tff(fact_8927_ATP_Olambda__747,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_do(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_747
tff(fact_8928_ATP_Olambda__748,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dz(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_748
tff(fact_8929_ATP_Olambda__749,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat,Uub: list(A),Uuc: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aa(nat,fun(list(A),fun(list(A),$o)),aTP_Lamp_aar(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & ( aa(list(A),nat,size_size(list(A)),Uuc) = Uua )
        & ? [Xys: list(A),X5: A,Y5: A,Xs5: list(A),Ys6: list(A)] :
            ( ( Uub = append(A,Xys,cons(A,X5,Xs5)) )
            & ( Uuc = append(A,Xys,cons(A,Y5,Ys6)) )
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X5),Y5),Uu) ) ) ) ).

% ATP.lambda_749
tff(fact_8930_ATP_Olambda__750,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fd(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)) ) ) ).

% ATP.lambda_750
tff(fact_8931_ATP_Olambda__751,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_fc(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_751
tff(fact_8932_ATP_Olambda__752,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: fun(A,real),Uuc: A] :
          ( aa(A,$o,aa(fun(A,real),fun(A,$o),aa(fun(A,real),fun(fun(A,real),fun(A,$o)),aTP_Lamp_acr(set(A),fun(fun(A,real),fun(fun(A,real),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( member(A,Uuc,Uu)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,Uua,Uuc)),aa(A,real,Uub,Uuc)) ) ) ) ).

% ATP.lambda_752
tff(fact_8933_ATP_Olambda__753,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_fe(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_753
tff(fact_8934_ATP_Olambda__754,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_de(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Uu),Uuc)),aa(nat,nat,binomial(Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_754
tff(fact_8935_ATP_Olambda__755,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_ln(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_755
tff(fact_8936_ATP_Olambda__756,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_nm(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_756
tff(fact_8937_ATP_Olambda__757,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_ll(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_757
tff(fact_8938_ATP_Olambda__758,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_lp(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_758
tff(fact_8939_ATP_Olambda__759,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_lr(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_759
tff(fact_8940_ATP_Olambda__760,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_ny(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua) ) ) ).

% ATP.lambda_760
tff(fact_8941_ATP_Olambda__761,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_jr(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( member(A,Uuc,Uu)
            & ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uuc)),aa(A,B,Uub,Uuc)) != one_one(B) ) ) ) ) ).

% ATP.lambda_761
tff(fact_8942_ATP_Olambda__762,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_jp(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( member(A,Uuc,Uu)
            & ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uua,Uuc)),aa(A,B,Uub,Uuc)) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_762
tff(fact_8943_ATP_Olambda__763,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_wi(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,aa(real,fun(real,real),divide_divide(real),one_one(real)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))) ) ) ).

% ATP.lambda_763
tff(fact_8944_ATP_Olambda__764,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_bk(fun(nat,A),fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uuc)) ) ) ).

% ATP.lambda_764
tff(fact_8945_ATP_Olambda__765,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ih(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_765
tff(fact_8946_ATP_Olambda__766,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_rw(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),divide_divide(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc))),Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))))) ) ) ).

% ATP.lambda_766
tff(fact_8947_ATP_Olambda__767,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: fun(nat,B),Uub: A,Uuc: nat] : ( aa(nat,B,aa(A,fun(nat,B),aa(fun(nat,B),fun(A,fun(nat,B)),aTP_Lamp_ru(fun(A,B),fun(fun(nat,B),fun(A,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uua,Uuc)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uuc)) ) ) ).

% ATP.lambda_767
tff(fact_8948_ATP_Olambda__768,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_qz(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(A,real,Uu,Uua)))),aa(num,real,numeral_numeral(real),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_768
tff(fact_8949_ATP_Olambda__769,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gj(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),Uub)),one_one(nat)))) ) ) ).

% ATP.lambda_769
tff(fact_8950_ATP_Olambda__770,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: set(B),Uuc: A] :
          ( aa(A,$o,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_wc(fun(A,B),fun(B,fun(set(B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> member(B,aa(A,B,Uu,Uuc),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uub),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B))))) ) ) ).

% ATP.lambda_770
tff(fact_8951_ATP_Olambda__771,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,A),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,A),fun(A,fun(A,$o)),aTP_Lamp_ags(fun(A,$o),fun(fun(A,A),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(A,$o,Uu,Uuc)
        & ( Uub = aa(A,A,Uua,Uuc) ) ) ) ).

% ATP.lambda_771
tff(fact_8952_ATP_Olambda__772,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: A] : ( aa(A,A,aa(B,fun(A,A),aa(A,fun(B,fun(A,A)),aTP_Lamp_abl(fun(B,A),fun(A,fun(B,fun(A,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uuc)) ) ) ).

% ATP.lambda_772
tff(fact_8953_ATP_Olambda__773,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_dq(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uuc)),aa(nat,nat,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_773
tff(fact_8954_ATP_Olambda__774,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_dh(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_774
tff(fact_8955_ATP_Olambda__775,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_dl(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_775
tff(fact_8956_ATP_Olambda__776,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,nat),Uua: fun(B,nat),Uub: A,Uuc: B] : ( aa(B,nat,aa(A,fun(B,nat),aa(fun(B,nat),fun(A,fun(B,nat)),aTP_Lamp_aah(fun(A,nat),fun(fun(B,nat),fun(A,fun(B,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,Uu,Uub)),aa(B,nat,Uua,Uuc)) ) ).

% ATP.lambda_776
tff(fact_8957_ATP_Olambda__777,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_rd(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),cos(real,aa(A,real,Uu,Uua))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ).

% ATP.lambda_777
tff(fact_8958_ATP_Olambda__778,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_rb(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uu,Uub)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))) ) ) ).

% ATP.lambda_778
tff(fact_8959_ATP_Olambda__779,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_qp(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua))) ) ) ).

% ATP.lambda_779
tff(fact_8960_ATP_Olambda__780,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_pw(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))))) ) ) ).

% ATP.lambda_780
tff(fact_8961_ATP_Olambda__781,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_py(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))))) ) ) ).

% ATP.lambda_781
tff(fact_8962_ATP_Olambda__782,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_xj(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc))),aa(A,B,Uu,Uub))),aa(A,B,Uua,Uuc)))),real_V7770717601297561774m_norm(A,Uuc)) ) ) ).

% ATP.lambda_782
tff(fact_8963_ATP_Olambda__783,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_xd(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),divide_divide(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))) ) ) ).

% ATP.lambda_783
tff(fact_8964_ATP_Olambda__784,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(fun(A,C),fun(real,fun(A,$o)),aTP_Lamp_wb(fun(A,B),fun(fun(A,C),fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(A,C,Uua,Uuc))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uuc))),Uub)) ) ) ).

% ATP.lambda_784
tff(fact_8965_ATP_Olambda__785,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: filter(A),Uuc: A] : ( aa(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_xl(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_xk(A,A)))))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_xk(A,A))))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_xk(A,A)))))) ) ) ).

% ATP.lambda_785
tff(fact_8966_ATP_Olambda__786,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_xf(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uub,Uuc)),aa(A,B,Uub,Uua))),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))) ) ) ).

% ATP.lambda_786
tff(fact_8967_ATP_Olambda__787,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_xg(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))) ) ) ).

% ATP.lambda_787
tff(fact_8968_ATP_Olambda__788,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(nat,fun(real,fun(A,$o)),aTP_Lamp_wh(fun(nat,A),fun(nat,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uub),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_bd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uuc)),set_ord_atMost(nat,Uua)))) ) ) ).

% ATP.lambda_788
tff(fact_8969_ATP_Olambda__789,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_id(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_789
tff(fact_8970_ATP_Olambda__790,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ib(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_790
tff(fact_8971_ATP_Olambda__791,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_gy(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_791
tff(fact_8972_ATP_Olambda__792,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_fx(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_792
tff(fact_8973_ATP_Olambda__793,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_iy(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_793
tff(fact_8974_ATP_Olambda__794,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(B,A),Uua: B,Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_ql(fun(B,A),fun(B,fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua))),aa(B,A,Uub,Uuc))),aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)))) ) ) ).

% ATP.lambda_794
tff(fact_8975_ATP_Olambda__795,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,C)),Uuc: B,Uud: B] : ( aa(B,C,aa(B,fun(B,C),aa(fun(A,fun(B,C)),fun(B,fun(B,C)),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C))),aTP_Lamp_qv(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aa(B,fun(B,fun(A,C)),aa(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C)))),aTP_Lamp_qu(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))))),Uu),Uua),Uub),Uuc),Uud)),Uu) ) ) ).

% ATP.lambda_795
tff(fact_8976_ATP_Olambda__796,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_fq(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_fp(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uua),Uub),Uuc),Uud)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_796
tff(fact_8977_ATP_Olambda__797,axiom,
    ! [Uu: nat,Uua: fun(nat,fun(real,real)),Uub: real,Uuc: nat,Uud: real] : ( aa(real,real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_pr(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),Uu),Uua),Uub),Uuc),Uud) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Uua,Uuc),Uud)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_pq(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uua),Uuc),Uud)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))),aa(real,real,aa(real,fun(real,real),times_times(real),Uub),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uud),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))))) ) ).

% ATP.lambda_797
tff(fact_8978_ATP_Olambda__798,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_gk(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gj(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uua),Uuc),Uud)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uud),Uu))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud)) ) ) ).

% ATP.lambda_798
tff(fact_8979_ATP_Olambda__799,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ed(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uud)),Uua)),one_one(A))),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_799
tff(fact_8980_ATP_Olambda__800,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_dx(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_800
tff(fact_8981_ATP_Olambda__801,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_dy(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uub)),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_801
tff(fact_8982_ATP_Olambda__802,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat,Uud: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_fp(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uud)),one_one(nat)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_802
tff(fact_8983_ATP_Olambda__803,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: nat,Uud: A] : ( aa(A,B,aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_qn(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uuc)),aa(A,B,Uua,Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),one_one(nat)))) ) ) ).

% ATP.lambda_803
tff(fact_8984_ATP_Olambda__804,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(B,A),Uua: B,Uub: fun(B,A),Uuc: int,Uud: B] : ( aa(B,A,aa(int,fun(B,A),aa(fun(B,A),fun(int,fun(B,A)),aa(B,fun(fun(B,A),fun(int,fun(B,A))),aTP_Lamp_zs(fun(B,A),fun(B,fun(fun(B,A),fun(int,fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uub,Uud)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Uuc)),power_int(A,aa(B,A,Uu,Uua),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uuc),one_one(int))))) ) ) ).

% ATP.lambda_804
tff(fact_8985_ATP_Olambda__805,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,C)),Uuc: B,Uud: B,Uue: A] : ( aa(A,C,aa(B,fun(A,C),aa(B,fun(B,fun(A,C)),aa(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C)))),aTP_Lamp_qu(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,aa(A,fun(B,C),Uub,Uue),Uud)),aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(B,fun(A,C),aTP_Lamp_qs(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uuc)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(set(A),set(A),insert(A,Uue),bot_bot(set(A)))))) ) ) ).

% ATP.lambda_805
tff(fact_8986_ATP_Olambda__806,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qi(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uud,Uue)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uuc,Uub)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_806
tff(fact_8987_ATP_Olambda__807,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,real),Uud: fun(A,real),Uue: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_qx(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(real,real,aa(real,fun(real,real),times_times(real),powr(real,aa(A,real,Uu,Uub),aa(A,real,Uuc,Uub))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uud,Uue)),aa(real,real,ln_ln(real),aa(A,real,Uu,Uub)))),aa(real,real,aa(real,fun(real,real),divide_divide(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uue)),aa(A,real,Uuc,Uub))),aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_807
tff(fact_8988_ATP_Olambda__808,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qa(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_808
tff(fact_8989_ATP_Olambda__809,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qg(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_809
tff(fact_8990_ATP_Olambda__810,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_qr(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uub))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(A,B,Uuc,Uub))),aa(A,B,Uud,Uue))),aa(B,B,inverse_inverse(B),aa(A,B,Uuc,Uub))))),aa(B,B,aa(B,fun(B,B),divide_divide(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_810
tff(fact_8991_ATP_Olambda__811,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: fun(D,A),Uuc: D,Uud: fun(D,B),Uue: fun(D,B),Uuf: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,B),fun(fun(D,B),fun(D,C)),aa(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))),aa(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))),aa(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))))),aTP_Lamp_aez(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),aa(D,B,Uue,Uuf))),aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uub,Uuf)),aa(D,B,Uud,Uuc))) ) ) ).

% ATP.lambda_811
tff(fact_8992_ATP_Olambda__812,axiom,
    ! [Uu: nat,Uua: list(vEBT_VEBT),Uub: vEBT_VEBT,Uuc: nat,Uud: nat,Uue: nat,Uuf: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_ni(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uue),Uuf)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuf),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uu))
        & ! [I: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uud))
           => ( ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,Uua),I)),X_13)
            <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Uub),I) ) )
        & $ite(
            Uue = Uuf,
            ! [X5: vEBT_VEBT] :
              ( member(vEBT_VEBT,X5,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),Uua))
             => ~ ? [X8: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X5),X8) ),
            ( vEBT_V5917875025757280293ildren(Uuc,Uua,Uuf)
            & ! [X5: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X5),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uu))
               => ( vEBT_V5917875025757280293ildren(Uuc,Uua,X5)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uue),X5)
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X5),Uuf) ) ) ) ) ) ) ) ).

% ATP.lambda_812
tff(fact_8993_ATP_Olambda__813,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_aai(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_813
tff(fact_8994_ATP_Olambda__814,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] : ( aa(list(A),set(A),aTP_Lamp_aec(set(A),fun(list(A),set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_814
tff(fact_8995_ATP_Olambda__815,axiom,
    ! [Uu: rat,Uua: nat] : ( aa(nat,rat,aTP_Lamp_aby(rat,fun(nat,rat),Uu),Uua) = Uu ) ).

% ATP.lambda_815
tff(fact_8996_ATP_Olambda__816,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_qc(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_816
tff(fact_8997_ATP_Olambda__817,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_aad(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_817
tff(fact_8998_ATP_Olambda__818,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: real] : ( aa(real,A,aTP_Lamp_aga(A,fun(real,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_818
tff(fact_8999_ATP_Olambda__819,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bb(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_819
tff(fact_9000_ATP_Olambda__820,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_or(A,fun(A,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_820
tff(fact_9001_ATP_Olambda__821,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_km(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_821
tff(fact_9002_ATP_Olambda__822,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_aav(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_822
tff(fact_9003_ATP_Olambda__823,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zero(A)
        & topological_t2_space(A)
        & topolo8386298272705272623_space(B) )
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_sf(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_823
tff(fact_9004_ATP_Olambda__824,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_aau(A,fun(nat,A),Uu),Uua) = Uu ) ).

% ATP.lambda_824
tff(fact_9005_ATP_Olambda__825,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_aat(A,fun(B,A),Uu),Uua) = Uu ) ).

% ATP.lambda_825
tff(fact_9006_ATP_Olambda__826,axiom,
    ! [Uu: complex] : ( aa(complex,complex,aTP_Lamp_ez(complex,complex),Uu) = Uu ) ).

% ATP.lambda_826
tff(fact_9007_ATP_Olambda__827,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_afu(real,real),Uu) = Uu ) ).

% ATP.lambda_827
tff(fact_9008_ATP_Olambda__828,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_gf(nat,nat),Uu) = Uu ) ).

% ATP.lambda_828
tff(fact_9009_ATP_Olambda__829,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_hp(int,int),Uu) = Uu ) ).

% ATP.lambda_829
tff(fact_9010_ATP_Olambda__830,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_xk(A,A),Uu) = Uu ) ) ).

% ATP.lambda_830
tff(fact_9011_ATP_Olambda__831,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_os(A,A),Uu) = Uu ) ) ).

% ATP.lambda_831
tff(fact_9012_ATP_Olambda__832,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_xo(A,A),Uu) = Uu ) ) ).

% ATP.lambda_832
tff(fact_9013_ATP_Olambda__833,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_xp(A,A),Uu) = Uu ) ) ).

% ATP.lambda_833
tff(fact_9014_ATP_Olambda__834,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_lx(A,A),Uu) = Uu ) ) ).

% ATP.lambda_834
tff(fact_9015_ATP_Olambda__835,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ac(A,A),Uu) = Uu ) ) ).

% ATP.lambda_835
tff(fact_9016_ATP_Olambda__836,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_agh(A,A),Uu) = Uu ) ) ).

% ATP.lambda_836
tff(fact_9017_ATP_Olambda__837,axiom,
    ! [A: $tType] :
      ( topolo4638772830378233104ormity(A)
     => ! [Uu: product_unit] : ( aa(product_unit,filter(product_prod(A,A)),aTP_Lamp_afh(product_unit,filter(product_prod(A,A))),Uu) = topolo7806501430040627800ormity(A) ) ) ).

% ATP.lambda_837
tff(fact_9018_ATP_Olambda__838,axiom,
    ! [Uu: nat] : ( aa(nat,rat,aTP_Lamp_acd(nat,rat),Uu) = zero_zero(rat) ) ).

% ATP.lambda_838
tff(fact_9019_ATP_Olambda__839,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_av(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_839
tff(fact_9020_ATP_Olambda__840,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ar(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_840
tff(fact_9021_ATP_Olambda__841,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_eo(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_841
tff(fact_9022_ATP_Olambda__842,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_aas(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_842
tff(fact_9023_ATP_Olambda__843,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_qd(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_843
tff(fact_9024_ATP_Olambda__844,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: A] : ( aa(A,real,aTP_Lamp_aen(A,real),Uu) = zero_zero(real) ) ) ).

% ATP.lambda_844
tff(fact_9025_ATP_Olambda__845,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_aet(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_845
tff(fact_9026_ATP_Olambda__846,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ab(A,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_846
tff(fact_9027_ATP_Olambda__847,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_agj(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_847
tff(fact_9028_ATP_Olambda__848,axiom,
    ! [A: $tType,B: $tType] :
      ( zero(B)
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_agp(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_848
tff(fact_9029_ATP_Olambda__849,axiom,
    ! [Uu: nat] : ( aa(nat,rat,aTP_Lamp_ace(nat,rat),Uu) = one_one(rat) ) ).

% ATP.lambda_849
tff(fact_9030_ATP_Olambda__850,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_go(B,A),Uu) = one_one(A) ) ) ).

% ATP.lambda_850
tff(fact_9031_ATP_Olambda__851,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,real,aTP_Lamp_kr(A,real),Uu) = one_one(real) ) ).

% ATP.lambda_851
tff(fact_9032_ATP_Olambda__852,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,nat,aTP_Lamp_kn(A,nat),Uu) = one_one(nat) ) ).

% ATP.lambda_852
tff(fact_9033_ATP_Olambda__853,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_gz(real,$o),Uu)
    <=> $false ) ).

% ATP.lambda_853
tff(fact_9034_ATP_Olambda__854,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_is(nat,$o),Uu)
    <=> $false ) ).

% ATP.lambda_854
tff(fact_9035_ATP_Olambda__855,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_ir(nat,$o),Uu)
    <=> $true ) ).

% ATP.lambda_855
tff(fact_9036_ATP_Olambda__856,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(nat,nat),aTP_Lamp_afj(A,fun(nat,nat)),Uu) = suc ) ).

% ATP.lambda_856

% Type constructors (795)
tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice(product_unit) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice(extended_enat) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A11: $tType] : bounded_lattice(filter(A11)) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice($o) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType] : bounded_lattice(set(A11)) ).

tff(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A11: $tType,A13: $tType] :
      ( bounded_lattice(A13)
     => bounded_lattice(fun(A11,A13)) ) ).

tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( comple6319245703460814977attice(A13)
     => condit1219197933456340205attice(fun(A11,A13)) ) ).

tff(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( counta3822494911875563373attice(A13)
     => counta3822494911875563373attice(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A13: $tType] :
      ( bounded_lattice(A13)
     => bounde4967611905675639751up_bot(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A13: $tType] :
      ( bounded_lattice(A13)
     => bounde4346867609351753570nf_top(fun(A11,A13)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( comple6319245703460814977attice(A13)
     => comple6319245703460814977attice(fun(A11,A13)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A13: $tType] :
      ( boolea8198339166811842893lgebra(A13)
     => boolea8198339166811842893lgebra(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A13: $tType] :
      ( semilattice_sup(A13)
     => semilattice_sup(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A13: $tType] :
      ( semilattice_inf(A13)
     => semilattice_inf(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A13: $tType] :
      ( order_top(A13)
     => order_top(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A13: $tType] :
      ( order_bot(A13)
     => order_bot(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A13: $tType] :
      ( preorder(A13)
     => preorder(fun(A11,A13)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A13: $tType] :
      ( lattice(A13)
     => lattice(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A13: $tType] :
      ( order(A13)
     => order(fun(A11,A13)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ord(A13)
     => ord(fun(A11,A13)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A13: $tType] :
      ( uminus(A13)
     => uminus(fun(A11,A13)) ) ).

tff(tcon_fun___Groups_Ominus,axiom,
    ! [A11: $tType,A13: $tType] :
      ( minus(A13)
     => minus(fun(A11,A13)) ) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom(int) ).

tff(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if(int) ).

tff(tcon_Int_Oint___Groups_Ominus_14,axiom,
    minus(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Groups_Oplus,axiom,
    plus(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_23,axiom,
    normal6328177297339901930cative(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_24,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_25,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_26,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_27,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_28,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_29,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_30,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_31,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_32,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_33,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Otopological__space_34,axiom,
    topolo4958980785337419405_space(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_35,axiom,
    topolo1944317154257567458pology(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_36,axiom,
    topolo4987421752381908075d_mult(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_37,axiom,
    topolo5987344860129210374id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_38,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_39,axiom,
    topolo2564578578187576103pology(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_40,axiom,
    semiri2026040879449505780visors(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_41,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_42,axiom,
    topolo4211221413907600880p_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_43,axiom,
    semido2269285787275462019factor(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_44,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_45,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_46,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_47,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__mult_48,axiom,
    topolo1898628316856586783d_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_49,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_50,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__add_51,axiom,
    topolo6943815403480290642id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_52,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_53,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_54,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Ot2__space_55,axiom,
    topological_t2_space(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_56,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom_57,axiom,
    normal8620421768224518004emidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_58,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_59,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_60,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_61,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_62,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_63,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_64,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__cancel_65,axiom,
    semiring_1_cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_66,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_67,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_68,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_69,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_70,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_71,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_72,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_73,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_74,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_75,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_76,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_77,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_78,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_79,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_80,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_81,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_82,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_83,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_84,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_85,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_86,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_87,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_88,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_89,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_90,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_91,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_92,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_93,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_94,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_95,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_96,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_97,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom_98,axiom,
    semidom(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_99,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Groups_Ominus_100,axiom,
    minus(nat) ).

tff(tcon_Nat_Onat___Power_Opower_101,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_102,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_103,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oplus_104,axiom,
    plus(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_105,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_106,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Nat_Osize,axiom,
    size(nat) ).

tff(tcon_Num_Onum___Orderings_Opreorder_107,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_108,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_109,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_110,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Oplus_111,axiom,
    plus(num) ).

tff(tcon_Num_Onum___Nat_Osize_112,axiom,
    size(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_113,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_114,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_115,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_116,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_117,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_118,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_119,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_120,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_121,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_122,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_123,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_124,axiom,
    semiri2026040879449505780visors(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_125,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_126,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_127,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_128,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_129,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_130,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_131,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_132,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_133,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_134,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_135,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_136,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_137,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_138,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_139,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_140,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_141,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_142,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_143,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_144,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_145,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_146,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__cancel_147,axiom,
    semiring_1_cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_148,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_149,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_150,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_151,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_152,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_153,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_154,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_155,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_156,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_157,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_158,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_159,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_160,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_161,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_162,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_163,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_164,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_165,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_166,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_167,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_168,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_169,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_170,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__divide_171,axiom,
    idom_divide(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_172,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_173,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_174,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_175,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_176,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_177,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_178,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_179,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_180,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_181,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_182,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_183,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_184,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_185,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom_186,axiom,
    semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_187,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_188,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_189,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Oabs__if_190,axiom,
    abs_if(rat) ).

tff(tcon_Rat_Orat___Groups_Ominus_191,axiom,
    minus(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_192,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_193,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_194,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Groups_Oplus_195,axiom,
    plus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_196,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_197,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_198,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_199,axiom,
    dvd(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_200,axiom,
    ! [A11: $tType] : condit1219197933456340205attice(set(A11)) ).

tff(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_201,axiom,
    ! [A11: $tType] : counta3822494911875563373attice(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_202,axiom,
    ! [A11: $tType] : bounde4967611905675639751up_bot(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_203,axiom,
    ! [A11: $tType] : bounde4346867609351753570nf_top(set(A11)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_204,axiom,
    ! [A11: $tType] : comple6319245703460814977attice(set(A11)) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_205,axiom,
    ! [A11: $tType] : boolea8198339166811842893lgebra(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_206,axiom,
    ! [A11: $tType] : semilattice_sup(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_207,axiom,
    ! [A11: $tType] : semilattice_inf(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_208,axiom,
    ! [A11: $tType] : order_top(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_209,axiom,
    ! [A11: $tType] : order_bot(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Opreorder_210,axiom,
    ! [A11: $tType] : preorder(set(A11)) ).

tff(tcon_Set_Oset___Lattices_Olattice_211,axiom,
    ! [A11: $tType] : lattice(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oorder_212,axiom,
    ! [A11: $tType] : order(set(A11)) ).

tff(tcon_Set_Oset___Orderings_Oord_213,axiom,
    ! [A11: $tType] : ord(set(A11)) ).

tff(tcon_Set_Oset___Groups_Ouminus_214,axiom,
    ! [A11: $tType] : uminus(set(A11)) ).

tff(tcon_Set_Oset___Groups_Ominus_215,axiom,
    ! [A11: $tType] : minus(set(A11)) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_216,axiom,
    condit1219197933456340205attice($o) ).

tff(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_217,axiom,
    counta3822494911875563373attice($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Otopological__space_218,axiom,
    topolo4958980785337419405_space($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_219,axiom,
    topolo1944317154257567458pology($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_220,axiom,
    bounde4967611905675639751up_bot($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_221,axiom,
    bounde4346867609351753570nf_top($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_222,axiom,
    comple6319245703460814977attice($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_223,axiom,
    topolo2564578578187576103pology($o) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_224,axiom,
    boolea8198339166811842893lgebra($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Ot2__space_225,axiom,
    topological_t2_space($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_226,axiom,
    semilattice_sup($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_227,axiom,
    semilattice_inf($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_228,axiom,
    order_top($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_229,axiom,
    order_bot($o) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_230,axiom,
    preorder($o) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_231,axiom,
    linorder($o) ).

tff(tcon_HOL_Obool___Lattices_Olattice_232,axiom,
    lattice($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder_233,axiom,
    order($o) ).

tff(tcon_HOL_Obool___Orderings_Oord_234,axiom,
    ord($o) ).

tff(tcon_HOL_Obool___Groups_Ouminus_235,axiom,
    uminus($o) ).

tff(tcon_HOL_Obool___Groups_Ominus_236,axiom,
    minus($o) ).

tff(tcon_List_Olist___Nat_Osize_237,axiom,
    ! [A11: $tType] : size(list(A11)) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_238,axiom,
    condit6923001295902523014norder(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_239,axiom,
    condit1219197933456340205attice(real) ).

tff(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_240,axiom,
    semiri1453513574482234551roduct(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_241,axiom,
    ordere1937475149494474687imp_le(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_242,axiom,
    semiri6575147826004484403cancel(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_243,axiom,
    strict9044650504122735259up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_244,axiom,
    ordere580206878836729694up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_245,axiom,
    ordere2412721322843649153imp_le(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_246,axiom,
    linord2810124833399127020strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_247,axiom,
    strict7427464778891057005id_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_248,axiom,
    ordere8940638589300402666id_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Otopological__space_249,axiom,
    topolo4958980785337419405_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_250,axiom,
    topolo1944317154257567458pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_251,axiom,
    archim462609752435547400_field(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_252,axiom,
    linord715952674999750819strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist(real) ).

tff(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_253,axiom,
    unboun7993243217541854897norder(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_254,axiom,
    topolo5987344860129210374id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_255,axiom,
    linord4140545234300271783up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_256,axiom,
    topolo2564578578187576103pology(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_257,axiom,
    semiri2026040879449505780visors(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_258,axiom,
    linord181362715937106298miring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_259,axiom,
    topolo4211221413907600880p_mult(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_260,axiom,
    linord8928482502909563296strict(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_261,axiom,
    semiri3467727345109120633visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_262,axiom,
    ordere6658533253407199908up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_263,axiom,
    ordere166539214618696060dd_abs(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_264,axiom,
    archim2362893244070406136eiling(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_265,axiom,
    ordere6911136660526730532id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_266,axiom,
    linord5086331880401160121up_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_267,axiom,
    cancel2418104881723323429up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ouniformity,axiom,
    topolo4638772830378233104ormity(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_268,axiom,
    ring_15535105094025558882visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__monoid__add_269,axiom,
    topolo6943815403480290642id_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_270,axiom,
    cancel1802427076303600483id_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring__strict_271,axiom,
    linord4710134922213307826strict(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_272,axiom,
    comm_s4317794764714335236cancel(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Odist__norm,axiom,
    real_V6936659425649961206t_norm(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ot2__space_273,axiom,
    topological_t2_space(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__comm__semiring_274,axiom,
    ordere2520102378445227354miring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1_275,axiom,
    linord6961819062388156250ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add_276,axiom,
    ordered_ab_group_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_277,axiom,
    cancel_semigroup_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring_278,axiom,
    linordered_semiring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring__0_279,axiom,
    ordered_semiring_0(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semidom_280,axiom,
    linordered_semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__linorder_281,axiom,
    dense_linorder(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__sup_282,axiom,
    semilattice_sup(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__inf_283,axiom,
    semilattice_inf(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__mult_284,axiom,
    ab_semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__cancel_285,axiom,
    semiring_1_cancel(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_286,axiom,
    comm_monoid_mult(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__add_287,axiom,
    ab_semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Olinordered__field_288,axiom,
    linordered_field(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring_289,axiom,
    ordered_semiring(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring__abs_290,axiom,
    ordered_ring_abs(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__add_291,axiom,
    comm_monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring_292,axiom,
    linordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__idom_293,axiom,
    linordered_idom(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1_294,axiom,
    comm_semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__0_295,axiom,
    comm_semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__order_296,axiom,
    dense_order(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__mult_297,axiom,
    semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom__divide_298,axiom,
    semidom_divide(real) ).

tff(tcon_Real_Oreal___Num_Osemiring__numeral_299,axiom,
    semiring_numeral(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__add_300,axiom,
    semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__abs__sgn_301,axiom,
    field_abs_sgn(real) ).

tff(tcon_Real_Oreal___Fields_Odivision__ring_302,axiom,
    division_ring(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__less__one_303,axiom,
    zero_less_one(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring_304,axiom,
    comm_semiring(real) ).

tff(tcon_Real_Oreal___Nat_Osemiring__char__0_305,axiom,
    semiring_char_0(real) ).

tff(tcon_Real_Oreal___Groups_Oab__group__add_306,axiom,
    ab_group_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__char__0_307,axiom,
    field_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__neq__one_308,axiom,
    zero_neq_one(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring_309,axiom,
    ordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__abs__sgn_310,axiom,
    idom_abs_sgn(real) ).

tff(tcon_Real_Oreal___Orderings_Opreorder_311,axiom,
    preorder(real) ).

tff(tcon_Real_Oreal___Orderings_Olinorder_312,axiom,
    linorder(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__mult_313,axiom,
    monoid_mult(real) ).

tff(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__divide_314,axiom,
    idom_divide(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring__1_315,axiom,
    comm_ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__add_316,axiom,
    monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1_317,axiom,
    semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__0_318,axiom,
    semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__top_319,axiom,
    no_top(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__bot_320,axiom,
    no_bot(real) ).

tff(tcon_Real_Oreal___Lattices_Olattice_321,axiom,
    lattice(real) ).

tff(tcon_Real_Oreal___Groups_Ogroup__add_322,axiom,
    group_add(real) ).

tff(tcon_Real_Oreal___Rings_Omult__zero_323,axiom,
    mult_zero(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring_324,axiom,
    comm_ring(real) ).

tff(tcon_Real_Oreal___Orderings_Oorder_325,axiom,
    order(real) ).

tff(tcon_Real_Oreal___Num_Oneg__numeral_326,axiom,
    neg_numeral(real) ).

tff(tcon_Real_Oreal___Nat_Oring__char__0_327,axiom,
    ring_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring_328,axiom,
    semiring(real) ).

tff(tcon_Real_Oreal___Fields_Oinverse_329,axiom,
    inverse(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom_330,axiom,
    semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Oord_331,axiom,
    ord(real) ).

tff(tcon_Real_Oreal___Groups_Ouminus_332,axiom,
    uminus(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1_333,axiom,
    ring_1(real) ).

tff(tcon_Real_Oreal___Rings_Oabs__if_334,axiom,
    abs_if(real) ).

tff(tcon_Real_Oreal___Groups_Ominus_335,axiom,
    minus(real) ).

tff(tcon_Real_Oreal___Fields_Ofield_336,axiom,
    field(real) ).

tff(tcon_Real_Oreal___Power_Opower_337,axiom,
    power(real) ).

tff(tcon_Real_Oreal___Num_Onumeral_338,axiom,
    numeral(real) ).

tff(tcon_Real_Oreal___Groups_Ozero_339,axiom,
    zero(real) ).

tff(tcon_Real_Oreal___Groups_Oplus_340,axiom,
    plus(real) ).

tff(tcon_Real_Oreal___Rings_Oring_341,axiom,
    ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom_342,axiom,
    idom(real) ).

tff(tcon_Real_Oreal___Groups_Oone_343,axiom,
    one(real) ).

tff(tcon_Real_Oreal___Rings_Odvd_344,axiom,
    dvd(real) ).

tff(tcon_String_Ochar___Nat_Osize_345,axiom,
    size(char) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_346,axiom,
    ! [A11: $tType] : condit1219197933456340205attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_347,axiom,
    ! [A11: $tType] : counta3822494911875563373attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_348,axiom,
    ! [A11: $tType] : bounde4967611905675639751up_bot(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_349,axiom,
    ! [A11: $tType] : bounde4346867609351753570nf_top(filter(A11)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_350,axiom,
    ! [A11: $tType] : comple6319245703460814977attice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_351,axiom,
    ! [A11: $tType] : semilattice_sup(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_352,axiom,
    ! [A11: $tType] : semilattice_inf(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_353,axiom,
    ! [A11: $tType] : order_top(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_354,axiom,
    ! [A11: $tType] : order_bot(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_355,axiom,
    ! [A11: $tType] : preorder(filter(A11)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_356,axiom,
    ! [A11: $tType] : lattice(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_357,axiom,
    ! [A11: $tType] : order(filter(A11)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_358,axiom,
    ! [A11: $tType] : ord(filter(A11)) ).

tff(tcon_Option_Ooption___Nat_Osize_359,axiom,
    ! [A11: $tType] : size(option(A11)) ).

tff(tcon_String_Oliteral___Groups_Osemigroup__add_360,axiom,
    semigroup_add(literal) ).

tff(tcon_String_Oliteral___Orderings_Opreorder_361,axiom,
    preorder(literal) ).

tff(tcon_String_Oliteral___Orderings_Olinorder_362,axiom,
    linorder(literal) ).

tff(tcon_String_Oliteral___Groups_Omonoid__add_363,axiom,
    monoid_add(literal) ).

tff(tcon_String_Oliteral___Orderings_Oorder_364,axiom,
    order(literal) ).

tff(tcon_String_Oliteral___Orderings_Oord_365,axiom,
    ord(literal) ).

tff(tcon_String_Oliteral___Groups_Ozero_366,axiom,
    zero(literal) ).

tff(tcon_String_Oliteral___Groups_Oplus_367,axiom,
    plus(literal) ).

tff(tcon_String_Oliteral___Nat_Osize_368,axiom,
    size(literal) ).

tff(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_369,axiom,
    semiri1453513574482234551roduct(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_370,axiom,
    topolo3112930676232923870pology(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_371,axiom,
    real_V8999393235501362500lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_372,axiom,
    real_V2822296259951069270ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_373,axiom,
    semiri6575147826004484403cancel(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_374,axiom,
    real_V4412858255891104859lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_375,axiom,
    real_V822414075346904944vector(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_376,axiom,
    topolo4958980785337419405_space(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_377,axiom,
    real_V3459762299906320749_field(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_378,axiom,
    real_V5047593784448816457lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_379,axiom,
    real_V768167426530841204y_dist(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_380,axiom,
    topolo5987344860129210374id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_381,axiom,
    semiri2026040879449505780visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_382,axiom,
    real_V2191834092415804123ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_383,axiom,
    real_V8037385150606011577_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_384,axiom,
    topolo4211221413907600880p_mult(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_385,axiom,
    topolo7287701948861334536_space(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_386,axiom,
    topolo8386298272705272623_space(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_387,axiom,
    semiri3467727345109120633visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_388,axiom,
    real_V7819770556892013058_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_389,axiom,
    topolo1287966508704411220up_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_390,axiom,
    real_V4867850818363320053vector(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_391,axiom,
    cancel2418104881723323429up_add(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ouniformity_392,axiom,
    topolo4638772830378233104ormity(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_393,axiom,
    ring_15535105094025558882visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_394,axiom,
    real_V7773925162809079976_field(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_395,axiom,
    topolo6943815403480290642id_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_396,axiom,
    cancel1802427076303600483id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_397,axiom,
    comm_s4317794764714335236cancel(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Odist__norm_398,axiom,
    real_V6936659425649961206t_norm(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__group__add_399,axiom,
    topolo1633459387980952147up_add(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_400,axiom,
    topological_t2_space(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_401,axiom,
    cancel_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_402,axiom,
    real_Vector_banach(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_403,axiom,
    ab_semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_404,axiom,
    semiring_1_cancel(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_405,axiom,
    comm_monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_406,axiom,
    ab_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_407,axiom,
    comm_monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_408,axiom,
    comm_semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_409,axiom,
    comm_semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_410,axiom,
    semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom__divide_411,axiom,
    semidom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Num_Osemiring__numeral_412,axiom,
    semiring_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__add_413,axiom,
    semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_414,axiom,
    field_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Odivision__ring_415,axiom,
    division_ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_416,axiom,
    comm_semiring(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_417,axiom,
    semiring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__group__add_418,axiom,
    ab_group_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__char__0_419,axiom,
    field_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_420,axiom,
    zero_neq_one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_421,axiom,
    idom_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__mult_422,axiom,
    monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__divide_423,axiom,
    idom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_424,axiom,
    comm_ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__add_425,axiom,
    monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1_426,axiom,
    semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__0_427,axiom,
    semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ogroup__add_428,axiom,
    group_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Omult__zero_429,axiom,
    mult_zero(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring_430,axiom,
    comm_ring(complex) ).

tff(tcon_Complex_Ocomplex___Num_Oneg__numeral_431,axiom,
    neg_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Oring__char__0_432,axiom,
    ring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring_433,axiom,
    semiring(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Oinverse_434,axiom,
    inverse(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom_435,axiom,
    semidom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ouminus_436,axiom,
    uminus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1_437,axiom,
    ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ominus_438,axiom,
    minus(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield_439,axiom,
    field(complex) ).

tff(tcon_Complex_Ocomplex___Power_Opower_440,axiom,
    power(complex) ).

tff(tcon_Complex_Ocomplex___Num_Onumeral_441,axiom,
    numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ozero_442,axiom,
    zero(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oplus_443,axiom,
    plus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring_444,axiom,
    ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom_445,axiom,
    idom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oone_446,axiom,
    one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Odvd_447,axiom,
    dvd(complex) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_448,axiom,
    condit6923001295902523014norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_449,axiom,
    condit1219197933456340205attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_450,axiom,
    counta3822494911875563373attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_451,axiom,
    strict9044650504122735259up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_452,axiom,
    strict7427464778891057005id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_453,axiom,
    canoni5634975068530333245id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_454,axiom,
    bounde4967611905675639751up_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_455,axiom,
    bounde4346867609351753570nf_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_456,axiom,
    linord4140545234300271783up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_457,axiom,
    comple6319245703460814977attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_458,axiom,
    linord181362715937106298miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_459,axiom,
    semiri3467727345109120633visors(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_460,axiom,
    ordere6658533253407199908up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_461,axiom,
    ordere6911136660526730532id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_462,axiom,
    ordere2520102378445227354miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_463,axiom,
    semilattice_sup(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_464,axiom,
    semilattice_inf(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_465,axiom,
    ab_semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_466,axiom,
    comm_monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_467,axiom,
    ab_semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_468,axiom,
    ordered_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_469,axiom,
    comm_monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_470,axiom,
    comm_semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_471,axiom,
    comm_semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_472,axiom,
    semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_473,axiom,
    semiring_numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_474,axiom,
    semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_475,axiom,
    zero_less_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_476,axiom,
    comm_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Owellorder_477,axiom,
    wellorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_478,axiom,
    order_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_479,axiom,
    order_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_480,axiom,
    semiring_char_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_481,axiom,
    zero_neq_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Opreorder_482,axiom,
    preorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Olinorder_483,axiom,
    linorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_484,axiom,
    monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_485,axiom,
    monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_486,axiom,
    semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_487,axiom,
    semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Olattice_488,axiom,
    lattice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Omult__zero_489,axiom,
    mult_zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder_490,axiom,
    order(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring_491,axiom,
    semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oord_492,axiom,
    ord(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ominus_493,axiom,
    minus(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Power_Opower_494,axiom,
    power(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Onumeral_495,axiom,
    numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ozero_496,axiom,
    zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oplus_497,axiom,
    plus(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oone_498,axiom,
    one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Odvd_499,axiom,
    dvd(extended_enat) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_500,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( topolo4958980785337419405_space(A11)
        & topolo4958980785337419405_space(A13) )
     => topolo4958980785337419405_space(product_prod(A11,A13)) ) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_501,axiom,
    ! [A11: $tType,A13: $tType] :
      ( ( topological_t2_space(A11)
        & topological_t2_space(A13) )
     => topological_t2_space(product_prod(A11,A13)) ) ).

tff(tcon_Product__Type_Oprod___Nat_Osize_502,axiom,
    ! [A11: $tType,A13: $tType] : size(product_prod(A11,A13)) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_503,axiom,
    condit6923001295902523014norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_504,axiom,
    condit1219197933456340205attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_505,axiom,
    counta3822494911875563373attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_506,axiom,
    bounde4967611905675639751up_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_507,axiom,
    bounde4346867609351753570nf_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_508,axiom,
    comple5582772986160207858norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_509,axiom,
    comple6319245703460814977attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_510,axiom,
    boolea8198339166811842893lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_511,axiom,
    semilattice_sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_512,axiom,
    semilattice_inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Owellorder_513,axiom,
    wellorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__top_514,axiom,
    order_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__bot_515,axiom,
    order_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Opreorder_516,axiom,
    preorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Olinorder_517,axiom,
    linorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Olattice_518,axiom,
    lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder_519,axiom,
    order(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oord_520,axiom,
    ord(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ouminus_521,axiom,
    uminus(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ominus_522,axiom,
    minus(product_unit) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_523,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_524,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_525,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_526,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_527,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_528,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_529,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_530,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_531,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_532,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_533,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_534,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_535,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_536,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_537,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_538,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_539,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_540,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_541,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_542,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_543,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_544,axiom,
    semiri2026040879449505780visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_545,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_546,axiom,
    euclid5891614535332579305n_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_547,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_548,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_549,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_550,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_551,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_552,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_553,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_554,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_555,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_556,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_557,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_558,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_559,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_560,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_561,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_562,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_563,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_564,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_565,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_566,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_567,axiom,
    semiring_1_cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_568,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_569,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_570,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_571,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_572,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_573,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_574,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_575,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_576,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_577,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_578,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_579,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_580,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_581,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_582,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_583,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_584,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_585,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_586,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_587,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_588,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_589,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_590,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_591,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_592,axiom,
    ring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_593,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_594,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_595,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_596,axiom,
    idom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_597,axiom,
    idom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_598,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_599,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_600,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_601,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_602,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_603,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_604,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_605,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_606,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_607,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_608,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom_609,axiom,
    semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_610,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_611,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_612,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_613,axiom,
    abs_if(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ominus_614,axiom,
    minus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_615,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_616,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_617,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oplus_618,axiom,
    plus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_619,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_620,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_621,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_622,axiom,
    dvd(code_integer) ).

tff(tcon_VEBT__Definitions_OVEBT___Nat_Osize_623,axiom,
    size(vEBT_VEBT) ).

% Helper facts (3)
tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( X != Y )
      | aa(A,$o,aa(A,fun(A,$o),fequal(A),X),Y) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ~ aa(A,$o,aa(A,fun(A,$o),fequal(A),X),Y)
      | ( X = Y ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( aa(A,$o,P,fChoice(A,P))
      = ( ? [X8: A] : aa(A,$o,P,X8) ) ) ).

% Free types (2)
tff(tfree_0,hypothesis,
    real_V4867850818363320053vector(a) ).

tff(tfree_1,hypothesis,
    semiring_1(a) ).

% Conjectures (1)
tff(conj_0,conjecture,
    ! [X_1: nat] : ~ aa(nat,$o,vEBT_V8194947554948674370ptions(vEBT_vebt_buildup(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),divide_divide(nat),aa(nat,nat,suc,aa(nat,nat,suc,va))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))))),X_1) ).

%------------------------------------------------------------------------------
