%------------------------------------------------------------------------------
% File     : VBT00018^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00569_026210
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00569_026210 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9493 (3037 unt; 562 typ;   0 def)
%            Number of atoms       : 27592 (9331 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 167204 (2012   ~; 334   |;2179   &;150223   @)
%                                         (   0 <=>;12456  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   11 (  10 usr)
%            Number of type conns  : 3439 (3439   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  556 ( 552 usr;  12 con; 0-9 aty)
%            Number of variables   : 28435 (2456   ^24640   !; 834   ?;28435   :)
%                                         ( 505  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 17:44:18.270
%------------------------------------------------------------------------------
% Could-be-implicit typings (16)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (546)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onegative,type,
    code_negative: num > code_integer ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opositive,type,
    code_positive: num > code_integer ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T ) ).

thf(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

thf(sy_c_Extended__Nat_Othe__enat,type,
    extended_the_enat: extended_enat > nat ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( list @ A ) ) > ( product_prod @ ( A > B ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Ocan__select,type,
    can_select: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__ex1,type,
    list_ex1: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omember,type,
    member: 
      !>[A: $tType] : ( ( list @ A ) > A > $o ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocomplete,type,
    topolo2479028161051973599mplete: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead,type,
    vEBT_VEBT_elim_dead: vEBT_VEBT > extended_enat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead__rel,type,
    vEBT_V312737461966249ad_rel: ( product_prod @ vEBT_VEBT @ extended_enat ) > ( product_prod @ vEBT_VEBT @ extended_enat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member2: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_dega____,type,
    dega: nat ).

thf(sy_v_i____,type,
    i: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summarya____,type,
    summarya: vEBT_VEBT ).

thf(sy_v_treeLista____,type,
    treeLista: list @ vEBT_VEBT ).

% Relevant facts (8183)
thf(fact_0__C2_Ohyps_C_I3_J,axiom,
    m = na ).

% "2.hyps"(3)
thf(fact_1__092_060open_062i_A_060_A2_A_094_Am_092_060close_062,axiom,
    ord_less @ nat @ i @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ).

% \<open>i < 2 ^ m\<close>
thf(fact_2__C2_Ohyps_C_I6_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeLista ) )
     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ).

% "2.hyps"(6)
thf(fact_3_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,N: nat] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ N ) ) ) ) ).

% inthall
thf(fact_4__C2_Ohyps_C_I2_J,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeLista )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "2.hyps"(2)
thf(fact_5_intind,axiom,
    ! [A: $tType,I: nat,N: nat,P: A > $o,X3: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( P @ X3 )
       => ( P @ ( nth @ A @ ( replicate @ A @ N @ X3 ) @ I ) ) ) ) ).

% intind
thf(fact_6_in__set__member,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
      = ( member @ A @ Xs @ X3 ) ) ).

% in_set_member
thf(fact_7__C2_OIH_C_I1_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeLista ) )
     => ( ( vEBT_invar_vebt @ X @ na )
        & ( ( vEBT_VEBT_elim_dead @ X @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) )
          = X ) ) ) ).

% "2.IH"(1)
thf(fact_8_in__set__insert,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X3 @ Xs )
        = Xs ) ) ).

% in_set_insert
thf(fact_9_list__ex1__iff,axiom,
    ! [A: $tType] :
      ( ( list_ex1 @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] :
          ? [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs2 ) )
            & ( P2 @ X4 )
            & ! [Y: A] :
                ( ( ( member2 @ A @ Y @ ( set2 @ A @ Xs2 ) )
                  & ( P2 @ Y ) )
               => ( Y = X4 ) ) ) ) ) ).

% list_ex1_iff
thf(fact_10_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member2 @ A @ ( nth @ A @ Xs @ N ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_11_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) )
       => ( P @ ( nth @ A @ Xs @ N ) ) ) ) ).

% list_ball_nth
thf(fact_12_in__set__conv__nth,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
      = ( ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I2 )
              = X3 ) ) ) ) ).

% in_set_conv_nth
thf(fact_13_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,X3: A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I3 ) ) )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( P @ X3 ) ) ) ).

% all_nth_imp_all_set
thf(fact_14_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) )
      = ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_15__C2_Ohyps_C_I5_J,axiom,
    ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ summarya @ X_1 ) ).

% "2.hyps"(5)
thf(fact_16__C2_Ohyps_C_I1_J,axiom,
    vEBT_invar_vebt @ summarya @ m ).

% "2.hyps"(1)
thf(fact_17__C2_OIH_C_I2_J,axiom,
    ( ( vEBT_VEBT_elim_dead @ summarya @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) )
    = summarya ) ).

% "2.IH"(2)
thf(fact_18_length__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N @ X3 ) )
      = N ) ).

% length_replicate
thf(fact_19_nth__replicate,axiom,
    ! [A: $tType,I: nat,N: nat,X3: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X3 ) @ I )
        = X3 ) ) ).

% nth_replicate
thf(fact_20_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs3: list @ A] :
          ( ! [Ys: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P @ Ys ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs ) ) ).

% length_induct
thf(fact_21_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X3: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N )
     => ( ! [Y2: A] :
            ( ( member2 @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( Y2 = X3 ) )
       => ( Xs
          = ( replicate @ A @ N @ X3 ) ) ) ) ).

% replicate_eqI
thf(fact_22_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs3: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs3 )
      = N ) ).

% Ex_list_of_length
thf(fact_23_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( Xs != Ys2 ) ) ).

% neq_if_length_neq
thf(fact_24_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( X2 = X3 ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X3 )
        = Xs ) ) ).

% replicate_length_same
thf(fact_25_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z: list @ A] : ( Y3 = Z ) )
      = ( ^ [Xs2: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( nth @ A @ Xs2 @ I2 )
                  = ( nth @ A @ Ys3 @ I2 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_26_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ K )
           => ? [X5: A] : ( P @ I2 @ X5 ) ) )
      = ( ? [Xs2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = K )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ K )
               => ( P @ I2 @ ( nth @ A @ Xs2 @ I2 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_27_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I3 )
              = ( nth @ A @ Ys2 @ I3 ) ) )
       => ( Xs = Ys2 ) ) ) ).

% nth_equalityI
thf(fact_28__C2_Ohyps_C_I4_J,axiom,
    ( dega
    = ( plus_plus @ nat @ na @ m ) ) ).

% "2.hyps"(4)
thf(fact_29_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_30_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_31_semiring__norm_I83_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) ).

% semiring_norm(83)
thf(fact_32_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_33_can__select__set__list__ex1,axiom,
    ! [A: $tType,P: A > $o,A2: list @ A] :
      ( ( can_select @ A @ P @ ( set2 @ A @ A2 ) )
      = ( list_ex1 @ A @ P @ A2 ) ) ).

% can_select_set_list_ex1
thf(fact_34_enat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( extended_enat2 @ Nat )
        = ( extended_enat2 @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% enat.inject
thf(fact_35_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_36_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_37_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_38_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_39_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(87)
thf(fact_40_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_41_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_42_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z2 ) ) ) ).

% add_numeral_left
thf(fact_43_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(2)
thf(fact_44_mem__Collect__eq,axiom,
    ! [A: $tType,A3: A,P: A > $o] :
      ( ( member2 @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) ).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( collect @ A
        @ ^ [X4: A] : ( member2 @ A @ X4 @ A2 ) )
      = A2 ) ).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_47_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X2: A] :
          ( ( F2 @ X2 )
          = ( G @ X2 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_48_enat__ord__simps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% enat_ord_simps(2)
thf(fact_49_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_50_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_51_numeral__less__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_less_enat_iff
thf(fact_52_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_53_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_54_enat__iless,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K2: nat] :
          ( N
          = ( extended_enat2 @ K2 ) ) ) ).

% enat_iless
thf(fact_55_chain__incr,axiom,
    ! [A: $tType,Y4: A > extended_enat,K: nat] :
      ( ! [I3: A] :
        ? [J: A] : ( ord_less @ extended_enat @ ( Y4 @ I3 ) @ ( Y4 @ J ) )
     => ? [J2: A] : ( ord_less @ extended_enat @ ( extended_enat2 @ K ) @ ( Y4 @ J2 ) ) ) ).

% chain_incr
thf(fact_56_can__select__def,axiom,
    ! [A: $tType] :
      ( ( can_select @ A )
      = ( ^ [P2: A > $o,A4: set @ A] :
          ? [X4: A] :
            ( ( member2 @ A @ X4 @ A4 )
            & ( P2 @ X4 )
            & ! [Y: A] :
                ( ( ( member2 @ A @ Y @ A4 )
                  & ( P2 @ Y ) )
               => ( Y = X4 ) ) ) ) ) ).

% can_select_def
thf(fact_57_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_58_numeral__eq__enat,axiom,
    ( ( numeral_numeral @ extended_enat )
    = ( ^ [K3: num] : ( extended_enat2 @ ( numeral_numeral @ nat @ K3 ) ) ) ) ).

% numeral_eq_enat
thf(fact_59_less__enatE,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ~ ! [K2: nat] :
            ( ( N
              = ( extended_enat2 @ K2 ) )
           => ~ ( ord_less @ nat @ K2 @ M ) ) ) ).

% less_enatE
thf(fact_60_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ A3 ) ) ).

% verit_comp_simplify1(1)
thf(fact_61_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_62_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_63_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_64_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_65_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_66_pow__sum,axiom,
    ! [A3: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A3 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A3 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_67_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_68_the__enat_Osimps,axiom,
    ! [N: nat] :
      ( ( extended_the_enat @ ( extended_enat2 @ N ) )
      = N ) ).

% the_enat.simps
thf(fact_69_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_70_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_71_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_72_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% deg_not_0
thf(fact_73_enat_Osimps_I4_J,axiom,
    ! [T: $tType,F1: nat > T,F22: T,Nat: nat] :
      ( ( extended_case_enat @ T @ F1 @ F22 @ ( extended_enat2 @ Nat ) )
      = ( F1 @ Nat ) ) ).

% enat.simps(4)
thf(fact_74_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X4: nat,N2: nat] : ( divide_divide @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% high_def
thf(fact_75_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_76_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% add.right_neutral
thf(fact_77_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A3 @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_78_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = A3 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_79_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = A3 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_80_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ B2 @ A3 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_81_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ A3 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_82_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( plus_plus @ A @ X3 @ Y5 )
            = ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y5
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_83_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X3 @ Y5 ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y5
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_84_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% add_0
thf(fact_85_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A3: nat] :
      ( ( ( A3
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A3 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_86_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_87_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_88_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_89_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_90_plus__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( plus_plus @ nat @ M @ N ) ) ) ).

% plus_enat_simps(1)
thf(fact_91_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X3: A,N: nat,Y5: A] :
      ( ( ( replicate @ A @ M @ X3 )
        = ( replicate @ A @ N @ Y5 ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X3 = Y5 ) ) ) ) ).

% replicate_eq_replicate
thf(fact_92_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(6)
thf(fact_93_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_94_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_95_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_96_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_97_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_98_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_99_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_100_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_101_nat__zero__less__power__iff,axiom,
    ! [X3: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X3 @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_102_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_103_in__set__replicate,axiom,
    ! [A: $tType,X3: A,N: nat,Y5: A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ ( replicate @ A @ N @ Y5 ) ) )
      = ( ( X3 = Y5 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_104_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A3: A,P: A > $o] :
      ( ( ? [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ ( replicate @ A @ N @ A3 ) ) )
            & ( P @ X4 ) ) )
      = ( ( P @ A3 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_105_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A3: A,P: A > $o] :
      ( ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ ( replicate @ A @ N @ A3 ) ) )
           => ( P @ X4 ) ) )
      = ( ( P @ A3 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_106_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A3: A,N: nat] :
          ( ( ( power_power @ A @ A3 @ N )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_107_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A3: A] :
          ( ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_108_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_109_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y5
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_110_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% enat_less_induct
thf(fact_111_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X3: A] :
          ( ( ( zero_zero @ A )
            = X3 )
          = ( X3
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_112_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member2 @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_113_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_114_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_115_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_116_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_117_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_118_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% add.comm_neutral
thf(fact_119_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% add.group_left_neutral
thf(fact_120_bot__nat__0_Oextremum__strict,axiom,
    ! [A3: nat] :
      ~ ( ord_less @ nat @ A3 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_121_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_122_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_123_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_124_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_125_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_126_infinite__descent0,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N3 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) ).

% infinite_descent0
thf(fact_127_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X3: A] :
      ( ! [X2: A] :
          ( ( ( V2 @ X2 )
            = ( zero_zero @ nat ) )
         => ( P @ X2 ) )
     => ( ! [X2: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X2 ) )
           => ( ~ ( P @ X2 )
             => ? [Y6: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y6 ) @ ( V2 @ X2 ) )
                  & ~ ( P @ Y6 ) ) ) )
       => ( P @ X3 ) ) ) ).

% infinite_descent0_measure
thf(fact_128_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_129_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_130_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_131_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A3 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_132_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_133_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_134_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_135_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% verit_sum_simplify
thf(fact_136_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A3: A,N: nat] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A3 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_137_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_138_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A3 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_139_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_140_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_141_less__imp__add__positive,axiom,
    ! [I: nat,J3: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I @ K2 )
            = J3 ) ) ) ).

% less_imp_add_positive
thf(fact_142_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_143_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% half_gt_zero_iff
thf(fact_144_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ one2 ) )
          = A3 ) ) ).

% divide_numeral_1
thf(fact_145_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_146_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_147_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% zero_less_power
thf(fact_148_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_149_pow_Osimps_I1_J,axiom,
    ! [X3: num] :
      ( ( pow @ X3 @ one2 )
      = X3 ) ).

% pow.simps(1)
thf(fact_150_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X3: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_151_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A3: A] :
          ( ! [X2: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ B @ ( F2 @ Y6 ) @ ( F2 @ X2 ) )
                 => ( P @ Y6 ) )
             => ( P @ X2 ) )
         => ( P @ A3 ) ) ) ).

% measure_induct
thf(fact_152_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A3: A] :
          ( ! [X2: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ B @ ( F2 @ Y6 ) @ ( F2 @ X2 ) )
                 => ( P @ Y6 ) )
             => ( P @ X2 ) )
         => ( P @ A3 ) ) ) ).

% measure_induct_rule
thf(fact_153_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_154_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( I = J3 )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_155_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A,K: A,A3: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_156_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_157_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_158_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_159_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_160_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ B4 @ A5 ) ) ) ) ).

% add.commute
thf(fact_161_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_162_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_163_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_164_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_165_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_166_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_167_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_168_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_169_nat__less__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% nat_less_induct
thf(fact_170_infinite__descent,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) ).

% infinite_descent
thf(fact_171_linorder__neqE__nat,axiom,
    ! [X3: nat,Y5: nat] :
      ( ( X3 != Y5 )
     => ( ~ ( ord_less @ nat @ X3 @ Y5 )
       => ( ord_less @ nat @ Y5 @ X3 ) ) ) ).

% linorder_neqE_nat
thf(fact_172_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X3: A] :
      ( ! [X2: A] :
          ( ~ ( P @ X2 )
         => ? [Y6: A] :
              ( ( ord_less @ nat @ ( V2 @ Y6 ) @ ( V2 @ X2 ) )
              & ~ ( P @ Y6 ) ) )
     => ( P @ X3 ) ) ).

% infinite_descent_measure
thf(fact_173_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( size_size @ A @ X3 )
           != ( size_size @ A @ Y5 ) )
         => ( X3 != Y5 ) ) ) ).

% size_neq_size_imp_neq
thf(fact_174_length__pos__if__in__set,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_175_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_176_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_177_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_178_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X3
             != ( zero_zero @ A ) )
            | ( Y5
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_179_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J3 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_180_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( I = J3 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_181_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J3 )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_182_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_183_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_184_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_185_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_186_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_187_add__lessD1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ J3 ) @ K )
     => ( ord_less @ nat @ I @ K ) ) ).

% add_lessD1
thf(fact_188_add__less__mono,axiom,
    ! [I: nat,J3: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J3 @ L ) ) ) ) ).

% add_less_mono
thf(fact_189_not__add__less1,axiom,
    ! [I: nat,J3: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I @ J3 ) @ I ) ).

% not_add_less1
thf(fact_190_not__add__less2,axiom,
    ! [J3: nat,I: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J3 @ I ) @ I ) ).

% not_add_less2
thf(fact_191_add__less__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J3 @ K ) ) ) ).

% add_less_mono1
thf(fact_192_trans__less__add1,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ J3 @ M ) ) ) ).

% trans_less_add1
thf(fact_193_trans__less__add2,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ M @ J3 ) ) ) ).

% trans_less_add2
thf(fact_194_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_195_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_196_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N ) @ N ) ) ).

% buildup_gives_valid
thf(fact_197_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_198_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_199_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_200_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_201_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ord_less @ A @ X3 @ ( divide_divide @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_202_high__inv,axiom,
    ! [X3: nat,N: nat,Y5: nat] :
      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X3 ) @ N )
        = Y5 ) ) ).

% high_inv
thf(fact_203_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_204_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X3 ) ) ).

% field_sum_of_halves
thf(fact_205_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_206_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_207_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_208_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_209_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A3 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_210_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_211_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_212_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_213_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_214_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_215_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_216_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_217_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_218_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_219_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A3 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_220_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_221_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_222_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_223_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_224_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_225_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_226_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_227_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_228_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_229_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_230_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y5 @ Y5 ) )
            = ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y5
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_231_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_232_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_233_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_234_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_235_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ B2 )
            = A3 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_236_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_237_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_238_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ A3 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_239_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_240_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_241_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_242_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A3: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_243_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_244_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_245_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_246_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_247_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_248_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A3 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_249_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_250_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A3 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_251_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_252_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_253_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A3 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_254_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_255_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_256_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_257_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_258_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_259_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_260_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_261_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_262_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ B4 @ A5 ) ) ) ) ).

% mult.commute
thf(fact_263_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_264_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A3 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A3 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_265_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A3 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A3 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_266_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A3 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_267_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_268_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A3
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_269_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,E: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ E ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_270_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_271_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_272_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_273_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_274_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_275_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_276_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y5: A,Z2: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X3 @ W ) @ ( times_times @ A @ Y5 @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_277_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y5: A,Z2: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ Y5 @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_278_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_279_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A,Y5: A,N: nat] :
          ( ( ( times_times @ A @ X3 @ Y5 )
            = ( times_times @ A @ Y5 @ X3 ) )
         => ( ( times_times @ A @ ( power_power @ A @ X3 @ N ) @ Y5 )
            = ( times_times @ A @ Y5 @ ( power_power @ A @ X3 @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_280_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A3 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_281_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ A3 )
          = ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_commutes
thf(fact_282_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( power_power @ A @ A3 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A3 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_283_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_284_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_285_left__add__mult__distrib,axiom,
    ! [I: nat,U: nat,J3: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I @ J3 ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_286_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_287_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_288_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_289_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_290_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_291_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_292_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_293_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_294_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_295_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_296_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_297_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A3 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_298_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_299_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_300_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_301_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_302_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_303_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_304_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_305_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A3 @ A3 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_306_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_307_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A3
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A3 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_308_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A3 )
            = ( B2
              = ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_309_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A3 @ C2 )
              = B2 )
           => ( A3
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_310_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A3 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A3 ) ) ) ) ).

% divide_eq_imp
thf(fact_311_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_312_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A3 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_313_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y5: A,Z2: A,X3: A,W: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X3 @ Y5 )
                = ( divide_divide @ A @ W @ Z2 ) )
              = ( ( times_times @ A @ X3 @ Z2 )
                = ( times_times @ A @ W @ Y5 ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_314_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I ) ) ).

% less_mult_imp_div_less
thf(fact_315_realpow__pos__nth__unique,axiom,
    ! [N: nat,A3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
       => ? [X2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
            & ( ( power_power @ real @ X2 @ N )
              = A3 )
            & ! [Y6: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y6 )
                  & ( ( power_power @ real @ Y6 @ N )
                    = A3 ) )
               => ( Y6 = X2 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_316_realpow__pos__nth,axiom,
    ! [N: nat,A3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ( ( power_power @ real @ R @ N )
              = A3 ) ) ) ) ).

% realpow_pos_nth
thf(fact_317_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_318_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X3: A,Y5: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y5 @ Y5 ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_319_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_320_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_321_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,Z2: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y5 ) @ X3 )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_322_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,X3: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( ord_less @ A @ X3 @ ( times_times @ A @ Z2 @ Y5 ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_323_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_324_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_325_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_326_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_327_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_328_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_329_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_330_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_331_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y5: A,Z2: A,X3: A,W: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W @ Y5 ) ) @ ( times_times @ A @ Y5 @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_332_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y5: A,X3: A,Z2: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X3 @ ( times_times @ A @ Z2 @ Y5 ) ) @ Y5 ) ) ) ) ).

% add_frac_num
thf(fact_333_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y5: A,Z2: A,X3: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X3 @ Y5 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X3 @ ( times_times @ A @ Z2 @ Y5 ) ) @ Y5 ) ) ) ) ).

% add_num_frac
thf(fact_334_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X3 @ ( divide_divide @ A @ Y5 @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ Z2 ) @ Y5 ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_335_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ Y5 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X3 @ ( times_times @ A @ Y5 @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_336_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( numeral_numeral @ A @ one2 ) )
          = A3 ) ) ).

% mult_numeral_1_right
thf(fact_337_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A3 )
          = A3 ) ) ).

% mult_numeral_1
thf(fact_338_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q2 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_339_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( power_power @ A @ A3 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_add
thf(fact_340_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_341_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_342_mult__less__mono2,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J3 ) ) ) ) ).

% mult_less_mono2
thf(fact_343_mult__less__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J3 @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_344_enat__0__iff_I2_J,axiom,
    ! [X3: nat] :
      ( ( ( zero_zero @ extended_enat )
        = ( extended_enat2 @ X3 ) )
      = ( X3
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(2)
thf(fact_345_enat__0__iff_I1_J,axiom,
    ! [X3: nat] :
      ( ( ( extended_enat2 @ X3 )
        = ( zero_zero @ extended_enat ) )
      = ( X3
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(1)
thf(fact_346_zero__enat__def,axiom,
    ( ( zero_zero @ extended_enat )
    = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% zero_enat_def
thf(fact_347_split__div,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I2: nat,J4: nat] :
              ( ( ord_less @ nat @ J4 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I2 ) @ J4 ) )
               => ( P @ I2 ) ) ) ) ) ) ).

% split_div
thf(fact_348_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_349_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_350_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y5 @ Y5 ) ) )
          = ( ( X3
             != ( zero_zero @ A ) )
            | ( Y5
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_351_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_352_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_353_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( X3 != Y5 )
         => ( ~ ( ord_less @ A @ X3 @ Y5 )
           => ( ord_less @ A @ Y5 @ X3 ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_354_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
        ? [X_12: A] : ( ord_less @ A @ X @ X_12 ) ) ).

% linordered_field_no_ub
thf(fact_355_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
        ? [Y2: A] : ( ord_less @ A @ Y2 @ X ) ) ).

% linordered_field_no_lb
thf(fact_356_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_357_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_358_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_359_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_360_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_361_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_362_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A3 @ A3 ) ) ) ).

% power2_eq_square
thf(fact_363_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A] :
          ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X3 @ X3 ) @ X3 ) @ X3 ) ) ) ).

% power4_eq_xxxx
thf(fact_364_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A3 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_365_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_366_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X3: A,Y5: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) @ Y5 ) ) ) ) ).

% power2_sum
thf(fact_367_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E2: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
                & ( ord_less @ A @ E2 @ D1 )
                & ( ord_less @ A @ E2 @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_368_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_369_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X3 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y5 @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_370_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_371_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_372_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_373_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_374_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_375_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% divide_pos_pos
thf(fact_376_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_377_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_378_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% divide_neg_neg
thf(fact_379_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_380_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit0_div_2
thf(fact_381_low__inv,axiom,
    ! [X3: nat,N: nat,Y5: nat] :
      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X3 ) @ N )
        = X3 ) ) ).

% low_inv
thf(fact_382_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( plus_plus @ A @ A3 @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_383_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X3: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N ) @ X3 ) ).

% buildup_nothing_in_leaf
thf(fact_384_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_385_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ! [X2: list @ A] :
          ( ( member2 @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X2 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N ) ) ) ).

% length_mul_elem
thf(fact_386_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R2: A,A3: A,B2: A,C2: A,D2: A] :
          ( ( R2
           != ( zero_zero @ A ) )
         => ( ( ( A3 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A3 @ ( times_times @ A @ R2 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R2 @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_387_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ Y5 @ Z2 ) )
            = ( ord_less @ A @ X3 @ Y5 ) ) ) ) ).

% mult_less_iff1
thf(fact_388_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X3: A,Y5: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X3 @ Y5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_389_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_390_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X3: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N ) @ X3 ) ).

% buildup_nothing_in_min_max
thf(fact_391_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X3: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X3 @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_392_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X4: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X4 )
          | ( vEBT_VEBT_membermima @ T3 @ X4 ) ) ) ) ).

% both_member_options_def
thf(fact_393_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_394_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_395_bot__nat__0_Oextremum,axiom,
    ! [A3: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A3 ) ).

% bot_nat_0.extremum
thf(fact_396_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_397_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_398_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_399_enat__ord__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% enat_ord_simps(1)
thf(fact_400_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_401_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_402_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_403_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_404_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_405_not__real__square__gt__zero,axiom,
    ! [X3: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X3 @ X3 ) ) )
      = ( X3
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_406_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_407_times__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( times_times @ nat @ M @ N ) ) ) ).

% times_enat_simps(1)
thf(fact_408_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ).

% semiring_norm(13)
thf(fact_409_semiring__norm_I12_J,axiom,
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) ).

% semiring_norm(12)
thf(fact_410_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_411_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_412_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_413_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_414_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_415_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_416_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_417_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_418_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_419_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_420_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_421_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_422_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_423_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_424_numeral__le__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_le_enat_iff
thf(fact_425_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A3 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_426_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_427_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_428_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_429_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_430_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X3 = Y5 ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_431_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_432_split__zdiv,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I2: int,J4: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J4 )
                & ( ord_less @ int @ J4 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I2 ) @ J4 ) ) )
             => ( P @ I2 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I2: int,J4: int] :
              ( ( ( ord_less @ int @ K @ J4 )
                & ( ord_less_eq @ int @ J4 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I2 ) @ J4 ) ) )
             => ( P @ I2 ) ) ) ) ) ).

% split_zdiv
thf(fact_433_zdiv__mono1,axiom,
    ! [A3: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_434_zdiv__mono2,axiom,
    ! [A3: int,B5: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( divide_divide @ int @ A3 @ B5 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_435_q__pos__lemma,axiom,
    ! [B5: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
     => ( ( ord_less @ int @ R3 @ B5 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q3 ) ) ) ) ).

% q_pos_lemma
thf(fact_436_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( divide_divide @ int @ I @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_437_zmult__zless__mono2,axiom,
    ! [I: int,J3: int,K: int] :
      ( ( ord_less @ int @ I @ J3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I ) @ ( times_times @ int @ K @ J3 ) ) ) ) ).

% zmult_zless_mono2
thf(fact_438_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X4: real,Y: real] :
          ( ( ord_less @ real @ X4 @ Y )
          | ( X4 = Y ) ) ) ) ).

% less_eq_real_def
thf(fact_439_int__div__neg__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( divide_divide @ int @ A3 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_440_int__div__pos__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( divide_divide @ int @ A3 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_441_zdiv__mono1__neg,axiom,
    ! [A3: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A3 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_442_zdiv__mono2__neg,axiom,
    ! [A3: int,B5: int,B2: int] :
      ( ( ord_less @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A3 @ B5 ) @ ( divide_divide @ int @ A3 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_443_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_444_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_445_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R2: int,B5: int,Q3: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
       => ( ( ord_less @ int @ R3 @ B5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q3 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_446_div__neg__pos__less0,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_447_div__nonneg__neg__le0,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_448_div__nonpos__pos__le0,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_449_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A3 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_450_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A3 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_451_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I @ K ) )
        = ( ord_less_eq @ int @ K @ I ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_452_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R2: int,B5: int,Q3: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q3 ) @ R3 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q3 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_453_unique__quotient__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,Q2: int,R2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less @ int @ R2 @ B2 )
           => ( ord_less_eq @ int @ Q3 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_454_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A3 @ B2 ) )
        = ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_455_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A3 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_456_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A3 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A3 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_457_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q3: int,R3: int,Q2: int,R2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( ord_less @ int @ B2 @ R3 )
           => ( ord_less_eq @ int @ Q2 @ Q3 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_458_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_459_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_460_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_461_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_462_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_463_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_464_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_465_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_466_zdiv__zmult2__eq,axiom,
    ! [C2: int,A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A3 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A3 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_467_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
          | ~ ( ord_less_eq @ A @ A3 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% verit_la_disequality
thf(fact_468_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ A3 ) ) ).

% verit_comp_simplify1(2)
thf(fact_469_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_470_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) ) ).

% zero_le
thf(fact_471_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B5: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B5 @ A6 ) )
          = ( ord_less @ B @ A6 @ B5 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_472_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J3 )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_473_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( I = J3 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_474_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J3 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_475_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_476_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_477_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A3 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_478_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_479_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
            ? [C4: A] :
              ( B4
              = ( plus_plus @ A @ A5 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_480_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_481_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_482_le__num__One__iff,axiom,
    ! [X3: num] :
      ( ( ord_less_eq @ num @ X3 @ one2 )
      = ( X3 = one2 ) ) ).

% le_num_One_iff
thf(fact_483_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_484_bot__nat__0_Oextremum__unique,axiom,
    ! [A3: nat] :
      ( ( ord_less_eq @ nat @ A3 @ ( zero_zero @ nat ) )
      = ( A3
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_485_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A3: nat] :
      ( ( ord_less_eq @ nat @ A3 @ ( zero_zero @ nat ) )
     => ( A3
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_486_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_487_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M3 @ N2 )
          & ( M3 != N2 ) ) ) ) ).

% nat_less_le
thf(fact_488_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_489_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( ( ord_less @ nat @ M3 @ N2 )
          | ( M3 = N2 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_490_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_491_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_492_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I: nat,J3: nat] :
      ( ! [I3: nat,J2: nat] :
          ( ( ord_less @ nat @ I3 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I3 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I @ J3 )
       => ( ord_less_eq @ nat @ ( F2 @ I ) @ ( F2 @ J3 ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_493_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B3 )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( member2 @ A @ X4 @ B3 ) ) ) ) ).

% subset_code(1)
thf(fact_494_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_495_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_496_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_497_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_498_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_499_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_500_add__le__mono,axiom,
    ! [I: nat,J3: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J3 @ L ) ) ) ) ).

% add_le_mono
thf(fact_501_add__le__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J3 @ K ) ) ) ).

% add_le_mono1
thf(fact_502_trans__le__add1,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J3 @ M ) ) ) ).

% trans_le_add1
thf(fact_503_trans__le__add2,axiom,
    ! [I: nat,J3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J3 ) ) ) ).

% trans_le_add2
thf(fact_504_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N2: nat] :
        ? [K3: nat] :
          ( N2
          = ( plus_plus @ nat @ M3 @ K3 ) ) ) ) ).

% nat_le_iff_add
thf(fact_505_mult__le__mono2,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J3 ) ) ) ).

% mult_le_mono2
thf(fact_506_mult__le__mono1,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J3 @ K ) ) ) ).

% mult_le_mono1
thf(fact_507_mult__le__mono,axiom,
    ! [I: nat,J3: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J3 @ L ) ) ) ) ).

% mult_le_mono
thf(fact_508_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_509_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_510_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_511_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_512_enat__ile,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K2: nat] :
          ( N
          = ( extended_enat2 @ K2 ) ) ) ).

% enat_ile
thf(fact_513_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_514_L2__set__mult__ineq__lemma,axiom,
    ! [A3: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A3 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_515_iadd__le__enat__iff,axiom,
    ! [X3: extended_enat,Y5: extended_enat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ X3 @ Y5 ) @ ( extended_enat2 @ N ) )
      = ( ? [Y7: nat,X6: nat] :
            ( ( X3
              = ( extended_enat2 @ X6 ) )
            & ( Y5
              = ( extended_enat2 @ Y7 ) )
            & ( ord_less_eq @ nat @ ( plus_plus @ nat @ X6 @ Y7 ) @ N ) ) ) ) ).

% iadd_le_enat_iff
thf(fact_516_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ Y5 @ Z2 ) )
            = ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_517_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X3 ) @ ( times_times @ A @ Z2 @ Y5 ) )
            = ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_518_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( ( divide_divide @ A @ A3 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_519_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_520_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_521_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_522_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_523_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_524_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_525_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_526_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_527_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_528_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_529_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_530_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_531_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_532_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_533_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_534_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_535_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_536_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_537_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ A3 ) ) ) ).

% zero_le_square
thf(fact_538_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_539_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_540_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X3 @ Y5 )
                = ( zero_zero @ A ) )
              = ( ( X3
                  = ( zero_zero @ A ) )
                & ( Y5
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_541_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ( ( plus_plus @ A @ X3 @ Y5 )
                = ( zero_zero @ A ) )
              = ( ( X3
                  = ( zero_zero @ A ) )
                & ( Y5
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_542_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_543_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_544_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_545_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_546_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_547_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_548_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_549_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_550_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_551_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J3 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_552_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J3: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J3 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_553_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_554_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_555_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_556_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_557_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_558_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_559_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_560_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A3 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_561_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% zero_le_power
thf(fact_562_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_563_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_564_ex__least__nat__le,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K2 )
               => ~ ( P @ I4 ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_565_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less @ nat @ M4 @ N3 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_566_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_567_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_568_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_569_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_570_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_571_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_572_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_573_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_574_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_575_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_576_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_577_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_578_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_579_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_580_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_581_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_582_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_583_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_584_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_585_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_586_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_587_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_588_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ X3 @ ( plus_plus @ A @ Y5 @ E2 ) ) )
         => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% field_le_epsilon
thf(fact_589_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y5 @ Y5 ) ) @ ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y5
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_590_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y5 @ Y5 ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_591_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,X3: A,W: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z2 )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ ( divide_divide @ A @ Y5 @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_592_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A,W: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less @ A @ X3 @ Y5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ ( divide_divide @ A @ Y5 @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_593_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A,W: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ ( divide_divide @ A @ Y5 @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_594_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_595_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_596_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_597_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y5 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_598_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_599_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_600_four__x__squared,axiom,
    ! [X3: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_601_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_602_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_603_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_604_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_605_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_606_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_607_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_608_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_609_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_610_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_611_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,X3: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( ord_less_eq @ A @ X3 @ ( times_times @ A @ Z2 @ Y5 ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_612_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,Z2: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y5 ) @ X3 )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_613_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_614_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A3 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A3 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_615_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A3 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A3 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_616_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_617_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_618_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_619_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q2 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_620_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_621_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_622_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_623_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
             => ( X3 = Y5 ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_624_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ).

% power2_le_imp_le
thf(fact_625_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_626_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ord_less @ A @ X3 @ Y5 ) ) ) ) ).

% power2_less_imp_less
thf(fact_627_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_628_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( Y5
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_629_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_630_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_631_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y5: A,X3: A,Z2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y5 ) @ ( times_times @ A @ X3 @ Z2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z2 ) @ ( times_times @ A @ X3 @ Y5 ) ) )
          = ( ( W = X3 )
            | ( Y5 = Z2 ) ) ) ) ).

% crossproduct_eq
thf(fact_632_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( A3 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A3 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_633_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) @ Y5 ) @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_634_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N2: nat,TreeList: list @ vEBT_VEBT,X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X4 @ N2 ) ) @ ( vEBT_VEBT_low @ X4 @ N2 ) ) ) ) ).

% in_children_def
thf(fact_635_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,X3: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ X3 ) ) ) ) ).

% both_member_options_ding
thf(fact_636_set__n__deg__not__0,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,M: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N ) ) ) ).

% set_n_deg_not_0
thf(fact_637_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X4: nat,N2: nat] : ( modulo_modulo @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% low_def
thf(fact_638_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ X3 @ X3 ) ) ).

% order_refl
thf(fact_639_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ A3 ) ) ).

% dual_order.refl
thf(fact_640_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ( ( modulo_modulo @ A @ X3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X3 @ M ) )
              | ( ( modulo_modulo @ A @ X3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X3 @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_641_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int] :
            ( ( P @ X2 )
           => ( P @ ( plus_plus @ int @ X2 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X: int] :
              ( ( P @ X )
             => ( P @ ( plus_plus @ int @ X @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_642_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A3 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_643_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_644_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X3: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X3 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X3 ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_645_even__odd__cases,axiom,
    ! [X3: nat] :
      ( ! [N3: nat] :
          ( X3
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X3
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_646_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% nat.inject
thf(fact_647_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_648_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_649_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_650_real__divide__square__eq,axiom,
    ! [R2: real,A3: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R2 @ A3 ) @ ( times_times @ real @ R2 @ R2 ) )
      = ( divide_divide @ real @ A3 @ R2 ) ) ).

% real_divide_square_eq
thf(fact_651_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_652_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% mult.right_neutral
thf(fact_653_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A3 )
          = A3 ) ) ).

% mult_1
thf(fact_654_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% bits_div_by_1
thf(fact_655_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% div_by_1
thf(fact_656_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_657_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_658_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_659_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% mod_by_0
thf(fact_660_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_661_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_662_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_663_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_664_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_665_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_666_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_667_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_668_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_669_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( one_one @ nat ) )
          = A3 ) ) ).

% power_one_right
thf(fact_670_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_671_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_672_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = M ) ) ).

% mod_less
thf(fact_673_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_674_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A3: A] :
          ( ( ( times_times @ A @ C2 @ A3 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_675_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_676_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A3: A,C2: A] :
          ( ( ( times_times @ A @ A3 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_677_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_678_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_679_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_680_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ A3 )
            = ( one_one @ A ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_681_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( ( A3
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A3 @ A3 )
              = ( zero_zero @ A ) ) )
          & ( ( A3
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A3 @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_682_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ A3 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_683_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A3 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_684_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ A3 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_685_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_686_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_687_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_688_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ( power_power @ A @ A3 @ M )
              = ( power_power @ A @ A3 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_689_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_690_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A3 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_691_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_692_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_693_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_694_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_695_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_696_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_697_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_698_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_699_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_700_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_701_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_702_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_703_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_704_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_705_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_706_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( suc @ ( zero_zero @ nat ) ) )
          = A3 ) ) ).

% power_Suc0_right
thf(fact_707_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_708_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_709_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_710_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_711_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_712_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_713_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_714_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_715_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_716_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_717_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_718_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_719_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_720_nat__power__eq__Suc__0__iff,axiom,
    ! [X3: nat,M: nat] :
      ( ( ( power_power @ nat @ X3 @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X3
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_721_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X3: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X3 )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X3
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_722_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X3: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X3 ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X3 ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_723_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_724_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_725_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_726_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_727_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_728_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_729_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_730_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_731_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_732_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_733_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_734_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_735_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_736_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_737_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_738_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X3: nat,Y5: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X3 ) @ ( power_power @ A @ B2 @ Y5 ) )
            = ( ord_less @ nat @ X3 @ Y5 ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_739_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_740_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_741_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_742_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_743_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_744_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_745_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_746_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self4
thf(fact_747_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self3
thf(fact_748_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N @ K ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self2
thf(fact_749_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self1
thf(fact_750_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_751_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_752_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_753_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_754_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_755_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_756_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X3: nat,Y5: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X3 ) @ ( power_power @ A @ B2 @ Y5 ) )
            = ( ord_less_eq @ nat @ X3 @ Y5 ) ) ) ) ).

% power_increasing_iff
thf(fact_757_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_758_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_759_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_760_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_761_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_762_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_763_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_764_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X3 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X3 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_765_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X3: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X3 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X3 ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_766_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X3 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X3 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_767_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X3: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X3 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X3 ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_768_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y5: nat,X3: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y5 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( Y5
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_769_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X3: num,N: nat,Y5: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N )
            = ( semiring_1_of_nat @ A @ Y5 ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N )
            = Y5 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_770_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_771_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_772_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_773_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_774_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_775_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_776_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_777_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_778_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_779_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X3 ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_780_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_781_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: nat,I: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_782_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: nat,I: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less_eq @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_783_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X3: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X3 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X3 ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_784_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_785_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W2: int,Z3: int] :
        ? [N2: nat] :
          ( Z3
          = ( plus_plus @ int @ W2 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_786_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_787_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_788_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_789_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_790_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_791_complete__real,axiom,
    ! [S2: set @ real] :
      ( ? [X: real] : ( member2 @ real @ X @ S2 )
     => ( ? [Z4: real] :
          ! [X2: real] :
            ( ( member2 @ real @ X2 @ S2 )
           => ( ord_less_eq @ real @ X2 @ Z4 ) )
       => ? [Y2: real] :
            ( ! [X: real] :
                ( ( member2 @ real @ X @ S2 )
               => ( ord_less_eq @ real @ X @ Y2 ) )
            & ! [Z4: real] :
                ( ! [X2: real] :
                    ( ( member2 @ real @ X2 @ S2 )
                   => ( ord_less_eq @ real @ X2 @ Z4 ) )
               => ( ord_less_eq @ real @ Y2 @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_792_verit__la__generic,axiom,
    ! [A3: int,X3: int] :
      ( ( ord_less_eq @ int @ A3 @ X3 )
      | ( A3 = X3 )
      | ( ord_less_eq @ int @ X3 @ A3 ) ) ).

% verit_la_generic
thf(fact_793_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_794_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% zle_int
thf(fact_795_zmod__int,axiom,
    ! [A3: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A3 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_796_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R4: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X2: nat] : ( R4 @ X2 @ X2 )
       => ( ! [X2: nat,Y2: nat,Z5: nat] :
              ( ( R4 @ X2 @ Y2 )
             => ( ( R4 @ Y2 @ Z5 )
               => ( R4 @ X2 @ Z5 ) ) )
         => ( ! [N3: nat] : ( R4 @ N3 @ ( suc @ N3 ) )
           => ( R4 @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_797_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_798_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y6: nat] :
                ( ( P @ Y6 )
               => ( ord_less_eq @ nat @ Y6 @ X2 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_799_full__nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% full_nat_induct
thf(fact_800_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_801_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_802_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_803_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_804_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_805_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_806_le__trans,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ord_less_eq @ nat @ J3 @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) ).

% le_trans
thf(fact_807_Suc__le__D,axiom,
    ! [N: nat,M5: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M5 )
     => ? [M4: nat] :
          ( M5
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_808_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_809_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_810_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_811_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_812_Suc__inject,axiom,
    ! [X3: nat,Y5: nat] :
      ( ( ( suc @ X3 )
        = ( suc @ Y5 ) )
     => ( X3 = Y5 ) ) ).

% Suc_inject
thf(fact_813_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_814_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X3: A] :
          ( ( ( one_one @ A )
            = X3 )
          = ( X3
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_815_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_816_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% mod_Suc_eq
thf(fact_817_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N ) ) ).

% mod_Suc_Suc_eq
thf(fact_818_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_819_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_820_mod__induct,axiom,
    ! [P: nat > $o,N: nat,P3: nat,M: nat] :
      ( ( P @ N )
     => ( ( ord_less @ nat @ N @ P3 )
       => ( ( ord_less @ nat @ M @ P3 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P3 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P3 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_821_real__of__nat__div__aux,axiom,
    ! [X3: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X3 ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X3 @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X3 @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_822_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W2: int,Z3: int] :
        ? [N2: nat] :
          ( Z3
          = ( plus_plus @ int @ W2 @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_823_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_824_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N2: nat] : ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_825_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_826_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_827_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_828_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_829_nat__induct__non__zero,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_830_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_831_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_832_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_833_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_834_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_835_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_836_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I: nat,J3: nat] :
          ( ( ord_less_eq @ nat @ I @ J3 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ).

% of_nat_mono
thf(fact_837_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_838_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_839_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_840_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_841_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X3: nat,Y5: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X3 ) @ Y5 )
          = ( times_times @ A @ Y5 @ ( semiring_1_of_nat @ A @ X3 ) ) ) ) ).

% mult_of_nat_commute
thf(fact_842_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ N ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A3 @ N ) @ B2 ) ) ) ).

% power_mod
thf(fact_843_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_844_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_845_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q5: int] :
          ( M
          = ( times_times @ int @ D2 @ Q5 ) ) ) ).

% zmod_eq_0D
thf(fact_846_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N4 )
           => ( ord_less_eq @ A @ ( F2 @ N ) @ ( F2 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_847_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N @ N4 )
           => ( ord_less_eq @ A @ ( F2 @ N4 ) @ ( F2 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_848_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_849_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% nonneg_int_cases
thf(fact_850_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_851_int__ops_I5_J,axiom,
    ! [A3: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A3 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_852_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z2: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z2 ) ) ).

% zadd_int_left
thf(fact_853_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_854_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_855_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_856_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_857_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_858_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X2: nat] : ( P @ X2 @ ( zero_zero @ nat ) )
     => ( ! [Y2: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y2 ) )
       => ( ! [X2: nat,Y2: nat] :
              ( ( P @ X2 @ Y2 )
             => ( P @ ( suc @ X2 ) @ ( suc @ Y2 ) ) )
         => ( P @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_859_nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N ) ) ) ).

% nat_induct
thf(fact_860_vebt__buildup_Ocases,axiom,
    ! [X3: nat] :
      ( ( X3
       != ( zero_zero @ nat ) )
     => ( ( X3
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X3
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_861_old_Onat_Oexhaust,axiom,
    ! [Y5: nat] :
      ( ( Y5
       != ( zero_zero @ nat ) )
     => ~ ! [Nat3: nat] :
            ( Y5
           != ( suc @ Nat3 ) ) ) ).

% old.nat.exhaust
thf(fact_862_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_863_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_864_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_865_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_866_int__ops_I7_J,axiom,
    ! [A3: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A3 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_867_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_868_strict__inc__induct,axiom,
    ! [I: nat,J3: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ! [I3: nat] :
            ( ( J3
              = ( suc @ I3 ) )
           => ( P @ I3 ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ J3 )
             => ( ( P @ ( suc @ I3 ) )
               => ( P @ I3 ) ) )
         => ( P @ I ) ) ) ) ).

% strict_inc_induct
thf(fact_869_less__Suc__induct,axiom,
    ! [I: nat,J3: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ! [I3: nat] : ( P @ I3 @ ( suc @ I3 ) )
       => ( ! [I3: nat,J2: nat,K2: nat] :
              ( ( ord_less @ nat @ I3 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K2 )
               => ( ( P @ I3 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I3 @ K2 ) ) ) ) )
         => ( P @ I @ J3 ) ) ) ) ).

% less_Suc_induct
thf(fact_870_less__trans__Suc,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ( ord_less @ nat @ J3 @ K )
       => ( ord_less @ nat @ ( suc @ I ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_871_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_872_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_873_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M6: nat] :
            ( ( M
              = ( suc @ M6 ) )
            & ( ord_less @ nat @ N @ M6 ) ) ) ) ).

% Suc_less_eq2
thf(fact_874_All__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( suc @ N ) )
           => ( P @ I2 ) ) )
      = ( ( P @ N )
        & ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ N )
           => ( P @ I2 ) ) ) ) ).

% All_less_Suc
thf(fact_875_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_876_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_877_Ex__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( suc @ N ) )
            & ( P @ I2 ) ) )
      = ( ( P @ N )
        | ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ N )
            & ( P @ I2 ) ) ) ) ).

% Ex_less_Suc
thf(fact_878_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_879_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_880_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_881_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_882_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_883_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_884_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_885_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat] : ( ord_less_eq @ nat @ ( suc @ N2 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_886_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_887_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_888_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_889_inc__induct,axiom,
    ! [I: nat,J3: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( P @ J3 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I @ N3 )
             => ( ( ord_less @ nat @ N3 @ J3 )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I ) ) ) ) ).

% inc_induct
thf(fact_890_dec__induct,axiom,
    ! [I: nat,J3: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( P @ I )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I @ N3 )
             => ( ( ord_less @ nat @ N3 @ J3 )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J3 ) ) ) ) ).

% dec_induct
thf(fact_891_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_892_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_893_real__of__nat__div4,axiom,
    ! [N: nat,X3: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X3 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X3 ) ) ) ).

% real_of_nat_div4
thf(fact_894_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_895_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_896_div__mod__decomp__int,axiom,
    ! [A2: int,N: int] :
      ( A2
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A2 @ N ) @ N ) @ ( modulo_modulo @ int @ A2 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_897_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_898_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_899_nat__arith_Osuc1,axiom,
    ! [A2: nat,K: nat,A3: nat] :
      ( ( A2
        = ( plus_plus @ nat @ K @ A3 ) )
     => ( ( suc @ A2 )
        = ( plus_plus @ nat @ K @ ( suc @ A3 ) ) ) ) ).

% nat_arith.suc1
thf(fact_900_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_901_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A3 )
          = A3 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_902_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% mult.comm_neutral
thf(fact_903_of__nat__eq__enat,axiom,
    ( ( semiring_1_of_nat @ extended_enat )
    = extended_enat2 ) ).

% of_nat_eq_enat
thf(fact_904_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_905_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_906_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_907_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_908_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_909_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A3 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_910_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_911_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ A3 ) ) ) ) ).

% power_Suc_le_self
thf(fact_912_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_913_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ A3 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_914_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_915_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ B2 )
            = A3 )
          = ( ( divide_divide @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_916_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_917_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_918_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D3: A] :
                ( B2
               != ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ D3 ) ) ) ) ) ).

% mod_eqE
thf(fact_919_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_920_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_921_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_922_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_923_verit__le__mono__div,axiom,
    ! [A2: nat,B3: nat,N: nat] :
      ( ( ord_less @ nat @ A2 @ B3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A2 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B3 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B3 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_924_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_925_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_926_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_927_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_928_reals__Archimedean3,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ! [Y6: real] :
        ? [N3: nat] : ( ord_less @ real @ Y6 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X3 ) ) ) ).

% reals_Archimedean3
thf(fact_929_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q5: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q5 ) ) ) ).

% mod_eq_0D
thf(fact_930_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_931_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_932_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_933_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_934_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_935_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_936_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( modulo_modulo @ int @ I @ K )
        = I )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zmod_trivial_iff
thf(fact_937_int__mod__pos__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( modulo_modulo @ int @ A3 @ B2 )
            = R2 ) ) ) ) ).

% int_mod_pos_eq
thf(fact_938_int__mod__neg__eq,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( A3
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( modulo_modulo @ int @ A3 @ B2 )
            = R2 ) ) ) ) ).

% int_mod_neg_eq
thf(fact_939_pos__mod__conj,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A3 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A3 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_940_neg__mod__conj,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A3 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A3 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_941_split__zmod,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I2: int,J4: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J4 )
                & ( ord_less @ int @ J4 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I2 ) @ J4 ) ) )
             => ( P @ J4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I2: int,J4: int] :
              ( ( ( ord_less @ int @ K @ J4 )
                & ( ord_less_eq @ int @ J4 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I2 ) @ J4 ) ) )
             => ( P @ J4 ) ) ) ) ) ).

% split_zmod
thf(fact_942_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_943_nat__mod__eq__iff,axiom,
    ! [X3: nat,N: nat,Y5: nat] :
      ( ( ( modulo_modulo @ nat @ X3 @ N )
        = ( modulo_modulo @ nat @ Y5 @ N ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X3 @ ( times_times @ nat @ N @ Q1 ) )
            = ( plus_plus @ nat @ Y5 @ ( times_times @ nat @ N @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_944_nat__mod__eq__lemma,axiom,
    ! [X3: nat,N: nat,Y5: nat] :
      ( ( ( modulo_modulo @ nat @ X3 @ N )
        = ( modulo_modulo @ nat @ Y5 @ N ) )
     => ( ( ord_less_eq @ nat @ Y5 @ X3 )
       => ? [Q5: nat] :
            ( X3
            = ( plus_plus @ nat @ Y5 @ ( times_times @ nat @ N @ Q5 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_945_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S3: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_946_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_947_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_948_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_Suc
thf(fact_949_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ A3 ) ) ) ).

% power_Suc2
thf(fact_950_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_951_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N4: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N @ N4 )
           => ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ N4 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_952_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_953_zmod__zmult2__eq,axiom,
    ! [C2: int,A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A3 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A3 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A3 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_954_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J4: nat] :
            ( ( M
              = ( suc @ J4 ) )
            & ( ord_less @ nat @ J4 @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_955_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_956_All__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( suc @ N ) )
           => ( P @ I2 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ N )
           => ( P @ ( suc @ I2 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_957_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M3: nat] :
            ( N
            = ( suc @ M3 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_958_Ex__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( suc @ N ) )
            & ( P @ I2 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ N )
            & ( P @ ( suc @ I2 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_959_ex__least__nat__less,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N )
            & ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ K2 )
               => ~ ( P @ I4 ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_960_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_961_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_962_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_963_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_964_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_965_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_966_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_967_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_968_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q5: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q5 ) ) ) ) ).

% less_natE
thf(fact_969_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ I @ M ) ) ) ).

% less_add_Suc1
thf(fact_970_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ M @ I ) ) ) ).

% less_add_Suc2
thf(fact_971_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N2: nat] :
        ? [K3: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M3 @ K3 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_972_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K2: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_973_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_974_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_975_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_976_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_977_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A] : ( ord_less @ A @ A3 @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_978_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_979_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( one_one @ A ) )
            = ( A3 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_980_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X3: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_981_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_982_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% one_le_power
thf(fact_983_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A3: A] :
          ( ( ord_less_eq @ nat @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ A3 @ N5 ) ) ) ) ) ).

% power_increasing
thf(fact_984_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_985_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_986_nat__one__le__power,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I @ N ) ) ) ).

% nat_one_le_power
thf(fact_987_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X3: A,Y5: A,N: nat] :
          ( ( ( times_times @ A @ X3 @ Y5 )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ Y5 @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_988_zdiv__int,axiom,
    ! [A3: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A3 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_989_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_one_over
thf(fact_990_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_991_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_992_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_993_Suc__ile__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ ( suc @ M ) ) @ N )
      = ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ N ) ) ).

% Suc_ile_eq
thf(fact_994_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_995_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( ( modulo_modulo @ A @ A3 @ B2 )
              = A3 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_996_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_997_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_998_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_999_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_1000_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A3 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_1001_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A3 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_1002_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( A3
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_1003_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = A3 ) ) ).

% div_mult_mod_eq
thf(fact_1004_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) )
          = A3 ) ) ).

% mod_div_mult_eq
thf(fact_1005_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) )
          = A3 ) ) ).

% mod_mult_div_eq
thf(fact_1006_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A3: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = A3 ) ) ).

% mult_div_mod_eq
thf(fact_1007_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_1008_real__archimedian__rdiv__eq__0,axiom,
    ! [X3: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X3 ) @ C2 ) )
         => ( X3
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_1009_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_1010_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A3 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A3 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_1011_div__less__mono,axiom,
    ! [A2: nat,B3: nat,N: nat] :
      ( ( ord_less @ nat @ A2 @ B3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A2 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B3 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A2 @ N ) @ ( divide_divide @ nat @ B3 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_1012_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J3: int,K: nat] :
      ( ( ord_less @ int @ I @ J3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J3 ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_1013_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M @ N ) ) ) ).

% mod_mult2_eq
thf(fact_1014_div__mod__decomp,axiom,
    ! [A2: nat,N: nat] :
      ( A2
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A2 @ N ) @ N ) @ ( modulo_modulo @ nat @ A2 @ N ) ) ) ).

% div_mod_decomp
thf(fact_1015_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I2: int,J4: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J4 )
                & ( ord_less @ int @ J4 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I2 ) @ J4 ) ) )
             => ( P @ I2 @ J4 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1016_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I2: int,J4: int] :
              ( ( ( ord_less @ int @ K @ J4 )
                & ( ord_less_eq @ int @ J4 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I2 ) @ J4 ) ) )
             => ( P @ I2 @ J4 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1017_zdiv__mono__strict,axiom,
    ! [A2: int,B3: int,N: int] :
      ( ( ord_less @ int @ A2 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ( ( modulo_modulo @ int @ A2 @ N )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B3 @ N )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A2 @ N ) @ ( divide_divide @ int @ B3 @ N ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1018_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_1019_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ( ord_less_eq @ A @ Y5 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y5 @ X3 ) @ X3 ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1020_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
           => ( ( ord_less_eq @ A @ Y5 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X3 @ Y5 ) @ X3 ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1021_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1022_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ A3 ) ) ) ) ).

% mult_left_le
thf(fact_1023_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
            = ( X3 = Y5 ) ) ) ) ).

% order_antisym_conv
thf(fact_1024_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ~ ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% linorder_le_cases
thf(fact_1025_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A3 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_1026_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,F2: B > A,B2: B,C2: B] :
          ( ( A3
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_1027_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
          | ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% linorder_linear
thf(fact_1028_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( X3 = Y5 )
         => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% order_eq_refl
thf(fact_1029_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A3 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_1030_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_1031_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_1032_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
            ! [X4: A] : ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ).

% le_fun_def
thf(fact_1033_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_1034_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) ).

% le_funE
thf(fact_1035_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) ).

% le_funD
thf(fact_1036_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( A3 = B2 ) ) ) ) ).

% antisym
thf(fact_1037_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.trans
thf(fact_1038_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( A3 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_1039_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_1040_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A3: A,B2: A] :
          ( ! [A7: A,B6: A] :
              ( ( ord_less_eq @ A @ A7 @ B6 )
             => ( P @ A7 @ B6 ) )
         => ( ! [A7: A,B6: A] :
                ( ( P @ B6 @ A7 )
               => ( P @ A7 @ B6 ) )
           => ( P @ A3 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_1041_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ A @ Y5 @ Z2 )
           => ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) ).

% order_trans
thf(fact_1042_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% order.trans
thf(fact_1043_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ A @ Y5 @ X3 )
           => ( X3 = Y5 ) ) ) ) ).

% order_antisym
thf(fact_1044_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_1045_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_1046_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X4: A,Y: A] :
              ( ( ord_less_eq @ A @ X4 @ Y )
              & ( ord_less_eq @ A @ Y @ X4 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_1047_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ~ ( ord_less_eq @ A @ Y5 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y5 @ X3 )
             => ~ ( ord_less_eq @ A @ X3 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X3 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y5 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y5 )
                 => ~ ( ord_less_eq @ A @ Y5 @ X3 ) )
               => ( ( ( ord_less_eq @ A @ Y5 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X3 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X3 )
                     => ~ ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_1048_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A3 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( B2 != A3 ) ) ) ) ).

% nle_le
thf(fact_1049_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_1050_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_1051_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_1052_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_1053_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1054_realpow__pos__nth2,axiom,
    ! [A3: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ? [R: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
          & ( ( power_power @ real @ R @ ( suc @ N ) )
            = A3 ) ) ) ).

% realpow_pos_nth2
thf(fact_1055_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_1056_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A3: A] :
          ( ( ord_less_eq @ nat @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N5 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1057_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1058_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ A3 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1059_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ~ ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% order_less_imp_not_less
thf(fact_1060_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( Y5 != X3 ) ) ) ).

% order_less_imp_not_eq2
thf(fact_1061_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( X3 != Y5 ) ) ) ).

% order_less_imp_not_eq
thf(fact_1062_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
          | ( X3 = Y5 )
          | ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% linorder_less_linear
thf(fact_1063_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A,P: $o] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( ord_less @ A @ Y5 @ X3 )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_1064_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ~ ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% order_less_not_sym
thf(fact_1065_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A3 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_1066_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_1067_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A] :
          ~ ( ord_less @ A @ X3 @ X3 ) ) ).

% order_less_irrefl
thf(fact_1068_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ B @ ( F2 @ A3 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_1069_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,F2: B > A,B2: B,C2: B] :
          ( ( A3
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_1070_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( ord_less @ A @ Y5 @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) ).

% order_less_trans
thf(fact_1071_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A3 ) ) ) ).

% order_less_asym'
thf(fact_1072_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( X3 != Y5 ) )
          = ( ( ord_less @ A @ X3 @ Y5 )
            | ( ord_less @ A @ Y5 @ X3 ) ) ) ) ).

% linorder_neq_iff
thf(fact_1073_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ~ ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% order_less_asym
thf(fact_1074_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( X3 != Y5 )
         => ( ~ ( ord_less @ A @ X3 @ Y5 )
           => ( ord_less @ A @ Y5 @ X3 ) ) ) ) ).

% linorder_neqE
thf(fact_1075_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( A3 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_1076_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( A3 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_1077_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_1078_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ~ ( ord_less @ A @ X3 @ Y5 ) )
          = ( ( ord_less @ A @ Y5 @ X3 )
            | ( X3 = Y5 ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_1079_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_1080_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A3: A,B2: A] :
          ( ! [A7: A,B6: A] :
              ( ( ord_less @ A @ A7 @ B6 )
             => ( P @ A7 @ B6 ) )
         => ( ! [A7: A] : ( P @ A7 @ A7 )
           => ( ! [A7: A,B6: A] :
                  ( ( P @ B6 @ A7 )
                 => ( P @ A7 @ B6 ) )
             => ( P @ A3 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_1081_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P4: A > $o] :
            ? [X7: A] : ( P4 @ X7 ) )
        = ( ^ [P2: A > $o] :
            ? [N2: A] :
              ( ( P2 @ N2 )
              & ! [M3: A] :
                  ( ( ord_less @ A @ M3 @ N2 )
                 => ~ ( P2 @ M3 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_1082_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ A3 ) ) ).

% dual_order.irrefl
thf(fact_1083_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ~ ( ord_less @ A @ A3 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_1084_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ~ ( ord_less @ A @ X3 @ Y5 )
         => ( ( X3 != Y5 )
           => ( ord_less @ A @ Y5 @ X3 ) ) ) ) ).

% linorder_cases
thf(fact_1085_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y5: A,X3: A] :
          ( ~ ( ord_less @ A @ Y5 @ X3 )
         => ( ( ~ ( ord_less @ A @ X3 @ Y5 ) )
            = ( X3 = Y5 ) ) ) ) ).

% antisym_conv3
thf(fact_1086_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A3: A] :
          ( ! [X2: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ A @ Y6 @ X2 )
                 => ( P @ Y6 ) )
             => ( P @ X2 ) )
         => ( P @ A3 ) ) ) ).

% less_induct
thf(fact_1087_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_1088_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_1089_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A3 ) ) ) ).

% order.asym
thf(fact_1090_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( X3 != Y5 ) ) ) ).

% less_imp_neq
thf(fact_1091_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ? [Z5: A] :
              ( ( ord_less @ A @ X3 @ Z5 )
              & ( ord_less @ A @ Z5 @ Y5 ) ) ) ) ).

% dense
thf(fact_1092_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X3: A] :
        ? [X_12: A] : ( ord_less @ A @ X3 @ X_12 ) ) ).

% gt_ex
thf(fact_1093_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X3: A] :
        ? [Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ).

% lt_ex
thf(fact_1094_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ Z4 @ X2 )
             => ( ( P @ X2 )
                = ( P5 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z4 @ X2 )
               => ( ( Q @ X2 )
                  = ( Q6 @ X2 ) ) )
           => ? [Z5: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z5 @ X )
               => ( ( ( P @ X )
                    & ( Q @ X ) )
                  = ( ( P5 @ X )
                    & ( Q6 @ X ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1095_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ Z4 @ X2 )
             => ( ( P @ X2 )
                = ( P5 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z4 @ X2 )
               => ( ( Q @ X2 )
                  = ( Q6 @ X2 ) ) )
           => ? [Z5: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z5 @ X )
               => ( ( ( P @ X )
                    | ( Q @ X ) )
                  = ( ( P5 @ X )
                    | ( Q6 @ X ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1096_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z5 @ X )
         => ( X != T2 ) ) ) ).

% pinf(3)
thf(fact_1097_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z5 @ X )
         => ( X != T2 ) ) ) ).

% pinf(4)
thf(fact_1098_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z5 @ X )
         => ~ ( ord_less @ A @ X @ T2 ) ) ) ).

% pinf(5)
thf(fact_1099_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z5 @ X )
         => ( ord_less @ A @ T2 @ X ) ) ) ).

% pinf(7)
thf(fact_1100_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z5: C] :
        ! [X: C] :
          ( ( ord_less @ C @ Z5 @ X )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_1101_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Z4 )
             => ( ( P @ X2 )
                = ( P5 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z4 )
               => ( ( Q @ X2 )
                  = ( Q6 @ X2 ) ) )
           => ? [Z5: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z5 )
               => ( ( ( P @ X )
                    & ( Q @ X ) )
                  = ( ( P5 @ X )
                    & ( Q6 @ X ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1102_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Z4 )
             => ( ( P @ X2 )
                = ( P5 @ X2 ) ) )
         => ( ? [Z4: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z4 )
               => ( ( Q @ X2 )
                  = ( Q6 @ X2 ) ) )
           => ? [Z5: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z5 )
               => ( ( ( P @ X )
                    | ( Q @ X ) )
                  = ( ( P5 @ X )
                    | ( Q6 @ X ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1103_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z5 )
         => ( X != T2 ) ) ) ).

% minf(3)
thf(fact_1104_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z5 )
         => ( X != T2 ) ) ) ).

% minf(4)
thf(fact_1105_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z5 )
         => ( ord_less @ A @ X @ T2 ) ) ) ).

% minf(5)
thf(fact_1106_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z5 )
         => ~ ( ord_less @ A @ T2 @ X ) ) ) ).

% minf(7)
thf(fact_1107_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z5: C] :
        ! [X: C] :
          ( ( ord_less @ C @ X @ Z5 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_1108_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_1109_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1110_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1111_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_1112_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1113_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ A3 @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1114_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_1115_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_1116_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_1117_div__nat__eqI,axiom,
    ! [N: nat,Q2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q2 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_1118_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A3: A] :
          ( ( ord_less @ nat @ N @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ A3 @ N5 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_1119_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_1120_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_1121_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1122_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1123_conj__le__cong,axiom,
    ! [X3: int,X8: int,P: $o,P5: $o] :
      ( ( X3 = X8 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X8 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X8 )
            & P5 ) ) ) ) ).

% conj_le_cong
thf(fact_1124_imp__le__cong,axiom,
    ! [X3: int,X8: int,P: $o,P5: $o] :
      ( ( X3 = X8 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X8 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X8 )
           => P5 ) ) ) ) ).

% imp_le_cong
thf(fact_1125_split__mod,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I2: nat,J4: nat] :
              ( ( ord_less @ nat @ J4 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I2 ) @ J4 ) )
               => ( P @ J4 ) ) ) ) ) ) ).

% split_mod
thf(fact_1126_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_1127_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_1128_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_1129_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z5 )
             => ( ( ord_less @ A @ Z5 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z5 @ X3 ) @ Y5 ) ) )
         => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% field_le_mult_one_interval
thf(fact_1130_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_1131_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_1132_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_1133_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_1134_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_1135_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_1136_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_1137_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_1138_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X3: A,A3: A,Y5: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X3 @ A3 )
         => ( ( ord_less_eq @ A @ Y5 @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X3 ) @ ( times_times @ A @ V @ Y5 ) ) @ A3 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1139_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1140_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ A3 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A3 @ B2 ) )
            | ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1141_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_1142_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_1143_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N5: nat,A3: A] :
          ( ( ord_less @ nat @ N @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A3 @ N5 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1144_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1145_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_1146_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_1147_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_1148_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_1149_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_1150_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1151_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_1152_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_1153_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_1154_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_1155_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X3: A,A3: A,Y5: A,U: A,V: A] :
          ( ( ord_less @ A @ X3 @ A3 )
         => ( ( ord_less @ A @ Y5 @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X3 ) @ ( times_times @ A @ V @ Y5 ) ) @ A3 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1156_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_1157_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 )
         => ( ( plus_plus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_1158_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_1159_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A3 @ ( power_power @ A @ ( power_power @ A @ A3 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_1160_nat__bit__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_1161_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_1162_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_1163_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_1164_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_1165_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_1166_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less @ A @ X3 @ Y5 )
            | ( X3 = Y5 ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_1167_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
          | ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% linorder_le_less_linear
thf(fact_1168_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A3 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_1169_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_1170_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A3 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_1171_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_1172_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ A @ Y5 @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) ).

% order_less_le_trans
thf(fact_1173_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less @ A @ Y5 @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) ).

% order_le_less_trans
thf(fact_1174_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( A3 != B2 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_1175_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( A3 != B2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_1176_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% order_less_imp_le
thf(fact_1177_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ~ ( ord_less @ A @ X3 @ Y5 ) )
          = ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% linorder_not_less
thf(fact_1178_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ~ ( ord_less_eq @ A @ X3 @ Y5 ) )
          = ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% linorder_not_le
thf(fact_1179_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X4: A,Y: A] :
              ( ( ord_less_eq @ A @ X4 @ Y )
              & ( X4 != Y ) ) ) ) ) ).

% order_less_le
thf(fact_1180_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X4: A,Y: A] :
              ( ( ord_less @ A @ X4 @ Y )
              | ( X4 = Y ) ) ) ) ) ).

% order_le_less
thf(fact_1181_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_1182_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_1183_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ~ ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_1184_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_1185_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_1186_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( A5 != B4 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_1187_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less @ A @ B4 @ A5 )
              | ( A5 = B4 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_1188_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ! [W3: A] :
                ( ( ord_less @ A @ X3 @ W3 )
               => ( ( ord_less @ A @ W3 @ Y5 )
                 => ( ord_less_eq @ A @ W3 @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y5 @ Z2 ) ) ) ) ).

% dense_le_bounded
thf(fact_1189_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less @ A @ Z2 @ X3 )
         => ( ! [W3: A] :
                ( ( ord_less @ A @ Z2 @ W3 )
               => ( ( ord_less @ A @ W3 @ X3 )
                 => ( ord_less_eq @ A @ Y5 @ W3 ) ) )
           => ( ord_less_eq @ A @ Y5 @ Z2 ) ) ) ) ).

% dense_ge_bounded
thf(fact_1190_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ~ ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_1191_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_1192_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_1193_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( A5 != B4 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_1194_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
              | ( A5 = B4 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_1195_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y5: A,X3: A] :
          ( ~ ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ord_less @ A @ X3 @ Y5 ) ) ) ).

% not_le_imp_less
thf(fact_1196_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X4: A,Y: A] :
              ( ( ord_less_eq @ A @ X4 @ Y )
              & ~ ( ord_less_eq @ A @ Y @ X4 ) ) ) ) ) ).

% less_le_not_le
thf(fact_1197_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y5: A,Z2: A] :
          ( ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Y5 )
             => ( ord_less_eq @ A @ X2 @ Z2 ) )
         => ( ord_less_eq @ A @ Y5 @ Z2 ) ) ) ).

% dense_le
thf(fact_1198_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,Y5: A] :
          ( ! [X2: A] :
              ( ( ord_less @ A @ Z2 @ X2 )
             => ( ord_less_eq @ A @ Y5 @ X2 ) )
         => ( ord_less_eq @ A @ Y5 @ Z2 ) ) ) ).

% dense_ge
thf(fact_1199_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ~ ( ord_less @ A @ X3 @ Y5 ) )
            = ( X3 = Y5 ) ) ) ) ).

% antisym_conv2
thf(fact_1200_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ~ ( ord_less @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
            = ( X3 = Y5 ) ) ) ) ).

% antisym_conv1
thf(fact_1201_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A3 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 )
            | ( A3 = B2 ) ) ) ) ).

% nless_le
thf(fact_1202_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ~ ( ord_less @ A @ X3 @ Y5 )
         => ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% leI
thf(fact_1203_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ~ ( ord_less @ A @ X3 @ Y5 ) ) ) ).

% leD
thf(fact_1204_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z5 @ X )
         => ~ ( ord_less_eq @ A @ X @ T2 ) ) ) ).

% pinf(6)
thf(fact_1205_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z5 @ X )
         => ( ord_less_eq @ A @ T2 @ X ) ) ) ).

% pinf(8)
thf(fact_1206_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z5 )
         => ( ord_less_eq @ A @ X @ T2 ) ) ) ).

% minf(6)
thf(fact_1207_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z5 )
         => ~ ( ord_less_eq @ A @ T2 @ X ) ) ) ).

% minf(8)
thf(fact_1208_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_1209_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1210_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1211_nat__induct2,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct2
thf(fact_1212_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E ) ) ) ).

% nat_approx_posE
thf(fact_1213_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1214_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% double_not_eq_Suc_double
thf(fact_1215_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_double_not_eq_double
thf(fact_1216_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1217_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_1218_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1219_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1220_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1221_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1222_zle__add1__eq__le,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z2 ) ) ).

% zle_add1_eq_le
thf(fact_1223_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) ).

% int_int_eq
thf(fact_1224_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F3 ) ) ) ) ) ).

% less_fun_def
thf(fact_1225_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y3: nat,Z: nat] : ( Y3 = Z ) )
    = ( ^ [A5: nat,B4: nat] :
          ( ( semiring_1_of_nat @ int @ A5 )
          = ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(1)
thf(fact_1226_int__if,axiom,
    ! [P: $o,A3: nat,B2: nat] :
      ( ( P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A3 @ B2 ) )
          = ( semiring_1_of_nat @ int @ A3 ) ) )
      & ( ~ P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A3 @ B2 ) )
          = ( semiring_1_of_nat @ int @ B2 ) ) ) ) ).

% int_if
thf(fact_1227_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_1228_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1229_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_1230_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_1231_int__ops_I4_J,axiom,
    ! [A3: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A3 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_1232_real__arch__pow,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ? [N3: nat] : ( ord_less @ real @ Y5 @ ( power_power @ real @ X3 @ N3 ) ) ) ).

% real_arch_pow
thf(fact_1233_odd__nonzero,axiom,
    ! [Z2: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1234_int__ge__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_ge_induct
thf(fact_1235_int__gr__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_gr_induct
thf(fact_1236_zless__add1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z2 )
        | ( W = Z2 ) ) ) ).

% zless_add1_eq
thf(fact_1237_one__enat__def,axiom,
    ( ( one_one @ extended_enat )
    = ( extended_enat2 @ ( one_one @ nat ) ) ) ).

% one_enat_def
thf(fact_1238_enat__1__iff_I1_J,axiom,
    ! [X3: nat] :
      ( ( ( extended_enat2 @ X3 )
        = ( one_one @ extended_enat ) )
      = ( X3
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(1)
thf(fact_1239_enat__1__iff_I2_J,axiom,
    ! [X3: nat] :
      ( ( ( one_one @ extended_enat )
        = ( extended_enat2 @ X3 ) )
      = ( X3
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(2)
thf(fact_1240_real__arch__pow__inv,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X3 @ N3 ) @ Y5 ) ) ) ).

% real_arch_pow_inv
thf(fact_1241_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat,M3: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M3 ) ) ) ) ).

% nat_less_real_le
thf(fact_1242_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N2: nat,M3: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_1243_int__one__le__iff__zero__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% int_one_le_iff_zero_less
thf(fact_1244_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1245_odd__less__0__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1246_add1__zle__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% add1_zle_eq
thf(fact_1247_zless__imp__add1__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ Z2 )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 ) ) ).

% zless_imp_add1_zle
thf(fact_1248_int__div__less__self,axiom,
    ! [X3: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X3 @ K ) @ X3 ) ) ) ).

% int_div_less_self
thf(fact_1249_le__imp__0__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% le_imp_0_less
thf(fact_1250_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_1251_verit__le__mono__div__int,axiom,
    ! [A2: int,B3: int,N: int] :
      ( ( ord_less @ int @ A2 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B3 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B3 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1252_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X3 @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_1253_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [N3: nat] : ( ord_less @ A @ X3 @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_1254_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_1: nat] : ( P @ X_1 )
       => ? [N3: nat] :
            ( ~ ( P @ N3 )
            & ( P @ ( suc @ N3 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_1255_pos__zmod__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A3 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1256_pos__zdiv__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( divide_divide @ int @ B2 @ A3 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1257_neg__zdiv__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A3 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1258_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ? [N3: nat] : ( ord_less @ A @ Y5 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X3 ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_1259_linear__plus__1__le__power,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X3 ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X3 @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_1260_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X2: vEBT_VEBT] :
                      ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_1261_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_1262_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M4 @ N3 ) )
             => ( P @ M4 @ N3 ) ) )
       => ( P @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_1263_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X2: vEBT_VEBT] :
                      ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_1264_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_1265_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1266_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_1267_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( one_one @ nat ) )
          = A3 ) ) ).

% pochhammer_1
thf(fact_1268_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_1269_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1270_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_1271_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ ( zero_zero @ nat ) ) )
          = A3 ) ) ).

% pochhammer_Suc0
thf(fact_1272_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1273_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1274_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1275_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X3: nat,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( semiring_1_of_nat @ A @ X3 ) @ N )
          = ( semiring_1_of_nat @ A @ ( comm_s3205402744901411588hammer @ nat @ X3 @ N ) ) ) ) ).

% pochhammer_of_nat
thf(fact_1276_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_1277_VEBT_Oexhaust,axiom,
    ! [Y5: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y5
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y5
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_1278_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_1279_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_1280_VEBT__internal_Oelim__dead_Osimps_I1_J,axiom,
    ! [A3: $o,B2: $o,Uu: extended_enat] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Leaf @ A3 @ B2 ) @ Uu )
      = ( vEBT_Leaf @ A3 @ B2 ) ) ).

% VEBT_internal.elim_dead.simps(1)
thf(fact_1281_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R2: int] :
      ( ( bit_concat_bit @ N @ K @ ( bit_concat_bit @ M @ L @ R2 ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N ) @ ( bit_concat_bit @ N @ K @ L ) @ R2 ) ) ).

% concat_bit_assoc
thf(fact_1282_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X3 @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_1283_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A3 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A3 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_1284_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A3 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A3 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_1285_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X4: A] : ( plus_plus @ A @ X4 @ X4 ) ) ) ) ).

% dbl_def
thf(fact_1286_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_1287_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_1288_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X3 @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_1289_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_1290_invar__vebt_Ointros_I1_J,axiom,
    ! [A3: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A3 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_1291_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_1292_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A3: $o,B2: $o,X3: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A3 @ B2 ) @ X3 )
      = ( ( ( X3
            = ( zero_zero @ nat ) )
         => A3 )
        & ( ( X3
           != ( zero_zero @ nat ) )
         => ( ( ( X3
                = ( one_one @ nat ) )
             => B2 )
            & ( X3
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_1293_bounded__Max__nat,axiom,
    ! [P: nat > $o,X3: nat,M7: nat] :
      ( ( P @ X3 )
     => ( ! [X2: nat] :
            ( ( P @ X2 )
           => ( ord_less_eq @ nat @ X2 @ M7 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X: nat] :
                    ( ( P @ X )
                   => ( ord_less_eq @ nat @ X @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1294_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_1295_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ A3 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_1296_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A3 @ N ) @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_1297_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_1298_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_1299_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A3: nat,B2: nat] :
      ( ! [A7: nat,B6: nat] :
          ( ( P @ A7 @ B6 )
          = ( P @ B6 @ A7 ) )
     => ( ! [A7: nat] : ( P @ A7 @ ( zero_zero @ nat ) )
       => ( ! [A7: nat,B6: nat] :
              ( ( P @ A7 @ B6 )
             => ( P @ A7 @ ( plus_plus @ nat @ A7 @ B6 ) ) )
         => ( P @ A3 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1300_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_1301_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N: nat] :
      ( ( P @ K )
     => ( ! [X2: A] :
            ( ( P @ X2 )
           => ? [Y6: A] :
                ( ( P @ Y6 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y6 ) @ ( F2 @ X2 ) ) ) )
       => ? [Y2: A] :
            ( ( P @ Y2 )
            & ~ ( ord_less @ nat @ ( F2 @ Y2 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1302_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1303_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1304_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1305_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_1306_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1307_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( dvd_dvd @ nat @ M @ N ) ) ).

% int_dvd_int_iff
thf(fact_1308_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ A3 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_1309_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A3 )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_1310_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1311_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1312_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1313_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1314_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ A3 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( divide_divide @ A @ C2 @ A3 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1315_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1316_of__nat__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( semiring_char_0_fact @ nat @ N ) )
          = ( semiring_char_0_fact @ A @ N ) ) ) ).

% of_nat_fact
thf(fact_1317_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1318_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A3 ) @ ( times_times @ A @ C2 @ A3 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1319_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1320_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1321_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1322_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1323_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A3 ) @ B2 ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1324_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1325_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ A3 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1326_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1327_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
            = A3 ) ) ) ).

% unit_div_1_div_1
thf(fact_1328_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1329_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1330_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A3 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1331_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1332_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_1333_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_1334_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1335_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1336_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1337_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
            = ( divide_divide @ A @ B2 @ A3 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1338_even__Suc,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_Suc
thf(fact_1339_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% even_Suc_Suc_iff
thf(fact_1340_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1341_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_1342_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_1343_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1344_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1345_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1346_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ).

% even_mod_2_iff
thf(fact_1347_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1348_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1349_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_1350_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1351_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1352_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1353_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1354_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1355_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_1356_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A3
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1357_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1358_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1359_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1360_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A3 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_1361_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A3 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1362_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A3
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1363_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_1364_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ A3 @ A3 ) ) ).

% dvd_refl
thf(fact_1365_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_1366_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_1367_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_1368_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ).

% fact_mono_nat
thf(fact_1369_fact__ge__self,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_self
thf(fact_1370_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( zero_zero @ A ) )
             => ( B4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1371_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A3 )
         => ( A3
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1372_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ N )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_1373_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ~ ! [K2: A] :
                ( A3
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1374_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A3: A,B2: A,K: A] :
          ( ( A3
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% dvdI
thf(fact_1375_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B4: A,A5: A] :
            ? [K3: A] :
              ( A5
              = ( times_times @ A @ B4 @ K3 ) ) ) ) ) ).

% dvd_def
thf(fact_1376_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ C2 )
         => ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1377_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1378_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A3 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1379_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] : ( dvd_dvd @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1380_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1381_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1382_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] : ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ A3 ) ) ) ).

% dvd_triv_right
thf(fact_1383_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A3
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1384_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P3: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ P3 @ ( times_times @ A @ A3 @ B2 ) )
         => ~ ! [X2: A,Y2: A] :
                ( ( P3
                  = ( times_times @ A @ X2 @ Y2 ) )
               => ( ( dvd_dvd @ A @ X2 @ A3 )
                 => ~ ( dvd_dvd @ A @ Y2 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1385_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1386_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% unit_imp_dvd
thf(fact_1387_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A3 ) ) ).

% one_dvd
thf(fact_1388_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ A3 @ C2 )
           => ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1389_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1390_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1391_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A3 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A3 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A3 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1392_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A3 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A3 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1393_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1394_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X3: A,Y5: A,N: nat] :
          ( ( dvd_dvd @ A @ X3 @ Y5 )
         => ( dvd_dvd @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ Y5 @ N ) ) ) ) ).

% dvd_power_same
thf(fact_1395_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A3: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A3 )
     => ( A3
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_1396_gcd__nat_Onot__eq__extremum,axiom,
    ! [A3: nat] :
      ( ( ( A3
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A3 @ ( zero_zero @ nat ) )
        & ( A3
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_1397_gcd__nat_Oextremum__unique,axiom,
    ! [A3: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A3 )
      = ( A3
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_1398_gcd__nat_Oextremum__strict,axiom,
    ! [A3: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A3 )
        & ( ( zero_zero @ nat )
         != A3 ) ) ).

% gcd_nat.extremum_strict
thf(fact_1399_gcd__nat_Oextremum,axiom,
    ! [A3: nat] : ( dvd_dvd @ nat @ A3 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_1400_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A3 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1401_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N ) ) ) ) ) ).

% dvd_mod
thf(fact_1402_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A3 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A3 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_1403_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A3 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A3 ) ) ) ) ).

% dvd_mod_iff
thf(fact_1404_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_1405_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_1406_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A3 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1407_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_1408_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1409_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_1410_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X: B] :
          ( ( ord_less @ B @ Z5 @ X )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_1411_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X: B] :
          ( ( ord_less @ B @ Z5 @ X )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1412_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X: B] :
          ( ( ord_less @ B @ X @ Z5 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ).

% minf(9)
thf(fact_1413_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X: B] :
          ( ( ord_less @ B @ X @ Z5 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_1414_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_1415_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_1416_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( zero_zero @ A ) )
            = ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1417_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1418_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1419_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1420_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1421_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1422_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A3 @ B2 )
              = ( times_times @ A @ A3 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1423_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A3 )
              = ( times_times @ A @ C2 @ A3 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1424_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_1425_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1426_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1427_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1428_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1429_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1430_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1431_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1432_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1433_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A3 )
              = ( divide_divide @ A @ C2 @ A3 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1434_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1435_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1436_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A3 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_1437_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1438_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( modulo_modulo @ A @ B4 @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1439_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1440_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_mono
thf(fact_1441_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1442_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A3 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A3 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1443_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X3: A,Y5: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ Y5 @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1444_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1445_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1446_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_1447_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N )
       => ~ ( dvd_dvd @ int @ N @ M ) ) ) ).

% zdvd_not_zless
thf(fact_1448_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_1449_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1450_bezout__add__nat,axiom,
    ! [A3: nat,B2: nat] :
    ? [D3: nat,X2: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D3 @ A3 )
      & ( dvd_dvd @ nat @ D3 @ B2 )
      & ( ( ( times_times @ nat @ A3 @ X2 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D3 ) )
        | ( ( times_times @ nat @ B2 @ X2 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A3 @ Y2 ) @ D3 ) ) ) ) ).

% bezout_add_nat
thf(fact_1451_bezout__lemma__nat,axiom,
    ! [D2: nat,A3: nat,B2: nat,X3: nat,Y5: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A3 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A3 @ X3 )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X3 )
              = ( plus_plus @ nat @ ( times_times @ nat @ A3 @ Y5 ) @ D2 ) ) )
         => ? [X2: nat,Y2: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A3 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A3 @ B2 ) )
              & ( ( ( times_times @ nat @ A3 @ X2 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A3 @ B2 ) @ Y2 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A3 @ B2 ) @ X2 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A3 @ Y2 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1452_zdvd__period,axiom,
    ! [A3: int,D2: int,X3: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A3 @ D2 )
     => ( ( dvd_dvd @ int @ A3 @ ( plus_plus @ int @ X3 @ T2 ) )
        = ( dvd_dvd @ int @ A3 @ ( plus_plus @ int @ ( plus_plus @ int @ X3 @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1453_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_1454_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_1455_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_1456_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ~ ( ( A3
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A3 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1457_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X4: A] : ( P @ ( times_times @ A @ L @ X4 ) ) )
          = ( ? [X4: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X4 @ ( zero_zero @ A ) ) )
                & ( P @ X4 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1458_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A3 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A3 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1459_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1460_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1461_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A3 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A3 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A3 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1462_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( zero_zero @ A ) )
            = ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1463_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ).

% even_numeral
thf(fact_1464_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1465_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1466_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1467_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1468_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A3
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A3 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1469_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = C2 )
            = ( A3
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1470_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1471_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A3 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1472_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_1473_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_1474_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_1475_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_1476_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_1477_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1478_bezout__add__strong__nat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3
       != ( zero_zero @ nat ) )
     => ? [D3: nat,X2: nat,Y2: nat] :
          ( ( dvd_dvd @ nat @ D3 @ A3 )
          & ( dvd_dvd @ nat @ D3 @ B2 )
          & ( ( times_times @ nat @ A3 @ X2 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D3 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1479_zdvd__imp__le,axiom,
    ! [Z2: int,N: int] :
      ( ( dvd_dvd @ int @ Z2 @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z2 @ N ) ) ) ).

% zdvd_imp_le
thf(fact_1480_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1481_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_1482_option_Osize__neq,axiom,
    ! [A: $tType,X3: option @ A] :
      ( ( size_size @ ( option @ A ) @ X3 )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_1483_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X2: A] :
          ( ( P @ X2 )
          & ! [Y6: A] :
              ( ( P @ Y6 )
             => ( ord_less_eq @ nat @ ( M @ X2 ) @ ( M @ Y6 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_1484_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1485_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ~ ( ( A3
               != ( zero_zero @ A ) )
             => ! [B6: A] :
                  ( ( B6
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B6 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A3 )
                        = B6 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B6 )
                          = A3 )
                       => ( ( ( times_times @ A @ A3 @ B6 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A3 )
                           != ( times_times @ A @ C2 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1486_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1487_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ A3 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1488_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ~ ! [B6: A] :
                ( A3
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) ) ) ) ).

% evenE
thf(fact_1489_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1490_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1491_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) )
              & ( ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1492_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X3: A,M: nat,N: nat] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X3 @ M ) @ ( power_power @ A @ X3 @ N ) )
            = ( ( dvd_dvd @ A @ X3 @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1493_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X3: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X3
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X3 @ ( power_power @ A @ X3 @ N ) ) ) ) ).

% dvd_power
thf(fact_1494_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1495_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1496_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1497_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_1498_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_1499_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A3 ) ) ) ).

% even_two_times_div_two
thf(fact_1500_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1501_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1502_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_1503_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_1504_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_1505_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1506_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A3 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1507_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A3 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1508_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A3 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1509_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ~ ! [B6: A] :
                ( A3
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1510_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1511_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1512_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1513_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A3: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1514_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_1515_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1516_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1517_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A3 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A3
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1518_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: A] :
            ( ( P @ Y2 )
           => ( ord_less @ nat @ ( F2 @ Y2 ) @ B2 ) )
       => ? [X2: A] :
            ( ( P @ X2 )
            & ! [Y6: A] :
                ( ( P @ Y6 )
               => ( ord_less_eq @ nat @ ( F2 @ Y6 ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_1519_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A3
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1520_Bernoulli__inequality__even,axiom,
    ! [N: nat,X3: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X3 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_1521_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_1522_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_1523_div2__even__ext__nat,axiom,
    ! [X3: nat,Y5: nat] :
      ( ( ( divide_divide @ nat @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X3 )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y5 ) )
       => ( X3 = Y5 ) ) ) ).

% div2_even_ext_nat
thf(fact_1524_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1525_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_1526_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1527_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( ( vEBT_invar_vebt @ A1 @ A22 )
     => ( ( ? [A7: $o,B6: $o] :
              ( A1
              = ( vEBT_Leaf @ A7 @ B6 ) )
         => ( A22
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( A22 = Deg2 )
               => ( ! [X: vEBT_VEBT] :
                      ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M4 ) )
                         => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                           => ~ ! [X: vEBT_VEBT] :
                                  ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A1
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( A22 = Deg2 )
                 => ( ! [X: vEBT_VEBT] :
                        ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M4 ) )
                           => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                             => ~ ! [X: vEBT_VEBT] :
                                    ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi: nat,Ma2: nat] :
                  ( ( A1
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X: vEBT_VEBT] :
                          ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M4 ) )
                             => ( ! [I4: nat] :
                                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X5 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                               => ( ( ( Mi = Ma2 )
                                   => ! [X: vEBT_VEBT] :
                                        ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi != Ma2 )
                                         => ! [I4: nat] :
                                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                    = I4 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                & ! [X: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X @ N3 )
                                                        = I4 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ X @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi @ X )
                                                      & ( ord_less_eq @ nat @ X @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi: nat,Ma2: nat] :
                    ( ( A1
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X: vEBT_VEBT] :
                            ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M4 ) )
                               => ( ! [I4: nat] :
                                      ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X5 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                                 => ( ( ( Mi = Ma2 )
                                     => ! [X: vEBT_VEBT] :
                                          ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi != Ma2 )
                                           => ! [I4: nat] :
                                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                      = I4 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                  & ! [X: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X @ N3 )
                                                          = I4 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ X @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi @ X )
                                                        & ( ord_less_eq @ nat @ X @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_1528_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A12: vEBT_VEBT,A23: nat] :
          ( ( ? [A5: $o,B4: $o] :
                ( A12
                = ( vEBT_Leaf @ A5 @ B4 ) )
            & ( A23
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X5 )
              & ! [X4: vEBT_VEBT] :
                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X5 )
              & ! [X4: vEBT_VEBT] :
                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi2: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma3 ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ! [I2: nat] :
                  ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                 => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X5 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I2 ) ) )
              & ( ( Mi2 = Ma3 )
               => ! [X4: vEBT_VEBT] :
                    ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi2 != Ma3 )
               => ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I2 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X4: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X4 @ N2 )
                              = I2 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X4 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X4 )
                            & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi2: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma3 ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ! [I2: nat] :
                  ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                 => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X5 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I2 ) ) )
              & ( ( Mi2 = Ma3 )
               => ! [X4: vEBT_VEBT] :
                    ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi2 != Ma3 )
               => ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I2 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X4: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X4 @ N2 )
                              = I2 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X4 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X4 )
                            & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_1529_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_1530_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% diff_zero
thf(fact_1531_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_1532_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% diff_0_right
thf(fact_1533_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_1534_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% add_diff_cancel_right'
thf(fact_1535_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A3 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1536_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ A3 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1537_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A3 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1538_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% diff_add_cancel
thf(fact_1539_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% add_diff_cancel
thf(fact_1540_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A3 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1541_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_1542_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1543_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_1544_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_1545_diff__diff__cancel,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I ) )
        = I ) ) ).

% diff_diff_cancel
thf(fact_1546_diff__diff__left,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J3 ) @ K )
      = ( minus_minus @ nat @ I @ ( plus_plus @ nat @ J3 @ K ) ) ) ).

% diff_diff_left
thf(fact_1547_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1548_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_1549_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_1550_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1551_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1552_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1553_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_1554_mi__ma__2__deg,axiom,
    ! [Mi3: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( ord_less_eq @ nat @ Mi3 @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_1555_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1556_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( ord_less @ A @ B2 @ A3 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1557_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ B2 )
            = A3 ) ) ) ).

% le_add_diff_inverse2
thf(fact_1558_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A3 @ B2 ) )
            = A3 ) ) ) ).

% le_add_diff_inverse
thf(fact_1559_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1560_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1561_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A3: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1562_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1563_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A3 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1564_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_1565_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_1566_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_1567_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_1568_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1569_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1570_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J3 @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J3 ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_1571_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J3 @ K ) @ I )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J3 @ I ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_1572_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( minus_minus @ nat @ I @ ( minus_minus @ nat @ J3 @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ J3 ) ) ) ).

% Nat.diff_diff_right
thf(fact_1573_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_1574_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1575_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi3: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X3: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X3 )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X3 = Mi3 )
          | ( X3 = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_1576_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_1577_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( minus_minus @ nat @ I @ ( suc @ ( minus_minus @ nat @ J3 @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ ( suc @ J3 ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1578_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J3 @ K ) ) @ I )
        = ( minus_minus @ nat @ ( suc @ J3 ) @ ( plus_plus @ nat @ K @ I ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1579_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X3: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi3: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X3 ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_1580_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P3: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P3 ) ) )
          = P3 ) ) ).

% odd_of_bool_self
thf(fact_1581_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_1582_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1583_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1584_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_1585_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_1586_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1587_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1588_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1589_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1590_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1591_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_1592_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_1593_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A3 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_1594_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_1595_diff__commute,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J3 ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I @ K ) @ J3 ) ) ).

% diff_commute
thf(fact_1596_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P3: $o,Q2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P3 )
            = ( zero_neq_one_of_bool @ A @ Q2 ) )
          = ( P3 = Q2 ) ) ) ).

% of_bool_eq_iff
thf(fact_1597_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_1598_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1599_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_1600_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1601_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1602_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1603_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [A5: A,B4: A] :
              ( ( minus_minus @ A @ A5 @ B4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_1604_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1605_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1606_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1607_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1608_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D4: A,Q: A > $o] :
          ( ! [X2: A,K2: A] :
              ( ( P @ X2 )
              = ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
         => ( ! [X2: A,K2: A] :
                ( ( Q @ X2 )
                = ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
           => ! [X: A,K4: A] :
                ( ( ( P @ X )
                  & ( Q @ X ) )
                = ( ( P @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) )
                  & ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1609_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D4: A,Q: A > $o] :
          ( ! [X2: A,K2: A] :
              ( ( P @ X2 )
              = ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
         => ( ! [X2: A,K2: A] :
                ( ( Q @ X2 )
                = ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
           => ! [X: A,K4: A] :
                ( ( ( P @ X )
                  | ( Q @ X ) )
                = ( ( P @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) )
                  | ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1610_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1611_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A3 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A3 ) @ ( times_times @ A @ C2 @ A3 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1612_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1613_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1614_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_1615_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1616_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A3 )
         => ( C2
            = ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1617_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1618_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1619_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1620_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1621_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( A3
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1622_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = C2 )
          = ( A3
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1623_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,K: A,A3: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1624_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A3 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1625_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( dvd_dvd @ A @ X3 @ Y5 )
         => ( ( dvd_dvd @ A @ X3 @ Z2 )
           => ( dvd_dvd @ A @ X3 @ ( minus_minus @ A @ Y5 @ Z2 ) ) ) ) ) ).

% dvd_diff
thf(fact_1626_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1627_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I ) ) ) ) ).

% zero_induct_lemma
thf(fact_1628_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_1629_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_1630_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1631_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1632_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1633_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1634_less__imp__diff__less,axiom,
    ! [J3: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J3 @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J3 @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_1635_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_1636_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_1637_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_1638_le__diff__iff_H,axiom,
    ! [A3: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A3 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A3 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A3 ) ) ) ) ).

% le_diff_iff'
thf(fact_1639_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_1640_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N @ L ) ) ) ).

% diff_le_mono
thf(fact_1641_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_1642_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_1643_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_1644_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1645_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_1646_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1647_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_1648_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_1649_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_1650_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_1651_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1652_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_1653_bezout1__nat,axiom,
    ! [A3: nat,B2: nat] :
    ? [D3: nat,X2: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D3 @ A3 )
      & ( dvd_dvd @ nat @ D3 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A3 @ X2 ) @ ( times_times @ nat @ B2 @ Y2 ) )
          = D3 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X2 ) @ ( times_times @ nat @ A3 @ Y2 ) )
          = D3 ) ) ) ).

% bezout1_nat
thf(fact_1654_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi3: nat,Ma: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT,X3: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ X3 )
      = ( ( X3 = Mi3 )
        | ( X3 = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_1655_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1656_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1657_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1658_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P3: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P3 ) )
          = ( ( P3
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P3
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1659_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P3: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P3 ) )
          = ( ~ ( ( P3
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P3
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1660_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1661_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1662_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A,J3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J3 @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J3 @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J3 ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1663_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ord_less_eq @ A @ I @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1664_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1665_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1666_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% diff_add
thf(fact_1667_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% le_add_diff
thf(fact_1668_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1669_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1670_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A3 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1671_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1672_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1673_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1674_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ A3 @ ( minus_minus @ A @ B2 @ A3 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1675_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A3 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A3 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1676_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ~ ( ord_less @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A3 @ B2 ) )
            = A3 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_1677_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( ord_less @ A @ A3 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1678_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1679_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X3: A,Y5: A,A3: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X3 @ Y5 ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X3 @ ( minus_minus @ A @ Y5 @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X3 @ A3 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1680_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X3: A,Y5: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( times_times @ A @ Y5 @ Y5 ) )
          = ( times_times @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( minus_minus @ A @ X3 @ Y5 ) ) ) ) ).

% square_diff_square_factored
thf(fact_1681_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1682_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1683_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A3: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1684_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1685_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_1686_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_1687_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_1688_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_1689_diff__less__mono,axiom,
    ! [A3: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A3 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A3 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A3 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_1690_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_1691_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1692_less__diff__conv,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ J3 @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J3 ) ) ).

% less_diff_conv
thf(fact_1693_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_1694_le__diff__conv,axiom,
    ! [J3: nat,K: nat,I: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J3 @ K ) @ I )
      = ( ord_less_eq @ nat @ J3 @ ( plus_plus @ nat @ I @ K ) ) ) ).

% le_diff_conv
thf(fact_1695_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( ord_less_eq @ nat @ I @ ( minus_minus @ nat @ J3 @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ J3 ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1696_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J3 ) @ K )
        = ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J3 @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1697_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J3 @ I ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J3 @ K ) @ I ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1698_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ( minus_minus @ nat @ J3 @ I )
          = K )
        = ( J3
          = ( plus_plus @ nat @ K @ I ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1699_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1700_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N2: nat] : ( if @ nat @ ( ord_less @ nat @ M3 @ N2 ) @ M3 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ).

% mod_if
thf(fact_1701_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_1702_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_1703_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q2 )
          = ( modulo_modulo @ nat @ N @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1704_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_1705_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1706_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1707_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1708_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1709_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X3 @ Z2 ) @ Y5 )
            = ( divide_divide @ A @ ( minus_minus @ A @ X3 @ ( times_times @ A @ Y5 @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1710_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X3 @ ( divide_divide @ A @ Y5 @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ Y5 ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1711_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y5: A,Z2: A,X3: A,W: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W @ Y5 ) ) @ ( times_times @ A @ Y5 @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1712_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A3 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1713_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X3 @ X3 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1714_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D4: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D4 )
         => ! [X: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1715_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D4: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D4 )
         => ! [X: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D4 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1716_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1717_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1718_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1719_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1720_diff__Suc__less,axiom,
    ! [N: nat,I: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_1721_nat__diff__split,axiom,
    ! [P: nat > $o,A3: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A3 @ B2 ) )
      = ( ( ( ord_less @ nat @ A3 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D5: nat] :
            ( ( A3
              = ( plus_plus @ nat @ B2 @ D5 ) )
           => ( P @ D5 ) ) ) ) ).

% nat_diff_split
thf(fact_1722_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A3: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A3 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A3 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D5: nat] :
                ( ( A3
                  = ( plus_plus @ nat @ B2 @ D5 ) )
                & ~ ( P @ D5 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1723_less__diff__conv2,axiom,
    ! [K: nat,J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J3 )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J3 @ K ) @ I )
        = ( ord_less @ nat @ J3 @ ( plus_plus @ nat @ I @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1724_nat__diff__add__eq2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J3 @ I ) @ U ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1725_nat__diff__add__eq1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J3 @ I )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J3 ) @ U ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_1726_nat__le__add__iff2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J3 @ I ) @ U ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1727_nat__le__add__iff1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J3 @ I )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J3 ) @ U ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_1728_nat__eq__add__iff2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J3 @ I ) @ U ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1729_nat__eq__add__iff1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J3 @ I )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J3 ) @ U ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_1730_dvd__minus__add,axiom,
    ! [Q2: nat,N: nat,R2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R2 @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q2 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R2 @ M ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1731_mod__nat__eqI,axiom,
    ! [R2: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R2 @ N )
     => ( ( ord_less_eq @ nat @ R2 @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R2 ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R2 ) ) ) ) ).

% mod_nat_eqI
thf(fact_1732_fact__div__fact__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R2 @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R2 ) ) ) @ ( power_power @ nat @ N @ R2 ) ) ) ).

% fact_div_fact_le_pow
thf(fact_1733_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N2: nat] : ( minus_minus @ nat @ M3 @ ( times_times @ nat @ ( divide_divide @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ).

% modulo_nat_def
thf(fact_1734_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_1735_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1736_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,Z2: A,X3: A,W: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W @ Y5 ) ) @ ( times_times @ A @ Y5 @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1737_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,Z2: A,X3: A,W: A] :
          ( ( Y5
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X3 @ Z2 ) @ ( times_times @ A @ W @ Y5 ) ) @ ( times_times @ A @ Y5 @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1738_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y5: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X3 @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y5 @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_1739_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,N: nat,M: nat] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A3 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_1740_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1741_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1742_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M3 @ N2 )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ) ).

% div_if
thf(fact_1743_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_1744_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% add_eq_if
thf(fact_1745_nat__less__add__iff1,axiom,
    ! [J3: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J3 @ I )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J3 ) @ U ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_1746_nat__less__add__iff2,axiom,
    ! [I: nat,J3: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J3 @ U ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J3 @ I ) @ U ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1747_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_1748_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1749_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1750_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X3: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y5: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X3 @ Xa @ Xb @ Xc )
        = Y5 )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y5 = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y5
            = ( set_fo6178422350223883121st_nat @ A @ X3 @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X3 @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_1751_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F3: nat > A > A,A5: nat,B4: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B4 @ A5 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A5 @ ( one_one @ nat ) ) @ B4 @ ( F3 @ A5 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_1752_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R2: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R2 )
           => ( ( ord_less_eq @ A @ R2 @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R2 @ ( minus_minus @ A @ V @ U ) ) @ S ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1753_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1754_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,N: nat,M: nat] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) )
                = ( power_power @ A @ A3 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A3 @ M ) @ ( power_power @ A @ A3 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1755_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1756_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A3 )
            = ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1757_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_1758_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_1759_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_1760_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A3: A] :
          ( ! [A7: A] :
              ( ( ( divide_divide @ A @ A7 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A7 )
             => ( P @ A7 ) )
         => ( ! [A7: A,B6: $o] :
                ( ( P @ A7 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A7 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A7 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A7 ) ) ) ) )
           => ( P @ A3 ) ) ) ) ).

% bits_induct
thf(fact_1761_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_1762_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_1763_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_1764_list__decode_Ocases,axiom,
    ! [X3: nat] :
      ( ( X3
       != ( zero_zero @ nat ) )
     => ~ ! [N3: nat] :
            ( X3
           != ( suc @ N3 ) ) ) ).

% list_decode.cases
thf(fact_1765_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y5: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X3 @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) @ Y5 ) ) ) ) ).

% power2_diff
thf(fact_1766_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1767_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1768_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1769_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi3: nat,Ma: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X5 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi3 = Ma )
                   => ! [X2: vEBT_VEBT] :
                        ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi3 != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X2: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X2 @ N )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ X2 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi3 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_1770_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1771_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1772_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi3: nat,Ma: nat] :
      ( ! [X2: vEBT_VEBT] :
          ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X2 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X5 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi3 = Ma )
                   => ! [X2: vEBT_VEBT] :
                        ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi3 != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X2: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X2 @ N )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ X2 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi3 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_1773_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1774_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R2: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R2 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R2 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R2 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R2 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R2 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R2 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1775_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_1776_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_1777_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H: A,Z2: A,K5: real,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z2 @ H ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ N ) @ ( power_power @ A @ Z2 @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_1778_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H: nat > A,G: A,N: nat] :
      ( ! [N3: nat] :
          ( ( F2 @ ( suc @ N3 ) )
          = ( H @ N3 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = G ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = ( H @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1779_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: A,R2: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R2 ) )
          = ( R2
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_1780_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_1781_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_1782_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_1783_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1784_idiff__enat__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( extended_enat2 @ ( zero_zero @ nat ) ) )
      = N ) ).

% idiff_enat_0_right
thf(fact_1785_idiff__enat__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ ( zero_zero @ nat ) ) @ N )
      = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% idiff_enat_0
thf(fact_1786_idiff__enat__enat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A3 ) @ ( extended_enat2 @ B2 ) )
      = ( extended_enat2 @ ( minus_minus @ nat @ A3 @ B2 ) ) ) ).

% idiff_enat_enat
thf(fact_1787_zle__diff1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% zle_diff1_eq
thf(fact_1788_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_1789_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1790_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_1791_int__diff__cases,axiom,
    ! [Z2: int] :
      ~ ! [M4: nat,N3: nat] :
          ( Z2
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_diff_cases
thf(fact_1792_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N ) )
     => ( ( dvd_dvd @ int @ K @ N )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_1793_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_1794_int__le__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I @ K )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_le_induct
thf(fact_1795_int__less__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_less_induct
thf(fact_1796_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X3: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,D3: nat] :
          ( X3
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D3 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg3: nat] :
            ( X3
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_1797_add__diff__assoc__enat,axiom,
    ! [Z2: extended_enat,Y5: extended_enat,X3: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z2 @ Y5 )
     => ( ( plus_plus @ extended_enat @ X3 @ ( minus_minus @ extended_enat @ Y5 @ Z2 ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X3 @ Y5 ) @ Z2 ) ) ) ).

% add_diff_assoc_enat
thf(fact_1798_Bolzano,axiom,
    ! [A3: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A3 @ B2 )
     => ( ! [A7: real,B6: real,C3: real] :
            ( ( P @ A7 @ B6 )
           => ( ( P @ B6 @ C3 )
             => ( ( ord_less_eq @ real @ A7 @ B6 )
               => ( ( ord_less_eq @ real @ B6 @ C3 )
                 => ( P @ A7 @ C3 ) ) ) ) )
       => ( ! [X2: real] :
              ( ( ord_less_eq @ real @ A3 @ X2 )
             => ( ( ord_less_eq @ real @ X2 @ B2 )
               => ? [D6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                    & ! [A7: real,B6: real] :
                        ( ( ( ord_less_eq @ real @ A7 @ X2 )
                          & ( ord_less_eq @ real @ X2 @ B6 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B6 @ A7 ) @ D6 ) )
                       => ( P @ A7 @ B6 ) ) ) ) )
         => ( P @ A3 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1799_plusinfinity,axiom,
    ! [D2: int,P5: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int,K2: int] :
            ( ( P5 @ X2 )
            = ( P5 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X2: int] :
              ( ( ord_less @ int @ Z4 @ X2 )
             => ( ( P @ X2 )
                = ( P5 @ X2 ) ) )
         => ( ? [X_1: int] : ( P5 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% plusinfinity
thf(fact_1800_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int,K2: int] :
            ( ( P1 @ X2 )
            = ( P1 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X2: int] :
              ( ( ord_less @ int @ X2 @ Z4 )
             => ( ( P @ X2 )
                = ( P1 @ X2 ) ) )
         => ( ? [X_1: int] : ( P1 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% minusinfinity
thf(fact_1801_int__induct,axiom,
    ! [P: int > $o,K: int,I: int] :
      ( ( P @ K )
     => ( ! [I3: int] :
            ( ( ord_less_eq @ int @ K @ I3 )
           => ( ( P @ I3 )
             => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_induct
thf(fact_1802_int__ops_I6_J,axiom,
    ! [A3: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A3 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A3 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_1803_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int] :
            ( ( P @ X2 )
           => ( P @ ( minus_minus @ int @ X2 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X: int] :
              ( ( P @ X )
             => ( P @ ( minus_minus @ int @ X @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1804_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_1805_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X3: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A7: $o,B6: $o,X2: nat] :
          ( X3
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A7 @ B6 ) @ X2 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X3
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X2: nat] :
              ( X3
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ X2 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_1806_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X9: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_1807_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X9: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_1808_zdiff__int__split,axiom,
    ! [P: int > $o,X3: nat,Y5: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X3 @ Y5 ) ) )
      = ( ( ( ord_less_eq @ nat @ Y5 @ X3 )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X3 ) @ ( semiring_1_of_nat @ int @ Y5 ) ) ) )
        & ( ( ord_less @ nat @ X3 @ Y5 )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_1809_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_1810_real__of__nat__div2,axiom,
    ! [N: nat,X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X3 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X3 ) ) ) ) ).

% real_of_nat_div2
thf(fact_1811_real__of__nat__div3,axiom,
    ! [N: nat,X3: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X3 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X3 ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_1812_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1813_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1814_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X3: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X3
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X3
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X2: nat] :
              ( X3
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X2 ) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT,X2: nat] :
                ( X3
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) @ X2 ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT,X2: nat] :
                  ( X3
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ X2 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_1815_neg__zmod__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A3 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1816_real__average__minus__second,axiom,
    ! [B2: real,A3: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A3 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1817_real__average__minus__first,axiom,
    ! [A3: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A3 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A3 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1818_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A3: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_1819_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A3: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_1820_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A3: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A3 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A3 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_1821_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( zero_zero @ real ) )
          = ( X3
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_1822_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
          = ( ( X3
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_1823_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X3 )
            = ( zero_zero @ real ) )
          = ( X3
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_1824_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_1825_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_1826_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_1827_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_1828_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_1829_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) ) ).

% norm_ge_zero
thf(fact_1830_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X3 @ Y5 ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ Y5 ) ) ) ) ).

% norm_mult
thf(fact_1831_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A3: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_1832_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: A,N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X3 @ N ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ N ) ) ) ).

% norm_power
thf(fact_1833_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A3 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_1834_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat,Z2: A] :
          ( ( ( power_power @ A @ W @ N )
            = ( power_power @ A @ Z2 @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_1835_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X3: A,R2: real,Y5: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ R2 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y5 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X3 @ Y5 ) ) @ ( times_times @ real @ R2 @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_1836_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X3 @ Y5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ Y5 ) ) ) ) ).

% norm_mult_ineq
thf(fact_1837_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ Y5 ) ) @ E )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ E ) ) ) ).

% norm_triangle_lt
thf(fact_1838_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,R2: real,Y5: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ R2 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y5 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ ( plus_plus @ real @ R2 @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_1839_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A3 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_1840_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ Y5 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ E ) ) ) ).

% norm_triangle_le
thf(fact_1841_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ Y5 ) ) ) ) ).

% norm_triangle_ineq
thf(fact_1842_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,R2: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ R2 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( plus_plus @ real @ R2 @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_1843_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X3: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X3 @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_1844_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Y5 ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ Z2 ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_1845_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ Y5 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Y5 ) ) @ E ) ) ) ).

% norm_triangle_le_diff
thf(fact_1846_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Y5 ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ Z2 ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_1847_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A3 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_1848_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y5 ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Y5 ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_1849_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat] :
          ( ( ( power_power @ A @ W @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_1850_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A3 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_1851_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: A] :
          ( ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X3 )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_1852_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z2 @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z2 @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_1853_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X4 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X4 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_1854_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys2 ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) @ ( nth @ B @ Ys2 @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ) ).

% product_nth
thf(fact_1855_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q2: int,R2: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A3 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1856_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N2: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1857_binomial__code,axiom,
    ( binomial
    = ( ^ [N2: nat,K3: nat] : ( if @ nat @ ( ord_less @ nat @ N2 @ K3 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K3 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ K3 ) @ ( one_one @ nat ) ) @ N2 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K3 ) ) ) ) ) ) ).

% binomial_code
thf(fact_1858_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q2: int,R2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R2 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1859_ln__inj__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ( ln_ln @ real @ X3 )
            = ( ln_ln @ real @ Y5 ) )
          = ( X3 = Y5 ) ) ) ) ).

% ln_inj_iff
thf(fact_1860_ln__less__cancel__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X3 ) @ ( ln_ln @ real @ Y5 ) )
          = ( ord_less @ real @ X3 @ Y5 ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_1861_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_1862_ln__le__cancel__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X3 ) @ ( ln_ln @ real @ Y5 ) )
          = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_1863_ln__eq__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( ln_ln @ real @ X3 )
          = ( zero_zero @ real ) )
        = ( X3
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_1864_ln__gt__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X3 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X3 ) ) ) ).

% ln_gt_zero_iff
thf(fact_1865_ln__less__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X3 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X3 @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_1866_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_1867_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_1868_binomial__1,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = N ) ).

% binomial_1
thf(fact_1869_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_1870_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_1871_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_1872_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys2 ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% length_product
thf(fact_1873_triangle__Suc,axiom,
    ! [N: nat] :
      ( ( nat_triangle @ ( suc @ N ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N ) @ ( suc @ N ) ) ) ).

% triangle_Suc
thf(fact_1874_ln__ge__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X3 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X3 ) ) ) ).

% ln_ge_zero_iff
thf(fact_1875_ln__le__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X3 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X3 @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_1876_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_1877_unique__quotient,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
       => ( Q2 = Q3 ) ) ) ).

% unique_quotient
thf(fact_1878_unique__remainder,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
       => ( R2 = R3 ) ) ) ).

% unique_remainder
thf(fact_1879_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_1880_div__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R2: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
     => ( ( divide_divide @ int @ K @ L )
        = Q2 ) ) ).

% div_int_unique
thf(fact_1881_mod__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R2: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
     => ( ( modulo_modulo @ int @ K @ L )
        = R2 ) ) ).

% mod_int_unique
thf(fact_1882_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_1883_ln__less__self,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less @ real @ ( ln_ln @ real @ X3 ) @ X3 ) ) ).

% ln_less_self
thf(fact_1884_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) ) ).

% Suc_times_binomial
thf(fact_1885_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_1886_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( binomial @ N @ ( minus_minus @ nat @ N @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_1887_choose__mult__lemma,axiom,
    ! [M: nat,R2: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R2 ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R2 ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R2 ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_1888_binomial__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R2 @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R2 ) @ ( power_power @ nat @ N @ R2 ) ) ) ).

% binomial_le_pow
thf(fact_1889_ln__bound,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X3 ) @ X3 ) ) ).

% ln_bound
thf(fact_1890_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_1891_ln__gt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X3 ) ) ) ).

% ln_gt_zero
thf(fact_1892_ln__less__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X3 ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_1893_ln__gt__zero__imp__gt__one,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ord_less @ real @ ( one_one @ real ) @ X3 ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_1894_ln__ge__zero,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X3 ) ) ) ).

% ln_ge_zero
thf(fact_1895_Suc__times__binomial__add,axiom,
    ! [A3: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A3 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A3 @ B2 ) ) @ ( suc @ A3 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A3 @ B2 ) ) @ A3 ) ) ) ).

% Suc_times_binomial_add
thf(fact_1896_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_1897_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_1898_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N @ K ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_1899_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1900_eucl__rel__int,axiom,
    ! [K: int,L: int] : ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% eucl_rel_int
thf(fact_1901_ln__ge__zero__imp__ge__one,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X3 ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_1902_ln__add__one__self__le__self,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) ) @ X3 ) ) ).

% ln_add_one_self_le_self
thf(fact_1903_ln__mult,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ln_ln @ real @ ( times_times @ real @ X3 @ Y5 ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X3 ) @ ( ln_ln @ real @ Y5 ) ) ) ) ) ).

% ln_mult
thf(fact_1904_binomial__absorption,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N @ ( suc @ K ) ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_1905_ln__eq__minus__one,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( ln_ln @ real @ X3 )
          = ( minus_minus @ real @ X3 @ ( one_one @ real ) ) )
       => ( X3
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_1906_ln__div,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X3 @ Y5 ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X3 ) @ ( ln_ln @ real @ Y5 ) ) ) ) ) ).

% ln_div
thf(fact_1907_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_1908_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_1909_binomial__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_1910_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_1911_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_1912_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_1913_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_1914_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_1915_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_1916_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_1917_ln__le__minus__one,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X3 ) @ ( minus_minus @ real @ X3 @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_1918_ln__diff__le,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X3 ) @ ( ln_ln @ real @ Y5 ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X3 @ Y5 ) @ Y5 ) ) ) ) ).

% ln_diff_le
thf(fact_1919_ln__realpow,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ln_ln @ real @ ( power_power @ real @ X3 @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X3 ) ) ) ) ).

% ln_realpow
thf(fact_1920_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_1921_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_1922_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_1923_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_1924_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( binomial @ N @ ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_1925_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_1926_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_1927_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_1928_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_1929_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R2: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q2 ) @ R2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
            & ( ord_less @ int @ R2 @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R2 )
                & ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1930_ln__one__plus__pos__lower__bound,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X3 @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_1931_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_1932_tanh__ln__real,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( tanh @ real @ ( ln_ln @ real @ X3 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_1933_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R2: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
      = ( plus_plus @ int @ Q2
        @ ( zero_neq_one_of_bool @ int
          @ ( R2
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_1934_ln__one__minus__pos__lower__bound,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X3 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X3 ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_1935_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1936_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) ) @ X3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_1937_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X3: A > nat,X22: A] :
      ( ( size_option @ A @ X3 @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X3 @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_1938_set__decode__Suc,axiom,
    ! [N: nat,X3: nat] :
      ( ( member2 @ nat @ ( suc @ N ) @ ( nat_set_decode @ X3 ) )
      = ( member2 @ nat @ N @ ( nat_set_decode @ ( divide_divide @ nat @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1939_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A3 ) )
          = A3 ) ) ).

% add.inverse_inverse
thf(fact_1940_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A3 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1941_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( uminus_uminus @ B @ ( uminus_uminus @ B @ B2 ) )
          = B2 ) ) ).

% verit_minus_simplify(4)
thf(fact_1942_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_idempotent
thf(fact_1943_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_abs
thf(fact_1944_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1945_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = A3 )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1946_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( A3
            = ( uminus_uminus @ A @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1947_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1948_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A3 ) )
          = ( ( zero_zero @ A )
            = A3 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1949_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1950_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1951_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1952_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1953_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A3 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1954_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1955_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1956_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( plus_plus @ A @ A3 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1957_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ A3 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1958_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A3 ) ) ) ).

% minus_diff_eq
thf(fact_1959_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A3 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1960_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_1961_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1962_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ( abs_abs @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1963_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1964_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y5: A] :
          ( ( dvd_dvd @ A @ X3 @ ( uminus_uminus @ A @ Y5 ) )
          = ( dvd_dvd @ A @ X3 @ Y5 ) ) ) ).

% dvd_minus_iff
thf(fact_1965_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: A,Y5: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X3 ) @ Y5 )
          = ( dvd_dvd @ A @ X3 @ Y5 ) ) ) ).

% minus_dvd_iff
thf(fact_1966_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_1967_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ A3 ) )
          = ( times_times @ A @ A3 @ A3 ) ) ) ).

% abs_mult_self_eq
thf(fact_1968_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_1969_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1970_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_1971_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_minus_cancel
thf(fact_1972_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_minus
thf(fact_1973_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1974_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_1975_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_1976_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_1977_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_1978_negative__zle,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_1979_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_1980_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_1981_tanh__real__zero__iff,axiom,
    ! [X3: real] :
      ( ( ( tanh @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( X3
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_1982_tanh__real__less__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X3 ) @ ( tanh @ real @ Y5 ) )
      = ( ord_less @ real @ X3 @ Y5 ) ) ).

% tanh_real_less_iff
thf(fact_1983_tanh__real__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X3 ) @ ( tanh @ real @ Y5 ) )
      = ( ord_less_eq @ real @ X3 @ Y5 ) ) ).

% tanh_real_le_iff
thf(fact_1984_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1985_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1986_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1987_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1988_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1989_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1990_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_pos
thf(fact_1991_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1992_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1993_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1994_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1995_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A3 )
          = ( uminus_uminus @ A @ A3 ) ) ) ).

% diff_0
thf(fact_1996_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1997_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_1998_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_1999_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2000_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ A3 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% abs_le_self_iff
thf(fact_2001_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( abs_abs @ A @ A3 )
            = A3 ) ) ) ).

% abs_of_nonneg
thf(fact_2002_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A3 ) ) ) ).

% uminus_add_conv_diff
thf(fact_2003_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A3 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_2004_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A3 ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2005_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A] :
          ( ( divide_divide @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X3 ) ) ) ).

% divide_minus1
thf(fact_2006_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A3 ) ) ) ).

% div_minus1_right
thf(fact_2007_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_2008_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2009_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_2010_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_2011_negative__zless,axiom,
    ! [N: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2012_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_2013_real__add__minus__iff,axiom,
    ! [X3: real,A3: real] :
      ( ( ( plus_plus @ real @ X3 @ ( uminus_uminus @ real @ A3 ) )
        = ( zero_zero @ real ) )
      = ( X3 = A3 ) ) ).

% real_add_minus_iff
thf(fact_2014_tanh__real__pos__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X3 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% tanh_real_pos_iff
thf(fact_2015_tanh__real__neg__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2016_tanh__real__nonpos__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2017_tanh__real__nonneg__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X3 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% tanh_real_nonneg_iff
thf(fact_2018_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_2019_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_2020_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_2021_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_2022_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_2023_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_2024_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A3 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2025_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A3 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2026_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A3 )
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2027_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_2028_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A3 ) )
          = A3 ) ) ).

% left_minus_one_mult_self
thf(fact_2029_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_2030_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2031_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y5: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y5 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y5 ) ) ) ).

% semiring_norm(168)
thf(fact_2032_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_2033_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_2034_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y5: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y5 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y5 ) ) ) ).

% semiring_norm(172)
thf(fact_2035_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y5: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y5 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y5 ) ) ) ).

% semiring_norm(171)
thf(fact_2036_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y5: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y5 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y5 ) ) ) ).

% semiring_norm(170)
thf(fact_2037_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_2038_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_2039_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_2040_artanh__minus__real,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X3 ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X3 ) ) ) ) ).

% artanh_minus_real
thf(fact_2041_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_2042_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_2043_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_2044_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_2045_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A3 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_2046_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_2047_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A3 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_2048_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_2049_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_2050_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A3 )
          = ( ord_less @ A @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_2051_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A3 ) @ N ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_2052_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_2053_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2054_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2055_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_2056_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_2057_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_2058_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_2059_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_2060_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_2061_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_2062_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( power_power @ A @ A3 @ N ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_2063_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( uminus_uminus @ A @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_minus_odd
thf(fact_2064_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A3: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A3 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_2065_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_2066_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_2067_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_2068_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_2069_set__decode__0,axiom,
    ! [X3: nat] :
      ( ( member2 @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X3 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X3 ) ) ) ).

% set_decode_0
thf(fact_2070_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_2071_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_2072_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_2073_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_2074_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_minus_self
thf(fact_2075_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_2076_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_2077_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_2078_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% equation_minus_iff
thf(fact_2079_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A3 ) ) ) ).

% minus_equation_iff
thf(fact_2080_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
         => ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B2 ) ) ) ) ).

% verit_negate_coefficient(3)
thf(fact_2081_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( abs_abs @ A @ X3 )
            = ( abs_abs @ A @ Y5 ) )
          = ( ( X3 = Y5 )
            | ( X3
              = ( uminus_uminus @ A @ Y5 ) ) ) ) ) ).

% abs_eq_iff
thf(fact_2082_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ B2 )
          = ( ( ord_less @ A @ A3 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_2083_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A3 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2084_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
            & ( ( B2 = A3 )
              | ( B2
                = ( uminus_uminus @ A @ A3 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_2085_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( abs_abs @ A @ A3 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A3 = B2 )
              | ( A3
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_2086_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if
thf(fact_2087_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A5: A] : ( if @ A @ ( ord_less @ A @ A5 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A5 ) @ A5 ) ) ) ) ).

% abs_if_raw
thf(fact_2088_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A3 )
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% abs_of_neg
thf(fact_2089_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A5: real] : ( if @ real @ ( ord_less @ real @ A5 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A5 ) @ A5 ) ) ) ).

% abs_real_def
thf(fact_2090_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_2091_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_self
thf(fact_2092_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( ( abs_abs @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_2093_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_2094_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2095_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ).

% abs_minus_commute
thf(fact_2096_tanh__real__gt__neg1,axiom,
    ! [X3: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X3 ) ) ).

% tanh_real_gt_neg1
thf(fact_2097_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A3 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A3 ) @ N ) ) ) ).

% power_abs
thf(fact_2098_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L: A,K: A] :
          ( ( ( abs_abs @ A @ L )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_2099_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% le_minus_iff
thf(fact_2100_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) ).

% minus_le_iff
thf(fact_2101_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% le_imp_neg_le
thf(fact_2102_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_2103_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) ).

% minus_less_iff
thf(fact_2104_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% less_minus_iff
thf(fact_2105_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_2106_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_2107_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( times_times @ A @ A3 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_2108_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ A3 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A3 = B2 )
            | ( A3
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_2109_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_2110_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_2111_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_2112_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,K: A,A3: A] :
          ( ( A2
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( uminus_uminus @ A @ A2 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_2113_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A3 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_2114_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_2115_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_2116_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_2117_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A3 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_2118_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_2119_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_2120_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A,A6: A] :
          ( ( ( modulo_modulo @ A @ A3 @ B2 )
            = ( modulo_modulo @ A @ A6 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A6 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_2121_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_2122_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_2123_int__cases2,axiom,
    ! [Z2: int] :
      ( ! [N3: nat] :
          ( Z2
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z2
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% int_cases2
thf(fact_2124_signed__take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_2125_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% subset_decode_imp_le
thf(fact_2126_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_zero
thf(fact_2127_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2128_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( abs_abs @ A @ A3 )
            = A3 ) ) ) ).

% abs_of_pos
thf(fact_2129_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2130_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2131_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2132_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2133_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2134_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_2135_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_2136_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_2137_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_2138_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_2139_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_2140_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_2141_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_2142_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_2143_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% add_eq_0_iff
thf(fact_2144_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_2145_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A3 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_2146_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_2147_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B2 )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_2148_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_2149_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_2150_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X3: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X3 ) )
          = ( times_times @ A @ X3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_2151_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_2152_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_2153_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_2154_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_2155_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X3: A] :
          ( ( ( times_times @ A @ X3 @ X3 )
            = ( one_one @ A ) )
          = ( ( X3
              = ( one_one @ A ) )
            | ( X3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_2156_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_2157_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_2158_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_2159_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_2160_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_2161_real__minus__mult__self__le,axiom,
    ! [U: real,X3: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X3 @ X3 ) ) ).

% real_minus_mult_self_le
thf(fact_2162_int__cases,axiom,
    ! [Z2: int] :
      ( ! [N3: nat] :
          ( Z2
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z2
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% int_cases
thf(fact_2163_int__of__nat__induct,axiom,
    ! [P: int > $o,Z2: int] :
      ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ int @ N3 ) )
     => ( ! [N3: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) )
       => ( P @ Z2 ) ) ) ).

% int_of_nat_induct
thf(fact_2164_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_2165_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_2166_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_2167_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2168_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_2169_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_2170_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X4: real,Y: real] : ( plus_plus @ real @ X4 @ ( uminus_uminus @ real @ Y ) ) ) ) ).

% minus_real_def
thf(fact_2171_tanh__real__lt__1,axiom,
    ! [X3: real] : ( ord_less @ real @ ( tanh @ real @ X3 ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2172_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X3: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ E2 ) )
         => ( X3
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2173_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y5 ) @ X3 )
            = ( abs_abs @ A @ ( times_times @ A @ Y5 @ X3 ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2174_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              | ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2175_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A3 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_2176_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X3 ) @ Y5 )
            = ( abs_abs @ A @ ( divide_divide @ A @ X3 @ Y5 ) ) ) ) ) ).

% abs_div_pos
thf(fact_2177_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,A3: A,R2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ A3 ) ) @ R2 )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ R2 ) @ X3 )
            & ( ord_less_eq @ A @ X3 @ ( plus_plus @ A @ A3 @ R2 ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_2178_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2179_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2180_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,A3: A,R2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ A3 ) ) @ R2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A3 @ R2 ) @ X3 )
            & ( ord_less @ A @ X3 @ ( plus_plus @ A @ A3 @ R2 ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_2181_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_2182_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_2183_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_2184_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_2185_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_2186_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_2187_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_2188_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_2189_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_2190_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_2191_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_2192_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_2193_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_2194_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_2195_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_2196_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_2197_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_2198_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_2199_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A3 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_2200_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A3 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_2201_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A3 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A3 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_2202_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_2203_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_2204_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_2205_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_2206_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_2207_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_minus
thf(fact_2208_lemma__interval__lt,axiom,
    ! [A3: real,X3: real,B2: real] :
      ( ( ord_less @ real @ A3 @ X3 )
     => ( ( ord_less @ real @ X3 @ B2 )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [Y6: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y6 ) ) @ D3 )
               => ( ( ord_less @ real @ A3 @ Y6 )
                  & ( ord_less @ real @ Y6 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_2209_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_2210_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A,Y5: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X3 ) @ Y5 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) ) ) ).

% norm_uminus_minus
thf(fact_2211_sin__bound__lemma,axiom,
    ! [X3: real,Y5: real,U: real,V: real] :
      ( ( X3 = Y5 )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X3 @ U ) @ Y5 ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_2212_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2213_real__add__less__0__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X3 @ Y5 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y5 @ ( uminus_uminus @ real @ X3 ) ) ) ).

% real_add_less_0_iff
thf(fact_2214_real__0__less__add__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X3 @ Y5 ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X3 ) @ Y5 ) ) ).

% real_0_less_add_iff
thf(fact_2215_real__0__le__add__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X3 @ Y5 ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X3 ) @ Y5 ) ) ).

% real_0_le_add_iff
thf(fact_2216_real__add__le__0__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X3 @ Y5 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y5 @ ( uminus_uminus @ real @ X3 ) ) ) ).

% real_add_le_0_iff
thf(fact_2217_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2218_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% nonpos_int_cases
thf(fact_2219_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2220_zmod__zminus2__eq__if,axiom,
    ! [A3: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A3 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A3 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A3 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A3 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A3 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_2221_zmod__zminus1__eq__if,axiom,
    ! [A3: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A3 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A3 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A3 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A3 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A3 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_2222_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X3 ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2223_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_2224_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_2225_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_2226_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_2227_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_2228_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_2229_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_2230_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_2231_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_2232_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X3 @ Z2 ) ) @ Y5 )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X3 ) @ ( times_times @ A @ Y5 @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_2233_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X3 @ Z2 ) ) @ Y5 )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X3 ) @ ( times_times @ A @ Y5 @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_2234_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A3 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_2235_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_2236_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A3 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ).

% even_minus
thf(fact_2237_lemma__interval,axiom,
    ! [A3: real,X3: real,B2: real] :
      ( ( ord_less @ real @ A3 @ X3 )
     => ( ( ord_less @ real @ X3 @ B2 )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [Y6: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y6 ) ) @ D3 )
               => ( ( ord_less_eq @ real @ A3 @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_2238_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X3 = Y5 )
            | ( X3
              = ( uminus_uminus @ A @ Y5 ) ) ) ) ) ).

% power2_eq_iff
thf(fact_2239_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2240_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2241_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A3 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K3: nat] :
                ( ( ord_less @ nat @ K3 @ N )
                & ( A3
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K3 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_2242_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_2243_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_2244_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_2245_ln__add__one__self__le__self2,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) ) @ X3 ) ) ).

% ln_add_one_self_le_self2
thf(fact_2246_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_2247_negative__zless__0,axiom,
    ! [N: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2248_negD,axiom,
    ! [X3: int] :
      ( ( ord_less @ int @ X3 @ ( zero_zero @ int ) )
     => ? [N3: nat] :
          ( X3
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% negD
thf(fact_2249_verit__less__mono__div__int2,axiom,
    ! [A2: int,B3: int,N: int] :
      ( ( ord_less_eq @ int @ A2 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B3 @ N ) @ ( divide_divide @ int @ A2 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_2250_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_2251_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ ( abs_abs @ A @ Y5 ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2252_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X3 )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2253_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( abs_abs @ A @ A3 ) @ N )
            = ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_even_abs
thf(fact_2254_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_2255_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_2256_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_2257_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_2258_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_2259_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_2260_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_2261_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_2262_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A3: A] :
          ( ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A3
              = ( one_one @ A ) )
            | ( A3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_2263_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
              = ( power_power @ A @ A3 @ N ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
              = ( uminus_uminus @ A @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_2264_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_2265_realpow__square__minus__le,axiom,
    ! [U: real,X3: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_2266_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2267_ln__one__minus__pos__upper__bound,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X3 ) ) @ ( uminus_uminus @ real @ X3 ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2268_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_2269_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_2270_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A3: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A3 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A3 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A3 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A3 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_2271_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A3: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A3 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A3 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A3 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A3 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_2272_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y5 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ Y5 ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2273_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2274_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2275_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_2276_zminus1__lemma,axiom,
    ! [A3: int,B2: int,Q2: int,R2: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R2 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A3 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R2
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R2 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_2277_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_2278_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_2279_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) ) @ X3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2280_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2281_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) )
          = ( power_power @ A @ A3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_2282_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2283_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R2 ) @ K ) )
          = ( times_times @ A @ R2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R2 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2284_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_2285_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2286_Bernoulli__inequality,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X3 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_2287_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_2288_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2289_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2290_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2291_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2292_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2293_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2294_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2295_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2296_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2297_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X3: A > nat] :
      ( ( size_option @ A @ X3 @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_2298_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) ) @ X3 ) ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2299_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2300_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X3: A] :
          ( ! [X2: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
             => ( P @ X2 @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X3 ) @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2301_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2302_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2303_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y5 ) )
          = ( ord_less @ A @ Y5 @ X3 ) ) ) ).

% compl_less_compl_iff
thf(fact_2304_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y5 ) )
          = ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% compl_le_compl_iff
thf(fact_2305_arctan__double,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X3 ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X3 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2306_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2307_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(90)
thf(fact_2308_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y32 ) )
      = ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
thf(fact_2309_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) ).

% semiring_norm(89)
thf(fact_2310_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) ).

% semiring_norm(88)
thf(fact_2311_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2312_semiring__norm_I84_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) ).

% semiring_norm(84)
thf(fact_2313_zdvd1__eq,axiom,
    ! [X3: int] :
      ( ( dvd_dvd @ int @ X3 @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X3 )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2314_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_2315_arctan__eq__zero__iff,axiom,
    ! [X3: real] :
      ( ( ( arctan @ X3 )
        = ( zero_zero @ real ) )
      = ( X3
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_2316_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_2317_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_2318_zabs__less__one__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z2 ) @ ( one_one @ int ) )
      = ( Z2
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2319_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(7)
thf(fact_2320_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(9)
thf(fact_2321_arctan__less__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( arctan @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_2322_zero__less__arctan__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X3 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% zero_less_arctan_iff
thf(fact_2323_arctan__le__zero__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_2324_zero__le__arctan__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X3 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% zero_le_arctan_iff
thf(fact_2325_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) ).

% semiring_norm(14)
thf(fact_2326_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) ).

% semiring_norm(15)
thf(fact_2327_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_2328_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_2329_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_2330_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2331_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_2332_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2333_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2334_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2335_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2336_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2337_semiring__norm_I4_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2338_semiring__norm_I3_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% semiring_norm(3)
thf(fact_2339_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2340_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_2341_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_2342_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2343_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2344_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2345_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2346_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2347_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2348_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2349_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2350_zdvd__antisym__abs,axiom,
    ! [A3: int,B2: int] :
      ( ( dvd_dvd @ int @ A3 @ B2 )
     => ( ( dvd_dvd @ int @ B2 @ A3 )
       => ( ( abs_abs @ int @ A3 )
          = ( abs_abs @ int @ B2 ) ) ) ) ).

% zdvd_antisym_abs
thf(fact_2351_arctan__monotone,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ X3 @ Y5 )
     => ( ord_less @ real @ ( arctan @ X3 ) @ ( arctan @ Y5 ) ) ) ).

% arctan_monotone
thf(fact_2352_arctan__less__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( arctan @ X3 ) @ ( arctan @ Y5 ) )
      = ( ord_less @ real @ X3 @ Y5 ) ) ).

% arctan_less_iff
thf(fact_2353_arctan__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X3 ) @ ( arctan @ Y5 ) )
      = ( ord_less_eq @ real @ X3 @ Y5 ) ) ).

% arctan_le_iff
thf(fact_2354_arctan__monotone_H,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ X3 @ Y5 )
     => ( ord_less_eq @ real @ ( arctan @ X3 ) @ ( arctan @ Y5 ) ) ) ).

% arctan_monotone'
thf(fact_2355_xor__num_Ocases,axiom,
    ! [X3: product_prod @ num @ num] :
      ( ( X3
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X3
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X3
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M4: num] :
                ( X3
               != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) )
           => ( ! [M4: num,N3: num] :
                  ( X3
                 != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M4: num,N3: num] :
                    ( X3
                   != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M4: num] :
                      ( X3
                     != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) )
                 => ( ! [M4: num,N3: num] :
                        ( X3
                       != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M4: num,N3: num] :
                          ( X3
                         != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_2356_num_Oexhaust,axiom,
    ! [Y5: num] :
      ( ( Y5 != one2 )
     => ( ! [X23: num] :
            ( Y5
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y5
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2357_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I2: int] : ( if @ int @ ( ord_less @ int @ I2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I2 ) @ I2 ) ) ) ).

% zabs_def
thf(fact_2358_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2359_abs__div,axiom,
    ! [Y5: int,X3: int] :
      ( ( dvd_dvd @ int @ Y5 @ X3 )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X3 @ Y5 ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X3 ) @ ( abs_abs @ int @ Y5 ) ) ) ) ).

% abs_div
thf(fact_2360_sin__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( sin_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( cos_coeff @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% sin_coeff_Suc
thf(fact_2361_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2362_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2363_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2364_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2365_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2366_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2367_dvd__imp__le__int,axiom,
    ! [I: int,D2: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2368_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_2369_cos__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( cos_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% cos_coeff_Suc
thf(fact_2370_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2371_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ).

% odd_numeral
thf(fact_2372_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2373_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A3 @ A3 ) @ A3 ) ) ) ).

% power3_eq_cube
thf(fact_2374_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2375_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2376_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2377_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2378_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2379_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2380_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_2381_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_2382_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_div_eq_add3_div
thf(fact_2383_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2384_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I3 )
            & ( ord_less @ nat @ I3 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
           => ? [I3: nat] :
                ( ( ord_less_eq @ nat @ M @ I3 )
                & ( ord_less_eq @ nat @ I3 @ N )
                & ( ( F2 @ I3 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2385_incr__lemma,axiom,
    ! [D2: int,Z2: int,X3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z2 @ ( plus_plus @ int @ X3 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X3 @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_2386_decr__lemma,axiom,
    ! [D2: int,X3: int,Z2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X3 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X3 @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z2 ) ) ).

% decr_lemma
thf(fact_2387_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2388_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y5 ) @ X3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ Y5 ) ) ) ).

% compl_le_swap2
thf(fact_2389_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ ( uminus_uminus @ A @ X3 ) )
         => ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ Y5 ) ) ) ) ).

% compl_le_swap1
thf(fact_2390_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y5 ) @ ( uminus_uminus @ A @ X3 ) ) ) ) ).

% compl_mono
thf(fact_2391_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ ( uminus_uminus @ A @ X3 ) )
         => ( ord_less @ A @ X3 @ ( uminus_uminus @ A @ Y5 ) ) ) ) ).

% compl_less_swap1
thf(fact_2392_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y5 ) @ X3 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X3 ) @ Y5 ) ) ) ).

% compl_less_swap2
thf(fact_2393_nat__ivt__aux,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2394_complex__mod__minus__le__complex__mod,axiom,
    ! [X3: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X3 ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2395_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A3: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A3 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2396_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2397_arctan__add,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X3 ) @ ( arctan @ Y5 ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X3 @ Y5 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X3 @ Y5 ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2398_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2399_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2400_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2401_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_2402_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_2403_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2404_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2405_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2406_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2407_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2408_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_2409_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2410_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2411_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2412_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2413_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_2414_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2415_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2416_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_2417_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_2418_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2419_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2420_numeral__div__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_2421_minus__numeral__div__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_2422_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2423_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2424_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_2425_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_2426_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_2427_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_2428_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_2429_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_2430_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2431_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2432_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K3: num] : ( suc @ ( pred_numeral @ K3 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2433_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K3: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K3 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2434_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X4: A] : ( plus_plus @ A @ ( plus_plus @ A @ X4 @ X4 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2435_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2436_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M3: num,N2: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% divmod_int_def
thf(fact_2437_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N2: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ) ).

% divmod_def
thf(fact_2438_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M3: num,N2: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N2 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_2439_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X4: A] : ( minus_minus @ A @ ( plus_plus @ A @ X4 @ X4 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2440_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N2: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N2 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N2 @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N2 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_2441_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_2442_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_2443_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2444_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2445_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_2446_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A3 ) )
          = ( sgn_sgn @ A @ A3 ) ) ) ).

% sgn_sgn
thf(fact_2447_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_2448_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_2449_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_2450_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_2451_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_2452_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_2453_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A3 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A3 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_2454_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A3 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A3 ) @ N ) ) ) ).

% power_sgn
thf(fact_2455_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_2456_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_2457_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% sgn_greater
thf(fact_2458_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_2459_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ A3 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A3 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_2460_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_2461_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_2462_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_2463_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_2464_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( sgn_sgn @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_2465_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_2466_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_2467_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ A3 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_2468_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_2469_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_2470_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A3 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_2471_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_2472_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_2473_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R2: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R2 ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R2
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_2474_dvd__sgn__mult__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R2 ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R2
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_2475_mult__sgn__dvd__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R2 ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R2
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_2476_sgn__mult__dvd__iff,axiom,
    ! [R2: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R2 ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R2
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_2477_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_2478_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_2479_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_2480_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% even_take_bit_eq
thf(fact_2481_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A3 )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2482_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_2483_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_2484_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_2485_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2486_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_2487_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A3 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_2488_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_2489_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_2490_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_2491_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_2492_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ( ( ( sgn_sgn @ A @ X3 )
            = ( zero_zero @ A ) )
          = ( X3
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_2493_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_2494_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X3 @ Y5 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X3 ) @ ( sgn_sgn @ A @ Y5 ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_2495_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A3: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A3 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A3 @ B2 ) )
            = ( sgn_sgn @ A @ A3 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_2496_take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_2497_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_2498_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_2499_concat__bit__take__bit__eq,axiom,
    ! [N: nat,B2: int] :
      ( ( bit_concat_bit @ N @ ( bit_se2584673776208193580ke_bit @ int @ N @ B2 ) )
      = ( bit_concat_bit @ N @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_2500_concat__bit__eq__iff,axiom,
    ! [N: nat,K: int,L: int,R2: int,S: int] :
      ( ( ( bit_concat_bit @ N @ K @ L )
        = ( bit_concat_bit @ N @ R2 @ S ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N @ R2 ) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
thf(fact_2501_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_2502_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_2503_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A3: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A3 ) )
         => ( ( ( sgn_sgn @ A @ A3 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A3 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_2504_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_2505_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_2506_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_2507_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_2508_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_2509_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_2510_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A3 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_2511_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K3: A] : ( times_times @ A @ K3 @ ( sgn_sgn @ A @ K3 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_2512_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( sgn_sgn @ A @ A3 ) )
          = A3 ) ) ).

% abs_mult_sgn
thf(fact_2513_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( abs_abs @ A @ A3 ) )
          = A3 ) ) ).

% sgn_mult_abs
thf(fact_2514_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X3 ) @ ( abs_abs @ A @ X3 ) )
          = X3 ) ) ).

% mult_sgn_abs
thf(fact_2515_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L2: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_2516_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A3: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A3 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A3 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_2517_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A3 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_2518_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A3: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A3 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A3 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_2519_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L ) )
     => ( ( divide_divide @ int @ K @ L )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_2520_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A3: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A3 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A3 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_2521_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A3: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A3 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A3 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_2522_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_2523_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_2524_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% sgn_1_pos
thf(fact_2525_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A3 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A3 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_2526_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( A3
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A3
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_2527_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_2528_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_2529_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_2530_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_2531_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_2532_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X4: A] :
              ( if @ A
              @ ( X4
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X4 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_2533_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I2: int] :
          ( if @ int
          @ ( I2
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I2 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_2534_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ( ( ( X3
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X3 ) )
              = ( zero_zero @ real ) ) )
          & ( ( X3
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X3 ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_2535_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_2536_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( dvd_dvd @ int @ L @ K )
     => ( ( divide_divide @ int @ K @ L )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_2537_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_2538_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( modulo_modulo @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_2539_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_2540_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_nat_less_exp
thf(fact_2541_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_2542_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( modulo_modulo @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_nat_def
thf(fact_2543_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_int_less_exp
thf(fact_2544_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( modulo_modulo @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_def
thf(fact_2545_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_2546_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A3 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_2547_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2548_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_2549_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_2550_mask__nat__less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% mask_nat_less_exp
thf(fact_2551_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2552_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_2553_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_2554_eucl__rel__int__remainderI,axiom,
    ! [R2: int,L: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R2 )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L ) @ R2 ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R2 ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_2555_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2556_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_2557_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_2558_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2559_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2560_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2561_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_2562_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N2: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2563_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A32: product_prod @ int @ int] :
          ( ? [K3: int] :
              ( ( A12 = K3 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A32
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K3 ) ) )
          | ? [L3: int,K3: int,Q4: int] :
              ( ( A12 = K3 )
              & ( A23 = L3 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L3
               != ( zero_zero @ int ) )
              & ( K3
                = ( times_times @ int @ Q4 @ L3 ) ) )
          | ? [R5: int,L3: int,K3: int,Q4: int] :
              ( ( A12 = K3 )
              & ( A23 = L3 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L3 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L3 ) )
              & ( K3
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L3 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_2564_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A33: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A33 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A33
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q5: int] :
              ( ( A33
                = ( product_Pair @ int @ int @ Q5 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q5 @ A22 ) ) ) )
         => ~ ! [R: int,Q5: int] :
                ( ( A33
                  = ( product_Pair @ int @ int @ Q5 @ R ) )
               => ( ( ( sgn_sgn @ int @ R )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q5 @ A22 ) @ R ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_2565_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_2566_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2567_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2568_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2569_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2570_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N2: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2571_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_2572_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_2573_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( plus_plus @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2574_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_2575_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2576_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2577_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_2578_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2579_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2580_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_2581_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K3: int,L3: int] :
          ( if @ int
          @ ( L3
            = ( zero_zero @ int ) )
          @ K3
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L3 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L3 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L3 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L3 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L3 @ K3 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_2582_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K3: int,L3: int] :
          ( if @ int
          @ ( L3
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L3 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L3 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L3 @ K3 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_2583_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X4: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_2584_zero__le__sgn__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X3 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% zero_le_sgn_iff
thf(fact_2585_sgn__le__0__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_2586_nat__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( semiring_1_of_nat @ int @ N ) )
      = N ) ).

% nat_int
thf(fact_2587_exp__less__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ X3 @ Y5 )
     => ( ord_less @ real @ ( exp @ real @ X3 ) @ ( exp @ real @ Y5 ) ) ) ).

% exp_less_mono
thf(fact_2588_exp__less__cancel__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( exp @ real @ X3 ) @ ( exp @ real @ Y5 ) )
      = ( ord_less @ real @ X3 @ Y5 ) ) ).

% exp_less_cancel_iff
thf(fact_2589_exp__le__cancel__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X3 ) @ ( exp @ real @ Y5 ) )
      = ( ord_less_eq @ real @ X3 @ Y5 ) ) ).

% exp_le_cancel_iff
thf(fact_2590_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_2591_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_2592_exp__eq__one__iff,axiom,
    ! [X3: real] :
      ( ( ( exp @ real @ X3 )
        = ( one_one @ real ) )
      = ( X3
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_2593_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2594_nat__of__bool,axiom,
    ! [P: $o] :
      ( ( nat2 @ ( zero_neq_one_of_bool @ int @ P ) )
      = ( zero_neq_one_of_bool @ nat @ P ) ) ).

% nat_of_bool
thf(fact_2595_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_2596_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_2597_nat__0__iff,axiom,
    ! [I: int] :
      ( ( ( nat2 @ I )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_2598_nat__le__0,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z2 )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_2599_zless__nat__conj,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
        & ( ord_less @ int @ W @ Z2 ) ) ) ).

% zless_nat_conj
thf(fact_2600_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_2601_one__less__exp__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X3 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% one_less_exp_iff
thf(fact_2602_exp__less__one__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( exp @ real @ X3 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_2603_exp__le__one__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X3 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_2604_one__le__exp__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X3 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% one_le_exp_iff
thf(fact_2605_nat__zminus__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_2606_int__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
          = Z2 ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_2607_exp__ln__iff,axiom,
    ! [X3: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X3 ) )
        = X3 )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% exp_ln_iff
thf(fact_2608_exp__ln,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( exp @ real @ ( ln_ln @ real @ X3 ) )
        = X3 ) ) ).

% exp_ln
thf(fact_2609_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_2610_zero__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% zero_less_nat_eq
thf(fact_2611_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2612_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2613_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2614_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2615_diff__nat__numeral,axiom,
    ! [V: num,V4: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V4 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V4 ) ) ) ) ).

% diff_nat_numeral
thf(fact_2616_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X3: num,N: nat,Y5: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N )
        = ( nat2 @ Y5 ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N )
        = Y5 ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_2617_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y5: int,X3: num,N: nat] :
      ( ( ( nat2 @ Y5 )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N ) )
      = ( Y5
        = ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_2618_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( dvd_dvd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_abs_dvd_iff
thf(fact_2619_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( ( dvd_dvd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% dvd_nat_abs_iff
thf(fact_2620_one__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ).

% one_less_nat_eq
thf(fact_2621_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_2622_numeral__power__less__nat__cancel__iff,axiom,
    ! [X3: num,N: nat,A3: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N ) @ ( nat2 @ A3 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) @ A3 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_2623_nat__less__numeral__power__cancel__iff,axiom,
    ! [A3: int,X3: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A3 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N ) )
      = ( ord_less @ int @ A3 @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_2624_numeral__power__le__nat__cancel__iff,axiom,
    ! [X3: num,N: nat,A3: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N ) @ ( nat2 @ A3 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) @ A3 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_2625_nat__le__numeral__power__cancel__iff,axiom,
    ! [A3: int,X3: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A3 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X3 ) @ N ) )
      = ( ord_less_eq @ int @ A3 @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_2626_nat__mask__eq,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% nat_mask_eq
thf(fact_2627_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_2628_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_2629_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X3 ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) ) ) ).

% norm_exp
thf(fact_2630_exp__less__cancel,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( exp @ real @ X3 ) @ ( exp @ real @ Y5 ) )
     => ( ord_less @ real @ X3 @ Y5 ) ) ).

% exp_less_cancel
thf(fact_2631_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( ( exp @ A @ X3 )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_2632_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( exp @ A @ A2 ) @ A2 )
          = ( times_times @ A @ A2 @ ( exp @ A @ A2 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_2633_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_2634_num__induct,axiom,
    ! [P: num > $o,X3: num] :
      ( ( P @ one2 )
     => ( ! [X2: num] :
            ( ( P @ X2 )
           => ( P @ ( inc @ X2 ) ) )
       => ( P @ X3 ) ) ) ).

% num_induct
thf(fact_2635_add__inc,axiom,
    ! [X3: num,Y5: num] :
      ( ( plus_plus @ num @ X3 @ ( inc @ Y5 ) )
      = ( inc @ ( plus_plus @ num @ X3 @ Y5 ) ) ) ).

% add_inc
thf(fact_2636_not__exp__less__zero,axiom,
    ! [X3: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X3 ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_2637_exp__gt__zero,axiom,
    ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X3 ) ) ).

% exp_gt_zero
thf(fact_2638_exp__total,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
     => ? [X2: real] :
          ( ( exp @ real @ X2 )
          = Y5 ) ) ).

% exp_total
thf(fact_2639_not__exp__le__zero,axiom,
    ! [X3: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X3 ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_2640_exp__ge__zero,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X3 ) ) ).

% exp_ge_zero
thf(fact_2641_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_2642_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I2: num] : ( nat2 @ ( numeral_numeral @ int @ I2 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_2643_real__sgn__eq,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [X4: real] : ( divide_divide @ real @ X4 @ ( abs_abs @ real @ X4 ) ) ) ) ).

% real_sgn_eq
thf(fact_2644_nat__mono,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ X3 @ Y5 )
     => ( ord_less_eq @ nat @ ( nat2 @ X3 ) @ ( nat2 @ Y5 ) ) ) ).

% nat_mono
thf(fact_2645_eq__nat__nat__iff,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( ( nat2 @ Z2 )
            = ( nat2 @ Z6 ) )
          = ( Z2 = Z6 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_2646_all__nat,axiom,
    ( ( ^ [P4: nat > $o] :
        ! [X7: nat] : ( P4 @ X7 ) )
    = ( ^ [P2: nat > $o] :
        ! [X4: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X4 )
         => ( P2 @ ( nat2 @ X4 ) ) ) ) ) ).

% all_nat
thf(fact_2647_ex__nat,axiom,
    ( ( ^ [P4: nat > $o] :
        ? [X7: nat] : ( P4 @ X7 ) )
    = ( ^ [P2: nat > $o] :
        ? [X4: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X4 )
          & ( P2 @ ( nat2 @ X4 ) ) ) ) ) ).

% ex_nat
thf(fact_2648_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_2649_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_2650_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ( times_times @ A @ X3 @ Y5 )
            = ( times_times @ A @ Y5 @ X3 ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
            = ( times_times @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ Y5 ) ) ) ) ) ).

% exp_add_commuting
thf(fact_2651_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( times_times @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ Y5 ) )
          = ( exp @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) ) ) ).

% mult_exp_exp
thf(fact_2652_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
          = ( divide_divide @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ Y5 ) ) ) ) ).

% exp_diff
thf(fact_2653_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_2654_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M3 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_2655_semiring__norm_I27_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) ).

% semiring_norm(27)
thf(fact_2656_semiring__norm_I28_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) ).

% semiring_norm(28)
thf(fact_2657_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2658_inc_Osimps_I2_J,axiom,
    ! [X3: num] :
      ( ( inc @ ( bit0 @ X3 ) )
      = ( bit1 @ X3 ) ) ).

% inc.simps(2)
thf(fact_2659_inc_Osimps_I3_J,axiom,
    ! [X3: num] :
      ( ( inc @ ( bit1 @ X3 ) )
      = ( bit0 @ ( inc @ X3 ) ) ) ).

% inc.simps(3)
thf(fact_2660_exp__gt__one,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X3 ) ) ) ).

% exp_gt_one
thf(fact_2661_add__One,axiom,
    ! [X3: num] :
      ( ( plus_plus @ num @ X3 @ one2 )
      = ( inc @ X3 ) ) ).

% add_One
thf(fact_2662_exp__ge__add__one__self,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) @ ( exp @ real @ X3 ) ) ).

% exp_ge_add_one_self
thf(fact_2663_nat__mono__iff,axiom,
    ! [Z2: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W @ Z2 ) ) ) ).

% nat_mono_iff
thf(fact_2664_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( ( times_times @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_2665_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z2: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z2 ) ) ).

% zless_nat_eq_int_zless
thf(fact_2666_nat__le__iff,axiom,
    ! [X3: int,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X3 ) @ N )
      = ( ord_less_eq @ int @ X3 @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_le_iff
thf(fact_2667_int__eq__iff,axiom,
    ! [M: nat,Z2: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z2 )
      = ( ( M
          = ( nat2 @ Z2 ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% int_eq_iff
thf(fact_2668_nat__0__le,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
        = Z2 ) ) ).

% nat_0_le
thf(fact_2669_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X3 @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X3 ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_2670_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X3: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X3 ) )
          = ( power_power @ A @ ( exp @ A @ X3 ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_2671_nat__int__add,axiom,
    ! [A3: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A3 @ B2 ) ) ).

% nat_int_add
thf(fact_2672_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_2673_nat__abs__mult__distrib,axiom,
    ! [W: int,Z2: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z2 ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z2 ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_2674_mult__inc,axiom,
    ! [X3: num,Y5: num] :
      ( ( times_times @ num @ X3 @ ( inc @ Y5 ) )
      = ( plus_plus @ num @ ( times_times @ num @ X3 @ Y5 ) @ X3 ) ) ).

% mult_inc
thf(fact_2675_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_2676_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_2677_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_2678_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A5: real] :
          ( if @ real
          @ ( A5
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A5 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_2679_exp__ge__add__one__self__aux,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) @ ( exp @ real @ X3 ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_2680_lemma__exp__total,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y5 )
     => ? [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less_eq @ real @ X2 @ ( minus_minus @ real @ Y5 @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X2 )
            = Y5 ) ) ) ).

% lemma_exp_total
thf(fact_2681_ln__ge__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ Y5 @ ( ln_ln @ real @ X3 ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y5 ) @ X3 ) ) ) ).

% ln_ge_iff
thf(fact_2682_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X3: num] :
          ( ( numeral_numeral @ A @ ( inc @ X3 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2683_ln__x__over__x__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ Y5 )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y5 ) @ Y5 ) @ ( divide_divide @ real @ ( ln_ln @ real @ X3 ) @ X3 ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_2684_nat__less__eq__zless,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W @ Z2 ) ) ) ).

% nat_less_eq_zless
thf(fact_2685_nat__le__eq__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less_eq @ int @ W @ Z2 ) ) ) ).

% nat_le_eq_zle
thf(fact_2686_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_2687_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_2688_split__nat,axiom,
    ! [P: nat > $o,I: int] :
      ( ( P @ ( nat2 @ I ) )
      = ( ! [N2: nat] :
            ( ( I
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ( P @ N2 ) )
        & ( ( ord_less @ int @ I @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_2689_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_2690_nat__add__distrib,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( nat2 @ ( plus_plus @ int @ Z2 @ Z6 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_2691_nat__mult__distrib,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) ) ) ) ).

% nat_mult_distrib
thf(fact_2692_Suc__as__int,axiom,
    ( suc
    = ( ^ [A5: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_2693_nat__diff__distrib_H,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
       => ( ( nat2 @ ( minus_minus @ int @ X3 @ Y5 ) )
          = ( minus_minus @ nat @ ( nat2 @ X3 ) @ ( nat2 @ Y5 ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_2694_nat__diff__distrib,axiom,
    ! [Z6: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
     => ( ( ord_less_eq @ int @ Z6 @ Z2 )
       => ( ( nat2 @ ( minus_minus @ int @ Z2 @ Z6 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_2695_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_2696_nat__div__distrib,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( nat2 @ ( divide_divide @ int @ X3 @ Y5 ) )
        = ( divide_divide @ nat @ ( nat2 @ X3 ) @ ( nat2 @ Y5 ) ) ) ) ).

% nat_div_distrib
thf(fact_2697_nat__div__distrib_H,axiom,
    ! [Y5: int,X3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ( nat2 @ ( divide_divide @ int @ X3 @ Y5 ) )
        = ( divide_divide @ nat @ ( nat2 @ X3 ) @ ( nat2 @ Y5 ) ) ) ) ).

% nat_div_distrib'
thf(fact_2698_nat__power__eq,axiom,
    ! [Z2: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( power_power @ int @ Z2 @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z2 ) @ N ) ) ) ).

% nat_power_eq
thf(fact_2699_nat__mod__distrib,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
       => ( ( nat2 @ ( modulo_modulo @ int @ X3 @ Y5 ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X3 ) @ ( nat2 @ Y5 ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_2700_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_2701_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_2702_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_2703_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_2704_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2705_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_2706_sgn__power__injE,axiom,
    ! [A3: real,N: nat,X3: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A3 ) @ ( power_power @ real @ ( abs_abs @ real @ A3 ) @ N ) )
        = X3 )
     => ( ( X3
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A3 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_2707_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( suc @ ( nat2 @ Z2 ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_2708_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_2709_nat__mult__distrib__neg,axiom,
    ! [Z2: int,Z6: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z2 ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z6 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_2710_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X3 @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X3 ) ) ) ) ).

% exp_divide_power_eq
thf(fact_2711_nat__abs__int__diff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A3 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A3 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A3 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A3 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_2712_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_2713_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2714_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) )
          = ( power_power @ A @ ( exp @ A @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2715_nat__dvd__iff,axiom,
    ! [Z2: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z2 ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( dvd_dvd @ int @ Z2 @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_2716_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2717_exp__bound,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X3 ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2718_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_2719_real__exp__bound__lemma,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X3 ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X3 ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2720_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X3 @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X3 ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_2721_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less_eq @ real @ X3 @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X3 @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X3 ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_2722_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2723_exp__lower__Taylor__quadratic,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X3 ) @ ( divide_divide @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X3 ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_2724_log__base__10__eq1,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X3 )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X3 ) ) ) ) ).

% log_base_10_eq1
thf(fact_2725_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K3 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_2726_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L3: int] :
          ( if @ int
          @ ( ( K3
              = ( zero_zero @ int ) )
            | ( L3
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L3
            @ ( if @ int
              @ ( L3
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K3
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_2727_arctan__half,axiom,
    ( arctan
    = ( ^ [X4: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X4 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_2728_log__base__10__eq2,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X3 )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X3 ) ) ) ) ).

% log_base_10_eq2
thf(fact_2729_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2730_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) ) ) ).

% and.right_idem
thf(fact_2731_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) ) ) ).

% and.left_idem
thf(fact_2732_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ A3 )
          = A3 ) ) ).

% and.idem
thf(fact_2733_real__sqrt__eq__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( sqrt @ X3 )
        = ( sqrt @ Y5 ) )
      = ( X3 = Y5 ) ) ).

% real_sqrt_eq_iff
thf(fact_2734_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_2735_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_2736_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X3 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_2737_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_2738_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_2739_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X3: real] :
      ( ( ( sqrt @ X3 )
        = ( zero_zero @ real ) )
      = ( X3
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_2740_real__sqrt__less__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) )
      = ( ord_less @ real @ X3 @ Y5 ) ) ).

% real_sqrt_less_iff
thf(fact_2741_real__sqrt__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) )
      = ( ord_less_eq @ real @ X3 @ Y5 ) ) ).

% real_sqrt_le_iff
thf(fact_2742_real__sqrt__eq__1__iff,axiom,
    ! [X3: real] :
      ( ( ( sqrt @ X3 )
        = ( one_one @ real ) )
      = ( X3
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_2743_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_2744_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_2745_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A3 )
          = A3 ) ) ).

% and.left_neutral
thf(fact_2746_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A3 ) ) ).

% and.right_neutral
thf(fact_2747_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X3 ) ) ).

% bit.conj_one_right
thf(fact_2748_real__sqrt__gt__0__iff,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y5 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y5 ) ) ).

% real_sqrt_gt_0_iff
thf(fact_2749_real__sqrt__lt__0__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( sqrt @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_2750_real__sqrt__ge__0__iff,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y5 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 ) ) ).

% real_sqrt_ge_0_iff
thf(fact_2751_real__sqrt__le__0__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_2752_real__sqrt__gt__1__iff,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y5 ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y5 ) ) ).

% real_sqrt_gt_1_iff
thf(fact_2753_real__sqrt__lt__1__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( sqrt @ X3 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X3 @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_2754_real__sqrt__ge__1__iff,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y5 ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y5 ) ) ).

% real_sqrt_ge_1_iff
thf(fact_2755_real__sqrt__le__1__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X3 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_2756_log__one,axiom,
    ! [A3: real] :
      ( ( log @ A3 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_2757_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_2758_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_2759_real__sqrt__mult__self,axiom,
    ! [A3: real] :
      ( ( times_times @ real @ ( sqrt @ A3 ) @ ( sqrt @ A3 ) )
      = ( abs_abs @ real @ A3 ) ) ).

% real_sqrt_mult_self
thf(fact_2760_real__sqrt__abs2,axiom,
    ! [X3: real] :
      ( ( sqrt @ ( times_times @ real @ X3 @ X3 ) )
      = ( abs_abs @ real @ X3 ) ) ).

% real_sqrt_abs2
thf(fact_2761_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_2762_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y5: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_2763_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_2764_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_2765_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_2766_log__eq__one,axiom,
    ! [A3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( log @ A3 @ A3 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_2767_log__less__cancel__iff,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
         => ( ( ord_less @ real @ ( log @ A3 @ X3 ) @ ( log @ A3 @ Y5 ) )
            = ( ord_less @ real @ X3 @ Y5 ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_2768_log__less__one__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( log @ A3 @ X3 ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X3 @ A3 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_2769_one__less__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A3 @ X3 ) )
          = ( ord_less @ real @ A3 @ X3 ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_2770_log__less__zero__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( log @ A3 @ X3 ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X3 @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_2771_zero__less__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A3 @ X3 ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X3 ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_2772_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_2773_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_2774_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_2775_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y5: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_2776_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ).

% and_numerals(3)
thf(fact_2777_log__le__cancel__iff,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
         => ( ( ord_less_eq @ real @ ( log @ A3 @ X3 ) @ ( log @ A3 @ Y5 ) )
            = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_2778_log__le__one__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ ( log @ A3 @ X3 ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X3 @ A3 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_2779_one__le__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A3 @ X3 ) )
          = ( ord_less_eq @ real @ A3 @ X3 ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_2780_log__le__zero__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ ( log @ A3 @ X3 ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X3 @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_2781_zero__le__log__cancel__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A3 @ X3 ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X3 ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_2782_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_2783_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_2784_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_2785_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_2786_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_2787_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_2788_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ).

% and_numerals(6)
thf(fact_2789_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ).

% and_numerals(4)
thf(fact_2790_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% bit_0
thf(fact_2791_real__sqrt__abs,axiom,
    ! [X3: real] :
      ( ( sqrt @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X3 ) ) ).

% real_sqrt_abs
thf(fact_2792_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_2793_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_2794_log__pow__cancel,axiom,
    ! [A3: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( log @ A3 @ ( power_power @ real @ A3 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_2795_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_2796_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_2797_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_2798_real__sqrt__pow2,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( power_power @ real @ ( sqrt @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X3 ) ) ).

% real_sqrt_pow2
thf(fact_2799_real__sqrt__pow2__iff,axiom,
    ! [X3: real] :
      ( ( ( power_power @ real @ ( sqrt @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X3 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% real_sqrt_pow2_iff
thf(fact_2800_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X3: real,Y5: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_2801_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_2802_bit__and__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_and_int_iff
thf(fact_2803_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A3 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_2804_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_and_iff
thf(fact_2805_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se5824344872417868541ns_and @ A @ B4 @ A5 ) ) ) ) ).

% and.commute
thf(fact_2806_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_2807_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_2808_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_2809_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% bit_numeral_iff
thf(fact_2810_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_2811_real__sqrt__less__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ X3 @ Y5 )
     => ( ord_less @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) ) ) ).

% real_sqrt_less_mono
thf(fact_2812_real__sqrt__le__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ X3 @ Y5 )
     => ( ord_less_eq @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) ) ) ).

% real_sqrt_le_mono
thf(fact_2813_real__sqrt__divide,axiom,
    ! [X3: real,Y5: real] :
      ( ( sqrt @ ( divide_divide @ real @ X3 @ Y5 ) )
      = ( divide_divide @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) ) ) ).

% real_sqrt_divide
thf(fact_2814_real__sqrt__mult,axiom,
    ! [X3: real,Y5: real] :
      ( ( sqrt @ ( times_times @ real @ X3 @ Y5 ) )
      = ( times_times @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) ) ) ).

% real_sqrt_mult
thf(fact_2815_real__sqrt__power,axiom,
    ! [X3: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X3 @ K ) )
      = ( power_power @ real @ ( sqrt @ X3 ) @ K ) ) ).

% real_sqrt_power
thf(fact_2816_real__sqrt__minus,axiom,
    ! [X3: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X3 ) )
      = ( uminus_uminus @ real @ ( sqrt @ X3 ) ) ) ).

% real_sqrt_minus
thf(fact_2817_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_2818_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A3 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            & ( M != N ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_2819_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_2820_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_2821_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_2822_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_2823_real__sqrt__gt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X3 ) ) ) ).

% real_sqrt_gt_zero
thf(fact_2824_real__sqrt__ge__zero,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X3 ) ) ) ).

% real_sqrt_ge_zero
thf(fact_2825_real__sqrt__eq__zero__cancel,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( sqrt @ X3 )
          = ( zero_zero @ real ) )
       => ( X3
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_2826_real__sqrt__ge__one,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X3 ) ) ) ).

% real_sqrt_ge_one
thf(fact_2827_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A3 ) @ N )
          = ( ( ord_less @ nat @ N @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) ) ) ) ).

% bit_take_bit_iff
thf(fact_2828_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_2829_AND__lower,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X3 @ Y5 ) ) ) ).

% AND_lower
thf(fact_2830_AND__upper1,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X3 @ Y5 ) @ X3 ) ) ).

% AND_upper1
thf(fact_2831_AND__upper2,axiom,
    ! [Y5: int,X3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X3 @ Y5 ) @ Y5 ) ) ).

% AND_upper2
thf(fact_2832_AND__upper1_H,axiom,
    ! [Y5: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ( ord_less_eq @ int @ Y5 @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y5 @ Ya ) @ Z2 ) ) ) ).

% AND_upper1'
thf(fact_2833_AND__upper2_H,axiom,
    ! [Y5: int,Z2: int,X3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ( ord_less_eq @ int @ Y5 @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X3 @ Y5 ) @ Z2 ) ) ) ).

% AND_upper2'
thf(fact_2834_log__def,axiom,
    ( log
    = ( ^ [A5: real,X4: real] : ( divide_divide @ real @ ( ln_ln @ real @ X4 ) @ ( ln_ln @ real @ A5 ) ) ) ) ).

% log_def
thf(fact_2835_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_2836_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,N: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A3 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_2837_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_2838_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_2839_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_2840_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2841_real__div__sqrt,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( divide_divide @ real @ X3 @ ( sqrt @ X3 ) )
        = ( sqrt @ X3 ) ) ) ).

% real_div_sqrt
thf(fact_2842_sqrt__add__le__add__sqrt,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X3 @ Y5 ) ) @ ( plus_plus @ real @ ( sqrt @ X3 ) @ ( sqrt @ Y5 ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_2843_le__real__sqrt__sumsq,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X3 @ X3 ) @ ( times_times @ real @ Y5 @ Y5 ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_2844_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_2845_AND__upper1_H_H,axiom,
    ! [Y5: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ( ord_less @ int @ Y5 @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y5 @ Ya ) @ Z2 ) ) ) ).

% AND_upper1''
thf(fact_2846_AND__upper2_H_H,axiom,
    ! [Y5: int,Z2: int,X3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ( ord_less @ int @ Y5 @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X3 @ Y5 ) @ Z2 ) ) ) ).

% AND_upper2''
thf(fact_2847_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_2848_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N2 @ A5 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_2849_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_2850_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_2851_log__base__change,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X3 )
          = ( divide_divide @ real @ ( log @ A3 @ X3 ) @ ( log @ A3 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_2852_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ).

% even_and_iff_int
thf(fact_2853_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_2854_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_2855_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_2856_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_2857_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2858_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2859_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2860_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_concat_bit @ N2 @ K3 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_2861_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A3: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_2862_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) ) ).

% bit_Suc
thf(fact_2863_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_2864_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A3 )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_2865_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
         => ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_2866_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_2867_real__less__rsqrt,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y5 )
     => ( ord_less @ real @ X3 @ ( sqrt @ Y5 ) ) ) ).

% real_less_rsqrt
thf(fact_2868_sqrt__le__D,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X3 ) @ Y5 )
     => ( ord_less_eq @ real @ X3 @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_2869_real__le__rsqrt,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y5 )
     => ( ord_less_eq @ real @ X3 @ ( sqrt @ Y5 ) ) ) ).

% real_le_rsqrt
thf(fact_2870_log__mult,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
           => ( ( log @ A3 @ ( times_times @ real @ X3 @ Y5 ) )
              = ( plus_plus @ real @ ( log @ A3 @ X3 ) @ ( log @ A3 @ Y5 ) ) ) ) ) ) ) ).

% log_mult
thf(fact_2871_log__divide,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
           => ( ( log @ A3 @ ( divide_divide @ real @ X3 @ Y5 ) )
              = ( minus_minus @ real @ ( log @ A3 @ X3 ) @ ( log @ A3 @ Y5 ) ) ) ) ) ) ) ).

% log_divide
thf(fact_2872_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_2873_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_2874_log__base__pow,axiom,
    ! [A3: real,N: nat,X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( log @ ( power_power @ real @ A3 @ N ) @ X3 )
        = ( divide_divide @ real @ ( log @ A3 @ X3 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_2875_log__nat__power,axiom,
    ! [X3: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( log @ B2 @ ( power_power @ real @ X3 @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X3 ) ) ) ) ).

% log_nat_power
thf(fact_2876_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2877_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2878_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2879_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_2880_real__le__lsqrt,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ord_less_eq @ real @ X3 @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X3 ) @ Y5 ) ) ) ) ).

% real_le_lsqrt
thf(fact_2881_real__sqrt__unique,axiom,
    ! [Y5: real,X3: real] :
      ( ( ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( sqrt @ X3 )
          = Y5 ) ) ) ).

% real_sqrt_unique
thf(fact_2882_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_2883_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X3 )
     => ( Y5
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_2884_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y5 )
     => ( X3
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_2885_real__sqrt__sum__squares__ge1,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_2886_real__sqrt__sum__squares__ge2,axiom,
    ! [Y5: real,X3: real] : ( ord_less_eq @ real @ Y5 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_2887_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A3: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A3 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_2888_sqrt__ge__absD,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( sqrt @ Y5 ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y5 ) ) ).

% sqrt_ge_absD
thf(fact_2889_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_2890_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_2891_log__eq__div__ln__mult__log,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
             => ( ( log @ A3 @ X3 )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A3 ) ) @ ( log @ B2 @ X3 ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_2892_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K3: int,N2: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_int_def
thf(fact_2893_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2894_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2895_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2896_arctan__ubound,axiom,
    ! [Y5: real] : ( ord_less @ real @ ( arctan @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2897_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_2898_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_2899_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2900_real__less__lsqrt,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ord_less @ real @ X3 @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X3 ) @ Y5 ) ) ) ) ).

% real_less_lsqrt
thf(fact_2901_sqrt__sum__squares__le__sum,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X3 @ Y5 ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_2902_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_2903_real__sqrt__ge__abs1,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_2904_real__sqrt__ge__abs2,axiom,
    ! [Y5: real,X3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_2905_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X3 ) @ ( abs_abs @ real @ Y5 ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_2906_ln__sqrt,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ln_ln @ real @ ( sqrt @ X3 ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_2907_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_2908_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X4: real] : ( ln_ln @ real @ ( plus_plus @ real @ X4 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_2909_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2910_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_2911_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_2912_arctan__lbound,axiom,
    ! [Y5: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y5 ) ) ).

% arctan_lbound
thf(fact_2913_arctan__bounded,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y5 ) )
      & ( ord_less @ real @ ( arctan @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2914_arsinh__real__aux,axiom,
    ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_2915_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X3: real,Y5: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_2916_real__sqrt__power__even,axiom,
    ! [N: nat,X3: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( power_power @ real @ ( sqrt @ X3 ) @ N )
          = ( power_power @ real @ X3 @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_2917_arith__geo__mean__sqrt,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X3 @ Y5 ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X3 @ Y5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_2918_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_2919_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_2920_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L3: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_2921_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K3: int] :
          ( plus_plus @ int @ K3
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% set_bit_eq
thf(fact_2922_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( minus_minus @ int @ K3 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N2 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_2923_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_2924_cos__x__y__le__one,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_2925_real__sqrt__sum__squares__less,axiom,
    ! [X3: real,U: real,Y5: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y5 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_2926_arcosh__real__def,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
     => ( ( arcosh @ real @ X3 )
        = ( ln_ln @ real @ ( plus_plus @ real @ X3 @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_2927_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_2928_sqrt__sum__squares__half__less,axiom,
    ! [X3: real,U: real,Y5: real] :
      ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y5 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_2929_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_2930_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2931_arctan__inverse,axiom,
    ! [X3: real] :
      ( ( X3
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X3 ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X3 ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X3 ) ) ) ) ).

% arctan_inverse
thf(fact_2932_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_2933_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_2934_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2935_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_2936_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_2937_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_2938_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_2939_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2940_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_2941_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_2942_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_2943_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_2944_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_2945_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) ) ) ).

% zero_le_floor
thf(fact_2946_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( cos @ A @ X3 ) ) @ ( times_times @ A @ ( sin @ A @ X3 ) @ ( sin @ A @ X3 ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2947_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X3 @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_2948_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X3 ) ) ) ).

% numeral_le_floor
thf(fact_2949_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ).

% zero_less_floor
thf(fact_2950_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_2951_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_2952_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X3 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_2953_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X3 ) ) ) ).

% zero_less_ceiling
thf(fact_2954_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ).

% one_le_floor
thf(fact_2955_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X3 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_2956_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_2957_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_2958_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X3 ) ) ) ).

% one_le_ceiling
thf(fact_2959_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X3 ) ) ) ).

% numeral_less_ceiling
thf(fact_2960_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_2961_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X3 @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_2962_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X3 ) ) ) ).

% one_less_ceiling
thf(fact_2963_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X3 @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_2964_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X3 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_2965_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_2966_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_2967_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X3 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_2968_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: num,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ).

% floor_numeral_power
thf(fact_2969_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: num,N: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ).

% ceiling_numeral_power
thf(fact_2970_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2971_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2972_and__nat__numerals_I1_J,axiom,
    ! [Y5: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y5 ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_2973_and__nat__numerals_I3_J,axiom,
    ! [X3: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X3 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_2974_floor__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A3 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A3 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_2975_nat__ceiling__le__eq,axiom,
    ! [X3: real,A3: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X3 ) ) @ A3 )
      = ( ord_less_eq @ real @ X3 @ ( semiring_1_of_nat @ real @ A3 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_2976_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_2977_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 ) ) ) ).

% zero_le_ceiling
thf(fact_2978_and__nat__numerals_I2_J,axiom,
    ! [Y5: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y5 ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_2979_and__nat__numerals_I4_J,axiom,
    ! [X3: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X3 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_2980_ceiling__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A3 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A3 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_2981_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% numeral_less_floor
thf(fact_2982_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_2983_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) ) ) ).

% one_less_floor
thf(fact_2984_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_2985_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X3 @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2986_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% numeral_le_ceiling
thf(fact_2987_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X3 ) ) ) ).

% neg_numeral_le_floor
thf(fact_2988_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_2989_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_2990_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X3 ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_2991_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2992_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2993_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_2994_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_2995_cos__periodic,axiom,
    ! [X3: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X3 ) ) ).

% cos_periodic
thf(fact_2996_sin__periodic,axiom,
    ! [X3: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X3 ) ) ).

% sin_periodic
thf(fact_2997_cos__2pi__minus,axiom,
    ! [X3: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X3 ) )
      = ( cos @ real @ X3 ) ) ).

% cos_2pi_minus
thf(fact_2998_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_2999_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_3000_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_3001_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_3002_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_3003_floor__minus__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A3 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A3 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_3004_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A3: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A3 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A3 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_3005_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_3006_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_3007_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_3008_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_3009_sin__2pi__minus,axiom,
    ! [X3: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X3 ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X3 ) ) ) ).

% sin_2pi_minus
thf(fact_3010_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% neg_numeral_less_floor
thf(fact_3011_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3012_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X3 @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_3013_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X3: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_3014_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_3015_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_3016_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_3017_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archimedean_ceiling @ A @ X3 ) ) ) ).

% floor_le_ceiling
thf(fact_3018_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cos @ A @ X3 )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X3 )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3019_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X3 ) @ ( cos @ A @ Y5 ) ) @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( sin @ A @ Y5 ) ) ) ) ) ).

% sin_diff
thf(fact_3020_polar__Ex,axiom,
    ! [X3: real,Y5: real] :
    ? [R: real,A7: real] :
      ( ( X3
        = ( times_times @ real @ R @ ( cos @ real @ A7 ) ) )
      & ( Y5
        = ( times_times @ real @ R @ ( sin @ real @ A7 ) ) ) ) ).

% polar_Ex
thf(fact_3021_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X3 ) @ ( cos @ A @ Y5 ) ) @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( sin @ A @ Y5 ) ) ) ) ) ).

% sin_add
thf(fact_3022_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( cos @ A @ Y5 ) ) @ ( times_times @ A @ ( sin @ A @ X3 ) @ ( sin @ A @ Y5 ) ) ) ) ) ).

% cos_add
thf(fact_3023_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( cos @ A @ Y5 ) ) @ ( times_times @ A @ ( sin @ A @ X3 ) @ ( sin @ A @ Y5 ) ) ) ) ) ).

% cos_diff
thf(fact_3024_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( sin @ A @ X3 )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X3 ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3025_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ X3 ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_3026_sin__zero__abs__cos__one,axiom,
    ! [X3: real] :
      ( ( ( sin @ real @ X3 )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X3 ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3027_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X3 ) ) @ ( cos @ A @ X3 ) ) ) ) ).

% sin_double
thf(fact_3028_sincos__principal__value,axiom,
    ! [X3: real] :
    ? [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
      & ( ord_less_eq @ real @ Y2 @ pi )
      & ( ( sin @ real @ Y2 )
        = ( sin @ real @ X3 ) )
      & ( ( cos @ real @ Y2 )
        = ( cos @ real @ X3 ) ) ) ).

% sincos_principal_value
thf(fact_3029_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y5 ) ) ) ) ).

% floor_mono
thf(fact_3030_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y5 ) )
         => ( ord_less @ A @ X3 @ Y5 ) ) ) ).

% floor_less_cancel
thf(fact_3031_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_3032_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_3033_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y5 ) @ ( archimedean_ceiling @ A @ X3 ) ) ) ) ).

% ceiling_mono
thf(fact_3034_sin__x__le__x,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( sin @ real @ X3 ) @ X3 ) ) ).

% sin_x_le_x
thf(fact_3035_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( archimedean_ceiling @ A @ Y5 ) )
         => ( ord_less @ A @ X3 @ Y5 ) ) ) ).

% ceiling_less_cancel
thf(fact_3036_sin__le__one,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( sin @ real @ X3 ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_3037_cos__le__one,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( cos @ real @ X3 ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3038_abs__sin__x__le__abs__x,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X3 ) ) @ ( abs_abs @ real @ X3 ) ) ).

% abs_sin_x_le_abs_x
thf(fact_3039_cos__arctan__not__zero,axiom,
    ! [X3: real] :
      ( ( cos @ real @ ( arctan @ X3 ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_3040_sin__cos__le1,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X3 ) @ ( sin @ real @ Y5 ) ) @ ( times_times @ real @ ( cos @ real @ X3 ) @ ( cos @ real @ Y5 ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3041_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( power_power @ A @ ( sin @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3042_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3043_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_3044_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y5 ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) ) ) ).

% le_floor_add
thf(fact_3045_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ R2 @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R2 ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_3046_sin__gt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X3 ) ) ) ) ).

% sin_gt_zero
thf(fact_3047_sin__x__ge__neg__x,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X3 ) @ ( sin @ real @ X3 ) ) ) ).

% sin_x_ge_neg_x
thf(fact_3048_sin__ge__zero,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X3 ) ) ) ) ).

% sin_ge_zero
thf(fact_3049_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X3 ) @ ( archimedean_ceiling @ A @ Y5 ) ) ) ) ).

% ceiling_add_le
thf(fact_3050_real__nat__ceiling__ge,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ X3 @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X3 ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_3051_sin__ge__minus__one,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X3 ) ) ).

% sin_ge_minus_one
thf(fact_3052_cos__inj__pi,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ pi )
           => ( ( ( cos @ real @ X3 )
                = ( cos @ real @ Y5 ) )
             => ( X3 = Y5 ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3053_cos__mono__le__eq,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X3 ) @ ( cos @ real @ Y5 ) )
              = ( ord_less_eq @ real @ Y5 @ X3 ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3054_cos__monotone__0__pi__le,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X3 ) @ ( cos @ real @ Y5 ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3055_cos__ge__minus__one,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X3 ) ) ).

% cos_ge_minus_one
thf(fact_3056_abs__sin__le__one,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X3 ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_3057_abs__cos__le__one,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X3 ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3058_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% and_nat_def
thf(fact_3059_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z2 @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3060_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3061_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3062_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z2 ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3063_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z2 ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3064_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z2 ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3065_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3066_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3067_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R2 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R2 ) ) ) @ R2 ) ) ) ).

% of_nat_floor
thf(fact_3068_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_3069_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A3 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_3070_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_3071_nat__floor__neg,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X3 ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_3072_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3073_floor__eq3,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X3 ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_3074_le__nat__floor,axiom,
    ! [X3: nat,A3: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X3 ) @ A3 )
     => ( ord_less_eq @ nat @ X3 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A3 ) ) ) ) ).

% le_nat_floor
thf(fact_3075_cos__monotone__0__pi,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ pi )
         => ( ord_less @ real @ ( cos @ real @ X3 ) @ ( cos @ real @ Y5 ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3076_cos__mono__less__eq,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X3 ) @ ( cos @ real @ Y5 ) )
              = ( ord_less @ real @ Y5 @ X3 ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3077_sin__eq__0__pi,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X3 )
     => ( ( ord_less @ real @ X3 @ pi )
       => ( ( ( sin @ real @ X3 )
            = ( zero_zero @ real ) )
         => ( X3
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_3078_sin__zero__pi__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ pi )
     => ( ( ( sin @ real @ X3 )
          = ( zero_zero @ real ) )
        = ( X3
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_3079_cos__monotone__minus__pi__0_H,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y5 ) @ ( cos @ real @ X3 ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3080_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_3081_sincos__total__pi,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X3
              = ( cos @ real @ T4 ) )
            & ( Y5
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3082_sin__cos__sqrt,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X3 ) )
     => ( ( sin @ real @ X3 )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3083_sin__expansion__lemma,axiom,
    ! [X3: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X3 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X3 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3084_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A3 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_3085_cos__expansion__lemma,axiom,
    ! [X3: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X3 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X3 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3086_sin__gt__zero__02,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X3 ) ) ) ) ).

% sin_gt_zero_02
thf(fact_3087_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A3 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A3 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3088_floor__eq4,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X3 ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_3089_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3090_cos__is__zero,axiom,
    ? [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
      & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      & ! [Y6: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y6 )
            & ( ord_less_eq @ real @ Y6 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y6 )
              = ( zero_zero @ real ) ) )
         => ( Y6 = X2 ) ) ) ).

% cos_is_zero
thf(fact_3091_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3092_cos__monotone__minus__pi__0,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y5 ) @ ( cos @ real @ X3 ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3093_cos__total,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ? [X2: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ pi )
            & ( ( cos @ real @ X2 )
              = Y5 )
            & ! [Y6: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ pi )
                  & ( ( cos @ real @ Y6 )
                    = Y5 ) )
               => ( Y6 = X2 ) ) ) ) ) ).

% cos_total
thf(fact_3094_sincos__total__pi__half,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X3
                = ( cos @ real @ T4 ) )
              & ( Y5
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3095_sincos__total__2pi__le,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X3
            = ( cos @ real @ T4 ) )
          & ( Y5
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3096_sincos__total__2pi,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X3
                  = ( cos @ real @ T4 ) )
               => ( Y5
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3097_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_nat_def
thf(fact_3098_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_3099_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3100_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3101_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3102_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z2 ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3103_sin__gt__zero2,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X3 ) ) ) ) ).

% sin_gt_zero2
thf(fact_3104_sin__lt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ pi @ X3 )
     => ( ( ord_less @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X3 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_3105_cos__double__less__one,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X3 ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3106_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_3107_cos__gt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X3 ) ) ) ) ).

% cos_gt_zero
thf(fact_3108_sin__inj__pi,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X3 )
                = ( sin @ real @ Y5 ) )
             => ( X3 = Y5 ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_3109_sin__mono__le__eq,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X3 ) @ ( sin @ real @ Y5 ) )
              = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_3110_sin__monotone__2pi__le,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y5 ) @ ( sin @ real @ X3 ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_3111_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3112_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3113_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3114_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3115_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X3 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X3 ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3116_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( ( M3
              = ( zero_zero @ nat ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_3117_sin__le__zero,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ pi @ X3 )
     => ( ( ord_less @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X3 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_3118_sin__less__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X3 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_3119_sin__monotone__2pi,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y5 ) @ ( sin @ real @ X3 ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_3120_sin__mono__less__eq,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X3 ) @ ( sin @ real @ Y5 ) )
              = ( ord_less @ real @ X3 @ Y5 ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_3121_sin__total,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ? [X2: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X2 )
              = Y5 )
            & ! [Y6: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y6 )
                    = Y5 ) )
               => ( Y6 = X2 ) ) ) ) ) ).

% sin_total
thf(fact_3122_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_3123_cos__gt__zero__pi,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X3 ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3124_cos__ge__zero,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X3 ) ) ) ) ).

% cos_ge_zero
thf(fact_3125_cos__one__2pi,axiom,
    ! [X3: real] :
      ( ( ( cos @ real @ X3 )
        = ( one_one @ real ) )
      = ( ? [X4: nat] :
            ( X3
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X4 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X4: nat] :
            ( X3
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X4 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3126_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_3127_sin__arctan,axiom,
    ! [X3: real] :
      ( ( sin @ real @ ( arctan @ X3 ) )
      = ( divide_divide @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3128_cos__arctan,axiom,
    ! [X3: real] :
      ( ( cos @ real @ ( arctan @ X3 ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3129_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_3130_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_3131_sin__zero__lemma,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( sin @ real @ X3 )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X3
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_3132_sin__zero__iff,axiom,
    ! [X3: real] :
      ( ( ( sin @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X3
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X3
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_3133_cos__zero__lemma,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( cos @ real @ X3 )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X3
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3134_cos__zero__iff,axiom,
    ! [X3: real] :
      ( ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X3
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X3
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3135_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X3 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3136_sin__tan,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X3 )
        = ( divide_divide @ real @ ( tan @ real @ X3 ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3137_cos__tan,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X3 )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3138_complex__unimodular__polar,axiom,
    ! [Z2: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z2
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3139_ceiling__log__eq__powr__iff,axiom,
    ! [X3: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X3 ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_3140_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z2: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z2 )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_3141_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z2: A] :
          ( ( ( powr @ A @ W @ Z2 )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_3142_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_3143_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X3: A] :
          ( ( ( X3
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X3 @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X3
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X3 @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_3144_powr__gt__zero,axiom,
    ! [X3: real,A3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X3 @ A3 ) )
      = ( ( X3
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_3145_powr__nonneg__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A3 @ X3 ) @ ( zero_zero @ real ) )
      = ( A3
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_3146_powr__less__cancel__iff,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( ( ord_less @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ X3 @ B2 ) )
        = ( ord_less @ real @ A3 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_3147_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_3148_powr__eq__one__iff,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
     => ( ( ( powr @ real @ A3 @ X3 )
          = ( one_one @ real ) )
        = ( X3
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_3149_powr__one__gt__zero__iff,axiom,
    ! [X3: real] :
      ( ( ( powr @ real @ X3 @ ( one_one @ real ) )
        = X3 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% powr_one_gt_zero_iff
thf(fact_3150_powr__one,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( powr @ real @ X3 @ ( one_one @ real ) )
        = X3 ) ) ).

% powr_one
thf(fact_3151_powr__le__cancel__iff,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ X3 @ B2 ) )
        = ( ord_less_eq @ real @ A3 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_3152_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_3153_log__powr__cancel,axiom,
    ! [A3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( log @ A3 @ ( powr @ real @ A3 @ Y5 ) )
          = Y5 ) ) ) ).

% log_powr_cancel
thf(fact_3154_powr__log__cancel,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( powr @ real @ A3 @ ( log @ A3 @ X3 ) )
            = X3 ) ) ) ) ).

% powr_log_cancel
thf(fact_3155_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3156_tan__periodic__n,axiom,
    ! [X3: real,N: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X3 ) ) ).

% tan_periodic_n
thf(fact_3157_tan__periodic__nat,axiom,
    ! [X3: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X3 ) ) ).

% tan_periodic_nat
thf(fact_3158_powr__numeral,axiom,
    ! [X3: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( powr @ real @ X3 @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_3159_tan__periodic,axiom,
    ! [X3: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X3 ) ) ).

% tan_periodic
thf(fact_3160_square__powr__half,axiom,
    ! [X3: real] :
      ( ( powr @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X3 ) ) ).

% square_powr_half
thf(fact_3161_powr__powr,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X3 @ A3 ) @ B2 )
      = ( powr @ real @ X3 @ ( times_times @ real @ A3 @ B2 ) ) ) ).

% powr_powr
thf(fact_3162_Complex__eq__0,axiom,
    ! [A3: real,B2: real] :
      ( ( ( complex2 @ A3 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A3
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_3163_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_3164_powr__non__neg,axiom,
    ! [A3: real,X3: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A3 @ X3 ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_3165_powr__less__mono2__neg,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ A3 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ X3 @ Y5 )
         => ( ord_less @ real @ ( powr @ real @ Y5 @ A3 ) @ ( powr @ real @ X3 @ A3 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_3166_powr__mono2,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ Y5 )
         => ( ord_less_eq @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ Y5 @ A3 ) ) ) ) ) ).

% powr_mono2
thf(fact_3167_powr__ge__pzero,axiom,
    ! [X3: real,Y5: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X3 @ Y5 ) ) ).

% powr_ge_pzero
thf(fact_3168_powr__less__mono,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
       => ( ord_less @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ X3 @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_3169_powr__less__cancel,axiom,
    ! [X3: real,A3: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ X3 @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
       => ( ord_less @ real @ A3 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_3170_powr__mono,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( ( ord_less_eq @ real @ A3 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
       => ( ord_less_eq @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ X3 @ B2 ) ) ) ) ).

% powr_mono
thf(fact_3171_Complex__eq__1,axiom,
    ! [A3: real,B2: real] :
      ( ( ( complex2 @ A3 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A3
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3172_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3173_Complex__eq__numeral,axiom,
    ! [A3: real,B2: real,W: num] :
      ( ( ( complex2 @ A3 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A3
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3174_powr__mono2_H,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ A3 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ Y5 )
         => ( ord_less_eq @ real @ ( powr @ real @ Y5 @ A3 ) @ ( powr @ real @ X3 @ A3 ) ) ) ) ) ).

% powr_mono2'
thf(fact_3175_powr__less__mono2,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ X3 @ Y5 )
         => ( ord_less @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ Y5 @ A3 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_3176_powr__inj,axiom,
    ! [A3: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A3 @ X3 )
            = ( powr @ real @ A3 @ Y5 ) )
          = ( X3 = Y5 ) ) ) ) ).

% powr_inj
thf(fact_3177_gr__one__powr,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X3 @ Y5 ) ) ) ) ).

% gr_one_powr
thf(fact_3178_ge__one__powr__ge__zero,axiom,
    ! [X3: real,A3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X3 @ A3 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_3179_powr__mono__both,axiom,
    ! [A3: real,B2: real,X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( ord_less_eq @ real @ A3 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
         => ( ( ord_less_eq @ real @ X3 @ Y5 )
           => ( ord_less_eq @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ Y5 @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_3180_powr__le1,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X3 @ A3 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_3181_powr__divide,axiom,
    ! [X3: real,Y5: real,A3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( powr @ real @ ( divide_divide @ real @ X3 @ Y5 ) @ A3 )
          = ( divide_divide @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ Y5 @ A3 ) ) ) ) ) ).

% powr_divide
thf(fact_3182_powr__mult,axiom,
    ! [X3: real,Y5: real,A3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( powr @ real @ ( times_times @ real @ X3 @ Y5 ) @ A3 )
          = ( times_times @ real @ ( powr @ real @ X3 @ A3 ) @ ( powr @ real @ Y5 @ A3 ) ) ) ) ) ).

% powr_mult
thf(fact_3183_divide__powr__uminus,axiom,
    ! [A3: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A3 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A3 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_3184_log__base__powr,axiom,
    ! [A3: real,B2: real,X3: real] :
      ( ( A3
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A3 @ B2 ) @ X3 )
        = ( divide_divide @ real @ ( log @ A3 @ X3 ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_3185_ln__powr,axiom,
    ! [X3: real,Y5: real] :
      ( ( X3
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X3 @ Y5 ) )
        = ( times_times @ real @ Y5 @ ( ln_ln @ real @ X3 ) ) ) ) ).

% ln_powr
thf(fact_3186_log__powr,axiom,
    ! [X3: real,B2: real,Y5: real] :
      ( ( X3
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X3 @ Y5 ) )
        = ( times_times @ real @ Y5 @ ( log @ B2 @ X3 ) ) ) ) ).

% log_powr
thf(fact_3187_Complex__eq__neg__1,axiom,
    ! [A3: real,B2: real] :
      ( ( ( complex2 @ A3 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A3
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3188_Complex__eq__neg__numeral,axiom,
    ! [A3: real,B2: real,W: num] :
      ( ( ( complex2 @ A3 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A3
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3189_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X3: A,A3: A,B2: A] :
          ( ( powr @ A @ X3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X3 @ A3 ) @ ( powr @ A @ X3 @ B2 ) ) ) ) ).

% powr_add
thf(fact_3190_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_3191_complex__mult,axiom,
    ! [A3: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A3 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A3 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A3 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3192_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( sin @ A @ X4 ) @ ( cos @ A @ X4 ) ) ) ) ) ).

% tan_def
thf(fact_3193_powr__realpow,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( powr @ real @ X3 @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X3 @ N ) ) ) ).

% powr_realpow
thf(fact_3194_powr__less__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y5 ) @ X3 )
          = ( ord_less @ real @ Y5 @ ( log @ B2 @ X3 ) ) ) ) ) ).

% powr_less_iff
thf(fact_3195_less__powr__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ X3 @ ( powr @ real @ B2 @ Y5 ) )
          = ( ord_less @ real @ ( log @ B2 @ X3 ) @ Y5 ) ) ) ) ).

% less_powr_iff
thf(fact_3196_log__less__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ ( log @ B2 @ X3 ) @ Y5 )
          = ( ord_less @ real @ X3 @ ( powr @ real @ B2 @ Y5 ) ) ) ) ) ).

% log_less_iff
thf(fact_3197_less__log__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less @ real @ Y5 @ ( log @ B2 @ X3 ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y5 ) @ X3 ) ) ) ) ).

% less_log_iff
thf(fact_3198_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X3: A,A3: A] :
          ( ( powr @ A @ X3 @ ( uminus_uminus @ A @ A3 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X3 @ A3 ) ) ) ) ).

% powr_minus_divide
thf(fact_3199_powr__neg__one,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( powr @ real @ X3 @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X3 ) ) ) ).

% powr_neg_one
thf(fact_3200_powr__mult__base,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( times_times @ real @ X3 @ ( powr @ real @ X3 @ Y5 ) )
        = ( powr @ real @ X3 @ ( plus_plus @ real @ ( one_one @ real ) @ Y5 ) ) ) ) ).

% powr_mult_base
thf(fact_3201_powr__le__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y5 ) @ X3 )
          = ( ord_less_eq @ real @ Y5 @ ( log @ B2 @ X3 ) ) ) ) ) ).

% powr_le_iff
thf(fact_3202_le__powr__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ ( powr @ real @ B2 @ Y5 ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X3 ) @ Y5 ) ) ) ) ).

% le_powr_iff
thf(fact_3203_log__le__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X3 ) @ Y5 )
          = ( ord_less_eq @ real @ X3 @ ( powr @ real @ B2 @ Y5 ) ) ) ) ) ).

% log_le_iff
thf(fact_3204_le__log__iff,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( ord_less_eq @ real @ Y5 @ ( log @ B2 @ X3 ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y5 ) @ X3 ) ) ) ) ).

% le_log_iff
thf(fact_3205_ln__powr__bound,axiom,
    ! [X3: real,A3: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X3 ) @ ( divide_divide @ real @ ( powr @ real @ X3 @ A3 ) @ A3 ) ) ) ) ).

% ln_powr_bound
thf(fact_3206_ln__powr__bound2,axiom,
    ! [X3: real,A3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X3 ) @ A3 ) @ ( times_times @ real @ ( powr @ real @ A3 @ A3 ) @ X3 ) ) ) ) ).

% ln_powr_bound2
thf(fact_3207_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3208_log__add__eq__powr,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( plus_plus @ real @ ( log @ B2 @ X3 ) @ Y5 )
            = ( log @ B2 @ ( times_times @ real @ X3 @ ( powr @ real @ B2 @ Y5 ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_3209_add__log__eq__powr,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( plus_plus @ real @ Y5 @ ( log @ B2 @ X3 ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y5 ) @ X3 ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_3210_minus__log__eq__powr,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( minus_minus @ real @ Y5 @ ( log @ B2 @ X3 ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y5 ) @ X3 ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_3211_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3212_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X4: A,A5: A] :
              ( if @ A
              @ ( X4
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A5 @ ( ln_ln @ A @ X4 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_3213_lemma__tan__total,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
     => ? [X2: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y5 @ ( tan @ real @ X2 ) ) ) ) ).

% lemma_tan_total
thf(fact_3214_tan__gt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X3 ) ) ) ) ).

% tan_gt_zero
thf(fact_3215_tan__total,axiom,
    ! [Y5: real] :
    ? [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
      & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X2 )
        = Y5 )
      & ! [Y6: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y6 )
            & ( ord_less @ real @ Y6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y6 )
              = Y5 ) )
         => ( Y6 = X2 ) ) ) ).

% tan_total
thf(fact_3216_tan__monotone,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ X3 )
       => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y5 ) @ ( tan @ real @ X3 ) ) ) ) ) ).

% tan_monotone
thf(fact_3217_tan__monotone_H,axiom,
    ! [Y5: real,X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
         => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y5 @ X3 )
              = ( ord_less @ real @ ( tan @ real @ Y5 ) @ ( tan @ real @ X3 ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3218_tan__mono__lt__eq,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
         => ( ( ord_less @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X3 ) @ ( tan @ real @ Y5 ) )
              = ( ord_less @ real @ X3 @ Y5 ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3219_lemma__tan__total1,axiom,
    ! [Y5: real] :
    ? [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
      & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X2 )
        = Y5 ) ) ).

% lemma_tan_total1
thf(fact_3220_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3221_tan__inverse,axiom,
    ! [Y5: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y5 ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y5 ) ) ) ).

% tan_inverse
thf(fact_3222_log__minus__eq__powr,axiom,
    ! [B2: real,X3: real,Y5: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( minus_minus @ real @ ( log @ B2 @ X3 ) @ Y5 )
            = ( log @ B2 @ ( times_times @ real @ X3 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y5 ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_3223_complex__norm,axiom,
    ! [X3: real,Y5: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X3 @ Y5 ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3224_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y5 )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X3 ) @ ( tan @ A @ Y5 ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( cos @ A @ Y5 ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3225_powr__half__sqrt,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( powr @ real @ X3 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X3 ) ) ) ).

% powr_half_sqrt
thf(fact_3226_powr__neg__numeral,axiom,
    ! [X3: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( powr @ real @ X3 @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_3227_tan__total__pos,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
     => ? [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X2 )
            = Y5 ) ) ) ).

% tan_total_pos
thf(fact_3228_tan__pos__pi2__le,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X3 ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3229_tan__less__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X3 ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3230_tan__mono__le,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ Y5 )
       => ( ( ord_less @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X3 ) @ ( tan @ real @ Y5 ) ) ) ) ) ).

% tan_mono_le
thf(fact_3231_tan__mono__le__eq,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
         => ( ( ord_less @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X3 ) @ ( tan @ real @ Y5 ) )
              = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3232_tan__bound__pi2,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X3 ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3233_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3234_arctan,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y5 ) )
      & ( ord_less @ real @ ( arctan @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y5 ) )
        = Y5 ) ) ).

% arctan
thf(fact_3235_arctan__tan,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X3 ) )
          = X3 ) ) ) ).

% arctan_tan
thf(fact_3236_arctan__unique,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X3 )
            = Y5 )
         => ( ( arctan @ Y5 )
            = X3 ) ) ) ) ).

% arctan_unique
thf(fact_3237_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y5 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X3 ) @ ( tan @ A @ Y5 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X3 ) @ ( tan @ A @ Y5 ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3238_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y5 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X3 ) @ ( tan @ A @ Y5 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X3 ) @ ( tan @ A @ Y5 ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3239_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y5 )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X3 ) @ ( tan @ A @ Y5 ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( cos @ A @ Y5 ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3240_tan__total__pi4,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ? [Z5: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z5 )
          & ( ord_less @ real @ Z5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z5 )
            = X3 ) ) ) ).

% tan_total_pi4
thf(fact_3241_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X4 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X4 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3242_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X4: A] : ( ln_ln @ A @ ( plus_plus @ A @ X4 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_3243_cos__arcsin,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X3 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3244_sin__arccos__abs,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y5 ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3245_sin__arccos,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X3 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3246_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X4: A] : ( ln_ln @ A @ ( plus_plus @ A @ X4 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_3247_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_3248_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X3: real] :
          ( ( ( real_Vector_of_real @ A @ X3 )
            = ( zero_zero @ A ) )
          = ( X3
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_3249_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_3250_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X3: real,Y5: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X3 @ Y5 ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X3 ) @ ( real_Vector_of_real @ A @ Y5 ) ) ) ) ).

% of_real_mult
thf(fact_3251_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_3252_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X3: real,Y5: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X3 @ Y5 ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X3 ) @ ( real_Vector_of_real @ A @ Y5 ) ) ) ) ).

% of_real_divide
thf(fact_3253_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X3: real,Y5: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X3 @ Y5 ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X3 ) @ ( real_Vector_of_real @ A @ Y5 ) ) ) ) ).

% of_real_add
thf(fact_3254_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X3: real,N: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X3 @ N ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X3 ) @ N ) ) ) ).

% of_real_power
thf(fact_3255_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3256_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_3257_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_3258_cos__arccos,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y5 ) )
          = Y5 ) ) ) ).

% cos_arccos
thf(fact_3259_sin__arcsin,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y5 ) )
          = Y5 ) ) ) ).

% sin_arcsin
thf(fact_3260_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X3 ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X3 @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_3261_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X3 ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X3 @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_3262_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3263_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3264_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_3265_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_3266_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3267_complex__exp__exists,axiom,
    ! [Z2: complex] :
    ? [A7: complex,R: real] :
      ( Z2
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( exp @ complex @ A7 ) ) ) ).

% complex_exp_exists
thf(fact_3268_sgn__eq,axiom,
    ( ( sgn_sgn @ complex )
    = ( ^ [Z3: complex] : ( divide_divide @ complex @ Z3 @ ( real_Vector_of_real @ complex @ ( real_V7770717601297561774m_norm @ complex @ Z3 ) ) ) ) ) ).

% sgn_eq
thf(fact_3269_complex__eq__cancel__iff2,axiom,
    ! [X3: real,Y5: real,Xa: real] :
      ( ( ( complex2 @ X3 @ Y5 )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X3 = Xa )
        & ( Y5
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_3270_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X4: real] : ( complex2 @ X4 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_3271_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_3272_complex__of__real__mult__Complex,axiom,
    ! [R2: real,X3: real,Y5: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( complex2 @ X3 @ Y5 ) )
      = ( complex2 @ ( times_times @ real @ R2 @ X3 ) @ ( times_times @ real @ R2 @ Y5 ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_3273_Complex__mult__complex__of__real,axiom,
    ! [X3: real,Y5: real,R2: real] :
      ( ( times_times @ complex @ ( complex2 @ X3 @ Y5 ) @ ( real_Vector_of_real @ complex @ R2 ) )
      = ( complex2 @ ( times_times @ real @ X3 @ R2 ) @ ( times_times @ real @ Y5 @ R2 ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_3274_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y5: real,X3: real] :
          ( ( Y5
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X3 @ Y5 ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X3 ) @ ( real_Vector_of_real @ A @ Y5 ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_3275_arccos__le__arccos,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ Y5 )
       => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y5 ) @ ( arccos @ X3 ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3276_arccos__eq__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X3 )
          = ( arccos @ Y5 ) )
        = ( X3 = Y5 ) ) ) ).

% arccos_eq_iff
thf(fact_3277_arccos__le__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X3 ) @ ( arccos @ Y5 ) )
          = ( ord_less_eq @ real @ Y5 @ X3 ) ) ) ) ).

% arccos_le_mono
thf(fact_3278_arcsin__minus,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X3 ) )
          = ( uminus_uminus @ real @ ( arcsin @ X3 ) ) ) ) ) ).

% arcsin_minus
thf(fact_3279_arcsin__le__arcsin,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ Y5 )
       => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X3 ) @ ( arcsin @ Y5 ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3280_arcsin__eq__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X3 )
            = ( arcsin @ Y5 ) )
          = ( X3 = Y5 ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3281_arcsin__le__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X3 ) @ ( arcsin @ Y5 ) )
          = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ) ).

% arcsin_le_mono
thf(fact_3282_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X3: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_3283_arccos__lbound,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y5 ) ) ) ) ).

% arccos_lbound
thf(fact_3284_arccos__less__arccos,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ Y5 )
       => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y5 ) @ ( arccos @ X3 ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3285_arccos__less__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X3 ) @ ( arccos @ Y5 ) )
          = ( ord_less @ real @ Y5 @ X3 ) ) ) ) ).

% arccos_less_mono
thf(fact_3286_arccos__ubound,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y5 ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3287_arccos__cos,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ pi )
       => ( ( arccos @ ( cos @ real @ X3 ) )
          = X3 ) ) ) ).

% arccos_cos
thf(fact_3288_arcsin__less__arcsin,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ Y5 )
       => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X3 ) @ ( arcsin @ Y5 ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3289_arcsin__less__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X3 ) @ ( arcsin @ Y5 ) )
          = ( ord_less @ real @ X3 @ Y5 ) ) ) ) ).

% arcsin_less_mono
thf(fact_3290_cos__arccos__abs,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y5 ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y5 ) )
        = Y5 ) ) ).

% cos_arccos_abs
thf(fact_3291_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A3: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A3 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A3 ) ) ) ) ).

% norm_of_real_diff
thf(fact_3292_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3293_arccos__lt__bounded,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y5 ) )
          & ( ord_less @ real @ ( arccos @ Y5 ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3294_arccos__bounded,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y5 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y5 ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3295_sin__arccos__nonzero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X3 ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3296_arccos__cos2,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X3 )
       => ( ( arccos @ ( cos @ real @ X3 ) )
          = ( uminus_uminus @ real @ X3 ) ) ) ) ).

% arccos_cos2
thf(fact_3297_arccos__minus,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X3 ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X3 ) ) ) ) ) ).

% arccos_minus
thf(fact_3298_cos__arcsin__nonzero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X3 ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3299_arccos,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y5 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y5 ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y5 ) )
            = Y5 ) ) ) ) ).

% arccos
thf(fact_3300_arccos__minus__abs,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X3 ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X3 ) ) ) ) ).

% arccos_minus_abs
thf(fact_3301_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X4: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3302_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X4: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3303_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X3 ) )
          = ( cos @ A @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3304_arccos__le__pi2,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3305_arcsin__lt__bounded,axiom,
    ! [Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y5 ) )
          & ( ord_less @ real @ ( arcsin @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3306_arcsin__lbound,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y5 ) ) ) ) ).

% arcsin_lbound
thf(fact_3307_arcsin__ubound,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3308_arcsin__bounded,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y5 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3309_arcsin__sin,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X3 ) )
          = X3 ) ) ) ).

% arcsin_sin
thf(fact_3310_arcsin,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y5 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y5 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y5 ) )
            = Y5 ) ) ) ) ).

% arcsin
thf(fact_3311_arcsin__pi,axiom,
    ! [Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y5 )
     => ( ( ord_less_eq @ real @ Y5 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y5 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y5 ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y5 ) )
            = Y5 ) ) ) ) ).

% arcsin_pi
thf(fact_3312_arcsin__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X3 ) @ Y5 )
              = ( ord_less_eq @ real @ X3 @ ( sin @ real @ Y5 ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3313_le__arcsin__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y5 )
         => ( ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y5 @ ( arcsin @ X3 ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y5 ) @ X3 ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3314_cos__npi__int,axiom,
    ! [N: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_3315_cot__less__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X3 ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3316_cot__periodic,axiom,
    ! [X3: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X3 ) ) ).

% cot_periodic
thf(fact_3317_powr__int,axiom,
    ! [X3: real,I: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X3 @ ( ring_1_of_int @ real @ I ) )
            = ( power_power @ real @ X3 @ ( nat2 @ I ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X3 @ ( ring_1_of_int @ real @ I ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( nat2 @ ( uminus_uminus @ int @ I ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_3318_sin__zero__iff__int,axiom,
    ! [X3: real] :
      ( ( ( sin @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( ? [I2: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I2 )
            & ( X3
              = ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3319_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: int,Z2: int] :
          ( ( ( ring_1_of_int @ A @ W )
            = ( ring_1_of_int @ A @ Z2 ) )
          = ( W = Z2 ) ) ) ).

% of_int_eq_iff
thf(fact_3320_of__int__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( ring_1 @ A ) )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_char_0_fact @ int @ N ) )
          = ( semiring_char_0_fact @ A @ N ) ) ) ).

% of_int_fact
thf(fact_3321_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) )
            = X3 )
          = ( ? [N2: int] :
                ( X3
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_3322_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X3 ) )
            = X3 )
          = ( ? [N2: int] :
                ( X3
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_3323_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_3324_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_3325_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z2 ) )
          = ( Z2
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_3326_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( zero_zero @ A ) )
          = ( Z2
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_3327_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ W @ Z2 ) ) ) ).

% of_int_le_iff
thf(fact_3328_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_3329_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( numeral_numeral @ A @ N ) )
          = ( Z2
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_3330_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ W @ Z2 ) ) ) ).

% of_int_less_iff
thf(fact_3331_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_3332_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_3333_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_3334_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z2 ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_add
thf(fact_3335_of__int__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ Z2 ) )
          = ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_minus
thf(fact_3336_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W @ Z2 ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_diff
thf(fact_3337_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_1_of_nat @ int @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_int_of_nat_eq
thf(fact_3338_of__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: int] :
          ( ( ring_1_of_int @ A @ ( abs_abs @ int @ X3 ) )
          = ( abs_abs @ A @ ( ring_1_of_int @ A @ X3 ) ) ) ) ).

% of_int_abs
thf(fact_3339_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z2 @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z2 ) @ N ) ) ) ).

% of_int_power
thf(fact_3340_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X3: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X3 ) )
          = ( ( power_power @ int @ B2 @ W )
            = X3 ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_3341_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X3: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X3 )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X3
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_3342_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( ring_1_of_int @ A @ ( zero_neq_one_of_bool @ int @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_int_of_bool
thf(fact_3343_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_3344_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X3 @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X3 ) @ Z2 ) ) ) ).

% ceiling_add_of_int
thf(fact_3345_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_3346_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_le_iff
thf(fact_3347_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_3348_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_less_iff
thf(fact_3349_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_3350_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z2: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z2 ) ) ) ).

% of_int_numeral_le_iff
thf(fact_3351_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z2 @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_3352_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z2 @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_3353_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z2: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z2 ) ) ) ).

% of_int_numeral_less_iff
thf(fact_3354_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_3355_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_3356_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_3357_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_3358_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X3: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X3 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X3 ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_3359_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X3 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_3360_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X3: num,N: nat,Y5: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N )
            = ( ring_1_of_int @ A @ Y5 ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N )
            = Y5 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_3361_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y5: int,X3: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y5 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( Y5
            = ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_3362_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X3: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X3 ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X3 ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_3363_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X3 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X3 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_3364_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z2 ) )
            = ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_nat_nat
thf(fact_3365_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_3366_tan__periodic__int,axiom,
    ! [X3: real,I: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X3 @ ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ pi ) ) )
      = ( tan @ real @ X3 ) ) ).

% tan_periodic_int
thf(fact_3367_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3368_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: num,N: nat,A3: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) @ ( ring_1_of_int @ A @ A3 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) @ A3 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_3369_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: int,X3: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( ord_less_eq @ int @ A3 @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_3370_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: num,N: nat,A3: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) @ ( ring_1_of_int @ A @ A3 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) @ A3 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_3371_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: int,X3: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( ord_less @ int @ A3 @ ( power_power @ int @ ( numeral_numeral @ int @ X3 ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_3372_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X3: num,N: nat,Y5: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) ) @ N )
            = ( ring_1_of_int @ A @ Y5 ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X3 ) ) @ N )
            = Y5 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_3373_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y5: int,X3: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y5 )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) ) @ N ) )
          = ( Y5
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X3 ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_3374_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_3375_cos__int__2pin,axiom,
    ! [N: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_3376_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: int,X3: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) ) @ N ) )
          = ( ord_less_eq @ int @ A3 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X3 ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_3377_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: num,N: nat,A3: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) ) @ N ) @ ( ring_1_of_int @ A @ A3 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X3 ) ) @ N ) @ A3 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_3378_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: num,N: nat,A3: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) ) @ N ) @ ( ring_1_of_int @ A @ A3 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X3 ) ) @ N ) @ A3 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_3379_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: int,X3: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) ) @ N ) )
          = ( ord_less @ int @ A3 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X3 ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_3380_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: int,Y5: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X3 ) @ Y5 )
          = ( times_times @ A @ Y5 @ ( ring_1_of_int @ A @ X3 ) ) ) ) ).

% mult_of_int_commute
thf(fact_3381_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [Z5: int] : ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ Z5 ) ) ) ).

% ex_le_of_int
thf(fact_3382_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [Z5: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z5 ) @ X3 ) ) ).

% ex_of_int_less
thf(fact_3383_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [Z5: int] : ( ord_less @ A @ X3 @ ( ring_1_of_int @ A @ Z5 ) ) ) ).

% ex_less_of_int
thf(fact_3384_pochhammer__of__int,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X3: int,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( ring_1_of_int @ A @ X3 ) @ N )
          = ( ring_1_of_int @ A @ ( comm_s3205402744901411588hammer @ int @ X3 @ N ) ) ) ) ).

% pochhammer_of_int
thf(fact_3385_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) @ X3 ) ) ).

% of_int_floor_le
thf(fact_3386_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X3 ) ) ) ) ).

% le_of_int_ceiling
thf(fact_3387_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_3388_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_and_eq
thf(fact_3389_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X3: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X3 ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X3 ) ) ) ) ) ).

% cos_int_times_real
thf(fact_3390_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X3: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X3 ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X3 ) ) ) ) ) ).

% sin_int_times_real
thf(fact_3391_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_int_mask_eq
thf(fact_3392_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X3 ) ) ) ).

% le_floor_iff
thf(fact_3393_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ Z2 )
          = ( ord_less @ A @ X3 @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% floor_less_iff
thf(fact_3394_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A3: int] :
          ( ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ A3 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ A3 ) ) ) ).

% ceiling_le
thf(fact_3395_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X3 ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% ceiling_le_iff
thf(fact_3396_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less @ int @ Z2 @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ X3 ) ) ) ).

% less_ceiling_iff
thf(fact_3397_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( plus_plus @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ X3 ) ) ) ) ).

% int_add_floor
thf(fact_3398_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ Z2 )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ) ).

% floor_add_int
thf(fact_3399_real__of__int__div4,axiom,
    ! [N: int,X3: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X3 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X3 ) ) ) ).

% real_of_int_div4
thf(fact_3400_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_3401_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,N: nat] :
          ( ( X3
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X3 @ N ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ N ) ) ) ) ).

% floor_power
thf(fact_3402_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( ( dvd_dvd @ int @ D2 @ N )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_3403_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_nonneg
thf(fact_3404_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X3 )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% of_int_leD
thf(fact_3405_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_pos
thf(fact_3406_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X3 )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% of_int_lessD
thf(fact_3407_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [Z5: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z5 ) @ X3 )
          & ( ord_less @ A @ X3 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_3408_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
        ? [X2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X2 ) @ X3 )
          & ( ord_less @ A @ X3 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) ) )
          & ! [Y6: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y6 ) @ X3 )
                & ( ord_less @ A @ X3 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y6 @ ( one_one @ int ) ) ) ) )
             => ( Y6 = X2 ) ) ) ) ).

% floor_exists1
thf(fact_3409_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R2 ) ) @ ( plus_plus @ A @ R2 @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3410_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_3411_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R2 ) ) @ ( one_one @ A ) ) @ R2 ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3412_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X3: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X3 ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X3 ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_3413_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N2: int,M3: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_3414_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N2: int,M3: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M3 ) ) ) ) ).

% int_less_real_le
thf(fact_3415_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A3 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A3 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3416_sin__zero__iff__int2,axiom,
    ! [X3: real] :
      ( ( ( sin @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( ? [I2: int] :
            ( X3
            = ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3417_real__of__int__div__aux,axiom,
    ! [X3: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X3 ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X3 @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X3 @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_3418_real__of__int__floor__add__one__gt,axiom,
    ! [R2: real] : ( ord_less @ real @ R2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_3419_floor__eq,axiom,
    ! [N: int,X3: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X3 )
          = N ) ) ) ).

% floor_eq
thf(fact_3420_real__of__int__floor__add__one__ge,axiom,
    ! [R2: real] : ( ord_less_eq @ real @ R2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_3421_real__of__int__floor__gt__diff__one,axiom,
    ! [R2: real] : ( ord_less @ real @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_3422_real__of__int__floor__ge__diff__one,axiom,
    ! [R2: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_3423_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I2: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I2 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I2 ) @ ( one_one @ A ) ) ) )
               => ( P @ I2 ) ) ) ) ) ).

% floor_split
thf(fact_3424_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A3: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X3 )
            = A3 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A3 ) @ X3 )
            & ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_3425_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X3 )
         => ( ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X3 )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_3426_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I2: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I2 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I2 ) ) )
               => ( P @ I2 ) ) ) ) ) ).

% ceiling_split
thf(fact_3427_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A3: int] :
          ( ( ( archimedean_ceiling @ A @ X3 )
            = A3 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A3 ) @ ( one_one @ A ) ) @ X3 )
            & ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ A3 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3428_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X3 )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_3429_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X3 ) ) @ ( one_one @ A ) ) @ X3 )
          & ( ord_less_eq @ A @ X3 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X3 ) ) ) ) ) ).

% ceiling_correct
thf(fact_3430_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% less_floor_iff
thf(fact_3431_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ Z2 )
          = ( ord_less @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_3432_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( cos @ A @ X4 ) @ ( sin @ A @ X4 ) ) ) ) ) ).

% cot_def
thf(fact_3433_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X3 ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3434_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X3: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X3 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X3 ) ) ) ).

% le_ceiling_iff
thf(fact_3435_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) @ X3 )
          & ( ord_less @ A @ X3 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_3436_real__of__int__div2,axiom,
    ! [N: int,X3: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X3 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X3 ) ) ) ) ).

% real_of_int_div2
thf(fact_3437_real__of__int__div3,axiom,
    ! [N: int,X3: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X3 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X3 ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_3438_floor__eq2,axiom,
    ! [N: int,X3: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X3 )
          = N ) ) ) ).

% floor_eq2
thf(fact_3439_floor__divide__real__eq__div,axiom,
    ! [B2: int,A3: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A3 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A3 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_3440_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P3 @ Q2 ) ) ) @ Q2 ) @ P3 ) ) ) ).

% floor_divide_lower
thf(fact_3441_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P3 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P3 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3442_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_3443_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] : ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K3 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K3 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_3444_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P3 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P3 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_3445_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P3 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P3 ) ) ) ).

% ceiling_divide_lower
thf(fact_3446_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X3: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X3 )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3447_cos__one__2pi__int,axiom,
    ! [X3: real] :
      ( ( ( cos @ real @ X3 )
        = ( one_one @ real ) )
      = ( ? [X4: int] :
            ( X3
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X4 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3448_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3449_floor__log__eq__powr__iff,axiom,
    ! [X3: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X3 ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X3 )
            & ( ord_less @ real @ X3 @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_3450_cot__gt__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X3 ) ) ) ) ).

% cot_gt_zero
thf(fact_3451_tan__cot_H,axiom,
    ! [X3: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 ) )
      = ( cot @ real @ X3 ) ) ).

% tan_cot'
thf(fact_3452_cos__zero__iff__int,axiom,
    ! [X3: real] :
      ( ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( ? [I2: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I2 )
            & ( X3
              = ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3453_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y5 ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y5 ) @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X3 )
              = Y5 ) ) ) ) ).

% round_unique
thf(fact_3454_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3455_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3456_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X3 )
            = N ) ) ) ).

% round_unique'
thf(fact_3457_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) @ X3 ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_3458_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_3459_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_3460_complex__i__mult__minus,axiom,
    ! [X3: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X3 ) )
      = ( uminus_uminus @ complex @ X3 ) ) ).

% complex_i_mult_minus
thf(fact_3461_divide__i,axiom,
    ! [X3: complex] :
      ( ( divide_divide @ complex @ X3 @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X3 ) ) ).

% divide_i
thf(fact_3462_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3463_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_3464_divide__numeral__i,axiom,
    ! [Z2: complex,N: num] :
      ( ( divide_divide @ complex @ Z2 @ ( times_times @ complex @ ( numeral_numeral @ complex @ N ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z2 ) ) @ ( numeral_numeral @ complex @ N ) ) ) ).

% divide_numeral_i
thf(fact_3465_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3466_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3467_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_3468_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_3469_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3470_complex__i__not__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( numeral_numeral @ complex @ W ) ) ).

% complex_i_not_numeral
thf(fact_3471_i__times__eq__iff,axiom,
    ! [W: complex,Z2: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z2 )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z2 ) ) ) ) ).

% i_times_eq_iff
thf(fact_3472_complex__i__not__neg__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_i_not_neg_numeral
thf(fact_3473_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X3 ) @ ( archimedean_round @ A @ Y5 ) ) ) ) ).

% round_mono
thf(fact_3474_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archimedean_round @ A @ X3 ) ) ) ).

% floor_le_round
thf(fact_3475_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X3 ) @ ( archimedean_ceiling @ A @ X3 ) ) ) ).

% ceiling_ge_round
thf(fact_3476_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3477_Complex__eq__i,axiom,
    ! [X3: real,Y5: real] :
      ( ( ( complex2 @ X3 @ Y5 )
        = imaginary_unit )
      = ( ( X3
          = ( zero_zero @ real ) )
        & ( Y5
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3478_Complex__mult__i,axiom,
    ! [A3: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A3 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A3 ) ) ).

% Complex_mult_i
thf(fact_3479_i__mult__Complex,axiom,
    ! [A3: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A3 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A3 ) ) ).

% i_mult_Complex
thf(fact_3480_i__complex__of__real,axiom,
    ! [R2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R2 ) )
      = ( complex2 @ ( zero_zero @ real ) @ R2 ) ) ).

% i_complex_of_real
thf(fact_3481_complex__of__real__i,axiom,
    ! [R2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R2 ) ) ).

% complex_of_real_i
thf(fact_3482_Complex__eq,axiom,
    ( complex2
    = ( ^ [A5: real,B4: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A5 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% Complex_eq
thf(fact_3483_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z2 ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_3484_complex__split__polar,axiom,
    ! [Z2: complex] :
    ? [R: real,A7: real] :
      ( Z2
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A7 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A7 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_3485_cmod__unit__one,axiom,
    ! [A3: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A3 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A3 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_3486_cmod__complex__polar,axiom,
    ! [R2: real,A3: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A3 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A3 ) ) ) ) ) )
      = ( abs_abs @ real @ R2 ) ) ).

% cmod_complex_polar
thf(fact_3487_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X4: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X4 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_3488_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_3489_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) ) ) ).

% of_int_round_ge
thf(fact_3490_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less @ A @ ( minus_minus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X3 ) ) ) ) ).

% of_int_round_gt
thf(fact_3491_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3492_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3493_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3494_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3495_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X4: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X4 ) ) @ ( archimedean_ceiling @ A @ X4 ) @ ( archim6421214686448440834_floor @ A @ X4 ) ) ) ) ) ).

% round_altdef
thf(fact_3496_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_3497_csqrt__eq__0,axiom,
    ! [Z2: complex] :
      ( ( ( csqrt @ Z2 )
        = ( zero_zero @ complex ) )
      = ( Z2
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_3498_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z2 ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_3499_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3500_power2__csqrt,axiom,
    ! [Z2: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z2 ) ).

% power2_csqrt
thf(fact_3501_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3502_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3503_cis__neq__zero,axiom,
    ! [A3: real] :
      ( ( cis @ A3 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_3504_cis__Arg,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z2 ) )
        = ( sgn_sgn @ complex @ Z2 ) ) ) ).

% cis_Arg
thf(fact_3505_DeMoivre,axiom,
    ! [A3: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A3 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A3 ) ) ) ).

% DeMoivre
thf(fact_3506_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X3 ) ) ) ).

% frac_ge_0
thf(fact_3507_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X3 ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_3508_cis__mult,axiom,
    ! [A3: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A3 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A3 @ B2 ) ) ) ).

% cis_mult
thf(fact_3509_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X3 @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X3 ) ) ) ).

% frac_1_eq
thf(fact_3510_cis__divide,axiom,
    ! [A3: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A3 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A3 @ B2 ) ) ) ).

% cis_divide
thf(fact_3511_cis__Arg__unique,axiom,
    ! [Z2: complex,X3: real] :
      ( ( ( sgn_sgn @ complex @ Z2 )
        = ( cis @ X3 ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X3 )
       => ( ( ord_less_eq @ real @ X3 @ pi )
         => ( ( arg @ Z2 )
            = X3 ) ) ) ) ).

% cis_Arg_unique
thf(fact_3512_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3513_Arg__correct,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z2 )
          = ( cis @ ( arg @ Z2 ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
        & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ) ).

% Arg_correct
thf(fact_3514_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( archimedean_frac @ A @ X3 )
            = X3 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
            & ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_3515_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y5 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y5 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y5 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y5 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_3516_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B4: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_3517_of__real__sqrt,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X3 ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X3 ) ) ) ) ).

% of_real_sqrt
thf(fact_3518_Arg__bounded,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
      & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ).

% Arg_bounded
thf(fact_3519_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y5 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y5 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X3 ) @ ( archimedean_frac @ A @ Y5 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y5 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_3520_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( ( member2 @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3521_powr__real__of__int,axiom,
    ! [X3: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X3 @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X3 @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X3 @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X3 @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_3522_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_3523_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_3524_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A3 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A3 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3525_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A3 ) )
          = A3 ) ) ).

% inverse_inverse_eq
thf(fact_3526_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ ( bit_se5824344971392196577ns_xor @ A @ X3 @ Y5 ) )
          = Y5 ) ) ).

% bit.xor_left_self
thf(fact_3527_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3528_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( ( inverse_inverse @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3529_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3530_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A] :
          ( ( ( inverse_inverse @ A @ X3 )
            = ( one_one @ A ) )
          = ( X3
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3531_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3532_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A3 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A3 ) ) ) ).

% inverse_divide
thf(fact_3533_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A3 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A3 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3534_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% xor.right_neutral
thf(fact_3535_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% xor.left_neutral
thf(fact_3536_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_3537_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ X3 )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_3538_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A3 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A3 ) ) ) ) ).

% abs_inverse
thf(fact_3539_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A3: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A3 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A3 ) ) ) ) ).

% sgn_inverse
thf(fact_3540_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A3 ) )
          = ( sgn_sgn @ A @ A3 ) ) ) ).

% inverse_sgn
thf(fact_3541_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_3542_not__infinity__eq,axiom,
    ! [X3: extended_enat] :
      ( ( ( X3
         != ( extend4730790105801354508finity @ extended_enat ) ) )
      = ( ? [I2: nat] :
            ( X3
            = ( extended_enat2 @ I2 ) ) ) ) ).

% not_infinity_eq
thf(fact_3543_not__enat__eq,axiom,
    ! [X3: extended_enat] :
      ( ( ! [Y: nat] :
            ( X3
           != ( extended_enat2 @ Y ) ) )
      = ( X3
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% not_enat_eq
thf(fact_3544_enat__ord__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_less @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( Q2
         != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% enat_ord_simps(4)
thf(fact_3545_enat__ord__simps_I6_J,axiom,
    ! [Q2: extended_enat] :
      ~ ( ord_less @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 ) ).

% enat_ord_simps(6)
thf(fact_3546_plus__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( plus_plus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% plus_enat_simps(2)
thf(fact_3547_plus__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( plus_plus @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% plus_enat_simps(3)
thf(fact_3548_enat__ord__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( Q2
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat_ord_simps(5)
thf(fact_3549_enat__ord__code_I3_J,axiom,
    ! [Q2: extended_enat] : ( ord_less_eq @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(3)
thf(fact_3550_idiff__infinity,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% idiff_infinity
thf(fact_3551_times__enat__simps_I2_J,axiom,
    ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% times_enat_simps(2)
thf(fact_3552_enat_Osimps_I5_J,axiom,
    ! [T: $tType,F1: nat > T,F22: T] :
      ( ( extended_case_enat @ T @ F1 @ F22 @ ( extend4730790105801354508finity @ extended_enat ) )
      = F22 ) ).

% enat.simps(5)
thf(fact_3553_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3554_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3555_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3556_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3557_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3558_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3559_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( archimedean_frac @ A @ X3 )
            = ( zero_zero @ A ) )
          = ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_3560_idiff__self,axiom,
    ! [N: extended_enat] :
      ( ( N
       != ( extend4730790105801354508finity @ extended_enat ) )
     => ( ( minus_minus @ extended_enat @ N @ N )
        = ( zero_zero @ extended_enat ) ) ) ).

% idiff_self
thf(fact_3561_add__diff__cancel__enat,axiom,
    ! [X3: extended_enat,Y5: extended_enat] :
      ( ( X3
       != ( extend4730790105801354508finity @ extended_enat ) )
     => ( ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X3 @ Y5 ) @ X3 )
        = Y5 ) ) ).

% add_diff_cancel_enat
thf(fact_3562_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3563_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3564_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ A3 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3565_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A3 @ ( inverse_inverse @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3566_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3567_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) )
            | ( member2 @ A @ Y5 @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ Y5 ) ) ) ) ) ).

% floor_add2
thf(fact_3568_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X3 ) )
          = ( ~ ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_3569_idiff__infinity__right,axiom,
    ! [A3: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A3 ) @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_infinity_right
thf(fact_3570_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3571_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_3572_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y5: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) ) ) ).

% xor_numerals(1)
thf(fact_3573_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y5: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) ) ) ).

% xor_numerals(2)
thf(fact_3574_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X3 ) ) ) ) ).

% xor_numerals(5)
thf(fact_3575_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X3 ) ) ) ) ).

% xor_numerals(8)
thf(fact_3576_times__enat__simps_I3_J,axiom,
    ! [N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(3)
thf(fact_3577_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( ( ( M
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( M
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(4)
thf(fact_3578_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_3579_xor__nat__numerals_I1_J,axiom,
    ! [Y5: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y5 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y5 ) ) ) ).

% xor_nat_numerals(1)
thf(fact_3580_xor__nat__numerals_I2_J,axiom,
    ! [Y5: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y5 ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y5 ) ) ) ).

% xor_nat_numerals(2)
thf(fact_3581_xor__nat__numerals_I3_J,axiom,
    ! [X3: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X3 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X3 ) ) ) ).

% xor_nat_numerals(3)
thf(fact_3582_xor__nat__numerals_I4_J,axiom,
    ! [X3: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X3 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X3 ) ) ) ).

% xor_nat_numerals(4)
thf(fact_3583_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_3584_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_3585_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A3 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_inverse
thf(fact_3586_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( member2 @ A @ ( power_power @ A @ A3 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_3587_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X3: real] :
          ( ( X3
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X3 ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X3 ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_3588_real__sqrt__inverse,axiom,
    ! [X3: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X3 ) )
      = ( inverse_inverse @ real @ ( sqrt @ X3 ) ) ) ).

% real_sqrt_inverse
thf(fact_3589_enat_Odistinct_I2_J,axiom,
    ! [Nat5: nat] :
      ( ( extend4730790105801354508finity @ extended_enat )
     != ( extended_enat2 @ Nat5 ) ) ).

% enat.distinct(2)
thf(fact_3590_enat_Odistinct_I1_J,axiom,
    ! [Nat: nat] :
      ( ( extended_enat2 @ Nat )
     != ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat.distinct(1)
thf(fact_3591_enat_Oexhaust,axiom,
    ! [Y5: extended_enat] :
      ( ! [Nat3: nat] :
          ( Y5
         != ( extended_enat2 @ Nat3 ) )
     => ( Y5
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat.exhaust
thf(fact_3592_enat2__cases,axiom,
    ! [Y5: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y5
            = ( extended_enat2 @ Nat3 ) )
       => ! [Nata: nat] :
            ( Ya
           != ( extended_enat2 @ Nata ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y5
              = ( extended_enat2 @ Nat3 ) )
         => ( Ya
           != ( extend4730790105801354508finity @ extended_enat ) ) )
       => ( ( ( Y5
              = ( extend4730790105801354508finity @ extended_enat ) )
           => ! [Nat3: nat] :
                ( Ya
               != ( extended_enat2 @ Nat3 ) ) )
         => ~ ( ( Y5
                = ( extend4730790105801354508finity @ extended_enat ) )
             => ( Ya
               != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ) ).

% enat2_cases
thf(fact_3593_enat3__cases,axiom,
    ! [Y5: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y5
            = ( extended_enat2 @ Nat3 ) )
       => ( ? [Nata: nat] :
              ( Ya
              = ( extended_enat2 @ Nata ) )
         => ! [Natb: nat] :
              ( Yb
             != ( extended_enat2 @ Natb ) ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y5
              = ( extended_enat2 @ Nat3 ) )
         => ( ? [Nata: nat] :
                ( Ya
                = ( extended_enat2 @ Nata ) )
           => ( Yb
             != ( extend4730790105801354508finity @ extended_enat ) ) ) )
       => ( ( ? [Nat3: nat] :
                ( Y5
                = ( extended_enat2 @ Nat3 ) )
           => ( ( Ya
                = ( extend4730790105801354508finity @ extended_enat ) )
             => ! [Nata: nat] :
                  ( Yb
                 != ( extended_enat2 @ Nata ) ) ) )
         => ( ( ? [Nat3: nat] :
                  ( Y5
                  = ( extended_enat2 @ Nat3 ) )
             => ( ( Ya
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( Yb
                 != ( extend4730790105801354508finity @ extended_enat ) ) ) )
           => ( ( ( Y5
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( ? [Nat3: nat] :
                      ( Ya
                      = ( extended_enat2 @ Nat3 ) )
                 => ! [Nata: nat] :
                      ( Yb
                     != ( extended_enat2 @ Nata ) ) ) )
             => ( ( ( Y5
                    = ( extend4730790105801354508finity @ extended_enat ) )
                 => ( ? [Nat3: nat] :
                        ( Ya
                        = ( extended_enat2 @ Nat3 ) )
                   => ( Yb
                     != ( extend4730790105801354508finity @ extended_enat ) ) ) )
               => ( ( ( Y5
                      = ( extend4730790105801354508finity @ extended_enat ) )
                   => ( ( Ya
                        = ( extend4730790105801354508finity @ extended_enat ) )
                     => ! [Nat3: nat] :
                          ( Yb
                         != ( extended_enat2 @ Nat3 ) ) ) )
                 => ~ ( ( Y5
                        = ( extend4730790105801354508finity @ extended_enat ) )
                     => ( ( Ya
                          = ( extend4730790105801354508finity @ extended_enat ) )
                       => ( Yb
                         != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ) ) ) ) ) ) ).

% enat3_cases
thf(fact_3594_enat__ex__split,axiom,
    ( ( ^ [P4: extended_enat > $o] :
        ? [X7: extended_enat] : ( P4 @ X7 ) )
    = ( ^ [P2: extended_enat > $o] :
          ( ( P2 @ ( extend4730790105801354508finity @ extended_enat ) )
          | ? [X4: nat] : ( P2 @ ( extended_enat2 @ X4 ) ) ) ) ) ).

% enat_ex_split
thf(fact_3595_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( member2 @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member2 @ A @ ( minus_minus @ A @ A3 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_3596_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A] :
          ( ( member2 @ A @ ( uminus_uminus @ A @ X3 ) @ ( ring_1_Ints @ A ) )
          = ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) ) ) ) ).

% minus_in_Ints_iff
thf(fact_3597_Ints__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( member2 @ A @ ( uminus_uminus @ A @ A3 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_minus
thf(fact_3598_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_3599_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A3 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A3 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3600_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_3601_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se5824344971392196577ns_xor @ A @ B4 @ A5 ) ) ) ) ).

% xor.commute
thf(fact_3602_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_3603_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( member2 @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member2 @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_3604_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member2 @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_3605_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( member2 @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member2 @ A @ ( times_times @ A @ A3 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_3606_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member2 @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_3607_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member2 @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_3608_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3609_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A3 ) )
            = A3 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3610_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A3 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A3 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3611_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( ( inverse_inverse @ A @ A3 )
            = ( zero_zero @ A ) )
         => ( A3
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3612_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3613_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y5: A,X3: A] :
          ( ( ( times_times @ A @ Y5 @ X3 )
            = ( times_times @ A @ X3 @ Y5 ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y5 ) @ X3 )
            = ( times_times @ A @ X3 @ ( inverse_inverse @ A @ Y5 ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3614_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A3 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_3615_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] : ( member2 @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_int
thf(fact_3616_Ints__induct,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q2: A,P: A > $o] :
          ( ( member2 @ A @ Q2 @ ( ring_1_Ints @ A ) )
         => ( ! [Z5: int] : ( P @ ( ring_1_of_int @ A @ Z5 ) )
           => ( P @ Q2 ) ) ) ) ).

% Ints_induct
thf(fact_3617_Ints__cases,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q2: A] :
          ( ( member2 @ A @ Q2 @ ( ring_1_Ints @ A ) )
         => ~ ! [Z5: int] :
                ( Q2
               != ( ring_1_of_int @ A @ Z5 ) ) ) ) ).

% Ints_cases
thf(fact_3618_infinity__ne__i0,axiom,
    ( extend4730790105801354508finity @ extended_enat )
 != ( zero_zero @ extended_enat ) ).

% infinity_ne_i0
thf(fact_3619_Ints__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( member2 @ A @ ( abs_abs @ A @ A3 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_abs
thf(fact_3620_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ B2 ) @ N )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_xor_iff
thf(fact_3621_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y5: A,Z2: A,X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y5 @ Z2 ) @ X3 )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y5 @ X3 ) @ ( bit_se5824344872417868541ns_and @ A @ Z2 @ X3 ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_3622_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X3 @ ( bit_se5824344971392196577ns_xor @ A @ Y5 @ Z2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X3 @ Y5 ) @ ( bit_se5824344872417868541ns_and @ A @ X3 @ Z2 ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_3623_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] : ( member2 @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_nat
thf(fact_3624_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_xor_eq
thf(fact_3625_fact__in__Ints,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( ring_1 @ A ) )
     => ! [N: nat] : ( member2 @ A @ ( semiring_char_0_fact @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% fact_in_Ints
thf(fact_3626_plus__eq__infty__iff__enat,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( M
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( N
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% plus_eq_infty_iff_enat
thf(fact_3627_enat__add__left__cancel,axiom,
    ! [A3: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ A3 @ B2 )
        = ( plus_plus @ extended_enat @ A3 @ C2 ) )
      = ( ( A3
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( B2 = C2 ) ) ) ).

% enat_add_left_cancel
thf(fact_3628_enat__ord__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( ord_less_eq @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_simps(3)
thf(fact_3629_infinity__ne__i1,axiom,
    ( extend4730790105801354508finity @ extended_enat )
 != ( one_one @ extended_enat ) ).

% infinity_ne_i1
thf(fact_3630_numeral__ne__infinity,axiom,
    ! [K: num] :
      ( ( numeral_numeral @ extended_enat @ K )
     != ( extend4730790105801354508finity @ extended_enat ) ) ).

% numeral_ne_infinity
thf(fact_3631_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R2: real,X3: A] :
          ( ( ord_less_eq @ real @ R2 @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X3 ) ) @ ( inverse_inverse @ real @ R2 ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3632_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3633_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3634_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A3 ) )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3635_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( zero_zero @ A ) )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3636_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3637_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3638_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3639_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3640_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A3 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3641_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A3 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3642_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3643_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3644_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3645_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% divide_inverse
thf(fact_3646_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ ( inverse_inverse @ A @ B4 ) @ A5 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3647_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3648_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X3 @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ N ) @ ( power_power @ A @ X3 @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3649_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X3 @ M ) @ ( inverse_inverse @ A @ X3 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X3 ) @ ( power_power @ A @ X3 @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3650_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X3: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X3 )
          = ( times_times @ A @ X3 @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3651_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A3 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A3 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3652_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X3: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X3 )
          = ( times_times @ A @ X3 @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3653_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X4: real,Y: real] : ( times_times @ real @ X4 @ ( inverse_inverse @ real @ Y ) ) ) ) ).

% divide_real_def
thf(fact_3654_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A3 @ A3 )
              = ( zero_zero @ A ) )
            = ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_3655_enat__ord__code_I4_J,axiom,
    ! [M: nat] : ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(4)
thf(fact_3656_less__infinityE,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ N @ ( extend4730790105801354508finity @ extended_enat ) )
     => ~ ! [K2: nat] :
            ( N
           != ( extended_enat2 @ K2 ) ) ) ).

% less_infinityE
thf(fact_3657_infinity__ilessE,axiom,
    ! [M: nat] :
      ~ ( ord_less @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ M ) ) ).

% infinity_ilessE
thf(fact_3658_enat__ord__code_I5_J,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) ) ).

% enat_ord_code(5)
thf(fact_3659_infinity__ileE,axiom,
    ! [M: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ M ) ) ).

% infinity_ileE
thf(fact_3660_enat__add__left__cancel__less,axiom,
    ! [A3: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( plus_plus @ extended_enat @ A3 @ B2 ) @ ( plus_plus @ extended_enat @ A3 @ C2 ) )
      = ( ( A3
         != ( extend4730790105801354508finity @ extended_enat ) )
        & ( ord_less @ extended_enat @ B2 @ C2 ) ) ) ).

% enat_add_left_cancel_less
thf(fact_3661_enat__add__left__cancel__le,axiom,
    ! [A3: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ A3 @ B2 ) @ ( plus_plus @ extended_enat @ A3 @ C2 ) )
      = ( ( A3
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( ord_less_eq @ extended_enat @ B2 @ C2 ) ) ) ).

% enat_add_left_cancel_le
thf(fact_3662_imult__is__infinity,axiom,
    ! [A3: extended_enat,B2: extended_enat] :
      ( ( ( times_times @ extended_enat @ A3 @ B2 )
        = ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( ( A3
            = ( extend4730790105801354508finity @ extended_enat ) )
          & ( B2
           != ( zero_zero @ extended_enat ) ) )
        | ( ( B2
            = ( extend4730790105801354508finity @ extended_enat ) )
          & ( A3
           != ( zero_zero @ extended_enat ) ) ) ) ) ).

% imult_is_infinity
thf(fact_3663_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3664_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3665_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3666_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3667_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X3 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3668_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X3 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
            & ( ord_less @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3669_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3670_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ A3 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3671_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3672_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3673_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( minus_minus @ A @ B2 @ A3 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3674_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3675_inverse__powr,axiom,
    ! [Y5: real,A3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y5 ) @ A3 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y5 @ A3 ) ) ) ) ).

% inverse_powr
thf(fact_3676_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ A3 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_3677_VEBT__internal_Oelim__dead_Ocases,axiom,
    ! [X3: product_prod @ vEBT_VEBT @ extended_enat] :
      ( ! [A7: $o,B6: $o,Uu2: extended_enat] :
          ( X3
         != ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Leaf @ A7 @ B6 ) @ Uu2 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
            ( X3
           != ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) @ ( extend4730790105801354508finity @ extended_enat ) ) )
       => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,L2: nat] :
              ( X3
             != ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) @ ( extended_enat2 @ L2 ) ) ) ) ) ).

% VEBT_internal.elim_dead.cases
thf(fact_3678_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A3: int] :
          ( ( dvd_dvd @ int @ B2 @ A3 )
         => ( member2 @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A3 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_3679_imult__infinity,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
     => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% imult_infinity
thf(fact_3680_imult__infinity__right,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
     => ( ( times_times @ extended_enat @ N @ ( extend4730790105801354508finity @ extended_enat ) )
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% imult_infinity_right
thf(fact_3681_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3682_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ B2 @ A3 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A3 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3683_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3684_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X3 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X3 ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3685_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X3 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
            & ( ord_less_eq @ A @ X3 @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3686_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( minus_minus @ A @ A3 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3687_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X3 ) ) ) ).

% reals_Archimedean
thf(fact_3688_forall__pos__mono__1,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D3: real,E2: real] :
          ( ( ord_less @ real @ D3 @ E2 )
         => ( ( P @ D3 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3689_forall__pos__mono,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D3: real,E2: real] :
          ( ( ord_less @ real @ D3 @ E2 )
         => ( ( P @ D3 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono
thf(fact_3690_real__arch__inverse,axiom,
    ! [E: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
      = ( ? [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ E ) ) ) ) ).

% real_arch_inverse
thf(fact_3691_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_3692_sqrt__divide__self__eq,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( divide_divide @ real @ ( sqrt @ X3 ) @ X3 )
        = ( inverse_inverse @ real @ ( sqrt @ X3 ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3693_ln__inverse,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X3 ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X3 ) ) ) ) ).

% ln_inverse
thf(fact_3694_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ A3 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_3695_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) )
         => ( ( X3
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X3 ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_3696_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X3 ) @ ( one_one @ A ) )
           => ( X3
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_3697_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: A,Y5: A] :
          ( ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) )
         => ( ( member2 @ A @ Y5 @ ( ring_1_Ints @ A ) )
           => ( ( X3 = Y5 )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ Y5 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_3698_sin__times__pi__eq__0,axiom,
    ! [X3: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X3 @ pi ) )
        = ( zero_zero @ real ) )
      = ( member2 @ real @ X3 @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_3699_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X3 ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3700_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: nat,N: nat] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X3 @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3701_log__inverse,axiom,
    ! [A3: real,X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
     => ( ( A3
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( log @ A3 @ ( inverse_inverse @ real @ X3 ) )
            = ( uminus_uminus @ real @ ( log @ A3 @ X3 ) ) ) ) ) ) ).

% log_inverse
thf(fact_3702_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A] :
          ( ( ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X3 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member2 @ A @ X3 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X3 ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X3 ) ) ) ) ) ) ).

% frac_neg
thf(fact_3703_exp__plus__inverse__exp,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X3 ) @ ( inverse_inverse @ real @ ( exp @ real @ X3 ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3704_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A3: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A3 )
         => ( ( member2 @ B @ A3 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A3 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A3 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_3705_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X3: A,A3: A] :
          ( ( ( archimedean_frac @ A @ X3 )
            = A3 )
          = ( ( member2 @ A @ ( minus_minus @ A @ X3 @ A3 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
            & ( ord_less @ A @ A3 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_3706_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A3: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A3 )
         => ( ( member2 @ B @ A3 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A3 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A3 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_3707_plus__inverse__ge__2,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X3 @ ( inverse_inverse @ real @ X3 ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3708_real__inv__sqrt__pow2,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X3 ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3709_tan__cot,axiom,
    ! [X3: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X3 ) ) ) ).

% tan_cot
thf(fact_3710_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member2 @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_3711_cos__integer__2pi,axiom,
    ! [N: real] :
      ( ( member2 @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_3712_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_3713_real__le__x__sinh,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X3 ) @ ( inverse_inverse @ real @ ( exp @ real @ X3 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3714_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_3715_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A3 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% one_xor_eq
thf(fact_3716_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% xor_one_eq
thf(fact_3717_real__le__abs__sinh,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X3 ) @ ( inverse_inverse @ real @ ( exp @ real @ X3 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3718_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3719_sinh__ln__real,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( sinh @ real @ ( ln_ln @ real @ X3 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X3 @ ( inverse_inverse @ real @ X3 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3720_cosh__ln__real,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( cosh @ real @ ( ln_ln @ real @ X3 ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X3 @ ( inverse_inverse @ real @ X3 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3721_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A3 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_3722_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_3723_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cosh @ A @ X3 )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3724_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3725_sinh__real__zero__iff,axiom,
    ! [X3: real] :
      ( ( ( sinh @ real @ X3 )
        = ( zero_zero @ real ) )
      = ( X3
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3726_sinh__real__less__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X3 ) @ ( sinh @ real @ Y5 ) )
      = ( ord_less @ real @ X3 @ Y5 ) ) ).

% sinh_real_less_iff
thf(fact_3727_sinh__real__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X3 ) @ ( sinh @ real @ Y5 ) )
      = ( ord_less_eq @ real @ X3 @ Y5 ) ) ).

% sinh_real_le_iff
thf(fact_3728_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3729_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_3730_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A3: A] :
          ( ( gbinomial @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_3731_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A3: A] :
          ( ( gbinomial @ A @ A3 @ ( suc @ ( zero_zero @ nat ) ) )
          = A3 ) ) ).

% gbinomial_Suc0
thf(fact_3732_sinh__real__neg__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3733_sinh__real__pos__iff,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X3 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% sinh_real_pos_iff
thf(fact_3734_sinh__real__nonneg__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X3 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 ) ) ).

% sinh_real_nonneg_iff
thf(fact_3735_sinh__real__nonpos__iff,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X3 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3736_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_3737_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_3738_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ N )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
         != ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ) ).

% bit_xor_int_iff
thf(fact_3739_cosh__real__nonzero,axiom,
    ! [X3: real] :
      ( ( cosh @ real @ X3 )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3740_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X3 ) @ ( cosh @ A @ Y5 ) ) @ ( times_times @ A @ ( cosh @ A @ X3 ) @ ( sinh @ A @ Y5 ) ) ) ) ) ).

% sinh_diff
thf(fact_3741_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X3 @ Y5 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X3 ) @ ( cosh @ A @ Y5 ) ) @ ( times_times @ A @ ( sinh @ A @ X3 ) @ ( sinh @ A @ Y5 ) ) ) ) ) ).

% cosh_diff
thf(fact_3742_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X3 ) @ ( cosh @ A @ Y5 ) ) @ ( times_times @ A @ ( sinh @ A @ X3 ) @ ( sinh @ A @ Y5 ) ) ) ) ) ).

% cosh_add
thf(fact_3743_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X3 ) @ ( cosh @ A @ Y5 ) ) @ ( times_times @ A @ ( cosh @ A @ X3 ) @ ( sinh @ A @ Y5 ) ) ) ) ) ).

% sinh_add
thf(fact_3744_sinh__less__cosh__real,axiom,
    ! [X3: real] : ( ord_less @ real @ ( sinh @ real @ X3 ) @ ( cosh @ real @ X3 ) ) ).

% sinh_less_cosh_real
thf(fact_3745_sinh__le__cosh__real,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( sinh @ real @ X3 ) @ ( cosh @ real @ X3 ) ) ).

% sinh_le_cosh_real
thf(fact_3746_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( sinh @ A @ X4 ) @ ( cosh @ A @ X4 ) ) ) ) ) ).

% tanh_def
thf(fact_3747_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X3 ) @ ( sinh @ A @ X3 ) )
          = ( exp @ A @ X3 ) ) ) ).

% cosh_plus_sinh
thf(fact_3748_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X3 ) @ ( cosh @ A @ X3 ) )
          = ( exp @ A @ X3 ) ) ) ).

% sinh_plus_cosh
thf(fact_3749_XOR__lower,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X3 @ Y5 ) ) ) ) ).

% XOR_lower
thf(fact_3750_cosh__real__pos,axiom,
    ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X3 ) ) ).

% cosh_real_pos
thf(fact_3751_cosh__real__nonneg,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X3 ) ) ).

% cosh_real_nonneg
thf(fact_3752_cosh__real__nonneg__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X3 ) @ ( cosh @ real @ Y5 ) )
          = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3753_cosh__real__nonpos__le__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y5 @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X3 ) @ ( cosh @ real @ Y5 ) )
          = ( ord_less_eq @ real @ Y5 @ X3 ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3754_cosh__real__ge__1,axiom,
    ! [X3: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X3 ) ) ).

% cosh_real_ge_1
thf(fact_3755_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X3 ) ) @ ( cosh @ A @ X3 ) ) ) ) ).

% sinh_double
thf(fact_3756_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X4: complex,Y: complex] : ( times_times @ complex @ X4 @ ( inverse_inverse @ complex @ Y ) ) ) ) ).

% divide_complex_def
thf(fact_3757_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A3 @ K ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_3758_cosh__real__strict__mono,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ Y5 )
       => ( ord_less @ real @ ( cosh @ real @ X3 ) @ ( cosh @ real @ Y5 ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3759_cosh__real__nonneg__less__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ord_less @ real @ ( cosh @ real @ X3 ) @ ( cosh @ real @ Y5 ) )
          = ( ord_less @ real @ X3 @ Y5 ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3760_cosh__real__nonpos__less__iff,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y5 @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X3 ) @ ( cosh @ real @ Y5 ) )
          = ( ord_less @ real @ Y5 @ X3 ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3761_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_3762_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( power_power @ A @ ( cosh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3763_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( power_power @ A @ ( sinh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3764_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3765_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% xor_nat_def
thf(fact_3766_arcosh__cosh__real,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( arcosh @ real @ ( cosh @ real @ X3 ) )
        = X3 ) ) ).

% arcosh_cosh_real
thf(fact_3767_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3768_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ A3 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_3769_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A3 @ K ) )
          = ( times_times @ A @ A3 @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_3770_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A3 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_3771_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ A3 @ ( gbinomial @ A @ A3 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_3772_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ A3 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_3773_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_3774_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) )
          = ( times_times @ A @ A3 @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_3775_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A3: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A3 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_3776_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_3777_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_3778_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_3779_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A5 ) @ ( one_one @ A ) ) @ K3 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_3780_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ( cosh @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y5 )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X3 @ Y5 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X3 ) @ ( tanh @ A @ Y5 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X3 ) @ ( tanh @ A @ Y5 ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3781_XOR__upper,axiom,
    ! [X3: int,N: nat,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less @ int @ X3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y5 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X3 @ Y5 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_3782_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A3 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_3783_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A3 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_3784_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A5 ) @ K3 ) ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_3785_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ K3 ) ) @ ( one_one @ A ) ) @ K3 ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_3786_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z3: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z3 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z3 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3787_complex__inverse,axiom,
    ! [A3: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A3 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A3 @ ( plus_plus @ real @ ( power_power @ real @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3788_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L3: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_3789_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z3 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z3 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3790_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N )
          = ( ( ord_less @ nat @ N @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_3791_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L3: int] :
          ( if @ int
          @ ( K3
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L3 )
          @ ( if @ int
            @ ( L3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K3 )
            @ ( if @ int
              @ ( K3
                = ( zero_zero @ int ) )
              @ L3
              @ ( if @ int
                @ ( L3
                  = ( zero_zero @ int ) )
                @ K3
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_3792_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3793_psubsetI,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( A2 != B3 )
       => ( ord_less @ ( set @ A ) @ A2 @ B3 ) ) ) ).

% psubsetI
thf(fact_3794_subset__antisym,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( A2 = B3 ) ) ) ).

% subset_antisym
thf(fact_3795_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) ).

% Compl_subset_Compl_iff
thf(fact_3796_Compl__anti__mono,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) ) ) ).

% Compl_anti_mono
thf(fact_3797_subsetI,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
         => ( member2 @ A @ X2 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% subsetI
thf(fact_3798_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) )
          = X3 ) ) ).

% bit.double_compl
thf(fact_3799_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X3 )
            = ( bit_ri4277139882892585799ns_not @ A @ Y5 ) )
          = ( X3 = Y5 ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_3800_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_3801_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_3802_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A3: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_3803_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_3804_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A3 ) ) ) ).

% push_bit_push_bit
thf(fact_3805_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_3806_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ Y5 )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X3 @ Y5 ) ) ) ) ).

% bit.xor_compl_left
thf(fact_3807_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X3 @ Y5 ) ) ) ) ).

% bit.xor_compl_right
thf(fact_3808_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_3809_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_3810_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X3 @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_3811_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ X3 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_3812_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_3813_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_3814_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_3815_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_3816_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ X3 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_3817_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X3 ) ) ) ).

% bit.xor_one_right
thf(fact_3818_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 )
          = ( bit_ri4277139882892585799ns_not @ A @ X3 ) ) ) ).

% bit.xor_one_left
thf(fact_3819_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_3820_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_3821_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_3822_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% even_not_iff
thf(fact_3823_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_3824_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_3825_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_3826_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_3827_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A3 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_3828_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_3829_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_3830_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% even_push_bit_iff
thf(fact_3831_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_3832_bit__not__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff
thf(fact_3833_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_3834_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_3835_psubsetD,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C2: A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ( ( member2 @ A @ C2 @ A2 )
       => ( member2 @ A @ C2 @ B3 ) ) ) ).

% psubsetD
thf(fact_3836_psubset__trans,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A2 @ C6 ) ) ) ).

% psubset_trans
thf(fact_3837_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ? [B6: A] : ( member2 @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_3838_push__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_3839_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_3840_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_3841_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ A3 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) ) ) ) ).

% push_bit_minus
thf(fact_3842_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_3843_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_3844_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_3845_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_3846_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_3847_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_3848_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_3849_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_3850_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_3851_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A3 ) ) ) ) ).

% push_bit_take_bit
thf(fact_3852_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N ) @ A3 ) ) ) ) ).

% take_bit_push_bit
thf(fact_3853_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_3854_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_3855_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_3856_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A5: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_3857_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_3858_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_3859_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A3: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_3860_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_3861_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_3862_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_3863_in__mono,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member2 @ A @ X3 @ A2 )
       => ( member2 @ A @ X3 @ B3 ) ) ) ).

% in_mono
thf(fact_3864_subsetD,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member2 @ A @ C2 @ A2 )
       => ( member2 @ A @ C2 @ B3 ) ) ) ).

% subsetD
thf(fact_3865_equalityE,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( A2 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) ) ).

% equalityE
thf(fact_3866_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
          ! [X4: A] :
            ( ( member2 @ A @ X4 @ A4 )
           => ( member2 @ A @ X4 @ B8 ) ) ) ) ).

% subset_eq
thf(fact_3867_equalityD1,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( A2 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% equalityD1
thf(fact_3868_equalityD2,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( A2 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) ).

% equalityD2
thf(fact_3869_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
          ! [T3: A] :
            ( ( member2 @ A @ T3 @ A4 )
           => ( member2 @ A @ T3 @ B8 ) ) ) ) ).

% subset_iff
thf(fact_3870_subset__refl,axiom,
    ! [A: $tType,A2: set @ A] : ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) ).

% subset_refl
thf(fact_3871_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_3872_subset__trans,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C6 ) ) ) ).

% subset_trans
thf(fact_3873_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: set @ A,Z: set @ A] : ( Y3 = Z ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A4 ) ) ) ) ).

% set_eq_subset
thf(fact_3874_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) ) ) ) ).

% Collect_mono_iff
thf(fact_3875_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A4 @ B8 )
            | ( A4 = B8 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_3876_subset__psubset__trans,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A2 @ C6 ) ) ) ).

% subset_psubset_trans
thf(fact_3877_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B8 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B8 @ A4 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_3878_psubset__subset__trans,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A2 @ C6 ) ) ) ).

% psubset_subset_trans
thf(fact_3879_psubset__imp__subset,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% psubset_imp_subset
thf(fact_3880_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B8 )
            & ( A4 != B8 ) ) ) ) ).

% psubset_eq
thf(fact_3881_psubsetE,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) ) ).

% psubsetE
thf(fact_3882_Diff__mono,axiom,
    ! [A: $tType,A2: set @ A,C6: set @ A,D4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ D4 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ ( minus_minus @ ( set @ A ) @ C6 @ D4 ) ) ) ) ).

% Diff_mono
thf(fact_3883_Diff__subset,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ A2 ) ).

% Diff_subset
thf(fact_3884_double__diff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ( minus_minus @ ( set @ A ) @ B3 @ ( minus_minus @ ( set @ A ) @ C6 @ A2 ) )
          = A2 ) ) ) ).

% double_diff
thf(fact_3885_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q2 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_3886_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K3: int,L3: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L3 ) ) ) ) ).

% concat_bit_eq
thf(fact_3887_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se5824344971392196577ns_xor @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_3888_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_se5824344971392196577ns_xor @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_3889_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_3890_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_3891_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_3892_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_3893_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_3894_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_3895_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_3896_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_3897_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_3898_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3899_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_3900_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_3901_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_3902_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( times_times @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_int_def
thf(fact_3903_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( times_times @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_nat_def
thf(fact_3904_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( times_times @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3905_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A3 )
         => ~ ! [B6: A] :
                ( A3
               != ( bit_se4730199178511100633sh_bit @ A @ N @ B6 ) ) ) ) ).

% exp_dvdE
thf(fact_3906_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_3907_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_3908_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_3909_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_3910_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_3911_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_3912_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_3913_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X5: nat > real] :
        ! [J4: nat] :
        ? [M8: nat] :
        ! [M3: nat] :
          ( ( ord_less_eq @ nat @ M8 @ M3 )
         => ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M8 @ N2 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X5 @ M3 ) @ ( X5 @ N2 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J4 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_3914_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y5: $o] :
      ( ( ( vEBT_VEBT_membermima @ X3 @ Xa )
        = Y5 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X3
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y5 )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X3
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y5 )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X3
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y5
                  = ( ~ ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc: vEBT_VEBT] :
                      ( X3
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) )
                 => ( Y5
                    = ( ~ ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X3
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                   => ( Y5
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_3915_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X3 @ Xa )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X3
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X3
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X3
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa = Mi )
                  | ( Xa = Ma2 ) ) )
           => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc: vEBT_VEBT] :
                      ( X3
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) )
                 => ( ( Xa = Mi )
                    | ( Xa = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X3
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_3916_csqrt_Osimps_I1_J,axiom,
    ! [Z2: complex] :
      ( ( re @ ( csqrt @ Z2 ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_3917_complex__Re__numeral,axiom,
    ! [V: num] :
      ( ( re @ ( numeral_numeral @ complex @ V ) )
      = ( numeral_numeral @ real @ V ) ) ).

% complex_Re_numeral
thf(fact_3918_Re__divide__of__nat,axiom,
    ! [Z2: complex,N: nat] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Re_divide_of_nat
thf(fact_3919_Re__divide__of__real,axiom,
    ! [Z2: complex,R2: real] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( real_Vector_of_real @ complex @ R2 ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ R2 ) ) ).

% Re_divide_of_real
thf(fact_3920_Re__sgn,axiom,
    ! [Z2: complex] :
      ( ( re @ ( sgn_sgn @ complex @ Z2 ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% Re_sgn
thf(fact_3921_Re__divide__numeral,axiom,
    ! [Z2: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_3922_cos__Arg__i__mult__zero,axiom,
    ! [Y5: complex] :
      ( ( Y5
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y5 )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y5 ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_3923_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_less_as_int
thf(fact_3924_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X4: A] : ( member2 @ A @ X4 @ A4 )
            @ ^ [X4: A] : ( member2 @ A @ X4 @ B8 ) ) ) ) ).

% less_eq_set_def
thf(fact_3925_Collect__subset,axiom,
    ! [A: $tType,A2: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X4: A] :
            ( ( member2 @ A @ X4 @ A2 )
            & ( P @ X4 ) ) )
      @ A2 ) ).

% Collect_subset
thf(fact_3926_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X4: A] : ( member2 @ A @ X4 @ A4 )
            @ ^ [X4: A] : ( member2 @ A @ X4 @ B8 ) ) ) ) ).

% less_set_def
thf(fact_3927_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A3 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A3 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A3 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_3928_less__enat__def,axiom,
    ( ( ord_less @ extended_enat )
    = ( ^ [M3: extended_enat,N2: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [M1: nat] : ( extended_case_enat @ $o @ ( ord_less @ nat @ M1 ) @ $true @ N2 )
          @ $false
          @ M3 ) ) ) ).

% less_enat_def
thf(fact_3929_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H2: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_3930_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X4: A] : X4 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_3931_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X4: A] : ( times_times @ A @ X4 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_3932_less__eq__enat__def,axiom,
    ( ( ord_less_eq @ extended_enat )
    = ( ^ [M3: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [N1: nat] :
              ( extended_case_enat @ $o
              @ ^ [M1: nat] : ( ord_less_eq @ nat @ M1 @ N1 )
              @ $false
              @ M3 )
          @ $true ) ) ) ).

% less_eq_enat_def
thf(fact_3933_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A3 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_3934_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_3935_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A5: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_leq_as_int
thf(fact_3936_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_3937_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_3938_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_3939_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_3940_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_3941_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_3942_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_3943_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A5: nat,B4: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A5 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_3944_plus__enat__def,axiom,
    ( ( plus_plus @ extended_enat )
    = ( ^ [M3: extended_enat,N2: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [O: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [P6: nat] : ( extended_enat2 @ ( plus_plus @ nat @ O @ P6 ) )
              @ ( extend4730790105801354508finity @ extended_enat )
              @ N2 )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ M3 ) ) ) ).

% plus_enat_def
thf(fact_3945_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_3946_complex__Re__le__cmod,axiom,
    ! [X3: complex] : ( ord_less_eq @ real @ ( re @ X3 ) @ ( real_V7770717601297561774m_norm @ complex @ X3 ) ) ).

% complex_Re_le_cmod
thf(fact_3947_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_3948_diff__enat__def,axiom,
    ( ( minus_minus @ extended_enat )
    = ( ^ [A5: extended_enat,B4: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [X4: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [Y: nat] : ( extended_enat2 @ ( minus_minus @ nat @ X4 @ Y ) )
              @ ( zero_zero @ extended_enat )
              @ B4 )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ A5 ) ) ) ).

% diff_enat_def
thf(fact_3949_diff__nat__eq__if,axiom,
    ! [Z6: int,Z2: int] :
      ( ( ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) )
          = ( nat2 @ Z2 ) ) )
      & ( ~ ( ord_less @ int @ Z6 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z6 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z2 @ Z6 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z2 @ Z6 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_3950_times__enat__def,axiom,
    ( ( times_times @ extended_enat )
    = ( ^ [M3: extended_enat,N2: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [O: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [P6: nat] : ( extended_enat2 @ ( times_times @ nat @ O @ P6 ) )
              @ ( if @ extended_enat
                @ ( O
                  = ( zero_zero @ nat ) )
                @ ( zero_zero @ extended_enat )
                @ ( extend4730790105801354508finity @ extended_enat ) )
              @ N2 )
          @ ( if @ extended_enat
            @ ( N2
              = ( zero_zero @ extended_enat ) )
            @ ( zero_zero @ extended_enat )
            @ ( extend4730790105801354508finity @ extended_enat ) )
          @ M3 ) ) ) ).

% times_enat_def
thf(fact_3951_abs__Re__le__cmod,axiom,
    ! [X3: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X3 ) ) ).

% abs_Re_le_cmod
thf(fact_3952_Re__csqrt,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) ) ).

% Re_csqrt
thf(fact_3953_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X4: nat] :
          ( collect @ nat
          @ ^ [N2: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_3954_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) @ N2 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A5 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_3955_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_3956_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va2: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va2 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_3957_cmod__plus__Re__le__0__iff,axiom,
    ! [Z2: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z2 )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_3958_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L3: nat] : ( times_times @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ L3 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_3959_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A3: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A3 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A3 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_3960_vebt__buildup_Oelims,axiom,
    ! [X3: nat,Y5: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X3 )
        = Y5 )
     => ( ( ( X3
            = ( zero_zero @ nat ) )
         => ( Y5
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X3
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y5
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X3
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y5
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y5
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_3961_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT,X3: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V ) @ TreeList2 @ S ) @ X3 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_3962_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X5: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X5 @ M3 ) @ ( X5 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_3963_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ M4 ) @ ( X9 @ N3 ) ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X9 ) ) ) ).

% CauchyI
thf(fact_3964_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X9 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M10: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M2 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N7 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ M2 ) @ ( X9 @ N7 ) ) ) @ E ) ) ) ) ) ) ).

% CauchyD
thf(fact_3965_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X3: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList2 @ Vd2 ) @ X3 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_3966_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi3: nat,Ma: nat,V: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma ) ) @ ( suc @ V ) @ TreeList2 @ Vc2 ) @ X3 )
      = ( ( X3 = Mi3 )
        | ( X3 = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X3 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_3967_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X3 @ Xa )
     => ( ! [A7: $o,B6: $o] :
            ( ( X3
              = ( vEBT_Leaf @ A7 @ B6 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A7 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X3
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X3
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_3968_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X3 @ Xa )
     => ( ! [A7: $o,B6: $o] :
            ( ( X3
              = ( vEBT_Leaf @ A7 @ B6 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A7 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X3
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_3969_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y5: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X3 @ Xa )
        = Y5 )
     => ( ! [A7: $o,B6: $o] :
            ( ( X3
              = ( vEBT_Leaf @ A7 @ B6 ) )
           => ( Y5
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A7 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X3
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y5 )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X3
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( Y5
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_3970_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X3 @ Xa )
     => ( ! [Mi: nat,Ma2: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X3
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa = Mi )
                | ( Xa = Ma2 ) ) )
       => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc: vEBT_VEBT] :
                  ( X3
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) )
             => ~ ( ( Xa = Mi )
                  | ( Xa = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X3
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_3971_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K3 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_3972_monoseq__arctan__series,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X3 @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_3973_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z3: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z3 ) @ ( re @ Z3 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z3 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z3 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z3 ) @ ( re @ Z3 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_3974_ln__series,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X3 )
          = ( suminf @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X3 @ ( one_one @ real ) ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_3975_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_3976_complex__Im__fact,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_3977_complex__Im__of__int,axiom,
    ! [Z2: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_3978_Im__complex__of__real,axiom,
    ! [Z2: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z2 ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_3979_Im__power__real,axiom,
    ! [X3: complex,N: nat] :
      ( ( ( im @ X3 )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X3 @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_3980_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_3981_complex__Im__of__nat,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_3982_Im__i__times,axiom,
    ! [Z2: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z2 ) )
      = ( re @ Z2 ) ) ).

% Im_i_times
thf(fact_3983_Im__divide__of__real,axiom,
    ! [Z2: complex,R2: real] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( real_Vector_of_real @ complex @ R2 ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ R2 ) ) ).

% Im_divide_of_real
thf(fact_3984_Im__sgn,axiom,
    ! [Z2: complex] :
      ( ( im @ ( sgn_sgn @ complex @ Z2 ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% Im_sgn
thf(fact_3985_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_3986_Re__power__real,axiom,
    ! [X3: complex,N: nat] :
      ( ( ( im @ X3 )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X3 @ N ) )
        = ( power_power @ real @ ( re @ X3 ) @ N ) ) ) ).

% Re_power_real
thf(fact_3987_Re__i__times,axiom,
    ! [Z2: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z2 ) )
      = ( uminus_uminus @ real @ ( im @ Z2 ) ) ) ).

% Re_i_times
thf(fact_3988_Im__divide__numeral,axiom,
    ! [Z2: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_3989_Im__divide__of__nat,axiom,
    ! [Z2: complex,N: nat] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Im_divide_of_nat
thf(fact_3990_csqrt__of__real__nonneg,axiom,
    ! [X3: complex] :
      ( ( ( im @ X3 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X3 ) )
       => ( ( csqrt @ X3 )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X3 ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_3991_csqrt__minus,axiom,
    ! [X3: complex] :
      ( ( ( ord_less @ real @ ( im @ X3 ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X3 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X3 ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X3 ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X3 ) ) ) ) ).

% csqrt_minus
thf(fact_3992_csqrt__of__real__nonpos,axiom,
    ! [X3: complex] :
      ( ( ( im @ X3 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X3 ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X3 )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X3 ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_3993_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X3: A,Q: A > $o] :
      ( ( P @ X3 )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X3 ) ) ) ).

% rev_predicate1D
thf(fact_3994_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X3: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X3 )
       => ( Q @ X3 ) ) ) ).

% predicate1D
thf(fact_3995_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_3996_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_3997_complex__is__Int__iff,axiom,
    ! [Z2: complex] :
      ( ( member2 @ complex @ Z2 @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z2 )
          = ( zero_zero @ real ) )
        & ? [I2: int] :
            ( ( re @ Z2 )
            = ( ring_1_of_int @ real @ I2 ) ) ) ) ).

% complex_is_Int_iff
thf(fact_3998_abs__Im__le__cmod,axiom,
    ! [X3: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X3 ) ) ).

% abs_Im_le_cmod
thf(fact_3999_times__complex_Osimps_I2_J,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( im @ ( times_times @ complex @ X3 @ Y5 ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( im @ Y5 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( re @ Y5 ) ) ) ) ).

% times_complex.simps(2)
thf(fact_4000_Im__eq__0,axiom,
    ! [Z2: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z2 ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z2 ) )
     => ( ( im @ Z2 )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_4001_cmod__eq__Im,axiom,
    ! [Z2: complex] :
      ( ( ( re @ Z2 )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( abs_abs @ real @ ( im @ Z2 ) ) ) ) ).

% cmod_eq_Im
thf(fact_4002_cmod__eq__Re,axiom,
    ! [Z2: complex] :
      ( ( ( im @ Z2 )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( abs_abs @ real @ ( re @ Z2 ) ) ) ) ).

% cmod_eq_Re
thf(fact_4003_cmod__Im__le__iff,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( ( re @ X3 )
        = ( re @ Y5 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X3 ) @ ( real_V7770717601297561774m_norm @ complex @ Y5 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X3 ) ) @ ( abs_abs @ real @ ( im @ Y5 ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_4004_cmod__Re__le__iff,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( ( im @ X3 )
        = ( im @ Y5 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X3 ) @ ( real_V7770717601297561774m_norm @ complex @ Y5 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X3 ) ) @ ( abs_abs @ real @ ( re @ Y5 ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_4005_times__complex_Osimps_I1_J,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( re @ ( times_times @ complex @ X3 @ Y5 ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( im @ Y5 ) ) ) ) ).

% times_complex.simps(1)
thf(fact_4006_csqrt__principal,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) )
      | ( ( ( re @ ( csqrt @ Z2 ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z2 ) ) ) ) ) ).

% csqrt_principal
thf(fact_4007_cmod__le,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) ) ).

% cmod_le
thf(fact_4008_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A3: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A3 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A3 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_4009_Re__exp,axiom,
    ! [Z2: complex] :
      ( ( re @ ( exp @ complex @ Z2 ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z2 ) ) @ ( cos @ real @ ( im @ Z2 ) ) ) ) ).

% Re_exp
thf(fact_4010_Im__exp,axiom,
    ! [Z2: complex] :
      ( ( im @ ( exp @ complex @ Z2 ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z2 ) ) @ ( sin @ real @ ( im @ Z2 ) ) ) ) ).

% Im_exp
thf(fact_4011_complex__eq,axiom,
    ! [A3: complex] :
      ( A3
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A3 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A3 ) ) ) ) ) ).

% complex_eq
thf(fact_4012_fun__complex__eq,axiom,
    ! [A: $tType,F2: A > complex] :
      ( F2
      = ( ^ [X4: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F2 @ X4 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_4013_monoseq__realpow,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X3 ) ) ) ) ).

% monoseq_realpow
thf(fact_4014_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X4: complex,Y: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X4 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X4 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X4 ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X4 ) @ ( re @ Y ) ) ) ) ) ) ).

% times_complex.code
thf(fact_4015_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z3: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z3 ) ) ) @ ( cis @ ( im @ Z3 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_4016_cmod__power2,axiom,
    ! [Z2: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_4017_Im__power2,axiom,
    ! [X3: complex] :
      ( ( im @ ( power_power @ complex @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X3 ) ) @ ( im @ X3 ) ) ) ).

% Im_power2
thf(fact_4018_Re__power2,axiom,
    ! [X3: complex] :
      ( ( re @ ( power_power @ complex @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_4019_complex__eq__0,axiom,
    ! [Z2: complex] :
      ( ( Z2
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_4020_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z3: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_4021_inverse__complex_Osimps_I1_J,axiom,
    ! [X3: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X3 ) )
      = ( divide_divide @ real @ ( re @ X3 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_4022_complex__neq__0,axiom,
    ! [Z2: complex] :
      ( ( ( Z2
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_4023_Re__divide,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( re @ ( divide_divide @ complex @ X3 @ Y5 ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_4024_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_4025_csqrt__unique,axiom,
    ! [W: complex,Z2: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z2 )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z2 )
          = W ) ) ) ).

% csqrt_unique
thf(fact_4026_inverse__complex_Osimps_I2_J,axiom,
    ! [X3: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X3 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X3 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_4027_Im__divide,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( im @ ( divide_divide @ complex @ X3 @ Y5 ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X3 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( re @ X3 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_4028_complex__abs__le__norm,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% complex_abs_le_norm
thf(fact_4029_complex__unit__circle,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_4030_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X4: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X4 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X4 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_4031_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X4: complex,Y: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X4 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X4 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X4 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X4 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_4032_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K3: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_4033_csqrt_Osimps_I2_J,axiom,
    ! [Z2: complex] :
      ( ( im @ ( csqrt @ Z2 ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z2 )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z2 ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_4034_arctan__series,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( ( arctan @ X3 )
        = ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X3 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_4035_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_4036_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N2: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_4037_summable__arctan__series,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X3 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_4038_Im__Reals__divide,axiom,
    ! [R2: complex,Z2: complex] :
      ( ( member2 @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R2 @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R2 ) ) @ ( im @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_4039_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_4040_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N2: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_4041_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_4042_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_4043_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_4044_Re__divide__Reals,axiom,
    ! [R2: complex,Z2: complex] :
      ( ( member2 @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ Z2 @ R2 ) )
        = ( divide_divide @ real @ ( re @ Z2 ) @ ( re @ R2 ) ) ) ) ).

% Re_divide_Reals
thf(fact_4045_real__eq__imaginary__iff,axiom,
    ! [Y5: complex,X3: complex] :
      ( ( member2 @ complex @ Y5 @ ( real_Vector_Reals @ complex ) )
     => ( ( member2 @ complex @ X3 @ ( real_Vector_Reals @ complex ) )
       => ( ( X3
            = ( times_times @ complex @ imaginary_unit @ Y5 ) )
          = ( ( X3
              = ( zero_zero @ complex ) )
            & ( Y5
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_4046_imaginary__eq__real__iff,axiom,
    ! [Y5: complex,X3: complex] :
      ( ( member2 @ complex @ Y5 @ ( real_Vector_Reals @ complex ) )
     => ( ( member2 @ complex @ X3 @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y5 )
            = X3 )
          = ( ( X3
              = ( zero_zero @ complex ) )
            & ( Y5
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_4047_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_4048_Im__divide__Reals,axiom,
    ! [R2: complex,Z2: complex] :
      ( ( member2 @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ Z2 @ R2 ) )
        = ( divide_divide @ real @ ( im @ Z2 ) @ ( re @ R2 ) ) ) ) ).

% Im_divide_Reals
thf(fact_4049_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_4050_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N5: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_4051_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_4052_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( real_Vector_Reals @ A ) )
         => ( ( member2 @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member2 @ A @ ( times_times @ A @ A3 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_4053_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( real_Vector_Reals @ A ) )
         => ( ( member2 @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member2 @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_4054_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member2 @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_4055_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member2 @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_4056_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( member2 @ A @ A3 @ ( real_Vector_Reals @ A ) )
         => ( member2 @ A @ ( power_power @ A @ A3 @ N ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_4057_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( real_Vector_Reals @ A ) )
         => ( ( member2 @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member2 @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_4058_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_4059_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_4060_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_add
thf(fact_4061_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_4062_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_4063_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_4064_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) ) ) ) ).

% summable_mult
thf(fact_4065_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu3: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_4066_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_4067_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_4068_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_4069_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_4070_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N5: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member2 @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N5 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4071_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X3: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_4072_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N2: nat] :
                    ( ( F2 @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_4073_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_4074_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_4075_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_zero_power'
thf(fact_4076_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_0_powser
thf(fact_4077_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_4078_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_4079_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N2 @ M ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_4080_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_4081_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_4082_complex__is__Real__iff,axiom,
    ! [Z2: complex] :
      ( ( member2 @ complex @ Z2 @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z2 )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_4083_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( real_Vector_Reals @ A ) )
         => ( ( member2 @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member2 @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_4084_Complex__in__Reals,axiom,
    ! [X3: real] : ( member2 @ complex @ ( complex2 @ X3 @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_4085_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( real_Vector_Reals @ A ) )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( member2 @ A @ ( inverse_inverse @ A @ A3 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_4086_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) ) ) ) ).

% summable_rabs
thf(fact_4087_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_4088_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_4089_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_4090_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X3 ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_4091_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_4092_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) ) ) ).

% summable_norm
thf(fact_4093_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X3: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ) ).

% powser_inside
thf(fact_4094_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ).

% summable_exp
thf(fact_4095_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
                @ Z2 ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_4096_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
              @ Z2 )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_4097_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R2: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( ( summable @ A @ F2 )
           => ? [N9: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ N9 @ N7 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I2: nat] : ( F2 @ ( plus_plus @ nat @ I2 @ N7 ) ) ) )
                  @ R2 ) ) ) ) ) ).

% suminf_exist_split
thf(fact_4098_summable__power__series,axiom,
    ! [F2: nat > real,Z2: real] :
      ( ! [I3: nat] : ( ord_less_eq @ real @ ( F2 @ I3 ) @ ( one_one @ real ) )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I3 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z2 )
         => ( ( ord_less @ real @ Z2 @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( F2 @ I2 ) @ ( power_power @ real @ Z2 @ I2 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_4099_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R2: real,R0: real,A3: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R2 )
         => ( ( ord_less @ real @ R2 @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A3 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A3 @ N2 ) ) @ ( power_power @ real @ R2 @ N2 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_4100_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N5: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_4101_Re__Reals__divide,axiom,
    ! [R2: complex,Z2: complex] :
      ( ( member2 @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R2 @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R2 ) @ ( re @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_4102_sin__paired,axiom,
    ! [X3: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X3 @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X3 ) ) ).

% sin_paired
thf(fact_4103_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X3
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X3
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
                   => ( ( Xa = Mi )
                      | ( Xa = Ma2 ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X3
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) @ Xa ) )
                     => ( ( Xa = Mi )
                        | ( Xa = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X3
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_4104_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y5: $o] :
      ( ( ( vEBT_VEBT_membermima @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X3
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y5
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y5
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X3
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y5
                      = ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X3
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) )
                   => ( ( Y5
                        = ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) @ Xa ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X3
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                     => ( ( Y5
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_4105_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_4106_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N2: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_4107_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A3: nat > A,X3: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( A3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
            @ X3 )
          = ( ( A3 @ ( zero_zero @ nat ) )
            = X3 ) ) ) ).

% powser_sums_zero_iff
thf(fact_4108_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( sums @ A @ F2 @ S )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_4109_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( ! [N3: nat] :
              ( ( F2 @ N3 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F2 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_4110_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A3: A,C2: A] :
          ( ( sums @ A @ F2 @ A3 )
         => ( sums @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 )
            @ ( divide_divide @ A @ A3 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_4111_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A3: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A3 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_4112_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A3: A,C2: A] :
          ( ( sums @ A @ F2 @ A3 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 )
            @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_4113_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A3: A,C2: A] :
          ( ( sums @ A @ F2 @ A3 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
            @ ( times_times @ A @ C2 @ A3 ) ) ) ) ).

% sums_mult
thf(fact_4114_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F2 @ I ) ) ) ).

% sums_single
thf(fact_4115_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_4116_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_4117_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A3: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
            @ A3 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A3 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_4118_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
              @ S )
           => ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_Suc_imp
thf(fact_4119_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ L )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_4120_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_4121_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F2: nat > A,S: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ N )
             => ( ( F2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I2: nat] : ( F2 @ ( plus_plus @ nat @ I2 @ N ) )
              @ S )
            = ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_4122_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( if @ A @ ( N2 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z2 @ N2 ) )
          @ ( power_power @ A @ Z2 @ M ) ) ) ).

% powser_sums_if
thf(fact_4123_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A3: nat > A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( A3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
          @ ( A3 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_4124_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_4125_power__half__series,axiom,
    ( sums @ real
    @ ^ [N2: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N2 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_4126_sums__if_H,axiom,
    ! [G: nat > real,X3: real] :
      ( ( sums @ real @ G @ X3 )
     => ( sums @ real
        @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X3 ) ) ).

% sums_if'
thf(fact_4127_sums__if,axiom,
    ! [G: nat > real,X3: real,F2: nat > real,Y5: real] :
      ( ( sums @ real @ G @ X3 )
     => ( ( sums @ real @ F2 @ Y5 )
       => ( sums @ real
          @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( F2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X3 @ Y5 ) ) ) ) ).

% sums_if
thf(fact_4128_cos__paired,axiom,
    ! [X3: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ real @ X3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      @ ( cos @ real @ X3 ) ) ).

% cos_paired
thf(fact_4129_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [Mi: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X3
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa ) )
               => ~ ( ( Xa = Mi )
                    | ( Xa = Ma2 ) ) ) )
         => ( ! [Mi: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc ) @ Xa ) )
                 => ~ ( ( Xa = Mi )
                      | ( Xa = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X3
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_4130_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y5: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [A7: $o,B6: $o] :
              ( ( X3
                = ( vEBT_Leaf @ A7 @ B6 ) )
             => ( ( Y5
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A7 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A7 @ B6 ) @ Xa ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y5
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X3
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
                 => ( ( Y5
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_4131_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [A7: $o,B6: $o] :
              ( ( X3
                = ( vEBT_Leaf @ A7 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A7 @ B6 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A7 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_4132_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [A7: $o,B6: $o] :
              ( ( X3
                = ( vEBT_Leaf @ A7 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A7 @ B6 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A7 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X3
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_4133_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X3: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( C2 @ N2 ) ) @ ( power_power @ A @ X3 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_4134_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( C4 @ ( suc @ N2 ) ) ) ) ) ) ).

% diffs_def
thf(fact_4135_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X3: A] :
          ( ! [X2: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_4136_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 )
         => ( ! [X2: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K5 )
               => ( summable @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_4137_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X4: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X4 )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X4 @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_4138_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X9 @ M4 ) @ ( X9 @ N3 ) ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% monoI1
thf(fact_4139_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( X9 @ M4 ) ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% monoI2
thf(fact_4140_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X5: nat > A] :
              ( ! [M3: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N2 )
                 => ( ord_less_eq @ A @ ( X5 @ M3 ) @ ( X5 @ N2 ) ) )
              | ! [M3: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N2 )
                 => ( ord_less_eq @ A @ ( X5 @ N2 ) @ ( X5 @ M3 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_4141_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,X3: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A3 @ X3 )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) )
          = ( ( A3 = B2 )
            | ( X3
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_4142_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_4143_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X3: A,A3: real,Y5: A] :
          ( ( times_times @ A @ X3 @ ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) )
          = ( real_V8093663219630862766scaleR @ A @ A3 @ ( times_times @ A @ X3 @ Y5 ) ) ) ) ).

% mult_scaleR_right
thf(fact_4144_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A3: real,X3: A,Y5: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ Y5 )
          = ( real_V8093663219630862766scaleR @ A @ A3 @ ( times_times @ A @ X3 @ Y5 ) ) ) ) ).

% mult_scaleR_left
thf(fact_4145_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,X3: A,Y5: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A3 @ X3 )
            = ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) )
          = ( ( X3 = Y5 )
            | ( A3
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_4146_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,B2: real,X3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A3 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A3 @ B2 ) @ X3 ) ) ) ).

% scaleR_scaleR
thf(fact_4147_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X3 )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_4148_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,X3: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A3 @ X3 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ real ) )
            | ( X3
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_4149_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A3: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A3 ) )
            = ( plus_plus @ A @ A3 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A3 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_4150_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X3: real,Y5: A,N: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X3 @ Y5 ) @ N )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X3 @ N ) @ ( power_power @ A @ Y5 @ N ) ) ) ) ).

% scaleR_power
thf(fact_4151_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A3: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A3 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A3 ) )
          = A3 ) ) ).

% scaleR_collapse
thf(fact_4152_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: real,X3: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) )
          = ( times_times @ real @ ( abs_abs @ real @ A3 ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) ) ) ).

% norm_scaleR
thf(fact_4153_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A3 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A3 ) ) ) ).

% scaleR_times
thf(fact_4154_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A3 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A3 ) ) ) ).

% inverse_scaleR_times
thf(fact_4155_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A3 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A3 ) ) ) ).

% fraction_scaleR_times
thf(fact_4156_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = A3 ) ) ).

% scaleR_half_double
thf(fact_4157_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,X3: A,Y5: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A3 @ ( plus_plus @ A @ X3 @ Y5 ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) ) ) ) ).

% scaleR_right_distrib
thf(fact_4158_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A,A3: real,B2: real] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A3 @ X3 )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) )
           => ( A3 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_4159_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_4160_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,X3: A,Y5: A] :
          ( ( A3
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A3 @ X3 )
              = ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) )
           => ( X3 = Y5 ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_4161_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: real,B2: real,X3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A3 @ B2 ) @ X3 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) ) ) ) ).

% scaleR_left_distrib
thf(fact_4162_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: real,Y5: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X3 @ Y5 ) @ Xa )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X3 @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y5 @ Xa ) ) ) ) ).

% scaleR_left.add
thf(fact_4163_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_4164_scaleR__complex_Osimps_I1_J,axiom,
    ! [R2: real,X3: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R2 @ X3 ) )
      = ( times_times @ real @ R2 @ ( re @ X3 ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_4165_scaleR__complex_Osimps_I2_J,axiom,
    ! [R2: real,X3: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R2 @ X3 ) )
      = ( times_times @ real @ R2 @ ( im @ X3 ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_4166_complex__scaleR,axiom,
    ! [R2: real,A3: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R2 @ ( complex2 @ A3 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R2 @ A3 ) @ ( times_times @ real @ R2 @ B2 ) ) ) ).

% complex_scaleR
thf(fact_4167_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A3: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_4168_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: real,X3: A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_4169_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_4170_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_4171_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_4172_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A3: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_4173_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X3: A,Y5: A,A3: real] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_4174_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A,U: real,V: real,A3: A] :
          ( ( X3
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A3 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X3
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X3 )
                = ( real_V8093663219630862766scaleR @ A @ U @ A3 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_4175_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A3: A,X3: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A3 )
            = X3 )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X3
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A3 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X3 ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_4176_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A3 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_4177_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A3 ) @ E ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_4178_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A3 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A3
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_4179_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A3 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A3
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_4180_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: A] :
          ( ( ord_less_eq @ real @ A3 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_4181_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,X3: A] :
          ( ( ord_less_eq @ real @ A3 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_4182_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,X3: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
         => ( ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_4183_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,X3: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_4184_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A3 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_4185_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,X3: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
              & ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A3 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_4186_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_4187_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A3: real,B2: real,X3: A,Y5: A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y5 ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_4188_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X3: A,A3: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ real @ A3 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ X3 ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_4189_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X3 )
          = ( plus_plus @ A @ X3 @ X3 ) ) ) ).

% scaleR_2
thf(fact_4190_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X3: A,C2: A,Y5: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X3 ) @ C2 )
              = Y5 )
            = ( X3
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y5 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_4191_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y5: A,X3: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y5
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X3 ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y5 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X3 ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_4192_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A3 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_4193_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A3 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_4194_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_4195_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A3 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_4196_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A3 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_4197_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A3 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_4198_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_4199_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A3 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_4200_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A3: real,X3: A] :
          ( ( A3
           != ( zero_zero @ real ) )
         => ( ( X3
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A3 ) @ ( inverse_inverse @ A @ X3 ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_4201_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X4: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X4 ) ) @ ( times_times @ real @ R5 @ ( im @ X4 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_4202_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ).

% summable_exp_generic
thf(fact_4203_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X3 @ N2 ) )
          @ ( sin @ A @ X3 ) ) ) ).

% sin_converges
thf(fact_4204_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X4: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) ) ) ) ) ).

% sin_def
thf(fact_4205_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X3 @ N2 ) )
          @ ( cos @ A @ X3 ) ) ) ).

% cos_converges
thf(fact_4206_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X4: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) ) ) ) ) ).

% cos_def
thf(fact_4207_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_4208_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_4209_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_4210_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_4211_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_4212_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_4213_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_4214_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A3 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_4215_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A3: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_4216_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A3: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A3 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_4217_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) )
          @ ( exp @ A @ X3 ) ) ) ).

% exp_converges
thf(fact_4218_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X4: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X4 @ N2 ) ) ) ) ) ) ).

% exp_def
thf(fact_4219_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_4220_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ N2 ) ) )
          @ ( sin @ A @ X3 ) ) ) ).

% sin_minus_converges
thf(fact_4221_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ N2 ) )
          @ ( cos @ A @ X3 ) ) ) ).

% cos_minus_converges
thf(fact_4222_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_4223_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_4224_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X4: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N2 ) ) ) @ ( power_power @ A @ X4 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_4225_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X3 ) ) ) ).

% cosh_converges
thf(fact_4226_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) ) )
          @ ( sinh @ A @ X3 ) ) ) ).

% sinh_converges
thf(fact_4227_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( X9 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% mono_SucI1
thf(fact_4228_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ ( suc @ N3 ) ) @ ( X9 @ N3 ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% mono_SucI2
thf(fact_4229_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X5: nat > A] :
              ( ! [N2: nat] : ( ord_less_eq @ A @ ( X5 @ N2 ) @ ( X5 @ ( suc @ N2 ) ) )
              | ! [N2: nat] : ( ord_less_eq @ A @ ( X5 @ ( suc @ N2 ) ) @ ( X5 @ N2 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_4230_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I2: A] : ( plus_plus @ A @ I2 @ ( one_one @ A ) )
              @ N2
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_4231_Arg__def,axiom,
    ( arg
    = ( ^ [Z3: complex] :
          ( if @ real
          @ ( Z3
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A5: real] :
                ( ( ( sgn_sgn @ complex @ Z3 )
                  = ( cis @ A5 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A5 )
                & ( ord_less_eq @ real @ A5 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4232_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_4233_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) ) @ ( power_power @ A @ X3 @ N2 ) ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ P6 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( sin @ A @ X3 ) @ ( sin @ A @ Y5 ) ) ) ) ).

% sin_x_sin_y
thf(fact_4234_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member2 @ A @ I @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I @ K ) ) ) ).

% atMost_iff
thf(fact_4235_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ B )
     => ! [A2: set @ A,F2: A > B] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ A2 )
             => ( member2 @ B @ ( F2 @ X2 ) @ ( ring_1_Ints @ B ) ) )
         => ( member2 @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A2 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_sum
thf(fact_4236_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F2: B > nat,A2: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A2 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X4: B] : ( semiring_1_of_nat @ A @ ( F2 @ X4 ) )
            @ A2 ) ) ) ).

% of_nat_sum
thf(fact_4237_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: B > int,A2: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F2 @ A2 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X4: B] : ( ring_1_of_int @ A @ ( F2 @ X4 ) )
            @ A2 ) ) ) ).

% of_int_sum
thf(fact_4238_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X3 ) @ ( set_ord_atMost @ A @ Y5 ) )
          = ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% atMost_subset_iff
thf(fact_4239_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_4240_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I2: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I2 ) )
            @ A2 ) ) ) ).

% norm_sum
thf(fact_4241_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,G: B > real] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) @ ( G @ X2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S2 ) ) ) ) ).

% sum_norm_le
thf(fact_4242_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A3: A,A2: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I2: B] : ( modulo_modulo @ A @ ( F2 @ I2 ) @ A3 )
              @ A2 )
            @ A3 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ A3 ) ) ) ).

% mod_sum_eq
thf(fact_4243_verit__sko__ex_H,axiom,
    ! [A: $tType,P: A > $o,A2: $o] :
      ( ( ( P @ ( fChoice @ A @ P ) )
        = A2 )
     => ( ( ? [X5: A] : ( P @ X5 ) )
        = A2 ) ) ).

% verit_sko_ex'
thf(fact_4244_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P4: A > $o] :
          ! [X7: A] : ( P4 @ X7 ) )
      = ( ^ [P2: A > $o] :
            ( P2
            @ ( fChoice @ A
              @ ^ [X4: A] :
                  ~ ( P2 @ X4 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_4245_verit__sko__forall_H,axiom,
    ! [A: $tType,P: A > $o,A2: $o] :
      ( ( ( P
          @ ( fChoice @ A
            @ ^ [X4: A] :
                ~ ( P @ X4 ) ) )
        = A2 )
     => ( ( ! [X5: A] : ( P @ X5 ) )
        = A2 ) ) ).

% verit_sko_forall'
thf(fact_4246_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B3: A,A2: A,P: A > $o] :
      ( ( B3 = A2 )
     => ( ( ( fChoice @ A @ P )
          = A2 )
        = ( ( fChoice @ A @ P )
          = B3 ) ) ) ).

% verit_sko_forall''
thf(fact_4247_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X3: A,P: A > $o] :
      ( ( X3
        = ( fChoice @ A @ P ) )
     => ( ( ? [X5: A] : ( P @ X5 ) )
        = ( P @ X3 ) ) ) ).

% verit_sko_ex_indirect
thf(fact_4248_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X3: A,P: A > $o,P5: A > $o] :
      ( ( X3
        = ( fChoice @ A @ P ) )
     => ( ! [X2: A] :
            ( ( P @ X2 )
            = ( P5 @ X2 ) )
       => ( ( ? [X5: A] : ( P5 @ X5 ) )
          = ( P @ X3 ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_4249_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X3: A,P: A > $o] :
      ( ( X3
        = ( fChoice @ A
          @ ^ [X4: A] :
              ~ ( P @ X4 ) ) )
     => ( ( ! [X5: A] : ( P @ X5 ) )
        = ( P @ X3 ) ) ) ).

% verit_sko_forall_indirect
thf(fact_4250_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X3: A,P: A > $o,P5: A > $o] :
      ( ( X3
        = ( fChoice @ A
          @ ^ [X4: A] :
              ~ ( P @ X4 ) ) )
     => ( ! [X2: A] :
            ( ( P @ X2 )
            = ( P5 @ X2 ) )
       => ( ( ! [X5: A] : ( P5 @ X5 ) )
          = ( P @ X3 ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_4251_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_4252_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ I2 ) @ ( F2 @ ( suc @ I2 ) ) )
            @ ( set_ord_atMost @ nat @ I ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I ) ) ) ) ) ).

% sum_telescope
thf(fact_4253_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X4: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ X4 @ I2 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( D2 @ I2 ) @ ( power_power @ A @ X4 @ I2 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ N )
               => ( ( C2 @ I2 )
                  = ( D2 @ I2 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_4254_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A3: nat > A,B3: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A3 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A3 @ ( set_ord_atMost @ nat @ N3 ) ) @ B3 )
           => ( summable @ A @ A3 ) ) ) ) ).

% bounded_imp_summable
thf(fact_4255_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X4: A] : ( ord_less_eq @ A @ X4 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_4256_sum__choose__lower,axiom,
    ! [R2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ ( plus_plus @ nat @ R2 @ K3 ) @ K3 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R2 @ N ) ) @ N ) ) ).

% sum_choose_lower
thf(fact_4257_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J4: nat] : ( binomial @ ( plus_plus @ nat @ N @ J4 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_4258_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J4: nat] : ( binomial @ ( plus_plus @ nat @ N @ J4 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_4259_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W3: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ W3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_4260_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X4: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ X4 @ I2 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ N )
               => ( ( C2 @ I2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_4261_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ K3 ) ) @ K3 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_4262_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K3: nat] : ( binomial @ ( minus_minus @ nat @ N @ K3 ) @ ( minus_minus @ nat @ M @ K3 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_4263_vandermonde,axiom,
    ! [M: nat,N: nat,R2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( binomial @ M @ K3 ) @ ( binomial @ N @ ( minus_minus @ nat @ R2 @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ R2 ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N ) @ R2 ) ) ).

% vandermonde
thf(fact_4264_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_4265_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_4266_binomial,axiom,
    ! [A3: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A3 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K3 ) ) @ ( power_power @ nat @ A3 @ K3 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_4267_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A3: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A3 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( summable @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I2 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_4268_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A3: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A3 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A3 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I2 ) ) )
                    @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_4269_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_4270_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A3: nat > A,N: nat,B2: nat > A,X3: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ M @ I3 )
             => ( ( A3 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( power_power @ A @ X3 @ I2 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J4: nat] : ( times_times @ A @ ( B2 @ J4 ) @ ( power_power @ A @ X3 @ J4 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K3: nat] : ( times_times @ A @ ( A3 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X3 @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_4271_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A3 @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_4272_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K3 ) ) @ ( power_power @ A @ A3 @ K3 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_4273_polynomial__product__nat,axiom,
    ! [M: nat,A3: nat > nat,N: nat,B2: nat > nat,X3: nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ M @ I3 )
         => ( ( A3 @ I3 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I2: nat] : ( times_times @ nat @ ( A3 @ I2 ) @ ( power_power @ nat @ X3 @ I2 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J4: nat] : ( times_times @ nat @ ( B2 @ J4 ) @ ( power_power @ nat @ X3 @ J4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K3: nat] : ( times_times @ nat @ ( A3 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X3 @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_4274_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( power_power @ nat @ ( binomial @ N @ K3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_4275_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ A3 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_4276_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A3: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A3 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( sums @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I2 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) )
              @ ( times_times @ A @ ( suminf @ A @ A3 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_4277_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_4278_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) ).

% of_nat_aux.simps(1)
thf(fact_4279_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,M: nat,I5: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( power_power @ A @ X3 @ ( plus_plus @ nat @ M @ I2 ) )
            @ I5 )
          = ( times_times @ A @ ( power_power @ A @ X3 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ I5 ) ) ) ) ).

% sum_power_add
thf(fact_4280_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P3: nat,K: nat,G: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P3 )
         => ( ( ord_less_eq @ nat @ K @ P3 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( if @ A @ ( J4 = K ) @ ( zero_zero @ A ) @ ( H @ ( minus_minus @ nat @ J4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P3 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( H @ J4 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_4281_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A3: A,X3: A,Y5: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A3 ) @ K3 ) @ ( power_power @ A @ X3 @ K3 ) ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A3 ) @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_4282_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X3: A,Y5: A,N: nat] :
          ( ( ( times_times @ A @ X3 @ Y5 )
            = ( times_times @ A @ Y5 @ X3 ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I2 ) ) @ ( power_power @ A @ X3 @ I2 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I2 ) ) ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ N @ I2 ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_4283_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z2: A,A3: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z2 @ N )
              = A3 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I2
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A3 )
                      @ ( if @ A @ ( I2 = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z2 @ I2 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_4284_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( ( X3
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X3
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ).

% sum_gp0
thf(fact_4285_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_4286_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K3 ) ) @ K3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_4287_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A3: A,X3: A,Y5: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A3 ) @ K3 ) @ ( power_power @ A @ X3 @ K3 ) ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A3 ) @ ( one_one @ A ) ) @ K3 ) @ ( power_power @ A @ X3 @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_4288_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_4289_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I2: nat] : ( times_times @ nat @ I2 @ ( binomial @ N @ I2 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_4290_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_4291_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ? [M10: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M10 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z4 @ I2 ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_4292_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_4293_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_4294_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_4295_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A3 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A3 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_4296_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_4297_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_4298_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X3 @ N2 ) ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ P6 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( cos @ A @ X3 ) @ ( cos @ A @ Y5 ) ) ) ) ).

% cos_x_cos_y
thf(fact_4299_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,Y5: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X3 @ N2 ) ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ P6 @ N2 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X3 @ Y5 ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_4300_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A2: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] : ( abs_abs @ B @ ( F2 @ I2 ) )
            @ A2 ) ) ) ).

% sum_abs_ge_zero
thf(fact_4301_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A2: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A2 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] : ( abs_abs @ B @ ( F2 @ I2 ) )
            @ A2 ) ) ) ).

% sum_abs
thf(fact_4302_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,X3: A > B,A3: A > B,B2: B,Delta: B] :
          ( ! [I3: A] :
              ( ( member2 @ A @ I3 @ I5 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X3 @ I3 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X3 @ I5 )
              = ( one_one @ B ) )
           => ( ! [I3: A] :
                  ( ( member2 @ A @ I3 @ I5 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A3 @ I3 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I2: A] : ( times_times @ B @ ( A3 @ I2 ) @ ( X3 @ I2 ) )
                      @ I5 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_4303_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu3: B] : ( zero_zero @ A )
            @ A2 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_4304_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N2: nat] : N2 ) ) ).

% of_nat_id
thf(fact_4305_int__sum,axiom,
    ! [B: $tType,F2: B > nat,A2: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A2 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X4: B] : ( semiring_1_of_nat @ int @ ( F2 @ X4 ) )
        @ A2 ) ) ).

% int_sum
thf(fact_4306_Complex__sum_H,axiom,
    ! [A: $tType,F2: A > real,S: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X4: A] : ( complex2 @ ( F2 @ X4 ) @ ( zero_zero @ real ) )
        @ S )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F2 @ S ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_4307_sum__subtractf__nat,axiom,
    ! [A: $tType,A2: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
         => ( ord_less_eq @ nat @ ( G @ X2 ) @ ( F2 @ X2 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X4: A] : ( minus_minus @ nat @ ( F2 @ X4 ) @ ( G @ X4 ) )
          @ A2 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A2 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_4308_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A2: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 )
        = ( suc @ N ) )
     => ? [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X2 ) ) ) ) ).

% sum_SucD
thf(fact_4309_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X4: complex] : X4
          @ ( collect @ complex
            @ ^ [Z3: complex] :
                ( ( power_power @ complex @ Z3 @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_4310_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X4: complex] : X4
          @ ( collect @ complex
            @ ^ [Z3: complex] :
                ( ( power_power @ complex @ Z3 @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_4311_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A2: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
           != ( zero_zero @ A ) )
         => ~ ! [A7: B] :
                ( ( member2 @ B @ A7 @ A2 )
               => ( ( G @ A7 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_4312_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ( G @ X2 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_4313_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_4314_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R2: A,F2: B > A,A2: set @ B] :
          ( ( times_times @ A @ R2 @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ R2 @ ( F2 @ N2 ) )
            @ A2 ) ) ) ).

% sum_distrib_left
thf(fact_4315_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A2: set @ B,R2: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ R2 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ ( F2 @ N2 ) @ R2 )
            @ A2 ) ) ) ).

% sum_distrib_right
thf(fact_4316_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A2: set @ A,G: C > B,B3: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B3 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J4: C] : ( times_times @ B @ ( F2 @ I2 ) @ ( G @ J4 ) )
                @ B3 )
            @ A2 ) ) ) ).

% sum_product
thf(fact_4317_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H: B > A,A2: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X4: B] : ( plus_plus @ A @ ( G @ X4 ) @ ( H @ X4 ) )
            @ A2 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H @ A2 ) ) ) ) ).

% sum.distrib
thf(fact_4318_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A2: set @ B,R2: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ R2 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( divide_divide @ A @ ( F2 @ N2 ) @ R2 )
            @ A2 ) ) ) ).

% sum_divide_distrib
thf(fact_4319_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_4320_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) ) ) ) ).

% sum_nonneg
thf(fact_4321_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ nat,F2: nat > A,G: nat > A] :
          ( ~ ( member2 @ nat @ ( zero_zero @ nat ) @ A2 )
         => ( ! [X2: nat] :
                ( ( member2 @ nat @ ( suc @ X2 ) @ A2 )
               => ( ( F2 @ ( suc @ X2 ) )
                  = ( G @ ( suc @ X2 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A2 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_4322_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X3 @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X3 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_4323_Maclaurin__cos__expansion2,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X3 )
            & ( ( cos @ real @ X3 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_4324_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X3 )
            & ( ( sin @ real @ X3 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_4325_Maclaurin__sin__expansion4,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X3 )
          & ( ( sin @ real @ X3 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_4326_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member2 @ A @ I @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I @ K ) ) ) ).

% lessThan_iff
thf(fact_4327_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X3 ) @ ( set_ord_lessThan @ A @ Y5 ) )
          = ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% lessThan_subset_iff
thf(fact_4328_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_4329_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M3 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_4330_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X4: A] : ( ord_less @ A @ X4 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_4331_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N ) )
          = ( ord_less @ A @ M @ N ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_4332_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A3 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_4333_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X2: A] : ( ord_less_eq @ nat @ ( Q @ X2 ) @ ( P @ X2 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X4: A] : ( minus_minus @ nat @ ( P @ X4 ) @ ( Q @ X4 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_4334_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X3: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X3 )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X3 ) ) ) ) ).

% suminf_le_const
thf(fact_4335_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N: nat,R2: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ I2 ) @ R2 )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_4336_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_4337_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_4338_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_4339_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X3: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X3 )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_4340_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I2: nat] : ( F2 @ ( plus_plus @ nat @ I2 @ N ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_4341_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I2: nat] : ( F2 @ ( plus_plus @ nat @ I2 @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) )
          = ( sums @ A @ F2 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_4342_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A,N: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( sums @ A
            @ ^ [I2: nat] : ( F2 @ ( plus_plus @ nat @ I2 @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_4343_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X3 @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_4344_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_4345_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,N: nat] :
          ( ( X3
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X3 @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X3 @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_4346_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_4347_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_4348_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_4349_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_4350_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( ( X3
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X3
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_4351_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z2: A,H: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z2 @ P6 ) ) @ ( power_power @ A @ Z2 @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ Z2 @ P6 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ M @ P6 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_4352_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat,Y5: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X3 @ ( suc @ N ) ) @ ( power_power @ A @ Y5 @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X3 @ Y5 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X3 @ P6 ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ N @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_4353_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat,Y5: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X3 @ N ) @ ( power_power @ A @ Y5 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X3 @ Y5 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) ) @ ( power_power @ A @ X3 @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_4354_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A3: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ A3 @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B6: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z4 @ I2 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A3 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I2: nat] : ( times_times @ A @ ( B6 @ I2 ) @ ( power_power @ A @ Z4 @ I2 ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_4355_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A3: A] :
        ? [B6: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z4 @ I2 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A3 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( B6 @ I2 ) @ ( power_power @ A @ Z4 @ I2 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ A3 @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_4356_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_4357_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_4358_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( power_power @ A @ X3 @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_4359_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X3: real,N: nat,Diff: nat > A > real] :
          ( ( X3
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X3 @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_4360_Maclaurin__lemma,axiom,
    ! [H: real,F2: real > real,J3: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ? [B9: real] :
          ( ( F2 @ H )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J3 @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_4361_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) @ ( F2 @ I2 ) @ ( G @ I2 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I2: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum_split_even_odd
thf(fact_4362_Maclaurin__exp__le,axiom,
    ! [X3: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
      & ( ( exp @ real @ X3 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X3 @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_4363_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A3: nat > A,X3: A,Y5: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( power_power @ A @ X3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( power_power @ A @ Y5 @ I2 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X3 @ Y5 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( A3 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J4 @ K3 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y5 @ K3 ) ) @ ( power_power @ A @ X3 @ J4 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J4 ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_4364_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X4: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X4 @ N2 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ K ) ) ) @ ( power_power @ A @ X4 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_4365_Maclaurin__sin__bound,axiom,
    ! [X3: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X3 )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X3 ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_4366_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D3: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D3 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D3 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_4367_Maclaurin__exp__lt,axiom,
    ! [X3: real,N: nat] :
      ( ( X3
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
            & ( ( exp @ real @ X3 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X3 @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_4368_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H: A,Z2: A,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ N ) @ ( power_power @ A @ Z2 @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P6: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H ) @ Q4 ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P6 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_4369_Maclaurin__sin__expansion,axiom,
    ! [X3: real,N: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X3 )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_4370_Maclaurin__sin__expansion2,axiom,
    ! [X3: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
      & ( ( sin @ real @ X3 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_4371_Maclaurin__cos__expansion,axiom,
    ! [X3: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
      & ( ( cos @ real @ X3 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X3 @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_4372_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K3: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K3 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z3: complex] :
              ( ( power_power @ complex @ Z3 @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4373_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X3: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X3
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X3
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X3 @ M ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_4374_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ R2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R2 @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_4375_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_4376_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H: A,L4: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H )
            = ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) )
          = ( ( ( L = L4 )
              & ( H = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H )
              & ~ ( ord_less_eq @ A @ L4 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_4377_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member2 @ A @ I @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_4378_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_4379_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H )
            | ( ord_less_eq @ A @ H @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_4380_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_4381_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H: A,L4: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H ) @ ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) ) ) ).

% not_Iic_le_Icc
thf(fact_4382_ex__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X4: nat] :
            ( ( member2 @ nat @ X4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X4 ) ) ) ) ).

% ex_nat_less
thf(fact_4383_all__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X4: nat] :
            ( ( member2 @ nat @ X4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X4 ) ) ) ) ).

% all_nat_less
thf(fact_4384_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_4385_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_4386_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A3 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A3 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A3 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_4387_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_4388_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_4389_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_4390_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_4391_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_4392_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_4393_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_4394_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_4395_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A3: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A3 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( plus_plus @ A @ ( F2 @ A5 ) )
            @ A3
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_4396_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A,P3: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P3 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P3 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_4397_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_4398_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_4399_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_4400_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X3: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X3 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_4401_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ~ ! [N9: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ M2 )
                     => ! [N7: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N7 ) ) ) @ E ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_4402_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X3: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X3 @ M ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_4403_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_4404_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X4: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ X4 @ I2 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X4: nat] :
                ( ( member2 @ nat @ X4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_4405_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J4: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J4 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_4406_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_4407_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I2 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_4408_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_4409_arith__series__nat,axiom,
    ! [A3: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I2: nat] : ( plus_plus @ nat @ A3 @ ( times_times @ nat @ I2 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_4410_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_4411_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I2 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_4412_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_4413_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_4414_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X3: A,M: nat,N: nat] :
          ( ( ( X3
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X3
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X3 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X3 @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X3 @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_4415_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A3: nat > A,X3: A,Y5: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( power_power @ A @ X3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( power_power @ A @ Y5 @ I2 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X3 @ Y5 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J4: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I2: nat] : ( times_times @ A @ ( A3 @ I2 ) @ ( power_power @ A @ Y5 @ ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J4 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
                    @ ( power_power @ A @ X3 @ J4 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_4416_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_4417_vebt__buildup_Opelims,axiom,
    ! [X3: nat,Y5: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X3 )
        = Y5 )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X3 )
       => ( ( ( X3
              = ( zero_zero @ nat ) )
           => ( ( Y5
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X3
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y5
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X3
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y5
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y5
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_4418_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_4419_arctan__def,axiom,
    ( arctan
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X4: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
              & ( ord_less @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X4 )
                = Y ) ) ) ) ) ).

% arctan_def
thf(fact_4420_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( ring_1 @ B ) )
     => ! [A2: set @ A,F2: A > B] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ A2 )
             => ( member2 @ B @ ( F2 @ X2 ) @ ( ring_1_Ints @ B ) ) )
         => ( member2 @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A2 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_prod
thf(fact_4421_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > nat,A2: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A2 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : ( semiring_1_of_nat @ A @ ( F2 @ X4 ) )
            @ A2 ) ) ) ).

% of_nat_prod
thf(fact_4422_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F2: B > int,A2: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F2 @ A2 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : ( ring_1_of_int @ A @ ( F2 @ X4 ) )
            @ A2 ) ) ) ).

% of_int_prod
thf(fact_4423_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_4424_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_4425_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_4426_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_4427_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H: B > A,A2: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : ( times_times @ A @ ( G @ X4 ) @ ( H @ X4 ) )
            @ A2 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ H @ A2 ) ) ) ) ).

% prod.distrib
thf(fact_4428_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A2: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ A2 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) ) ) ) ).

% prod_dividef
thf(fact_4429_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A2: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A2 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N )
            @ A2 ) ) ) ).

% prod_power_distrib
thf(fact_4430_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A2: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A5: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A5 ) )
            @ A2 ) ) ) ).

% norm_prod_le
thf(fact_4431_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A3: A,A2: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I2: B] : ( modulo_modulo @ A @ ( F2 @ I2 ) @ A3 )
              @ A2 )
            @ A3 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ A3 ) ) ) ).

% mod_prod_eq
thf(fact_4432_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) ) ) ) ).

% prod_nonneg
thf(fact_4433_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: set @ B,F2: B > A,G: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) ) ) ) ).

% prod_mono
thf(fact_4434_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) ) ) ) ).

% prod_pos
thf(fact_4435_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) ) ) ) ).

% prod_ge_1
thf(fact_4436_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A2: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A2 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A5: B] : ( power_power @ A @ C2 @ ( F2 @ A5 ) )
            @ A2 ) ) ) ).

% power_sum
thf(fact_4437_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_4438_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) )
                & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_4439_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_4440_ln__neg__is__const,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X3 )
        = ( the @ real
          @ ^ [X4: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_4441_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_4442_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_4443_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_4444_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_4445_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_4446_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_4447_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_4448_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X4: nat] : X4
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod
thf(fact_4449_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A3: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A3 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( times_times @ A @ ( F2 @ A5 ) )
            @ A3
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_4450_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A,P3: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P3 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P3 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_4451_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X2: int,K2: int] :
            ( ( P @ X2 )
            = ( P @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ( ? [X5: int] : ( P @ X5 ) )
          = ( ? [X4: int] :
                ( ( member2 @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X4 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_4452_bset_I3_J,axiom,
    ! [D4: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X = T2 )
             => ( ( minus_minus @ int @ X @ D4 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_4453_bset_I4_J,axiom,
    ! [D4: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ T2 @ B3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X != T2 )
             => ( ( minus_minus @ int @ X @ D4 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_4454_bset_I5_J,axiom,
    ! [D4: int,B3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ B3 )
                 => ( X
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less @ int @ X @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X @ D4 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_4455_bset_I7_J,axiom,
    ! [D4: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ T2 @ B3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X @ D4 ) ) ) ) ) ) ).

% bset(7)
thf(fact_4456_aset_I3_J,axiom,
    ! [D4: int,T2: int,A2: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A2 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ A2 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X = T2 )
             => ( ( plus_plus @ int @ X @ D4 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_4457_aset_I4_J,axiom,
    ! [D4: int,T2: int,A2: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ T2 @ A2 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ A2 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( X != T2 )
             => ( ( plus_plus @ int @ X @ D4 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_4458_aset_I5_J,axiom,
    ! [D4: int,T2: int,A2: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ T2 @ A2 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ A2 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less @ int @ X @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X @ D4 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_4459_aset_I7_J,axiom,
    ! [D4: int,A2: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ A2 )
                 => ( X
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X @ D4 ) ) ) ) ) ).

% aset(7)
thf(fact_4460_norm__prod__diff,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I5: set @ I6,Z2: I6 > A,W: I6 > A] :
          ( ! [I3: I6] :
              ( ( member2 @ I6 @ I3 @ I5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z2 @ I3 ) ) @ ( one_one @ real ) ) )
         => ( ! [I3: I6] :
                ( ( member2 @ I6 @ I3 @ I5 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I3 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I6 @ A @ Z2 @ I5 ) @ ( groups7121269368397514597t_prod @ I6 @ A @ W @ I5 ) ) )
              @ ( groups7311177749621191930dd_sum @ I6 @ real
                @ ^ [I2: I6] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z2 @ I2 ) @ ( W @ I2 ) ) )
                @ I5 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_4461_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_4462_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X4: nat] : X4
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_4463_bset_I6_J,axiom,
    ! [D4: int,B3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ B3 )
                 => ( X
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less_eq @ int @ X @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X @ D4 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_4464_bset_I8_J,axiom,
    ! [D4: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B3 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X @ D4 ) ) ) ) ) ) ).

% bset(8)
thf(fact_4465_aset_I6_J,axiom,
    ! [D4: int,T2: int,A2: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ( member2 @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A2 )
       => ! [X: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ A2 )
                   => ( X
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( ord_less_eq @ int @ X @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X @ D4 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_4466_aset_I8_J,axiom,
    ! [D4: int,A2: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ! [X: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ A2 )
                 => ( X
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X @ D4 ) ) ) ) ) ).

% aset(8)
thf(fact_4467_cppi,axiom,
    ! [D4: int,P: int > $o,P5: int > $o,A2: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ? [Z4: int] :
          ! [X2: int] :
            ( ( ord_less @ int @ Z4 @ X2 )
           => ( ( P @ X2 )
              = ( P5 @ X2 ) ) )
       => ( ! [X2: int] :
              ( ! [Xa3: int] :
                  ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                 => ! [Xb3: int] :
                      ( ( member2 @ int @ Xb3 @ A2 )
                     => ( X2
                       != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
             => ( ( P @ X2 )
               => ( P @ ( plus_plus @ int @ X2 @ D4 ) ) ) )
         => ( ! [X2: int,K2: int] :
                ( ( P5 @ X2 )
                = ( P5 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D4 ) ) ) )
           => ( ( ? [X5: int] : ( P @ X5 ) )
              = ( ? [X4: int] :
                    ( ( member2 @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ( P5 @ X4 ) )
                | ? [X4: int] :
                    ( ( member2 @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ? [Y: int] :
                        ( ( member2 @ int @ Y @ A2 )
                        & ( P @ ( minus_minus @ int @ Y @ X4 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_4468_cpmi,axiom,
    ! [D4: int,P: int > $o,P5: int > $o,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D4 )
     => ( ? [Z4: int] :
          ! [X2: int] :
            ( ( ord_less @ int @ X2 @ Z4 )
           => ( ( P @ X2 )
              = ( P5 @ X2 ) ) )
       => ( ! [X2: int] :
              ( ! [Xa3: int] :
                  ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                 => ! [Xb3: int] :
                      ( ( member2 @ int @ Xb3 @ B3 )
                     => ( X2
                       != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
             => ( ( P @ X2 )
               => ( P @ ( minus_minus @ int @ X2 @ D4 ) ) ) )
         => ( ! [X2: int,K2: int] :
                ( ( P5 @ X2 )
                = ( P5 @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K2 @ D4 ) ) ) )
           => ( ( ? [X5: int] : ( P @ X5 ) )
              = ( ? [X4: int] :
                    ( ( member2 @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ( P5 @ X4 ) )
                | ? [X4: int] :
                    ( ( member2 @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D4 ) )
                    & ? [Y: int] :
                        ( ( member2 @ int @ Y @ B3 )
                        & ( P @ ( plus_plus @ int @ Y @ X4 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_4469_arccos__def,axiom,
    ( arccos
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
              & ( ord_less_eq @ real @ X4 @ pi )
              & ( ( cos @ real @ X4 )
                = Y ) ) ) ) ) ).

% arccos_def
thf(fact_4470_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_4471_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I2 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_4472_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X4: nat] : X4
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_4473_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_4474_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_4475_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I2 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_4476_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P3: nat,K: nat,G: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P3 )
         => ( ( ord_less_eq @ nat @ K @ P3 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( if @ A @ ( J4 = K ) @ ( one_one @ A ) @ ( H @ ( minus_minus @ nat @ J4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P3 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J4: nat] : ( if @ A @ ( ord_less @ nat @ J4 @ K ) @ ( G @ J4 ) @ ( H @ J4 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_4477_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ A3 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_4478_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L3: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L3 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L3 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_4479_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L3: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L3 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L3 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_4480_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
          & ( ord_less_eq @ real @ X4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X4 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_4481_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
            & ( ord_less_eq @ real @ X4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X4 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_4482_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X4: int] : X4
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_4483_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L3: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L3 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L3 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_4484_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X4: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
              & ( ord_less_eq @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X4 )
                = Y ) ) ) ) ) ).

% arcsin_def
thf(fact_4485_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N2: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N2
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N2 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_4486_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_4487_pred__subset__eq,axiom,
    ! [A: $tType,R4: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X4: A] : ( member2 @ A @ X4 @ R4 )
        @ ^ [X4: A] : ( member2 @ A @ X4 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R4 @ S2 ) ) ).

% pred_subset_eq
thf(fact_4488_VEBT__internal_Oelim__dead_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( vEBT_Node @ Info @ Deg
        @ ( map @ vEBT_VEBT @ vEBT_VEBT
          @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          @ TreeList2 )
        @ ( vEBT_VEBT_elim_dead @ Summary @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% VEBT_internal.elim_dead.simps(2)
thf(fact_4489_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4 )
      = ( ^ [Xs2: list @ A] : Xs2 ) ) ).

% map_ident
thf(fact_4490_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,G: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ G @ Xs ) )
      = ( ! [X4: B] :
            ( ( member2 @ B @ X4 @ ( set2 @ B @ Xs ) )
           => ( ( F2 @ X4 )
              = ( G @ X4 ) ) ) ) ) ).

% map_eq_conv
thf(fact_4491_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_4492_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N: nat,X3: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N @ X3 ) )
      = ( replicate @ A @ N @ ( F2 @ X3 ) ) ) ).

% map_replicate
thf(fact_4493_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N )
        = ( F2 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% nth_map
thf(fact_4494_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J4: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ J4 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_4495_int__prod,axiom,
    ! [B: $tType,F2: B > nat,A2: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A2 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X4: B] : ( semiring_1_of_nat @ int @ ( F2 @ X4 ) )
        @ A2 ) ) ).

% int_prod
thf(fact_4496_list_Omap__ident,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4
        @ T2 )
      = T2 ) ).

% list.map_ident
thf(fact_4497_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs: list @ B,G: C > A,Ys2: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ C @ A @ G @ Ys2 ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys2 ) ) ) ).

% map_eq_imp_length_eq
thf(fact_4498_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) ) ) ).

% map_concat
thf(fact_4499_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys2: list @ B,F2: A > B] :
      ( ( ? [Xs2: list @ A] :
            ( Ys2
            = ( map @ A @ B @ F2 @ Xs2 ) ) )
      = ( ! [X4: B] :
            ( ( member2 @ B @ X4 @ ( set2 @ B @ Ys2 ) )
           => ? [Y: A] :
                ( X4
                = ( F2 @ Y ) ) ) ) ) ).

% ex_map_conv
thf(fact_4500_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ A,F2: A > B,G: A > B] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( F2 @ X2 )
              = ( G @ X2 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ G @ Ys2 ) ) ) ) ).

% map_cong
thf(fact_4501_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > A] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X2 )
            = X2 ) )
     => ( ( map @ A @ A @ F2 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_4502_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B,G: A > B] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X2 )
            = ( G @ X2 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs )
        = ( map @ A @ B @ G @ Xs ) ) ) ).

% map_ext
thf(fact_4503_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X3: list @ A,Xa: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z5: A,Za: A] :
          ( ( member2 @ A @ Z5 @ ( set2 @ A @ X3 ) )
         => ( ( member2 @ A @ Za @ ( set2 @ A @ Xa ) )
           => ( ( ( F2 @ Z5 )
                = ( Fa @ Za ) )
             => ( Z5 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X3 )
          = ( map @ A @ B @ Fa @ Xa ) )
       => ( X3 = Xa ) ) ) ).

% list.inj_map_strong
thf(fact_4504_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X3: list @ A,F2: A > B,G: A > B] :
      ( ! [Z5: A] :
          ( ( member2 @ A @ Z5 @ ( set2 @ A @ X3 ) )
         => ( ( F2 @ Z5 )
            = ( G @ Z5 ) ) )
     => ( ( map @ A @ B @ F2 @ X3 )
        = ( map @ A @ B @ G @ X3 ) ) ) ).

% list.map_cong0
thf(fact_4505_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X3: list @ A,Ya: list @ A,F2: A > B,G: A > B] :
      ( ( X3 = Ya )
     => ( ! [Z5: A] :
            ( ( member2 @ A @ Z5 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z5 )
              = ( G @ Z5 ) ) )
       => ( ( map @ A @ B @ F2 @ X3 )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_4506_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J4: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J4 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_4507_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X4: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_4508_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J4: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ J4 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_4509_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I2: nat,J4: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J4 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( G @ I2 @ ( minus_minus @ nat @ K3 @ I2 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_4510_prod__int__plus__eq,axiom,
    ! [I: nat,J3: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ ( plus_plus @ nat @ I @ J3 ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X4: int] : X4
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I @ J3 ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_4511_subrelI,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X2: A,Y2: B] :
          ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R2 )
         => ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S ) ) ).

% subrelI
thf(fact_4512_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X4: A,Y: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ R4 )
        @ ^ [X4: A,Y: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R4 @ S2 ) ) ).

% pred_subset_eq2
thf(fact_4513_length__n__lists__elem,axiom,
    ! [A: $tType,Ys2: list @ A,N: nat,Xs: list @ A] :
      ( ( member2 @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys2 )
        = N ) ) ).

% length_n_lists_elem
thf(fact_4514_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N2: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M3 @ N2 ) @ ( modulo_modulo @ nat @ M3 @ N2 ) ) ) ) ).

% divmod_nat_def
thf(fact_4515_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M3: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_4516_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_n_lists
thf(fact_4517_VEBT__internal_Oelim__dead_Oelims,axiom,
    ! [X3: vEBT_VEBT,Xa: extended_enat,Y5: vEBT_VEBT] :
      ( ( ( vEBT_VEBT_elim_dead @ X3 @ Xa )
        = Y5 )
     => ( ! [A7: $o,B6: $o] :
            ( ( X3
              = ( vEBT_Leaf @ A7 @ B6 ) )
           => ( Y5
             != ( vEBT_Leaf @ A7 @ B6 ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X3
                = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( Xa
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( Y5
                 != ( vEBT_Node @ Info2 @ Deg2
                    @ ( map @ vEBT_VEBT @ vEBT_VEBT
                      @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      @ TreeList3 )
                    @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) )
         => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) )
               => ! [L2: nat] :
                    ( ( Xa
                      = ( extended_enat2 @ L2 ) )
                   => ( Y5
                     != ( vEBT_Node @ Info2 @ Deg2
                        @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                          @ ( map @ vEBT_VEBT @ vEBT_VEBT
                            @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            @ TreeList3 ) )
                        @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extended_enat2 @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.elims
thf(fact_4518_VEBT__internal_Oelim__dead_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,L: nat] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ ( extended_enat2 @ L ) )
      = ( vEBT_Node @ Info @ Deg
        @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( map @ vEBT_VEBT @ vEBT_VEBT
            @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ TreeList2 ) )
        @ ( vEBT_VEBT_elim_dead @ Summary @ ( extended_enat2 @ ( divide_divide @ nat @ L @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.simps(3)
thf(fact_4519_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X2: A,Y2: B] :
          ( ( P @ X2 @ Y2 )
         => ( Q @ X2 @ Y2 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_4520_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( take @ A @ N @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_4521_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% take_all_iff
thf(fact_4522_nth__take,axiom,
    ! [A: $tType,I: nat,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( nth @ A @ ( take @ A @ N @ Xs ) @ I )
        = ( nth @ A @ Xs @ I ) ) ) ).

% nth_take
thf(fact_4523_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs2: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X4: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 ) @ Ys3 )
              @ Xs2 ) ) ) ) ).

% product_concat_map
thf(fact_4524_take__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( take @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( take @ B @ N @ Xs ) ) ) ).

% take_map
thf(fact_4525_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X3: A,Y5: B,Q: A > B > $o] :
      ( ( P @ X3 @ Y5 )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X3 @ Y5 ) ) ) ).

% rev_predicate2D
thf(fact_4526_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X3: A,Y5: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X3 @ Y5 )
       => ( Q @ X3 @ Y5 ) ) ) ).

% predicate2D
thf(fact_4527_in__set__takeD,axiom,
    ! [A: $tType,X3: A,N: nat,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) )
     => ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% in_set_takeD
thf(fact_4528_take__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ! [I3: nat] :
          ( ( take @ A @ I3 @ Xs )
          = ( take @ A @ I3 @ Ys2 ) )
     => ( Xs = Ys2 ) ) ).

% take_equalityI
thf(fact_4529_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_take_subset
thf(fact_4530_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_4531_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys2 ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ K )
             => ( ( nth @ A @ Xs @ I3 )
                = ( nth @ A @ Ys2 @ I3 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys2 ) ) ) ) ) ).

% nth_take_lemma
thf(fact_4532_VEBT__internal_Oelim__dead_Opelims,axiom,
    ! [X3: vEBT_VEBT,Xa: extended_enat,Y5: vEBT_VEBT] :
      ( ( ( vEBT_VEBT_elim_dead @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ X3 @ Xa ) )
       => ( ! [A7: $o,B6: $o] :
              ( ( X3
                = ( vEBT_Leaf @ A7 @ B6 ) )
             => ( ( Y5
                  = ( vEBT_Leaf @ A7 @ B6 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Leaf @ A7 @ B6 ) @ Xa ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( Xa
                    = ( extend4730790105801354508finity @ extended_enat ) )
                 => ( ( Y5
                      = ( vEBT_Node @ Info2 @ Deg2
                        @ ( map @ vEBT_VEBT @ vEBT_VEBT
                          @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          @ TreeList3 )
                        @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extend4730790105801354508finity @ extended_enat ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) )
           => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                  ( ( X3
                    = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) )
                 => ! [L2: nat] :
                      ( ( Xa
                        = ( extended_enat2 @ L2 ) )
                     => ( ( Y5
                          = ( vEBT_Node @ Info2 @ Deg2
                            @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                              @ ( map @ vEBT_VEBT @ vEBT_VEBT
                                @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                @ TreeList3 ) )
                            @ ( vEBT_VEBT_elim_dead @ Summary2 @ ( extended_enat2 @ ( divide_divide @ nat @ L2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary2 ) @ ( extended_enat2 @ L2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.pelims
thf(fact_4533_accp__subset,axiom,
    ! [A: $tType,R1: A > A > $o,R22: A > A > $o] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R1 @ R22 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R22 ) @ ( accp @ A @ R1 ) ) ) ).

% accp_subset
thf(fact_4534_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A2: A > B > $o,B3: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A2 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B3 ) ) ) ) ).

% Collect_case_prod_mono
thf(fact_4535_complex__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_4536_complex__cnj__mult,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( cnj @ ( times_times @ complex @ X3 @ Y5 ) )
      = ( times_times @ complex @ ( cnj @ X3 ) @ ( cnj @ Y5 ) ) ) ).

% complex_cnj_mult
thf(fact_4537_complex__cnj__divide,axiom,
    ! [X3: complex,Y5: complex] :
      ( ( cnj @ ( divide_divide @ complex @ X3 @ Y5 ) )
      = ( divide_divide @ complex @ ( cnj @ X3 ) @ ( cnj @ Y5 ) ) ) ).

% complex_cnj_divide
thf(fact_4538_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_4539_complex__cnj__zero__iff,axiom,
    ! [Z2: complex] :
      ( ( ( cnj @ Z2 )
        = ( zero_zero @ complex ) )
      = ( Z2
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_4540_complex__cnj__power,axiom,
    ! [X3: complex,N: nat] :
      ( ( cnj @ ( power_power @ complex @ X3 @ N ) )
      = ( power_power @ complex @ ( cnj @ X3 ) @ N ) ) ).

% complex_cnj_power
thf(fact_4541_complex__cnj__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( numeral_numeral @ complex @ W ) )
      = ( numeral_numeral @ complex @ W ) ) ).

% complex_cnj_numeral
thf(fact_4542_complex__cnj__neg__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_cnj_neg_numeral
thf(fact_4543_complex__In__mult__cnj__zero,axiom,
    ! [Z2: complex] :
      ( ( im @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_4544_Re__complex__div__eq__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A3 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_4545_Im__complex__div__eq__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A3 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_4546_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z3: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z3 @ ( cnj @ Z3 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_4547_Re__complex__div__gt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A3 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_4548_Re__complex__div__lt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A3 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_4549_Re__complex__div__ge__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A3 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_4550_Re__complex__div__le__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A3 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_4551_Im__complex__div__gt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A3 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_4552_Im__complex__div__lt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A3 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_4553_Im__complex__div__ge__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A3 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_4554_Im__complex__div__le__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A3 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_4555_complex__mod__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_4556_complex__div__gt__0,axiom,
    ! [A3: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A3 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A3 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A3 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_4557_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_4558_complex__norm__square,axiom,
    ! [Z2: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) ) ).

% complex_norm_square
thf(fact_4559_complex__add__cnj,axiom,
    ! [Z2: complex] :
      ( ( plus_plus @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z2 ) ) ) ) ).

% complex_add_cnj
thf(fact_4560_complex__diff__cnj,axiom,
    ! [Z2: complex] :
      ( ( minus_minus @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z2 ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_4561_accp__subset__induct,axiom,
    ! [A: $tType,D4: A > $o,R4: A > A > $o,X3: A,P: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ D4 @ ( accp @ A @ R4 ) )
     => ( ! [X2: A,Z5: A] :
            ( ( D4 @ X2 )
           => ( ( R4 @ Z5 @ X2 )
             => ( D4 @ Z5 ) ) )
       => ( ( D4 @ X3 )
         => ( ! [X2: A] :
                ( ( D4 @ X2 )
               => ( ! [Z4: A] :
                      ( ( R4 @ Z4 @ X2 )
                     => ( P @ Z4 ) )
                 => ( P @ X2 ) ) )
           => ( P @ X3 ) ) ) ) ) ).

% accp_subset_induct
thf(fact_4562_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A5: complex,B4: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A5 @ ( cnj @ B4 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_4563_cnj__add__mult__eq__Re,axiom,
    ! [Z2: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z2 ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z2 @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_4564_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys2 ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X4: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 ) @ Ys2 )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_4565_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A3: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A3 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A3 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A3 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A3 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A3 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A3 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_4566_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X3: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y5: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X3 @ Xa @ Xb @ Xc )
        = Y5 )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X3 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb @ Xa )
               => ( Y5 = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb @ Xa )
               => ( Y5
                  = ( set_fo6178422350223883121st_nat @ A @ X3 @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X3 @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X3 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_4567_in__measure,axiom,
    ! [A: $tType,X3: A,Y5: A,F2: A > nat] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ).

% in_measure
thf(fact_4568_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A1: nat,A22: nat,A33: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A1 @ ( product_Pair @ nat @ A @ A22 @ A33 ) ) ) )
     => ( ! [F5: nat > A > A,A7: nat,B6: nat,Acc3: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F5 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A7 @ ( product_Pair @ nat @ A @ B6 @ Acc3 ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B6 @ A7 )
               => ( P @ F5 @ ( plus_plus @ nat @ A7 @ ( one_one @ nat ) ) @ B6 @ ( F5 @ A7 @ Acc3 ) ) )
             => ( P @ F5 @ A7 @ B6 @ Acc3 ) ) )
       => ( P @ A0 @ A1 @ A22 @ A33 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_4569_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D5: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z3: int] :
                ( ( ord_less_eq @ int @ D5 @ Z3 )
                & ( ord_less @ int @ Z7 @ Z3 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_4570_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D5: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z3: int] :
                ( ( ord_less_eq @ int @ D5 @ Z7 )
                & ( ord_less @ int @ Z7 @ Z3 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_4571_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I3: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I3 @ J2 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I3 @ J2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_4572_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4573_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4574_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A3 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_4575_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4576_length__upt,axiom,
    ! [I: nat,J3: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I @ J3 ) )
      = ( minus_minus @ nat @ J3 @ I ) ) ).

% length_upt
thf(fact_4577_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member2 @ A @ I @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4578_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,J3: A,M: A,N: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ J3 ) @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
          = ( ( ord_less_eq @ A @ J3 @ I )
            | ( ( ord_less_eq @ A @ M @ I )
              & ( ord_less_eq @ A @ J3 @ N ) ) ) ) ) ).

% ivl_subset
thf(fact_4579_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,N: A,M: A] :
          ( ( ord_less_eq @ A @ I @ N )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ M ) @ ( set_or7035219750837199246ssThan @ A @ I @ N ) )
            = ( set_or7035219750837199246ssThan @ A @ N @ M ) ) ) ) ).

% ivl_diff
thf(fact_4580_nth__upt,axiom,
    ! [I: nat,K: nat,J3: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J3 )
     => ( ( nth @ nat @ ( upt @ I @ J3 ) @ K )
        = ( plus_plus @ nat @ I @ K ) ) ) ).

% nth_upt
thf(fact_4581_take__upt,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ M ) @ N )
     => ( ( take @ nat @ M @ ( upt @ I @ N ) )
        = ( upt @ I @ ( plus_plus @ nat @ I @ M ) ) ) ) ).

% take_upt
thf(fact_4582_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4583_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4584_map__Suc__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_4585_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4586_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A3 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4587_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A3 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4588_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I2: nat,J4: nat] : ( set2 @ nat @ ( upt @ I2 @ J4 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_4589_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
            | ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4590_ex__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X4: nat] :
            ( ( member2 @ nat @ X4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X4 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4591_all__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X4: nat] :
            ( ( member2 @ nat @ X4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X4 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4592_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_4593_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ N2 @ ( suc @ M3 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_4594_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast_upt
thf(fact_4595_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I2: nat] : ( plus_plus @ nat @ I2 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_4596_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4597_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( plus_plus @ nat @ I2 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4598_map__replicate__trivial,axiom,
    ! [A: $tType,X3: A,I: nat] :
      ( ( map @ nat @ A
        @ ^ [I2: nat] : X3
        @ ( upt @ ( zero_zero @ nat ) @ I ) )
      = ( replicate @ A @ I @ X3 ) ) ).

% map_replicate_trivial
thf(fact_4599_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A3: B,C2: B,B2: B,D2: B,G: B > A,H: B > A] :
          ( ( A3 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X2: B] :
                  ( ( ord_less_eq @ B @ C2 @ X2 )
                 => ( ( ord_less @ B @ X2 @ D2 )
                   => ( ( G @ X2 )
                      = ( H @ X2 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A3 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4600_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A3: B,C2: B,B2: B,D2: B,G: B > A,H: B > A] :
          ( ( A3 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X2: B] :
                  ( ( ord_less_eq @ B @ C2 @ X2 )
                 => ( ( ord_less @ B @ X2 @ D2 )
                   => ( ( G @ X2 )
                      = ( H @ X2 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A3 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4601_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P3: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P3 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P3 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P3 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4602_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,P3: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P3 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P3 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P3 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4603_size__list__estimation,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: nat,F2: A > nat] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y5 @ ( F2 @ X3 ) )
       => ( ord_less @ nat @ Y5 @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_4604_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_4605_size__list__estimation_H,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: nat,F2: A > nat] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y5 @ ( F2 @ X3 ) )
       => ( ord_less_eq @ nat @ Y5 @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_4606_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P3: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P3 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P3 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P3 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4607_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ) ) ) ).

% atMost_upto
thf(fact_4608_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_4609_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_4610_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4611_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4612_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_4613_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4614_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4615_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A3 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4616_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4617_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4618_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A3 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4619_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4620_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4621_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N ) ) @ I )
        = ( F2 @ ( plus_plus @ nat @ M @ I ) ) ) ) ).

% nth_map_upt
thf(fact_4622_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4623_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I2 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4624_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A3 @ I2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J4: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( A3 @ I2 @ J4 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_4625_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I2 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4626_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A3 @ I2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J4: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( A3 @ I2 @ J4 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J4 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_4627_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4628_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4629_prod__Suc__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_Suc_fact
thf(fact_4630_prod__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_fact
thf(fact_4631_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4632_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4633_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I3 )
              = ( F2 @ ( plus_plus @ nat @ M @ I3 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_4634_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_4635_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4636_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4637_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ I2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4638_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_4639_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M3 )
                 => ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4640_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_4641_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( bit_se4730199178511100633sh_bit @ A @ K3 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ K3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% take_bit_sum
thf(fact_4642_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4643_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4644_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K3 @ I2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4645_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4646_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4647_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K3: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ I2 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) )
              @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4648_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs2: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs2 @ N2 ) ) @ ( power_power @ A @ A5 @ N2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4649_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4650_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A3: nat > A,B2: nat > A] :
          ( ! [I3: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I3 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N )
               => ( ord_less_eq @ A @ ( A3 @ I3 ) @ ( A3 @ J2 ) ) ) )
         => ( ! [I3: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I3 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K3: nat] : ( times_times @ A @ ( A3 @ K3 ) @ ( B2 @ K3 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4651_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A3: nat > nat,B2: nat > nat] :
      ( ! [I3: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I3 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N )
           => ( ord_less_eq @ nat @ ( A3 @ I3 ) @ ( A3 @ J2 ) ) ) )
     => ( ! [I3: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I3 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I3 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I2: nat] : ( times_times @ nat @ ( A3 @ I2 ) @ ( B2 @ I2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4652_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_4653_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_4654_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_4655_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L3: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L3 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L3 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4656_case__nat__add__eq__if,axiom,
    ! [A: $tType,A3: A,F2: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A3 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_4657_case__nat__numeral,axiom,
    ! [A: $tType,A3: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A3 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_4658_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K3: code_integer] :
          ( if @ code_integer
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4659_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_4660_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_4661_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_4662_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_4663_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H @ F1 )
        @ ^ [X4: nat] : ( H @ ( F22 @ X4 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_4664_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_4665_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( uminus_uminus @ code_integer @ L ) ) ).

% minus_integer_code(2)
thf(fact_4666_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_4667_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M3: num,N2: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N2 ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N2 ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_4668_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_4669_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_4670_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_4671_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_4672_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_4673_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_4674_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_4675_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_4676_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(1)
thf(fact_4677_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(2)
thf(fact_4678_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X4: A,F3: nat > A,N2: nat] :
            ( if @ A
            @ ( N2
              = ( zero_zero @ nat ) )
            @ X4
            @ ( F3 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_4679_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K3: int] :
          ( if @ code_integer @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K3 ) ) )
          @ ( if @ code_integer
            @ ( K3
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4680_Code__Numeral_Opositive__def,axiom,
    ( code_positive
    = ( numeral_numeral @ code_integer ) ) ).

% Code_Numeral.positive_def
thf(fact_4681_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_4682_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K3: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K3 ) @ K3 ) ) ) ).

% abs_integer_code
thf(fact_4683_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_4684_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X3 ) )
      = ( ord_less @ int @ Xa @ X3 ) ) ).

% less_integer.abs_eq
thf(fact_4685_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_4686_unset__bit__integer_Oabs__eq,axiom,
    ! [Xa: nat,X3: int] :
      ( ( bit_se2638667681897837118et_bit @ code_integer @ Xa @ ( code_integer_of_int @ X3 ) )
      = ( code_integer_of_int @ ( bit_se2638667681897837118et_bit @ int @ Xa @ X3 ) ) ) ).

% unset_bit_integer.abs_eq
thf(fact_4687_divide__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X3 ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa @ X3 ) ) ) ).

% divide_integer.abs_eq
thf(fact_4688_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_4689_times__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X3 ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa @ X3 ) ) ) ).

% times_integer.abs_eq
thf(fact_4690_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X3: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X3 ) )
      = ( ord_less_eq @ int @ Xa @ X3 ) ) ).

% less_eq_integer.abs_eq
thf(fact_4691_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_4692_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_4693_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K3 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_4694_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L3: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K3 @ L3 ) @ ( modulo_modulo @ code_integer @ K3 @ L3 ) ) ) ) ).

% divmod_integer_def
thf(fact_4695_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A3: A,F2: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A3 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A3 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_4696_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_4697_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_4698_rec__nat__numeral,axiom,
    ! [A: $tType,A3: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A3 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A3 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_4699_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X4: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X4 ) ) ) ) ).

% old.rec_nat_def
thf(fact_4700_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S4: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S4 ) )
                @ ( S4
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_4701_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_4702_divmod__abs__code_I6_J,axiom,
    ! [J3: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J3 )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_4703_subset__Collect__iff,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member2 @ A @ X4 @ A2 )
                & ( P @ X4 ) ) ) )
        = ( ! [X4: A] :
              ( ( member2 @ A @ X4 @ B3 )
             => ( P @ X4 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_4704_subset__CollectI,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ B3 )
           => ( ( Q @ X2 )
             => ( P @ X2 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member2 @ A @ X4 @ B3 )
                & ( Q @ X4 ) ) )
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member2 @ A @ X4 @ A2 )
                & ( P @ X4 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_4705_divmod__abs__code_I5_J,axiom,
    ! [J3: code_integer] :
      ( ( code_divmod_abs @ J3 @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J3 ) ) ) ).

% divmod_abs_code(5)
thf(fact_4706_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X4: real] :
          ( the @ int
          @ ^ [Z3: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z3 ) @ X4 )
              & ( ord_less @ real @ X4 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_4707_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K3: code_integer,L3: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L3 ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L3 ) ) ) ) ) ).

% divmod_abs_def
thf(fact_4708_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L3 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ ( code_divmod_abs @ K3 @ L3 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S4: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S4
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L3 @ S4 ) ) )
                @ ( code_divmod_abs @ K3 @ L3 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L3
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K3 @ L3 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S4: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S4
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L3 ) @ S4 ) ) )
                    @ ( code_divmod_abs @ K3 @ L3 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_4709_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X4: rat] :
          ( the @ int
          @ ^ [Z3: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z3 ) @ X4 )
              & ( ord_less @ rat @ X4 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_4710_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L3: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_4711_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) ) ) ).

% or.right_idem
thf(fact_4712_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A3 @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) ) ) ).

% or.left_idem
thf(fact_4713_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A3 @ A3 )
          = A3 ) ) ).

% or.idem
thf(fact_4714_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% or.left_neutral
thf(fact_4715_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% or.right_neutral
thf(fact_4716_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_4717_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4718_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_4719_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X3 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_4720_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4721_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4722_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X3 @ Y5 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4723_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X3 @ Y5 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4724_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y5: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) ) ) ).

% or_numerals(2)
thf(fact_4725_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X3 ) ) ) ) ).

% or_numerals(8)
thf(fact_4726_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) @ X3 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4727_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X3 @ ( bit_ri4277139882892585799ns_not @ A @ X3 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4728_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ).

% or_numerals(3)
thf(fact_4729_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X3 ) ) ) ) ).

% or_numerals(5)
thf(fact_4730_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y5: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) ) ) ).

% or_numerals(1)
thf(fact_4731_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_4732_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_4733_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4734_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4735_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_4736_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y5 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_4737_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X3: num,Y5: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X3 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y5 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X3 ) @ ( numeral_numeral @ A @ Y5 ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_4738_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A5: rat] :
          ( if @ rat
          @ ( A5
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A5 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_4739_obtain__pos__sum,axiom,
    ! [R2: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R2
                 != ( plus_plus @ rat @ S3 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_4740_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X4: rat,Y: rat] :
          ( ( ord_less @ rat @ X4 @ Y )
          | ( X4 = Y ) ) ) ) ).

% less_eq_rat_def
thf(fact_4741_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X3 @ ( zero_zero @ A ) )
          = X3 ) ) ).

% bit.disj_zero_right
thf(fact_4742_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4743_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_4744_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A3 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A3 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_4745_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A5: A,B4: A] : ( bit_se1065995026697491101ons_or @ A @ B4 @ A5 ) ) ) ) ).

% or.commute
thf(fact_4746_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A3 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_4747_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_or_iff
thf(fact_4748_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X3 @ ( bit_se1065995026697491101ons_or @ A @ Y5 @ Z2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X3 @ Y5 ) @ ( bit_se5824344872417868541ns_and @ A @ X3 @ Z2 ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_4749_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X3 @ ( bit_se5824344872417868541ns_and @ A @ Y5 @ Z2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X3 @ Y5 ) @ ( bit_se1065995026697491101ons_or @ A @ X3 @ Z2 ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_4750_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y5: A,Z2: A,X3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y5 @ Z2 ) @ X3 )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y5 @ X3 ) @ ( bit_se5824344872417868541ns_and @ A @ Z2 @ X3 ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_4751_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y5: A,Z2: A,X3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y5 @ Z2 ) @ X3 )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y5 @ X3 ) @ ( bit_se1065995026697491101ons_or @ A @ Z2 @ X3 ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_4752_bit__or__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        | ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_or_int_iff
thf(fact_4753_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_or_eq
thf(fact_4754_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A5: rat] : ( if @ rat @ ( ord_less @ rat @ A5 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A5 ) @ A5 ) ) ) ).

% abs_rat_def
thf(fact_4755_OR__lower,axiom,
    ! [X3: int,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X3 @ Y5 ) ) ) ) ).

% OR_lower
thf(fact_4756_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_4757_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4758_plus__and__or,axiom,
    ! [X3: int,Y5: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X3 @ Y5 ) @ ( bit_se1065995026697491101ons_or @ int @ X3 @ Y5 ) )
      = ( plus_plus @ int @ X3 @ Y5 ) ) ).

% plus_and_or
thf(fact_4759_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A5: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4760_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A5: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4761_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L3: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ ( bit_ri4277139882892585799ns_not @ int @ L3 ) ) ) ) ) ).

% or_int_def
thf(fact_4762_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4763_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X4: A,Y: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X4 @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X4 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4764_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X4: A,Y: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X4 @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X4 ) @ Y ) ) ) ) ) ).

% bit.xor_def
thf(fact_4765_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4766_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L3: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ L3 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ L3 ) ) ) ) ).

% xor_int_def
thf(fact_4767_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K3: int,L3: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L3 ) ) ) ) ).

% concat_bit_def
thf(fact_4768_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( bit_se1065995026697491101ons_or @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4769_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4770_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,X3: A,Y5: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ X3 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ X3 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ Y5 )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ Y5 )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X3 = Y5 ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4771_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4772_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4773_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X3 @ Y5 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X3 @ Y5 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X3 )
              = Y5 ) ) ) ) ).

% bit.compl_unique
thf(fact_4774_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4775_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4776_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A3 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4777_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_4778_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4779_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A3 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% or_one_eq
thf(fact_4780_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A3 )
          = ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% one_or_eq
thf(fact_4781_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4782_OR__upper,axiom,
    ! [X3: int,N: nat,Y5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ( ord_less @ int @ X3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y5 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X3 @ Y5 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_4783_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4784_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A5 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4785_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4786_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4787_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4788_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4789_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L3: int] :
          ( if @ int
          @ ( ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ int ) )
            @ L3
            @ ( if @ int
              @ ( L3
                = ( zero_zero @ int ) )
              @ K3
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4790_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_4791_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_4792_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X3 ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X3 ) ) ) ).

% max_0_1(4)
thf(fact_4793_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( numeral_numeral @ A @ X3 ) ) ) ).

% max_0_1(3)
thf(fact_4794_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_4795_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_4796_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X3 ) ) ) ).

% max_0_1(6)
thf(fact_4797_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( numeral_numeral @ A @ X3 ) ) ) ).

% max_0_1(5)
thf(fact_4798_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_4799_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_4800_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_4801_or__nat__numerals_I2_J,axiom,
    ! [Y5: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y5 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y5 ) ) ) ).

% or_nat_numerals(2)
thf(fact_4802_or__nat__numerals_I4_J,axiom,
    ! [X3: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X3 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X3 ) ) ) ).

% or_nat_numerals(4)
thf(fact_4803_or__nat__numerals_I1_J,axiom,
    ! [Y5: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y5 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y5 ) ) ) ).

% or_nat_numerals(1)
thf(fact_4804_or__nat__numerals_I3_J,axiom,
    ! [X3: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X3 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X3 ) ) ) ).

% or_nat_numerals(3)
thf(fact_4805_or__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4806_or__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4807_or__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4808_or__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4809_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def_raw
thf(fact_4810_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: int,Y5: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X3 @ Y5 ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X3 ) @ ( ring_1_of_int @ A @ Y5 ) ) ) ) ).

% of_int_max
thf(fact_4811_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def
thf(fact_4812_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( ord_max @ A @ X3 @ Y5 )
            = X3 ) ) ) ).

% max_absorb1
thf(fact_4813_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_max @ A @ X3 @ Y5 )
            = Y5 ) ) ) ).

% max_absorb2
thf(fact_4814_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( plus_plus @ A @ X3 @ ( ord_max @ A @ Y5 @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( plus_plus @ A @ X3 @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_4815_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X3 @ Y5 ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X3 @ Z2 ) @ ( plus_plus @ A @ Y5 @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_4816_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X3 @ Y5 ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X3 @ Z2 ) @ ( minus_minus @ A @ Y5 @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_4817_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4818_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: nat,Y5: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X3 @ Y5 ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X3 ) @ ( semiring_1_of_nat @ A @ Y5 ) ) ) ) ).

% of_nat_max
thf(fact_4819_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4820_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4821_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4822_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4823_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4824_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4825_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4826_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% or_nat_def
thf(fact_4827_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4828_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_4829_or__not__num__neg_Oelims,axiom,
    ! [X3: num,Xa: num,Y5: num] :
      ( ( ( bit_or_not_num_neg @ X3 @ Xa )
        = Y5 )
     => ( ( ( X3 = one2 )
         => ( ( Xa = one2 )
           => ( Y5 != one2 ) ) )
       => ( ( ( X3 = one2 )
           => ! [M4: num] :
                ( ( Xa
                  = ( bit0 @ M4 ) )
               => ( Y5
                 != ( bit1 @ M4 ) ) ) )
         => ( ( ( X3 = one2 )
             => ! [M4: num] :
                  ( ( Xa
                    = ( bit1 @ M4 ) )
                 => ( Y5
                   != ( bit1 @ M4 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X3
                    = ( bit0 @ N3 ) )
               => ( ( Xa = one2 )
                 => ( Y5
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X3
                      = ( bit0 @ N3 ) )
                   => ! [M4: num] :
                        ( ( Xa
                          = ( bit0 @ M4 ) )
                       => ( Y5
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X3
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa
                            = ( bit1 @ M4 ) )
                         => ( Y5
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X3
                          = ( bit1 @ N3 ) )
                     => ( ( Xa = one2 )
                       => ( Y5 != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X3
                            = ( bit1 @ N3 ) )
                         => ! [M4: num] :
                              ( ( Xa
                                = ( bit0 @ M4 ) )
                             => ( Y5
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X3
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa
                                  = ( bit1 @ M4 ) )
                               => ( Y5
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_4830_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4831_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4832_numeral__or__not__num__eq,axiom,
    ! [M: num,N: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4833_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4834_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4835_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4836_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X3 @ Y5 ) @ Z2 )
          = ( ( ord_less @ A @ X3 @ Z2 )
            & ( ord_less @ A @ Y5 @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_4837_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_4838_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% max.absorb3
thf(fact_4839_max__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% max_enat_simps(4)
thf(fact_4840_max__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% max_enat_simps(5)
thf(fact_4841_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_4842_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_4843_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% max.absorb1
thf(fact_4844_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_4845_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% max.bounded_iff
thf(fact_4846_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_4847_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_4848_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_4849_max__nat_Oright__neutral,axiom,
    ! [A3: nat] :
      ( ( ord_max @ nat @ A3 @ ( zero_zero @ nat ) )
      = A3 ) ).

% max_nat.right_neutral
thf(fact_4850_max__nat_Oneutr__eq__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A3 @ B2 ) )
      = ( ( A3
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_4851_max__nat_Oleft__neutral,axiom,
    ! [A3: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A3 )
      = A3 ) ).

% max_nat.left_neutral
thf(fact_4852_max__nat_Oeq__neutr__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A3 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_4853_max__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_enat_simps(1)
thf(fact_4854_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_4855_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_4856_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_4857_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_4858_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_4859_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q2 ) @ ( plus_plus @ nat @ N @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_4860_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_4861_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ N @ M6 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_4862_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ M6 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_4863_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_4864_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_4865_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% max.absorb_iff2
thf(fact_4866_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% max.absorb_iff1
thf(fact_4867_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X3 @ Y5 ) )
          = ( ( ord_less_eq @ A @ Z2 @ X3 )
            | ( ord_less_eq @ A @ Z2 @ Y5 ) ) ) ) ).

% le_max_iff_disj
thf(fact_4868_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_4869_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ A3 @ ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_4870_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( ord_max @ A @ A5 @ B4 ) ) ) ) ) ).

% max.order_iff
thf(fact_4871_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% max.boundedI
thf(fact_4872_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% max.boundedE
thf(fact_4873_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( ord_max @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% max.orderI
thf(fact_4874_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( A3
            = ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_4875_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_4876_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X3 @ Y5 ) )
          = ( ( ord_less @ A @ Z2 @ X3 )
            | ( ord_less @ A @ Z2 @ Y5 ) ) ) ) ).

% less_max_iff_disj
thf(fact_4877_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less @ A @ B2 @ A3 )
             => ~ ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% max.strict_boundedE
thf(fact_4878_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( ord_max @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_4879_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A3 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_4880_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_4881_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4882_or__not__num__neg_Opelims,axiom,
    ! [X3: num,Xa: num,Y5: num] :
      ( ( ( bit_or_not_num_neg @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X3 @ Xa ) )
       => ( ( ( X3 = one2 )
           => ( ( Xa = one2 )
             => ( ( Y5 = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X3 = one2 )
             => ! [M4: num] :
                  ( ( Xa
                    = ( bit0 @ M4 ) )
                 => ( ( Y5
                      = ( bit1 @ M4 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M4 ) ) ) ) ) )
           => ( ( ( X3 = one2 )
               => ! [M4: num] :
                    ( ( Xa
                      = ( bit1 @ M4 ) )
                   => ( ( Y5
                        = ( bit1 @ M4 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M4 ) ) ) ) ) )
             => ( ! [N3: num] :
                    ( ( X3
                      = ( bit0 @ N3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y5
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ one2 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X3
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa
                            = ( bit0 @ M4 ) )
                         => ( ( Y5
                              = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                 => ( ! [N3: num] :
                        ( ( X3
                          = ( bit0 @ N3 ) )
                       => ! [M4: num] :
                            ( ( Xa
                              = ( bit1 @ M4 ) )
                           => ( ( Y5
                                = ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) )
                   => ( ! [N3: num] :
                          ( ( X3
                            = ( bit1 @ N3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y5 = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ one2 ) ) ) ) )
                     => ( ! [N3: num] :
                            ( ( X3
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa
                                  = ( bit0 @ M4 ) )
                               => ( ( Y5
                                    = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X3
                                = ( bit1 @ N3 ) )
                             => ! [M4: num] :
                                  ( ( Xa
                                    = ( bit1 @ M4 ) )
                                 => ( ( Y5
                                      = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_4883_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4884_rat__inverse__code,axiom,
    ! [P3: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,B4: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A5
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A5 ) @ B4 ) @ ( abs_abs @ int @ A5 ) ) )
        @ ( quotient_of @ P3 ) ) ) ).

% rat_inverse_code
thf(fact_4885_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_4886_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_4887_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_4888_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_4889_quotient__of__div,axiom,
    ! [R2: rat,N: int,D2: int] :
      ( ( ( quotient_of @ R2 )
        = ( product_Pair @ int @ int @ N @ D2 ) )
     => ( R2
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_4890_quotient__of__denom__pos,axiom,
    ! [R2: rat,P3: int,Q2: int] :
      ( ( ( quotient_of @ R2 )
        = ( product_Pair @ int @ int @ P3 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% quotient_of_denom_pos
thf(fact_4891_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D5: int] : ( ord_less @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_code
thf(fact_4892_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A5: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D5: int] : ( ord_less_eq @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_eq_code
thf(fact_4893_rat__plus__code,axiom,
    ! [P3: rat,Q2: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P3 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P3 ) ) ) ).

% rat_plus_code
thf(fact_4894_rat__minus__code,axiom,
    ! [P3: rat,Q2: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P3 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P3 ) ) ) ).

% rat_minus_code
thf(fact_4895_normalize__negative,axiom,
    ! [Q2: int,P3: int] :
      ( ( ord_less @ int @ Q2 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P3 @ Q2 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P3 ) @ ( uminus_uminus @ int @ Q2 ) ) ) ) ) ).

% normalize_negative
thf(fact_4896_normalize__denom__zero,axiom,
    ! [P3: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P3 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_4897_normalize__denom__pos,axiom,
    ! [R2: product_prod @ int @ int,P3: int,Q2: int] :
      ( ( ( normalize @ R2 )
        = ( product_Pair @ int @ int @ P3 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% normalize_denom_pos
thf(fact_4898_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P3: int,R2: int] :
      ( ( Q2
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P3 @ Q2 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R2 @ S ) ) )
         => ( ( times_times @ int @ P3 @ S )
            = ( times_times @ int @ R2 @ Q2 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_4899_rat__divide__code,axiom,
    ! [P3: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P3 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C4 @ B4 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P3 ) ) ) ).

% rat_divide_code
thf(fact_4900_rat__times__code,axiom,
    ! [P3: rat,Q2: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P3 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ B4 ) @ ( times_times @ int @ C4 @ D5 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P3 ) ) ) ).

% rat_times_code
thf(fact_4901_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_4902_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_4903_prod__decode__aux_Oelims,axiom,
    ! [X3: nat,Xa: nat,Y5: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X3 @ Xa )
        = Y5 )
     => ( ( ( ord_less_eq @ nat @ Xa @ X3 )
         => ( Y5
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X3 @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X3 )
         => ( Y5
            = ( nat_prod_decode_aux @ ( suc @ X3 ) @ ( minus_minus @ nat @ Xa @ ( suc @ X3 ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_4904_Frct__code__post_I1_J,axiom,
    ! [A3: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A3 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_4905_Frct__code__post_I2_J,axiom,
    ! [A3: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A3 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_4906_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_4907_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K3: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K3 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K3 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K3 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K3 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_4908_prod__decode__aux_Opelims,axiom,
    ! [X3: nat,Xa: nat,Y5: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X3 @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X3 )
               => ( Y5
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X3 @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X3 )
               => ( Y5
                  = ( nat_prod_decode_aux @ ( suc @ X3 ) @ ( minus_minus @ nat @ Xa @ ( suc @ X3 ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X3 @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_4909_bezw__0,axiom,
    ! [X3: nat] :
      ( ( bezw @ X3 @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_4910_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A2 )
              & ( member2 @ nat @ ( zero_zero @ nat ) @ A2 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) ) @ ( D2 @ I2 ) )
                @ A2 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A2 )
                & ( member2 @ nat @ ( zero_zero @ nat ) @ A2 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) ) @ ( D2 @ I2 ) )
                @ A2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4911_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_4912_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4913_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ F4 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ F4 )
              = ( zero_zero @ A ) )
            = ( ! [X4: B] :
                  ( ( member2 @ B @ X4 @ F4 )
                 => ( ( F2 @ X4 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4914_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 )
              = ( zero_zero @ A ) )
            = ( ? [X4: B] :
                  ( ( member2 @ B @ X4 @ A2 )
                  & ( ( F2 @ X4 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4915_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4916_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4917_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A3: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member2 @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A3 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A3 ) ) )
            & ( ~ ( member2 @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A3 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_4918_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A3: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member2 @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A3 ) ) )
            & ( ~ ( member2 @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_4919_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A2: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A2 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member2 @ nat @ R5 @ A2 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_4920_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_4921_prod__pos__nat__iff,axiom,
    ! [A: $tType,A2: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A2 ) )
        = ( ! [X4: A] :
              ( ( member2 @ A @ X4 @ A2 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X4 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4922_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A2 )
              & ( member2 @ nat @ ( zero_zero @ nat ) @ A2 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) )
                @ A2 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A2 )
                & ( member2 @ nat @ ( zero_zero @ nat ) @ A2 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) )
                @ A2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4923_finite__list,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ? [Xs3: list @ A] :
          ( ( set2 @ A @ Xs3 )
          = A2 ) ) ).

% finite_list
thf(fact_4924_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X4: nat] :
          ( ( member2 @ nat @ X4 @ N6 )
         => ( ord_less_eq @ nat @ X4 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4925_bounded__nat__set__is__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ! [X2: nat] :
          ( ( member2 @ nat @ X2 @ N5 )
         => ( ord_less @ nat @ X2 @ N ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4926_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X4: nat] :
          ( ( member2 @ nat @ X4 @ N6 )
         => ( ord_less @ nat @ X4 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4927_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4928_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F2 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N2: nat] : ( ord_less_eq @ nat @ ( F2 @ N2 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4929_finite__lists__length__eq,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 )
              & ( ( size_size @ ( list @ A ) @ Xs2 )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4930_sum__mono__inv,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I6 > A,I5: set @ I6,G: I6 > A,I: I6] :
          ( ( ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ I5 )
            = ( groups7311177749621191930dd_sum @ I6 @ A @ G @ I5 ) )
         => ( ! [I3: I6] :
                ( ( member2 @ I6 @ I3 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) )
           => ( ( member2 @ I6 @ I @ I5 )
             => ( ( finite_finite @ I6 @ I5 )
               => ( ( F2 @ I )
                  = ( G @ I ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4931_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ? [X: B] :
                ( ( member2 @ B @ X @ A2 )
                & ( ( F2 @ X )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_4932_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4933_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4934_finite__lists__length__le,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4935_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member2 @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_finite
thf(fact_4936_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,X3: B > A,Y5: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member2 @ B @ I2 @ I5 )
                  & ( ( X3 @ I2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member2 @ B @ I2 @ I5 )
                    & ( ( Y5 @ I2 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member2 @ B @ I2 @ I5 )
                    & ( ( plus_plus @ A @ ( X3 @ I2 ) @ ( Y5 @ I2 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4937_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,X3: B > A,Y5: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member2 @ B @ I2 @ I5 )
                  & ( ( X3 @ I2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member2 @ B @ I2 @ I5 )
                    & ( ( Y5 @ I2 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member2 @ B @ I2 @ I5 )
                    & ( ( times_times @ A @ ( X3 @ I2 ) @ ( Y5 @ I2 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4938_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X4: B] :
                    ( ( member2 @ B @ X4 @ A2 )
                    & ( P @ X4 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( G @ X4 ) @ ( zero_zero @ A ) )
              @ A2 ) ) ) ) ).

% sum.inter_filter
thf(fact_4939_set__encode__inf,axiom,
    ! [A2: set @ nat] :
      ( ~ ( finite_finite @ nat @ A2 )
     => ( ( nat_set_encode @ A2 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_4940_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member2 @ A @ X4 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A3 @ X4 )
                & ( ord_less_eq @ A @ X4 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4941_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G: C > A,I: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X2: C] :
                  ( ( member2 @ C @ X2 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X2 ) ) )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S )
                   => ? [Xa3: C] :
                        ( ( member2 @ C @ Xa3 @ T2 )
                        & ( ( I @ Xa3 )
                          = X2 )
                        & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ Xa3 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4942_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ A2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 )
                = ( zero_zero @ A ) )
              = ( ! [X4: B] :
                    ( ( member2 @ B @ X4 @ A2 )
                   => ( ( F2 @ X4 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4943_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: set @ I6,F2: I6 > A,G: I6 > A] :
          ( ( finite_finite @ I6 @ A2 )
         => ( ! [X2: I6] :
                ( ( member2 @ I6 @ X2 @ A2 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
           => ( ? [X: I6] :
                  ( ( member2 @ I6 @ X @ A2 )
                  & ( ord_less @ A @ ( F2 @ X ) @ ( G @ X ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ I6 @ A @ G @ A2 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4944_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R4: A > A > $o,S2: set @ B,H: B > A,G: B > A] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R4 @ X1 @ X23 )
                  & ( R4 @ Y1 @ Y23 ) )
               => ( R4 @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S2 )
                   => ( R4 @ ( H @ X2 ) @ ( G @ X2 ) ) )
               => ( R4 @ ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4945_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R4: A > A > $o,S2: set @ B,H: B > A,G: B > A] :
          ( ( R4 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R4 @ X1 @ X23 )
                  & ( R4 @ Y1 @ Y23 ) )
               => ( R4 @ ( times_times @ A @ X1 @ Y1 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S2 )
                   => ( R4 @ ( H @ X2 ) @ ( G @ X2 ) ) )
               => ( R4 @ ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4946_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,S2: set @ B,I: C > B,J3: B > C,T6: set @ C,G: B > A,H: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A7: B] :
                  ( ( member2 @ B @ A7 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) )
                 => ( ( I @ ( J3 @ A7 ) )
                    = A7 ) )
             => ( ! [A7: B] :
                    ( ( member2 @ B @ A7 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) )
                   => ( member2 @ C @ ( J3 @ A7 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B6: C] :
                      ( ( member2 @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J3 @ ( I @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member2 @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member2 @ B @ ( I @ B6 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) ) )
                   => ( ! [A7: B] :
                          ( ( member2 @ B @ A7 @ S5 )
                         => ( ( G @ A7 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member2 @ C @ B6 @ T5 )
                           => ( ( H @ B6 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A7: B] :
                              ( ( member2 @ B @ A7 @ S2 )
                             => ( ( H @ ( J3 @ A7 ) )
                                = ( G @ A7 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_4947_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ B3 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B3 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_4948_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B3: set @ B,A2: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ B3 )
           => ( ! [A7: B] :
                  ( ( member2 @ B @ A7 @ A2 )
                 => ( dvd_dvd @ A @ ( F2 @ A7 ) @ ( G @ A7 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_4949_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A2: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X4: A] :
              ( ( member2 @ A @ X4 @ A2 )
              & ( ( F2 @ X4 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y: A] :
                  ( ( member2 @ A @ Y @ A2 )
                 => ( ( X4 != Y )
                   => ( ( F2 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4950_sum__eq__1__iff,axiom,
    ! [A: $tType,A2: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 )
          = ( one_one @ nat ) )
        = ( ? [X4: A] :
              ( ( member2 @ A @ X4 @ A2 )
              & ( ( F2 @ X4 )
                = ( one_one @ nat ) )
              & ! [Y: A] :
                  ( ( member2 @ A @ Y @ A2 )
                 => ( ( X4 != Y )
                   => ( ( F2 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4951_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,B3: A,I: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = B3 )
             => ( ( member2 @ B @ I @ S )
               => ( ord_less_eq @ A @ ( F2 @ I ) @ B3 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4952_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,I: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = ( zero_zero @ A ) )
             => ( ( member2 @ B @ I @ S )
               => ( ( F2 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4953_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A2
                @ ( collect @ B
                  @ ^ [X4: B] :
                      ( ( G @ X4 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_4954_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D5: nat] : ( dvd_dvd @ nat @ D5 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4955_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A2: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A2 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member2 @ nat @ R5 @ A2 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A2 ) ) ) ) ).

% sums_If_finite_set
thf(fact_4956_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_4957_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member2 @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N5 ) ) ) ) ) ).

% sums_finite
thf(fact_4958_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N5: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N5 )
         => ( ! [N3: nat] :
                ( ~ ( member2 @ nat @ N3 @ N5 )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N5 ) ) ) ) ) ).

% suminf_finite
thf(fact_4959_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K3: A] :
                ( ( member2 @ A @ K3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K3 ) @ A3 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4960_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_4961_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N5 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_4962_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,I: B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( member2 @ B @ I @ I5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ! [I3: B] :
                    ( ( member2 @ B @ I3 @ I5 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4963_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,I: A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( member2 @ A @ I @ I5 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I ) )
             => ( ! [I3: A] :
                    ( ( member2 @ A @ I3 @ I5 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4964_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A2: set @ B,B3: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A7: B] :
                    ( ( member2 @ B @ A7 @ ( minus_minus @ ( set @ B ) @ C6 @ A2 ) )
                   => ( ( G @ A7 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member2 @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B3 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4965_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A2: set @ B,B3: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A7: B] :
                    ( ( member2 @ B @ A7 @ ( minus_minus @ ( set @ B ) @ C6 @ A2 ) )
                   => ( ( G @ A7 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member2 @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B3 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4966_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4967_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4968_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S2 )
                   => ( ( G @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4969_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S2 )
                   => ( ( G @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4970_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: set @ B,A2: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A2 )
         => ( ( finite_finite @ B @ A2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4971_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( ord_less_eq @ ( set @ B ) @ B3 @ A2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) ) ) ) ) ).

% sum_diff
thf(fact_4972_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A2: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A2 )
         => ( ( finite_finite @ B @ A2 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A2 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4973_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A2: set @ B,B3: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A7: B] :
                    ( ( member2 @ B @ A7 @ ( minus_minus @ ( set @ B ) @ C6 @ A2 ) )
                   => ( ( G @ A7 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member2 @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A2 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ B3 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ C6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_4974_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A2: set @ B,B3: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A7: B] :
                    ( ( member2 @ B @ A7 @ ( minus_minus @ ( set @ B ) @ C6 @ A2 ) )
                   => ( ( G @ A7 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member2 @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ C6 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A2 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ B3 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_4975_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_4976_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_4977_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H @ X2 )
                    = ( one_one @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S2 )
                   => ( ( G @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H @ T6 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_4978_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member2 @ B @ X2 @ S2 )
                   => ( ( G @ X2 )
                      = ( H @ X2 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_4979_sum__diff__nat,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B3 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_4980_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z3: A] :
                  ( ( power_power @ A @ Z3 @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4981_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,H: B > C,S2: set @ B,T6: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A7: B] :
                    ( ( member2 @ B @ A7 @ S5 )
                   => ( ( G @ ( H @ A7 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member2 @ C @ B6 @ T5 )
                     => ( ( G @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X4: B] : ( G @ ( H @ X4 ) )
                      @ S2 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T6 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4982_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S2: A,A2: set @ nat,S5: A,F2: nat > A] :
          ( ( sums @ A @ G @ S2 )
         => ( ( finite_finite @ nat @ A2 )
           => ( ( S5
                = ( plus_plus @ A @ S2
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
                    @ A2 ) ) )
             => ( sums @ A
                @ ^ [N2: nat] : ( if @ A @ ( member2 @ nat @ N2 @ A2 ) @ ( F2 @ N2 ) @ ( G @ N2 ) )
                @ S5 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4983_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B3: set @ B,A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A2 @ B3 )
           => ( ! [B6: B] :
                  ( ( member2 @ B @ B6 @ ( minus_minus @ ( set @ B ) @ B3 @ A2 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4984_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) )
            = ( ? [X4: B] :
                  ( ( member2 @ B @ X4 @ A2 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4985_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I5: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I5 )
           => ( ! [N3: nat] :
                  ( ( member2 @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I5 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4986_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B3: set @ A,A2: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
           => ( ( member2 @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X2: A] :
                      ( ( member2 @ A @ X2 @ B3 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X2 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4987_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B3: set @ A,A2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
           => ( ! [B6: A] :
                  ( ( member2 @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B6 ) ) )
             => ( ! [A7: A] :
                    ( ( member2 @ A @ A7 @ A2 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A7 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4988_ln__prod,axiom,
    ! [A: $tType,I5: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I5 )
     => ( ! [I3: A] :
            ( ( member2 @ A @ I3 @ I5 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I3 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I5 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X4: A] : ( ln_ln @ real @ ( F2 @ X4 ) )
            @ I5 ) ) ) ) ).

% ln_prod
thf(fact_4989_even__set__encode__iff,axiom,
    ! [A2: set @ nat] :
      ( ( finite_finite @ nat @ A2 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A2 ) )
        = ( ~ ( member2 @ nat @ ( zero_zero @ nat ) @ A2 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4990_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X4: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ X4 @ I2 ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ N )
                & ( ( C2 @ I2 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4991_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z3: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z3 @ I2 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4992_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4993_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less @ nat @ N2 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4994_finite__Collect__subsets,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A2 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4995_finite__interval__int1,axiom,
    ! [A3: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less_eq @ int @ A3 @ I2 )
            & ( ord_less_eq @ int @ I2 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_4996_finite__interval__int4,axiom,
    ! [A3: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less @ int @ A3 @ I2 )
            & ( ord_less @ int @ I2 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4997_finite__interval__int3,axiom,
    ! [A3: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less @ int @ A3 @ I2 )
            & ( ord_less_eq @ int @ I2 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4998_finite__interval__int2,axiom,
    ! [A3: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I2: int] :
            ( ( ord_less_eq @ int @ A3 @ I2 )
            & ( ord_less @ int @ I2 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4999_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z3: complex] :
              ( ( power_power @ complex @ Z3 @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_5000_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_5001_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X: list @ A] :
          ( ( member2 @ ( list @ A ) @ X @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_5002_finite__enat__bounded,axiom,
    ! [A2: set @ extended_enat,N: nat] :
      ( ! [Y2: extended_enat] :
          ( ( member2 @ extended_enat @ Y2 @ A2 )
         => ( ord_less_eq @ extended_enat @ Y2 @ ( extended_enat2 @ N ) ) )
     => ( finite_finite @ extended_enat @ A2 ) ) ).

% finite_enat_bounded
thf(fact_5003_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D5: int] : ( dvd_dvd @ int @ D5 @ I ) ) ) ) ).

% finite_divisors_int
thf(fact_5004_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: set @ A,A3: A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( member2 @ A @ A3 @ A2 )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ A2 )
                & ( ord_less_eq @ A @ X2 @ A3 )
                & ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ A2 )
                   => ( ( ord_less_eq @ A @ Xa3 @ X2 )
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_5005_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: set @ A,A3: A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( member2 @ A @ A3 @ A2 )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ A2 )
                & ( ord_less_eq @ A @ A3 @ X2 )
                & ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ A2 )
                   => ( ( ord_less_eq @ A @ X2 @ Xa3 )
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_5006_finite__subset,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( finite_finite @ A @ B3 )
       => ( finite_finite @ A @ A2 ) ) ) ).

% finite_subset
thf(fact_5007_infinite__super,axiom,
    ! [A: $tType,S2: set @ A,T6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ T6 ) ) ) ).

% infinite_super
thf(fact_5008_rev__finite__subset,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( finite_finite @ A @ A2 ) ) ) ).

% rev_finite_subset
thf(fact_5009_finite__psubset__induct,axiom,
    ! [A: $tType,A2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A2 )
     => ( ! [A8: set @ A] :
            ( ( finite_finite @ A @ A8 )
           => ( ! [B10: set @ A] :
                  ( ( ord_less @ ( set @ A ) @ B10 @ A8 )
                 => ( P @ B10 ) )
             => ( P @ A8 ) ) )
       => ( P @ A2 ) ) ) ).

% finite_psubset_induct
thf(fact_5010_finite__nat__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S6: set @ nat] :
        ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S6 @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ).

% finite_nat_iff_bounded_le
thf(fact_5011_finite__nat__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S6: set @ nat] :
        ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S6 @ ( set_ord_lessThan @ nat @ K3 ) ) ) ) ).

% finite_nat_iff_bounded
thf(fact_5012_finite__nat__bounded,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S2 @ ( set_ord_lessThan @ nat @ K2 ) ) ) ).

% finite_nat_bounded
thf(fact_5013_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M3: int] :
          ? [N2: int] :
            ( ( ord_less_eq @ int @ M3 @ ( abs_abs @ int @ N2 ) )
            & ( member2 @ int @ N2 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_5014_infinite__int__iff__unbounded,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M3: int] :
          ? [N2: int] :
            ( ( ord_less @ int @ M3 @ ( abs_abs @ int @ N2 ) )
            & ( member2 @ int @ N2 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_5015_unbounded__k__infinite,axiom,
    ! [K: nat,S2: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N7: nat] :
              ( ( ord_less @ nat @ M4 @ N7 )
              & ( member2 @ nat @ N7 @ S2 ) ) )
     => ~ ( finite_finite @ nat @ S2 ) ) ).

% unbounded_k_infinite
thf(fact_5016_infinite__nat__iff__unbounded,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M3: nat] :
          ? [N2: nat] :
            ( ( ord_less @ nat @ M3 @ N2 )
            & ( member2 @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_5017_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M3: nat] :
          ? [N2: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
            & ( member2 @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_5018_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z3: complex] :
                ( ( power_power @ complex @ Z3 @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z3: complex] :
                ( ( power_power @ complex @ Z3 @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_5019_in__finite__psubset,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( member2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A2 @ B3 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
        & ( finite_finite @ A @ B3 ) ) ) ).

% in_finite_psubset
thf(fact_5020_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X9: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X9 )
     => ( ( finite_finite @ A @ X9 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X9 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_5021_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_5022_real__root__Suc__0,axiom,
    ! [X3: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X3 )
      = X3 ) ).

% real_root_Suc_0
thf(fact_5023_root__0,axiom,
    ! [X3: real] :
      ( ( root @ ( zero_zero @ nat ) @ X3 )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_5024_real__root__eq__iff,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X3 )
          = ( root @ N @ Y5 ) )
        = ( X3 = Y5 ) ) ) ).

% real_root_eq_iff
thf(fact_5025_count__notin,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X3 )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_5026_real__root__eq__0__iff,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X3 )
          = ( zero_zero @ real ) )
        = ( X3
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_5027_real__root__less__iff,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X3 ) @ ( root @ N @ Y5 ) )
        = ( ord_less @ real @ X3 @ Y5 ) ) ) ).

% real_root_less_iff
thf(fact_5028_real__root__le__iff,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X3 ) @ ( root @ N @ Y5 ) )
        = ( ord_less_eq @ real @ X3 @ Y5 ) ) ) ).

% real_root_le_iff
thf(fact_5029_real__root__eq__1__iff,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X3 )
          = ( one_one @ real ) )
        = ( X3
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_5030_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_5031_real__root__lt__0__iff,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X3 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X3 @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_5032_real__root__gt__0__iff,axiom,
    ! [N: nat,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y5 ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y5 ) ) ) ).

% real_root_gt_0_iff
thf(fact_5033_real__root__le__0__iff,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X3 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X3 @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_5034_real__root__ge__0__iff,axiom,
    ! [N: nat,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y5 ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 ) ) ) ).

% real_root_ge_0_iff
thf(fact_5035_real__root__lt__1__iff,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X3 ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X3 @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_5036_real__root__gt__1__iff,axiom,
    ! [N: nat,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y5 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y5 ) ) ) ).

% real_root_gt_1_iff
thf(fact_5037_real__root__le__1__iff,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X3 ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X3 @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_5038_real__root__ge__1__iff,axiom,
    ! [N: nat,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y5 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y5 ) ) ) ).

% real_root_ge_1_iff
thf(fact_5039_real__root__pow__pos2,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( power_power @ real @ ( root @ N @ X3 ) @ N )
          = X3 ) ) ) ).

% real_root_pow_pos2
thf(fact_5040_real__root__divide,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( root @ N @ ( divide_divide @ real @ X3 @ Y5 ) )
      = ( divide_divide @ real @ ( root @ N @ X3 ) @ ( root @ N @ Y5 ) ) ) ).

% real_root_divide
thf(fact_5041_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X3: real] :
      ( ( root @ ( times_times @ nat @ M @ N ) @ X3 )
      = ( root @ M @ ( root @ N @ X3 ) ) ) ).

% real_root_mult_exp
thf(fact_5042_real__root__mult,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( root @ N @ ( times_times @ real @ X3 @ Y5 ) )
      = ( times_times @ real @ ( root @ N @ X3 ) @ ( root @ N @ Y5 ) ) ) ).

% real_root_mult
thf(fact_5043_real__root__commute,axiom,
    ! [M: nat,N: nat,X3: real] :
      ( ( root @ M @ ( root @ N @ X3 ) )
      = ( root @ N @ ( root @ M @ X3 ) ) ) ).

% real_root_commute
thf(fact_5044_real__root__inverse,axiom,
    ! [N: nat,X3: real] :
      ( ( root @ N @ ( inverse_inverse @ real @ X3 ) )
      = ( inverse_inverse @ real @ ( root @ N @ X3 ) ) ) ).

% real_root_inverse
thf(fact_5045_real__root__minus,axiom,
    ! [N: nat,X3: real] :
      ( ( root @ N @ ( uminus_uminus @ real @ X3 ) )
      = ( uminus_uminus @ real @ ( root @ N @ X3 ) ) ) ).

% real_root_minus
thf(fact_5046_real__root__pos__pos__le,axiom,
    ! [X3: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X3 ) ) ) ).

% real_root_pos_pos_le
thf(fact_5047_real__root__less__mono,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X3 @ Y5 )
       => ( ord_less @ real @ ( root @ N @ X3 ) @ ( root @ N @ Y5 ) ) ) ) ).

% real_root_less_mono
thf(fact_5048_real__root__le__mono,axiom,
    ! [N: nat,X3: real,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X3 @ Y5 )
       => ( ord_less_eq @ real @ ( root @ N @ X3 ) @ ( root @ N @ Y5 ) ) ) ) ).

% real_root_le_mono
thf(fact_5049_real__root__power,axiom,
    ! [N: nat,X3: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X3 @ K ) )
        = ( power_power @ real @ ( root @ N @ X3 ) @ K ) ) ) ).

% real_root_power
thf(fact_5050_real__root__abs,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X3 ) )
        = ( abs_abs @ real @ ( root @ N @ X3 ) ) ) ) ).

% real_root_abs
thf(fact_5051_sgn__root,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X3 ) )
        = ( sgn_sgn @ real @ X3 ) ) ) ).

% sgn_root
thf(fact_5052_real__root__gt__zero,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X3 ) ) ) ) ).

% real_root_gt_zero
thf(fact_5053_real__root__strict__decreasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N5 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
         => ( ord_less @ real @ ( root @ N5 @ X3 ) @ ( root @ N @ X3 ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_5054_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_5055_root__abs__power,axiom,
    ! [N: nat,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y5 @ N ) ) )
        = ( abs_abs @ real @ Y5 ) ) ) ).

% root_abs_power
thf(fact_5056_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X3 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_5057_real__root__pos__pos,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X3 ) ) ) ) ).

% real_root_pos_pos
thf(fact_5058_real__root__strict__increasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N5 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X3 ) @ ( root @ N5 @ X3 ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_5059_real__root__decreasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N5 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X3 )
         => ( ord_less_eq @ real @ ( root @ N5 @ X3 ) @ ( root @ N @ X3 ) ) ) ) ) ).

% real_root_decreasing
thf(fact_5060_real__root__pow__pos,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( power_power @ real @ ( root @ N @ X3 ) @ N )
          = X3 ) ) ) ).

% real_root_pow_pos
thf(fact_5061_real__root__power__cancel,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( root @ N @ ( power_power @ real @ X3 @ N ) )
          = X3 ) ) ) ).

% real_root_power_cancel
thf(fact_5062_real__root__pos__unique,axiom,
    ! [N: nat,Y5: real,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
       => ( ( ( power_power @ real @ Y5 @ N )
            = X3 )
         => ( ( root @ N @ X3 )
            = Y5 ) ) ) ) ).

% real_root_pos_unique
thf(fact_5063_odd__real__root__power__cancel,axiom,
    ! [N: nat,X3: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X3 @ N ) )
        = X3 ) ) ).

% odd_real_root_power_cancel
thf(fact_5064_odd__real__root__unique,axiom,
    ! [N: nat,Y5: real,X3: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ( power_power @ real @ Y5 @ N )
          = X3 )
       => ( ( root @ N @ X3 )
          = Y5 ) ) ) ).

% odd_real_root_unique
thf(fact_5065_odd__real__root__pow,axiom,
    ! [N: nat,X3: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( power_power @ real @ ( root @ N @ X3 ) @ N )
        = X3 ) ) ).

% odd_real_root_pow
thf(fact_5066_real__root__increasing,axiom,
    ! [N: nat,N5: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N5 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
         => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X3 ) @ ( root @ N5 @ X3 ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_5067_sgn__power__root,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X3 ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X3 ) ) @ N ) )
        = X3 ) ) ).

% sgn_power_root
thf(fact_5068_root__sgn__power,axiom,
    ! [N: nat,Y5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N ) ) )
        = Y5 ) ) ).

% root_sgn_power
thf(fact_5069_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_5070_log__root,axiom,
    ! [N: nat,A3: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
       => ( ( log @ B2 @ ( root @ N @ A3 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A3 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_5071_log__base__root,axiom,
    ! [N: nat,B2: real,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N @ B2 ) @ X3 )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X3 ) ) ) ) ) ).

% log_base_root
thf(fact_5072_split__root,axiom,
    ! [P: real > $o,N: nat,X3: real] :
      ( ( P @ ( root @ N @ X3 ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
                = X3 )
             => ( P @ Y ) ) ) ) ) ).

% split_root
thf(fact_5073_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A4: set @ A,B8: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A4 @ B8 )
              & ( finite_finite @ A @ B8 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_5074_root__powr__inverse,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( ( root @ N @ X3 )
          = ( powr @ real @ X3 @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_5075_set__encode__insert,axiom,
    ! [A2: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ A2 )
     => ( ~ ( member2 @ nat @ N @ A2 )
       => ( ( nat_set_encode @ ( insert2 @ nat @ N @ A2 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A2 ) ) ) ) ) ).

% set_encode_insert
thf(fact_5076_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X9: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X9 )
     => ( ( finite_finite @ A @ X9 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X4: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X4 ) @ ( F2 @ X4 ) )
            @ X9 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_5077_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A5: B] :
                      ( ( member2 @ B @ A5 @ A2 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A5 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_5078_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_5079_insert__subset,axiom,
    ! [A: $tType,X3: A,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X3 @ A2 ) @ B3 )
      = ( ( member2 @ A @ X3 @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ).

% insert_subset
thf(fact_5080_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] : ( ord_less_eq @ nat @ I2 @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_5081_card_Oinfinite,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ~ ( finite_finite @ A @ A2 )
     => ( ( finite_card @ A @ A2 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_5082_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Ns ) )
               => ( X4
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_5083_List_Oset__insert,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( set2 @ A @ ( insert @ A @ X3 @ Xs ) )
      = ( insert2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% List.set_insert
thf(fact_5084_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y5: A,A2: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : Y5
            @ A2 )
          = ( power_power @ A @ Y5 @ ( finite_card @ B @ A2 ) ) ) ) ).

% prod_constant
thf(fact_5085_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( zero_zero @ A )
              @ Xs ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_5086_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,X3: B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ~ ( member2 @ B @ X3 @ A2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
              = ( plus_plus @ A @ ( G @ X3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) ) ) ) ) ) ).

% sum.insert
thf(fact_5087_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,X3: B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ~ ( member2 @ B @ X3 @ A2 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
              = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) ) ) ) ) ) ).

% prod.insert
thf(fact_5088_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y5: A,A2: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X4: B] : Y5
            @ A2 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A2 ) ) @ Y5 ) ) ) ).

% sum_constant
thf(fact_5089_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X4: nat] : X4
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_5090_card__insert__le,axiom,
    ! [A: $tType,A2: set @ A,X3: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ ( insert2 @ A @ X3 @ A2 ) ) ) ).

% card_insert_le
thf(fact_5091_insert__mono,axiom,
    ! [A: $tType,C6: set @ A,D4: set @ A,A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ D4 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A3 @ C6 ) @ ( insert2 @ A @ A3 @ D4 ) ) ) ).

% insert_mono
thf(fact_5092_subset__insert,axiom,
    ! [A: $tType,X3: A,A2: set @ A,B3: set @ A] :
      ( ~ ( member2 @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ).

% subset_insert
thf(fact_5093_subset__insertI,axiom,
    ! [A: $tType,B3: set @ A,A3: A] : ( ord_less_eq @ ( set @ A ) @ B3 @ ( insert2 @ A @ A3 @ B3 ) ) ).

% subset_insertI
thf(fact_5094_subset__insertI2,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ B2 @ B3 ) ) ) ).

% subset_insertI2
thf(fact_5095_n__subsets,axiom,
    ! [A: $tType,A2: set @ A,K: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B8 @ A2 )
                & ( ( finite_card @ A @ B8 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A2 ) @ K ) ) ) ).

% n_subsets
thf(fact_5096_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A2: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A2 ) )
      = ( ? [A5: A,B8: set @ A] :
            ( ( A2
              = ( insert2 @ A @ A5 @ B8 ) )
            & ~ ( member2 @ A @ A5 @ B8 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B8 ) )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5097_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ~ ( finite_finite @ A @ A2 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A2 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_5098_card__subset__eq,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( ( ( finite_card @ A @ A2 )
            = ( finite_card @ A @ B3 ) )
         => ( A2 = B3 ) ) ) ) ).

% card_subset_eq
thf(fact_5099_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,A2: set @ B,R2: B > A > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ! [A7: B] :
            ( ( member2 @ B @ A7 @ A2 )
           => ? [B11: A] :
                ( ( member2 @ A @ B11 @ B3 )
                & ( R2 @ A7 @ B11 ) ) )
       => ( ! [A13: B,A24: B,B6: A] :
              ( ( member2 @ B @ A13 @ A2 )
             => ( ( member2 @ B @ A24 @ A2 )
               => ( ( member2 @ A @ B6 @ B3 )
                 => ( ( R2 @ A13 @ B6 )
                   => ( ( R2 @ A24 @ B6 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A2 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_5100_subset__Diff__insert,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,X3: A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B3 @ ( insert2 @ A @ X3 @ C6 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B3 @ C6 ) )
        & ~ ( member2 @ A @ X3 @ A2 ) ) ) ).

% subset_Diff_insert
thf(fact_5101_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X3 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_5102_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_5103_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y5: set @ A,X3: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y5 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert2 @ A @ X3 @ Y5 ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_5104_card__lists__length__eq,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 )
                & ( ( size_size @ ( list @ A ) @ Xs2 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A2 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_5105_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_5106_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_5107_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( plus_plus @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ Xs ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_addf
thf(fact_5108_card__length__sum__list__rec,axiom,
    ! [M: nat,N5: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L3: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L3 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L3 )
                  = N5 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L3: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L3 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L3 )
                    = N5 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L3: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L3 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L3 ) @ ( one_one @ nat ) )
                    = N5 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_5109_card__length__sum__list,axiom,
    ! [M: nat,N5: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L3: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L3 )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L3 )
                = N5 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N5 @ M ) @ ( one_one @ nat ) ) @ N5 ) ) ).

% card_length_sum_list
thf(fact_5110_card__2__iff_H,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X4: A] :
            ( ( member2 @ A @ X4 @ S2 )
            & ? [Y: A] :
                ( ( member2 @ A @ Y @ S2 )
                & ( X4 != Y )
                & ! [Z3: A] :
                    ( ( member2 @ A @ Z3 @ S2 )
                   => ( ( Z3 = X4 )
                      | ( Z3 = Y ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_5111_card__ge__0__finite,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A2 ) )
     => ( finite_finite @ A @ A2 ) ) ).

% card_ge_0_finite
thf(fact_5112_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set @ A] :
      ( ( ord_less_eq @ nat @ N @ ( finite_card @ A @ S2 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S2 )
           => ( ( ( finite_card @ A @ T7 )
                = N )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_5113_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C6: nat] :
      ( ! [G3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G3 @ F4 )
         => ( ( finite_finite @ A @ G3 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G3 ) @ C6 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C6 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_5114_card__seteq,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B3 ) @ ( finite_card @ A @ A2 ) )
         => ( A2 = B3 ) ) ) ) ).

% card_seteq
thf(fact_5115_card__mono,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) ) ) ) ).

% card_mono
thf(fact_5116_card__less__sym__Diff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5117_card__le__sym__Diff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_5118_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_5119_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_5120_psubset__card__mono,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
       => ( ord_less @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) ) ) ) ).

% psubset_card_mono
thf(fact_5121_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,X3: B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( ( member2 @ B @ X3 @ A2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) ) )
            & ( ~ ( member2 @ B @ X3 @ A2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
                = ( plus_plus @ A @ ( G @ X3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_5122_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,X3: B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( ( member2 @ B @ X3 @ A2 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) ) )
            & ( ~ ( member2 @ B @ X3 @ A2 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
                = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_5123_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_5124_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X4: A] :
                  ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
                 => ( X4
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_5125_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_5126_atLeast0__atMost__Suc,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_5127_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_5128_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert2 @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_5129_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert2 @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_5130_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert2 @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_5131_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_5132_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_5133_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert2 @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_5134_card__less,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ( member2 @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member2 @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_5135_card__less__Suc,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ( member2 @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] :
                  ( ( member2 @ nat @ ( suc @ K3 ) @ M7 )
                  & ( ord_less @ nat @ K3 @ I ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member2 @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_5136_card__less__Suc2,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ~ ( member2 @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member2 @ nat @ ( suc @ K3 ) @ M7 )
                & ( ord_less @ nat @ K3 @ I ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member2 @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_5137_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert2 @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_5138_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_5139_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A2: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X4: A] : ( suc @ ( F2 @ X4 ) )
        @ A2 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 ) @ ( finite_card @ A @ A2 ) ) ) ).

% sum_Suc
thf(fact_5140_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,T6: set @ B,R4: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ T6 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I2: A] :
                        ( ( member2 @ A @ I2 @ S2 )
                        & ( R4 @ I2 @ X2 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I2: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J4: B] :
                        ( ( member2 @ B @ J4 @ T6 )
                        & ( R4 @ I2 @ J4 ) ) ) )
              @ S2 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T6 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5141_subset__card__intvl__is__intvl,axiom,
    ! [A2: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A2 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A2 ) ) ) )
     => ( A2
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A2 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_5142_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_5143_real__of__card,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A2 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X4: A] : ( one_one @ real )
        @ A2 ) ) ).

% real_of_card
thf(fact_5144_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A2: set @ B,K5: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A2 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) ) ) ) ).

% sum_bounded_below
thf(fact_5145_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A2: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A2 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_5146_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X4: A] :
              ( ( member2 @ A @ X4 @ A2 )
             => ! [Y: A] :
                  ( ( member2 @ A @ Y @ A2 )
                 => ( X4 = Y ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5147_card__Diff__subset,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_5148_card__psubset,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ ( set @ A ) @ A2 @ B3 ) ) ) ) ).

% card_psubset
thf(fact_5149_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_5150_card__lists__length__le,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A2 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_5151_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_5152_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_5153_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z3: A] :
                    ( ( power_power @ A @ Z3 @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_5154_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N5: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N5 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_5155_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F3: B > nat,Xs2: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F3 @ Xs2 ) ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_5156_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_5157_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R2: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X4: C] : R2
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R2 ) ) ) ).

% sum_list_triv
thf(fact_5158_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X4: A] : ( suc @ ( F2 @ X4 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_5159_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z3: complex] :
                  ( ( power_power @ complex @ Z3 @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_5160_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z3: complex] :
                ( ( power_power @ complex @ Z3 @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_5161_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,K5: real] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S2 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_5162_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A2 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_5163_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A2: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A2 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A2 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_5164_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs2: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_5165_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X4: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X4 ) @ ( F2 @ X4 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_5166_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z3: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z3 @ I2 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_5167_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A3: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member2 @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A3 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member2 @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5168_set__decode__plus__power__2,axiom,
    ! [N: nat,Z2: nat] :
      ( ~ ( member2 @ nat @ N @ ( nat_set_decode @ Z2 ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z2 ) )
        = ( insert2 @ nat @ N @ ( nat_set_decode @ Z2 ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_5169_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z3: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z3 @ I2 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z3: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z3 @ I2 ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5170_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A2: set @ A,K: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A2 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs2: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = K )
                  & ( distinct @ A @ Xs2 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X4: nat] : X4
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A2 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A2 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5171_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A2: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A2 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = K )
                & ( distinct @ A @ Xs2 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X4: nat] : X4
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A2 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A2 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5172_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq @ nat @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_5173_distinct__insert,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( distinct @ A @ ( insert @ A @ X3 @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_insert
thf(fact_5174_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ( finite_finite @ A @ A2 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs2: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = N )
              & ( distinct @ A @ Xs2 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5175_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R4: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R4 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X4: B,Y: B] : ( R4 @ ( F2 @ X4 ) @ ( F2 @ Y ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_5176_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_5177_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] :
          ( ( finite_finite @ A @ A2 )
         => ? [X2: list @ A] :
              ( ( ( set2 @ A @ X2 )
                = A2 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X2 )
              & ( distinct @ A @ X2 )
              & ! [Y6: list @ A] :
                  ( ( ( ( set2 @ A @ Y6 )
                      = A2 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y6 )
                    & ( distinct @ A @ Y6 ) )
                 => ( Y6 = X2 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_5178_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_5179_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 )
             => ( ( distinct @ A @ Ys2 )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys2 ) )
                 => ( Xs = Ys2 ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_5180_distinct__upt,axiom,
    ! [I: nat,J3: nat] : ( distinct @ nat @ ( upt @ I @ J3 ) ) ).

% distinct_upt
thf(fact_5181_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys2 )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys2 ) ) ) ) ).

% distinct_product
thf(fact_5182_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_5183_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o,Q: A > A > $o] :
      ( ! [X2: A,Y2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( P @ X2 @ Y2 )
             => ( Q @ X2 @ Y2 ) ) ) )
     => ( ( sorted_wrt @ A @ P @ Xs )
       => ( sorted_wrt @ A @ Q @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_5184_distinct__take,axiom,
    ! [A: $tType,Xs: list @ A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( take @ A @ I @ Xs ) ) ) ).

% distinct_take
thf(fact_5185_sorted__wrt__take,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( take @ A @ N @ Xs ) ) ) ).

% sorted_wrt_take
thf(fact_5186_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_5187_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_5188_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys2 )
           => ( ( ( set2 @ A @ Ys2 )
                = ( set2 @ A @ Xs ) )
             => ( Ys2 = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_5189_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs ) ) ) ) ).

% sorted_take
thf(fact_5190_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X3: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X3 ) ) ) ).

% sorted_replicate
thf(fact_5191_finite__distinct__list,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ? [Xs3: list @ A] :
          ( ( ( set2 @ A @ Xs3 )
            = A2 )
          & ( distinct @ A @ Xs3 ) ) ) ).

% finite_distinct_list
thf(fact_5192_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_wrt_upt
thf(fact_5193_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_5194_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X4: B,Y: B] : ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( F2 @ Y ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_5195_subseqs__distinctD,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A] :
      ( ( member2 @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys2 ) ) ) ).

% subseqs_distinctD
thf(fact_5196_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs ) ) ).

% sorted_wrt01
thf(fact_5197_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P2: A > A > $o,Xs2: list @ A] :
          ! [I2: nat,J4: nat] :
            ( ( ord_less @ nat @ I2 @ J4 )
           => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P2 @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ A @ Xs2 @ J4 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_5198_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,I: nat,J3: nat] :
      ( ( sorted_wrt @ A @ P @ Xs )
     => ( ( ord_less @ nat @ I @ J3 )
       => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_5199_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_5200_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_5201_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,J3: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I )
              = ( nth @ A @ Xs @ J3 ) )
            = ( I = J3 ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5202_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs2: list @ A] :
          ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ! [J4: nat] :
                ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( I2 != J4 )
                 => ( ( nth @ A @ Xs2 @ I2 )
                   != ( nth @ A @ Xs2 @ J4 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5203_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X4: A] : X4
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_5204_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_5205_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I2: nat,J4: nat] :
                ( ( ord_less @ nat @ I2 @ J4 )
               => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_5206_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ? [X2: nat] :
            ( ( ord_less @ nat @ X2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X2 )
              = X3 )
            & ! [Y6: nat] :
                ( ( ( ord_less @ nat @ Y6 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y6 )
                    = X3 ) )
               => ( Y6 = X2 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5207_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_5208_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_5209_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert2 @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_5210_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I2: nat] :
                ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ ( suc @ I2 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_5211_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] :
          ( ( finite_finite @ A @ A2 )
         => ~ ! [L2: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
               => ( ( ( set2 @ A @ L2 )
                    = A2 )
                 => ( ( size_size @ ( list @ A ) @ L2 )
                   != ( finite_card @ A @ A2 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_5212_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I2: nat,J4: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J4 )
               => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_5213_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: nat,J3: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_5214_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I @ ( nth @ nat @ Ns @ I ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_5215_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A2: set @ nat,B3: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A2
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B3
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A2 @ B3 ) ) ) ) ).

% bij_betw_nth
thf(fact_5216_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L3: int] :
          ( if @ int
          @ ( ( member2 @ int @ K3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member2 @ int @ L3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_5217_and__int_Oelims,axiom,
    ! [X3: int,Xa: int,Y5: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X3 @ Xa )
        = Y5 )
     => ( ( ( ( member2 @ int @ X3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member2 @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y5
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member2 @ int @ X3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member2 @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y5
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_5218_and__int_Opelims,axiom,
    ! [X3: int,Xa: int,Y5: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X3 @ Xa ) )
       => ~ ( ( ( ( ( member2 @ int @ X3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member2 @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y5
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member2 @ int @ X3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member2 @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y5
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X3 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X3 @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_5219_empty__subsetI,axiom,
    ! [A: $tType,A2: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) ).

% empty_subsetI
thf(fact_5220_subset__empty,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_5221_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_5222_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_5223_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_5224_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_5225_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A3: A,A2: set @ A,B2: A] :
      ( ( ( insert2 @ A @ A3 @ A2 )
        = ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_5226_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A3: A,A2: set @ A] :
      ( ( ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert2 @ A @ A3 @ A2 ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_5227_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_5228_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) )
          = ( ~ ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_5229_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_5230_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A2 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% Diff_eq_empty_iff
thf(fact_5231_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_5232_card__0__eq,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ( finite_card @ A @ A2 )
          = ( zero_zero @ nat ) )
        = ( A2
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_5233_subset__Compl__singleton,axiom,
    ! [A: $tType,A2: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member2 @ A @ B2 @ A2 ) ) ) ).

% subset_Compl_singleton
thf(fact_5234_set__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X3 ) )
        = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_5235_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_5236_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_5237_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) ).

% bot.extremum
thf(fact_5238_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ( ( ( A3
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A3 ) ) ) ).

% bot.not_eq_extremum
thf(fact_5239_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_5240_not__psubset__empty,axiom,
    ! [A: $tType,A2: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_5241_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( minus_minus @ A @ X3 @ Y5 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ).

% diff_shunt_var
thf(fact_5242_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: set @ A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( A2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ A2 )
                & ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ A2 )
                   => ( ( ord_less_eq @ A @ Xa3 @ X2 )
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_5243_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: set @ A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( A2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ A2 )
                & ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ A2 )
                   => ( ( ord_less_eq @ A @ X2 @ Xa3 )
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_5244_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X9: set @ A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ? [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ X9 )
                    & ( ord_less @ A @ X2 @ Xa3 ) ) )
           => ~ ( finite_finite @ A @ X9 ) ) ) ) ).

% infinite_growing
thf(fact_5245_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
                & ~ ? [Xa3: A] :
                      ( ( member2 @ A @ Xa3 @ S2 )
                      & ( ord_less @ A @ Xa3 @ X2 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_5246_subset__singleton__iff,axiom,
    ! [A: $tType,X9: set @ A,A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X9 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X9
          = ( bot_bot @ ( set @ A ) ) )
        | ( X9
          = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_5247_subset__singletonD,axiom,
    ! [A: $tType,A2: set @ A,X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ( A2
          = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_5248_subset__Compl__self__eq,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_5249_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X2: B,S7: set @ B] :
                  ( ( finite_finite @ B @ S7 )
                 => ( ! [Y6: B] :
                        ( ( member2 @ B @ Y6 @ S7 )
                       => ( ord_less_eq @ A @ ( F2 @ Y6 ) @ ( F2 @ X2 ) ) )
                   => ( ( P @ S7 )
                     => ( P @ ( insert2 @ B @ X2 @ S7 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_5250_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A2 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X: A] :
                        ( ( member2 @ A @ X @ A8 )
                       => ( ord_less @ A @ B6 @ X ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert2 @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A2 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_5251_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A2 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X: A] :
                        ( ( member2 @ A @ X @ A8 )
                       => ( ord_less @ A @ X @ B6 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert2 @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A2 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_5252_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( A2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ A2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_5253_finite__subset__induct_H,axiom,
    ! [A: $tType,F4: set @ A,A2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A2 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A7: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member2 @ A @ A7 @ A2 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A2 )
                   => ( ~ ( member2 @ A @ A7 @ F6 )
                     => ( ( P @ F6 )
                       => ( P @ ( insert2 @ A @ A7 @ F6 ) ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_5254_finite__subset__induct,axiom,
    ! [A: $tType,F4: set @ A,A2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A2 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A7: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member2 @ A @ A7 @ A2 )
                 => ( ~ ( member2 @ A @ A7 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert2 @ A @ A7 @ F6 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_5255_card__eq__0__iff,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( ( finite_card @ A @ A2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A2 ) ) ) ).

% card_eq_0_iff
thf(fact_5256_Diff__single__insert,axiom,
    ! [A: $tType,A2: set @ A,X3: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ B3 ) ) ) ).

% Diff_single_insert
thf(fact_5257_subset__insert__iff,axiom,
    ! [A: $tType,A2: set @ A,X3: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ B3 ) )
      = ( ( ( member2 @ A @ X3 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
        & ( ~ ( member2 @ A @ X3 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ) ).

% subset_insert_iff
thf(fact_5258_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I3: B] :
                  ( ( member2 @ B @ I3 @ I5 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ).

% sum_pos
thf(fact_5259_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I3: A] :
                  ( ( member2 @ A @ I3 @ I5 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_5260_card__gt__0__iff,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A2 ) )
      = ( ( A2
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A2 ) ) ) ).

% card_gt_0_iff
thf(fact_5261_finite__remove__induct,axiom,
    ! [A: $tType,B3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
                 => ( ! [X: A] :
                        ( ( member2 @ A @ X @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% finite_remove_induct
thf(fact_5262_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B3: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B3 )
         => ( P @ B3 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
                 => ( ! [X: A] :
                        ( ( member2 @ A @ X @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% remove_induct
thf(fact_5263_card__Suc__eq,axiom,
    ! [A: $tType,A2: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A2 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A2
              = ( insert2 @ A @ B4 @ B8 ) )
            & ~ ( member2 @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B8
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_5264_card__eq__SucD,axiom,
    ! [A: $tType,A2: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A2 )
        = ( suc @ K ) )
     => ? [B6: A,B9: set @ A] :
          ( ( A2
            = ( insert2 @ A @ B6 @ B9 ) )
          & ~ ( member2 @ A @ B6 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_5265_card__1__singleton__iff,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( ( finite_card @ A @ A2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X4: A] :
            ( A2
            = ( insert2 @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_5266_card__Diff1__le,axiom,
    ! [A: $tType,A2: set @ A,X3: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A2 ) ) ).

% card_Diff1_le
thf(fact_5267_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S2 )
             => ( ( P @ T7 )
               => ? [X: A] :
                    ( ( member2 @ A @ X @ ( minus_minus @ ( set @ A ) @ S2 @ T7 ) )
                    & ( P @ ( insert2 @ A @ X @ T7 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_5268_psubset__insert__iff,axiom,
    ! [A: $tType,A2: set @ A,X3: A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ B3 ) )
      = ( ( ( member2 @ A @ X3 @ B3 )
         => ( ord_less @ ( set @ A ) @ A2 @ B3 ) )
        & ( ~ ( member2 @ A @ X3 @ B3 )
         => ( ( ( member2 @ A @ X3 @ A2 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
            & ( ~ ( member2 @ A @ X3 @ A2 )
             => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_5269_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X3 ) )
      = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_5270_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X3 ) )
          = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_5271_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I2: int,J4: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J4 @ I2 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert2 @ int @ I2 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J4 ) ) ) ) ) ).

% simp_from_to
thf(fact_5272_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ A2 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                  & ( ord_less @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) ) )
           => ( ( A2
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_5273_card__2__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X4: A,Y: A] :
            ( ( S2
              = ( insert2 @ A @ X4 @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X4 != Y ) ) ) ) ).

% card_2_iff
thf(fact_5274_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,X3: B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( member2 @ B @ X3 @ A2 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
              = ( plus_plus @ A @ ( G @ X3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_5275_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A,X3: B] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
            = ( plus_plus @ A @ ( G @ X3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_5276_card__3__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X4: A,Y: A,Z3: A] :
            ( ( S2
              = ( insert2 @ A @ X4 @ ( insert2 @ A @ Y @ ( insert2 @ A @ Z3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X4 != Y )
            & ( Y != Z3 )
            & ( X4 != Z3 ) ) ) ) ).

% card_3_iff
thf(fact_5277_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A2 ) )
     => ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_5278_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,G: B > A,X3: B] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X3 @ A2 ) )
            = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_5279_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,X3: B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( member2 @ B @ X3 @ A2 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A2 )
              = ( times_times @ A @ ( G @ X3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_5280_card__Diff1__less__iff,axiom,
    ! [A: $tType,A2: set @ A,X3: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A2 ) )
      = ( ( finite_finite @ A @ A2 )
        & ( member2 @ A @ X3 @ A2 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5281_card__Diff2__less,axiom,
    ! [A: $tType,A2: set @ A,X3: A,Y5: A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( member2 @ A @ X3 @ A2 )
       => ( ( member2 @ A @ Y5 @ A2 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert2 @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A2 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5282_card__Diff1__less,axiom,
    ! [A: $tType,A2: set @ A,X3: A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( member2 @ A @ X3 @ A2 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A2 ) ) ) ) ).

% card_Diff1_less
thf(fact_5283_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A3: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member2 @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member2 @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_5284_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A3: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member2 @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member2 @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A3 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_5285_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I: C,A2: set @ C,F2: C > B] :
          ( ( member2 @ C @ I @ A2 )
         => ( ! [X2: C] :
                ( ( member2 @ C @ X2 @ ( minus_minus @ ( set @ C ) @ A2 @ ( insert2 @ C @ I @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X2 ) ) )
           => ( ( finite_finite @ C @ A2 )
             => ( ord_less_eq @ B @ ( F2 @ I ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A2 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_5286_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A2 ) ) ) ) )
         => ( ( finite_finite @ B @ A2 )
           => ( ( A2
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5287_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: set @ B,F2: B > A,A3: B] :
          ( ( finite_finite @ B @ A2 )
         => ( ( ( F2 @ A3 )
             != ( zero_zero @ A ) )
           => ( ( ( member2 @ B @ A3 @ A2 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( F2 @ A3 ) ) ) )
              & ( ~ ( member2 @ B @ A3 @ A2 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_5288_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( sinh @ A @ X3 )
            = ( zero_zero @ A ) )
          = ( member2 @ A @ ( exp @ A @ X3 ) @ ( insert2 @ A @ ( one_one @ A ) @ ( insert2 @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_5289_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K2: int,L2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L2 ) )
           => ( ( ~ ( ( member2 @ int @ K2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member2 @ int @ L2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_5290_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member2 @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member2 @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member2 @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member2 @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_5291_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ~ ! [L2: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L2 ) )
               => ( ( ( set2 @ B @ L2 )
                    = A2 )
                 => ( ( size_size @ ( list @ B ) @ L2 )
                   != ( finite_card @ B @ A2 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_5292_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I5: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I2: A] :
                    ( ( member2 @ A @ I2 @ I5 )
                    & ( ( F2 @ I2 )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member2 @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I ) ) ) )
              & ( ~ ( member2 @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_5293_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys2 ) )
      = ( distinct @ A @ Ys2 ) ) ).

% distinct_union
thf(fact_5294_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_5295_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_5296_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_5297_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_5298_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P3: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P3 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_5299_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_5300_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,P3: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member2 @ B @ X4 @ I5 )
                  & ( ( P3 @ X4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member2 @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P3 @ ( insert2 @ B @ I @ I5 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P3 @ I5 ) ) )
            & ( ~ ( member2 @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P3 @ ( insert2 @ B @ I @ I5 ) )
                = ( plus_plus @ A @ ( P3 @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ P3 @ I5 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_5301_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_5302_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_5303_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member2 @ B @ X4 @ I5 )
                  & ( ( G @ X4 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) ) ) ).

% sum.non_neutral'
thf(fact_5304_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_5305_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_5306_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I2: B] : ( plus_plus @ A @ ( G @ I2 ) @ ( H @ I2 ) )
              @ I5 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I5 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_5307_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_5308_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A,H: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ S2 )
                 => ( ( G @ X2 )
                    = ( H @ X2 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_5309_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,H: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H @ I3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ S2 )
                 => ( ( G @ X2 )
                    = ( H @ X2 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_5310_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X2 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_5311_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X2 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_5312_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member2 @ B @ X4 @ I5 )
                  & ( ( G @ X4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X4: B] :
                    ( ( member2 @ B @ X4 @ I5 )
                    & ( ( H @ X4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I2: B] : ( plus_plus @ A @ ( G @ I2 ) @ ( H @ I2 ) )
                @ I5 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I5 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_5313_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P6: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X4: B] :
                      ( ( member2 @ B @ X4 @ I7 )
                      & ( ( P6 @ X4 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X4: B] :
                      ( ( member2 @ B @ X4 @ I7 )
                      & ( ( P6 @ X4 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_5314_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert2 @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_5315_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_5316_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_5317_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert2 @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_5318_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I5: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I2: A] :
                  ( ( member2 @ A @ I2 @ I5 )
                  & ( ( F2 @ I2 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member2 @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I ) ) ) )
            & ( ~ ( member2 @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_5319_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L ) )
              & ( ( set2 @ B @ L )
                = A2 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A2 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_5320_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S2 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_5321_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X3 ) )
          = ( insert2 @ A @ X3 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5322_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X3: A,Y5: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ I @ Y5 )
      = ( list_update @ A @ Xs @ I @ Y5 ) ) ).

% list_update_overwrite
thf(fact_5323_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X3: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I @ X3 ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_5324_nth__list__update__neq,axiom,
    ! [A: $tType,I: nat,J3: nat,Xs: list @ A,X3: A] :
      ( ( I != J3 )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ J3 )
        = ( nth @ A @ Xs @ J3 ) ) ) ).

% nth_list_update_neq
thf(fact_5325_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I: nat] :
      ( ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ I ) )
      = Xs ) ).

% list_update_id
thf(fact_5326_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X3: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I )
     => ( ( list_update @ A @ Xs @ I @ X3 )
        = Xs ) ) ).

% list_update_beyond
thf(fact_5327_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,Y5: A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs @ M @ Y5 ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_update_cancel
thf(fact_5328_nth__list__update__eq,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,X3: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ I )
        = X3 ) ) ).

% nth_list_update_eq
thf(fact_5329_set__swap,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J3: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ J3 ) ) @ J3 @ ( nth @ A @ Xs @ I ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_5330_distinct__swap,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J3: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ J3 ) ) @ J3 @ ( nth @ A @ Xs @ I ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_5331_take__update__swap,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X3: A] :
      ( ( take @ A @ M @ ( list_update @ A @ Xs @ N @ X3 ) )
      = ( list_update @ A @ ( take @ A @ M @ Xs ) @ N @ X3 ) ) ).

% take_update_swap
thf(fact_5332_list__update__swap,axiom,
    ! [A: $tType,I: nat,I8: nat,Xs: list @ A,X3: A,X8: A] :
      ( ( I != I8 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ I8 @ X8 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I8 @ X8 ) @ I @ X3 ) ) ) ).

% list_update_swap
thf(fact_5333_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_5334_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,K: nat,Y5: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs @ K @ Y5 ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs ) @ K @ ( F2 @ Y5 ) ) ) ).

% map_update
thf(fact_5335_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A2: set @ A,X3: A,I: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A2 )
     => ( ( member2 @ A @ X3 @ A2 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I @ X3 ) ) @ A2 ) ) ) ).

% set_update_subsetI
thf(fact_5336_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X3: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I @ X3 ) ) @ ( insert2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_5337_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,X3: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member2 @ A @ X3 @ ( set2 @ A @ ( list_update @ A @ Xs @ N @ X3 ) ) ) ) ).

% set_update_memI
thf(fact_5338_nth__list__update,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J3: nat,X3: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I = J3 )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ J3 )
            = X3 ) )
        & ( ( I != J3 )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ J3 )
            = ( nth @ A @ Xs @ J3 ) ) ) ) ) ).

% nth_list_update
thf(fact_5339_list__update__same__conv,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,X3: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I @ X3 )
          = Xs )
        = ( ( nth @ A @ Xs @ I )
          = X3 ) ) ) ).

% list_update_same_conv
thf(fact_5340_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B,B3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( ( ord_less_eq @ ( set @ B ) @ B3 @ S2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ B3 ) )
           => ( ( finite_finite @ B @ A2 )
             => ( ( finite_finite @ B @ B3 )
               => ( A2 = B3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_5341_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) )
            = A2 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_5342_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) )
          = ( finite_card @ B @ A2 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_5343_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_5344_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_5345_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_5346_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X3: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X3 ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_5347_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A3: A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member2 @ A @ A3 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ I ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I @ A3 ) ) ) ) ).

% distinct_list_update
thf(fact_5348_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X3: B,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X3 @ A2 ) @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert2 @ B @ X3 @ A2 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_5349_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X3: B,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X3 @ A2 ) @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ( ~ ( member2 @ B @ X3 @ A2 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert2 @ B @ X3 @ A2 ) )
              = ( insort_key @ A @ B @ Less_eq @ F2 @ X3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_5350_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X3: B,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X3 @ A2 ) @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_5351_in__set__remove1,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( A3 != B2 )
     => ( ( member2 @ A @ A3 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_5352_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X3 @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5353_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X3 @ Xs ) ) ) ).

% distinct_remove1
thf(fact_5354_remove1__commute,axiom,
    ! [A: $tType,X3: A,Y5: A,Zs: list @ A] :
      ( ( remove1 @ A @ X3 @ ( remove1 @ A @ Y5 @ Zs ) )
      = ( remove1 @ A @ Y5 @ ( remove1 @ A @ X3 @ Zs ) ) ) ).

% remove1_commute
thf(fact_5355_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_5356_notin__set__remove1,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ~ ( member2 @ A @ X3 @ ( set2 @ A @ ( remove1 @ A @ Y5 @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_5357_remove1__idem,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X3 @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_5358_set__remove1__subset,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X3 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_5359_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A3 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_5360_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X3: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X3 @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_5361_length__remove1,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X3 @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X3 @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_5362_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X3: B,Xs: list @ B,F2: B > A] :
          ( ( member2 @ B @ X3 @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) )
            = ( plus_plus @ A @ ( F2 @ X3 ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X3 @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_5363_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A2 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A2 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A2 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_5364_card__Pow,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A2 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A2 ) ) ) ) ).

% card_Pow
thf(fact_5365_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_5366_Pow__iff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( member2 @ ( set @ A ) @ A2 @ ( pow2 @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% Pow_iff
thf(fact_5367_PowI,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( member2 @ ( set @ A ) @ A2 @ ( pow2 @ A @ B3 ) ) ) ).

% PowI
thf(fact_5368_sorted__list__of__set__range,axiom,
    ! [M: nat,N: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% sorted_list_of_set_range
thf(fact_5369_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A2 ) )
            = A2 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_5370_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A2 ) )
          = ( finite_card @ A @ A2 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_5371_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_div_numeral
thf(fact_5372_fst__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( divide_divide @ nat @ M @ N ) ) ).

% fst_divmod_nat
thf(fact_5373_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_5374_PowD,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( member2 @ ( set @ A ) @ A2 @ ( pow2 @ A @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% PowD
thf(fact_5375_Pow__mono,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A2 ) @ ( pow2 @ A @ B3 ) ) ) ).

% Pow_mono
thf(fact_5376_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A4: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A4 ) ) ) ) ).

% Pow_def
thf(fact_5377_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,B3: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A2 )
            = ( linord4507533701916653071of_set @ A @ B3 ) )
         => ( ( finite_finite @ A @ A2 )
           => ( ( finite_finite @ A @ B3 )
             => ( A2 = B3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_5378_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A2 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_5379_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A2 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_5380_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A2 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_5381_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% fst_divmod
thf(fact_5382_binomial__def,axiom,
    ( binomial
    = ( ^ [N2: nat,K3: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K6: set @ nat] :
                ( ( member2 @ ( set @ nat ) @ K6 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
                & ( ( finite_card @ nat @ K6 )
                  = K3 ) ) ) ) ) ) ).

% binomial_def
thf(fact_5383_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_5384_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X3 @ ( linord4507533701916653071of_set @ A @ A2 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5385_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_5386_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_5387_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_5388_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_5389_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A3 ) ) ) ).

% drop_bit_drop_bit
thf(fact_5390_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_5391_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A3 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_5392_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A3 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_5393_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_5394_fst__divmod__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L ) )
      = ( divide_divide @ code_integer @ K @ L ) ) ).

% fst_divmod_integer
thf(fact_5395_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_5396_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_5397_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_5398_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_5399_fst__divmod__abs,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L ) )
      = ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L ) ) ) ).

% fst_divmod_abs
thf(fact_5400_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_5401_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_5402_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5403_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_mod_numeral
thf(fact_5404_map__snd__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_5405_snd__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_snd @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( modulo_modulo @ nat @ M @ N ) ) ).

% snd_divmod_nat
thf(fact_5406_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_5407_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_5408_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_5409_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_5410_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_5411_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_5412_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys2: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys2 ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys2 ) )
       => ( Xs = Ys2 ) ) ) ).

% pair_list_eqI
thf(fact_5413_distinct__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ).

% distinct_enumerate
thf(fact_5414_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_5415_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_5416_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
            = A3 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_5417_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_5418_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A3 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_5419_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A3 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_5420_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_5421_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% snd_divmod
thf(fact_5422_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( divide_divide @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5423_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A5 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5424_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) )
          = A3 ) ) ).

% bits_ident
thf(fact_5425_in__set__enumerate__eq,axiom,
    ! [A: $tType,P3: product_prod @ nat @ A,N: nat,Xs: list @ A] :
      ( ( member2 @ ( product_prod @ nat @ A ) @ P3 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P3 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P3 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P3 ) @ N ) )
          = ( product_snd @ nat @ A @ P3 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_5426_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N @ A3 )
            = A3 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_5427_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_5428_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N2: nat,K3: int] : ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_int_def
thf(fact_5429_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A5: A] : ( divide_divide @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_5430_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ A3 )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_5431_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_5432_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A5 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_5433_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: nat > A,M: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F2 @ ( upt @ N @ M ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K3: nat] : ( product_Pair @ nat @ A @ K3 @ ( F2 @ K3 ) )
        @ ( upt @ N @ M ) ) ) ).

% enumerate_map_upt
thf(fact_5434_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_5435_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A3: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M @ A3 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A3 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_5436_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,M: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_5437_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5438_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A5: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ A5
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_5439_bezw_Oelims,axiom,
    ! [X3: nat,Xa: nat,Y5: product_prod @ int @ int] :
      ( ( ( bezw @ X3 @ Xa )
        = Y5 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y5
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y5
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X3 @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_5440_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X4: nat,Y: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X4 @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X4 @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X4 @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X4 @ Y ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_5441_bezw_Opelims,axiom,
    ! [X3: nat,Xa: nat,Y5: product_prod @ int @ int] :
      ( ( ( bezw @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X3 @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y5
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y5
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X3 @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X3 @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_5442_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_5443_drop__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_5444_quotient__of__denom__pos_H,axiom,
    ! [R2: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R2 ) ) ) ).

% quotient_of_denom_pos'
thf(fact_5445_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_5446_bezw__non__0,axiom,
    ! [Y5: nat,X3: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y5 )
     => ( ( bezw @ X3 @ Y5 )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X3 @ Y5 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X3 @ Y5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X3 @ Y5 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X3 @ Y5 ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_5447_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_5448_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_5449_minus__numeral__mod__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_5450_numeral__mod__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_5451_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L3: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L3 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_5452_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5453_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F3: A > nat,G2: B > nat,P6: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F3 @ ( product_fst @ A @ B @ P6 ) ) @ ( G2 @ ( product_snd @ A @ B @ P6 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5454_finite__enumerate,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [R: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S2 ) ) )
          & ! [N7: nat] :
              ( ( ord_less @ nat @ N7 @ ( finite_card @ nat @ S2 ) )
             => ( member2 @ nat @ ( R @ N7 ) @ S2 ) ) ) ) ).

% finite_enumerate
thf(fact_5455_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_5456_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add1
thf(fact_5457_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add2
thf(fact_5458_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_5459_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A3: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A3 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N ) @ A3 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5460_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A3: A,N: num] :
          ( ( gcd_gcd @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_gcd @ A @ A3 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5461_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_5462_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X3: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ X3 )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N ) @ X3 ) ) ).

% gcd_neg_numeral_1_int
thf(fact_5463_gcd__neg__numeral__2__int,axiom,
    ! [X3: int,N: num] :
      ( ( gcd_gcd @ int @ X3 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( gcd_gcd @ int @ X3 @ ( numeral_numeral @ int @ N ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_5464_gcd__0__left__int,axiom,
    ! [X3: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X3 )
      = ( abs_abs @ int @ X3 ) ) ).

% gcd_0_left_int
thf(fact_5465_gcd__0__int,axiom,
    ! [X3: int] :
      ( ( gcd_gcd @ int @ X3 @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X3 ) ) ).

% gcd_0_int
thf(fact_5466_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add_mult
thf(fact_5467_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_5468_gcd__ge__0__int,axiom,
    ! [X3: int,Y5: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X3 @ Y5 ) ) ).

% gcd_ge_0_int
thf(fact_5469_bezout__int,axiom,
    ! [X3: int,Y5: int] :
    ? [U3: int,V3: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U3 @ X3 ) @ ( times_times @ int @ V3 @ Y5 ) )
      = ( gcd_gcd @ int @ X3 @ Y5 ) ) ).

% bezout_int
thf(fact_5470_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) ) ) ).

% gcd_mult_distrib_int
thf(fact_5471_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_5472_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_5473_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_5474_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A3 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_5475_gcd__le1__int,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A3 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A3 @ B2 ) @ A3 ) ) ).

% gcd_le1_int
thf(fact_5476_gcd__le2__int,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A3 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5477_gcd__cases__int,axiom,
    ! [X3: int,Y5: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
         => ( P @ ( gcd_gcd @ int @ X3 @ Y5 ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
         => ( ( ord_less_eq @ int @ Y5 @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X3 @ ( uminus_uminus @ int @ Y5 ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X3 @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y5 )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X3 ) @ Y5 ) ) ) )
         => ( ( ( ord_less_eq @ int @ X3 @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y5 @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X3 ) @ ( uminus_uminus @ int @ Y5 ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X3 @ Y5 ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5478_gcd__unique__int,axiom,
    ! [D2: int,A3: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A3 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A3 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A3 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5479_gcd__non__0__int,axiom,
    ! [Y5: int,X3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y5 )
     => ( ( gcd_gcd @ int @ X3 @ Y5 )
        = ( gcd_gcd @ int @ Y5 @ ( modulo_modulo @ int @ X3 @ Y5 ) ) ) ) ).

% gcd_non_0_int
thf(fact_5480_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K3: int,L3: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L3
              = ( zero_zero @ int ) )
            @ K3
            @ ( gcd_gcd @ int @ L3 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K3 ) @ ( abs_abs @ int @ L3 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5481_less__by__empty,axiom,
    ! [A: $tType,A2: set @ ( product_prod @ A @ A ),B3: set @ ( product_prod @ A @ A )] :
      ( ( A2
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A2 @ B3 ) ) ).

% less_by_empty
thf(fact_5482_nat__descend__induct,axiom,
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
           => ( ! [I4: nat] :
                  ( ( ord_less @ nat @ K2 @ I4 )
                 => ( P @ I4 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_5483_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F3: A > B,A4: set @ A] :
            ! [R5: A,S4: A] :
              ( ( ( member2 @ A @ R5 @ A4 )
                & ( member2 @ A @ S4 @ A4 )
                & ( ord_less @ A @ R5 @ S4 ) )
             => ( ord_less @ B @ ( F3 @ R5 ) @ ( F3 @ S4 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5484_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A2: set @ A,F2: A > B] :
          ( ! [R: A,S3: A] :
              ( ( member2 @ A @ R @ A2 )
             => ( ( member2 @ A @ S3 @ A2 )
               => ( ( ord_less @ A @ R @ S3 )
                 => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A2 ) ) ) ).

% strict_mono_onI
thf(fact_5485_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A2: set @ A,R2: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A2 )
         => ( ( member2 @ A @ R2 @ A2 )
           => ( ( member2 @ A @ S @ A2 )
             => ( ( ord_less @ A @ R2 @ S )
               => ( ord_less @ B @ ( F2 @ R2 ) @ ( F2 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5486_gcd__0__left__nat,axiom,
    ! [X3: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X3 )
      = X3 ) ).

% gcd_0_left_nat
thf(fact_5487_gcd__0__nat,axiom,
    ! [X3: nat] :
      ( ( gcd_gcd @ nat @ X3 @ ( zero_zero @ nat ) )
      = X3 ) ).

% gcd_0_nat
thf(fact_5488_gcd__nat_Oright__neutral,axiom,
    ! [A3: nat] :
      ( ( gcd_gcd @ nat @ A3 @ ( zero_zero @ nat ) )
      = A3 ) ).

% gcd_nat.right_neutral
thf(fact_5489_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A3 @ B2 ) )
      = ( ( A3
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_5490_gcd__nat_Oleft__neutral,axiom,
    ! [A3: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A3 )
      = A3 ) ).

% gcd_nat.left_neutral
thf(fact_5491_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A3: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A3 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_5492_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5493_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5494_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5495_gcd__le2__nat,axiom,
    ! [B2: nat,A3: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A3 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5496_gcd__le1__nat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A3 @ B2 ) @ A3 ) ) ).

% gcd_le1_nat
thf(fact_5497_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N @ M ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff2_nat
thf(fact_5498_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff1_nat
thf(fact_5499_gcd__nat_Oelims,axiom,
    ! [X3: nat,Xa: nat,Y5: nat] :
      ( ( ( gcd_gcd @ nat @ X3 @ Xa )
        = Y5 )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y5 = X3 ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y5
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5500_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X4: nat,Y: nat] :
          ( if @ nat
          @ ( Y
            = ( zero_zero @ nat ) )
          @ X4
          @ ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X4 @ Y ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5501_gcd__non__0__nat,axiom,
    ! [Y5: nat,X3: nat] :
      ( ( Y5
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X3 @ Y5 )
        = ( gcd_gcd @ nat @ Y5 @ ( modulo_modulo @ nat @ X3 @ Y5 ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5502_bezout__nat,axiom,
    ! [A3: nat,B2: nat] :
      ( ( A3
       != ( zero_zero @ nat ) )
     => ? [X2: nat,Y2: nat] :
          ( ( times_times @ nat @ A3 @ X2 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ ( gcd_gcd @ nat @ A3 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5503_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A3: nat] :
    ? [X2: nat,Y2: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ ( times_times @ nat @ A3 @ X2 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A3 @ X2 ) @ ( times_times @ nat @ B2 @ Y2 ) )
          = ( gcd_gcd @ nat @ A3 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A3 @ Y2 ) @ ( times_times @ nat @ B2 @ X2 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X2 ) @ ( times_times @ nat @ A3 @ Y2 ) )
          = ( gcd_gcd @ nat @ A3 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5504_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K3: code_integer,L3: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L3
              = ( zero_zero @ code_integer ) )
            @ K3
            @ ( gcd_gcd @ code_integer @ L3 @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L3 ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_5505_bezw__aux,axiom,
    ! [X3: nat,Y5: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X3 @ Y5 ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X3 @ Y5 ) ) @ ( semiring_1_of_nat @ int @ X3 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X3 @ Y5 ) ) @ ( semiring_1_of_nat @ int @ Y5 ) ) ) ) ).

% bezw_aux
thf(fact_5506_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A2: set @ A,X3: A,Y5: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A2 )
         => ( ( member2 @ A @ X3 @ A2 )
           => ( ( member2 @ A @ Y5 @ A2 )
             => ( ( ord_less_eq @ A @ X3 @ Y5 )
               => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_5507_gcd__nat_Opelims,axiom,
    ! [X3: nat,Xa: nat,Y5: nat] :
      ( ( ( gcd_gcd @ nat @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X3 @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y5 = X3 ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y5
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X3 @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X3 @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5508_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L3
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L3
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K3 )
                  = ( sgn_sgn @ code_integer @ L3 ) )
                @ ( code_divmod_abs @ K3 @ L3 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S4: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S4
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L3 ) @ S4 ) ) )
                  @ ( code_divmod_abs @ K3 @ L3 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5509_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_5510_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G ) ) ) ).

% map_comp_map
thf(fact_5511_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G ) @ Xs ) ) ).

% map_map
thf(fact_5512_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_5513_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F2: A > B,V: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F2 @ V ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F2 ) @ V ) ) ).

% list.map_comp
thf(fact_5514_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) ) ) ).

% List.map.comp
thf(fact_5515_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_5516_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_5517_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_5518_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_5519_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_5520_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H: B > A,G: C > B,A2: set @ C] :
          ( ( ( H @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X2: B,Y2: B] :
                ( ( H @ ( plus_plus @ B @ X2 @ Y2 ) )
                = ( plus_plus @ A @ ( H @ X2 ) @ ( H @ Y2 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H @ G ) @ A2 )
              = ( H @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A2 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5521_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J3: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J3 @ ( suc @ I ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J3 ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5522_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5523_xor__minus__numerals_I1_J,axiom,
    ! [N: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5524_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member2 @ A @ I @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5525_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G ) @ Xs ) ) ).

% size_list_map
thf(fact_5526_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5527_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5528_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5529_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5530_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5531_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5532_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5533_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5534_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y5: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y5 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y5 ) ) ) ).

% semiring_norm(167)
thf(fact_5535_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y5: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y5 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y5 ) ) ) ).

% semiring_norm(166)
thf(fact_5536_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5537_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5538_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5539_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5540_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5541_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_5542_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5543_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5544_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5545_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5546_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5547_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5548_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5549_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5550_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5551_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5552_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5553_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5554_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5555_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_5556_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5557_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K3: num,L3: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K3 ) @ ( numeral_numeral @ A @ L3 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5558_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X3: B,Y5: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( member2 @ B @ X3 @ S2 )
       => ( ( member2 @ B @ Y5 @ S2 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y5 ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X3 ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X3 ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y5 ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_5559_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5560_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5561_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5562_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5563_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A3 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5564_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5565_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N2 ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5566_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_5567_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_5568_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_5569_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_5570_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_5571_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ M3 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_5572_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5573_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5574_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5575_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5576_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5577_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5578_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5579_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5580_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5581_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5582_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5583_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5584_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5585_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5586_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5587_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5588_Code__Numeral_Onegative__def,axiom,
    ( code_negative
    = ( comp @ code_integer @ code_integer @ num @ ( uminus_uminus @ code_integer ) @ ( numeral_numeral @ code_integer ) ) ) ).

% Code_Numeral.negative_def
thf(fact_5589_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_5590_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X3: B,B2: A,A3: A] :
          ( ( nO_MATCH @ B @ A @ X3 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5591_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X3: B,B2: A,A3: A] :
          ( ( nO_MATCH @ B @ A @ X3 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5592_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A,Y5: A,A3: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X3 @ Y5 ) @ A3 )
         => ( ( real_V8093663219630862766scaleR @ A @ A3 @ ( plus_plus @ A @ X3 @ Y5 ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5593_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A,Y5: A,A3: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X3 @ Y5 ) @ A3 )
         => ( ( real_V8093663219630862766scaleR @ A @ A3 @ ( minus_minus @ A @ X3 @ Y5 ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ A3 @ Y5 ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5594_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X3: B,Y5: B,C2: A,A3: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y5 ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5595_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X3: B,Y5: B,A3: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y5 ) @ A3 )
         => ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5596_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X3: B,Y5: B,A3: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y5 ) @ A3 )
         => ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5597_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X3: B,Y5: B,C2: A,A3: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X3 @ Y5 ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5598_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X3 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X3 ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X3 @ N ) ) ) ) ) ).

% power_minus'
thf(fact_5599_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A,Y5: A,C2: C,A3: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X3 @ Y5 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A3 @ B2 ) @ X3 )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5600_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X3: A,Y5: A,C2: C,A3: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X3 @ Y5 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A3 @ B2 ) @ X3 )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A3 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X3 ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5601_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5602_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F3: A > B] :
            ? [K6: real] :
            ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5603_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs2: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( times_times @ A @ A5 ) @ ( F3 @ ( nth @ B @ Xs2 @ N2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5604_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_5605_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X3: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X3 )
      = X3 ) ).

% funpow_0
thf(fact_5606_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow_add
thf(fact_5607_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_5608_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_5609_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% comp_funpow
thf(fact_5610_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F2 ) ) ).

% funpow_mult
thf(fact_5611_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N: nat,X3: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N @ F2 @ X3 ) )
      = ( compow @ ( A > A ) @ N @ F2 @ ( F2 @ X3 ) ) ) ).

% funpow_swap1
thf(fact_5612_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F2: A > A,X3: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ X3 )
        = X3 )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N ) @ F2 @ X3 )
        = ( compow @ ( A > A ) @ M @ F2 @ X3 ) ) ) ).

% funpow_mod_eq
thf(fact_5613_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S2: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S2 @ S2 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ S2 @ S2 ) ) ).

% bij_betw_funpow
thf(fact_5614_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X3: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X3 ) @ ( times_times @ A @ X3 ) )
          = ( times_times @ A @ ( power_power @ A @ X3 @ ( F2 @ X3 ) ) ) ) ) ).

% funpow_times_power
thf(fact_5615_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5616_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A3: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A3 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A3 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5617_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K3: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K3 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5618_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N2: nat,P2: A > A > $o,X4: A,Y: A] :
          ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = X4 )
            & ( ( F3 @ N2 )
              = Y )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ N2 )
               => ( P2 @ ( F3 @ I2 ) @ ( F3 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5619_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5620_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_5621_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_5622_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R4 )
      = ( ^ [Y3: A,Z: A] : ( Y3 = Z ) ) ) ).

% relpowp.simps(1)
thf(fact_5623_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X3: A,Y5: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X3 @ Y5 )
     => ( X3 = Y5 ) ) ).

% relpowp_0_E
thf(fact_5624_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X3: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X3 @ X3 ) ).

% relpowp_0_I
thf(fact_5625_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_5626_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_5627_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X3: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X3 @ Z2 )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X3 != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( compow @ ( A > A > $o ) @ M4 @ P @ X3 @ Y2 )
               => ~ ( P @ Y2 @ Z2 ) ) ) ) ) ).

% relpowp_E
thf(fact_5628_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X3: A,Z2: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X3 @ Z2 )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X3 != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( P @ X3 @ Y2 )
               => ~ ( compow @ ( A > A > $o ) @ M4 @ P @ Y2 @ Z2 ) ) ) ) ) ).

% relpowp_E2
thf(fact_5629_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5630_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L3: code_integer,J4: code_integer] :
                ( if @ nat
                @ ( J4
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L3 ) @ ( code_nat_of_integer @ L3 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L3 ) @ ( code_nat_of_integer @ L3 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_5631_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X3 @ A2 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X3
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5632_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X4: nat,Y: nat] : ( ord_less_eq @ nat @ Y @ X4 )
    @ ^ [X4: nat,Y: nat] : ( ord_less @ nat @ Y @ X4 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5633_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X3: B,F2: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X3 @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_5634_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_5635_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( finite_finite @ A @ A2 )
         => ( ~ ( member2 @ A @ X3 @ A2 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X3 @ A2 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ X3
                @ ( linord4507533701916653071of_set @ A @ A2 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_5636_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Y5: B,Xs: list @ B] :
          ( ( ( F2 @ X3 )
           != ( F2 @ Y5 ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y5 @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X3 @ ( linorder_insort_key @ B @ A @ F2 @ Y5 @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_5637_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X4: A] : X4
            @ X3
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Y5
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X4: A] : X4
            @ Y5
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X3
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_5638_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y5: A,X3: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Y5 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X3 ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X3 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Y5 ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_5639_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
          = ( insert2 @ B @ X3 @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_5640_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
          = ( ~ ( member2 @ B @ X3 @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_5641_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X3
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_5642_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_5643_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,Xs: list @ A] :
          ( ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ A3
                @ ( remove1 @ A @ A3 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_5644_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M3: nat,N2: nat] :
        ( ( dvd_dvd @ nat @ M3 @ N2 )
        & ( M3 != N2 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_5645_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( member2 @ A @ X3 @ A2 )
           => ( ( linord4507533701916653071of_set @ A @ A2 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ X3
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5646_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J3: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J3 @ I ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J3 ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5647_card__UNION,axiom,
    ! [A: $tType,A2: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A2 )
     => ( ! [X2: set @ A] :
            ( ( member2 @ ( set @ A ) @ X2 @ A2 )
           => ( finite_finite @ A @ X2 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A2 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5648_set__removeAll,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X3 @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5649_removeAll__id,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X3 @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_5650_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
            = Y5 ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5651_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
            = X3 ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5652_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X3 @ Y5 ) )
            = Y5 ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5653_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X3 @ Y5 ) )
            = X3 ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5654_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member2 @ A @ I @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5655_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_5656_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5657_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5658_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5659_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X3 @ Y5 ) )
            = Y5 ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5660_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X3 @ Y5 ) )
            = Y5 ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_5661_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X3 @ Y5 ) )
            = X3 ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5662_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X3 @ Y5 ) )
            = X3 ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_5663_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A3 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A3 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A3 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_5664_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X3 @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_5665_card__Union__le__sum__card,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ).

% card_Union_le_sum_card
thf(fact_5666_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            | ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_5667_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5668_length__removeAll__less__eq,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_5669_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A3: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ A3 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A3 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5670_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: set @ ( set @ B ),G: B > A] :
          ( ! [X2: set @ B] :
              ( ( member2 @ ( set @ B ) @ X2 @ B3 )
             => ( finite_finite @ B @ X2 ) )
         => ( ! [A14: set @ B] :
                ( ( member2 @ ( set @ B ) @ A14 @ B3 )
               => ! [A25: set @ B] :
                    ( ( member2 @ ( set @ B ) @ A25 @ B3 )
                   => ( ( A14 != A25 )
                     => ! [X2: B] :
                          ( ( member2 @ B @ X2 @ A14 )
                         => ( ( member2 @ B @ X2 @ A25 )
                           => ( ( G @ X2 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B3 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_5671_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] :
      ( ! [X2: set @ A] :
          ( ( member2 @ ( set @ A ) @ X2 @ U4 )
         => ( finite_finite @ A @ X2 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5672_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X3 @ Xs )
        = ( removeAll @ A @ X3 @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_5673_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ ( suc @ M3 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_5674_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ L ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E ) ) ) ) ).

% cInf_asclose
thf(fact_5675_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ L ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E ) ) ) ) ).

% cSup_asclose
thf(fact_5676_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_5677_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_5678_length__removeAll__less,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X3 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_5679_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5680_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5681_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A3 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A3 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5682_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y5 @ X3 ) )
            = Y5 ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_5683_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y5 @ X3 ) )
            = Y5 ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5684_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y5 @ X3 ) )
            = X3 ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_5685_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_5686_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y5 @ X3 ) )
            = X3 ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5687_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y5 @ X3 ) )
            = Y5 ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5688_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y5 @ X3 ) )
            = X3 ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5689_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y5 @ X3 ) )
            = Y5 ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5690_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y5 @ X3 ) )
            = X3 ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5691_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A3: A] :
        ? [B6: A] :
          ( ( ord_less @ A @ A3 @ B6 )
          | ( ord_less @ A @ B6 @ A3 ) ) ) ).

% ex_gt_or_lt
thf(fact_5692_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A3: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( P @ A3 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A3 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X: A] :
                      ( ( ( ord_less_eq @ A @ A3 @ X )
                        & ( ord_less @ A @ X @ C3 ) )
                     => ( P @ X ) )
                  & ! [D6: A] :
                      ( ! [X2: A] :
                          ( ( ( ord_less_eq @ A @ A3 @ X2 )
                            & ( ord_less @ A @ X2 @ D6 ) )
                         => ( P @ X2 ) )
                     => ( ord_less_eq @ A @ D6 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5693_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X9: set @ A] :
          ( ( member2 @ A @ Z2 @ X9 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ( complete_Sup_Sup @ A @ X9 )
              = Z2 ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5694_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X9: set @ A,A3: A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ X9 )
             => ( ord_less_eq @ A @ X2 @ A3 ) )
         => ( ! [Y2: A] :
                ( ! [X: A] :
                    ( ( member2 @ A @ X @ X9 )
                   => ( ord_less_eq @ A @ X @ Y2 ) )
               => ( ord_less_eq @ A @ A3 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ X9 )
              = A3 ) ) ) ) ).

% cSup_eq
thf(fact_5695_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X9: set @ A] :
          ( ( member2 @ A @ Z2 @ X9 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ( ord_less_eq @ A @ Z2 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ X9 )
              = Z2 ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5696_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X9: set @ A,A3: A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ X9 )
             => ( ord_less_eq @ A @ A3 @ X2 ) )
         => ( ! [Y2: A] :
                ( ! [X: A] :
                    ( ( member2 @ A @ X @ X9 )
                   => ( ord_less_eq @ A @ Y2 @ X ) )
               => ( ord_less_eq @ A @ Y2 @ A3 ) )
           => ( ( complete_Inf_Inf @ A @ X9 )
              = A3 ) ) ) ) ).

% cInf_eq
thf(fact_5697_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,A3: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ( ord_less_eq @ A @ X2 @ A3 ) )
           => ( ! [Y2: A] :
                  ( ! [X: A] :
                      ( ( member2 @ A @ X @ X9 )
                     => ( ord_less_eq @ A @ X @ Y2 ) )
                 => ( ord_less_eq @ A @ A3 @ Y2 ) )
             => ( ( complete_Sup_Sup @ A @ X9 )
                = A3 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5698_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,Z2: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X9 ) @ Z2 ) ) ) ) ).

% cSup_least
thf(fact_5699_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,X3: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( member2 @ A @ X3 @ X9 )
           => ( ord_less_eq @ A @ X3 @ ( complete_Sup_Sup @ A @ X9 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5700_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y5: A,X9: set @ A] :
          ( ( ord_less @ A @ Y5 @ ( complete_Sup_Sup @ A @ X9 ) )
         => ( ( X9
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X2: A] :
                  ( ( member2 @ A @ X2 @ X9 )
                 => ~ ( ord_less @ A @ Y5 @ X2 ) ) ) ) ) ).

% less_cSupE
thf(fact_5701_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X9: set @ A,Z2: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z2 @ ( complete_Sup_Sup @ A @ X9 ) )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
                & ( ord_less @ A @ Z2 @ X2 ) ) ) ) ) ).

% less_cSupD
thf(fact_5702_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X9: set @ A,X3: A,A3: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( member2 @ A @ X3 @ X9 )
           => ( ! [X2: A] :
                  ( ( member2 @ A @ X2 @ X9 )
                 => ( ord_less @ A @ X2 @ A3 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X9 ) @ A3 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5703_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,A3: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ( ord_less_eq @ A @ A3 @ X2 ) )
           => ( ! [Y2: A] :
                  ( ! [X: A] :
                      ( ( member2 @ A @ X @ X9 )
                     => ( ord_less_eq @ A @ Y2 @ X ) )
                 => ( ord_less_eq @ A @ Y2 @ A3 ) )
             => ( ( complete_Inf_Inf @ A @ X9 )
                = A3 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5704_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,Z2: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
               => ( ord_less_eq @ A @ Z2 @ X2 ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ X9 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5705_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,X3: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( member2 @ A @ X3 @ X9 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X9 ) @ X3 ) ) ) ) ).

% cInf_le_finite
thf(fact_5706_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X9: set @ A,Z2: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X9 ) @ Z2 )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ X9 )
                & ( ord_less @ A @ X2 @ Z2 ) ) ) ) ) ).

% cInf_lessD
thf(fact_5707_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X9: set @ A,X3: A,A3: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( member2 @ A @ X3 @ X9 )
           => ( ! [X2: A] :
                  ( ( member2 @ A @ X2 @ X9 )
                 => ( ord_less @ A @ A3 @ X2 ) )
             => ( ord_less @ A @ A3 @ ( complete_Inf_Inf @ A @ X9 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5708_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X9: set @ A,A3: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( X9
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X9 ) @ A3 )
              = ( ! [X4: A] :
                    ( ( member2 @ A @ X4 @ X9 )
                   => ( ord_less @ A @ X4 @ A3 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5709_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X9: set @ A,A3: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( X9
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A3 @ ( complete_Inf_Inf @ A @ X9 ) )
              = ( ! [X4: A] :
                    ( ( member2 @ A @ X4 @ X9 )
                   => ( ord_less @ A @ A3 @ X4 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5710_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A3: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ A3 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A3 ) ) ) ) ).

% cSup_abs_le
thf(fact_5711_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A2 )
            = ( bot_bot @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X4 )
               => ? [Y: A] :
                    ( ( member2 @ A @ Y @ A2 )
                    & ( ord_less @ A @ Y @ X4 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5712_finite__subset__Union,axiom,
    ! [A: $tType,A2: set @ A,B12: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ B12 ) )
       => ~ ! [F7: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F7 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F7 @ B12 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_5713_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A] :
          ( ( A2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5714_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A2: set @ A,V: A] :
          ( ( member2 @ A @ U @ A2 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5715_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ B2 )
          = ( ! [X4: A] :
                ( ( member2 @ A @ X4 @ A2 )
               => ( ord_less_eq @ A @ X4 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5716_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A,A2: set @ A] :
          ( ( member2 @ A @ X3 @ A2 )
         => ( ord_less_eq @ A @ X3 @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ).

% Sup_upper
thf(fact_5717_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,Z2: A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ A2 )
             => ( ord_less_eq @ A @ X2 @ Z2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ Z2 ) ) ) ).

% Sup_least
thf(fact_5718_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,B3: set @ A] :
          ( ! [A7: A] :
              ( ( member2 @ A @ A7 @ A2 )
             => ? [X: A] :
                  ( ( member2 @ A @ X @ B3 )
                  & ( ord_less_eq @ A @ A7 @ X ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_mono
thf(fact_5719_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,X3: A] :
          ( ! [Y2: A] :
              ( ( member2 @ A @ Y2 @ A2 )
             => ( ord_less_eq @ A @ Y2 @ X3 ) )
         => ( ! [Y2: A] :
                ( ! [Z4: A] :
                    ( ( member2 @ A @ Z4 @ A2 )
                   => ( ord_less_eq @ A @ Z4 @ Y2 ) )
               => ( ord_less_eq @ A @ X3 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ A2 )
              = X3 ) ) ) ) ).

% Sup_eqI
thf(fact_5720_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: A,S2: set @ A] :
          ( ( ord_less @ A @ A3 @ ( complete_Sup_Sup @ A @ S2 ) )
          = ( ? [X4: A] :
                ( ( member2 @ A @ X4 @ S2 )
                & ( ord_less @ A @ A3 @ X4 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5721_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,Z2: A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ A2 )
             => ( ord_less_eq @ A @ Z2 @ X2 ) )
         => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ A2 ) ) ) ) ).

% Inf_greatest
thf(fact_5722_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A2: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A2 ) )
          = ( ! [X4: A] :
                ( ( member2 @ A @ X4 @ A2 )
               => ( ord_less_eq @ A @ B2 @ X4 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5723_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A2: set @ A,V: A] :
          ( ( member2 @ A @ U @ A2 )
         => ( ( ord_less_eq @ A @ U @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_5724_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A,A2: set @ A] :
          ( ( member2 @ A @ X3 @ A2 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ X3 ) ) ) ).

% Inf_lower
thf(fact_5725_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ A,A2: set @ A] :
          ( ! [B6: A] :
              ( ( member2 @ A @ B6 @ B3 )
             => ? [X: A] :
                  ( ( member2 @ A @ X @ A2 )
                  & ( ord_less_eq @ A @ X @ B6 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_mono
thf(fact_5726_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,X3: A] :
          ( ! [I3: A] :
              ( ( member2 @ A @ I3 @ A2 )
             => ( ord_less_eq @ A @ X3 @ I3 ) )
         => ( ! [Y2: A] :
                ( ! [I4: A] :
                    ( ( member2 @ A @ I4 @ A2 )
                   => ( ord_less_eq @ A @ Y2 @ I4 ) )
               => ( ord_less_eq @ A @ Y2 @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ A2 )
              = X3 ) ) ) ) ).

% Inf_eqI
thf(fact_5727_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S2: set @ A,A3: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A3 )
          = ( ? [X4: A] :
                ( ( member2 @ A @ X4 @ S2 )
                & ( ord_less @ A @ X4 @ A3 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5728_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_1: A] : ( P @ ( zero_zero @ nat ) @ X_1 )
     => ( ! [X2: A,N3: nat] :
            ( ( P @ N3 @ X2 )
           => ? [Y6: A] :
                ( ( P @ ( suc @ N3 ) @ Y6 )
                & ( Q @ N3 @ X2 @ Y6 ) ) )
       => ? [F5: nat > A] :
          ! [N7: nat] :
            ( ( P @ N7 @ ( F5 @ N7 ) )
            & ( Q @ N7 @ ( F5 @ N7 ) @ ( F5 @ ( suc @ N7 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_5729_Union__least,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member2 @ ( set @ A ) @ X10 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ C6 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) @ C6 ) ) ).

% Union_least
thf(fact_5730_Union__upper,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ ( set @ A )] :
      ( ( member2 @ ( set @ A ) @ B3 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) ) ) ).

% Union_upper
thf(fact_5731_Union__subsetI,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ! [X2: set @ A] :
          ( ( member2 @ ( set @ A ) @ X2 @ A2 )
         => ? [Y6: set @ A] :
              ( ( member2 @ ( set @ A ) @ Y6 @ B3 )
              & ( ord_less_eq @ ( set @ A ) @ X2 @ Y6 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_subsetI
thf(fact_5732_Inter__lower,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ ( set @ A )] :
      ( ( member2 @ ( set @ A ) @ B3 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A2 ) @ B3 ) ) ).

% Inter_lower
thf(fact_5733_Inter__greatest,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member2 @ ( set @ A ) @ X10 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ C6 @ X10 ) )
     => ( ord_less_eq @ ( set @ A ) @ C6 @ ( complete_Inf_Inf @ ( set @ A ) @ A2 ) ) ) ).

% Inter_greatest
thf(fact_5734_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X3: A,A2: set @ A] :
          ( ( ord_less_eq @ A @ X3 @ ( complete_Sup_Sup @ A @ A2 ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X3 )
               => ? [X4: A] :
                    ( ( member2 @ A @ X4 @ A2 )
                    & ( ord_less @ A @ Y @ X4 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5735_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ X3 )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X3 @ Y )
               => ? [X4: A] :
                    ( ( member2 @ A @ X4 @ A2 )
                    & ( ord_less @ A @ X4 @ Y ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5736_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member2 @ A @ V3 @ A2 )
             => ( ord_less_eq @ A @ U @ V3 ) )
         => ( ( A2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5737_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5738_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member2 @ A @ V3 @ A2 )
             => ( ord_less_eq @ A @ V3 @ U ) )
         => ( ( A2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5739_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ A,A2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A2 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5740_Union__mono,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_mono
thf(fact_5741_Inter__anti__mono,axiom,
    ! [A: $tType,B3: set @ ( set @ A ),A2: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B3 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A2 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) ) ).

% Inter_anti_mono
thf(fact_5742_Inter__subset,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),B3: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member2 @ ( set @ A ) @ X10 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ B3 ) )
     => ( ( A2
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A2 ) @ B3 ) ) ) ).

% Inter_subset
thf(fact_5743_subset__Pow__Union,axiom,
    ! [A: $tType,A2: set @ ( set @ A )] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ A2 @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) ) ) ).

% subset_Pow_Union
thf(fact_5744_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C6 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C3: set @ A] :
              ( ( member2 @ ( set @ A ) @ C3 @ C6 )
             => ( ( finite_card @ A @ C3 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member2 @ ( set @ A ) @ C1 @ C6 )
               => ( ( member2 @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5745_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5746_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K3 ) ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L3: code_integer,J4: code_integer] :
                  ( if @ int
                  @ ( J4
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L3 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L3 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_5747_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5748_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ Y5 @ Z2 ) )
          = ( ( ord_less_eq @ A @ X3 @ Y5 )
            & ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_5749_Int__subset__iff,axiom,
    ! [A: $tType,C6: set @ A,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C6 @ A2 )
        & ( ord_less_eq @ ( set @ A ) @ C6 @ B3 ) ) ) ).

% Int_subset_iff
thf(fact_5750_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_5751_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_5752_times__integer_Orep__eq,axiom,
    ! [X3: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X3 @ Xa ) )
      = ( times_times @ int @ ( code_int_of_integer @ X3 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% times_integer.rep_eq
thf(fact_5753_divide__integer_Orep__eq,axiom,
    ! [X3: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X3 @ Xa ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X3 ) @ ( code_int_of_integer @ Xa ) ) ) ).

% divide_integer.rep_eq
thf(fact_5754_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X4 ) ) )
              @ A2 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A2 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5755_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X4 ) ) @ ( F2 @ X4 ) )
              @ A2 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A2 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5756_Union__Int__subset,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A2 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_Int_subset
thf(fact_5757_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A2 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5758_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,X3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ X3 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X3 ) ) ) ).

% less_infI1
thf(fact_5759_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X3: A,A3: A] :
          ( ( ord_less @ A @ B2 @ X3 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X3 ) ) ) ).

% less_infI2
thf(fact_5760_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% inf.absorb3
thf(fact_5761_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5762_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A3 @ B2 )
             => ~ ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5763_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( inf_inf @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5764_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5765_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5766_Int__mono,axiom,
    ! [A: $tType,A2: set @ A,C6: set @ A,B3: set @ A,D4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D4 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) @ ( inf_inf @ ( set @ A ) @ C6 @ D4 ) ) ) ) ).

% Int_mono
thf(fact_5767_Int__lower1,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) @ A2 ) ).

% Int_lower1
thf(fact_5768_Int__lower2,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) @ B3 ) ).

% Int_lower2
thf(fact_5769_Int__absorb1,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
     => ( ( inf_inf @ ( set @ A ) @ A2 @ B3 )
        = B3 ) ) ).

% Int_absorb1
thf(fact_5770_Int__absorb2,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( inf_inf @ ( set @ A ) @ A2 @ B3 )
        = A2 ) ) ).

% Int_absorb2
thf(fact_5771_Int__greatest,axiom,
    ! [A: $tType,C6: set @ A,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) ) ) ).

% Int_greatest
thf(fact_5772_Int__Collect__mono,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ A2 )
           => ( ( P @ X2 )
             => ( Q @ X2 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A2 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B3 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5773_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5774_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5775_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5776_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5777_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5778_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ A3 ) ) ).

% inf.cobounded1
thf(fact_5779_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( inf_inf @ A @ A5 @ B4 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5780_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ A @ X3 @ Z2 )
           => ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ Y5 @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_5781_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5782_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A3 @ B2 )
             => ~ ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5783_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( inf_inf @ A @ X3 @ Y5 )
            = Y5 ) ) ) ).

% inf_absorb2
thf(fact_5784_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( inf_inf @ A @ X3 @ Y5 )
            = X3 ) ) ) ).

% inf_absorb1
thf(fact_5785_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5786_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% inf.absorb1
thf(fact_5787_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X4: A,Y: A] :
              ( ( inf_inf @ A @ X4 @ Y )
              = X4 ) ) ) ) ).

% le_iff_inf
thf(fact_5788_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X3: A,Y5: A] :
          ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( F2 @ X2 @ Y2 ) @ X2 )
         => ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( F2 @ X2 @ Y2 ) @ Y2 )
           => ( ! [X2: A,Y2: A,Z5: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ( ord_less_eq @ A @ X2 @ Z5 )
                   => ( ord_less_eq @ A @ X2 @ ( F2 @ Y2 @ Z5 ) ) ) )
             => ( ( inf_inf @ A @ X3 @ Y5 )
                = ( F2 @ X3 @ Y5 ) ) ) ) ) ) ).

% inf_unique
thf(fact_5789_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( inf_inf @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5790_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( A3
            = ( inf_inf @ A @ A3 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5791_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X3: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ X3 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X3 ) ) ) ).

% le_infI2
thf(fact_5792_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,X3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ X3 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X3 ) ) ) ).

% le_infI1
thf(fact_5793_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5794_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X3 @ A3 )
         => ( ( ord_less_eq @ A @ X3 @ B2 )
           => ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5795_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X3 @ ( inf_inf @ A @ A3 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X3 @ A3 )
             => ~ ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ).

% le_infE
thf(fact_5796_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ Y5 ) ) ).

% inf_le2
thf(fact_5797_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ X3 ) ) ).

% inf_le1
thf(fact_5798_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ X3 ) ) ).

% inf_sup_ord(1)
thf(fact_5799_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ Y5 ) ) ).

% inf_sup_ord(2)
thf(fact_5800_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K3: code_integer,L3: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L3 ) ) ) ) ).

% integer_less_iff
thf(fact_5801_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X4: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X4 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_5802_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X4: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X4 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_5803_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K3: code_integer,L3: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L3 ) ) ) ) ).

% integer_less_eq_iff
thf(fact_5804_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( inf_inf @ A @ X3 @ Y5 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ Y5 ) ) ) ) ).

% inf_shunt
thf(fact_5805_unset__bit__integer_Orep__eq,axiom,
    ! [X3: nat,Xa: code_integer] :
      ( ( code_int_of_integer @ ( bit_se2638667681897837118et_bit @ code_integer @ X3 @ Xa ) )
      = ( bit_se2638667681897837118et_bit @ int @ X3 @ ( code_int_of_integer @ Xa ) ) ) ).

% unset_bit_integer.rep_eq
thf(fact_5806_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A3 ) ) ) ) ).

% Ioc_disjoint
thf(fact_5807_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A2 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ B3 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5808_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( member2 @ B @ X4 @ B3 ) @ ( G @ X4 ) @ ( zero_zero @ A ) )
              @ A2 ) ) ) ) ).

% sum.inter_restrict
thf(fact_5809_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H @ I3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T6 ) )
                   => ( ( G @ I3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X2: B] :
                      ( ( member2 @ B @ X2 @ ( inf_inf @ ( set @ B ) @ S2 @ T6 ) )
                     => ( ( G @ X2 )
                        = ( H @ X2 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H @ T6 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_5810_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,K: A] :
          ( ( ( ord_less @ A @ X3 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X3 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5811_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5812_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A2 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5813_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,P: B > $o,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( H @ X4 ) @ ( G @ X4 ) )
              @ A2 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H @ ( inf_inf @ ( set @ B ) @ A2 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5814_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,P: B > $o,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( H @ X4 ) @ ( G @ X4 ) )
              @ A2 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H @ ( inf_inf @ ( set @ B ) @ A2 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5815_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A5: B] : ( divide_divide @ A @ ( F2 @ A5 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A2
                  @ ( collect @ B
                    @ ^ [A5: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A5 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A2
                    @ ( collect @ B
                      @ ^ [A5: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A5 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5816_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys4: list @ A] :
            ( ( member2 @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member2 @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member2 @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_5817_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5818_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X4: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) )
          @ Xa
          @ X3 ) ) ) ).

% times_int.abs_eq
thf(fact_5819_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X: A] :
                  ( ( member2 @ A @ X @ S2 )
                  & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5820_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) ) ).

% finite_shuffles
thf(fact_5821_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X2: nat,Y2: nat] :
          ( Z2
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X2 @ Y2 ) ) ) ).

% eq_Abs_Integ
thf(fact_5822_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs2: list @ A,Ys3: list @ A] : ( shuffles @ A @ Ys3 @ Xs2 ) ) ) ).

% shuffles_commutes
thf(fact_5823_int_Oabs__induct,axiom,
    ! [P: int > $o,X3: int] :
      ( ! [Y2: product_prod @ nat @ nat] : ( P @ ( abs_Integ @ Y2 ) )
     => ( P @ X3 ) ) ).

% int.abs_induct
thf(fact_5824_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ) ).

% length_shuffles
thf(fact_5825_nat_Oabs__eq,axiom,
    ! [X3: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X3 ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X3 ) ) ).

% nat.abs_eq
thf(fact_5826_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5827_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N2: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5828_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys2 )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_5829_uminus__int_Oabs__eq,axiom,
    ! [X3: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X4: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X4 )
          @ X3 ) ) ) ).

% uminus_int.abs_eq
thf(fact_5830_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5831_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X3 ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I2: nat,J4: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J4 ) )
            @ X3 ) ) ) ).

% of_int.abs_eq
thf(fact_5832_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) )
        @ Xa
        @ X3 ) ) ).

% less_int.abs_eq
thf(fact_5833_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) )
        @ Xa
        @ X3 ) ) ).

% less_eq_int.abs_eq
thf(fact_5834_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X4: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) )
          @ Xa
          @ X3 ) ) ) ).

% plus_int.abs_eq
thf(fact_5835_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X3: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X3 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X4: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) )
          @ Xa
          @ X3 ) ) ) ).

% minus_int.abs_eq
thf(fact_5836_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y5: A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member2 @ A @ Y5 @ S2 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) @ ( F2 @ Y5 ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5837_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys3: list @ A] :
            ( ( member2 @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs3: list @ A] :
            ( ( ( member2 @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member2 @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys3 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5838_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X2: list @ A] :
          ( ( member2 @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X2 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_5839_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5840_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A3 )
        = ( nil @ B ) )
      = ( A3
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_5841_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_5842_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_5843_upt__conv__Nil,axiom,
    ! [J3: nat,I: nat] :
      ( ( ord_less_eq @ nat @ J3 @ I )
     => ( ( upt @ I @ J3 )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_5844_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X3: A] :
      ( ( ( list_update @ A @ Xs @ K @ X3 )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_5845_concat__replicate__trivial,axiom,
    ! [A: $tType,I: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_5846_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_5847_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( enumerate @ A @ N @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_5848_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_5849_list__ex1__simps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) ).

% list_ex1_simps(1)
thf(fact_5850_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_5851_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_5852_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_5853_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_5854_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs2: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_5855_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_5856_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_5857_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_5858_replicate__empty,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( replicate @ A @ N @ X3 )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_5859_empty__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X3 ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_5860_upt__eq__Nil__conv,axiom,
    ! [I: nat,J3: nat] :
      ( ( ( upt @ I @ J3 )
        = ( nil @ nat ) )
      = ( ( J3
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J3 @ I ) ) ) ).

% upt_eq_Nil_conv
thf(fact_5861_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_5862_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] :
          ( ~ ( finite_finite @ A @ A2 )
         => ( ( linord4507533701916653071of_set @ A @ A2 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_5863_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A3: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_5864_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X4: list @ A] :
            ( ( member2 @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X4
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_5865_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X4: list @ A] :
            ( ( member2 @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X4
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_5866_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_5867_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: set @ A] :
          ( ( finite_finite @ A @ A2 )
         => ( ( ( linord4507533701916653071of_set @ A @ A2 )
              = ( nil @ A ) )
            = ( A2
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5868_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: set @ A] :
          ( ( ( gcd_Gcd @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_5869_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys2
          = ( nil @ A ) )
       => ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys2 ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_5870_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_5871_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys2 )
      = ( insert2 @ ( list @ A ) @ Ys2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_5872_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_5873_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X3: A] :
      ( ( removeAll @ A @ X3 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_5874_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_5875_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_5876_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I: nat,V: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I @ V )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_5877_list__update__code_I1_J,axiom,
    ! [A: $tType,I: nat,Y5: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I @ Y5 )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_5878_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > A > $o] : ( sorted_wrt @ A @ P @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_5879_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_5880_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_5881_take__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( take @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% take_Nil
thf(fact_5882_member__rec_I2_J,axiom,
    ! [A: $tType,Y5: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y5 ) ).

% member_rec(2)
thf(fact_5883_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X3: A] :
      ( ( remove1 @ A @ X3 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_5884_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A3: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A3 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_5885_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_5886_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_5887_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_5888_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_5889_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_5890_replicate__0,axiom,
    ! [A: $tType,X3: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X3 )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_5891_upt__0,axiom,
    ! [I: nat] :
      ( ( upt @ I @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_5892_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X3: A > nat] :
      ( ( size_list @ A @ X3 @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_5893_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y5: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y5 )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_5894_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_5895_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_5896_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert2 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_5897_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A2: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A2 @ S2 )
       => ( ( finite_finite @ B @ A2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A2 )
              = ( nil @ B ) )
            = ( A2
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5898_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( member2 @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5899_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I3 ) )
              = N ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I2: nat] :
                ( map @ nat @ A
                @ ^ [J4: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J4 ) @ I2 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_5900_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_5901_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X4: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z3: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U2 @ Z3 ) ) )
          @ ( rep_Integ @ X4 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5902_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N: nat,X3: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N @ X3 ) )
      = ( compow @ ( A > A ) @ N @ ( F2 @ X3 ) ) ) ).

% foldr_replicate
thf(fact_5903_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_5904_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: A,L: list @ B,K: list @ B,F2: B > A > A,G: B > A > A] :
      ( ( A3 = B2 )
     => ( ( L = K )
       => ( ! [A7: A,X2: B] :
              ( ( member2 @ B @ X2 @ ( set2 @ B @ L ) )
             => ( ( F2 @ X2 @ A7 )
                = ( G @ X2 @ A7 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L @ A3 )
            = ( foldr @ B @ A @ G @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_5905_Gcd__int__greater__eq__0,axiom,
    ! [K5: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_5906_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X4: list @ A] :
            ( ( member2 @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X4
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_5907_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F2: C > B,Xs: list @ C,A3: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F2 @ Xs ) @ A3 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F2 ) @ Xs @ A3 ) ) ).

% foldr_map
thf(fact_5908_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_5909_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs2: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs2 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_5910_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X4: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X4 ) ) ) ) ).

% nat.rep_eq
thf(fact_5911_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A5: A,Xs2: list @ B] :
              ( foldr @ B @ A
              @ ^ [X4: B,B4: A] : ( plus_plus @ A @ ( F3 @ X4 ) @ ( times_times @ A @ A5 @ B4 ) )
              @ Xs2
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_5912_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X4: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I2: nat,J4: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J4 ) )
              @ ( rep_Integ @ X4 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_5913_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X4: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z3: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U2 @ Z3 ) ) )
          @ ( rep_Integ @ X4 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5914_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_5915_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_5916_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_5917_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_5918_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys2 ) )
      = ( Xs = Ys2 ) ) ).

% rev_is_rev_conv
thf(fact_5919_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_5920_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_5921_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_5922_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_5923_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_5924_rev__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X3 ) )
      = ( replicate @ A @ N @ X3 ) ) ).

% rev_replicate
thf(fact_5925_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_5926_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_5927_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_5928_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X4: A,Y: A] : ( P @ Y @ X4 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_5929_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys2 )
      = ( Xs
        = ( rev @ A @ Ys2 ) ) ) ).

% rev_swap
thf(fact_5930_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_5931_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y5: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y5 ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y5 ) ) ) ).

% rev_update
thf(fact_5932_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_5933_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I2: nat] :
                ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I2 ) ) @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_5934_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I2: nat,J4: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J4 )
               => ( ( ord_less @ nat @ J4 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J4 ) @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_5935_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: nat,J3: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J3 ) @ ( nth @ A @ Xs @ I ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_5936_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y5: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y5 )
                = Y5 ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y5 )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y5 ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_5937_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs2: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_5938_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys2 )
        = ( insert2 @ ( list @ A ) @ Ys2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_5939_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat,J3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J3
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I ) @ J3 )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_5940_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I ) ) ) ) ).

% transpose_column
thf(fact_5941_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I ) ) ) ) ) ).

% transpose_column_length
thf(fact_5942_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X4: A] :
            ( ( Q @ X4 )
            & ( P @ X4 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_5943_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_5944_remove1__filter__not,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ~ ( P @ X3 )
     => ( ( remove1 @ A @ X3 @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_5945_removeAll__filter__not,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ~ ( P @ X3 )
     => ( ( removeAll @ A @ X3 @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_5946_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( P @ X4 ) ) ) ) ).

% set_filter
thf(fact_5947_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ~ ( P @ X2 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_5948_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_5949_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_5950_filter__empty__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X4 ) ) ) ) ).

% filter_empty_conv
thf(fact_5951_empty__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P @ Xs ) )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X4 ) ) ) ) ).

% empty_filter_conv
thf(fact_5952_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( filter2 @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_5953_filter__replicate,axiom,
    ! [A: $tType,P: A > $o,X3: A,N: nat] :
      ( ( ( P @ X3 )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N @ X3 ) )
          = ( replicate @ A @ N @ X3 ) ) )
      & ( ~ ( P @ X3 )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N @ X3 ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_5954_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% filter_map
thf(fact_5955_rev__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_5956_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X4: A] :
            ( filter2 @ A
            @ ^ [Y: A] : ( X4 != Y ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_5957_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X4: A] :
                ~ ( P @ X4 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_5958_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,X3: B,F2: B > A,Xs: list @ B] :
          ( ~ ( P @ X3 )
         => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
            = ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_5959_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X3: A,Xs: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X3 @ Xs ) )
      = ( remove1 @ A @ X3 @ ( filter2 @ A @ Q @ Xs ) ) ) ).

% filter_remove1
thf(fact_5960_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,P: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_5961_filter__id__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = Xs )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) ) ) ).

% filter_id_conv
thf(fact_5962_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( filter2 @ A @ P @ Xs )
          = ( filter2 @ A @ Q @ Ys2 ) ) ) ) ).

% filter_cong
thf(fact_5963_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_5964_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_5965_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X4: A] :
                ( X4
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_5966_inter__set__filter,axiom,
    ! [A: $tType,A2: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A2 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X4: A] : ( member2 @ A @ X4 @ A2 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_5967_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter2 @ A @ P @ Xs ) ) ) ).

% distinct_filter
thf(fact_5968_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( member2 @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs )
        @ ( filter2 @ A
          @ ^ [X4: A] :
              ~ ( P @ X4 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_5969_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,P: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_5970_filter__concat,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter2 @ A @ P3 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P3 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_5971_replicate__length__filter,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
              @ X3 )
            @ Xs ) )
        @ X3 )
      = ( filter2 @ A
        @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ X3 )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_5972_length__filter__less,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,P: A > $o] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X3 )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_5973_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_5974_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X4: B] :
                  ( ( F2 @ X4 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_5975_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( F2 @ X4 ) @ ( zero_zero @ A ) )
              @ Xs ) ) ) ) ).

% sum_list_map_filter'
thf(fact_5976_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_5977_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X2 )
               => ( ( F2 @ X2 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_5978_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o,X3: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P @ X3 )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X3 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_5979_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y5: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X4: A] : ( X4 != Y5 )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_5980_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] :
                ~ ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys2 ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_5981_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] : ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_5982_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] :
                ~ ( member2 @ A @ X4 @ ( set2 @ A @ Ys2 ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_5983_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] : ( member2 @ A @ X4 @ ( set2 @ A @ Ys2 ) )
            @ Zs )
          = Ys2 ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_5984_length__filter__conv__card,axiom,
    ! [A: $tType,P3: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P3 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P3 @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_5985_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_5986_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs2: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs2 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X4: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X4 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_5987_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs2: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X4: list @ A] :
              ( X4
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_5988_nth__transpose,axiom,
    ! [A: $tType,I: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs2: list @ A] : ( nth @ A @ Xs2 @ I )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_5989_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X4: B] : ( if @ ( option @ A ) @ ( P @ X4 ) @ ( some @ A @ ( F2 @ X4 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_5990_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X4: list @ A] :
              ( X4
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_5991_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lex @ A @ R2 ) )
     => ~ ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys2 ) )
             => ( ( ( take @ A @ I3 @ Xs )
                  = ( take @ A @ I3 @ Ys2 ) )
               => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Ys2 @ I3 ) ) @ R2 ) ) ) ) ) ).

% lex_take_index
thf(fact_5992_takeWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P @ ( takeWhile @ A @ P @ Xs ) )
      = ( takeWhile @ A @ P @ Xs ) ) ).

% takeWhile_idem
thf(fact_5993_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = Xs )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_5994_takeWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X3: A,N: nat] :
      ( ( ( P @ X3 )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N @ X3 ) )
          = ( replicate @ A @ N @ X3 ) ) )
      & ( ~ ( P @ X3 )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N @ X3 ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_5995_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_5996_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_5997_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_5998_set__takeWhileD,axiom,
    ! [A: $tType,X3: A,P: A > $o,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
        & ( P @ X3 ) ) ) ).

% set_takeWhileD
thf(fact_5999_takeWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ L ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( takeWhile @ A @ P @ L )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_6000_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( takeWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_6001_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs2 ) ) @ Xs2 ) ) ) ).

% takeWhile_eq_take
thf(fact_6002_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_6003_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_6004_Nil__notin__lex,axiom,
    ! [A: $tType,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) @ ( lex @ A @ R2 ) ) ).

% Nil_notin_lex
thf(fact_6005_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R2 ) ) ).

% Nil2_notin_lex
thf(fact_6006_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_6007_takeWhile__nth,axiom,
    ! [A: $tType,J3: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs ) @ J3 )
        = ( nth @ A @ Xs @ J3 ) ) ) ).

% takeWhile_nth
thf(fact_6008_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J3: nat,P: A > $o,Xs: list @ A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ J3 )
         => ( P @ ( nth @ A @ Xs @ I3 ) ) )
     => ( ( ord_less_eq @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J3 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_6009_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P: A > $o] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I3 ) ) ) )
     => ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P @ ( nth @ A @ Xs @ N ) ) )
       => ( ( takeWhile @ A @ P @ Xs )
          = ( take @ A @ N @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_6010_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X4: B] : ( ord_less @ A @ T2 @ ( F2 @ X4 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X4: B] : ( ord_less @ A @ T2 @ ( F2 @ X4 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_6011_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A3: B,Xs: list @ B,F2: B > A] :
          ( ( member2 @ B @ A3 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X4: B] :
                        ( ( F2 @ A3 )
                        = ( F2 @ X4 ) )
                    @ Xs ) )
                = A3 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A3 @ ( remove1 @ B @ A3 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_6012_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( semiring_1_of_nat @ A @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_6013_hd__upt,axiom,
    ! [I: nat,J3: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ( hd @ nat @ ( upt @ I @ J3 ) )
        = I ) ) ).

% hd_upt
thf(fact_6014_hd__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X3 ) )
        = X3 ) ) ).

% hd_replicate
thf(fact_6015_hd__take,axiom,
    ! [A: $tType,J3: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J3 )
     => ( ( hd @ A @ ( take @ A @ J3 @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_6016_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member2 @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_6017_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A3: list @ A] :
      ( ( A3
       != ( nil @ A ) )
     => ( member2 @ A @ ( hd @ A @ A3 ) @ ( set2 @ A @ A3 ) ) ) ).

% list.set_sel(1)
thf(fact_6018_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_6019_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_6020_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A3: list @ A,F2: A > B] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A3 ) )
        = ( F2 @ ( hd @ A @ A3 ) ) ) ) ).

% list.map_sel(1)
thf(fact_6021_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_6022_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_6023_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X4: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X4 ) ) ) ) ).

% uminus_int_def
thf(fact_6024_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M3: nat,N2: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M3 @ N2 ) ) @ M3 ) ) ) ).

% prod_encode_def
thf(fact_6025_le__prod__encode__1,axiom,
    ! [A3: nat,B2: nat] : ( ord_less_eq @ nat @ A3 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A3 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_6026_le__prod__encode__2,axiom,
    ! [B2: nat,A3: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A3 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_6027_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode_aux @ K @ M ) )
      = ( plus_plus @ nat @ ( nat_triangle @ K ) @ M ) ) ).

% prod_encode_prod_decode_aux
thf(fact_6028_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ U2 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ V5 ) @ ( times_times @ nat @ Y @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_6029_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ Y @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_6030_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ U2 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_6031_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs ) ) ) ) ).

% nth_image
thf(fact_6032_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
      = ( ? [Y: A,N2: nat] :
            ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N2 ) @ Y ) @ R2 )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys2
              = ( list_update @ A @ Xs @ N2 @ Y ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_6033_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N5: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N5 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N5 ) ) ).

% bij_betw_Suc
thf(fact_6034_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S2 )
          = S2 ) ) ).

% image_add_0
thf(fact_6035_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J3: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I @ J3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_6036_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J3: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I @ J3 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_6037_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A3: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A3 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A3 ) ) ) ) ).

% image_add_atMost
thf(fact_6038_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,A2: set @ A,B3: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A3 ) @ A2 @ B3 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ A2 )
            = B3 ) ) ) ).

% bij_betw_add
thf(fact_6039_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V ) )
      = ( image @ A @ B @ F2 @ ( set2 @ A @ V ) ) ) ).

% list.set_map
thf(fact_6040_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_6041_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J3: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I @ J3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_6042_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J3: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I @ J3 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J3 @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_6043_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A2: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) )
            = ( bot_bot @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X4 )
               => ? [Y: B] :
                    ( ( member2 @ B @ Y @ A2 )
                    & ( ord_less @ A @ ( F2 @ Y ) @ X4 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_6044_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A3 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_6045_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A3 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_6046_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% image_set
thf(fact_6047_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A2 ) @ ( image @ B @ A @ F2 @ B3 ) ) ) ).

% image_Int_subset
thf(fact_6048_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_6049_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,B3: set @ C,F2: B > A,G: C > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ? [X: C] :
                  ( ( member2 @ C @ X @ B3 )
                  & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ X ) ) ) )
         => ( ! [J2: C] :
                ( ( member2 @ C @ J2 @ B3 )
               => ? [X: B] :
                    ( ( member2 @ B @ X @ A2 )
                    & ( ord_less_eq @ A @ ( G @ J2 ) @ ( F2 @ X ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_6050_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,B3: set @ C,G: C > A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ? [X: C] :
                  ( ( member2 @ C @ X @ B3 )
                  & ( ord_less_eq @ A @ ( G @ X ) @ ( F2 @ I3 ) ) ) )
         => ( ! [J2: C] :
                ( ( member2 @ C @ J2 @ B3 )
               => ? [X: B] :
                    ( ( member2 @ B @ X @ A2 )
                    & ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ) ).

% INF_eq
thf(fact_6051_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_6052_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,F8: B > A,F2: A > B,A9: set @ B] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
         => ( ( F8 @ ( F2 @ X2 ) )
            = X2 ) )
     => ( ! [X2: B] :
            ( ( member2 @ B @ X2 @ A9 )
           => ( ( F2 @ ( F8 @ X2 ) )
              = X2 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ A9 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F8 @ A9 ) @ A2 )
           => ( bij_betw @ A @ B @ F2 @ A2 @ A9 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_6053_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A2: set @ A,A9: set @ B,B3: set @ A,B13: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A2 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( ( ( image @ A @ B @ F2 @ B3 )
            = B13 )
         => ( bij_betw @ A @ B @ F2 @ B3 @ B13 ) ) ) ) ).

% bij_betw_subset
thf(fact_6054_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A2 ) @ ( image @ B @ A @ F2 @ B3 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) ) ).

% image_diff_subset
thf(fact_6055_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ( finite_finite @ A @ B8 )
              & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A2 ) ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ( finite_finite @ B @ B8 )
              & ( ord_less_eq @ ( set @ B ) @ B8 @ A2 ) )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_6056_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B8: set @ A] :
            ( ( finite_finite @ A @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A2 ) )
            & ( P @ B8 ) ) )
      = ( ? [B8: set @ B] :
            ( ( finite_finite @ B @ B8 )
            & ( ord_less_eq @ ( set @ B ) @ B8 @ A2 )
            & ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_6057_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A2: set @ B] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A2 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A2 )
            & ( finite_finite @ B @ C7 )
            & ( B3
              = ( image @ B @ A @ F2 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_6058_finite__surj,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,B3: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A2 ) )
       => ( finite_finite @ B @ B3 ) ) ) ).

% finite_surj
thf(fact_6059_zero__notin__Suc__image,axiom,
    ! [A2: set @ nat] :
      ~ ( member2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A2 ) ) ).

% zero_notin_Suc_image
thf(fact_6060_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A2 ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B8 @ A2 )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_subset_image
thf(fact_6061_image__mono,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ).

% image_mono
thf(fact_6062_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,F2: A > B,B3: set @ B] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
         => ( member2 @ B @ ( F2 @ X2 ) @ B3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ B3 ) ) ).

% image_subsetI
thf(fact_6063_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A2: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A2 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A2 )
           => ( B3
             != ( image @ B @ A @ F2 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_6064_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A2 ) @ B3 )
      = ( ! [X4: B] :
            ( ( member2 @ B @ X4 @ A2 )
           => ( member2 @ A @ ( F2 @ X4 ) @ B3 ) ) ) ) ).

% image_subset_iff
thf(fact_6065_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A2: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A2 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A2 )
            & ( B3
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_6066_listrel1__mono,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R2 ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_6067_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A2: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A2 ) @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A2 ) ) @ ( pow2 @ A @ B3 ) ) ) ).

% image_Pow_mono
thf(fact_6068_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_6069_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,F2: B > A,X3: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ X3 ) )
         => ( ! [Y2: A] :
                ( ! [I4: B] :
                    ( ( member2 @ B @ I4 @ A2 )
                   => ( ord_less_eq @ A @ ( F2 @ I4 ) @ Y2 ) )
               => ( ord_less_eq @ A @ X3 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) )
              = X3 ) ) ) ) ).

% SUP_eqI
thf(fact_6070_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,B3: set @ C,F2: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member2 @ B @ N3 @ A2 )
             => ? [X: C] :
                  ( ( member2 @ C @ X @ B3 )
                  & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ).

% SUP_mono
thf(fact_6071_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,F2: B > A,U: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_6072_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A2: set @ B] :
          ( ! [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A2 ) ) ) ) ) ).

% SUP_mono'
thf(fact_6073_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A2: set @ B,F2: B > A] :
          ( ( member2 @ B @ I @ A2 )
         => ( ord_less_eq @ A @ ( F2 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) ) ) ) ).

% SUP_upper
thf(fact_6074_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A2: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ U )
          = ( ! [X4: B] :
                ( ( member2 @ B @ X4 @ A2 )
               => ( ord_less_eq @ A @ ( F2 @ X4 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_6075_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A2: set @ B,U: A,F2: B > A] :
          ( ( member2 @ B @ I @ A2 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_6076_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A2: set @ B,Y5: A,I: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ Y5 )
         => ( ( member2 @ B @ I @ A2 )
           => ( ord_less @ A @ ( F2 @ I ) @ Y5 ) ) ) ) ).

% SUP_lessD
thf(fact_6077_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: A,F2: B > A,A2: set @ B] :
          ( ( ord_less @ A @ A3 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) )
          = ( ? [X4: B] :
                ( ( member2 @ B @ X4 @ A2 )
                & ( ord_less @ A @ A3 @ ( F2 @ X4 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_6078_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,X3: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ X3 @ ( F2 @ I3 ) ) )
         => ( ! [Y2: A] :
                ( ! [I4: B] :
                    ( ( member2 @ B @ I4 @ A2 )
                   => ( ord_less_eq @ A @ Y2 @ ( F2 @ I4 ) ) )
               => ( ord_less_eq @ A @ Y2 @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) )
              = X3 ) ) ) ) ).

% INF_eqI
thf(fact_6079_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ B,A2: set @ C,F2: C > A,G: B > A] :
          ( ! [M4: B] :
              ( ( member2 @ B @ M4 @ B3 )
             => ? [X: C] :
                  ( ( member2 @ C @ X @ A2 )
                  & ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A2 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ).

% INF_mono
thf(fact_6080_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A2: set @ B,F2: B > A] :
          ( ( member2 @ B @ I @ A2 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( F2 @ I ) ) ) ) ).

% INF_lower
thf(fact_6081_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A2: set @ B] :
          ( ! [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A2 ) ) ) ) ) ).

% INF_mono'
thf(fact_6082_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A2: set @ B,F2: B > A,U: A] :
          ( ( member2 @ B @ I @ A2 )
         => ( ( ord_less_eq @ A @ ( F2 @ I ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_6083_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A2: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) )
          = ( ! [X4: B] :
                ( ( member2 @ B @ X4 @ A2 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X4 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_6084_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,U: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A2 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) ) ) ) ).

% INF_greatest
thf(fact_6085_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y5: A,F2: B > A,A2: set @ B,I: B] :
          ( ( ord_less @ A @ Y5 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) )
         => ( ( member2 @ B @ I @ A2 )
           => ( ord_less @ A @ Y5 @ ( F2 @ I ) ) ) ) ) ).

% less_INF_D
thf(fact_6086_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A2: set @ B,A3: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ A3 )
          = ( ? [X4: B] :
                ( ( member2 @ B @ X4 @ A2 )
                & ( ord_less @ A @ ( F2 @ X4 ) @ A3 ) ) ) ) ) ).

% INF_less_iff
thf(fact_6087_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A4: set @ A] :
          ? [N2: nat,F3: nat > A] :
            ( A4
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N2 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_6088_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A2: set @ A,F2: nat > A,N: nat] :
      ( ( A2
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N ) ) ) )
     => ( finite_finite @ A @ A2 ) ) ).

% nat_seg_image_imp_finite
thf(fact_6089_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R2 ) ) ).

% not_Nil_listrel1
thf(fact_6090_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R2 ) ) ).

% not_listrel1_Nil
thf(fact_6091_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% listrel1_eq_len
thf(fact_6092_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X3: A,F2: B > A,A2: set @ B] :
          ( ( ord_less_eq @ A @ X3 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X3 )
               => ? [X4: B] :
                    ( ( member2 @ B @ X4 @ A2 )
                    & ( ord_less @ A @ Y @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_6093_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A2: set @ B,X3: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ X3 )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X3 @ Y )
               => ? [X4: B] :
                    ( ( member2 @ B @ X4 @ A2 )
                    & ( ord_less @ A @ ( F2 @ X4 ) @ Y ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_6094_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A2: set @ B,F2: B > A,M7: A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ A2 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_6095_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,C2: A,F2: B > A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ I5 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I3 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X4: B] :
                    ( ( member2 @ B @ X4 @ I5 )
                   => ( ( F2 @ X4 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_6096_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A2: set @ B,M: A,F2: B > A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ A2 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X2 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_6097_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,F2: B > A,C2: A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X4: B] :
                    ( ( member2 @ B @ X4 @ I5 )
                   => ( ( F2 @ X4 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_6098_card__image__le,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A2 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A2 ) ) @ ( finite_card @ A @ A2 ) ) ) ).

% card_image_le
thf(fact_6099_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F8: A > B,A9: set @ A,A10: set @ B,F2: C > A,A2: set @ C] :
      ( ( bij_betw @ A @ B @ F8 @ A9 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A2 ) @ A9 )
       => ( ( bij_betw @ C @ A @ F2 @ A2 @ A9 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F8 @ F2 ) @ A2 @ A10 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_6100_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,B3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A2 @ B3 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ A2 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_6101_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ B,A2: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A2 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ B3 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_6102_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ C,G: B > C,H: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T6 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X4: B] :
                            ( ( member2 @ B @ X4 @ S2 )
                            & ( ( G @ X4 )
                              = Y ) ) ) )
                  @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_6103_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ C,G: B > C,H: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T6 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X4: B] :
                            ( ( member2 @ B @ X4 @ S2 )
                            & ( ( G @ X4 )
                              = Y ) ) ) )
                  @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_6104_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,H: B > C,G: C > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ! [X2: B,Y2: B] :
                ( ( member2 @ B @ X2 @ A2 )
               => ( ( member2 @ B @ Y2 @ A2 )
                 => ( ( X2 != Y2 )
                   => ( ( ( H @ X2 )
                        = ( H @ Y2 ) )
                     => ( ( G @ ( H @ X2 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H @ A2 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H ) @ A2 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_6105_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ B,F2: B > A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_6106_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A2 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B3 ) @ ( finite_card @ A @ A2 ) ) ) ) ).

% surj_card_le
thf(fact_6107_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X3: A,Y5: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X3 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y5 ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_6108_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_6109_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_6110_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_6111_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N ) )
      = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_6112_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Xs ) ) )
          = ( ~ ( member2 @ A @ ( F2 @ X3 ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_6113_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I2: nat] : ( M7 @ ( plus_plus @ nat @ I2 @ K ) )
          @ ( set_ord_lessThan @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_6114_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I2: nat] : ( M7 @ ( plus_plus @ nat @ I2 @ K ) )
          @ ( set_ord_atMost @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_6115_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I5: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I5 )
         => ( ! [I3: C] :
                ( ( member2 @ C @ I3 @ I5 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I3 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I5 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I5 ) ) ) ) ) ).

% sum_image_le
thf(fact_6116_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X3: A,Y5: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X3 ) @ ( times_times @ A @ C2 @ Y5 ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X3 @ Y5 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y5 ) @ ( times_times @ A @ C2 @ X3 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X3 @ Y5 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_6117_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( times_times @ A @ X4 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X3 @ C2 ) @ ( times_times @ A @ Y5 @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( times_times @ A @ X4 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y5 @ C2 ) @ ( times_times @ A @ X3 @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( times_times @ A @ X4 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X3 @ Y5 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_6118_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X4 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A3 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A3 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_6119_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X4 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A3 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A3 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_6120_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( plus_plus @ A @ ( divide_divide @ A @ X4 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( divide_divide @ A @ X4 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A3 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( divide_divide @ A @ X4 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A3 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_6121_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( minus_minus @ A @ ( divide_divide @ A @ X4 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( divide_divide @ A @ X4 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( divide_divide @ A @ X4 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_6122_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R4: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R4 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S2 ) @ R4 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X4: A] : ( F2 @ ( G @ X4 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X4: A] :
                                ( ( member2 @ A @ X4 @ S2 )
                                & ( ( G @ X4 )
                                  = Y ) ) ) ) )
                      @ ( F2 @ Y ) )
                  @ R4 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_6123_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_6124_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y5: nat,X3: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y5 )
       => ( ( image @ nat @ nat
            @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X3 @ Y5 ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X3 @ C2 ) @ ( minus_minus @ nat @ Y5 @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y5 )
       => ( ( ( ord_less @ nat @ X3 @ Y5 )
           => ( ( image @ nat @ nat
                @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X3 @ Y5 ) )
              = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X3 @ Y5 )
           => ( ( image @ nat @ nat
                @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X3 @ Y5 ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_6125_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs2: list @ A,Ys3: list @ A] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_6126_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A2: A,B3: A] :
          ( ( inf_inf @ A @ A2
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X4: nat] : B3
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A2 @ B3 ) ) ) ).

% INF_nat_binary
thf(fact_6127_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_6128_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B3: B > ( set @ A ),A2: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X4: B] : ( pow2 @ A @ ( B3 @ X4 ) )
          @ A2 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B3 @ A2 ) ) ) ) ).

% UN_Pow_subset
thf(fact_6129_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X5: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X5 ) ) ) ) ) ).

% Inf_real_def
thf(fact_6130_filter__shuffles,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P ) @ ( shuffles @ A @ Xs @ Ys2 ) )
      = ( shuffles @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys2 ) ) ) ).

% filter_shuffles
thf(fact_6131_finite__int__iff__bounded__le,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S6: set @ int] :
        ? [K3: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S6 ) @ ( set_ord_atMost @ int @ K3 ) ) ) ) ).

% finite_int_iff_bounded_le
thf(fact_6132_finite__int__iff__bounded,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S6: set @ int] :
        ? [K3: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S6 ) @ ( set_ord_lessThan @ int @ K3 ) ) ) ) ).

% finite_int_iff_bounded
thf(fact_6133_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A2: B > ( set @ A ),I5: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A2 @ I5 ) ) @ B3 )
      = ( ! [X4: B] :
            ( ( member2 @ B @ X4 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ ( A2 @ X4 ) @ B3 ) ) ) ) ).

% UN_subset_iff
thf(fact_6134_UN__upper,axiom,
    ! [B: $tType,A: $tType,A3: A,A2: set @ A,B3: A > ( set @ B )] :
      ( ( member2 @ A @ A3 @ A2 )
     => ( ord_less_eq @ ( set @ B ) @ ( B3 @ A3 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A2 ) ) ) ) ).

% UN_upper
thf(fact_6135_UN__least,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,B3: A > ( set @ B ),C6: set @ B] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
         => ( ord_less_eq @ ( set @ B ) @ ( B3 @ X2 ) @ C6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A2 ) ) @ C6 ) ) ).

% UN_least
thf(fact_6136_UN__mono,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ A2 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A2 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B3 ) ) ) ) ) ).

% UN_mono
thf(fact_6137_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,A2: B > ( set @ A ),I5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A2 @ I5 ) ) )
      = ( ! [X4: B] :
            ( ( member2 @ B @ X4 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ B3 @ ( A2 @ X4 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_6138_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ A2 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A2 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_6139_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,C6: set @ B,B3: A > ( set @ B )] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ A2 )
         => ( ord_less_eq @ ( set @ B ) @ C6 @ ( B3 @ X2 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C6 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A2 ) ) ) ) ).

% INT_greatest
thf(fact_6140_INT__lower,axiom,
    ! [B: $tType,A: $tType,A3: A,A2: set @ A,B3: A > ( set @ B )] :
      ( ( member2 @ A @ A3 @ A2 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A2 ) ) @ ( B3 @ A3 ) ) ) ).

% INT_lower
thf(fact_6141_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set @ A,A2: A > ( set @ B ),F2: B > C,A9: A > ( set @ C )] :
      ( ! [I3: A,J2: A] :
          ( ( member2 @ A @ I3 @ I5 )
         => ( ( member2 @ A @ J2 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A2 @ I3 ) @ ( A2 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A2 @ J2 ) @ ( A2 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member2 @ A @ I3 @ I5 )
           => ( bij_betw @ B @ C @ F2 @ ( A2 @ I3 ) @ ( A9 @ I3 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A2 @ I5 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I5 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_6142_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X9: set @ A,A2: set @ ( product_prod @ A @ B ),Y4: set @ B,P: A > B > $o,Q: A > B > $o] :
      ( ( X9
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A2 ) )
     => ( ( Y4
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A2 ) )
       => ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ X9 )
             => ! [Xa2: B] :
                  ( ( member2 @ B @ Xa2 @ Y4 )
                 => ( ( P @ X2 @ Xa2 )
                   => ( Q @ X2 @ Xa2 ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) ).

% Collect_split_mono_strong
thf(fact_6143_subset__subseqs,axiom,
    ! [A: $tType,X9: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X9 @ ( set2 @ A @ Xs ) )
     => ( member2 @ ( set @ A ) @ X9 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_6144_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_6145_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X4: int] : ( plus_plus @ int @ X4 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_6146_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A2: A > ( set @ B )] :
      ( ( finite_finite @ A @ I5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A2 @ I5 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I2: A] : ( finite_card @ B @ ( A2 @ I2 ) )
          @ I5 ) ) ) ).

% card_UN_le
thf(fact_6147_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G: C > ( set @ B ),X3: C,X9: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G @ X3 ) ) ) @ X9 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X3 )
        @ ( collect @ B
          @ ^ [X4: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X4 ) @ X9 ) ) ) ) ).

% UN_image_subset
thf(fact_6148_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S2: set @ A] :
      ( ! [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I3 ) @ S2 )
     => ( ( finite_finite @ A @ S2 )
       => ( ? [N8: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N8 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N8 )
                     => ( ( ord_less @ nat @ M4 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ( F2 @ N8 )
                    = ( F2 @ N3 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_6149_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_6150_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A3 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_6151_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A2 )
            = ( top_top @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ X4 @ ( top_top @ A ) )
               => ? [Y: A] :
                    ( ( member2 @ A @ Y @ A2 )
                    & ( ord_less @ A @ X4 @ Y ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_6152_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_6153_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A2: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A2 ) )
            = ( top_top @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ X4 @ ( top_top @ A ) )
               => ? [Y: B] :
                    ( ( member2 @ B @ Y @ A2 )
                    & ( ord_less @ A @ X4 @ ( F2 @ Y ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_6154_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X3 )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X3 ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_6155_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_6156_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B3: set @ A,I: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B3 )
     => ( member2 @ A @ ( F2 @ I ) @ B3 ) ) ).

% range_subsetD
thf(fact_6157_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_6158_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_6159_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_6160_subset__UNIV,axiom,
    ! [A: $tType,A2: set @ A] : ( ord_less_eq @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_6161_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) ) ) ).

% not_UNIV_le_Icc
thf(fact_6162_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H ) ) ) ).

% not_UNIV_le_Iic
thf(fact_6163_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_6164_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A3 ) ) ).

% top.extremum_strict
thf(fact_6165_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ( ( ( A3
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A3 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_6166_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_6167_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A2 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A2 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_6168_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X4: A] : X4 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_6169_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_6170_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_6171_conj__subset__def,axiom,
    ! [A: $tType,A2: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A2
        @ ( collect @ A
          @ ^ [X4: A] :
              ( ( P @ X4 )
              & ( Q @ X4 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_6172_UN__UN__finite__eq,axiom,
    ! [A: $tType,A2: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N2: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_6173_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_6174_UN__finite__subset,axiom,
    ! [A: $tType,A2: nat > ( set @ A ),C6: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_6175_UN__finite2__eq,axiom,
    ! [A: $tType,A2: nat > ( set @ A ),B3: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_6176_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F3: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_6177_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M3: nat] : ( modulo_modulo @ nat @ M3 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_6178_UN__finite2__subset,axiom,
    ! [A: $tType,A2: nat > ( set @ A ),B3: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A2 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_6179_suminf__eq__SUP__real,axiom,
    ! [X9: nat > real] :
      ( ( summable @ real @ X9 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X9 @ I3 ) )
       => ( ( suminf @ real @ X9 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I2: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X9 @ ( set_ord_lessThan @ nat @ I2 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_6180_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_6181_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_6182_remdups__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( remdups @ nat @ ( upt @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% remdups_upt
thf(fact_6183_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X3: list @ A] :
      ( ( ( remdups @ A @ X3 )
        = ( nil @ A ) )
      = ( X3
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_6184_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X3: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X3 ) )
      = ( X3
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_6185_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_6186_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_6187_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_6188_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_6189_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_6190_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_6191_range__mult,axiom,
    ! [A3: real] :
      ( ( ( A3
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A3 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert2 @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A3
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A3 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_6192_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_6193_infinite__UNIV__int,axiom,
    ~ ( finite_finite @ int @ ( top_top @ ( set @ int ) ) ) ).

% infinite_UNIV_int
thf(fact_6194_top__enat__def,axiom,
    ( ( top_top @ extended_enat )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% top_enat_def
thf(fact_6195_remdups__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_6196_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_6197_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_6198_insert__remdups,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( insert @ A @ X3 @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ ( insert @ A @ X3 @ Xs ) ) ) ).

% insert_remdups
thf(fact_6199_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_6200_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_6201_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_6202_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X3 @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X3 @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_6203_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_6204_Ints__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_Ints @ A )
        = ( image @ int @ A @ ( ring_1_of_int @ A ) @ ( top_top @ ( set @ int ) ) ) ) ) ).

% Ints_def
thf(fact_6205_int__in__range__abs,axiom,
    ! [N: nat] : ( member2 @ int @ ( semiring_1_of_nat @ int @ N ) @ ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) ) ) ).

% int_in_range_abs
thf(fact_6206_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_6207_root__def,axiom,
    ( root
    = ( ^ [N2: nat,X4: real] :
          ( if @ real
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) )
            @ X4 ) ) ) ) ).

% root_def
thf(fact_6208_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_6209_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_6210_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_6211_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N ) ) ) ).

% char_of_mod_256
thf(fact_6212_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_6213_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A3: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A3 ) )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_6214_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N2: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_6215_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_6216_char_Osize_I2_J,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X15 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_6217_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_6218_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_6219_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_6220_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_6221_char_Osize__gen,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X15 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_6222_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_6223_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_6224_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list @ A,Y21: A,Y222: list @ A] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
thf(fact_6225_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X222 ) )
      = ( insert2 @ A @ X21 @ ( set2 @ A @ X222 ) ) ) ).

% list.simps(15)
thf(fact_6226_nth__Cons__Suc,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ ( suc @ N ) )
      = ( nth @ A @ Xs @ N ) ) ).

% nth_Cons_Suc
thf(fact_6227_nth__Cons__0,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ ( zero_zero @ nat ) )
      = X3 ) ).

% nth_Cons_0
thf(fact_6228_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X3 @ Xs ) )
      = ( cons @ A @ X3 @ ( take @ A @ N @ Xs ) ) ) ).

% take_Suc_Cons
thf(fact_6229_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( plus_plus @ A @ X3 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% sum_list.Cons
thf(fact_6230_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X3 @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_6231_singleton__rev__conv,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( ( cons @ A @ X3 @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X3 @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_6232_insert__Nil,axiom,
    ! [A: $tType,X3: A] :
      ( ( insert @ A @ X3 @ ( nil @ A ) )
      = ( cons @ A @ X3 @ ( nil @ A ) ) ) ).

% insert_Nil
thf(fact_6233_not__in__set__insert,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X3 @ Xs )
        = ( cons @ A @ X3 @ Xs ) ) ) ).

% not_in_set_insert
thf(fact_6234_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) ) @ ( listrel1 @ A @ R2 ) )
      = ( ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R2 )
          & ( Xs = Ys2 ) )
        | ( ( X3 = Y5 )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_6235_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A3: A,X3: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ ( cons @ B @ X3 @ Xs ) )
          = ( plus_plus @ A @ ( F2 @ X3 ) @ ( times_times @ A @ A3 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_6236_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X3: B,Xs: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X3 @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X3 ) @ ( enumerate @ B @ ( suc @ N ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_6237_nth__Cons__numeral,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_6238_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X3: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X3 @ Xs ) )
      = ( cons @ A @ X3 @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_6239_Cons__in__lex,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) ) @ ( lex @ A @ R2 ) )
      = ( ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R2 )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys2 ) ) )
        | ( ( X3 = Y5 )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lex @ A @ R2 ) ) ) ) ) ).

% Cons_in_lex
thf(fact_6240_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X4: B] : ( cons @ A @ ( F2 @ X4 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_6241_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_6242_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,X3: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) )
     => ( Xs
       != ( cons @ A @ X3 @ Ys2 ) ) ) ).

% impossible_Cons
thf(fact_6243_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C,Ws: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys2 )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X2: A,Xs3: list @ A,Y2: B,Ys4: list @ B,Z5: C,Zs2: list @ C,W3: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P @ Xs3 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ B @ Y2 @ Ys4 ) @ ( cons @ C @ Z5 @ Zs2 ) @ ( cons @ D @ W3 @ Ws2 ) ) ) ) ) )
             => ( P @ Xs @ Ys2 @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_6244_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys2 )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X2: A,Xs3: list @ A,Y2: B,Ys4: list @ B,Z5: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs3 @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ B @ Y2 @ Ys4 ) @ ( cons @ C @ Z5 @ Zs2 ) ) ) ) )
           => ( P @ Xs @ Ys2 @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_6245_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X2: A,Xs3: list @ A,Y2: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs3 @ Ys4 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ B @ Y2 @ Ys4 ) ) ) )
         => ( P @ Xs @ Ys2 ) ) ) ) ).

% list_induct2
thf(fact_6246_length__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_Cons
thf(fact_6247_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_6248_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_6249_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),X3: A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ X3 @ Ys2 ) ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel1I2
thf(fact_6250_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X3: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X3 @ Xs ) )
      = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( foldr @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_Cons
thf(fact_6251_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X3 @ ( nil @ B ) )
          = ( cons @ B @ X3 @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_6252_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( ( P @ X3 )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ ( takeWhile @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X3 )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_6253_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( ( ( Zs = Xs )
         => ( Ys2
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys2 )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X2: A,Xs4: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X2 @ Xs4 ) )
               => ! [Z5: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z5 @ Zs4 ) )
                   => ( ( X2 = Z5 )
                     => ~ ( member2 @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys2 ) ) ) ) )
           => ~ ! [Y2: A,Ys5: list @ A] :
                  ( ( Ys2
                    = ( cons @ A @ Y2 @ Ys5 ) )
                 => ! [Z5: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z5 @ Zs4 ) )
                     => ( ( Y2 = Z5 )
                       => ~ ( member2 @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys5 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_6254_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X21: A,X222: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X222 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X222 ) ) ) ).

% list.simps(9)
thf(fact_6255_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ A,F2: B > A,Ys2: list @ B] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ? [Z5: B,Zs2: list @ B] :
          ( ( Ys2
            = ( cons @ B @ Z5 @ Zs2 ) )
          & ( X3
            = ( F2 @ Z5 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_6256_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs: list @ B,Y5: A,Ys2: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y5 @ Ys2 ) )
     => ? [Z5: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z5 @ Zs2 ) )
          & ( ( F2 @ Z5 )
            = Y5 )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys2 ) ) ) ).

% map_eq_Cons_D
thf(fact_6257_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ A,F2: B > A,Ys2: list @ B] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
      = ( ? [Z3: B,Zs3: list @ B] :
            ( ( Ys2
              = ( cons @ B @ Z3 @ Zs3 ) )
            & ( X3
              = ( F2 @ Z3 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_6258_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Y5: A,Ys2: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y5 @ Ys2 ) )
      = ( ? [Z3: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z3 @ Zs3 ) )
            & ( ( F2 @ Z3 )
              = Y5 )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys2 ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_6259_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X4: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X4 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_6260_list__update__code_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,I: nat,Y5: A] :
      ( ( list_update @ A @ ( cons @ A @ X3 @ Xs ) @ ( suc @ I ) @ Y5 )
      = ( cons @ A @ X3 @ ( list_update @ A @ Xs @ I @ Y5 ) ) ) ).

% list_update_code(3)
thf(fact_6261_list__update__code_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A] :
      ( ( list_update @ A @ ( cons @ A @ X3 @ Xs ) @ ( zero_zero @ nat ) @ Y5 )
      = ( cons @ A @ Y5 @ Xs ) ) ).

% list_update_code(2)
thf(fact_6262_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_6263_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X3 )
      = ( cons @ A @ X3 @ ( replicate @ A @ N @ X3 ) ) ) ).

% replicate_Suc
thf(fact_6264_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A,Z2: A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( member2 @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z2 @ Ys2 ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_6265_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A,Z2: A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( member2 @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z2 @ Xs ) @ Ys2 ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_6266_distinct__length__2__or__more,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A3 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A3 != B2 )
        & ( distinct @ A @ ( cons @ A @ A3 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_6267_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y5: A,X222: list @ A,X21: A] :
      ( ( member2 @ A @ Y5 @ ( set2 @ A @ X222 ) )
     => ( member2 @ A @ Y5 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ) ).

% list.set_intros(2)
thf(fact_6268_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] : ( member2 @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ).

% list.set_intros(1)
thf(fact_6269_list_Oset__cases,axiom,
    ! [A: $tType,E: A,A3: list @ A] :
      ( ( member2 @ A @ E @ ( set2 @ A @ A3 ) )
     => ( ! [Z23: list @ A] :
            ( A3
           != ( cons @ A @ E @ Z23 ) )
       => ~ ! [Z12: A,Z23: list @ A] :
              ( ( A3
                = ( cons @ A @ Z12 @ Z23 ) )
             => ~ ( member2 @ A @ E @ ( set2 @ A @ Z23 ) ) ) ) ) ).

% list.set_cases
thf(fact_6270_set__ConsD,axiom,
    ! [A: $tType,Y5: A,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ Y5 @ ( set2 @ A @ ( cons @ A @ X3 @ Xs ) ) )
     => ( ( Y5 = X3 )
        | ( member2 @ A @ Y5 @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_6271_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,I: nat,V: A] :
      ( ( list_update @ A @ ( cons @ A @ X3 @ Xs ) @ I @ V )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V @ Xs )
        @ ^ [J4: nat] : ( cons @ A @ X3 @ ( list_update @ A @ Xs @ J4 @ V ) )
        @ I ) ) ).

% list_update.simps(2)
thf(fact_6272_not__Cons__self2,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( cons @ A @ X3 @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_6273_member__rec_I1_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A] :
      ( ( member @ A @ ( cons @ A @ X3 @ Xs ) @ Y5 )
      = ( ( X3 = Y5 )
        | ( member @ A @ Xs @ Y5 ) ) ) ).

% member_rec(1)
thf(fact_6274_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Y5: A,Xs: list @ A] :
      ( ( ( X3 = Y5 )
       => ( ( remove1 @ A @ X3 @ ( cons @ A @ Y5 @ Xs ) )
          = Xs ) )
      & ( ( X3 != Y5 )
       => ( ( remove1 @ A @ X3 @ ( cons @ A @ Y5 @ Xs ) )
          = ( cons @ A @ Y5 @ ( remove1 @ A @ X3 @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_6275_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Y5: A,Xs: list @ A] :
      ( ( ( X3 = Y5 )
       => ( ( removeAll @ A @ X3 @ ( cons @ A @ Y5 @ Xs ) )
          = ( removeAll @ A @ X3 @ Xs ) ) )
      & ( ( X3 != Y5 )
       => ( ( removeAll @ A @ X3 @ ( cons @ A @ Y5 @ Xs ) )
          = ( cons @ A @ Y5 @ ( removeAll @ A @ X3 @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_6276_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X3: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F5: A > B,Bs2: list @ B] :
          ( X3
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F5: A > B,A7: A,As: list @ A,Bs2: list @ B] :
            ( X3
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A7 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_6277_successively_Ocases,axiom,
    ! [A: $tType,X3: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X3
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ( ! [P8: A > A > $o,X2: A] :
            ( X3
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
       => ~ ! [P8: A > A > $o,X2: A,Y2: A,Xs3: list @ A] :
              ( X3
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs3 ) ) ) ) ) ) ).

% successively.cases
thf(fact_6278_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X3: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F5: A > B,X2: A] :
              ( X3
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F5 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
         => ( ! [F5: A > B,X2: A,Y2: A,Zs2: list @ A] :
                ( X3
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F5 @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) ) )
           => ~ ! [A7: A > B] :
                  ( X3
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A7 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_6279_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X3: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X3
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ~ ! [P8: A > A > $o,X2: A,Ys4: list @ A] :
            ( X3
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X2 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_6280_shuffles_Ocases,axiom,
    ! [A: $tType,X3: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X3
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs3: list @ A] :
            ( X3
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ ( nil @ A ) ) )
       => ~ ! [X2: A,Xs3: list @ A,Y2: A,Ys4: list @ A] :
              ( X3
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_6281_splice_Ocases,axiom,
    ! [A: $tType,X3: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X3
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X2: A,Xs3: list @ A,Ys4: list @ A] :
            ( X3
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_6282_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] : ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs3: list @ A] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_6283_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X2: A,Xs3: list @ A] : ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys4: list @ B] : ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys4 ) )
         => ( ! [X2: A,Xs3: list @ A,Y2: B,Ys4: list @ B] :
                ( ( P @ Xs3 @ Ys4 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ B @ Y2 @ Ys4 ) ) )
           => ( P @ Xs @ Ys2 ) ) ) ) ) ).

% list_induct2'
thf(fact_6284_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( Xs
            = ( cons @ A @ Y @ Ys3 ) ) ) ) ).

% neq_Nil_conv
thf(fact_6285_remdups__adj_Ocases,axiom,
    ! [A: $tType,X3: list @ A] :
      ( ( X3
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( X3
           != ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ~ ! [X2: A,Y2: A,Xs3: list @ A] :
              ( X3
             != ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs3 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_6286_transpose_Ocases,axiom,
    ! [A: $tType,X3: list @ ( list @ A )] :
      ( ( X3
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X3
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X2: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
              ( X3
             != ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_6287_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: list @ A] :
          ( ! [X2: A,Xs3: list @ A] :
              ( X3
             != ( cons @ A @ X2 @ Xs3 ) )
         => ( X3
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_6288_list_Oexhaust,axiom,
    ! [A: $tType,Y5: list @ A] :
      ( ( Y5
       != ( nil @ A ) )
     => ~ ! [X212: A,X223: list @ A] :
            ( Y5
           != ( cons @ A @ X212 @ X223 ) ) ) ).

% list.exhaust
thf(fact_6289_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X222: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_6290_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) ).

% list.distinct(1)
thf(fact_6291_sorted__wrt1,axiom,
    ! [A: $tType,P: A > A > $o,X3: A] : ( sorted_wrt @ A @ P @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_6292_distinct__singleton,axiom,
    ! [A: $tType,X3: A] : ( distinct @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_6293_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( ( P @ X3 )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ ( filter2 @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X3 )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( filter2 @ A @ P @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_6294_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_6295_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X3: B,Y5: B,Ys2: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X3 @ ( cons @ B @ Y5 @ Ys2 ) )
              = ( cons @ B @ X3 @ ( cons @ B @ Y5 @ Ys2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X3 @ ( cons @ B @ Y5 @ Ys2 ) )
              = ( cons @ B @ Y5 @ ( linorder_insort_key @ B @ A @ F2 @ X3 @ Ys2 ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_6296_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X3 @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_6297_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X3 @ Y5 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y5 @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_6298_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_6299_List_Oinsert__def,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X4: A,Xs2: list @ A] : ( if @ ( list @ A ) @ ( member2 @ A @ X4 @ ( set2 @ A @ Xs2 ) ) @ Xs2 @ ( cons @ A @ X4 @ Xs2 ) ) ) ) ).

% List.insert_def
thf(fact_6300_take__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( take @ A @ N @ ( cons @ A @ X3 @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M3: nat] : ( cons @ A @ X3 @ ( take @ A @ M3 @ Xs ) )
        @ N ) ) ).

% take_Cons
thf(fact_6301_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs @ Ys2 ) ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs ) @ Ys2 ) ) ).

% Cons_shuffles_subset1
thf(fact_6302_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y5: A,Xs: list @ A,Ys2: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y5 ) @ ( shuffles @ A @ Xs @ Ys2 ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) ) ).

% Cons_shuffles_subset2
thf(fact_6303_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y5: A,Ys2: list @ A,Xs: list @ A] :
      ( ( member2 @ ( list @ A ) @ ( cons @ A @ Y5 @ Ys2 ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member2 @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_6304_nth__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
      = ( case_nat @ A @ X3 @ ( nth @ A @ Xs ) @ N ) ) ).

% nth_Cons
thf(fact_6305_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X4: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X4 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_6306_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_6307_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X3 @ Ys2 ) )
          = ( ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Ys2 ) )
               => ( ord_less_eq @ A @ X3 @ X4 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 ) ) ) ) ).

% sorted_simps(2)
thf(fact_6308_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X3 @ Ys2 ) )
          = ( ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Ys2 ) )
               => ( ord_less @ A @ X3 @ X4 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys2 ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_6309_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A3: B] :
          ( ! [X2: B] :
              ( ( member2 @ B @ X2 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A3 ) @ ( F2 @ X2 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A3 @ Xs )
            = ( cons @ B @ A3 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_6310_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y5: A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) @ ( listrel1 @ A @ R2 ) )
     => ( ! [X2: A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys2 ) )
           => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y5 ) @ R2 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y5 @ Zs2 ) )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_6311_Cons__listrel1E1,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( ! [Y2: A] :
            ( ( Ys2
              = ( cons @ A @ Y2 @ Xs ) )
           => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R2 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys2
                = ( cons @ A @ X3 @ Zs2 ) )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_6312_listrel1I1,axiom,
    ! [A: $tType,X3: A,Y5: A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R2 )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Xs ) ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel1I1
thf(fact_6313_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Y5: A,Xs: list @ A] :
      ( ( ( X3 = Y5 )
       => ( ( count_list @ A @ ( cons @ A @ X3 @ Xs ) @ Y5 )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y5 ) @ ( one_one @ nat ) ) ) )
      & ( ( X3 != Y5 )
       => ( ( count_list @ A @ ( cons @ A @ X3 @ Xs ) @ Y5 )
          = ( count_list @ A @ Xs @ Y5 ) ) ) ) ).

% count_list.simps(2)
thf(fact_6314_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_6315_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y: A] : ( cons @ A @ Y @ Ys3 )
              @ Xs )
          @ ( n_lists @ A @ N @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_6316_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
          = X3 ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_6317_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X3: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X3 @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X3 @ X21 ) @ ( size_list @ A @ X3 @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_6318_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [Xs3: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ ( nil @ A ) ) )
             => ( P @ Xs3 @ ( nil @ A ) ) )
         => ( ! [X2: A,Xs3: list @ A,Y2: A,Ys4: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys4 ) ) )
               => ( ( P @ Xs3 @ ( cons @ A @ Y2 @ Ys4 ) )
                 => ( ( P @ ( cons @ A @ X2 @ Xs3 ) @ Ys4 )
                   => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) )
           => ( P @ A0 @ A1 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_6319_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I2: nat] : ( F2 @ ( suc @ I2 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_6320_nth__equal__first__eq,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,N: nat] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
            = X3 )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_6321_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X3: A,Y5: A,Xs: list @ A,N: nat] :
      ( ( X3 != Y5 )
     => ( ( ( nth @ A @ ( cons @ A @ X3 @ Xs ) @ N )
          = Y5 )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y5 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_6322_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X3 @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_6323_Cons__replicate__eq,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,N: nat,Y5: A] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( replicate @ A @ N @ Y5 ) )
      = ( ( X3 = Y5 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X3 ) ) ) ) ).

% Cons_replicate_eq
thf(fact_6324_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( set_Cons @ A @ A2 @ ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X4: A] : ( cons @ A @ X4 @ ( nil @ A ) )
        @ A2 ) ) ).

% set_Cons_sing_Nil
thf(fact_6325_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H2: A,T3: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_6326_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_6327_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_6328_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_6329_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > ( list @ A ) > B,X21: A,X222: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( cons @ A @ X21 @ X222 ) )
      = ( F22 @ X21 @ X222 ) ) ).

% list.simps(5)
thf(fact_6330_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M @ Q2 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_6331_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A2: set @ A,As2: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A2 @ As2 ) )
      = ( set_Cons @ A @ A2 @ ( listset @ A @ As2 ) ) ) ).

% listset.simps(2)
thf(fact_6332_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_6333_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H @ F1 )
        @ ^ [X16: A,X24: list @ A] : ( H @ ( F22 @ X16 @ X24 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_6334_upt__conv__Cons,axiom,
    ! [I: nat,J3: nat] :
      ( ( ord_less @ nat @ I @ J3 )
     => ( ( upt @ I @ J3 )
        = ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J3 ) ) ) ) ).

% upt_conv_Cons
thf(fact_6335_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_6336_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_6337_upt__eq__Cons__conv,axiom,
    ! [I: nat,J3: nat,X3: nat,Xs: list @ nat] :
      ( ( ( upt @ I @ J3 )
        = ( cons @ nat @ X3 @ Xs ) )
      = ( ( ord_less @ nat @ I @ J3 )
        & ( I = X3 )
        & ( ( upt @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ J3 )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_6338_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X3
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H2: A,T3: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H2: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_6339_transpose_Oelims,axiom,
    ! [A: $tType,X3: list @ ( list @ A ),Y5: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X3 )
        = Y5 )
     => ( ( ( X3
            = ( nil @ ( list @ A ) ) )
         => ( Y5
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X3
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y5
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X2: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X3
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss2 ) )
               => ( Y5
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X2
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H2: A,T3: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs3
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H2: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_6340_upt__rec,axiom,
    ( upt
    = ( ^ [I2: nat,J4: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I2 @ J4 ) @ ( cons @ nat @ I2 @ ( upt @ ( suc @ I2 ) @ J4 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_6341_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_6342_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J3: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I ) @ J3 )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J3 ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I ) @ J3 ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_6343_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J3: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ J3 )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J3 ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I ) @ J3 ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_6344_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X3
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H2: A,T3: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H2: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_6345_transpose_Opelims,axiom,
    ! [A: $tType,X3: list @ ( list @ A ),Y5: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X3 )
        = Y5 )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X3 )
       => ( ( ( X3
              = ( nil @ ( list @ A ) ) )
           => ( ( Y5
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X3
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y5
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X2: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X3
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss2 ) )
                 => ( ( Y5
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X2
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H2: A,T3: list @ A] : ( cons @ A @ H2 @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs3
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H2: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_6346_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_6347_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_6348_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_6349_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_6350_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X2: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs3
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H2: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_6351_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H2: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_6352_list__encode_Oelims,axiom,
    ! [X3: list @ nat,Y5: nat] :
      ( ( ( nat_list_encode @ X3 )
        = Y5 )
     => ( ( ( X3
            = ( nil @ nat ) )
         => ( Y5
           != ( zero_zero @ nat ) ) )
       => ~ ! [X2: nat,Xs3: list @ nat] :
              ( ( X3
                = ( cons @ nat @ X2 @ Xs3 ) )
             => ( Y5
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X2 @ ( nat_list_encode @ Xs3 ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_6353_tl__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ N ) ) ).

% tl_upt
thf(fact_6354_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_6355_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_6356_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_6357_tl__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( tl @ A @ ( replicate @ A @ N @ X3 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X3 ) ) ).

% tl_replicate
thf(fact_6358_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) ).

% list.sel(3)
thf(fact_6359_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X4: A] :
            ( Xs
            = ( cons @ A @ X4 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_6360_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X4: A] :
            ( Xs
            = ( cons @ A @ X4 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_6361_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List2: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
thf(fact_6362_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_6363_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A3: list @ A,X3: A] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ ( tl @ A @ A3 ) ) )
       => ( member2 @ A @ X3 @ ( set2 @ A @ A3 ) ) ) ) ).

% list.set_sel(2)
thf(fact_6364_take__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_tl
thf(fact_6365_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_6366_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_tl
thf(fact_6367_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_6368_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A3: list @ A,F2: A > B] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A3 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A3 ) ) ) ) ).

% list.map_sel(2)
thf(fact_6369_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X224: list @ A] : X224 ) ) ).

% tl_def
thf(fact_6370_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_6371_tl__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( take @ A @ N @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( tl @ A @ Xs ) ) ) ).

% tl_take
thf(fact_6372_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F23: A > ( list @ A ) > B,List3: list @ A] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F12
            @ ( F23 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_6373_list__encode_Osimps_I1_J,axiom,
    ( ( nat_list_encode @ ( nil @ nat ) )
    = ( zero_zero @ nat ) ) ).

% list_encode.simps(1)
thf(fact_6374_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs2: list @ A] :
            ( if @ nat
            @ ( Xs2
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_6375_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_6376_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z2: A,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ Ys2 ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z2 )
          & ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys2 ) ) )
        | ( ( Ys2
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys2 )
            = Z2 )
          & ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys2 ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_6377_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_6378_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_6379_take__Suc,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N @ ( tl @ A @ Xs ) ) ) ) ) ).

% take_Suc
thf(fact_6380_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F3: A > nat,Xs2: list @ A] :
            ( if @ nat
            @ ( Xs2
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F3 @ ( hd @ A @ Xs2 ) ) @ ( size_list @ A @ F3 @ ( tl @ A @ Xs2 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_6381_list__encode_Opelims,axiom,
    ! [X3: list @ nat,Y5: nat] :
      ( ( ( nat_list_encode @ X3 )
        = Y5 )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X3 )
       => ( ( ( X3
              = ( nil @ nat ) )
           => ( ( Y5
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X2: nat,Xs3: list @ nat] :
                ( ( X3
                  = ( cons @ nat @ X2 @ Xs3 ) )
               => ( ( Y5
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X2 @ ( nat_list_encode @ Xs3 ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X2 @ Xs3 ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_6382_shuffles_Opelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y5: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Xa ) )
       => ( ( ( X3
              = ( nil @ A ) )
           => ( ( Y5
                = ( insert2 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ( ( ( Xa
                = ( nil @ A ) )
             => ( ( Y5
                  = ( insert2 @ ( list @ A ) @ X3 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) ) ) )
           => ~ ! [X2: A,Xs3: list @ A] :
                  ( ( X3
                    = ( cons @ A @ X2 @ Xs3 ) )
                 => ! [Y2: A,Ys4: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ Y2 @ Ys4 ) )
                     => ( ( Y5
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y2 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs3 ) @ Ys4 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_6383_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X3 @ Y5 ) @ Z2 )
          = ( ( ord_less_eq @ A @ X3 @ Z2 )
            & ( ord_less_eq @ A @ Y5 @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_6384_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% sup.bounded_iff
thf(fact_6385_Un__subset__iff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) @ C6 )
      = ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
        & ( ord_less_eq @ ( set @ A ) @ B3 @ C6 ) ) ) ).

% Un_subset_iff
thf(fact_6386_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys2 ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) ) ).

% set_union
thf(fact_6387_Diff__subset__conv,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ C6 )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B3 @ C6 ) ) ) ).

% Diff_subset_conv
thf(fact_6388_Diff__partition,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( sup_sup @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) )
        = B3 ) ) ).

% Diff_partition
thf(fact_6389_Un__Pow__subset,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A2 ) @ ( pow2 @ A @ B3 ) ) @ ( pow2 @ A @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ) ).

% Un_Pow_subset
thf(fact_6390_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y5: A,X3: A] : ( ord_less_eq @ A @ Y5 @ ( sup_sup @ A @ X3 @ Y5 ) ) ) ).

% inf_sup_ord(4)
thf(fact_6391_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ X3 @ Y5 ) ) ) ).

% inf_sup_ord(3)
thf(fact_6392_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A,X3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ X3 )
         => ~ ( ( ord_less_eq @ A @ A3 @ X3 )
             => ~ ( ord_less_eq @ A @ B2 @ X3 ) ) ) ) ).

% le_supE
thf(fact_6393_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,X3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ X3 )
         => ( ( ord_less_eq @ A @ B2 @ X3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ X3 ) ) ) ) ).

% le_supI
thf(fact_6394_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ X3 @ Y5 ) ) ) ).

% sup_ge1
thf(fact_6395_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y5: A,X3: A] : ( ord_less_eq @ A @ Y5 @ ( sup_sup @ A @ X3 @ Y5 ) ) ) ).

% sup_ge2
thf(fact_6396_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X3 @ A3 )
         => ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_6397_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ X3 @ B2 )
         => ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_6398_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_6399_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_6400_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y5: A,X3: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( ord_less_eq @ A @ Z2 @ X3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y5 @ Z2 ) @ X3 ) ) ) ) ).

% sup_least
thf(fact_6401_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X4: A,Y: A] :
              ( ( sup_sup @ A @ X4 @ Y )
              = Y ) ) ) ) ).

% le_iff_sup
thf(fact_6402_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( A3
            = ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_6403_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( sup_sup @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% sup.orderI
thf(fact_6404_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X3: A,Y5: A] :
          ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ X2 @ ( F2 @ X2 @ Y2 ) )
         => ( ! [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ ( F2 @ X2 @ Y2 ) )
           => ( ! [X2: A,Y2: A,Z5: A] :
                  ( ( ord_less_eq @ A @ Y2 @ X2 )
                 => ( ( ord_less_eq @ A @ Z5 @ X2 )
                   => ( ord_less_eq @ A @ ( F2 @ Y2 @ Z5 ) @ X2 ) ) )
             => ( ( sup_sup @ A @ X3 @ Y5 )
                = ( F2 @ X3 @ Y5 ) ) ) ) ) ) ).

% sup_unique
thf(fact_6405_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% sup.absorb1
thf(fact_6406_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_6407_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( sup_sup @ A @ X3 @ Y5 )
            = X3 ) ) ) ).

% sup_absorb1
thf(fact_6408_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( sup_sup @ A @ X3 @ Y5 )
            = Y5 ) ) ) ).

% sup_absorb2
thf(fact_6409_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% sup.boundedE
thf(fact_6410_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% sup.boundedI
thf(fact_6411_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( sup_sup @ A @ A5 @ B4 ) ) ) ) ) ).

% sup.order_iff
thf(fact_6412_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ A3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_6413_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_6414_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_6415_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_6416_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_6417_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_6418_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: set @ A,B8: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A4 @ B8 )
            = B8 ) ) ) ).

% subset_Un_eq
thf(fact_6419_subset__UnE,axiom,
    ! [A: $tType,C6: set @ A,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ! [A11: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A11 @ A2 )
           => ! [B14: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B14 @ B3 )
               => ( C6
                 != ( sup_sup @ ( set @ A ) @ A11 @ B14 ) ) ) ) ) ).

% subset_UnE
thf(fact_6420_Un__absorb2,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
     => ( ( sup_sup @ ( set @ A ) @ A2 @ B3 )
        = A2 ) ) ).

% Un_absorb2
thf(fact_6421_Un__absorb1,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( sup_sup @ ( set @ A ) @ A2 @ B3 )
        = B3 ) ) ).

% Un_absorb1
thf(fact_6422_Un__upper2,axiom,
    ! [A: $tType,B3: set @ A,A2: set @ A] : ( ord_less_eq @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ).

% Un_upper2
thf(fact_6423_Un__upper1,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ).

% Un_upper1
thf(fact_6424_Un__least,axiom,
    ! [A: $tType,A2: set @ A,C6: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) @ C6 ) ) ) ).

% Un_least
thf(fact_6425_Un__mono,axiom,
    ! [A: $tType,A2: set @ A,C6: set @ A,B3: set @ A,D4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D4 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) @ ( sup_sup @ ( set @ A ) @ C6 @ D4 ) ) ) ) ).

% Un_mono
thf(fact_6426_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_6427_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_6428_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_6429_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y5: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ ( inf_inf @ A @ X3 @ Z2 ) ) @ ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y5 @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_6430_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X3: A,Y5: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y5 @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y5 ) @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_6431_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) @ C6 )
        = ( inf_inf @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B3 @ C6 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C6 @ A2 ) ) ).

% Un_Int_assoc_eq
thf(fact_6432_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,A3: A,B2: A] :
          ( ( ord_less @ A @ X3 @ A3 )
         => ( ord_less @ A @ X3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_6433_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X3: A,B2: A,A3: A] :
          ( ( ord_less @ A @ X3 @ B2 )
         => ( ord_less @ A @ X3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_6434_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% sup.absorb3
thf(fact_6435_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_6436_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less @ A @ B2 @ A3 )
             => ~ ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_6437_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( sup_sup @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_6438_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A3 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_6439_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_6440_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys2 ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) ) ) ).

% set_shuffles
thf(fact_6441_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( sup_sup @ A @ X3 @ Y5 )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ Y5 ) ) ) ).

% sup_shunt
thf(fact_6442_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y5 ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_6443_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X3 @ ( uminus_uminus @ A @ Y5 ) ) @ Z2 )
          = ( ord_less_eq @ A @ X3 @ ( sup_sup @ A @ Y5 @ Z2 ) ) ) ) ).

% shunt2
thf(fact_6444_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P3: A,Q2: A,R2: A] :
          ( ( ord_less_eq @ A @ P3 @ ( sup_sup @ A @ Q2 @ R2 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P3 @ ( uminus_uminus @ A @ Q2 ) ) @ R2 ) ) ) ).

% sup_neg_inf
thf(fact_6445_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A2 ) @ ( complete_Inf_Inf @ A @ B3 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_6446_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_6447_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_6448_card__Un__le,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) ) ) ).

% card_Un_le
thf(fact_6449_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_6450_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_6451_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A,Ys2: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y5 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs ) @ Ys2 ) ) ) ) ).

% shuffles.simps(3)
thf(fact_6452_Inter__Un__subset,axiom,
    ! [A: $tType,A2: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A2 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A2 @ B3 ) ) ) ).

% Inter_Un_subset
thf(fact_6453_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_6454_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_6455_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_6456_card__Un__Int,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_6457_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_6458_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_6459_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_6460_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_6461_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_6462_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_6463_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ A2
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X4: nat] : B3
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) ).

% SUP_nat_binary
thf(fact_6464_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X4: A,Y: A] : ( ord_less_eq @ A @ Y @ X4 )
        @ ^ [X4: A,Y: A] : ( ord_less @ A @ Y @ X4 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_6465_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) )
                 => ( ( G @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_6466_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_6467_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A2 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_6468_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_6469_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A2 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_6470_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_6471_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A2: set @ A,B3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_6472_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A2 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_6473_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A2 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_6474_card__Un__disjoint,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ( inf_inf @ ( set @ A ) @ A2 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_6475_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_6476_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_6477_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_6478_sum__Un__nat,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_6479_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_6480_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_6481_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A2: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A2 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) )
                 => ( ( F2 @ X2 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A2 @ B3 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A2 @ B3 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_6482_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_6483_shuffles_Oelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y5: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X3 @ Xa )
        = Y5 )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y5
           != ( insert2 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y5
             != ( insert2 @ ( list @ A ) @ X3 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X2: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X2 @ Xs3 ) )
               => ! [Y2: A,Ys4: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ Y2 @ Ys4 ) )
                   => ( Y5
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y2 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs3 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_6484_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Y5: A,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y5 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs ) @ Ys2 ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_6485_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X3: A,Ys2: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X3 ) ).

% concat_inth
thf(fact_6486_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I2: int,J4: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J4 @ I2 ) @ Js @ ( upto_aux @ I2 @ ( minus_minus @ int @ J4 @ ( one_one @ int ) ) @ ( cons @ int @ J4 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6487_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys2 = Zs ) ) ).

% same_append_eq
thf(fact_6488_append__same__eq,axiom,
    ! [A: $tType,Ys2: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys2 @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys2 = Zs ) ) ).

% append_same_eq
thf(fact_6489_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys2 ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys2 @ Zs ) ) ) ).

% append_assoc
thf(fact_6490_append_Oassoc,axiom,
    ! [A: $tType,A3: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A3 @ B2 ) @ C2 )
      = ( append @ A @ A3 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_6491_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_6492_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_6493_self__append__conv2,axiom,
    ! [A: $tType,Y5: list @ A,Xs: list @ A] :
      ( ( Y5
        = ( append @ A @ Xs @ Y5 ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_6494_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Ys2 )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_6495_self__append__conv,axiom,
    ! [A: $tType,Y5: list @ A,Ys2: list @ A] :
      ( ( Y5
        = ( append @ A @ Y5 @ Ys2 ) )
      = ( Ys2
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_6496_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Xs )
      = ( Ys2
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_6497_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_6498_append_Oright__neutral,axiom,
    ! [A: $tType,A3: list @ A] :
      ( ( append @ A @ A3 @ ( nil @ A ) )
      = A3 ) ).

% append.right_neutral
thf(fact_6499_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys2 ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys2 @ Vs ) )
        = ( ( Xs = Ys2 )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_6500_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys2 ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys2 ) ) ) ).

% map_append
thf(fact_6501_filter__append,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( filter2 @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys2 ) ) ) ).

% filter_append
thf(fact_6502_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( rev @ A @ Ys2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_6503_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys2: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys2 ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys2 ) ) ) ).

% concat_append
thf(fact_6504_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs: list @ B,Ys2: list @ B,A3: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs @ Ys2 ) @ A3 )
      = ( foldr @ B @ A @ F2 @ Xs @ ( foldr @ B @ A @ F2 @ Ys2 @ A3 ) ) ) ).

% foldr_append
thf(fact_6505_removeAll__append,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A] :
      ( ( removeAll @ A @ X3 @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( removeAll @ A @ X3 @ Xs ) @ ( removeAll @ A @ X3 @ Ys2 ) ) ) ).

% removeAll_append
thf(fact_6506_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X3: A,Ys2: list @ A,Y5: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) )
        = ( append @ A @ Ys2 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys2 )
        & ( X3 = Y5 ) ) ) ).

% append1_eq_conv
thf(fact_6507_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% length_append
thf(fact_6508_set__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) ) ).

% set_append
thf(fact_6509_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( groups8242544230860333062m_list @ A @ Ys2 ) ) ) ) ).

% sum_list_append
thf(fact_6510_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_6511_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys2 ) ) ) ).

% tl_append2
thf(fact_6512_takeWhile__append1,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X3 )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_6513_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys2 ) ) ) ) ).

% takeWhile_append2
thf(fact_6514_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A,Ys2: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ F2 @ Ys2 ) ) ) ).

% size_list_append
thf(fact_6515_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X3: A,Ys2: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X3 ) ).

% nth_append_length
thf(fact_6516_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys2 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
      = ( nth @ A @ Ys2 @ N ) ) ).

% nth_append_length_plus
thf(fact_6517_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y5: A,Ys2: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y5 @ Ys2 ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys2 ) @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_6518_take__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( take @ A @ N @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( take @ A @ N @ Xs ) @ ( take @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys2 ) ) ) ).

% take_append
thf(fact_6519_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X3: A,Ys2: list @ A,Y5: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ Ys2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y5 )
      = ( append @ A @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) ) ).

% list_update_length
thf(fact_6520_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys2 )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_6521_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_6522_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_6523_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_6524_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_6525_sup__int__def,axiom,
    ( ( sup_sup @ int )
    = ( ord_max @ int ) ) ).

% sup_int_def
thf(fact_6526_takeWhile__tail,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A,L: list @ A] :
      ( ~ ( P @ X3 )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ X3 @ L ) ) )
        = ( takeWhile @ A @ P @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_6527_replicate__app__Cons__same,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N @ X3 ) @ ( cons @ A @ X3 @ Xs ) )
      = ( cons @ A @ X3 @ ( append @ A @ ( replicate @ A @ N @ X3 ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_6528_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( P @ X4 ) ) )
      = ( ? [Ys3: list @ A,X4: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X4 @ Zs3 ) ) )
            & ( P @ X4 )
            & ! [Y: A] :
                ( ( member2 @ A @ Y @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_6529_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( P @ X4 ) ) )
      = ( ? [Ys3: list @ A,X4: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X4 @ Zs3 ) ) )
            & ( P @ X4 )
            & ! [Y: A] :
                ( ( member2 @ A @ Y @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_6530_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs3 ) ) )
            & ~ ( member2 @ A @ X3 @ ( set2 @ A @ Ys3 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_6531_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs3 ) ) )
            & ~ ( member2 @ A @ X3 @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_6532_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ~ ! [Ys4: list @ A,X2: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
           => ( ( P @ X2 )
             => ~ ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P @ Xa3 ) ) ) ) ) ).

% split_list_first_propE
thf(fact_6533_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ~ ! [Ys4: list @ A,X2: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
           => ( ( P @ X2 )
             => ~ ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P @ Xa3 ) ) ) ) ) ).

% split_list_last_propE
thf(fact_6534_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ? [Ys4: list @ A,X2: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ( P @ X2 )
          & ! [Xa3: A] :
              ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
             => ~ ( P @ Xa3 ) ) ) ) ).

% split_list_first_prop
thf(fact_6535_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ? [Ys4: list @ A,X2: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ( P @ X2 )
          & ! [Xa3: A] :
              ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa3 ) ) ) ) ).

% split_list_last_prop
thf(fact_6536_in__set__conv__decomp,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_6537_append__Cons__eq__iff,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A,Xs5: list @ A,Ys6: list @ A] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Ys2 ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X3 @ Ys2 ) )
            = ( append @ A @ Xs5 @ ( cons @ A @ X3 @ Ys6 ) ) )
          = ( ( Xs = Xs5 )
            & ( Ys2 = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_6538_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ~ ! [Ys4: list @ A,X2: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
           => ~ ( P @ X2 ) ) ) ).

% split_list_propE
thf(fact_6539_split__list__first,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ~ ( member2 @ A @ X3 @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_6540_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ? [Ys4: list @ A,X2: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ( P @ X2 ) ) ) ).

% split_list_prop
thf(fact_6541_split__list__last,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ~ ( member2 @ A @ X3 @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_6542_split__list,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) ) ) ).

% split_list
thf(fact_6543_append__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A] :
      ( ( append @ A @ ( cons @ A @ X3 @ Xs ) @ Ys2 )
      = ( cons @ A @ X3 @ ( append @ A @ Xs @ Ys2 ) ) ) ).

% append_Cons
thf(fact_6544_Cons__eq__appendI,axiom,
    ! [A: $tType,X3: A,Xs1: list @ A,Ys2: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X3 @ Xs1 )
        = Ys2 )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X3 @ Xs )
          = ( append @ A @ Ys2 @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_6545_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X3: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X3 @ Xs ) )
      = ( append @ A @ X3 @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_6546_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys2: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys2
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss1: list @ ( list @ A ),Xs2: list @ A,Xs6: list @ A,Xss22: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs6 ) @ Xss22 ) ) )
              & ( Ys2
                = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs2 ) )
              & ( Zs
                = ( append @ A @ Xs6 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_6547_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys2: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys2 @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss12: list @ ( list @ A ),Xs3: list @ A,Xs4: list @ A,Xss23: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs4 ) @ Xss23 ) ) )
            & ( Ys2
              = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs3 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_6548_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] : ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs3: list @ A] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_6549_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys2: list @ A,Zs: list @ A,X3: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys2 @ Zs )
        = ( cons @ A @ X3 @ Xs ) )
      = ( ( ( Ys2
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X3 @ Xs ) ) )
        | ? [Ys7: list @ A] :
            ( ( Ys2
              = ( cons @ A @ X3 @ Ys7 ) )
            & ( ( append @ A @ Ys7 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_6550_Cons__eq__append__conv,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ( ( Ys2
            = ( nil @ A ) )
          & ( ( cons @ A @ X3 @ Xs )
            = Zs ) )
        | ? [Ys7: list @ A] :
            ( ( ( cons @ A @ X3 @ Ys7 )
              = Ys2 )
            & ( Xs
              = ( append @ A @ Ys7 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_6551_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y2: A] :
            ( Xs
           != ( append @ A @ Ys4 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_6552_rev__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A,Xs3: list @ A] :
            ( ( P @ Xs3 )
           => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) ).

% rev_induct
thf(fact_6553_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs = Ys2 )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys2 ) ) ) ).

% eq_Nil_appendI
thf(fact_6554_append_Oleft__neutral,axiom,
    ! [A: $tType,A3: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A3 )
      = A3 ) ).

% append.left_neutral
thf(fact_6555_append__Nil,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys2 )
      = Ys2 ) ).

% append_Nil
thf(fact_6556_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
    ? [Ps: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs4 ) )
      & ( Ys2
        = ( append @ A @ Ps @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) ).

% longest_common_prefix
thf(fact_6557_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( hd @ A @ Ys2 ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_6558_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys2 ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys2 ) ) ) ).

% remdups_append2
thf(fact_6559_sorted__wrt__append,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,Ys2: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
      = ( ( sorted_wrt @ A @ P @ Xs )
        & ( sorted_wrt @ A @ P @ Ys2 )
        & ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ! [Y: A] :
                ( ( member2 @ A @ Y @ ( set2 @ A @ Ys2 ) )
               => ( P @ X4 @ Y ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_6560_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys2 )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys2
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_6561_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs1: list @ A,Zs: list @ A,Ys2: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys2
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys2 )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_6562_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X3: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M ) @ X3 )
      = ( append @ A @ ( replicate @ A @ N @ X3 ) @ ( replicate @ A @ M @ X3 ) ) ) ).

% replicate_add
thf(fact_6563_append__replicate__commute,axiom,
    ! [A: $tType,N: nat,X3: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X3 ) @ ( replicate @ A @ K @ X3 ) )
      = ( append @ A @ ( replicate @ A @ K @ X3 ) @ ( replicate @ A @ N @ X3 ) ) ) ).

% append_replicate_commute
thf(fact_6564_remove1__append,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A] :
      ( ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X3 @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ ( remove1 @ A @ X3 @ Xs ) @ Ys2 ) ) )
      & ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X3 @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X3 @ Ys2 ) ) ) ) ) ).

% remove1_append
thf(fact_6565_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys2 ) ) ) ).

% enumerate_append_eq
thf(fact_6566_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys2: list @ A,Zs: list @ A,F2: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys2 @ Zs )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys2
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs2 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_6567_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys2
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs2 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_6568_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys2 )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R2 ) ) ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys2 @ Vs ) ) @ ( listrel1 @ A @ R2 ) ) ) ).

% append_listrel1I
thf(fact_6569_lex__append__leftI,axiom,
    ! [A: $tType,Ys2: list @ A,Zs: list @ A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lex @ A @ R2 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R2 ) ) ) ).

% lex_append_leftI
thf(fact_6570_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_6571_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys2 )
        @ ^ [Z3: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys2 )
        @ Xs ) ) ).

% tl_append
thf(fact_6572_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Ys2 @ Xs ) )
     => ? [M4: nat,N3: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M4 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
            = Ys2 ) ) ) ).

% comm_append_are_replicate
thf(fact_6573_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs != Ys2 )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys2 ) )
       => ? [Pre: list @ A,X2: A,Xs4: list @ A,Y2: A,Ys5: list @ A] :
            ( ( X2 != Y2 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys2
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_6574_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys2 ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys2 )
            & ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
               => ! [Y: A] :
                    ( ( member2 @ A @ Y @ ( set2 @ A @ Ys2 ) )
                   => ( ord_less_eq @ A @ X4 @ Y ) ) ) ) ) ) ).

% sorted_append
thf(fact_6575_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs3: list @ A,Ys4: list @ A,Zs2: list @ A,Y2: A] :
          ( Ws
          = ( append @ A @ Xs3 @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_6576_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( ~ ( distinct @ A @ As3 ) )
      = ( ? [Xs2: list @ A,Y: A,Ys3: list @ A] :
            ( ( member2 @ A @ Y @ ( set2 @ A @ Xs2 ) )
            & ( distinct @ A @ Xs2 )
            & ( As3
              = ( append @ A @ Xs2 @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_6577_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: A > $o,Ys2: list @ A,X3: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys2 )
        = ( cons @ A @ X3 @ Xs ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys2
              = ( append @ A @ Us2 @ ( cons @ A @ X3 @ Vs2 ) ) )
            & ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X4 ) )
            & ( P @ X3 )
            & ( Xs
              = ( filter2 @ A @ P @ Vs2 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_6578_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( filter2 @ A @ P @ Ys2 ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys2
              = ( append @ A @ Us2 @ ( cons @ A @ X3 @ Vs2 ) ) )
            & ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X4 ) )
            & ( P @ X3 )
            & ( Xs
              = ( filter2 @ A @ P @ Vs2 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_6579_filter__eq__ConsD,axiom,
    ! [A: $tType,P: A > $o,Ys2: list @ A,X3: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys2 )
        = ( cons @ A @ X3 @ Xs ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys2
            = ( append @ A @ Us3 @ ( cons @ A @ X3 @ Vs3 ) ) )
          & ! [X: A] :
              ( ( member2 @ A @ X @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X ) )
          & ( P @ X3 )
          & ( Xs
            = ( filter2 @ A @ P @ Vs3 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_6580_Cons__eq__filterD,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( filter2 @ A @ P @ Ys2 ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys2
            = ( append @ A @ Us3 @ ( cons @ A @ X3 @ Vs3 ) ) )
          & ! [X: A] :
              ( ( member2 @ A @ X @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X ) )
          & ( P @ X3 )
          & ( Xs
            = ( filter2 @ A @ P @ Vs3 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_6581_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_6582_replicate__append__same,axiom,
    ! [A: $tType,I: nat,X3: A] :
      ( ( append @ A @ ( replicate @ A @ I @ X3 ) @ ( cons @ A @ X3 @ ( nil @ A ) ) )
      = ( cons @ A @ X3 @ ( replicate @ A @ I @ X3 ) ) ) ).

% replicate_append_same
thf(fact_6583_upt__add__eq__append,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( upt @ I @ ( plus_plus @ nat @ J3 @ K ) )
        = ( append @ nat @ ( upt @ I @ J3 ) @ ( upt @ J3 @ ( plus_plus @ nat @ J3 @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_6584_list__update__append1,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,Ys2: list @ A,X3: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys2 ) @ I @ X3 )
        = ( append @ A @ ( list_update @ A @ Xs @ I @ X3 ) @ Ys2 ) ) ) ).

% list_update_append1
thf(fact_6585_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J3: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( set_or7035219750837199246ssThan @ nat @ I @ ( plus_plus @ nat @ J3 @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I @ J3 ) @ ( set_or7035219750837199246ssThan @ nat @ J3 @ ( plus_plus @ nat @ J3 @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_6586_remove1__split,axiom,
    ! [A: $tType,A3: A,Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A3 @ Xs )
          = Ys2 )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A3 @ Rs ) ) )
              & ~ ( member2 @ A @ A3 @ ( set2 @ A @ Ls ) )
              & ( Ys2
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_6587_lex__append__leftD,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ! [X2: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R2 ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lex @ A @ R2 ) ) ) ) ).

% lex_append_leftD
thf(fact_6588_lex__append__left__iff,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ! [X2: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R2 ) )
        = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lex @ A @ R2 ) ) ) ) ).

% lex_append_left_iff
thf(fact_6589_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_6590_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lex @ A @ R2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys2 @ Vs ) ) @ ( lex @ A @ R2 ) ) ) ) ).

% lex_append_rightI
thf(fact_6591_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_6592_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_6593_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_6594_nth__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys2 ) @ N )
          = ( nth @ A @ Xs @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys2 ) @ N )
          = ( nth @ A @ Ys2 @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_6595_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A,X3: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys2 ) @ N @ X3 )
          = ( append @ A @ ( list_update @ A @ Xs @ N @ X3 ) @ Ys2 ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys2 ) @ N @ X3 )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys2 @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ X3 ) ) ) ) ) ).

% list_update_append
thf(fact_6596_listrel1I,axiom,
    ! [A: $tType,X3: A,Y5: A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R2 )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X3 @ Vs ) ) )
       => ( ( Ys2
            = ( append @ A @ Us @ ( cons @ A @ Y5 @ Vs ) ) )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% listrel1I
thf(fact_6597_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ~ ! [X2: A,Y2: A] :
            ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 )
           => ! [Us3: list @ A,Vs3: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs3 ) ) )
               => ( Ys2
                 != ( append @ A @ Us3 @ ( cons @ A @ Y2 @ Vs3 ) ) ) ) ) ) ).

% listrel1E
thf(fact_6598_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ A,Ys2: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X3 @ Xs ) @ Ys2 )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ Ys2 ) @ ( product @ A @ B @ Xs @ Ys2 ) ) ) ).

% product.simps(2)
thf(fact_6599_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X3: A,Ys2: list @ A,Y5: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ ( append @ A @ Ys2 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R2 ) )
      = ( ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
          & ( X3 = Y5 ) )
        | ( ( Xs = Ys2 )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R2 ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_6600_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A3: A,Xs: list @ B,Ys2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ ( append @ B @ Xs @ Ys2 ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A3 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ Ys2 ) ) ) ) ) ).

% horner_sum_append
thf(fact_6601_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_6602_upt__Suc__append,axiom,
    ! [I: nat,J3: nat] :
      ( ( ord_less_eq @ nat @ I @ J3 )
     => ( ( upt @ I @ ( suc @ J3 ) )
        = ( append @ nat @ ( upt @ I @ J3 ) @ ( cons @ nat @ J3 @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_6603_upt__Suc,axiom,
    ! [I: nat,J3: nat] :
      ( ( ( ord_less_eq @ nat @ I @ J3 )
       => ( ( upt @ I @ ( suc @ J3 ) )
          = ( append @ nat @ ( upt @ I @ J3 ) @ ( cons @ nat @ J3 @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I @ J3 )
       => ( ( upt @ I @ ( suc @ J3 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_6604_Pow__set_I2_J,axiom,
    ! [B: $tType,X3: B,Xs: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X3 @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert2 @ B @ X3 ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_6605_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys2
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys2 )
            = ( append @ A @ Ys2 @ Xs ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs @ Ys2 ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_6606_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X2 @ A3 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ A3
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A3 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_6607_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I ) @ Xs )
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_6608_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X3: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( M != N )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) @ M )
            = ( nth @ A @ Xs @ M ) ) ) ) ) ).

% nth_repl
thf(fact_6609_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y5: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ Y5 @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N ) @ Xs ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_6610_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X4: list @ A] : X4 ) ) ).

% drop0
thf(fact_6611_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ ( plus_plus @ nat @ N @ M ) @ Xs ) ) ).

% drop_drop
thf(fact_6612_drop__upt,axiom,
    ! [M: nat,I: nat,J3: nat] :
      ( ( drop @ nat @ M @ ( upt @ I @ J3 ) )
      = ( upt @ ( plus_plus @ nat @ I @ M ) @ J3 ) ) ).

% drop_upt
thf(fact_6613_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ ( cons @ A @ X3 @ Xs ) )
      = ( drop @ A @ N @ Xs ) ) ).

% drop_Suc_Cons
thf(fact_6614_length__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_drop
thf(fact_6615_append__take__drop__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( drop @ A @ N @ Xs ) )
      = Xs ) ).

% append_take_drop_id
thf(fact_6616_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,X3: A] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X3 ) )
        = ( drop @ A @ M @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_6617_drop__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X3: A] :
      ( ( drop @ A @ I @ ( replicate @ A @ K @ X3 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I ) @ X3 ) ) ).

% drop_replicate
thf(fact_6618_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_6619_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil
thf(fact_6620_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_6621_drop__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys2: list @ A] :
      ( ( drop @ A @ N @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( drop @ A @ N @ Xs ) @ ( drop @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys2 ) ) ) ).

% drop_append
thf(fact_6622_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X3: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X3 @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_6623_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs ) @ I )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N @ I ) ) ) ) ).

% nth_drop
thf(fact_6624_nth__via__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y5: A,Ys2: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( cons @ A @ Y5 @ Ys2 ) )
     => ( ( nth @ A @ Xs @ N )
        = Y5 ) ) ).

% nth_via_drop
thf(fact_6625_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_6626_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_drop_subset
thf(fact_6627_drop__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( drop @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( drop @ B @ N @ Xs ) ) ) ).

% drop_map
thf(fact_6628_distinct__drop,axiom,
    ! [A: $tType,Xs: list @ A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( drop @ A @ I @ Xs ) ) ) ).

% distinct_drop
thf(fact_6629_drop__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ M @ N ) @ ( drop @ A @ N @ Xs ) ) ) ).

% drop_take
thf(fact_6630_in__set__dropD,axiom,
    ! [A: $tType,X3: A,N: nat,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) )
     => ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% in_set_dropD
thf(fact_6631_sorted__wrt__drop,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( drop @ A @ N @ Xs ) ) ) ).

% sorted_wrt_drop
thf(fact_6632_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_6633_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( drop @ A @ M @ Xs ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N @ M ) @ Xs ) ) ) ).

% take_drop
thf(fact_6634_drop__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( drop @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% drop_Nil
thf(fact_6635_tl__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( drop @ A @ N @ Xs ) )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% tl_drop
thf(fact_6636_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ Xs )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% drop_Suc
thf(fact_6637_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_6638_take__add,axiom,
    ! [A: $tType,I: nat,J3: nat,Xs: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I @ J3 ) @ Xs )
      = ( append @ A @ ( take @ A @ I @ Xs ) @ ( take @ A @ J3 @ ( drop @ A @ I @ Xs ) ) ) ) ).

% take_add
thf(fact_6639_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Zs )
      = ( ( Xs
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) )
        & ( Ys2
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_6640_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A,X3: A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X3 ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs ) @ ( minus_minus @ nat @ N @ M ) @ X3 ) ) ) ).

% drop_update_swap
thf(fact_6641_drop__Cons,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( drop @ A @ N @ ( cons @ A @ X3 @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X3 @ Xs )
        @ ^ [M3: nat] : ( drop @ A @ M3 @ Xs )
        @ N ) ) ).

% drop_Cons
thf(fact_6642_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X3: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ Xs ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X3 @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_6643_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_6644_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ N ) ) ) ).

% hd_drop_conv_nth
thf(fact_6645_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% drop_rev
thf(fact_6646_rev__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I ) @ ( rev @ A @ Xs ) ) ) ).

% rev_drop
thf(fact_6647_rev__take,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( rev @ A @ ( take @ A @ I @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I ) @ ( rev @ A @ Xs ) ) ) ).

% rev_take
thf(fact_6648_take__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% take_rev
thf(fact_6649_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs ) )
        = ( drop @ A @ I @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_6650_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I: nat,J3: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I @ J3 )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J3 @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_6651_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_6652_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,A3: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I @ A3 )
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ A3 @ ( drop @ A @ ( suc @ I ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_6653_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_6654_upto_Opelims,axiom,
    ! [X3: int,Xa: int,Y5: list @ int] :
      ( ( ( upto @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X3 @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X3 @ Xa )
               => ( Y5
                  = ( cons @ int @ X3 @ ( upto @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X3 @ Xa )
               => ( Y5
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X3 @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_6655_upto_Opsimps,axiom,
    ! [I: int,J3: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I @ J3 ) )
     => ( ( ( ord_less_eq @ int @ I @ J3 )
         => ( ( upto @ I @ J3 )
            = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J3 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I @ J3 )
         => ( ( upto @ I @ J3 )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6656_upto__empty,axiom,
    ! [J3: int,I: int] :
      ( ( ord_less @ int @ J3 @ I )
     => ( ( upto @ I @ J3 )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_6657_upto__Nil2,axiom,
    ! [I: int,J3: int] :
      ( ( ( nil @ int )
        = ( upto @ I @ J3 ) )
      = ( ord_less @ int @ J3 @ I ) ) ).

% upto_Nil2
thf(fact_6658_upto__Nil,axiom,
    ! [I: int,J3: int] :
      ( ( ( upto @ I @ J3 )
        = ( nil @ int ) )
      = ( ord_less @ int @ J3 @ I ) ) ).

% upto_Nil
thf(fact_6659_upto__single,axiom,
    ! [I: int] :
      ( ( upto @ I @ I )
      = ( cons @ int @ I @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_6660_nth__upto,axiom,
    ! [I: int,K: nat,J3: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) @ J3 )
     => ( ( nth @ int @ ( upto @ I @ J3 ) @ K )
        = ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6661_length__upto,axiom,
    ! [I: int,J3: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I @ J3 ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J3 @ I ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_6662_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6663_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6664_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6665_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6666_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I2: int,J4: int] : ( append @ int @ ( upto @ I2 @ J4 ) ) ) ) ).

% upto_aux_def
thf(fact_6667_sorted__wrt__upto,axiom,
    ! [I: int,J3: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I @ J3 ) ) ).

% sorted_wrt_upto
thf(fact_6668_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I2: int,J4: int] : ( set2 @ int @ ( upto @ I2 @ J4 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_6669_distinct__upto,axiom,
    ! [I: int,J3: int] : ( distinct @ int @ ( upto @ I @ J3 ) ) ).

% distinct_upto
thf(fact_6670_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I2: int,J4: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J4 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_6671_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_6672_upto__code,axiom,
    ( upto
    = ( ^ [I2: int,J4: int] : ( upto_aux @ I2 @ J4 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_6673_upto__split2,axiom,
    ! [I: int,J3: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J3 )
     => ( ( ord_less_eq @ int @ J3 @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ J3 ) @ ( upto @ ( plus_plus @ int @ J3 @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6674_upto__split1,axiom,
    ! [I: int,J3: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J3 )
     => ( ( ord_less_eq @ int @ J3 @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) @ ( upto @ J3 @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6675_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I2: int,J4: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J4 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_6676_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I2: int,J4: int] : ( set2 @ int @ ( upto @ I2 @ ( minus_minus @ int @ J4 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_6677_upto__rec1,axiom,
    ! [I: int,J3: int] :
      ( ( ord_less_eq @ int @ I @ J3 )
     => ( ( upto @ I @ J3 )
        = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% upto_rec1
thf(fact_6678_upto_Oelims,axiom,
    ! [X3: int,Xa: int,Y5: list @ int] :
      ( ( ( upto @ X3 @ Xa )
        = Y5 )
     => ( ( ( ord_less_eq @ int @ X3 @ Xa )
         => ( Y5
            = ( cons @ int @ X3 @ ( upto @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X3 @ Xa )
         => ( Y5
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6679_upto_Osimps,axiom,
    ( upto
    = ( ^ [I2: int,J4: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I2 @ J4 ) @ ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J4 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6680_upto__rec2,axiom,
    ! [I: int,J3: int] :
      ( ( ord_less_eq @ int @ I @ J3 )
     => ( ( upto @ I @ J3 )
        = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) @ ( cons @ int @ J3 @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6681_upto__split3,axiom,
    ! [I: int,J3: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J3 )
     => ( ( ord_less_eq @ int @ J3 @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) @ ( cons @ int @ J3 @ ( upto @ ( plus_plus @ int @ J3 @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6682_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [X2: A,Xs3: list @ A,Ys4: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Ys4 ) )
             => ( ( P @ Ys4 @ Xs3 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) @ Ys4 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) ).

% splice.pinduct
thf(fact_6683_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys ) ) ) ) ).

% set_relcomp
thf(fact_6684_relcomp__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set @ ( product_prod @ A @ B ),R2: set @ ( product_prod @ A @ B ),S8: set @ ( product_prod @ B @ C ),S: set @ ( product_prod @ B @ C )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ R2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S8 @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R3 @ S8 ) @ ( relcomp @ A @ B @ C @ R2 @ S ) ) ) ) ).

% relcomp_mono
thf(fact_6685_min__ext__compat,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S2 ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R4 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R4 ) ) ) ).

% min_ext_compat
thf(fact_6686_splice_Opelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y5: list @ A] :
      ( ( ( splice @ A @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Xa ) )
       => ( ( ( X3
              = ( nil @ A ) )
           => ( ( Y5 = Xa )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X2: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X2 @ Xs3 ) )
               => ( ( Y5
                    = ( cons @ A @ X2 @ ( splice @ A @ Xa @ Xs3 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xa ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_6687_splice__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% splice_Nil2
thf(fact_6688_split__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( splice @ A @ Xs @ Ys2 )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) ).

% split_Nil_iff
thf(fact_6689_splice__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] : ( member2 @ ( list @ A ) @ ( splice @ A @ Xs @ Ys2 ) @ ( shuffles @ A @ Xs @ Ys2 ) ) ).

% splice_in_shuffles
thf(fact_6690_length__splice,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ).

% length_splice
thf(fact_6691_splice__replicate,axiom,
    ! [A: $tType,M: nat,X3: A,N: nat] :
      ( ( splice @ A @ ( replicate @ A @ M @ X3 ) @ ( replicate @ A @ N @ X3 ) )
      = ( replicate @ A @ ( plus_plus @ nat @ M @ N ) @ X3 ) ) ).

% splice_replicate
thf(fact_6692_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A] :
      ( ( splice @ A @ ( cons @ A @ X3 @ Xs ) @ Ys2 )
      = ( cons @ A @ X3 @ ( splice @ A @ Ys2 @ Xs ) ) ) ).

% splice.simps(2)
thf(fact_6693_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( splice @ A @ ( nil @ A ) @ Ys2 )
      = Ys2 ) ).

% splice.simps(1)
thf(fact_6694_splice_Oelims,axiom,
    ! [A: $tType,X3: list @ A,Xa: list @ A,Y5: list @ A] :
      ( ( ( splice @ A @ X3 @ Xa )
        = Y5 )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y5 != Xa ) )
       => ~ ! [X2: A,Xs3: list @ A] :
              ( ( X3
                = ( cons @ A @ X2 @ Xs3 ) )
             => ( Y5
               != ( cons @ A @ X2 @ ( splice @ A @ Xa @ Xs3 ) ) ) ) ) ) ).

% splice.elims
thf(fact_6695_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ Ys2 ) )
     => ( ( splice @ A @ ( cons @ A @ X3 @ Xs ) @ Ys2 )
        = ( cons @ A @ X3 @ ( splice @ A @ Ys2 @ Xs ) ) ) ) ).

% splice.psimps(2)
thf(fact_6696_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys2 )
        = Ys2 ) ) ).

% splice.psimps(1)
thf(fact_6697_max__ext__compat,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S2 ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R4 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R4 ) ) ) ).

% max_ext_compat
thf(fact_6698_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A,Y5: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys2 @ ( product_Pair @ A @ ( list @ A ) @ Y5 @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys2 @ ( cons @ A @ Y5 @ Zs ) ) )
        & ( P @ Y5 )
        & ~ ? [X: A] :
              ( ( member2 @ A @ X @ ( set2 @ A @ Ys2 ) )
              & ( P @ X ) ) ) ) ).

% extract_SomeE
thf(fact_6699_extract__Nil__code,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( extract @ A @ P @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_6700_extract__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
              & ( P @ X4 ) ) ) ) ).

% extract_None_iff
thf(fact_6701_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys2: list @ A,Y5: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys2 @ ( product_Pair @ A @ ( list @ A ) @ Y5 @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys2 @ ( cons @ A @ Y5 @ Zs ) ) )
        & ( P @ Y5 )
        & ~ ? [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Ys2 ) )
              & ( P @ X4 ) ) ) ) ).

% extract_Some_iff
thf(fact_6702_INF__filter__not__bot,axiom,
    ! [I6: $tType,A: $tType,B3: set @ I6,F4: I6 > ( filter @ A )] :
      ( ! [X10: set @ I6] :
          ( ( ord_less_eq @ ( set @ I6 ) @ X10 @ B3 )
         => ( ( finite_finite @ I6 @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I6 @ ( filter @ A ) @ F4 @ X10 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I6 @ ( filter @ A ) @ F4 @ B3 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_6703_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B3: set @ B] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( member2 @ B @ ( F2 @ X2 ) @ B3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B3 ) ) ).

% image_Collect_subsetI
thf(fact_6704_Inf__filter__not__bot,axiom,
    ! [A: $tType,B3: set @ ( filter @ A )] :
      ( ! [X10: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X10 @ B3 )
         => ( ( finite_finite @ ( filter @ A ) @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X10 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B3 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_6705_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,F4: A > ( filter @ B )] :
      ( ! [I3: A] :
          ( ( member2 @ A @ I3 @ I5 )
         => ! [J2: A] :
              ( ( member2 @ A @ J2 @ I5 )
             => ? [X: A] :
                  ( ( member2 @ A @ X @ I5 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ I3 ) @ ( F4 @ J2 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ I5 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X4: A] :
              ( ( member2 @ A @ X4 @ I5 )
              & ( ( F4 @ X4 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_6706_prop__restrict,axiom,
    ! [A: $tType,X3: A,Z8: set @ A,X9: set @ A,P: A > $o] :
      ( ( member2 @ A @ X3 @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member2 @ A @ X4 @ X9 )
                & ( P @ X4 ) ) ) )
       => ( P @ X3 ) ) ) ).

% prop_restrict
thf(fact_6707_Collect__restrict,axiom,
    ! [A: $tType,X9: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X4: A] :
            ( ( member2 @ A @ X4 @ X9 )
            & ( P @ X4 ) ) )
      @ X9 ) ).

% Collect_restrict
thf(fact_6708_subset__emptyI,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ! [X2: A] :
          ~ ( member2 @ A @ X2 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_6709_insert__subsetI,axiom,
    ! [A: $tType,X3: A,A2: set @ A,X9: set @ A] :
      ( ( member2 @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ X9 @ A2 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X3 @ X9 ) @ A2 ) ) ) ).

% insert_subsetI
thf(fact_6710_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs2 ) @ ( product_Pair @ A @ ( list @ A ) @ Y @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs2 ) ) ) ) ).

% extract_def
thf(fact_6711_DERIV__even__real__root,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_6712_dropWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P @ ( dropWhile @ A @ P @ Xs ) )
      = ( dropWhile @ A @ P @ Xs ) ) ).

% dropWhile_idem
thf(fact_6713_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_6714_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
        = ( dropWhile @ A @ P @ Ys2 ) ) ) ).

% dropWhile_append2
thf(fact_6715_dropWhile__append1,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X3 )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys2 ) ) ) ) ).

% dropWhile_append1
thf(fact_6716_dropWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X3: A,N: nat] :
      ( ( ( P @ X3 )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N @ X3 ) )
          = ( nil @ A ) ) )
      & ( ~ ( P @ X3 )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N @ X3 ) )
          = ( replicate @ A @ N @ X3 ) ) ) ) ).

% dropWhile_replicate
thf(fact_6717_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( dropWhile @ A @ P @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_6718_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y5: A,Z2: A,X3: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z2 @ X3 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z2 ) @ S2 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z2 ) ) @ Y5 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_6719_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X3: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X3 ) @ ( image @ A @ A @ G @ S ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_6720_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y5: A,Z2: A,X3: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z2 @ X3 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z2 ) @ S2 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ Z2 @ X4 ) )
            @ Y5
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_6721_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F9 @ F10 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F10 @ F9 ) ) ) ) ).

% less_filter_def
thf(fact_6722_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_6723_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_6724_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y5: A,X3: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_6725_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,X3: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_6726_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X3 @ S ) @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) ) ) ).

% at_le
thf(fact_6727_DERIV__pos__imp__increasing,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A3 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y6 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_6728_DERIV__neg__imp__decreasing,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A3 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y6 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_6729_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A3 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y6 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_6730_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A3 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y6 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_6731_deriv__nonneg__imp__mono,axiom,
    ! [A3: real,B2: real,G: real > real,G4: real > real] :
      ( ! [X2: real] :
          ( ( member2 @ real @ X2 @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X2: real] :
            ( ( member2 @ real @ X2 @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G4 @ X2 ) ) )
       => ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A3 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_6732_MVT2,axiom,
    ! [A3: real,B2: real,F2: real > real,F8: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less_eq @ real @ A3 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z5: real] :
            ( ( ord_less @ real @ A3 @ Z5 )
            & ( ord_less @ real @ Z5 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A3 ) @ ( F8 @ Z5 ) ) ) ) ) ) ).

% MVT2
thf(fact_6733_hd__dropWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
       != ( nil @ A ) )
     => ~ ( P @ ( hd @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_6734_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_6735_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( dropWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_6736_DERIV__local__const,axiom,
    ! [F2: real > real,L: real,X3: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y2: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y2 ) ) @ D2 )
             => ( ( F2 @ X3 )
                = ( F2 @ Y2 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_6737_DERIV__ln,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_6738_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X3: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( cos @ A @ ( G @ X4 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X3 ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_6739_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa: A] :
          ( has_field_derivative @ A
          @ ^ [X4: A] : ( cos @ A @ ( plus_plus @ A @ X4 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_6740_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X3: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member2 @ real @ ( minus_minus @ real @ X3 @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F2 @ X3 ) @ ( F2 @ ( minus_minus @ real @ X3 @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_6741_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X3: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member2 @ real @ ( minus_minus @ real @ X3 @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X3 @ H5 ) ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_6742_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( ( ( G @ X3 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X4: A] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D4 @ ( G @ X3 ) ) @ ( times_times @ A @ ( F2 @ X3 ) @ E4 ) ) @ ( times_times @ A @ ( G @ X3 ) @ ( G @ X3 ) ) )
                @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_6743_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X3: A,S: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X3 ) ) @ ( times_times @ A @ Db @ ( F2 @ X3 ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_6744_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X3 ) @ E4 ) @ ( times_times @ A @ D4 @ ( G @ X3 ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_6745_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
            @ ( times_times @ A @ C2 @ D4 )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_6746_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
            @ ( times_times @ A @ D4 @ C2 )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_6747_has__field__derivative__cosh,axiom,
    ! [A15: $tType] :
      ( ( ( real_Vector_banach @ A15 )
        & ( real_V3459762299906320749_field @ A15 ) )
     => ! [G: A15 > A15,Db: A15,X3: A15,S: set @ A15] :
          ( ( has_field_derivative @ A15 @ G @ Db @ ( topolo174197925503356063within @ A15 @ X3 @ S ) )
         => ( has_field_derivative @ A15
            @ ^ [X4: A15] : ( cosh @ A15 @ ( G @ X4 ) )
            @ ( times_times @ A15 @ ( sinh @ A15 @ ( G @ X3 ) ) @ Db )
            @ ( topolo174197925503356063within @ A15 @ X3 @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_6748_has__field__derivative__sinh,axiom,
    ! [A15: $tType] :
      ( ( ( real_Vector_banach @ A15 )
        & ( real_V3459762299906320749_field @ A15 ) )
     => ! [G: A15 > A15,Db: A15,X3: A15,S: set @ A15] :
          ( ( has_field_derivative @ A15 @ G @ Db @ ( topolo174197925503356063within @ A15 @ X3 @ S ) )
         => ( has_field_derivative @ A15
            @ ^ [X4: A15] : ( sinh @ A15 @ ( G @ X4 ) )
            @ ( times_times @ A15 @ ( cosh @ A15 @ ( G @ X3 ) ) @ Db )
            @ ( topolo174197925503356063within @ A15 @ X3 @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_6749_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( divide_divide @ A @ ( F2 @ X4 ) @ C2 )
            @ ( divide_divide @ A @ D4 @ C2 )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% DERIV_cdivide
thf(fact_6750_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X3: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_6751_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,F4: filter @ A,G: A > A,G4: A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G4 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z3: A] : ( plus_plus @ A @ ( F2 @ Z3 ) @ ( G @ Z3 ) )
              @ ( plus_plus @ A @ F8 @ G4 )
              @ F4 ) ) ) ) ).

% field_differentiable_add
thf(fact_6752_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( plus_plus @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( plus_plus @ A @ D4 @ E4 )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_6753_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X4: A] : K
          @ ( zero_zero @ A )
          @ F4 ) ) ).

% DERIV_const
thf(fact_6754_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X3: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member2 @ real @ ( plus_plus @ real @ X3 @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F2 @ X3 ) @ ( F2 @ ( plus_plus @ real @ X3 @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_6755_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X3: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member2 @ real @ ( plus_plus @ real @ X3 @ H5 ) @ S2 )
                 => ( ( ord_less @ real @ H5 @ D3 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X3 @ H5 ) ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_6756_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X3 ) ) @ D4 ) @ ( inverse_inverse @ A @ ( F2 @ X3 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_6757_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X3: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X3 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_6758_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X3: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X3 @ H5 ) ) @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_6759_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X3: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F2 @ X3 ) @ ( F2 @ ( plus_plus @ real @ X3 @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_6760_DERIV__isconst__all,axiom,
    ! [F2: real > real,X3: real,Y5: real] :
      ( ! [X2: real] : ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F2 @ X3 )
        = ( F2 @ Y5 ) ) ) ).

% DERIV_isconst_all
thf(fact_6761_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y5: A,X3: A,Z2: A] :
          ( ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X3 @ Z2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ X4 @ Z2 ) )
            @ Y5
            @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_6762_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X3: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( sin @ A @ ( G @ X4 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X3 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_6763_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G: A > A,G4: A > A,F2: A > A,F8: A,X3: A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ S )
             => ( has_field_derivative @ A @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member2 @ A @ ( F2 @ X3 ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
                @ ( times_times @ A @ F8 @ ( G4 @ ( F2 @ X3 ) ) )
                @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_6764_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G4: A > A,F2: A > A,F8: A,X3: A] :
          ( ! [X2: A] : ( has_field_derivative @ A @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
              @ ( times_times @ A @ F8 @ ( G4 @ ( F2 @ X3 ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_6765_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X3: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X3 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( F2 @ ( G @ X4 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_6766_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,G: A > A,E4: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E4 @ ( topolo174197925503356063within @ A @ ( F2 @ X3 ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
              @ ( times_times @ A @ E4 @ D4 )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_6767_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X3: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( exp @ A @ ( G @ X4 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X3 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_6768_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X3: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F2 @ X3 ) @ ( F2 @ ( minus_minus @ real @ X3 @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_6769_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X3: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D3 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X3 @ H5 ) ) @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_6770_DERIV__const__ratio__const2,axiom,
    ! [A3: real,B2: real,F2: real > real,K: real] :
      ( ( A3 != B2 )
     => ( ! [X2: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) ) @ ( minus_minus @ real @ B2 @ A3 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_6771_DERIV__const__ratio__const,axiom,
    ! [A3: real,B2: real,F2: real > real,K: real] :
      ( ( A3 != B2 )
     => ( ! [X2: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A3 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_6772_dropWhile__append3,axiom,
    ! [A: $tType,P: A > $o,Y5: A,Xs: list @ A,Ys2: list @ A] :
      ( ~ ( P @ Y5 )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) )
        = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) ) ) ) ).

% dropWhile_append3
thf(fact_6773_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_6774_DERIV__isconst3,axiom,
    ! [A3: real,B2: real,X3: real,Y5: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( member2 @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
       => ( ( member2 @ real @ Y5 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
         => ( ! [X2: real] :
                ( ( member2 @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X3 )
              = ( F2 @ Y5 ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_6775_set__dropWhileD,axiom,
    ! [A: $tType,X3: A,P: A > $o,Xs: list @ A] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_6776_dropWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ L ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( dropWhile @ A @ P @ L )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_6777_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_6778_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( ( P @ X3 )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( dropWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X3 )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_6779_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( power_power @ A @ ( F2 @ X4 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D4 @ ( power_power @ A @ ( F2 @ X3 ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_6780_DERIV__const__average,axiom,
    ! [A3: real,B2: real,V: real > real,K: real] :
      ( ( A3 != B2 )
     => ( ! [X2: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A3 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A3 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_6781_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X3: A,S: set @ A] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_6782_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( power_power @ A @ ( F2 @ X4 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D4 @ ( power_power @ A @ ( F2 @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% DERIV_power
thf(fact_6783_DERIV__local__min,axiom,
    ! [F2: real > real,L: real,X3: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y2: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y2 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_6784_DERIV__local__max,axiom,
    ! [F2: real > real,L: real,X3: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y2: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y2 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y2 ) @ ( F2 @ X3 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_6785_DERIV__ln__divide,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_6786_DERIV__pow,axiom,
    ! [N: nat,X3: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X4: real] : ( power_power @ real @ X4 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X3 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X3 @ S ) ) ).

% DERIV_pow
thf(fact_6787_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X3: A] :
          ( ! [Y2: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_6788_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A3: A,X3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ X3 )
         => ( ( ord_less @ A @ X3 @ B2 )
           => ( ( topolo174197925503356063within @ A @ X3 @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_6789_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X3: real,N: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X4: real] : ( power_power @ real @ ( G @ X4 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G @ X3 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_6790_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_6791_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X3: A,S: set @ A,G: A > A,E: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( has_field_derivative @ A @ G @ E @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( ( ( G @ X3 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y: A] : ( divide_divide @ A @ ( F2 @ Y ) @ ( G @ Y ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X3 ) ) @ ( times_times @ A @ E @ ( F2 @ X3 ) ) ) @ ( power_power @ A @ ( G @ X3 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_6792_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X3: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X3 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_6793_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Y5: A,Ys2: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( cons @ A @ Y5 @ Ys2 ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) ) )
        & ~ ( P @ Y5 ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_6794_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F8: A,Z2: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z5 ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) )
                @ ( F2 @ Z5 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) )
                @ F8 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_6795_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ! [X2: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
         => ~ ( P @ X2 ) )
     => ( ( takeWhile @ A @ P @ Xs )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_6796_dropWhile__eq__drop,axiom,
    ! [A: $tType] :
      ( ( dropWhile @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] : ( drop @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs2 ) ) @ Xs2 ) ) ) ).

% dropWhile_eq_drop
thf(fact_6797_has__real__derivative__powr,axiom,
    ! [Z2: real,R2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z2 )
     => ( has_field_derivative @ real
        @ ^ [Z3: real] : ( powr @ real @ Z3 @ R2 )
        @ ( times_times @ real @ R2 @ ( powr @ real @ Z2 @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_6798_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F8: real > nat > real,X0: real,A3: real,B2: real,L5: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X4: real] : ( F2 @ X4 @ N3 )
          @ ( F8 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X2: real] :
            ( ( member2 @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
           => ( summable @ real @ ( F2 @ X2 ) ) )
       => ( ( member2 @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
         => ( ( summable @ real @ ( F8 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N3: nat,X2: real,Y2: real] :
                    ( ( member2 @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
                   => ( ( member2 @ real @ Y2 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X2 @ N3 ) @ ( F2 @ Y2 @ N3 ) ) ) @ ( times_times @ real @ ( L5 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y2 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X4: real] : ( suminf @ real @ ( F2 @ X4 ) )
                  @ ( suminf @ real @ ( F8 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_6799_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X3: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X4: A] :
                      ( suminf @ A
                      @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) )
                  @ ( suminf @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
                  @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_6800_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X3: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_6801_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z2: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z5 ) @ K5 )
             => ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z3: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z3 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_6802_DERIV__log,axiom,
    ! [X3: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X3 ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_6803_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X3: real,R2: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) )
       => ( has_field_derivative @ real
          @ ^ [X4: real] : ( powr @ real @ ( G @ X4 ) @ R2 )
          @ ( times_times @ real @ ( times_times @ real @ R2 @ ( powr @ real @ ( G @ X3 ) @ ( minus_minus @ real @ R2 @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_6804_DERIV__powr,axiom,
    ! [G: real > real,M: real,X3: real,F2: real > real,R2: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) )
       => ( ( has_field_derivative @ real @ F2 @ R2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X4: real] : ( powr @ real @ ( G @ X4 ) @ ( F2 @ X4 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X3 ) @ ( F2 @ X3 ) ) @ ( plus_plus @ real @ ( times_times @ real @ R2 @ ( ln_ln @ real @ ( G @ X3 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X3 ) ) @ ( G @ X3 ) ) ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_6805_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_6806_DERIV__real__sqrt,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X3 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_6807_DERIV__arctan,axiom,
    ! [X3: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_6808_arsinh__real__has__field__derivative,axiom,
    ! [X3: real,A2: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ A2 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_6809_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( sin @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_6810_has__field__derivative__tanh,axiom,
    ! [A15: $tType] :
      ( ( ( real_Vector_banach @ A15 )
        & ( real_V3459762299906320749_field @ A15 ) )
     => ! [G: A15 > A15,X3: A15,Db: A15,S: set @ A15] :
          ( ( ( cosh @ A15 @ ( G @ X3 ) )
           != ( zero_zero @ A15 ) )
         => ( ( has_field_derivative @ A15 @ G @ Db @ ( topolo174197925503356063within @ A15 @ X3 @ S ) )
           => ( has_field_derivative @ A15
              @ ^ [X4: A15] : ( tanh @ A15 @ ( G @ X4 ) )
              @ ( times_times @ A15 @ ( minus_minus @ A15 @ ( one_one @ A15 ) @ ( power_power @ A15 @ ( tanh @ A15 @ ( G @ X3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A15 @ X3 @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_6811_DERIV__real__sqrt__generic,axiom,
    ! [X3: real,D4: real] :
      ( ( X3
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
         => ( D4
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X3 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
           => ( D4
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X3 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_6812_arcosh__real__has__field__derivative,axiom,
    ! [X3: real,A2: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ A2 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_6813_artanh__real__has__field__derivative,axiom,
    ! [X3: real,A2: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ A2 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_6814_DERIV__power__series_H,axiom,
    ! [R4: real,F2: nat > real,X0: real] :
      ( ! [X2: real] :
          ( ( member2 @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R4 ) @ R4 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) )
     => ( ( member2 @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R4 ) @ R4 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
         => ( has_field_derivative @ real
            @ ^ [X4: real] :
                ( suminf @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( F2 @ N2 ) @ ( power_power @ real @ X4 @ ( suc @ N2 ) ) ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X0 @ N2 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_6815_dropWhile__nth,axiom,
    ! [A: $tType,J3: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs ) @ J3 )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_6816_DERIV__real__root,axiom,
    ! [N: nat,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_6817_DERIV__arccos,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_6818_DERIV__arcsin,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_6819_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y: A] : ( Y != X3 )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X3
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y: A] : ( Y != X3 )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_6820_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y: A] : ( Y != X3 )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y: A] : ( Y != X3 )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_6821_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X3: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X2: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
          & ( ( F2 @ X3 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X3 @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6822_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X3: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X2: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
            & ( ( F2 @ X3 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X3 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_6823_DERIV__odd__real__root,axiom,
    ! [N: nat,X3: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X3
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6824_Maclaurin__minus,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ H @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F2 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6825_Maclaurin2,axiom,
    ! [H: real,Diff: nat > real > real,F2: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H )
              & ( ( F2 @ H )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6826_Maclaurin,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H )
                & ( ( F2 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6827_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X3: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X3
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X2: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
                & ( ( F2 @ X3 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X3 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6828_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X3: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T4: real] :
            ( ( ( ord_less @ nat @ M4 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X3 ) )
            & ( ( F2 @ X3 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X3 @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X3 @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6829_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A3: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A3 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A3 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A3 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F2 @ A3 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A3 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A3 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6830_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A3: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A3 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A3 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6831_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A3: real,B2: real,C2: real,X3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A3 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A3 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A3 @ X3 )
               => ( ( ord_less_eq @ real @ X3 @ B2 )
                 => ( ( X3 != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X3 @ C2 )
                         => ( ( ord_less @ real @ X3 @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X3 @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X3 ) ) )
                        & ( ( F2 @ X3 )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X3 @ C2 ) @ M3 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X3 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6832_Maclaurin__lemma2,axiom,
    ! [N: nat,H: real,Diff: nat > real > real,K: nat,B3: real] :
      ( ! [M4: nat,T4: real] :
          ( ( ( ord_less @ nat @ M4 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ U2 @ P6 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M2 ) ) )
                    @ ( times_times @ real @ B3 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ T8 @ P6 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B3 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6833_DERIV__arctan__series,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X6: real] :
            ( suminf @ real
            @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X6 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( power_power @ real @ X3 @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_6834_DERIV__real__root__generic,axiom,
    ! [N: nat,X3: real,D4: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X3
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
             => ( D4
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X3 @ ( zero_zero @ real ) )
               => ( D4
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D4
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X3 ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D4 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_6835_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X3: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X3 ) )
         => ( ( ord_less @ real @ ( G @ X3 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X4: A] : ( arcsin @ ( G @ X4 ) )
                @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6836_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X3: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X3 ) )
         => ( ( ord_less @ real @ ( G @ X3 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X4: A] : ( arccos @ ( G @ X4 ) )
                @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6837_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_6838_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F3: A > A,D7: A] : ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D7 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6839_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A > A,F4: filter @ A,D8: A] :
          ( ( has_derivative @ A @ A @ F2 @ D4 @ F4 )
         => ( ! [X2: A] :
                ( ( times_times @ A @ X2 @ D8 )
                = ( D4 @ X2 ) )
           => ( has_field_derivative @ A @ F2 @ D8 @ F4 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6840_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ F4 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D4 ) @ F4 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6841_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F8: D > real,X3: D,S: set @ D,G: D > C,G4: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X3 @ S ) )
         => ( ( has_derivative @ D @ C @ G @ G4 @ ( topolo174197925503356063within @ D @ X3 @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X4: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ^ [H2: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X3 ) @ ( G4 @ H2 ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F8 @ H2 ) @ ( G @ X3 ) ) )
              @ ( topolo174197925503356063within @ D @ X3 @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6842_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F4: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X4: A] : C2
          @ ^ [X4: A] : ( zero_zero @ B )
          @ F4 ) ) ).

% has_derivative_const
thf(fact_6843_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,F4: filter @ A,G: A > B,G4: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G4 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ^ [X4: A] : ( plus_plus @ B @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
              @ F4 ) ) ) ) ).

% has_derivative_add
thf(fact_6844_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G4: C > A,F4: filter @ C,X3: A] :
          ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ X3 @ ( G @ X4 ) )
            @ ^ [X4: C] : ( times_times @ A @ X3 @ ( G4 @ X4 ) )
            @ F4 ) ) ) ).

% has_derivative_mult_right
thf(fact_6845_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G4: C > A,F4: filter @ C,Y5: A] :
          ( ( has_derivative @ C @ A @ G @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ ( G @ X4 ) @ Y5 )
            @ ^ [X4: C] : ( times_times @ A @ ( G4 @ X4 ) @ Y5 )
            @ F4 ) ) ) ).

% has_derivative_mult_left
thf(fact_6846_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F8: D > A,X3: D,S: set @ D,G: D > A,G4: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X3 @ S ) )
         => ( ( has_derivative @ D @ A @ G @ G4 @ ( topolo174197925503356063within @ D @ X3 @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ^ [H2: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X3 ) @ ( G4 @ H2 ) ) @ ( times_times @ A @ ( F8 @ H2 ) @ ( G @ X3 ) ) )
              @ ( topolo174197925503356063within @ D @ X3 @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6847_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: A > B,X3: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X4: A] : ( zero_zero @ B )
            @ F4
            @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( F4
            = ( ^ [H2: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_6848_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G4: A > A > B,F2: C > A,S: set @ C,X3: C,F8: C > A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
           => ( ( member2 @ C @ X3 @ S )
             => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X3 @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X4: C] : ( G @ ( F2 @ X4 ) )
                  @ ^ [Y: C] : ( G4 @ ( F2 @ X3 ) @ ( F8 @ Y ) )
                  @ ( topolo174197925503356063within @ C @ X3 @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6849_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( exp @ real @ ( G @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( exp @ real @ ( G @ X3 ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_6850_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( sin @ real @ ( G @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( cos @ real @ ( G @ X3 ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_6851_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X4: A] : ( sinh @ A @ ( G @ X4 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X3 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_6852_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X4: A] : ( cosh @ A @ ( G @ X4 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X3 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_6853_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F8: C > A,X3: C,S2: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X3 @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X3 @ S2 ) )
           => ( ( ( G @ X3 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X4: C] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ^ [H2: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F8 @ H2 ) @ ( G @ X3 ) ) @ ( times_times @ A @ ( F2 @ X3 ) @ ( G4 @ H2 ) ) ) @ ( times_times @ A @ ( G @ X3 ) @ ( G @ X3 ) ) )
                @ ( topolo174197925503356063within @ C @ X3 @ S2 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6854_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X3: C,F8: C > A,S2: set @ C] :
          ( ( ( F2 @ X3 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X3 @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X4: C] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ^ [H2: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X3 ) ) @ ( F8 @ H2 ) ) @ ( inverse_inverse @ A @ ( F2 @ X3 ) ) ) )
              @ ( topolo174197925503356063within @ C @ X3 @ S2 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6855_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: A,S2: set @ A] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H2: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X3 ) @ H2 ) @ ( inverse_inverse @ A @ X3 ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6856_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F8: real,G: A > real,X3: A,G4: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F8 @ ( topolo174197925503356063within @ real @ ( G @ X3 ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( F2 @ ( G @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ F8 )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6857_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( cos @ real @ ( G @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X3 ) ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_6858_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A,S2: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
         => ( has_derivative @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N )
            @ ^ [Y: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F8 @ Y ) ) @ ( power_power @ B @ ( F2 @ X3 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% has_derivative_power
thf(fact_6859_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X3: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( ln_ln @ real @ ( G @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( G @ X3 ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6860_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F8: C > A,X3: C,S2: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X3 @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X3 @ S2 ) )
           => ( ( ( G @ X3 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X4: C] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ^ [H2: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X3 ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X3 ) ) @ ( G4 @ H2 ) ) @ ( inverse_inverse @ A @ ( G @ X3 ) ) ) ) @ ( divide_divide @ A @ ( F8 @ H2 ) @ ( G @ X3 ) ) )
                @ ( topolo174197925503356063within @ C @ X3 @ S2 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6861_has__derivative__prod,axiom,
    ! [B: $tType,I6: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I5: set @ I6,F2: I6 > A > B,F8: I6 > A > B,X3: A,S2: set @ A] :
          ( ! [I3: I6] :
              ( ( member2 @ I6 @ I3 @ I5 )
             => ( has_derivative @ A @ B @ ( F2 @ I3 ) @ ( F8 @ I3 ) @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X4: A] :
                ( groups7121269368397514597t_prod @ I6 @ B
                @ ^ [I2: I6] : ( F2 @ I2 @ X4 )
                @ I5 )
            @ ^ [Y: A] :
                ( groups7311177749621191930dd_sum @ I6 @ B
                @ ^ [I2: I6] :
                    ( times_times @ B @ ( F8 @ I2 @ Y )
                    @ ( groups7121269368397514597t_prod @ I6 @ B
                      @ ^ [J4: I6] : ( F2 @ J4 @ X3 )
                      @ ( minus_minus @ ( set @ I6 ) @ I5 @ ( insert2 @ I6 @ I2 @ ( bot_bot @ ( set @ I6 ) ) ) ) ) )
                @ I5 )
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% has_derivative_prod
thf(fact_6862_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X3: A,X9: set @ A,F2: A > real,F8: A > real] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ X9 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ X9 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) )
             => ( ( member2 @ A @ X3 @ X9 )
               => ( has_derivative @ A @ real
                  @ ^ [X4: A] : ( powr @ real @ ( G @ X4 ) @ ( F2 @ X4 ) )
                  @ ^ [H2: A] : ( times_times @ real @ ( powr @ real @ ( G @ X3 ) @ ( F2 @ X3 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F8 @ H2 ) @ ( ln_ln @ real @ ( G @ X3 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G4 @ H2 ) @ ( F2 @ X3 ) ) @ ( G @ X3 ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X3 @ X9 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6863_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X3: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( sqrt @ ( G @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X3 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6864_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( arctan @ ( G @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_6865_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X3: A,G4: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G @ X3 ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( tan @ real @ ( G @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6866_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X4: A,Xa4: list @ A] : ( some @ A @ X4 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs2 ) ) ) ) ).

% find_dropWhile
thf(fact_6867_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X3: A,F2: real > Aa,G4: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X3 ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member2 @ Aa @ ( F2 @ ( G @ X3 ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X4: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X4 ) ) ) )
                @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6868_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A3: A,Y5: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A3 ) @ Y5 )
         => ( ( ord_less_eq @ B @ Y5 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A3 @ B2 )
             => ( ! [X2: A] :
                    ( ( ( ord_less_eq @ A @ A3 @ X2 )
                      & ( ord_less_eq @ A @ X2 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A3 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y5 ) ) ) ) ) ) ) ).

% IVT
thf(fact_6869_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y5: B,A3: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y5 )
         => ( ( ord_less_eq @ B @ Y5 @ ( F2 @ A3 ) )
           => ( ( ord_less_eq @ A @ A3 @ B2 )
             => ( ! [X2: A] :
                    ( ( ( ord_less_eq @ A @ A3 @ X2 )
                      & ( ord_less_eq @ A @ X2 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A3 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y5 ) ) ) ) ) ) ) ).

% IVT2
thf(fact_6870_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F4
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6871_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X4: D] : ( times_times @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6872_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6873_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6874_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6875_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N ) ) ) ) ).

% continuous_power
thf(fact_6876_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X4: D] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_add
thf(fact_6877_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys2 ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( find @ A @ P @ Xs )
          = ( find @ A @ Q @ Ys2 ) ) ) ) ).

% find_cong
thf(fact_6878_isCont__Lb__Ub,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ( ord_less_eq @ real @ A3 @ X2 )
              & ( ord_less_eq @ real @ X2 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L6: real,M10: real] :
            ( ! [X: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X )
                  & ( ord_less_eq @ real @ X @ B2 ) )
               => ( ( ord_less_eq @ real @ L6 @ ( F2 @ X ) )
                  & ( ord_less_eq @ real @ ( F2 @ X ) @ M10 ) ) )
            & ! [Y6: real] :
                ( ( ( ord_less_eq @ real @ L6 @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ M10 ) )
               => ? [X2: real] :
                    ( ( ord_less_eq @ real @ A3 @ X2 )
                    & ( ord_less_eq @ real @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y6 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_6879_isCont__real__sqrt,axiom,
    ! [X3: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_6880_isCont__real__root,axiom,
    ! [X3: real,N: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ ( root @ N ) ) ).

% isCont_real_root
thf(fact_6881_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A3: A,S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S ) @ G )
           => ( ( ( G @ A3 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S )
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6882_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A3: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( times_times @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6883_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A3: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% isCont_add
thf(fact_6884_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A3: A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N ) ) ) ) ).

% isCont_power
thf(fact_6885_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A3: A,S: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S ) @ F2 )
         => ( ( ( F2 @ A3 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S )
              @ ^ [X4: A] : ( inverse_inverse @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_6886_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A3: A,S: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S ) @ F2 )
         => ( ( ( F2 @ A3 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S )
              @ ^ [X4: A] : ( sgn_sgn @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_6887_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( ( P @ X3 )
       => ( ( find @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( some @ A @ X3 ) ) )
      & ( ~ ( P @ X3 )
       => ( ( find @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( find @ A @ P @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_6888_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > $o] :
      ( ( find @ A @ Uu @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_6889_find__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
              & ( P @ X4 ) ) ) ) ).

% find_None_iff
thf(fact_6890_find__None__iff2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P @ Xs ) )
      = ( ~ ? [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
              & ( P @ X4 ) ) ) ) ).

% find_None_iff2
thf(fact_6891_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
              ! [X: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X )
                  & ( ord_less_eq @ real @ X @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X ) @ M10 ) ) ) ) ) ).

% isCont_bounded
thf(fact_6892_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A3 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X ) @ M10 ) )
                & ? [X2: real] :
                    ( ( ord_less_eq @ real @ A3 @ X2 )
                    & ( ord_less_eq @ real @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_6893_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A3 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ M10 @ ( F2 @ X ) ) )
                & ? [X2: real] :
                    ( ( ord_less_eq @ real @ A3 @ X2 )
                    & ( ord_less_eq @ real @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_6894_isCont__inverse__function2,axiom,
    ! [A3: real,X3: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ X3 )
     => ( ( ord_less @ real @ X3 @ B2 )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ A3 @ Z5 )
             => ( ( ord_less_eq @ real @ Z5 @ B2 )
               => ( ( G @ ( F2 @ Z5 ) )
                  = Z5 ) ) )
         => ( ! [Z5: real] :
                ( ( ord_less_eq @ real @ A3 @ Z5 )
               => ( ( ord_less_eq @ real @ Z5 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X3 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6895_isCont__ln,axiom,
    ! [X3: real] :
      ( ( X3
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_6896_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A3: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A3 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6897_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A3: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ A3 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( sgn_sgn @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_6898_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,S: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ S ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ X3 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ S )
              @ ^ [X4: A] : ( tan @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_6899_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A,S: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ S ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ X3 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ S )
              @ ^ [X4: A] : ( cot @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_6900_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: C,A2: set @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X3 @ A2 ) @ F2 )
         => ( ( ( cosh @ A @ ( F2 @ X3 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X3 @ A2 )
              @ ^ [X4: C] : ( tanh @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_6901_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A,X3: A] :
          ( ( has_field_derivative @ A @ F2 @ L @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G2: A > A] :
                ( ! [Z3: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z3 ) @ ( F2 @ X3 ) )
                    = ( times_times @ A @ ( G2 @ Z3 ) @ ( minus_minus @ A @ Z3 @ X3 ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ G2 )
                & ( ( G2 @ X3 )
                  = L ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6902_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A3 @ B2 )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A3 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X ) @ M10 ) )
                & ! [N8: A] :
                    ( ( ord_less @ A @ N8 @ M10 )
                   => ? [X2: real] :
                        ( ( ord_less_eq @ real @ A3 @ X2 )
                        & ( ord_less_eq @ real @ X2 @ B2 )
                        & ( ord_less @ A @ N8 @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6903_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cos @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_6904_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( sin @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_6905_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ( cosh @ A @ X3 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_6906_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ A3 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( tan @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_6907_isCont__arcosh,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6908_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ A3 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( cot @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_6909_DERIV__inverse__function,axiom,
    ! [F2: real > real,D4: real,G: real > real,X3: real,A3: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D4 @ ( topolo174197925503356063within @ real @ ( G @ X3 ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D4
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A3 @ X3 )
         => ( ( ord_less @ real @ X3 @ B2 )
           => ( ! [Y2: real] :
                  ( ( ord_less @ real @ A3 @ Y2 )
                 => ( ( ord_less @ real @ Y2 @ B2 )
                   => ( ( F2 @ ( G @ Y2 ) )
                      = Y2 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D4 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_6910_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A3: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W2: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ W2 @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_6911_isCont__arccos,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6912_isCont__arcsin,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6913_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X3: A] :
          ( ! [Y2: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X4: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6914_LIM__less__bound,axiom,
    ! [B2: real,X3: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X3 )
     => ( ! [X2: real] :
            ( ( member2 @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X3 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6915_isCont__artanh,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6916_find__Some__iff2,axiom,
    ! [A: $tType,X3: A,P: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X3 )
        = ( find @ A @ P @ Xs ) )
      = ( ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I2 ) )
            & ( X3
              = ( nth @ A @ Xs @ I2 ) )
            & ! [J4: nat] :
                ( ( ord_less @ nat @ J4 @ I2 )
               => ~ ( P @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_6917_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,X3: A] :
      ( ( ( find @ A @ P @ Xs )
        = ( some @ A @ X3 ) )
      = ( ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I2 ) )
            & ( X3
              = ( nth @ A @ Xs @ I2 ) )
            & ! [J4: nat] :
                ( ( ord_less @ nat @ J4 @ I2 )
               => ~ ( P @ ( nth @ A @ Xs @ J4 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_6918_isCont__inverse__function,axiom,
    ! [D2: real,X3: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z5: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z5 @ X3 ) ) @ D2 )
           => ( ( G @ ( F2 @ Z5 ) )
              = Z5 ) )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z5 @ X3 ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X3 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6919_GMVT_H,axiom,
    ! [A3: real,B2: real,F2: real > real,G: real > real,G4: real > real,F8: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [Z5: real] :
            ( ( ord_less_eq @ real @ A3 @ Z5 )
           => ( ( ord_less_eq @ real @ Z5 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ A3 @ Z5 )
             => ( ( ord_less_eq @ real @ Z5 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z5: real] :
                ( ( ord_less @ real @ A3 @ Z5 )
               => ( ( ord_less @ real @ Z5 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G4 @ Z5 ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z5: real] :
                  ( ( ord_less @ real @ A3 @ Z5 )
                 => ( ( ord_less @ real @ Z5 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F8 @ Z5 ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A3 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) ) @ ( G4 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A3 ) ) @ ( F8 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6920_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X3: real,F2: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member2 @ A @ ( F2 @ X3 ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X4: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F2 @ X4 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_6921_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A3: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ K5 @ N2 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A3 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X4: A] :
                    ( suminf @ Aa
                    @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ ( F2 @ X4 ) @ N2 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_6922_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X3: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_6923_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F3: A > $o,Xs2: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F3 @ Xs2 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F3 ) @ Xs2 ) ) ) ) ).

% partition_filter_conv
thf(fact_6924_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X3: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H2: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X3 @ H2 ) @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X3 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6925_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6926_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6927_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X4: A] : ( power_power @ real @ ( F2 @ X4 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6928_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X3: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H2: A] : ( F2 @ ( plus_plus @ A @ X3 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X3 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6929_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X4: A] : ( sqrt @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_6930_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X4: A] : ( root @ N @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_real_root
thf(fact_6931_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F24: filter @ B,F13: filter @ A,F25: filter @ B,F14: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ F24 @ F13 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F24 @ F25 )
       => ( ( ord_less_eq @ ( filter @ A ) @ F14 @ F13 )
         => ( filterlim @ A @ B @ F2 @ F25 @ F14 ) ) ) ) ).

% filterlim_mono
thf(fact_6932_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F4: filter @ B,F11: filter @ B,F2: B > A,L: A] :
          ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F11 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mono
thf(fact_6933_partition__filter1,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ Xs ) ) ).

% partition_filter1
thf(fact_6934_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I5: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X4: A] : ( F2 @ X4 @ I3 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I2: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F2 @ I2 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F4 ) ) ) ).

% tendsto_null_sum
thf(fact_6935_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X3: real,F4: filter @ A,N: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X3 ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X4: A] : ( root @ N @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N @ X3 ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_6936_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A3 ) )
              @ F4 ) ) ) ) ).

% tendsto_inverse
thf(fact_6937_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X4: D] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6938_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,A3: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( ( cosh @ A @ A3 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X4: C] : ( tanh @ A @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A3 ) )
              @ F4 ) ) ) ) ).

% tendsto_tanh
thf(fact_6939_tendsto__powr,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( A3
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A3 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr
thf(fact_6940_tendsto__ln,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( A3
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( ln_ln @ real @ ( F2 @ X4 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A3 ) )
          @ F4 ) ) ) ).

% tendsto_ln
thf(fact_6941_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X4: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_6942_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X4: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_6943_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_norm_zero
thf(fact_6944_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( sgn_sgn @ A @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F4 ) ) ) ) ).

% tendsto_sgn
thf(fact_6945_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A3: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( ( cos @ A @ A3 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X4: A] : ( tan @ A @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A3 ) )
              @ F4 ) ) ) ) ).

% tendsto_tan
thf(fact_6946_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A3: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( ( sin @ A @ A3 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X4: A] : ( cot @ A @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A3 ) )
              @ F4 ) ) ) ) ).

% tendsto_cot
thf(fact_6947_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( plus_plus @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A3 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_add
thf(fact_6948_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X4: B] : ( plus_plus @ A @ C2 @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F4 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F4 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6949_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X4: A] : ( abs_abs @ real @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
     => ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_6950_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X4: A] : ( abs_abs @ real @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
      = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_6951_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X4: A] : ( abs_abs @ real @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_rabs_zero
thf(fact_6952_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X3: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X3 ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X4: A] : ( sqrt @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X3 ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_6953_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A3: B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A3 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A3 @ N ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_6954_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A3: B,F4: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A3 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A3 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6955_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_right
thf(fact_6956_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
            @ F4 ) ) ) ).

% tendsto_mult_left
thf(fact_6957_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A3 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_mult
thf(fact_6958_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X4: D] : ( times_times @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6959_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X4: B] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A3 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6960_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X4: B] : ( divide_divide @ A @ ( F2 @ X4 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_6961_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6962_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6963_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X4: D] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6964_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X4: A] : ( minus_minus @ B @ ( F2 @ X4 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 ) ) ) ).

% LIM_zero
thf(fact_6965_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X4: A] : ( minus_minus @ B @ ( F2 @ X4 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_iff
thf(fact_6966_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A3: A,F4: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X4: B] : ( minus_minus @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 ) ) ) ) ).

% Lim_transform
thf(fact_6967_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X4: B] : ( minus_minus @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 ) ) ) ) ).

% Lim_transform2
thf(fact_6968_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X4: A] : ( minus_minus @ B @ ( F2 @ X4 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_cancel
thf(fact_6969_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G: B > A,F4: filter @ B,A3: A] :
          ( ( filterlim @ B @ A
            @ ^ [X4: B] : ( minus_minus @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 ) ) ) ) ).

% Lim_transform_eq
thf(fact_6970_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A3 )
       => ( ( ord_less @ real @ A3 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( artanh @ real @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A3 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_6971_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
         => ( ( A3
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A3 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6972_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A3: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A3 )
       => ( filterlim @ B @ real
          @ ^ [X4: B] : ( arcosh @ real @ ( F2 @ X4 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A3 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_6973_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_6974_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A3: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ X4 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A3 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6975_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A3: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X4: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_6976_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A3: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A3 ) ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H2: A] : ( F2 @ ( plus_plus @ A @ A3 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A3 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6977_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A3: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H2: A] : ( F2 @ ( plus_plus @ A @ A3 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6978_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A3: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H2: A] : ( F2 @ ( plus_plus @ A @ A3 @ H2 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6979_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A3: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A3 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H2: A] : ( F2 @ ( plus_plus @ A @ A3 @ H2 ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6980_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
          = ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y ) @ ( F2 @ X3 ) ) @ ( minus_minus @ A @ Y @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6981_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
         => ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y ) @ ( F2 @ X3 ) ) @ ( minus_minus @ A @ Y @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% has_field_derivativeD
thf(fact_6982_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L: B,A3: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( X2 != A3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X2 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_6983_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A3: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( X2 != A3 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X2 ) ) )
           => ( ! [X2: A] :
                  ( ( X2 != A3 )
                 => ( ord_less_eq @ real @ ( G @ X2 ) @ ( F2 @ X2 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6984_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L: filter @ B,X3: A,S2: set @ A,T6: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X3 @ T6 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_6985_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R4: real,A3: A,F2: A > B,G: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
         => ( ! [X2: A] :
                ( ( X2 != A3 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A3 ) ) @ R4 )
                 => ( ( F2 @ X2 )
                    = ( G @ X2 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6986_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A3: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X4: A] :
                        ( ( ( X4 != A3 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X4 @ A3 ) ) @ S4 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X4 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6987_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A3: A,F2: A > B,L5: B] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A3 ) ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L5 ) ) @ R ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6988_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A3: A,R2: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X: A] :
                    ( ( ( X != A3 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ A3 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X ) @ L5 ) ) @ R2 ) ) ) ) ) ) ).

% LIM_D
thf(fact_6989_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A3: A,D4: A] :
          ( ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A3 @ H2 ) ) @ ( F2 @ A3 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X4: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X4 ) @ ( F2 @ A3 ) ) @ ( minus_minus @ A @ X4 @ A3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6990_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R ) )
               => ( ord_less @ real @ ( F2 @ X ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6991_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R ) )
               => ( ( F2 @ X )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6992_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6993_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A3: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A3 ) ) @ D6 ) )
                     => ( ( F2 @ X2 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6994_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A3: C,S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A3 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A3 @ S ) @ G )
           => ( ( ( F2 @ A3 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A3 @ S )
                @ ^ [X4: C] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_6995_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X3: A,S: set @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X3 @ S ) @ F2 )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X3 @ S )
              @ ^ [X4: A] : ( ln_ln @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_6996_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X3 @ H2 ) ) @ ( F2 @ X3 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6997_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A] :
          ( ( has_field_derivative @ A @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X3 @ H2 ) ) @ ( F2 @ X3 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6998_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z3 ) @ ( one_one @ A ) ) @ Z3 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6999_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A3: A,F2: A > B,G: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F2 @ A3 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A3 ) ) @ D6 ) )
                     => ( ( F2 @ X2 )
                       != ( F2 @ A3 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_7000_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_7001_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
     => ( ! [X: A] :
            ( ( member2 @ A @ X @ ( set2 @ A @ Yes ) )
           => ( P @ X ) )
        & ! [X: A] :
            ( ( member2 @ A @ X @ ( set2 @ A @ No ) )
           => ~ ( P @ X ) ) ) ) ).

% partition_P
thf(fact_7002_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_7003_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D4: A,X3: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D4 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X3 @ H2 ) ) @ ( F2 @ X3 ) ) @ H2 )
            @ ( topolo7230453075368039082e_nhds @ A @ D4 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_7004_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A3: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ X4 @ A3 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_7005_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A3: C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A3 @ ( top_top @ ( set @ C ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A3 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F2 @ A3 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A3 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X4: C] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_7006_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X3: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( ln_ln @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_7007_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X3 @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No2: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Yes2 ) @ No2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X3 @ No2 ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_7008_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) ).

% partition_filter2
thf(fact_7009_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A3: A,D2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A3 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_7010_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D2: A,F4: filter @ B,A3: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A3 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_7011_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A3: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X2: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ S )
               => ( sums @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( A3 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) )
                  @ ( F2 @ X2 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A3 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_7012_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A3: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X2: A] :
                ( ( X2
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ S )
                 => ( sums @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( A3 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) )
                    @ ( F2 @ X2 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A3 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_7013_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N3 ) ) @ ( times_times @ real @ ( F2 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H2: A] : ( suminf @ B @ ( G @ H2 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_7014_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A3: A,S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A3 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A3 @ S ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A3 ) )
             => ( ( ( F2 @ A3 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A3 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A3 @ S )
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_7015_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X4: real] : ( divide_divide @ real @ ( cos @ real @ X4 ) @ ( sin @ real @ X4 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_7016_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_7017_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A3: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A3 ) )
             => ( ( ( F2 @ A3 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A3 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_7018_summable__Leibniz_I3_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A3 )
       => ( ( ord_less @ real @ ( A3 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N7: nat] :
              ( member2 @ real
              @ ( suminf @ real
                @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_7019_summable__Leibniz_I2_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A3 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A3 @ ( zero_zero @ nat ) ) )
         => ! [N7: nat] :
              ( member2 @ real
              @ ( suminf @ real
                @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_7020_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( A3 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_7021_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( A3 @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_7022_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( A3 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_7023_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A3: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A3 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_7024_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A3: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A3 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_7025_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ? [U3: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ ( U3 @ N7 ) @ X3 )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_7026_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ? [U3: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ X3 @ ( U3 @ N7 ) )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_7027_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N5: nat,X9: nat > A,Y4: nat > A,X3: A,Y5: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N5 @ N3 )
             => ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( Y4 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y4 @ ( topolo7230453075368039082e_nhds @ A @ Y5 ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ) ).

% lim_mono
thf(fact_7028_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,X3: A,Y4: nat > A,Y5: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y4 @ ( topolo7230453075368039082e_nhds @ A @ Y5 ) @ ( at_top @ nat ) )
           => ( ? [N8: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( Y4 @ N3 ) ) )
             => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_7029_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,M7: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F2 @ N3 ) @ C6 ) )
           => ( ord_less_eq @ A @ L @ C6 ) ) ) ) ).

% Lim_bounded
thf(fact_7030_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,N5: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N5 @ N3 )
               => ( ord_less_eq @ A @ C6 @ ( F2 @ N3 ) ) )
           => ( ord_less_eq @ A @ C6 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_7031_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,X3: A,A3: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ A3 @ ( X9 @ N3 ) ) )
           => ( ord_less_eq @ A @ A3 @ X3 ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_7032_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,X3: A,A3: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ ( X9 @ N3 ) @ A3 ) )
           => ( ord_less_eq @ A @ X3 @ A3 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_7033_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A3: A] :
          ( ! [N3: nat] : ( member2 @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A3 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_7034_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A3: A] :
          ( ! [N3: nat] : ( member2 @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A3 ) ) ) ) ).

% Inf_lim
thf(fact_7035_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_7036_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_7037_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X4: nat] : ( times_times @ nat @ X4 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_7038_monoseq__convergent,axiom,
    ! [X9: nat > real,B3: real] :
      ( ( topological_monoseq @ real @ X9 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X9 @ I3 ) ) @ B3 )
       => ~ ! [L6: real] :
              ~ ( filterlim @ nat @ real @ X9 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_7039_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( root @ N2 @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_7040_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: nat > A,X3: A] :
          ( ( topological_monoseq @ A @ A3 )
         => ( ( filterlim @ nat @ A @ A3 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) )
           => ( ( ! [N7: nat] : ( ord_less_eq @ A @ ( A3 @ N7 ) @ X3 )
                & ! [M2: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N7 )
                   => ( ord_less_eq @ A @ ( A3 @ M2 ) @ ( A3 @ N7 ) ) ) )
              | ( ! [N7: nat] : ( ord_less_eq @ A @ X3 @ ( A3 @ N7 ) )
                & ! [M2: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N7 )
                   => ( ord_less_eq @ A @ ( A3 @ N7 ) @ ( A3 @ M2 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_7041_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A3: A] :
          ( filterlim @ nat @ A
          @ ^ [N2: nat] : ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ N2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_7042_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_7043_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X9: nat > A,X3: A,L: nat] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( X9 @ ( times_times @ nat @ N2 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X3 )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_7044_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N2: nat] : ( minus_minus @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L2: real] :
                ( ! [N7: nat] : ( ord_less_eq @ real @ ( F2 @ N7 ) @ L2 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) )
                & ! [N7: nat] : ( ord_less_eq @ real @ L2 @ ( G @ N7 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_7045_LIMSEQ__inverse__zero,axiom,
    ! [X9: nat > real] :
      ( ! [R: real] :
        ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less @ real @ R @ ( X9 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( X9 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_7046_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_7047_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( root @ N2 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_7048_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_7049_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ L )
       => ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [N7: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F2 @ N7 ) @ E2 ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_7050_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_7051_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_7052_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_7053_LIMSEQ__realpow__zero,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X3 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_7054_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_7055_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_7056_LIMSEQ__divide__realpow__zero,axiom,
    ! [X3: real,A3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( divide_divide @ real @ A3 @ ( power_power @ real @ X3 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_7057_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_7058_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_7059_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X3 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X3 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_7060_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F3: nat > A,S4: A] :
              ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S4 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_7061_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X3: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N2: nat] : ( root @ N2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X3 )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X3 @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_7062_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No2: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No2 @ N2 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ N2 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_7063_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,L5: A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [No3: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No3 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ N3 ) @ L5 ) ) @ R ) ) )
         => ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_7064_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,L5: A,R2: real] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [No4: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No4 @ N7 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ N7 ) @ L5 ) ) @ R2 ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_7065_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X3: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X3 ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_7066_tendsto__exp__limit__sequentially,axiom,
    ! [X3: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X3 @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X3 ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_7067_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X3: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y: B] : ( power_power @ A @ X3 @ ( F2 @ Y ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_7068_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( times_times @ real @ R2 @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_7069_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_7070_summable__Leibniz_I1_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A3 )
       => ( summable @ real
          @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A3 @ N2 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_7071_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z2: A,S: nat > A,A3: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z2 @ ( S @ N2 ) ) ) @ ( F2 @ Z2 ) ) @ ( S @ N2 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A3 )
                  @ ( at_top @ nat ) )
               => ( Df = A3 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_7072_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X3: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X3 @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_7073_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X3: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X3 @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_7074_summable,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A3 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A3 @ ( suc @ N3 ) ) @ ( A3 @ N3 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A3 @ N2 ) ) ) ) ) ) ).

% summable
thf(fact_7075_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J4: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J4 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K2: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J4: nat] : ( minus_minus @ real @ ( Theta @ J4 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J4 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_7076_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J4: nat] : ( cos @ real @ ( Theta @ J4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J4: nat] : ( minus_minus @ real @ ( Theta @ J4 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J4 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_7077_summable__Leibniz_I4_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A3 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_7078_zeroseq__arctan__series,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X3 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X3 @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_7079_summable__Leibniz_H_I2_J,axiom,
    ! [A3: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A3 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A3 @ ( suc @ N3 ) ) @ ( A3 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_7080_summable__Leibniz_H_I3_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A3 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A3 @ ( suc @ N3 ) ) @ ( A3 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_7081_sums__alternating__upper__lower,axiom,
    ! [A3: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A3 @ ( suc @ N3 ) ) @ ( A3 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A3 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L2: real] :
              ( ! [N7: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                  @ L2 )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) )
              & ! [N7: nat] :
                  ( ord_less_eq @ real @ L2
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_7082_summable__Leibniz_I5_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A3 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_7083_summable__Leibniz_H_I4_J,axiom,
    ! [A3: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A3 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A3 @ ( suc @ N3 ) ) @ ( A3 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_7084_summable__Leibniz_H_I5_J,axiom,
    ! [A3: nat > real] :
      ( ( filterlim @ nat @ real @ A3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A3 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A3 @ ( suc @ N3 ) ) @ ( A3 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I2 ) @ ( A3 @ I2 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_7085_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X3 ) ) ) @ ( minus_minus @ B @ ( F2 @ Y ) @ ( plus_plus @ B @ ( F2 @ X3 ) @ ( F8 @ ( minus_minus @ A @ Y @ X3 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_7086_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D4: A > B,X3: A] :
          ( ( has_derivative @ A @ B @ F2 @ D4 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D4 )
            & ( filterlim @ A @ real
              @ ^ [H2: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X3 @ H2 ) ) @ ( F2 @ X3 ) ) @ ( D4 @ H2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_7087_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X4: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_7088_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_7089_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F3: real > real] :
        ? [C4: real] :
          ( F3
          = ( ^ [X4: real] : ( times_times @ real @ X4 @ C4 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_7090_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y5: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X4: A] : ( divide_divide @ A @ X4 @ Y5 ) ) ) ).

% bounded_linear_divide
thf(fact_7091_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X3: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X3 ) ) ) ).

% bounded_linear_mult_right
thf(fact_7092_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y5: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ ( G @ X4 ) @ Y5 ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_7093_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X3: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ X3 @ ( G @ X4 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_7094_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y5: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X4: A] : ( times_times @ A @ X4 @ Y5 ) ) ) ).

% bounded_linear_mult_left
thf(fact_7095_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_7096_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X4: C] : ( F2 @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_7097_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_7098_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_7099_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X2: A,Y2: A] :
              ( ( F2 @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( ! [R: real,X2: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R @ X2 ) )
                = ( real_V8093663219630862766scaleR @ B @ R @ ( F2 @ X2 ) ) )
           => ( ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_7100_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ real
              @ ^ [Y: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X3 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X3 ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_7101_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X3 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X3 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_7102_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F8: A > B,X3: A,F2: A > B,S: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F8 )
         => ( ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X3 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X3 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivativeI
thf(fact_7103_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ? [E3: A > B] :
                ( ! [H2: A] :
                    ( ( F2 @ ( plus_plus @ A @ X3 @ H2 ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X3 ) @ ( F8 @ H2 ) ) @ ( E3 @ H2 ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H2: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H2 ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_7104_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X3 ) ) ) @ ( minus_minus @ B @ ( F2 @ Y ) @ ( plus_plus @ B @ ( F2 @ X3 ) @ ( F8 @ ( minus_minus @ A @ Y @ X3 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_7105_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F3: A > B,F15: A > B,F9: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F15 )
              & ( filterlim @ A @ B
                @ ^ [Y: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X4: A] : X4 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F3 @ Y )
                        @ ( F3
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X4: A] : X4 ) ) )
                      @ ( F15
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X4: A] : X4 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F9 ) ) ) ) ) ).

% has_derivative_def
thf(fact_7106_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X3: A,S2: set @ A,F2: A > B,F8: A > B] :
          ( ( member2 @ A @ X3 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
                & ? [E3: A > B] :
                    ( ! [H2: A] :
                        ( ( member2 @ A @ ( plus_plus @ A @ X3 @ H2 ) @ S2 )
                       => ( ( F2 @ ( plus_plus @ A @ X3 @ H2 ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X3 ) @ ( F8 @ H2 ) ) @ ( E3 @ H2 ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H2: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H2 ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_7107_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: A,S2: set @ A,T6: set @ A] :
          ( ( member2 @ A @ A3 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
             => ( ( topolo174197925503356063within @ A @ A3 @ T6 )
                = ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_7108_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X3: A,Y5: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member2 @ A @ X3 @ S2 )
           => ( ( ord_less @ A @ X3 @ Y5 )
             => ? [B6: A] :
                  ( ( ord_less @ A @ X3 @ B6 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X3 @ B6 ) @ S2 ) ) ) ) ) ) ).

% open_right
thf(fact_7109_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( topolo1002775350975398744n_open @ A @ A2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ A2 )
               => ( ord_less @ A @ X2 @ X3 ) )
           => ~ ( member2 @ A @ ( complete_Sup_Sup @ A @ A2 ) @ A2 ) ) ) ) ).

% Sup_notin_open
thf(fact_7110_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A2: set @ A,X3: A] :
          ( ( topolo1002775350975398744n_open @ A @ A2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ A2 )
               => ( ord_less @ A @ X3 @ X2 ) )
           => ~ ( member2 @ A @ ( complete_Inf_Inf @ A @ A2 ) @ A2 ) ) ) ) ).

% Inf_notin_open
thf(fact_7111_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X3: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I4: nat] :
              ( ( member2 @ A @ X3 @ ( A8 @ I4 ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) ) )
          & ! [S10: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S10 )
                & ( member2 @ A @ X3 @ S10 ) )
             => ? [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I3 ) @ S10 ) ) ) ) ).

% first_countable_basis
thf(fact_7112_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X4: A] :
              ( ( member2 @ A @ X4 @ S6 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member2 @ A @ X4 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S6 ) ) ) ) ) ) ).

% open_subopen
thf(fact_7113_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ S2 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member2 @ A @ X2 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S2 ) ) ) ).

% openI
thf(fact_7114_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X3: A,Y5: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member2 @ A @ X3 @ S2 )
           => ( ( ord_less @ A @ Y5 @ X3 )
             => ? [B6: A] :
                  ( ( ord_less @ A @ B6 @ X3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B6 @ X3 ) @ S2 ) ) ) ) ) ) ).

% open_left
thf(fact_7115_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S6 )
               => ( ( member2 @ A @ F0 @ S6 )
                 => ? [N6: nat] :
                    ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N2 )
                     => ( member2 @ A @ ( F2 @ N2 ) @ S6 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_7116_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_7117_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X4: A] : ( inverse_inverse @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_7118_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X4: A] : ( sgn_sgn @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_7119_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F4
                @ ^ [X4: A] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_7120_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X4: A] : ( ln_ln @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_7121_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( cos @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X4: A] : ( tan @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_7122_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( sin @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X4: A] : ( cot @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_7123_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F2 )
         => ( ( ( cosh @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F4
                    @ ^ [X4: C] : X4 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F4
              @ ^ [X4: C] : ( tanh @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_7124_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X4: A] : ( arcosh @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_7125_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A3: A,S2: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A3 )
         => ( ( member2 @ A @ A3 @ S2 )
           => ( ( topolo1002775350975398744n_open @ A @ S2 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ S2 ) )
                = ( filterlim @ A @ D
                  @ ^ [H2: A] : ( F2 @ ( plus_plus @ A @ A3 @ H2 ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_7126_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X4: A] : X4 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X4: A] : X4 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_7127_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E: real,F8: A > B,S: set @ A,X3: A,F2: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( ( real_V3181309239436604168linear @ A @ B @ F8 )
           => ( ! [Y2: A] :
                  ( ( member2 @ A @ Y2 @ S )
                 => ( ( Y2 != X3 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X3 ) @ E )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) ) @ ( F8 @ ( minus_minus @ A @ Y2 @ X3 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ X3 ) ) ) @ ( H6 @ Y2 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X3 @ S ) )
               => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_7128_tendsto__exp__limit__at__right,axiom,
    ! [X3: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X3 @ Y ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X3 ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_7129_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member2 @ A @ I @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I ) ) ) ).

% greaterThan_iff
thf(fact_7130_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ A3 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_7131_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A3 ) @ ( plus_plus @ A @ C2 @ A3 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_7132_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A] :
          ( ( real_V557655796197034286t_dist @ A @ X3 @ X3 )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_7133_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X3 @ Y5 )
            = ( zero_zero @ real ) )
          = ( X3 = Y5 ) ) ) ).

% dist_eq_0_iff
thf(fact_7134_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X3 ) @ ( set_ord_greaterThan @ A @ Y5 ) )
          = ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% greaterThan_subset_iff
thf(fact_7135_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X3 )
          = ( real_V7770717601297561774m_norm @ A @ X3 ) ) ) ).

% dist_0_norm
thf(fact_7136_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) )
          = ( ( X3 != Y5 ) ) ) ) ).

% zero_less_dist_iff
thf(fact_7137_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ ( zero_zero @ real ) )
          = ( X3 = Y5 ) ) ) ).

% dist_le_zero_iff
thf(fact_7138_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X3: A] :
          ( ( ord_less @ A @ X3 @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X3 ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_7139_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X3: real,A3: A,Y5: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X3 @ A3 ) @ ( real_V8093663219630862766scaleR @ A @ Y5 @ A3 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y5 ) ) @ ( real_V7770717601297561774m_norm @ A @ A3 ) ) ) ) ).

% dist_scaleR
thf(fact_7140_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X4: A] :
              ( ( member2 @ A @ X4 @ S6 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X4 ) @ E3 )
                     => ( member2 @ A @ Y @ S6 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_7141_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_7142_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Z2: A,Y5: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y5 @ Z2 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ E ) ) ) ).

% dist_triangle_le
thf(fact_7143_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A,A3: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A3 @ X3 ) @ ( real_V557655796197034286t_dist @ A @ A3 @ Y5 ) ) ) ) ).

% dist_triangle3
thf(fact_7144_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A,Z2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y5 @ Z2 ) ) ) ) ).

% dist_triangle2
thf(fact_7145_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Z2: A,Y5: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Z2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ ( real_V557655796197034286t_dist @ A @ Y5 @ Z2 ) ) ) ) ).

% dist_triangle
thf(fact_7146_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) ) ) ).

% zero_le_dist
thf(fact_7147_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X4: A] : ( real_V557655796197034286t_dist @ A @ X4 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_7148_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Z2: A,Y5: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y5 @ Z2 ) ) @ E )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ E ) ) ) ).

% dist_triangle_lt
thf(fact_7149_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y5: A,E1: real,X22: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y5 ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y5 ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_7150_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A] :
          ( ( X3 != Y5 )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) ) ) ) ).

% dist_pos_lt
thf(fact_7151_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X3: A,Y5: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_7152_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L3: A] : ( collect @ A @ ( ord_less @ A @ L3 ) ) ) ) ) ).

% greaterThan_def
thf(fact_7153_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y5: A,X3: A,E: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X3 ) @ E )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y5 ) @ E ) ) ) ).

% dist_commute_lessI
thf(fact_7154_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A3: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A3 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A3 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_7155_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A3 @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_7156_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_7157_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,A3: A,S2: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ A3 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member2 @ A @ A3 @ S2 )
             => ( ! [X2: A] :
                    ( ( member2 @ A @ X2 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A3 ) @ D2 )
                     => ( ( F2 @ X2 )
                        = ( G @ X2 ) ) ) )
               => ( has_field_derivative @ A @ G @ F8 @ ( topolo174197925503356063within @ A @ A3 @ S2 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_7158_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X3: A,S: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member2 @ A @ X3 @ S )
             => ( ! [X17: A] :
                    ( ( member2 @ A @ X17 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X3 ) @ D2 )
                     => ( ( F2 @ X17 )
                        = ( G @ X17 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F8 @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_7159_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X5: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X5 @ M3 ) @ ( X5 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_7160_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S4: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S4 @ N2 ) @ ( S4 @ N6 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_7161_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X9 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M10: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M2 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N7 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M2 ) @ ( X9 @ N7 ) ) @ E ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_7162_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M4 ) @ ( X9 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X9 ) ) ) ).

% metric_CauchyI
thf(fact_7163_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ? [A7: A,B6: A] :
              ( ( member2 @ A @ X3 @ ( set_ord_lessThan @ A @ A7 ) )
              & ( member2 @ A @ Y5 @ ( set_ord_greaterThan @ A @ B6 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A7 ) @ ( set_ord_greaterThan @ A @ B6 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_7164_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A,A3: real] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X4: real] : ( F2 @ ( plus_plus @ real @ X4 @ A3 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_7165_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L: A,A3: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ C @ A3 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X2: C] :
                ( ( X2 != A3 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X2 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A3 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_7166_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L: B,X3: A,S2: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X17: A] :
                  ( ( member2 @ A @ X17 @ S2 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X17 @ X3 ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X3 ) @ D2 )
                     => ( ( F2 @ X17 )
                        = ( G @ X17 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_7167_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y5: A,X15: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X15 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_r
thf(fact_7168_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y5: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y5 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y5 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_l
thf(fact_7169_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,X22: A,E: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X42 ) @ E ) ) ) ) ) ).

% dist_triangle_third
thf(fact_7170_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G5: filter @ B,X3: A,S2: set @ A,F4: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G5 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G5 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X17: A] :
                    ( ( member2 @ A @ X17 @ S2 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X17 @ X3 ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X17 @ X3 ) @ D2 )
                       => ( ( F2 @ X17 )
                          = ( G @ X17 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_7171_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M4 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M4 ) @ ( X9 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X9 ) ) ) ).

% CauchyI'
thf(fact_7172_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M3 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ M3 ) @ ( F3 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_7173_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
          = ( filterlim @ A @ real
            @ ^ [X4: A] : ( real_V557655796197034286t_dist @ B @ ( F2 @ X4 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_dist_iff
thf(fact_7174_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P3: A,F13: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P3 @ ( set_ord_greaterThan @ A @ P3 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P3 ) )
             => ( filterlim @ B @ A
                @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_7175_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A3: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X4: A] :
                        ( ( ( X4 != A3 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A3 ) @ S4 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X4 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_7176_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A3: A,R2: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X: A] :
                    ( ( ( X != A3 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ A3 ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X ) @ L5 ) @ R2 ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_7177_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A3: A,F2: A > B,L5: B] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A3 ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ L5 ) @ R ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_7178_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L: B,A3: A,R4: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
           => ( ! [X2: A] :
                  ( ( X2 != A3 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A3 ) @ R4 )
                   => ( ( F2 @ X2 )
                      = ( G @ X2 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_7179_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L5: A,R2: real] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [No4: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No4 @ N7 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N7 ) @ L5 ) @ R2 ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_7180_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L5: A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [No3: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No3 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N3 ) @ L5 ) @ R ) ) )
         => ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_7181_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No2: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No2 @ N2 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N2 ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_7182_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X5: nat > A] :
            ! [J4: nat] :
            ? [M8: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ M8 @ M3 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X5 @ M3 ) @ ( X5 @ N2 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J4 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_7183_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A3: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A3 ) @ D6 ) )
                     => ( ( F2 @ X2 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_7184_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_7185_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A3: A,F2: A > C,G: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F2 @ A3 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X2: A] :
                      ( ( ( X2 != A3 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A3 ) @ D6 ) )
                     => ( ( F2 @ X2 )
                       != ( F2 @ A3 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X4: A] : ( G @ ( F2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_7186_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A3: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_lessThan @ A @ A3 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A3 ) ) @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( if @ B @ ( ord_less_eq @ A @ X4 @ A3 ) @ ( G @ X4 ) @ ( F2 @ X4 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_7187_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No2 )
                    & ! [N2: nat] :
                        ( ( ord_less_eq @ nat @ No2 @ N2 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N2 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_7188_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S6: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K3: set @ A] :
                  ( ( finite_finite @ A @ K3 )
                  & ( ord_less_eq @ ( set @ A ) @ S6
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X4: A] :
                            ( collect @ A
                            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ Y ) @ E3 ) )
                        @ K3 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_7189_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_7190_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( topolo6688025880775521714ounded @ A @ T6 ) ) ) ) ).

% totally_bounded_subset
thf(fact_7191_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_7192_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_7193_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_7194_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_7195_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_7196_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X2: real] :
          ( ( ord_less_eq @ real @ X2 @ B2 )
         => ? [Y6: real] :
              ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y6 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_7197_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X4: real] : ( power_power @ real @ ( F2 @ X4 ) @ N )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_7198_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_7199_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A7: A,B6: A,X2: A] :
              ( ( member2 @ A @ A7 @ S2 )
             => ( ( member2 @ A @ B6 @ S2 )
               => ( ( ord_less_eq @ A @ A7 @ X2 )
                 => ( ( ord_less_eq @ A @ X2 @ B6 )
                   => ( member2 @ A @ X2 @ S2 ) ) ) ) )
         => ? [A7: A,B6: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B6 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B6 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A7 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A7 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A7 @ B6 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A7 @ B6 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A7 @ B6 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A7 @ B6 ) ) ) ) ) ).

% interval_cases
thf(fact_7200_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X4: real] : ( power_power @ real @ ( F2 @ X4 ) @ N )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_7201_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_7202_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member2 @ A @ I @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I ) ) ) ).

% atLeast_iff
thf(fact_7203_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X3 ) @ ( set_ord_atLeast @ A @ Y5 ) )
          = ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ).

% atLeast_subset_iff
thf(fact_7204_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I ) ) ) ) ).

% image_add_atLeast
thf(fact_7205_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H: A,L4: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) @ ( set_ord_atLeast @ A @ L4 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H )
            | ( ord_less_eq @ A @ L4 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_7206_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A3 ) @ ( set_ord_atLeast @ A @ A3 ) ) ) ).

% Ioi_le_Ico
thf(fact_7207_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_7208_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_7209_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_ord_atMost @ A @ H3 ) ) ) ).

% not_Ici_le_Iic
thf(fact_7210_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H: A,L4: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H ) @ ( set_ord_atLeast @ A @ L4 ) ) ) ).

% not_Iic_le_Ici
thf(fact_7211_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L3: A] : ( collect @ A @ ( ord_less_eq @ A @ L3 ) ) ) ) ) ).

% atLeast_def
thf(fact_7212_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L ) ) ) ).

% not_UNIV_le_Ici
thf(fact_7213_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,L4: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) ) ) ).

% not_Ici_le_Icc
thf(fact_7214_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_7215_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A3 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A3 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_7216_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( power_power @ real @ ( F2 @ X4 ) @ N )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_7217_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_7218_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_7219_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X4: A] : ( inverse_inverse @ real @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_7220_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_7221_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( G @ X4 ) @ ( F2 @ X4 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_7222_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_7223_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ real @ S @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( powr @ real @ ( F2 @ X4 ) @ S )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% tendsto_neg_powr
thf(fact_7224_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X4: real] : ( divide_divide @ real @ ( ln_ln @ real @ X4 ) @ X4 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_7225_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X4: real] : ( F2 @ ( inverse_inverse @ real @ X4 ) )
        @ F4
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_7226_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X4: real] : ( F2 @ ( inverse_inverse @ real @ X4 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_7227_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_7228_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_7229_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_7230_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X4: real] : ( divide_divide @ real @ ( power_power @ real @ X4 @ K ) @ ( exp @ real @ X4 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_7231_tendsto__exp__limit__at__top,axiom,
    ! [X3: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X3 @ Y ) ) @ Y )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X3 ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_7232_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_7233_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X2: real] :
          ( ( ord_less_eq @ real @ B2 @ X2 )
         => ? [Y6: real] :
              ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y6 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_7234_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_7235_lhopital__left__at__top,axiom,
    ! [G: real > real,X3: real,G4: real > real,F2: real > real,F8: real > real,Y5: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y5 )
                @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y5 )
                @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_7236_lhopital__right__at__top,axiom,
    ! [G: real > real,X3: real,G4: real > real,F2: real > real,F8: real > real,Y5: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y5 )
                @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y5 )
                @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_7237_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X3: A,Y5: A,P: A > $o] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X3 @ ( set_ord_greaterThan @ A @ X3 ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ X3 @ B4 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ X3 @ Y )
                     => ( ( ord_less @ A @ Y @ B4 )
                       => ( P @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_7238_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X3: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X3 @ ( set_ord_greaterThan @ A @ X3 ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ X3 @ B4 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ X3 @ Y )
                   => ( ( ord_less @ A @ Y @ B4 )
                     => ( P @ Y ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_7239_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X2: A,Y2: A] :
              ( ( Q @ X2 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: B] :
                ( ( P @ X2 )
               => ( ( F2 @ ( G @ X2 ) )
                  = X2 ) )
           => ( ! [X2: B] :
                  ( ( P @ X2 )
                 => ( Q @ ( G @ X2 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_7240_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_7241_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N6 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_7242_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N6 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_7243_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X2: A] :
              ( ( ord_less_eq @ A @ C2 @ X2 )
             => ( P @ X2 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_7244_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_7245_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y5: A,X3: A,P: A > $o] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X3 @ ( set_ord_lessThan @ A @ X3 ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X3 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ B4 @ Y )
                     => ( ( ord_less @ A @ Y @ X3 )
                       => ( P @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_7246_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X3: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X3 @ ( set_ord_lessThan @ A @ X3 ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ B4 @ X3 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ B4 @ Y )
                   => ( ( ord_less @ A @ Y @ X3 )
                     => ( P @ Y ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_7247_filter__leD,axiom,
    ! [A: $tType,F4: filter @ A,F11: filter @ A,P: A > $o] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 )
     => ( ( eventually @ A @ P @ F11 )
       => ( eventually @ A @ P @ F4 ) ) ) ).

% filter_leD
thf(fact_7248_filter__leI,axiom,
    ! [A: $tType,F11: filter @ A,F4: filter @ A] :
      ( ! [P8: A > $o] :
          ( ( eventually @ A @ P8 @ F11 )
         => ( eventually @ A @ P8 @ F4 ) )
     => ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 ) ) ).

% filter_leI
thf(fact_7249_le__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
          ! [P2: A > $o] :
            ( ( eventually @ A @ P2 @ F10 )
           => ( eventually @ A @ P2 @ F9 ) ) ) ) ).

% le_filter_def
thf(fact_7250_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ ( top_top @ A ) )
                  & ! [Z3: A] :
                      ( ( ord_less @ A @ B4 @ Z3 )
                     => ( P @ Z3 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_7251_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X4: A] : ( ord_less_eq @ A @ X4 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_7252_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N2 @ N6 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_7253_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N2 @ N6 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_7254_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X4: A] : ( ord_less @ A @ X4 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_7255_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F4: filter @ B,G5: filter @ A,F11: filter @ B,G6: filter @ A,F8: A > B] :
      ( ( filterlim @ A @ B @ F2 @ F4 @ G5 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G6 @ G5 )
         => ( ( eventually @ A
              @ ^ [X4: A] :
                  ( ( F2 @ X4 )
                  = ( F8 @ X4 ) )
              @ G6 )
           => ( filterlim @ A @ B @ F8 @ F11 @ G6 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_7256_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N2: B] : ( ord_less_eq @ A @ ( G @ N2 ) @ ( H @ N2 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_7257_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y5: A,F4: filter @ B,A3: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y5 ) @ F4 )
         => ( ( ord_less @ A @ Y5 @ A3 )
           => ( eventually @ B
              @ ^ [X4: B] : ( ord_less @ A @ ( F2 @ X4 ) @ A3 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_7258_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y5: A,F4: filter @ B,A3: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y5 ) @ F4 )
         => ( ( ord_less @ A @ A3 @ Y5 )
           => ( eventually @ B
              @ ^ [X4: B] : ( ord_less @ A @ A3 @ ( F2 @ X4 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_7259_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y5: A,F2: B > A,F4: filter @ B] :
          ( ! [A7: A] :
              ( ( ord_less @ A @ A7 @ Y5 )
             => ( eventually @ B
                @ ^ [X4: B] : ( ord_less @ A @ A7 @ ( F2 @ X4 ) )
                @ F4 ) )
         => ( ! [A7: A] :
                ( ( ord_less @ A @ Y5 @ A7 )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ A @ ( F2 @ X4 ) @ A7 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y5 ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_7260_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X3: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ F4 )
          = ( ! [L3: A] :
                ( ( ord_less @ A @ L3 @ X3 )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ A @ L3 @ ( F2 @ X4 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X3 @ U2 )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ A @ ( F2 @ X4 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_7261_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X4: B] : ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_7262_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X4 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_7263_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X4 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_7264_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less @ B @ Z9 @ ( F2 @ X4 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_7265_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X3: A] : ( eventually @ A @ ( ord_less @ A @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( set_ord_greaterThan @ A @ X3 ) ) ) ) ).

% eventually_at_right_less
thf(fact_7266_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_7267_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_7268_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_7269_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N2: B] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N2: B] : ( ord_less_eq @ real @ ( G @ N2 ) @ ( H @ N2 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_7270_eventually__Inf__base,axiom,
    ! [A: $tType,B3: set @ ( filter @ A ),P: A > $o] :
      ( ( B3
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F6: filter @ A] :
            ( ( member2 @ ( filter @ A ) @ F6 @ B3 )
           => ! [G3: filter @ A] :
                ( ( member2 @ ( filter @ A ) @ G3 @ B3 )
               => ? [X: filter @ A] :
                    ( ( member2 @ ( filter @ A ) @ X @ B3 )
                    & ( ord_less_eq @ ( filter @ A ) @ X @ ( inf_inf @ ( filter @ A ) @ F6 @ G3 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B3 ) )
          = ( ? [X4: filter @ A] :
                ( ( member2 @ ( filter @ A ) @ X4 @ B3 )
                & ( eventually @ A @ P @ X4 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_7271_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A3: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A3 @ S2 ) )
          = ( ? [D5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                & ! [X4: A] :
                    ( ( member2 @ A @ X4 @ S2 )
                   => ( ( ( X4 != A3 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A3 ) @ D5 ) )
                     => ( P @ X4 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_7272_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A3: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A3 ) )
          = ( ? [D5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                & ! [X4: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A3 ) @ D5 )
                   => ( P @ X4 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_7273_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A3: A,B2: A,P: A > $o] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) )
             => ( P @ X2 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_7274_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A3: A,B2: A,P: A > $o] :
          ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) )
             => ( P @ X2 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_7275_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A3: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A3 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X4: A] : ( P @ ( plus_plus @ A @ X4 @ A3 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_7276_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ L )
            @ F4 )
         => ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ L )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ X2 @ ( F2 @ N2 ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_7277_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ L @ ( F2 @ N2 ) )
            @ F4 )
         => ( ! [X2: A] :
                ( ( ord_less @ A @ L @ X2 )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ ( F2 @ N2 ) @ X2 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_7278_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X4 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_7279_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_7280_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X3: A,F4: filter @ B,A3: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I2: B] : ( ord_less_eq @ A @ ( F2 @ I2 ) @ A3 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X3 @ A3 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_7281_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X3: A,F4: filter @ B,A3: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I2: B] : ( ord_less_eq @ A @ A3 @ ( F2 @ I2 ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A3 @ X3 ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_7282_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X3: A,G: B > A,Y5: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) @ F4 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y5 ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X4: B] : ( ord_less_eq @ A @ ( G @ X4 ) @ ( F2 @ X4 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y5 @ X3 ) ) ) ) ) ) ).

% tendsto_le
thf(fact_7283_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A3: A,F4: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X4: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X4 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X4 ) @ A3 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_7284_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A3: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
      = ( eventually @ real
        @ ^ [X4: real] : ( P @ ( plus_plus @ real @ X4 @ A3 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_7285_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F4: B > ( filter @ A ),B3: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B3 ) ) )
      = ( ? [X5: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X5 @ B3 )
            & ( finite_finite @ B @ X5 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X5 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_7286_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X4 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X4: A] : ( arcosh @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_7287_eventually__at__right__real,axiom,
    ! [A3: real,B2: real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( eventually @ real
        @ ^ [X4: real] : ( member2 @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ A3 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) ) ) ).

% eventually_at_right_real
thf(fact_7288_eventually__at__left__real,axiom,
    ! [B2: real,A3: real] :
      ( ( ord_less @ real @ B2 @ A3 )
     => ( eventually @ real
        @ ^ [X4: real] : ( member2 @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A3 ) )
        @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) ) ) ).

% eventually_at_left_real
thf(fact_7289_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A3: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A3 @ S2 ) )
          = ( ? [D5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                & ! [X4: A] :
                    ( ( member2 @ A @ X4 @ S2 )
                   => ( ( ( X4 != A3 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A3 ) @ D5 ) )
                     => ( P @ X4 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_7290_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_7291_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ L5 @ ( F2 @ X4 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_7292_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,E: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ( eventually @ B
              @ ^ [X4: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X4 ) @ L ) @ E )
              @ F4 ) ) ) ) ).

% tendstoD
thf(fact_7293_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ( eventually @ B
                @ ^ [X4: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X4 ) @ L ) @ E2 )
                @ F4 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ).

% tendstoI
thf(fact_7294_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X4 ) @ L ) @ E3 )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff
thf(fact_7295_eventually__Inf,axiom,
    ! [A: $tType,P: A > $o,B3: set @ ( filter @ A )] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B3 ) )
      = ( ? [X5: set @ ( filter @ A )] :
            ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X5 @ B3 )
            & ( finite_finite @ ( filter @ A ) @ X5 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ X5 ) ) ) ) ) ).

% eventually_Inf
thf(fact_7296_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X4: real] : ( P @ ( inverse_inverse @ real @ X4 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_7297_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X4: real] : ( P @ ( inverse_inverse @ real @ X4 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_7298_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A3: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A3 )
       => ( ( eventually @ B
            @ ^ [X4: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X4 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X4: B] : ( arcosh @ real @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A3 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_7299_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A3: A] :
          ( ! [X2: A,Y2: A] :
              ( ( Q @ X2 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: B] :
                ( ( P @ X2 )
               => ( ( F2 @ ( G @ X2 ) )
                  = X2 ) )
           => ( ! [X2: B] :
                  ( ( P @ X2 )
                 => ( Q @ ( G @ X2 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_lessThan @ A @ A3 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ B6 @ A3 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_lessThan @ A @ A3 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_7300_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,F4: A > ( filter @ B ),P: B > $o] :
      ( ( B3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A7: A] :
            ( ( member2 @ A @ A7 @ B3 )
           => ! [B6: A] :
                ( ( member2 @ A @ B6 @ B3 )
               => ? [X: A] :
                    ( ( member2 @ A @ X @ B3 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ A7 ) @ ( F4 @ B6 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ B3 ) ) )
          = ( ? [X4: A] :
                ( ( member2 @ A @ X4 @ B3 )
                & ( eventually @ B @ P @ ( F4 @ X4 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_7301_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A3: A] :
          ( ! [X2: A,Y2: A] :
              ( ( Q @ X2 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: B] :
                ( ( P @ X2 )
               => ( ( F2 @ ( G @ X2 ) )
                  = X2 ) )
           => ( ! [X2: B] :
                  ( ( P @ X2 )
                 => ( Q @ ( G @ X2 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ A3 @ B6 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_7302_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ K5 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_7303_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X4: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X4: A] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_7304_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X4: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X4: A] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A3 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_7305_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A3
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A3 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_7306_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member2 @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F2 @ X4 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_7307_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A3: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A3 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A3 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X4 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X4: A] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_7308_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member2 @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_7309_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X4: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
        @ F4 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_7310_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X4: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
        @ F4 )
     => ( ( filterlim @ A @ real
          @ ^ [X4: A] : ( inverse_inverse @ real @ ( F2 @ X4 ) )
          @ ( at_top @ real )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_7311_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X4: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( inverse_inverse @ real @ ( F2 @ X4 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_7312_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X4: A] : ( ord_less @ real @ ( F2 @ X4 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( inverse_inverse @ real @ ( F2 @ X4 ) )
          @ ( at_bot @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_7313_lhopital__at__top__at__top,axiom,
    ! [F2: real > real,A3: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_7314_lhopital,axiom,
    ! [F2: real > real,X3: real,G: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_7315_lhopital__right__at__top__at__top,axiom,
    ! [F2: real > real,A3: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_7316_lhopital__at__top__at__bot,axiom,
    ! [F2: real > real,A3: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_7317_lhopital__left__at__top__at__top,axiom,
    ! [F2: real > real,A3: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_7318_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G4: real > real,F2: real > real,F8: real > real,X3: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X3 )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X3 )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_7319_lhopital__at__top,axiom,
    ! [G: real > real,X3: real,G4: real > real,F2: real > real,F8: real > real,Y5: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y5 )
                @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y5 )
                @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_7320_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G0 @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F0 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G0 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F0 @ X4 ) @ ( G0 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_7321_lhopital__right,axiom,
    ! [F2: real > real,X3: real,G: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_greaterThan @ real @ X3 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_7322_lhopital__left,axiom,
    ! [F2: real > real,X3: real,G: real > real,G4: real > real,F8: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X3 @ ( set_ord_lessThan @ real @ X3 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_7323_lhopital__right__at__top__at__bot,axiom,
    ! [F2: real > real,A3: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_greaterThan @ real @ A3 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_7324_lhopital__left__at__top__at__bot,axiom,
    ! [F2: real > real,A3: real,G: real > real,F8: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A3 @ ( set_ord_lessThan @ real @ A3 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_7325_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G4: real > real,F2: real > real,F8: real > real,X3: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F8 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X3 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X3 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_7326_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B3: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z3: A] :
                    ( ord_less_eq @ real @ B3
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ Z3 @ I2 ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_7327_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F9: filter @ A] :
            ? [Y: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X4 ) @ Y ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_7328_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N2: nat] : ( P @ ( plus_plus @ nat @ N2 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_7329_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I2: nat] : ( P @ ( plus_plus @ nat @ I2 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_7330_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_7331_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N2 )
           => ( P @ N2 ) ) ) ) ).

% eventually_sequentially
thf(fact_7332_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X2: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X2 )
         => ( P @ X2 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_7333_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_7334_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_7335_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_7336_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X4: nat] : ( plus_plus @ A @ ( F2 @ X4 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_7337_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X9 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_7338_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X4: nat] : ( plus_plus @ A @ ( F2 @ X4 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_7339_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X9 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_7340_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X4: nat] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_7341_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,K5: real] :
          ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N3 ) ) @ K5 )
         => ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_7342_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X3: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I4: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) )
             => ( ! [I4: nat] : ( member2 @ A @ X3 @ ( A8 @ I4 ) )
               => ~ ! [S10: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S10 )
                     => ( ( member2 @ A @ X3 @ S10 )
                       => ( eventually @ nat
                          @ ^ [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I2 ) @ S10 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_7343_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X4: nat] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_7344_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
              ! [X4: A] :
                ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X4 ) )
               => ( P @ X4 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_7345_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F4: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_7346_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_7347_Bseq__eq__bounded,axiom,
    ! [F2: nat > real,A3: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F2 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) )
     => ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_7348_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_7349_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G @ N2 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_7350_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N7 ) ) @ K9 ) ) ) ) ).

% BseqD
thf(fact_7351_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
         => ~ ! [K9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
               => ~ ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N7 ) ) @ K9 ) ) ) ) ).

% BseqE
thf(fact_7352_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X9: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N3 ) ) @ K5 )
           => ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_7353_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N2 ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_7354_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_7355_Bseq__realpow,axiom,
    ! [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ord_less_eq @ real @ X3 @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X3 ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_7356_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_7357_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_7358_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X4: C] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_7359_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_7360_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_7361_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P3: A > $o] :
          ( ( eventually @ A @ P3 @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B4 )
                & ! [X4: A] :
                    ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X4 ) )
                   => ( P3 @ X4 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_7362_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K5: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ K5 )
            @ F4 )
         => ( bfun @ A @ B @ F2 @ F4 ) ) ) ).

% BfunI
thf(fact_7363_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X4: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_7364_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X4: A] : ( ord_less @ real @ ( F2 @ X4 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_7365_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X4: A] : ( inverse_inverse @ B @ ( G @ X4 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F4 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_7366_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [X4: A] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X9 @ N2 ) @ ( uminus_uminus @ A @ X4 ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_7367_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [N6: nat] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X9 @ N2 ) @ ( uminus_uminus @ A @ ( X9 @ N6 ) ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_7368_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X4: A] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_7369_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X4: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X4 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_7370_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X4: B] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ F4 ) ) ) ) ).

% Bfun_inverse
thf(fact_7371_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X3: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X3 ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_7372_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F2 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_7373_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X4: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_7374_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F4 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ B9 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_7375_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F9: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X4 ) ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_7376_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A5: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A5 )
               => ! [B4: nat] :
                    ( ( ord_less @ nat @ A5 @ B4 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A5 @ B4 ) ) ) @ ( G @ A5 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_7377_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M3: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M3 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N2 ) ) ) @ ( G @ M3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_7378_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X4: A] :
              ! [Y: A] :
                ( ( ord_less_eq @ A @ X4 @ Y )
               => ( P @ Y ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_7379_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P2: A > $o] :
              ( the @ A
              @ ^ [X4: A] :
                  ( ( P2 @ X4 )
                  & ! [Y: A] :
                      ( ( P2 @ Y )
                     => ( ord_less_eq @ A @ Y @ X4 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_7380_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A3: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ! [F5: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ A3 @ ( F5 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F5 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F5 )
                   => ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P @ ( F5 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_7381_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ord_less_eq @ B @ ( F2 @ Y5 ) @ ( F2 @ X3 ) ) ) ) ) ).

% antimonoD
thf(fact_7382_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ord_less_eq @ B @ ( F2 @ Y5 ) @ ( F2 @ X3 ) ) ) ) ) ).

% antimonoE
thf(fact_7383_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_7384_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X4: A,Y: A] :
              ( ( ord_less_eq @ A @ X4 @ Y )
             => ( ord_less_eq @ B @ ( F3 @ Y ) @ ( F3 @ X4 ) ) ) ) ) ) ).

% antimono_def
thf(fact_7385_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: nat > A,I: nat] :
          ( ( order_antimono @ nat @ A @ A2 )
         => ( ord_less_eq @ A @ ( A2 @ ( suc @ I ) ) @ ( A2 @ I ) ) ) ) ).

% decseq_SucD
thf(fact_7386_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ ( suc @ N3 ) ) @ ( X9 @ N3 ) )
         => ( order_antimono @ nat @ A @ X9 ) ) ) ).

% decseq_SucI
thf(fact_7387_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_7388_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X5: nat > A] :
            ! [M3: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N2 )
             => ( ord_less_eq @ A @ ( X5 @ N2 ) @ ( X5 @ M3 ) ) ) ) ) ) ).

% decseq_def
thf(fact_7389_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J3: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J3 )
           => ( ord_less_eq @ A @ ( F2 @ J3 ) @ ( F2 @ I ) ) ) ) ) ).

% decseqD
thf(fact_7390_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_1: nat] : ( P @ X_1 )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_7391_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_7392_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_7393_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X3: A,Q: A > $o] :
          ( ( P @ X3 )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ Y2 @ X3 ) )
           => ( ! [X2: A] :
                  ( ( P @ X2 )
                 => ( ! [Y6: A] :
                        ( ( P @ Y6 )
                       => ( ord_less_eq @ A @ Y6 @ X2 ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_7394_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X3: A] :
          ( ( P @ X3 )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ Y2 @ X3 ) )
           => ( ( order_Greatest @ A @ P )
              = X3 ) ) ) ) ).

% Greatest_equality
thf(fact_7395_decseq__bounded,axiom,
    ! [X9: nat > real,B3: real] :
      ( ( order_antimono @ nat @ real @ X9 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ B3 @ ( X9 @ I3 ) )
       => ( bfun @ nat @ real @ X9 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_7396_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,L5: A,N: nat] :
          ( ( order_antimono @ nat @ A @ X9 )
         => ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X9 @ N ) ) ) ) ) ).

% decseq_ge
thf(fact_7397_decseq__convergent,axiom,
    ! [X9: nat > real,B3: real] :
      ( ( order_antimono @ nat @ real @ X9 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ B3 @ ( X9 @ I3 ) )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X9 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I4: nat] : ( ord_less_eq @ real @ L6 @ ( X9 @ I4 ) ) ) ) ) ).

% decseq_convergent
thf(fact_7398_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A3: B,B2: B,X9: B > C,L5: C] :
          ( ( ord_less @ B @ A3 @ B2 )
         => ( ! [S7: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ A3 @ ( S7 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ B @ ( S7 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S7 )
                   => ( ( filterlim @ nat @ B @ S7 @ ( topolo7230453075368039082e_nhds @ B @ A3 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N2: nat] : ( X9 @ ( S7 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X9 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A3 @ ( set_ord_greaterThan @ B @ A3 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_7399_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y4: set @ B,X9: set @ A,F4: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y4 ) @ X9 )
     => ( ( eventually @ B
          @ ^ [X4: B] : ( member2 @ B @ X4 @ Y4 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X9 @ F2 @ ( map_filter_on @ B @ A @ Y4 @ G @ F4 ) )
          = ( map_filter_on @ B @ C @ Y4 @ ( comp @ A @ C @ B @ F2 @ G ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_7400_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F9: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P2: A > $o] :
                  ( ( eventually @ A @ P2 @ F9 )
                  & ! [X4: A,Y: A] :
                      ( ( ( P2 @ X4 )
                        & ( P2 @ Y ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ Y ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_7401_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [F4: filter @ A,X3: A] :
          ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) )
         => ( topolo6773858410816713723filter @ A @ F4 ) ) ) ).

% nhds_imp_cauchy_filter
thf(fact_7402_GMVT,axiom,
    ! [A3: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ( ord_less_eq @ real @ A3 @ X2 )
              & ( ord_less_eq @ real @ X2 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X2: real] :
              ( ( ( ord_less @ real @ A3 @ X2 )
                & ( ord_less @ real @ X2 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A3 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X2: real] :
                  ( ( ( ord_less @ real @ A3 @ X2 )
                    & ( ord_less @ real @ X2 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A3 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A3 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_7403_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A2: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A2 ) @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A2 ) ) @ ( finite_Fpow @ A @ B3 ) ) ) ).

% image_Fpow_mono
thf(fact_7404_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q2 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_7405_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q2 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_7406_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X3: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_7407_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ F4 ) ) ) ) ).

% differentiable_add
thf(fact_7408_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X3: A,S: set @ A,N: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N )
            @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ).

% differentiable_power
thf(fact_7409_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X3: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X4: A] : ( times_times @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_7410_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X3: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X3 @ S ) )
           => ( ( ( G @ X3 )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G @ X4 ) )
                @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_7411_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X3: A,S: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X4: A] : ( inverse_inverse @ B @ ( F2 @ X4 ) )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% differentiable_inverse
thf(fact_7412_Fpow__mono,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A2 ) @ ( finite_Fpow @ A @ B3 ) ) ) ).

% Fpow_mono
thf(fact_7413_Fpow__subset__Pow,axiom,
    ! [A: $tType,A2: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A2 ) @ ( pow2 @ A @ A2 ) ) ).

% Fpow_subset_Pow
thf(fact_7414_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A4: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X5: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X5 @ A4 )
                & ( finite_finite @ A @ X5 ) ) ) ) ) ).

% Fpow_def
thf(fact_7415_MVT,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A3 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L2: real,Z5: real] :
              ( ( ord_less @ real @ A3 @ Z5 )
              & ( ord_less @ real @ Z5 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A3 ) @ L2 ) ) ) ) ) ) ).

% MVT
thf(fact_7416_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,C6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: B] :
                ( ( member2 @ B @ T7 @ C6 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C6 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C6 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_7417_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X2: C] :
                  ( ( member2 @ C @ X2 @ S )
                 => ( ( F2 @ X2 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X4: C] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_7418_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X4: A] : ( ln_ln @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_7419_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X4: A] : ( sgn_sgn @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_7420_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X4: A] : ( inverse_inverse @ B @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_7421_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G )
           => ( ! [X2: A] :
                  ( ( member2 @ A @ X2 @ S )
                 => ( ( G @ X2 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_7422_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_7423_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A2: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A2 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A2
              @ ^ [X4: D] : ( times_times @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_7424_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_7425_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_7426_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_7427_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X4: A] : ( sqrt @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_7428_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A2: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A2 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A2
              @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_7429_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F2: C > B,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ N ) ) ) ) ).

% continuous_on_power
thf(fact_7430_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X4: D] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_7431_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,N: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X4: A] : ( root @ N @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_7432_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A2: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A2 ) )
         => ( ! [X2: A,Y2: A] :
                ( ( member2 @ A @ X2 @ A2 )
               => ( ( member2 @ A @ Y2 @ A2 )
                 => ( ( ord_less_eq @ A @ X2 @ Y2 )
                   => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A2 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_7433_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G: A > B,S: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X4: C] : ( G @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_7434_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_7435_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A3: A,Y5: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A3 ) @ Y5 )
         => ( ( ord_less_eq @ B @ Y5 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A3 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A3 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y5 ) ) ) ) ) ) ) ).

% IVT'
thf(fact_7436_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y5: B,A3: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y5 )
         => ( ( ord_less_eq @ B @ Y5 @ ( F2 @ A3 ) )
           => ( ( ord_less_eq @ A @ A3 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 )
               => ? [X2: A] :
                    ( ( ord_less_eq @ A @ A3 @ X2 )
                    & ( ord_less_eq @ A @ X2 @ B2 )
                    & ( ( F2 @ X2 )
                      = Y5 ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_7437_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
                & ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ S2 )
                   => ( ord_less_eq @ A @ Xa3 @ X2 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_7438_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member2 @ A @ X2 @ S2 )
                & ! [Xa3: A] :
                    ( ( member2 @ A @ Xa3 @ S2 )
                   => ( ord_less_eq @ A @ X2 @ Xa3 ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_7439_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X2: A] :
                  ( ( member2 @ A @ X2 @ S )
                  & ! [Xa3: A] :
                      ( ( member2 @ A @ Xa3 @ S )
                     => ( ord_less_eq @ B @ ( F2 @ Xa3 ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_7440_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X2: A] :
                  ( ( member2 @ A @ X2 @ S )
                  & ! [Xa3: A] :
                      ( ( member2 @ A @ Xa3 @ S )
                     => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Xa3 ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_7441_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_7442_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( cos @ A @ ( F2 @ X2 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X4: A] : ( tan @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_7443_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                  = ( collect @ A
                    @ ^ [X4: A] :
                        ( ( member2 @ A @ X4 @ S )
                        & ( ord_less @ real @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_7444_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( sin @ A @ ( F2 @ X2 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X4: A] : ( cot @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_7445_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A2 @ F2 )
         => ( ! [X2: C] :
                ( ( member2 @ C @ X2 @ A2 )
               => ( ( cosh @ A @ ( F2 @ X2 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A2
              @ ^ [X4: C] : ( tanh @ A @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_7446_continuous__on__arcosh_H,axiom,
    ! [A2: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A2 @ F2 )
     => ( ! [X2: real] :
            ( ( member2 @ real @ X2 @ A2 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A2
          @ ^ [X4: real] : ( arcosh @ real @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_7447_continuous__image__closed__interval,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A3 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
       => ? [C3: real,D3: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C3 @ D3 ) )
            & ( ord_less_eq @ real @ C3 @ D3 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_7448_continuous__on__arcosh,axiom,
    ! [A2: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A2 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A2 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_7449_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                = ( collect @ A
                  @ ^ [X4: A] :
                      ( ( member2 @ A @ X4 @ S )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X4 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_7450_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X2: C] :
                  ( ( member2 @ C @ X2 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
                    & ( ( ( F2 @ X2 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X4: C] : ( powr @ real @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_7451_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ( ! [X2: A] :
                  ( ( member2 @ A @ X2 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) )
             => ( ! [X2: A] :
                    ( ( member2 @ A @ X2 @ S )
                   => ( ( F2 @ X2 )
                     != ( one_one @ real ) ) )
               => ( ! [X2: A] :
                      ( ( member2 @ A @ X2 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_7452_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X2 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X2 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X4: A] : ( arccos @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_7453_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X2 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X2 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X4: A] : ( arcsin @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_7454_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: A,B2: A,F2: A > A] :
          ( ! [X2: A] :
              ( ( ord_less_eq @ A @ A3 @ X2 )
             => ( ( ord_less_eq @ A @ X2 @ B2 )
               => ? [Y6: A] : ( has_field_derivative @ A @ F2 @ Y6 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_7455_Rolle__deriv,axiom,
    ! [A3: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( ( F2 @ A3 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
         => ( ! [X2: real] :
                ( ( ord_less @ real @ A3 @ X2 )
               => ( ( ord_less @ real @ X2 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z5: real] :
                ( ( ord_less @ real @ A3 @ Z5 )
                & ( ord_less @ real @ Z5 @ B2 )
                & ( ( F8 @ Z5 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_7456_mvt,axiom,
    ! [A3: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A3 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A3 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) )
                   != ( F8 @ Xi @ ( minus_minus @ real @ B2 @ A3 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_7457_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A3: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_7458_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A3: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A3 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A3 ) ) @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_7459_DERIV__isconst__end,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A3 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A3 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_7460_DERIV__neg__imp__decreasing__open,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less @ real @ A3 @ X2 )
           => ( ( ord_less @ real @ X2 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y6 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A3 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_7461_DERIV__pos__imp__increasing__open,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ! [X2: real] :
            ( ( ord_less @ real @ A3 @ X2 )
           => ( ( ord_less @ real @ X2 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y6 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A3 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_7462_continuous__on__artanh,axiom,
    ! [A2: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A2 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A2 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_7463_DERIV__isconst2,axiom,
    ! [A3: real,B2: real,F2: real > real,X3: real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
       => ( ! [X2: real] :
              ( ( ord_less @ real @ A3 @ X2 )
             => ( ( ord_less @ real @ X2 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A3 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ( ( F2 @ X3 )
                = ( F2 @ A3 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_7464_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A3: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A3 ) ) @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_greaterThan @ A @ A3 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X2: A] :
                  ( ( ord_less @ A @ A3 @ X2 )
                 => ( ( ord_less @ A @ X2 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X2 ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A3 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_7465_Rolle,axiom,
    ! [A3: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A3 @ B2 )
     => ( ( ( F2 @ A3 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A3 @ B2 ) @ F2 )
         => ( ! [X2: real] :
                ( ( ord_less @ real @ A3 @ X2 )
               => ( ( ord_less @ real @ X2 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z5: real] :
                ( ( ord_less @ real @ A3 @ Z5 )
                & ( ord_less @ real @ Z5 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_7466_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member2 @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_7467_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X: set @ A] :
                  ( ( member2 @ ( set @ A ) @ X @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C9: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C9 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C9 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_7468_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S6: set @ A] :
            ! [C10: set @ ( set @ A )] :
              ( ( ! [X4: set @ A] :
                    ( ( member2 @ ( set @ A ) @ X4 @ C10 )
                   => ( topolo1002775350975398744n_open @ A @ X4 ) )
                & ( ord_less_eq @ ( set @ A ) @ S6 @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) )
             => ? [D7: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D7 @ C10 )
                  & ( finite_finite @ ( set @ A ) @ D7 )
                  & ( ord_less_eq @ ( set @ A ) @ S6 @ ( complete_Sup_Sup @ ( set @ A ) @ D7 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_7469_the__elem__set,axiom,
    ! [A: $tType,X3: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
      = X3 ) ).

% the_elem_set
thf(fact_7470_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A3: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ! [F5: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ B2 @ ( F5 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F5 @ N7 ) @ A3 )
                 => ( ( order_mono @ nat @ A @ F5 )
                   => ( ( filterlim @ nat @ A @ F5 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P @ ( F5 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A3 @ ( set_ord_lessThan @ A @ A3 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_7471_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P3: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P3 ) @ P3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P3 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_7472_incseq__bounded,axiom,
    ! [X9: nat > real,B3: real] :
      ( ( order_mono @ nat @ real @ X9 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( X9 @ I3 ) @ B3 )
       => ( bfun @ nat @ real @ X9 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_7473_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I: nat,J3: nat,X3: A,Y5: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J3 )
           => ( ( ord_less_eq @ A @ X3 @ Y5 )
             => ( ( ord_less_eq @ A @ X3 @ ( F2 @ X3 ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I @ F2 @ X3 ) @ ( compow @ ( A > A ) @ J3 @ F2 @ Y5 ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_7474_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
           => ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ).

% mono_invE
thf(fact_7475_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A3 ) ) ) ) ).

% mono_mult
thf(fact_7476_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_7477_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( X9 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X9 ) ) ) ).

% incseq_SucI
thf(fact_7478_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: nat > A,I: nat] :
          ( ( order_mono @ nat @ A @ A2 )
         => ( ord_less_eq @ A @ ( A2 @ I ) @ ( A2 @ ( suc @ I ) ) ) ) ) ).

% incseq_SucD
thf(fact_7479_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) ) ).

% monoD
thf(fact_7480_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X3 @ Y5 )
           => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) ) ).

% monoE
thf(fact_7481_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_7482_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X4: A,Y: A] :
              ( ( ord_less_eq @ A @ X4 @ Y )
             => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y ) ) ) ) ) ) ).

% mono_def
thf(fact_7483_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J3: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J3 )
           => ( ord_less_eq @ A @ ( F2 @ I ) @ ( F2 @ J3 ) ) ) ) ) ).

% incseqD
thf(fact_7484_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X5: nat > A] :
            ! [M3: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N2 )
             => ( ord_less_eq @ A @ ( X5 @ M3 ) @ ( X5 @ N2 ) ) ) ) ) ) ).

% incseq_def
thf(fact_7485_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A2: A,B3: A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A2 @ B3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ A2 ) @ ( compow @ ( A > A ) @ N @ F2 @ B3 ) ) ) ) ) ).

% funpow_mono
thf(fact_7486_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A2: A,B3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A2 @ B3 ) ) @ ( inf_inf @ B @ ( F2 @ A2 ) @ ( F2 @ B3 ) ) ) ) ) ).

% mono_inf
thf(fact_7487_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A2: A,B3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A2 ) @ ( F2 @ B3 ) ) @ ( F2 @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) ) ).

% mono_sup
thf(fact_7488_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P3: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P3 @ ( F2 @ P3 ) )
           => ( ord_less_eq @ A @ P3 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_7489_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N: A,M5: B,N4: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
              = ( set_or7035219750837199246ssThan @ B @ M5 @ N4 ) )
           => ( ( ord_less @ A @ M @ N )
             => ( ( F2 @ M )
                = M5 ) ) ) ) ) ).

% mono_image_least
thf(fact_7490_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A3 ) ) ) ).

% mono_add
thf(fact_7491_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_7492_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ) ).

% mono_pow
thf(fact_7493_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_7494_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
           => ( ord_less @ A @ X3 @ Y5 ) ) ) ) ).

% mono_strict_invE
thf(fact_7495_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I2: nat] : ( compow @ ( A > A ) @ I2 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_7496_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A2: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X4: C] : ( F2 @ ( A2 @ X4 ) )
                @ I5 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A2 @ I5 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_7497_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A2: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A2 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ) ).

% mono_Sup
thf(fact_7498_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A2: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A2 @ I5 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X4: C] : ( F2 @ ( A2 @ X4 ) )
                @ I5 ) ) ) ) ) ).

% mono_INF
thf(fact_7499_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A2: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A2 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A2 ) ) ) ) ) ).

% mono_Inf
thf(fact_7500_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I2: nat] : ( compow @ ( A > A ) @ I2 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_7501_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,L5: A,N: nat] :
          ( ( order_mono @ nat @ A @ X9 )
         => ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X9 @ N ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_7502_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_7503_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_7504_incseq__convergent,axiom,
    ! [X9: nat > real,B3: real] :
      ( ( order_mono @ nat @ real @ X9 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( X9 @ I3 ) @ B3 )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X9 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I4: nat] : ( ord_less_eq @ real @ ( X9 @ I4 ) @ L6 ) ) ) ) ).

% incseq_convergent
thf(fact_7505_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M3 ) @ M3 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_7506_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N3: nat] :
                  ( ( ( F2 @ N3 )
                    = ( F2 @ ( suc @ N3 ) ) )
                 => ( ( F2 @ ( suc @ N3 ) )
                    = ( F2 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N9: nat] :
                  ( ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N9 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N9 )
                         => ( ( ord_less @ nat @ M2 @ N7 )
                           => ( ord_less @ A @ ( F2 @ M2 ) @ ( F2 @ N7 ) ) ) ) )
                  & ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N7 )
                     => ( ( F2 @ N9 )
                        = ( F2 @ N7 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_7507_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A3: B,X9: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A3 )
         => ( ! [S7: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ ( S7 @ N7 ) @ A3 )
               => ( ! [N7: nat] : ( ord_less @ B @ B2 @ ( S7 @ N7 ) )
                 => ( ( order_mono @ nat @ B @ S7 )
                   => ( ( filterlim @ nat @ B @ S7 @ ( topolo7230453075368039082e_nhds @ B @ A3 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N2: nat] : ( X9 @ ( S7 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A3 @ ( set_ord_lessThan @ B @ A3 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_7508_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys2 )
      = ( ? [F3: nat > nat] :
            ( ( order_mono @ nat @ nat @ F3 )
            & ( ( image @ nat @ nat @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I2 )
                  = ( nth @ A @ Ys2 @ ( F3 @ I2 ) ) ) )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I2 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) )
                  = ( ( F3 @ I2 )
                    = ( F3 @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_7509_range__abs__Nats,axiom,
    ( ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) )
    = ( semiring_1_Nats @ int ) ) ).

% range_abs_Nats
thf(fact_7510_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_7511_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_7512_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_7513_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_7514_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( cons @ A @ X3 @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_7515_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A2: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A2 ) @ ( F2 @ B3 ) ) ) ) ).

% mono_Int
thf(fact_7516_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A2: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A2 ) @ ( F2 @ B3 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ) ) ).

% mono_Un
thf(fact_7517_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_7518_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( semiring_1_Nats @ A ) )
         => ( ( member2 @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member2 @ A @ ( times_times @ A @ A3 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_7519_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W: num] : ( member2 @ A @ ( numeral_numeral @ A @ W ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_7520_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member2 @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_7521_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( semiring_1_Nats @ A ) )
         => ( ( member2 @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member2 @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_7522_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member2 @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_7523_fact__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] : ( member2 @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% fact_in_Nats
thf(fact_7524_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( semiring_1_Nats @ A ) )
         => ~ ! [N3: nat] :
                ( X3
               != ( semiring_1_of_nat @ A @ N3 ) ) ) ) ).

% Nats_cases
thf(fact_7525_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X3: A,P: A > $o] :
          ( ( member2 @ A @ X3 @ ( semiring_1_Nats @ A ) )
         => ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ A @ N3 ) )
           => ( P @ X3 ) ) ) ) ).

% Nats_induct
thf(fact_7526_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] : ( member2 @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_7527_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_7528_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X3: A,Y5: A,Xs: list @ A] :
      ( ( ( X3 = Y5 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) ) ) )
      & ( ( X3 != Y5 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Xs ) ) )
          = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y5 @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_7529_remdups__adj_Oelims,axiom,
    ! [A: $tType,X3: list @ A,Y5: list @ A] :
      ( ( ( remdups_adj @ A @ X3 )
        = Y5 )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y5
           != ( nil @ A ) ) )
       => ( ! [X2: A] :
              ( ( X3
                = ( cons @ A @ X2 @ ( nil @ A ) ) )
             => ( Y5
               != ( cons @ A @ X2 @ ( nil @ A ) ) ) )
         => ~ ! [X2: A,Y2: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs3 ) ) )
               => ~ ( ( ( X2 = Y2 )
                     => ( Y5
                        = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs3 ) ) ) )
                    & ( ( X2 != Y2 )
                     => ( Y5
                        = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs3 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_7530_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X3: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) )
      = ( cons @ A @ X3 @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_7531_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( cons @ A @ X3
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y: A] : ( Y = X3 )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_7532_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7533_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_7534_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( semiring_1_Nats @ A ) )
         => ( ( member2 @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A3 )
             => ( member2 @ A @ ( minus_minus @ A @ A3 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_7535_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X3: A,Y5: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X3 = Y5 ) @ ( nil @ A ) @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_7536_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_7537_remdups__adj__Cons,axiom,
    ! [A: $tType,X3: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X3 @ ( nil @ A ) )
        @ ^ [Y: A,Xs2: list @ A] : ( if @ ( list @ A ) @ ( X3 = Y ) @ ( cons @ A @ Y @ Xs2 ) @ ( cons @ A @ X3 @ ( cons @ A @ Y @ Xs2 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_7538_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_7539_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X3 ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X3 ) )
          = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7540_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X3: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X3 @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X3 ) ) ) ).

% remdups_adj_singleton
thf(fact_7541_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X3: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X3 @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_7542_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_7543_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y5: A,Ys2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y5 @ Ys2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X4: A] : ( X4 = Y5 )
            @ Ys2 ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_7544_tl__remdups__adj,axiom,
    ! [A: $tType,Ys2: list @ A] :
      ( ( Ys2
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys2 ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X4: A] :
                ( X4
                = ( hd @ A @ Ys2 ) )
            @ ( tl @ A @ Ys2 ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_7545_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N2: A] :
              ( ( member2 @ A @ N2 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_7546_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7547_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7548_remdups__adj_Opelims,axiom,
    ! [A: $tType,X3: list @ A,Y5: list @ A] :
      ( ( ( remdups_adj @ A @ X3 )
        = Y5 )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X3 )
       => ( ( ( X3
              = ( nil @ A ) )
           => ( ( Y5
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( X3
                  = ( cons @ A @ X2 @ ( nil @ A ) ) )
               => ( ( Y5
                    = ( cons @ A @ X2 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
           => ~ ! [X2: A,Y2: A,Xs3: list @ A] :
                  ( ( X3
                    = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs3 ) ) )
                 => ( ( ( ( X2 = Y2 )
                       => ( Y5
                          = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs3 ) ) ) )
                      & ( ( X2 != Y2 )
                       => ( Y5
                          = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs3 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs3 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_7549_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X4: nat] : ( F2 @ ( G @ X4 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_7550_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N @ ( F2 @ N ) ) ) ).

% strict_mono_imp_increasing
thf(fact_7551_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R2: A > B,M: A,N: A] :
          ( ( order_strict_mono @ A @ B @ R2 )
         => ( ( ord_less_eq @ A @ M @ N )
           => ( ord_less_eq @ B @ ( R2 @ M ) @ ( R2 @ N ) ) ) ) ) ).

% strict_mono_leD
thf(fact_7552_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
            = ( ord_less_eq @ A @ X3 @ Y5 ) ) ) ) ).

% strict_mono_less_eq
thf(fact_7553_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K ) ) ) ).

% strict_mono_add
thf(fact_7554_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N2: nat] : ( ord_less @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_7555_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X3 @ Y5 )
           => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) ) ).

% strict_monoD
thf(fact_7556_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
             => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_7557_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X4: A,Y: A] :
              ( ( ord_less @ A @ X4 @ Y )
             => ( ord_less @ B @ ( F3 @ X4 ) @ ( F3 @ Y ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_7558_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X3: A,Y5: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
            = ( ord_less @ A @ X3 @ Y5 ) ) ) ) ).

% strict_mono_less
thf(fact_7559_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member2 @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( F2 @ ( G @ N2 ) ) )
              = ( summable @ A @ F2 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_7560_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member2 @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N2: nat] : ( F2 @ ( G @ N2 ) )
                @ C2 )
              = ( sums @ A @ F2 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_7561_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member2 @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N2: nat] : ( F2 @ ( G @ N2 ) ) )
              = ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_7562_complex__is__Nat__iff,axiom,
    ! [Z2: complex] :
      ( ( member2 @ complex @ Z2 @ ( semiring_1_Nats @ complex ) )
      = ( ( ( im @ Z2 )
          = ( zero_zero @ real ) )
        & ? [I2: nat] :
            ( ( re @ Z2 )
            = ( semiring_1_of_nat @ real @ I2 ) ) ) ) ).

% complex_is_Nat_iff
thf(fact_7563_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq @ nat @ X2 @ Y2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y2 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X4: nat] : ( F2 @ ( G @ X4 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_7564_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I5: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ I5 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I3 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I5 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I5 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_7565_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N: A,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R2 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N ) @ R2 ) )
        | ( ( M = N )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R2 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_7566_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R2 ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_7567_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R2 ) ) ).

% Nil_lenlex_iff2
thf(fact_7568_lenlex__irreflexive,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R2 ) ) ) ).

% lenlex_irreflexive
thf(fact_7569_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ ( G @ X4 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_7570_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T6 )
           => ( ( ( inf_inf @ ( set @ A ) @ S2 @ T6 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T6 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_7571_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S2: set @ A,Y5: A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ~ ( member2 @ A @ Y5 @ S2 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member2 @ A @ Y5 @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S2 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_7572_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X3: A,A2: set @ A] :
          ( ( member2 @ A @ X3 @ A2 )
         => ( ( topolo1002775350975398744n_open @ A @ A2 )
           => ? [A11: set @ A] :
                ( ( member2 @ A @ X3 @ A11 )
                & ( topolo7761053866217962861closed @ A @ A11 )
                & ( ord_less_eq @ ( set @ A ) @ A11 @ A2 )
                & ( eventually @ A
                  @ ^ [Y: A] : ( member2 @ A @ Y @ A11 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X3 ) ) ) ) ) ) ).

% nhds_closed
thf(fact_7573_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R2 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_7574_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R4: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R4 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys2 ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys2 ) ) @ ( lenlex @ A @ R4 ) ) ) ) ).

% lenlex_append1
thf(fact_7575_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F4: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: set @ A] :
                ( ( member2 @ ( set @ A ) @ T7 @ F4 )
               => ( topolo7761053866217962861closed @ A @ T7 ) )
           => ( ! [F16: set @ ( set @ A )] :
                  ( ( finite_finite @ ( set @ A ) @ F16 )
                 => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F16 @ F4 )
                   => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F16 ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F4 ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip
thf(fact_7576_compact__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [U6: set @ A] :
            ! [A4: set @ ( set @ A )] :
              ( ! [X4: set @ A] :
                  ( ( member2 @ ( set @ A ) @ X4 @ A4 )
                 => ( topolo7761053866217962861closed @ A @ X4 ) )
             => ( ! [B8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B8 @ A4 )
                   => ( ( finite_finite @ ( set @ A ) @ B8 )
                     => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) )
                       != ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) )
                 != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% compact_fip
thf(fact_7577_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F8: real > real] :
      ( ! [X2: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F8 @ X2 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_7578_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs2 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_7579_lenlex__append2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys2: list @ A] :
      ( ( irrefl @ A @ R4 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys2 ) ) @ ( lenlex @ A @ R4 ) )
        = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lenlex @ A @ R4 ) ) ) ) ).

% lenlex_append2
thf(fact_7580_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_7581_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys2 ) )
        = ( Xs = Ys2 ) ) ) ).

% inj_map_eq_map
thf(fact_7582_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A3 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_7583_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A] :
          ( ( inj_on @ A @ A
            @ ^ [B4: A] : ( divide_divide @ A @ B4 @ A3 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_7584_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_7585_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_7586_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_7587_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,A9: set @ B] :
      ( ( A2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F3: A > B] :
              ( ( inj_on @ A @ B @ F3 @ A2 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A2 ) @ A9 ) ) )
        = ( ? [G2: B > A] :
              ( ( image @ B @ A @ G2 @ A9 )
              = A2 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_7588_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A2: set @ A,F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
             => ( ( member2 @ A @ X2 @ A2 )
               => ( ( member2 @ A @ Y2 @ A2 )
                 => ( ( F2 @ X2 )
                   != ( F2 @ Y2 ) ) ) ) )
         => ( ! [X2: A,Y2: A] :
                ( ( member2 @ A @ X2 @ A2 )
               => ( ( member2 @ A @ Y2 @ A2 )
                 => ( ( ord_less_eq @ A @ X2 @ Y2 )
                    | ( ord_less_eq @ A @ Y2 @ X2 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A2 ) ) ) ) ).

% linorder_inj_onI
thf(fact_7589_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( inj_on @ A @ B @ F2 @ A2 ) ) ) ).

% subset_inj_on
thf(fact_7590_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( inj_on @ A @ B @ F2 @ B3 ) ) ) ).

% inj_on_subset
thf(fact_7591_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A2: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( ( image @ A @ B @ F2 @ A2 )
              = ( image @ A @ B @ F2 @ B3 ) )
            = ( A2 = B3 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_7592_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A3: A,A2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( member2 @ A @ A3 @ B3 )
       => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ( ( member2 @ B @ ( F2 @ A3 ) @ ( image @ A @ B @ F2 @ A2 ) )
            = ( member2 @ A @ A3 @ A2 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_7593_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: B > A,T6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( image @ B @ A @ F2 @ T6 ) )
      = ( ? [U6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U6 @ T6 )
            & ( inj_on @ B @ A @ F2 @ U6 )
            & ( S2
              = ( image @ B @ A @ F2 @ U6 ) ) ) ) ) ).

% subset_image_inj
thf(fact_7594_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A2: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_7595_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A2: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A2 @ B3 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_7596_endo__inj__surj,axiom,
    ! [A: $tType,A2: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A2 ) @ A2 )
       => ( ( inj_on @ A @ A @ F2 @ A2 )
         => ( ( image @ A @ A @ F2 @ A2 )
            = A2 ) ) ) ) ).

% endo_inj_surj
thf(fact_7597_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ B3 )
       => ( ( finite_finite @ B @ B3 )
         => ( finite_finite @ A @ A2 ) ) ) ) ).

% inj_on_finite
thf(fact_7598_finite__surj__inj,axiom,
    ! [A: $tType,A2: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( image @ A @ A @ F2 @ A2 ) )
       => ( inj_on @ A @ A @ F2 @ A2 ) ) ) ).

% finite_surj_inj
thf(fact_7599_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ ( image @ A @ B @ F2 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ).

% inj_image_subset_iff
thf(fact_7600_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_7601_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys2 ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys2 ) )
        = ( Xs = Ys2 ) ) ) ).

% inj_on_map_eq_map
thf(fact_7602_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys2 ) ) )
       => ( Xs = Ys2 ) ) ) ).

% map_inj_on
thf(fact_7603_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A2: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A2 ) ) @ ( finite_card @ B @ A2 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A2 ) ) ).

% pigeonhole
thf(fact_7604_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_7605_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys2: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys2 ) ) ) ).

% map_injective
thf(fact_7606_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_7607_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X4: A] : X4
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_7608_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A3 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_7609_irrefl__lex,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R2 )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R2 ) ) ) ).

% irrefl_lex
thf(fact_7610_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,A2: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( plus_plus @ A @ B4 @ A3 )
          @ A2 ) ) ).

% inj_on_add'
thf(fact_7611_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,A2: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A3 ) @ A2 ) ) ).

% inj_on_add
thf(fact_7612_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( inj_on @ B @ A @ F2 @ S2 ) ) ).

% folding_insort_key.inj_on
thf(fact_7613_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,A2: set @ A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A3 ) @ A2 ) ) ) ).

% inj_on_mult
thf(fact_7614_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A2 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A2 ) ) ).

% inj_on_mapI
thf(fact_7615_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
       => ( ord_less @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ).

% inj_on_strict_subset
thf(fact_7616_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
             => ( ( F2 @ X2 )
               != ( F2 @ Y2 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_7617_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: set @ A,X3: B,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A2 )
     => ( ( member2 @ B @ X3 @ ( image @ A @ B @ F2 @ A2 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ( member2 @ A @ ( the_inv_into @ A @ B @ A2 @ F2 @ X3 ) @ B3 ) ) ) ) ).

% the_inv_into_into
thf(fact_7618_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X3: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X3 @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X3 ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_7619_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A3: A,X3: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A3 @ X3 )
         => ( ( ord_less @ A @ X3 @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A3 ) @ ( F2 @ X3 ) )
                    & ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X3 ) )
                    & ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ A3 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_7620_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_7621_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set @ A,A2: A > ( set @ B ),F2: B > C] :
      ( ! [I3: A,J2: A] :
          ( ( member2 @ A @ I3 @ I5 )
         => ( ( member2 @ A @ J2 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A2 @ I3 ) @ ( A2 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A2 @ J2 ) @ ( A2 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member2 @ A @ I3 @ I5 )
           => ( inj_on @ B @ C @ F2 @ ( A2 @ I3 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A2 @ I5 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_7622_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y5: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert2 @ A @ Y5 @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X4: A] :
              ( ( F2 @ Y5 )
              = ( F2 @ X4 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
            @ Y5 )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_7623_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A2: set @ A,B3: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ B3 )
       => ( ( inj_on @ B @ A @ G @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B3 ) @ A2 )
           => ( ( finite_finite @ A @ A2 )
             => ( ( finite_finite @ B @ B3 )
               => ( ( finite_card @ A @ A2 )
                  = ( finite_card @ B @ B3 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_7624_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,T6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ( ( finite_card @ A @ S2 )
            = ( finite_card @ B @ T6 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S2 ) @ T6 )
           => ( ( ! [X4: B] :
                    ( ( member2 @ B @ X4 @ T6 )
                   => ? [Y: A] :
                        ( ( member2 @ A @ Y @ S2 )
                        & ( ( F2 @ Y )
                          = X4 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_7625_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_7626_lexl__not__refl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),X3: list @ A] :
      ( ( irrefl @ A @ R2 )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ X3 ) @ ( lex @ A @ R2 ) ) ) ).

% lexl_not_refl
thf(fact_7627_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X3: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert2 @ A @ X3 @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X3 @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X3 ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_7628_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C6: set @ A,A2: set @ C,B3: C > ( set @ A ),J3: C] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ! [X2: C] :
            ( ( member2 @ C @ X2 @ A2 )
           => ( ord_less_eq @ ( set @ A ) @ ( B3 @ X2 ) @ C6 ) )
       => ( ( member2 @ C @ J3 @ A2 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B3 @ A2 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X4: C] : ( image @ A @ B @ F2 @ ( B3 @ X4 ) )
                @ A2 ) ) ) ) ) ) ).

% image_INT
thf(fact_7629_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ B @ B3 ) )
         => ? [F5: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A2 ) @ B3 )
              & ( inj_on @ A @ B @ F5 @ A2 ) ) ) ) ) ).

% card_le_inj
thf(fact_7630_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A2: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ B3 )
       => ( ( finite_finite @ B @ B3 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ B @ B3 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_7631_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A2 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( ? [F3: A > B] :
                ( ( inj_on @ A @ B @ F3 @ A2 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A2 ) @ B3 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ B @ B3 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_7632_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_7633_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys2: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys2 ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys2 ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys2 ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys2 ) )
                   => ( Xs = Ys2 ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_7634_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A2: set @ A,B3: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ B3 )
       => ( ( inj_on @ B @ A @ G @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B3 ) @ A2 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A2 @ B3 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_7635_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T9 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_7636_inj__on__rev,axiom,
    ! [A: $tType,A2: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A2 ) ).

% inj_on_rev
thf(fact_7637_inj__on__diff__nat,axiom,
    ! [N5: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member2 @ nat @ N3 @ N5 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ K )
        @ N5 ) ) ).

% inj_on_diff_nat
thf(fact_7638_inj__on__Cons1,axiom,
    ! [A: $tType,X3: A,A2: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ A2 ) ).

% inj_on_Cons1
thf(fact_7639_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_7640_inj__Suc,axiom,
    ! [N5: set @ nat] : ( inj_on @ nat @ nat @ suc @ N5 ) ).

% inj_Suc
thf(fact_7641_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X5: $o > A,Y8: $o > A] :
              ( ( ord_less_eq @ A @ ( X5 @ $false ) @ ( Y8 @ $false ) )
              & ( ord_less_eq @ A @ ( X5 @ $true ) @ ( Y8 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_7642_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ? [N3: nat,F5: nat > A] :
          ( ( A2
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F5
            @ ( collect @ nat
              @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_7643_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A2: set @ A] :
      ( ( finite_finite @ A @ A2 )
     => ? [F5: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F5 @ A2 )
            = ( collect @ nat
              @ ^ [I2: nat] : ( ord_less @ nat @ I2 @ N3 ) ) )
          & ( inj_on @ A @ nat @ F5 @ A2 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_7644_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X2: nat] :
            ( ( member2 @ nat @ X2 @ I5 )
           => ( ord_less @ nat @ X2 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I5 ) ) ) ).

% inj_on_nth
thf(fact_7645_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ? [F5: nat > A] :
          ( ( inj_on @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ).

% infinite_countable_subset
thf(fact_7646_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ~ ( finite_finite @ A @ S2 ) )
      = ( ? [F3: nat > A] :
            ( ( inj_on @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_7647_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_7648_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ S )
        = S )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K3: nat] : ( compow @ ( A > A ) @ K3 @ F2 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_7649_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_7650_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_7651_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
         => ( ! [X2: nat] :
                ( ~ ( member2 @ nat @ X2 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X2 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_7652_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T9 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_7653_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C6: set @ A,B3: set @ A,X3: A] :
      ( ( inj_on @ A @ B @ G @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member2 @ ( B > A )
          @ ^ [I2: B] : ( if @ A @ ( member2 @ B @ I2 @ ( image @ A @ B @ G @ C6 ) ) @ ( the_inv_into @ A @ B @ C6 @ G @ I2 ) @ X3 )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_7654_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X4: B] : ( set2 @ A @ ( F2 @ X4 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_7655_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_7656_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X3: B,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X3 @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X3 ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) ).

% bind_simps(2)
thf(fact_7657_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ A,F2: A > ( list @ B ),G: A > ( list @ B )] :
      ( ( Xs = Ys2 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( ( F2 @ X2 )
              = ( G @ X2 ) ) )
       => ( ( bind @ A @ B @ Xs @ F2 )
          = ( bind @ A @ B @ Ys2 @ G ) ) ) ) ).

% list_bind_cong
thf(fact_7658_refl__ge__eq,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ! [X2: A] : ( R4 @ X2 @ X2 )
     => ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R4 ) ) ).

% refl_ge_eq
thf(fact_7659_ge__eq__refl,axiom,
    ! [A: $tType,R4: A > A > $o,X3: A] :
      ( ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R4 )
     => ( R4 @ X3 @ X3 ) ) ).

% ge_eq_refl
thf(fact_7660_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs2: list @ A,F3: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F3 @ Xs2 ) ) ) ) ).

% List.bind_def
thf(fact_7661_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A16: set @ B,B15: set @ A,F22: C > D,B23: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A16 )
        = B15 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F22 @ B23 ) @ A26 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B15 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A16 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_7662_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X3: A,N: int,S2: set @ A] :
          ( ( X3
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X4: A] : ( power_int @ A @ X4 @ N )
            @ ^ [Y: A] : ( times_times @ A @ Y @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ X3 @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X3 @ S2 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_7663_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_7664_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y5: A] :
          ( ( power_int @ A @ Y5 @ ( one_one @ int ) )
          = Y5 ) ) ).

% power_int_1_right
thf(fact_7665_power__int__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,N: int] :
          ( ( sgn_sgn @ A @ ( power_int @ A @ A3 @ N ) )
          = ( power_int @ A @ ( sgn_sgn @ A @ A3 ) @ N ) ) ) ).

% power_int_sgn
thf(fact_7666_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X3 @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_7667_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y5: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y5 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y5 @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_7668_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_7669_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( ( power_int @ A @ X3 @ N )
            = ( zero_zero @ A ) )
          = ( ( X3
              = ( zero_zero @ A ) )
            & ( N
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_7670_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X3: B] :
          ( ( power_int @ B @ X3 @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_7671_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N ) )
          = ( abs_abs @ A @ ( power_int @ A @ A3 @ N ) ) ) ) ).

% abs_power_int_minus
thf(fact_7672_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X3: A,N: nat] :
          ( ( power_int @ A @ X3 @ ( semiring_1_of_nat @ int @ N ) )
          = ( power_power @ A @ X3 @ N ) ) ) ).

% power_int_of_nat
thf(fact_7673_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: num,N: num] :
          ( ( power_int @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( power_int @ A @ X3 @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_7674_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_7675_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_7676_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X3: A,N: num] :
          ( ( power_int @ A @ X3 @ ( numeral_numeral @ int @ N ) )
          = ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% power_int_numeral
thf(fact_7677_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X3: num,N: int,Y5: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X3 ) @ N )
            = ( real_Vector_of_real @ A @ Y5 ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X3 ) @ N )
            = Y5 ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_7678_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y5: real,X3: num,N: int] :
          ( ( ( real_Vector_of_real @ A @ Y5 )
            = ( power_int @ A @ ( numeral_numeral @ A @ X3 ) @ N ) )
          = ( Y5
            = ( power_int @ real @ ( numeral_numeral @ real @ X3 ) @ N ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_7679_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y5: A] :
          ( ( power_int @ A @ Y5 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y5 ) ) ) ).

% power_int_minus1_right
thf(fact_7680_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X3 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_7681_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X3 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_7682_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_7683_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A3: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( power_int @ A @ A3 @ N ) ) ) ) ).

% power_int_minus_left_even
thf(fact_7684_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A3: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( uminus_uminus @ A @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_7685_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_7686_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% zero_le_power_int
thf(fact_7687_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A3: A] :
          ( ( ord_less_eq @ int @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ A3 @ N5 ) ) ) ) ) ).

% power_int_increasing
thf(fact_7688_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A3: A,S: set @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S ) @ F2 )
         => ( ( ( F2 @ A3 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A3 @ S )
              @ ^ [X4: A] : ( power_int @ B @ ( F2 @ X4 ) @ N ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_7689_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A3: A,F4: filter @ B,N: int] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A3 ) @ F4 )
         => ( ( A3
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( power_int @ A @ ( F2 @ X4 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A3 @ N ) )
              @ F4 ) ) ) ) ).

% tendsto_power_int
thf(fact_7690_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F2: A > B,N: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ S )
               => ( ( F2 @ X2 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X4: A] : ( power_int @ B @ ( F2 @ X4 ) @ N ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_7691_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_7692_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X3 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% zero_less_power_int
thf(fact_7693_power__int__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( power_int @ A @ X3 @ ( uminus_uminus @ int @ N ) )
          = ( inverse_inverse @ A @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_minus
thf(fact_7694_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X3 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_7695_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y5: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X3 @ Y5 ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ Y5 @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_7696_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: int,N: int] :
          ( ( power_int @ A @ X3 @ ( times_times @ int @ M @ N ) )
          = ( power_int @ A @ ( power_int @ A @ X3 @ M ) @ N ) ) ) ).

% power_int_mult
thf(fact_7697_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,Y5: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X3 @ Y5 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ Y5 @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_7698_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X3 @ N ) @ X3 )
          = ( times_times @ A @ X3 @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_commutes
thf(fact_7699_power__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ A3 @ N ) )
          = ( power_int @ A @ ( abs_abs @ A @ A3 ) @ N ) ) ) ).

% power_int_abs
thf(fact_7700_power__int__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( power_int @ A @ ( inverse_inverse @ A @ X3 ) @ N )
          = ( inverse_inverse @ A @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_inverse
thf(fact_7701_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X3 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_one_over
thf(fact_7702_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,M: int,N: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( M != N ) )
         => ( ( power_int @ A @ X3 @ ( minus_minus @ int @ M @ N ) )
            = ( divide_divide @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ X3 @ N ) ) ) ) ) ).

% power_int_diff
thf(fact_7703_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A3: A] :
          ( ( ord_less @ int @ N @ N5 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ A3 @ N5 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_7704_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X3: A,S: set @ A,N: int] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X4: A] : ( power_int @ B @ ( F2 @ X4 ) @ N )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% differentiable_power_int
thf(fact_7705_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X4: A] : ( power_int @ B @ ( F2 @ X4 ) @ N ) ) ) ) ) ).

% continuous_power_int
thf(fact_7706_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A3: A] :
          ( ( ord_less @ int @ N @ N5 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A3 @ N5 ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_7707_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,Y5: A,N: int] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
             => ( ord_less_eq @ A @ ( power_int @ A @ X3 @ N ) @ ( power_int @ A @ Y5 @ N ) ) ) ) ) ) ).

% power_int_mono
thf(fact_7708_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,N: int] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_7709_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X3 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X3 @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_7710_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_7711_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: int,N: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X3 @ ( plus_plus @ int @ M @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ X3 @ N ) ) ) ) ) ).

% power_int_add
thf(fact_7712_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X3: C,A3: A,N: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X3 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_7713_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,N: int] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ B2 @ N ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_7714_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_7715_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N5: int,A3: A] :
          ( ( ord_less_eq @ int @ N @ N5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
             => ( ( ( A3
                   != ( zero_zero @ A ) )
                  | ( N5
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N5 ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_7716_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X3 @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_7717_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X3 )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ X3 @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_7718_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X3 )
         => ( ( ord_less @ A @ ( power_int @ A @ X3 @ M ) @ ( power_int @ A @ X3 @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_7719_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X3: A,N: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X3 @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X3 )
            = ( power_int @ A @ X3 @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_7720_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A3: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
              = ( power_int @ A @ A3 @ N ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
              = ( uminus_uminus @ A @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_7721_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X3 @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X3 @ M ) @ X3 ) ) ) ) ).

% power_int_add_1
thf(fact_7722_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X3: A,M: int] :
          ( ( ( X3
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X3 @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X3 @ ( power_int @ A @ X3 @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_7723_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: A > B,A26: set @ A,A16: set @ B,F1: B > C,B15: set @ C,F22: D > A,B23: set @ D] :
      ( ( member2 @ ( A > B ) @ G @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A16 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A16 ) @ B15 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F22 @ B23 ) @ A26 )
         => ( member2 @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B23 @ F1 @ F22 @ G ) @ ( bNF_Wellorder_Func @ D @ C @ B23 @ B15 ) ) ) ) ) ).

% Func_map
thf(fact_7724_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X4: A,N2: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) @ ( power_power @ A @ X4 @ ( nat2 @ N2 ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X4 ) @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_7725_powr__real__of__int_H,axiom,
    ! [X3: real,N: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
     => ( ( ( X3
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N ) )
       => ( ( powr @ real @ X3 @ ( ring_1_of_int @ real @ N ) )
          = ( power_int @ real @ X3 @ N ) ) ) ) ).

% powr_real_of_int'
thf(fact_7726_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X3: A,S: set @ A,N: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X3 @ S ) )
         => ( ( ( F2 @ X3 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( power_int @ A @ ( F2 @ X4 ) @ N )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X3 ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X3 @ S ) ) ) ) ) ).

% DERIV_power_int
thf(fact_7727_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X3: C,F8: C > A,S2: set @ C,N: int] :
          ( ( ( F2 @ X3 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X3 @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X4: C] : ( power_int @ A @ ( F2 @ X4 ) @ N )
              @ ^ [H2: C] : ( times_times @ A @ ( F8 @ H2 ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X3 ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X3 @ S2 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_7728_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less @ A @ X3 @ Y5 )
         => ( ( topolo174197925503356063within @ A @ X3 @ ( set_ord_greaterThan @ A @ X3 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A5: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X3 @ A5 ) )
                @ ( set_ord_greaterThan @ A @ X3 ) ) ) ) ) ) ).

% at_right_eq
thf(fact_7729_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less @ A @ Y5 @ X3 )
         => ( ( topolo174197925503356063within @ A @ X3 @ ( set_ord_lessThan @ A @ X3 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A5: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A5 @ X3 ) )
                @ ( set_ord_lessThan @ A @ X3 ) ) ) ) ) ) ).

% at_left_eq
thf(fact_7730_principal__le__iff,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A2 ) @ ( principal @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ).

% principal_le_iff
thf(fact_7731_le__principal,axiom,
    ! [A: $tType,F4: filter @ A,A2: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( principal @ A @ A2 ) )
      = ( eventually @ A
        @ ^ [X4: A] : ( member2 @ A @ X4 @ A2 )
        @ F4 ) ) ).

% le_principal
thf(fact_7732_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I5: set @ A,F4: A > ( set @ B ),F2: B > C,G5: D > ( set @ C ),J5: set @ D] :
      ( ( I5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I3: A] :
            ( ( member2 @ A @ I3 @ I5 )
           => ! [J2: A] :
                ( ( member2 @ A @ J2 @ I5 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I3 ) @ ( F4 @ J2 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J2 ) @ ( F4 @ I3 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J4: D] : ( principal @ C @ ( G5 @ J4 ) )
                @ J5 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I2: A] : ( principal @ B @ ( F4 @ I2 ) )
                @ I5 ) ) )
          = ( ! [X4: D] :
                ( ( member2 @ D @ X4 @ J5 )
               => ? [Y: A] :
                    ( ( member2 @ A @ Y @ I5 )
                    & ! [Z3: B] :
                        ( ( member2 @ B @ Z3 @ ( F4 @ Y ) )
                       => ( member2 @ C @ ( F2 @ Z3 ) @ ( G5 @ X4 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_7733_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X4: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X4 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_7734_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X4: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X4 ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_7735_complete__uniform,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo2479028161051973599mplete @ A )
        = ( ^ [S6: set @ A] :
            ! [F9: filter @ A] :
              ( ( ord_less_eq @ ( filter @ A ) @ F9 @ ( principal @ A @ S6 ) )
             => ( ( F9
                 != ( bot_bot @ ( filter @ A ) ) )
               => ( ( topolo6773858410816713723filter @ A @ F9 )
                 => ? [X4: A] :
                      ( ( member2 @ A @ X4 @ S6 )
                      & ( ord_less_eq @ ( filter @ A ) @ F9 @ ( topolo7230453075368039082e_nhds @ A @ X4 ) ) ) ) ) ) ) ) ) ).

% complete_uniform
thf(fact_7736_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X4: A,Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ Y ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_7737_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X5: nat > A] :
            ! [P2: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P2 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N6: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ M3 )
                     => ( P2 @ ( product_Pair @ A @ A @ ( X5 @ N2 ) @ ( X5 @ M3 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_7738_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X4: complex,Y: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X4 @ Y ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_7739_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X4: real,Y: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X4 @ Y ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_7740_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X4: A,Y: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ Y ) @ E3 )
                   => ( P @ ( product_Pair @ A @ A @ X4 @ Y ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_7741_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_7742_nths__shift__lemma,axiom,
    ! [A: $tType,A2: set @ nat,Xs: list @ A,I: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member2 @ nat @ ( product_snd @ A @ nat @ P6 ) @ A2 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I @ ( plus_plus @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member2 @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P6 ) @ I ) @ A2 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7743_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_7744_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( zip @ A @ B @ Xs @ Ys2 )
        = ( nil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ B ) ) ) ) ).

% zip_eq_Nil_iff
thf(fact_7745_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( nil @ ( product_prod @ A @ B ) )
        = ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ B ) ) ) ) ).

% Nil_eq_zip_iff
thf(fact_7746_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys2 )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip_Nil
thf(fact_7747_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
        = Xs ) ) ).

% map_fst_zip
thf(fact_7748_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
        = Ys2 ) ) ).

% map_snd_zip
thf(fact_7749_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ A,Y5: B,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y5 @ Ys2 ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_Cons_Cons
thf(fact_7750_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Us: list @ B,Ys2: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys2 ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Us ) @ ( zip @ A @ B @ Ys2 @ Vs ) ) ) ) ).

% zip_append
thf(fact_7751_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys2 ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) @ I )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I ) @ ( nth @ B @ Ys2 @ I ) ) ) ) ) ).

% nth_zip
thf(fact_7752_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Xy2: product_prod @ A @ B,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs @ Ys2 )
        = ( cons @ ( product_prod @ A @ B ) @ Xy2 @ Xys ) )
     => ~ ! [X2: A,Xs4: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Xs4 ) )
           => ! [Y2: B,Ys5: list @ B] :
                ( ( Ys2
                  = ( cons @ B @ Y2 @ Ys5 ) )
               => ( ( Xy2
                    = ( product_Pair @ A @ B @ X2 @ Y2 ) )
                 => ( Xys
                   != ( zip @ A @ B @ Xs4 @ Ys5 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_7753_zip__same,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Xs ) ) )
      = ( ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) )
        & ( A3 = B2 ) ) ) ).

% zip_same
thf(fact_7754_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X3: A,Y5: B,Xs: list @ A,Ys2: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
     => ~ ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ~ ( member2 @ B @ Y5 @ ( set2 @ B @ Ys2 ) ) ) ) ).

% in_set_zipE
thf(fact_7755_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X3: A,Y5: B,Xs: list @ A,Ys2: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
     => ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% set_zip_leftD
thf(fact_7756_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X3: A,Y5: B,Xs: list @ A,Ys2: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
     => ( member2 @ B @ Y5 @ ( set2 @ B @ Ys2 ) ) ) ).

% set_zip_rightD
thf(fact_7757_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I: nat,X3: A,Ys2: list @ B,Y5: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs @ I @ X3 ) @ ( list_update @ B @ Ys2 @ I @ Y5 ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) @ I @ ( product_Pair @ A @ B @ X3 @ Y5 ) ) ) ).

% zip_update
thf(fact_7758_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X4: A] : ( product_Pair @ A @ A @ X4 @ X4 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_7759_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% distinct_zipI1
thf(fact_7760_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys2: list @ A,Xs: list @ B] :
      ( ( distinct @ A @ Ys2 )
     => ( distinct @ ( product_prod @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys2 ) ) ) ).

% distinct_zipI2
thf(fact_7761_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys2 ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ) ).

% zip_rev
thf(fact_7762_take__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( take @ ( product_prod @ A @ B ) @ N @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( zip @ A @ B @ ( take @ A @ N @ Xs ) @ ( take @ B @ N @ Ys2 ) ) ) ).

% take_zip
thf(fact_7763_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A] :
      ( ( zip @ A @ B @ Xs @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip.simps(1)
thf(fact_7764_drop__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys2: list @ B] :
      ( ( drop @ ( product_prod @ A @ B ) @ N @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( zip @ A @ B @ ( drop @ A @ N @ Xs ) @ ( drop @ B @ N @ Ys2 ) ) ) ).

% drop_zip
thf(fact_7765_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_7766_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys2
         != ( nil @ B ) )
       => ( ( hd @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
          = ( product_Pair @ A @ B @ ( hd @ A @ Xs ) @ ( hd @ B @ Ys2 ) ) ) ) ) ).

% hd_zip
thf(fact_7767_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list @ ( product_prod @ A @ B )] :
      ( ( zip @ A @ B @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs ) @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs ) )
      = Zs ) ).

% zip_map_fst_snd
thf(fact_7768_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B,I: nat,Xy2: product_prod @ A @ B] :
      ( ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) @ I @ Xy2 )
      = ( zip @ A @ B @ ( list_update @ A @ Xs @ I @ ( product_fst @ A @ B @ Xy2 ) ) @ ( list_update @ B @ Ys2 @ I @ ( product_snd @ A @ B @ Xy2 ) ) ) ) ).

% update_zip
thf(fact_7769_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs2: list @ A,Ys3: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X4: B,Y: A] : ( product_Pair @ A @ B @ Y @ X4 ) )
            @ ( zip @ B @ A @ Ys3 @ Xs2 ) ) ) ) ).

% zip_commute
thf(fact_7770_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys2 @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X4: A,Z3: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X4 @ ( product_Pair @ B @ C @ Y @ Z3 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys2 @ ( zip @ A @ C @ Xs @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_7771_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: A > $o,Xs: list @ A,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P @ Xs ) @ Ys2 )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_takeWhile_fst
thf(fact_7772_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,P: B > $o,Ys2: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( takeWhile @ B @ P @ Ys2 ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_takeWhile_snd
thf(fact_7773_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs: list @ C,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ Ys2 )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X4: C] : ( product_Pair @ A @ B @ ( F2 @ X4 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys2 ) ) ) ).

% zip_map1
thf(fact_7774_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F2: C > B,Ys2: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F2 @ Ys2 ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X4: A,Y: C] : ( product_Pair @ A @ B @ X4 @ ( F2 @ Y ) ) )
        @ ( zip @ A @ C @ Xs @ Ys2 ) ) ) ).

% zip_map2
thf(fact_7775_zip__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,F2: C > A,Xs: list @ C,G: D > B,Ys2: list @ D] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ ( map @ D @ B @ G @ Ys2 ) )
      = ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X4: C,Y: D] : ( product_Pair @ A @ B @ ( F2 @ X4 ) @ ( G @ Y ) ) )
        @ ( zip @ C @ D @ Xs @ Ys2 ) ) ) ).

% zip_map_map
thf(fact_7776_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H: B > C > A,F2: D > B,Xs: list @ D,G: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs ) @ ( map @ D @ C @ G @ Xs ) ) )
      = ( map @ D @ A
        @ ^ [X4: D] : ( H @ ( F2 @ X4 ) @ ( G @ X4 ) )
        @ Xs ) ) ).

% map2_map_map
thf(fact_7777_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,X3: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
       => ~ ! [Y2: B] :
              ~ ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_7778_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Y5: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( member2 @ B @ Y5 @ ( set2 @ B @ Ys2 ) )
       => ~ ! [X2: A] :
              ~ ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_7779_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) )
     => ( ( ( zip @ A @ B @ Xs @ Ys2 )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys2 ) ) ) ) ).

% zip_eq_conv
thf(fact_7780_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_7781_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N: nat,X3: A,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( replicate @ A @ N @ X3 ) @ Ys2 )
      = ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ ( take @ B @ N @ Ys2 ) ) ) ).

% zip_replicate1
thf(fact_7782_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_7783_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs: list @ B,G: D > C,Ys2: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G @ Ys2 ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X4: B,Y: D] : ( F2 @ ( product_Pair @ B @ C @ X4 @ ( G @ Y ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys2 ) ) ) ).

% map_zip_map2
thf(fact_7784_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G: D > B,Xs: list @ D,Ys2: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G @ Xs ) @ Ys2 ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X4: D,Y: C] : ( F2 @ ( product_Pair @ B @ C @ ( G @ X4 ) @ Y ) ) )
        @ ( zip @ D @ C @ Xs @ Ys2 ) ) ) ).

% map_zip_map
thf(fact_7785_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N: nat,Y5: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N @ Y5 ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X4: A] : ( product_Pair @ A @ B @ X4 @ Y5 )
        @ ( take @ A @ N @ Xs ) ) ) ).

% zip_replicate2
thf(fact_7786_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X3: A,Xs: list @ A,Ys2: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X3 @ Xs ) @ Ys2 )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y: B,Ys3: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ ( zip @ A @ B @ Xs @ Ys3 ) )
        @ Ys2 ) ) ).

% zip_Cons1
thf(fact_7787_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y5: B,Ys2: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y5 @ Ys2 ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z3: A,Zs3: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z3 @ Y5 ) @ ( zip @ A @ B @ Zs3 @ Ys2 ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_7788_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_7789_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ B] :
      ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys2 ) @ Zs )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ ( take @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) @ ( zip @ A @ B @ Ys2 @ ( drop @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% zip_append1
thf(fact_7790_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( append @ B @ Ys2 @ Zs ) )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys2 ) @ Xs ) @ Ys2 ) @ ( zip @ A @ B @ ( drop @ A @ ( size_size @ ( list @ B ) @ Ys2 ) @ Xs ) @ Zs ) ) ) ).

% zip_append2
thf(fact_7791_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_7792_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_7793_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P6 ) ) )
          @ ( zip @ A @ nat @ Xs @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P6 ) )
          @ ( zip @ A @ nat @ Xs @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7794_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P3: product_prod @ A @ B,Xs: list @ A,Ys2: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ P3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
      = ( ? [N2: nat] :
            ( ( ( nth @ A @ Xs @ N2 )
              = ( product_fst @ A @ B @ P3 ) )
            & ( ( nth @ B @ Ys2 @ N2 )
              = ( product_snd @ A @ B @ P3 ) )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ).

% in_set_zip
thf(fact_7795_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs2: list @ A,A4: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P6: product_prod @ A @ nat] : ( member2 @ nat @ ( product_snd @ A @ nat @ P6 ) @ A4 )
              @ ( zip @ A @ nat @ Xs2 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7796_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X3 @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_7797_nths__nil,axiom,
    ! [A: $tType,A2: set @ nat] :
      ( ( nths @ A @ ( nil @ A ) @ A2 )
      = ( nil @ A ) ) ).

% nths_nil
thf(fact_7798_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_7799_nths__upt__eq__take,axiom,
    ! [A: $tType,L: list @ A,N: nat] :
      ( ( nths @ A @ L @ ( set_ord_lessThan @ nat @ N ) )
      = ( take @ A @ N @ L ) ) ).

% nths_upt_eq_take
thf(fact_7800_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_7801_nths__singleton,axiom,
    ! [A: $tType,A2: set @ nat,X3: A] :
      ( ( ( member2 @ nat @ ( zero_zero @ nat ) @ A2 )
       => ( ( nths @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ A2 )
          = ( cons @ A @ X3 @ ( nil @ A ) ) ) )
      & ( ~ ( member2 @ nat @ ( zero_zero @ nat ) @ A2 )
       => ( ( nths @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ A2 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_7802_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,I5: set @ nat] :
      ( ( nths @ A @ ( map @ B @ A @ F2 @ Xs ) @ I5 )
      = ( map @ B @ A @ F2 @ ( nths @ B @ Xs @ I5 ) ) ) ).

% nths_map
thf(fact_7803_inj__split__Cons,axiom,
    ! [A: $tType,X9: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs2: list @ A,N2: A] : ( cons @ A @ N2 @ Xs2 ) )
      @ X9 ) ).

% inj_split_Cons
thf(fact_7804_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N2: nat,Xs2: list @ A] : ( nths @ A @ Xs2 @ ( collect @ nat @ ( ord_less_eq @ nat @ N2 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_7805_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I5: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs @ I5 ) ) ) ) ).

% sorted_nths
thf(fact_7806_set__nths__subset,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs @ I5 ) ) @ ( set2 @ A @ Xs ) ) ).

% set_nths_subset
thf(fact_7807_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num,Y5: num] :
          ( ( ( numeral_numeral @ A @ X3 )
            = ( numeral_numeral @ A @ Y5 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X3 @ Y5 ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_7808_nths__all,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( member2 @ nat @ I3 @ I5 ) )
     => ( ( nths @ A @ Xs @ I5 )
        = Xs ) ) ).

% nths_all
thf(fact_7809_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X4: A,Y: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X4 @ Y ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_7810_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_7811_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z3: A] :
              ( Z3
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_7812_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_7813_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_7814_notin__set__nthsI,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,I5: set @ nat] :
      ( ~ ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
     => ~ ( member2 @ A @ X3 @ ( set2 @ A @ ( nths @ A @ Xs @ I5 ) ) ) ) ).

% notin_set_nthsI
thf(fact_7815_in__set__nthsD,axiom,
    ! [A: $tType,X3: A,Xs: list @ A,I5: set @ nat] :
      ( ( member2 @ A @ X3 @ ( set2 @ A @ ( nths @ A @ Xs @ I5 ) ) )
     => ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) ) ) ).

% in_set_nthsD
thf(fact_7816_distinct__nthsI,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( nths @ A @ Xs @ I5 ) ) ) ).

% distinct_nthsI
thf(fact_7817_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_7818_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_7819_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num] :
          ( ( ( numeral_numeral @ A @ X3 )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X3 ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_7820_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y5: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y5 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y5 ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_7821_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys2: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys2 @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X4: A,Y: B,Z3: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X4 @ ( product_Pair @ B @ C @ Y @ Z3 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys2 ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_7822_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X3 ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_7823_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y5: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y5 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y5 ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_7824_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N2: nat,Xs2: list @ A] : ( zip @ nat @ A @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) @ Xs2 ) ) ) ).

% enumerate_eq_zip
thf(fact_7825_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_7826_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I5: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N @ Xs ) @ I5 )
      = ( nths @ A @ Xs @ ( image @ nat @ nat @ ( plus_plus @ nat @ N ) @ I5 ) ) ) ).

% nths_drop
thf(fact_7827_nths__append,axiom,
    ! [A: $tType,L: list @ A,L4: list @ A,A2: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L4 ) @ A2 )
      = ( append @ A @ ( nths @ A @ L @ A2 )
        @ ( nths @ A @ L4
          @ ( collect @ nat
            @ ^ [J4: nat] : ( member2 @ nat @ ( plus_plus @ nat @ J4 @ ( size_size @ ( list @ A ) @ L ) ) @ A2 ) ) ) ) ) ).

% nths_append
thf(fact_7828_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num,Y5: num] :
          ( ( ( numeral_numeral @ A @ X3 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y5 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X3 @ Y5 ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_7829_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num,Y5: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) )
            = ( numeral_numeral @ A @ Y5 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X3 @ Y5 ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_7830_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num,Y5: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X3 ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y5 ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y5 @ X3 ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_7831_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P6: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P6 ) ) ) ) ).

% rat_floor_code
thf(fact_7832_filter__in__nths,axiom,
    ! [A: $tType,Xs: list @ A,S: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ( filter2 @ A
          @ ^ [X4: A] : ( member2 @ A @ X4 @ ( set2 @ A @ ( nths @ A @ Xs @ S ) ) )
          @ Xs )
        = ( nths @ A @ Xs @ S ) ) ) ).

% filter_in_nths
thf(fact_7833_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I5 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member2 @ nat @ I2 @ I5 ) ) ) ) ) ).

% length_nths
thf(fact_7834_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_7835_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P2: A > $o,Xs2: list @ A] :
            ( nths @ A @ Xs2
            @ ( collect @ nat
              @ ^ [I2: nat] :
                  ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                  & ( P2 @ ( nth @ A @ Xs2 @ I2 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_7836_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X3: num] :
          ( ( ( numeral_numeral @ A @ X3 )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X3 @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_7837_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y5: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y5 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y5 ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_7838_nths__Cons,axiom,
    ! [A: $tType,X3: A,L: list @ A,A2: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X3 @ L ) @ A2 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member2 @ nat @ ( zero_zero @ nat ) @ A2 ) @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J4: nat] : ( member2 @ nat @ ( suc @ J4 ) @ A2 ) ) ) ) ) ).

% nths_Cons
thf(fact_7839_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y5: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y5 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y5 ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_7840_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K3 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L3: code_integer,J4: code_integer] :
                ( if @ num
                @ ( J4
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L3 ) @ ( code_num_of_integer @ L3 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L3 ) @ ( code_num_of_integer @ L3 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_7841_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X3: A,Xs: list @ A] :
      ( ( ( P @ X3 )
       => ( ( extract @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X3 @ Xs ) ) ) ) )
      & ( ~ ( P @ X3 )
       => ( ( extract @ A @ P @ ( cons @ A @ X3 @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X3 @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_7842_lists__length__Suc__eq,axiom,
    ! [A: $tType,A2: set @ A,N: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs2: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 )
            & ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( suc @ N ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs2: list @ A,N2: A] : ( cons @ A @ N2 @ Xs2 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs2: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A2 )
                & ( ( size_size @ ( list @ A ) @ Xs2 )
                  = N ) ) )
          @ ^ [Uu3: list @ A] : A2 ) ) ) ).

% lists_length_Suc_eq
thf(fact_7843_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,P3: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member2 @ B @ X4 @ I5 )
                  & ( ( P3 @ X4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member2 @ B @ I @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P3 @ ( insert2 @ B @ I @ I5 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P3 @ I5 ) ) )
            & ( ~ ( member2 @ B @ I @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P3 @ ( insert2 @ B @ I @ I5 ) )
                = ( times_times @ A @ ( P3 @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ P3 @ I5 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_7844_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys2 ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu3: A] : ( set2 @ B @ Ys2 ) ) ) ).

% set_product
thf(fact_7845_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A2: B > ( set @ A ),I5: set @ B] :
    ? [F5: A > ( product_prod @ B @ A )] :
      ( ( inj_on @ A @ ( product_prod @ B @ A ) @ F5 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A2 @ I5 ) ) )
      & ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) ) @ ( image @ A @ ( product_prod @ B @ A ) @ F5 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A2 @ I5 ) ) ) @ ( product_Sigma @ B @ A @ I5 @ A2 ) ) ) ).

% Ex_inj_on_UNION_Sigma
thf(fact_7846_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,C6: set @ B,B3: set @ A,D4: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu3: A] : C6 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu3: A] : D4 ) )
      = ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ( C6
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
          & ( ord_less_eq @ ( set @ B ) @ C6 @ D4 ) ) ) ) ).

% times_subset_iff
thf(fact_7847_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,C6: set @ A,B3: A > ( set @ B ),D4: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C6 )
     => ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ A2 )
           => ( ord_less_eq @ ( set @ B ) @ ( B3 @ X2 ) @ ( D4 @ X2 ) ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ A2 @ B3 ) @ ( product_Sigma @ A @ B @ C6 @ D4 ) ) ) ) ).

% Sigma_mono
thf(fact_7848_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X3: A,C6: set @ A,A2: set @ B,B3: set @ B] :
      ( ( member2 @ A @ X3 @ C6 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
          @ ( product_Sigma @ B @ A @ A2
            @ ^ [Uu3: B] : C6 )
          @ ( product_Sigma @ B @ A @ B3
            @ ^ [Uu3: B] : C6 ) )
        = ( ord_less_eq @ ( set @ B ) @ A2 @ B3 ) ) ) ).

% Times_subset_cancel2
thf(fact_7849_relcomp__subset__Sigma,axiom,
    ! [B: $tType,C: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),A2: set @ A,B3: set @ B,S: set @ ( product_prod @ B @ C ),C6: set @ C] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu3: A] : B3 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S
          @ ( product_Sigma @ B @ C @ B3
            @ ^ [Uu3: B] : C6 ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R2 @ S )
          @ ( product_Sigma @ A @ C @ A2
            @ ^ [Uu3: A] : C6 ) ) ) ) ).

% relcomp_subset_Sigma
thf(fact_7850_open__prod__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ ( product_prod @ A @ B )] :
          ( ! [X2: product_prod @ A @ B] :
              ( ( member2 @ ( product_prod @ A @ B ) @ X2 @ S2 )
             => ? [A17: set @ A,B10: set @ B] :
                  ( ( topolo1002775350975398744n_open @ A @ A17 )
                  & ( topolo1002775350975398744n_open @ B @ B10 )
                  & ( member2 @ ( product_prod @ A @ B ) @ X2
                    @ ( product_Sigma @ A @ B @ A17
                      @ ^ [Uu3: A] : B10 ) )
                  & ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                    @ ( product_Sigma @ A @ B @ A17
                      @ ^ [Uu3: A] : B10 )
                    @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) @ S2 ) ) ) ).

% open_prod_intro
thf(fact_7851_open__prod__elim,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ ( product_prod @ A @ B ),X3: product_prod @ A @ B] :
          ( ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) @ S2 )
         => ( ( member2 @ ( product_prod @ A @ B ) @ X3 @ S2 )
           => ~ ! [A8: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A8 )
                 => ! [B9: set @ B] :
                      ( ( topolo1002775350975398744n_open @ B @ B9 )
                     => ( ( member2 @ ( product_prod @ A @ B ) @ X3
                          @ ( product_Sigma @ A @ B @ A8
                            @ ^ [Uu3: A] : B9 ) )
                       => ~ ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                            @ ( product_Sigma @ A @ B @ A8
                              @ ^ [Uu3: A] : B9 )
                            @ S2 ) ) ) ) ) ) ) ).

% open_prod_elim
thf(fact_7852_open__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ( ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) )
        = ( ^ [S6: set @ ( product_prod @ A @ B )] :
            ! [X4: product_prod @ A @ B] :
              ( ( member2 @ ( product_prod @ A @ B ) @ X4 @ S6 )
             => ? [A4: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A4 )
                  & ? [B8: set @ B] :
                      ( ( topolo1002775350975398744n_open @ B @ B8 )
                      & ( member2 @ ( product_prod @ A @ B ) @ X4
                        @ ( product_Sigma @ A @ B @ A4
                          @ ^ [Uu3: A] : B8 ) )
                      & ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                        @ ( product_Sigma @ A @ B @ A4
                          @ ^ [Uu3: A] : B8 )
                        @ S6 ) ) ) ) ) ) ) ).

% open_prod_def
thf(fact_7853_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,B3: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu3: A] : B3 ) )
      = ( times_times @ nat @ ( finite_card @ A @ A2 ) @ ( finite_card @ B @ B3 ) ) ) ).

% card_cartesian_product
thf(fact_7854_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I2: B] : ( times_times @ A @ ( G @ I2 ) @ ( H @ I2 ) )
              @ I5 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H @ I5 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_7855_Restr__subset,axiom,
    ! [A: $tType,A2: set @ A,B3: set @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
            @ ( product_Sigma @ A @ A @ B3
              @ ^ [Uu3: A] : B3 ) )
          @ ( product_Sigma @ A @ A @ A2
            @ ^ [Uu3: A] : A2 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
          @ ( product_Sigma @ A @ A @ A2
            @ ^ [Uu3: A] : A2 ) ) ) ) ).

% Restr_subset
thf(fact_7856_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X2 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T6 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_7857_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X2 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_7858_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,H: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H @ I3 )
                  = ( one_one @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ S2 )
                 => ( ( G @ X2 )
                    = ( H @ X2 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_7859_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G: B > A,H: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X2: B] :
                ( ( member2 @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G @ X2 )
                  = ( one_one @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member2 @ B @ X2 @ S2 )
                 => ( ( G @ X2 )
                    = ( H @ X2 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
                = ( groups1962203154675924110t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_7860_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member2 @ B @ X4 @ I5 )
                  & ( ( G @ X4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X4: B] :
                    ( ( member2 @ B @ X4 @ I5 )
                    & ( ( H @ X4 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I2: B] : ( times_times @ A @ ( G @ I2 ) @ ( H @ I2 ) )
                @ I5 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H @ I5 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_7861_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ B,S2: set @ ( product_prod @ A @ B ),Y5: B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu3: A] : B3 )
        @ S2 )
     => ( ( member2 @ B @ Y5 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 ) ) ) ) ).

% subset_fst_imageI
thf(fact_7862_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A2: set @ A,B3: set @ B,S2: set @ ( product_prod @ A @ B ),X3: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu3: A] : B3 )
        @ S2 )
     => ( ( member2 @ A @ X3 @ A2 )
       => ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ S2 ) ) ) ) ).

% subset_snd_imageI
thf(fact_7863_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A2: set @ ( product_prod @ A @ B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A2
      @ ( product_Sigma @ A @ B @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A2 )
        @ ^ [Uu3: A] : ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A2 ) ) ) ).

% subset_fst_snd
thf(fact_7864_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A2: set @ A,F2: A > B,B3: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( bNF_Gr @ A @ B @ A2 @ F2 )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu3: A] : B3 ) )
      = ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A2 ) @ B3 ) ) ).

% Gr_incl
thf(fact_7865_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y5: $o] :
      ( ( ( vEBT_VEBT_valid @ X3 @ Xa )
        = Y5 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X3
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y5
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X3
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( Y5
                = ( ~ ( ( Deg2 = Xa )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X5 )
                          & ! [X4: vEBT_VEBT] :
                              ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I2: nat] :
                                  ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X5 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                              & ( ( Mi2 = Ma3 )
                               => ! [X4: vEBT_VEBT] :
                                    ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                              & ( ( Mi2 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X4: nat] :
                                      ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                       => ( ( ord_less @ nat @ Mi2 @ X4 )
                                          & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_7866_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y ) )
              & ( ord_less_eq @ A @ X4 @ Y ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_7867_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y ) )
              & ( ord_less_eq @ A @ Y @ X4 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_7868_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y ) )
              & ( ord_less @ A @ X4 @ Y ) ) ) ) ) ).

% open_subdiagonal
thf(fact_7869_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y ) )
              & ( ord_less @ A @ Y @ X4 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_7870_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A4: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z3: list @ A] :
              ? [X4: A,Xs2: list @ A] :
                ( ( Z3
                  = ( cons @ A @ X4 @ Xs2 ) )
                & ( member2 @ A @ X4 @ A4 )
                & ( member2 @ ( list @ A ) @ Xs2 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_7871_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X3 @ Xa )
     => ~ ! [X2: A,Ys4: list @ A] :
            ( ( Xa
              = ( cons @ A @ X2 @ Ys4 ) )
           => ( ! [Xa2: A] :
                  ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
                 => ( X3 @ X2 @ Xa2 ) )
              & ( sorted_wrt @ A @ X3 @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_7872_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > A > $o,X3: A,Ys2: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( cons @ A @ X3 @ Ys2 ) )
      = ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Ys2 ) )
           => ( P @ X3 @ X4 ) )
        & ( sorted_wrt @ A @ P @ Ys2 ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_7873_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A4: set @ A,P2: A > $o] :
          ! [X4: A] :
            ( ( member2 @ A @ X4 @ A4 )
           => ( P2 @ X4 ) ) ) ) ).

% Ball_def_raw
thf(fact_7874_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X16: list @ A,X24: list @ A] :
            ( ? [Y: A,Ys3: list @ A] :
                ( ( X16
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) ) )
            | ? [X4: A,Y: A,Xs2: list @ A,Ys3: list @ A] :
                ( ( X16
                  = ( cons @ A @ X4 @ Xs2 ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) )
                & ( ord_less @ A @ X4 @ Y ) )
            | ? [X4: A,Y: A,Xs2: list @ A,Ys3: list @ A] :
                ( ( X16
                  = ( cons @ A @ X4 @ Xs2 ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) )
                & ~ ( ord_less @ A @ X4 @ Y )
                & ~ ( ord_less @ A @ Y @ X4 )
                & ( P6 @ Xs2 @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_7875_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X16: list @ A,X24: list @ A] :
          ( ? [Y: A,Ys3: list @ A] :
              ( ( X16
                = ( nil @ A ) )
              & ( X24
                = ( cons @ A @ Y @ Ys3 ) ) )
          | ? [X4: A,Y: A,Xs2: list @ A,Ys3: list @ A] :
              ( ( X16
                = ( cons @ A @ X4 @ Xs2 ) )
              & ( X24
                = ( cons @ A @ Y @ Ys3 ) )
              & ( Less @ X4 @ Y ) )
          | ? [X4: A,Y: A,Xs2: list @ A,Ys3: list @ A] :
              ( ( X16
                = ( cons @ A @ X4 @ Xs2 ) )
              & ( X24
                = ( cons @ A @ Y @ Ys3 ) )
              & ~ ( Less @ X4 @ Y )
              & ~ ( Less @ Y @ X4 )
              & ( P6 @ Xs2 @ Ys3 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_7876_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A4: set @ A,P2: A > $o] : ( ord_less_eq @ ( set @ A ) @ A4 @ ( collect @ A @ P2 ) ) ) ) ).

% Ball_Collect
thf(fact_7877_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A4: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X4: A] :
                    ( ( member2 @ A @ X4 @ A4 )
                   => ( ord_less_eq @ A @ B4 @ X4 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_7878_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A4: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X4: A] :
                    ( ( member2 @ A @ X4 @ A4 )
                   => ( ord_less_eq @ A @ X4 @ B4 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_7879_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys3: list @ A] :
                ? [Us2: list @ A,Z3: A,Z7: A,Vs2: list @ A] :
                  ( ( Xs2
                    = ( append @ A @ Us2 @ ( cons @ A @ Z3 @ Vs2 ) ) )
                  & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Z7 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z7 @ Vs2 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_7880_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys2: list @ A,X4: A,Y: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs2
                        = ( append @ A @ Xys2 @ ( cons @ A @ X4 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y @ Ys7 ) ) )
                      & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_7881_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys2 ) ) ) )
      & ( ~ ! [X: A] :
              ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
             => ( P @ X ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_7882_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys2: list @ A] :
      ( ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( dropWhile @ A @ P @ Ys2 ) ) )
      & ( ~ ! [X: A] :
              ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
             => ( P @ X ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys2 ) ) ) ) ).

% dropWhile_append
thf(fact_7883_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X3 @ Xa )
     => ( ( Xa
         != ( nil @ A ) )
       => ~ ! [X2: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys4 ) )
             => ~ ( ! [Xa3: A] :
                      ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                     => ( X3 @ X2 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X3 @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_7884_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A,Y5: $o] :
      ( ( ( sorted_wrt @ A @ X3 @ Xa )
        = Y5 )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ~ Y5 )
       => ~ ! [X2: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys4 ) )
             => ( Y5
                = ( ~ ( ! [Y: A] :
                          ( ( member2 @ A @ Y @ ( set2 @ A @ Ys4 ) )
                         => ( X3 @ X2 @ Y ) )
                      & ( sorted_wrt @ A @ X3 @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_7885_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs2: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I2: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs2 @ I2 ) )
                & ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_7886_pairs__le__eq__Sigma,axiom,
    ! [M: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I2: nat,J4: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ J4 ) @ M ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_7887_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I5 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I2: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs @ I2 ) )
            & ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member2 @ nat @ I2 @ I5 ) ) ) ) ).

% set_nths
thf(fact_7888_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList2 @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X4: vEBT_VEBT] :
            ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X5 )
            & ! [X4: vEBT_VEBT] :
                ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi2: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ X5 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
                & ( ( Mi2 = Ma3 )
                 => ! [X4: vEBT_VEBT] :
                      ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                & ( ( Mi2 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                    & ! [X4: nat] :
                        ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X4 )
                         => ( ( ord_less @ nat @ Mi2 @ X4 )
                            & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_7889_funpow__inj__finite,axiom,
    ! [A: $tType,P3: A > A,X3: A] :
      ( ( inj_on @ A @ A @ P3 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y: A] :
              ? [N2: nat] :
                ( Y
                = ( compow @ ( A > A ) @ N2 @ P3 @ X3 ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P3 @ X3 )
               != X3 ) ) ) ) ).

% funpow_inj_finite
thf(fact_7890_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X3 @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X3
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X3
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( Deg2 = Xa )
                & ! [X2: vEBT_VEBT] :
                    ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X5 )
                    & ! [X4: vEBT_VEBT] :
                        ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi2: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I2: nat] :
                            ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X5 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                        & ( ( Mi2 = Ma3 )
                         => ! [X4: vEBT_VEBT] :
                              ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                        & ( ( Mi2 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                            & ! [X4: nat] :
                                ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                 => ( ( ord_less @ nat @ Mi2 @ X4 )
                                    & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_7891_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X3 @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X3
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X3
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X: vEBT_VEBT] :
                      ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X5 )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi2: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X5 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                          & ( ( Mi2 = Ma3 )
                           => ! [X4: vEBT_VEBT] :
                                ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                          & ( ( Mi2 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                              & ! [X4: nat] :
                                  ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                   => ( ( ord_less @ nat @ Mi2 @ X4 )
                                      & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_7892_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat,Y5: $o] :
      ( ( ( vEBT_VEBT_valid @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X3
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y5
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( Y5
                    = ( ( Deg2 = Xa )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X5 )
                          & ! [X4: vEBT_VEBT] :
                              ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I2: nat] :
                                  ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X5 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                              & ( ( Mi2 = Ma3 )
                               => ! [X4: vEBT_VEBT] :
                                    ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                              & ( ( Mi2 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X4: nat] :
                                      ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                       => ( ( ord_less @ nat @ Mi2 @ X4 )
                                          & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_7893_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X3
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa ) )
                 => ~ ( ( Deg2 = Xa )
                      & ! [X: vEBT_VEBT] :
                          ( ( member2 @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X5 )
                          & ! [X4: vEBT_VEBT] :
                              ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I2: nat] :
                                  ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X5 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                              & ( ( Mi2 = Ma3 )
                               => ! [X4: vEBT_VEBT] :
                                    ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                              & ( ( Mi2 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X4: nat] :
                                      ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                       => ( ( ord_less @ nat @ Mi2 @ X4 )
                                          & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_7894_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A2 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A2 ) )
                    & ! [X4: set @ A] :
                        ( ( member2 @ ( set @ A ) @ X4 @ A2 )
                       => ( member2 @ A @ ( F3 @ X4 ) @ X4 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_7895_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A2: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A2 ) )
                    & ! [X4: set @ A] :
                        ( ( member2 @ ( set @ A ) @ X4 @ A2 )
                       => ( member2 @ A @ ( F3 @ X4 ) @ X4 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A2 ) ) ) ) ).

% Sup_Inf_le
thf(fact_7896_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X5: set @ int] :
          ( the @ int
          @ ^ [X4: int] :
              ( ( member2 @ int @ X4 @ X5 )
              & ! [Y: int] :
                  ( ( member2 @ int @ Y @ X5 )
                 => ( ord_less_eq @ int @ Y @ X4 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_7897_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S6: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F9: filter @ A] :
                ! [X4: filter @ A] :
                  ( ( member2 @ ( filter @ A ) @ X4 @ S6 )
                 => ( ord_less_eq @ ( filter @ A ) @ F9 @ X4 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_7898_Union__maximal__sets,axiom,
    ! [A: $tType,F17: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ F17 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T9: set @ A] :
                ( ( member2 @ ( set @ A ) @ T9 @ F17 )
                & ! [X4: set @ A] :
                    ( ( member2 @ ( set @ A ) @ X4 @ F17 )
                   => ~ ( ord_less @ ( set @ A ) @ T9 @ X4 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F17 ) ) ) ).

% Union_maximal_sets
thf(fact_7899_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu3: A] :
            ? [N2: int] :
              ( ( Uu3
                = ( ring_1_of_int @ A @ N2 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_7900_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z: list @ A] : ( Y3 = Z ) )
      = ( ^ [Xs2: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs2 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [X4: product_prod @ A @ A] :
                ( ( member2 @ ( product_prod @ A @ A ) @ X4 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs2 @ Ys3 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y3: A,Z: A] : ( Y3 = Z )
                  @ X4 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_7901_concat__injective,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys2: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs )
        = ( concat @ A @ Ys2 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys2 ) )
       => ( ! [X2: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X2 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y: list @ A,Z3: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y )
                    = ( size_size @ ( list @ A ) @ Z3 ) )
                @ X2 ) )
         => ( Xs = Ys2 ) ) ) ) ).

% concat_injective
thf(fact_7902_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys2: list @ ( list @ A )] :
      ( ! [X2: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X2 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y: list @ A,Z3: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y )
                = ( size_size @ ( list @ A ) @ Z3 ) )
            @ X2 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys2 ) )
       => ( ( ( concat @ A @ Xs )
            = ( concat @ A @ Ys2 ) )
          = ( Xs = Ys2 ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_7903_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X3: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X3 @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X3
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X3
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa ) )
                 => ( ( Deg2 = Xa )
                    & ! [X2: vEBT_VEBT] :
                        ( ( member2 @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X5 )
                        & ! [X4: vEBT_VEBT] :
                            ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi2: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi2 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I2: nat] :
                                ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I2 ) @ X5 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
                            & ( ( Mi2 = Ma3 )
                             => ! [X4: vEBT_VEBT] :
                                  ( ( member2 @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X5: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X5 ) ) )
                            & ( ( Mi2 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                & ! [X4: nat] :
                                    ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                     => ( ( ord_less @ nat @ Mi2 @ X4 )
                                        & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_7904_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A2: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A2 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A2 ) )
                    & ! [X4: set @ A] :
                        ( ( member2 @ ( set @ A ) @ X4 @ A2 )
                       => ( member2 @ A @ ( F3 @ X4 ) @ X4 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_7905_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N2: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs2: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = N2 )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N2 )
                  & ? [Xys2: list @ A,X4: A,Y: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs2
                        = ( append @ A @ Xys2 @ ( cons @ A @ X4 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y @ Ys7 ) ) )
                      & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_7906_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R2 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_7907_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lexn @ A @ R2 @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys2 )
          = N ) ) ) ).

% lexn_length
thf(fact_7908_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_7909_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A,Y5: $o] :
      ( ( ( sorted_wrt @ A @ X3 @ Xa )
        = Y5 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y5
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) ) ) )
         => ~ ! [X2: A,Ys4: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ Ys4 ) )
               => ( ( Y5
                    = ( ! [Y: A] :
                          ( ( member2 @ A @ Y @ ( set2 @ A @ Ys4 ) )
                         => ( X3 @ X2 @ Y ) )
                      & ( sorted_wrt @ A @ X3 @ Ys4 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ ( cons @ A @ X2 @ Ys4 ) ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
thf(fact_7910_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) ) )
         => ~ ! [X2: A,Ys4: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ Ys4 ) )
               => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ ( cons @ A @ X2 @ Ys4 ) ) )
                 => ~ ( ! [Xa3: A] :
                          ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                         => ( X3 @ X2 @ Xa3 ) )
                      & ( sorted_wrt @ A @ X3 @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
thf(fact_7911_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X3: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X3 @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ Xa ) )
       => ~ ! [X2: A,Ys4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys4 ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X3 @ ( cons @ A @ X2 @ Ys4 ) ) )
               => ( ! [Xa2: A] :
                      ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Ys4 ) )
                     => ( X3 @ X2 @ Xa2 ) )
                  & ( sorted_wrt @ A @ X3 @ Ys4 ) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
thf(fact_7912_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X4: A,Y: A] :
                  ( ( ord_less @ nat @ ( F3 @ X4 ) @ ( F3 @ Y ) )
                  | ( ( ord_less_eq @ nat @ ( F3 @ X4 ) @ ( F3 @ Y ) )
                    & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_7913_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys2 ) )
        & ! [X4: product_prod @ A @ B] :
            ( ( member2 @ ( product_prod @ A @ B ) @ X4 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y: A,Z3: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Z3 ) @ R2 )
              @ X4 ) ) ) ) ).

% listrel_iff_zip
thf(fact_7914_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% listrel_eq_len
thf(fact_7915_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R2 ) )
     => ( Xs
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_7916_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R2 ) )
     => ( Xs
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_7917_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B )] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R2 ) ) ).

% listrel.Nil
thf(fact_7918_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R2 ) @ ( listrel @ A @ B @ S ) ) ) ).

% listrel_mono
thf(fact_7919_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X3: A,Y5: B,R2: set @ ( product_prod @ A @ B ),Xs: list @ A,Ys2: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) @ R2 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y5 @ Ys2 ) ) @ ( listrel @ A @ B @ R2 ) ) ) ) ).

% listrel.Cons
thf(fact_7920_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y5: A,Ys2: list @ A,Xs: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y5 @ Ys2 ) @ Xs ) @ ( listrel @ A @ B @ R2 ) )
     => ~ ! [Y2: B,Ys4: list @ B] :
            ( ( Xs
              = ( cons @ B @ Y2 @ Ys4 ) )
           => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y5 @ Y2 ) @ R2 )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys2 @ Ys4 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ).

% listrel_Cons1
thf(fact_7921_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y5: B,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y5 @ Ys2 ) ) @ ( listrel @ A @ B @ R2 ) )
     => ~ ! [X2: A,Xs3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Xs3 ) )
           => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ R2 )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys2 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ).

% listrel_Cons2
thf(fact_7922_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X3: A,Y5: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
     => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( mlex_prod @ A @ F2 @ R4 ) ) ) ).

% mlex_less
thf(fact_7923_mlex__iff,axiom,
    ! [A: $tType,X3: A,Y5: A,F2: A > nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( mlex_prod @ A @ F2 @ R4 ) )
      = ( ( ord_less @ nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
        | ( ( ( F2 @ X3 )
            = ( F2 @ Y5 ) )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R4 ) ) ) ) ).

% mlex_iff
thf(fact_7924_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X3: A,Y5: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( F2 @ Y5 ) )
     => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R4 )
       => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( mlex_prod @ A @ F2 @ R4 ) ) ) ) ).

% mlex_leq
thf(fact_7925_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R2 ) )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X2: A,Y2: B,Xs3: list @ A] :
              ( ( A1
                = ( cons @ A @ X2 @ Xs3 ) )
             => ! [Ys4: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y2 @ Ys4 ) )
                 => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R2 )
                   => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys4 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_7926_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( A1
            = ( nil @ A ) )
          & ( A22
            = ( nil @ B ) ) )
        | ? [X4: A,Y: B,Xs2: list @ A,Ys3: list @ B] :
            ( ( A1
              = ( cons @ A @ X4 @ Xs2 ) )
            & ( A22
              = ( cons @ B @ Y @ Ys3 ) )
            & ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ R2 )
            & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys3 ) @ ( listrel @ A @ B @ R2 ) ) ) ) ) ).

% listrel.simps
thf(fact_7927_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys2 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys2 ) )
        & ! [N2: nat] :
            ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N2 ) @ ( nth @ B @ Ys2 @ N2 ) ) @ R2 ) ) ) ) ).

% listrel_iff_nth
thf(fact_7928_relpow__finite__bounded1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R4 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R4 )
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                    & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_7929_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I2: int,N2: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
          & ( N2
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_7930_Rats__abs__iff,axiom,
    ! [X3: real] :
      ( ( member2 @ real @ ( abs_abs @ real @ X3 ) @ ( field_char_0_Rats @ real ) )
      = ( member2 @ real @ X3 @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_7931_finite__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) ) ) ) ).

% finite_relpow
thf(fact_7932_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Nats_subset_Rats
thf(fact_7933_Rats__no__top__le,axiom,
    ! [X3: real] :
    ? [X2: real] :
      ( ( member2 @ real @ X2 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X3 @ X2 ) ) ).

% Rats_no_top_le
thf(fact_7934_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_7935_Rats__no__bot__less,axiom,
    ! [X3: real] :
    ? [X2: real] :
      ( ( member2 @ real @ X2 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X2 @ X3 ) ) ).

% Rats_no_bot_less
thf(fact_7936_Rats__dense__in__real,axiom,
    ! [X3: real,Y5: real] :
      ( ( ord_less @ real @ X3 @ Y5 )
     => ? [X2: real] :
          ( ( member2 @ real @ X2 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X3 @ X2 )
          & ( ord_less @ real @ X2 @ Y5 ) ) ) ).

% Rats_dense_in_real
thf(fact_7937_relpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( plus_plus @ nat @ M @ N ) @ R4 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M @ R4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) ) ) ).

% relpow_add
thf(fact_7938_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( field_char_0_Rats @ A ) )
         => ( ( member2 @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member2 @ A @ ( times_times @ A @ A3 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_7939_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] : ( member2 @ A @ ( numeral_numeral @ A @ W ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_7940_Rats__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( field_char_0_Rats @ A ) )
         => ( ( member2 @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member2 @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_divide
thf(fact_7941_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,N: nat] :
          ( ( member2 @ A @ A3 @ ( field_char_0_Rats @ A ) )
         => ( member2 @ A @ ( power_power @ A @ A3 @ N ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_7942_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( field_char_0_Rats @ A ) )
         => ( ( member2 @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member2 @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_7943_Rats__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member2 @ A @ ( zero_zero @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_0
thf(fact_7944_relpow__E2,axiom,
    ! [A: $tType,X3: A,Z2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X3 != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 )
               => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R4 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_7945_relpow__E,axiom,
    ! [A: $tType,X3: A,Z2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X3 != Z2 ) )
       => ~ ! [Y2: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R4 ) )
               => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ R4 ) ) ) ) ) ).

% relpow_E
thf(fact_7946_relpow__0__E,axiom,
    ! [A: $tType,X3: A,Y5: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R4 ) )
     => ( X3 = Y5 ) ) ).

% relpow_0_E
thf(fact_7947_relpow__0__I,axiom,
    ! [A: $tType,X3: A,R4: set @ ( product_prod @ A @ A )] : ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R4 ) ) ).

% relpow_0_I
thf(fact_7948_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_7949_relpow__fun__conv,axiom,
    ! [A: $tType,A3: A,B2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
      = ( ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = A3 )
            & ( ( F3 @ N )
              = B2 )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ N )
               => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F3 @ I2 ) @ ( F3 @ ( suc @ I2 ) ) ) @ R4 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_7950_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I2: int,J4: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I2 ) @ ( ring_1_of_int @ real @ J4 ) ) )
          & ( J4
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_7951_relpow__finite__bounded,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R4 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R4 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_7952_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N2: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I2 @ R6 )
              @ ( collect @ nat
                @ ^ [I2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
                    & ( ord_less_eq @ nat @ I2 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_7953_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( transitive_trancl @ A @ R4 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R4 )
            @ ( collect @ nat
              @ ^ [N2: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                  & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_7954_ntrancl__Zero,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R4 )
      = R4 ) ).

% ntrancl_Zero
thf(fact_7955_trancl__power,axiom,
    ! [A: $tType,P3: product_prod @ A @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ P3 @ ( transitive_trancl @ A @ R4 ) )
      = ( ? [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( member2 @ ( product_prod @ A @ A ) @ P3 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R4 ) ) ) ) ) ).

% trancl_power
thf(fact_7956_trancl__subset__Sigma,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),A2: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2
        @ ( product_Sigma @ A @ A @ A2
          @ ^ [Uu3: A] : A2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R2 )
        @ ( product_Sigma @ A @ A @ A2
          @ ^ [Uu3: A] : A2 ) ) ) ).

% trancl_subset_Sigma
thf(fact_7957_trancl__mono,axiom,
    ! [A: $tType,P3: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ P3 @ ( transitive_trancl @ A @ R2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
       => ( member2 @ ( product_prod @ A @ A ) @ P3 @ ( transitive_trancl @ A @ S ) ) ) ) ).

% trancl_mono
thf(fact_7958_trancl__Int__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R2 ) @ S ) @ R2 ) @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R2 ) @ S ) ) ) ).

% trancl_Int_subset
thf(fact_7959_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_7960_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X4: list @ A,Y: list @ A] :
                ? [A5: A,V5: list @ A] :
                  ( ( Y
                    = ( append @ A @ X4 @ ( cons @ A @ A5 @ V5 ) ) )
                  | ? [U2: list @ A,B4: A,C4: A,W2: list @ A,Z3: list @ A] :
                      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C4 ) @ R5 )
                      & ( X4
                        = ( append @ A @ U2 @ ( cons @ A @ B4 @ W2 ) ) )
                      & ( Y
                        = ( append @ A @ U2 @ ( cons @ A @ C4 @ Z3 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_7961_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I2: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I2 ) @ ( nth @ B @ Ys2 @ I2 ) ) )
            & ( ord_less @ nat @ I2 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ) ) ) ).

% set_zip
thf(fact_7962_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% min.absorb1
thf(fact_7963_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_7964_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_7965_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X3: A,Y5: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X3 @ Y5 ) )
          = ( ( ord_less @ A @ Z2 @ X3 )
            & ( ord_less @ A @ Z2 @ Y5 ) ) ) ) ).

% min_less_iff_conj
thf(fact_7966_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_7967_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% min.absorb3
thf(fact_7968_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_7969_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_7970_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_7971_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A3 ) ) ) ).

% take_bit_take_bit
thf(fact_7972_take__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( take @ A @ M @ Xs ) )
      = ( take @ A @ ( ord_min @ nat @ N @ M ) @ Xs ) ) ).

% take_take
thf(fact_7973_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A3: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A3 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A3 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_7974_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_7975_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_7976_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X3 ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_7977_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_7978_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_7979_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X3 ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_7980_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X3 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_7981_length__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N @ Xs ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_take
thf(fact_7982_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N ) ) ) ) ).

% take_bit_of_mask
thf(fact_7983_take__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X3: A] :
      ( ( take @ A @ I @ ( replicate @ A @ K @ X3 ) )
      = ( replicate @ A @ ( ord_min @ nat @ I @ K ) @ X3 ) ) ).

% take_replicate
thf(fact_7984_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_7985_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_7986_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_7987_lexord__cons__cons,axiom,
    ! [A: $tType,A3: A,X3: list @ A,B2: A,Y5: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A3 @ X3 ) @ ( cons @ A @ B2 @ Y5 ) ) @ ( lexord @ A @ R2 ) )
      = ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R2 )
        | ( ( A3 = B2 )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Y5 ) @ ( lexord @ A @ R2 ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_7988_lexord__Nil__left,axiom,
    ! [A: $tType,Y5: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y5 ) @ ( lexord @ A @ R2 ) )
      = ( ? [A5: A,X4: list @ A] :
            ( Y5
            = ( cons @ A @ A5 @ X4 ) ) ) ) ).

% lexord_Nil_left
thf(fact_7989_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_7990_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_7991_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I: nat,X3: A,J3: nat,Y5: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I @ X3 ) @ ( replicate @ B @ J3 @ Y5 ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I @ J3 ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) ) ) ).

% zip_replicate
thf(fact_7992_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R2 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R2 ) )
        = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_7993_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) ) ).

% length_zip
thf(fact_7994_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys2: list @ B,P: ( list @ ( product_prod @ A @ B ) ) > $o] :
      ( ! [Zs2: list @ A,Ws2: list @ B,N3: nat] :
          ( ( ( size_size @ ( list @ A ) @ Zs2 )
            = ( size_size @ ( list @ B ) @ Ws2 ) )
         => ( ( N3
              = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) )
           => ( ( Zs2
                = ( take @ A @ N3 @ Xs ) )
             => ( ( Ws2
                  = ( take @ B @ N3 @ Ys2 ) )
               => ( P @ ( zip @ A @ B @ Zs2 @ Ws2 ) ) ) ) ) )
     => ( P @ ( zip @ A @ B @ Xs @ Ys2 ) ) ) ).

% zip_obtain_same_length
thf(fact_7995_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_7996_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N @ K @ L ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N ) @ L ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_7997_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X3 @ Y5 ) @ Z2 )
          = ( ( ord_less_eq @ A @ X3 @ Z2 )
            | ( ord_less_eq @ A @ Y5 @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_7998_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_7999_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_8000_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% min.absorb_iff2
thf(fact_8001_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% min.absorb_iff1
thf(fact_8002_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_8003_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ A3 ) ) ).

% min.cobounded1
thf(fact_8004_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( ord_min @ A @ A5 @ B4 ) ) ) ) ) ).

% min.order_iff
thf(fact_8005_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_8006_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A3 @ B2 )
             => ~ ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_8007_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( ord_min @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% min.orderI
thf(fact_8008_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( A3
            = ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_8009_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_8010_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def_raw
thf(fact_8011_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def
thf(fact_8012_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: A,Y5: A] :
          ( ( ord_less_eq @ A @ X3 @ Y5 )
         => ( ( ord_min @ A @ X3 @ Y5 )
            = X3 ) ) ) ).

% min_absorb1
thf(fact_8013_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y5: A,X3: A] :
          ( ( ord_less_eq @ A @ Y5 @ X3 )
         => ( ( ord_min @ A @ X3 @ Y5 )
            = Y5 ) ) ) ).

% min_absorb2
thf(fact_8014_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_8015_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_8016_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( ord_min @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_8017_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A3 @ B2 )
             => ~ ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_8018_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X3 @ Y5 ) @ Z2 )
          = ( ( ord_less @ A @ X3 @ Z2 )
            | ( ord_less @ A @ Y5 @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_8019_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R2: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N @ K @ L ) @ R2 )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N ) @ L @ R2 ) ) ) ).

% concat_bit_assoc_sym
thf(fact_8020_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X3 @ Y5 ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X3 @ Z2 ) @ ( minus_minus @ A @ Y5 @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_8021_min__diff,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I ) @ ( minus_minus @ nat @ N @ I ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I ) ) ).

% min_diff
thf(fact_8022_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_8023_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_8024_of__int__min,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X3: int,Y5: int] :
          ( ( ring_1_of_int @ A @ ( ord_min @ int @ X3 @ Y5 ) )
          = ( ord_min @ A @ ( ring_1_of_int @ A @ X3 ) @ ( ring_1_of_int @ A @ Y5 ) ) ) ) ).

% of_int_min
thf(fact_8025_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X3 @ Y5 ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X3 @ Z2 ) @ ( plus_plus @ A @ Y5 @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_8026_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X3: A,Y5: A,Z2: A] :
          ( ( plus_plus @ A @ X3 @ ( ord_min @ A @ Y5 @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ ( plus_plus @ A @ X3 @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_8027_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X3: A,Y5: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X3 @ Y5 ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y5 ) ) ) ) ).

% minus_min_eq_max
thf(fact_8028_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X3: A,Y5: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X3 @ Y5 ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y5 ) ) ) ) ).

% minus_max_eq_min
thf(fact_8029_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X3: nat,Y5: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X3 @ Y5 ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X3 ) @ ( semiring_1_of_nat @ A @ Y5 ) ) ) ) ).

% of_nat_min
thf(fact_8030_lexord__take__index__conv,axiom,
    ! [A: $tType,X3: list @ A,Y5: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Y5 ) @ ( lexord @ A @ R2 ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X3 ) @ ( size_size @ ( list @ A ) @ Y5 ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X3 ) @ Y5 )
            = X3 ) )
        | ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X3 ) @ ( size_size @ ( list @ A ) @ Y5 ) ) )
            & ( ( take @ A @ I2 @ X3 )
              = ( take @ A @ I2 @ Y5 ) )
            & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X3 @ I2 ) @ ( nth @ A @ Y5 @ I2 ) ) @ R2 ) ) ) ) ).

% lexord_take_index_conv
thf(fact_8031_lexord__Nil__right,axiom,
    ! [A: $tType,X3: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) @ ( lexord @ A @ R2 ) ) ).

% lexord_Nil_right
thf(fact_8032_lexord__linear,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),X3: list @ A,Y5: list @ A] :
      ( ! [A7: A,B6: A] :
          ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A7 @ B6 ) @ R2 )
          | ( A7 = B6 )
          | ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A7 ) @ R2 ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Y5 ) @ ( lexord @ A @ R2 ) )
        | ( X3 = Y5 )
        | ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y5 @ X3 ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_linear
thf(fact_8033_lexord__irreflexive,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R2 )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_irreflexive
thf(fact_8034_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V: list @ A,R2: set @ ( product_prod @ A @ A ),X3: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R2 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X3 @ U ) @ ( append @ A @ X3 @ V ) ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_append_leftI
thf(fact_8035_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A ),Ys2: list @ A,Zs: list @ A] :
      ( ! [X2: A,Y2: A,Z5: A] :
          ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R2 )
           => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z5 ) @ R2 )
             => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z5 ) @ R2 ) ) ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lexord @ A @ R2 ) )
       => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lexord @ A @ R2 ) )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R2 ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_8036_lexord__append__leftD,axiom,
    ! [A: $tType,X3: list @ A,U: list @ A,V: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X3 @ U ) @ ( append @ A @ X3 @ V ) ) @ ( lexord @ A @ R2 ) )
     => ( ! [A7: A] :
            ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A7 @ A7 ) @ R2 )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_append_leftD
thf(fact_8037_lexord__append__rightI,axiom,
    ! [A: $tType,Y5: list @ A,X3: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ? [B11: A,Z4: list @ A] :
          ( Y5
          = ( cons @ A @ B11 @ Z4 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ ( append @ A @ X3 @ Y5 ) ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_append_rightI
thf(fact_8038_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P3: A,X3: A,Y5: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ P3 @ ( ord_max @ A @ X3 @ Y5 ) )
              = ( ord_max @ A @ ( times_times @ A @ P3 @ X3 ) @ ( times_times @ A @ P3 @ Y5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ P3 @ ( ord_max @ A @ X3 @ Y5 ) )
              = ( ord_min @ A @ ( times_times @ A @ P3 @ X3 ) @ ( times_times @ A @ P3 @ Y5 ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_8039_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P3: A,X3: A,Y5: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ P3 @ ( ord_min @ A @ X3 @ Y5 ) )
              = ( ord_min @ A @ ( times_times @ A @ P3 @ X3 ) @ ( times_times @ A @ P3 @ Y5 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ P3 @ ( ord_min @ A @ X3 @ Y5 ) )
              = ( ord_max @ A @ ( times_times @ A @ P3 @ X3 ) @ ( times_times @ A @ P3 @ Y5 ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_8040_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P3: A,X3: A,Y5: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ ( ord_max @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_max @ A @ ( times_times @ A @ X3 @ P3 ) @ ( times_times @ A @ Y5 @ P3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ ( ord_max @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_min @ A @ ( times_times @ A @ X3 @ P3 ) @ ( times_times @ A @ Y5 @ P3 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_8041_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P3: A,X3: A,Y5: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ ( ord_min @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_min @ A @ ( times_times @ A @ X3 @ P3 ) @ ( times_times @ A @ Y5 @ P3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( times_times @ A @ ( ord_min @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_max @ A @ ( times_times @ A @ X3 @ P3 ) @ ( times_times @ A @ Y5 @ P3 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_8042_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys2: list @ A,Qs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys2 @ Qs ) ) @ ( lexord @ A @ R2 ) )
     => ( ( Xs != Ys2 )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys2 ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( lexord @ A @ R2 ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_8043_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P3: A,X3: A,Y5: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_max @ A @ ( divide_divide @ A @ X3 @ P3 ) @ ( divide_divide @ A @ Y5 @ P3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_min @ A @ ( divide_divide @ A @ X3 @ P3 ) @ ( divide_divide @ A @ Y5 @ P3 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_8044_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P3: A,X3: A,Y5: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_min @ A @ ( divide_divide @ A @ X3 @ P3 ) @ ( divide_divide @ A @ Y5 @ P3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P3 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X3 @ Y5 ) @ P3 )
              = ( ord_max @ A @ ( divide_divide @ A @ X3 @ P3 ) @ ( divide_divide @ A @ Y5 @ P3 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_8045_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ M6 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_8046_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ N @ M6 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_8047_lexord__lex,axiom,
    ! [A: $tType,X3: list @ A,Y5: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Y5 ) @ ( lex @ A @ R2 ) )
      = ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Y5 ) @ ( lexord @ A @ R2 ) )
        & ( ( size_size @ ( list @ A ) @ X3 )
          = ( size_size @ ( list @ A ) @ Y5 ) ) ) ) ).

% lexord_lex
thf(fact_8048_lexord__irrefl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R4 )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_irrefl
thf(fact_8049_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% mod_exp_eq
thf(fact_8050_lexord__append__left__rightI,axiom,
    ! [A: $tType,A3: A,B2: A,R2: set @ ( product_prod @ A @ A ),U: list @ A,X3: list @ A,Y5: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R2 )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A3 @ X3 ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y5 ) ) ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_append_left_rightI
thf(fact_8051_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,Zs: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys2 ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R2 ) )
      = ( ? [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ X4 ) @ R2 ) )
        | ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_8052_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R2: set @ ( product_prod @ A @ A ),V: list @ A,Z2: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R2 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W @ Z2 ) ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_sufI
thf(fact_8053_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys2: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys2 ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys2 ) ) @ Xs ) ) ).

% map_fst_zip_take
thf(fact_8054_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ B,Ys2: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys2 ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ B ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) @ Ys2 ) ) ).

% map_snd_zip_take
thf(fact_8055_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_8056_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs2: list @ A,Ys3: list @ A] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_8057_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( case_list @ A @ A @ X3
            @ ^ [A5: A,List3: list @ A] : ( ord_min @ A @ X3 @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_8058_min__enat__simps_I4_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) )
      = Q2 ) ).

% min_enat_simps(4)
thf(fact_8059_min__enat__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = Q2 ) ).

% min_enat_simps(5)
thf(fact_8060_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_8061_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_8062_min__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_enat_simps(1)
thf(fact_8063_inf__int__def,axiom,
    ( ( inf_inf @ int )
    = ( ord_min @ int ) ) ).

% inf_int_def
thf(fact_8064_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( transitive_rtrancl @ A @ R4 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R4 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_8065_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: list @ A,Y5: A] :
          ( ( ( min_list @ A @ X3 )
            = Y5 )
         => ( ! [X2: A,Xs3: list @ A] :
                ( ( X3
                  = ( cons @ A @ X2 @ Xs3 ) )
               => ( Y5
                 != ( case_list @ A @ A @ X2
                    @ ^ [A5: A,List3: list @ A] : ( ord_min @ A @ X2 @ ( min_list @ A @ Xs3 ) )
                    @ Xs3 ) ) )
           => ~ ( ( X3
                  = ( nil @ A ) )
               => ( Y5
                 != ( undefined @ A ) ) ) ) ) ) ).

% min_list.elims
thf(fact_8066_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list @ A,R2: set @ ( product_prod @ A @ A )] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) ) ).

% listrel_rtrancl_refl
thf(fact_8067_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_8068_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),Zs: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys2 @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_8069_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel1 @ A @ R2 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_8070_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( listrel @ A @ A @ R2 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_8071_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R2 ) )
      = ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
thf(fact_8072_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R2 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_8073_rtrancl__mono,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_mono
thf(fact_8074_rtrancl__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ S2 @ ( transitive_rtrancl @ A @ R4 ) )
       => ( ( transitive_rtrancl @ A @ S2 )
          = ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% rtrancl_subset
thf(fact_8075_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ ( transitive_rtrancl @ A @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_subset_rtrancl
thf(fact_8076_rtrancl__Un__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 ) @ ( transitive_rtrancl @ A @ S2 ) ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S2 ) ) ) ).

% rtrancl_Un_subset
thf(fact_8077_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X3: list @ A,Y5: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X3 @ Y5 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) )
     => ( ( size_size @ ( list @ A ) @ X3 )
        = ( size_size @ ( list @ A ) @ Y5 ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_8078_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X3: A,Y5: A,R2: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys2: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y5 @ Ys2 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_8079_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys2: list @ A,R2: set @ ( product_prod @ A @ A ),X3: A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ X3 @ Ys2 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_8080_hd__def,axiom,
    ! [A: $tType] :
      ( ( hd @ A )
      = ( case_list @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X224: list @ A] : X213 ) ) ).

% hd_def
thf(fact_8081_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A3: A,B2: A,R2: set @ ( product_prod @ A @ A ),A2: set @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2
          @ ( product_Sigma @ A @ A @ A2
            @ ^ [Uu3: A] : A2 ) )
       => ( ( A3 = B2 )
          | ( member2 @ A @ A3 @ A2 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_8082_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R2 ) ) ) ).

% listrel_subset_rtrancl_listrel1
thf(fact_8083_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X3: list @ A,Y5: A] :
          ( ( ( min_list @ A @ X3 )
            = Y5 )
         => ( ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ X3 )
           => ( ! [X2: A,Xs3: list @ A] :
                  ( ( X3
                    = ( cons @ A @ X2 @ Xs3 ) )
                 => ( ( Y5
                      = ( case_list @ A @ A @ X2
                        @ ^ [A5: A,List3: list @ A] : ( ord_min @ A @ X2 @ ( min_list @ A @ Xs3 ) )
                        @ Xs3 ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( cons @ A @ X2 @ Xs3 ) ) ) )
             => ~ ( ( X3
                    = ( nil @ A ) )
                 => ( ( Y5
                      = ( undefined @ A ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( nil @ A ) ) ) ) ) ) ) ) ).

% min_list.pelims
thf(fact_8084_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X3: A > B,Xa: list @ A,Y5: A] :
          ( ( ( arg_min_list @ A @ B @ X3 @ Xa )
            = Y5 )
         => ( ! [X2: A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ ( nil @ A ) ) )
               => ( Y5 != X2 ) )
           => ( ! [X2: A,Y2: A,Zs2: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) )
                 => ( Y5
                   != ( if @ A @ ( ord_less_eq @ B @ ( X3 @ X2 ) @ ( X3 @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) @ X2 @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ( Y5
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_8085_arg__min__list_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X3: A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X3 @ ( nil @ A ) ) )
          = X3 ) ) ).

% arg_min_list.simps(1)
thf(fact_8086_arg__min__list__in,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( member2 @ A @ ( arg_min_list @ A @ B @ F2 @ Xs ) @ ( set2 @ A @ Xs ) ) ) ) ).

% arg_min_list_in
thf(fact_8087_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X3: A,Y5: A,Zs: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Zs ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y5 @ Zs ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y5 @ Zs ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_8088_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X3: A > B,Xa: list @ A,Y5: A] :
          ( ( ( arg_min_list @ A @ B @ X3 @ Xa )
            = Y5 )
         => ( ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ Xa ) )
           => ( ! [X2: A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( nil @ A ) ) )
                 => ( ( Y5 = X2 )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
             => ( ! [X2: A,Y2: A,Zs2: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) )
                   => ( ( Y5
                        = ( if @ A @ ( ord_less_eq @ B @ ( X3 @ X2 ) @ ( X3 @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) @ X2 @ ( arg_min_list @ A @ B @ X3 @ ( cons @ A @ Y2 @ Zs2 ) ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) ) )
               => ~ ( ( Xa
                      = ( nil @ A ) )
                   => ( ( Y5
                        = ( undefined @ A ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X3 @ ( nil @ A ) ) ) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
thf(fact_8089_pow_Osimps_I3_J,axiom,
    ! [X3: num,Y5: num] :
      ( ( pow @ X3 @ ( bit1 @ Y5 ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X3 @ Y5 ) ) @ X3 ) ) ).

% pow.simps(3)
thf(fact_8090_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X4: num] : ( times_times @ num @ X4 @ X4 ) ) ) ).

% sqr_conv_mult
thf(fact_8091_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_8092_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_8093_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_8094_pow_Osimps_I2_J,axiom,
    ! [X3: num,Y5: num] :
      ( ( pow @ X3 @ ( bit0 @ Y5 ) )
      = ( sqr @ ( pow @ X3 @ Y5 ) ) ) ).

% pow.simps(2)
thf(fact_8095_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_8096_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X4: A] : X4 ) ) ) ).

% sorted_list_of_set_def
thf(fact_8097_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_8098_integer__of__num__def,axiom,
    ( code_integer_of_num
    = ( numeral_numeral @ code_integer ) ) ).

% integer_of_num_def
thf(fact_8099_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_8100_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) ) ).

% integer_of_num(2)
thf(fact_8101_rat__floor__lemma,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A3 @ B2 ) ) @ ( fract @ A3 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A3 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_8102_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X4: A,Y: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ R5 ) ) ) ) ) ) ).

% listrel_def
thf(fact_8103_mult__rat,axiom,
    ! [A3: int,B2: int,C2: int,D2: int] :
      ( ( times_times @ rat @ ( fract @ A3 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A3 @ C2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ).

% mult_rat
thf(fact_8104_divide__rat,axiom,
    ! [A3: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A3 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A3 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_8105_floor__Fract,axiom,
    ! [A3: int,B2: int] :
      ( ( archim6421214686448440834_floor @ rat @ ( fract @ A3 @ B2 ) )
      = ( divide_divide @ int @ A3 @ B2 ) ) ).

% floor_Fract
thf(fact_8106_less__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A3 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A3 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_8107_add__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A3 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A3 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_8108_le__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A3 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A3 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_8109_diff__rat,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A3 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A3 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_8110_sgn__rat,axiom,
    ! [A3: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A3 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A3 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_8111_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K3: num] : ( fract @ ( numeral_numeral @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_8112_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_8113_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q2: rat] :
      ( ! [A7: int,B6: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( P @ ( fract @ A7 @ B6 ) ) )
     => ( P @ Q2 ) ) ).

% Rat_induct_pos
thf(fact_8114_listrelp_ONil,axiom,
    ! [A: $tType,B: $tType,R2: A > B > $o] : ( listrelp @ A @ B @ R2 @ ( nil @ A ) @ ( nil @ B ) ) ).

% listrelp.Nil
thf(fact_8115_Fract__coprime,axiom,
    ! [A3: int,B2: int] :
      ( ( fract @ ( divide_divide @ int @ A3 @ ( gcd_gcd @ int @ A3 @ B2 ) ) @ ( divide_divide @ int @ B2 @ ( gcd_gcd @ int @ A3 @ B2 ) ) )
      = ( fract @ A3 @ B2 ) ) ).

% Fract_coprime
thf(fact_8116_mult__rat__cancel,axiom,
    ! [C2: int,A3: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A3 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A3 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_8117_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A3: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A3 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A3 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_8118_eq__rat_I3_J,axiom,
    ! [A3: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A3 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_8119_eq__rat_I2_J,axiom,
    ! [A3: int] :
      ( ( fract @ A3 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_8120_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_8121_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_8122_listrelp_OCons,axiom,
    ! [A: $tType,B: $tType,R2: A > B > $o,X3: A,Y5: B,Xs: list @ A,Ys2: list @ B] :
      ( ( R2 @ X3 @ Y5 )
     => ( ( listrelp @ A @ B @ R2 @ Xs @ Ys2 )
       => ( listrelp @ A @ B @ R2 @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y5 @ Ys2 ) ) ) ) ).

% listrelp.Cons
thf(fact_8123_Fract__of__int__quotient,axiom,
    ( fract
    = ( ^ [K3: int,L3: int] : ( divide_divide @ rat @ ( ring_1_of_int @ rat @ K3 ) @ ( ring_1_of_int @ rat @ L3 ) ) ) ) ).

% Fract_of_int_quotient
thf(fact_8124_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_8125_listrelp_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R5: A > B > $o,A12: list @ A,A23: list @ B] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A23
                = ( nil @ B ) ) )
            | ? [X4: A,Y: B,Xs2: list @ A,Ys3: list @ B] :
                ( ( A12
                  = ( cons @ A @ X4 @ Xs2 ) )
                & ( A23
                  = ( cons @ B @ Y @ Ys3 ) )
                & ( R5 @ X4 @ Y )
                & ( listrelp @ A @ B @ R5 @ Xs2 @ Ys3 ) ) ) ) ) ).

% listrelp.simps
thf(fact_8126_listrelp_Ocases,axiom,
    ! [A: $tType,B: $tType,R2: A > B > $o,A1: list @ A,A22: list @ B] :
      ( ( listrelp @ A @ B @ R2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X2: A,Y2: B,Xs3: list @ A] :
              ( ( A1
                = ( cons @ A @ X2 @ Xs3 ) )
             => ! [Ys4: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y2 @ Ys4 ) )
                 => ( ( R2 @ X2 @ Y2 )
                   => ~ ( listrelp @ A @ B @ R2 @ Xs3 @ Ys4 ) ) ) ) ) ) ).

% listrelp.cases
thf(fact_8127_zero__less__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A3 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A3 ) ) ) ).

% zero_less_Fract_iff
thf(fact_8128_Fract__less__zero__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A3 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A3 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_8129_Fract__less__one__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A3 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A3 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_8130_one__less__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A3 @ B2 ) )
        = ( ord_less @ int @ B2 @ A3 ) ) ) ).

% one_less_Fract_iff
thf(fact_8131_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_8132_zero__le__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A3 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 ) ) ) ).

% zero_le_Fract_iff
thf(fact_8133_Fract__le__zero__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A3 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_8134_one__le__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A3 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A3 ) ) ) ).

% one_le_Fract_iff
thf(fact_8135_Fract__le__one__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A3 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A3 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_8136_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_8137_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_8138_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X4: A,Y: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ R2 ) )
      = ( ^ [X4: list @ A,Y: list @ B] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X4 @ Y ) @ ( listrel @ A @ B @ R2 ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_8139_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N2: nat,Xs2: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Xs2 ) @ ( take @ A @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Xs2 ) ) ) ) ).

% rotate_drop_take
thf(fact_8140_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I2: nat,J4: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J4 ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_8141_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_8142_list_Omap__id0,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A @ ( id @ A ) )
      = ( id @ ( list @ A ) ) ) ).

% list.map_id0
thf(fact_8143_id__funpow,axiom,
    ! [A: $tType,N: nat] :
      ( ( compow @ ( A > A ) @ N @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_8144_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_8145_rotate__is__Nil__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( rotate @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate_is_Nil_conv
thf(fact_8146_set__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate @ A @ N @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate
thf(fact_8147_length__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate
thf(fact_8148_distinct__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate @ A @ N @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rotate
thf(fact_8149_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_8150_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_8151_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ ( suc @ N ) @ Xs )
      = ( rotate1 @ A @ ( rotate @ A @ N @ Xs ) ) ) ).

% rotate_Suc
thf(fact_8152_rotate__length01,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_length01
thf(fact_8153_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_id
thf(fact_8154_rotate__def,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N2: nat] : ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N2 @ ( rotate1 @ A ) ) ) ) ).

% rotate_def
thf(fact_8155_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_8156_rotate__add,axiom,
    ! [A: $tType,M: nat,N: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M @ N ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M ) @ ( rotate @ A @ N ) ) ) ).

% rotate_add
thf(fact_8157_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N2: nat,Xs2: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Xs2 ) ) ) ).

% rotate_conv_mod
thf(fact_8158_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ M @ ( rotate @ A @ N @ Xs ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M @ N ) @ Xs ) ) ).

% rotate_rotate
thf(fact_8159_rotate1__rotate__swap,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate1 @ A @ ( rotate @ A @ N @ Xs ) )
      = ( rotate @ A @ N @ ( rotate1 @ A @ Xs ) ) ) ).

% rotate1_rotate_swap
thf(fact_8160_foldr__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( foldr @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% foldr_Nil
thf(fact_8161_rotate__append,axiom,
    ! [A: $tType,L: list @ A,Q2: list @ A] :
      ( ( rotate @ A @ ( size_size @ ( list @ A ) @ L ) @ ( append @ A @ L @ Q2 ) )
      = ( append @ A @ Q2 @ L ) ) ).

% rotate_append
thf(fact_8162_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( foldr @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( foldr @ B @ A
        @ ^ [X4: B] : ( if @ ( A > A ) @ ( P @ X4 ) @ ( F2 @ X4 ) @ ( id @ A ) )
        @ Xs ) ) ).

% foldr_filter
thf(fact_8163_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_8164_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X4: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y ) ) ) ) ) ) ).

% less_int_def
thf(fact_8165_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_8166_List_Omap_Oidentity,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4 )
      = ( id @ ( list @ A ) ) ) ).

% List.map.identity
thf(fact_8167_list_Omap__id,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A @ ( id @ A ) @ T2 )
      = T2 ) ).

% list.map_id
thf(fact_8168_rotate__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( rotate @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate @ B @ N @ Xs ) ) ) ).

% rotate_map
thf(fact_8169_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% rotate_rev
thf(fact_8170_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,G: C > B,A2: set @ A,B3: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A5: A,B4: C] : ( times_times @ B @ ( F2 @ A5 ) @ ( G @ B4 ) ) )
            @ ( product_Sigma @ A @ C @ A2
              @ ^ [Uu3: A] : B3 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A2 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B3 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu3: B] :
                  ? [A5: A,B4: C] :
                    ( ( Uu3
                      = ( times_times @ B @ ( F2 @ A5 ) @ ( G @ B4 ) ) )
                    & ( member2 @ A @ A5 @ A2 )
                    & ( member2 @ C @ B4 @ B3 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_8171_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,M: nat] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate
thf(fact_8172_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_8173_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord144544945434240204of_set @ B @ A )
        = ( ^ [F3: B > A] : ( finite_folding_F @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ ( nil @ B ) ) ) ) ) ).

% sorted_key_list_of_set_def
thf(fact_8174_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_8175_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_8176_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_8177_take__bit__num__simps_I5_J,axiom,
    ! [R2: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_8178_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_8179_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num,Q2: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( some @ num @ Q2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_8180_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ N @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ one2 )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_8181_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_8182_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M3: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M3 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M3 ) ) ) ) ) ) ) ).

% take_bit_num_def

% Type constructors (743)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A15: $tType] : ( bounded_lattice @ ( filter @ A15 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A15: $tType] : ( bounded_lattice @ ( set @ A15 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( bounded_lattice @ A18 )
     => ( bounded_lattice @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( comple6319245703460814977attice @ A18 )
     => ( condit1219197933456340205attice @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( counta3822494911875563373attice @ A18 )
     => ( counta3822494911875563373attice @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( comple592849572758109894attice @ A18 )
     => ( comple592849572758109894attice @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( bounded_lattice @ A18 )
     => ( bounde4967611905675639751up_bot @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( bounded_lattice @ A18 )
     => ( bounde4346867609351753570nf_top @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( comple6319245703460814977attice @ A18 )
     => ( comple6319245703460814977attice @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( boolea8198339166811842893lgebra @ A18 )
     => ( boolea8198339166811842893lgebra @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( semilattice_sup @ A18 )
     => ( semilattice_sup @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( semilattice_inf @ A18 )
     => ( semilattice_inf @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( order_top @ A18 )
     => ( order_top @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( order_bot @ A18 )
     => ( order_bot @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( preorder @ A18 )
     => ( preorder @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( lattice @ A18 )
     => ( lattice @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( order @ A18 )
     => ( order @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( ord @ A18 )
     => ( ord @ ( A15 > A18 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( uminus @ A18 )
     => ( uminus @ ( A15 > A18 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_8,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_9,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_10,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_11,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_12,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_13,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_14,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_15,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_16,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_17,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_18,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_19,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_20,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_21,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_22,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_23,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_24,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_25,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_26,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_27,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_28,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_29,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_30,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_31,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_32,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_33,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_34,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_35,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_36,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_37,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_38,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_39,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_40,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_41,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_42,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_43,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_44,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_45,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_46,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_47,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_48,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_49,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_50,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_51,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_52,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_53,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_54,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_55,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_56,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_57,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_58,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_59,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_60,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_61,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_62,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_63,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_64,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_65,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_66,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_67,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_68,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_69,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_70,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_71,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_72,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_73,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_74,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_75,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_76,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_77,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_78,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_79,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_80,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_81,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_82,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_83,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_84,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_85,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_86,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_87,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_88,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_89,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_90,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_91,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_92,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Power_Opower_93,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_94,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_95,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_96,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_97,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_98,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_99,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_100,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_101,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_102,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_103,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_104,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_105,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_106,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_107,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_108,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_109,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_110,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_111,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_112,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_113,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_114,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_115,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_116,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_117,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_118,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_119,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_120,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_121,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_122,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_123,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_124,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_125,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_126,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_127,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_128,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_129,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_130,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_131,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_132,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_133,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_134,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_135,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_136,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_137,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_138,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_139,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_140,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_141,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_142,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_143,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_144,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_145,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_146,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_147,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_148,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_149,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_150,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_151,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_152,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_153,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_154,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_155,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_156,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_157,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_158,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_159,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_160,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_161,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_162,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_163,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_164,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_165,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_166,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_167,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_168,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_169,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_170,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_171,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_172,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_173,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_174,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_175,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_176,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_177,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_178,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_179,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_180,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_181,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_182,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_183,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_184,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_185,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_186,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_187,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_188,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_189,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_190,axiom,
    ! [A15: $tType] : ( condit1219197933456340205attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_191,axiom,
    ! [A15: $tType] : ( counta3822494911875563373attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_192,axiom,
    ! [A15: $tType] : ( comple592849572758109894attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_193,axiom,
    ! [A15: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_194,axiom,
    ! [A15: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_195,axiom,
    ! [A15: $tType] : ( comple6319245703460814977attice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_196,axiom,
    ! [A15: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_197,axiom,
    ! [A15: $tType] : ( semilattice_sup @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_198,axiom,
    ! [A15: $tType] : ( semilattice_inf @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_199,axiom,
    ! [A15: $tType] : ( order_top @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_200,axiom,
    ! [A15: $tType] : ( order_bot @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_201,axiom,
    ! [A15: $tType] : ( preorder @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_202,axiom,
    ! [A15: $tType] : ( lattice @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_203,axiom,
    ! [A15: $tType] : ( order @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_204,axiom,
    ! [A15: $tType] : ( ord @ ( set @ A15 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_205,axiom,
    ! [A15: $tType] : ( uminus @ ( set @ A15 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_206,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_207,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_208,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_209,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_210,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_211,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_212,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_213,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_214,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_215,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_216,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_217,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_218,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_219,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_220,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_221,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_222,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_223,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_224,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_225,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_226,axiom,
    uminus @ $o ).

thf(tcon_List_Olist___Nat_Osize_227,axiom,
    ! [A15: $tType] : ( size @ ( list @ A15 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_228,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_229,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_230,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_231,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_232,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_233,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_234,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_235,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_236,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_237,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_238,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_239,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_240,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_241,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_242,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_243,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_244,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_245,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_246,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_247,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_248,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_249,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_250,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_251,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_252,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_253,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_254,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_255,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_256,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_257,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_258,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_259,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_260,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_261,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_262,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_263,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_264,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_265,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_266,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_267,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_268,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_269,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_270,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_271,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_272,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_273,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_274,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_275,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_276,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_277,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_278,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_279,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_280,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_281,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_282,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_283,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_284,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_285,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_286,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_287,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_288,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_289,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_290,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_291,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_292,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_293,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_294,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_295,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_296,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_297,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_298,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_299,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_300,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_301,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_302,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_303,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_304,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_305,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_306,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_307,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_308,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_309,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_310,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_311,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_312,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_313,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_314,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_315,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_316,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_317,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_318,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_319,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_320,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_321,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_322,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_323,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_324,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_325,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_326,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_327,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_328,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_329,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_330,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_331,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_332,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_333,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_334,axiom,
    ! [A15: $tType] : ( condit1219197933456340205attice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_335,axiom,
    ! [A15: $tType] : ( counta3822494911875563373attice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_336,axiom,
    ! [A15: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_337,axiom,
    ! [A15: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_338,axiom,
    ! [A15: $tType] : ( comple6319245703460814977attice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_339,axiom,
    ! [A15: $tType] : ( semilattice_sup @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_340,axiom,
    ! [A15: $tType] : ( semilattice_inf @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_341,axiom,
    ! [A15: $tType] : ( order_top @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_342,axiom,
    ! [A15: $tType] : ( order_bot @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_343,axiom,
    ! [A15: $tType] : ( preorder @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_344,axiom,
    ! [A15: $tType] : ( lattice @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_345,axiom,
    ! [A15: $tType] : ( order @ ( filter @ A15 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_346,axiom,
    ! [A15: $tType] : ( ord @ ( filter @ A15 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_347,axiom,
    ! [A15: $tType] : ( size @ ( option @ A15 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_348,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_349,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_350,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_351,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_352,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_353,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_354,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_355,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_356,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_357,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_358,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_359,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_360,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_361,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_362,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_363,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_364,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_365,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_366,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_367,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_368,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_369,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_370,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_371,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_372,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_373,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_374,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_375,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_376,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_377,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_378,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_379,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_380,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_381,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_382,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_383,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_384,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_385,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_386,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_387,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_388,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_389,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_390,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_391,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_392,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_393,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_394,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_395,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_396,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_397,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_398,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_399,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_400,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_401,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_402,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_403,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_404,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_405,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_406,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_407,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_408,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_409,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_410,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_411,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_412,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_413,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_414,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_415,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_416,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_417,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_418,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_419,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_420,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_421,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_422,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_423,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_424,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_425,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_426,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_427,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_428,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_429,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_430,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_431,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_432,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_433,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_434,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_435,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_436,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_437,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_438,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_439,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_440,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_441,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_442,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_443,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_444,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_445,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_446,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_447,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_448,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_449,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_450,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_451,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_452,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_453,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_454,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_455,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_456,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_457,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_458,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_459,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_460,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_461,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_462,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_463,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_464,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_465,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_466,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_467,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_468,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_469,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_470,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_471,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_472,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_473,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_474,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_475,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_476,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( ( topolo4958980785337419405_space @ A15 )
        & ( topolo4958980785337419405_space @ A18 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A15 @ A18 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_477,axiom,
    ! [A15: $tType,A18: $tType] :
      ( ( ( topological_t2_space @ A15 )
        & ( topological_t2_space @ A18 ) )
     => ( topological_t2_space @ ( product_prod @ A15 @ A18 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_478,axiom,
    ! [A15: $tType,A18: $tType] : ( size @ ( product_prod @ A15 @ A18 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_479,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_480,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_481,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_482,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_483,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_484,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_485,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_486,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_487,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_488,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_489,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_490,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_491,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_492,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_493,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_494,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_495,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_496,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_497,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_498,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_499,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_500,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_501,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_502,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_503,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_504,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_505,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_506,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_507,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_508,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_509,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_510,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_511,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_512,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_513,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_514,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_515,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_516,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_517,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_518,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_519,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_520,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_521,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_522,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_523,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_524,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_525,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_526,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_527,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_528,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_529,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_530,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_531,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_532,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_533,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_534,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_535,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_536,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_537,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_538,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_539,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_540,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_541,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_542,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_543,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_544,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_545,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_546,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_547,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_548,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_549,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_550,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_551,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_552,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_553,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_554,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_555,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_556,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_557,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_558,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_559,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_560,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_561,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_562,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_563,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_564,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_565,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_566,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_567,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_568,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_569,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_570,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_571,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_572,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_573,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_574,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_575,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_576,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_577,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X3: A,Y5: A] :
      ( ( if @ A @ $false @ X3 @ Y5 )
      = Y5 ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X3: A,Y5: A] :
      ( ( if @ A @ $true @ X3 @ Y5 )
      = X3 ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X5: A] : ( P @ X5 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    member2 @ vEBT_VEBT @ ( nth @ vEBT_VEBT @ treeLista @ i ) @ ( set2 @ vEBT_VEBT @ treeLista ) ).

%------------------------------------------------------------------------------
